package com.jfinal.club._admin.admin_interface;

import com.jfinal.aop.Interceptor;
import com.jfinal.aop.Invocation;
import com.jfinal.club.common.model.Admins;
import com.jfinal.club.common.model.Navbar;
import com.jfinal.club.util.CacheSessionUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.club.vo.AccountRole;
import com.jfinal.club.vo.UserSessionVo;
import com.jfinal.core.JFinal;
import com.jfinal.kit.PathKit;
import org.apache.commons.lang3.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * @descriptions: 用户session 拦截器
 * @author: lc
 * @date: 2020-05-09 19:47:07
 * @Version: 1.0
 **/
public class AdminSessionInterface implements Interceptor {

    private CacheSessionUtil sessionUtil = CacheSessionUtil.getInstance( );

    @Override
    public void intercept(Invocation inv) {

        String sessionId = inv.getController( ).getCookie(Cons.JSESSIONID_ADMIN);
        UserSessionVo session = sessionUtil.getSession(sessionId);
        if(sessionId == null || session == null){
            inv.getController().redirect("/admin/login");
        }else{
            Admins account = session.getAdmins( );
            List< AccountRole > roleList = session.getRoleList( );
            inv.getController().setAttr("account",account);
            inv.getController().setAttr("adminRole",roleList);
            inv.invoke();
        }
    }
}
