/**
 * 请勿将俱乐部专享资源复制给任何人，保护知识产权即是保护我们所在的行业，进而保护我们自己的利益
 * 即便是公司的同事，也请尊重 JFinal 作者的努力与付出，不要复制给同事
 * 
 * 如果你尚未加入俱乐部，请立即删除该项目，或者现在加入俱乐部：http://jfinal.com/club
 * 
 * 俱乐部将提供 jfinal-club 项目源码、直播视频、专用 QQ 群，以及作者在俱乐部定期的分享与答疑，
 * 价值远比仅仅拥有 jfinal club 项目源代码要大得多，俱乐部福利资源是不断增加的，以下是俱乐部
 * 新福利计划：
 * https://jfinal.com/club/1-2
 * 
 * JFinal 俱乐部是七年以来首次寻求外部资源的尝试，以便于创建更加高品质的产品与服务，为你带来
 * 更多、更大的价值
 * 
 * JFinal 项目的可持续性发展需要你的支持！！！
 */

package com.jfinal.club._admin.common;

import com.jfinal.club._admin.admins.AdminsController;
import com.jfinal.club._admin.admin_interface.AdminSessionInterface;
import com.jfinal.club._admin.admin_interface.ContentPathInterface;
import com.jfinal.club._admin.data.appscene.photo.AdminPhotosController;
import com.jfinal.club._admin.data.home.appcase.AdminAppcaseController;
import com.jfinal.club._admin.data.home.appcase.appcasep.AdminAppCasePController;
import com.jfinal.club._admin.data.home.banner.AdminBannerController;
import com.jfinal.club._admin.data.home.news.AdminNewsController;
import com.jfinal.club._admin.data.home.registration.AdminRegistrationController;
import com.jfinal.club._admin.data.home.store.AdminStoreController;
import com.jfinal.club._admin.data.info.AdminPhotoController;
import com.jfinal.club._admin.data.info.AdminVideoController;
import com.jfinal.club._admin.data.info.AdminVrController;
import com.jfinal.club._admin.data.product.pkeyhole.AdminPKeyHoleController;
import com.jfinal.club._admin.data.product.product.attrextp.AdminAttrExtPController;
import com.jfinal.club._admin.data.product.product.attrp.AdminAttrPController;
import com.jfinal.club._admin.data.product.product.axialp.AdminAxialPController;
import com.jfinal.club._admin.data.product.product.colortype.AdminColorTypeController;
import com.jfinal.club._admin.data.product.pattr.AdminPAttrController;
import com.jfinal.club._admin.data.product.pcolor.AdminPColorController;
import com.jfinal.club._admin.data.product.pmaterial.AdminPMaterialController;
import com.jfinal.club._admin.data.product.ppatent.AdminPPatentController;
import com.jfinal.club._admin.data.product.product.AdminProductController;
import com.jfinal.club._admin.data.product.pstyle.AdminPStyleController;
import com.jfinal.club._admin.data.product.ptitle.AdminPTitleController;
import com.jfinal.club._admin.data.product.ptype.AdminPTypeController;
import com.jfinal.club._admin.data.search.AdminHotSearchController;
import com.jfinal.club._admin.data.search.AdminSearchProductLogController;
import com.jfinal.club._admin.data.search.AdminSearchStoreLogController;
import com.jfinal.club._admin.data.sys.*;
import com.jfinal.club._admin.data.wxuser.AdminWxUserController;
import com.jfinal.club._admin.demo.AdminDemoController;
import com.jfinal.club._admin.index.IndexAdminController;
import com.jfinal.club._admin.login.LoginAdminController;
import com.jfinal.club.common.upload.UploadController;
import com.jfinal.config.Routes;

/**
 * 后台管理路由
 * 注意：自 jfinal 3.0 开始，baseViewPath 改为在 Routes 中独立配置
 *      并且支持 Routes 级别的 Interceptor，这类拦截器将拦截所有
 *      在此 Routes 中添加的 Controller，行为上相当于 class 级别的拦截器
 *      Routes 级别的拦截器特别适用于后台管理这样的需要统一控制权限的场景
 *      减少了代码冗余
 */
public class AdminRoutes extends Routes {

	@Override
	public void config() {
		// 添加后台管理拦截器，将拦截在此方法中注册的所有 Controller
		addInterceptor(new AdminSessionInterface());
		addInterceptor(new ContentPathInterface());
		setBaseViewPath("/_view/_admin");

		add("/admin/login", LoginAdminController.class, "/login");
		add("/admin", IndexAdminController.class, "/index");
		add("/admin/demo", AdminDemoController.class, "/demo");
		add("/admin/ad", AdminsController.class, "/admins");
		add("/common/upload", UploadController.class);

		//home
		add("/admin/banner", AdminBannerController.class, "/data/home/banner");
		add("/admin/news", AdminNewsController.class, "/data/home/news");
		add("/admin/registration", AdminRegistrationController.class, "/data/home/registration");
		add("/admin/store", AdminStoreController.class, "/data/home/store");
		add("/admin/app_case", AdminAppcaseController.class, "/data/home/appcase");
		add("/admin/app_case_p", AdminAppCasePController.class, "/data/home/appcase/appcasep");

		//sys
		add("/admin/types", AdminTypesController.class, "/data/sys/types");
		add("/admin/seller", AdminSellerController.class, "/data/sys/seller");
		add("/admin/navbar", AdminNavbarController.class, "/data/sys/navbar");
		add("/admin/admins", AdminAdminsController.class, "/data/sys/admins");
		add("/admin/city", AdminCityController.class, "/data/sys/city");
		add("/admin/clearcache", AdminClearCacheController.class, "/data/sys/clearcache");

		//product
        add("/admin/product", AdminProductController.class, "/data/product/product");
        add("/admin/p_type", AdminPTypeController.class, "/data/product/ptype");
        add("/admin/p_material", AdminPMaterialController.class, "/data/product/pmaterial");
        add("/admin/p_color", AdminPColorController.class, "/data/product/pcolor");
        add("/admin/p_patent", AdminPPatentController.class, "/data/product/ppatent");
        add("/admin/p_style", AdminPStyleController.class, "/data/product/pstyle");
        add("/admin/p_attr", AdminPAttrController.class, "/data/product/pattr");
		add("/admin/p_title", AdminPTitleController.class, "/data/product/ptitle");
		add("/admin/p_keyhole", AdminPKeyHoleController.class, "/data/product/pkeyhole");

		// 一个产品 对 多个 数据信息
		add("/admin/color_type", AdminColorTypeController.class, "/data/product/product/colortype");
		add("/admin/axial_p", AdminAxialPController.class, "/data/product/product/axialp");
		add("/admin/attr_p", AdminAttrPController.class, "/data/product/product/attrp");
		add("/admin/attr_ext_p", AdminAttrExtPController.class, "/data/product/product/attrextp");

		//appscene
		add("/admin/photos", AdminPhotosController.class, "/data/appscene/photos");

		//search  product   store
		add("/admin/search_product_log", AdminSearchProductLogController.class, "/data/search/search_product_log");
		add("/admin/search_store_log", AdminSearchStoreLogController.class, "/data/search/search_store_log");
		add("/admin/hot_search", AdminHotSearchController.class, "/data/search/hot_search");
		//

		//资料库 info
		add("/admin/vr", AdminVrController.class, "/data/info/vr");
		add("/admin/video", AdminVideoController.class, "/data/info/video");
		add("/admin/photo", AdminPhotoController.class, "/data/info/photo");


		add("/admin/wxuser", AdminWxUserController.class, "/data/wxuser");

	}
}





