package com.jfinal.club._admin.data.appscene.photo;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Photos;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;

/**
 * @descriptions: 首页photos
 * @author: lc
 * @date: 2020-07-07 15:38:19
 * @Version: 1.0
 **/
public class AdminPhotosController extends BaseController {

    public void index(){
        Integer type = getInt("type", 1);
        Page< Photos > photos = Photos.dao.paginate(getInt("p", 1), getInt("s",Cons.ADMIN_PAGESIZE), "select * ", "from photos where type = ? order by sort desc,create_time desc",type);

        set("type", type);
        setAttr("page", photos);
    }

    public void add(){
        keepPara("type");
        render("add_edit.html");
    }

    public void save(){
        UploadFile file = getFile("filepath", Cons.APPSCENE_PHOTOS );
        Photos model = getModel(Photos.class);
        if(file != null){
            String filePath = CommonUtil.getFilePath(file, Cons.APPSCENE_PHOTOS);
            model.setImg(filePath);
        }
        if(model.getCreateTime() == null){
            model.setCreateTime(new Date());
        }
        model.save();
        renderJson(Ret.ok( ));
    }

    public void edit(){
        Photos photos = Photos.dao.findById(getInt("id"));
        set("type", photos.getType());
        set("photos",photos);
        render("add_edit.html");
    }

    public void update(){
        UploadFile file = getFile("filepath", Cons.APPSCENE_PHOTOS );
        Photos model = getModel(Photos.class);
        if(file != null){
            //删除源文件节约服务器磁盘空间
            CommonUtil.deleteFile(Photos.dao.findById(model.getId()).getImg());
            //添加新文件
            String filePath = CommonUtil.getFilePath(file, Cons.APPSCENE_PHOTOS);
            model.setImg(filePath);
        }
        model.removeNullValueAttrs().update();
        renderJson(Ret.ok( ));
    }

    public void delete(){
        Integer id = getInt("id");
        CommonUtil.deleteFile(Photos.dao.findById(id).getImg());
        Photos.dao.deleteById(id);
        renderJson(Ret.ok());
    }
}
