package com.jfinal.club._admin.data.home.appcase;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.service.TypeService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.*;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

/**
 * @descriptions: 应用案列
 * @author: lc
 * @date: 2020-07-09 11:33:33
 * @Version: 1.0
 **/
public class AdminAppcaseController extends BaseController {

    @Inject
    TypeService typeService;

    public void index( ) {
        Page< Appcase > page = Appcase.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select b.name,a.* ", "from appcase a left join types b on a.type = b.id order by a.sort desc,a.create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        set("typeList",typeService.listByType(1));
        render("add_edit.html");
    }

    public void save( ) {

        UploadFile banner = getFile("banner", Cons.HOME_APPCASE);
        UploadFile img = getFile("img", Cons.HOME_APPCASE);
        Appcase model = getModel(Appcase.class);
        if (banner != null) {
            String filePath = CommonUtil.getFilePath(banner, Cons.HOME_APPCASE);
            model.setBanner(filePath);
        }

        if (img != null) {
            String filePath = CommonUtil.getFilePath(img, Cons.HOME_APPCASE);
            model.setImg(filePath);
        }
        //将 style="" 替换成空
        if(StringUtils.isNotBlank(model.getContent())){
            model.setContent(model.getContent().replace("style=\"\"",""));
        }
        model.save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        set("typeList",typeService.listByType(1));
        set("appcase",Appcase.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile banner = getFile("banner", Cons.HOME_APPCASE);
        UploadFile img = getFile("img", Cons.HOME_APPCASE);
        Appcase model = getModel(Appcase.class);
        if (banner != null) {
            CommonUtil.deleteFile(Appcase.dao.findById(model.getId( )).getBanner( ));
            String filePath = CommonUtil.getFilePath(banner, Cons.HOME_APPCASE);
            model.setBanner(filePath);
        }

        if (img != null) {
            CommonUtil.deleteFile(Appcase.dao.findById(model.getId( )).getImg( ));
            String filePath = CommonUtil.getFilePath(img, Cons.HOME_APPCASE);
            model.setImg(filePath);
        }

        //将 style="" 替换成空
        if(StringUtils.isNotBlank(model.getContent())){
            model.setContent(model.getContent().replace("style=\"\"",""));
        }

        model.update( );
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        CommonUtil.deleteFile(Appcase.dao.findById(id).getBanner( ));
        CommonUtil.deleteFile(Appcase.dao.findById(id).getImg( ));
        Appcase.dao.deleteById(id);
        renderJson(Ret.ok());
    }

    /**
     * 失焦排序
      */
    public void blur_sort(){
        Appcase appcase = Appcase.dao.findById(getInt("id"));
        appcase.setSort(getInt("sort"));
        appcase.update();
        renderJson(Ret.ok());
    }

}
