package com.jfinal.club._admin.data.home.appcase.appcasep;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.AppcaseP;
import com.jfinal.club.common.model.AppcaseP;
import com.jfinal.club.common.model.PTitle;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;
import java.util.List;

/**
 * @descriptions: 应用案列的 款式表信息
 * @author: lc
 * @date: 2020-07-07 15:38:19
 * @Version: 1.0
 **/
public class AdminAppCasePController extends BaseController {

    public void index( ) {

        Integer appId = getInt("appId");

        Page< AppcaseP > page = AppcaseP.dao.paginate(getInt("p", 1), getInt("s", 10), "select * ", "from appcase_p where appid = ? order by sort desc ,create_time desc",appId);
        set("appId",appId);
        setAttr("page", page);
    }

    public void add( ) {
        keepPara("appId");
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile filepath = getFile("filepath", Cons.HOME_APPCASE);

        AppcaseP model = getModel(AppcaseP.class,"app_case_p");
        if(filepath != null){
            String filePath = CommonUtil.getFilePath(filepath, Cons.HOME_APPCASE);
            model.setImg(filePath);
        }
        model.setCreateTime(new Date( ));
        model.save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        keepPara("appId");
        AppcaseP appcaseP = AppcaseP.dao.findById(getInt("id"));

        set("app_case_p",appcaseP);
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile filepath = getFile("filepath", Cons.HOME_APPCASE);
        AppcaseP model = getModel(AppcaseP.class,"app_case_p");
        if(filepath != null){
            CommonUtil.deleteFile(AppcaseP.dao.findById(model.getId()).getImg());
            model.setImg(CommonUtil.getFilePath(filepath, Cons.HOME_APPCASE));
        }
        model.update( );
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        CommonUtil.deleteFile(AppcaseP.dao.findById(id).getImg());
        AppcaseP.dao.deleteById(id);
        renderJson(Ret.ok( ));
    }


}
