package com.jfinal.club._admin.data.home.banner;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Banner;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;

/**
 * @descriptions: 首页banner
 * @author: lc
 * @date: 2020-07-07 15:38:19
 * @Version: 1.0
 **/
public class AdminBannerController extends BaseController {

    public void index(){
        Page< Banner > banner = Banner.dao.paginate(getInt("p", 1), getInt("s",10), "select * ", "from banner order by sort desc,create_time desc");
        setAttr("page", banner);
    }

    public void add(){
        render("add_edit.html");
    }

    public void save(){
        UploadFile file = getFile("filepath", Cons.HOME_BANNER );
        Banner model = getModel(Banner.class);
        if(file != null){
            String filePath = CommonUtil.getFilePath(file, Cons.HOME_BANNER);
            model.setImg(filePath);
        }
        if(model.getCreateTime() == null){
            model.setCreateTime(new Date());
        }
        model.save();
        renderJson(Ret.ok( ));
    }

    public void edit(){
        set("banner",Banner.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update(){
        UploadFile file = getFile("filepath", Cons.HOME_BANNER );
        Banner model = getModel(Banner.class);
        if(file != null){
            //删除源文件节约服务器磁盘空间
            CommonUtil.deleteFile(Banner.dao.findById(model.getId()).getImg());
            //添加新文件
            String filePath = CommonUtil.getFilePath(file, Cons.HOME_BANNER);
            model.setImg(filePath);
        }
        model.update();
        renderJson(Ret.ok( ));
    }

    public void delete(){
        Integer id = getInt("id");
        CommonUtil.deleteFile(Banner.dao.findById(id).getImg());
        Banner.dao.deleteById(id);
        renderJson(Ret.ok());
    }
}
