package com.jfinal.club._admin.data.home.news;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.News;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.apache.commons.lang3.time.DateUtils;

import java.util.Date;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-07 17:47:10
 * @Version: 1.0
 **/
public class AdminNewsController extends BaseController {

    public void index(){
        Page< News > page = News.dao.paginate(getInt("p", 1), getInt("s",10), "select * ", "from news order by recommend desc,sort desc,create_time desc");
        setAttr("page", page);
        render("index.html");
    }

    public void add(){
        String nowDate = DateFormatUtils.format(new Date( ), "yyyy-MM-dd");
        set("nowDate",nowDate);
        render("add_edit.html");
    }

    public void save(){
        UploadFile filepath = getFile("filepath", Cons.HOME_NEWS);
        News model = getModel(News.class);

        if(filepath != null){
            String filePath = CommonUtil.getFilePath(filepath, Cons.HOME_NEWS);
            model.setImg(filePath);
        }

        if(model.getPubdate() == null){
            model.setPubdate(new Date());
        }

        //将 style="" 替换成空
        if(StringUtils.isNotBlank(model.getContent())){
            model.setContent(model.getContent().replace("style=\"\"",""));
        }

        model.setCreateTime(new Date());
        model.setFace(0);
        model.save();
        renderJson(Ret.ok( ));
    }

    public void edit(){
        set("news",News.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update(){
        UploadFile filepath = getFile("filepath", Cons.HOME_NEWS);
        News model = getModel(News.class);
        if(filepath != null){
            CommonUtil.deleteFile(News.dao.findById(model.getId()).getImg());
            String filePath = CommonUtil.getFilePath(filepath, Cons.HOME_NEWS);
            model.setImg(filePath);
        }
        if(model.getPubdate() == null){
            model.setPubdate(new Date());
        }
        //将 style="" 替换成空
        if(StringUtils.isNotBlank(model.getContent())){
            model.setContent(model.getContent().replace("style=\"\"",""));
        }
        model.update();
        renderJson(Ret.ok( ));
    }

    public void delete(){
        News news = News.dao.findById(getInt("id"));
        if(news.getFace() == 1){
            renderJson(Ret.fail("msg","请将海报设置其他数据后删除！"));
        }else {
            CommonUtil.deleteFile(News.dao.findById(getInt("id")).getImg());
            News.dao.deleteById(getInt("id"));
            renderJson(Ret.ok( ));
        }
    }


    public void face_t(){
        Db.update("update news a set a.face = 0 ");
        News.dao.findById(getInt("id")).set("face",1).removeNullValueAttrs().update();
        index();
    }

    public void recommend_t(){
        News.dao.findById(getInt("id")).set("recommend",1).removeNullValueAttrs().update();
        index();
    }

    public void recommend_f(){
        News.dao.findById(getInt("id")).set("recommend",0).removeNullValueAttrs().update();
        index();
    }
}
