package com.jfinal.club._admin.data.home.registration;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.product.AdminExcelService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.RegistrationForm;
import com.jfinal.club.common.model.RegistrationForm;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.PathKit;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.time.DateFormatUtils;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Date;

/**
 * @descriptions: 展会登记表
 * @author: lc
 * @date: 2020-10-24 17:47:10
 * @Version: 1.0
 **/
public class AdminRegistrationController extends BaseController {

    @Inject
    AdminExcelService excelService;

    public void index(){
        Page< RegistrationForm > page = RegistrationForm.dao.paginate(getInt("p", 1), getInt("s",10), "select * ", "from registration_form order by create_time desc");
        setAttr("page", page);
        render("index.html");
    }

    public void detail(){
        set("r",RegistrationForm.dao.findById(getInt("id")));
        render("detail.html");

    }

    public void export() throws UnsupportedEncodingException {
        //导出表
        excelService.createExcel();
        //2 下载
        File file = new File(PathKit.getWebRootPath( ), "upload" + Cons.EXPORT_SERVICE_NETWORK);
        renderFile(file, URLEncoder.encode(file.getName(),"utf-8"));
    }

    public void delete(){
        RegistrationForm.dao.deleteById(getInt("id"));
        renderJson(Ret.ok( ));
    }

}
