package com.jfinal.club._admin.data.info;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Photo;
import com.jfinal.club.common.model.Photo;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;

/**
 * @descriptions:  资料库 -> 图册管理
 * @author: lc
 * @date: 2020-07-23 18:58:33
 * @Version: 1.0
 **/
public class AdminPhotoController extends BaseController {
    public void index( ) {
        
        Page< Photo > page = Photo.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select *", "from photo group by sort desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile filepath = getFile("filepath", Cons.INFO_PHOTO);
        Photo model = getModel(Photo.class);
        if (filepath != null) {
            model.setImgUrl(CommonUtil.getFilePath(filepath, Cons.INFO_PHOTO));
        }
        //将 style="" 替换成空
        if(StringUtils.isNotBlank(model.getDetail())){
            model.setDetail(model.getDetail().replace("style=\"\"",""));
        }
        model.setCreateTime(new Date( ));
        model.save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        set("photo", Photo.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile filepath = getFile("filepath", Cons.INFO_PHOTO);
        Photo model = getModel(Photo.class);
        if (filepath != null) {
            CommonUtil.deleteFile(Photo.dao.findById(model.getId( )).getImgUrl( ));
            model.setImgUrl(CommonUtil.getFilePath(filepath, Cons.INFO_PHOTO));
        }
        //将 style="" 替换成空
        if(StringUtils.isNotBlank(model.getDetail())){
            model.setDetail(model.getDetail().replace("style=\"\"",""));
        }
        model.update( );
        renderJson(Ret.ok( ));
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        Photo photo = Photo.dao.findById(id);
        CommonUtil.deleteFile(photo.getImgUrl( ));
        Photo.dao.deleteById(id);
        renderJson(Ret.ok( ));
    }
}
