package com.jfinal.club._admin.data.info;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.News;
import com.jfinal.club.common.model.Video;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-23 18:57:37
 * @Version: 1.0
 **/
public class AdminVideoController extends BaseController {

    public void index( ) {
        Page< Video > page = Video.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select *", "from video group by sort desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile filepath = getFile("filepath", Cons.INFO_VIDEO);
        UploadFile filepaths = getFile("filepaths", Cons.INFO_VIDEO);
        Video model = getModel(Video.class);
        if (filepath != null) {
            model.setPosterUrl(CommonUtil.getFilePath(filepath, Cons.INFO_VIDEO));
        }
        if (filepaths != null) {
            model.setVideoUrl(CommonUtil.getFilePath(filepaths, Cons.INFO_VIDEO));
        }

        model.setCreateTime(new Date( ));
        model.save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        set("video", Video.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile filepath = getFile("filepath", Cons.INFO_VIDEO);
        UploadFile filepaths = getFile("filepaths", Cons.INFO_VIDEO);
        Video model = getModel(Video.class);
        if (filepath != null) {
            CommonUtil.deleteFile(Video.dao.findById(model.getId( )).getPosterUrl( ));
            model.setPosterUrl(CommonUtil.getFilePath(filepath, Cons.INFO_VIDEO));
        }
        if (filepaths != null) {
            CommonUtil.deleteFile(Video.dao.findById(model.getId( )).getVideoUrl( ));
            model.setVideoUrl(CommonUtil.getFilePath(filepaths, Cons.INFO_VIDEO));
        }

        model.update( );
        renderJson(Ret.ok( ));
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        Video video = Video.dao.findById(id);
        CommonUtil.deleteFile(video.getPosterUrl( ));
        CommonUtil.deleteFile(video.getVideoUrl( ));
        Video.dao.deleteById(id);
        renderJson(Ret.ok( ));
    }
}
