package com.jfinal.club._admin.data.info;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Vr;
import com.jfinal.club.common.model.Vr;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;

/**
 * @descriptions:  资料库 -> 图册管理
 * @author: lc
 * @date: 2020-07-23 18:58:33
 * @Version: 1.0
 **/
public class AdminVrController extends BaseController {
    public void index( ) {

        Page< Vr > page = Vr.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select *", "from vr group by sort desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile filepath = getFile("filepath", Cons.INFO_VR);
        Vr model = getModel(Vr.class);
        if (filepath != null) {
            model.setImgUrl(CommonUtil.getFilePath(filepath, Cons.INFO_VR));
        }

        model.setCreateTime(new Date( ));
        model.save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        set("vr", Vr.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile filepath = getFile("filepath", Cons.INFO_VR);
        Vr model = getModel(Vr.class);
        if (filepath != null) {
            CommonUtil.deleteFile(Vr.dao.findById(model.getId( )).getImgUrl( ));
            model.setImgUrl(CommonUtil.getFilePath(filepath, Cons.INFO_VR));
        }

        model.update( );
        renderJson(Ret.ok( ));
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        Vr vr = Vr.dao.findById(id);
        CommonUtil.deleteFile(vr.getImgUrl( ));
        Vr.dao.deleteById(id);
        renderJson(Ret.ok( ));
    }
}
