package com.jfinal.club._admin.data.product.pattr;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.AdminProductService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.PAttr;
import com.jfinal.club.common.model.PAttr;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.common.model.Store;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;
import java.util.List;

/**
 * @descriptions: 产品类型
 * @author: lc
 * @date: 2020-07-10 15:49:26
 * @Version: 1.0
 **/
public class AdminPAttrController extends BaseController {

    @Inject
    AdminProductService adminProductService;

    public void index( ) {

        Page< PAttr > page = PAttr.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", "from p_attr order by sort desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile file = getFile("filepath", Cons.PRODUCT_PATTR);
        PAttr model = getModel(PAttr.class,"p_attr");
        if(file != null){
            //添加新文件
            String filePath = CommonUtil.getFilePath(file, Cons.PRODUCT_PATTR);
            model.setImg(filePath);
        }

        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("p_attr", PAttr.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile file = getFile("filepath", Cons.PRODUCT_PATTR);
        PAttr model = getModel(PAttr.class,"p_attr");
        if(file != null){
            //删除源文件节约服务器磁盘空间
            CommonUtil.deleteFile(PAttr.dao.findById(model.getId()).getImg());
            String filePath = CommonUtil.getFilePath(file, Cons.PRODUCT_PATTR);
            model.setImg(filePath);
        }
        model.update();
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        List< Product > productList = adminProductService.listByPAttr(id);
        if (productList != null && productList.size( ) > 0) {
            renderJson(Ret.fail("msg", "请删除该类型下的所有产品信息!"));
        } else {
            CommonUtil.deleteFile(PAttr.dao.findById(id).getImg());
            PAttr.dao.deleteById(id);
            renderJson(Ret.ok("msg", "删除成功!"));
        }
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        PAttr appcase = PAttr.dao.findById(getInt("id"));
        appcase.setSort(getInt("sort"));
        appcase.update();
        renderJson(Ret.ok());
    }


    /**
     * 设置前台显示
     */
    public void show_t(){
        PAttr attr = PAttr.dao.findById(getInt("id"));
        attr.setShow(0);
        attr.update();
        renderNull();
    }

    public void show_f(){
        PAttr attr = PAttr.dao.findById(getInt("id"));
        attr.setShow(1);
        attr.update();
        renderNull();
    }
}
