package com.jfinal.club._admin.data.product.pkeyhole;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.AdminProductService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.PKeyhole;
import com.jfinal.club.common.model.PKeyhole;
import com.jfinal.club.common.model.PMaterial;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @descriptions: 钥匙孔
 * @author: lc
 * @date: 2020-07-10 15:49:26
 * @Version: 1.0
 **/
public class AdminPKeyHoleController extends BaseController {

    @Inject
    AdminProductService adminProductService;

    public void index( ) {

        Page< PKeyhole > page = PKeyhole.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), " select * "," from p_keyhole order by sort desc,create_time desc ");
        set("material",PMaterial.dao.find("select * from p_material order by sort desc,create_time desc"));
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile file = getFile("filepath",Cons.KEYHOLE);

        PKeyhole model = getModel(PKeyhole.class,"p_keyhole");

        if(file != null){
            model.setImg(CommonUtil.getFilePath(file,Cons.KEYHOLE));
        }

        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("p_keyhole", PKeyhole.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile file = getFile("filepath",Cons.KEYHOLE);
        PKeyhole model = getModel(PKeyhole.class, "p_keyhole");
        if(file != null){
            CommonUtil.deleteFile(PKeyhole.dao.findById(model.getId()).getImg());
            model.setImg(CommonUtil.getFilePath(file,Cons.KEYHOLE));
        }
        model.update( );
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        List< Product > productList = adminProductService.listByPKeyhole(id);
        if (productList != null && productList.size( ) > 0) {
            renderJson(Ret.fail("msg", "请删除该类型下的所有产品信息!"));
        } else {
            PKeyhole.dao.deleteById(id);
            renderJson(Ret.ok("msg", "删除成功!"));
        }
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        PKeyhole appcase = PKeyhole.dao.findById(getInt("id"));
        if(appcase != null){
            appcase.setSort(getInt("sort"));
            appcase.update();
        }
        renderJson(Ret.ok());
    }
}
