package com.jfinal.club._admin.data.product.pmaterial;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.AdminProductService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.PMaterial;
import com.jfinal.club.common.model.PMaterial;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;

import java.util.Date;
import java.util.List;

/**
 * @descriptions: 产品类型
 * @author: lc
 * @date: 2020-07-10 15:49:26
 * @Version: 1.0
 **/
public class AdminPMaterialController extends BaseController {

    @Inject
    AdminProductService adminProductService;

    public void index( ) {
        
        Page< PMaterial > page = PMaterial.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", "from p_material order by sort desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        PMaterial model = getModel(PMaterial.class,"p_material");
        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("p_material", PMaterial.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        getModel(PMaterial.class,"p_material").update( );
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        List< Product > productList = adminProductService.listByPMaterial(id);
        if (productList != null && productList.size( ) > 0) {
            renderJson(Ret.fail("msg", "请删除该类型下的所有产品信息!"));
        } else {
            PMaterial.dao.deleteById(id);
            renderJson(Ret.ok("msg", "删除成功!"));
        }
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        PMaterial appcase = PMaterial.dao.findById(getInt("id"));
        appcase.setSort(getInt("sort"));
        appcase.update();
        renderJson(Ret.ok());
    }
}
