package com.jfinal.club._admin.data.product.product;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.AdminProductService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.*;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.club.vo.ExcelUploadResultVo;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-17 14:04:10
 * @Version: 1.0
 **/
public class AdminProductController extends BaseController {

    @Inject
    AdminExcelService excelService;

    public void index( ) {

        Integer type = getInt("type",-1);
        String searchName = get("searchName","");

        set("type",type);
        set("searchName",searchName);

        ArrayList< Object > param = new ArrayList<>( );

        String sql = " FROM ( SELECT c.name title,b.name,b.knob ,d.code,d.color_cn,a.* FROM product a LEFT JOIN p_type b ON a.p_type = b.id LEFT JOIN p_title c ON a.p_title = c.id LEFT JOIN p_color d ON a.p_color = d.id ) a where 1=1 ";

        if(type != -1){
            sql += " and p_type = ? ";
            param.add(type);
        }

        if(StringUtils.isNotBlank(searchName)){
            searchName = "%"+searchName.trim()+"%";
            sql += " and ( model like ? or p_code like ? )";
            param.add(searchName);
            param.add(searchName);
        }

        sql += " order by a.p_type asc,a.sort desc,a.model asc,a.a.subsort desc,create_time DESC ";

        Page< Product > page = Product.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", sql,param.toArray());
        set("page", page);
        set("ptypes",PType.dao.find("select * from p_type order by sort desc,create_time desc"));
        render("index.html");
    }

    public void add( ) {
        keepPara("searchName","type","p","s");
        // 0 款式 单选
        List< PTitle > pTitles = PTitle.dao.find("select * from p_title order by sort,create_time desc");
        set("pTitles",pTitles);
        //1产品类型列表(单选)
        List< PType > pTypes = PType.dao.find("select * from p_type order by sort desc,create_time desc");
        set("ptypes",pTypes);
        //2 产品材质(单选)
        List< PMaterial > pMaterials = PMaterial.dao.find("select * from p_material order by sort desc,create_time desc");
        set("pMaterials",pMaterials);
        //3 产品颜色 (单选)
        List< PColor > pColors = PColor.dao.find("select id,concat(code,\" \",color_cn) name from p_color order by sort desc,create_time desc");
        set("pColors",pColors);
        //4 产品专利p_patent
        List< PPatent > pPatents = PPatent.dao.find("select * from p_patent order by sort desc,create_time desc");
        set("pPatents",pPatents);
        //4.5产品属性
        List< PAttr > pAttrs = PAttr.dao.find("select * from p_attr order by sort desc,create_time desc");
        set("pAttrs",pAttrs);
        // 5 产品系列
        List< PStyle > pStyles = PStyle.dao.find("select * from p_style order by sort desc,create_time desc");
        set("pStyles",pStyles);

        //6 锁孔设置
        List< PKeyhole > pKeyholes = PKeyhole.dao.find("select * from p_keyhole order by sort desc,create_time desc");
        set("pKeyholes",pKeyholes);

        render("add_edit.html");
    }

    public void save( ) {
        UploadFile file = getFile("filepath",Cons.PRODUCT_PRODUCT);
        UploadFile file1 = getFile("filepath1",Cons.PRODUCT_PRODUCT);
        UploadFile file2= getFile("filepath2",Cons.PRODUCT_PRODUCT);
        UploadFile file3= getFile("filepath3",Cons.PRODUCT_PRODUCT);
        UploadFile file4= getFile("filepath4",Cons.PRODUCT_PRODUCT);
        Product model = getModel(Product.class);

/*        String[] parameterValues = getRequest( ).getParameterValues("product.p_color");
        if(parameterValues != null){
            String join = StringUtils.join(parameterValues, ",");
            model.setPColor(join);
        }*/

        String[] p_patents = getRequest( ).getParameterValues("product.p_patent");
        if(p_patents != null){
            String join = StringUtils.join(p_patents, ",");
            model.setPPatent(join);
        }
        String[] p_attrs = getRequest( ).getParameterValues("product.p_attr");
        if(p_attrs != null){
            String join = StringUtils.join(p_attrs, ",");
            model.setPAttr(join);
        }


        if(file != null){
            model.setCoverImg(CommonUtil.getFilePath(file,Cons.PRODUCT_PRODUCT));
        }
        if(file1 != null){
            model.setImg(CommonUtil.getFilePath(file1,Cons.PRODUCT_PRODUCT));
        }
        if(file2 != null){
            model.setImgKeyhole(CommonUtil.getFilePath(file2,Cons.PRODUCT_PRODUCT));
        }
        if(file3 != null){
            model.setImgSample(CommonUtil.getFilePath(file3,Cons.PRODUCT_PRODUCT));
        }

        if(file4 != null){
            model.setImgKnob(CommonUtil.getFilePath(file4,Cons.PRODUCT_PRODUCT));
        }
        model.set("create_time",new Date()).set("modified_time",new Date()).save();
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        keepPara("searchName","type","p","s");

        Integer id = getInt("id");
        Product product = Product.dao.findById(id);

        // 0 款式 单选
        List< PTitle > pTitles = PTitle.dao.find("select * from p_title order by sort,create_time desc");
        set("pTitles",pTitles);
        //1产品类型列表(单选)
        List< PType > pTypes = PType.dao.find("select * from p_type order by sort desc,create_time desc");
        set("ptypes",pTypes);
        //2 产品材质(单选)
        List< PMaterial > pMaterials = PMaterial.dao.find("select * from p_material order by sort desc,create_time desc");
        set("pMaterials",pMaterials);
        //3 产品颜色 (单选)
        List< PColor > pColors = PColor.dao.find("select id,concat(code,\" \",color_cn) name from p_color where material_id = ? order by sort desc,create_time desc",product.getPMaterial());
        set("pColors",pColors);
        //4 产品专利p_patent
        List< PPatent > pPatents = PPatent.dao.find("select * from p_patent order by sort desc,create_time desc");
        set("pPatents",pPatents);
        //4.5产品属性
        List< PAttr > pAttrs = PAttr.dao.find("select * from p_attr order by sort desc,create_time desc");
        set("pAttrs",pAttrs);
        // 5 产品系列
        List< PStyle > pStyles = PStyle.dao.find("select * from p_style order by sort desc,create_time desc");
        set("pStyles",pStyles);
        //6 锁孔设置
        List< PKeyhole > pKeyholes = PKeyhole.dao.find("select * from p_keyhole order by sort desc,create_time desc");
        set("pKeyholes",pKeyholes);



        PType byId = PType.dao.findById(product.getPType( ));
        set("isknob",byId.getKnob() == 1?true:false);

/*        if(StringUtils.isNotBlank(product.getPColor())){
            List< String > list = Arrays.asList(StringUtils.splitPreserveAllTokens(product.getPColor( ), ","));
            pColors.forEach(a->{
                list.forEach(b->{
                   if(a.getId().equals(Integer.valueOf(b))){
                       a.put("active",1);
                   }
                });
            });
        }*/

        if(StringUtils.isNotBlank(product.getPAttr())){
            List< String > list = Arrays.asList(StringUtils.splitPreserveAllTokens(product.getPAttr( ), ","));
            pAttrs.forEach(a->{
                list.forEach(b->{
                    if(a.getId().equals(Integer.valueOf(b))){
                        a.put("active",1);
                    }
                });
            });
        }

        if(StringUtils.isNotBlank(product.getPPatent())){
            List< String > list = Arrays.asList(StringUtils.splitPreserveAllTokens(product.getPPatent( ), ","));
            pPatents.forEach(a->{
                list.forEach(b->{
                    if(a.getId().equals(Integer.valueOf(b))){
                        a.put("active",1);
                    }
                });
            });
        }



        set("product",product);
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile file = getFile("filepath",Cons.PRODUCT_PRODUCT);
        UploadFile file1 = getFile("filepath1",Cons.PRODUCT_PRODUCT);
        UploadFile file2= getFile("filepath2",Cons.PRODUCT_PRODUCT);
        UploadFile file3= getFile("filepath3",Cons.PRODUCT_PRODUCT);
        UploadFile file4= getFile("filepath4",Cons.PRODUCT_PRODUCT);

        Product model = getModel(Product.class);
/*        String[] parameterValues = getRequest( ).getParameterValues("product.p_color");
        if(parameterValues != null){
            String join = StringUtils.join(parameterValues, ",");
            model.setPColor(join);
        }*/

        String[] p_patents = getRequest( ).getParameterValues("product.p_patent");
        if(p_patents != null){
            String join = StringUtils.join(p_patents, ",");
            model.setPPatent(join);
        }else{
            model.setPPatent("");
        }

        String[] p_attrs = getRequest( ).getParameterValues("product.p_attr");
        if(p_attrs != null){
            String join = StringUtils.join(p_attrs, ",");
            model.setPAttr(join);
        }else{
            model.setPAttr("");
        }


        if(file != null){
            CommonUtil.deleteFile(Product.dao.findById(model.getId()).getCoverImg());
            model.setCoverImg(CommonUtil.getFilePath(file,Cons.PRODUCT_PRODUCT));
        }
        if(file1 != null){
            CommonUtil.deleteFile(Product.dao.findById(model.getId()).getImg());
            model.setImg(CommonUtil.getFilePath(file1,Cons.PRODUCT_PRODUCT));
        }
        if(file2 != null){
            CommonUtil.deleteFile(Product.dao.findById(model.getId()).getImgKeyhole());
            model.setImgKeyhole(CommonUtil.getFilePath(file2,Cons.PRODUCT_PRODUCT));
        }
        if(file3 != null){
            CommonUtil.deleteFile(Product.dao.findById(model.getId()).getImgSample());
            model.setImgSample(CommonUtil.getFilePath(file3,Cons.PRODUCT_PRODUCT));
        }

        if(file4 != null){
            CommonUtil.deleteFile(Product.dao.findById(model.getId()).getImgKnob());
            model.setImgKnob(CommonUtil.getFilePath(file4,Cons.PRODUCT_PRODUCT));
        }

        model.set("modified_time",new Date()).update();
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        Product product = Product.dao.findById(id);
        CommonUtil.deleteFile(product.getCoverImg());
        CommonUtil.deleteFile(product.getImg());
        //CommonUtil.deleteFile(product.getImgKeyhole());
        CommonUtil.deleteFile(product.getImgSample());
        CommonUtil.deleteFile(product.getImgKnob());
        //删除颜色分类 表
        List< ColorTypeP > colorTypePS = ColorTypeP.dao.find("select * from color_type_p where pid = ? ", product.getId( ));
        if(colorTypePS != null && colorTypePS.size() > 0){
            for (ColorTypeP colorTypeP : colorTypePS) {
                CommonUtil.deleteFile(colorTypeP.getImg());
                ColorTypeP.dao.deleteById(colorTypeP.getId());
            }
        }
        //删除轴长 轴长表
        List< AxialP > axialPS = AxialP.dao.find("select * from axial_p where pid = ? ", product.getId( ));
        if(axialPS != null && axialPS.size() > 0){
            for (AxialP axialP : axialPS) {
                CommonUtil.deleteFile(axialP.getImg());
                AxialP.dao.deleteById(axialP.getId());
            }
        }
        //删除产品属性 表
        List< AttrP > attrPS = AttrP.dao.find("select * from attr_p where pid = ? ", product.getId( ));
        if(attrPS != null && attrPS.size() > 0){
            for (AttrP attrP : attrPS) {
                CommonUtil.deleteFile(attrP.getImg());
                AttrP.dao.deleteById(attrP.getId());
            }
        }
        //删除扩展属性 表
        List< AttrExtP > attrExtPS = AttrExtP.dao.find("select * from attr_ext_p where pid = ? ", product.getId( ));
        if(attrExtPS != null && attrExtPS.size() > 0){
            for (AttrExtP attrExtP : attrExtPS) {
                AttrExtP.dao.deleteById(attrExtP.getId());
            }
        }
        Product.dao.deleteById(id);
        renderJson(Ret.ok());
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        Product p = Product.dao.findById(getInt("id"));
        if(p!=null){
            p.setSort(getInt("sort"));
            p.update();
        }
        renderJson(Ret.ok());
    }

    /**
     * 重叠排序失焦排序
     */
    public void blur_subsort(){
        Product p = Product.dao.findById(getInt("id"));
        if(p!=null){
            p.setSubsort(getInt("subsort"));
            p.update();
        }
        renderJson(Ret.ok());
    }


    /**
     * 判断是否 是门把手
     */
    public void isKnob(){
        Integer id = getInt("id");
        PType byId = PType.dao.findById(id);
        if(byId.getKnob() == 1){
            renderJson(Ret.ok());
        }else{
            renderJson(Ret.fail());
        }
    }




    /**
     * 导入
     * 文件上传
     */
    public void fileUpload( ) {
        UploadFile file = getFile("file");
        if (file == null) {
            renderJson("msg", "请选择导入文件!");
            return;
        }
        File file1 = file.getFile( );
        ExcelUploadResultVo vo = excelService.fileUpload(file1);
        CommonUtil.setCache("dealerExportVo", vo);
        //删除文件
        file1.delete( );
        renderJson(Ret.ok("data", vo));
    }

    public void color(){
        Integer materiaId = getInt("id");
        List< PColor > colorList = PColor.dao.find("select id,CONCAT(code,\" \",color_cn) name from p_color where material_id = ? ", materiaId);
        renderJson(Ret.ok("data",colorList));
    }
}
