package com.jfinal.club._admin.data.product.product.attrextp;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.AttrExtP;
import com.jfinal.club.common.model.AttrExtP;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;

/**
 * @descriptions: 属性分类
 * @author: lc
 * @date: 2020-07-17 15:10:27
 * @Version: 1.0
 **/
public class AdminAttrExtPController extends BaseController {


    public void index( ) {
        Integer pid = getInt("pid");
        Page< AttrExtP > page = AttrExtP.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", " from attr_ext_p where pid = ? order by sort desc,create_time desc",pid);
        set("page", page);
        set("pid", pid);
        render("index.html");
    }

    public void add( ) {
        keepPara("pid");
        render("add_edit.html");
    }

    public void save( ) {
        AttrExtP model = getModel(AttrExtP.class,"attr_ext_p");
        model.set("create_time",new Date()).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        keepPara("pid");
        Integer id = getInt("id");
        set("attr_ext_p", AttrExtP.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        AttrExtP model = getModel(AttrExtP.class,"attr_ext_p");
        model.update();
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        AttrExtP.dao.deleteById(id);
        renderJson(Ret.ok( ));
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        AttrExtP p = AttrExtP.dao.findById(getInt("id"));
        p.setSort(getInt("sort"));
        p.update();
        renderJson(Ret.ok());
    }
}
