package com.jfinal.club._admin.data.product.product.colortype;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.ColorTypeP;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;

/**
 * @descriptions: 颜色分类
 * @author: lc
 * @date: 2020-07-17 15:10:27
 * @Version: 1.0
 **/
public class AdminColorTypeController extends BaseController {


    public void index( ) {
        Integer pid = getInt("pid");
        Page< ColorTypeP > page = ColorTypeP.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", " from color_type_p where pid = ? order by sort desc,create_time desc",pid);
        set("page", page);
        set("pid", pid);
        render("index.html");
    }

    public void add( ) {
        keepPara("pid");
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile filepath = getFile("filepath", Cons.PRODUCT_COLORTYPE);
        ColorTypeP model = getModel(ColorTypeP.class,"color_type");
        if(filepath != null){
            model.setImg(CommonUtil.getFilePath(filepath, Cons.PRODUCT_COLORTYPE));
        }
        model.set("create_time",new Date()).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        keepPara("pid");
        Integer id = getInt("id");
        set("color_type", ColorTypeP.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile filepath = getFile("filepath", Cons.PRODUCT_COLORTYPE);
        ColorTypeP model = getModel(ColorTypeP.class,"color_type");
        if(filepath != null){
            CommonUtil.deleteFile(ColorTypeP.dao.findById(model.getId()).getImg());
            model.setImg(CommonUtil.getFilePath(filepath, Cons.PRODUCT_COLORTYPE));
        }
        model.update();
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Integer id = getInt("id");
        CommonUtil.deleteFile(ColorTypeP.dao.findById(id).getImg());
        ColorTypeP.dao.deleteById(id);
        renderJson(Ret.ok( ));
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        ColorTypeP p = ColorTypeP.dao.findById(getInt("id"));
        p.setSort(getInt("sort"));
        p.update();
        renderJson(Ret.ok());
    }
}
