package com.jfinal.club._admin.data.product.ptitle;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.AdminProductService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.PTitle;
import com.jfinal.club.common.model.PTitle;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;

import java.util.Date;
import java.util.List;

/**
 * @descriptions: 款式表  标题表
 * @author: lc
 * @date: 2020-07-10 15:49:26
 * @Version: 1.0
 **/
public class AdminPTitleController extends BaseController {

    @Inject
    AdminProductService adminProductService;

    public void index( ) {
        Page< PTitle > page = PTitle.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", "from p_title order by sort desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        PTitle model = getModel(PTitle.class,"p_title");

        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("p_title", PTitle.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        PTitle model = getModel(PTitle.class,"p_title");
        model.update();
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        List< Product > productList = adminProductService.listByPTitle(id);
        if (productList != null && productList.size( ) > 0) {
            renderJson(Ret.fail("msg", "请删除该类型下的所有产品信息!"));
        } else {
            PTitle.dao.deleteById(id);
            renderJson(Ret.ok("msg", "删除成功!"));
        }
    }

    /**
     * 失焦排序
     */
    public void blur_sort(){
        PTitle pTitle = PTitle.dao.findById(getInt("id"));
        pTitle.setSort(getInt("sort"));
        pTitle.update();
        renderJson(Ret.ok());
    }
}
