package com.jfinal.club._admin.data.search;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.HotSearch;
import com.jfinal.club.common.model.HotSearch;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;

import java.util.Date;

/**
 * @descriptions: 热门搜索
 * @author: lc
 * @date: 2020-07-22 14:35:02
 * @Version: 1.0
 **/
public class AdminHotSearchController extends BaseController {


    public void index( ) {
        
        Page< HotSearch > page = HotSearch.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", "from hot_search order by create_time desc");
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        HotSearch model = getModel(HotSearch.class,"hot_search");
        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("hot_search", HotSearch.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        HotSearch model = getModel(HotSearch.class,"hot_search");
        model.update();
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        HotSearch.dao.deleteById(id);
        renderJson(Ret.ok("msg", "删除成功!"));
    }

}
