package com.jfinal.club._admin.data.search;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.SearchProductLog;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.plugin.activerecord.Record;

import java.util.Date;
import java.util.List;

/**
 * @descriptions: 产品搜索日志
 * @author: lc
 * @date: 2020-07-10 15:49:26
 * @Version: 1.0
 **/
public class AdminSearchProductLogController extends BaseController {

    /**
     * 统计图之圆柱图
     */
    public void index( ) {
        Page< SearchProductLog > page = SearchProductLog.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", "from search_product_log order by result desc,create_time desc");
        set("page", page);
        render("index.html");
    }

    public void echar(){
        List< Record > reportList = Db.find(" SELECT COUNT(*) amount,keyword FROM search_product_log GROUP BY  keyword  ORDER BY amount DESC LIMIT 10 ");
        String data = "";
        if(reportList != null && reportList.size() > 0){
            for (int i = 0; i < reportList.size(); i++) {
                Record record = reportList.get(i);
                if(i < reportList.size() - 1){
                    data += "\""+record.get("keyword")+"\""+",";
                }else{
                    data += "\""+record.get("keyword")+"\"";
                }
            }
        }
        set("data",data);
        set("reportList",reportList);
        render("echar.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        SearchProductLog model = getModel(SearchProductLog.class,"search_product_log");
        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("search_product_log", SearchProductLog.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        SearchProductLog model = getModel(SearchProductLog.class,"search_product_log");
        model.update();
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        SearchProductLog.dao.deleteById(id);
        renderJson(Ret.ok("msg", "删除成功!"));
    }

}
