package com.jfinal.club._admin.data.search;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.SearchStoreLog;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.plugin.activerecord.Record;

import java.util.Date;
import java.util.List;

/**
 * @descriptions: 产品搜索日志
 * @author: lc
 * @date: 2020-07-10 15:49:26
 * @Version: 1.0
 **/
public class AdminSearchStoreLogController extends BaseController {

    public void index( ) {
        Page< SearchStoreLog > page = SearchStoreLog.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select * ", "from search_store_log order by result desc,create_time desc");
        set("page", page);
        render("index.html");
    }


    public void echar( ) {
        List< Record > reportList = Db.find(" SELECT COUNT(*) amount,keyword FROM search_store_log GROUP BY  keyword  ORDER BY amount DESC LIMIT 10 ");
        String data = "";
        if (reportList != null && reportList.size( ) > 0) {
            for (int i = 0; i < reportList.size( ); i++) {
                Record record = reportList.get(i);
                if (i < reportList.size( ) - 1) {
                    data += "\"" + record.get("keyword") + "\"" + ",";
                } else {
                    data += "\"" + record.get("keyword") + "\"";
                }
            }
        }
        set("data", data);
        set("reportList", reportList);
        render("echar.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        SearchStoreLog model = getModel(SearchStoreLog.class, "search_store_log");
        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("search_store_log", SearchStoreLog.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        SearchStoreLog model = getModel(SearchStoreLog.class, "search_store_log");
        model.update( );
        renderJson(Ret.ok( ));
    }


    public void delete( ) {
        Integer id = getInt("id");
        SearchStoreLog.dao.deleteById(id);
        renderJson(Ret.ok("msg", "删除成功!"));
    }

}
