package com.jfinal.club._admin.data.sys;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Area;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;

/**
 * @descriptions: 城市设置
 * @author: lc
 * @date: 2020-07-25 13:57:57
 * @Version: 1.0
 **/
public class AdminCityController extends BaseController {

    public void index( ) {
        String searchName = get("searchName");
        String tp = get("tp");
        set("tp",tp);
        set("searchName",searchName);
        String sql = " FROM ( ";
        sql += " SELECT id,city,remark,hot,sort FROM area WHERE TYPE = 02  and city != '省直辖县级行政区划' AND city != '省直辖县级行政单位' AND city != '自治区直辖县级行政区划'   ";
        ArrayList< Object > param = new ArrayList<>( );
        if (StringUtils.isNotBlank(searchName)) {
            searchName = "%"+searchName.trim( )+"%";
            sql += " AND city LIKE ? ";
            param.add(searchName);
        }
        if(StringUtils.isNotBlank(tp)){
            sql += " and remark = ? ";
            param.add(tp);
        }
        sql += " ) temp ORDER by hot desc , remark asc ,sort desc";
        Page< Area > page = Area.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), " select * ", sql, param.toArray( ));
        set("page", page);
        render("index.html");
    }

    public void edit( ) {
        Integer id = getInt("id");
        set("city", Area.dao.findById(id));
        render("add_edit.html");
    }

    public void update( ) {
        Area model = getModel(Area.class,"city");

        String city = model.getCity( );


        model.update();
        renderJson(Ret.ok( ));
    }


    /**
     * 失焦排序
     */
    public void blur_sort(){
        Area p = Area.dao.findById(getInt("id"));
        p.setSort(getInt("sort"));
        p.update();
        renderJson(Ret.ok());
    }




    /**
     * 设置热门城市
     */
    public void hot_t(){
        Area store = Area.dao.findById(getInt("id"));
        store.setHot(1);
        store.update();
        renderNull();
    }

    /**
     * 取消热门城市
     */
    public void hot_f(){
        Area store = Area.dao.findById(getInt("id"));
        store.setHot(0);
        store.update();
        renderNull();
    }
}
