package com.jfinal.club._admin.data.sys;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.PathKit;
import com.jfinal.kit.Ret;
import com.jfinal.upload.UploadFile;
import org.apache.commons.io.FileUtils;

import java.io.File;

/**
 * @descriptions: 清除临时文件缓存
 * @author: lc
 * @date: 2020-09-30 18:05:44
 * @Version: 1.0
 **/
public class AdminClearCacheController extends BaseController {

     public void index(){
         String tempFolder = PathKit.getWebRootPath( ) + "/upload"+Cons.TEMP_FILE;
         String watermarkFolder = PathKit.getWebRootPath() + "/upload/product/watermark/";
         long tempTotalSize = FileUtils.sizeOfDirectory(new File(tempFolder));
         long watermarkTotalSize = FileUtils.sizeOfDirectory(new File(watermarkFolder));
         set("otherFileSize", CommonUtil.fileSize(tempTotalSize));
         set("watermarkFileSize",CommonUtil.fileSize(watermarkTotalSize));
         set("totalFile",CommonUtil.fileSize(tempTotalSize+watermarkTotalSize));
     }

    /**
     * 执行清除系统缓存
     */
    public void execute(){
         String tempFolder = PathKit.getWebRootPath( ) + "/upload"+Cons.TEMP_FILE;
         String watermarkFolder = PathKit.getWebRootPath() + "/upload/product/watermark/";
         CommonUtil.deleteDir(tempFolder);
         CommonUtil.deleteDir(watermarkFolder);
         //删除过之后重新创建文件夹
         new File(tempFolder).mkdir();
         new File(watermarkFolder).mkdir();
         renderJson(Ret.ok( ));
     }





}
