package com.jfinal.club._admin.data.sys;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Navbar;
import com.jfinal.club.common.model.Navbar;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-09 16:20:56
 * @Version: 1.0
 **/
public class AdminNavbarController extends BaseController {

    public void index( ) {
        String searchName = get("searchName");
        set("searchName", searchName);
        ArrayList< Object > param = new ArrayList<>( );
        String sql = " from navbar  where 1=1 ";
        if (StringUtils.isNotBlank(searchName)) {
            searchName = "%" + searchName.trim( ) + "%";
            sql += " and name like ? ";
            param.add(searchName);
        }
        sql += " order by pid asc,  sort desc ,create_time asc ";
        Page< Navbar > page = Navbar.dao.paginate(getInt("p", 1), getInt("s", Cons.ADMIN_PAGESIZE), "select *", sql, param.toArray( ));
        set("page", page);
        render("index.html");
    }

    public void add( ) {
        set("navbarList", Navbar.dao.find("select * from navbar where pid = 0 order by sort desc"));
        render("add_edit.html");
    }

    public void save( ) {
        Navbar model = getModel(Navbar.class);
        model.set("create_time", new Date( )).save( );
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        set("navbarList", Navbar.dao.find("select * from navbar where pid = 0 order by sort desc"));
        Integer id = getInt("id");
        Navbar navbar = Navbar.dao.findById(id);
        set("navbar", navbar);
        render("add_edit.html");
    }

    public void update( ) {
        Navbar model = getModel(Navbar.class);
        model.update( );
        renderJson(Ret.ok( ));
    }

    public void levelTwo( ) {
        Integer id = getInt("id");
        Page< Navbar > page = Navbar.dao.paginate(getInt("p", 1), getInt("s", Integer.MAX_VALUE), "select *", "from navbar where pid = ? order by sort desc ,create_time asc  ", id);
        set("page", page);
        render("index.html");
    }

    public void delete( ) {
        Integer id = getInt("id");
        Navbar navbar = Navbar.dao.findById(id);
        Navbar.dao.deleteById(id);
        if (navbar.getPid( ) == 0) {
            Db.delete("delete from navbar where pid = ?", id);
        }
        renderJson(Ret.ok( ));
    }
}
