package com.jfinal.club._admin.data.sys;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.service.TypeService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Seller;
import com.jfinal.club.common.model.Types;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.upload.UploadFile;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-09 16:20:56
 * @Version: 1.0
 **/
public class AdminSellerController extends BaseController {

    @Inject
    TypeService typeService;

    public void index( ) {
        String searchName = get("searchName");
        Integer tp = getInt("tp");

        set("searchName",searchName);
        set("tp",tp);
        ArrayList< Object > param = new ArrayList<>( );
        String sql = " from (select a.*,b.name depart from seller a left join types b  on  a.`type` = b.id where 1=1 ";

        if(StringUtils.isNotBlank(searchName)){
            searchName = "%"+searchName.trim()+"%";
            sql += " and a.name like ? ";
            param.add(searchName);
        }
        if(tp != null){
            sql += " and a.type = ?";
            param.add(tp);
        }

        sql += " order by a.sort desc ,a.create_time desc ) a ";
        Page< Seller > page = Seller.dao.paginate(getInt("p", 1), getInt("s", Integer.MAX_VALUE), "select * ", sql,param.toArray());
        set("page",page);
        set("types",typeService.listByType(3));
        render("index.html");
    }

    public void add( ) {
        set("types",typeService.listByType(3));
        render("add_edit.html");
    }

    public void save( ) {
        UploadFile filepath = getFile("filepath", Cons.SYS_SELLER);
        Seller model = getModel(Seller.class);
        if(filepath != null){
            String filePath = CommonUtil.getFilePath(filepath, Cons.SYS_SELLER);
            model.setPhoto(filePath);
        }
        model.set("create_time",new Date()).save();
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        set("types",typeService.listByType(3));
        Integer id = getInt("id");
        Seller seller = Seller.dao.findById(id);
        set("seller",seller);
        render("add_edit.html");
    }

    public void update( ) {
        UploadFile filepath = getFile("filepath", Cons.SYS_SELLER);
        Seller model = getModel(Seller.class);
        if(filepath != null){
            CommonUtil.deleteFile(Seller.dao.findById(model.getId()).getPhoto());
            String filePath = CommonUtil.getFilePath(filepath, Cons.SYS_SELLER);
            model.setPhoto(filePath);
        }
        model.update();
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        CommonUtil.deleteFile(Seller.dao.findById(getInt("id")).getPhoto());
        Seller.dao.deleteById(getInt("id"));
        renderJson(Ret.ok());
    }
}
