package com.jfinal.club._admin.data.sys;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Admins;
import com.jfinal.club.common.model.Types;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Date;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-08 17:49:02
 * @Version: 1.0
 **/
public class AdminTypesController extends BaseController {

    public void index( ) {
        Integer tp = getInt("tp");
        String searchName = get("searchName");

        set("tp",tp);
        set("searchName",searchName);

        ArrayList< Object > param = new ArrayList<>( );
        String sql = " from types  where 1=1 ";
        if(tp != null){
            sql += " and type = ? ";
            param.add(tp);
        }

        if(StringUtils.isNotBlank(searchName)){
            searchName = "%"+searchName.trim()+"%";
            sql += " and name like ? ";
            param.add(searchName);
        }

        sql += " order by type asc, sort desc ,create_time desc ";
        Page< Types > page = Types.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select *", sql,param.toArray());
        set("page",page);

        render("index.html");
    }

    public void add( ) {
        render("add_edit.html");
    }

    public void save( ) {
        Types model = getModel(Types.class);
        model.set("create_time",new Date()).save();
        renderJson(Ret.ok( ));
    }

    public void edit( ) {
        Integer id = getInt("id");
        Types types = Types.dao.findById(id);
        set("types",types);
        render("add_edit.html");
    }

    public void update( ) {
        Types model = getModel(Types.class);
        model.update();
        renderJson(Ret.ok( ));
    }

    public void delete( ) {
        Types.dao.deleteById(getInt("id"));
        renderJson(Ret.ok());
    }


    public void active_t( ) {
        Types types = Types.dao.findById(getInt("id"));
        Db.update("update types a set a.active = 0 where type = ? ",types.getType());
        Types.dao.findById(getInt("id")).set("active", 1).removeNullValueAttrs( ).update( );
        index( );
    }

    public void active_f( ) {
        Types.dao.findById(getInt("id")).set("active", 0).removeNullValueAttrs( ).update( );
        index( );
    }
}
