package com.jfinal.club._admin.data.wxuser;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.product.product.AdminExcelService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.WxUser;
import com.jfinal.club.common.model.WxUser;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.PathKit;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

/**
 * @descriptions: 微信用户列表
 * @author: lc
 * @date: 2021-03-14 10:47:10
 * @Version: 1.0
 **/
public class AdminWxUserController extends BaseController {

    @Inject
    AdminWxUserService adminWxUserService;

    public void index() {

        String searchName = get("searchName", "");
        set("searchName", searchName);

        String sql = " from wx_user where nickname is not null ";

        ArrayList<Object> param = new ArrayList<>();
        if (StringUtils.isNotBlank(searchName)) {
            searchName = "%" + searchName + "%";
            sql += " and nickname like ? or mobile like ? or company like ? or job like ? ";
            param.add(searchName);
            param.add(searchName);
            param.add(searchName);
            param.add(searchName);
        }

        sql += " order by create_time desc";

        Page<WxUser> page = WxUser.dao.paginate(getInt("p", 1), getInt("s", 10), "select * ", sql, param.toArray());
        setAttr("page", page);
        render("index.html");
    }

    public void detail() {
        set("r", WxUser.dao.findById(getInt("id")));
        render("detail.html");

    }

    public void delete() {
        WxUser.dao.deleteById(getInt("id"));
        renderJson(Ret.ok());
    }

    public void edit() {
        set("wxuser", WxUser.dao.findById(getInt("id")));
        render("add_edit.html");
    }

    public void update() {
        WxUser model = getModel(WxUser.class, "wxuser");
        model.update();
        renderJson(Ret.ok());
    }

    /**
     * 数据导出  所有
     * all 1 导出所有 ，0导出选中
     * ids 选中的id
     */
    public void export() {
        String all = get("all", "1");
        String ids = get("ids", "");
        try {
            List<WxUser> list = null;

            if ("1".equals(all)) {
                list = WxUser.dao.find("select * from wx_user where nickname is not null order by create_time desc");
            }

            if ("0".equals(all) && StringUtils.isNotBlank(ids)) {
                list = WxUser.dao.find("select * from wx_user where nickname is not null and id in (" + ids + ") order by create_time desc");
            }
            //1生成excel 文件
            adminWxUserService.createExcel(list);
            //2 下载
            File file = new File(PathKit.getWebRootPath(), "upload" + Cons.WXUSER_EXCEL);
            renderFile(file, URLEncoder.encode(file.getName(), "utf-8"));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
    }

}
