package com.jfinal.club._admin.data.wxuser;

import com.jfinal.club.common.model.WxUser;
import com.jfinal.club.util.Cons;
import com.jfinal.club.util.ExcelUtils;
import com.jfinal.kit.PathKit;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import java.io.File;
import java.io.FileOutputStream;
import java.util.List;

/**
 * @Auther: LiuChao
 * @Date: 2021/3/15 00:08
 * @Description:
 */
public class AdminWxUserService {

    /**
     * 生成excel  文件
     */
    public void createExcel(List<WxUser> list) {

        //excel标题
        String[] title = {"微信昵称","手机号码","邮箱","所在公司","职务","用户状态","注册时间"};
        //sheet名
        String sheetName = "微信用户信息";

        if(list == null && list.size() <= 0){
            return;
        }

        String [][] content = new String[list.size()][7];

        for (int i = 0; i < list.size(); i++) {
            content[i] = new String[title.length];
            WxUser obj = list.get(i);
            content[i][0] = obj.getNickname();
            content[i][1] = obj.getMobile();
            content[i][2] = obj.getEmail();
            content[i][3] = obj.getCompany();
            content[i][4] = obj.getJob();
            content[i][5] = obj.getLock() == 1 ? "冻结":"活跃";
            content[i][6] = DateFormatUtils.format(obj.getCreateTime(),"yyyy-MM-dd hh:mm");
        }

        //创建HSSFWorkbook
        HSSFWorkbook wb = ExcelUtils.getHSSFWorkbook(sheetName, title, content, null);

        //响应到客户端
        try {
            FileOutputStream out = new FileOutputStream(new File(PathKit.getWebRootPath(),"upload"+Cons.WXUSER_EXCEL));
            wb.write(out);
            out.flush();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}
