package com.jfinal.club._app.home;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.service.TypeService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.Appcase;
import com.jfinal.club.common.model.AppcaseP;
import com.jfinal.club.common.model.Product;
import com.jfinal.club.common.model.Types;
import com.jfinal.club.util.CommonUtil;
import com.jfinal.club.util.Cons;
import com.jfinal.club.vo.StyleVo;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;
import com.jfinal.plugin.activerecord.Record;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-16 11:33:03
 * @Version: 1.0
 **/
public class AppCaseController extends BaseController {

    @Inject
    TypeService typeService;

    /**
     * type : 默认第一个
     * p : 当前页 默认1
     */
    public void index( ) {
        Integer type = getInt("type");
        List< Types > types = typeService.listByType(1);
        if (type == null) {
            type = types.get(0).getId( );
        }
        Page< Appcase > page = Appcase.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select a.id,a.banner ,a.title,a.type", "from appcase a where type = ? order by a.sort desc,a.create_time desc", type);

        HashMap< Object, Object > map = new HashMap<>(3);
        map.put("page", page);
        map.put("currentType", type);
        map.put("typeList", types);
        renderJson(Ret.ok("data", map));


    }


    /**
     * 案列详情
     * id : 案列id
     */
    public void detail( ) {
        Integer id = getInt("id");
        Appcase appcase = Appcase.dao.findById(id);
        List< Product > productList = Product.dao.find(" SELECT a.id,b.name,a.model,a.cover_img FROM product a inner JOIN p_title b ON a.p_title = b.id WHERE a.is_recommend = 1 ");

        //款式
        List< Record > listType = Db.find(" SELECT appid,title FROM appcase_p WHERE appid = ? GROUP BY title ORDER BY sort DESC,create_time desc ", id);

        ArrayList< StyleVo > styleList = new ArrayList<>( );
        if (listType != null && listType.size( ) > 0) {
            listType.forEach(a -> {
                StyleVo vo = new StyleVo( );
                vo.setTitle(a.get("title"));
                List< Record > productList1 = Db.find(" SELECT id,title,model,img cover_img FROM appcase_p WHERE appid = ? AND title = ? ", a.get("appid"),a.get("title"));
                vo.setList(productList1);
                styleList.add(vo);
            });
        }

        HashMap< Object, Object > map = new HashMap<>(3);
        map.put("appCase", appcase);
        map.put("styleList", styleList);
        map.put("productList", productList);
        renderJson(Ret.ok("data",map));
    }

}
