package com.jfinal.club._app.home;

import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.News;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Page;
import org.apache.commons.lang.time.DateFormatUtils;

import java.util.HashMap;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-09 14:28:46
 * @Version: 1.0
 **/
public class NewsController extends BaseController {

    public void index( ) {
        News first = News.dao.findFirst("select * from news where face = 1");
        Page< News > page = News.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select id,title,img,pubdate ", "from news where face !=1 order by sort desc,pubdate desc");
        if (page.getList() != null && page.getList().size( ) > 0) {
            page.getList().forEach(a -> a.put("formatDate", DateFormatUtils.format(a.getPubdate( ), "yyyy-MM-dd")));
        }
        HashMap< Object, Object > map = new HashMap<>(2);
        map.put("page", page);
        map.put("first", first);
        renderJson(Ret.ok("data", map));
    }

    public void detail( ) {
        News news = News.dao.findById(getInt("id"));
        news.put("formatDate",DateFormatUtils.format(news.getPubdate( ), "yyyy-MM-dd"));
        renderJson(Ret.ok("news", news));
    }


}
