package com.jfinal.club._app.info;

import com.jfinal.aop.Inject;
import com.jfinal.club._admin.data.service.TypeService;
import com.jfinal.club.common.controller.BaseController;
import com.jfinal.club.common.model.*;
import com.jfinal.club.util.Cons;
import com.jfinal.kit.Ret;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Page;

import java.util.HashMap;
import java.util.List;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-07-23 19:42:12
 * @Version: 1.0
 **/
public class InfoController extends BaseController {

    @Inject
    TypeService typeService;

    /**
     * type VR展馆id,视频技术id,图册资料id
     */
    public void index(){

        Integer type = getInt("type");

        List< Types > types = typeService.listByType(2);
        if(type == null){
            type = Types.dao.findFirst("select * from types where type = 2 and active = 1 ").getId();
        }

        HashMap< Object, Object > map = new HashMap<>(3);
        map.put("currentType",type == null ? 1:type);
        map.put("typeList",types);

        //如果 0 vr 1 视频资料 ,如果 2 图册
        if(type == 0){
            Page< Video > page = Video.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select * ", "from vr order by sort desc,create_time desc");
            map.put("page",page);
        }
        if(type == 1){
            Page< Video > page = Video.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select * ", "from video order by sort desc,create_time desc");
            map.put("page",page);
        }
        if(type == 2){
            Page< Photo > page = Photo.dao.paginate(getInt("p", 1), getInt("s", Cons.FRONT_PAGESIZE), "select * ", "from photo order by sort desc,create_time desc");
            map.put("page",page);
        }
        renderJson(Ret.ok("data",map));
    }

    /**
     * 相册的详情信息
     * id
     */
    public void photo_detail(){
        Integer id = getInt("id");
        Photo phone = Photo.dao.findById(id);
        renderJson(Ret.ok("data",phone));
    }

    public void rs(){
        List< Appcase > all = Appcase.dao.findAll( );

        all.forEach(a->{
            String content = a.getContent( );
            content = content.replace("http://101.132.187.227:8083","https://hoppe.jzdsh.com");
            a.setContent(content);
        });

        Db.batchUpdate(all,2000 );
    }

}
