-- --------------------------------------------------------
-- 主机:                           47.98.117.186
-- 服务器版本:                        5.7.30 - MySQL Community Server (GPL)
-- 服务器操作系统:                      Linux
-- HeidiSQL 版本:                  11.2.0.6228
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 导出 hoppe 的数据库结构
CREATE DATABASE IF NOT EXISTS `hoppe` /*!40100 DEFAULT CHARACTER SET utf8mb4 */;
USE `hoppe`;

-- 导出  表 hoppe.admins 结构
CREATE TABLE IF NOT EXISTS `admins` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `username` varchar(50) DEFAULT NULL COMMENT '用户名',
  `password` varchar(50) DEFAULT NULL COMMENT '密码',
  `avatar` varchar(50) DEFAULT NULL COMMENT '头像',
  `lock` tinyint(4) DEFAULT NULL COMMENT '是否锁定 0 否 1是',
  `create_date` datetime DEFAULT NULL COMMENT '创建时间',
  `role` varchar(500) DEFAULT NULL COMMENT '角色',
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8 COMMENT='后台管理员表';

-- 正在导出表  hoppe.admins 的数据：~3 rows (大约)
/*!40000 ALTER TABLE `admins` DISABLE KEYS */;
REPLACE INTO `admins` (`id`, `username`, `password`, `avatar`, `lock`, `create_date`, `role`) VALUES
	(1, 'admin', 'jzd207hoppe', '', 0, '2020-06-30 18:30:46', '0'),
	(2, 'liuchao', '123', '', 1, '2020-06-30 18:09:16', '5,6,7,8,3,9,10,11,12,13,14,40,41,16,17,19,20,21,26,27,33,29,30,23,24,34,42'),
	(5, 'xiaom', '123', NULL, 1, '2020-07-15 14:37:40', '0');
/*!40000 ALTER TABLE `admins` ENABLE KEYS */;

-- 导出  表 hoppe.admin_role 结构
CREATE TABLE IF NOT EXISTS `admin_role` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `admin_id` int(11) DEFAULT NULL COMMENT '用户id',
  `nav_id` int(11) DEFAULT NULL COMMENT '导航id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户权限表';

-- 正在导出表  hoppe.admin_role 的数据：~0 rows (大约)
/*!40000 ALTER TABLE `admin_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `admin_role` ENABLE KEYS */;

-- 导出  表 hoppe.appcase 结构
CREATE TABLE IF NOT EXISTS `appcase` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `type` int(11) DEFAULT NULL COMMENT '类型 分别是 1234,贸易商业,医疗界沟,运动文化,酒店旅馆',
  `banner` varchar(255) DEFAULT NULL COMMENT '封面图',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `img` varchar(255) DEFAULT NULL COMMENT '图2',
  `country` varchar(50) DEFAULT NULL COMMENT '国家',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `builder` varchar(50) DEFAULT NULL COMMENT '建筑师',
  `style` varchar(10000) DEFAULT NULL COMMENT '款式',
  `material` varchar(50) DEFAULT NULL COMMENT '材质',
  `surface` varchar(500) DEFAULT NULL COMMENT '表面处理',
  `content` mediumtext COMMENT '其他内容',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` date DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=utf8mb4 COMMENT='应用案列';

-- 正在导出表  hoppe.appcase 的数据：~18 rows (大约)
/*!40000 ALTER TABLE `appcase` DISABLE KEYS */;
REPLACE INTO `appcase` (`id`, `type`, `banner`, `title`, `img`, `country`, `city`, `builder`, `style`, `material`, `surface`, `content`, `sort`, `create_time`) VALUES
	(10, 1, '/upload/home/appcase/x1509d1f276.png', '意大利Mercedes Benz 奔驰', '/upload/home/appcase/x1509d1f2761.png', '意大利', '米兰', 'Studio architetti Daimler Chrysley', NULL, '不锈钢', 'F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-135741.png" title="WX20200925-135741.png" alt="WX20200925-135741.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-095904@2x2.png" title="2-WX20200926-095904@2x2.png" alt="2-WX20200926-095904@2x.png"/></p>', 0, '2020-07-31'),
	(23, 1, '/upload/home/appcase/封面.png', 'Parlement européen IPE4 欧洲议会', '/upload/home/appcase/WX20200924-224254@2x.png', '法国', '斯特拉斯堡', 'Architecture de Studio de Paris', NULL, '不锈钢', 'F69 – 不锈钢拉丝', '<p><br/></p><p><br/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-114050@2x.png" title="WX20200925-114050@2x.png" alt="WX20200925-114050@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1-WX20200926-095655@2x.png" title="1-WX20200926-095655@2x.png" alt="1-WX20200926-095655@2x.png"/></p><p><br/></p>', 1, NULL),
	(24, 1, '/upload/home/appcase/WX20200925-132750.png', 'Das Düsseldorfer Stadttor(城市之门), 杜塞尔多夫', '/upload/home/appcase/WX20200925-1327501.png', '德国', '杜塞尔多夫', 'Petzinka Pink GmbH & Co. KG, 杜塞尔多夫', NULL, '不锈钢', 'F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-132852.png" title="WX20200925-132852.png" alt="WX20200925-132852.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1-WX20200926-095655@2x1.png" title="1-WX20200926-095655@2x1.png" alt="1-WX20200926-095655@2x.png"/></p>', 0, NULL),
	(25, 1, '/upload/home/appcase/WX20200925-140154.png', 'Gerling Ring-Karree', '/upload/home/appcase/WX20200925-140630.png', '德国', '科隆', 'Lord Norman Foster + Partners, 伦敦', NULL, '不锈钢', '表面处理 F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-140630.png" title="WX20200925-140630.png" alt="WX20200925-140630.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-095904@2x1.png" title="2-WX20200926-095904@2x1.png" alt="2-WX20200926-095904@2x.png"/></p>', 0, NULL),
	(26, 4, '/upload/home/appcase/WX20200925-145119@2x4.png', '品尊国际', '/upload/home/appcase/WX20200925-145150@2x4.png', '中国', '上海', 'HOPPE', NULL, '黄铜, 尼龙', 'F45-R – 镀铬抛光-Resista®      F75-R – 铜色抛光/磨砂-Resista®       F9005M – 尼龙亚光黑', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-145150@2x.png" title="WX20200925-145150@2x.png" alt="WX20200925-145150@2x.png"/><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-095233@2x.png" title="2-WX20200926-095233@2x.png" alt="2-WX20200926-095233@2x.png"/></p>', 0, '2020-09-25'),
	(27, 4, '/upload/home/appcase/WX20200925-150402@2x.png', 'Gütschhöhe', '/upload/home/appcase/WX20200925-150402@2x1.png', '瑞士', '卢塞恩', 'MMJS Jauch-Stolz Architekten AG', NULL, '不锈钢', 'F69-不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-150432@2x.png" title="WX20200925-150432@2x.png" alt="WX20200925-150432@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-095233@2x1.png" title="2-WX20200926-095233@2x1.png" alt="2-WX20200926-095233@2x.png"/></p>', 0, '2020-09-26'),
	(28, 4, '/upload/home/appcase/WX20200925-150653@2x.png', 'Villa 别墅', '/upload/home/appcase/WX20200925-150653@2x1.png', '意大利', '都灵', 'Con3studio Architetti', NULL, '黄铜', 'F46-R – 铬色磨砂/抛光-Resista®', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-150719@2x.png" title="WX20200925-150719@2x.png" alt="WX20200925-150719@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-095233@2x2.png" title="2-WX20200926-095233@2x2.png" alt="2-WX20200926-095233@2x.png"/></p>', 0, '2020-09-26'),
	(29, 1, '/upload/home/appcase/WX20200925-133551.png', 'Fiera Milano', '/upload/home/appcase/WX20200925-1335511.png', '意大利', '米兰', 'Massimiliano Fuksas', NULL, '铝合金', 'F1 – 铝银色', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-133624.png" title="WX20200925-133624.png" alt="WX20200925-133624.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-095904@2x.png" title="2-WX20200926-095904@2x.png" alt="2-WX20200926-095904@2x.png"/></p>', 0, NULL),
	(30, 4, '/upload/home/appcase/WX20200925-144454@2x.png', '金茂三亚希尔顿大 酒店', '/upload/home/appcase/WX20200925-144454@2x1.png', '中国', '三亚', '金茂', NULL, '黄铜', 'F41-R 镀铬拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-144536@2x.png" title="WX20200925-144536@2x.png" alt="WX20200925-144536@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-100118@2x2.png" title="2-WX20200926-100118@2x2.png" alt="2-WX20200926-100118@2x.png"/></p>', 0, '2020-09-26'),
	(31, 4, '/upload/home/appcase/WX20200925-144653@2x.png', '酒店 Aria', '/upload/home/appcase/WX20200925-144653@2x1.png', '捷克', '布拉格', 'Rocco Magnoli', NULL, '黄铜', 'F71 – 铜抛光', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-144724@2x.png" title="WX20200925-144724@2x.png" alt="WX20200925-144724@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-100118@2x.png" title="2-WX20200926-100118@2x.png" alt="2-WX20200926-100118@2x.png"/></p>', 0, '2020-09-26'),
	(32, 4, '/upload/home/appcase/WX20200925-144846@2x.png', '酒店 Badenerhof/ 疗养院 Mariazellerhof', '/upload/home/appcase/WX20200925-144846@2x1.png', '奥地利', '巴登', '多位建筑师', NULL, '黄铜', 'F49/F69 – 镀铬抛光/不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-144906@2x.png" title="WX20200925-144906@2x.png" alt="WX20200925-144906@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2-WX20200926-100118@2x1.png" title="2-WX20200926-100118@2x1.png" alt="2-WX20200926-100118@2x.png"/></p>', 0, NULL),
	(33, 2, '/upload/home/appcase/WX20200925-150958@2x.png', '诊所楼', '/upload/home/appcase/WX20200925-150958@2x1.png', '奥地利', '巴登', 'Lazlo Krizmanics', NULL, '黄铜', 'F49/F98 – 镀铬抛光/镀铬哑光', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-151028@2x.png" title="WX20200925-151028@2x.png" alt="WX20200925-151028@2x.png"/><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-151040@2x.png" title="WX20200925-151040@2x.png" alt="WX20200925-151040@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200926-100408@2x1.png" title="WX20200926-100408@2x1.png" alt="WX20200926-100408@2x.png"/></p>', 0, NULL),
	(34, 2, '/upload/home/appcase/WX20200925-151144@2x.png', 'Rosenhof 老年公寓', '/upload/home/appcase/WX20200925-151144@2x1.png', '德国', '柏林', 'Gaedecke 建筑师事务所', NULL, '不锈钢', 'F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-151209@2x.png" title="WX20200925-151209@2x.png" alt="WX20200925-151209@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200926-100408@2x.png" title="WX20200926-100408@2x.png" alt="WX20200926-100408@2x.png"/></p>', 0, NULL),
	(35, 1, '/upload/home/appcase/WX20200925-142420.png', 'Montevideo Tower', '/upload/home/appcase/WX20200925-1424201.png', '荷兰', '鹿特丹', 'Mecanoo', NULL, '铝合金、不锈钢', 'F9 – 铝仿钢色， F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-142541.png" title="WX20200925-142541.png" alt="WX20200925-142541.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/3-WX20200926-100620@2x.png" title="3-WX20200926-100620@2x.png" alt="3-WX20200926-100620@2x.png"/></p>', 0, NULL),
	(36, 1, '/upload/home/appcase/WX20200925-143040.png', 'Eempolis', '/upload/home/appcase/WX20200925-1430401.png', '荷兰', '阿莫斯福特', 'Arcadis', NULL, '铝合金', 'F1 – 铝银色', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-143118.png" title="WX20200925-143118.png" alt="WX20200925-143118.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/3-WX20200926-100620@2x1.png" title="3-WX20200926-100620@2x1.png" alt="3-WX20200926-100620@2x.png"/></p>', 0, NULL),
	(37, 3, '/upload/home/appcase/WX20200925-151316@2x.png', 'Musée du quai Branly', '/upload/home/appcase/WX20200925-151316@2x1.png', '法国', '巴黎', 'Jean Nouvel', NULL, '黄铜', 'F49/F69 – 镀铬抛光/不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-151344@2x.png" title="WX20200925-151344@2x.png" alt="WX20200925-151344@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200926-100758@2x.png" title="WX20200926-100758@2x.png" alt="WX20200926-100758@2x.png"/></p>', 0, NULL),
	(38, 3, '/upload/home/appcase/WX20200925-151456@2x.png', '艺术馆', '/upload/home/appcase/WX20200925-151456@2x1.png', '匈牙利', '布达佩斯', 'Zoboki, Demeter & Co.', NULL, '不锈钢', 'F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-151516@2x.png" title="WX20200925-151516@2x.png" alt="WX20200925-151516@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200926-100758@2x1.png" title="WX20200926-100758@2x1.png" alt="WX20200926-100758@2x.png"/></p>', 0, NULL),
	(39, 3, '/upload/home/appcase/WX20200925-151558@2x.png', 'Allianz Arena', '/upload/home/appcase/WX20200925-151558@2x1.png', '德国', 'München-Fröttmaning', 'Herzog & Meuron', NULL, '不锈钢', 'F69 – 不锈钢拉丝', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200925-151626@2x.png" title="WX20200925-151626@2x.png" alt="WX20200925-151626@2x.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200926-100758@2x2.png" title="WX20200926-100758@2x2.png" alt="WX20200926-100758@2x.png"/></p>', 0, NULL);
/*!40000 ALTER TABLE `appcase` ENABLE KEYS */;

-- 导出  表 hoppe.appcase_p 结构
CREATE TABLE IF NOT EXISTS `appcase_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `appid` int(11) DEFAULT NULL COMMENT '应用案列id',
  `title` varchar(255) DEFAULT NULL COMMENT '款式',
  `model` varchar(255) DEFAULT NULL COMMENT '型号',
  `img` varchar(255) DEFAULT NULL COMMENT '图片',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=41 DEFAULT CHARSET=utf8 COMMENT='应用案列 对应的产品';

-- 正在导出表  hoppe.appcase_p 的数据：~32 rows (大约)
/*!40000 ALTER TABLE `appcase_p` DISABLE KEYS */;
REPLACE INTO `appcase_p` (`id`, `appid`, `title`, `model`, `img`, `sort`, `create_time`) VALUES
	(3, 1, '2', '4', NULL, 0, '2020-07-24 19:16:10'),
	(4, 1, '1', '30', NULL, 0, '2020-07-24 19:17:37'),
	(5, 1, '4', '9', NULL, 0, '2020-07-24 19:35:10'),
	(6, 1, '4', '6', NULL, 0, '2020-07-24 19:52:30'),
	(7, 9, '5', '29', NULL, 0, '2020-07-24 20:05:46'),
	(8, 9, '1', '26', NULL, 0, '2020-07-24 20:06:21'),
	(12, 10, 'Paris', 'E138Z/42K/42KS', '/upload/home/appcase/WX20200925-135943.png', 3, '2020-09-16 12:02:39'),
	(14, 10, 'Paris', 'E138GF1/55/55S', '/upload/home/appcase/WX20200925-140009.png', 2, '2020-09-16 12:03:19'),
	(17, 23, 'Bonn', 'E150F/353', '/upload/home/appcase/WX20200925-132054.png', 0, '2020-09-26 08:11:33'),
	(18, 23, 'Bonn', 'E75/3053/1590', '/upload/home/appcase/WX20200925-132119.png', 0, '2020-09-26 08:12:01'),
	(19, 10, 'Amsterdam', 'E0400/US956', '/upload/home/appcase/WX20200925-135914.png', 1, '2020-09-26 08:22:51'),
	(20, 24, 'Amsterdam', 'E1400F/42/42S', '/upload/home/appcase/WX20200925-132934.png', 0, '2020-09-26 08:29:29'),
	(21, 25, 'Amsterdam', 'E1400F/42/42S', '/upload/home/appcase/WX20200925-140710.png', 0, '2020-09-26 08:30:44'),
	(22, 26, 'Genova', 'M1535/19K/19KS', '/upload/home/appcase/WX20200925-145235@2x.png', 1, '2020-09-26 08:34:22'),
	(23, 26, 'Paris', 'HCS® K138S', '/upload/home/appcase/WX20200925-145348@2x.png', 0, '2020-09-26 08:34:54'),
	(24, 27, 'Stockholm', 'E1140Z/202FL', '/upload/home/appcase/WX20200925-150546@2x.png', 2, '2020-09-26 08:41:03'),
	(25, 27, 'Stockholm', 'E0140/US956', '/upload/home/appcase/WX20200925-150618@2x.png', 1, '2020-09-26 08:41:30'),
	(26, 28, 'Monte Carlo', 'M1550/25K/25KS', '/upload/home/appcase/WX20200925-150758@2x.png', 0, '2020-09-26 08:44:35'),
	(27, 29, 'Tôkyô', '1710/42KV/42KVS', '/upload/home/appcase/WX20200925-134134.png', 0, '2020-09-26 08:48:06'),
	(28, 30, 'Madrid', 'M157L/42K/42KS', '/upload/home/appcase/WX20200925-144614@2x.png', 0, '2020-09-26 08:51:45'),
	(29, 31, 'Wien', 'M123/15/15S', '/upload/home/appcase/WX20200925-144757@2x.png', 0, '2020-09-26 08:57:39'),
	(30, 32, 'Athinai', 'M156/19KV/19KVS', '/upload/home/appcase/WX20200925-144958@2x.png', 0, '2020-09-26 09:01:16'),
	(31, 33, 'Phoenix', 'M1640/19KV/19KVS', '/upload/home/appcase/WX20200925-151116@2x.png', 0, '2020-09-26 09:03:53'),
	(32, 34, 'Marseille', 'E1138/42KV/42KVS', '/upload/home/appcase/WX20200925-151233@2x.png', 0, '2020-09-26 09:06:08'),
	(33, 35, 'Tôkyô', '1710/42KV/42KVS', '/upload/home/appcase/WX20200925-142706.png', 2, '2020-09-26 09:09:19'),
	(34, 35, 'Bilbao', 'E1365Z/42K/42KS', '/upload/home/appcase/WX20200925-142744.png', 0, '2020-09-26 09:09:39'),
	(35, 36, 'Melbourne', '1672/19/19S', '/upload/home/appcase/WX20200925-143925@2x.png', 0, '2020-09-26 09:12:55'),
	(36, 37, 'Cortina', 'M195F/42K/42KS', '/upload/home/appcase/WX20200925-151425@2x.png', 0, '2020-09-26 09:16:15'),
	(37, 38, 'Amsterdam', 'E1400F/42/42S', '/upload/home/appcase/WX20200925-151537@2x.png', 0, '2020-09-26 09:18:22'),
	(38, 39, 'Paris', 'E138F', '/upload/home/appcase/WX20200925-151707@2x.png', 3, '2020-09-26 09:20:53'),
	(39, 39, 'Paris', 'E484', '/upload/home/appcase/WX20200925-151730@2x.png', 2, '2020-09-26 09:21:31'),
	(40, 39, 'Paris', 'E487', '/upload/home/appcase/WX20200925-151745@2x.png', 0, '2020-09-26 09:21:57');
/*!40000 ALTER TABLE `appcase_p` ENABLE KEYS */;

-- 导出  表 hoppe.area 结构
CREATE TABLE IF NOT EXISTS `area` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '唯一编号',
  `addr_code` varchar(30) CHARACTER SET utf8 DEFAULT NULL COMMENT '地区编号',
  `addr_name` varchar(512) CHARACTER SET utf8 DEFAULT NULL COMMENT '地区名称',
  `father_code` varchar(30) CHARACTER SET utf8 DEFAULT NULL COMMENT '父编号',
  `type` varchar(2) CHARACTER SET utf8 DEFAULT NULL COMMENT '类型，01：省，02：市，03：区县',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `remark` varchar(512) CHARACTER SET utf8 DEFAULT NULL COMMENT '备注',
  `city` varchar(512) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '城市  不显示”市“   针对地级市  小程序搜索要用',
  `front_show` char(2) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '0是 1否 ,设置是否在小程序 搜索使用',
  `sort` int(11) DEFAULT '0' COMMENT '排序',
  `hot` int(11) DEFAULT '0' COMMENT '设置是否热门城市 小程序用',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `addr_code` (`addr_code`)
) ENGINE=InnoDB AUTO_INCREMENT=3754 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='区县级数据字典';

-- 正在导出表  hoppe.area 的数据：~3,693 rows (大约)
/*!40000 ALTER TABLE `area` DISABLE KEYS */;
REPLACE INTO `area` (`id`, `addr_code`, `addr_name`, `father_code`, `type`, `create_time`, `update_time`, `remark`, `city`, `front_show`, `sort`, `hot`) VALUES
	(1, '110101', '东城区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2, '110102', '西城区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3, '110105', '朝阳区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(4, '110106', '丰台区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(5, '110107', '石景山区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(6, '110108', '海淀区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(7, '110109', '门头沟区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(8, '110111', '房山区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(9, '110112', '通州区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(10, '110113', '顺义区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(11, '110114', '昌平区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(12, '110115', '大兴区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(13, '110116', '怀柔区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(14, '110117', '平谷区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(15, '110118', '密云区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(16, '110119', '延庆区', '110100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(17, '110100', '北京市', '100001', '02', '2017-05-26 17:44:09', '2020-07-25 14:59:05', 'B', '北京', '0', 99, 1),
	(18, '120101', '和平区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(19, '120102', '河东区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(20, '120103', '河西区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(21, '120104', '南开区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(22, '120105', '河北区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(23, '120106', '红桥区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(24, '120110', '东丽区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(25, '120111', '西青区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(26, '120112', '津南区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(27, '120113', '北辰区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(28, '120114', '武清区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(29, '120115', '宝坻区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(30, '120116', '滨海新区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(31, '120117', '宁河区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(32, '120118', '静海区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(33, '120119', '蓟州区', '120100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(34, '120100', '天津市', '100002', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'T', '天津', '0', 0, 0),
	(35, '130101', '市辖区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(36, '130102', '长安区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(37, '130104', '桥西区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(38, '130105', '新华区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(39, '130107', '井陉矿区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(40, '130108', '裕华区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(41, '130109', '藁城区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(42, '130110', '鹿泉区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(43, '130111', '栾城区', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(44, '130121', '井陉县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(45, '130123', '正定县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(46, '130125', '行唐县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(47, '130126', '灵寿县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(48, '130127', '高邑县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(49, '130128', '深泽县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(50, '130129', '赞皇县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(51, '130130', '无极县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(52, '130131', '平山县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(53, '130132', '元氏县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(54, '130133', '赵县', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(55, '130183', '晋州市', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(56, '130184', '新乐市', '130100', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(57, '130201', '市辖区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(58, '130202', '路南区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(59, '130203', '路北区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(60, '130204', '古冶区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(61, '130205', '开平区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(62, '130207', '丰南区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(63, '130208', '丰润区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(64, '130209', '曹妃甸区', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(65, '130223', '滦县', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(66, '130224', '滦南县', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(67, '130225', '乐亭县', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(68, '130227', '迁西县', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(69, '130229', '玉田县', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(70, '130281', '遵化市', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(71, '130283', '迁安市', '130200', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(72, '130301', '市辖区', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(73, '130302', '海港区', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(74, '130303', '山海关区', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(75, '130304', '北戴河区', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(76, '130306', '抚宁区', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(77, '130321', '青龙满族自治县', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(78, '130322', '昌黎县', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(79, '130324', '卢龙县', '130300', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(80, '130401', '市辖区', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(81, '130402', '邯山区', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(82, '130403', '丛台区', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(83, '130404', '复兴区', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(84, '130406', '峰峰矿区', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(85, '130421', '邯郸县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(86, '130423', '临漳县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(87, '130424', '成安县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(88, '130425', '大名县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(89, '130426', '涉县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(90, '130427', '磁县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(91, '130428', '肥乡县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(92, '130429', '永年县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(93, '130430', '邱县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(94, '130431', '鸡泽县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(95, '130432', '广平县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(96, '130433', '馆陶县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(97, '130434', '魏县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(98, '130435', '曲周县', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(99, '130481', '武安市', '130400', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(100, '130501', '市辖区', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(101, '130502', '桥东区', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(102, '130503', '桥西区', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(103, '130521', '邢台县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(104, '130522', '临城县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(105, '130523', '内丘县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(106, '130524', '柏乡县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(107, '130525', '隆尧县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(108, '130526', '任县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(109, '130527', '南和县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(110, '130528', '宁晋县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(111, '130529', '巨鹿县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(112, '130530', '新河县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(113, '130531', '广宗县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(114, '130532', '平乡县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(115, '130533', '威县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(116, '130534', '清河县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(117, '130535', '临西县', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(118, '130581', '南宫市', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(119, '130582', '沙河市', '130500', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(120, '130601', '市辖区', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(121, '130602', '竞秀区', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(122, '130606', '莲池区', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(123, '130607', '满城区', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(124, '130608', '清苑区', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(125, '130609', '徐水区', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(126, '130623', '涞水县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(127, '130624', '阜平县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(128, '130626', '定兴县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(129, '130627', '唐县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(130, '130628', '高阳县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(131, '130629', '容城县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(132, '130630', '涞源县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(133, '130631', '望都县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(134, '130632', '安新县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(135, '130633', '易县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(136, '130634', '曲阳县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(137, '130635', '蠡县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(138, '130636', '顺平县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(139, '130637', '博野县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(140, '130638', '雄县', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(141, '130681', '涿州市', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(142, '130683', '安国市', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(143, '130684', '高碑店市', '130600', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(144, '130701', '市辖区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(145, '130702', '桥东区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(146, '130703', '桥西区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(147, '130705', '宣化区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(148, '130706', '下花园区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(149, '130708', '万全区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(150, '130709', '崇礼区', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(151, '130722', '张北县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(152, '130723', '康保县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(153, '130724', '沽源县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(154, '130725', '尚义县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(155, '130726', '蔚县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(156, '130727', '阳原县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(157, '130728', '怀安县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(158, '130730', '怀来县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(159, '130731', '涿鹿县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(160, '130732', '赤城县', '130700', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(161, '130801', '市辖区', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(162, '130802', '双桥区', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(163, '130803', '双滦区', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(164, '130804', '鹰手营子矿区', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(165, '130821', '承德县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(166, '130822', '兴隆县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(167, '130823', '平泉县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(168, '130824', '滦平县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(169, '130825', '隆化县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(170, '130826', '丰宁满族自治县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(171, '130827', '宽城满族自治县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(172, '130828', '围场满族蒙古族自治县', '130800', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(173, '130901', '市辖区', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(174, '130902', '新华区', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(175, '130903', '运河区', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(176, '130921', '沧县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(177, '130922', '青县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(178, '130923', '东光县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(179, '130924', '海兴县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(180, '130925', '盐山县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(181, '130926', '肃宁县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(182, '130927', '南皮县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(183, '130928', '吴桥县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(184, '130929', '献县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(185, '130930', '孟村回族自治县', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(186, '130981', '泊头市', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(187, '130982', '任丘市', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(188, '130983', '黄骅市', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(189, '130984', '河间市', '130900', '03', '2017-05-26 17:44:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(190, '131001', '市辖区', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(191, '131002', '安次区', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(192, '131003', '广阳区', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(193, '131022', '固安县', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(194, '131023', '永清县', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(195, '131024', '香河县', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(196, '131025', '大城县', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(197, '131026', '文安县', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(198, '131028', '大厂回族自治县', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(199, '131081', '霸州市', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(200, '131082', '三河市', '131000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(201, '131101', '市辖区', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(202, '131102', '桃城区', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(203, '131103', '冀州区', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(204, '131121', '枣强县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(205, '131122', '武邑县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(206, '131123', '武强县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(207, '131124', '饶阳县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(208, '131125', '安平县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(209, '131126', '故城县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(210, '131127', '景县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(211, '131128', '阜城县', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(212, '131182', '深州市', '131100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(213, '139001', '定州市', '139000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(214, '139002', '辛集市', '139000', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(215, '130100', '石家庄市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'S', '石家庄', '0', 0, 0),
	(216, '130200', '唐山市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'T', '唐山', '0', 0, 0),
	(217, '130300', '秦皇岛市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'Q', '秦皇岛', '0', 0, 0),
	(218, '130400', '邯郸市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'H', '邯郸', '0', 0, 0),
	(219, '130500', '邢台市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'X', '邢台', '0', 0, 0),
	(220, '130600', '保定市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'B', '保定', '0', 0, 0),
	(221, '130700', '张家口市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'Z', '张家口', '0', 0, 0),
	(222, '130800', '承德市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'C', '承德', '0', 0, 0),
	(223, '130900', '沧州市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'C', '沧州', '0', 0, 0),
	(224, '131000', '廊坊市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'L', '廊坊', '0', 0, 0),
	(225, '131100', '衡水市', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'H', '衡水', '0', 0, 0),
	(226, '139000', '省直辖县级行政区划', '100003', '02', '2017-05-26 17:44:11', '2020-07-08 11:30:50', 'S', '省直辖县级行政区划', '0', 0, 0),
	(227, '140101', '市辖区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(228, '140105', '小店区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(229, '140106', '迎泽区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(230, '140107', '杏花岭区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(231, '140108', '尖草坪区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(232, '140109', '万柏林区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(233, '140110', '晋源区', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(234, '140121', '清徐县', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(235, '140122', '阳曲县', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(236, '140123', '娄烦县', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(237, '140181', '古交市', '140100', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(238, '140201', '市辖区', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(239, '140202', '城区', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(240, '140203', '矿区', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(241, '140211', '南郊区', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(242, '140212', '新荣区', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(243, '140221', '阳高县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(244, '140222', '天镇县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(245, '140223', '广灵县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(246, '140224', '灵丘县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(247, '140225', '浑源县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(248, '140226', '左云县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(249, '140227', '大同县', '140200', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(250, '140301', '市辖区', '140300', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(251, '140302', '城区', '140300', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(252, '140303', '矿区', '140300', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(253, '140311', '郊区', '140300', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(254, '140321', '平定县', '140300', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(255, '140322', '盂县', '140300', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(256, '140401', '市辖区', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(257, '140402', '城区', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(258, '140411', '郊区', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(259, '140421', '长治县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(260, '140423', '襄垣县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(261, '140424', '屯留县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(262, '140425', '平顺县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(263, '140426', '黎城县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(264, '140427', '壶关县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(265, '140428', '长子县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(266, '140429', '武乡县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(267, '140430', '沁县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(268, '140431', '沁源县', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(269, '140481', '潞城市', '140400', '03', '2017-05-26 17:44:11', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(270, '140501', '市辖区', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(271, '140502', '城区', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(272, '140521', '沁水县', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(273, '140522', '阳城县', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(274, '140524', '陵川县', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(275, '140525', '泽州县', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(276, '140581', '高平市', '140500', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(277, '140601', '市辖区', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(278, '140602', '朔城区', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(279, '140603', '平鲁区', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(280, '140621', '山阴县', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(281, '140622', '应县', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(282, '140623', '右玉县', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(283, '140624', '怀仁县', '140600', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(284, '140701', '市辖区', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(285, '140702', '榆次区', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(286, '140721', '榆社县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(287, '140722', '左权县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(288, '140723', '和顺县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(289, '140724', '昔阳县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(290, '140725', '寿阳县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(291, '140726', '太谷县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(292, '140727', '祁县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(293, '140728', '平遥县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(294, '140729', '灵石县', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(295, '140781', '介休市', '140700', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(296, '140801', '市辖区', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(297, '140802', '盐湖区', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(298, '140821', '临猗县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(299, '140822', '万荣县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(300, '140823', '闻喜县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(301, '140824', '稷山县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(302, '140825', '新绛县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(303, '140826', '绛县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(304, '140827', '垣曲县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(305, '140828', '夏县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(306, '140829', '平陆县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(307, '140830', '芮城县', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(308, '140881', '永济市', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(309, '140882', '河津市', '140800', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(310, '140901', '市辖区', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(311, '140902', '忻府区', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(312, '140921', '定襄县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(313, '140922', '五台县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(314, '140923', '代县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(315, '140924', '繁峙县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(316, '140925', '宁武县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(317, '140926', '静乐县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(318, '140927', '神池县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(319, '140928', '五寨县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(320, '140929', '岢岚县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(321, '140930', '河曲县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(322, '140931', '保德县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(323, '140932', '偏关县', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(324, '140981', '原平市', '140900', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(325, '141001', '市辖区', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(326, '141002', '尧都区', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(327, '141021', '曲沃县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(328, '141022', '翼城县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(329, '141023', '襄汾县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(330, '141024', '洪洞县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(331, '141025', '古县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(332, '141026', '安泽县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(333, '141027', '浮山县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(334, '141028', '吉县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(335, '141029', '乡宁县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(336, '141030', '大宁县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(337, '141031', '隰县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(338, '141032', '永和县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(339, '141033', '蒲县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(340, '141034', '汾西县', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(341, '141081', '侯马市', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(342, '141082', '霍州市', '141000', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(343, '141101', '市辖区', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(344, '141102', '离石区', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(345, '141121', '文水县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(346, '141122', '交城县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(347, '141123', '兴县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(348, '141124', '临县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(349, '141125', '柳林县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(350, '141126', '石楼县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(351, '141127', '岚县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(352, '141128', '方山县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(353, '141129', '中阳县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(354, '141130', '交口县', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(355, '141181', '孝义市', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(356, '141182', '汾阳市', '141100', '03', '2017-05-26 17:44:12', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(357, '140100', '太原市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'T', '太原', '0', 0, 0),
	(358, '140200', '大同市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'D', '大同', '0', 0, 0),
	(359, '140300', '阳泉市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'Y', '阳泉', '0', 0, 0),
	(360, '140400', '长治市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'C', '长治', '0', 0, 0),
	(361, '140500', '晋城市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'J', '晋城', '0', 0, 0),
	(362, '140600', '朔州市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'S', '朔州', '0', 0, 0),
	(363, '140700', '晋中市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'J', '晋中', '0', 0, 0),
	(364, '140800', '运城市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'Y', '运城', '0', 0, 0),
	(365, '140900', '忻州市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'X', '忻州', '0', 0, 0),
	(366, '141000', '临汾市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'L', '临汾', '0', 0, 0),
	(367, '141100', '吕梁市', '100004', '02', '2017-05-26 17:44:12', '2020-07-08 11:30:50', 'L', '吕梁', '0', 0, 0),
	(368, '150101', '市辖区', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(369, '150102', '新城区', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(370, '150103', '回民区', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(371, '150104', '玉泉区', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(372, '150105', '赛罕区', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(373, '150121', '土默特左旗', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(374, '150122', '托克托县', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(375, '150123', '和林格尔县', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(376, '150124', '清水河县', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(377, '150125', '武川县', '150100', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(378, '150201', '市辖区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(379, '150202', '东河区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(380, '150203', '昆都仑区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(381, '150204', '青山区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(382, '150205', '石拐区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(383, '150206', '白云鄂博矿区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(384, '150207', '九原区', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(385, '150221', '土默特右旗', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(386, '150222', '固阳县', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(387, '150223', '达尔罕茂明安联合旗', '150200', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(388, '150301', '市辖区', '150300', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(389, '150302', '海勃湾区', '150300', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(390, '150303', '海南区', '150300', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(391, '150304', '乌达区', '150300', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(392, '150401', '市辖区', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(393, '150402', '红山区', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(394, '150403', '元宝山区', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(395, '150404', '松山区', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(396, '150421', '阿鲁科尔沁旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(397, '150422', '巴林左旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(398, '150423', '巴林右旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(399, '150424', '林西县', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(400, '150425', '克什克腾旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(401, '150426', '翁牛特旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(402, '150428', '喀喇沁旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(403, '150429', '宁城县', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(404, '150430', '敖汉旗', '150400', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(405, '150501', '市辖区', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(406, '150502', '科尔沁区', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(407, '150521', '科尔沁左翼中旗', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(408, '150522', '科尔沁左翼后旗', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(409, '150523', '开鲁县', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(410, '150524', '库伦旗', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(411, '150525', '奈曼旗', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(412, '150526', '扎鲁特旗', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(413, '150581', '霍林郭勒市', '150500', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(414, '150601', '市辖区', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(415, '150602', '东胜区', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(416, '150603', '康巴什区', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(417, '150621', '达拉特旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(418, '150622', '准格尔旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(419, '150623', '鄂托克前旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(420, '150624', '鄂托克旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(421, '150625', '杭锦旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(422, '150626', '乌审旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(423, '150627', '伊金霍洛旗', '150600', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(424, '150701', '市辖区', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(425, '150702', '海拉尔区', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(426, '150703', '扎赉诺尔区', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(427, '150721', '阿荣旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(428, '150722', '莫力达瓦达斡尔族自治旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(429, '150723', '鄂伦春自治旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(430, '150724', '鄂温克族自治旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(431, '150725', '陈巴尔虎旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(432, '150726', '新巴尔虎左旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(433, '150727', '新巴尔虎右旗', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(434, '150781', '满洲里市', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(435, '150782', '牙克石市', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(436, '150783', '扎兰屯市', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(437, '150784', '额尔古纳市', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(438, '150785', '根河市', '150700', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(439, '150801', '市辖区', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(440, '150802', '临河区', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(441, '150821', '五原县', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(442, '150822', '磴口县', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(443, '150823', '乌拉特前旗', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(444, '150824', '乌拉特中旗', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(445, '150825', '乌拉特后旗', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(446, '150826', '杭锦后旗', '150800', '03', '2017-05-26 17:44:13', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(447, '150901', '市辖区', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(448, '150902', '集宁区', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(449, '150921', '卓资县', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(450, '150922', '化德县', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(451, '150923', '商都县', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(452, '150924', '兴和县', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(453, '150925', '凉城县', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(454, '150926', '察哈尔右翼前旗', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(455, '150927', '察哈尔右翼中旗', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(456, '150928', '察哈尔右翼后旗', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(457, '150929', '四子王旗', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(458, '150981', '丰镇市', '150900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(459, '152201', '乌兰浩特市', '152200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(460, '152202', '阿尔山市', '152200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(461, '152221', '科尔沁右翼前旗', '152200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(462, '152222', '科尔沁右翼中旗', '152200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(463, '152223', '扎赉特旗', '152200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(464, '152224', '突泉县', '152200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(465, '152501', '二连浩特市', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(466, '152502', '锡林浩特市', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(467, '152522', '阿巴嘎旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(468, '152523', '苏尼特左旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(469, '152524', '苏尼特右旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(470, '152525', '东乌珠穆沁旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(471, '152526', '西乌珠穆沁旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(472, '152527', '太仆寺旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(473, '152528', '镶黄旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(474, '152529', '正镶白旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(475, '152530', '正蓝旗', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(476, '152531', '多伦县', '152500', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(477, '152921', '阿拉善左旗', '152900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(478, '152922', '阿拉善右旗', '152900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(479, '152923', '额济纳旗', '152900', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(480, '150100', '呼和浩特市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'H', '呼和浩特', '0', 0, 0),
	(481, '150200', '包头市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'B', '包头', '0', 0, 0),
	(482, '150300', '乌海市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'W', '乌海', '0', 0, 0),
	(483, '150400', '赤峰市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'C', '赤峰', '0', 0, 0),
	(484, '150500', '通辽市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'T', '通辽', '0', 0, 0),
	(485, '150600', '鄂尔多斯市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'E', '鄂尔多斯', '0', 0, 0),
	(486, '150700', '呼伦贝尔市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'H', '呼伦贝尔', '0', 0, 0),
	(487, '150800', '巴彦淖尔市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'B', '巴彦淖尔', '0', 0, 0),
	(488, '150900', '乌兰察布市', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'W', '乌兰察布', '0', 0, 0),
	(489, '152200', '兴安盟', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'X', '兴安盟', '0', 0, 0),
	(490, '152500', '锡林郭勒盟', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'X', '锡林郭勒盟', '0', 0, 0),
	(491, '152900', '阿拉善盟', '100005', '02', '2017-05-26 17:44:14', '2020-07-08 11:30:50', 'A', '阿拉善盟', '0', 0, 0),
	(492, '210101', '市辖区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(493, '210102', '和平区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(494, '210103', '沈河区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(495, '210104', '大东区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(496, '210105', '皇姑区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(497, '210106', '铁西区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(498, '210111', '苏家屯区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(499, '210112', '浑南区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(500, '210113', '沈北新区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(501, '210114', '于洪区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(502, '210115', '辽中区', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(503, '210123', '康平县', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(504, '210124', '法库县', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(505, '210181', '新民市', '210100', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(506, '210201', '市辖区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(507, '210202', '中山区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(508, '210203', '西岗区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(509, '210204', '沙河口区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(510, '210211', '甘井子区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(511, '210212', '旅顺口区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(512, '210213', '金州区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(513, '210214', '普兰店区', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(514, '210224', '长海县', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(515, '210281', '瓦房店市', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(516, '210283', '庄河市', '210200', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(517, '210301', '市辖区', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(518, '210302', '铁东区', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(519, '210303', '铁西区', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(520, '210304', '立山区', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(521, '210311', '千山区', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(522, '210321', '台安县', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(523, '210323', '岫岩满族自治县', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(524, '210381', '海城市', '210300', '03', '2017-05-26 17:44:14', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(525, '210401', '市辖区', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(526, '210402', '新抚区', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(527, '210403', '东洲区', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(528, '210404', '望花区', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(529, '210411', '顺城区', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(530, '210421', '抚顺县', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(531, '210422', '新宾满族自治县', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(532, '210423', '清原满族自治县', '210400', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(533, '210501', '市辖区', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(534, '210502', '平山区', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(535, '210503', '溪湖区', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(536, '210504', '明山区', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(537, '210505', '南芬区', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(538, '210521', '本溪满族自治县', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(539, '210522', '桓仁满族自治县', '210500', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(540, '210601', '市辖区', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(541, '210602', '元宝区', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(542, '210603', '振兴区', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(543, '210604', '振安区', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(544, '210624', '宽甸满族自治县', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(545, '210681', '东港市', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(546, '210682', '凤城市', '210600', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(547, '210701', '市辖区', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(548, '210702', '古塔区', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(549, '210703', '凌河区', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(550, '210711', '太和区', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(551, '210726', '黑山县', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(552, '210727', '义县', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(553, '210781', '凌海市', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(554, '210782', '北镇市', '210700', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(555, '210801', '市辖区', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(556, '210802', '站前区', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(557, '210803', '西市区', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(558, '210804', '鲅鱼圈区', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(559, '210811', '老边区', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(560, '210881', '盖州市', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(561, '210882', '大石桥市', '210800', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(562, '210901', '市辖区', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(563, '210902', '海州区', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(564, '210903', '新邱区', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(565, '210904', '太平区', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(566, '210905', '清河门区', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(567, '210911', '细河区', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(568, '210921', '阜新蒙古族自治县', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(569, '210922', '彰武县', '210900', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(570, '211001', '市辖区', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(571, '211002', '白塔区', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(572, '211003', '文圣区', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(573, '211004', '宏伟区', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(574, '211005', '弓长岭区', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(575, '211011', '太子河区', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(576, '211021', '辽阳县', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(577, '211081', '灯塔市', '211000', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(578, '211101', '市辖区', '211100', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(579, '211102', '双台子区', '211100', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(580, '211103', '兴隆台区', '211100', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(581, '211104', '大洼区', '211100', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(582, '211122', '盘山县', '211100', '03', '2017-05-26 17:44:15', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(583, '211201', '市辖区', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(584, '211202', '银州区', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(585, '211204', '清河区', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(586, '211221', '铁岭县', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(587, '211223', '西丰县', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(588, '211224', '昌图县', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(589, '211281', '调兵山市', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(590, '211282', '开原市', '211200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(591, '211301', '市辖区', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(592, '211302', '双塔区', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(593, '211303', '龙城区', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(594, '211321', '朝阳县', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(595, '211322', '建平县', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(596, '211324', '喀喇沁左翼蒙古族自治县', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(597, '211381', '北票市', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(598, '211382', '凌源市', '211300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(599, '211401', '市辖区', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(600, '211402', '连山区', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(601, '211403', '龙港区', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(602, '211404', '南票区', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(603, '211421', '绥中县', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(604, '211422', '建昌县', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(605, '211481', '兴城市', '211400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(606, '210100', '沈阳市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'S', '沈阳', '0', 0, 0),
	(607, '210200', '大连市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'D', '大连', '0', 0, 0),
	(608, '210300', '鞍山市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'A', '鞍山', '0', 0, 0),
	(609, '210400', '抚顺市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'F', '抚顺', '0', 0, 0),
	(610, '210500', '本溪市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'B', '本溪', '0', 0, 0),
	(611, '210600', '丹东市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'D', '丹东', '0', 0, 0),
	(612, '210700', '锦州市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'J', '锦州', '0', 0, 0),
	(613, '210800', '营口市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'Y', '营口', '0', 0, 0),
	(614, '210900', '阜新市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'F', '阜新', '0', 0, 0),
	(615, '211000', '辽阳市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'L', '辽阳', '0', 0, 0),
	(616, '211100', '盘锦市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'P', '盘锦', '0', 0, 0),
	(617, '211200', '铁岭市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'T', '铁岭', '0', 0, 0),
	(618, '211300', '朝阳市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'C', '朝阳', '0', 0, 0),
	(619, '211400', '葫芦岛市', '100006', '02', '2017-05-26 17:44:16', '2020-07-08 11:30:50', 'H', '葫芦岛', '0', 0, 0),
	(620, '220101', '市辖区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(621, '220102', '南关区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(622, '220103', '宽城区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(623, '220104', '朝阳区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(624, '220105', '二道区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(625, '220106', '绿园区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(626, '220112', '双阳区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(627, '220113', '九台区', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(628, '220122', '农安县', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(629, '220182', '榆树市', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(630, '220183', '德惠市', '220100', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(631, '220201', '市辖区', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(632, '220202', '昌邑区', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(633, '220203', '龙潭区', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(634, '220204', '船营区', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(635, '220211', '丰满区', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(636, '220221', '永吉县', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(637, '220281', '蛟河市', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(638, '220282', '桦甸市', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(639, '220283', '舒兰市', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(640, '220284', '磐石市', '220200', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(641, '220301', '市辖区', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(642, '220302', '铁西区', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(643, '220303', '铁东区', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(644, '220322', '梨树县', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(645, '220323', '伊通满族自治县', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(646, '220381', '公主岭市', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(647, '220382', '双辽市', '220300', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(648, '220401', '市辖区', '220400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(649, '220402', '龙山区', '220400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(650, '220403', '西安区', '220400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(651, '220421', '东丰县', '220400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(652, '220422', '东辽县', '220400', '03', '2017-05-26 17:44:16', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(653, '220501', '市辖区', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(654, '220502', '东昌区', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(655, '220503', '二道江区', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(656, '220521', '通化县', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(657, '220523', '辉南县', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(658, '220524', '柳河县', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(659, '220581', '梅河口市', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(660, '220582', '集安市', '220500', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(661, '220601', '市辖区', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(662, '220602', '浑江区', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(663, '220605', '江源区', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(664, '220621', '抚松县', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(665, '220622', '靖宇县', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(666, '220623', '长白朝鲜族自治县', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(667, '220681', '临江市', '220600', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(668, '220701', '市辖区', '220700', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(669, '220702', '宁江区', '220700', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(670, '220721', '前郭尔罗斯蒙古族自治县', '220700', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(671, '220722', '长岭县', '220700', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(672, '220723', '乾安县', '220700', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(673, '220781', '扶余市', '220700', '03', '2017-05-26 17:44:17', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(674, '220801', '市辖区', '220800', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(675, '220802', '洮北区', '220800', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(676, '220821', '镇赉县', '220800', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(677, '220822', '通榆县', '220800', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(678, '220881', '洮南市', '220800', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(679, '220882', '大安市', '220800', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(680, '222401', '延吉市', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(681, '222402', '图们市', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(682, '222403', '敦化市', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(683, '222404', '珲春市', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(684, '222405', '龙井市', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(685, '222406', '和龙市', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(686, '222424', '汪清县', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(687, '222426', '安图县', '222400', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(688, '220100', '长春市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'C', '长春', '0', 0, 0),
	(689, '220200', '吉林市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'J', '吉林', '0', 0, 0),
	(690, '220300', '四平市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'S', '四平', '0', 0, 0),
	(691, '220400', '辽源市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'L', '辽源', '0', 0, 0),
	(692, '220500', '通化市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'T', '通化', '0', 0, 0),
	(693, '220600', '白山市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'B', '白山', '0', 0, 0),
	(694, '220700', '松原市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'S', '松原', '0', 0, 0),
	(695, '220800', '白城市', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'B', '白城', '0', 0, 0),
	(696, '222400', '延边朝鲜族自治州', '100007', '02', '2017-05-26 17:44:48', '2020-07-08 11:30:50', 'Y', '延边朝鲜族自治州', '0', 0, 0),
	(697, '230101', '市辖区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(698, '230102', '道里区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(699, '230103', '南岗区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(700, '230104', '道外区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(701, '230108', '平房区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(702, '230109', '松北区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(703, '230110', '香坊区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(704, '230111', '呼兰区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(705, '230112', '阿城区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(706, '230113', '双城区', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(707, '230123', '依兰县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(708, '230124', '方正县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(709, '230125', '宾县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(710, '230126', '巴彦县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(711, '230127', '木兰县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(712, '230128', '通河县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(713, '230129', '延寿县', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(714, '230183', '尚志市', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(715, '230184', '五常市', '230100', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(716, '230201', '市辖区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(717, '230202', '龙沙区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(718, '230203', '建华区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(719, '230204', '铁锋区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(720, '230205', '昂昂溪区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(721, '230206', '富拉尔基区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(722, '230207', '碾子山区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(723, '230208', '梅里斯达斡尔族区', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(724, '230221', '龙江县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(725, '230223', '依安县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(726, '230224', '泰来县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(727, '230225', '甘南县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(728, '230227', '富裕县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(729, '230229', '克山县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(730, '230230', '克东县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(731, '230231', '拜泉县', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(732, '230281', '讷河市', '230200', '03', '2017-05-26 17:44:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(733, '230301', '市辖区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(734, '230302', '鸡冠区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(735, '230303', '恒山区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(736, '230304', '滴道区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(737, '230305', '梨树区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(738, '230306', '城子河区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(739, '230307', '麻山区', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(740, '230321', '鸡东县', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(741, '230381', '虎林市', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(742, '230382', '密山市', '230300', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(743, '230401', '市辖区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(744, '230402', '向阳区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(745, '230403', '工农区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(746, '230404', '南山区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(747, '230405', '兴安区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(748, '230406', '东山区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(749, '230407', '兴山区', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(750, '230421', '萝北县', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(751, '230422', '绥滨县', '230400', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(752, '230501', '市辖区', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(753, '230502', '尖山区', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(754, '230503', '岭东区', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(755, '230505', '四方台区', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(756, '230506', '宝山区', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(757, '230521', '集贤县', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(758, '230522', '友谊县', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(759, '230523', '宝清县', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(760, '230524', '饶河县', '230500', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(761, '230601', '市辖区', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(762, '230602', '萨尔图区', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(763, '230603', '龙凤区', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(764, '230604', '让胡路区', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(765, '230605', '红岗区', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(766, '230606', '大同区', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(767, '230621', '肇州县', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(768, '230622', '肇源县', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(769, '230623', '林甸县', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(770, '230624', '杜尔伯特蒙古族自治县', '230600', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(771, '230701', '市辖区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(772, '230702', '伊春区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(773, '230703', '南岔区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(774, '230704', '友好区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(775, '230705', '西林区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(776, '230706', '翠峦区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(777, '230707', '新青区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(778, '230708', '美溪区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(779, '230709', '金山屯区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(780, '230710', '五营区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(781, '230711', '乌马河区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(782, '230712', '汤旺河区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(783, '230713', '带岭区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(784, '230714', '乌伊岭区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(785, '230715', '红星区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(786, '230716', '上甘岭区', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(787, '230722', '嘉荫县', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(788, '230781', '铁力市', '230700', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(789, '230801', '市辖区', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(790, '230803', '向阳区', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(791, '230804', '前进区', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(792, '230805', '东风区', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(793, '230811', '郊区', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(794, '230822', '桦南县', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(795, '230826', '桦川县', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(796, '230828', '汤原县', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(797, '230881', '同江市', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(798, '230882', '富锦市', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(799, '230883', '抚远市', '230800', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(800, '230901', '市辖区', '230900', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(801, '230902', '新兴区', '230900', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(802, '230903', '桃山区', '230900', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(803, '230904', '茄子河区', '230900', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(804, '230921', '勃利县', '230900', '03', '2017-05-26 17:44:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(805, '231001', '市辖区', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(806, '231002', '东安区', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(807, '231003', '阳明区', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(808, '231004', '爱民区', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(809, '231005', '西安区', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(810, '231025', '林口县', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(811, '231081', '绥芬河市', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(812, '231083', '海林市', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(813, '231084', '宁安市', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(814, '231085', '穆棱市', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(815, '231086', '东宁市', '231000', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(816, '231101', '市辖区', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(817, '231102', '爱辉区', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(818, '231121', '嫩江县', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(819, '231123', '逊克县', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(820, '231124', '孙吴县', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(821, '231181', '北安市', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(822, '231182', '五大连池市', '231100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(823, '231201', '市辖区', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(824, '231202', '北林区', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(825, '231221', '望奎县', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(826, '231222', '兰西县', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(827, '231223', '青冈县', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(828, '231224', '庆安县', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(829, '231225', '明水县', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(830, '231226', '绥棱县', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(831, '231281', '安达市', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(832, '231282', '肇东市', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(833, '231283', '海伦市', '231200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(834, '232721', '呼玛县', '232700', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(835, '232722', '塔河县', '232700', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(836, '232723', '漠河县', '232700', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(837, '230100', '哈尔滨市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'H', '哈尔滨', '0', 0, 0),
	(838, '230200', '齐齐哈尔市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'Q', '齐齐哈尔', '0', 0, 0),
	(839, '230300', '鸡西市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'J', '鸡西', '0', 0, 0),
	(840, '230400', '鹤岗市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'H', '鹤岗', '0', 0, 0),
	(841, '230500', '双鸭山市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'S', '双鸭山', '0', 0, 0),
	(842, '230600', '大庆市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'D', '大庆', '0', 0, 0),
	(843, '230700', '伊春市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'Y', '伊春', '0', 0, 0),
	(844, '230800', '佳木斯市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'J', '佳木斯', '0', 0, 0),
	(845, '230900', '七台河市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'Q', '七台河', '0', 0, 0),
	(846, '231000', '牡丹江市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'M', '牡丹江', '0', 0, 0),
	(847, '231100', '黑河市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'H', '黑河', '0', 0, 0),
	(848, '231200', '绥化市', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'S', '绥化', '0', 0, 0),
	(849, '232700', '大兴安岭地区', '100008', '02', '2017-05-26 17:44:50', '2020-07-08 11:30:50', 'D', '大兴安岭地区', '0', 0, 0),
	(850, '310101', '黄浦区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(851, '310104', '徐汇区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(852, '310105', '长宁区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(853, '310106', '静安区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(854, '310107', '普陀区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(855, '310109', '虹口区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(856, '310110', '杨浦区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(857, '310112', '闵行区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(858, '310113', '宝山区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(859, '310114', '嘉定区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(860, '310115', '浦东新区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(861, '310116', '金山区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(862, '310117', '松江区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(863, '310118', '青浦区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(864, '310120', '奉贤区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(865, '310151', '崇明区', '310100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(866, '310100', '上海市', '100009', '02', '2017-05-26 17:44:50', '2020-07-30 15:30:33', 'S', '上海', '0', 100, 1),
	(867, '320101', '市辖区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(868, '320102', '玄武区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(869, '320104', '秦淮区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(870, '320105', '建邺区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(871, '320106', '鼓楼区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(872, '320111', '浦口区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(873, '320113', '栖霞区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(874, '320114', '雨花台区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(875, '320115', '江宁区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(876, '320116', '六合区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(877, '320117', '溧水区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(878, '320118', '高淳区', '320100', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(879, '320201', '市辖区', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(880, '320205', '锡山区', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(881, '320206', '惠山区', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(882, '320211', '滨湖区', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(883, '320213', '梁溪区', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(884, '320214', '新吴区', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(885, '320281', '江阴市', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(886, '320282', '宜兴市', '320200', '03', '2017-05-26 17:44:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(887, '320301', '市辖区', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(888, '320302', '鼓楼区', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(889, '320303', '云龙区', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(890, '320305', '贾汪区', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(891, '320311', '泉山区', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(892, '320312', '铜山区', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(893, '320321', '丰县', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(894, '320322', '沛县', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(895, '320324', '睢宁县', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(896, '320381', '新沂市', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(897, '320382', '邳州市', '320300', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(898, '320401', '市辖区', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(899, '320402', '天宁区', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(900, '320404', '钟楼区', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(901, '320411', '新北区', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(902, '320412', '武进区', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(903, '320413', '金坛区', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(904, '320481', '溧阳市', '320400', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(905, '320501', '市辖区', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(906, '320505', '虎丘区', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(907, '320506', '吴中区', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(908, '320507', '相城区', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(909, '320508', '姑苏区', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(910, '320509', '吴江区', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(911, '320581', '常熟市', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(912, '320582', '张家港市', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(913, '320583', '昆山市', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(914, '320585', '太仓市', '320500', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(915, '320601', '市辖区', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(916, '320602', '崇川区', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(917, '320611', '港闸区', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(918, '320612', '通州区', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(919, '320621', '海安县', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(920, '320623', '如东县', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(921, '320681', '启东市', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(922, '320682', '如皋市', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(923, '320684', '海门市', '320600', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(924, '320701', '市辖区', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(925, '320703', '连云区', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(926, '320706', '海州区', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(927, '320707', '赣榆区', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(928, '320722', '东海县', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(929, '320723', '灌云县', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(930, '320724', '灌南县', '320700', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(931, '320801', '市辖区', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(932, '320803', '淮安区', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(933, '320804', '淮阴区', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(934, '320812', '清江浦区', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(935, '320813', '洪泽区', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(936, '320826', '涟水县', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(937, '320830', '盱眙县', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(938, '320831', '金湖县', '320800', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(939, '320901', '市辖区', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(940, '320902', '亭湖区', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(941, '320903', '盐都区', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(942, '320904', '大丰区', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(943, '320921', '响水县', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(944, '320922', '滨海县', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(945, '320923', '阜宁县', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(946, '320924', '射阳县', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(947, '320925', '建湖县', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(948, '320981', '东台市', '320900', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(949, '321001', '市辖区', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(950, '321002', '广陵区', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(951, '321003', '邗江区', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(952, '321012', '江都区', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(953, '321023', '宝应县', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(954, '321081', '仪征市', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(955, '321084', '高邮市', '321000', '03', '2017-05-26 17:44:51', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(956, '321101', '市辖区', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(957, '321102', '京口区', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(958, '321111', '润州区', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(959, '321112', '丹徒区', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(960, '321181', '丹阳市', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(961, '321182', '扬中市', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(962, '321183', '句容市', '321100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(963, '321201', '市辖区', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(964, '321202', '海陵区', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(965, '321203', '高港区', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(966, '321204', '姜堰区', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(967, '321281', '兴化市', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(968, '321282', '靖江市', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(969, '321283', '泰兴市', '321200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(970, '321301', '市辖区', '321300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(971, '321302', '宿城区', '321300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(972, '321311', '宿豫区', '321300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(973, '321322', '沭阳县', '321300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(974, '321323', '泗阳县', '321300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(975, '321324', '泗洪县', '321300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(976, '320100', '南京市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'N', '南京', '0', 0, 0),
	(977, '320200', '无锡市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'W', '无锡', '0', 0, 0),
	(978, '320300', '徐州市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'X', '徐州', '0', 0, 0),
	(979, '320400', '常州市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'C', '常州', '0', 0, 0),
	(980, '320500', '苏州市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'S', '苏州', '0', 0, 0),
	(981, '320600', '南通市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'N', '南通', '0', 0, 0),
	(982, '320700', '连云港市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'L', '连云港', '0', 0, 0),
	(983, '320800', '淮安市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'H', '淮安', '0', 0, 0),
	(984, '320900', '盐城市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'Y', '盐城', '0', 0, 0),
	(985, '321000', '扬州市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'Y', '扬州', '0', 0, 0),
	(986, '321100', '镇江市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'Z', '镇江', '0', 0, 0),
	(987, '321200', '泰州市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'T', '泰州', '0', 0, 0),
	(988, '321300', '宿迁市', '100010', '02', '2017-05-26 17:44:52', '2020-07-08 11:30:50', 'S', '宿迁', '0', 0, 0),
	(989, '330101', '市辖区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(990, '330102', '上城区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(991, '330103', '下城区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(992, '330104', '江干区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(993, '330105', '拱墅区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(994, '330106', '西湖区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(995, '330108', '滨江区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(996, '330109', '萧山区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(997, '330110', '余杭区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(998, '330111', '富阳区', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(999, '330122', '桐庐县', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1000, '330127', '淳安县', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1001, '330182', '建德市', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1002, '330185', '临安市', '330100', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1003, '330201', '市辖区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1004, '330203', '海曙区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1005, '330204', '江东区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1006, '330205', '江北区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1007, '330206', '北仑区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1008, '330211', '镇海区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1009, '330212', '鄞州区', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1010, '330225', '象山县', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1011, '330226', '宁海县', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1012, '330281', '余姚市', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1013, '330282', '慈溪市', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1014, '330283', '奉化市', '330200', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1015, '330301', '市辖区', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1016, '330302', '鹿城区', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1017, '330303', '龙湾区', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1018, '330304', '瓯海区', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1019, '330305', '洞头区', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1020, '330324', '永嘉县', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1021, '330326', '平阳县', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1022, '330327', '苍南县', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1023, '330328', '文成县', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1024, '330329', '泰顺县', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1025, '330381', '瑞安市', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1026, '330382', '乐清市', '330300', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1027, '330401', '市辖区', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1028, '330402', '南湖区', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1029, '330411', '秀洲区', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1030, '330421', '嘉善县', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1031, '330424', '海盐县', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1032, '330481', '海宁市', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1033, '330482', '平湖市', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1034, '330483', '桐乡市', '330400', '03', '2017-05-26 17:44:52', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1035, '330501', '市辖区', '330500', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1036, '330502', '吴兴区', '330500', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1037, '330503', '南浔区', '330500', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1038, '330521', '德清县', '330500', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1039, '330522', '长兴县', '330500', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1040, '330523', '安吉县', '330500', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1041, '330601', '市辖区', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1042, '330602', '越城区', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1043, '330603', '柯桥区', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(1044, '330604', '上虞区', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1045, '330624', '新昌县', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1046, '330681', '诸暨市', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1047, '330683', '嵊州市', '330600', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1048, '330701', '市辖区', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1049, '330702', '婺城区', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1050, '330703', '金东区', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1051, '330723', '武义县', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1052, '330726', '浦江县', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1053, '330727', '磐安县', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1054, '330781', '兰溪市', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1055, '330782', '义乌市', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1056, '330783', '东阳市', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1057, '330784', '永康市', '330700', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1058, '330801', '市辖区', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1059, '330802', '柯城区', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(1060, '330803', '衢江区', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1061, '330822', '常山县', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1062, '330824', '开化县', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(1063, '330825', '龙游县', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1064, '330881', '江山市', '330800', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1065, '330901', '市辖区', '330900', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1066, '330902', '定海区', '330900', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1067, '330903', '普陀区', '330900', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1068, '330921', '岱山县', '330900', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1069, '330922', '嵊泗县', '330900', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1070, '331001', '市辖区', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1071, '331002', '椒江区', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1072, '331003', '黄岩区', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1073, '331004', '路桥区', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1074, '331021', '玉环县', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1075, '331022', '三门县', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1076, '331023', '天台县', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1077, '331024', '仙居县', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1078, '331081', '温岭市', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1079, '331082', '临海市', '331000', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1080, '331101', '市辖区', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1081, '331102', '莲都区', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1082, '331121', '青田县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1083, '331122', '缙云县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1084, '331123', '遂昌县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1085, '331124', '松阳县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1086, '331125', '云和县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1087, '331126', '庆元县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1088, '331127', '景宁畲族自治县', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1089, '331181', '龙泉市', '331100', '03', '2017-05-26 17:44:53', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1090, '330100', '杭州市', '100011', '02', '2017-05-26 17:44:53', '2020-07-25 14:59:15', 'H', '杭州', '0', 0, 1),
	(1091, '330200', '宁波市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'N', '宁波', '0', 0, 0),
	(1092, '330300', '温州市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'W', '温州', '0', 0, 0),
	(1093, '330400', '嘉兴市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'J', '嘉兴', '0', 0, 0),
	(1094, '330500', '湖州市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'H', '湖州', '0', 0, 0),
	(1095, '330600', '绍兴市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'S', '绍兴', '0', 0, 0),
	(1096, '330700', '金华市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'J', '金华', '0', 0, 0),
	(1097, '330800', '衢州市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'Z', '衢州', '0', 0, 0),
	(1098, '330900', '舟山市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'Z', '舟山', '0', 0, 0),
	(1099, '331000', '台州市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'T', '台州', '0', 0, 0),
	(1100, '331100', '丽水市', '100011', '02', '2017-05-26 17:44:53', '2020-07-08 11:30:50', 'L', '丽水', '0', 0, 0),
	(1101, '340101', '市辖区', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1102, '340102', '瑶海区', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1103, '340103', '庐阳区', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1104, '340104', '蜀山区', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1105, '340111', '包河区', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1106, '340121', '长丰县', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1107, '340122', '肥东县', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1108, '340123', '肥西县', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1109, '340124', '庐江县', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1110, '340181', '巢湖市', '340100', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1111, '340201', '市辖区', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1112, '340202', '镜湖区', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1113, '340203', '弋江区', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1114, '340207', '鸠江区', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1115, '340208', '三山区', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1116, '340221', '芜湖县', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1117, '340222', '繁昌县', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1118, '340223', '南陵县', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1119, '340225', '无为县', '340200', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1120, '340301', '市辖区', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1121, '340302', '龙子湖区', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1122, '340303', '蚌山区', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1123, '340304', '禹会区', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1124, '340311', '淮上区', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1125, '340321', '怀远县', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1126, '340322', '五河县', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1127, '340323', '固镇县', '340300', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1128, '340401', '市辖区', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1129, '340402', '大通区', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1130, '340403', '田家庵区', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1131, '340404', '谢家集区', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1132, '340405', '八公山区', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1133, '340406', '潘集区', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1134, '340421', '凤台县', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1135, '340422', '寿县', '340400', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1136, '340501', '市辖区', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1137, '340503', '花山区', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1138, '340504', '雨山区', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1139, '340506', '博望区', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1140, '340521', '当涂县', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1141, '340522', '含山县', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1142, '340523', '和县', '340500', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1143, '340601', '市辖区', '340600', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1144, '340602', '杜集区', '340600', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1145, '340603', '相山区', '340600', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1146, '340604', '烈山区', '340600', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1147, '340621', '濉溪县', '340600', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1148, '340701', '市辖区', '340700', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1149, '340705', '铜官区', '340700', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1150, '340706', '义安区', '340700', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1151, '340711', '郊区', '340700', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1152, '340722', '枞阳县', '340700', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1153, '340801', '市辖区', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1154, '340802', '迎江区', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1155, '340803', '大观区', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1156, '340811', '宜秀区', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1157, '340822', '怀宁县', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1158, '340824', '潜山县', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1159, '340825', '太湖县', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1160, '340826', '宿松县', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1161, '340827', '望江县', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1162, '340828', '岳西县', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1163, '340881', '桐城市', '340800', '03', '2017-05-26 17:44:54', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1164, '341001', '市辖区', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1165, '341002', '屯溪区', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1166, '341003', '黄山区', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1167, '341004', '徽州区', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1168, '341021', '歙县', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1169, '341022', '休宁县', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1170, '341023', '黟县', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1171, '341024', '祁门县', '341000', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1172, '341101', '市辖区', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1173, '341102', '琅琊区', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1174, '341103', '南谯区', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1175, '341122', '来安县', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1176, '341124', '全椒县', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1177, '341125', '定远县', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1178, '341126', '凤阳县', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1179, '341181', '天长市', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1180, '341182', '明光市', '341100', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1181, '341201', '市辖区', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1182, '341202', '颍州区', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1183, '341203', '颍东区', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1184, '341204', '颍泉区', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1185, '341221', '临泉县', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1186, '341222', '太和县', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1187, '341225', '阜南县', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1188, '341226', '颍上县', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1189, '341282', '界首市', '341200', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1190, '341301', '市辖区', '341300', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1191, '341302', '埇桥区', '341300', '03', '2017-05-26 17:44:55', '2017-11-20 20:55:24', 'Y', NULL, NULL, 0, 0),
	(1192, '341321', '砀山县', '341300', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1193, '341322', '萧县', '341300', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1194, '341323', '灵璧县', '341300', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1195, '341324', '泗县', '341300', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1196, '341501', '市辖区', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1197, '341502', '金安区', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1198, '341503', '裕安区', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1199, '341504', '叶集区', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1200, '341522', '霍邱县', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1201, '341523', '舒城县', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1202, '341524', '金寨县', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1203, '341525', '霍山县', '341500', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1204, '341601', '市辖区', '341600', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1205, '341602', '谯城区', '341600', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1206, '341621', '涡阳县', '341600', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1207, '341622', '蒙城县', '341600', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1208, '341623', '利辛县', '341600', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1209, '341701', '市辖区', '341700', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1210, '341702', '贵池区', '341700', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1211, '341721', '东至县', '341700', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1212, '341722', '石台县', '341700', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1213, '341723', '青阳县', '341700', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1214, '341801', '市辖区', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1215, '341802', '宣州区', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1216, '341821', '郎溪县', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1217, '341822', '广德县', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1218, '341823', '泾县', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1219, '341824', '绩溪县', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1220, '341825', '旌德县', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1221, '341881', '宁国市', '341800', '03', '2017-05-26 17:44:55', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1222, '340100', '合肥市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'H', '合肥', '0', 0, 0),
	(1223, '340200', '芜湖市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'W', '芜湖', '0', 0, 0),
	(1224, '340300', '蚌埠市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'B', '蚌埠', '0', 0, 0),
	(1225, '340400', '淮南市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'H', '淮南', '0', 0, 0),
	(1226, '340500', '马鞍山市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'M', '马鞍山', '0', 0, 0),
	(1227, '340600', '淮北市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'H', '淮北', '0', 0, 0),
	(1228, '340700', '铜陵市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'T', '铜陵', '0', 0, 0),
	(1229, '340800', '安庆市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'A', '安庆', '0', 0, 0),
	(1230, '341000', '黄山市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'H', '黄山', '0', 0, 0),
	(1231, '341100', '滁州市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'C', '滁州', '0', 0, 0),
	(1232, '341200', '阜阳市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'F', '阜阳', '0', 0, 0),
	(1233, '341300', '宿州市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'S', '宿州', '0', 0, 0),
	(1234, '341500', '六安市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'L', '六安', '0', 0, 0),
	(1235, '341600', '亳州市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'Z', '亳州', '0', 0, 0),
	(1236, '341700', '池州市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'C', '池州', '0', 0, 0),
	(1237, '341800', '宣城市', '100012', '02', '2017-05-26 17:44:56', '2020-07-08 11:30:50', 'X', '宣城', '0', 0, 0),
	(1238, '350101', '市辖区', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1239, '350102', '鼓楼区', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1240, '350103', '台江区', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1241, '350104', '仓山区', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1242, '350105', '马尾区', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1243, '350111', '晋安区', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1244, '350121', '闽侯县', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1245, '350122', '连江县', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1246, '350123', '罗源县', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1247, '350124', '闽清县', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1248, '350125', '永泰县', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1249, '350128', '平潭县', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1250, '350181', '福清市', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1251, '350182', '长乐市', '350100', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1252, '350201', '市辖区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1253, '350203', '思明区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1254, '350205', '海沧区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1255, '350206', '湖里区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1256, '350211', '集美区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1257, '350212', '同安区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1258, '350213', '翔安区', '350200', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1259, '350301', '市辖区', '350300', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1260, '350302', '城厢区', '350300', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1261, '350303', '涵江区', '350300', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1262, '350304', '荔城区', '350300', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1263, '350305', '秀屿区', '350300', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1264, '350322', '仙游县', '350300', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1265, '350401', '市辖区', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1266, '350402', '梅列区', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1267, '350403', '三元区', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1268, '350421', '明溪县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1269, '350423', '清流县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1270, '350424', '宁化县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1271, '350425', '大田县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1272, '350426', '尤溪县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1273, '350427', '沙县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1274, '350428', '将乐县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1275, '350429', '泰宁县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1276, '350430', '建宁县', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1277, '350481', '永安市', '350400', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1278, '350501', '市辖区', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1279, '350502', '鲤城区', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1280, '350503', '丰泽区', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1281, '350504', '洛江区', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1282, '350505', '泉港区', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1283, '350521', '惠安县', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1284, '350524', '安溪县', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1285, '350525', '永春县', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1286, '350526', '德化县', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1287, '350527', '金门县', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1288, '350581', '石狮市', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1289, '350582', '晋江市', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1290, '350583', '南安市', '350500', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1291, '350601', '市辖区', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1292, '350602', '芗城区', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1293, '350603', '龙文区', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1294, '350622', '云霄县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1295, '350623', '漳浦县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1296, '350624', '诏安县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1297, '350625', '长泰县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1298, '350626', '东山县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1299, '350627', '南靖县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1300, '350628', '平和县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1301, '350629', '华安县', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1302, '350681', '龙海市', '350600', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1303, '350701', '市辖区', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1304, '350702', '延平区', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1305, '350703', '建阳区', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1306, '350721', '顺昌县', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1307, '350722', '浦城县', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1308, '350723', '光泽县', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1309, '350724', '松溪县', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1310, '350725', '政和县', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1311, '350781', '邵武市', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1312, '350782', '武夷山市', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1313, '350783', '建瓯市', '350700', '03', '2017-05-26 17:44:56', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1314, '350801', '市辖区', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1315, '350802', '新罗区', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1316, '350803', '永定区', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1317, '350821', '长汀县', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1318, '350823', '上杭县', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1319, '350824', '武平县', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1320, '350825', '连城县', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1321, '350881', '漳平市', '350800', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1322, '350901', '市辖区', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1323, '350902', '蕉城区', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1324, '350921', '霞浦县', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1325, '350922', '古田县', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1326, '350923', '屏南县', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1327, '350924', '寿宁县', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1328, '350925', '周宁县', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1329, '350926', '柘荣县', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1330, '350981', '福安市', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1331, '350982', '福鼎市', '350900', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1332, '350100', '福州市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'F', '福州', '0', 0, 0),
	(1333, '350200', '厦门市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'X', '厦门', '0', 0, 0),
	(1334, '350300', '莆田市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'P', '莆田', '0', 0, 0),
	(1335, '350400', '三明市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'S', '三明', '0', 0, 0),
	(1336, '350500', '泉州市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'Q', '泉州', '0', 0, 0),
	(1337, '350600', '漳州市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'Z', '漳州', '0', 0, 0),
	(1338, '350700', '南平市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'N', '南平', '0', 0, 0),
	(1339, '350800', '龙岩市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'L', '龙岩', '0', 0, 0),
	(1340, '350900', '宁德市', '100013', '02', '2017-05-26 17:44:57', '2020-07-08 11:30:50', 'N', '宁德', '0', 0, 0),
	(1341, '360101', '市辖区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1342, '360102', '东湖区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1343, '360103', '西湖区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1344, '360104', '青云谱区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1345, '360105', '湾里区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1346, '360111', '青山湖区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1347, '360112', '新建区', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1348, '360121', '南昌县', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1349, '360123', '安义县', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1350, '360124', '进贤县', '360100', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1351, '360201', '市辖区', '360200', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1352, '360202', '昌江区', '360200', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1353, '360203', '珠山区', '360200', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1354, '360222', '浮梁县', '360200', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1355, '360281', '乐平市', '360200', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1356, '360301', '市辖区', '360300', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1357, '360302', '安源区', '360300', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1358, '360313', '湘东区', '360300', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1359, '360321', '莲花县', '360300', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1360, '360322', '上栗县', '360300', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1361, '360323', '芦溪县', '360300', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1362, '360401', '市辖区', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1363, '360402', '濂溪区', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1364, '360403', '浔阳区', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1365, '360421', '九江县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1366, '360423', '武宁县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1367, '360424', '修水县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1368, '360425', '永修县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1369, '360426', '德安县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1370, '360428', '都昌县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1371, '360429', '湖口县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1372, '360430', '彭泽县', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1373, '360481', '瑞昌市', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1374, '360482', '共青城市', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1375, '360483', '庐山市', '360400', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1376, '360501', '市辖区', '360500', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1377, '360502', '渝水区', '360500', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1378, '360521', '分宜县', '360500', '03', '2017-05-26 17:44:57', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1379, '360601', '市辖区', '360600', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1380, '360602', '月湖区', '360600', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1381, '360622', '余江县', '360600', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1382, '360681', '贵溪市', '360600', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1383, '360701', '市辖区', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1384, '360702', '章贡区', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1385, '360703', '南康区', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1386, '360721', '赣县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1387, '360722', '信丰县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1388, '360723', '大余县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1389, '360724', '上犹县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1390, '360725', '崇义县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1391, '360726', '安远县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1392, '360727', '龙南县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1393, '360728', '定南县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1394, '360729', '全南县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1395, '360730', '宁都县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1396, '360731', '于都县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1397, '360732', '兴国县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1398, '360733', '会昌县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1399, '360734', '寻乌县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1400, '360735', '石城县', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1401, '360781', '瑞金市', '360700', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1402, '360801', '市辖区', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1403, '360802', '吉州区', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1404, '360803', '青原区', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1405, '360821', '吉安县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1406, '360822', '吉水县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1407, '360823', '峡江县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1408, '360824', '新干县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1409, '360825', '永丰县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1410, '360826', '泰和县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1411, '360827', '遂川县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1412, '360828', '万安县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1413, '360829', '安福县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1414, '360830', '永新县', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1415, '360881', '井冈山市', '360800', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1416, '360901', '市辖区', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1417, '360902', '袁州区', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1418, '360921', '奉新县', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1419, '360922', '万载县', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1420, '360923', '上高县', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1421, '360924', '宜丰县', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1422, '360925', '靖安县', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1423, '360926', '铜鼓县', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1424, '360981', '丰城市', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1425, '360982', '樟树市', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1426, '360983', '高安市', '360900', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1427, '361001', '市辖区', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1428, '361002', '临川区', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1429, '361021', '南城县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1430, '361022', '黎川县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1431, '361023', '南丰县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1432, '361024', '崇仁县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1433, '361025', '乐安县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1434, '361026', '宜黄县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1435, '361027', '金溪县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1436, '361028', '资溪县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1437, '361029', '东乡县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1438, '361030', '广昌县', '361000', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1439, '361101', '市辖区', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1440, '361102', '信州区', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1441, '361103', '广丰区', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1442, '361121', '上饶县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1443, '361123', '玉山县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1444, '361124', '铅山县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1445, '361125', '横峰县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1446, '361126', '弋阳县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1447, '361127', '余干县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1448, '361128', '鄱阳县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1449, '361129', '万年县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1450, '361130', '婺源县', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1451, '361181', '德兴市', '361100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1452, '360100', '南昌市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'N', '南昌', '0', 0, 0),
	(1453, '360200', '景德镇市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'J', '景德镇', '0', 0, 0),
	(1454, '360300', '萍乡市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'P', '萍乡', '0', 0, 0),
	(1455, '360400', '九江市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'J', '九江', '0', 0, 0),
	(1456, '360500', '新余市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'X', '新余', '0', 0, 0),
	(1457, '360600', '鹰潭市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'Y', '鹰潭', '0', 0, 0),
	(1458, '360700', '赣州市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'G', '赣州', '0', 0, 0),
	(1459, '360800', '吉安市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'J', '吉安', '0', 0, 0),
	(1460, '360900', '宜春市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'Y', '宜春', '0', 0, 0),
	(1461, '361000', '抚州市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'F', '抚州', '0', 0, 0),
	(1462, '361100', '上饶市', '100014', '02', '2017-05-26 17:44:58', '2020-07-08 11:30:50', 'S', '上饶', '0', 0, 0),
	(1463, '370101', '市辖区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1464, '370102', '历下区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1465, '370103', '市中区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1466, '370104', '槐荫区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1467, '370105', '天桥区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1468, '370112', '历城区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1469, '370113', '长清区', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1470, '370124', '平阴县', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1471, '370125', '济阳县', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1472, '370126', '商河县', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1473, '370181', '章丘市', '370100', '03', '2017-05-26 17:44:58', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1474, '370201', '市辖区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1475, '370202', '市南区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1476, '370203', '市北区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1477, '370211', '黄岛区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1478, '370212', '崂山区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1479, '370213', '李沧区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1480, '370214', '城阳区', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1481, '370281', '胶州市', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1482, '370282', '即墨市', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1483, '370283', '平度市', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1484, '370285', '莱西市', '370200', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1485, '370301', '市辖区', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1486, '370302', '淄川区', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1487, '370303', '张店区', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1488, '370304', '博山区', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1489, '370305', '临淄区', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1490, '370306', '周村区', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1491, '370321', '桓台县', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1492, '370322', '高青县', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1493, '370323', '沂源县', '370300', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1494, '370401', '市辖区', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1495, '370402', '市中区', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1496, '370403', '薛城区', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1497, '370404', '峄城区', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1498, '370405', '台儿庄区', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1499, '370406', '山亭区', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1500, '370481', '滕州市', '370400', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1501, '370501', '市辖区', '370500', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1502, '370502', '东营区', '370500', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1503, '370503', '河口区', '370500', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1504, '370505', '垦利区', '370500', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(1505, '370522', '利津县', '370500', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1506, '370523', '广饶县', '370500', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1507, '370601', '市辖区', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1508, '370602', '芝罘区', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1509, '370611', '福山区', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1510, '370612', '牟平区', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1511, '370613', '莱山区', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1512, '370634', '长岛县', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1513, '370681', '龙口市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1514, '370682', '莱阳市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1515, '370683', '莱州市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1516, '370684', '蓬莱市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1517, '370685', '招远市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1518, '370686', '栖霞市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1519, '370687', '海阳市', '370600', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1520, '370701', '市辖区', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1521, '370702', '潍城区', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1522, '370703', '寒亭区', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1523, '370704', '坊子区', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1524, '370705', '奎文区', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(1525, '370724', '临朐县', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1526, '370725', '昌乐县', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1527, '370781', '青州市', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1528, '370782', '诸城市', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1529, '370783', '寿光市', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1530, '370784', '安丘市', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1531, '370785', '高密市', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1532, '370786', '昌邑市', '370700', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1533, '370801', '市辖区', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1534, '370811', '任城区', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1535, '370812', '兖州区', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1536, '370826', '微山县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1537, '370827', '鱼台县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1538, '370828', '金乡县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1539, '370829', '嘉祥县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1540, '370830', '汶上县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1541, '370831', '泗水县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1542, '370832', '梁山县', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1543, '370881', '曲阜市', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1544, '370883', '邹城市', '370800', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1545, '370901', '市辖区', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1546, '370902', '泰山区', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1547, '370911', '岱岳区', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1548, '370921', '宁阳县', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1549, '370923', '东平县', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1550, '370982', '新泰市', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1551, '370983', '肥城市', '370900', '03', '2017-05-26 17:44:59', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1552, '371001', '市辖区', '371000', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1553, '371002', '环翠区', '371000', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1554, '371003', '文登区', '371000', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1555, '371082', '荣成市', '371000', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1556, '371083', '乳山市', '371000', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1557, '371101', '市辖区', '371100', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1558, '371102', '东港区', '371100', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1559, '371103', '岚山区', '371100', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1560, '371121', '五莲县', '371100', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1561, '371122', '莒县', '371100', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1562, '371201', '市辖区', '371200', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1563, '371202', '莱城区', '371200', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1564, '371203', '钢城区', '371200', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1565, '371301', '市辖区', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1566, '371302', '兰山区', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1567, '371311', '罗庄区', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1568, '371312', '河东区', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1569, '371321', '沂南县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1570, '371322', '郯城县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1571, '371323', '沂水县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1572, '371324', '兰陵县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1573, '371325', '费县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1574, '371326', '平邑县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1575, '371327', '莒南县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1576, '371328', '蒙阴县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1577, '371329', '临沭县', '371300', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1578, '371401', '市辖区', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1579, '371402', '德城区', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1580, '371403', '陵城区', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1581, '371422', '宁津县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1582, '371423', '庆云县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1583, '371424', '临邑县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1584, '371425', '齐河县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1585, '371426', '平原县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1586, '371427', '夏津县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1587, '371428', '武城县', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1588, '371481', '乐陵市', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1589, '371482', '禹城市', '371400', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1590, '371501', '市辖区', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1591, '371502', '东昌府区', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1592, '371521', '阳谷县', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1593, '371522', '莘县', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1594, '371523', '茌平县', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1595, '371524', '东阿县', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1596, '371525', '冠县', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1597, '371526', '高唐县', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1598, '371581', '临清市', '371500', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1599, '371601', '市辖区', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1600, '371602', '滨城区', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1601, '371603', '沾化区', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1602, '371621', '惠民县', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1603, '371622', '阳信县', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1604, '371623', '无棣县', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1605, '371625', '博兴县', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1606, '371626', '邹平县', '371600', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1607, '371701', '市辖区', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1608, '371702', '牡丹区', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1609, '371703', '定陶区', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1610, '371721', '曹县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1611, '371722', '单县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1612, '371723', '成武县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1613, '371724', '巨野县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1614, '371725', '郓城县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1615, '371726', '鄄城县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1616, '371728', '东明县', '371700', '03', '2017-05-26 17:45:00', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1617, '370100', '济南市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'J', '济南', '0', 0, 0),
	(1618, '370200', '青岛市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'Q', '青岛', '0', 0, 0),
	(1619, '370300', '淄博市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'Z', '淄博', '0', 0, 0),
	(1620, '370400', '枣庄市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'Z', '枣庄', '0', 0, 0),
	(1621, '370500', '东营市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'D', '东营', '0', 0, 0),
	(1622, '370600', '烟台市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'Y', '烟台', '0', 0, 0),
	(1623, '370700', '潍坊市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'W', '潍坊', '0', 0, 0),
	(1624, '370800', '济宁市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'J', '济宁', '0', 0, 0),
	(1625, '370900', '泰安市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'T', '泰安', '0', 0, 0),
	(1626, '371000', '威海市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'W', '威海', '0', 0, 0),
	(1627, '371100', '日照市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'R', '日照', '0', 0, 0),
	(1628, '371200', '莱芜市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'L', '莱芜', '0', 0, 0),
	(1629, '371300', '临沂市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'L', '临沂', '0', 0, 0),
	(1630, '371400', '德州市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'D', '德州', '0', 0, 0),
	(1631, '371500', '聊城市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'L', '聊城', '0', 0, 0),
	(1632, '371600', '滨州市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'B', '滨州', '0', 0, 0),
	(1633, '371700', '菏泽市', '100015', '02', '2017-05-26 17:45:00', '2020-07-08 11:30:50', 'H', '菏泽', '0', 0, 0),
	(1634, '410101', '市辖区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1635, '410102', '中原区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1636, '410103', '二七区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(1637, '410104', '管城回族区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1638, '410105', '金水区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1639, '410106', '上街区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1640, '410108', '惠济区', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1641, '410122', '中牟县', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1642, '410181', '巩义市', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1643, '410182', '荥阳市', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1644, '410183', '新密市', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1645, '410184', '新郑市', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1646, '410185', '登封市', '410100', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1647, '410201', '市辖区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1648, '410202', '龙亭区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1649, '410203', '顺河回族区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1650, '410204', '鼓楼区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1651, '410205', '禹王台区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1652, '410211', '金明区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1653, '410212', '祥符区', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1654, '410221', '杞县', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1655, '410222', '通许县', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1656, '410223', '尉氏县', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1657, '410225', '兰考县', '410200', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1658, '410301', '市辖区', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1659, '410302', '老城区', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1660, '410303', '西工区', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1661, '410304', '瀍河回族区', '410300', '03', '2017-05-26 17:45:01', '2017-11-20 20:57:21', 'C', NULL, NULL, 0, 0),
	(1662, '410305', '涧西区', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1663, '410306', '吉利区', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1664, '410311', '洛龙区', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1665, '410322', '孟津县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1666, '410323', '新安县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1667, '410324', '栾川县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1668, '410325', '嵩县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1669, '410326', '汝阳县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1670, '410327', '宜阳县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1671, '410328', '洛宁县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1672, '410329', '伊川县', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1673, '410381', '偃师市', '410300', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1674, '410401', '市辖区', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1675, '410402', '新华区', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1676, '410403', '卫东区', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1677, '410404', '石龙区', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1678, '410411', '湛河区', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1679, '410421', '宝丰县', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1680, '410422', '叶县', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1681, '410423', '鲁山县', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1682, '410425', '郏县', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1683, '410481', '舞钢市', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1684, '410482', '汝州市', '410400', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1685, '410501', '市辖区', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1686, '410502', '文峰区', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1687, '410503', '北关区', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1688, '410505', '殷都区', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1689, '410506', '龙安区', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1690, '410522', '安阳县', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1691, '410523', '汤阴县', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1692, '410526', '滑县', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1693, '410527', '内黄县', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1694, '410581', '林州市', '410500', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1695, '410601', '市辖区', '410600', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1696, '410602', '鹤山区', '410600', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1697, '410603', '山城区', '410600', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1698, '410611', '淇滨区', '410600', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1699, '410621', '浚县', '410600', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1700, '410622', '淇县', '410600', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1701, '410701', '市辖区', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1702, '410702', '红旗区', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1703, '410703', '卫滨区', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1704, '410704', '凤泉区', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1705, '410711', '牧野区', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1706, '410721', '新乡县', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1707, '410724', '获嘉县', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1708, '410725', '原阳县', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1709, '410726', '延津县', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1710, '410727', '封丘县', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1711, '410728', '长垣县', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1712, '410781', '卫辉市', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1713, '410782', '辉县市', '410700', '03', '2017-05-26 17:45:01', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1714, '410801', '市辖区', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1715, '410802', '解放区', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1716, '410803', '中站区', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1717, '410804', '马村区', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1718, '410811', '山阳区', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1719, '410821', '修武县', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1720, '410822', '博爱县', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1721, '410823', '武陟县', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1722, '410825', '温县', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1723, '410882', '沁阳市', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1724, '410883', '孟州市', '410800', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1725, '410901', '市辖区', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1726, '410902', '华龙区', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1727, '410922', '清丰县', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1728, '410923', '南乐县', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1729, '410926', '范县', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1730, '410927', '台前县', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1731, '410928', '濮阳县', '410900', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1732, '411001', '市辖区', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1733, '411002', '魏都区', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1734, '411023', '许昌县', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1735, '411024', '鄢陵县', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1736, '411025', '襄城县', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1737, '411081', '禹州市', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1738, '411082', '长葛市', '411000', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1739, '411101', '市辖区', '411100', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1740, '411102', '源汇区', '411100', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1741, '411103', '郾城区', '411100', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1742, '411104', '召陵区', '411100', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1743, '411121', '舞阳县', '411100', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1744, '411122', '临颍县', '411100', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1745, '411201', '市辖区', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1746, '411202', '湖滨区', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1747, '411203', '陕州区', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1748, '411221', '渑池县', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1749, '411224', '卢氏县', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1750, '411281', '义马市', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1751, '411282', '灵宝市', '411200', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1752, '411301', '市辖区', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1753, '411302', '宛城区', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1754, '411303', '卧龙区', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1755, '411321', '南召县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1756, '411322', '方城县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1757, '411323', '西峡县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1758, '411324', '镇平县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1759, '411325', '内乡县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1760, '411326', '淅川县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1761, '411327', '社旗县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1762, '411328', '唐河县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1763, '411329', '新野县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1764, '411330', '桐柏县', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1765, '411381', '邓州市', '411300', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1766, '411401', '市辖区', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1767, '411402', '梁园区', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1768, '411403', '睢阳区', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1769, '411421', '民权县', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1770, '411422', '睢县', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1771, '411423', '宁陵县', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1772, '411424', '柘城县', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1773, '411425', '虞城县', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1774, '411426', '夏邑县', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1775, '411481', '永城市', '411400', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1776, '411501', '市辖区', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1777, '411502', '浉河区', '411500', '03', '2017-05-26 17:45:02', '2017-11-20 20:56:47', 'S', NULL, NULL, 0, 0),
	(1778, '411503', '平桥区', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1779, '411521', '罗山县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1780, '411522', '光山县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1781, '411523', '新县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1782, '411524', '商城县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1783, '411525', '固始县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1784, '411526', '潢川县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1785, '411527', '淮滨县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1786, '411528', '息县', '411500', '03', '2017-05-26 17:45:02', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1787, '411601', '市辖区', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1788, '411602', '川汇区', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1789, '411621', '扶沟县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1790, '411622', '西华县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1791, '411623', '商水县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1792, '411624', '沈丘县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1793, '411625', '郸城县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1794, '411626', '淮阳县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1795, '411627', '太康县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1796, '411628', '鹿邑县', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1797, '411681', '项城市', '411600', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1798, '411701', '市辖区', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1799, '411702', '驿城区', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1800, '411721', '西平县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1801, '411722', '上蔡县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1802, '411723', '平舆县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(1803, '411724', '正阳县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1804, '411725', '确山县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1805, '411726', '泌阳县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1806, '411727', '汝南县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(1807, '411728', '遂平县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1808, '411729', '新蔡县', '411700', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1809, '419001', '济源市', '419000', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1810, '410100', '郑州市', '100016', '02', '2017-05-26 17:45:03', '2020-07-30 15:30:00', 'Z', '郑州', '0', 0, 0),
	(1811, '410200', '开封市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'K', '开封', '0', 0, 0),
	(1812, '410300', '洛阳市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'L', '洛阳', '0', 0, 0),
	(1813, '410400', '平顶山市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'P', '平顶山', '0', 0, 0),
	(1814, '410500', '安阳市', '100016', '02', '2017-05-26 17:45:03', '2020-07-25 14:58:30', 'A', '安阳', '0', 0, 0),
	(1815, '410600', '鹤壁市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'H', '鹤壁', '0', 0, 0),
	(1816, '410700', '新乡市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'X', '新乡', '0', 0, 0),
	(1817, '410800', '焦作市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'J', '焦作', '0', 0, 0),
	(1818, '410900', '濮阳市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'Z', '濮阳', '0', 0, 0),
	(1819, '411000', '许昌市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'X', '许昌', '0', 0, 0),
	(1820, '411100', '漯河市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'Z', '漯河', '0', 0, 0),
	(1821, '411200', '三门峡市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'S', '三门峡', '0', 0, 0),
	(1822, '411300', '南阳市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'N', '南阳', '0', 0, 0),
	(1823, '411400', '商丘市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'S', '商丘', '0', 0, 0),
	(1824, '411500', '信阳市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'X', '信阳', '0', 0, 0),
	(1825, '411600', '周口市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'Z', '周口', '0', 0, 0),
	(1826, '411700', '驻马店市', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'Z', '驻马店', '0', 0, 0),
	(1827, '419000', '省直辖县级行政区划', '100016', '02', '2017-05-26 17:45:03', '2020-07-08 11:30:50', 'S', '省直辖县级行政区划', '0', 0, 0),
	(1828, '420101', '市辖区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1829, '420102', '江岸区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1830, '420103', '江汉区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1831, '420104', '硚口区', '420100', '03', '2017-05-26 17:45:03', '2017-11-20 20:58:20', 'Q', NULL, NULL, 0, 0),
	(1832, '420105', '汉阳区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1833, '420106', '武昌区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1834, '420107', '青山区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1835, '420111', '洪山区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1836, '420112', '东西湖区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1837, '420113', '汉南区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1838, '420114', '蔡甸区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1839, '420115', '江夏区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1840, '420116', '黄陂区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1841, '420117', '新洲区', '420100', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1842, '420201', '市辖区', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1843, '420202', '黄石港区', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1844, '420203', '西塞山区', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1845, '420204', '下陆区', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1846, '420205', '铁山区', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1847, '420222', '阳新县', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1848, '420281', '大冶市', '420200', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1849, '420301', '市辖区', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1850, '420302', '茅箭区', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1851, '420303', '张湾区', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1852, '420304', '郧阳区', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1853, '420322', '郧西县', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1854, '420323', '竹山县', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1855, '420324', '竹溪县', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1856, '420325', '房县', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1857, '420381', '丹江口市', '420300', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1858, '420501', '市辖区', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1859, '420502', '西陵区', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1860, '420503', '伍家岗区', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1861, '420504', '点军区', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1862, '420505', '猇亭区', '420500', '03', '2017-05-26 17:45:03', '2017-11-20 20:57:54', 'X', NULL, NULL, 0, 0),
	(1863, '420506', '夷陵区', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1864, '420525', '远安县', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1865, '420526', '兴山县', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1866, '420527', '秭归县', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1867, '420528', '长阳土家族自治县', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1868, '420529', '五峰土家族自治县', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1869, '420581', '宜都市', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1870, '420582', '当阳市', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1871, '420583', '枝江市', '420500', '03', '2017-05-26 17:45:03', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1872, '420601', '市辖区', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1873, '420602', '襄城区', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1874, '420606', '樊城区', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(1875, '420607', '襄州区', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1876, '420624', '南漳县', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1877, '420625', '谷城县', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1878, '420626', '保康县', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1879, '420682', '老河口市', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1880, '420683', '枣阳市', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1881, '420684', '宜城市', '420600', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1882, '420701', '市辖区', '420700', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1883, '420702', '梁子湖区', '420700', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1884, '420703', '华容区', '420700', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1885, '420704', '鄂城区', '420700', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(1886, '420801', '市辖区', '420800', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1887, '420802', '东宝区', '420800', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1888, '420804', '掇刀区', '420800', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1889, '420821', '京山县', '420800', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1890, '420822', '沙洋县', '420800', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1891, '420881', '钟祥市', '420800', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1892, '420901', '市辖区', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1893, '420902', '孝南区', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1894, '420921', '孝昌县', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1895, '420922', '大悟县', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1896, '420923', '云梦县', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1897, '420981', '应城市', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1898, '420982', '安陆市', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(1899, '420984', '汉川市', '420900', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1900, '421001', '市辖区', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1901, '421002', '沙市区', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1902, '421003', '荆州区', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1903, '421022', '公安县', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1904, '421023', '监利县', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1905, '421024', '江陵县', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1906, '421081', '石首市', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1907, '421083', '洪湖市', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1908, '421087', '松滋市', '421000', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1909, '421101', '市辖区', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1910, '421102', '黄州区', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1911, '421121', '团风县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1912, '421122', '红安县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1913, '421123', '罗田县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1914, '421124', '英山县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1915, '421125', '浠水县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1916, '421126', '蕲春县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1917, '421127', '黄梅县', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1918, '421181', '麻城市', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(1919, '421182', '武穴市', '421100', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1920, '421201', '市辖区', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1921, '421202', '咸安区', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1922, '421221', '嘉鱼县', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1923, '421222', '通城县', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1924, '421223', '崇阳县', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1925, '421224', '通山县', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1926, '421281', '赤壁市', '421200', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1927, '421301', '市辖区', '421300', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1928, '421303', '曾都区', '421300', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1929, '421321', '随县', '421300', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1930, '421381', '广水市', '421300', '03', '2017-05-26 17:45:04', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(1931, '422801', '恩施市', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(1932, '422802', '利川市', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1933, '422822', '建始县', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(1934, '422823', '巴东县', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(1935, '422825', '宣恩县', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1936, '422826', '咸丰县', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1937, '422827', '来凤县', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1938, '422828', '鹤峰县', '422800', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1939, '429004', '仙桃市', '429000', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1940, '429005', '潜江市', '429000', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1941, '429006', '天门市', '429000', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1942, '429021', '神农架林区', '429000', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1943, '420100', '武汉市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'W', '武汉', '0', 0, 0),
	(1944, '420200', '黄石市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'H', '黄石', '0', 0, 0),
	(1945, '420300', '十堰市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'S', '十堰', '0', 0, 0),
	(1946, '420500', '宜昌市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'Y', '宜昌', '0', 0, 0),
	(1947, '420600', '襄阳市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'X', '襄阳', '0', 0, 0),
	(1948, '420700', '鄂州市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'E', '鄂州', '0', 0, 0),
	(1949, '420800', '荆门市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'J', '荆门', '0', 0, 0),
	(1950, '420900', '孝感市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'X', '孝感', '0', 0, 0),
	(1951, '421000', '荆州市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'J', '荆州', '0', 0, 0),
	(1952, '421100', '黄冈市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'H', '黄冈', '0', 0, 0),
	(1953, '421200', '咸宁市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'X', '咸宁', '0', 0, 0),
	(1954, '421300', '随州市', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'S', '随州', '0', 0, 0),
	(1955, '422800', '恩施土家族苗族自治州', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'E', '恩施土家族苗族自治州', '0', 0, 0),
	(1956, '429000', '省直辖县级行政区划', '100017', '02', '2017-05-26 17:45:05', '2020-07-08 11:30:50', 'S', '省直辖县级行政区划', '0', 0, 0),
	(1957, '430101', '市辖区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1958, '430102', '芙蓉区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1959, '430103', '天心区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1960, '430104', '岳麓区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1961, '430105', '开福区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(1962, '430111', '雨花区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1963, '430112', '望城区', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(1964, '430121', '长沙县', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1965, '430124', '宁乡县', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1966, '430181', '浏阳市', '430100', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1967, '430201', '市辖区', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1968, '430202', '荷塘区', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1969, '430203', '芦淞区', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(1970, '430204', '石峰区', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1971, '430211', '天元区', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(1972, '430221', '株洲县', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1973, '430223', '攸县', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1974, '430224', '茶陵县', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1975, '430225', '炎陵县', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1976, '430281', '醴陵市', '430200', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1977, '430301', '市辖区', '430300', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1978, '430302', '雨湖区', '430300', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1979, '430304', '岳塘区', '430300', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1980, '430321', '湘潭县', '430300', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1981, '430381', '湘乡市', '430300', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(1982, '430382', '韶山市', '430300', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1983, '430401', '市辖区', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1984, '430405', '珠晖区', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1985, '430406', '雁峰区', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(1986, '430407', '石鼓区', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1987, '430408', '蒸湘区', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1988, '430412', '南岳区', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(1989, '430421', '衡阳县', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1990, '430422', '衡南县', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1991, '430423', '衡山县', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1992, '430424', '衡东县', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(1993, '430426', '祁东县', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(1994, '430481', '耒阳市', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(1995, '430482', '常宁市', '430400', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(1996, '430501', '市辖区', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1997, '430502', '双清区', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(1998, '430503', '大祥区', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(1999, '430511', '北塔区', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2000, '430521', '邵东县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2001, '430522', '新邵县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2002, '430523', '邵阳县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2003, '430524', '隆回县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2004, '430525', '洞口县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2005, '430527', '绥宁县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2006, '430528', '新宁县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2007, '430529', '城步苗族自治县', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2008, '430581', '武冈市', '430500', '03', '2017-05-26 17:45:05', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2009, '430601', '市辖区', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2010, '430602', '岳阳楼区', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2011, '430603', '云溪区', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2012, '430611', '君山区', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2013, '430621', '岳阳县', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2014, '430623', '华容县', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2015, '430624', '湘阴县', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2016, '430626', '平江县', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2017, '430681', '汨罗市', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2018, '430682', '临湘市', '430600', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2019, '430701', '市辖区', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2020, '430702', '武陵区', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2021, '430703', '鼎城区', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2022, '430721', '安乡县', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2023, '430722', '汉寿县', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2024, '430723', '澧县', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2025, '430724', '临澧县', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2026, '430725', '桃源县', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2027, '430726', '石门县', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2028, '430781', '津市市', '430700', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2029, '430801', '市辖区', '430800', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2030, '430802', '永定区', '430800', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2031, '430811', '武陵源区', '430800', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2032, '430821', '慈利县', '430800', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2033, '430822', '桑植县', '430800', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2034, '430901', '市辖区', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2035, '430902', '资阳区', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2036, '430903', '赫山区', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2037, '430921', '南县', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2038, '430922', '桃江县', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2039, '430923', '安化县', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2040, '430981', '沅江市', '430900', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2041, '431001', '市辖区', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2042, '431002', '北湖区', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2043, '431003', '苏仙区', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2044, '431021', '桂阳县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2045, '431022', '宜章县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2046, '431023', '永兴县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2047, '431024', '嘉禾县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2048, '431025', '临武县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2049, '431026', '汝城县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2050, '431027', '桂东县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2051, '431028', '安仁县', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2052, '431081', '资兴市', '431000', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2053, '431101', '市辖区', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2054, '431102', '零陵区', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2055, '431103', '冷水滩区', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2056, '431121', '祁阳县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2057, '431122', '东安县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2058, '431123', '双牌县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2059, '431124', '道县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2060, '431125', '江永县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2061, '431126', '宁远县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2062, '431127', '蓝山县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2063, '431128', '新田县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2064, '431129', '江华瑶族自治县', '431100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2065, '431201', '市辖区', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2066, '431202', '鹤城区', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2067, '431221', '中方县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2068, '431222', '沅陵县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2069, '431223', '辰溪县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2070, '431224', '溆浦县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2071, '431225', '会同县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2072, '431226', '麻阳苗族自治县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2073, '431227', '新晃侗族自治县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2074, '431228', '芷江侗族自治县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2075, '431229', '靖州苗族侗族自治县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2076, '431230', '通道侗族自治县', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2077, '431281', '洪江市', '431200', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2078, '431301', '市辖区', '431300', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2079, '431302', '娄星区', '431300', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2080, '431321', '双峰县', '431300', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2081, '431322', '新化县', '431300', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2082, '431381', '冷水江市', '431300', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2083, '431382', '涟源市', '431300', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2084, '433101', '吉首市', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2085, '433122', '泸溪县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2086, '433123', '凤凰县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2087, '433124', '花垣县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2088, '433125', '保靖县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2089, '433126', '古丈县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2090, '433127', '永顺县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2091, '433130', '龙山县', '433100', '03', '2017-05-26 17:45:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2092, '430100', '长沙市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'C', '长沙', '0', 0, 0),
	(2093, '430200', '株洲市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'Z', '株洲', '0', 0, 0),
	(2094, '430300', '湘潭市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'X', '湘潭', '0', 0, 0),
	(2095, '430400', '衡阳市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'H', '衡阳', '0', 0, 0),
	(2096, '430500', '邵阳市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'S', '邵阳', '0', 0, 0),
	(2097, '430600', '岳阳市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'Y', '岳阳', '0', 0, 0),
	(2098, '430700', '常德市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'C', '常德', '0', 0, 0),
	(2099, '430800', '张家界市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'Z', '张家界', '0', 0, 0),
	(2100, '430900', '益阳市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'Y', '益阳', '0', 0, 0),
	(2101, '431000', '郴州市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'C', '郴州', '0', 0, 0),
	(2102, '431100', '永州市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'Y', '永州', '0', 0, 0),
	(2103, '431200', '怀化市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'H', '怀化', '0', 0, 0),
	(2104, '431300', '娄底市', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'L', '娄底', '0', 0, 0),
	(2105, '433100', '湘西土家族苗族自治州', '100018', '02', '2017-05-26 17:45:07', '2020-07-08 11:30:50', 'X', '湘西土家族苗族自治州', '0', 0, 0),
	(2106, '440101', '市辖区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2107, '440103', '荔湾区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2108, '440104', '越秀区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2109, '440105', '海珠区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2110, '440106', '天河区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2111, '440111', '白云区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2112, '440112', '黄埔区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2113, '440113', '番禺区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2114, '440114', '花都区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2115, '440115', '南沙区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2116, '440117', '从化区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2117, '440118', '增城区', '440100', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2118, '440201', '市辖区', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2119, '440203', '武江区', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2120, '440204', '浈江区', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2121, '440205', '曲江区', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2122, '440222', '始兴县', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2123, '440224', '仁化县', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2124, '440229', '翁源县', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2125, '440232', '乳源瑶族自治县', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2126, '440233', '新丰县', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2127, '440281', '乐昌市', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2128, '440282', '南雄市', '440200', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2129, '440301', '市辖区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2130, '440303', '罗湖区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2131, '440304', '福田区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2132, '440305', '南山区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2133, '440306', '宝安区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2134, '440307', '龙岗区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2135, '440308', '盐田区', '440300', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2136, '440401', '市辖区', '440400', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2137, '440402', '香洲区', '440400', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2138, '440403', '斗门区', '440400', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2139, '440404', '金湾区', '440400', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2140, '440501', '市辖区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2141, '440507', '龙湖区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2142, '440511', '金平区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2143, '440512', '濠江区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2144, '440513', '潮阳区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2145, '440514', '潮南区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2146, '440515', '澄海区', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2147, '440523', '南澳县', '440500', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2148, '440601', '市辖区', '440600', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2149, '440604', '禅城区', '440600', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2150, '440605', '南海区', '440600', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2151, '440606', '顺德区', '440600', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2152, '440607', '三水区', '440600', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2153, '440608', '高明区', '440600', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2154, '440701', '市辖区', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2155, '440703', '蓬江区', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2156, '440704', '江海区', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2157, '440705', '新会区', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2158, '440781', '台山市', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2159, '440783', '开平市', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2160, '440784', '鹤山市', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2161, '440785', '恩平市', '440700', '03', '2017-05-26 17:45:07', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(2162, '440801', '市辖区', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2163, '440802', '赤坎区', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2164, '440803', '霞山区', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2165, '440804', '坡头区', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2166, '440811', '麻章区', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2167, '440823', '遂溪县', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2168, '440825', '徐闻县', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2169, '440881', '廉江市', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2170, '440882', '雷州市', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2171, '440883', '吴川市', '440800', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2172, '440901', '市辖区', '440900', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2173, '440902', '茂南区', '440900', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2174, '440904', '电白区', '440900', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2175, '440981', '高州市', '440900', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2176, '440982', '化州市', '440900', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2177, '440983', '信宜市', '440900', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2178, '441201', '市辖区', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2179, '441202', '端州区', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2180, '441203', '鼎湖区', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2181, '441204', '高要区', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2182, '441223', '广宁县', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2183, '441224', '怀集县', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2184, '441225', '封开县', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2185, '441226', '德庆县', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2186, '441284', '四会市', '441200', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2187, '441301', '市辖区', '441300', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2188, '441302', '惠城区', '441300', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2189, '441303', '惠阳区', '441300', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2190, '441322', '博罗县', '441300', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2191, '441323', '惠东县', '441300', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2192, '441324', '龙门县', '441300', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2193, '441401', '市辖区', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2194, '441402', '梅江区', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2195, '441403', '梅县区', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2196, '441422', '大埔县', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2197, '441423', '丰顺县', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2198, '441424', '五华县', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2199, '441426', '平远县', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2200, '441427', '蕉岭县', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2201, '441481', '兴宁市', '441400', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2202, '441501', '市辖区', '441500', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2203, '441502', '城区', '441500', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2204, '441521', '海丰县', '441500', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2205, '441523', '陆河县', '441500', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2206, '441581', '陆丰市', '441500', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2207, '441601', '市辖区', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2208, '441602', '源城区', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2209, '441621', '紫金县', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2210, '441622', '龙川县', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2211, '441623', '连平县', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2212, '441624', '和平县', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2213, '441625', '东源县', '441600', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2214, '441701', '市辖区', '441700', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2215, '441702', '江城区', '441700', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2216, '441704', '阳东区', '441700', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2217, '441721', '阳西县', '441700', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2218, '441781', '阳春市', '441700', '03', '2017-05-26 17:45:08', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2219, '441801', '市辖区', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2220, '441802', '清城区', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2221, '441803', '清新区', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2222, '441821', '佛冈县', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2223, '441823', '阳山县', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2224, '441825', '连山壮族瑶族自治县', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2225, '441826', '连南瑶族自治县', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2226, '441881', '英德市', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2227, '441882', '连州市', '441800', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2228, '450101', '市辖区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2229, '450102', '兴宁区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2230, '450103', '青秀区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2231, '450105', '江南区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2232, '450107', '西乡塘区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2233, '450108', '良庆区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2234, '450109', '邕宁区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2235, '450110', '武鸣区', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2236, '450123', '隆安县', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2237, '450124', '马山县', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2238, '450125', '上林县', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2239, '450126', '宾阳县', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2240, '450127', '横县', '450100', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2241, '450201', '市辖区', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2242, '450202', '城中区', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2243, '450203', '鱼峰区', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2244, '450204', '柳南区', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2245, '450205', '柳北区', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2246, '450206', '柳江区', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2247, '450222', '柳城县', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2248, '450223', '鹿寨县', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2249, '450224', '融安县', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2250, '450225', '融水苗族自治县', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2251, '450226', '三江侗族自治县', '450200', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2252, '450301', '市辖区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2253, '450302', '秀峰区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2254, '450303', '叠彩区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2255, '450304', '象山区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2256, '450305', '七星区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2257, '450311', '雁山区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2258, '450312', '临桂区', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2259, '450321', '阳朔县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2260, '450323', '灵川县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2261, '450324', '全州县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2262, '450325', '兴安县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2263, '450326', '永福县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2264, '450327', '灌阳县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2265, '450328', '龙胜各族自治县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2266, '450329', '资源县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2267, '450330', '平乐县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2268, '450331', '荔浦县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2269, '450332', '恭城瑶族自治县', '450300', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2270, '450401', '市辖区', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2271, '450403', '万秀区', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2272, '450405', '长洲区', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2273, '450406', '龙圩区', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2274, '450421', '苍梧县', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2275, '450422', '藤县', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2276, '450423', '蒙山县', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2277, '450481', '岑溪市', '450400', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2278, '450501', '市辖区', '450500', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2279, '450502', '海城区', '450500', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2280, '450503', '银海区', '450500', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2281, '450512', '铁山港区', '450500', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2282, '450521', '合浦县', '450500', '03', '2017-05-26 17:45:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2283, '450601', '市辖区', '450600', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2284, '450602', '港口区', '450600', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2285, '450603', '防城区', '450600', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2286, '450621', '上思县', '450600', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2287, '450681', '东兴市', '450600', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2288, '450701', '市辖区', '450700', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2289, '450702', '钦南区', '450700', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2290, '450703', '钦北区', '450700', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2291, '450721', '灵山县', '450700', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2292, '450722', '浦北县', '450700', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2293, '450801', '市辖区', '450800', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2294, '450802', '港北区', '450800', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2295, '450803', '港南区', '450800', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2296, '450804', '覃塘区', '450800', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2297, '450821', '平南县', '450800', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2298, '450881', '桂平市', '450800', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2299, '450901', '市辖区', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2300, '450902', '玉州区', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2301, '450903', '福绵区', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2302, '450921', '容县', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2303, '450922', '陆川县', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2304, '450923', '博白县', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2305, '450924', '兴业县', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2306, '450981', '北流市', '450900', '03', '2017-05-26 17:45:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2307, '451001', '市辖区', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2308, '451002', '右江区', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2309, '451021', '田阳县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2310, '451022', '田东县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2311, '451023', '平果县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2312, '451024', '德保县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2313, '451026', '那坡县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2314, '451027', '凌云县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2315, '451028', '乐业县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2316, '451029', '田林县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2317, '451030', '西林县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2318, '451031', '隆林各族自治县', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2319, '451081', '靖西市', '451000', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2320, '451101', '市辖区', '451100', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2321, '451102', '八步区', '451100', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2322, '451103', '平桂区', '451100', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2323, '451121', '昭平县', '451100', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2324, '451122', '钟山县', '451100', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2325, '451123', '富川瑶族自治县', '451100', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2326, '451201', '市辖区', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2327, '451202', '金城江区', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2328, '451221', '南丹县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2329, '451222', '天峨县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2330, '451223', '凤山县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2331, '451224', '东兰县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2332, '451225', '罗城仫佬族自治县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2333, '451226', '环江毛南族自治县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2334, '451227', '巴马瑶族自治县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2335, '451228', '都安瑶族自治县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2336, '451229', '大化瑶族自治县', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2337, '451281', '宜州市', '451200', '03', '2017-05-26 17:45:41', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2338, '451301', '市辖区', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2339, '451302', '兴宾区', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2340, '451321', '忻城县', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2341, '451322', '象州县', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2342, '451323', '武宣县', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2343, '451324', '金秀瑶族自治县', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2344, '451381', '合山市', '451300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2345, '451401', '市辖区', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2346, '451402', '江州区', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2347, '451421', '扶绥县', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2348, '451422', '宁明县', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2349, '451423', '龙州县', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2350, '451424', '大新县', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2351, '451425', '天等县', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2352, '451481', '凭祥市', '451400', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2353, '450100', '南宁市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'N', '南宁', '0', 0, 0),
	(2354, '450200', '柳州市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'L', '柳州', '0', 0, 0),
	(2355, '450300', '桂林市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'G', '桂林', '0', 0, 0),
	(2356, '450400', '梧州市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'W', '梧州', '0', 0, 0),
	(2357, '450500', '北海市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'B', '北海', '0', 0, 0),
	(2358, '450600', '防城港市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'F', '防城港', '0', 0, 0),
	(2359, '450700', '钦州市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'Q', '钦州', '0', 0, 0),
	(2360, '450800', '贵港市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'G', '贵港', '0', 0, 0),
	(2361, '450900', '玉林市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'Y', '玉林', '0', 0, 0),
	(2362, '451000', '百色市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'B', '百色', '0', 0, 0),
	(2363, '451100', '贺州市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'H', '贺州', '0', 0, 0),
	(2364, '451200', '河池市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'H', '河池', '0', 0, 0),
	(2365, '451300', '来宾市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'L', '来宾', '0', 0, 0),
	(2366, '451400', '崇左市', '100020', '02', '2017-05-26 17:45:42', '2020-07-08 11:30:50', 'C', '崇左', '0', 0, 0),
	(2367, '460101', '市辖区', '460100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2368, '460105', '秀英区', '460100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2369, '460106', '龙华区', '460100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2370, '460107', '琼山区', '460100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2371, '460108', '美兰区', '460100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2372, '460201', '市辖区', '460200', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2373, '460202', '海棠区', '460200', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2374, '460203', '吉阳区', '460200', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2375, '460204', '天涯区', '460200', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2376, '460205', '崖州区', '460200', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2377, '460321', '西沙群岛', '460300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2378, '460322', '南沙群岛', '460300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2379, '460323', '中沙群岛的岛礁及其海域', '460300', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2380, '500101', '万州区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2381, '500102', '涪陵区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2382, '500103', '渝中区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2383, '500104', '大渡口区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2384, '500105', '江北区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2385, '500106', '沙坪坝区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2386, '500107', '九龙坡区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2387, '500108', '南岸区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2388, '500109', '北碚区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2389, '500110', '綦江区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2390, '500111', '大足区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2391, '500112', '渝北区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2392, '500113', '巴南区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2393, '500114', '黔江区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2394, '500115', '长寿区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2395, '500116', '江津区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2396, '500117', '合川区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2397, '500118', '永川区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2398, '500119', '南川区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2399, '500120', '璧山区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2400, '500151', '铜梁区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2401, '500152', '潼南区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2402, '500153', '荣昌区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2403, '500154', '开州区', '500100', '03', '2017-05-26 17:45:42', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2404, '500228', '梁平县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2405, '500229', '城口县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2406, '500230', '丰都县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2407, '500231', '垫江县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2408, '500232', '武隆县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2409, '500233', '忠县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2410, '500235', '云阳县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2411, '500236', '奉节县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2412, '500237', '巫山县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2413, '500238', '巫溪县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2414, '500240', '石柱土家族自治县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2415, '500241', '秀山土家族苗族自治县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2416, '500242', '酉阳土家族苗族自治县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2417, '500243', '彭水苗族土家族自治县', '500200', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2418, '500100', '重庆市', '100022', '02', '2017-05-26 17:45:43', '2020-07-08 11:30:50', 'Z', '重庆', '0', 0, 0),
	(2419, '500200', '县', '100022', '02', '2017-05-26 17:45:43', '2020-07-08 11:30:50', 'X', '县', '0', 0, 0),
	(2420, '510101', '市辖区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2421, '510104', '锦江区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2422, '510105', '青羊区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2423, '510106', '金牛区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2424, '510107', '武侯区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2425, '510108', '成华区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2426, '510112', '龙泉驿区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2427, '510113', '青白江区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2428, '510114', '新都区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2429, '510115', '温江区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2430, '510116', '双流区', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2431, '510121', '金堂县', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2432, '510124', '郫县', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2433, '510129', '大邑县', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2434, '510131', '蒲江县', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2435, '510132', '新津县', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2436, '510181', '都江堰市', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2437, '510182', '彭州市', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2438, '510183', '邛崃市', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2439, '510184', '崇州市', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2440, '510185', '简阳市', '510100', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2441, '510301', '市辖区', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2442, '510302', '自流井区', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2443, '510303', '贡井区', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2444, '510304', '大安区', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2445, '510311', '沿滩区', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2446, '510321', '荣县', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2447, '510322', '富顺县', '510300', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2448, '510401', '市辖区', '510400', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2449, '510402', '东区', '510400', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2450, '510403', '西区', '510400', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2451, '510411', '仁和区', '510400', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2452, '510421', '米易县', '510400', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2453, '510422', '盐边县', '510400', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2454, '510501', '市辖区', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2455, '510502', '江阳区', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2456, '510503', '纳溪区', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2457, '510504', '龙马潭区', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2458, '510521', '泸县', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2459, '510522', '合江县', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2460, '510524', '叙永县', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2461, '510525', '古蔺县', '510500', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2462, '510601', '市辖区', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2463, '510603', '旌阳区', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2464, '510623', '中江县', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2465, '510626', '罗江县', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2466, '510681', '广汉市', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2467, '510682', '什邡市', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2468, '510683', '绵竹市', '510600', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2469, '510701', '市辖区', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2470, '510703', '涪城区', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2471, '510704', '游仙区', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2472, '510705', '安州区', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2473, '510722', '三台县', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2474, '510723', '盐亭县', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2475, '510725', '梓潼县', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2476, '510726', '北川羌族自治县', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2477, '510727', '平武县', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2478, '510781', '江油市', '510700', '03', '2017-05-26 17:45:43', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2479, '510801', '市辖区', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2480, '510802', '利州区', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2481, '510811', '昭化区', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2482, '510812', '朝天区', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2483, '510821', '旺苍县', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2484, '510822', '青川县', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2485, '510823', '剑阁县', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2486, '510824', '苍溪县', '510800', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2487, '510901', '市辖区', '510900', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2488, '510903', '船山区', '510900', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2489, '510904', '安居区', '510900', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2490, '510921', '蓬溪县', '510900', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2491, '510922', '射洪县', '510900', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2492, '510923', '大英县', '510900', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2493, '511001', '市辖区', '511000', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2494, '511002', '市中区', '511000', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2495, '511011', '东兴区', '511000', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2496, '511024', '威远县', '511000', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2497, '511025', '资中县', '511000', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2498, '511028', '隆昌县', '511000', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2499, '511101', '市辖区', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2500, '511102', '市中区', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2501, '511111', '沙湾区', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2502, '511112', '五通桥区', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2503, '511113', '金口河区', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2504, '511123', '犍为县', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2505, '511124', '井研县', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2506, '511126', '夹江县', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2507, '511129', '沐川县', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2508, '511132', '峨边彝族自治县', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(2509, '511133', '马边彝族自治县', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2510, '511181', '峨眉山市', '511100', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(2511, '511301', '市辖区', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2512, '511302', '顺庆区', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2513, '511303', '高坪区', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2514, '511304', '嘉陵区', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2515, '511321', '南部县', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2516, '511322', '营山县', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2517, '511323', '蓬安县', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2518, '511324', '仪陇县', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2519, '511325', '西充县', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2520, '511381', '阆中市', '511300', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2521, '511401', '市辖区', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2522, '511402', '东坡区', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2523, '511403', '彭山区', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2524, '511421', '仁寿县', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2525, '511423', '洪雅县', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2526, '511424', '丹棱县', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2527, '511425', '青神县', '511400', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2528, '511501', '市辖区', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2529, '511502', '翠屏区', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2530, '511503', '南溪区', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2531, '511521', '宜宾县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2532, '511523', '江安县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2533, '511524', '长宁县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2534, '511525', '高县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2535, '511526', '珙县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2536, '511527', '筠连县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2537, '511528', '兴文县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2538, '511529', '屏山县', '511500', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2539, '511601', '市辖区', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2540, '511602', '广安区', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2541, '511603', '前锋区', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2542, '511621', '岳池县', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2543, '511622', '武胜县', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2544, '511623', '邻水县', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2545, '511681', '华蓥市', '511600', '03', '2017-05-26 17:45:44', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2546, '511701', '市辖区', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2547, '511702', '通川区', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2548, '511703', '达川区', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2549, '511722', '宣汉县', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2550, '511723', '开江县', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2551, '511724', '大竹县', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2552, '511725', '渠县', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2553, '511781', '万源市', '511700', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2554, '511801', '市辖区', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2555, '511802', '雨城区', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2556, '511803', '名山区', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2557, '511822', '荥经县', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2558, '511823', '汉源县', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2559, '511824', '石棉县', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2560, '511825', '天全县', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2561, '511826', '芦山县', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2562, '511827', '宝兴县', '511800', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2563, '511901', '市辖区', '511900', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2564, '511902', '巴州区', '511900', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2565, '511903', '恩阳区', '511900', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(2566, '511921', '通江县', '511900', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2567, '511922', '南江县', '511900', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2568, '511923', '平昌县', '511900', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2569, '512001', '市辖区', '512000', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2570, '512002', '雁江区', '512000', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2571, '512021', '安岳县', '512000', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2572, '512022', '乐至县', '512000', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2573, '513201', '马尔康市', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2574, '513221', '汶川县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2575, '513222', '理县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2576, '513223', '茂县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2577, '513224', '松潘县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2578, '513225', '九寨沟县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2579, '513226', '金川县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2580, '513227', '小金县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2581, '513228', '黑水县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2582, '513230', '壤塘县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2583, '513231', '阿坝县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2584, '513232', '若尔盖县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2585, '513233', '红原县', '513200', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2586, '513301', '康定市', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2587, '513322', '泸定县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2588, '513323', '丹巴县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2589, '513324', '九龙县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2590, '513325', '雅江县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2591, '513326', '道孚县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2592, '513327', '炉霍县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2593, '513328', '甘孜县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2594, '513329', '新龙县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2595, '513330', '德格县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2596, '513331', '白玉县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2597, '513332', '石渠县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2598, '513333', '色达县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2599, '513334', '理塘县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2600, '513335', '巴塘县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2601, '513336', '乡城县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2602, '513337', '稻城县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2603, '513338', '得荣县', '513300', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2604, '513401', '西昌市', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2605, '513422', '木里藏族自治县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2606, '513423', '盐源县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2607, '513424', '德昌县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2608, '513425', '会理县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2609, '513426', '会东县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2610, '513427', '宁南县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2611, '513428', '普格县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2612, '513429', '布拖县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2613, '513430', '金阳县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2614, '513431', '昭觉县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2615, '513432', '喜德县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2616, '513433', '冕宁县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2617, '513434', '越西县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2618, '513435', '甘洛县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2619, '513436', '美姑县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2620, '513437', '雷波县', '513400', '03', '2017-05-26 17:45:45', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2621, '510100', '成都市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'C', '成都', '0', 0, 0),
	(2622, '510300', '自贡市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'Z', '自贡', '0', 0, 0),
	(2623, '510400', '攀枝花市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'P', '攀枝花', '0', 0, 0),
	(2624, '510500', '泸州市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'Z', '泸州', '0', 0, 0),
	(2625, '510600', '德阳市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'D', '德阳', '0', 0, 0),
	(2626, '510700', '绵阳市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'M', '绵阳', '0', 0, 0),
	(2627, '510800', '广元市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'G', '广元', '0', 0, 0),
	(2628, '510900', '遂宁市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'S', '遂宁', '0', 0, 0),
	(2629, '511000', '内江市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'N', '内江', '0', 0, 0),
	(2630, '511100', '乐山市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'L', '乐山', '0', 0, 0),
	(2631, '511300', '南充市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'N', '南充', '0', 0, 0),
	(2632, '511400', '眉山市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'M', '眉山', '0', 0, 0),
	(2633, '511500', '宜宾市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'Y', '宜宾', '0', 0, 0),
	(2634, '511600', '广安市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'G', '广安', '0', 0, 0),
	(2635, '511700', '达州市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'D', '达州', '0', 0, 0),
	(2636, '511800', '雅安市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'Y', '雅安', '0', 0, 0),
	(2637, '511900', '巴中市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'B', '巴中', '0', 0, 0),
	(2638, '512000', '资阳市', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'Z', '资阳', '0', 0, 0),
	(2639, '513200', '阿坝藏族羌族自治州', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'A', '阿坝藏族羌族自治州', '0', 0, 0),
	(2640, '513300', '甘孜藏族自治州', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'G', '甘孜藏族自治州', '0', 0, 0),
	(2641, '513400', '凉山彝族自治州', '100023', '02', '2017-05-26 17:45:45', '2020-07-08 11:30:50', 'L', '凉山彝族自治州', '0', 0, 0),
	(2642, '520101', '市辖区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2643, '520102', '南明区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2644, '520103', '云岩区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2645, '520111', '花溪区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2646, '520112', '乌当区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2647, '520113', '白云区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2648, '520115', '观山湖区', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2649, '520121', '开阳县', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2650, '520122', '息烽县', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2651, '520123', '修文县', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2652, '520181', '清镇市', '520100', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2653, '520201', '钟山区', '520200', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2654, '520203', '六枝特区', '520200', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2655, '520221', '水城县', '520200', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2656, '520222', '盘县', '520200', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2657, '520301', '市辖区', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2658, '520302', '红花岗区', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2659, '520303', '汇川区', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2660, '520304', '播州区', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2661, '520322', '桐梓县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2662, '520323', '绥阳县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2663, '520324', '正安县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2664, '520325', '道真仡佬族苗族自治县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2665, '520326', '务川仡佬族苗族自治县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2666, '520327', '凤冈县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2667, '520328', '湄潭县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2668, '520329', '余庆县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2669, '520330', '习水县', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2670, '520381', '赤水市', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2671, '520382', '仁怀市', '520300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2672, '520401', '市辖区', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2673, '520402', '西秀区', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2674, '520403', '平坝区', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2675, '520422', '普定县', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2676, '520423', '镇宁布依族苗族自治县', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2677, '520424', '关岭布依族苗族自治县', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2678, '520425', '紫云苗族布依族自治县', '520400', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2679, '520501', '市辖区', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2680, '520502', '七星关区', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2681, '520521', '大方县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2682, '520522', '黔西县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2683, '520523', '金沙县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2684, '520524', '织金县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2685, '520525', '纳雍县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2686, '520526', '威宁彝族回族苗族自治县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2687, '520527', '赫章县', '520500', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2688, '520601', '市辖区', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2689, '520602', '碧江区', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2690, '520603', '万山区', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2691, '520621', '江口县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2692, '520622', '玉屏侗族自治县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2693, '520623', '石阡县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2694, '520624', '思南县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2695, '520625', '印江土家族苗族自治县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2696, '520626', '德江县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2697, '520627', '沿河土家族自治县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2698, '520628', '松桃苗族自治县', '520600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2699, '522301', '兴义市', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2700, '522322', '兴仁县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2701, '522323', '普安县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2702, '522324', '晴隆县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2703, '522325', '贞丰县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2704, '522326', '望谟县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2705, '522327', '册亨县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2706, '522328', '安龙县', '522300', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2707, '522601', '凯里市', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2708, '522622', '黄平县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2709, '522623', '施秉县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2710, '522624', '三穗县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2711, '522625', '镇远县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2712, '522626', '岑巩县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2713, '522627', '天柱县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2714, '522628', '锦屏县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2715, '522629', '剑河县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2716, '522630', '台江县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2717, '522631', '黎平县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2718, '522632', '榕江县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2719, '522633', '从江县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2720, '522634', '雷山县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2721, '522635', '麻江县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2722, '522636', '丹寨县', '522600', '03', '2017-05-26 17:45:46', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2723, '522701', '都匀市', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2724, '522702', '福泉市', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2725, '522722', '荔波县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2726, '522723', '贵定县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2727, '522725', '瓮安县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2728, '522726', '独山县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2729, '522727', '平塘县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2730, '522728', '罗甸县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2731, '522729', '长顺县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2732, '522730', '龙里县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2733, '522731', '惠水县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2734, '522732', '三都水族自治县', '522700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2735, '520100', '贵阳市', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'G', '贵阳', '0', 0, 0),
	(2736, '520200', '六盘水市', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'L', '六盘水', '0', 0, 0),
	(2737, '520300', '遵义市', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'Z', '遵义', '0', 0, 0),
	(2738, '520400', '安顺市', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'A', '安顺', '0', 0, 0),
	(2739, '520500', '毕节市', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'B', '毕节', '0', 0, 0),
	(2740, '520600', '铜仁市', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'T', '铜仁', '0', 0, 0),
	(2741, '522300', '黔西南布依族苗族自治州', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'Q', '黔西南布依族苗族自治州', '0', 0, 0),
	(2742, '522600', '黔东南苗族侗族自治州', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'Q', '黔东南苗族侗族自治州', '0', 0, 0),
	(2743, '522700', '黔南布依族苗族自治州', '100024', '02', '2017-05-26 17:45:47', '2020-07-08 11:30:50', 'Q', '黔南布依族苗族自治州', '0', 0, 0),
	(2744, '530101', '市辖区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2745, '530102', '五华区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2746, '530103', '盘龙区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2747, '530111', '官渡区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2748, '530112', '西山区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2749, '530113', '东川区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2750, '530114', '呈贡区', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2751, '530122', '晋宁县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2752, '530124', '富民县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2753, '530125', '宜良县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2754, '530126', '石林彝族自治县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2755, '530127', '嵩明县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2756, '530128', '禄劝彝族苗族自治县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2757, '530129', '寻甸回族彝族自治县', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2758, '530181', '安宁市', '530100', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2759, '530301', '市辖区', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2760, '530302', '麒麟区', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2761, '530303', '沾益区', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2762, '530321', '马龙县', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2763, '530322', '陆良县', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2764, '530323', '师宗县', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2765, '530324', '罗平县', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2766, '530325', '富源县', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2767, '530326', '会泽县', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2768, '530381', '宣威市', '530300', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2769, '530401', '市辖区', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2770, '530402', '红塔区', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2771, '530403', '江川区', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2772, '530422', '澄江县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2773, '530423', '通海县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2774, '530424', '华宁县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2775, '530425', '易门县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2776, '530426', '峨山彝族自治县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(2777, '530427', '新平彝族傣族自治县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2778, '530428', '元江哈尼族彝族傣族自治县', '530400', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2779, '530501', '市辖区', '530500', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2780, '530502', '隆阳区', '530500', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2781, '530521', '施甸县', '530500', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2782, '530523', '龙陵县', '530500', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2783, '530524', '昌宁县', '530500', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2784, '530581', '腾冲市', '530500', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(2785, '530601', '市辖区', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2786, '530602', '昭阳区', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2787, '530621', '鲁甸县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2788, '530622', '巧家县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2789, '530623', '盐津县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2790, '530624', '大关县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2791, '530625', '永善县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2792, '530626', '绥江县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2793, '530627', '镇雄县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2794, '530628', '彝良县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2795, '530629', '威信县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2796, '530630', '水富县', '530600', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2797, '530701', '市辖区', '530700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2798, '530702', '古城区', '530700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2799, '530721', '玉龙纳西族自治县', '530700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2800, '530722', '永胜县', '530700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2801, '530723', '华坪县', '530700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2802, '530724', '宁蒗彝族自治县', '530700', '03', '2017-05-26 17:45:47', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2803, '530801', '市辖区', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2804, '530802', '思茅区', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2805, '530821', '宁洱哈尼族彝族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2806, '530822', '墨江哈尼族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2807, '530823', '景东彝族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2808, '530824', '景谷傣族彝族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2809, '530825', '镇沅彝族哈尼族拉祜族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2810, '530826', '江城哈尼族彝族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2811, '530827', '孟连傣族拉祜族佤族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2812, '530828', '澜沧拉祜族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2813, '530829', '西盟佤族自治县', '530800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2814, '530901', '市辖区', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2815, '530902', '临翔区', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2816, '530921', '凤庆县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2817, '530922', '云县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2818, '530923', '永德县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2819, '530924', '镇康县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2820, '530925', '双江拉祜族佤族布朗族傣族自治县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2821, '530926', '耿马傣族佤族自治县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2822, '530927', '沧源佤族自治县', '530900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2823, '532301', '楚雄市', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2824, '532322', '双柏县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2825, '532323', '牟定县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2826, '532324', '南华县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2827, '532325', '姚安县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2828, '532326', '大姚县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2829, '532327', '永仁县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2830, '532328', '元谋县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2831, '532329', '武定县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2832, '532331', '禄丰县', '532300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2833, '532501', '个旧市', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2834, '532502', '开远市', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2835, '532503', '蒙自市', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2836, '532504', '弥勒市', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2837, '532523', '屏边苗族自治县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2838, '532524', '建水县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2839, '532525', '石屏县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2840, '532527', '泸西县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2841, '532528', '元阳县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2842, '532529', '红河县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2843, '532530', '金平苗族瑶族傣族自治县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2844, '532531', '绿春县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2845, '532532', '河口瑶族自治县', '532500', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2846, '532601', '文山市', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2847, '532622', '砚山县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2848, '532623', '西畴县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2849, '532624', '麻栗坡县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2850, '532625', '马关县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2851, '532626', '丘北县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2852, '532627', '广南县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2853, '532628', '富宁县', '532600', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2854, '532801', '景洪市', '532800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2855, '532822', '勐海县', '532800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2856, '532823', '勐腊县', '532800', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2857, '532901', '大理市', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2858, '532922', '漾濞彝族自治县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2859, '532923', '祥云县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2860, '532924', '宾川县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2861, '532925', '弥渡县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2862, '532926', '南涧彝族自治县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2863, '532927', '巍山彝族回族自治县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2864, '532928', '永平县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2865, '532929', '云龙县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2866, '532930', '洱源县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(2867, '532931', '剑川县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2868, '532932', '鹤庆县', '532900', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2869, '533102', '瑞丽市', '533100', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2870, '533103', '芒市', '533100', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2871, '533122', '梁河县', '533100', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2872, '533123', '盈江县', '533100', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2873, '533124', '陇川县', '533100', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2874, '533301', '泸水市', '533300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2875, '533323', '福贡县', '533300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(2876, '533324', '贡山独龙族怒族自治县', '533300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2877, '533325', '兰坪白族普米族自治县', '533300', '03', '2017-05-26 17:45:48', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2878, '533401', '香格里拉市', '533400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2879, '533422', '德钦县', '533400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2880, '533423', '维西傈僳族自治县', '533400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2881, '530100', '昆明市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'K', '昆明', '0', 0, 0),
	(2882, '530300', '曲靖市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'Q', '曲靖', '0', 0, 0),
	(2883, '530400', '玉溪市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'Y', '玉溪', '0', 0, 0),
	(2884, '530500', '保山市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'B', '保山', '0', 0, 0),
	(2885, '530600', '昭通市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'Z', '昭通', '0', 0, 0),
	(2886, '530700', '丽江市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'L', '丽江', '0', 0, 0),
	(2887, '530800', '普洱市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'P', '普洱', '0', 0, 0),
	(2888, '530900', '临沧市', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'L', '临沧', '0', 0, 0),
	(2889, '532300', '楚雄彝族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'C', '楚雄彝族自治州', '0', 0, 0),
	(2890, '532500', '红河哈尼族彝族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'H', '红河哈尼族彝族自治州', '0', 0, 0),
	(2891, '532600', '文山壮族苗族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'W', '文山壮族苗族自治州', '0', 0, 0),
	(2892, '532800', '西双版纳傣族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'X', '西双版纳傣族自治州', '0', 0, 0),
	(2893, '532900', '大理白族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'D', '大理白族自治州', '0', 0, 0),
	(2894, '533100', '德宏傣族景颇族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'D', '德宏傣族景颇族自治州', '0', 0, 0),
	(2895, '533300', '怒江傈僳族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'N', '怒江傈僳族自治州', '0', 0, 0),
	(2896, '533400', '迪庆藏族自治州', '100025', '02', '2017-05-26 17:45:49', '2020-07-08 11:30:50', 'D', '迪庆藏族自治州', '0', 0, 0),
	(2897, '540101', '市辖区', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2898, '540102', '城关区', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2899, '540103', '堆龙德庆区', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2900, '540121', '林周县', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2901, '540122', '当雄县', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2902, '540123', '尼木县', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2903, '540124', '曲水县', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2904, '540126', '达孜县', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2905, '540127', '墨竹工卡县', '540100', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2906, '540202', '桑珠孜区', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2907, '540221', '南木林县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2908, '540222', '江孜县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2909, '540223', '定日县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2910, '540224', '萨迦县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2911, '540225', '拉孜县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2912, '540226', '昂仁县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2913, '540227', '谢通门县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2914, '540228', '白朗县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2915, '540229', '仁布县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2916, '540230', '康马县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2917, '540231', '定结县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2918, '540232', '仲巴县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2919, '540233', '亚东县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2920, '540234', '吉隆县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2921, '540235', '聂拉木县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2922, '540236', '萨嘎县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2923, '540237', '岗巴县', '540200', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2924, '540302', '卡若区', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(2925, '540321', '江达县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2926, '540322', '贡觉县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2927, '540323', '类乌齐县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2928, '540324', '丁青县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(2929, '540325', '察雅县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2930, '540326', '八宿县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2931, '540327', '左贡县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2932, '540328', '芒康县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2933, '540329', '洛隆县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2934, '540330', '边坝县', '540300', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2935, '540402', '巴宜区', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2936, '540421', '工布江达县', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2937, '540422', '米林县', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2938, '540423', '墨脱县', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(2939, '540424', '波密县', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2940, '540425', '察隅县', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2941, '540426', '朗县', '540400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2942, '540501', '市辖区', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2943, '540502', '乃东区', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2944, '540521', '扎囊县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2945, '540522', '贡嘎县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2946, '540523', '桑日县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2947, '540524', '琼结县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2948, '540525', '曲松县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(2949, '540526', '措美县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2950, '540527', '洛扎县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2951, '540528', '加查县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2952, '540529', '隆子县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2953, '540530', '错那县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2954, '540531', '浪卡子县', '540500', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2955, '542421', '那曲县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2956, '542422', '嘉黎县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(2957, '542423', '比如县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2958, '542424', '聂荣县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2959, '542425', '安多县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(2960, '542426', '申扎县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2961, '542427', '索县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2962, '542428', '班戈县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2963, '542429', '巴青县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2964, '542430', '尼玛县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(2965, '542431', '双湖县', '542400', '03', '2017-05-26 17:45:49', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2966, '542521', '普兰县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(2967, '542522', '札达县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2968, '542523', '噶尔县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2969, '542524', '日土县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(2970, '542525', '革吉县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2971, '542526', '改则县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2972, '542527', '措勤县', '542500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2973, '540100', '拉萨市', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'L', '拉萨', '0', 0, 0),
	(2974, '540200', '日喀则市', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'R', '日喀则', '0', 0, 0),
	(2975, '540300', '昌都市', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'C', '昌都', '0', 0, 0),
	(2976, '540400', '林芝市', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'L', '林芝', '0', 0, 0),
	(2977, '540500', '山南市', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'S', '山南', '0', 0, 0),
	(2978, '542400', '那曲地区', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'N', '那曲地区', '0', 0, 0),
	(2979, '542500', '阿里地区', '100026', '02', '2017-05-26 17:45:50', '2020-07-08 11:30:50', 'A', '阿里地区', '0', 0, 0),
	(2980, '610101', '市辖区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2981, '610102', '新城区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(2982, '610103', '碑林区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(2983, '610104', '莲湖区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2984, '610111', '灞桥区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2985, '610112', '未央区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2986, '610113', '雁塔区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2987, '610114', '阎良区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2988, '610115', '临潼区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2989, '610116', '长安区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(2990, '610117', '高陵区', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(2991, '610122', '蓝田县', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(2992, '610124', '周至县', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(2993, '610125', '户县', '610100', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(2994, '610201', '市辖区', '610200', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(2995, '610202', '王益区', '610200', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(2996, '610203', '印台区', '610200', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2997, '610204', '耀州区', '610200', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2998, '610222', '宜君县', '610200', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(2999, '610301', '市辖区', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3000, '610302', '渭滨区', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3001, '610303', '金台区', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3002, '610304', '陈仓区', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3003, '610322', '凤翔县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3004, '610323', '岐山县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3005, '610324', '扶风县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3006, '610326', '眉县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3007, '610327', '陇县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3008, '610328', '千阳县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3009, '610329', '麟游县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3010, '610330', '凤县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3011, '610331', '太白县', '610300', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3012, '610401', '市辖区', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3013, '610402', '秦都区', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3014, '610403', '杨陵区', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3015, '610404', '渭城区', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3016, '610422', '三原县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3017, '610423', '泾阳县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3018, '610424', '乾县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3019, '610425', '礼泉县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3020, '610426', '永寿县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3021, '610427', '彬县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3022, '610428', '长武县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3023, '610429', '旬邑县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3024, '610430', '淳化县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3025, '610431', '武功县', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3026, '610481', '兴平市', '610400', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3027, '610501', '市辖区', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3028, '610502', '临渭区', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3029, '610503', '华州区', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3030, '610522', '潼关县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3031, '610523', '大荔县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3032, '610524', '合阳县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3033, '610525', '澄城县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3034, '610526', '蒲城县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3035, '610527', '白水县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3036, '610528', '富平县', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3037, '610581', '韩城市', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3038, '610582', '华阴市', '610500', '03', '2017-05-26 17:45:50', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3039, '620101', '市辖区', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3040, '620102', '城关区', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3041, '620103', '七里河区', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3042, '620104', '西固区', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3043, '620105', '安宁区', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3044, '620111', '红古区', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3045, '620121', '永登县', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3046, '620122', '皋兰县', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3047, '620123', '榆中县', '620100', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3048, '620201', '市辖区', '620200', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3049, '620301', '市辖区', '620300', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3050, '620302', '金川区', '620300', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3051, '620321', '永昌县', '620300', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3052, '620401', '市辖区', '620400', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3053, '620402', '白银区', '620400', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3054, '620403', '平川区', '620400', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3055, '620421', '靖远县', '620400', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3056, '620422', '会宁县', '620400', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3057, '620423', '景泰县', '620400', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3058, '620501', '市辖区', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3059, '620502', '秦州区', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3060, '620503', '麦积区', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3061, '620521', '清水县', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3062, '620522', '秦安县', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3063, '620523', '甘谷县', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3064, '620524', '武山县', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3065, '620525', '张家川回族自治县', '620500', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3066, '620601', '市辖区', '620600', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3067, '620602', '凉州区', '620600', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3068, '620621', '民勤县', '620600', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3069, '620622', '古浪县', '620600', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3070, '620623', '天祝藏族自治县', '620600', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3071, '620701', '市辖区', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3072, '620702', '甘州区', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3073, '620721', '肃南裕固族自治县', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3074, '620722', '民乐县', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3075, '620723', '临泽县', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3076, '620724', '高台县', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3077, '620725', '山丹县', '620700', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3078, '620801', '市辖区', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3079, '620802', '崆峒区', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3080, '620821', '泾川县', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3081, '620822', '灵台县', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3082, '620823', '崇信县', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3083, '620824', '华亭县', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3084, '620825', '庄浪县', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3085, '620826', '静宁县', '620800', '03', '2017-05-26 17:47:06', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3086, '620901', '市辖区', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3087, '620902', '肃州区', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3088, '620921', '金塔县', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3089, '620922', '瓜州县', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3090, '620923', '肃北蒙古族自治县', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3091, '620924', '阿克塞哈萨克族自治县', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3092, '620981', '玉门市', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3093, '620982', '敦煌市', '620900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3094, '621001', '市辖区', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3095, '621002', '西峰区', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3096, '621021', '庆城县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3097, '621022', '环县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3098, '621023', '华池县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3099, '621024', '合水县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3100, '621025', '正宁县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3101, '621026', '宁县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3102, '621027', '镇原县', '621000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3103, '621101', '市辖区', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3104, '621102', '安定区', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3105, '621121', '通渭县', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3106, '621122', '陇西县', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3107, '621123', '渭源县', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3108, '621124', '临洮县', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3109, '621125', '漳县', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3110, '621126', '岷县', '621100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3111, '621201', '市辖区', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3112, '621202', '武都区', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3113, '621221', '成县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3114, '621222', '文县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3115, '621223', '宕昌县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3116, '621224', '康县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3117, '621225', '西和县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3118, '621226', '礼县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3119, '621227', '徽县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3120, '621228', '两当县', '621200', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3121, '622901', '临夏市', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3122, '622921', '临夏县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3123, '622922', '康乐县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3124, '622923', '永靖县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3125, '622924', '广河县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3126, '622925', '和政县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3127, '622926', '东乡族自治县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3128, '622927', '积石山保安族东乡族撒拉族自治县', '622900', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3129, '623001', '合作市', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3130, '623021', '临潭县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3131, '623022', '卓尼县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3132, '623023', '舟曲县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3133, '623024', '迭部县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3134, '623025', '玛曲县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3135, '623026', '碌曲县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3136, '623027', '夏河县', '623000', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3137, '620100', '兰州市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'L', '兰州', '0', 0, 0),
	(3138, '620200', '嘉峪关市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'J', '嘉峪关', '0', 0, 0),
	(3139, '620300', '金昌市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'J', '金昌', '0', 0, 0),
	(3140, '620400', '白银市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'B', '白银', '0', 0, 0),
	(3141, '620500', '天水市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'T', '天水', '0', 0, 0),
	(3142, '620600', '武威市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'W', '武威', '0', 0, 0),
	(3143, '620700', '张掖市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'Z', '张掖', '0', 0, 0),
	(3144, '620800', '平凉市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'P', '平凉', '0', 0, 0),
	(3145, '620900', '酒泉市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'J', '酒泉', '0', 0, 0),
	(3146, '621000', '庆阳市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'Q', '庆阳', '0', 0, 0),
	(3147, '621100', '定西市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'D', '定西', '0', 0, 0),
	(3148, '621200', '陇南市', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'L', '陇南', '0', 0, 0),
	(3149, '622900', '临夏回族自治州', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'L', '临夏回族自治州', '0', 0, 0),
	(3150, '623000', '甘南藏族自治州', '100028', '02', '2017-05-26 17:47:07', '2020-07-08 11:30:50', 'G', '甘南藏族自治州', '0', 0, 0),
	(3151, '630101', '市辖区', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3152, '630102', '城东区', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3153, '630103', '城中区', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3154, '630104', '城西区', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3155, '630105', '城北区', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3156, '630121', '大通回族土族自治县', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3157, '630122', '湟中县', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3158, '630123', '湟源县', '630100', '03', '2017-05-26 17:47:07', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3159, '630202', '乐都区', '630200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3160, '630203', '平安区', '630200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3161, '630222', '民和回族土族自治县', '630200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3162, '630223', '互助土族自治县', '630200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3163, '630224', '化隆回族自治县', '630200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3164, '630225', '循化撒拉族自治县', '630200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3165, '632221', '门源回族自治县', '632200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3166, '632222', '祁连县', '632200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3167, '632223', '海晏县', '632200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3168, '632224', '刚察县', '632200', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3169, '632321', '同仁县', '632300', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3170, '632322', '尖扎县', '632300', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3171, '632323', '泽库县', '632300', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3172, '632324', '河南蒙古族自治县', '632300', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3173, '632521', '共和县', '632500', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3174, '632522', '同德县', '632500', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3175, '632523', '贵德县', '632500', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3176, '632524', '兴海县', '632500', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3177, '632525', '贵南县', '632500', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3178, '632621', '玛沁县', '632600', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3179, '632622', '班玛县', '632600', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3180, '632623', '甘德县', '632600', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3181, '632624', '达日县', '632600', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3182, '632625', '久治县', '632600', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3183, '632626', '玛多县', '632600', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3184, '632701', '玉树市', '632700', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3185, '632722', '杂多县', '632700', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3186, '632723', '称多县', '632700', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3187, '632724', '治多县', '632700', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3188, '632725', '囊谦县', '632700', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3189, '632726', '曲麻莱县', '632700', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3190, '632801', '格尔木市', '632800', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3191, '632802', '德令哈市', '632800', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3192, '632821', '乌兰县', '632800', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3193, '632822', '都兰县', '632800', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3194, '632823', '天峻县', '632800', '03', '2017-05-26 17:47:08', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3195, '630100', '西宁市', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'X', '西宁', '0', 0, 0),
	(3196, '630200', '海东市', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'H', '海东', '0', 0, 0),
	(3197, '632200', '海北藏族自治州', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'H', '海北藏族自治州', '0', 0, 0),
	(3198, '632300', '黄南藏族自治州', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'H', '黄南藏族自治州', '0', 0, 0),
	(3199, '632500', '海南藏族自治州', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'H', '海南藏族自治州', '0', 0, 0),
	(3200, '632600', '果洛藏族自治州', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'G', '果洛藏族自治州', '0', 0, 0),
	(3201, '632700', '玉树藏族自治州', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'Y', '玉树藏族自治州', '0', 0, 0),
	(3202, '632800', '海西蒙古族藏族自治州', '100029', '02', '2017-05-26 17:47:08', '2020-07-08 11:30:50', 'H', '海西蒙古族藏族自治州', '0', 0, 0),
	(3203, '640101', '市辖区', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3204, '640104', '兴庆区', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3205, '640105', '西夏区', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3206, '640106', '金凤区', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3207, '640121', '永宁县', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3208, '640122', '贺兰县', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3209, '640181', '灵武市', '640100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3210, '640201', '市辖区', '640200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3211, '640202', '大武口区', '640200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3212, '640205', '惠农区', '640200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3213, '640221', '平罗县', '640200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3214, '640301', '市辖区', '640300', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3215, '640302', '利通区', '640300', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3216, '640303', '红寺堡区', '640300', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3217, '640323', '盐池县', '640300', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3218, '640324', '同心县', '640300', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3219, '640381', '青铜峡市', '640300', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3220, '640401', '市辖区', '640400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3221, '640402', '原州区', '640400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3222, '640422', '西吉县', '640400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3223, '640423', '隆德县', '640400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3224, '640424', '泾源县', '640400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3225, '640425', '彭阳县', '640400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3226, '640501', '市辖区', '640500', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3227, '640502', '沙坡头区', '640500', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3228, '640521', '中宁县', '640500', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3229, '640522', '海原县', '640500', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3230, '640100', '银川市', '100030', '02', '2017-05-26 17:47:09', '2020-07-08 11:30:50', 'Y', '银川', '0', 0, 0),
	(3231, '640200', '石嘴山市', '100030', '02', '2017-05-26 17:47:09', '2020-07-08 11:30:50', 'S', '石嘴山', '0', 0, 0),
	(3232, '640300', '吴忠市', '100030', '02', '2017-05-26 17:47:09', '2020-07-08 11:30:50', 'W', '吴忠', '0', 0, 0),
	(3233, '640400', '固原市', '100030', '02', '2017-05-26 17:47:09', '2020-07-08 11:30:50', 'G', '固原', '0', 0, 0),
	(3234, '640500', '中卫市', '100030', '02', '2017-05-26 17:47:09', '2020-07-08 11:30:50', 'Z', '中卫', '0', 0, 0),
	(3235, '650101', '市辖区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3236, '650102', '天山区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3237, '650103', '沙依巴克区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3238, '650104', '新市区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3239, '650105', '水磨沟区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3240, '650106', '头屯河区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3241, '650107', '达坂城区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3242, '650109', '米东区', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3243, '650121', '乌鲁木齐县', '650100', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3244, '650201', '市辖区', '650200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3245, '650202', '独山子区', '650200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3246, '650203', '克拉玛依区', '650200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3247, '650204', '白碱滩区', '650200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3248, '650205', '乌尔禾区', '650200', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3249, '650402', '高昌区', '650400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3250, '650421', '鄯善县', '650400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3251, '650422', '托克逊县', '650400', '03', '2017-05-26 17:47:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3252, '650502', '伊州区', '650500', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3253, '650521', '巴里坤哈萨克自治县', '650500', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3254, '650522', '伊吾县', '650500', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3255, '652301', '昌吉市', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3256, '652302', '阜康市', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3257, '652323', '呼图壁县', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3258, '652324', '玛纳斯县', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3259, '652325', '奇台县', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3260, '652327', '吉木萨尔县', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3261, '652328', '木垒哈萨克自治县', '652300', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3262, '652701', '博乐市', '652700', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3263, '652702', '阿拉山口市', '652700', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3264, '652722', '精河县', '652700', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3265, '652723', '温泉县', '652700', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3266, '652801', '库尔勒市', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3267, '652822', '轮台县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3268, '652823', '尉犁县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3269, '652824', '若羌县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(3270, '652825', '且末县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3271, '652826', '焉耆回族自治县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3272, '652827', '和静县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3273, '652828', '和硕县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3274, '652829', '博湖县', '652800', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3275, '652901', '阿克苏市', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3276, '652922', '温宿县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3277, '652923', '库车县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3278, '652924', '沙雅县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3279, '652925', '新和县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3280, '652926', '拜城县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3281, '652927', '乌什县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3282, '652928', '阿瓦提县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3283, '652929', '柯坪县', '652900', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3284, '653001', '阿图什市', '653000', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3285, '653022', '阿克陶县', '653000', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3286, '653023', '阿合奇县', '653000', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3287, '653024', '乌恰县', '653000', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3288, '653101', '喀什市', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3289, '653121', '疏附县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3290, '653122', '疏勒县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3291, '653123', '英吉沙县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3292, '653124', '泽普县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3293, '653125', '莎车县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3294, '653126', '叶城县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3295, '653127', '麦盖提县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3296, '653128', '岳普湖县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3297, '653129', '伽师县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3298, '653130', '巴楚县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3299, '653131', '塔什库尔干塔吉克自治县', '653100', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3300, '653201', '和田市', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3301, '653221', '和田县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3302, '653222', '墨玉县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3303, '653223', '皮山县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3304, '653224', '洛浦县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3305, '653225', '策勒县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3306, '653226', '于田县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3307, '653227', '民丰县', '653200', '03', '2017-05-26 17:47:10', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3308, '654002', '伊宁市', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3309, '654003', '奎屯市', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3310, '654004', '霍尔果斯市', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3311, '654021', '伊宁县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3312, '654022', '察布查尔锡伯自治县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3313, '654023', '霍城县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3314, '654024', '巩留县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3315, '654025', '新源县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3316, '654026', '昭苏县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3317, '654027', '特克斯县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3318, '654028', '尼勒克县', '654000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3319, '654201', '塔城市', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3320, '654202', '乌苏市', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3321, '654221', '额敏县', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(3322, '654223', '沙湾县', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3323, '654224', '托里县', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3324, '654225', '裕民县', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3325, '654226', '和布克赛尔蒙古自治县', '654200', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3326, '654301', '阿勒泰市', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3327, '654321', '布尔津县', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3328, '654322', '富蕴县', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3329, '654323', '福海县', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3330, '654324', '哈巴河县', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3331, '654325', '青河县', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3332, '654326', '吉木乃县', '654300', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3333, '659001', '石河子市', '659000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3334, '659002', '阿拉尔市', '659000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'A', NULL, NULL, 0, 0),
	(3335, '659003', '图木舒克市', '659000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3336, '659004', '五家渠市', '659000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3337, '659006', '铁门关市', '659000', '03', '2017-05-26 17:47:11', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3338, '650100', '乌鲁木齐市', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'W', '乌鲁木齐', '0', 0, 0),
	(3339, '650200', '克拉玛依市', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'K', '克拉玛依', '0', 0, 0),
	(3340, '650400', '吐鲁番市', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'T', '吐鲁番', '0', 0, 0),
	(3341, '650500', '哈密市', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'H', '哈密', '0', 0, 0),
	(3342, '652300', '昌吉回族自治州', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'C', '昌吉回族自治州', '0', 0, 0),
	(3343, '652700', '博尔塔拉蒙古自治州', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'B', '博尔塔拉蒙古自治州', '0', 0, 0),
	(3344, '652800', '巴音郭楞蒙古自治州', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'B', '巴音郭楞蒙古自治州', '0', 0, 0),
	(3345, '652900', '阿克苏地区', '100031', '02', '2017-05-26 17:47:11', '2020-07-25 15:16:21', 'A', '阿克苏地区', '0', 1, 0),
	(3346, '653000', '克孜勒苏柯尔克孜自治州', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'K', '克孜勒苏柯尔克孜自治州', '0', 0, 0),
	(3347, '653100', '喀什地区', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'K', '喀什地区', '0', 0, 0),
	(3348, '653200', '和田地区', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'H', '和田地区', '0', 0, 0),
	(3349, '654000', '伊犁哈萨克自治州', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'Y', '伊犁哈萨克自治州', '0', 0, 0),
	(3350, '654200', '塔城地区', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'T', '塔城地区', '0', 0, 0),
	(3351, '654300', '阿勒泰地区', '100031', '02', '2017-05-26 17:47:11', '2020-07-25 14:55:02', 'A', '阿勒泰地区', '0', 0, 0),
	(3352, '659000', '自治区直辖县级行政区划', '100031', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'Z', '自治区直辖县级行政区划', '0', 0, 0),
	(3353, '100001', '北京市', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'B', NULL, NULL, 0, 0),
	(3354, '100002', '天津市', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3355, '100003', '河北省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3356, '100004', '山西省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3357, '100005', '内蒙古自治区', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'N', NULL, NULL, 0, 0),
	(3358, '100006', '辽宁省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'L', NULL, NULL, 0, 0),
	(3359, '100007', '吉林省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3360, '100008', '黑龙江省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3361, '100009', '上海市', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3362, '100010', '江苏省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3363, '100011', '浙江省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Z', NULL, NULL, 0, 0),
	(3364, '100012', '安徽省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'A', NULL, NULL, 0, 0),
	(3365, '100013', '福建省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'F', NULL, NULL, 0, 0),
	(3366, '100014', '江西省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3367, '100015', '山东省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3368, '100016', '河南省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3369, '100017', '湖北省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3370, '100018', '湖南省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3371, '100019', '广东省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'G', NULL, NULL, 0, 0),
	(3372, '100020', '广西壮族自治区', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'G', NULL, NULL, 0, 0),
	(3373, '100021', '海南省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3374, '100022', '重庆市', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Z', NULL, NULL, 0, 0),
	(3375, '100023', '四川省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3376, '100024', '贵州省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'G', NULL, NULL, 0, 0),
	(3377, '100025', '云南省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Y', NULL, NULL, 0, 0),
	(3378, '100026', '西藏自治区', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'X', NULL, NULL, 0, 0),
	(3379, '100027', '陕西省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3380, '100028', '甘肃省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'G', NULL, NULL, 0, 0),
	(3381, '100029', '青海省', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Q', NULL, NULL, 0, 0),
	(3382, '100030', '宁夏回族自治区', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'N', NULL, NULL, 0, 0),
	(3383, '100031', '新疆维吾尔自治区', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'X', NULL, NULL, 0, 0),
	(3384, '100032', '香港', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'X', NULL, NULL, 0, 0),
	(3385, '100033', '澳门', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'A', NULL, NULL, 0, 0),
	(3386, '100034', '台湾', '0000', '01', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3387, '710100', '香港', '100032', 'X', '2017-05-26 17:47:11', '2020-07-25 14:39:07', 'T', '香港', '0', 0, 0),
	(3388, '710101', '中西区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:07:58', 'Z', NULL, NULL, 0, 0),
	(3389, '710102', '湾仔区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:03', 'W', NULL, NULL, 0, 0),
	(3390, '710103', '东区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:06', 'D', NULL, NULL, 0, 0),
	(3391, '710104', '南区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:09', 'N', NULL, NULL, 0, 0),
	(3392, '710105', '观塘区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:13', 'G', NULL, NULL, 0, 0),
	(3393, '710106', '油尖旺区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:15', 'Y', NULL, NULL, 0, 0),
	(3394, '710107', '九龙城区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:18', 'J', NULL, NULL, 0, 0),
	(3395, '710108', '深水埗区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:21', 'S', NULL, NULL, 0, 0),
	(3396, '710109', '黄大仙区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:23', 'H', NULL, NULL, 0, 0),
	(3397, '710110', '葵青区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:25', 'K', NULL, NULL, 0, 0),
	(3398, '710111', '元朗区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:27', 'Y', NULL, NULL, 0, 0),
	(3399, '710112', '离岛区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:28', 'L', NULL, NULL, 0, 0),
	(3400, '710113', '北区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:31', 'B', NULL, NULL, 0, 0),
	(3401, '710114', '西贡区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:32', 'X', NULL, NULL, 0, 0),
	(3402, '710115', '沙田区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:35', 'S', NULL, NULL, 0, 0),
	(3403, '710116', '大埔区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:37', 'D', NULL, NULL, 0, 0),
	(3404, '710117', '荃湾区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:39', 'Z', NULL, NULL, 0, 0),
	(3405, '710118', '屯门区', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:43', 'T', NULL, NULL, 0, 0),
	(3406, '710119', '其他', '710100', '03', '2017-05-26 17:47:11', '2017-07-10 17:08:45', 'Q', NULL, NULL, 0, 0),
	(3407, '810100', '澳门', '100033', '02', '2017-05-26 17:47:11', '2020-07-25 17:27:11', 'A', '澳门', '0', 0, 1),
	(3408, '810101', '花地玛堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3409, '810102', '圣安多尼堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3410, '810103', '大堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'D', NULL, NULL, 0, 0),
	(3411, '810104', '望德堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'W', NULL, NULL, 0, 0),
	(3412, '810105', '风顺堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'F', NULL, NULL, 0, 0),
	(3413, '810106', '嘉模堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3414, '810107', '圣方济各堂区', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'S', NULL, NULL, 0, 0),
	(3415, '810108', '路氹城', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'L', NULL, NULL, 0, 0),
	(3416, '810109', '其他', '810100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Q', NULL, NULL, 0, 0),
	(3417, '910100', '台湾省', '100034', '02', '2017-05-26 17:47:11', '2020-07-08 11:30:50', 'T', '台湾省', '0', 0, 0),
	(3418, '910101', '台北市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3419, '910102', '新北市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'X', NULL, NULL, 0, 0),
	(3420, '910103', '台中市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3421, '910104', '台南市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3422, '910105', '高雄市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'G', NULL, NULL, 0, 0),
	(3423, '910106', '桃园县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3424, '910107', '新竹县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'X', NULL, NULL, 0, 0),
	(3425, '910108', '苗栗县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'M', NULL, NULL, 0, 0),
	(3426, '910109', '彰化县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Z', NULL, NULL, 0, 0),
	(3427, '910110', '南投县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'N', NULL, NULL, 0, 0),
	(3428, '910111', '云林县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Y', NULL, NULL, 0, 0),
	(3429, '910112', '嘉义县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3430, '910113', '屏东县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'P', NULL, NULL, 0, 0),
	(3431, '910114', '宜兰县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Y', NULL, NULL, 0, 0),
	(3432, '910115', '花莲县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'H', NULL, NULL, 0, 0),
	(3433, '910116', '台东县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'T', NULL, NULL, 0, 0),
	(3434, '910117', '金门县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3435, '910118', '连江县', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'L', NULL, NULL, 0, 0),
	(3436, '910119', '基隆市 ', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3437, '910120', '新竹市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'X', NULL, NULL, 0, 0),
	(3438, '910121', '嘉义市', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'J', NULL, NULL, 0, 0),
	(3439, '910122', '其他', '910100', '03', '2017-05-26 17:47:11', '2017-05-26 17:47:11', 'Q', NULL, NULL, 0, 0),
	(3440, '920101', '广州市', '100019', '02', '2017-05-26 17:44:09', '2020-07-25 14:59:11', 'G', '广州', '0', 0, 1),
	(3441, '920102', '深圳市', '100019', '02', '2017-05-26 17:44:09', '2020-07-25 14:59:21', 'S', '深圳', '0', 0, 1),
	(3442, '920105', '珠海市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Z', '珠海', '0', 0, 0),
	(3443, '920106', '汕头市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'S', '汕头', '0', 0, 0),
	(3444, '920107', '韶关市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'S', '韶关', '0', 0, 0),
	(3445, '920108', '佛山市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'F', '佛山', '0', 0, 0),
	(3446, '920109', '江门市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'J', '江门', '0', 0, 0),
	(3447, '920111', '湛江市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Z', '湛江', '0', 0, 0),
	(3448, '920112', '茂名市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'M', '茂名', '0', 0, 0),
	(3449, '920113', '肇庆市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Z', '肇庆', '0', 0, 0),
	(3450, '920114', '惠州市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'H', '惠州', '0', 0, 0),
	(3451, '920115', '梅州市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'M', '梅州', '0', 0, 0),
	(3452, '920116', '汕尾市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'S', '汕尾', '0', 0, 0),
	(3453, '920117', '河源市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'H', '河源', '0', 0, 0),
	(3454, '920118', '阳江市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Y', '阳江', '0', 0, 0),
	(3455, '920119', '清远市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Q', '清远', '0', 0, 0),
	(3456, '920120', '东莞市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'D', '东莞', '0', 0, 0),
	(3457, '920121', '中山市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Z', '中山', '0', 0, 0),
	(3458, '920122', '潮州市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'C', '潮州', '0', 0, 0),
	(3459, '920123', '揭阳市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'J', '揭阳', '0', 0, 0),
	(3460, '920124', '云浮市', '100019', '02', '2017-05-26 17:44:09', '2020-07-08 11:30:50', 'Y', '云浮', '0', 0, 0),
	(3461, '921001', '越秀区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3462, '921001', '广州市', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3463, '921002', '荔湾区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3464, '921005', '海珠区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3465, '921006', '天河区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3466, '921007', '白云区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3467, '921008', '黄埔区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3468, '921009', '番禺区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3469, '921011', '花都区', '000019', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3470, '921012', '南沙区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3471, '921013', '萝岗区', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3472, '921014', '增城市', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3473, '921015', '从化市', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3474, '921016', '其他', '920101', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3475, '922017', '福田区', '920102', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3476, '922018', '罗湖区', '920102', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3477, '922019', '南山区', '920102', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3478, '922020', '宝安区', '920102', '03', '2017-05-26 17:44:09', '2017-06-06 16:53:51', 'B', NULL, NULL, 0, 0),
	(3479, '922021', '龙岗区', '920102', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3480, '922022', '盐田区', '920102', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3481, '922023', '其他', '920102', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3482, '923017', '香洲区', '920105', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3483, '923018', '斗门区', '920105', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3484, '923019', '金湾区', '920105', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3485, '923020', '其他', '920105', '03', '2017-05-26 17:44:09', '2017-06-06 16:53:51', 'Q', NULL, NULL, 0, 0),
	(3486, '924021', '金平区', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3487, '924022', '濠江区', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3488, '924023', '龙湖区', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3489, '924024', '潮阳区', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3490, '924025', '潮南区', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3491, '924026', '澄海区', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3492, '924027', '南澳县', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3493, '924028', '其他', '920106', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3494, '924030', '浈江区', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3495, '924031', '武江区', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3496, '924032', '曲江区', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3497, '924033', '乐昌市', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3498, '924034', '南雄市', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3499, '924035', '始兴县', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3500, '924036', '仁化县', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(3501, '924037', '翁源县', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3502, '924038', '新丰县', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3503, '924039', '乳源瑶族自治县', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(3504, '924040', '其他', '920107', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3505, '924041', '禅城区', '920108', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3506, '924042', '南海区', '920108', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3507, '924043', '顺德区', '920108', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3508, '924044', '三水区', '920108', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3509, '924045', '高明区', '920108', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3510, '924046', '其他', '920108', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3511, '924047', '蓬江区', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3512, '924048', '江海区', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3513, '924049', '新会区', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3514, '924050', '恩平市', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'E', NULL, NULL, 0, 0),
	(3515, '924051', '台山市', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'T', NULL, NULL, 0, 0),
	(3516, '924052', '开平市', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'K', NULL, NULL, 0, 0),
	(3517, '924053', '鹤山市', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3518, '924054', '其他', '920109', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3519, '924055', '赤坎区', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3520, '924056', '霞山区', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3521, '924057', '坡头区', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3522, '924058', '麻章区', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3523, '924059', '吴川市', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3524, '924060', '廉江市', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3525, '924061', '雷州市', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3526, '924062', '遂溪县', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3527, '924063', '徐闻县', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3528, '924064', '其他', '920111', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3529, '925017', '茂南区', '920112', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3530, '925018', '茂港区', '920112', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3531, '925019', '化州市', '920112', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3532, '925020', '信宜市', '920112', '03', '2017-05-26 17:44:09', '2017-06-06 16:53:51', 'X', NULL, NULL, 0, 0),
	(3533, '925021', '高州市', '920112', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3534, '925022', '电白县', '920112', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3535, '925023', '其他', '920112', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3536, '926017', '端州区', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3537, '926018', '鼎湖区', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3538, '926019', '高要市', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3539, '926020', '四会市', '920113', '03', '2017-05-26 17:44:09', '2017-06-06 16:53:51', 'S', NULL, NULL, 0, 0),
	(3540, '926021', '广宁县', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'G', NULL, NULL, 0, 0),
	(3541, '926022', '怀集县', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3542, '926023', '封开县', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3543, '926024', '德庆县', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3544, '926025', '其他', '920113', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3545, '926026', '惠城区', '920114', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3546, '926027', '惠阳区', '920114', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3547, '926028', '博罗县', '920114', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'B', NULL, NULL, 0, 0),
	(3548, '926030', '惠东县', '920114', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3549, '926031', '龙门县', '920114', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3550, '926032', '其他', '920114', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3551, '926033', '梅江区', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3552, '926034', '兴宁市', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3553, '926035', '梅县', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'M', NULL, NULL, 0, 0),
	(3554, '926036', '大埔县', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3555, '926037', '丰顺县', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3556, '926038', '五华县', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3557, '926039', '平远县', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3558, '926040', '蕉岭县', '920115', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3559, '926041', '城区', '920116', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3560, '926042', '陆丰市', '920116', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3561, '926043', '海丰县', '920116', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3562, '926044', '陆河县', '920116', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3563, '926045', '源城区', '920117', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3564, '926046', '紫金县', '920117', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3565, '926047', '龙川县', '920117', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3566, '926048', '连平县', '920117', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3567, '926049', '和平县', '920117', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3568, '926050', '东源县', '920117', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3569, '926051', '江城区', '920118', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3570, '926052', '阳春市', '920118', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3571, '926053', '阳西县', '920118', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3572, '926054', '阳东县', '920118', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3573, '926055', '清城区', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3574, '926056', '英德市', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3575, '926057', '连州市', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3576, '926058', '佛冈县', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'F', NULL, NULL, 0, 0),
	(3577, '926059', '阳山县', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3578, '926060', '清新县', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3579, '926061', '连山壮族瑶族自治县', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3580, '926062', '连南瑶族自治县', '920119', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3581, '926063', '莞城街道', '920120', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3582, '926064', '南城街道', '920120', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'N', NULL, NULL, 0, 0),
	(3583, '926065', '东城街道', '920120', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3584, '926066', '万江街道', '920120', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3629, '927017', '石岐区', '920121', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'S', NULL, NULL, 0, 0),
	(3630, '927018', '东区', '920121', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'D', NULL, NULL, 0, 0),
	(3631, '927019', '西区', '920121', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3632, '927020', '南区', '920121', '03', '2017-05-26 17:44:09', '2017-06-06 16:53:51', 'N', NULL, NULL, 0, 0),
	(3633, '927021', '五桂山区', '920121', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'W', NULL, NULL, 0, 0),
	(3634, '927022', '湘桥区', '920122', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3635, '927023', '潮安县', '920122', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'C', NULL, NULL, 0, 0),
	(3645, '927026', '饶平县', '920122', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'R', NULL, NULL, 0, 0),
	(3646, '927027', '榕城区', '920123', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Z', NULL, NULL, 0, 0),
	(3647, '927028', '普宁市', '920123', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'P', NULL, NULL, 0, 0),
	(3648, '927030', '揭东县', '920123', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3649, '927031', '揭西县', '920123', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'J', NULL, NULL, 0, 0),
	(3650, '927032', '惠来县', '920123', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'H', NULL, NULL, 0, 0),
	(3651, '927033', '云城区', '920124', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3652, '927034', '罗定市', '920124', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'L', NULL, NULL, 0, 0),
	(3653, '927035', '云安县', '920124', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3654, '927036', '新兴县', '920124', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'X', NULL, NULL, 0, 0),
	(3655, '927037', '郁南县', '920124', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Y', NULL, NULL, 0, 0),
	(3656, '927038', '其他', '920124', '03', '2017-05-26 17:44:09', '2017-05-26 18:07:03', 'Q', NULL, NULL, 0, 0),
	(3657, '460100', '海口市', '100021', '02', '2019-12-12 11:51:51', '2020-07-08 11:30:50', 'H', '海口', '0', 0, 0),
	(3658, '460200', '三亚市', '100021', '02', '2019-12-12 11:57:01', '2020-07-08 11:30:50', 'S', '三亚', '0', 0, 0),
	(3659, '469000', '省直辖县级行政单位', '100021', '02', '2019-12-12 11:57:37', '2020-07-08 11:30:50', 'S', '省直辖县级行政单位', '0', 0, 0),
	(3666, '469001', '五指山市', '469000', '03', '2019-12-12 12:30:08', '2019-12-12 12:30:09', 'W', NULL, NULL, 0, 0),
	(3667, '469002', '琼海市', '469000', '03', '2019-12-12 12:30:23', '2019-12-12 12:30:24', 'Q', NULL, NULL, 0, 0),
	(3668, '469003', '儋州市', '469000', '03', '2019-12-12 12:30:51', '2019-12-12 12:30:52', 'Z', NULL, NULL, 0, 0),
	(3669, '469005', '文昌市', '469000', '03', '2019-12-12 12:31:18', '2019-12-12 12:31:19', 'W', NULL, NULL, 0, 0),
	(3670, '469006', '万宁市', '469000', '03', '2019-12-12 12:31:38', '2019-12-12 12:31:39', 'W', NULL, NULL, 0, 0),
	(3671, '469007', '东方市', '469000', '03', '2019-12-12 12:32:00', '2019-12-12 12:32:01', 'D', NULL, NULL, 0, 0),
	(3672, '469025', '定安县', '469000', '03', '2019-12-12 12:32:30', '2019-12-12 12:32:30', 'D', NULL, NULL, 0, 0),
	(3673, '469026', '屯昌县', '469000', '03', '2019-12-12 12:32:51', '2019-12-12 12:32:52', 'T', NULL, NULL, 0, 0),
	(3674, '469027', '澄迈县', '469000', '03', '2019-12-12 12:33:14', '2019-12-12 12:33:15', 'C', NULL, NULL, 0, 0),
	(3675, '469028', '临高县', '469000', '03', '2019-12-12 12:33:36', '2019-12-12 12:33:37', 'L', NULL, NULL, 0, 0),
	(3676, '469030', '白沙黎族自治县', '469000', '03', '2019-12-12 12:33:59', '2019-12-12 12:34:00', 'B', NULL, NULL, 0, 0),
	(3677, '469031', '昌江黎族自治县', '469000', '03', '2019-12-12 12:34:19', '2019-12-12 12:34:20', 'C', NULL, NULL, 0, 0),
	(3678, '469033', '乐东黎族自治县', '469000', '03', '2019-12-12 12:34:41', '2019-12-12 12:34:42', 'L', NULL, NULL, 0, 0),
	(3679, '469034', '陵水黎族自治县', '469000', '03', '2019-12-12 12:35:08', '2019-12-12 12:35:20', 'L', NULL, NULL, 0, 0),
	(3680, '469035', '保亭黎族苗族自治县', '469000', '03', '2019-12-12 12:35:41', '2019-12-12 12:35:42', 'B', NULL, NULL, 0, 0),
	(3681, '469036', '琼中黎族苗族自治县', '469000', '03', '2019-12-12 12:36:04', '2019-12-12 12:36:05', 'Q', NULL, NULL, 0, 0),
	(3682, '469037', '西沙群岛', '469000', '03', '2019-12-12 12:36:26', '2019-12-12 12:36:27', 'X', NULL, NULL, 0, 0),
	(3683, '469038', '南沙群岛', '469000', '03', '2019-12-12 12:36:48', '2019-12-12 12:36:49', 'N', NULL, NULL, 0, 0),
	(3684, '469039', '中沙群岛的岛礁及其海域', '469000', '03', '2019-12-12 12:37:06', '2019-12-12 12:37:07', 'Z', NULL, NULL, 0, 0),
	(3685, '610100', '西安市', '100027', '02', '2019-12-19 17:13:53', '2020-07-08 11:30:50', 'S', '西安', '0', 0, 0),
	(3686, '610200', '铜川市', '100027', '02', '2019-12-19 17:15:21', '2020-07-08 11:30:50', 'T', '铜川', '0', 0, 0),
	(3687, '610300', '宝鸡市', '100027', '02', '2019-12-19 17:26:49', '2020-07-08 11:30:50', 'B', '宝鸡', '0', 0, 0),
	(3688, '610400', '咸阳市', '100027', '02', '2019-12-19 17:27:22', '2020-07-08 11:30:50', 'X', '咸阳', '0', 0, 0),
	(3689, '610500', '渭南市', '100027', '02', '2019-12-19 17:27:50', '2020-07-08 11:30:50', 'W', '渭南', '0', 0, 0),
	(3690, '610600', '延安市', '100027', '02', '2019-12-19 17:28:21', '2020-07-08 11:30:50', 'Y', '延安', '0', 0, 0),
	(3691, '610700', '汉中市', '100027', '02', '2019-12-19 17:28:57', '2020-07-08 11:30:50', 'H', '汉中', '0', 0, 0),
	(3692, '610800', '榆林市', '100027', '02', '2019-12-19 17:29:17', '2020-07-08 11:30:50', 'Y', '榆林', '0', 0, 0),
	(3693, '610900', '安康市', '100027', '02', '2019-12-19 17:29:36', '2020-07-08 11:30:50', 'A', '安康', '0', 0, 0),
	(3694, '611000', '商洛市', '100027', '02', '2019-12-19 17:30:03', '2020-07-08 11:30:50', 'S', '商洛', '0', 0, 0),
	(3695, '610601', '市辖区', '610600', '03', '2019-12-19 17:39:03', '2019-12-19 17:39:04', 'S', NULL, NULL, 0, 0),
	(3696, '610602', '宝塔区', '610600', '03', '2019-12-19 17:39:27', '2019-12-19 17:39:28', 'B', NULL, NULL, 0, 0),
	(3697, '610621', '延长县', '610600', '03', '2019-12-19 17:39:55', '2019-12-19 17:39:56', 'Y', NULL, NULL, 0, 0),
	(3698, '610622', '延川县', '610600', '03', '2019-12-19 17:48:45', '2019-12-19 17:49:00', 'Y', NULL, NULL, 0, 0),
	(3700, '610623', '子长县', '610600', '03', '2019-12-19 17:42:59', '2019-12-19 17:43:13', 'Z', NULL, NULL, 0, 0),
	(3701, '610624', '安塞县', '610600', '03', '2019-12-19 17:42:59', '2019-12-19 17:43:16', 'A', NULL, NULL, 0, 0),
	(3702, '610625', '志丹县', '610600', '03', '2019-12-19 17:43:00', '2019-12-19 17:43:19', 'Z', NULL, NULL, 0, 0),
	(3703, '610626', '吴旗县', '610600', '03', '2019-12-19 17:43:01', '2019-12-19 17:43:21', 'W', NULL, NULL, 0, 0),
	(3704, '610627', '甘泉县', '610600', '03', '2019-12-19 17:43:02', '2019-12-19 17:43:24', 'G', NULL, NULL, 0, 0),
	(3705, '610628', '富　县', '610600', '03', '2019-12-19 17:43:02', '2019-12-19 17:43:27', 'F', NULL, NULL, 0, 0),
	(3706, '610629', '洛川县', '610600', '03', '2019-12-19 17:43:03', '2019-12-19 17:43:29', 'L', NULL, NULL, 0, 0),
	(3707, '610630', '宜川县', '610600', '03', '2019-12-19 17:43:03', '2019-12-19 17:43:32', 'Y', NULL, NULL, 0, 0),
	(3708, '610631', '黄龙县', '610600', '03', '2019-12-19 17:43:04', '2019-12-19 17:43:34', 'H', NULL, NULL, 0, 0),
	(3709, '610632', '黄陵县', '610600', '03', '2019-12-19 17:43:05', '2019-12-19 17:43:37', 'H', NULL, NULL, 0, 0),
	(3710, '610701', '市辖区', '610700', '03', '2019-12-19 17:48:25', '2019-12-19 17:48:29', 'S', NULL, NULL, 0, 0),
	(3711, '610702', '汉台区', '610700', '03', '2019-12-19 17:49:33', '2019-12-19 17:51:05', 'H', NULL, NULL, 0, 0),
	(3712, '610721', '南郑县', '610700', '03', '2019-12-19 17:49:37', '2019-12-19 17:51:03', 'N', NULL, NULL, 0, 0),
	(3713, '610722', '城固县', '610700', '03', '2019-12-19 17:49:38', '2019-12-19 17:51:00', 'C', NULL, NULL, 0, 0),
	(3714, '610723', '洋　县', '610700', '03', '2019-12-19 17:49:39', '2019-12-19 17:50:57', 'Y', NULL, NULL, 0, 0),
	(3715, '610724', '西乡县', '610700', '03', '2019-12-19 17:49:40', '2019-12-19 17:50:54', 'X', NULL, NULL, 0, 0),
	(3716, '610725', '勉　县', '610700', '03', '2019-12-19 17:49:40', '2019-12-19 17:50:51', 'M', NULL, NULL, 0, 0),
	(3717, '610726', '宁强县', '610700', '03', '2019-12-19 17:49:41', '2019-12-19 17:50:48', 'N', NULL, NULL, 0, 0),
	(3718, '610727', '略阳县', '610700', '03', '2019-12-19 17:49:42', '2019-12-19 17:50:46', 'L', NULL, NULL, 0, 0),
	(3719, '610728', '镇巴县', '610700', '03', '2019-12-19 17:49:42', '2019-12-19 17:50:43', 'Z', NULL, NULL, 0, 0),
	(3720, '610729', '留坝县', '610700', '03', '2019-12-19 17:49:43', '2019-12-19 17:50:39', 'L', NULL, NULL, 0, 0),
	(3721, '610730', '佛坪县', '610700', '03', '2019-12-19 17:49:44', '2019-12-19 17:50:36', 'F', NULL, NULL, 0, 0),
	(3722, '610801', '市辖区', '610800', '03', '2019-12-19 17:52:25', '2019-12-19 17:54:49', 'S', NULL, NULL, 0, 0),
	(3723, '610802', '榆阳区', '610800', '03', '2019-12-19 17:52:28', '2019-12-19 17:54:51', 'Y', NULL, NULL, 0, 0),
	(3724, '610821', '神木县', '610800', '03', '2019-12-19 17:52:28', '2019-12-19 17:54:54', 'S', NULL, NULL, 0, 0),
	(3725, '610822', '府谷县', '610800', '03', '2019-12-19 17:52:29', '2019-12-19 17:54:57', 'F', NULL, NULL, 0, 0),
	(3726, '610823', '横山县', '610800', '03', '2019-12-19 17:52:30', '2019-12-19 17:55:00', 'H', NULL, NULL, 0, 0),
	(3727, '610824', '靖边县', '610800', '03', '2019-12-19 17:52:32', '2019-12-19 17:55:03', 'J', NULL, NULL, 0, 0),
	(3728, '610825', '定边县', '610800', '03', '2019-12-19 17:52:33', '2019-12-19 17:55:07', 'D', NULL, NULL, 0, 0),
	(3729, '610826', '绥德县', '610800', '03', '2019-12-19 17:52:34', '2019-12-19 17:55:43', 'S', NULL, NULL, 0, 0),
	(3730, '610827', '米脂县', '610800', '03', '2019-12-19 17:52:35', '2019-12-19 17:55:47', 'M', NULL, NULL, 0, 0),
	(3731, '610828', '佳　县', '610800', '03', '2019-12-19 17:52:36', '2019-12-19 17:55:49', 'J', NULL, NULL, 0, 0),
	(3732, '610829', '吴堡县', '610800', '03', '2019-12-19 17:52:37', '2019-12-19 17:55:52', 'W', NULL, NULL, 0, 0),
	(3733, '610830', '清涧县', '610800', '03', '2019-12-19 17:52:38', '2019-12-19 17:55:56', 'Q', NULL, NULL, 0, 0),
	(3734, '610831', '子洲县', '610800', '03', '2019-12-19 17:52:39', '2019-12-19 17:55:58', 'Z', NULL, NULL, 0, 0),
	(3735, '610901', '市辖区', '610900', '03', '2019-12-19 17:56:35', '2019-12-19 17:58:22', 'S', NULL, NULL, 0, 0),
	(3736, '610902', '汉滨区', '610900', '03', '2019-12-19 17:56:37', '2019-12-19 17:58:25', 'H', NULL, NULL, 0, 0),
	(3737, '610921', '汉阴县', '610900', '03', '2019-12-19 17:56:38', '2019-12-19 17:58:27', 'H', NULL, NULL, 0, 0),
	(3738, '610922', '石泉县', '610900', '03', '2019-12-19 17:56:39', '2019-12-19 17:58:29', 'S', NULL, NULL, 0, 0),
	(3739, '610923', '宁陕县', '610900', '03', '2019-12-19 17:56:40', '2019-12-19 17:58:32', 'N', NULL, NULL, 0, 0),
	(3740, '610924', '紫阳县', '610900', '03', '2019-12-19 17:56:40', '2019-12-19 17:58:34', 'Z', NULL, NULL, 0, 0),
	(3741, '610925', '岚皋县', '610900', '03', '2019-12-19 17:56:41', '2019-12-19 17:58:37', 'L', NULL, NULL, 0, 0),
	(3742, '610926', '平利县', '610900', '03', '2019-12-19 17:56:42', '2019-12-19 17:58:40', 'P', NULL, NULL, 0, 0),
	(3743, '610927', '镇坪县', '610900', '03', '2019-12-19 17:56:43', '2019-12-19 17:58:44', 'Z', NULL, NULL, 0, 0),
	(3744, '610928', '旬阳县', '610900', '03', '2019-12-19 17:56:43', '2019-12-19 17:58:46', 'X', NULL, NULL, 0, 0),
	(3745, '610929', '白河县', '610900', '03', '2019-12-19 17:56:45', '2019-12-19 17:58:49', 'B', NULL, NULL, 0, 0),
	(3746, '611026', '柞水县', '611000', '03', '2019-12-19 17:59:15', '2019-12-19 18:01:18', 'Z', NULL, NULL, 0, 0),
	(3747, '611025', '镇安县', '611000', '03', '2019-12-19 17:59:16', '2019-12-19 18:01:16', 'Z', NULL, NULL, 0, 0),
	(3748, '611024', '山阳县', '611000', '03', '2019-12-19 17:59:16', '2019-12-19 18:01:14', 'S', NULL, NULL, 0, 0),
	(3749, '611023', '商南县', '611000', '03', '2019-12-19 17:59:17', '2019-12-19 18:01:12', 'S', NULL, NULL, 0, 0),
	(3750, '611022', '丹凤县', '611000', '03', '2019-12-19 17:59:18', '2019-12-19 18:01:09', 'D', NULL, NULL, 0, 0),
	(3751, '611021', '洛南县', '611000', '03', '2019-12-19 17:59:19', '2019-12-19 18:01:07', 'L', NULL, NULL, 0, 0),
	(3752, '611002', '商州区', '611000', '03', '2019-12-19 17:59:20', '2019-12-19 18:01:04', 'S', NULL, NULL, 0, 0),
	(3753, '611001', '市辖区', '611000', '03', '2019-12-19 17:59:21', '2019-12-19 18:01:00', 'S', NULL, NULL, 0, 0);
/*!40000 ALTER TABLE `area` ENABLE KEYS */;

-- 导出  表 hoppe.attr_ext_p 结构
CREATE TABLE IF NOT EXISTS `attr_ext_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品扩展属性id',
  `pid` int(11) DEFAULT NULL COMMENT '为了给产品加扩展属性 - 产品id',
  `key` varchar(255) DEFAULT NULL COMMENT '属性名',
  `value` varchar(255) DEFAULT NULL COMMENT '属性内容',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb4 COMMENT='产品扩展属性  k-v      多对1产品';

-- 正在导出表  hoppe.attr_ext_p 的数据：~16 rows (大约)
/*!40000 ALTER TABLE `attr_ext_p` DISABLE KEYS */;
REPLACE INTO `attr_ext_p` (`id`, `pid`, `key`, `value`, `sort`, `create_time`) VALUES
	(1, NULL, NULL, NULL, NULL, '2020-07-20 18:53:01'),
	(3, 1, 'hhh', 'ss', 8, '2020-07-20 18:55:11'),
	(4, NULL, 'dddd', 'dd', 0, '2020-07-20 18:55:21'),
	(5, 1, 'ss', 'ss', 0, '2020-07-20 18:56:09'),
	(6, 1, 'zhe?', 'ss', 0, '2020-07-20 18:56:36'),
	(8, 4, 'F49/F9', '2711560', 50, '2020-07-31 13:07:02'),
	(9, 4, 'F72/F9', '2711463', 49, '2020-07-31 14:43:04'),
	(12, 33, 'F9-11', '3887102', 9, '2020-07-31 17:44:56'),
	(13, 33, 'F1-11', '3887090', 10, '2020-07-31 17:45:22'),
	(14, 50, 'F9', '3819345', 9, '2020-08-03 12:19:51'),
	(15, 50, 'F1', '3819337', 10, '2020-08-03 12:20:19'),
	(16, 4, 'F77R/F52R', '3043989', 48, '2020-08-04 18:14:58'),
	(17, 4, '数量/ 盒', '1', 47, '2020-08-04 18:15:16'),
	(18, 4, '数量 / 数量', '10', 46, '2020-08-04 18:15:55'),
	(23, 50, '数量/ 盒', '20', 8, '2020-08-05 11:39:00'),
	(24, 50, '数量/箱', '20', 7, '2020-08-05 11:39:29');
/*!40000 ALTER TABLE `attr_ext_p` ENABLE KEYS */;

-- 导出  表 hoppe.attr_p 结构
CREATE TABLE IF NOT EXISTS `attr_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品属性ID',
  `pid` int(11) DEFAULT NULL COMMENT '产品id',
  `title` varchar(255) DEFAULT NULL COMMENT '属性标题',
  `img` varchar(255) DEFAULT NULL COMMENT '属性图',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb4 COMMENT='产品属性';

-- 正在导出表  hoppe.attr_p 的数据：~12 rows (大约)
/*!40000 ALTER TABLE `attr_p` DISABLE KEYS */;
REPLACE INTO `attr_p` (`id`, `pid`, `title`, `img`, `sort`, `create_time`) VALUES
	(1, NULL, '使用类别 2（3, 4）DIN EN 1906', '/upload/product/patent/test41.jpg', 0, '2020-07-10 18:04:28'),
	(2, NULL, 'ss', '/upload/product/patent/test13.jpg', 0, '2020-07-17 19:19:41'),
	(3, 1, 'ssss', '/upload/product/attrp/test4.jpg', 9, '2020-07-18 14:48:00'),
	(4, 1, 'ss', '/upload/product/attrp/test41.jpg', 0, '2020-07-20 16:24:40'),
	(5, 4, '使用类别 2（3, 4）DIN EN 1906', '/upload/product/attrp/icon_sx_1.png', 10, '2020-07-30 16:54:25'),
	(6, 4, '防腐蚀 EN 1670（5 级）', '/upload/product/attrp/icon_sx_2.png', 9, '2020-07-30 16:54:36'),
	(8, 33, '防腐蚀 EN 1670（5 级）', '/upload/product/attrp/x3d4cca611.png', 0, '2020-07-31 17:44:33'),
	(9, 50, '使用类别 2（3, 4）DIN EN 1906', '/upload/product/attrp/icon_sx_11.png', 10, '2020-08-03 12:19:11'),
	(10, 4, '实心黄铜', '/upload/product/attrp/未标题-1.jpg', 0, '2020-08-04 18:13:10'),
	(12, 50, '防腐蚀 EN 1670（5 级）', '/upload/product/attrp/x3fe5558cc1.png', 9, '2020-08-05 11:37:46'),
	(13, 777, 'x', '/upload/product/attrp/favicon.ico', 0, '2020-09-07 00:32:05'),
	(14, 777, 's', '/upload/product/attrp/favicon1.ico', 0, '2020-09-07 00:32:20');
/*!40000 ALTER TABLE `attr_p` ENABLE KEYS */;

-- 导出  表 hoppe.axial_p 结构
CREATE TABLE IF NOT EXISTS `axial_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pid` int(11) DEFAULT NULL COMMENT '产品id',
  `title` varchar(255) DEFAULT NULL COMMENT '轴标题',
  `img` varchar(255) DEFAULT NULL COMMENT '路径',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8 COMMENT='轴长分类   产品下的';

-- 正在导出表  hoppe.axial_p 的数据：~5 rows (大约)
/*!40000 ALTER TABLE `axial_p` DISABLE KEYS */;
REPLACE INTO `axial_p` (`id`, `pid`, `title`, `img`, `sort`, `create_time`) VALUES
	(1, 1, 'sf555', '/upload/product/axial/test2.jpg', 5, '2020-07-18 14:35:59'),
	(3, 4, '37-42 mm', '/upload/product/axial/1-1.png', 0, '2020-07-30 16:50:56'),
	(6, 33, '62-74', '/upload/product/axial/211.png', 9, '2020-07-31 17:44:04'),
	(8, 33, '62-74', '/upload/product/axial/21.png', 10, '2020-08-04 17:02:07'),
	(9, 50, '32-42 mm', '/upload/product/axial/13.png', 0, '2020-08-04 17:03:20');
/*!40000 ALTER TABLE `axial_p` ENABLE KEYS */;

-- 导出  表 hoppe.banner 结构
CREATE TABLE IF NOT EXISTS `banner` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `title` varchar(255) DEFAULT NULL COMMENT 'banner标题',
  `img` varchar(255) DEFAULT NULL COMMENT 'banner路径',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` date DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8mb4 COMMENT='首页banner图';

-- 正在导出表  hoppe.banner 的数据：~5 rows (大约)
/*!40000 ALTER TABLE `banner` DISABLE KEYS */;
REPLACE INTO `banner` (`id`, `title`, `img`, `sort`, `create_time`) VALUES
	(6, 'banner1', '/upload/home/banner/M1643-843K+KV-843KS+KVS-PZ-F78-1-R-Motiv2-nW.jpg', 99, '2020-07-23'),
	(19, 'banner2', '/upload/home/banner/M1642-843K+KV-843KS+KVS-PZ-F49-R-Motiv2-nW.jpg', 0, '2020-07-30'),
	(20, 'banner3', '/upload/home/banner/M543-F84-1-R-Motiv1-nW.jpg', 0, '2020-09-16'),
	(22, 'banner2', '/upload/home/banner/2.jpg', 101, '2020-11-09'),
	(23, 'banner3', '/upload/home/banner/3.jpg', 100, '2020-11-09');
/*!40000 ALTER TABLE `banner` ENABLE KEYS */;

-- 导出  表 hoppe.collection 结构
CREATE TABLE IF NOT EXISTS `collection` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键自增id',
  `openid` varchar(255) DEFAULT NULL COMMENT 'openid',
  `pid` int(11) DEFAULT NULL COMMENT '产品id',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=149 DEFAULT CHARSET=utf8mb4 COMMENT='收藏列表';

-- 正在导出表  hoppe.collection 的数据：~13 rows (大约)
/*!40000 ALTER TABLE `collection` DISABLE KEYS */;
REPLACE INTO `collection` (`id`, `openid`, `pid`, `create_time`) VALUES
	(60, 'o1qmn5K8ofR-bZp4-wvNXHwucd8E', 378, '2021-03-17 12:55:02'),
	(64, 'o1qmn5K8ofR-bZp4-wvNXHwucd8E', 421, '2021-03-17 12:56:31'),
	(67, 'o1qmn5K8ofR-bZp4-wvNXHwucd8E', 162, '2021-03-17 12:57:18'),
	(106, 'o1qmn5D4tJR4vUdNAPxQR1DPSGFI', 71, '2021-03-17 23:50:22'),
	(137, 'o1qmn5K0eOuFtPpmadG6a8QhYrZk', 378, '2021-03-18 09:42:16'),
	(140, 'o1qmn5DKOijIlOKOabSm_SJcl4uA', 421, '2021-03-18 18:11:32'),
	(141, 'o1qmn5DKOijIlOKOabSm_SJcl4uA', 374, '2021-03-18 18:11:41'),
	(142, 'o1qmn5DKOijIlOKOabSm_SJcl4uA', 279, '2021-03-18 18:11:47'),
	(143, 'o1qmn5J2WCwuIxQ4geeZOKdekH5k', 378, '2021-03-24 13:15:13'),
	(144, 'o1qmn5P84-144oEvn3PMDXaOEqas', 378, '2021-03-24 18:51:30'),
	(146, 'o1qmn5MnpenH7wDHiLxnBzSBCDpQ', 115, '2021-03-25 10:45:38'),
	(147, 'o1qmn5MnpenH7wDHiLxnBzSBCDpQ', 673, '2021-03-25 10:45:45'),
	(148, 'o1qmn5EHk5uN-FDvQedCnvg5qQbw', 378, '2021-03-26 12:34:59');
/*!40000 ALTER TABLE `collection` ENABLE KEYS */;

-- 导出  表 hoppe.color_mapping 结构
CREATE TABLE IF NOT EXISTS `color_mapping` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `material` varchar(150) DEFAULT NULL COMMENT '材质',
  `code` varchar(150) DEFAULT NULL COMMENT '颜色代码',
  `color_cn` varchar(150) DEFAULT NULL COMMENT '颜色对应中文名称',
  `color_en` varchar(150) DEFAULT NULL COMMENT '颜色对应英文名称',
  PRIMARY KEY (`id`),
  UNIQUE KEY `code` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=61 DEFAULT CHARSET=utf8mb4 COMMENT='颜色对应表';

-- 正在导出表  hoppe.color_mapping 的数据：~59 rows (大约)
/*!40000 ALTER TABLE `color_mapping` DISABLE KEYS */;
REPLACE INTO `color_mapping` (`id`, `material`, `code`, `color_cn`, `color_en`) VALUES
	(2, '铝合金', 'F1', '银色', NULL),
	(3, '铝合金', 'F1-2-S', '哑光银色', NULL),
	(4, '铝合金', 'F1-11', '亮银色/哑光', NULL),
	(5, '铝合金', 'F1/F69', '银色/不锈钢磨砂', NULL),
	(6, '铝合金', 'F2', '香槟色', NULL),
	(7, '铝合金', 'F3', '铝金色', NULL),
	(8, '铝合金', 'F4', '古铜色', NULL),
	(9, '铝合金', 'F4-11', '古铜光亮/哑光', NULL),
	(10, '铝合金', 'F9', '仿钢色', NULL),
	(11, '铝合金', 'F9-11', '仿钢色抛光/哑光', NULL),
	(12, '铝合金', 'F31-1', '仿不锈钢/哑光', NULL),
	(13, '铝合金', 'F8707', '深褐色', NULL),
	(14, '铝合金', 'F9016', '交通白', NULL),
	(15, '铝合金', 'F9016M', '交通白光', NULL),
	(16, '铝合金', 'F9714M', '黑哑光', NULL),
	(17, '不锈钢', 'F69', '不锈钢磨砂', NULL),
	(18, '黄铜', 'F41-R', '镀铬拉丝', NULL),
	(19, '黄铜', 'F42-R', '镀镍丝光', NULL),
	(20, '黄铜', 'F45-R', '镀铬抛光/磨砂', NULL),
	(21, '黄铜', 'F49-R', '镀铬抛光', NULL),
	(22, '黄铜', 'F49/F9', '镀铬抛光/仿钢色', NULL),
	(23, '黄铜', 'F72', '铜拉丝', NULL),
	(24, '黄铜', 'F72/F9', '铜拉丝/仿钢色', NULL),
	(25, '黄铜', 'F73', '古铜色', NULL),
	(26, '黄铜', 'F74-R', '铜色, 磨砂/抛光', NULL),
	(27, '黄铜', 'F77-R', '铜色, 抛光', NULL),
	(28, '黄铜', 'F77-R/F52-R', '铜色, 抛光/丝光', NULL),
	(29, '黄铜', 'F78-R', '自然亮铜色', NULL),
	(30, '黄铜', 'F78-1-R', '自然丝光铜色', NULL),
	(31, '黄铜', 'F84-R', '亮玫瑰金', NULL),
	(32, '黄铜', 'F84-1-R', '丝光玫瑰金', NULL),
	(33, '黄铜', 'F96-R', '亮黑', NULL),
	(34, '黄铜', 'F96-1-R', '丝光黑', NULL),
	(35, '黄铜', 'F97-R', '亮烟灰色', NULL),
	(36, '黄铜', 'F97-1-R', '丝光烟灰色', NULL),
	(37, 'ARRONE 表面处理', 'PB', '铜抛光', NULL),
	(38, 'ARRONE 表面处理', 'AB', '古铜色', NULL),
	(39, 'ARRONE 表面处理', 'PVD', 'PVD-镀铜', NULL),
	(40, 'ARRONE 表面处理', 'MNP', '镍哑光', NULL),
	(41, 'ARRONE 表面处理', 'PSS', '光亮不锈钢', NULL),
	(42, 'ARRONE 表面处理', 'SSS', '丝光不锈钢', NULL),
	(43, 'ARRONE 表面处理', 'BLK', '黑', NULL),
	(44, '铝合金', 'F1-2', '哑光银色', NULL),
	(45, '铝合金', 'F9-2', '哑光仿钢色', NULL),
	(46, '尼龙', 'F7016M', '烟灰哑光', NULL),
	(47, '尼龙', 'F9005M', '乌黑哑光', NULL),
	(48, '尼龙', 'F9010M', '纯白哑光', NULL),
	(49, '不锈钢', 'F69-S', '不锈钢拉丝', NULL),
	(50, '黄铜', 'F41', '镀铬拉丝', NULL),
	(51, '黄铜', 'F49', '镀铬抛光', NULL),
	(52, '黄铜', 'F54', '复古黄铜色', NULL),
	(53, '黄铜', 'F55', '复古铜色', NULL),
	(54, '黄铜', 'F56', '复古青铜', NULL),
	(55, '黄铜', 'F76', '深红古铜', NULL),
	(56, '黄铜', 'F77', '铜色抛光', NULL),
	(57, '黄铜', 'F75-R', '铜色,抛光/丝光', NULL),
	(58, '黄铜', 'F77R', '铜色,抛光', NULL),
	(59, '黄铜', 'F52R', '抛光/丝光', NULL),
	(60, '黄铜', 'F49R', '镀铬抛光', NULL);
/*!40000 ALTER TABLE `color_mapping` ENABLE KEYS */;

-- 导出  表 hoppe.color_type_p 结构
CREATE TABLE IF NOT EXISTS `color_type_p` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `pid` int(11) DEFAULT NULL COMMENT '产品id',
  `title` varchar(100) DEFAULT NULL COMMENT '颜色名称',
  `img` varchar(255) DEFAULT NULL COMMENT '路径',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COMMENT='颜色分类  一个产品对应多个分类';

-- 正在导出表  hoppe.color_type_p 的数据：~16 rows (大约)
/*!40000 ALTER TABLE `color_type_p` DISABLE KEYS */;
REPLACE INTO `color_type_p` (`id`, `pid`, `title`, `img`, `sort`, `create_time`) VALUES
	(4, 1, '积分', '/upload/product/colorType/test10.jpg', 2, '2020-07-17 15:35:52'),
	(5, NULL, '第二个吧', '/upload/product/colorType/test51.jpeg', 0, '2020-07-18 13:51:31'),
	(6, NULL, 'fff', '/upload/product/colorType/test52.jpeg', 0, '2020-07-18 13:53:22'),
	(7, NULL, 'xx', '/upload/product/colorType/1593669290430.jpg', 0, '2020-07-18 13:53:46'),
	(8, 2, 'ff', '/upload/product/colorType/test41.jpg', 0, '2020-07-18 13:55:48'),
	(9, 2, 'sssss', '/upload/product/colorType/test6.jpg', 0, '2020-07-18 13:56:57'),
	(10, 2, 'daf', '/upload/product/colorType/test7.jpg', 0, '2020-07-18 13:57:25'),
	(11, 1, 'ddasd', '/upload/product/colorType/test61.jpg', 999, '2020-07-18 14:25:53'),
	(12, 1, 'fffffffff', '/upload/product/colorType/test62.jpg', 0, '2020-07-18 14:44:36'),
	(14, 4, '铜抛光', '/upload/product/colorType/1-1.png', 0, '2020-07-30 16:19:17'),
	(19, 33, '铜抛光', '/upload/product/colorType/12.png', 10, '2020-08-04 17:02:47'),
	(20, 50, '黑', '/upload/product/colorType/13.png', 10, '2020-08-04 17:03:04'),
	(23, 33, '古铜色', '/upload/product/colorType/21.png', 9, '2020-08-05 11:27:22'),
	(24, 33, '黑', '/upload/product/colorType/3.png', 8, '2020-08-05 11:28:11'),
	(25, 33, '丝光不锈钢', '/upload/product/colorType/4.png', 7, '2020-08-05 11:28:52'),
	(26, 777, '测试', '/upload/product/colorType/about_2.jpg', 0, '2020-09-07 01:20:36');
/*!40000 ALTER TABLE `color_type_p` ENABLE KEYS */;

-- 导出  表 hoppe.demo 结构
CREATE TABLE IF NOT EXISTS `demo` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键自增id',
  `title` varchar(50) DEFAULT NULL COMMENT '标题',
  `content` mediumtext COMMENT '内容',
  `desc` varchar(500) DEFAULT NULL COMMENT '描述',
  `sort` tinyint(4) DEFAULT NULL COMMENT '排序 由小到大',
  `status` tinyint(4) DEFAULT NULL COMMENT '状态  0未审核 1审核',
  `img` varchar(50) DEFAULT NULL COMMENT '图片上传',
  `create_date` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=utf8 COMMENT='案列表';

-- 正在导出表  hoppe.demo 的数据：~24 rows (大约)
/*!40000 ALTER TABLE `demo` DISABLE KEYS */;
REPLACE INTO `demo` (`id`, `title`, `content`, `desc`, `sort`, `status`, `img`, `create_date`) VALUES
	(1, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 0, '', '2020-05-11 11:56:30'),
	(2, 'Font Awesome总是不断的在往好的方向发展', '<p>Font Awesome总是不断的在往好的方向发展</p>', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:33'),
	(3, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:34'),
	(4, '123', '<p><br/></p><p><br/></p><p>Font Awesome总是不断的在往好的方向发展<br/></p><p><br/></p><p><img src="/upload/ue/img/c243002fe430b8fd10cbc8ebe1c5cf90.jpg" title="c243002fe430b8fd10cbc8ebe1c5cf90.jpg" alt="c243002fe430b8fd10cbc8ebe1c5cf90.jpg"/></p>', 'Font Awesome总是不断的在往好的方向发展\ndemolist\n', 20, 1, '/upload/demo/dd9d95e41c474aa345adec384e4a6b95.jpg', '2020-05-27 00:00:00'),
	(5, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:36'),
	(6, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:36'),
	(7, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:37'),
	(8, 'Font Awesome总是不断的在往好的方向发展', '<p>Font Awesome总是不断的在往好的方向发展</p>', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:38'),
	(9, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 1, NULL, '2020-05-11 11:59:41'),
	(10, 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 'Font Awesome总是不断的在往好的方向发展', 1, 0, NULL, '2020-05-11 11:59:39'),
	(11, 'Font Awesome总是不断的在往好的方向发展', '<p>Font Awesome总是不断的在往好的方向发展</p>', '那女孩对我说', 1, 0, NULL, '2020-05-11 11:59:40'),
	(13, NULL, '<p>dasdasdasdasdasd</p><p><br/></p><div id="baidu_pastebin" style="position: absolute; width: 1px; height: 1px; overflow: hidden; left: -1000px; white-space: nowrap; top: 34px;"><span style="white-space: normal;">dasdasdasdasdasd</span><br/></div>', NULL, NULL, 0, NULL, '2020-06-18 00:00:00'),
	(14, 'd', NULL, NULL, 0, 0, NULL, NULL),
	(15, NULL, NULL, NULL, 0, 0, NULL, NULL),
	(16, NULL, NULL, NULL, 0, 0, NULL, NULL),
	(17, NULL, NULL, NULL, 0, 0, NULL, NULL),
	(18, NULL, NULL, NULL, 0, 0, NULL, NULL),
	(19, 'sdasdasda', NULL, 'adsasda', 0, 0, NULL, NULL),
	(20, 'dd', NULL, 'ad', 0, 0, NULL, NULL),
	(21, '这是一个迷人的小情歌', NULL, NULL, 0, 0, NULL, NULL),
	(22, '顶顶顶顶顶大大多多多多多顶顶顶顶顶大大多多多多多点多的', NULL, NULL, 0, 0, NULL, NULL),
	(23, '打算的撒打算多所多所大所多', NULL, NULL, 0, 0, NULL, '2020-07-01 00:00:00'),
	(24, '111111111111', NULL, NULL, 0, 0, NULL, NULL),
	(25, '顶顶顶顶顶大大', NULL, NULL, 0, 0, NULL, NULL);
/*!40000 ALTER TABLE `demo` ENABLE KEYS */;

-- 导出  表 hoppe.hot_search 结构
CREATE TABLE IF NOT EXISTS `hot_search` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `title` varchar(1000) DEFAULT NULL COMMENT '标题',
  `type` int(11) DEFAULT NULL COMMENT '1 门店 2  产品',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COMMENT='热门搜索';

-- 正在导出表  hoppe.hot_search 的数据：~11 rows (大约)
/*!40000 ALTER TABLE `hot_search` DISABLE KEYS */;
REPLACE INTO `hot_search` (`id`, `title`, `type`, `sort`, `create_time`) VALUES
	(1, 'Amsterdam', 2, 0, '2020-07-22 15:01:17'),
	(2, '好博五金', 1, 0, '2020-07-22 15:03:21'),
	(3, '铁力路店', 1, 0, '2020-07-22 15:12:29'),
	(4, '徐家汇店', 1, 0, '2020-07-22 15:12:36'),
	(5, 'HOPPE 好博专卖店', 1, 0, '2020-07-22 15:12:52'),
	(6, '南翔店', 1, 0, '2020-07-22 15:13:00'),
	(7, '好博门店', 1, 0, '2020-07-22 15:13:05'),
	(8, '门把手', 2, 0, '2020-07-24 18:26:36'),
	(9, '锁芯', 2, 0, '2020-07-24 18:26:48'),
	(10, '1400/42K/42KS', 2, 0, '2020-07-24 18:27:27'),
	(12, '上海', 1, 0, '2020-07-30 15:28:44');
/*!40000 ALTER TABLE `hot_search` ENABLE KEYS */;

-- 导出  表 hoppe.navbar 结构
CREATE TABLE IF NOT EXISTS `navbar` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `name` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '导航名称',
  `icon` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '父标题 图 icon',
  `pid` int(11) DEFAULT NULL COMMENT '父节点',
  `url` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '链接',
  `discription` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '描述',
  `state` int(11) DEFAULT '0' COMMENT '(0用，1禁)',
  `sort` int(11) DEFAULT '0',
  `create_time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='导航栏';

-- 正在导出表  hoppe.navbar 的数据：~39 rows (大约)
/*!40000 ALTER TABLE `navbar` DISABLE KEYS */;
REPLACE INTO `navbar` (`id`, `name`, `icon`, `pid`, `url`, `discription`, `state`, `sort`, `create_time`) VALUES
	(2, '产品中心', '#xe6c6;', 0, '#', 'dd', 0, 98, '2020-07-15 12:27:31'),
	(3, '产品信息', NULL, 2, '/admin/product', '描述', 0, 0, '2020-07-15 13:19:59'),
	(4, '首页', '#xe67f;', 0, '#', '首页栏目', 1, 99, '2020-07-15 13:19:59'),
	(5, 'banners', '#xe616;', 4, '/admin/banner', NULL, 1, 0, '2020-07-15 13:20:00'),
	(6, '新闻资讯', NULL, 4, '/admin/news', NULL, 0, 0, '2020-07-15 13:20:01'),
	(7, '附近门店', NULL, 4, '/admin/store', NULL, 0, 0, '2020-07-15 13:20:01'),
	(8, '应用案列', NULL, 4, '/admin/app_case', NULL, 0, 0, '2020-07-15 13:20:02'),
	(9, '产品类型', NULL, 2, '/admin/p_type', NULL, 0, 0, '2020-07-15 13:22:01'),
	(10, '产品材质', NULL, 2, '/admin/p_material', NULL, 0, 0, '2020-07-15 13:22:15'),
	(11, '产品颜色', NULL, 2, '/admin/p_color', '产品颜色', 0, 0, '2020-07-15 13:22:32'),
	(12, '产品专利', NULL, 2, '/admin/p_patent', '产品颜色', 0, 0, '2020-07-15 13:22:47'),
	(13, '风格系列', NULL, 2, '/admin/p_style', '产品颜色', 0, 0, '2020-07-15 13:23:07'),
	(14, '产品款式', NULL, 2, '/admin/p_title', '产品款式', 0, 0, '2020-07-15 13:23:23'),
	(15, '应用体验', '#xe636;', 0, '#', '一级标题', 0, 98, '2020-07-15 13:24:27'),
	(16, '场景选择', NULL, 15, '/admin/photos?type=1', '应用场景1', 0, 0, '2020-07-15 13:25:06'),
	(17, '门窗材质', NULL, 15, '/admin/photos?type=2', '门窗材质', 0, 0, '2020-07-15 13:25:26'),
	(18, '资料库', '#xe72b;', 0, '#', '资料库', 0, 50, '2020-07-15 15:47:24'),
	(19, 'VR展馆', NULL, 18, '/admin/vr', NULL, 0, 0, '2020-07-15 15:47:47'),
	(20, '视频技术', NULL, 18, '/admin/video', NULL, 0, 0, '2020-07-15 15:48:09'),
	(21, '图册资料', NULL, 18, '/admin/photo', NULL, 0, 0, '2020-07-15 15:48:16'),
	(22, '系统设置', '#xe62e;', 0, '#', NULL, 0, 20, '2020-07-15 15:48:54'),
	(23, '类型设置', NULL, 22, '/admin/types', NULL, 0, 0, '2020-07-15 15:49:11'),
	(24, '销售人员', NULL, 22, '/admin/seller', NULL, 0, 0, '2020-07-15 15:49:24'),
	(25, '搜索统计', '#xe665;', 0, '#', NULL, 0, 40, '2020-07-15 15:49:37'),
	(26, '产品搜索', NULL, 25, '/admin/search_product_log', NULL, 0, 0, '2020-07-15 15:50:00'),
	(27, '门店搜索', NULL, 25, '/admin/search_store_log', NULL, 0, 0, '2020-07-15 15:50:13'),
	(28, '权限管理', '#xe62d;', 0, '#', NULL, 0, 30, '2020-07-15 15:50:50'),
	(29, '用户管理', NULL, 28, '/admin/admins', NULL, 0, 0, '2020-07-15 15:51:12'),
	(30, '导航设置', NULL, 28, '/admin/navbar', NULL, 0, 0, '2020-07-15 15:51:31'),
	(31, '微信用户', '#xe60d;', 0, '#', NULL, 0, 0, '2020-07-15 15:51:47'),
	(33, '热门搜索', NULL, 25, '/admin/hot_search', '设置热门搜索数据，包括门店和产品热门搜索', 0, 0, '2020-07-22 14:58:09'),
	(34, '城市设置', NULL, 22, '/admin/city', '城市设置', 0, 0, '2020-07-25 13:57:22'),
	(40, '产品属性', '#xe616;', 2, '/admin/p_attr', '产品属性', 0, 0, '2020-09-07 04:50:04'),
	(41, '锁孔设置', '#xe616;', 2, '/admin/p_keyhole', '产品可多选钥匙孔', 0, 0, '2020-09-22 19:25:28'),
	(42, '清除缓存', '#xe616;', 22, '/admin/clearcache', '清空系统临时文件,释放空间', 0, 0, '2020-09-30 19:35:24'),
	(43, '修改密码', '#xe616;', 28, '/admin/ad/editPassword', '当前用户密码更新', 0, 0, '2020-10-16 19:49:26'),
	(44, '展会登记', '#xe636;', 0, '#', NULL, 0, 1, '2020-10-24 19:02:47'),
	(45, '登记列表', '#xe616;', 44, '/admin/registration', '展会登记列表', 0, 0, '2020-10-24 19:03:16'),
	(46, '用户信息', '#xe616;', 31, '/admin/wxuser', '微信用户', 0, 0, '2021-03-15 23:07:06');
/*!40000 ALTER TABLE `navbar` ENABLE KEYS */;

-- 导出  表 hoppe.news 结构
CREATE TABLE IF NOT EXISTS `news` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `title` varchar(255) DEFAULT NULL COMMENT '新闻标题',
  `img` varchar(255) DEFAULT NULL COMMENT '新闻图',
  `content` longtext COMMENT '内容 富文本',
  `recommend` int(11) DEFAULT NULL COMMENT '是否推荐 0默认不推荐 1推荐',
  `face` int(11) DEFAULT NULL COMMENT '是否封面新闻，只能设置一个',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `pubdate` date DEFAULT NULL COMMENT '发布日期',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=63 DEFAULT CHARSET=utf8mb4 COMMENT='新闻资讯';

-- 正在导出表  hoppe.news 的数据：~31 rows (大约)
/*!40000 ALTER TABLE `news` DISABLE KEYS */;
REPLACE INTO `news` (`id`, `title`, `img`, `content`, `recommend`, `face`, `sort`, `pubdate`, `create_time`) VALUES
	(28, 'HOPPE 好博荣获金轩奖技术研发创新产品奖', '/upload/home/news/WX20200908-150712@2x.png', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200908-150712@2x.png" title="WX20200908-150712@2x.png" alt="WX20200908-150712@2x.png"/></p><p><br/></p><section label="Edit by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="97740" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 10px 20px; max-width: 100%; box-sizing: border-box; background-color: rgb(0, 35, 76); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; color: rgb(255, 255, 255); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 50px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; height: 6px; width: 6px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; height: 6px; width: 6px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; height: 6px; width: 6px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 50px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; height: 6px; width: 6px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; height: 6px; width: 6px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; height: 6px; width: 6px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section><section style="margin: -20px 20px 0px; padding: 1em; max-width: 100%; border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgb(254, 254, 254); box-shadow: rgb(0, 35, 76) 0px 0px 14.117646217346191px 0px inset; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto 30px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; justify-content: center; align-items: center; height: 1px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; width: 10px; height: 10px; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-brushtype="text" style="margin: 0px 10px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-weight: bold; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博 荣获金轩奖</p></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; width: 10px; height: 10px; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section data-autoskip="1" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">2020年8月31日，第四届建筑门窗幕墙行业金轩奖获奖名单正式公布，HOPPE 好博的<span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 15px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;">eHandle感应开启</span>成功斩获<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">技术研发创新产品</strong></span>奖项！</span></p><p hm_fix="321:548" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages __bg_gif " data-ratio="0.7875457875457875" data-s="300,640" data-type="gif" data-w="1092" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNk7aey8ibXd2qqgmibQKCg6yTVTVN6gibZxODYFiaNHNO1uJPicandTo6dB2Q/640?wx_fmt=gif" width="383px" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNk7aey8ibXd2qqgmibQKCg6yTVTVN6gibZxODYFiaNHNO1uJPicandTo6dB2Q/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); width: 602px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages" data-croporisrc="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNksDyepIOx6377iaWlnPsby1C2UsApCpwrbhmTCZR1PHORDoXMlblOg4g/640?wx_fmt=png" data-cropx1="600.5017421602788" data-cropx2="1002" data-cropy1="0" data-cropy2="50.623693379790936" data-ratio="0.12437810945273632" data-s="300,640" data-type="jpeg" data-w="402" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZvBibDDY3Sw6gOOnJJCRoj4jZbW0lAF03zb3HeBTzC03Bc2lQdq3ZTbg/640?wx_fmt=jpeg" width="151px" _width="151px" src="https://hoppe.jzdsh.com/upload/ue/img/04c5284762a0fbf0d209bc39511e7849.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 151px !important;" title="04c5284762a0fbf0d209bc39511e7849.jpg" alt="04c5284762a0fbf0d209bc39511e7849.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">射灯可根据地面颜色切换4种色彩模式</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">便 捷 –</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE&nbsp;好博感应开启</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博入户门 eHandle 感应开启技术让您无需停下手上繁忙的业务也可以轻松开门。房屋主人只要靠近门，大拉手就会接收到无线钥匙发出的加密信号。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;然后大拉手底部的射灯会自动亮起，说明房屋主人被允许进入房间。房屋主人只需用脚扫过射灯的光线，门便会自动开启，简单方便，无需触碰。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages __bg_gif " data-ratio="1.78" data-type="gif" data-w="200" height="214" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZu238uoOegiaGHPHZRdowKWiaPd3FS1qHW14YA7UeE8yqF3U7Z8FgWwyg/640?wx_fmt=gif" width="200px" _width="120px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZu238uoOegiaGHPHZRdowKWiaPd3FS1qHW14YA7UeE8yqF3U7Z8FgWwyg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 0.5440000295639038px; caret-color: rgb(0, 0, 0); font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 120px !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">内置的安全功能可防止您无意中在室内打开门锁。您可以根据不同的地面颜色切换光束的颜色，以确保其清晰可见。控制单元位于室内部分。</span></span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"></span></span></p></section></section></section></section><section data-tools="135编辑器" data-id="99749" style="margin: 0px; padding: 0px; max-width: 100%; height: 0px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6338028169014085" data-w="1136" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaa0HHPcodgQGhibhSns6J3Vg9OpWEibSRCs585GdPKU7M3PMH3as8vZrWLEoeHq0ItZhcUO95GdBnvQ/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/750e9ff5980b9683536916fc659ca1f6.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="750e9ff5980b9683536916fc659ca1f6.jpg" alt="750e9ff5980b9683536916fc659ca1f6.jpg"/></p></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; font-size: 14px; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; font-size: 14px; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;“金轩奖”创立于2014年，每两年举办一次，旨在通过奖项评选促进行业的良性竞争，鼓励行业创新，挖掘真正的技术创新产品和推动行业发展的企业和个人。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; font-size: 14px; letter-spacing: 4px; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; font-size: 14px; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;经过八年的耕耘，金轩奖已经成为建筑门窗幕墙行业极具深远影响力的大奖，不断引领行业发展最新趋势，深度洞悉市场发展与业态变化。</span></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; letter-spacing: 4px; line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.75" data-s="300,640" data-type="jpeg" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/FXtpIQ65wqNx9nN63NXkmibibUJTBszcicq4mTEibrP6ClyfOrwhpbPu5BAYQiaZFWCqOQytuTPF7IfG8XWicJXJ0Yqw/640?wx_fmt=jpeg" width="677px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/8ce1f71166229afb6973750ae9a01ea5.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); width: 674px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="8ce1f71166229afb6973750ae9a01ea5.jpg" alt="8ce1f71166229afb6973750ae9a01ea5.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;本届金轩奖结合专家建议和行业发展新趋势，根据不同类型奖项设置了针对性的投票方式及得分权重规则，使评选结果更加公正、专业、权威。在共有400余个候选名单中HOPPE 好博成功入围，并在各奖项角逐相较往届更为激烈的情况下摘得技术研发创新产品大奖。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.2109375" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkG3a71zoABdZfjzsvEgN9lhgPpxlx5WYB97ojqmcIZqEzNql1otVJsA/640?wx_fmt=png" width="677px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/c5dbbe4e2729e465b3fdf2cfc141ff49.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); width: 674px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="c5dbbe4e2729e465b3fdf2cfc141ff49.jpg" alt="c5dbbe4e2729e465b3fdf2cfc141ff49.jpg"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.4987298899237933" data-s="300,640" data-type="jpeg" data-w="1181" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaajKibJdQEALhdRzHzvKJEVbMZ3lculJ3COyLiaetruibqmPkojpInS0glrESWKQMSgVcc5czkcw3Hyw/640?wx_fmt=jpeg" width="677px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/d881e0c16ca0b9c3a20e6b3b5843cb79.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); width: 674px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="d881e0c16ca0b9c3a20e6b3b5843cb79.jpg" alt="d881e0c16ca0b9c3a20e6b3b5843cb79.jpg"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 35, 76); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;1<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">952年，弗里德里奇·好博(Friedrich Hoppe 音译)先生在德国锁具及五金的传统工业中心地带–杜塞尔多夫(Düsseldorf 音译)附近的小镇黑利根豪斯(Heiligenhaus 音译)创立了本公司。如今, HOPPE 好博集团业务遍及全球,总部设于瑞士。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;凭借着欧美七家工厂、近三千员工和拥有的国际市场，HOPPE 好博成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领导者地位。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important; text-align: center;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200908-151838@2x.png" title="WX20200908-151838@2x.png" alt="WX20200908-151838@2x.png"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博出品的门窗把手均为品牌产品，产品本身即是对品质的承诺。这些门窗把手可以很好地融入环境氛围，对体现个人室内设计风格起画龙点睛之笔，将“细节体现居住品位”这一理念带到实际生活中。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博把手不仅仅操作门窗的开启和关闭，我们的安全五金和防盗把手可以在锁闭门和窗时提供防盗保护，是有效提升安全性能的部件。有些 HOPPE 好博把手还拥有其他的特殊性能。比如，防火性能，智能化或者具有抗菌/抑菌功能。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.36444444444444446" data-w="900" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaa0HHPcodgQGhibhSns6J3VgvsQt2Hg75GQvuCOPqY4t9fd3jTLibYl4E0lIR6K3p2KfRk2GPqwvrFA/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/edf43eb5b401a669e66b1b5d2f3463c1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="edf43eb5b401a669e66b1b5d2f3463c1.jpg" alt="edf43eb5b401a669e66b1b5d2f3463c1.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博门窗把手使用优质原料在欧洲通过认证的工厂内生产和制作。在 HOPPE 好博，保护环境是必须的，也是基本的原则。任何 HOPPE 好博门窗把手的用户都拥有把手的 10 年机械功能质保。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; caret-color: rgb(0, 35, 76); color: rgb(0, 35, 76); line-height: normal; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.552" data-w="750" height="256" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabVv0YjnLj9c9m7hiaYf19MMAIx4HOedaTpUf3VO5p2qgmEtKtBVqoicZsdY7Sdv4U7CObNoYPrLtUw/640?" width="auto" _width="464px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5658b262f8bfdea7b05a7261635f28fb.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 464px !important;" title="5658b262f8bfdea7b05a7261635f28fb.jpg" alt="5658b262f8bfdea7b05a7261635f28fb.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; line-height: normal; letter-spacing: 1.5px; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="jpeg" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=jpeg" _width="482px" src="https://hoppe.jzdsh.com/upload/ue/img/cd8b22165f63597fdd57d1a013bc7b09.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 482px !important;" title="cd8b22165f63597fdd57d1a013bc7b09.jpg" alt="cd8b22165f63597fdd57d1a013bc7b09.jpg"/></p></section></section></section></section><p><br/></p><p><br/></p><p><br/></p>', 1, 1, 0, '2020-09-03', '2020-09-08 15:24:18'),
	(29, '汇融享赋能 聚合探新知', '/upload/home/news/WX20200908-173246@2x.png', '<p><br/></p><p><br/></p><section label="Edit by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" font-size:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="98970" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 6px; max-width: 100%; box-sizing: border-box; background-color: rgb(198, 217, 240); box-shadow: rgb(198, 217, 240) 0px 0px 15px; background-image: url(" background-size:="" word-wrap:="" break-word="" background-repeat:="" no-repeat=""><section style="margin: 0px 0px -10px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-color: rgb(0, 32, 96); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-color: rgb(0, 32, 96); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" hm_fix="350:550" style="margin: 0px; padding: 10px 25px; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; border: 1px solid rgb(0, 32, 96); color: rgb(0, 35, 76); word-wrap: break-word !important;">HOPPE 好博 | 欧迪克门窗</section><section style="margin: -10px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-color: rgb(0, 32, 96); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-color: rgb(0, 32, 96); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section></section></section><section data-tools="135编辑器" data-id="98971" style="margin: 0px; padding: 0px; max-width: 100%; height: 0px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-tools="135编辑器" data-id="98963" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 10px 10px; max-width: 100%; box-sizing: border-box; box-shadow: rgb(248, 241, 230) 0px 0px 15px; background-image: -webkit-linear-gradient(left, rgb(198, 217, 240), rgb(0, 35, 76)); word-wrap: break-word !important;"><section style="margin: 0px 0px -10px 1px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 14px; height: 14px; background-color: rgb(255, 255, 255); border: 1px solid rgb(198, 217, 240); overflow: hidden; transform: rotate(46deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px -4px; padding: 0px; max-width: 100%; width: 11px; height: 11px; background-color: rgb(255, 255, 255); border: 1px solid rgb(198, 217, 240); overflow: hidden; transform: rotate(46deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-autoskip="1" style="margin: 0px; padding: 1em; max-width: 100%; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(0, 35, 76); border: 1px solid rgb(198, 217, 240); background-color: rgb(255, 255, 255); background-image: url(" background-size:="" box-sizing:="" border-box="" word-wrap:="" break-word="" background-position:="" center="" background-repeat:="" no-repeat=""><p hm_fix="283:427" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img data-ratio="0.6296875" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabVv0YjnLj9c9m7hiaYf19MMxO2yqWdN0HvPGtcxpwNUgHoEeb0d9ovcRiaBeDicnCwTYaNOB8VabENg/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ecb06ad1ddb2600033eabe223c0f1197.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="ecb06ad1ddb2600033eabe223c0f1197.jpg" alt="ecb06ad1ddb2600033eabe223c0f1197.jpg"/></span></p><p hm_fix="283:427" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;佛山市南海欧迪克五金制品有限公司始创于2003年，致力于发展高端硅镁铝合金安全门窗，木铝门窗、阳光房定制，集研发、生产、销售、服务于一体。</span></p><p hm_fix="283:427" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p hm_fix="283:427" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;十五年来，欧迪克人坚持不懈的努力为“欧迪克门窗”赢得了无数的荣誉。系列产品畅销大江南北，遍布欧美三十多个国家及地区。获得由权威媒体及单位颁发的多项殊荣。</span></p><p hm_fix="283:427" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p hm_fix="283:427" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;目前为止，“欧迪克门窗”的专卖店遍布全国800多个城市及地区，共有900多家专卖店辐射全国。</span></p><p style="margin-top: 15px; margin-bottom: 15px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; word-spacing: -1.5px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;欧迪克家居集团目前拥有三大成熟专业的生产基地，拥有稳定的人才队伍服务于企业各岗位。始于2007年，欧迪克便引进德国海富纳数控自动生产线、意大利飞幕门窗生产设备，以雄厚的生产技术接轨国际市场，保证产品质量和货期。</p><p style="margin-top: 15px; margin-bottom: 15px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; word-spacing: -1.5px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;欧迪克门窗以独特鲜明的品牌形象和高品质的产品，赢得了消费者的一致认可，欧迪克门窗提倡自然、宁静、舒适的北欧生活方式，演绎低调简约的北欧生活新体验，致力为大众打造智能、安全、健康的生活空间。</p></section></section></section></section><section data-tools="135编辑器" data-id="98962" style="margin: 0px; padding: 0px; max-width: 100%; height: 0px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="98965" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 5px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 1em 15px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px; max-width: 100%; font-weight: bold; font-size: 24px; box-sizing: border-box !important; word-wrap: break-word !important;">八月</section><section data-brushtype="text" style="margin: -8px 0px 0px; padding: 0px; max-width: 100%; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;">2020</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; flex: 1 1 0%; display: flex; justify-content: flex-start; align-items: center; background-image: linear-gradient(-45deg, transparent 10px, rgb(198, 217, 240) 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px 1em; max-width: 100%; box-sizing: border-box; text-align: left; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; 2020年8月，HOPPE 好博技术交流团队来到了位于佛山市南海欧迪克门窗总部，就品牌历史、产品技术信息、实际安装方式以及市场定向推广进行了友好且紧密的深入交流。</p></section></section></section></section><section style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 1em 15px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px; max-width: 100%; font-weight: bold; font-size: 24px; box-sizing: border-box !important; word-wrap: break-word !important;">品牌</section><section data-brushtype="text" style="margin: -8px 0px 0px; padding: 0px; max-width: 100%; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; flex: 1 1 0%; display: flex; justify-content: flex-start; align-items: center; background-image: linear-gradient(-45deg, transparent 10px, rgb(198, 217, 240) 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px 1em; max-width: 100%; box-sizing: border-box; text-align: left; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><p hm_fix="394:536" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;作为一家提出室内门窗系统一体化解决方案的企业。欧迪克门窗一直致力于为各领域提供高端的门窗应用。未来，欧迪克将为更多的家居及商业提供专业高端的门窗系统服务，并致力成为定制门窗优质品牌。</span></p><p hm_fix="394:536" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img data-ratio="0.75" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabVv0YjnLj9c9m7hiaYf19MMx1p6UHtaL7Rg5DOaIRNsNlM1qY4V5Kg29LMiahj45F5JAAq0D0JSUcQ/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/3527edfa67084d6dda2f8a4efa970d88.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="3527edfa67084d6dda2f8a4efa970d88.jpg" alt="3527edfa67084d6dda2f8a4efa970d88.jpg"/></span></p><p hm_fix="394:536" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(178, 178, 178); color: rgb(178, 178, 178); font-size: 12px; font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">中国区</span><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(178, 178, 178); color: rgb(178, 178, 178); font-size: 12px; font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">市场部经理Lesley介绍品牌企业历史</span><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word=""></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 35, 76); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp; 1952年，弗里德里奇·好博(Friedrich Hoppe 音译)先生在德国锁具及五金的传统工业中心地带–杜塞尔多夫(Düsseldorf 音译)附近的小镇黑利根豪斯(Heiligenhaus 音译)创立了本公司。如今, HOPPE 好博集团业务遍及全球,总部设于瑞士。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 35, 76); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;凭借着欧美七家工厂、近三千员工和拥有的国际市场，HOPPE 好博成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领导者地位。</span></p></section></section></section></section><section style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 1em 15px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px; max-width: 100%; font-weight: bold; font-size: 24px; box-sizing: border-box !important; word-wrap: break-word !important;">技术</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; flex: 1 1 0%; display: flex; justify-content: flex-start; align-items: center; background-image: linear-gradient(-45deg, transparent 10px, rgb(198, 217, 240) 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px 1em; max-width: 100%; box-sizing: border-box; text-align: left; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; background-color: rgb(198, 217, 240); font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;欧迪克门窗自创立以来就秉承&quot;担社会责任，造健康建材&quot;的企业使命，执著于对&quot;绿色&quot;的追求，将生态和环境保护的理念融入企业经营中的的研发、生产、营销、消费等各个环节，将绿色&quot;基因&quot;注入企业的方方面面。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; background-color: rgb(198, 217, 240); font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;采用绿色技术、开发绿色新产品、实施绿色制造，开展绿色营销和绿色服务，欧迪克门窗通过一系列的措施和实际行动，肩负起了企业发展、保护环境、保持生态平衡的重任。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; background-color: rgb(198, 217, 240); font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;欧迪克门窗将继续坚持&quot;树木、树人、树品牌&quot;的环保公益方针，践行“环保生产，健康节能&quot;的执业宗旨。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; background-color: rgb(198, 217, 240); font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img data-ratio="1.3352272727272727" data-w="352" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabVv0YjnLj9c9m7hiaYf19MMI5YicVquTQfsREjc0icfvicfTqEqWEdhH39sqV8HmIUROiadPFPW7ibiayuQ/640" title="1ec4aa785d872e9f56894d67f0f8ad2d.jpg" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1ec4aa785d872e9f56894d67f0f8ad2d.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" alt="1ec4aa785d872e9f56894d67f0f8ad2d.jpg"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; word-spacing: -1.5000001192092896px; background-color: rgb(198, 217, 240); font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(178, 178, 178); color: rgb(178, 178, 178); font-size: 12px; font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">中国区产品经理Harvey分享产品技术信息</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博出品的门窗把手均为品牌产品，产品本身即是对品质的承诺。这些门窗把手可以很好地融入环境氛围，对体现个人室内设计风格起画龙点睛之笔，将“细节体现居住品位”这一理念带到实际生活中。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博把手不仅仅操作门窗的开启和关闭，我们的安全五金和防盗把手可以在锁闭门和窗时提供防盗保护，是有效提升安全性能的部件。有些 HOPPE 好博把手还拥有其他的特殊性能。比如，防火性能，智能化或者具有抗菌/抑菌功能。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博门窗把手使用优质原料在欧洲通过认证的工厂内生产和制作。在 HOPPE 好博，保护环境是必须的，也是基本的原则。任何 HOPPE 好博门窗把手的用户都拥有把手的 10 年机械功能质保。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.552" data-w="750" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabVv0YjnLj9c9m7hiaYf19MMAIx4HOedaTpUf3VO5p2qgmEtKtBVqoicZsdY7Sdv4U7CObNoYPrLtUw/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5658b262f8bfdea7b05a7261635f28fb1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="5658b262f8bfdea7b05a7261635f28fb1.jpg" alt="5658b262f8bfdea7b05a7261635f28fb.jpg"/></p></section></section></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><section data-tools="135编辑器" data-id="98959" style="margin: 0px; padding: 0px; max-width: 100%; height: 0px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-tools="135编辑器" data-id="98959" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; height: 1px; border-bottom-width: 10px; border-bottom-style: solid; border-bottom-color: rgb(0, 0, 0); border-left-width: 10px; border-left-style: solid; border-left-color: transparent; align-self: flex-start; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-brushtype="text" style="margin: 0px; padding: 5px 25px; max-width: 100%; font-weight: bold; letter-spacing: 1.5px; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">携手赋能 聚力合作</section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; height: 1px; border-bottom-width: 10px; border-bottom-style: solid; border-bottom-color: rgb(0, 0, 0); border-right-width: 10px; border-right-style: solid; border-right-color: transparent; align-self: flex-start; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section style="margin: -26px 0px 0px; padding: 10px; max-width: 100%; box-sizing: border-box; background-color: rgb(255, 255, 255); box-shadow: rgb(198, 217, 240) 0px 0px 15px; background-image: url(" background-size:="" word-wrap:="" break-word="" background-position:="" center="" background-repeat:="" no-repeat=""><section data-autoskip="1" style="margin: 0px; padding: 2em 1em 1em; max-width: 100%; box-sizing: border-box; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(0, 35, 76); border: 1px solid rgb(0, 35, 76); word-wrap: break-word !important;"><p hm_fix="395:355" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabVv0YjnLj9c9m7hiaYf19MMenQia2sAiadjAicINbtiar2tynY6pYPJZnZsmpiaegXYafW1xLAsX9zteeQ/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6189bda50cdab2cdac0f84e7ded4f248.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="6189bda50cdab2cdac0f84e7ded4f248.jpg" alt="6189bda50cdab2cdac0f84e7ded4f248.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(178, 178, 178); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">冷洪福总经理与HOPPE 好博团队合影留念</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;此次技术交流会中，欧迪克的研发部与采购部团队在冷总经理的带领下与HOPPE 好博技术交流团队一同讨论了许多门窗市场的实际问题。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;通过走进欧迪克工厂，与技术研发和市场采购面对面交流，关于HOPPE 好博产品在实际安装及推广中遇到的疑问和问题，HOPPE 好博团队给予了直接快速的反馈。通过互相面对面的深入接触，HOPPE 好博在更高效的解决应用问题，倾听客户的切实反馈。</p></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p></section></section></section><p><br/></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-08-26', '2020-09-08 17:38:28'),
	(30, '深入交流 携手共进', '/upload/home/news/1c6dc47736e4e68ad517b1e0e98795a0.jpg', '<p><br/></p><p><br/></p><p><br/></p><section label="Edit by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" font-size:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="99187" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 20px auto 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-color="#d82821" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 20px; font-weight: bold; text-align: center; text-decoration: inherit; color: rgb(255, 255, 255); border: 0px none; font-family: inherit; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px 0px -1.85em; padding: 0px; max-width: 100%; width: 674px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0.3em 0px 0px; padding: 0px; max-width: 100%; width: 674px; height: 0.3em; background-color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: 0.3em 0px 0px; padding: 0px; max-width: 100%; width: 674px; height: 0.3em; background-color: rgb(0, 35, 76); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: 0.3em 0px 0px; padding: 0px; max-width: 100%; width: 674px; height: 0.3em; background-color: rgb(0, 35, 76); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section style="margin: 0px; padding: 0px 15px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; line-height: 2.3em; background-color: rgb(0, 35, 76); word-wrap: break-word !important; min-height: 2.3em !important;"><section data-brushtype="text" hm_fix="322:505" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博 | 新豪轩门窗</section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="99188" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px 0px 10px; padding: 0px; max-width: 100%; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 1em 0px -2em -0.5em; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; float: left; width: 1em; height: 1em; border: 1px solid rgb(0, 35, 76); border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 14px; height: 14px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(0, 35, 76); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.8em 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 35, 76); word-wrap: break-word !important;"><section style="margin: 0px 0px 0px 1em; padding: 0px; max-width: 100%; clear: both; text-decoration: inherit; font-family: inherit; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5688073394495413" data-w="436" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabAR5ZAMUhB1u6ibrBGsklia2fzRzeaEAXJniaFh3mt4MZY3rwc8dR9jRQhRYMibMxAibgEh1wss0jKJwg/640" title="351560a9faf1081541f93676e2744966.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/351560a9faf1081541f93676e2744966.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; width: 647px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="351560a9faf1081541f93676e2744966.jpg"/></section><section data-autoskip="1" style="margin: 1em 0px 0px; padding: 0px; max-width: 100%; letter-spacing: 1.5px; line-height: 1.75em; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(65, 65, 65); text-indent: 2em; font-family: " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;</span>&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">佛山市新豪轩门业有限公司，2003年创立于国内门窗品牌之都——佛山，公司致力于为高端用户提供节能、智能、环保的门窗解决方案。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;新豪轩拥有专业性强、效率高的研发团队，并与欧洲门窗相关企业深度紧密合作，引进其先进设备、配件、技术和质检体系。雄厚的技术，使新豪轩门窗隔热、隔音、防水、防风、防撬、气密等性能优越，深受高端用户人群和专业设计机构的青睐，为公司赢得了崇高的荣誉。&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;为了人居环境更加和谐，为了成就共同的光荣与梦想，新豪轩一直秉承“创新•共赢•感恩”的企业精神，向着“铸造匠心门窗，成就世界品牌”的目标努力奋斗。</span></p></section></section></section></section></section></section></section><section data-tools="135编辑器" data-id="99188" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px 0px 10px; padding: 0px; max-width: 100%; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 1em 0px -2em -0.5em; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; float: left; width: 1em; height: 1em; border: 1px solid rgb(0, 35, 76); border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 14px; height: 14px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(0, 35, 76); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.8em 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 35, 76); word-wrap: break-word !important;"><section style="margin: 0px 0px 0px 1em; padding: 0px; max-width: 100%; clear: both; text-decoration: inherit; font-family: inherit; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5688073394495413" data-w="436" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabAR5ZAMUhB1u6ibrBGsklia2iazGictI3B0Hux5vXQQs1fUGsZV86YNuiaILcLb6SVGaNtlfG1ns6zZnw/640" title="4400d4f5ffc2d1760ab275b95dae581f.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4400d4f5ffc2d1760ab275b95dae581f.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; width: 647px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="4400d4f5ffc2d1760ab275b95dae581f.jpg"/></section><section data-autoskip="1" style="margin: 1em 0px 0px; padding: 0px; max-width: 100%; letter-spacing: 1.5px; line-height: 1.75em; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">2020年8月，HOPPE 好博技术交流团队来到了位于广东佛山新豪轩门业有限公司，双方进行了深入的技术研讨与产品交流。现场发言积极，交流高效踊跃。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;新豪轩，扎根南粤，默守耕耘，不忘初心。经过十几年的砥砺前行，旗下已拥有铝合金门窗公司、实木复合门公司、不锈钢门公司。公司目前在佛山市拥有三个生产基地，分别位于南海区狮山镇、南海区丹灶和罗村务庄，总面积达13万平方米，而建设当中的第四个生产基地位于云浮市新兴县，占地面积约为33万平方米。凭借富有竞争力的规模化产业优势，新豪轩成为了国内门窗行业的佼佼者，目前，在国内已经拥有了超过1800家品牌旗舰店，辐射各大城市，每年为数百万户家庭提供可靠而高质量的服务。</span></p></section></section></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="98306" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 674px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; height: 20px; border-top-width: 2px; border-right-width: 2px; border-left-width: 2px; border-style: solid solid none; border-top-color: rgb(0, 35, 76); border-right-color: rgb(0, 35, 76); border-left-color: rgb(0, 35, 76); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-brushtype="text" style="margin: 0px; padding: 10px 1em 6px; max-width: 100%; box-sizing: border-box; background-color: rgb(0, 35, 76); flex: 1 1 0%; color: rgb(255, 255, 255); word-wrap: break-word !important;">HOPPE 好博 技术交流活动</section><section style="margin: 0px; padding: 0px; max-width: 100%; height: 3px; background-color: rgb(0, 35, 76); opacity: 0.3; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 10px; padding: 12px; max-width: 100%; box-sizing: border-box; border-right-width: 2px; border-bottom-width: 2px; border-left-width: 2px; border-style: none solid solid; border-right-color: rgb(0, 35, 76); border-bottom-color: rgb(0, 35, 76); border-left-color: rgb(0, 35, 76); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabAR5ZAMUhB1u6ibrBGsklia2uwqNRl8nDBAZcaSXy8ysJ8jyT0AyyJJTSaJuJiaGAhiagRaRtWkQ6K6w/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5774cd9093f28ee06202473d062d4ddd.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="5774cd9093f28ee06202473d062d4ddd.jpg" alt="5774cd9093f28ee06202473d062d4ddd.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: 微软雅黑, " microsoft="" font-size:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word="">中国区市场部经理Lesley介绍品牌企业历史</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp; 1952年，弗里德里奇·好博(Friedrich Hoppe 音译)先生在德国锁具及五金的传统工业中心地带–杜塞尔多夫(Düsseldorf 音译)附近的小镇黑利根豪斯(Heiligenhaus 音译)创立了本公司。如今, HOPPE 好博集团业务遍及全球,总部设于瑞士。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;凭借着欧美七家工厂、近三千员工和拥有的国际市场，HOPPE 好博成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领导者地位。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5673076923076923" data-w="416" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabAR5ZAMUhB1u6ibrBGsklia2tu9bI1pwk3FuI7p2CfqkBtyTjOvxXfo6A2OdfFXypeTh9Z0cxaZjOg/640" title="cad37aa1ab9acd6624c6bb04b8a037f3.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/cad37aa1ab9acd6624c6bb04b8a037f3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 626px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="cad37aa1ab9acd6624c6bb04b8a037f3.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: 微软雅黑, " microsoft="" font-size:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word="">中国区产品经理Harvey分享产品技术信息</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">60多年来，HOPPE 好博一直在国际领先的门窗幕墙行业中带来其高质量和创新的解决方案。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博出品的门窗把手均为品牌产品，产品本身即是对品质的承诺。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;这些门窗把手可以很好地融入环境氛围，对体现个人室内设计风格起画龙点睛之笔，将“细节体现居住品位”这一理念带到实际生活中。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博把手不仅仅操作门窗的开启和关闭，我们的安全五金和防盗把手可以在锁闭门和窗时提供防盗保护，是有效提升安全性能的部件。有些 HOPPE 好博把手还拥有其他的特殊性能。比如，防火性能，智能化或者具有抗菌/抑菌功能。HOPPE 好博门窗把手使用优质原料在欧洲通过认证的工厂内生产和制作。在 HOPPE 好博，保护环境是必须的，也是基本的原则。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;我们有三种不同产品定位 duravert®, duraplus® 和 duranorm®，这让您更方便地寻找所需产品。产品线按技术、材质、设计和价格进行归类。所有把手具有一个共同点就是“使用 HOPPE 好博——体验卓越品质。”</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; font-family: 微软雅黑, " microsoft="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;所有HOPPE 好博门窗把手产品均享有品牌属性，以强调质量标准。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.28984375" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabupaekB8GYncJWoicUbmEZgFumevXA3GOoojyUJZgWlibPM2QstovaO3otengJ9svvpLEia0TTr8bQw/640?wx_fmt=png" width="677px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/b12069789b656293d3585c1eaae15ff9.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; width: 626px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="b12069789b656293d3585c1eaae15ff9.jpg" alt="b12069789b656293d3585c1eaae15ff9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section data-tools="135编辑器" data-id="99148" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 70px; height: 3px; background-image: -webkit-linear-gradient(left, rgb(113, 197, 232), rgb(0, 35, 76)); flex: 1 1 0%; overflow: hidden; transform: skewX(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 3px 0px 3px 7px; padding: 0px; max-width: 100%; width: 70px; height: 3px; background-image: -webkit-linear-gradient(left, rgb(113, 197, 232), rgb(0, 35, 76)); flex: 1 1 0%; overflow: hidden; transform: skewX(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 14px; padding: 0px; max-width: 100%; width: 70px; height: 3px; background-image: -webkit-linear-gradient(left, rgb(113, 197, 232), rgb(0, 35, 76)); flex: 1 1 0%; overflow: hidden; transform: skewX(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" hm_fix="309:729" style="margin: 0px; padding: 0px 1em; max-width: 100%; box-sizing: border-box; letter-spacing: 2px; font-weight: bold; line-height: 35px; word-wrap: break-word !important;">协进共荣</section><section style="margin: 0px 0px 0px 7px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 70px; height: 3px; background-image: -webkit-linear-gradient(left, rgb(113, 197, 232), rgb(0, 35, 76)); flex: 1 1 0%; overflow: hidden; transform: skewX(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 3px 0px 3px -7px; padding: 0px; max-width: 100%; width: 70px; height: 3px; background-image: -webkit-linear-gradient(left, rgb(113, 197, 232), rgb(0, 35, 76)); flex: 1 1 0%; overflow: hidden; transform: skewX(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px -14px; padding: 0px; max-width: 100%; width: 70px; height: 3px; background-image: -webkit-linear-gradient(left, rgb(113, 197, 232), rgb(0, 35, 76)); flex: 1 1 0%; overflow: hidden; transform: skewX(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66640625" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabAR5ZAMUhB1u6ibrBGsklia2tRibK8JhlJNxY07v2icFcA9icKEjYdXia9eZTkJmCbbFpeyspnpeHVeN1A/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1c6dc47736e4e68ad517b1e0e98795a0.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="1c6dc47736e4e68ad517b1e0e98795a0.jpg" alt="1c6dc47736e4e68ad517b1e0e98795a0.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: 微软雅黑, " microsoft="" font-size:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word="">冯文生总经理带领新豪轩团队与HOPPE 好博团队合影留念</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: justify; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); font-family: 微软雅黑, " microsoft="" box-sizing:="" border-box="" word-wrap:="" break-word="">&nbsp;&nbsp;&nbsp;&nbsp;此次技术交流会中，新豪轩团队在冯总的带领下与HOPPE 好博共同探讨了门窗市场行业动态、新品趋势与研发方向等切实话题。通过面对面交流，关于HOPPE 好博产品在实际使用中遇到的技术疑问和安装问题，HOPPE 好博技术团队给予了直接快速的回答，通过此次交流会，旨在更高效的解决应用问题，倾听客户反馈。</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p></section></section></section><p><br/></p><p style=";text-align: justify;font-size: 14px;font-family: Calibri, sans-serif;white-space: normal"><br/></p><p><br/></p>', 1, 0, 0, '2020-08-24', '2020-09-08 17:46:35'),
	(31, 'HOPPE 好博 eHandle荣获中国门窗幕墙创新·星品奖', '/upload/home/news/674ccffb7ce28d8ddb0f11613208ca62.jpg', '<p><br/></p><p><br/></p><p></p><section label="Edit by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="99504" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; align-items: flex-end; flex-direction: column; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 6px 1em; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; background-color: rgb(113, 197, 232); word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;">第26届WINDOOR</strong><span style="margin: 0px; padding: 0px; max-width: 100%; font-weight: normal; font-size: 14px; letter-spacing: 0.6217142939567566px; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;">门窗幕墙新品展</span></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; height: 1px; border-top-width: 10px; border-top-style: solid; border-top-color: rgb(113, 197, 232); border-right-width: 10px; border-right-style: solid; border-right-color: transparent; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section style="margin: -30px 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 664px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6673913043478261" data-w="460" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaa5icTKibjpnLzn5AVdUE4o7jvzae29UYdia7YOE0YULG024XyicXyCn6kTTXntWcEHu4SqbCic9gRw1pg/640" title="674ccffb7ce28d8ddb0f11613208ca62.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/674ccffb7ce28d8ddb0f11613208ca62.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 664px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="674ccffb7ce28d8ddb0f11613208ca62.jpg"/></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; text-indent: 32px; box-sizing: border-box !important; word-wrap: break-word !important;">8月13日</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; box-sizing: border-box !important; word-wrap: break-word !important;">，</span><strong style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; box-sizing: border-box !important; word-wrap: break-word !important;">「WINDOOR</strong><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; box-sizing: border-box !important; word-wrap: break-word !important;">门窗幕墙新品展</span><strong style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">」</span></strong><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; box-sizing: border-box !important; word-wrap: break-word !important;">在</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 0.6217142939567566px; text-indent: 32px; box-sizing: border-box !important; word-wrap: break-word !important;">广州·保利世贸博览馆、南丰国际会展中心盛大开幕。<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2020年，门窗行业受到疫情的波动和影响，但这丝毫没能影响业内人士对HOPPE 好博品牌及新品</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">的热情，大家依然更加倾向近距离的直面交流，HOPPE 好博的展位前人头攒动。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="99496" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="32%" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 215.671875px; height: 80px; border: 2px solid rgb(0, 35, 76); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: -10px 0px 0px -35px; padding: 0px 1em 10px 0em; max-width: 100%; font-size: 30px; font-weight: bold; color: rgb(0, 35, 76); background-color: rgb(113, 197, 232); align-self: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博</span></section><section data-brushtype="text" style="margin: 20px 0px 0px -100px; padding: 4px 1em; max-width: 100%; font-weight: bold; letter-spacing: 1.5px; align-self: center; background-color: rgb(0, 35, 76); color: rgb(113, 197, 232); box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">eHandle荣获年度星品奖</span></section></section></section></section><section data-tools="135编辑器" data-id="99511" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 3px 0px 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 20px 0px 13px; padding: 0px; max-width: 100%; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 638px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5630841121495327" data-w="428" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaa5icTKibjpnLzn5AVdUE4o7j4mZM8pka5gamK1Nd8oTc7fxVKtlbFEd5vIpwib8icvJjKcQBorgHRmfg/640" title="e6b34141bc619e5d11ad222dd4fb8043.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e6b34141bc619e5d11ad222dd4fb8043.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 638px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="e6b34141bc619e5d11ad222dd4fb8043.jpg"/></section></section><section style="margin: -90px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; align-items: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="60%" style="margin: 0px 7px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 402.59375px; height: 100px; border: 2px solid rgb(0, 35, 76); overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="99515" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto 12px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 15px 0px 0px; max-width: 100%; border-bottom-width: 2px; border-bottom-style: solid; border-bottom-color: rgb(0, 32, 96); transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; align-items: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px -35px 17px; padding: 0px; max-width: 100%; width: 2px; height: 35px; background-color: rgb(0, 32, 96); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 1em 15px 2em; max-width: 100%; box-sizing: border-box; border-left-width: 2px; border-left-style: solid; border-left-color: rgb(0, 32, 96); border-top-width: 2px; border-top-style: solid; border-top-color: rgb(0, 32, 96); word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px; max-width: 100%; font-weight: bold; letter-spacing: 1.5px; color: rgb(0, 32, 96); box-sizing: border-box !important; word-wrap: break-word !important;">eHandle入户门感应开启</section></section></section></section></section></section><section data-brushtype="text" style="margin: -60px 0px 0px; padding: 0px; max-width: 100%; letter-spacing: 1.5px; color: rgb(198, 217, 240); font-size: 35px; font-weight: bold; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博</section></section></section><section data-tools="135编辑器" data-id="99501" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 664px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.7929515418502202" data-w="454" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaa5icTKibjpnLzn5AVdUE4o7jGH1IHEpx9D8P8IJMiczIlfHozlPkBnh13E7HvN42lsic0fzia3zA2IWYA/640" title="caa59521d6ab9be45bc7f28801fa8402.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/caa59521d6ab9be45bc7f28801fa8402.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 664px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="caa59521d6ab9be45bc7f28801fa8402.jpg"/></section><section style="margin: -35px 0px 0px; padding: 3em 2em; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">eHandle入户门感应开启</span></strong><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博入户门 eHandle 感应开启技术让您无需停下手上繁忙的业务也可以轻松开门。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages __bg_gif " data-ratio="1.78" data-type="gif" data-w="200" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZu238uoOegiaGHPHZRdowKWiaPd3FS1qHW14YA7UeE8yqF3U7Z8FgWwyg/640?wx_fmt=gif" width="200px" _width="200px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZu238uoOegiaGHPHZRdowKWiaPd3FS1qHW14YA7UeE8yqF3U7Z8FgWwyg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 200px !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">房屋主人只要靠近门，大拉手就会接收到无线钥匙发出的加密信号。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">然后，大拉手底部的射灯会自动亮起，说明房屋主人被允许进入房间。房屋主人只需用脚扫过射灯的光线，门便会自动开启，简单方便，无需触碰。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); font-size: 17px; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-backh="1073" data-backw="716" data-ratio="1.4987298899237933" data-s="300,640" data-type="jpeg" data-w="1181" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaajKibJdQEALhdRzHzvKJEVbMZ3lculJ3COyLiaetruibqmPkojpInS0glrESWKQMSgVcc5czkcw3Hyw/640?wx_fmt=jpeg" width="677px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/d881e0c16ca0b9c3a20e6b3b5843cb791.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; font-weight: normal; width: 600px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="d881e0c16ca0b9c3a20e6b3b5843cb791.jpg" alt="d881e0c16ca0b9c3a20e6b3b5843cb79.jpg"/></span></strong></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">内置的安全功能可防止您无意中在室内打开门锁。您可以根据不同的地面颜色切换光束的颜色，以确保其清晰可见。控制单元位于室内部分。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages __bg_gif " data-ratio="0.7875457875457875" data-s="300,640" data-type="gif" data-w="1092" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNk7aey8ibXd2qqgmibQKCg6yTVTVN6gibZxODYFiaNHNO1uJPicandTo6dB2Q/640?wx_fmt=gif" width="383px" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNk7aey8ibXd2qqgmibQKCg6yTVTVN6gibZxODYFiaNHNO1uJPicandTo6dB2Q/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; width: 600px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages" data-croporisrc="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNksDyepIOx6377iaWlnPsby1C2UsApCpwrbhmTCZR1PHORDoXMlblOg4g/640?wx_fmt=png" data-cropx1="600.5017421602788" data-cropx2="1002" data-cropy1="0" data-cropy2="50.623693379790936" data-ratio="0.12437810945273632" data-s="300,640" data-type="jpeg" data-w="402" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZvBibDDY3Sw6gOOnJJCRoj4jZbW0lAF03zb3HeBTzC03Bc2lQdq3ZTbg/640?wx_fmt=jpeg" width="151px" _width="151px" src="https://hoppe.jzdsh.com/upload/ue/img/04c5284762a0fbf0d209bc39511e78491.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 151px !important;" title="04c5284762a0fbf0d209bc39511e78491.jpg" alt="04c5284762a0fbf0d209bc39511e7849.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">射灯可根据地面颜色切换4种色彩模式</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">技术参数</span></p><section data-role="list" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博大拉手型号 E5095GC</span></p><ul class=" list-paddingleft-2" style="padding-top: 0px; padding-right: 0px; padding-bottom: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">可以搭配任何型号的电子锁</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">可设定高达 500 个无线钥匙</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">感应距离：大约 1 m</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">大拉手安装高度：离地 20 cm 到 50 cm 之间</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">可选长度：100 cm; 120 cm; 140 cm; 160 cm</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">射灯颜色有白色，蓝色，绿色，红色可选</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">防护等级：IP 44</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></li></ul></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 0.544px; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="jpeg" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=jpeg" width="677px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/cd8b22165f63597fdd57d1a013bc7b092.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; width: 674px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; overflow-wrap: break-word !important; visibility: visible !important;" title="cd8b22165f63597fdd57d1a013bc7b092.jpg" alt="cd8b22165f63597fdd57d1a013bc7b09.jpg"/></p></section></section></section></section><p></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-08-15', '2020-09-08 17:58:22'),
	(32, 'HOPPE 好博 x 中环家居', '/upload/home/news/WX20200908-180332@2x.png', '<p><br/></p><p><br/></p><section label="Edit by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" font-size:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20200908-180439@2x.png" title="WX20200908-180439@2x.png" alt="WX20200908-180439@2x.png"/></p></section><section data-tools="135编辑器" data-id="99373" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 20px; height: 20px; background-image: -webkit-linear-gradient(right, rgb(113, 197, 232), rgb(244, 246, 255)); flex-shrink: 0; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 18px 0px 0px -4px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(82, 127, 255)); flex-shrink: 0; overflow: hidden; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; align-self: flex-end; color: rgb(0, 35, 76); word-wrap: break-word !important;">HOPPE 好博</section></section><section data-autoskip="1" style="margin: 0px 0px 0px 20px; padding: 1em; max-width: 100%; box-sizing: border-box; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 35, 76); color: rgb(66, 66, 66); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博于1952年在德国创立，专注执手领域68年。如今，HOPPE 好博集团业务遍及全球，总部设于瑞士。凭借着欧美七家工厂、近三千员工和拥有的国际市场，HOPPE 好博成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领导者。&nbsp;</p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 20px; height: 20px; background-image: -webkit-linear-gradient(right, rgb(113, 197, 232), rgb(244, 246, 255)); flex-shrink: 0; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 18px 0px 0px -4px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(82, 127, 255)); flex-shrink: 0; overflow: hidden; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; align-self: flex-end; color: rgb(0, 35, 76); word-wrap: break-word !important;">Central Link Home 中环家居</section></section><section data-autoskip="1" style="margin: 0px 0px 0px 20px; padding: 1em; max-width: 100%; box-sizing: border-box; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 35, 76); color: rgb(66, 66, 66); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">常州中环家居是一家多元化发展的公司，专业专注高端家居品牌服务十二年。中环家居甄选国内外知名家居品牌，旗下有20多个国内外知名家居品牌，将整体木作，进口橱柜，衣柜，家具及家电整合，为常州精英阶层定制专业的、与国际时尚接轨的整体家居设计理念与产品。&nbsp;</p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 20px; height: 20px; background-image: -webkit-linear-gradient(right, rgb(113, 197, 232), rgb(244, 246, 255)); flex-shrink: 0; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 18px 0px 0px -4px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(82, 127, 255)); flex-shrink: 0; overflow: hidden; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; align-self: flex-end; color: rgb(0, 35, 76); word-wrap: break-word !important;">品牌交流设计师分享会</section></section><section data-autoskip="1" style="margin: 0px 0px 0px 20px; padding: 1em; max-width: 100%; box-sizing: border-box; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 35, 76); color: rgb(66, 66, 66); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">8月10日，HOPPE 好博团队来到了常州，与中环家居的设计师们深入交流品牌调性并共同探讨了在家装领域的产品搭配与设计心得。</p></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="99374" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 8px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 1 1 0%; align-self: flex-end; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 15px; height: 15px; background-image: -webkit-linear-gradient(right, rgb(113, 197, 232), rgb(244, 246, 255)); flex-shrink: 0; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 18px 0px 0px -4px; padding: 0px; max-width: 100%; width: 7px; height: 7px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); flex-shrink: 0; overflow: hidden; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" style="margin: 0px; padding: 0px 8px; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; color: rgb(0, 35, 76); word-wrap: break-word !important;">HOPPE 好博</section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 1 1 0%; word-wrap: break-word !important;"><section data-width="80%" style="margin: 0px; padding: 0px; max-width: 100%; height: 1px; width: 224.125px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="30%" style="margin: 3px 0px 0px; padding: 0px; max-width: 100%; height: 1px; width: 84.046875px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section data-autoskip="1" style="margin: 0px; padding: 6px 0px; max-width: 100%; box-sizing: border-box; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(0, 35, 76); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">中国区市场部经理 Lesley</p></section></section><section data-width="35%" style="margin: 0px 0px 0px 10px; padding: 0px; max-width: 100%; width: 230.296875px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-w="156" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32b1tILoVBohGtzZPJrcWfsS0iaWtVibVXDCEfrksYKia3GjOggTKZBMDaPA/640" title="4e0f77afed04d8dda74f609348488998.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4e0f77afed04d8dda74f609348488998.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 230.296875px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="4e0f77afed04d8dda74f609348488998.jpg"/></section></section><section data-autoskip="1" style="margin: 10px auto; padding: 0px; max-width: 100%; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(43, 43, 43); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">作为活动开场，Lesley向大家介绍了HOPPE 好博的品牌历史，公司文化以及产品的生产工艺特色。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bkSZy0dN7AWrd46pn0nYRB1aviaaVcXgyJAibhlicZf8fcJQFKFE6pehWg/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/10e9419ae1de47d08c36ed4280a4c60e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="10e9419ae1de47d08c36ed4280a4c60e.jpg" alt="10e9419ae1de47d08c36ed4280a4c60e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">无论是何种风格,出自欧洲设计师之手的 HOPPE 好博产品,都是专业人士的首选。从我们琳琅满目、风格各异、材质多样（铝合金、不锈钢、尼龙、黄铜）的门窗五金中选择,从入户门、室内门到窗户上彰显出使用者独特的风格和气质。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.5" data-w="1080" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32b4XF4y1uVxvZ6BfsicR4yrBZAoxXvD59iagCFajsmWzOofZESMT9SibX1g/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f7e369fe737e3e3abdc92ec30a4c4437.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="f7e369fe737e3e3abdc92ec30a4c4437.jpg" alt="f7e369fe737e3e3abdc92ec30a4c4437.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博极为注重环保,始终不遗余力地将环保措施推行到各个环节:</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 环保五金生产工艺</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 废水回收并通过工厂的水循环系统再用于生产用水</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 环保包装材料</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 可重复利用的废料作辅料内部循环再用</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 利用工艺过程产生的热能</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 可替代能源</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• 提高能源利用率</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">• “黑森州环境联盟”成员</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博集团在德国、意大利及捷克的所有生产工厂均通过了 DIN EN ISO 14001: 2009(环境管理体系)认证。自2014年起,德国施塔特阿伦多夫的</span><br style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE AG 获得了 DIN EN ISO50001:2011 (能源管理系统) 认证。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6648148148148149" data-w="1080" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32buOJe3GxNMaiccKZqsiblDQadN6yytTqaFcGV99Hib3AoVU8QJkArJ04Cg/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/22253e25ff4936885ed5e291fcbbd390.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="22253e25ff4936885ed5e291fcbbd390.jpg" alt="22253e25ff4936885ed5e291fcbbd390.jpg"/></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: center; transform: rotateZ(-180deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 648.15625px; height: 1px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="99374" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 8px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 1 1 0%; align-self: flex-end; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 15px; height: 15px; background-image: -webkit-linear-gradient(right, rgb(113, 197, 232), rgb(244, 246, 255)); flex-shrink: 0; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 18px 0px 0px -4px; padding: 0px; max-width: 100%; width: 7px; height: 7px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); flex-shrink: 0; overflow: hidden; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" style="margin: 0px; padding: 0px 8px; max-width: 100%; box-sizing: border-box; font-weight: bold; letter-spacing: 1.5px; color: rgb(0, 35, 76); word-wrap: break-word !important;">HOPPE 好博</section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 1 1 0%; word-wrap: break-word !important;"><section data-width="80%" style="margin: 0px; padding: 0px; max-width: 100%; height: 1px; width: 224.125px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="30%" style="margin: 3px 0px 0px; padding: 0px; max-width: 100%; height: 1px; width: 84.046875px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section data-autoskip="1" style="margin: 0px; padding: 6px 0px; max-width: 100%; box-sizing: border-box; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(0, 35, 76); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">中国区零售部负责人 Bruce</p></section></section><section data-width="35%" style="margin: 0px 0px 0px 10px; padding: 0px; max-width: 100%; width: 230.296875px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-w="156" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bT0FRswk1LNnGYQ3SUpHuEfZTBPy4sg1fibd2KQwZPj8ub7WbRBLVpHg/640" title="7309207d11f1fa7a2dc4e27c36f54eeb.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7309207d11f1fa7a2dc4e27c36f54eeb.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 230.296875px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="7309207d11f1fa7a2dc4e27c36f54eeb.jpg"/></section></section><section data-autoskip="1" style="margin: 10px auto; padding: 0px; max-width: 100%; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(43, 43, 43); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">在设计师们对HOPPE 好博品牌文化了解后，Bruce给大家带来了更加深入的关于产品本身的探讨。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="448" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bytxaOaYlBiblwzaP1ccGA6wKTAyLTxJUm9sPpQuTUK6h9WuRo0Uoxkg/640" title="6b4cff4e75a0d723c9c3c65bc94a9820.jpg" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6b4cff4e75a0d723c9c3c65bc94a9820.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" alt="6b4cff4e75a0d723c9c3c65bc94a9820.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">对于每位注重生活品质、致力使自己的室内设计更趋完美的人来说, HOPPE 好博这一欧洲门窗行业首屈一指的领导品牌,以其物超所值的高品质产品,必能更加彰显用户的居住品位。&nbsp;</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bftCcfFOIvWOwISUWTBfxz9OFWhufhr4FuDBIeywpbHsUFWciaLxrTBg/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/9b7f7089af9761446543dcea99a244f3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="9b7f7089af9761446543dcea99a244f3.jpg" alt="9b7f7089af9761446543dcea99a244f3.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); box-sizing: border-box !important; word-wrap: break-word !important;">所有 HOPPE 好博门窗把手均享有10 年使用保证，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); box-sizing: border-box !important; word-wrap: break-word !important;">无数次针对耐用性和静态撞击的随机检测</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); box-sizing: border-box !important; word-wrap: break-word !important;">旨在尽可能真实地反映出门窗把手在“日常生活”中使用时受撞击的状态。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/>• 在真正的门窗上进行的检测：不仅是产品本身的操作性能，同时其与门窗五金件配合后的耐用性也得到了检测<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/>• 大大高于 DIN EN 1906 和RAL-GZ 607/9 标准中的耐用性测试所要求的操作次数<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/>• HOPPE 好博的 10 年机械功能质保远远超出了欧洲法定的2年</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6657407407407407" data-w="1080" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bCgIqMJvkQ1ibGW6RouuZjwgIHxy37PlAO2HTqSLdm2tFld9ESJS8pjw/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/375056087d71399f3839c659f7046138.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="375056087d71399f3839c659f7046138.jpg" alt="375056087d71399f3839c659f7046138.jpg"/></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: center; transform: rotateZ(-180deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 648.15625px; height: 1px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="paragraph" style="white-space: normal; margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><p></p><section data-tools="135编辑器" data-id="99378" style="white-space: normal; margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 0px 80px; max-width: 100%; box-sizing: border-box; display: flex; overflow: hidden; word-wrap: break-word !important;"><section data-width="50%" style="margin: 0px 15px 0px 10px; padding: 0px; max-width: 100%; width: 312px; background-color: rgb(244, 244, 255); text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; height: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 45px -15px -65px 15px; padding: 0px; max-width: 100%; font-size: 14px; letter-spacing: 1.5px; color: rgb(0, 35, 76); display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"></section></section><section data-width="100%" style="margin: 80px -15px -80px 15px; padding: 0px; max-width: 100%; width: 312px; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1200" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bpvYulHDYO6FmxmmTPg8icGQicRQ1QC6jPJrjzfIv6ToAto4DMAzibQh6w/640" title="e918602c26d30566cd6121d4e76ef7d0.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e918602c26d30566cd6121d4e76ef7d0.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 312px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="e918602c26d30566cd6121d4e76ef7d0.jpg"/></section></section><section data-width="50%" style="margin: 0px 10px -80px 15px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 312px; display: flex; justify-content: center; align-items: center; height: auto; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; flex: 1 1 0%; width: 312px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 312px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.3333333333333333" data-w="900" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bPs6dcmLEAEkmWTqEtPibmHWtYgufVZovouvDC8OLOfz383PtLn05W8g/640" title="b3c6a7fd7badcafe12d22ab9b2e1e012.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/b3c6a7fd7badcafe12d22ab9b2e1e012.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 312px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="b3c6a7fd7badcafe12d22ab9b2e1e012.jpg"/></section><section data-width="98%" style="margin: 0px auto; padding: 0px; max-width: 100%; width: 305.75px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 25px 0px 0px; padding: 0px; max-width: 100%; height: 1px; background-image: linear-gradient(to right, rgb(113, 197, 232), rgb(0, 35, 76)); width: 305.75px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; height: 1px; background-image: linear-gradient(to right, rgb(113, 197, 232), rgb(0, 35, 76)); width: 305.75px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; height: 1px; background-image: linear-gradient(to right, rgb(113, 197, 232), rgb(0, 35, 76)); width: 305.75px; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section></section></section><section data-role="paragraph" style="white-space: normal; margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="99380" style="white-space: normal; margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; align-items: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 472.859375px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1200" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bEKuxmRfNuciaA4pgSgDkwgM51PMX8SAhIm9COGib0L2T3xVRMDCYXFhg/640" title="09dbd5af9932b93ac2ba95b202e69988.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/09dbd5af9932b93ac2ba95b202e69988.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 472.859375px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="09dbd5af9932b93ac2ba95b202e69988.jpg"/></section><section data-width="40%" style="margin: 0px 0px 0px 12px; padding: 0px; max-width: 100%; width: 189.140625px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.3333333333333333" data-w="900" data-width="100%" height="171" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bcRNQpwX8vRr68npRl0ns77icTK53YIgckXTUhLZz8jyNQKBGpJicX8Vg/640" title="bc301efe2c2cf901799c0a0902e07d30.jpg" width="129" _width="129px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/bc301efe2c2cf901799c0a0902e07d30.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 129px !important; visibility: visible !important;" alt="bc301efe2c2cf901799c0a0902e07d30.jpg"/></section></section><section style="margin: 12px 45px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; align-items: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 201.671875px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1200" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bT0FRswk1LNnGYQ3SUpHuEfZTBPy4sg1fibd2KQwZPj8ub7WbRBLVpHg/640" title="7309207d11f1fa7a2dc4e27c36f54eeb1.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7309207d11f1fa7a2dc4e27c36f54eeb1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 201.671875px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="7309207d11f1fa7a2dc4e27c36f54eeb.jpg"/></section><section data-width="100%" style="margin: 0px 12px; padding: 0px; max-width: 100%; width: 201.671875px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1200" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bJgXRsQtEE4wKVIwJLeWLUqibUQYibogOa3vcWCb5VV06ibDad48OOjqvA/640" title="ca67eec09c63ca0672ffeb216923667e.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ca67eec09c63ca0672ffeb216923667e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 201.671875px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="ca67eec09c63ca0672ffeb216923667e.jpg"/></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 201.671875px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-w="1280" data-width="100%" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabQ44zSWk8mQXr0ic8h0F32bkSZy0dN7AWrd46pn0nYRB1aviaaVcXgyJAibhlicZf8fcJQFKFE6pehWg/640" title="10e9419ae1de47d08c36ed4280a4c60e1.jpg" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/10e9419ae1de47d08c36ed4280a4c60e1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 201.671875px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" alt="10e9419ae1de47d08c36ed4280a4c60e.jpg"/></section></section><section style="margin: 12px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 649px; height: 1px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 10px; height: 10px; background-image: -webkit-linear-gradient(right, rgb(0, 35, 76), rgb(113, 197, 232)); flex-shrink: 0; overflow: hidden; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: -20px 0px 0px -5px; padding: 0px; max-width: 100%; width: 20px; height: 20px; background-image: -webkit-linear-gradient(right, rgb(113, 197, 232), rgb(244, 246, 255)); flex-shrink: 0; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section><section data-role="paragraph" style="white-space: normal; margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p></section><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br/></p></section></section></section>', 1, 0, 0, '2020-08-12', '2020-09-08 18:23:35'),
	(34, '2020第五届中国大定制家居营销发展论坛', '/upload/home/news/dd96c01a0f29b26a0606e2f781a87c96.jpg', '<p><br/></p><p><br/></p><p><br/></p><section data-tools="135编辑器" data-id="98494" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 6px; max-width: 100%; box-sizing: border-box; border: 2px solid rgb(0, 35, 76); word-wrap: break-word !important;"><section style="margin: 0px; padding: 1em 5px; max-width: 100%; box-sizing: border-box; background-color: rgb(255, 255, 255); color: rgb(51, 51, 51); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 6px; border-left-style: solid; border-left-color: rgb(0, 35, 76); border-right-width: 6px; border-right-style: solid; border-right-color: rgb(0, 35, 76); text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 28px; letter-spacing: 2px; color: rgb(62, 65, 72); font-weight: bold; box-sizing: border-box !important; word-wrap: break-word !important;">大定制家居发展论坛</section><section data-brushtype="text" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; letter-spacing: 1.5px; color: rgb(62, 65, 72); box-sizing: border-box !important; word-wrap: break-word !important;">金菠萝颁奖典礼</section></section><section data-width="100%" style="margin: 1em 0px; padding: 0px; max-width: 100%; width: 758px; height: 1px; background-color: rgb(0, 35, 76); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-autoskip="1" style="margin: 0px; padding: 1em 1em 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; letter-spacing: 1.5px; line-height: 1.75em; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(178, 178, 178); font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66640625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBWq8mjLPWk0iabF8Aib39AAOyiaYkkwQsjtQd1Ad3IJfmFYXheU1vkJebw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/73cdfafa6feab87ec72be77e79c35f35.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="73cdfafa6feab87ec72be77e79c35f35.jpg" alt="73cdfafa6feab87ec72be77e79c35f35.jpg"/><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66953125" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBn8vFVCATia5JoicCBJYdxN8cGETByfCOJqAzx2etTYMxAldkMB5fdOtQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a8cb9f4d2755ed4a7c53b541ecde922d.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="a8cb9f4d2755ed4a7c53b541ecde922d.jpg" alt="a8cb9f4d2755ed4a7c53b541ecde922d.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2020年7月10日，由中国建博会（广州）、慧亚传媒、菠萝家联合举办的2020第五届中国大定制家居营销发展论坛暨家居品牌金菠萝奖颁奖典礼于琶洲展馆B区8号会议室盛大举行。</span><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBrwkdH6tUVeDpibO1Bdbzl0InVZUIufMBDVyEmvMSNshP16rVBBWOJOA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" title="e514b549f31051609a992a6097d0cf65.jpg" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e514b549f31051609a992a6097d0cf65.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" alt="e514b549f31051609a992a6097d0cf65.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibB1jyhL9jV8vbUhPIeQ41iaqSTpgApuG7KHribOMZhxqOdJdBmYfAr0D7w/640?wx_fmt=jpeg" data-type="jpeg" data-w="1200" title="03b5f8d3bbe111412fbeb7ccce705421.jpg" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/03b5f8d3bbe111412fbeb7ccce705421.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" alt="03b5f8d3bbe111412fbeb7ccce705421.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博作为支持单位出席，共同聚焦门窗与全屋定制家装行业发展前景！</span><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;">并现场播放了</span><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;">SecuSan®抗菌把手的宣传视频，反响强烈。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(51, 46, 46); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 0px 1em; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 30px; border-left-style: solid; border-left-color: rgb(0, 35, 76); display: inline-block; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; box-sizing: border-box; font-size: 35px; letter-spacing: 1.5px; font-weight: bold; word-wrap: break-word !important;">金菠萝奖颁奖</section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; box-sizing: border-box; font-size: 12px; letter-spacing: 1.5px; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 6px; padding: 0px; max-width: 100%; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 30px; height: 1px; background-color: rgb(0, 35, 76); float: right; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="90%" style="margin: 5px 0px 0px; padding: 0px; max-width: 100%; width: 191.6875px; height: 1px; background-color: rgb(0, 35, 76); clear: both; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 6px 0px 0px; padding: 1em; max-width: 100%; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6666666666666666" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibB7tz5vsxlzjjTccyvBTY5Fe3UKOSfJIG93DwUTPr3qfsqZ3EzAklugg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1200" title="fd0abdbec12461bf4a577b3465540b54.jpg" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/fd0abdbec12461bf4a577b3465540b54.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" alt="fd0abdbec12461bf4a577b3465540b54.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6666666666666666" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBaI2LyTqCKuc9DCibyenW2zVkQ7ibW4t6uQt338AY5lH9nqKp4hzYkS8A/640?wx_fmt=jpeg" data-type="jpeg" data-w="1200" title="dd96c01a0f29b26a0606e2f781a87c96.jpg" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/dd96c01a0f29b26a0606e2f781a87c96.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" alt="dd96c01a0f29b26a0606e2f781a87c96.jpg"/></p></section><section style="margin: -120px 0px 0px; padding: 100px 0px 0px; max-width: 100%; box-sizing: border-box; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; font-size: 14px; letter-spacing: 1.5px; line-height: 1.75em; border-bottom-width: 2px; border-bottom-style: solid; border-bottom-color: rgb(0, 35, 76); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.4612159329140462" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBZwWuFhIUVGtasJib0DjGwyhmvIRwooKoBZpPSNoXswlXMnPMBvBmqBg/640?wx_fmt=png" data-type="png" data-w="954" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/7c391c81386a0524162aafa47c37d2b6.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="7c391c81386a0524162aafa47c37d2b6.jpg" alt="7c391c81386a0524162aafa47c37d2b6.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; font-size: 12px; color: rgb(178, 178, 178); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博荣获门窗行业“金牌供应商”奖</span></p></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="98492" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 1em; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 30px; border-left-style: solid; border-left-color: rgb(0, 35, 76); display: inline-block; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; box-sizing: border-box; font-size: 35px; letter-spacing: 1.5px; color: rgb(51, 51, 51); font-weight: bold; word-wrap: break-word !important;">授牌仪式</section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; box-sizing: border-box; font-size: 12px; letter-spacing: 1.5px; color: rgb(51, 51, 51); word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 0px 0px 6px; padding: 0px; max-width: 100%; flex: 1 1 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 30px; height: 1px; background-color: rgb(0, 35, 76); float: right; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="90%" style="margin: 5px 0px 0px; padding: 0px; max-width: 100%; width: 126px; height: 1px; background-color: rgb(0, 35, 76); clear: both; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66953125" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibB16OTCoRtPvzBNCJddkvc27DFR1epibLRQF20T1u6tTFQfekhDPQFHfQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e21c86811961ffd3d0edfd60c4a06fe3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="e21c86811961ffd3d0edfd60c4a06fe3.jpg" alt="e21c86811961ffd3d0edfd60c4a06fe3.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 15px; letter-spacing: 1.5px; text-align: justify; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">在2020年这样特殊的时期下，全国定制和门窗的经销商大会再度启航，慧亚传媒董事长黄金荣先生表示慧亚传媒的服务内容进行了调整，减少企业受到疫情的影响，同时预测了家居行业下一步的竞争趋势将在育商渠道数据化的建设。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6069767441860465" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBNlPTBtKrKZfFTPL9xRCkxqtwuI4spGRd68zFzAjCQ2aTfqJBTNSS8w/640?wx_fmt=jpeg" data-type="jpeg" data-w="430" data-width="100%" title="37716550881c12c244374b406f5c75c4.jpg" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/37716550881c12c244374b406f5c75c4.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" alt="37716550881c12c244374b406f5c75c4.jpg"/><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1.5px; text-align: justify; background-color: rgb(255, 255, 255); font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; font-size: 12px; color: rgb(178, 178, 178); box-sizing: border-box !important; word-wrap: break-word !important;">慧亚传媒董事长黄金荣为支持单位—HOPPE好博授牌</span></p><section data-tools="135编辑器" data-id="98492" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: -120px 0px 0px; padding: 100px 0px 0px; max-width: 100%; box-sizing: border-box; background-color: rgb(255, 255, 255); color: rgb(51, 51, 51); word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; letter-spacing: 1.5px; line-height: 1.75em; border-bottom-width: 2px; border-bottom-style: solid; border-bottom-color: rgb(0, 35, 76); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(51, 46, 46); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 15px; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p></section></section></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><section data-tools="135编辑器" data-id="98492" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: -120px 0px 0px; padding: 100px 0px 0px; max-width: 100%; box-sizing: border-box; background-color: rgb(255, 255, 255); color: rgb(51, 51, 51); word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; letter-spacing: 1.5px; line-height: 1.75em; border-bottom-width: 2px; border-bottom-style: solid; border-bottom-color: rgb(0, 35, 76); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.66953125" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBR51W6ecymkqErkeAwQpH5NCjvqonJFb0oiadpys9eRZFFUib0T5eZsuQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/62da1bb613b955c49ba87bf433cdb015.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="62da1bb613b955c49ba87bf433cdb015.jpg" alt="62da1bb613b955c49ba87bf433cdb015.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span data-ratio="1.7666666666666666" id="js_tx_video_container_0.24472333240532862" class="js_tx_video_container" style="margin: 0px; padding: 0px; max-width: 100%; display: block; width: 646px; height: 376px; box-sizing: border-box !important; word-wrap: break-word !important;"><iframe frameborder="0" width="646" height="363.375" allow="autoplay; fullscreen" allowfullscreen="true" src="https://v.qq.com/txp/iframe/player.html?origin=https%3A%2F%2Fmp.weixin.qq.com&chid=17&vid=q1347bqwgzh&autoplay=false&full=true&show1080p=false&isDebugIframe=false" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"></iframe></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博推出的SecuSan® 为杀菌、抗菌功能的表面处理，它可以应用在多种门、窗把手表面。SecuSan® 系列抗菌、杀菌门、窗把手材质以铝合金和不锈钢最为常见。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.61875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBiah628BLI25mxjCuyA3IOmjq1W7lpmkibNMAwmMVwproxBcicMK5OfadQ/640?wx_fmt=png" data-type="png" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/445202d6b1cd890b79e4a62a2f7ae8b9.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="445202d6b1cd890b79e4a62a2f7ae8b9.jpg" alt="445202d6b1cd890b79e4a62a2f7ae8b9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;">SecuSan® 表面为银离子涂层，其涂层颗粒细密均匀，有种特别精密的质感。当触摸把手的时候，是非常光滑细腻的手感。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.7328125" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBicoEjn4Zf2NjNWRvxoQLibk4iaGxn8QlQZOomRjGibW35UKCQYbHcPg8lA/640?wx_fmt=png" data-type="png" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/17fab00b42294d15c9508f8ac2677aa3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="17fab00b42294d15c9508f8ac2677aa3.jpg" alt="17fab00b42294d15c9508f8ac2677aa3.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;">当其表面附着细菌量很多时，其表面涂层中的银离子就会破坏病菌、细菌的细胞膜，阻断细胞的呼吸和营养吸收，从而阻止病菌、细菌的细胞分裂，生长导致其死亡。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.7046875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBkAtlcafgSmbib3QNicRet8MHcp8ibUVen71XQGLxQOv0vf8hqPx16ibIIQ/640?wx_fmt=png" data-type="png" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/06104c5e7f5ddc554b1eec35236567c3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="06104c5e7f5ddc554b1eec35236567c3.jpg" alt="06104c5e7f5ddc554b1eec35236567c3.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); box-sizing: border-box !important; word-wrap: break-word !important;">把手依据日本工业标准 JISZ 2801:2000 和国际标准 ISO 22196：2011 进行测试，24 小时内</span><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; caret-color: rgb(51, 46, 46); color: rgb(51, 46, 46); box-sizing: border-box !important; word-wrap: break-word !important;">细菌量至少减少 99.9%。通过对 K12 大肠杆菌消除对比测试，5 分钟后该菌减少系数达到 60%。6 小时基本被消除，而在没有表面抗菌涂层的情况下，细菌没有显著减少。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.719676549865229" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBcfNM9sKGnm4jdCQQMISe1bkfGL5uy6cRqiczgMxfOY8WLPiaRTkY91Rg/640?wx_fmt=png" data-type="png" data-w="742" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/18d33f2a22941af1f8fdee44b6bea42e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="18d33f2a22941af1f8fdee44b6bea42e.jpg" alt="18d33f2a22941af1f8fdee44b6bea42e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(51, 46, 46); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博把手外观简洁大方，融入了品牌低调务实的理念，把手能适合多种装修风格，门、窗把手在医院、学校、护理机构、幼儿园等公共领域都有很好的应用。在抗菌、杀菌方面 SecuSan® 系列门把手表现突出，能够及时清除各类细菌、病菌，藻类和微生物，</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(51, 46, 46); box-sizing: border-box !important; word-wrap: break-word !important;">是您放心的选择！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 15px; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p></section></section></section></section><p><br/></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p><br/></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="jpeg" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=jpeg" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/cd8b22165f63597fdd57d1a013bc7b093.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="cd8b22165f63597fdd57d1a013bc7b093.jpg" alt="cd8b22165f63597fdd57d1a013bc7b09.jpg"/></p><p><br/></p></section><p><br/></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-07-16', '2020-09-09 17:20:23'),
	(35, '新标杆 · HOPPE 好博木门品牌', '/upload/home/news/1e797993b4fe3b5cc8816efee72fbe01.jpg', '<p><br/></p><p><br/></p><p><br/></p><section style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; letter-spacing: 0.6217142939567566px; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; letter-spacing: 1.8px; line-height: 2; font-size: 15px; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="98779" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 5px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="98779" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-cropselx1="0" data-cropselx2="784" data-cropsely1="0" data-cropsely2="372" data-ratio="0.48619447779111646" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZOiapdyPlXFvxB8qZqSvUibBo2zNsA1LrTOnC7NS3icZfdmr5m8qJjpsNRAXb5drLdCtzPyZaVC9UPQ/640?wx_fmt=png" data-type="png" data-w="1666" _width="578px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c50bc5d63d8a98d69c7c9e7e666a02ae1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 578px !important; visibility: visible !important;" title="c50bc5d63d8a98d69c7c9e7e666a02ae1.jpg" alt="c50bc5d63d8a98d69c7c9e7e666a02ae.jpg"/></section><section style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; letter-spacing: 0.6217142939567566px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; letter-spacing: 1.8px; line-height: 2; font-size: 15px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 1em; text-indent: 0em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">一场疫情加速木门行业洗牌 百舸争流<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/>品牌迭代 行业进化<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/>竞争格局重塑之下</span></strong></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 1em; text-indent: 0em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">2020上半场HOPPE 好博给您答案</span></strong></section></section></section><section data-tools="135编辑器" data-id="98778" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; border: 1px solid rgb(0, 35, 76); word-wrap: break-word !important;"><section style="margin: 20px 17px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px 0px -30px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; height: 6px; border-bottom-width: 6px; border-bottom-style: solid; border-bottom-color: rgb(0, 35, 76); border-left-width: 13px; border-left-style: solid; border-left-color: transparent; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 0px -30px; padding: 8px 1em; max-width: 100%; background-color: rgb(0, 35, 76); color: rgb(255, 255, 255); font-size: 16px; letter-spacing: 1.5px; font-weight: bold; box-sizing: border-box !important; word-wrap: break-word !important;">68年专注执手领域</section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; height: 1px; border-top-width: 20px; border-top-style: solid; border-top-color: transparent; border-left-width: 20px; border-left-style: solid; border-left-color: rgb(0, 35, 76); border-bottom-width: 20px; border-bottom-style: solid; border-bottom-color: transparent; overflow: hidden; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 10px 0px 0px; padding: 0em 0px 1em; max-width: 100%; box-sizing: border-box; text-align: justify; line-height: 1.75em; letter-spacing: 1.5px; font-size: 14px; color: rgb(51, 51, 51); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">1952 年，弗里德里奇·好博 (Friedrich Hoppe 音译)先生在德国创立了本公司。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">如今, HOPPE 好博集团业务遍及全球,总部设于瑞士。</span><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">凭借着欧美七家工厂、近三千员工和拥有的国际市场, HOPPE 好博成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领导者。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博集团在德国、意大利及捷克的所有生产工厂均通过了 DIN EN ISO 14001: 2009(环境管理体系)认证。自2014年起,德国施塔特阿伦多夫的HOPPE AG 获得了 DIN EN ISO50001:2011 (能源管理系统) 认证。</span></p></section></section></section></section></section><section data-tools="135编辑器" data-id="98764" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(178, 178, 178); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">（▽左划看更多）</span></p><section data-tools="135编辑器" data-id="98243" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px 0px 15px; max-width: 100%; box-sizing: border-box; white-space: nowrap; width: 784px; overflow-x: scroll; word-wrap: break-word !important;"><section data-width="60%" style="margin: 0px; padding: 0px; max-width: 100%; word-wrap: break-word; display: inline-block; white-space: normal; vertical-align: top; width: 470.390625px; box-sizing: border-box !important;"><section data-width="90%" style="margin: 0px auto; padding: 2px; max-width: 100%; box-sizing: border-box; background-color: rgb(51, 51, 51); color: rgb(255, 255, 255); width: 423.34375px; word-wrap: break-word !important;"><img data-ratio="1.5542168674698795" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv96cknK19Kpxjorib4iaDFxicPZXUssHTJIwT6crQWYNickBMb3BekqgAiakA/640?wx_fmt=jpeg" data-type="jpeg" data-w="249" data-width="100%" title="9a0c25fc312e2f9110d8114102c8e1151.jpg" _width="419.34375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/9a0c25fc312e2f9110d8114102c8e1151.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 419.34375px !important; visibility: visible !important;" alt="9a0c25fc312e2f9110d8114102c8e115.jpg"/><p data-brushtype="text" style="margin-top: 0px; margin-bottom: 0px; padding: 5px 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">全进口五金</p></section></section><section data-width="60%" style="margin: 0px; padding: 0px; max-width: 100%; word-wrap: break-word; display: inline-block; white-space: normal; vertical-align: top; width: 470.390625px; box-sizing: border-box !important;"><section data-width="90%" style="margin: 0px auto; padding: 2px; max-width: 100%; box-sizing: border-box; background-color: rgb(51, 51, 51); color: rgb(255, 255, 255); width: 423.34375px; word-wrap: break-word !important;"><img data-ratio="1.5542168674698795" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9R9tPibB6W5Pzd9KaWwU0pCGvQMYFfk2yvpy9436vsYlwGJEQC48srdw/640?wx_fmt=jpeg" data-type="jpeg" data-w="249" data-width="100%" title="ee5091d7a08bf5207db071c60b97e5651.jpg" _width="419.34375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ee5091d7a08bf5207db071c60b97e5651.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 419.34375px !important; visibility: visible !important;" alt="ee5091d7a08bf5207db071c60b97e565.jpg"/><p data-brushtype="text" style="margin-top: 0px; margin-bottom: 0px; padding: 5px 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">品质有保证</p></section></section><section data-width="60%" style="margin: 0px; padding: 0px; max-width: 100%; word-wrap: break-word; display: inline-block; white-space: normal; vertical-align: top; width: 470.390625px; box-sizing: border-box !important;"><section data-width="90%" style="margin: 0px auto; padding: 2px; max-width: 100%; box-sizing: border-box; background-color: rgb(51, 51, 51); color: rgb(255, 255, 255); width: 423.34375px; word-wrap: break-word !important;"><img data-ratio="1.5542168674698795" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9CWAooFxZyhmQ1VOd8Pt5jkLeIicqD9B8NseTjb8jGtbygMcdZlic2PuQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="249" data-width="100%" title="0ba679bcf77e9aa1c640ec6b10779d131.jpg" _width="419.34375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/0ba679bcf77e9aa1c640ec6b10779d131.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 419.34375px !important; visibility: visible !important;" alt="0ba679bcf77e9aa1c640ec6b10779d13.jpg"/><p data-brushtype="text" style="margin-top: 0px; margin-bottom: 0px; padding: 5px 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">多元同系列</p></section></section></section></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(178, 178, 178); box-sizing: border-box !important; word-wrap: break-word !important;">（△左划看更多）</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(178, 178, 178); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p></section><img class="rich_pages " data-ratio="0.6666666666666666" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9aHoAR6HYTo9h3RriaIv4TAxxC97bHA6TY6ETQ3E9fVkic67QY8FgaAPQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="2880" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/1e797993b4fe3b5cc8816efee72fbe01.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; color: rgb(51, 51, 51); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" font-size:="" box-sizing:="" border-box="" word-wrap:="" break-word="" height:="" auto="" width:="" 674px="" visibility:="" visible="" title="1e797993b4fe3b5cc8816efee72fbe01.jpg" alt="1e797993b4fe3b5cc8816efee72fbe01.jpg"/></section></section></section></section></section></section></section><p><br/></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博一直在国际领先的门窗幕墙行业中带来其高质量和创新的解决方案。在木门执手领域，HOPPE 好博带来了dura<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">vert</strong>®“脱俗精品”，dura<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">plus</strong>®“精致主流”，平移门五金产品，HCS®整体系统锁等产品。材质包含了铝合金，黄铜与聚酰胺（尼龙），多种选择更适合多场景应用。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">所有HOPPE 好博门窗把手产品均享有如下品牌属性，以强调质量标准。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-ratio="0.28984375" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabupaekB8GYncJWoicUbmEZgFumevXA3GOoojyUJZgWlibPM2QstovaO3otengJ9svvpLEia0TTr8bQw/640?wx_fmt=png" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/b12069789b656293d3585c1eaae15ff91.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 674px !important;" title="b12069789b656293d3585c1eaae15ff91.jpg" alt="b12069789b656293d3585c1eaae15ff9.jpg"/></p><p><br/></p><p><br/></p><section 0="" data-tools="135编辑器" data-id="97818" data-width="45%" style="margin: 0px auto; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" width:="" flex:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 113.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 113.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.605263157894737" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9VtoM9USA9m9mpkqFTicmbx0J4ibSViawa0sAAh7ZFJLEIPtzrsj3n3ENg/640?wx_fmt=jpeg" data-type="jpeg" data-w="152" data-width="100%" title="4311b613e0ea5faeff3dbb70c94b96cb.jpg" _width="113.59375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4311b613e0ea5faeff3dbb70c94b96cb.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 113.59375px !important; visibility: visible !important;" alt="4311b613e0ea5faeff3dbb70c94b96cb.jpg"/></section><section data-brushtype="text" style="margin: 6px 0px 0px; padding: 0px; max-width: 100%; text-align: center; color: rgb(51, 51, 51); font-size: 14px; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-width="100%" style="margin: 0px 6px; padding: 0px; max-width: 100%; width: 113.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 113.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.605263157894737" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9BYFITZy1T3RTQqyzpribVrf4LPJJq9AfA3eXegwqmAE9QibAVLpEpqrg/640?wx_fmt=jpeg" data-type="jpeg" data-w="152" data-width="100%" title="580e6d9e3a8c23af1b9c543489bfe870.jpg" _width="113.59375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/580e6d9e3a8c23af1b9c543489bfe870.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 113.59375px !important; visibility: visible !important;" alt="580e6d9e3a8c23af1b9c543489bfe870.jpg"/></section><section data-brushtype="text" style="margin: 6px 0px 0px; padding: 0px; max-width: 100%; text-align: center; color: rgb(51, 51, 51); font-size: 14px; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 113.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 113.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.605263157894737" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9hV3URbZbJ0czHux02z5MrQ0rBes8aA9nJjE8c5ZTGCH8AjW2elhic3A/640?wx_fmt=jpeg" data-type="jpeg" data-w="152" data-width="100%" title="4a8dbbe3380a1da922bf9954364f8e601.jpg" _width="113.59375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4a8dbbe3380a1da922bf9954364f8e601.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 113.59375px !important; visibility: visible !important;" alt="4a8dbbe3380a1da922bf9954364f8e60.jpg"/></section><section data-brushtype="text" style="margin: 6px 0px 0px; padding: 0px; max-width: 100%; text-align: center; color: rgb(51, 51, 51); font-size: 14px; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section></section><p><br/></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(93, 101, 116); font-family: " pingfang="" helvetica="" text-align:="" white-space:="" word-spacing:="" background-color:="" font-size:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word="">借着此次机会，HOPPE 好博与来自木门行业及相关产业链近500位业内人士将齐聚羊城，参加这一木门行业的顶级盛会。</span><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(93, 101, 116); font-family: " pingfang="" helvetica="" text-align:="" white-space:="" word-spacing:="" background-color:="" font-size:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word="">数百家木门行业品牌、供应商品牌、装企、房企及行业相关从业者齐聚一堂，以“新品类、新标杆”为主题，在渠道转型、产品升级、营销定位等领域思想碰撞，共同总结探讨全新市场形势下的品牌发展方向。</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-ratio="1.414516129032258" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYK7L606xs4H3BQu8q5yyv9Cr54wtm2gmicGW7oiafbuVGWbetbcRMwOmA1UzXVRrs4XEjS08qYqBVg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1240" _width="494px" src="https://hoppe.jzdsh.com/upload/ue/img/fbcac7017823bf6205583dc509036496.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 494px !important; visibility: visible !important;" title="fbcac7017823bf6205583dc509036496.jpg" alt="fbcac7017823bf6205583dc509036496.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(93, 101, 116); font-family: " pingfang="" helvetica="" text-align:="" white-space:="" word-spacing:="" background-color:="" font-size:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; letter-spacing: 0.5440000295639038px; font-size: 16px; text-align: right; caret-color: rgb(93, 101, 116); color: rgb(93, 101, 116); font-family: " pingfang="" helvetica="" word-spacing:="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">2020木门供应商品牌-共荣奖</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp; &nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p><br/></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="jpeg" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=jpeg" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/cd8b22165f63597fdd57d1a013bc7b094.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="cd8b22165f63597fdd57d1a013bc7b094.jpg" alt="cd8b22165f63597fdd57d1a013bc7b09.jpg"/></p><p><br/></p></section><p><br/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2020-07-15', '2020-09-09 17:37:49'),
	(37, 'ARRONE 安侬 | HOPPE 好博集团旗下品牌', '/upload/home/news/WX20200910-134849@2x.png', '<p><br/></p><p><br/></p><p></p><section data-tools="135编辑器" data-id="97609" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; background-image: url(" wx_fmt="jpeg&quot;);" background-size:="" word-wrap:="" break-word="" background-repeat:="" no-repeat=""><section style="margin: 0px; padding: 10px 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-bgless="spin" data-bgopacity="60%" data-brushtype="text" style="margin: 0px; padding: 8px 1em; max-width: 100%; box-sizing: border-box; background-color: rgb(0, 32, 96); color: rgb(255, 255, 255); letter-spacing: 5px; font-size: 30px; font-weight: bold; word-wrap: break-word !important;">ARRONE® 安侬®</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><section data-bgless="spin" data-bgopacity="60%" data-width="100%" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; width: 784px; height: 2px; background-color: rgb(0, 32, 96); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-bgless="spin" data-bgopacity="0%" data-width="100%" style="margin: 3px 0px 0px; padding: 0px; max-width: 100%; width: 784px; height: 2px; background-color: rgb(84, 141, 212); overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><p></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博集团旗下的ARRONE 安侬品牌涵盖了全方位高品质的门窗五金及配件产品。ARRONE 安侬产品与 HOPPE 好博的各类铝合金、黄铜、不锈钢和尼龙门窗五金可完美搭配。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">自 1993 年推出的以来，ARRONE 安侬已成为五金市场一个知名品牌且具有显著的地位。ARRONE 安侬产品线不断更新，各种附加功能日渐丰富，满足日益增长的市场需求。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9153259949195597" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf6qzDAYoxI8MoicT2PfSicWnXFnnbRkoZXAZLmQN77KYgZ9dvicQK14qtMId4rRvIgEjg7P0MKGYKA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1181" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/8fc380716cca55dcb7ca2e709767faa9.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="8fc380716cca55dcb7ca2e709767faa9.jpg" alt="8fc380716cca55dcb7ca2e709767faa9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">ARRONE 安侬的产品范围包括：锁体、锁芯、合页、闭门器、地弹簧、逃生装置、无障碍设施及配件等。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">作为产品线的重要组成部分，ARRONE 安侬磁力锁给您带来高品质静音体验。磁力锁完美的利用了磁力原理解决机械锁的物理碰撞问题，让开锁声音变到最小。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p></p><section data-brushtype="text" style="margin: 0px; padding: 10px 1em 6px; max-width: 100%; box-sizing: border-box; text-align: start; background-color: rgb(0, 35, 76); flex: 1 1 0%; color: rgb(255, 255, 255); word-wrap: break-word !important;">ARRONE® 安侬®磁力锁</section><p></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="372" data-ratio="0.6779911373707533" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZncNRYFskNxsOD0umQn2LqyQVPlHwbUhYTaiadTCLgAtu4JkHl9cNEYNq5NJ0yYxBjY38ic49icE7vg/640?wx_fmt=png" data-type="png" data-w="677" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/9c3be932433b5fd381ec7298086258f2.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 578px !important; visibility: visible !important;" title="9c3be932433b5fd381ec7298086258f2.jpg" alt="9c3be932433b5fd381ec7298086258f2.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.67578125" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabf6qzDAYoxI8MoicT2PfSicWn5IXaRyqxRSLGC99LjZBWkMqZRvicFw3cuOpZNQKwsl8Acl6Sia5sqJA/640?wx_fmt=png" data-type="png" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/af9bff145cbced7555ad06d5f4007120.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="af9bff145cbced7555ad06d5f4007120.jpg" alt="af9bff145cbced7555ad06d5f4007120.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.371875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabf6qzDAYoxI8MoicT2PfSicWzAA1B8az6qZDEu2fwRFP2lAvAGzqWynrAlK9McP1GIMjPySYpyTXtg/640?wx_fmt=png" data-type="png" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/a6090911e6d54aa377891958518eebaa.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="a6090911e6d54aa377891958518eebaa.jpg" alt="a6090911e6d54aa377891958518eebaa.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; letter-spacing: 0.544px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; letter-spacing: 0.544px; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="jpeg" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=jpeg" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/cd8b22165f63597fdd57d1a013bc7b095.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; overflow-wrap: break-word !important; visibility: visible !important; width: 674px !important;" title="cd8b22165f63597fdd57d1a013bc7b095.jpg" alt="cd8b22165f63597fdd57d1a013bc7b09.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><p></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-size: 16px; letter-spacing: 0.544px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; overflow-wrap: break-word !important;"><br/></p><p><br/></p>', 0, 0, 0, '2020-05-27', '2020-09-10 13:59:41'),
	(38, 'HOPPE 好博与中国木门技术联盟深入合作，共同探讨木门技术', '/upload/home/news/WX20200910-141850@2x.png', '<p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博&nbsp;为中国木门行业发展助力</span></strong></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="285" data-ratio="0.6028789161727349" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabupaekB8GYncJWoicUbmEZgLNIKBUiaH99lYZwLBBhIzWSxdNdiaxr9ib1S9cFJcLZqkb6M388gWk5Aw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1181" _width="440px" src="https://hoppe.jzdsh.com/upload/ue/img/ae66a0f05e6b05f1dbef11fbc5b01b46.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 440px !important;" title="ae66a0f05e6b05f1dbef11fbc5b01b46.jpg" alt="ae66a0f05e6b05f1dbef11fbc5b01b46.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; 1952年，弗里德里奇·好博(Friedrich Hoppe 音译)先生在德国锁具及五金的传统工业中心地带–杜塞尔多夫(Düsseldorf 音译)附近的小镇黑利根豪斯(Heiligenhaus 音译)创立了本公司。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">如今, HOPPE 好博集团业务遍及全球,总部设于瑞士</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; 60多年来，HOPPE 好博一直在国际领先的门窗幕墙行业中带来其高质量和创新的解决方案。在木门执手领域，HOPPE 好博带来了dura<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">vert</strong>®“脱俗精品”，dura<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">plus</strong>®“精致主流”，平移门五金产品，HCS®整体系统锁等产品。材质包含了铝合金，黄铜与聚酰胺（尼龙），多种选择更适合多场景应用。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;所有HOPPE 好博门窗把手产品均享有品牌属性，以强调质量标准。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-ratio="0.28984375" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabupaekB8GYncJWoicUbmEZgFumevXA3GOoojyUJZgWlibPM2QstovaO3otengJ9svvpLEia0TTr8bQw/640?wx_fmt=png" data-type="png" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/b12069789b656293d3585c1eaae15ff92.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="b12069789b656293d3585c1eaae15ff92.jpg" alt="b12069789b656293d3585c1eaae15ff9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博于2020年，以副会长单位正式加入中国木门技术联盟。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-ratio="1.4140625" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaa8v2C52QUx26Ggq1ibUye0yTZmx9YpdEZ8qOiaicHUVBk3y4m0dibCsqwW3hpE3hwib9ibbC9jslQ30naA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/5bf2abba0dc29edd56c6320d2212066e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="5bf2abba0dc29edd56c6320d2212066e.jpg" alt="5bf2abba0dc29edd56c6320d2212066e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;中国木门技术联盟 Chinese Wooden Doors Technology Alliance 成立于2013 年，是由木门生产企业、木门供应商企业（包括但不限于五金、板材、油漆、饰面材料、木工机械设备等） 、科学研究院所、专家团体、门业设计师、安装服务公司、软件公司等组成的行业组织。有着包含五金、油漆、包覆、除尘、胶合、研发等诸多专业领域在内的木门行业专家资源，推动木门行业的技术交流与发展。&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-croporisrc="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaa8v2C52QUx26Ggq1ibUye0yKKzPNv22ku3CWEh7q5z8FdvSib3k3ZGia3AeluV1jE3pDk6icWW87icdibQ/640?wx_fmt=jpeg" data-cropx1="0" data-cropx2="1080" data-cropy1="0" data-cropy2="440.9688581314879" data-ratio="0.4074074074074074" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabupaekB8GYncJWoicUbmEZgX0WN8cHrkMosRfPBvh8WnVmHNsI57UBtFpUjFIRhCS5MLIHvIdTZVA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/d2e6966cb96feb8f977ec539e7d7448e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 578px !important; visibility: visible !important;" title="d2e6966cb96feb8f977ec539e7d7448e.jpg" alt="d2e6966cb96feb8f977ec539e7d7448e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(178, 178, 178); box-sizing: border-box !important; word-wrap: break-word !important;">2019技术会议成员</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;中国木门技术联盟凝聚行业力量，以企业为技术创新主体，共同提升木门产品品质，解</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">决木门行业技术难题，打造中国木门行业核心竞争力，推动木门行业技术结构优化升级，促</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">进中国木门行业健康、可持续性发展。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; 2020, HOPPE 好博与中国木门技术联盟CWDTA敬请期待！<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp; &nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="png" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=png" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/04f597a29f0bf0e8e0e2d39485a205e8.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="04f597a29f0bf0e8e0e2d39485a205e8.jpg" alt="04f597a29f0bf0e8e0e2d39485a205e8.jpg"/></p><p><br/></p></section><p></p><p><br/></p><p><br/></p>', 0, 0, 0, '2020-04-22', '2020-09-10 14:23:00'),
	(39, '新款New York 系列 精致造型手感出色', '/upload/home/news/f6a698c773fd402563b562ceefccfe0e.jpg', '<p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;精细的制作工艺只为更优质的品质，以现代简约为理念，HOPPE 好博&nbsp;dura<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">plus</strong>® 产品线推出 New York 系列1810/3347N窄底座联体式型材门面板把手。铝合金材质，定位于精致主流执手市场。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="363" data-ratio="0.52421875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZcaYyRxQVP3dXPIF16nOkTUCgBvlZ9wMJD1QwFJXiaEhO90INzdwtkLsL6h6yjAacqEibOIqsOic6vw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/f6a698c773fd402563b562ceefccfe0e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="f6a698c773fd402563b562ceefccfe0e.jpg" alt="f6a698c773fd402563b562ceefccfe0e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;该款&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">New York</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;系列</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">1810/3347N</span>型材门把手采用窄底座联体式设计。在把手规格中，标配了<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">复位弹簧</strong>以及免维护垫圈，其连体背板自带安装螺柱。在方轴配置上，更是标配了 HOPPE 好博的快装技术</span><img class="rich_pages" data-ratio="0.2624113475177305" data-s="300,640" data-type="png" data-w="141" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabBuk8zuibTd1V2IlecWib2lWlfJchvxLAQq4FDsGibwBeQFwhdlNcKv7P2bTOc6w4GGzby9Yk3HcU8A/640?wx_fmt=png" _width="50px" src="https://hoppe.jzdsh.com/upload/ue/img/9d22144277f3fcb0baa22c133a42149b.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 50px !important;" title="9d22144277f3fcb0baa22c133a42149b.jpg" alt="9d22144277f3fcb0baa22c133a42149b.jpg"/>。<span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">普通的门把手安装需要很多步骤, 既复杂又费时。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">而 HOPPE&nbsp;好博的快装方轴技术使得门</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">把</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">手</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">的安装变</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">得</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">简单快捷，比起</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">普通把手节省 75% 的安装时间:仅需将把手从</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">门两边对插即可。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="229" data-ratio="0.48782961460446245" data-s="300,640" data-type="png" data-w="1972" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbd0CKoqAerSCibfb2ulibeGoT4JWTFC5AWkRtGeEjUpLicPDsx6BrAWRSUA/640?wx_fmt=png" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/1ed215b5e1e2625447bc22bb2685c835.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="1ed215b5e1e2625447bc22bb2685c835.jpg" alt="1ed215b5e1e2625447bc22bb2685c835.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"></span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">New York</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;系列</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">1810/3347N</span>窄底座联体式型材门面板把手隶属于<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">dura</span><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">plus</strong><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">® 产品线，<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">dura</span><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">plus</strong><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">®&nbsp;呈现了精致主流的市场理念。在<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">New York</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;系列</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">1810/3347N</span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">型材门把手的</span></span>色彩方面，也提供了许多选择。</span></span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img class="rich_pages " data-cropselx1="30" data-cropselx2="477" data-cropsely1="0" data-cropsely2="325" data-ratio="0.6406844106463878" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZcaYyRxQVP3dXPIF16nOkT2FuhwYF8baBneVNt5If6LVnl7Ed1pbmzCHpKI4o8D22nPGU1puFicPQ/640?wx_fmt=png" data-type="png" data-w="2104" _width="507px" src="https://hoppe.jzdsh.com/upload/ue/img/0103f2980f277159f54bdc84643e6a0e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 507px !important;" title="0103f2980f277159f54bdc84643e6a0e.jpg" alt="0103f2980f277159f54bdc84643e6a0e.jpg"/></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" caret-color:="" color:="" font-size:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 784px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="443" data-ratio="0.2513812154696133" data-s="300,640" data-type="png" data-w="1448" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57TdbdM7pdstv7bicb2Kic9iaPggOyxFfvaykuQjWj9fgfm0ChMadQcPugErnFw/640?wx_fmt=png" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/3db4e1e553aabcefdd666dc6759941fb1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="3db4e1e553aabcefdd666dc6759941fb1.jpg" alt="3db4e1e553aabcefdd666dc6759941fb.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="420" data-ratio="0.8053993250843644" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZcaYyRxQVP3dXPIF16nOkTF3ahTU5jaCXUY3kYiaj7vUlqVulHDntmhRXlo5yoXX6A3AT86YvajkA/640?wx_fmt=png" data-type="png" data-w="1778" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/9cfdc473c6051adf1af4294806dea7c8.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 578px !important; visibility: visible !important;" title="9cfdc473c6051adf1af4294806dea7c8.jpg" alt="9cfdc473c6051adf1af4294806dea7c8.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="371" data-ratio="0.6223300970873786" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZcaYyRxQVP3dXPIF16nOkTA0Msdvjuce3K1KNCbS3jPCmmDo7ohF6C1uNvywTicbUdWSz6HK1XuqQ/640?wx_fmt=png" data-type="png" data-w="2060" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/ea9eb7b40125391fe1be7b24f07d8915.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="ea9eb7b40125391fe1be7b24f07d8915.jpg" alt="ea9eb7b40125391fe1be7b24f07d8915.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" caret-color:="" color:="" font-size:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="png" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=png" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/04f597a29f0bf0e8e0e2d39485a205e81.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 578px !important;" title="04f597a29f0bf0e8e0e2d39485a205e81.jpg" alt="04f597a29f0bf0e8e0e2d39485a205e8.jpg"/></p><p><br/></p></section></section></section><p></p><p><br/></p><p><br/></p>', 0, 0, 0, '2020-04-01', '2020-09-10 14:37:26'),
	(40, 'HOPPE 好博亚太区总裁Eric Kersten致全体好博人的一封信', '/upload/home/news/WX20200910-143937@2x.png', '<p><br/></p><p><br/></p><p><br/></p><section data-tools="135编辑器" data-id="97146" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; display: flex; justify-content: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: -2px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 25px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.1666666666666667" data-src="https://mmbiz.qpic.cn/mmbiz_png/YUyZ7AOL3onWl7HutUicn4iaJ9r2icpgrK2bM8uy4QBVbBOl1rAQ49EBSB3uAnqo0aHFQTrnKenPhBVzTpsNFXLNA/640?wx_fmt=png" data-type="png" data-w="42" data-width="100%" _width="25px" src="https://mmbiz.qpic.cn/mmbiz_png/YUyZ7AOL3onWl7HutUicn4iaJ9r2icpgrK2bM8uy4QBVbBOl1rAQ49EBSB3uAnqo0aHFQTrnKenPhBVzTpsNFXLNA/640?wx_fmt=png&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 25px !important; visibility: visible !important;"/></section><section data-brushtype="text" style="margin: 0px; padding: 0px 0px 0px 10px; max-width: 100%; box-sizing: border-box; font-size: 16px; color: rgb(112, 169, 248); letter-spacing: 1.5px; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">亚太区总裁Eric Kersten致全体好博人</span></section></section><section style="margin: 2px 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; border-bottom-width: 2px; border-bottom-style: dashed; border-bottom-color: rgb(112, 169, 248); flex: 1 1 0%; height: 1px; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section></section><section data-tools="135编辑器" data-id="97128" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 35px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.8556149732620321" data-src="https://mmbiz.qpic.cn/mmbiz_gif/YUyZ7AOL3om3q5niccnl3SQuwEVE0XWS422hVNE60ZlGxRZ56hkSjticCfZz8N0ic1YX6iatnmpfiaxC8b1vFK9dNyg/640?wx_fmt=gif" data-type="gif" data-w="187" _width="35px" src="https://mmbiz.qpic.cn/mmbiz_gif/YUyZ7AOL3om3q5niccnl3SQuwEVE0XWS422hVNE60ZlGxRZ56hkSjticCfZz8N0ic1YX6iatnmpfiaxC8b1vFK9dNyg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 35px !important; visibility: visible !important;"/></section><section data-brushtype="text" style="margin: 0px 0px 0px 5px; padding: 0px; max-width: 100%; font-weight: bold; font-size: 18px; text-align: justify; letter-spacing: 1.5px; color: rgb(230, 25, 42); box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">我的朋友们，请共同加油!</span></section></section></section><section data-tools="135编辑器" data-id="97134" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); width: 120px; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.18220338983050846" data-src="https://mmbiz.qpic.cn/mmbiz_png/YUyZ7AOL3omA3ztb0MOL9xfkdKq8r6p6v9Az4Jp4PISRicDfusj4vOhqdWRwp0MfP2jLKt4Kibfmp1khZrkbLJ9Q/640?wx_fmt=png" data-type="png" data-w="236" data-width="100%" _width="120px" src="https://hoppe.jzdsh.com/upload/ue/img/be696b20165862a083ceb76394992fd0.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 120px !important; visibility: visible !important;" title="be696b20165862a083ceb76394992fd0.jpg" alt="be696b20165862a083ceb76394992fd0.jpg"/></section><section style="margin: -17px 0px 0px; padding: 5px; max-width: 100%; box-sizing: border-box; box-shadow: rgb(228, 228, 228) 2px 2px 0px; background-color: rgb(242, 248, 255); overflow: hidden; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; border: 2px dashed rgb(138, 184, 248); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; letter-spacing: 1px; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">My dear HOPPE family:</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1px; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">我亲爱的好博家人们：</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;">For the past three weeks till now, the world’s attention is focused on China because of the coronavirus. The climbing data in the daily news report also affect my heart</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: SimSun; letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;">，</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;">and&nbsp;we must remember that these are people, not numbers.</span></span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"></span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">在这过去的三周时间里，由于新型冠状病毒，全世界的注意力都集中在中国。<span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;">每天新闻报道中不断增长的数据也令我揪心，我们必须要记住这些都是生命，不只是数字。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-indent: 48px; color: rgb(0, 35, 76); font-family: Helvetica; letter-spacing: 1px; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-indent: 48px; color: rgb(0, 35, 76); font-family: Helvetica; letter-spacing: 1px; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE AG continues to have confidence in China’s capacity to control the outbreak.</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博集团对中国控制疫情方面的能力非常有信心。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">As President Asia, I would like to extend sincere greetings to all who are currently going through this difficult time.</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1.5px; box-sizing: border-box !important; word-wrap: break-word !important;">作为亚太区总裁，我谨向所有正在经历这一困难时期的人们致以诚挚的问候。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE Shanghai will resume working on February 10th. The operation is going on in an orderly manner. The delivery and logistics are also recovering.</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博上海于2月10日恢复正常工作。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">工作安排正在有序地进行。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">快递和物流也在恢复中。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">At the meantime, I hope our Chinese employees could keep well protection while solving daily jobs and wish you all stay healthy.</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">同时，希望我们的中国员工在日常工作中注意保护好自己，希望大家身体健康。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-size: 14px; text-indent: 48px; font-family: Helvetica; box-sizing: border-box !important; word-wrap: break-word !important;">Lastly, I would like to quote Dr Tedros Adhanom from&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-size: 14px; text-indent: 48px; font-family: Helvetica; letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;">World Health Organization:</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; letter-spacing: 1px; text-indent: 48px; box-sizing: border-box !important; word-wrap: break-word !important;">最后，我想引用世界卫生组织Tedros Adhanom博士的一段话:</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; font-weight: normal; box-sizing: border-box !important; word-wrap: break-word !important;">This is the time for facts, not fear.</span></strong><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; font-weight: normal; box-sizing: border-box !important; word-wrap: break-word !important;"></span></strong></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1px; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">要事实，不要恐惧。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; font-weight: normal; box-sizing: border-box !important; word-wrap: break-word !important;">This is the time for science, not rumours.</span></strong><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; font-weight: normal; box-sizing: border-box !important; word-wrap: break-word !important;"></span></strong></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1px; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">要科学，不要谣言。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; font-weight: normal; box-sizing: border-box !important; word-wrap: break-word !important;">This is the time for solidarity, not stigma.</span></strong><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; letter-spacing: 1px; font-weight: normal; box-sizing: border-box !important; word-wrap: break-word !important;"></span></strong></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 1px; color: rgb(0, 35, 76); font-family: Helvetica; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">要团结，不要污名。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">Eric Kersten</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">Member of the Board</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">董事会成员</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">President Asia/ Middle East/ Pacific</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; color: rgb(0, 0, 0); font-size: medium; letter-spacing: 1.5px; font-family: Calibri, sans-serif; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; font-family: Helvetica; color: rgb(0, 35, 76); font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">亚洲/中东/太平洋地区总裁</span></p></section></section></section></section><p><br/></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p><br/></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" caret-color:="" color:="" text-align:="" transform:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 0px; padding: 0px; max-width: 100%; height: 360px; vertical-align: top; overflow: hidden auto; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 40px 0px 20px; padding: 0px; max-width: 100%; transform: translate3d(0px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 10px 10px 80px; max-width: 100%; box-sizing: border-box; vertical-align: top; background-size: 99.86509704589844%; background-attachment: scroll; border-width: 0px; background-color: rgb(254, 255, 255); line-height: 1.8; box-shadow: rgb(102, 102, 102) 0px 0px 5px; word-wrap: break-word !important; background-position: 0% 0%; background-repeat: no-repeat repeat;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(51, 59, 108); line-height: 1.8; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">（▲向上滑动查看内容）</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(51, 59, 108); line-height: 1.8em; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.2959866220735785" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaVzTKp3lkSQ8lGWLXzrN6Ap0p1Rg6libPrWBCLApEE1NhWac4l2dF8tKQAWpNr549Dy2qb3v8uaBw/640?wx_fmt=png" data-type="png" data-w="1196" _width="674px" src="https://hoppe.jzdsh.com/upload/ue/img/640.jpeg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 674px !important; visibility: visible !important;" title="640.jpeg" alt="640.jpeg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section></section></section><section style="margin: -120px 0px 10px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" caret-color:="" color:="" text-align:="" transform:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><img data-ratio="0.46921797004991683" data-src="https://mmbiz.qpic.cn/mmbiz_png/yqVAqoZvDibGwwGGhKKxn4akcNpC4GoG9vxeL09ujul1qNynYNu7Isxa0VsmDhOed7uBwWP5qBPMDCoDlib8ibwsA/640?wx_fmt=png" data-type="png" data-w="601" data-width="100%" width="100%" _width="674px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f82b55698e97bf7f5a44c88d31494abc.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; box-shadow: rgb(0, 0, 0) 0px 0px 0px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 674px !important;" title="f82b55698e97bf7f5a44c88d31494abc.jpg" alt="f82b55698e97bf7f5a44c88d31494abc.jpg"/></section><p><br/></p><p><br/></p>', 1, 0, 0, '2020-02-11', '2020-09-10 14:48:13'),
	(42, 'HOPPE 好博延迟开工通知', '/upload/home/news/封面.png', '<p><br/></p><p><br/></p><p><br/></p><section data-tools="135编辑器" data-id="97154" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; width: 36px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 36px; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.075268817204301" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZgXF3iaISEGkFfPVyqtyLQ9t1FMd8icMWlicUk5f1nCthSPGiaxrv1HnspYr1JhJK7FRiafdorRTD5soA/640?wx_fmt=png" data-type="png" data-w="372" data-width="100%" title="3865d9cc6d296acb4165c8a92553ce0c.jpg" _width="36px" src="https://hoppe.jzdsh.com/upload/ue/img/3865d9cc6d296acb4165c8a92553ce0c.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 36px !important; visibility: visible !important;" alt="3865d9cc6d296acb4165c8a92553ce0c.jpg"/></section></section><section style="margin: 5px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-bgless="spin" data-bgopacity="50%" style="margin: 0px; padding: 0px; max-width: 100%; width: 14px; height: 14px; background-color: rgba(110, 168, 248, 0.9); transform: rotate(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-bgless="spin" data-bgopacity="50%" style="margin: 0px 0px 0px 4px; padding: 0px; max-width: 100%; width: 14px; height: 14px; background-color: rgba(110, 168, 248, 0.4); transform: rotate(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-brushtype="text" style="margin: 0px; padding: 0px 12px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; letter-spacing: 1.5px; color: rgb(112, 169, 248); word-wrap: break-word !important;">HOPPE 好博</section><section data-bgless="spin" data-bgopacity="50%" style="margin: 0px 4px 0px 0px; padding: 0px; max-width: 100%; width: 14px; height: 14px; background-color: rgba(110, 168, 248, 0.4); transform: rotate(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-bgless="spin" data-bgopacity="50%" style="margin: 0px; padding: 0px; max-width: 100%; width: 14px; height: 14px; background-color: rgba(110, 168, 248, 0.9); transform: rotate(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section data-brushtype="text" style="margin: 6px 0px 0px; padding: 0px 12px; max-width: 100%; box-sizing: border-box; font-size: 14px; text-align: center; letter-spacing: 1.5px; color: rgb(112, 169, 248); word-wrap: break-word !important;">抗疫保卫战 与您共战疫</section></section></section><section data-tools="135编辑器" data-id="97156" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 0px; padding: 0px; max-width: 100%; background-image: url(" wx_fmt="png" background-size:="" word-wrap:="" break-word="" background-position:="" center="" background-repeat:="" repeat="" section="" text-align:="" font-weight:="" line-height:="" background-color:="" height:="" box-sizing:="" border-box="" right=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 25px 0px 0px; padding: 0px; max-width: 100%; text-align: center; display: flex; justify-content: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 25px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.1666666666666667" data-src="https://mmbiz.qpic.cn/mmbiz_png/YUyZ7AOL3onWl7HutUicn4iaJ9r2icpgrK2bM8uy4QBVbBOl1rAQ49EBSB3uAnqo0aHFQTrnKenPhBVzTpsNFXLNA/640?wx_fmt=png" data-type="png" data-w="42" data-width="100%" _width="25px" src="https://hoppe.jzdsh.com/upload/ue/img/a4e87f221fcc4d55ef33f76f848c4c5f.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 25px !important; visibility: visible !important;" title="a4e87f221fcc4d55ef33f76f848c4c5f.jpg" alt="a4e87f221fcc4d55ef33f76f848c4c5f.jpg"/></section><section data-brushtype="text" style="margin: 0px; padding: 0px 0px 0px 10px; max-width: 100%; box-sizing: border-box; font-size: 16px; color: rgb(51, 51, 51); font-weight: bold; letter-spacing: 1.5px; word-wrap: break-word !important;">延迟开工通知</section></section><section style="margin: 2px 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; border-bottom-width: 2px; border-bottom-style: dashed; border-bottom-color: rgb(112, 169, 248); flex: 1 1 0%; height: 1px; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><section data-autoskip="1" style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; font-size: 14px; letter-spacing: 1.5px; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">新春佳节之际，新型冠状病毒感染的肺炎疫情给全国人民带来了不安，为切实保障员工的身心健康，避免人员聚集发生交叉感染，HOPPE 好博特此通告：</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">原定1月31日开工</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">现于2月10日开工</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">我们将严格遵循国家相关部门关于疫情的通报及要求，妥善安排工作。制定完善的安全防疫措施，为复工后的安全防疫做好充分准备。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">原我们齐心协力，共度难关。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">2020年02月07日</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; caret-color: rgb(112, 169, 248); color: rgb(112, 169, 248); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section data-tools="135编辑器" data-id="97121" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; height: 120px; width: 10px; background-color: rgb(214, 227, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 1 1 0%; border: 1px solid rgb(186, 212, 253); word-wrap: break-word !important;"><img data-ratio="0.590566037735849" data-src="https://mmbiz.qpic.cn/mmbiz_png/YUyZ7AOL3omnIar2tMwHf8oLnZRs2zJiaCaFNePhJgAQeWThvCQyN9vdqpt1PfA8AdEjaVJplsxVgSF3GkuegWw/640?wx_fmt=png" data-type="png" data-w="530" data-width="100%" _width="300px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4f5f4f13393d584a859612baf0a1b044.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="4f5f4f13393d584a859612baf0a1b044.jpg" alt="4f5f4f13393d584a859612baf0a1b044.jpg"/></section></section></section></section></section></section><p><br/></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p><br/></p><section style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" display:="" justify-content:="" align-items:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 0px; padding: 0px; max-width: 100%; width: 55px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 55px; height: 55px; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; overflow: hidden; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/YUyZ7AOL3omnIar2tMwHf8oLnZRs2zJiafX793CFDkCfkUvSyd6ePccHSrNplhb0hAHULOWGCficCRvmOzyERn9A/640?wx_fmt=png" data-type="png" data-w="94" data-width="100%" _width="55px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/8c417ae318db9a6c2c287d441286cbb5.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 55px !important; visibility: visible !important;" title="8c417ae318db9a6c2c287d441286cbb5.jpg" alt="8c417ae318db9a6c2c287d441286cbb5.jpg"/></section></section><section data-brushtype="text" style="margin: 0px 0px 0px 10px; padding: 0px; max-width: 100%; color: rgb(102, 102, 102); font-size: 16px; letter-spacing: 1.5px; font-weight: bold; box-sizing: border-box !important; word-wrap: break-word !important;">温馨提示</section></section><p style="text-align:center"><img class="rich_pages " data-ratio="3.7824074074074074" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZgXF3iaISEGkFfPVyqtyLQ9BDM1vqApt0yJ6PDFx67EpMHs06NIOOst55ictojiccIZsy0kmnYYm4Sg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7b9d4858a0d2bae2c02c213de386fa541.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="7b9d4858a0d2bae2c02c213de386fa541.jpg" alt="7b9d4858a0d2bae2c02c213de386fa54.jpg"/></p><p style="text-align:center"><img class="rich_pages  __bg_gif" data-ratio="0.6940874035989717" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZgXF3iaISEGkFfPVyqtyLQ92eia3XKGEyI33F1oUJAevibFcBQW7LfWypQBQqI2VFrialBibYObPSC97Q/640?wx_fmt=gif" data-type="gif" data-w="1556" _width="178px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZgXF3iaISEGkFfPVyqtyLQ92eia3XKGEyI33F1oUJAevibFcBQW7LfWypQBQqI2VFrialBibYObPSC97Q/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 178px !important; visibility: visible !important;"/></p><p style="text-align:center"><img class="rich_pages " data-ratio="0.9828125" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabb13yZQWju7w5ZoKpMUR80t82cPTIt8iaYupA46icVDkoc2m2452p6s1wmrGtJNpA1PIUezcEuz6zA/640?wx_fmt=png" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7d4ba5b2f7e72758a8d0e24297f66430.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 300px !important;" title="7d4ba5b2f7e72758a8d0e24297f66430.jpg" alt="7d4ba5b2f7e72758a8d0e24297f66430.jpg"/></p><p><br/></p>', 0, 0, 0, '2020-02-07', '2020-09-17 20:04:50'),
	(43, 'HOPPE 好博 “鼠”不尽的精彩！', '/upload/home/news/封面1.png', '<p><br/></p><p></p><p><section data-tools="135编辑器" data-id="96913" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border: 5px solid rgb(33, 181, 193); transform: rotate(0deg); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border: 2px solid rgb(252, 231, 166); background-color: rgb(251, 182, 208); background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEoxowz7EJ2cgotwKdAW5ImnsbaKj8B2Uoaj8pgIiaImPzfQggE4e5TekA/640?wx_fmt=png&quot;); background-size: 100%; overflow: hidden; word-wrap: break-word !important; background-position: center center; background-repeat: repeat repeat;"><section style="margin: 0px; padding: 2px 0.5em; max-width: 100%; box-sizing: border-box; display: flex; justify-content: center; align-items: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 15px; transform: rotate(90deg); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI64E398EGsyicnPN7aSjgDp4ljhKZXuofwiczTKAtSoMTUNPPG7Coh2P6w/640?wx_fmt=png" data-type="png" data-w="19" _width="15px" src="https://hoppe.jzdsh.com/upload/ue/img/3aa01a63a4b27e79961c63197ba738182.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 15px !important; visibility: visible !important;" title="3aa01a63a4b27e79961c63197ba738182.jpg" alt="3aa01a63a4b27e79961c63197ba73818.jpg"/></section><section data-brushtype="text" style="margin: 0px; padding: 2px 0.6em; max-width: 100%; box-sizing: border-box; font-weight: bold; font-size: 16px; letter-spacing: 1.5px; line-height: 1.75em; color: rgb(255, 255, 255); word-wrap: break-word !important;">鼠年大吉</section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 15px; transform: rotate(90deg); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI64E398EGsyicnPN7aSjgDp4ljhKZXuofwiczTKAtSoMTUNPPG7Coh2P6w/640?wx_fmt=png" data-type="png" data-w="19" _width="15px" src="https://hoppe.jzdsh.com/upload/ue/img/3aa01a63a4b27e79961c63197ba738183.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 15px !important; visibility: visible !important;" title="3aa01a63a4b27e79961c63197ba738183.jpg" alt="3aa01a63a4b27e79961c63197ba73818.jpg"/></section></section></section></section></section></section></section><section data-tools="135编辑器" data-id="96894" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 40px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.2903225806451613" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6ynLIbLIweuzERBxRpSB9dsnmK4IOhnxCW5w7pQL32d50HWJkIRbSzQ/640?wx_fmt=png" data-type="png" data-w="62" data-width="100%" _width="40px" src="https://hoppe.jzdsh.com/upload/ue/img/a01d3a63e2636003ee5c46f2c021dd7d4.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 40px !important; visibility: visible !important;" title="a01d3a63e2636003ee5c46f2c021dd7d4.jpg" alt="a01d3a63e2636003ee5c46f2c021dd7d.jpg"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">H</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">O</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">P</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">P</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">E</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 40px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.2903225806451613" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6ynLIbLIweuzERBxRpSB9dsnmK4IOhnxCW5w7pQL32d50HWJkIRbSzQ/640?wx_fmt=png" data-type="png" data-w="62" data-width="100%" _width="40px" src="https://hoppe.jzdsh.com/upload/ue/img/a01d3a63e2636003ee5c46f2c021dd7d5.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; transform: scaleX(-1); box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 40px !important; visibility: visible !important;" title="a01d3a63e2636003ee5c46f2c021dd7d5.jpg" alt="a01d3a63e2636003ee5c46f2c021dd7d.jpg"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEoqLDo5xzJEuDgggAZB8ZXJenGTzupyGwyNuuKCiafE7KDMU4sXtGOtVw/640?wx_fmt=jpeg&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center top; background-repeat: repeat repeat;"><section style="margin: 10px 0px 0px; padding: 1em; max-width: 100%; box-sizing: border-box; border: 4px solid rgb(225, 7, 6); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">1952年，弗里德里奇·好博(Friedrich Hoppe 音译)先生在德国锁具及五金的传统工业中心地带–杜塞尔多夫(Düsseldorf 音译)附近的小镇黑利根豪斯(Heiligenhaus 音译)创立了本公司。1954年,好博先生将公司迁往德国黑森州的斯塔特阿伦多夫(Stadtallendorf 音译),奠定了日后持续发展壮大的基石。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">如今, HOPPE 好博集团业务遍及全球,总部设于瑞士,由家族第二代成员沃尔夫·好博 (Wolf Hoppe) 和克里斯托弗·好博(Christoph Hoppe)先生共同领导。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">60多年来，HOPPE 好博一直在国际领先的门窗幕墙行业中带来其高质量和创新的解决方案。凭借着欧美七家工厂、近三千员工和拥有的国际市场，HOPPE 好博家族企业成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领者。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); color: rgb(51, 51, 51); text-align: justify; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.49296875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4sfxMXHgRT7IP6ibpzZ4sDF2K5TrGC4peHPDDnYDBjBnehjU7MjoxPTw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/3bc03271e892b0521060481a4503e6501.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="3bc03271e892b0521060481a4503e6501.jpg" alt="3bc03271e892b0521060481a4503e650.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="96912" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 30px auto 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: -30px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">新</section></section></section><section style="margin: 0px 0px 0px -20px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">的</section></section></section><section style="margin: 0px 0px 0px -20px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">一</section></section></section><section style="margin: 0px 0px 0px -20px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">年</section></section></section></section></section></section><section data-tools="135编辑器" data-id="96912" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 30px auto 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: -30px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">三</section></section></section><section style="margin: 0px 0px 0px -20px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">大</section></section></section><section style="margin: 0px 0px 0px -20px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">精</section></section></section><section style="margin: 0px 0px 0px -20px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEonia6ZabKT29BFYMAZsq5dIRGuTkoNaq1Gl6olUt2ibkmCSaib7wmjejFQ/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 25px; max-width: 100%; box-sizing: border-box; font-size: 20px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">彩</section></section></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="96905" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 10px auto; padding: 0px 0px 1em; max-width: 100%; box-sizing: border-box; width: 784px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; width: 80px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.322314049586777" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC6T1Ahicengcu2gQ0PNKyQErP71KAamUYlEicMHkfLFHVrNPSY3ZpgICHVBsicsomdW8GBkxrCB4LXjg/640?wx_fmt=png" data-type="png" data-w="121" data-width="100%" _width="80px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ce948475d3a57c11499bd3dc08dfc1d33.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 80px !important; visibility: visible !important;" title="ce948475d3a57c11499bd3dc08dfc1d33.jpg" alt="ce948475d3a57c11499bd3dc08dfc1d3.jpg"/></section><section data-brushtype="text" style="margin: -52px 0px 0px -3px; padding: 0px; max-width: 100%; text-align: center; font-size: 18px; font-weight: bold; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">0<span data-original-title="" title="" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">1</span></section></section></section><section data-tools="135编辑器" data-id="96893" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">0</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">0</section></section></section></section><section style="margin: -52px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 60px; box-sizing: border-box !important; word-wrap: break-word !important;"></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 60px; box-sizing: border-box !important; word-wrap: break-word !important;"></section></section><section data-width="100%" style="margin: 1em 0px 0px; padding: 0px; max-width: 100%; width: 784px; box-sizing: border-box !important; word-wrap: break-word !important;"></section><section data-width="100%" style="margin: 1em 0px 0px; padding: 0px; max-width: 100%; width: 784px; box-sizing: border-box !important; word-wrap: break-word !important;"><br/></section><section style="margin: 0px; padding: 0px 1em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(225, 7, 6); border-right-width: 1px; border-right-style: solid; border-right-color: rgb(225, 7, 6); word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; text-align: justify; letter-spacing: 1.5px; line-height: 1.75em; color: rgb(51, 51, 51); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">二十五载耕耘，WINDOOR博览会一直携手来自世界各地的铝门窗幕墙精英企业，发布企业新产品、新战略、新举措，展示新研发技术，共同打造专业的门窗幕墙新产品首秀平台。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">广州保利世贸博览馆南丰国际会展中心双馆联动展出并同期举办学术交流、房地产高峰论坛、星品评选、百强门窗评选及智能家居高峰论坛等系列活动，精彩不断!</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; caret-color: rgb(51, 51, 51); text-indent: 32px; font-family: Verdana, Tahoma, Arial; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.4533333333333333" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEoxbibrpIEJXlgvcLDAQYUOoic8CU4bia4srgtwhyGsHoK38Qib6UlkEibib7w/640?wx_fmt=png" data-type="png" data-w="1200" data-width="100%" title="f354824fe457af86ecf3610f864d33e91.jpg" _width="300px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f354824fe457af86ecf3610f864d33e91.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); text-align: start; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" alt="f354824fe457af86ecf3610f864d33e9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">2020年，HOPPE 好博的全新感应开启把手HandsFree获得了第26届铝门窗幕墙的<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">创新星品奖</strong>，该产品将会在<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">星品展位</strong>展出。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(51, 51, 51); font-family: Verdana, Tahoma, Arial; font-size: 16px; text-indent: 32px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="2.852" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEoQDrBYcianapZW814FiaW3dDd7EMzTG1BuH37zMS8fXl4WjVazpibdThIA/640?wx_fmt=jpeg" data-type="jpeg" data-w="750" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/1c529992e644f6619b2f851cdedc93b91.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="1c529992e644f6619b2f851cdedc93b91.jpg" alt="1c529992e644f6619b2f851cdedc93b9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博入户门 eHandle 感应开启技术让您无需停下手上繁忙的业务也可以轻松开门。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">房屋主人只要靠近门，大拉手就会接收到无线钥匙发出的加密信号。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">然后大拉手底部的射灯会自动亮起，说明房屋主人被允许进入房间。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">房屋主人只需用脚扫过射灯的光线，门便会自动开启，简单方便，无需触碰。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(51, 51, 51); font-size: 17px; letter-spacing: 0.5440000295639038px; font-family: -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="1.78" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZu238uoOegiaGHPHZRdowKWiaPd3FS1qHW14YA7UeE8yqF3U7Z8FgWwyg/640?wx_fmt=gif" data-type="gif" data-w="200" _width="200px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZu238uoOegiaGHPHZRdowKWiaPd3FS1qHW14YA7UeE8yqF3U7Z8FgWwyg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 200px !important; visibility: visible !important;"/></p></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 784px; transform: scaleY(-1); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.06548672566371681" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6GO14iaBbMsb8nhtuKgCR0Nm8U8rIjiaW79UeAHgfB8WurIywfe5hBicAw/640?wx_fmt=png" data-type="png" data-w="565" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2419472b64199c9ac6db7e605bb47cbe.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2419472b64199c9ac6db7e605bb47cbe.jpg" alt="2419472b64199c9ac6db7e605bb47cbe.jpg"/></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="96905" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 10px auto; padding: 0px 0px 1em; max-width: 100%; box-sizing: border-box; width: 784px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; width: 80px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.322314049586777" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC6T1Ahicengcu2gQ0PNKyQErP71KAamUYlEicMHkfLFHVrNPSY3ZpgICHVBsicsomdW8GBkxrCB4LXjg/640?wx_fmt=png" data-type="png" data-w="121" data-width="100%" _width="80px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ce948475d3a57c11499bd3dc08dfc1d34.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 80px !important; visibility: visible !important;" title="ce948475d3a57c11499bd3dc08dfc1d34.jpg" alt="ce948475d3a57c11499bd3dc08dfc1d3.jpg"/></section><section data-brushtype="text" style="margin: -52px 0px 0px -3px; padding: 0px; max-width: 100%; text-align: center; font-size: 18px; font-weight: bold; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">0<span data-original-title="" title="" data-num="2" aria-describedby="tooltip398380" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</span></section></section></section><section data-tools="135编辑器" data-id="96893" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">0</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">0</section></section></section></section><section style="margin: -52px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 60px; box-sizing: border-box !important; word-wrap: break-word !important;"></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 60px; box-sizing: border-box !important; word-wrap: break-word !important;"></section></section><section data-width="100%" style="margin: 1em 0px 0px; padding: 0px; max-width: 100%; width: 784px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.06548672566371681" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6GO14iaBbMsb8nhtuKgCR0Nm8U8rIjiaW79UeAHgfB8WurIywfe5hBicAw/640?wx_fmt=png" data-type="png" data-w="565" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2419472b64199c9ac6db7e605bb47cbe1.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2419472b64199c9ac6db7e605bb47cbe1.jpg" alt="2419472b64199c9ac6db7e605bb47cbe.jpg"/></section><section style="margin: 0px; padding: 0px 1em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(225, 7, 6); border-right-width: 1px; border-right-style: solid; border-right-color: rgb(225, 7, 6); word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; text-align: justify; letter-spacing: 1.5px; line-height: 1.75em; color: rgb(51, 51, 51); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">纽伦堡门窗幕墙展（FENSTERBAU FRONTALE）欧洲地区一流的，极具影响力的关于门窗技术方面的大展览盛会，它是由纽伦堡会展公司NürnbergMesse GmbH自1988起开始举办, 是世界上规模较大、水平较高、较具专业代表性的门窗幕墙业盛会，也是全球知名的门窗幕墙展之一。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">每两年，全世界门窗幕墙行业都会在该展会汇聚一堂。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">作为世界顶级展会，该展会引领潮流，不仅为这个繁荣的行业提供了更多展示的空间，也为各细分市场提供了更广泛和深层次的产品展示。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">展商和专业采购商们可以在这里找到决定市场前景的创新产品和技术、门窗幕墙领域更高的市场 、更多的机械、设备展示及贴身的服务及未来幕墙行业的新材料和加固系统。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">2020年，HOPPE 好博将会继续在纽伦堡门窗幕墙展隆重亮相。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">届时欢迎各位来到德国，光临好博<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">展台H4/4-115</strong>！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 0.5440000295639038px; font-size: 16px; caret-color: rgb(51, 51, 51); text-align: left; font-family: -apple-system, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5555555555555556" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEoRnTw6I7GicicDrDsUF8S9RUaNd5jFOl1mmFJicUpRnuyODv1icCCiaTY6icg/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" data-width="100%" title="c2ca3c0230847330be1bfd8c2bb72d701.jpg" _width="300px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c2ca3c0230847330be1bfd8c2bb72d701.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" alt="c2ca3c0230847330be1bfd8c2bb72d70.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 11px; color: rgb(191, 191, 191); font-family: arial, helvetica, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">2018年HOPPE 好博<span style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">纽伦堡幕墙展台上人山人海</span></span></p></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 784px; transform: scaleY(-1); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.06548672566371681" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6GO14iaBbMsb8nhtuKgCR0Nm8U8rIjiaW79UeAHgfB8WurIywfe5hBicAw/640?wx_fmt=png" data-type="png" data-w="565" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2419472b64199c9ac6db7e605bb47cbe2.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2419472b64199c9ac6db7e605bb47cbe2.jpg" alt="2419472b64199c9ac6db7e605bb47cbe.jpg"/></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="96905" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 10px auto; padding: 0px 0px 1em; max-width: 100%; box-sizing: border-box; width: 784px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; width: 80px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.322314049586777" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC6T1Ahicengcu2gQ0PNKyQErP71KAamUYlEicMHkfLFHVrNPSY3ZpgICHVBsicsomdW8GBkxrCB4LXjg/640?wx_fmt=png" data-type="png" data-w="121" data-width="100%" _width="80px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ce948475d3a57c11499bd3dc08dfc1d35.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 80px !important; visibility: visible !important;" title="ce948475d3a57c11499bd3dc08dfc1d35.jpg" alt="ce948475d3a57c11499bd3dc08dfc1d3.jpg"/></section><section data-brushtype="text" style="margin: -52px 0px 0px -3px; padding: 0px; max-width: 100%; text-align: center; font-size: 18px; font-weight: bold; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">0<span data-original-title="" title="" data-num="3" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">3</span></section></section></section><section data-tools="135编辑器" data-id="96893" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">0</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">0</section></section></section></section><section style="margin: -52px 0px 0px; padding: 0px; max-width: 100%; display: flex; justify-content: space-between; align-items: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 60px; box-sizing: border-box !important; word-wrap: break-word !important;"></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 60px; box-sizing: border-box !important; word-wrap: break-word !important;"></section></section><section data-width="100%" style="margin: 1em 0px 0px; padding: 0px; max-width: 100%; width: 784px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.06548672566371681" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6GO14iaBbMsb8nhtuKgCR0Nm8U8rIjiaW79UeAHgfB8WurIywfe5hBicAw/640?wx_fmt=png" data-type="png" data-w="565" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2419472b64199c9ac6db7e605bb47cbe3.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2419472b64199c9ac6db7e605bb47cbe3.jpg" alt="2419472b64199c9ac6db7e605bb47cbe.jpg"/></section><section style="margin: 0px; padding: 0px 1em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(225, 7, 6); border-right-width: 1px; border-right-style: solid; border-right-color: rgb(225, 7, 6); word-wrap: break-word !important;"><section data-autoskip="1" style="margin: 0px; padding: 1em 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; text-align: justify; letter-spacing: 1.5px; line-height: 1.75em; color: rgb(51, 51, 51); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">中国国际门窗幕墙博览会FENESTRATION BAU China（简称FBC）迄今已有17 年的历史，致力于整合门窗幕墙创新产品、技术、解决方案及商业合作模式的发掘，助力行业企业的发展及技术创新，是目前亚太地区专业门窗幕墙系统解决方案旗舰博览会。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">该展会起源于“中国门窗博览会”(Fenestration China)。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">今年，FENESTRATION BAU China 2020中国国际门窗幕墙博览会将于10月29日-11月1日在北京中国国际展览中心（新馆）盛大举办。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">30多年来，HOPPE 一直在国际领先的门窗幕墙贸易博览会 BAU上展出，展示其高质量和创新的解决方案。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">届时，欢迎莅临</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">好博<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">展台E2.208</strong></span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 17px; box-sizing: border-box !important; word-wrap: break-word !important;">共洽商机！</span></p></section><section data-width="100%" style="margin: 0px; padding: 1em 0px 0px; max-width: 100%; box-sizing: border-box; width: 750px; word-wrap: break-word !important;"><img data-ratio="0.8408333333333333" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEoSHR41JQTUEjoP4ic7MtkppZ95wDlAYicyvQKWsOQvn0dyHe6xRtXthtA/640?wx_fmt=png" data-type="png" data-w="1200" data-width="100%" title="fbdd29496e20b34e02400c984d5b0b501.jpg" _width="300px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/fbdd29496e20b34e02400c984d5b0b501.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" alt="fbdd29496e20b34e02400c984d5b0b50.jpg"/></section></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 784px; transform: scaleY(-1); box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.06548672566371681" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6GO14iaBbMsb8nhtuKgCR0Nm8U8rIjiaW79UeAHgfB8WurIywfe5hBicAw/640?wx_fmt=png" data-type="png" data-w="565" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2419472b64199c9ac6db7e605bb47cbe4.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2419472b64199c9ac6db7e605bb47cbe4.jpg" alt="2419472b64199c9ac6db7e605bb47cbe.jpg"/></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-tools="135编辑器" data-id="96885" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; width: 40px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.2903225806451613" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6ynLIbLIweuzERBxRpSB9dsnmK4IOhnxCW5w7pQL32d50HWJkIRbSzQ/640?wx_fmt=png" data-type="png" data-w="62" data-width="100%" _width="40px" src="https://hoppe.jzdsh.com/upload/ue/img/a01d3a63e2636003ee5c46f2c021dd7d6.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 40px !important; visibility: visible !important;" title="a01d3a63e2636003ee5c46f2c021dd7d6.jpg" alt="a01d3a63e2636003ee5c46f2c021dd7d.jpg"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">迎</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">新</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">春</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">贺</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">新</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">禧</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 40px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.2903225806451613" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC7aAThYvAjffwYibQiccfATI6ynLIbLIweuzERBxRpSB9dsnmK4IOhnxCW5w7pQL32d50HWJkIRbSzQ/640?wx_fmt=png" data-type="png" data-w="62" data-width="100%" _width="40px" src="https://hoppe.jzdsh.com/upload/ue/img/a01d3a63e2636003ee5c46f2c021dd7d7.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; transform: scaleX(-1); box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 40px !important; visibility: visible !important;" title="a01d3a63e2636003ee5c46f2c021dd7d7.jpg" alt="a01d3a63e2636003ee5c46f2c021dd7d.jpg"/></section></section></section></section><section data-tools="135编辑器" data-id="96883" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: center; align-items: center; color: rgb(255, 255, 255); flex: 1 1 0%; font-weight: bold; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">鼠</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">不</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">尽</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">的</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">喜</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEom0a8ABEyflwVVgV27Oib3zh6buNRpjTXvOo8wnoOEa4S1pRBN8kO4QA/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center center; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 15px; max-width: 100%; box-sizing: border-box; font-size: 16px; text-align: center; word-wrap: break-word !important;"><section data-brushtype="text" style="margin: 0px 0px 2px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">气</section></section></section></section></section></section></p><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.6650641025641025" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEo0ia0eSqfIFz1xQBPG4WbZjPyDHJzFZxGyGSN0PAT7YScTtYtsnFk2vQ/640?wx_fmt=gif" data-type="gif" data-w="624" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZA1GC9ObcL4hlxWg6ibPKEo0ia0eSqfIFz1xQBPG4WbZjPyDHJzFZxGyGSN0PAT7YScTtYtsnFk2vQ/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">你的新年愿望是什么呢？</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">欢迎在下方评论区留言，参与话题互动。</span></p><p></p><p><section data-tools="135编辑器" data-id="94462" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 1em 0px; max-width: 100%; box-sizing: border-box; width: 784px; text-align: center; word-wrap: break-word !important;"><img data-ratio="0.10063897763578275" data-src="https://mmbiz.qpic.cn/mmbiz_gif/7QRTvkK2qC7wNIkibhfGkXx894K8IcOH1wWJHibvzXm7mHQFHmZwDvKlVa2xjpLjDXOUbmKlWicUVLiaeWqcgAnicTw/640?wx_fmt=gif" data-type="gif" data-w="626" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/7QRTvkK2qC7wNIkibhfGkXx894K8IcOH1wWJHibvzXm7mHQFHmZwDvKlVa2xjpLjDXOUbmKlWicUVLiaeWqcgAnicTw/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="2" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></section></section></p><p></p><p><br/></p>', 0, 0, 0, '2020-01-24', '2020-09-17 20:34:12'),
	(44, '阳台门把手也有颜色搭配新玩法！', '/upload/home/news/封面2.png', '<p><br/></p><p><br/></p><section class="" data-tools="135编辑器" data-id="2329" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" text-align:="" caret-color:="" color:="" box-sizing:="" border-box="" word-wrap:="" break-word=""><section style="margin: 0px; padding: 10px 2px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 780px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="" data-cropselx1="0" data-cropselx2="780" data-cropsely1="0" data-cropsely2="492" data-ratio="0.687" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYOZyibu9c5zibqbFvqy4bRx6hric7fCHw3Nzyo8289jeYarZh8dYP8s6gFrINPial62p85Im742I40SA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/783e7644e4804e420478d58652eee44a.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; border-top-left-radius: 20px; border-top-right-radius: 20px; border-bottom-right-radius: 20px; border-bottom-left-radius: 20px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="783e7644e4804e420478d58652eee44a.jpg" alt="783e7644e4804e420478d58652eee44a.jpg"/></section><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 780px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-bgless="spin" data-bglessp="280" data-bgopacity="60%" style="margin: -2.8em 0px 0px 1.2em; padding: 0px 2px 3px 0px; max-width: 100%; box-sizing: border-box; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgba(239, 172, 223, 0.4); z-index: 999; word-wrap: break-word !important;"><section data-bgless="spin" data-bglessp="280" data-bgopacity="6%" style="margin: -10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; z-index: 999; width: 4.5em; height: 4.5em; line-height: 4.5em; font-size: 18px; letter-spacing: 2px; text-align: center; color: rgb(255, 255, 255); display: inline-block; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(239, 172, 223); word-wrap: break-word !important;">多主题</section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; justify-content: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-bgless="spin" data-bglessp="240" data-bgopacity="60%" style="margin: -6em 2em 0px 0px; padding: 0px 2px 5px 0px; max-width: 100%; box-sizing: border-box; background-color: rgba(144, 211, 220, 0.4); z-index: 999; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; word-wrap: break-word !important;"><section data-bgless="spin" data-bglessp="240" data-bgopacity="6%" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; z-index: 999; width: 6em; height: 6em; font-size: 20px; text-align: justify; color: rgb(255, 255, 255); display: inline-block; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(144, 211, 220); word-wrap: break-word !important;"><section style="margin: 1.3em auto 0px; padding: 0px; max-width: 100%; width: 5.5em; font-size: 14px; line-height: 1.5em; box-sizing: border-box !important; word-wrap: break-word !important;">室内是雅静的生活区域室外是灵动的花鸟世界</section></section></section></section><section data-width="100%" style="margin: -3.5em 0px 0px; padding: 0px; max-width: 100%; width: 780px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><section data-width="100%" style="margin: -3.5em 0px 0px; padding: 0px; max-width: 100%; width: 780px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="" data-cropselx1="0" data-cropselx2="574" data-cropsely1="0" data-cropsely2="389" data-ratio="0.673972602739726" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYOZyibu9c5zibqbFvqy4bRx6OOgicVDBRHcjIlia0Q6iaUTr0Bic3j9Vibm5GpQYjP7Vfqx33cwMW9OIu5Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="1095" data-width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/9a3332a6233d882e61318c639d4d4dc1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; border-top-left-radius: 20px; border-top-right-radius: 20px; border-bottom-right-radius: 20px; border-bottom-left-radius: 20px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="9a3332a6233d882e61318c639d4d4dc1.jpg" alt="9a3332a6233d882e61318c639d4d4dc1.jpg"/></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">在房屋装修过程中，为了可以更好的保证装修施工工程效果更完美，同时也可以给自己带来更好的装修体验，大家在房屋装修过程中，一定要合理选择风格主题。最重要的就是适合的装修风格，能够让自己在日后居住的过程中带来更好的满足感和幸福感。所以，在确定了合适的装修风格主题之后，才可以让装修工程更合理的设计。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">当施工开始后，大家通常会更重视施工项目质量的好坏，反而忽略了室内装修色彩搭配的相关问题。而室内装潢里，硬装的色彩搭配又是非常重要的环节。合理的色彩搭配能够为室内增添良好的氛围，并让人感到舒适愉悦。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">但是，当室内与室外各有不同主题的时候，色彩的一致性就受到了挑战。在精致的生活中，当大环境的主题定下来后，对细节的把控显得尤为重要。就好比，对阳台门把手的色彩选择上，室内室外风格不一致怎么办？</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">主题色彩如何搭配？</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">您还在纠结吗？</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">叮咚！这里有一封给您的信</span>！</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages __bg_gif" data-ratio="0.3709677419354839" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYOZyibu9c5zibqbFvqy4bRx6wxU20v6Z7ianHVpoPtRHx3ITuRWpSIfbRzTJ89KZhmaaFOXtQUuqHHg/640?wx_fmt=gif" data-type="gif" data-w="62" _width="91px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYOZyibu9c5zibqbFvqy4bRx6wxU20v6Z7ianHVpoPtRHx3ITuRWpSIfbRzTJ89KZhmaaFOXtQUuqHHg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 91px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">谁说多种风格不能两全其美</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">就让</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博</strong></span><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">成为您的最爱！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; transform: translate3d(0px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; height: 360px; vertical-align: top; overflow: hidden auto; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 40px 0px 20px; padding: 0px; max-width: 100%; transform: translate3d(0px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 10px 10px 80px; max-width: 100%; box-sizing: border-box; vertical-align: top; background-size: 99.86509704589844%; background-attachment: scroll; border-width: 0px; background-color: rgb(254, 255, 255); line-height: 1.8; box-shadow: rgb(102, 102, 102) 0px 0px 5px; word-wrap: break-word !important; background-position: 0% 0%; background-repeat: no-repeat repeat;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section class="" data-autoskip="1" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(51, 59, 108); line-height: 1.8em; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(0, 0, 0); font-size: 17px; text-align: center; font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(51, 59, 108); line-height: 1.8; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">(▲向上滑动查看最新色彩搭配）</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(0, 0, 0); font-size: 17px; text-align: center; font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; word-wrap: break-word !important;"><section class="" data-autoskip="1" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(51, 59, 108); line-height: 1.8em; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">全新阳台门把手色彩搭配:</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">更灵活，更多的设计选择！</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">新的HOPPE 好博阳台门把手，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">可根据窗的室内侧与室外侧的不同色彩自由搭配，方轴独立包装。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">亮点:可以根据客户的要求更精确地选择</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">例如，内外可以有不同的颜色搭配，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">也可以使用一个矮脖子把手搭配纱窗。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">目前，HOPPE 好博的Tokyo, New York, Toulon, Luxembourg, Atlanta, Brest, London系列都可自由选择搭配哦！</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.555" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4F2EvyJrXd8RIqos6yOGhXCZ0W3M8ONQiakvuTBxDwSaFOCAMo2UTjjw/640?wx_fmt=gif" data-type="gif" data-w="400" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4F2EvyJrXd8RIqos6yOGhXCZ0W3M8ONQiakvuTBxDwSaFOCAMo2UTjjw/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section></section></section><section style="margin: -120px 0px 10px; padding: 0px; max-width: 100%; text-align: center; transform: translate3d(0px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><img class="" data-ratio="0.46921797004991683" data-src="https://mmbiz.qpic.cn/mmbiz_png/yqVAqoZvDibGwwGGhKKxn4akcNpC4GoG9vxeL09ujul1qNynYNu7Isxa0VsmDhOed7uBwWP5qBPMDCoDlib8ibwsA/640?wx_fmt=png" data-type="png" data-w="601" data-width="100%" width="100%" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/f82b55698e97bf7f5a44c88d31494abc1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; box-shadow: rgb(0, 0, 0) 0px 0px 0px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 300px !important;" title="f82b55698e97bf7f5a44c88d31494abc1.jpg" alt="f82b55698e97bf7f5a44c88d31494abc.jpg"/></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">看完了<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 35, 76); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博</span>的阳台门把手色彩搭配方案，您是否又多了一种装修思路呢！</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">在选择装修风格的过程当中，建议大家结合家庭实际空间来进行设计和考量，多彩风格会更适合现代的家庭空间。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section class="" data-tools="135编辑器" data-id="89517" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section class="" style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; background-image: url(" wx_fmt="jpeg" background-size:="" height:="" box-sizing:="" border-box="" word-wrap:="" break-word="" background-position:="" left="" background-repeat:="" no-repeat="" section="" class="rich_pages  __bg_gif" p="" span="" strong="" hoppe="" br="" img="" data-ratio="0.555" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4F2EvyJrXd8RIqos6yOGhXCZ0W3M8ONQiakvuTBxDwSaFOCAMo2UTjjw/640?wx_fmt=gif" data-type="gif" data-w="400" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4F2EvyJrXd8RIqos6yOGhXCZ0W3M8ONQiakvuTBxDwSaFOCAMo2UTjjw/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="2" data-fail="0" new="">&nbsp;</section></section></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p></section></section><p><br/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2019-12-30', '2020-09-17 20:53:12'),
	(45, 'HOPPE 好博衷心祝您圣诞快乐！', '/upload/home/news/封面3.png', '<h2 class="rich_media_title" id="activity-name" style="white-space: normal; margin: 0px 0px 14px; padding: 0px; font-size: 22px; line-height: 1.4;"><br/></h2><p><span class="rich_media_meta rich_media_meta_text" style="margin: 0px 10px 10px 0px; padding: 0px; display: inline-block; vertical-align: middle; font-size: 15px; color: rgba(0, 0, 0, 0.3);">HOPPE好博集团</span>&nbsp;<span class="rich_media_meta rich_media_meta_nickname" id="profileBt" style="margin: 0px 10px 10px 0px; padding: 0px; display: inline-block; vertical-align: middle; font-size: 15px; position: relative;"><a id="js_name" style="margin: 0px; padding: 0px; color: var(--weui-LINK); cursor: pointer;">HOPPE好博集团&nbsp;</a></span><span id="publish_time" class="rich_media_meta rich_media_meta_text" style="margin: 0px 10px 10px 0px; padding: 0px; display: inline-block; vertical-align: middle; font-size: 15px; color: rgba(0, 0, 0, 0.3);">2019-12-24</span></p><p></p><p><section class="" data-tools="135编辑器" data-id="94197" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 1em 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; width: 6em; box-sizing: border-box !important; word-wrap: break-word !important;"><img class=" __bg_gif" data-ratio="0.38303341902313626" data-src="https://mmbiz.qpic.cn/mmbiz_gif/7QRTvkK2qC48QFHh3VibY1KQ5JZGhZ6TwFXYZc51Nia9qFEiadNYHyZbdIcZVcicibxpKo5bAlRkjtcicvtXIXxLLsNw/640?wx_fmt=gif" data-type="gif" data-w="389" data-width="100%" _width="96px" src="https://mmbiz.qpic.cn/mmbiz_gif/7QRTvkK2qC48QFHh3VibY1KQ5JZGhZ6TwFXYZc51Nia9qFEiadNYHyZbdIcZVcicibxpKo5bAlRkjtcicvtXIXxLLsNw/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 96px !important; visibility: visible !important;"/></section></section></section><section class="" data-tools="135编辑器" data-id="96525" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section class="" style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px; max-width: 100%; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px; max-width: 100%; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC4xoRYaic9j05KWBFAn6qZCeYhbs2FBdicKqWyE2C6gvQcVMpaJ8skAbFeGAUnYSHtNZCjpmthzWcicw/640?wx_fmt=png&quot;); background-size: 100%; box-sizing: border-box !important; word-wrap: break-word !important; background-position: center bottom; background-repeat: no-repeat no-repeat;"><img class="" data-ratio="0.15171288743882544" data-src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC4xoRYaic9j05KWBFAn6qZCeYhbs2FBdicKqWyE2C6gvQcVMpaJ8skAbFeGAUnYSHtNZCjpmthzWcicw/640?wx_fmt=png" data-type="png" data-w="613" data-width="100%" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_png/7QRTvkK2qC4xoRYaic9j05KWBFAn6qZCeYhbs2FBdicKqWyE2C6gvQcVMpaJ8skAbFeGAUnYSHtNZCjpmthzWcicw/640?wx_fmt=png&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; opacity: 0; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></section></section><section data-width="96%" style="margin: -10px auto 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 752.625px; border-bottom-left-radius: 12px; border-bottom-right-radius: 12px; border-right-width: 5px; border-bottom-width: 5px; border-left-width: 5px; border-style: none solid solid; border-right-color: rgb(212, 24, 37); border-bottom-color: rgb(212, 24, 37); border-left-color: rgb(212, 24, 37); word-wrap: break-word !important;"><section data-autoskip="1" class="" style="margin: 0px; padding: 1em; max-width: 100%; box-sizing: border-box; font-size: 14px; text-align: justify; letter-spacing: 1.5px; line-height: 1.75em; color: rgb(5, 133, 97); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">2019年即将过去<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">我们衷心感谢您在这一年<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">与HOPPE 好博的精诚合作<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">祝您和您的家人</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">圣诞快乐</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">新的一年万事如意！</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; caret-color: rgb(5, 133, 97); font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><img class=" __bg_gif" data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/7QRTvkK2qC48QFHh3VibY1KQ5JZGhZ6Tw7EOEMhX74aJlGJlReHc6eGyfxLgEDoL4amvulvsJDZkuF03MZVQfng/640?wx_fmt=gif" data-type="gif" data-w="500" data-width="100%" height="62" width="62" _width="91px" src="https://mmbiz.qpic.cn/mmbiz_gif/7QRTvkK2qC48QFHh3VibY1KQ5JZGhZ6Tw7EOEMhX74aJlGJlReHc6eGyfxLgEDoL4amvulvsJDZkuF03MZVQfng/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; display: block; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 91px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4IUJq8NFxh6O2LNzKWapKoYibNKkw2ZQQtgHctWiajtjdUVL2McEkcBUg/640?wx_fmt=jpeg" data-type="jpeg" data-ratio="0.776" data-w="750" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/ea278055c5d3976d88c8a6a438a17b16.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(5, 133, 97); text-align: center; font-family: mp-quote, -apple-system-font, BlinkMacSystemFont, Arial, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="ea278055c5d3976d88c8a6a438a17b16.jpg" alt="ea278055c5d3976d88c8a6a438a17b16.jpg"/></p></section></section></section></section><section class="" data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section class="" data-tools="135编辑器" data-id="96529" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px auto; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px 15px; max-width: 100%; display: flex; justify-content: space-between; align-items: flex-end; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"></section></section></section></p><p></p><p><br/></p>', 0, 0, 0, '2019-12-24', '2020-09-17 20:55:56'),
	(46, 'HOPPE 好博授权经销店——坐标：镇江', '/upload/home/news/封面4.png', '<p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博授权经销店以定位清晰的设计展示 HOPPE 好博品牌欧洲制作五金，在品类繁多的五金市场中始终保持高品质、高辨识度形象，吸引了越来越多的高端五金零售商加入 HOPPE 好博授权经销店的队伍。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.5542570951585977" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4Hsxc9dfCqNbulj6iaIP91PbNrsibf2upxon0D3X7icCo3FriceHfMS0Dhg/640?wx_fmt=png" data-type="png" data-w="1198" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2945e8c82adfcb5883d7b0a29fbf0363.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2945e8c82adfcb5883d7b0a29fbf0363.jpg" alt="2945e8c82adfcb5883d7b0a29fbf0363.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;">欢迎光临我们在镇江的授权店，体验和选购！</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.5555555555555556" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4DrMkvKicLqyYnUG0iawP1R3AWTnvsia9ZMVZxXzoTZibVY7qWj6M4cVqQA/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/88ede4de6eac1c3b7b78f0d0ccbf88fe.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="88ede4de6eac1c3b7b78f0d0ccbf88fe.jpg" alt="88ede4de6eac1c3b7b78f0d0ccbf88fe.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.49296875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw4sfxMXHgRT7IP6ibpzZ4sDF2K5TrGC4peHPDDnYDBjBnehjU7MjoxPTw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/3bc03271e892b0521060481a4503e6502.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="3bc03271e892b0521060481a4503e6502.jpg" alt="3bc03271e892b0521060481a4503e650.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.55546875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYyicvcbDdGU0hbQXdpFpsw47wTjc6nDfZ5bmrOoKTiaEZ1d4kxPric3e2EK2lDx1espjUBV0Ws2D0OQ/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/f577f54cabd8bffee91247c2754263c0.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="f577f54cabd8bffee91247c2754263c0.jpg" alt="f577f54cabd8bffee91247c2754263c0.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">加盟联系电话：021-31116650 或发送电子邮件至 info.china@hoppe.com</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9828125" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabb13yZQWju7w5ZoKpMUR80t82cPTIt8iaYupA46icVDkoc2m2452p6s1wmrGtJNpA1PIUezcEuz6zA/640?wx_fmt=png" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7d4ba5b2f7e72758a8d0e24297f664301.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 300px !important;" title="7d4ba5b2f7e72758a8d0e24297f664301.jpg" alt="7d4ba5b2f7e72758a8d0e24297f66430.jpg"/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2019-12-23', '2020-09-17 20:59:48'),
	(47, '新年优惠，就“鼠”HOPPE 好博！', '/upload/home/news/封面5.png', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/65bcf4d9ee3e094b0d5f63c47f39c337.jpg" title="65bcf4d9ee3e094b0d5f63c47f39c337.jpg" alt="65bcf4d9ee3e094b0d5f63c47f39c337.jpg"/></p>', 0, 0, 0, '2019-12-14', '2020-09-17 21:01:19'),
	(48, '严正声明！', '/upload/home/news/WX20200917-195647@2x.png', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/3dcd15b015f03b61cec5dc395e540d87.jpg"  title="3dcd15b015f03b61cec5dc395e540d87.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/35c28809ed26b8776d981b63ea95c783.jpg"  title="35c28809ed26b8776d981b63ea95c783.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/6aacac3b9c10ecc4950aea1d5ac0e280.jpg"  title="6aacac3b9c10ecc4950aea1d5ac0e280.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/617edf9336c602f8b884ccd1547142d1.jpg"  title="617edf9336c602f8b884ccd1547142d1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/799370b430b001c821f983b43ec8f55d.jpg"  title="799370b430b001c821f983b43ec8f55d.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1463eb06f89dde03201263bd85fe41ed.jpg"  title="1463eb06f89dde03201263bd85fe41ed.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1163021b12109ef9824b43dfbce09bf4.jpg"  title="1163021b12109ef9824b43dfbce09bf4.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/bfd0f146759182fdccfa87b3194ead98.jpg"  title="bfd0f146759182fdccfa87b3194ead98.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/c4e354a3eee8e80a7fb48fd0a48cee9c.jpg"  title="c4e354a3eee8e80a7fb48fd0a48cee9c.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/c08bf73056699e66ff264a3ce3f6da0e.jpg"  title="c08bf73056699e66ff264a3ce3f6da0e.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/d1f4e80a215504e4049e1563ae45430c.jpg"  title="d1f4e80a215504e4049e1563ae45430c.jpg"/></p><p><br/></p>', 0, 0, 0, '2019-12-03', '2020-09-17 21:02:56'),
	(49, '见证HOPPE 好博高光时刻，FBC中国国际门窗幕墙博览会圆满闭幕', '/upload/home/news/WX20200917-195711@2x.png', '<p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.164" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkySCCY1zESyG3WgwEWgRMNltiamPmDJWaDvf8R2Pr3icUrFYQhTbmEoKw/640?wx_fmt=png" data-type="png" data-w="1000" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/963abf787d563dbca6cfec9dd86031b0.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="963abf787d563dbca6cfec9dd86031b0.jpg" alt="963abf787d563dbca6cfec9dd86031b0.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.35078125" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LF3MOMzf4Ng0lawb3g9fZCTeXfyl528S4icEO51WicZuFicTfCTumPFEGzg/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/8230b57708051ddc8bff05e68cdcc8bb.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="8230b57708051ddc8bff05e68cdcc8bb.jpg" alt="8230b57708051ddc8bff05e68cdcc8bb.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;FENESTRATION BAU China 2019中国国际门窗幕墙博览会11月5-11月8日在上海新国际博览中心盛大举办，整合了慕尼黑BAU优势资源的FBC展会及会议获得空前成功，圆满闭幕。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;本次FBC博览会通过十余场专业技术研讨与上万种新品展示交流，带来了一场别开生面的行业盛会。本届博览会共有696家参展商，展览面积达到110,000平方米，大家纷纷展出最新的绿色、安全、智能门窗幕墙新品及创新材料解决方案，展期4天共接待专业观众及买家达到120,000人次。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.75" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LFUpib6ZEGIwL02XcnFfSGMwx13mAcRLFmsIEiaJsvHXiaeia1aVXPjssaEA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/cadc18c92b3fc883ce79226c18e0418e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="cadc18c92b3fc883ce79226c18e0418e.jpg" alt="cadc18c92b3fc883ce79226c18e0418e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; 30多年来，HOPPE 一直在国际领先的门窗幕墙贸易博览会 BAU上展出，展示其高质量和创新的解决方案。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;在今年的展台上，HOPPE 好博携全新eHandle智能把手；安全标准——SecuForte® 窗把手；带有 Resista® 十年表层质保的新色彩等新产品亮相，展台吸引了众多客户和同行前来参观学习，交流新产品新技术。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.75" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LFNibzLpzrhJ6y2KibdBaiaAoQRM0NOBIKlY3PE6iasRK8KJ0fJgVM6RSSXQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/3ee48fb6d92c1024c1c39ac91ed1d902.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="3ee48fb6d92c1024c1c39ac91ed1d902.jpg" alt="3ee48fb6d92c1024c1c39ac91ed1d902.jpg"/></p><p></p><p><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 105px; height: 80px; vertical-align: top; overflow: hidden; background-size: contain; background-attachment: scroll; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_gif/KianF0WE3MLk7Iib3y5LCfBwLdGOgD5m2U0zMHaicld6738yaicsTDiaFJw2yAKKe9HyJkp6EYxd7S4D0PkaxjhJscA/640?wx_fmt=gif&quot;); word-wrap: break-word !important; background-position: 50% 50%; background-repeat: no-repeat no-repeat;"><section powered-by="xiumi.us" style="margin: 25px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">1</p></section></section></section></section></p><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">便 捷 、安 全&nbsp;–</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE&nbsp;好博指纹开启</span></strong></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;近年来，生物识别技术的应用不再只限于高度戒备的场所。用稳定的生理特征 来识别身份已经越来越多地应用到了大众的日常生活中。其中，利用指纹识别 来替代钥匙就是最常见的一种。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;每个人的指纹都独一无二的，不会遗失，被偷窃或被替换。手指只需轻轻划过 指纹识别装置，门就能解锁。将指纹锁功能集成在大拉手或入户门把手上，比安装在其他地方操作更简便，一个步骤开门。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span></p><p></p><p><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 105px; height: 80px; vertical-align: top; overflow: hidden; background-size: contain; background-attachment: scroll; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_gif/KianF0WE3MLk7Iib3y5LCfBwLdGOgD5m2U0zMHaicld6738yaicsTDiaFJw2yAKKe9HyJkp6EYxd7S4D0PkaxjhJscA/640?wx_fmt=gif&quot;); word-wrap: break-word !important; background-position: 50% 50%; background-repeat: no-repeat no-repeat;"><section powered-by="xiumi.us" style="margin: 25px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">2</p></section></section></section></section></p><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">便 捷 –</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE&nbsp;好博感应开启</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博入户门 eHandle 感应开启技术让您无需停下手上繁忙的业务也可以轻松开门。房屋主人只要靠近门，大拉手就会接收到无线钥匙发出的加密信号。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;然后大拉手底部的射灯会自动亮起，说明房屋主人被允许进入房间。房屋主人只需用脚扫过射灯的光线，门便会自动开启，简单方便，无需触碰。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;内置的安全功能可防止您无意中在室内打开门锁。您可以根据不同的地面颜色切换光束的颜色，以确保其清晰可见。控制单元位于室内部分。</span></p><p></p><p><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 105px; height: 80px; vertical-align: top; overflow: hidden; background-size: contain; background-attachment: scroll; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_gif/KianF0WE3MLk7Iib3y5LCfBwLdGOgD5m2U0zMHaicld6738yaicsTDiaFJw2yAKKe9HyJkp6EYxd7S4D0PkaxjhJscA/640?wx_fmt=gif&quot;); word-wrap: break-word !important; background-position: 50% 50%; background-repeat: no-repeat no-repeat;"><section powered-by="xiumi.us" style="margin: 25px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">3<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section></p><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.75" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LF99aTibYLl6xhoVsBp5GnBicHcogFQ751LEzLJfNUGAUMfdib1Th6GJOIw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/afac6510db87b60627715bce0ddb4ba9.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="afac6510db87b60627715bce0ddb4ba9.jpg" alt="afac6510db87b60627715bce0ddb4ba9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博 SecuForte® 技术再次提高防盗标杆：带 SecuForte® 的窗把手用全新方式自动锁定——守住窗户要塞，想通过撬窗入室，难上加难。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;带 SecuForte® 窗把手只能在室内，且把把手向底座按压方可进行操作。从室外用蛮力开启，将可能导致把手脱落，窗户被锁死。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;由此，SecuForte®&nbsp;技术有效防止通过刺穿玻璃密封或在型材上钻孔去撬动窗把手以达到开窗入室目的。</span></p><p></p><p><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 105px; height: 80px; vertical-align: top; overflow: hidden; background-size: contain; background-attachment: scroll; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_gif/KianF0WE3MLk7Iib3y5LCfBwLdGOgD5m2U0zMHaicld6738yaicsTDiaFJw2yAKKe9HyJkp6EYxd7S4D0PkaxjhJscA/640?wx_fmt=gif&quot;); word-wrap: break-word !important; background-position: 50% 50%; background-repeat: no-repeat no-repeat;"><section powered-by="xiumi.us" style="margin: 25px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section class="" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">4</p></section></section></section></section></p><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.75" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LFfeH637FRBPYkVEZUJ2H7m0kQ17BauPXxDicSfeR2V595gSKFAtVpeDQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/924dccea88c02ed2273496e09d9a0101.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="924dccea88c02ed2273496e09d9a0101.jpg" alt="924dccea88c02ed2273496e09d9a0101.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">品质卓越的把手出新的潮流色彩啦:四个全新颜色-每一种都有亮光和丝光两种质感处理-适用于个人不同装修风格。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">比如,黑色和烟灰色能够突出室内多颜色家具的细节表现或加重同色调室内装修的风格气质。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">暖色调的铜可以很好地与天然木头和黄铜颜色表面处理搭配,豪华的内室采用金色把手会是不错的选择。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages __bg_gif " data-ratio="1.0418794688457609" data-s="300,640" data-type="gif" data-w="979" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tUNCSxh9icMonc0iboV4hsW2CzoSEEHFEKo6icQOibM5WW2dWdqbh0F7zZg/640?wx_fmt=gif" _width="56px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tUNCSxh9icMonc0iboV4hsW2CzoSEEHFEKo6icQOibM5WW2dWdqbh0F7zZg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 56px !important;"/><img class=" __bg_gif" data-ratio="0.5625" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LFVA2wTKeymgwsJibiaycOf8WeKtDyH4v6ljmxsQGqTaTfSJDP1JjGKekA/640?wx_fmt=gif" data-type="gif" data-w="480" height="270" title="点击查看源网页" width="480" _width="105px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaaboD0dGVXv9jJdJOP3s0LFVA2wTKeymgwsJibiaycOf8WeKtDyH4v6ljmxsQGqTaTfSJDP1JjGKekA/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); text-align: start; top: 133px; left: 182px; cursor: pointer; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 105px !important; visibility: visible !important;"/><img class="rich_pages __bg_gif " data-ratio="1.0397959183673469" data-s="300,640" data-type="gif" data-w="980" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tXcl19ZODLgw4UV29JXQKXt1kYbicoAeeyicAjQeQKa8xH8RAOUDm4IgQ/640?wx_fmt=gif" _width="57px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tXcl19ZODLgw4UV29JXQKXt1kYbicoAeeyicAjQeQKa8xH8RAOUDm4IgQ/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="2" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; text-align: start; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 57px !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;新色彩的一大优势是其持久的表现力,即使在高强度地使用环境或恶劣天气条件下依然表现”出色”!它们带有 Resista®&nbsp;十年表层质 保,随时接受检验.新的产品都通过欧标 EN 1670&nbsp;的测试。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-src="https://mmbiz.qpic.cn/mmbiz_gif/Stu8GN8e8U1QEwsNzLaP3UdCS1Gxib6E1DDfCbt85ZCPqLYjFRMpssm5nFFJW3ZFdKg7hg7yyMS5vxlpAmUFUSw/640?wx_fmt=gif" data-w="400" width="100%" data-type="gif" _width="73px" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/Stu8GN8e8U1QEwsNzLaP3UdCS1Gxib6E1DDfCbt85ZCPqLYjFRMpssm5nFFJW3ZFdKg7hg7yyMS5vxlpAmUFUSw/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="3" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); text-align: start; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 73px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;本次FBC展会已圆满落幕，我们期待下一次与您相见，您也可以通过公众号把您对我们的意见和建议留言给我们。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;展会落幕，团队还在路上，脚步还未停歇，初心仍未更改！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9828125" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabb13yZQWju7w5ZoKpMUR80t82cPTIt8iaYupA46icVDkoc2m2452p6s1wmrGtJNpA1PIUezcEuz6zA/640?wx_fmt=png" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7d4ba5b2f7e72758a8d0e24297f664302.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 300px !important;" title="7d4ba5b2f7e72758a8d0e24297f664302.jpg" alt="7d4ba5b2f7e72758a8d0e24297f66430.jpg"/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2019-11-21', '2020-09-17 21:08:08'),
	(50, 'HOPPE 好博授权经销店——坐标：常州', '/upload/home/news/WX20200917-195738@2x.png', '<p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博授权经销店以定位清晰的设计展示 HOPPE 好博品牌欧洲制作五金，在品类繁多的五金市场中始终保持高品质、高辨识度形象，吸引了越来越多的高端五金零售商加入 HOPPE 好博授权经销店的队伍。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.5546875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaae7EgwvCZpXCbhA3oD0CyVamyMfibGYWdnmWxDCMP19ObDwVu5YI3HlQWO7hsqJEyhft5d9xKEBeQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/89032eceba250f70698e8c75450bde8e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="89032eceba250f70698e8c75450bde8e.jpg" alt="89032eceba250f70698e8c75450bde8e.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"></span><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">欢迎光临我们在常州的授权店，体验和选购！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.5555555555555556" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaae7EgwvCZpXCbhA3oD0CyV7mcknxP6BbuRar4micics9T4VV5lIsViac6eicQLZJnVuGCGZ8DUca8DFw/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/2878401de06bfe206c816aa0953a6772.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="2878401de06bfe206c816aa0953a6772.jpg" alt="2878401de06bfe206c816aa0953a6772.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"></span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.5555555555555556" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaae7EgwvCZpXCbhA3oD0CyV8xxsBU3GGZCugbocQ1Po1JlibxOupISJPQCic62qX1iaerjiaibdib9XmSKg/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/c1d4b3bd706e4ee9dbb93e19e5e6bbf9.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="c1d4b3bd706e4ee9dbb93e19e5e6bbf9.jpg" alt="c1d4b3bd706e4ee9dbb93e19e5e6bbf9.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.5546875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaae7EgwvCZpXCbhA3oD0CyVOD7HAsTriaBLbMKO4QhGkQ9Wia6dHksGhVRp1QDl2l4IdPwpH53WAqrA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/c6b54b188801b9ec9d671624f676f392.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="c6b54b188801b9ec9d671624f676f392.jpg" alt="c6b54b188801b9ec9d671624f676f392.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">加盟联系电话：021-31116650 或发送电子邮件至 info.china@hoppe.com</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9828125" data-s="300,640" data-type="png" data-w="1280" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabb13yZQWju7w5ZoKpMUR80t82cPTIt8iaYupA46icVDkoc2m2452p6s1wmrGtJNpA1PIUezcEuz6zA/640?wx_fmt=png" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7d4ba5b2f7e72758a8d0e24297f664303.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important; width: 300px !important;" title="7d4ba5b2f7e72758a8d0e24297f664303.jpg" alt="7d4ba5b2f7e72758a8d0e24297f66430.jpg"/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2019-11-15', '2020-09-17 21:11:03'),
	(51, '忘带钥匙？您就是钥匙！HOPPE 好博智能把手给您答案！', '/upload/home/news/封面6.png', '<p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.6979655712050078" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkbtmBLpdNeVSRwFnJLib9Wt3YHACKyux1Dw2d7mDTXiciaBAPuIeZBHt2g/640?wx_fmt=gif" data-type="gif" data-w="639" _width="268px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkbtmBLpdNeVSRwFnJLib9Wt3YHACKyux1Dw2d7mDTXiciaBAPuIeZBHt2g/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 268px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">您经历过着急出门却找不到钥匙吗？</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">您经常在家门口翻兜找钥匙吗？</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">您有过忘带钥匙的经历吗？</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博&nbsp;eHandle智能把手</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">给您&nbsp;<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">2</strong>&nbsp;种方案！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">指纹开启 | 感应开启</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.6666666666666666" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkrj54iceWsxfSyvUNNp7IFqTLctsa89s7oDgdSRsTwBTnYia12aAxaq5A/640?wx_fmt=gif" data-type="gif" data-w="600" _width="100px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkrj54iceWsxfSyvUNNp7IFqTLctsa89s7oDgdSRsTwBTnYia12aAxaq5A/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 100px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.21015625" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkH5DLchfzpBoNZ8PicTQChoTTkQJ7ofSAq5LwPpqdCjdGr0TfVEFMxcw/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/0df8fa957bce560bb2a5fa2a9cbd3343.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="0df8fa957bce560bb2a5fa2a9cbd3343.jpg" alt="0df8fa957bce560bb2a5fa2a9cbd3343.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.8927272727272727" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZkzwrL8HKyZbVrwiakL3u3xSzUO4w5zibgHYLzicHghibSDTJYeQfDfnNvw/640?wx_fmt=png" data-type="png" data-w="1100" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/27d6d8c2b2afab208137dc6ff8ab8ea2.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="27d6d8c2b2afab208137dc6ff8ab8ea2.jpg" alt="27d6d8c2b2afab208137dc6ff8ab8ea2.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">便 捷 、安 全&nbsp;–</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE&nbsp;好博指纹开启</span></strong></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;近年来，生物识别技术的应用不再只限于高度戒备的场所。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">用稳定的生理特征 来识别身份已经越来越多地应用到了大众的日常生活中。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">其中，利用指纹识别 来替代钥匙就是最常见的一种。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;每个人的指纹都独一无二的，不会遗失，被偷窃或被替换。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">手指只需轻轻划过 指纹识别装置，门就能解锁。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">将指纹锁功能集成在大拉手或入户门把手上，比 安装在其他地方操作更简便，一个步骤开门。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;安全的重要性毋庸置疑:指纹锁把控着进入楼宇空间或私人住所的权限。</span><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">只有识别到拥有授权的指纹才能开启。</span><span style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">用复制钥匙来钻安全漏洞的方法已成为历史。</span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"></span></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.40390625" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZbPdcXibtn0skDy1OPuPlTdWLACpicQib22R4WT4rLuBicuwAn9DmC7ftrg/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/10bf62631070858a6b6ffc4efd6d1371.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="10bf62631070858a6b6ffc4efd6d1371.jpg" alt="10bf62631070858a6b6ffc4efd6d1371.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">与&nbsp;Idencom&nbsp;指纹识别技术合作</span></strong><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/>&nbsp;&nbsp;&nbsp; HOPPE 好博公司选用全球生物识别技术领先的供应商 Idencom 公司提供的 指纹识别装置。具有超强稳定性和舒适用户体验。精巧的设计使识别装置准确嵌入 HOPPE 好博把手。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">解锁过程有指纹锁独立完成，</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">一个指纹锁最多可以设置150个指纹。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; Idencom 公司提供安全级别最高的指纹识别装置。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">不同于市面上的其他指纹识 别要求按压指纹，Idencom 在指纹划过时进行动态识别。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">这样不会有指纹痕迹 残留，避免了指纹被复制盗用。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-backh="200" data-backw="500" data-before-oversubscription-url="https://mmbiz.qlogo.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZttu0V7WUdvM0G5iaZY3SicWgsT0ibkrSPccGiby4n3COj4ymh350vcRX9Q/0?wx_fmt=gif" data-ratio="0.4" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZttu0V7WUdvM0G5iaZY3SicWgsT0ibkrSPccGiby4n3COj4ymh350vcRX9Q/640?wx_fmt=gif" data-type="gif" data-w="500" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZttu0V7WUdvM0G5iaZY3SicWgsT0ibkrSPccGiby4n3COj4ymh350vcRX9Q/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="2" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">产品优势</span></strong><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">:</span></p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 2.2em; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">使用便捷、安全</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">符合人体工程学</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">精工设计</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">与市面上大多数常见锁体通用&nbsp;</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">无须在门上增加开孔</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">大拉手安装采用好博专利技术的安装组件</span></p></li></ul><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.6666666666666666" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkrj54iceWsxfSyvUNNp7IFqTLctsa89s7oDgdSRsTwBTnYia12aAxaq5A/640?wx_fmt=gif" data-type="gif" data-w="600" _width="100px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkrj54iceWsxfSyvUNNp7IFqTLctsa89s7oDgdSRsTwBTnYia12aAxaq5A/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="3" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 100px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.2109375" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkG3a71zoABdZfjzsvEgN9lhgPpxlx5WYB97ojqmcIZqEzNql1otVJsA/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/c5dbbe4e2729e465b3fdf2cfc141ff491.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="c5dbbe4e2729e465b3fdf2cfc141ff491.jpg" alt="c5dbbe4e2729e465b3fdf2cfc141ff49.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.7875457875457875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNk7aey8ibXd2qqgmibQKCg6yTVTVN6gibZxODYFiaNHNO1uJPicandTo6dB2Q/640?wx_fmt=gif" data-type="gif" data-w="1092" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNk7aey8ibXd2qqgmibQKCg6yTVTVN6gibZxODYFiaNHNO1uJPicandTo6dB2Q/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="4" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages" data-croporisrc="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNksDyepIOx6377iaWlnPsby1C2UsApCpwrbhmTCZR1PHORDoXMlblOg4g/640?wx_fmt=png" data-cropx1="600.5017421602788" data-cropx2="1002" data-cropy1="0" data-cropy2="50.623693379790936" data-ratio="0.12437810945273632" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYgWPLXdAqhfFUzhcefg5IZvBibDDY3Sw6gOOnJJCRoj4jZbW0lAF03zb3HeBTzC03Bc2lQdq3ZTbg/640?wx_fmt=jpeg" data-type="jpeg" data-w="402" _width="151px" src="https://hoppe.jzdsh.com/upload/ue/img/04c5284762a0fbf0d209bc39511e78492.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 151px !important; visibility: visible !important;" title="04c5284762a0fbf0d209bc39511e78492.jpg" alt="04c5284762a0fbf0d209bc39511e7849.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">射灯可根据地面颜色切换4种色彩模式</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">便 捷 –</span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE&nbsp;好博感应开启</span></strong><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"></span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博入户门 eHandle 感应开启技术让您无需停下手上繁忙的业务也可以轻松开门。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">房屋主人只要靠近门，大拉手就会接收到无线钥匙发出的加密信号。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;然后大拉手底部的射灯会自动亮起，说明房屋主人被允许进入房间。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">房屋主人只需用脚扫过射灯的光线，门便会自动开启，简单方便，无需触碰。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;内置的安全功能可防止您无意中在室内打开门锁。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">您可以根据不同的地面颜色切换光束的颜色，以确保其清晰可见。</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">控制单元位于室内部分。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.4987298899237933" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaajKibJdQEALhdRzHzvKJEVbMZ3lculJ3COyLiaetruibqmPkojpInS0glrESWKQMSgVcc5czkcw3Hyw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1181" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/d881e0c16ca0b9c3a20e6b3b5843cb792.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="d881e0c16ca0b9c3a20e6b3b5843cb792.jpg" alt="d881e0c16ca0b9c3a20e6b3b5843cb79.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">技术参数</span></p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 2.2em; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博大拉手型号 E5095GC</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">可以搭配任何型号的电子锁</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">可设定高达 500 个无线钥匙</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">感应距离：</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">大约 1 m</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">大拉手安装高度：</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">离地 20 cm 到 50 cm 之间</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">可选长度：</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">100 cm; 120 cm; 140 cm; 160 cm</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">射灯颜色有白色，蓝色，绿色，红色可选</span></p></li><li><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">防护等级：</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">IP 44</span></p></li></ul><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.6666666666666666" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkrj54iceWsxfSyvUNNp7IFqTLctsa89s7oDgdSRsTwBTnYia12aAxaq5A/640?wx_fmt=gif" data-type="gif" data-w="600" _width="100px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZaexlDoCia8OPn6Cc2rcQNkrj54iceWsxfSyvUNNp7IFqTLctsa89s7oDgdSRsTwBTnYia12aAxaq5A/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="5" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 100px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.6947608200455581" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYKsGwathel7oBDAJRQtU4tNeicNJ7alYawbekhShsHKcuoIQBHOHBWSzcwvheSKARYamSyfJlCJqQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="878" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/6a4a82cc1bc1993ebd64c81ac3e9118a.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="6a4a82cc1bc1993ebd64c81ac3e9118a.jpg" alt="6a4a82cc1bc1993ebd64c81ac3e9118a.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;中国国际门窗幕墙博览会FENESTRATION BAU China（简称FBC）迄今已有16 年的历史，致力于整合门窗幕墙创新产品、技术、解决方案及商业合作模式的发掘，助力行业企业的发展及技术创新，是目前亚太地区专业门窗幕墙系统解决方案旗舰博览会。</span><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 0, 0); font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">2019中国国际门窗幕墙博览会，正在11月5-8日在上海新国际展览中心（浦东）盛大举办。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; 30多年来，HOPPE 好博一直在国际领先的门窗幕墙贸易博览会BAU上展出，展示其高质量和创新的解决方案。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><iframe class="video_iframe rich_pages" data-vidtype="2" data-mpvid="wxv_1065519618149761025" data-cover="http%3A%2F%2Fmmbiz.qpic.cn%2Fmmbiz_jpg%2F6GqXbok17iaajKibJdQEALhdRzHzvKJEVbYriaw1GRG7icd6ibNu8FhOKMsLV8Ykqiadias9PGXeoTGBwhnZ4icAmUVUjQ%2F0%3Fwx_fmt%3Djpeg" allowfullscreen="" frameborder="0" data-ratio="1.7777777777777777" data-w="960" data-src="https://mp.weixin.qq.com/mp/readtemplate?t=pages/video_player_tmpl&amp;auto=0&amp;vid=wxv_1065519618149761025" width="300" height="181" data-vh="168.75" data-vw="300" scrolling="no" marginwidth="0" marginheight="0" src="https://mp.weixin.qq.com/mp/videoplayer?video_h=168.75&video_w=300&scene=1&random_num=5819&article_title=%E5%BF%98%E5%B8%A6%E9%92%A5%E5%8C%99%EF%BC%9F%E6%82%A8%E5%B0%B1%E6%98%AF%E9%92%A5%E5%8C%99%EF%BC%81HOPPE%20%E5%A5%BD%E5%8D%9A%E6%99%BA%E8%83%BD%E6%8A%8A%E6%89%8B%E7%BB%99%E6%82%A8%E7%AD%94%E6%A1%88%EF%BC%81&source=4&vid=wxv_1065519618149761025&mid=2650531745&idx=1&__biz=MzA3MjgzNjc0NQ==&nodetailbar=0&uin=MTYxMjMzMDU0Mw==&key=349ef81838e6cf3c5eace0d72c0fb1753c33521e368a85e10063c3946618c11418112afaefe8ad214930aa382768b9c19e1ccb19a79da25a4c11140d40f57c9e8df7c1b851501262bc54077a032bf08eedf3f2c81159d0bdc55baacdaa088c6c8911f30d8193ce7fba125d2b43706066acdf0ee55a719c00a9ead78b9ed82108&pass_ticket=ULsblcrNVWkLlbh0AdFYsPhYOIPk137BOoYxzMMqgFcNASIsbIDOjM/I1Z4+KRNo&version=/mmbizwap/zh_CN/htmledition/js/appmsg/index5099a6.js&devicetype=iMac MacBookPro12,1 OSX OSX 10.15.6 build(19G2021)&wxtoken=777&sessionid=svr_e9639947993&preview=0&is_in_pay_subscribe=0&nickname=HOPPE%E5%A5%BD%E5%8D%9A%E9%9B%86%E5%9B%A2&roundHeadImg=http://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZqfhlvjicV1Thicrt1wSUMpoVoooekyR0OtdibnHRu7czrgu3SdobcQJ1U8Zz50YQDIAnMzVAvuzzUA/0?wx_fmt=png&enterid=1600348284&subscene=" style="margin: 0px; padding: 0px; max-width: 100%; display: block; overflow: hidden; top: 0px; box-sizing: border-box !important; word-wrap: break-word !important; width: 300px !important; height: 181px !important;"></iframe></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">本次展台上展出的eHandle HandsFree感应把手</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">搭配了丝吉利娅的KFV锁体作为演示</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;">欢迎莅临<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE</strong>&nbsp;<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">好博展台W2.107</strong>共洽商机！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9828125" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabb13yZQWju7w5ZoKpMUR80t82cPTIt8iaYupA46icVDkoc2m2452p6s1wmrGtJNpA1PIUezcEuz6zA/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7d4ba5b2f7e72758a8d0e24297f664304.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="7d4ba5b2f7e72758a8d0e24297f664304.jpg" alt="7d4ba5b2f7e72758a8d0e24297f66430.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2019-11-07', '2020-09-17 21:15:54'),
	(52, '旧貌换新颜？HOPPE 好博全新色彩与您相约中国国际门窗幕墙博览会！', '/upload/home/news/封面7.png', '<p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.6947608200455581" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYKsGwathel7oBDAJRQtU4tNeicNJ7alYawbekhShsHKcuoIQBHOHBWSzcwvheSKARYamSyfJlCJqQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="878" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/6a4a82cc1bc1993ebd64c81ac3e9118a1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="6a4a82cc1bc1993ebd64c81ac3e9118a1.jpg" alt="6a4a82cc1bc1993ebd64c81ac3e9118a.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">中国国际门窗幕墙博览会</span></span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">FENESTRATION BAU China（简称FBC）迄今已有16 年的历史，致力于整合门窗幕墙创新产品、技术、解决方案及商业合作模式的发掘，助力行业企业的发展及技术创新，是目前亚太地区专业门窗幕墙系统解决方案旗舰博览会。该展会起源于“中国门窗博览会”(Fenestration China)。2017年，该展会首次以新名称-中国国际门窗幕墙博览会举办。2018年，656家国内外参展商展示了建筑材料、建筑信息技术、立面、窗户、建筑自动化、建筑技术和门等领域的产品。参观展览会的人数到达十万人次。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">今年，FENESTRATION BAU China 2019中国国际门窗幕墙博览会将于11月5-8日在上海新国际展览中心（浦东）盛大举办。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;">30多年来，HOPPE 一直在国际领先的门窗幕墙贸易博览会 BAU上展出，展示其高质量和创新的解决方案。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; box-sizing: border-box !important; word-wrap: break-word !important;">届时，欢迎莅临<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">好博展台W2.107</strong></span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;">共洽商机！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: &quot;Titillium Web&quot;, -apple-system, &quot;PingFang SC&quot;, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, Arial, &quot;Microsoft YaHei&quot;, &quot;Source Han Sans SC&quot;, &quot;Noto Sans CJK SC&quot;, &quot;WenQuanYi Micro Hei&quot;, sans-serif; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.41505791505791506" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaWhJPkD50d2ovibAaTFbeNeskiccm8lUu04MhvhB0MWKtpPRYt9fKPJuzKgibiaLeibnIe4OhoEqBl9fg/640?wx_fmt=png" data-type="png" data-w="1036" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/70d0edcb4f5ee7b1df937cd54c58e551.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="70d0edcb4f5ee7b1df937cd54c58e551.jpg" alt="70d0edcb4f5ee7b1df937cd54c58e551.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="1.0418794688457609" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tUNCSxh9icMonc0iboV4hsW2CzoSEEHFEKo6icQOibM5WW2dWdqbh0F7zZg/640?wx_fmt=gif" data-type="gif" data-w="979" _width="86px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tUNCSxh9icMonc0iboV4hsW2CzoSEEHFEKo6icQOibM5WW2dWdqbh0F7zZg/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 86px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">品质卓越的把手出新的潮流色彩啦:四个全新颜色-每一种都有亮光</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">和丝光两种质感处理-适用于个人不同装修风格。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="1.0397959183673469" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tXcl19ZODLgw4UV29JXQKXt1kYbicoAeeyicAjQeQKa8xH8RAOUDm4IgQ/640?wx_fmt=gif" data-type="gif" data-w="980" _width="87px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tXcl19ZODLgw4UV29JXQKXt1kYbicoAeeyicAjQeQKa8xH8RAOUDm4IgQ/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 87px !important; visibility: visible !important;"/></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">比如,黑色和烟灰色能够突出室内多颜色家具的细节表现或加重同色调室内装修的风格气质。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="1.445466491458607" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tXploPKkZmFuk0kXCWPN7xDAvTxjbNUFpUYbyibJUbsQyntE6kazFarQ/640?wx_fmt=gif" data-type="gif" data-w="761" _width="62px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4tXploPKkZmFuk0kXCWPN7xDAvTxjbNUFpUYbyibJUbsQyntE6kazFarQ/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="2" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 62px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">暖色调的铜可以很好地与天然木头和黄铜颜色表面处理搭配,豪华的内室采用金色把手会是不错的选择。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.9823008849557522" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4t1Wg0q6f9yPZJNoRTLm04zibkZTfp4qlSrpK0PETqggyvH4ibAXibcShMQ/640?wx_fmt=gif" data-type="gif" data-w="565" _width="90px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYKsGwathel7oBDAJRQtU4t1Wg0q6f9yPZJNoRTLm04zibkZTfp4qlSrpK0PETqggyvH4ibAXibcShMQ/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="3" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 90px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">新色彩的一大优势是其持久的表现力,即使在高强度地使用环境或恶劣天气条件下依然表现”出色”!它们带有&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: HelveticaNeueLTW1G; box-sizing: border-box !important; word-wrap: break-word !important;">Resista</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: HelveticaNeueLTW1G; vertical-align: 3pt; box-sizing: border-box !important; word-wrap: break-word !important;">®&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">十年表层质 保,随时接受检验.新的产品都通过欧标&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: HelveticaNeueLTW1G; box-sizing: border-box !important; word-wrap: break-word !important;">EN 1670&nbsp;</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;">的测试。</span></span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 7pt; font-family: DFPHeiW3-GBK-EUC-H-Identity-H; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.6718403547671841" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaWhJPkD50d2ovibAaTFbeNeNwo9tkib4ibojrVkbc351bgDXLfyEnN5ibws2rJib3dSlAMLz6WXUVK8eA/640?wx_fmt=png" data-type="png" data-w="902" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7f61b6ccbccf5855dd0fa32eb77c0d15.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="7f61b6ccbccf5855dd0fa32eb77c0d15.jpg" alt="7f61b6ccbccf5855dd0fa32eb77c0d15.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9828125" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabb13yZQWju7w5ZoKpMUR80t82cPTIt8iaYupA46icVDkoc2m2452p6s1wmrGtJNpA1PIUezcEuz6zA/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/7d4ba5b2f7e72758a8d0e24297f664305.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="7d4ba5b2f7e72758a8d0e24297f664305.jpg" alt="7d4ba5b2f7e72758a8d0e24297f66430.jpg"/></p><p><br/></p><p><br/></p>', 0, 0, 0, '2019-10-29', '2020-09-17 21:19:35'),
	(53, 'Toulon系列新品 短颈窗执手', '/upload/home/news/WX20200917-213359@2x.png', '<p></p><p><section label="Edit by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; font-family: -apple-system-font, BlinkMacSystemFont, &quot;Helvetica Neue&quot;, &quot;PingFang SC&quot;, &quot;Hiragino Sans GB&quot;, &quot;Microsoft YaHei UI&quot;, &quot;Microsoft YaHei&quot;, Arial, sans-serif; letter-spacing: 0.5440000295639038px; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-croporisrc="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabf5rCduyvFezEnFdwGzibhPKQjY3PIVBdkmCIesiaFgaZEqWAkvXFnib46DM6zVgZVIasUof36dgbqQ/640" data-cropx1="0" data-cropx2="960" data-cropy1="0" data-cropy2="348.78892733564015" data-ratio="0.3625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZQBcmkPs35D7lKXOv3wvfY4PPIXp6jTcFuTJdfMXPu3SiaLDFqFpzibobHMJR9YgCkdJBIJIBiaY40Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="960" _width="300px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/d92e6d7d39fc8bb50be65b179ffe8649.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="d92e6d7d39fc8bb50be65b179ffe8649.jpg" alt="d92e6d7d39fc8bb50be65b179ffe8649.jpg"/>&nbsp;&nbsp;&nbsp;&nbsp;</section><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;精细的制作工艺只为更优质的品质，以现代简约为理念，HOPPE 好博&nbsp;dura</span><strong style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">plus</strong><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">® 产品线推出 Toulon 系列0737FL/U34FL短颈可翻转铝合金窗把手，</span><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">定位于精致主流执手市场。</span></section><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span></section><section data-role="outer" label="Powered by 135editor.com" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;"></span><section data-tools="135编辑器" data-id="99782" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 10px 5px; padding: 16px 0px 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: -10px 0px 0px 5px; padding: 0px 0px 5px; max-width: 100%; box-sizing: border-box; border: 3px solid rgb(0, 35, 76); word-wrap: break-word !important;"><section style="margin: -8px 3px 0px -8px; padding: 1.2em; max-width: 100%; box-sizing: border-box; border: 2px solid rgb(0, 35, 76); overflow: hidden; word-wrap: break-word !important;"><section data-width="100%" style="margin: 0px; padding: 0px; max-width: 100%; width: 236.625px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.5" data-w="1200" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf5rCduyvFezEnFdwGzibhPBldqQf4mFITrtWw5Fia6icFe0sew8K7qkLwCRjSz2TjBEpbCSE8asVaQ/640" title="1954e73be40b5423605cb2d490120736.jpg" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1954e73be40b5423605cb2d490120736.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" alt="1954e73be40b5423605cb2d490120736.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;该款Toulon 系列0737FL/U34FL短颈可翻转铝合金窗把手采用极薄设计，造型精致适用于双层窗。全盖式底座，螺丝暗装，视觉效果简洁美观。锌合金安装基座搭配HOPPE 好博的实心方轴，用细节体现居住品位。</span></p></section></section></section></section></section><section data-tools="135编辑器" data-id="95743" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-tools="135编辑器" data-id="95743" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin: 0px 16px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; letter-spacing: 2px; line-height: 1.75em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; caret-color: red; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(63, 63, 63); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; font-family: Optima-Regular, PingFangTC-light; box-sizing: border-box !important; word-wrap: break-word !important;">产品效果图▼</strong></span></strong><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; letter-spacing: 2px; text-align: center; font-family: Optima-Regular, PingFangTC-light; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; word-wrap: break-word !important;"><section style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: top; word-wrap: break-word !important;"><section style="margin: 0px 0px -30px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; vertical-align: top; overflow-x: auto; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 500%; box-sizing: border-box; flex: 0 0 500%; display: flex; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 20%; display: inline-block; vertical-align: bottom; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; border: 0px none rgb(62, 62, 62); border-top-left-radius: 15px; border-top-right-radius: 15px; border-bottom-right-radius: 15px; border-bottom-left-radius: 15px; overflow: hidden; word-wrap: break-word !important;"><img data-ratio="1.5" data-w="1200" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf5rCduyvFezEnFdwGzibhPDCicVhWYkBHib47xqBfqeNoHwMSribU2Va5fibFYKhBRWpasYib8sbicrwRw/640" title="71e494e37e8dd6f3f6f6137404adb7a0.jpg" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/71e494e37e8dd6f3f6f6137404adb7a0.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" alt="71e494e37e8dd6f3f6f6137404adb7a0.jpg"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 180px; height: 30px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><table width="180"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:0.col1:0.col1:0.col1:1.col1:0.classicTable1:0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:0.col1:1.col1:0.classicTable1:0.td@@0" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(1,169,216,0.3)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(1,169,216)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:0.col1:1.col1:0.classicTable1:0.td@@1" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:0.col1:1.col1:0.classicTable1:0.td@@2" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:0.col1:1.col1:0.classicTable1:0.td@@3" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:0.col1:1.col1:0.classicTable1:0.td@@4" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td></tr></tbody></table></section></section></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 20%; display: inline-block; vertical-align: bottom; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; border: 0px none rgb(62, 62, 62); border-top-left-radius: 15px; border-top-right-radius: 15px; border-bottom-right-radius: 15px; border-bottom-left-radius: 15px; overflow: hidden; word-wrap: break-word !important;"><img data-ratio="1.5" data-w="1200" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf5rCduyvFezEnFdwGzibhPdQ6HEe6kjkpEbz2YKvsibxAHZibiaG4ibT8xSaiadzHBKTC6Wib2icwdH9rjQ/640" title="b3b13c52c7ab61ab8fe2f0099789ae84.jpg" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/b3b13c52c7ab61ab8fe2f0099789ae84.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" alt="b3b13c52c7ab61ab8fe2f0099789ae84.jpg"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 180px; height: 30px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><table width="180"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:0.col1:0.col1:1.col1:1.col1:0.classicTable1:0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:1.col1:1.col1:0.classicTable1:0.td@@0" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:1.col1:1.col1:0.classicTable1:0.td@@1" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(1,169,216,0.3)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(1,169,216)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:1.col1:1.col1:0.classicTable1:0.td@@2" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:1.col1:1.col1:0.classicTable1:0.td@@3" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:1.col1:1.col1:0.classicTable1:0.td@@4" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td></tr></tbody></table></section></section></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 20%; display: inline-block; vertical-align: bottom; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; border: 0px none rgb(62, 62, 62); border-top-left-radius: 15px; border-top-right-radius: 15px; border-bottom-right-radius: 15px; border-bottom-left-radius: 15px; overflow: hidden; word-wrap: break-word !important;"><img data-ratio="0.6666666666666666" data-w="444" height="649" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf5rCduyvFezEnFdwGzibhPebaWHI86mDwEBUcxODicyydrRjqN0xiaRyzSsPXxUWndvESeREEGPWXg/640" title="a6c63b6ecee3f25ce00cf19e5be46b4f.jpg" width="143" _width="105px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a6c63b6ecee3f25ce00cf19e5be46b4f.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 105px !important; visibility: visible !important;" alt="a6c63b6ecee3f25ce00cf19e5be46b4f.jpg"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 180px; height: 30px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><table width="180"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:0.col1:0.col1:2.col1:1.col1:0.classicTable1:0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:2.col1:1.col1:0.classicTable1:0.td@@0" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:2.col1:1.col1:0.classicTable1:0.td@@1" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:2.col1:1.col1:0.classicTable1:0.td@@2" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(1,169,216,0.3)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(1,169,216)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:2.col1:1.col1:0.classicTable1:0.td@@3" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:2.col1:1.col1:0.classicTable1:0.td@@4" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td></tr></tbody></table></section></section></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 20%; display: inline-block; vertical-align: bottom; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; border: 0px none rgb(62, 62, 62); border-top-left-radius: 15px; border-top-right-radius: 15px; border-bottom-right-radius: 15px; border-bottom-left-radius: 15px; overflow: hidden; word-wrap: break-word !important;"><img data-ratio="0.6666666666666666" data-w="444" height="645" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf5rCduyvFezEnFdwGzibhPqEnvbib6XAbWLf52swRAPv3QtK4lvNd41SQFibnb0tM9nOO3vCeO5eZg/640" title="fcb3c894f47af3db40b620d3cf8d8a65.jpg" width="142" _width="105px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/fcb3c894f47af3db40b620d3cf8d8a65.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 105px !important; visibility: visible !important;" alt="fcb3c894f47af3db40b620d3cf8d8a65.jpg"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 180px; height: 30px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><table width="180"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:0.col1:0.col1:3.col1:1.col1:0.classicTable1:0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:3.col1:1.col1:0.classicTable1:0.td@@0" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:3.col1:1.col1:0.classicTable1:0.td@@1" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:3.col1:1.col1:0.classicTable1:0.td@@2" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:3.col1:1.col1:0.classicTable1:0.td@@3" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(1,169,216,0.3)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(1,169,216)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:3.col1:1.col1:0.classicTable1:0.td@@4" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td></tr></tbody></table></section></section></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 20%; display: inline-block; vertical-align: bottom; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; border: 0px none rgb(62, 62, 62); border-top-left-radius: 15px; border-top-right-radius: 15px; border-bottom-right-radius: 15px; border-bottom-left-radius: 15px; overflow: hidden; word-wrap: break-word !important;"><img data-ratio="0.6666666666666666" data-w="444" height="651" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabf5rCduyvFezEnFdwGzibhPTctyAibYWFWj0ESkqKA1S7iagibqcxibq8X7FjR1AXroWApQNqZh5Dwzzw/640" title="bc39aa667d9c0f452f45cf842c8b2405.jpg" width="143" _width="103px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/bc39aa667d9c0f452f45cf842c8b2405.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 103px !important; visibility: visible !important;" alt="bc39aa667d9c0f452f45cf842c8b2405.jpg"/></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 180px; height: 30px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><table width="180"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:0.col1:0.col1:4.col1:1.col1:0.classicTable1:0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:4.col1:1.col1:0.classicTable1:0.td@@0" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:4.col1:1.col1:0.classicTable1:0.td@@1" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:4.col1:1.col1:0.classicTable1:0.td@@2" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:4.col1:1.col1:0.classicTable1:0.td@@3" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgba(118,178,124,0)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:0.col1:4.col1:1.col1:0.classicTable1:0.td@@4" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(1,169,216,0.3)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(1,169,216)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td></tr></tbody></table></section></section></section></section></section></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 180px; height: 30px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><table width="180"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:0.col1:1.col1:0.classicTable1:0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:1.col1:0.classicTable1:0.td@@0" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(237,237,237)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:1.col1:0.classicTable1:0.td@@1" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(237, 237, 237)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:1.col1:0.classicTable1:0.td@@2" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(237, 237, 237)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:1.col1:0.classicTable1:0.td@@3" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(237, 237, 237)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:0.col1:1.col1:0.classicTable1:0.td@@4" width="20.0000%" style="margin: 0px; padding: 0px 3px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; flex: 0 0 80%; display: flex; vertical-align: middle; line-height: 0; word-wrap: break-word !important;"><svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewbox="0 0 27 27" style="flex:0 0 100%;vertical-align: middle;max-width: 100%;box-sizing: border-box;" width="100%" xml:space="default"><g style="box-sizing: border-box;"><path style="box-sizing: border-box;" d="M13.5,27C6.06,27,0,20.94,0,13.5S6.06,0,13.5,0S27,6.06,27,13.5S20.94,27,13.5,27z M13.5,2   C7.16,2,2,7.16,2,13.5S7.16,25,13.5,25S25,19.84,25,13.5S19.84,2,13.5,2z" fill="rgba(118,178,124,0)"></path><circle style="box-sizing: border-box;" cx="13.5" cy="13.5" r="6" fill="rgb(237, 237, 237)"></circle></g><text x="-10000" y="-10000">_</text></svg></section></section></td></tr></tbody></table></section></section></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; background-color: rgb(255, 255, 255); word-wrap: break-word !important; overflow-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">（左右滑动进行翻看）</span></p></section></section></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博出品的门窗把手均为品牌产品，产品本身即是对品质的承诺。这些门窗把手可以很好地融入环境氛围，对体现个人室内设计风格起画龙点睛之笔，将“细节体现居住品位”这一理念带到实际生活中。</span></p></section></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.9957203994293866" data-w="1402" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabf5rCduyvFezEnFdwGzibhPj9QcV9VQCRbQ7ib9GLoDDibYicPOmlNoWzk8d1T2ynlniavlPuQW104Emw/640" _width="auto" class="" src="https://hoppe.jzdsh.com/upload/ue/img/0d83016b10e212ef5ffbeccc284c5443.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: auto !important; visibility: visible !important;" title="0d83016b10e212ef5ffbeccc284c5443.jpg" alt="0d83016b10e212ef5ffbeccc284c5443.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp;&nbsp;</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;&nbsp;&nbsp; HOPPE 好博致力于将全套门窗把手系列提供给用户选择，在推出该款Toulon短颈可翻转窗执手后，Toulon系列已全面上线，包括分体式门把手、mini-rose门把手、大拉手、窗把手、分体式型材门把手以及多种表面处理色彩供您选择。任何 HOPPE 好博门窗把手的用户都拥有把手的 10 年机械功能质保。</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages  __bg_gif" data-ratio="0.5528273809523809" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZQBcmkPs35D7lKXOv3wvfYqJcx0ZURXiccZYVyFpYBibue95icyGjicb9EAiaurUoZT0LYia9ughv6Sc5g/640?wx_fmt=gif" data-type="gif" data-w="1344" _width="300px" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZQBcmkPs35D7lKXOv3wvfYqJcx0ZURXiccZYVyFpYBibue95icyGjicb9EAiaurUoZT0LYia9ughv6Sc5g/640?wx_fmt=gif&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.740625" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZQBcmkPs35D7lKXOv3wvfYv1zDhVv2a6ibMD8nSvRtkMCDFT3JuDicWVDy4HF0de3hOFWJEyRiaIZcA/640?wx_fmt=png" data-type="png" data-w="1280" _width="300px" src="https://hoppe.jzdsh.com/upload/ue/img/a1d1599bfb38579d9dcaec0c1a4fc81c.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 300px !important; visibility: visible !important;" title="a1d1599bfb38579d9dcaec0c1a4fc81c.jpg" alt="a1d1599bfb38579d9dcaec0c1a4fc81c.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"></span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section data-role="paragraph" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><section style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="226" data-ratio="0.43673469387755104" data-s="300,640" data-type="png" data-w="1960" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaaQmibdIxjQDw0AUpM57Tdbdx4vlPC2Iqwc1P5dBqaM6dNSokoqVGTfvQVVmuGF7zJWJM5Oib4ER2fQ/640?wx_fmt=png" width="578px" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/04f597a29f0bf0e8e0e2d39485a205e82.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; width: 300px; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="04f597a29f0bf0e8e0e2d39485a205e82.jpg" alt="04f597a29f0bf0e8e0e2d39485a205e8.jpg"/></p><p><br/></p></section></section></section></section></p><p></p><p><br/></p>', 0, 0, 0, '2020-09-10', '2020-09-17 21:51:44'),
	(55, '双十一 | HOPPE 好博 爆款底价 当红钜惠', '/upload/home/news/11.91.png', '<p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.9629629629629629" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaattqYhrLbAaIBhIsKm6sjZkRibbVWCPhRblmOo73FiaUSVAz8EFCXHyrhKaHKkazDSKo8GNnmmiaMJA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" src="https://hoppe.jzdsh.com/upload/ue/img/784d7c7790004823b96c898d674b6713.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="784d7c7790004823b96c898d674b6713.jpg" alt="784d7c7790004823b96c898d674b6713.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="0.8055555555555556" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaattqYhrLbAaIBhIsKm6sjZz4nLbLUaV7tTFo8fXg0qWaEgwmrMicpdQxK8mR1kYwicvJDuleRgx3XA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" src="https://hoppe.jzdsh.com/upload/ue/img/def81053d3ad6d2f8cc49460e9e8a6df.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="def81053d3ad6d2f8cc49460e9e8a6df.jpg" alt="def81053d3ad6d2f8cc49460e9e8a6df.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="1180" data-ratio="2.0416666666666665" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaattqYhrLbAaIBhIsKm6sjZZBSEP1nUzKiaO6aOJICo4JGNewMAC5EboZnRiacBueUFkuwcSh90OTIA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/b1ae09496f50f503a0cc7b0133fbf283.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 578px !important; visibility: visible !important;" title="b1ae09496f50f503a0cc7b0133fbf283.jpg" alt="b1ae09496f50f503a0cc7b0133fbf283.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.0703703703703704" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaattqYhrLbAaIBhIsKm6sjZvYSWtiaFWW1LibTVZFBGIRvLNz45zGeCAKPWOWgnBA0ibxv97sOxjib3zg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" src="https://hoppe.jzdsh.com/upload/ue/img/530fdf6a0dd1464f6685c583114d15c7.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="530fdf6a0dd1464f6685c583114d15c7.jpg" alt="530fdf6a0dd1464f6685c583114d15c7.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-cropselx1="0" data-cropselx2="578" data-cropsely1="0" data-cropsely2="944" data-ratio="1.6296296296296295" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaattqYhrLbAaIBhIsKm6sjZpcaVGRQAvWpic5Sz7RVDdPn4Rg7ueXmoKd91xx5t79pwqleiaF7Qt0sg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="578px" src="https://hoppe.jzdsh.com/upload/ue/img/cc5c0071b78afec2eaf98c6a8dc494b4.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 578px !important; visibility: visible !important;" title="cc5c0071b78afec2eaf98c6a8dc494b4.jpg" alt="cc5c0071b78afec2eaf98c6a8dc494b4.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><img class="rich_pages " data-ratio="1.3388888888888888" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaattqYhrLbAaIBhIsKm6sjZfJnySp8ibWePy2G3Ts8nYMeLVIB8bOgtT3Yjdm6Ddoib98lUf1NvYQzg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" src="https://hoppe.jzdsh.com/upload/ue/img/f7a0f7c1593444a4a8e81b1316ef231f.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="f7a0f7c1593444a4a8e81b1316ef231f.jpg" alt="f7a0f7c1593444a4a8e81b1316ef231f.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; line-height: 1.6; box-sizing: border-box !important; word-wrap: break-word !important;"></span></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(178, 185, 192) 1px 0px 10px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.437037" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabbILozXkRpglNzvvudguUibqQP8cM35QB8g07xA5qz4KXQ0fl9p3QlfzX0icqiarPqqOhiaewdXwJjjg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e471b77fdee100741b405a88ab53e395.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="e471b77fdee100741b405a88ab53e395.jpg" alt="e471b77fdee100741b405a88ab53e395.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><a target="_blank" href="http://mp.weixin.qq.com/s?__biz=MzA3MjgzNjc0NQ==&mid=2650532870&idx=1&sn=d116082a97cf53623478cef378a096a4&chksm=87177fe0b060f6f6c24ba3e5d78170020e1d91a506b7fc9853ae91d025da03bfcade63db2df6&scene=21#wechat_redirect" textvalue="你已选中了添加链接的内容" data-itemshowtype="0" tab="innerlink" data-linktype="1" hasload="1" style="margin: 0px; padding: 0px; color: rgb(87, 107, 149); text-decoration: none; cursor: pointer; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span class="js_jump_icon h5_image_link" data-positionback="static" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 0; font-size: 0px; display: inline-block; position: relative; top: auto; left: auto; right: auto; bottom: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabbILozXkRpglNzvvudguUibmTBAOsDCGGZ0reTb4jlK2suCNibia0xIspGlH7okukD7zccNuIORS9Ig/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f9192df4ace462661963ab7884a154ff1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; border: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f9192df4ace462661963ab7884a154ff1.jpg" alt="f9192df4ace462661963ab7884a154ff.jpg"/></span></a></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信小程序</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 点击查看小程序使用指南</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabbILozXkRpglNzvvudguUibjVH4CzuP2B8jz35KficvAPuyztsdzCicv2kxlmP5iaCtRibJx1WHZObK6Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/63145ef91857a16409633389195560ea.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="63145ef91857a16409633389195560ea.jpg" alt="63145ef91857a16409633389195560ea.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信公众号</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码关注我们</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabbILozXkRpglNzvvudguUibia9jUjTt3GVKK247bD5CcFxBiaVWHm1JAcF0MzfAYmLJRQ8icicjuibibw4A/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/02ae75207bdc4e9928fc590451850d7e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="02ae75207bdc4e9928fc590451850d7e.jpg" alt="02ae75207bdc4e9928fc590451850d7e.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博官网</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码进入官网</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.4657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabbILozXkRpglNzvvudguUibVKXgr4jAW55UICUnEicCfleqFPvWSn2BzCMnhrGoLM8E777MZqFEDCQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f1876d8467d7caf949ea72cef716bf92.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="f1876d8467d7caf949ea72cef716bf92.jpg" alt="f1876d8467d7caf949ea72cef716bf92.jpg"/></section></section></section></section></section><p></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-11-09', '2020-12-04 15:53:14'),
	(56, '68年只做门窗把手，德国HOPPE 好博五金亮相中国木门技术大会并获奖', '/upload/home/news/12.2.jpg', '<p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;line-height: 1.4;color: rgba(0, 0, 0, 0.3)"><img src="https://hoppe.jzdsh.com/upload/ue/img/WX20201204-164519@2x.png" title="WX20201204-164519@2x.png" alt="WX20201204-164519@2x.png"/></p><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-family: -apple-system-font, BlinkMacSystemFont, &#39;Helvetica Neue&#39;, &#39;PingFang SC&#39;, &#39;Hiragino Sans GB&#39;, &#39;Microsoft YaHei UI&#39;, &#39;Microsoft YaHei&#39;, Arial, sans-serif;letter-spacing: 0.5440000295639038px;font-size: 16px;word-wrap: break-word !important"><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;box-shadow: rgb(0, 0, 0) 0px 0px 0px;word-wrap: break-word !important"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhYTiaGtm2hiavrDAfwUK37EBWQncN1wRduiaQQ3ewSfdyBJW8yNPZwCwlA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/cb94204bf783897224e99a1f4d3bfa891.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="cb94204bf783897224e99a1f4d3bfa891.jpg" alt="cb94204bf783897224e99a1f4d3bfa89.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 10px 0px 5px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 677px;vertical-align: top;border-bottom-width: 4px;border-bottom-style: solid;border-bottom-color: rgb(0, 47, 91);border-bottom-right-radius: 0px;box-shadow: rgb(0, 0, 0) 0px 0px 0px;background-color: rgb(244, 244, 244);word-wrap: break-word !important"><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px 13px;max-width: 100%;box-sizing: border-box;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">德国五金品牌HOPPE 好博是享誉国际的门窗五金控制系统方案服务商，致力于引领全球高端门窗五金及系统的研制与创新，让使用者体验到触手可及的生活细节之美。</p></section></section><section powered-by="xiumi.us" style="margin: 13px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px 13px;max-width: 100%;box-sizing: border-box;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">2020年11月在广州召开的第八届中国木门技术大会上，HOPPE 好博荣获2020联盟星选•木门技术智造力产业英贤奖。</p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;width: 649.90625px;height: auto;word-wrap: break-word !important"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhaBcXoF9SskP1MAHl7m2mK28fYZf1iaqZYl1CaKWNXKSEnUYYFliaIZrw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/010265062632c7ba99753670aa77aebc1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;width: 649.90625px;word-wrap: break-word !important;height: auto !important;visibility: visible !important" title="010265062632c7ba99753670aa77aebc1.jpg" alt="010265062632c7ba99753670aa77aebc.jpg"/></section></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 677px;vertical-align: top;border-width: 2px 1px;border-top-left-radius: 0px;border-top-right-radius: 0px;border-bottom-right-radius: 0px;border-bottom-left-radius: 0px;border-style: solid none;border-color: rgb(62, 62, 62);word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;align-items: center;display: flex;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: bottom;width: auto;flex: 0 0 auto;border-width: 0px 0px 0px 2px;border-top-left-radius: 1px;border-top-right-radius: 1px;border-bottom-right-radius: 1px;border-bottom-left-radius: 1px;border-style: none none none solid;border-color: rgb(62, 62, 62);overflow: hidden;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;transform: translate3d(-10px, 0px, 0px);word-wrap: break-word !important"><section style=";padding: 6px 10px 6px 20px;max-width: 100%;box-sizing: border-box;display: inline-block;min-width: 10%;vertical-align: top;transform: matrix(1, 0, -0.2, 1, 0, 0);border: 2px solid rgb(62, 62, 62);border-top-left-radius: 0px;border-top-right-radius: 0px;border-bottom-right-radius: 0px;border-bottom-left-radius: 0px;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;line-height: 1;letter-spacing: 0px;color: rgb(255, 255, 255);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">HOPPE 好博</strong></p></section></section></section></section><section style=";padding: 3px 0px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: bottom;width: auto;flex: 1 1 auto;border-width: 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 17px;line-height: 1;letter-spacing: 0.5px;color: rgb(9, 9, 9);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">获广泛关注与认可</strong></p></section></section><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: bottom;width: auto;flex: 0 0 auto;border: 0px none rgb(62, 62, 62);border-top-left-radius: 1px;border-top-right-radius: 1px;border-bottom-right-radius: 1px;border-bottom-left-radius: 1px;overflow: hidden;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;transform: translate3d(10px, 0px, 0px);word-wrap: break-word !important"><section style=";padding: 6px 10px;max-width: 100%;box-sizing: border-box;display: inline-block;min-width: 10%;vertical-align: top;transform: matrix(1, 0, -0.2, 1, 0, 0);border: 2px solid rgb(62, 62, 62);border-top-left-radius: 0px;border-top-right-radius: 0px;border-bottom-right-radius: 0px;border-bottom-left-radius: 0px;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;line-height: 1;letter-spacing: 0px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: right;word-wrap: break-word !important"><section style=";padding: 0px 20px 0px 0px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 609.296875px;vertical-align: top;border-left-width: 6px;border-left-style: solid;border-left-color: rgb(243, 243, 243);border-bottom-left-radius: 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 15px;padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;word-wrap: break-word !important"><section style=";padding: 10px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 670.21875px;vertical-align: top;border: 0px none rgb(62, 62, 62);border-top-left-radius: 8px;border-top-right-radius: 8px;border-bottom-right-radius: 8px;border-bottom-left-radius: 8px;overflow: hidden;box-shadow: rgb(231, 231, 231) 0px 0px 6px;height: auto;word-wrap: break-word !important"><section powered-by="xiumi.us" style="margin: 0px 0px 16px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhyiacicPkdBa2jiaT5yBnIfn32QBen7HUUhicZYibsEicltBoAKttMus0kIvg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/8bea338d14d3758040c5a52964115a2e1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="8bea338d14d3758040c5a52964115a2e1.jpg" alt="8bea338d14d3758040c5a52964115a2e.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">在大会的“木门产业链双十一采购节”环节，HOPPE 好博五金也得到了联盟专家认可和推介。联盟专家杨波表示，自己家用的就是HOPPE 好博五金，“手感各方面不用说，是好东西。”<br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 16px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhKMQuvxRo8gDlzwqIfbuIHSPqyoKufExXA2iaTuz6NABnTESCjClOkZA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/3831c86e0d16febfcd083667459f302a1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="3831c86e0d16febfcd083667459f302a1.jpg" alt="3831c86e0d16febfcd083667459f302a.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE 好博自上世纪90年代进入中国以来，以其品质和服务获得了国内市场认可。目前，HOPPE 好博已成为很多高端定制木门的标配五金。随着消费升级，人们对木门的要求已不仅仅是品质和体验感上的提高，对档次和高端的需求也日益强烈。在这样的背景下，木门企业选择五金品牌时，不妨对HOPPE 好博进行关注和考察。<br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 677px;vertical-align: top;border-width: 2px 1px;border-top-left-radius: 0px;border-top-right-radius: 0px;border-bottom-right-radius: 0px;border-bottom-left-radius: 0px;border-style: solid none;border-color: rgb(62, 62, 62);word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;align-items: center;display: flex;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: bottom;width: auto;flex: 0 0 auto;border-width: 0px 0px 0px 2px;border-top-left-radius: 1px;border-top-right-radius: 1px;border-bottom-right-radius: 1px;border-bottom-left-radius: 1px;border-style: none none none solid;border-color: rgb(62, 62, 62);overflow: hidden;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;transform: translate3d(-10px, 0px, 0px);word-wrap: break-word !important"><section style=";padding: 6px 10px 6px 20px;max-width: 100%;box-sizing: border-box;display: inline-block;min-width: 10%;vertical-align: top;transform: matrix(1, 0, -0.2, 1, 0, 0);border: 2px solid rgb(62, 62, 62);border-top-left-radius: 0px;border-top-right-radius: 0px;border-bottom-right-radius: 0px;border-bottom-left-radius: 0px;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;line-height: 1;letter-spacing: 0px;color: rgb(255, 255, 255);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">HOPPE 好博</strong></p></section></section></section></section><section style=";padding: 3px 0px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: bottom;width: auto;flex: 1 1 auto;border-width: 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 17px;line-height: 1;letter-spacing: 0.5px;color: rgb(9, 9, 9);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">专注专业 品质卓越</strong></p></section></section><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: bottom;width: auto;flex: 0 0 auto;border: 0px none rgb(62, 62, 62);border-top-left-radius: 1px;border-top-right-radius: 1px;border-bottom-right-radius: 1px;border-bottom-left-radius: 1px;overflow: hidden;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;transform: translate3d(10px, 0px, 0px);word-wrap: break-word !important"><section style=";padding: 6px 10px;max-width: 100%;box-sizing: border-box;display: inline-block;min-width: 10%;vertical-align: top;transform: matrix(1, 0, -0.2, 1, 0, 0);border: 2px solid rgb(62, 62, 62);border-top-left-radius: 0px;border-top-right-radius: 0px;border-bottom-right-radius: 0px;border-bottom-left-radius: 0px;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;line-height: 1;letter-spacing: 0px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: right;word-wrap: break-word !important"><section style=";padding: 0px 20px 0px 0px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 609.296875px;vertical-align: top;border-left-width: 6px;border-left-style: solid;border-left-color: rgb(243, 243, 243);border-bottom-left-radius: 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px;padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;word-wrap: break-word !important"><section style=";padding: 10px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 670.21875px;vertical-align: top;border: 0px none rgb(62, 62, 62);border-top-left-radius: 8px;border-top-right-radius: 8px;border-bottom-right-radius: 8px;border-bottom-left-radius: 8px;overflow: hidden;box-shadow: rgb(231, 231, 231) 0px 0px 6px;height: auto;word-wrap: break-word !important"><section powered-by="xiumi.us" style="margin: 0px 0px 5px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;box-shadow: rgb(0, 0, 0) 0px 0px 0px;word-wrap: break-word !important"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efh6065PLz4yB9eYp5mDK41JiapppdcGayHvcN9ymefhoLg9BaWicN2Gibyg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/0990b61880df001324dff9dfb00cf8181.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="0990b61880df001324dff9dfb00cf8181.jpg" alt="0990b61880df001324dff9dfb00cf818.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 16px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhv37Znrs8iaR1qC0rkkhUkCtnicUicG3b0YYia66yJCVpnEFjeCvpjtQD8w/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e585ce8832d34bf58be844f919d38b9a1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="e585ce8832d34bf58be844f919d38b9a1.jpg" alt="e585ce8832d34bf58be844f919d38b9a.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">会上， HOPPE 好博中国区市场经理叶宝霞在“国际技术”环节，对HOPPE 好博品牌、技术、产品做了介绍。</p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 2px;max-width: 100%;box-sizing: border-box;display: inline-block;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section style="margin: 0px 5px 0px 0px;padding: 0px 8px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(0, 47, 91);background-color: rgb(255, 255, 255);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">HOPPE 好博</p></section><section style=";padding: 0px 5px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(255, 255, 255);font-size: 18px;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">&nbsp;品 牌&nbsp;</strong></p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE 好博1952年在德国创立伊始，就确立了专注门窗把手的目标。68年后的今天，HOPPE 好博已在全球建立7家工厂，分别位于德国、意大利和捷克，并依然传承和坚持着这种专注。</p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 2px;max-width: 100%;box-sizing: border-box;display: inline-block;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section style="margin: 0px 5px 0px 0px;padding: 0px 8px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(0, 47, 91);background-color: rgb(255, 255, 255);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">HOPPE 好博</p></section><section style=";padding: 0px 5px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(255, 255, 255);font-size: 18px;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">&nbsp;产 品&nbsp;</strong></p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;box-shadow: rgb(0, 0, 0) 0px 0px 0px;word-wrap: break-word !important"><img data-ratio="0.6212963" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efh8Ph9RdUeI97x1MvQHDUy9NAm6LiclRVnrV28kic7HdWLiaCHQbHDGnCAg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1e80335bfd5a6a2f874eb9f70a9c4c501.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="1e80335bfd5a6a2f874eb9f70a9c4c501.jpg" alt="1e80335bfd5a6a2f874eb9f70a9c4c50.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">对于木门而言，把手是视觉焦点，往往是画龙点睛之处，对整个木门的谐调性起着关键作用。风格不搭、色彩不配、质感脱节，都会成为整樘木门的败笔。很多木门企业之所以开始注重标配五金，就是为了使五金对木门起到品质、观感提升的作用，而不是相反。门锁、把手是标配五金中最为重要的部分，好五金产品能够大大提升木门的品质感、体验感。</p><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;line-height: normal;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"/></section><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE 好博五金之所以誉满全球，就因为它不仅做到了自身产品品质、设计卓越，还关照了整樘木门的使用感受、安全、环保和空间风格的一致性打造。</p></section><section powered-by="xiumi.us" style="margin: 16px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.5046296" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efh2Uyj708R3sUW0vDuqnKF2sv8jmZ78uLaIruiaAh3t1bxoXqCsealdibA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1c8afb04de8f90d861040490cf8314111.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="1c8afb04de8f90d861040490cf8314111.jpg" alt="1c8afb04de8f90d861040490cf831411.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE 好博五金款式丰富、设计经典，时尚与典雅同在，硬朗与圆润皆存，同时具有丰富色彩可选，可以满足不同环境、不同空间的搭配需求。</p><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;line-height: normal;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"/></section><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE 好博五金采用优质铝合金、不锈钢、黄铜和尼龙为原材料，材质特性的充分发挥，制作工艺的严谨，保证了HOPPE 好博五金的品质卓越。</p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 2px;max-width: 100%;box-sizing: border-box;display: inline-block;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section style="margin: 0px 5px 0px 0px;padding: 0px 8px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(0, 47, 91);background-color: rgb(255, 255, 255);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">HOPPE 好博</p></section><section style=";padding: 0px 5px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(255, 255, 255);font-size: 18px;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">&nbsp;品 质&nbsp;</strong></p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.6657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhtMrsf5dsOXQk1LEljMWJicv3dsicrWicjv0dgboNCiaYFP91FB1rShYRuw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1bc3c25e3df6f24b4f43c8897f11615e1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="1bc3c25e3df6f24b4f43c8897f11615e1.jpg" alt="1bc3c25e3df6f24b4f43c8897f11615e.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE好博内部执行着严格的品质检测标准，住宅五金要达到182500次启闭检测，非住宅五金要通过255500次，相当于10年时间里，住宅用产品每天开关门50次，非住宅用产品每天开关门70次。HOPPE 好博要求，无论是门把手还是配件，在检测过程中不能产生任何松动，才属于合格。</p><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;line-height: normal;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"/></section><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">“HOPPE 好博为所有品牌产品提供10年机械功能质保。”叶宝霞经理介绍到。</p><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;line-height: normal;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"/></section><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">除了10年机械功能质保，HOPPE 好博还提供10年表层质量保证。带有Resista<sup style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 12px;word-wrap: break-word !important">®</sup>&nbsp;表面处理的五金，即使在沿海等极端环境或高频次使用条件下，依然可以保证表面和颜色10年如新。</p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 2px;max-width: 100%;box-sizing: border-box;display: inline-block;background-color: rgb(0, 47, 91);word-wrap: break-word !important"><section style="margin: 0px 5px 0px 0px;padding: 0px 8px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(0, 47, 91);background-color: rgb(255, 255, 255);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">HOPPE 好博</p></section><section style=";padding: 0px 5px;max-width: 100%;box-sizing: border-box;display: inline-block;color: rgb(255, 255, 255);font-size: 18px;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">&nbsp;技 术&nbsp;</strong></p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.6890496" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhbZ2foj92ZtmqmvwBFB5lexLfM3G7ibUpGn8gCZuDNnBhdKLAkt3cMhA/640?wx_fmt=png" data-type="png" data-w="968" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/76a80bb9d8206627f3079dc47aaabcb71.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="76a80bb9d8206627f3079dc47aaabcb71.jpg" alt="76a80bb9d8206627f3079dc47aaabcb7.jpg"/></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 10px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 643.703125px;vertical-align: top;background-color: rgb(244, 244, 244);border-width: 0px;height: auto;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 14px;color: rgb(9, 9, 9);letter-spacing: 0px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">HOPPE 好博生产工具由自己研发设计和制造</strong></p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;text-align: justify;font-size: 14px;color: rgb(9, 9, 9);line-height: 2;letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">HOPPE 好博五金还采用了HOPPE Quick-Fit Connection专利技术，几乎不需要工具也可以完成安装，只需要将把手对插即可搞定。</p><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;line-height: normal;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"/></section><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;text-indent: 2em;word-wrap: break-word !important">尤其引起门企注意的是，叶宝霞经理在分享中提到，HOPPE 好博生产把手的设备和工具，是自己研发、设计和制造的。这意味着，市场上没有办法购买到相同设备，也无法做出同样产品，这就保证了市场上HOPPE 好博产品的纯正。这也是HOPPE 好博的核心竞争力所在。</p></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><br style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;text-align: center;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;display: inline-block;width: 663.453125px;vertical-align: top;box-shadow: rgb(178, 185, 192) 1px 0px 10px;word-wrap: break-word !important"><section powered-by="xiumi.us" style="margin: 0px 0px 20px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.437037" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhHibRWdPrMMDV7UeqUicVvKCM2YITesqpAM2zdbDMCaSgfYogehueZn3w/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a5fdcbb15a6beda06a4c5d50259aebc71.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="a5fdcbb15a6beda06a4c5d50259aebc71.jpg" alt="a5fdcbb15a6beda06a4c5d50259aebc7.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 5px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: middle;width: 253.4375px;box-shadow: rgb(0, 0, 0) 0px 0px 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;width: 243.4375px;word-wrap: break-word !important"><a target="_blank" href="http://mp.weixin.qq.com/s?__biz=MzA3MjgzNjc0NQ==&mid=2650532870&idx=1&sn=d116082a97cf53623478cef378a096a4&chksm=87177fe0b060f6f6c24ba3e5d78170020e1d91a506b7fc9853ae91d025da03bfcade63db2df6&scene=21#wechat_redirect" textvalue="你已选中了添加链接的内容" data-itemshowtype="0" tab="innerlink" data-linktype="1" hasload="1" style=";padding: 0px;color: rgb(87, 107, 149);cursor: pointer;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"><span class="js_jump_icon h5_image_link" data-positionback="static" style=";padding: 0px;max-width: 100%;line-height: 0;font-size: 0px;display: inline-block;position: relative;top: auto;left: auto;right: auto;bottom: auto;box-sizing: border-box !important;word-wrap: break-word !important"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhTQN4bfuJpcH7oVqovWFZgoqGorIJC260rH5P0gTiaibXn8XDg87ibicSRg/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f9192df4ace462661963ab7884a154ff2.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;border: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;width: 243.4375px;word-wrap: break-word !important;height: auto !important;visibility: visible !important" title="f9192df4ace462661963ab7884a154ff2.jpg" alt="f9192df4ace462661963ab7884a154ff.jpg"/></span></a></section></section></section><section style=";padding: 5px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: middle;width: 410px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 15px;color: rgb(0, 47, 91);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">HOPPE 好博微信小程序</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;border-top-width: 1px;border-top-style: dashed;border-top-color: rgb(62, 62, 62);word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top"></svg></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 14px;color: rgb(72, 72, 72);letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">👈 点击查看小程序使用指南</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 5px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: middle;width: 253.4375px;box-shadow: rgb(0, 0, 0) 0px 0px 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;width: 243.4375px;word-wrap: break-word !important"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efh82UeXicDf5bBHWumVUcbegQP1BibWbvTr1FUNOcwwulz0mgxibOIUh2MA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7cfff7163b5a9e140f465e9e9d8d6a2f1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;width: 243.4375px;word-wrap: break-word !important;height: auto !important;visibility: visible !important" title="7cfff7163b5a9e140f465e9e9d8d6a2f1.jpg" alt="7cfff7163b5a9e140f465e9e9d8d6a2f.jpg"/></section></section></section><section style=";padding: 5px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: middle;width: 410px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 15px;color: rgb(0, 47, 91);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">HOPPE 好博微信公众号</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;border-top-width: 1px;border-top-style: dashed;border-top-color: rgb(62, 62, 62);word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top"></svg></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 14px;color: rgb(72, 72, 72);letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">👈 长按识别二维码关注我们</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 5px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: middle;width: 253.4375px;box-shadow: rgb(0, 0, 0) 0px 0px 0px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;width: 243.4375px;word-wrap: break-word !important"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhazhrID4NvLvhkvwl6qwRrOaBgy9HrS5IDfmME22aP0f2zSXcibjIia5g/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/dfd8133c6d82d7ad87b4172861c2cfbc1.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;width: 243.4375px;word-wrap: break-word !important;height: auto !important;visibility: visible !important" title="dfd8133c6d82d7ad87b4172861c2cfbc1.jpg" alt="dfd8133c6d82d7ad87b4172861c2cfbc.jpg"/></section></section></section><section style=";padding: 5px;max-width: 100%;box-sizing: border-box;display: inline-block;vertical-align: middle;width: 410px;word-wrap: break-word !important"><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 15px;color: rgb(0, 47, 91);word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important"><strong style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important">HOPPE 好博官网</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;border-top-width: 1px;border-top-style: dashed;border-top-color: rgb(62, 62, 62);word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box !important;word-wrap: break-word !important"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top"></svg></section></section></section><section powered-by="xiumi.us" style=";padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;font-size: 14px;color: rgb(72, 72, 72);letter-spacing: 0.5px;word-wrap: break-word !important"><p style="margin-top: 0px;margin-bottom: 0px;padding: 0px;max-width: 100%;box-sizing: border-box;clear: both;min-height: 1em;word-wrap: break-word !important">👈 长按识别二维码进入官网</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 0px;padding: 0px;max-width: 100%;box-sizing: border-box;word-wrap: break-word !important"><section style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;display: inline-block;line-height: 0;word-wrap: break-word !important"><img data-ratio="0.4657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZVLOTvu1FjIG6O1MhO7efhYnLfGxpx8Lb0kw4NhZAN5xF0kVwddicnicgV5G7afcePZOkpTJSaLLDA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/02de63514fd5b5c0b243fc30ee1586e51.jpg" crossorigin="anonymous" data-fail="0" style=";padding: 0px;max-width: 100%;box-sizing: border-box;vertical-align: middle;word-wrap: break-word !important;height: auto !important;width: 677px !important;visibility: visible !important" title="02de63514fd5b5c0b243fc30ee1586e51.jpg" alt="02de63514fd5b5c0b243fc30ee1586e5.jpg"/></section></section></section></section></section><p><br/></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-12-02', '2020-12-04 16:43:22'),
	(57, 'HOPPE 好博领衔旗下ARRONE 安侬品牌，重磅推出零售套装！', '/upload/home/news/11.24.jpg', '<p><br/></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-family: -apple-system-font, BlinkMacSystemFont, " helvetica="" pingfang="" hiragino="" sans="" microsoft="" yahei="" letter-spacing:="" font-size:="" word-wrap:="" break-word=""><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 3px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 670.21875px; vertical-align: top; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 662.21875px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 658.21875px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 645.046875px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 645.046875px; vertical-align: top; overflow-x: auto; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 300%; box-sizing: border-box; overflow: hidden; width: 1935.140625px; transform: rotate(0deg); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 645.03125px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 645.03125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 645.03125px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 645.03125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 645.03125px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 645.03125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; line-height: 0; width: 26.3125px; word-wrap: break-word !important;"></section><section style="margin: 0px 0px 2px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; line-height: 1.2em; font-size: 14px; color: rgb(35, 35, 35); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-shadow: rgb(255, 255, 255) 2px 0px 2px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"></span></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/46e397c1f802f66f2c33909961fa19271.jpg" title="46e397c1f802f66f2c33909961fa19271.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/c359a1c3c2edfae471ee1aafe2526f351.jpg" title="c359a1c3c2edfae471ee1aafe2526f351.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/a407f31c43910238b0265b4cbc0854241.jpg" title="a407f31c43910238b0265b4cbc0854241.jpg"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-shadow: rgb(255, 255, 255) 2px 0px 2px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><br/></span><br/></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; line-height: 0; width: 26.3125px; word-wrap: break-word !important;"></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">为帮助消费者以更高的性价比购买优质产品，HOPPE 好博零售特推出多款可靠实用的产品套装。同时，为维护广大消费者的合法权益，避免因购买假冒伪劣产品带来损失，HOPPE 好博产品防伪标签及防伪查询系统从源头上为消费者保驾护航，让消费者买的放心，用的安心！</p></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.18016194331983806" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvNGYbbZZ3q6VEyPbL9jia0QZsDeCR7JpkaOIW4DEjuV9QVqL8zJfpNVw/640?wx_fmt=jpeg" data-type="jpeg" data-w="988" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/38dc7152fddeb46f518724ac4145107a.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="38dc7152fddeb46f518724ac4145107a.jpg" alt="38dc7152fddeb46f518724ac4145107a.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 17px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 40.609375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvDoicF8P7EHQVNYUF9BsSxHgoDiafFsjeMfbDSMtm5DhSYRcxp9ZzafYw/640?wx_fmt=gif" data-type="gif" data-w="400" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvDoicF8P7EHQVNYUF9BsSxHgoDiafFsjeMfbDSMtm5DhSYRcxp9ZzafYw/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 40.609375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(135, 135, 135) 0px 0px 3px; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">HOPPE 好博集团致力于研发、生产和销售细节体现品味风格的铝合金、不锈钢、尼龙和黄铜制门窗五金。HOPPE 好博产品线能够做到门把手与窗把手同颜色、同款式、同系列。现在，伴随着零售经销店产品套装的推出，真正实现为用户提供一站式解决方案。</span></p></section></section><section powered-by="xiumi.us" style="margin: 14px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">HOPPE 好博集团旗下的ARRONE 安侬品牌涵盖了全方位高品质的门窗五金及配件产品。ARRONE 安侬产品与HOPPE 好博集团旗下的各类铝合金、黄铜、不锈钢和尼龙门窗五金产品可进行完美搭配。</span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; min-width: 10%; flex: 0 0 auto; height: auto; align-self: flex-end; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 38px; color: rgb(0, 47, 91); line-height: 1; letter-spacing: 0px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">01</strong></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; align-self: flex-end; flex: 0 0 0%; height: auto; line-height: 2; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 14px; vertical-align: top; flex: 0 0 auto; height: auto; line-height: 0; letter-spacing: 0px; align-self: flex-start; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 14px; height: auto; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif" data-type="gif" data-w="300" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 14px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.5607787274453941" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvk6Ag1vKmGlpPDSFfPQAGAXNZUBEUk7KRrjUVyrmdPBHsLXVVRp6Dxw/640?wx_fmt=jpeg" data-type="jpeg" data-w="2106" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/36541f5c6fa09e5baf90bff1c5e7f8f7.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="36541f5c6fa09e5baf90bff1c5e7f8f7.jpg" alt="36541f5c6fa09e5baf90bff1c5e7f8f7.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 5px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.665" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvNAZgOKuzUldU8icicYUZUpHibT18ibzLTIoxyK7cZCTen3sNtGKbPSC8IQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f33ede395e78b961f97e1321688b4205.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f33ede395e78b961f97e1321688b4205.jpg" alt="f33ede395e78b961f97e1321688b4205.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">黑哑光与其他色彩组合，能够很好地起到衬托作用，可以充分显示其他色的光感与色感。黑哑光能够突出室内多颜色家具的细节表现或加重同色调室内装修的风格气质。</span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; min-width: 10%; flex: 0 0 auto; height: auto; align-self: flex-end; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 38px; color: rgb(0, 47, 91); line-height: 1; letter-spacing: 0px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">02</strong></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; align-self: flex-end; flex: 0 0 0%; height: auto; line-height: 2; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 14px; vertical-align: top; flex: 0 0 auto; height: auto; line-height: 0; letter-spacing: 0px; align-self: flex-start; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 14px; height: auto; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif" data-type="gif" data-w="300" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="2" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 14px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.6959340011785504" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvXicGIDjqptPibyfbZiaxxFDVLnNOuVne78xtG96FcXOwQPYI0wR33Omicg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1697" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/fc0b6b6e460dbbc772431ef04c51a400.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="fc0b6b6e460dbbc772431ef04c51a400.jpg" alt="fc0b6b6e460dbbc772431ef04c51a400.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 5px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.665" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvdl7ZkSYIp8mpVbRJ4UXaw6m1H3aYE7GzdcpSTNJoqJIZhSeErY79qA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/776dbf16f1e78a6df01302b398ad270f.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="776dbf16f1e78a6df01302b398ad270f.jpg" alt="776dbf16f1e78a6df01302b398ad270f.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">银灰系的色彩对其他颜色的融合亲和力非常强，被称为“万搭色”，无论是冷色还是暖色，与银灰色相搭配，都能碰撞出精彩的火花。银灰色系在风格上也更加简洁利落、低调优雅而又质感大气。</span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; min-width: 10%; flex: 0 0 auto; height: auto; align-self: flex-end; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 38px; color: rgb(0, 47, 91); line-height: 1; letter-spacing: 0px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">03</strong></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; align-self: flex-end; flex: 0 0 0%; height: auto; line-height: 2; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 14px; vertical-align: top; flex: 0 0 auto; height: auto; line-height: 0; letter-spacing: 0px; align-self: flex-start; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 14px; height: auto; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif" data-type="gif" data-w="300" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="3" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 14px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="1.0262489415749365" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvaEuoSx3icW9TwITaEyG0BmIxZ2slomibCZFlmFFeJhKfyfCnLKvN87wg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1181" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5414b4e7d369cfe1ac659a2a26d174b2.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="5414b4e7d369cfe1ac659a2a26d174b2.jpg" alt="5414b4e7d369cfe1ac659a2a26d174b2.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 5px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.665" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCv8v1HGsAMbEu5lgiaTZwhg3rHnb3pdL9CEcwmuD7hsmzeCWmcGq0HacQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e404a00f03556c68b854458e5b279e4b.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="e404a00f03556c68b854458e5b279e4b.jpg" alt="e404a00f03556c68b854458e5b279e4b.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">暖色调的铜可以很好地与天然木头和黄铜颜色表面处理搭配，豪华的内室采用金色把手将会是不错的选择。铜色，给人温馨而高贵的感觉，能够使居室更具品位，也能很好地展现出铜色丰富的色彩表现力。</span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; min-width: 10%; flex: 0 0 auto; height: auto; align-self: flex-end; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 38px; color: rgb(0, 47, 91); line-height: 1; letter-spacing: 0px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">04</strong></p></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: bottom; width: auto; align-self: flex-end; flex: 0 0 0%; height: auto; line-height: 2; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 14px; vertical-align: top; flex: 0 0 auto; height: auto; line-height: 0; letter-spacing: 0px; align-self: flex-start; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 14px; height: auto; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif" data-type="gif" data-w="300" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvyq2ljqveVupO6ybZJXWNkAbpVvQMryP3wlzDDdMY2hXQtz5I4aHjiag/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="4" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 14px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><img data-ratio="1.0414902624894158" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCv3reD5fTr5bDkPfnwFgLWZoctxpKpWOku0h24Mvrq0Q4ibkp642tQvbQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1181" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/adf9182e46450ef167646a9776113fc3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="adf9182e46450ef167646a9776113fc3.jpg" alt="adf9182e46450ef167646a9776113fc3.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 5px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 627.3125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.665" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvMFcaxk7Pju9okXaWuUibGnVMKakDkBNqU2xxnqUb32pRQrqpVRlfGibA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c9c313e3b7000fef1d56b529c07a70dc.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 627.3125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="c9c313e3b7000fef1d56b529c07a70dc.jpg" alt="c9c313e3b7000fef1d56b529c07a70dc.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">质感金属古铜色，呈现出一种华丽而不失庄重的铜系之美。恰到好处地点缀，便能起到不一样的轻奢复古的效果。</span></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><img data-ratio="0.20647773279352227" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvzw5nWZYqepicswliaicSWS2cqgsEtUVYDJLSTfxaRt9ew2sK0ia3BsZP6Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="988" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/21f597c889b538742ba1e44e10b6351a.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="21f597c889b538742ba1e44e10b6351a.jpg" alt="21f597c889b538742ba1e44e10b6351a.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 17px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 40.609375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvDoicF8P7EHQVNYUF9BsSxHgoDiafFsjeMfbDSMtm5DhSYRcxp9ZzafYw/640?wx_fmt=gif" data-type="gif" data-w="400" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvDoicF8P7EHQVNYUF9BsSxHgoDiafFsjeMfbDSMtm5DhSYRcxp9ZzafYw/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="5" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 40.609375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 5px 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(135, 135, 135) 0px 0px 3px; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 6px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 640.375px; height: auto; word-wrap: break-word !important;"><img data-ratio="2.42" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvE7elicJGoVgElRiaR7Wfr3KWtS8HTgvP4xbfNFzHgvYHJENcxTy5crRw/640?wx_fmt=jpeg" data-type="jpeg" data-w="600" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/b695d53b95163281081975f210ec96bb.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 640.375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="b695d53b95163281081975f210ec96bb.jpg" alt="b695d53b95163281081975f210ec96bb.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 16px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 13px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👆&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(168, 163, 163); word-wrap: break-word !important;">套装产品上的防伪标签</span>&nbsp;👆</p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">套装产品中，每一个产品的独立包装上均附有HOPPE 好博防伪标签。</span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 653.453125px; word-wrap: break-word !important;"><table width="653"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:8.col1:4.classicTable1:0" powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:4.classicTable1:0.td@@0" width="12.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 2px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; vertical-align: top; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 3px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 10px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; border: 1px solid rgb(0, 47, 91); width: 1.8em; height: 1.8em; line-height: 1.8em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; color: rgb(255, 255, 255); background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">1</strong></p></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:4.classicTable1:0.td@@1" width="88.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 0px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">打开微信“扫一扫”，扫描产品防伪标签上的二维码。</p></section></td></tr></tbody></table></section></section><section powered-by="xiumi.us" style="margin: 13px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 470.484375px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.649090909090909" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvlwu8ZiaQibpjL5ZLQD5ITYm9yFVxngeQjp5ibo3dJ6S9aXyvQ1dVQ3chA/640?wx_fmt=png" data-type="png" data-w="550" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/87b960ebe79dd891b1b92ac3cc3e729f.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 470.484375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="87b960ebe79dd891b1b92ac3cc3e729f.jpg" alt="87b960ebe79dd891b1b92ac3cc3e729f.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 653.453125px; word-wrap: break-word !important;"><table width="653"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:8.col1:6.classicTable1:0" powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:6.classicTable1:0.td@@0" width="12.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 2px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; vertical-align: top; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 3px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 10px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; border: 1px solid rgb(0, 47, 91); width: 1.8em; height: 1.8em; line-height: 1.8em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; color: rgb(255, 255, 255); background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">2</strong></p></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:6.classicTable1:0.td@@1" width="88.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 0px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">扫码之后关注“HOPPE好博集团”微信公众号；</p></section></td></tr></tbody></table></section></section><section powered-by="xiumi.us" style="margin: 13px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 457.40625px; height: auto; word-wrap: break-word !important;"><img data-ratio="2.077777777777778" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvxHku5q0Dib7JZqFO6X7ApnuwOyoBgTBSzkk4cxKW8rdsbT0v9eUu3nw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1b20c2a42337034169cc721464fb5a7d.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 457.40625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="1b20c2a42337034169cc721464fb5a7d.jpg" alt="1b20c2a42337034169cc721464fb5a7d.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; text-align: left; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: justify; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; word-wrap: break-word !important;">关注之后根据提示，点击公众号底部菜单栏<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(0, 47, 91); word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">“品质卓越”——“防伪查询”</strong></span>或者输入<span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(0, 47, 91); word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">关键词“防伪查询”</strong></span>即可进入HOPPE 好博防伪查询平台。</span><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 326.71875px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 320.171875px; height: auto; word-wrap: break-word !important;"><img data-ratio="2.1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvLKzia4R0Cv0eHKw6CMiambMvslnlAoNNrqTwkZBSxx4elJ60H5poibnFg/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c84ed8c7624725c7b3962fc2e0fe021d.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.171875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="c84ed8c7624725c7b3962fc2e0fe021d.jpg" alt="c84ed8c7624725c7b3962fc2e0fe021d.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 326.71875px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 320.171875px; height: auto; word-wrap: break-word !important;"><img data-ratio="2.1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvnDlSUKroqKU1MHutfW1dYQNrJcbkUmlzqgwibPicwuMtOVljWibdfbgDg/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/86686d85d30455bfc544ffafb0ec4fb4.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.171875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="86686d85d30455bfc544ffafb0ec4fb4.jpg" alt="86686d85d30455bfc544ffafb0ec4fb4.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 653.453125px; word-wrap: break-word !important;"><table width="653"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:8.col1:10.classicTable1:0" powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:10.classicTable1:0.td@@0" width="12.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 2px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; vertical-align: top; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 3px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 10px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; border: 1px solid rgb(0, 47, 91); width: 1.8em; height: 1.8em; line-height: 1.8em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; color: rgb(255, 255, 255); background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">3</strong></p></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:10.classicTable1:0.td@@1" width="88.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 0px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">在防伪查询页面，点击输入框右侧图标，再次扫描防伪标签上的二维码可自动识别录入防伪码（无需手动输入）；</p></section></td></tr></tbody></table></section></section><section powered-by="xiumi.us" style="margin: 13px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 444.34375px; height: auto; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><img data-ratio="1.7179487179487178" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCv8pDfxvhlLibrWmQ40fNGA4VXL7FfdqyyuYbDu4oqhA41KVYY6zicfNeQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="351" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7473463fcac0fa5f594e217a8177f705.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 444.34375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="7473463fcac0fa5f594e217a8177f705.jpg" alt="7473463fcac0fa5f594e217a8177f705.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 653.453125px; word-wrap: break-word !important;"><table width="653"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:8.col1:12.classicTable1:0" powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:12.classicTable1:0.td@@0" width="12.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 2px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; vertical-align: top; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 3px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 10px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; border: 1px solid rgb(0, 47, 91); width: 1.8em; height: 1.8em; line-height: 1.8em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; color: rgb(255, 255, 255); background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">4</strong></p></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:12.classicTable1:0.td@@1" width="88.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 0px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">输入防伪码之后，点击查询即可出现查询结果；</p></section></td></tr></tbody></table></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 326.71875px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 320.171875px; height: auto; word-wrap: break-word !important;"><img data-ratio="1.7179487179487178" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCv53xCeoK7RjeAqMy5B4t6vSolDz3kHzBRBErZw8I7WBeibVpUOfvHNpw/640?wx_fmt=jpeg" data-type="jpeg" data-w="351" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/bdfd43b1945a10348d961c7c00941663.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.171875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="bdfd43b1945a10348d961c7c00941663.jpg" alt="bdfd43b1945a10348d961c7c00941663.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 326.71875px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 320.171875px; height: auto; word-wrap: break-word !important;"><img data-ratio="1.7179487179487178" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvxTDr8ArBjoEYEsUDoiakXFWtVYiaeWwg5UAgib66lVt0HzSyR6LTEtJEg/640?wx_fmt=jpeg" data-type="jpeg" data-w="351" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/d23101e7a290de7d7b790c05ad6ad30e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.171875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="d23101e7a290de7d7b790c05ad6ad30e.jpg" alt="d23101e7a290de7d7b790c05ad6ad30e.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 653.453125px; word-wrap: break-word !important;"><table width="653"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:8.col1:14.classicTable1:0" powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:14.classicTable1:0.td@@0" width="12.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 2px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; vertical-align: top; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 3px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 10px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; border: 1px solid rgb(0, 47, 91); width: 1.8em; height: 1.8em; line-height: 1.8em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; color: rgb(255, 255, 255); background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">5</strong></p></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:14.classicTable1:0.td@@1" width="88.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 0px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">查询结果会显示查询时间，如果查询结果显示有多次查询记录，就需要留意产品存在的异常情况。</p></section></td></tr></tbody></table></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 326.71875px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 320.171875px; height: auto; word-wrap: break-word !important;"><img data-ratio="1.7179487179487178" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCviaNXbubxVp8JT6t4Rlw0NOb0ibejEmRgkYnkOz6qFQQdRbro2iaN8nGpw/640?wx_fmt=jpeg" data-type="jpeg" data-w="351" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c9c1cf8f290d6771c081735d1935c531.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.171875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="c9c1cf8f290d6771c081735d1935c531.jpg" alt="c9c1cf8f290d6771c081735d1935c531.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 326.71875px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 320.171875px; height: auto; word-wrap: break-word !important;"><img data-ratio="1.7179487179487178" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCv9jaNsBsRTw1Ml8I6glV2zs5NURQyjPczHTfFSEBpTvN2IzbHwboAaA/640?wx_fmt=jpeg" data-type="jpeg" data-w="351" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5588dd0e93eafff79a0201ec775cd0b1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.171875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="5588dd0e93eafff79a0201ec775cd0b1.jpg" alt="5588dd0e93eafff79a0201ec775cd0b1.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; min-height: 40px; word-wrap: break-word !important;"><section style="margin: 0px auto -10px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 653.453125px; word-wrap: break-word !important;"><table width="653"><tbody style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><tr opera-tn-ra-comp="_$.pages:0.layers:0.comps:8.col1:16.classicTable1:0" powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;" class="firstRow"><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:16.classicTable1:0.td@@0" width="12.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 2px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; vertical-align: top; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 3px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 10px; word-wrap: break-word !important;"><section style="margin: 0px auto; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; border: 1px solid rgb(0, 47, 91); width: 1.8em; height: 1.8em; line-height: 1.8em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; color: rgb(255, 255, 255); background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">6</strong></p></section></section></td><td colspan="1" rowspan="1" opera-tn-ra-cell="_$.pages:0.layers:0.comps:8.col1:16.classicTable1:0.td@@1" width="88.0000%" style="margin: 0px; padding-top: 10px; padding-right: 5px; padding-left: 0px; word-break: break-all; -webkit-hyphens: auto; border-style: none; border-color: rgb(62, 62, 62) rgb(62, 62, 62) rgb(207, 207, 207); max-width: 100%; box-sizing: border-box; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">如遇异常情况，可联系HOPPE 好博法务邮箱legal-sh@hoppe.com。HOPPE 好博切实维护消费者合法权益，助消费者安心选购，放心使用！</p></section></td></tr></tbody></table></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(178, 185, 192) 1px 0px 10px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.43703703703703706" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCv4Qc5qkk06qiaZtkft5mpFXNmaGwYp8tVx8Emd47ozLl5xyTFLib5HxNg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/acef8d9c8b056172b0ddf6770e1f65e1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="acef8d9c8b056172b0ddf6770e1f65e1.jpg" alt="acef8d9c8b056172b0ddf6770e1f65e1.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><a target="_blank" href="http://mp.weixin.qq.com/s?__biz=MzA3MjgzNjc0NQ==&mid=2650532870&idx=1&sn=d116082a97cf53623478cef378a096a4&chksm=87177fe0b060f6f6c24ba3e5d78170020e1d91a506b7fc9853ae91d025da03bfcade63db2df6&scene=21#wechat_redirect" textvalue="你已选中了添加链接的内容" data-itemshowtype="0" tab="innerlink" data-linktype="1" hasload="1" style="margin: 0px; padding: 0px; color: rgb(87, 107, 149); text-decoration: none; cursor: pointer; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span class="js_jump_icon h5_image_link" data-positionback="static" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 0; font-size: 0px; display: inline-block; position: relative; top: auto; left: auto; right: auto; bottom: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvJTY9hIN5NoG7jbX5pO1QKfqa4HnMKVrXqZ4FTEiafIbuzJv15Wge5Iw/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f9192df4ace462661963ab7884a154ff3.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; border: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f9192df4ace462661963ab7884a154ff3.jpg" alt="f9192df4ace462661963ab7884a154ff.jpg"/></span></a></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信小程序</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 点击查看小程序使用指南</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvjFIqqGmICE83RDwf5M2IGLKnbO8UNfwXiaA7SPt0H4icJ2hkrDN4xnfg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/8d328a5e799b71d0a07df98d28180012.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="8d328a5e799b71d0a07df98d28180012.jpg" alt="8d328a5e799b71d0a07df98d28180012.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信公众号</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码关注我们</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvkicHAMDZUsxkJtBCrMJH4SGmeGX8al1OUvuPRgvmria03fU31C8qvCwQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ffa00ee23385f7ed8d31c65cde67b409.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="ffa00ee23385f7ed8d31c65cde67b409.jpg" alt="ffa00ee23385f7ed8d31c65cde67b409.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博官网</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码进入官网</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.46574074074074073" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaZkcUeg8AGFGWQrsvEydcCvO1uCXlpHNvOyNo5PVRpwqMrkZCE4SRyqZicM2licQp4iaUY3NPWxDQVqg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c468ab54b09653a96f5c227ecb01642a.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="c468ab54b09653a96f5c227ecb01642a.jpg" alt="c468ab54b09653a96f5c227ecb01642a.jpg"/></section></section></section></section></section><p><br/></p><p><br/></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-11-24', '2020-12-04 17:31:09');
REPLACE INTO `news` (`id`, `title`, `img`, `content`, `recommend`, `face`, `sort`, `pubdate`, `create_time`) VALUES
	(58, 'HOPPE 好博微信小程序上线啦！', '/upload/home/news/10.263.jpg', '<p><br/></p><p></p><p><section data-mpa-powered-by="yiban.io" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 20px; padding: 0px; max-width: 100%; text-align: center; justify-content: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 663.453125px; vertical-align: top; height: auto; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 5px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 661.453125px; vertical-align: top; background-color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section><section powered-by="xiumi.us" style="margin: 14px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; letter-spacing: 0.5px; line-height: 2; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博微信小程序火热上线啦！VR展馆、查找产品、应用体验……您想要的，这里都有！HOPPE 好博微信小程序具体都有哪些功能呢？我们一起来看一看吧！</p></section></section><section powered-by="xiumi.us" style="margin: 18px 0px 12px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 330.71875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxURnD7WBrSF1kNsw3QmFFYib2vIxEjtprOXLtx6T0KQA1hs3AJ4IovOOw/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f9192df4ace462661963ab7884a154ff4.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 330.71875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f9192df4ace462661963ab7884a154ff4.jpg" alt="f9192df4ace462661963ab7884a154ff.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 13px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">👆&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(168, 163, 163); box-sizing: border-box !important; word-wrap: break-word !important;">长按识别进入小程序</span>&nbsp;👆</p></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 661.453125px; vertical-align: bottom; background-color: rgb(0, 47, 91); align-self: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; background-color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 135.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px; max-width: 100%; display: inline-block; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(1, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; border: 2px dotted white; width: 1.6em; height: 1.6em; font-size: 20px; line-height: 1.5em; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">一</strong></p></section></section></section></section><section style="margin: 0px; padding: 0px 5px 0px 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 541.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; color: rgb(255, 255, 255); letter-spacing: 0.5px; line-height: 1.8; font-size: 18px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">首页导航栏四大功能</strong></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 10px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; border-style: solid; border-width: 1px; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; border-color: rgb(246, 246, 246) rgb(240, 240, 240) rgb(240, 240, 240); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.22962962962962963" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUabGJSdE5RxfuEiaibUicNATMrpR7iaDqiawQdfiaUnRBAxelkEKJL38LvCaA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7e6c5b13c6e354206934cea2a18d4f311.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="7e6c5b13c6e354206934cea2a18d4f311.jpg" alt="7e6c5b13c6e354206934cea2a18d4f31.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUX2pqS6cDIqRa9jNQyTxAiatea6fmZd8bF0HJwTicAfGVYWpHgrPyDbzw/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ba886fdf9f89ebb911632ed9804b5c911.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="ba886fdf9f89ebb911632ed9804b5c911.jpg" alt="ba886fdf9f89ebb911632ed9804b5c91.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击首页页面上方“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">应用案例</strong></span>”图标，可查看HOPPE 好博产品在不同领域的应用案例及案例详情介绍。</p></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.093" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUJfCSTOibBUezDaVMlm88Dt73ayhlzYjTIgjVEQJh7n9wibibP7gh0whyQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/91e471ae0f1d240696cd9519080f981c1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="91e471ae0f1d240696cd9519080f981c1.jpg" alt="91e471ae0f1d240696cd9519080f981c.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.093" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUY19CDooJJzvR07WH4aH5cpTopRG9FTrzKmFicCHLSQUJSDkJ7BmRibTQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a7ed3baa456907e848556b27b84c1d871.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="a7ed3baa456907e848556b27b84c1d871.jpg" alt="a7ed3baa456907e848556b27b84c1d87.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUSQkTBLQnAYkZ2lSf3mObkXlicASSe2kuZbZHS0YdHEibCFvbd30iaxSPA/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/55bcc2435e9871c51fda029586a3cd0a1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="55bcc2435e9871c51fda029586a3cd0a1.jpg" alt="55bcc2435e9871c51fda029586a3cd0a.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击首页页面上方“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">附近门店</strong></span>”图标，可以实现：</p></section><section powered-by="xiumi.us" style="margin: 26px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 98.25px; align-self: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; transform: translate3d(-5px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 33px; height: 33px; vertical-align: top; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: right; justify-content: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 29.6875px; box-shadow: rgb(242, 169, 169) 0px 0px 0px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.7782101167315175" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUFUzCLdjOPSMINoCRuk8L20nVfG305El0LdZGoFKPMdNd2VzZvCJMaQ/640?wx_fmt=png" data-type="png" data-w="257" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/4050eaa16effeb13333c4d1d0726daf11.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 29.6875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="4050eaa16effeb13333c4d1d0726daf11.jpg" alt="4050eaa16effeb13333c4d1d0726daf1.jpg"/></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 524px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">智能抓取您所在的城市</p></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 98.25px; align-self: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; transform: translate3d(-5px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 33px; height: 33px; vertical-align: top; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: right; justify-content: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 29.6875px; box-shadow: rgb(242, 169, 169) 0px 0px 0px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUeISccXiavYV1Gugy2iaLXu1Ln4tiaiapddlC3oWmJDwl6M2GBa1XLc8wHg/640?wx_fmt=png" data-type="png" data-w="200" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/83c8b363ed2fc7c1a77d328d54136da81.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 29.6875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="83c8b363ed2fc7c1a77d328d54136da81.jpg" alt="83c8b363ed2fc7c1a77d328d54136da8.jpg"/></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 524px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">自动定位离您最近的授权经销店</p></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 98.25px; align-self: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; transform: translate3d(-5px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 33px; height: 33px; vertical-align: top; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: right; justify-content: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 29.6875px; box-shadow: rgb(242, 169, 169) 0px 0px 0px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUYvpFO7X8l7ClILv7a5jXTgRbia7CmCZuOCwC1vVbblZfoLJU76eXUBg/640?wx_fmt=png" data-type="png" data-w="200" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/678309c49273fe576b0b292c7b5165591.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 29.6875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="678309c49273fe576b0b292c7b5165591.jpg" alt="678309c49273fe576b0b292c7b516559.jpg"/></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 524px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">一键导航</p></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 98.25px; align-self: flex-start; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; transform: translate3d(-5px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 33px; height: 33px; vertical-align: top; overflow: hidden; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: right; justify-content: flex-end; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 29.6875px; box-shadow: rgb(242, 169, 169) 0px 0px 0px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUiaOHkPSRV43mmItTicDibtYQZ6X6wrOLgtGymDUiaS8YtwvT50ZJLQ0nug/640?wx_fmt=png" data-type="png" data-w="200" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/323f8f41c5969846388f447c9bdcfc2c1.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 29.6875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="323f8f41c5969846388f447c9bdcfc2c1.jpg" alt="323f8f41c5969846388f447c9bdcfc2c.jpg"/></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 524px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">一键拨号</p></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUXRwuRyicWhCUA2LJIGdofcReQHAo9FjLM0afYGKxLBiadCicchaFNRnvA/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4cc437283d25a440cf639329ea7c8bc51.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="4cc437283d25a440cf639329ea7c8bc51.jpg" alt="4cc437283d25a440cf639329ea7c8bc5.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击首页页面上方“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">新闻资讯</strong></span>”图标，可查看HOPPE 好博相关的新闻资讯信息。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.4925925925925927" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU85WV2NDeLj1ic2FGtCGhAictMbnMHP3UJLLkSwq155kC5ww15jvicwXkw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/eb2c1189b4b49ef01f7a9605be9819861.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="eb2c1189b4b49ef01f7a9605be9819861.jpg" alt="eb2c1189b4b49ef01f7a9605be981986.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU9qxABExIQlGJqupuib1Ng5iaRcPpGyg7aaCfBiceuML96pibL9gNiceQibjg/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/dd411589c1f3560774bb38aa108ae92c1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="dd411589c1f3560774bb38aa108ae92c1.jpg" alt="dd411589c1f3560774bb38aa108ae92c.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击首页页面上方“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">关于我们</strong></span>”图标，可查看关于HOPPE 好博的更多详细信息，包括“集团简介”、“品牌承诺”、“ARRONE”、“组织架构”。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.659" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUJD4XbgaIHOCc0IZEfmEUbTMWGOeiajFhnERgyosoIWUBEOXmtVV8Ydw/640?wx_fmt=gif" data-type="gif" data-w="1000" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUJD4XbgaIHOCc0IZEfmEUbTMWGOeiajFhnERgyosoIWUBEOXmtVV8Ydw/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; flex-flow: row nowrap; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; flex: 0 0 0%; align-self: center; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; transform: rotateZ(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; font-size: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 8px; height: 8px; vertical-align: top; overflow: hidden; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; box-shadow: rgba(255, 255, 255, 0) 2px -2px 0px; background-color: rgba(149, 114, 239, 0.07); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 100 100 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; color: rgb(0, 47, 91); letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;集团简介</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 14px; max-width: 100%; display: inline-block; width: 655px; vertical-align: top; border-width: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 6px 0px 15px 13px; max-width: 100%; display: inline-block; width: 641px; vertical-align: top; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); border-bottom-left-radius: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 6px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博集团简介及历史故事。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; flex-flow: row nowrap; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; flex: 0 0 0%; align-self: center; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; transform: rotateZ(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; font-size: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 8px; height: 8px; vertical-align: top; overflow: hidden; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; box-shadow: rgba(255, 255, 255, 0) 2px -2px 0px; background-color: rgba(149, 114, 239, 0.07); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 100 100 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; color: rgb(0, 47, 91); letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">品牌承诺</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 14px; max-width: 100%; display: inline-block; width: 655px; vertical-align: top; border-width: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 6px 0px 15px 13px; max-width: 100%; display: inline-block; width: 641px; vertical-align: top; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); border-bottom-left-radius: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.33544303797468356" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUzmFlZkgMrqpJOJqfYXdSKWwkVpT5WAsD1dXLf2ibjp3WAibaphtkkG6w/640?wx_fmt=png" data-type="png" data-w="1106" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/8e84cf7a07226283d1539272a9fe3c7f1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="8e84cf7a07226283d1539272a9fe3c7f1.jpg" alt="8e84cf7a07226283d1539272a9fe3c7f.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; flex-flow: row nowrap; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; flex: 0 0 0%; align-self: center; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; transform: rotateZ(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; font-size: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 8px; height: 8px; vertical-align: top; overflow: hidden; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; box-shadow: rgba(255, 255, 255, 0) 2px -2px 0px; background-color: rgba(149, 114, 239, 0.07); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 100 100 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; color: rgb(0, 47, 91); letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">ARRONE</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 14px; max-width: 100%; display: inline-block; width: 655px; vertical-align: top; border-width: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 6px 0px 15px 13px; max-width: 100%; display: inline-block; width: 641px; vertical-align: top; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); border-bottom-left-radius: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 6px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博旗下ARRONE 安侬品牌介绍。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: flex; flex-flow: row nowrap; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; flex: 0 0 0%; align-self: center; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; transform: rotateZ(45deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; font-size: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 8px; height: 8px; vertical-align: top; overflow: hidden; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; box-shadow: rgba(255, 255, 255, 0) 2px -2px 0px; background-color: rgba(149, 114, 239, 0.07); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 100 100 0%; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; color: rgb(0, 47, 91); letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">组织架构</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 14px; max-width: 100%; display: inline-block; width: 655px; vertical-align: top; border-width: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 6px 0px 15px 13px; max-width: 100%; display: inline-block; width: 641px; vertical-align: top; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); border-bottom-left-radius: 0px; letter-spacing: 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 6px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博现已发展为拥有欧美七家工厂、近三千员工，总部位于瑞士，业务遍及全球的集团企业。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; background-color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 135.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px; max-width: 100%; display: inline-block; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(1, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; border: 2px dotted white; width: 1.6em; height: 1.6em; font-size: 20px; line-height: 1.5em; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">二</strong></p></section></section></section></section><section style="margin: 0px; padding: 0px 5px 0px 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 541.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; color: rgb(255, 255, 255); letter-spacing: 0.5px; line-height: 1.8; font-size: 18px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">体验中心特色功能</strong></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 10px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; border-style: solid; border-width: 1px; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; border-color: rgb(246, 246, 246) rgb(240, 240, 240) rgb(240, 240, 240); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 30px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUf4X1qvuVem1dsvko2P3MVzy54jnyibvRu0tMGReRQ0k3CHwpP7MiaQaw/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/fd2f6783f9e7a86c243a0fb0752c82b01.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="fd2f6783f9e7a86c243a0fb0752c82b01.jpg" alt="fd2f6783f9e7a86c243a0fb0752c82b0.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 6px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 78.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 42.4375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUIZ26xWK7azrib4d8OssyP0j8c1CyDTU6Kp2icGgVXlkVVEmQcUicEiaib0w/640?wx_fmt=jpeg" data-type="jpeg" data-w="60" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/22b5f2f221cebb87747f83b6d54ef37f1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 42.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="22b5f2f221cebb87747f83b6d54ef37f1.jpg" alt="22b5f2f221cebb87747f83b6d54ef37f.jpg"/></section></section></section><section style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; display: inline-block; vertical-align: top; width: 576.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -5px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 14px; letter-spacing: 0.5px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;">选择场景：</span></strong>可以选择产品具体想要运用的场景，查看产品应用效果。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUATt9S9uMhdtpOb44EdmXuxibuiabVNb1hBZIKdFjcy7OTplfvZIhHeFw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/743cd9ef76130a4bc177667fc7d1a71f1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="743cd9ef76130a4bc177667fc7d1a71f1.jpg" alt="743cd9ef76130a4bc177667fc7d1a71f.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUBWHTAJstxEaWJGHqgAmM2WwsyFWugDq7kHBdS0yRucRiaozPEt5BENw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f060e8cf027b2c141134d5173130b2af1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f060e8cf027b2c141134d5173130b2af1.jpg" alt="f060e8cf027b2c141134d5173130b2af.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 6px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 78.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 42.4375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUdqBia5RxZnpPb1dj0ibDKyljBqA4qcHQib50SGiaV5xr3J7dTYludUqcxQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="60" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/bff158643f12d81d227325a3a59535c91.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 42.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="bff158643f12d81d227325a3a59535c91.jpg" alt="bff158643f12d81d227325a3a59535c9.jpg"/></section></section></section><section style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; display: inline-block; vertical-align: top; width: 576.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -5px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 14px; letter-spacing: 0.5px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;">选择门材质：</span></strong>根据不同场景和需求，还可以选择不同的门材质，查看产品应用效果。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUgYMPgC4IVuuwca11YAHaBlYP5ryHyp67MIJrDdEmLahIswsqsJujicQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/dc4b6f58b324e713e246c9bc289efaba1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="dc4b6f58b324e713e246c9bc289efaba1.jpg" alt="dc4b6f58b324e713e246c9bc289efaba.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUlTQ08X2iapbCYsOLAGPAES5EBlLd2nfStbLmUoGe37YNKpXTfL88qpw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/08f091114d3b46502d33c3fcf89605342.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="08f091114d3b46502d33c3fcf89605342.jpg" alt="08f091114d3b46502d33c3fcf8960534.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 6px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 78.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 42.4375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU9YtVMu160ULvvLicz9oZibrHrBuIxdGKHYBUM2ReqBzhMiaVUA8IVFJyw/640?wx_fmt=jpeg" data-type="jpeg" data-w="60" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4cdc0ca0a9ec8a70d711fe3c6a82e3a61.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 42.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="4cdc0ca0a9ec8a70d711fe3c6a82e3a61.jpg" alt="4cdc0ca0a9ec8a70d711fe3c6a82e3a6.jpg"/></section></section></section><section style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; display: inline-block; vertical-align: top; width: 576.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -5px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 14px; letter-spacing: 0.5px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">选择产品：</strong></span>可以根据产品材质，查看对应类别下不同产品的应用效果。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUnH9P9icXlPl5ro91oVnCrJ6PY8hBX6ia85rsEpX1WwoibyPApLgWyatiaw/640?wx_fmt=gif" data-type="gif" data-w="1000" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUnH9P9icXlPl5ro91oVnCrJ6PY8hBX6ia85rsEpX1WwoibyPApLgWyatiaw/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 6px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 78.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 42.4375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUAGDbI2qa8RQnPqmhDPNcbFTSs52uoZPIhUzs4Nff9ynkDdtERCnLcg/640?wx_fmt=jpeg" data-type="jpeg" data-w="60" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/08666a727f1d1885c66b8d29a69b0ed71.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 42.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="08666a727f1d1885c66b8d29a69b0ed71.jpg" alt="08666a727f1d1885c66b8d29a69b0ed7.jpg"/></section></section></section><section style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; display: inline-block; vertical-align: top; width: 576.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -2px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 14px; letter-spacing: 0.5px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">点击箭头处可查看所选产品的详细信息。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxULxzZvqP7D7icyPP3uuFoGQbE6AcIw2mKT3QSQyfAjsjFsYtUslicVAHA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/590b61ad730f1091b5f11a8720f994912.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="590b61ad730f1091b5f11a8720f994912.jpg" alt="590b61ad730f1091b5f11a8720f99491.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUubwTZCKGv8sUgdbqbpx6rGspa3DbwnmgldMJejPYsvGx4rt2LbGVoA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ac3b372719f5750a52349bef80cd068a1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="ac3b372719f5750a52349bef80cd068a1.jpg" alt="ac3b372719f5750a52349bef80cd068a.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 6px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 78.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 42.4375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUMBgbsvA6CMuqgiapTpYI3bjCO9ibvEziaRHeRY6gNrc9TD6UONU7CSHiag/640?wx_fmt=jpeg" data-type="jpeg" data-w="60" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/2d33f30f237021faf7332f2dc239afb01.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 42.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="2d33f30f237021faf7332f2dc239afb01.jpg" alt="2d33f30f237021faf7332f2dc239afb0.jpg"/></section></section></section><section style="margin: 0px; padding: 0px 0px 0px 5px; max-width: 100%; display: inline-block; vertical-align: top; width: 576.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -5px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 14px; letter-spacing: 0.5px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">点击右上角“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">保存</strong></span>”按钮可将最终产品应用效果图进行保存下载之后分享给好友。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUh0VaD7BedlkLBISoDicFogCicHXESo9ib5JO5vk0S78jMk7SOOCOXuFwQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e5291fe671b410fb8129d72a861cc4831.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="e5291fe671b410fb8129d72a861cc4831.jpg" alt="e5291fe671b410fb8129d72a861cc483.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 3px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUh15eBHAeU3A8LGsBAIvA9uxyh6xeQYv3up30UfxfEsmXNpAjgHTicicw/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7e7634acb20f467fc84ffb454409785c1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="7e7634acb20f467fc84ffb454409785c1.jpg" alt="7e7634acb20f467fc84ffb454409785c.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">全方位、多角度带您线上参观HOPPE 好博广州分公司。VR展馆，点击🔍更多精彩，等您发现！<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.107" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU7cucCjgibDDpIIWkux2cXsSOWwrM5Rzsickuc1iccmPIvCczUeH3ooP0w/640?wx_fmt=gif" data-type="gif" data-w="1000" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU7cucCjgibDDpIIWkux2cXsSOWwrM5Rzsickuc1iccmPIvCczUeH3ooP0w/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="2" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; background-color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 135.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px; max-width: 100%; display: inline-block; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(1, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; border: 2px dotted white; width: 1.6em; height: 1.6em; font-size: 20px; line-height: 1.5em; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">三</strong></p></section></section></section></section><section style="margin: 0px; padding: 0px 5px 0px 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 541.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; color: rgb(255, 255, 255); letter-spacing: 0.5px; line-height: 1.8; font-size: 18px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">产品中心</strong></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 10px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; border-style: solid; border-width: 1px; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; border-color: rgb(246, 246, 246) rgb(240, 240, 240) rgb(240, 240, 240); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击页面底部“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">产品中心</strong></span>”，可以查看HOPPE 好博的所有产品。点击左侧不同产品类别，可以看到该类别下的所有产品。</p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.1074074074074076" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU5m5Bd9080oDYADnPNTWIqmibyPia1WID56PiaGJtnVgLfvaVdV3PRiaTtQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/806db9d02d48f77b5ae66ae956fa51381.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="806db9d02d48f77b5ae66ae956fa51381.jpg" alt="806db9d02d48f77b5ae66ae956fa5138.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击右上角“<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">筛选</strong></span>”按钮，还可根据材质和颜色来选择相应的产品。</p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 432.296875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.1074074074074076" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUTmm7ianRKeia7OesqouWgSGYOEeYHnlqV3HyYLsPc97SnzZeaQeiaU49g/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c39242d38edef2c83792c9efa1e2f7851.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 432.296875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="c39242d38edef2c83792c9efa1e2f7851.jpg" alt="c39242d38edef2c83792c9efa1e2f785.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; background-color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 135.390625px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px; max-width: 100%; display: inline-block; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; background-color: rgb(1, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; border: 2px dotted white; width: 1.6em; height: 1.6em; font-size: 20px; line-height: 1.5em; color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">四</strong></p></section></section></section></section><section style="margin: 0px; padding: 0px 5px 0px 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 541.59375px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; color: rgb(255, 255, 255); letter-spacing: 0.5px; line-height: 1.8; font-size: 18px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">其他功能</strong></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 10px; max-width: 100%; display: inline-block; width: 677px; vertical-align: top; border-style: solid; border-width: 1px; border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; border-color: rgb(246, 246, 246) rgb(240, 240, 240) rgb(240, 240, 240); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUgcdxp3jlUFB8ibhR6ibtrXgaRsicjsIj8qpbemz4ibbRoAjGMovcRibf9Sg/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5bfee4875cbab1cfd8c2c2ca9b6f92e11.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="5bfee4875cbab1cfd8c2c2ca9b6f92e11.jpg" alt="5bfee4875cbab1cfd8c2c2ca9b6f92e1.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">可以查看HOPPE 好博相关技术视频、图册资料等。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUVRGtFARWIBomMlHs9geMBVqKkKYPjy5N9rY7COuwqva1ZMia90ByRbQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c87374c6e3e180eab71d87f379b050481.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="c87374c6e3e180eab71d87f379b050481.jpg" alt="c87374c6e3e180eab71d87f379b05048.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUc2LvicIkTkSam8bqHwRA9y9bVJTgCOuek07fkcCvW0N9SkGL3JsGDiaw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/17da970753c69b170130bca2bf0609421.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="17da970753c69b170130bca2bf0609421.jpg" alt="17da970753c69b170130bca2bf060942.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 24px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1713106" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUcPciaLA9YkqHSeLEl6AQR9ChJzMHs4ibreghpOxhABVp1kJoGCgcjthA/640?wx_fmt=jpeg" data-type="jpeg" data-w="969" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f6bd8b62e94dc0c4dd04680dee6923c41.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="f6bd8b62e94dc0c4dd04680dee6923c41.jpg" alt="f6bd8b62e94dc0c4dd04680dee6923c4.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">查看HOPPE 好博相关联系方式及地址信息。点击“<strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(0, 47, 91); box-sizing: border-box !important; word-wrap: break-word !important;">更多销售信息</span></strong>”还可以查看各部门销售的相关信息。</p></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUY8tCKG9wXVZShYiaM0icnLUKcgP3ErGou4lKTkUiaHeaQK6RNR2m8brhA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f7f9ff0041daca7b959d70a5ff5489da1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f7f9ff0041daca7b959d70a5ff5489da1.jpg" alt="f7f9ff0041daca7b959d70a5ff5489da.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 327.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.9375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="2.1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU1ByCwfJ6748yyMqibyjCPrz48nr7jZLiceCLFWmng14pMsBehsfCia7icg/640?wx_fmt=gif" data-type="gif" data-w="1000" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU1ByCwfJ6748yyMqibyjCPrz48nr7jZLiceCLFWmng14pMsBehsfCia7icg/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="3" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.9375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 21px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; background-color: white; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; border: 1px solid rgba(0, 0, 0, 0); mix-blend-mode: screen; opacity: 0.7; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; height: 1.5em; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUVOYzpWJ9EeCFiaO0zO6nBaMgOpic3375vc8R7RTGPgF1WeHlx4jm8fFg/640?wx_fmt=gif&quot;); background-size: cover; box-sizing: border-box !important; word-wrap: break-word !important; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section style="margin: -1.5em 0px 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 16px; color: rgb(0, 47, 91); font-weight: bold; letter-spacing: 1px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">更多精彩，等您发现！</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; font-size: 21px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; background-color: white; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; border: 1px solid rgba(0, 0, 0, 0); mix-blend-mode: screen; opacity: 0.7; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; height: 1.5em; background-image: url(&quot;https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUVOYzpWJ9EeCFiaO0zO6nBaMgOpic3375vc8R7RTGPgF1WeHlx4jm8fFg/640?wx_fmt=gif&quot;); background-size: cover; box-sizing: border-box !important; word-wrap: break-word !important; background-repeat: no-repeat no-repeat;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section style="margin: -1.5em 0px 0px; padding: 0px; max-width: 100%; line-height: 2; font-size: 16px; color: rgb(0, 47, 91); font-weight: bold; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">赶快打开HOPPE 好博小程序，抢先体验吧！</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.43703703703703706" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUDlEictPVm4Slu9h78vh83XsR5jFd89DOU3SrFL3jViaSicMia6vZB2f7eA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/144090f2acb107837be9ee2034deef201.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="144090f2acb107837be9ee2034deef201.jpg" alt="144090f2acb107837be9ee2034deef20.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 1.8; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">请长按图片扫描下方二维码</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">关注HOPPE 好博集团官方微信公众号</span></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 392.65625px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUQq0nmVBE2JhLE0VaLmibVomVNLcicJqh9x3E7W3kwAXfBJGewJOOB3aQ/640?wx_fmt=png" data-type="png" data-w="256" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a6c28851e219673a9a34345814d715151.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 392.65625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="a6c28851e219673a9a34345814d715151.jpg" alt="a6c28851e219673a9a34345814d71515.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 18px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; font-size: 14px; color: rgb(9, 9, 9); line-height: 1.8; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">请长按图片扫描下方二维码</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">登录HOPPE 好博集团官网获取更多信息</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 379.109375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxUuhzkHRftW9sXvMaMnkBiaxlZFPlLBEOV7sHlxdticMbUV9uvGPZSANPg/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f372620de1c72ca7f42c3866c74232cf1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 379.109375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="f372620de1c72ca7f42c3866c74232cf1.jpg" alt="f372620de1c72ca7f42c3866c74232cf.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 22px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; line-height: 1.8; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">www.hoppe.com</span></p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.46574074074074073" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYvvyQ369xic0BHn2zptxKxU2N1m5WEx9JiaDKxqMQDqt7LaVdR4Ca3Ipyrsj4otERzlEvBMFH8wpow/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/9fa045b84cd590323297556d68f2c8061.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="9fa045b84cd590323297556d68f2c8061.jpg" alt="9fa045b84cd590323297556d68f2c806.jpg"/></section></section></section></p><p></p><p><br/></p>', 1, 0, 0, '2020-10-26', '2020-12-05 16:35:30'),
	(59, '共创行业新势头 | HOPPE 好博展台精彩回顾', '/upload/home/news/11.3.jpg', '<p><br/></p><p></p><p><section data-mpa-powered-by="yiban.io" style="margin: 0px; padding: 0px; max-width: 100%; background-color: rgb(244, 244, 244); font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 16px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 5px; max-width: 100%; display: inline-block; border: 1px solid rgb(192, 200, 209); background-color: rgb(255, 255, 255); width: 636.375px; box-shadow: rgb(220, 221, 221) 3.5px 3.5px 0px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5822222222222222" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja446vJb1OtBqJARWtbyNzR0OTDb0n7XxHkK8XcqkNM9RXlCb1uHJsPw/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f5d6b64de978922ec120b6eafd5b58e9.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="f5d6b64de978922ec120b6eafd5b58e9.jpg" alt="f5d6b64de978922ec120b6eafd5b58e9.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 5px 0px 25px; padding: 0px; max-width: 100%; text-align: left; transform: translate3d(4px, 0px, 0px); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 3px; max-width: 100%; display: inline-block; border-bottom-width: 5px; border-bottom-style: solid; border-bottom-color: rgb(0, 47, 91); font-size: 17px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">FBC 2020</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 8px; max-width: 100%; line-height: 2; letter-spacing: 0.5px; font-size: 14px; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">为期四天的FBC 2020中国国际门窗幕墙博览会已圆满闭幕，HOPPE 好博凭借其高质量的产品展示、丰富的现场活动、周到的展台服务吸引了众多专业观众前来参观。FBC博览会作为行业趋势发展风向标的超级平台，今年的HOPPE 好博展台有哪些不同呢？接下来，让我们一起回顾HOPPE 好博展台这四天的精彩瞬间吧！</span></p></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px 10px; max-width: 100%; display: inline-block; vertical-align: top; background-color: rgb(0, 47, 91); border: 0px none rgb(0, 47, 91); border-top-left-radius: 6px; border-top-right-radius: 6px; border-bottom-right-radius: 6px; border-bottom-left-radius: 6px; overflow: hidden; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 636.375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; color: rgb(255, 255, 255); font-size: 18px; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">金轩奖颁奖盛典</strong></p></section><section style="margin: 0px 3px 0px 5px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 8px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 5px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 5px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px -9px 0px 0px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 8px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 4px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 4px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 10px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 6px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 6px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; display: inline-block; vertical-align: top; box-shadow: rgba(0, 0, 0, 0) 0px 0px 0px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; overflow: hidden; width: 636.375px; background-color: rgb(255, 255, 255); height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6666667" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njau5yQb8OkdanS4XGk65ezSMAQM3P7SQyw3jcgjpaU1l32hn0Ydr34zg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/35948a755cbf0d3cd759b7e323c58042.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="35948a755cbf0d3cd759b7e323c58042.jpg" alt="35948a755cbf0d3cd759b7e323c58042.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">第四届建筑门窗幕墙行业金轩奖颁奖盛典于10月28日在京召开，门窗幕墙及建筑、地产领域行业翘楚齐聚于此，共同见证了此次行业盛宴！</p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.7633587786259542" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njahjic63APzXb54g1xn3XBkACDBpFiaOaljTBibKFwic8WKkiavUAQ5GyYOCQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="786" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6dbb75ebcaa00c4d18af90f0666e1df4.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="6dbb75ebcaa00c4d18af90f0666e1df4.jpg" alt="6dbb75ebcaa00c4d18af90f0666e1df4.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博eHandle感应开启成功斩获金轩奖技术研发创新产品奖。</p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.3333333" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaZOo77c7tFQEovtgHEsMJukygzypfyqLc6ZVcJNkuEIMmUY81letibJw/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/0ed9d9cffbe4a82a0f3f1435d7a9fa7e.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="0ed9d9cffbe4a82a0f3f1435d7a9fa7e.jpg" alt="0ed9d9cffbe4a82a0f3f1435d7a9fa7e.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">展会期间，企业部大中华区总负责人胡姚文先生，接受广东省门窗协会记者邀请，介绍了HOPPE 好博的获奖产品——金轩奖技术研发创新产品eHandle感应开启，并与奖杯合影留念。</p><section style="margin: 0px; padding: 0px; max-width: 100%; text-indent: 2em; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><iframe class="video_iframe rich_pages" data-vidtype="2" data-mpvid="wxv_1589387537817583617" data-cover="http%3A%2F%2Fmmbiz.qpic.cn%2Fmmbiz_jpg%2F6GqXbok17iaakkkYeYdOV44zwQSBy2njaxC48BtybAQjbbEAkafKucly7fEjtfPhB3zsaPTteKY1tr5Yo9chVMA%2F0%3Fwx_fmt%3Djpeg" allowfullscreen="" frameborder="0" data-ratio="0.5625" data-w="1080" data-src="https://mp.weixin.qq.com/mp/readtemplate?t=pages/video_player_tmpl&amp;auto=0&amp;vid=wxv_1589387537817583617" width="596" height="459" data-vh="447" data-vw="596" scrolling="no" marginwidth="0" marginheight="0" src="https://mp.weixin.qq.com/mp/videoplayer?video_h=447&video_w=596&scene=0&random_num=2007&article_title=%E5%85%B1%E5%88%9B%E8%A1%8C%E4%B8%9A%E6%96%B0%E5%8A%BF%E5%A4%B4%20%7C%20%20HOPPE%20%E5%A5%BD%E5%8D%9A%E5%B1%95%E5%8F%B0%E7%B2%BE%E5%BD%A9%E5%9B%9E%E9%A1%BE&source=4&vid=wxv_1589387537817583617&mid=2650533128&idx=1&__biz=MzA3MjgzNjc0NQ==&nodetailbar=0&uin=MTYxMjMzMDU0Mw==&key=b0ef2a265df6e2d51d511f1586cc45282239456a343ca41bcff7bb317ddb77df2fc29bf409e746f11b88cfce827e865f90e5460a40f1c9c3227828070307776a00d3a367da4c9a9e4f0ace7281178ad62fa2332bf0a22db058c9736424705bf8ffaf1195d005a5fcc7c1b1ff90fc62f15d31dfbc976a46949516ac970b95a454&pass_ticket=Hcx0NYzCtZ2QfL40j9h7RDV6j0U5qRIgCX7D/sm+LzJpYOdKYFd8CiHdwuTfLqhk&version=&devicetype=iMac MacBookPro12,1 OSX OSX 10.16 build(20B29)&wxtoken=777&sessionid=svr_d91e92b8673&preview=0&is_in_pay_subscribe=0&nickname=HOPPE%E5%A5%BD%E5%8D%9A%E9%9B%86%E5%9B%A2&roundHeadImg=http://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZqfhlvjicV1Thicrt1wSUMpoVoooekyR0OtdibnHRu7czrgu3SdobcQJ1U8Zz50YQDIAnMzVAvuzzUA/0?wx_fmt=png&enterid=1607157441&subscene=" style="margin: 0px; padding: 0px; max-width: 100%; display: block; overflow: hidden; top: 0px; box-sizing: border-box !important; word-wrap: break-word !important; width: 596px !important; height: 459px !important;"></iframe></p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 12px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">本次展台上eHandle感应开启把手与makos入户门品牌合作演示自动开启效果。</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px -6px; padding: 0px; max-width: 100%; line-height: 1.2; letter-spacing: 0.5px; color: rgb(0, 47, 91); text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;eHandle-入户门感应开启&nbsp;</strong></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 202px; height: 10px; background-color: rgba(172, 169, 169, 0.37); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 7px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.5px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.78" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaakkkYeYdOV44zwQSBy2njafXTicNj4F0FTbI2efg6AEibNK5gzRnBMKzmxCfkYy4HKGnyiauvMX08bQ/640?wx_fmt=gif" data-type="gif" data-w="200" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaakkkYeYdOV44zwQSBy2njafXTicNj4F0FTbI2efg6AEibNK5gzRnBMKzmxCfkYy4HKGnyiauvMX08bQ/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="0" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.5px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博入户门 eHandle 感应开启技术让您无需停下手上繁忙的业务也可以轻松开门。房屋主人只要靠近门，大拉手就会接收到无线钥匙发出的加密信号。然后，大拉手底部的射灯会自动亮起，说明房屋主人被允许进入房间。房屋主人只需用脚扫过射灯的光线，门便会自动开启，简单方便，无需触碰。</p></section></section><section powered-by="xiumi.us" style="margin: 16px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 591.71875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.7875" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaakkkYeYdOV44zwQSBy2njaM7eibIY4e3iaSwFicpQiaibdIZF1ApKmqq4W1X8RiaJeRI3GKMzyf8CKuCXA/640?wx_fmt=gif" data-type="gif" data-w="640" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaakkkYeYdOV44zwQSBy2njaM7eibIY4e3iaSwFicpQiaibdIZF1ApKmqq4W1X8RiaJeRI3GKMzyf8CKuCXA/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="1" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 591.71875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 246.546875px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.1243781" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njad78GxQFT4US9qpNic8J4lR46xHviaJUpcIprHNIzibIhzcexMzEsibFEOg/640?wx_fmt=jpeg" data-type="jpeg" data-w="402" _width="100%" src="https://hoppe.jzdsh.com/upload/ue/img/90de891929fb57a7e8746552404ef244.jpg" crossorigin="anonymous" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 246.546875px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="90de891929fb57a7e8746552404ef244.jpg" alt="90de891929fb57a7e8746552404ef244.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 13px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(168, 163, 163); box-sizing: border-box !important; word-wrap: break-word !important;">射灯可根据地面颜色切换4种色彩模式</span></p></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">内置的安全功能可防止您无意中在室内打开门锁。您可以根据不同的地面颜色切换光束的颜色，以确保其清晰可见。控制单元位于室内部分。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px 10px; max-width: 100%; display: inline-block; vertical-align: top; background-color: rgb(0, 47, 91); border: 0px none rgb(0, 47, 91); border-top-left-radius: 6px; border-top-right-radius: 6px; border-bottom-right-radius: 6px; border-bottom-left-radius: 6px; overflow: hidden; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 636.375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; color: rgb(255, 255, 255); font-size: 18px; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">直播互动</strong></p></section><section style="margin: 0px 3px 0px 5px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 8px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 5px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 5px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px -9px 0px 0px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 8px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 4px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 4px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 10px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 6px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 6px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; display: inline-block; vertical-align: top; box-shadow: rgba(0, 0, 0, 0) 0px 0px 0px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; overflow: hidden; width: 636.375px; background-color: rgb(255, 255, 255); height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaXcbzJXwhUwaBGej2icbC3ZGJGSwqkScRJQO8gzIlUYwcswx3bBicDJEw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a44495dd611d912a8ea109552b3368b1.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="a44495dd611d912a8ea109552b3368b1.jpg" alt="a44495dd611d912a8ea109552b3368b1.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 5px 0px 15px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.75" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja75JAVbun398cpogFobia3z4BsgOfeLNzgnWXia93ZKCFaGJlFyIiavfoQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/d5cccba169b22ca7386d04a13c54c632.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="d5cccba169b22ca7386d04a13c54c632.jpg" alt="d5cccba169b22ca7386d04a13c54c632.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博市场部大中华区经理Lesley叶女士，参与了FBC的现场直播并向直播间的观众们介绍了HOPPE 好博的SecuSan<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">®</sup>&nbsp;抗菌把手以及eHandle感应开启。实时直播吸引了数万名网友同时在线观看。</p></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.66640625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaZYTaPZ7Cnx2FcKy2tuGs7FwDvicGm7VibjSF0PJwUkk9MkTF5yR4iaOlQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/f22736f3d0cdb0f4a18a3fce81a62a84.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="f22736f3d0cdb0f4a18a3fce81a62a84.jpg" alt="f22736f3d0cdb0f4a18a3fce81a62a84.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 13px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">👆&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(168, 163, 163); box-sizing: border-box !important; word-wrap: break-word !important;">长按识别查看精彩回放</span>&nbsp;👆</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">点击“万万没想到——门窗新品大求真”，拖动视频进度条至2小时30分处，可直达HOPPE 好博展台直播回放哦。</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px 0px -6px; padding: 0px; max-width: 100%; line-height: 1.2; letter-spacing: 0.5px; color: rgb(0, 47, 91); text-align: right; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">&nbsp;SecuSan<sup style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;">®</sup>-新卫生标准&nbsp;</strong></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 181.078125px; height: 10px; background-color: rgba(172, 169, 169, 0.37); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 20px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.6314815" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaakkkYeYdOV44zwQSBy2njaxrLIgdUNy6AnE4icHrXWUE781DHsP7QWC1QAVTPTLgZ8db7NujPwEWg/640?wx_fmt=png" data-type="png" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6963333e672aef3c4dc8e00278f1ed3a.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="6963333e672aef3c4dc8e00278f1ed3a.jpg" alt="6963333e672aef3c4dc8e00278f1ed3a.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">SecuSan<sup style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;">®</sup>&nbsp;为 HOPPE 好博推出的杀菌、抗菌功能的表面处理，它可以应用在多种门、窗把手表面，把手材质以铝合金和不锈钢最为常见。其涂层颗粒细密均匀，有种特别精密的质感。当触摸把手的时候，您会惊讶地发现它并没有想像中的沙砾感，而是非常光滑细腻。</p></section></section><section powered-by="xiumi.us" style="margin: 17px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.7341513" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaakkkYeYdOV44zwQSBy2njamLiaDXssjhk5vyiclopiay6P6xX8Ur7OdFZK2WoiaKwgpe6xBnObQILpxw/640?wx_fmt=png" data-type="png" data-w="978" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1072d69349afd61785ce86123f0c9946.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="1072d69349afd61785ce86123f0c9946.jpg" alt="1072d69349afd61785ce86123f0c9946.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">SecuSan<sup style="margin: 0px; padding: 0px; max-width: 100%; font-size: 12px; box-sizing: border-box !important; word-wrap: break-word !important;">®</sup>&nbsp;表面为银离子涂层。当其表面附着细菌量很多时，其表面涂层中的银离子就会破坏病菌、细菌的细胞膜，阻断细胞的呼吸和营养吸收，从而阻止病菌、细菌的细胞分裂，生长导致其死亡。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 4px 10px; max-width: 100%; display: inline-block; vertical-align: top; background-color: rgb(0, 47, 91); border: 0px none rgb(0, 47, 91); border-top-left-radius: 6px; border-top-right-radius: 6px; border-bottom-right-radius: 6px; border-bottom-left-radius: 6px; overflow: hidden; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 636.375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: left; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; display: inline-block; vertical-align: middle; color: rgb(255, 255, 255); font-size: 18px; letter-spacing: 2px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;">现场讲解</strong></p></section><section style="margin: 0px 3px 0px 5px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 8px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 5px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 5px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px -9px 0px 0px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 8px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 4px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 4px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; width: 0px; border-left-width: 10px; border-left-style: solid; border-left-color: rgb(255, 255, 255); border-top-width: 6px; border-top-style: solid; border-top-color: transparent; border-bottom-width: 6px; border-bottom-style: solid; border-bottom-color: transparent; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; display: inline-block; vertical-align: top; box-shadow: rgba(0, 0, 0, 0) 0px 0px 0px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; overflow: hidden; width: 636.375px; background-color: rgb(255, 255, 255); height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; overflow-x: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 1000%; overflow: hidden; width: 6040.46875px; transform: rotate(0deg); box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njabKooyW02vx1L1BcX5Ln8nfHB70vdicq6tp1OqcOQwcWflJPVBUIQceQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ae629a54d6758cbc3abe618dda52e8ab.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="ae629a54d6758cbc3abe618dda52e8ab.jpg" alt="ae629a54d6758cbc3abe618dda52e8ab.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja3OdDMPquYPaHY6svgITUoMOBkfAEIRPYkR2UqTvqKcK8P0GwJ1Tkyg/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/3aa29440fbf0e55fc64c568ec9c8a260.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="3aa29440fbf0e55fc64c568ec9c8a260.jpg" alt="3aa29440fbf0e55fc64c568ec9c8a260.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaAnRwbhJlnaGwV0o021iaMmiaddxjuXs7oFAlNyq42paiaibib0I7QCduNibw/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/50ba9c419dc7fa3aeb1811bbb4dbe4c0.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="50ba9c419dc7fa3aeb1811bbb4dbe4c0.jpg" alt="50ba9c419dc7fa3aeb1811bbb4dbe4c0.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njadiaGLrjBc7NWZGIsWpicFHMPz6l0ibWlT1CZ7zt8Qpglb0I3ibE5w60Ckw/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/b2767d5270bf78ad07711c919be0df66.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="b2767d5270bf78ad07711c919be0df66.jpg" alt="b2767d5270bf78ad07711c919be0df66.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaw2iaibWZrm70eibm6OpicqYDKXefjGvgUdQiaNDtL2cgnRu1gicTOuv06PXA/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaw2iaibWZrm70eibm6OpicqYDKXefjGvgUdQiaNDtL2cgnRu1gicTOuv06PXA/640?wx_fmt=jpeg&tp=webp&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja7NNVP95QK1ibpTJus81TH1ibvWFKLgB0xAvmrT8nB4BekM2QwT05iaRNw/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja7NNVP95QK1ibpTJus81TH1ibvWFKLgB0xAvmrT8nB4BekM2QwT05iaRNw/640?wx_fmt=jpeg&tp=webp&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaQsNdx8wYJEFuGwWnuFjHg2NyibRsytvTllETEgRjXiaYvrnJFXKQ8SRw/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaQsNdx8wYJEFuGwWnuFjHg2NyibRsytvTllETEgRjXiaYvrnJFXKQ8SRw/640?wx_fmt=jpeg&tp=webp&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja45snYTCNCNicyf5g18Wibc05OItaYicgGzo2jVndgcR0ezLOwrKNWEh2g/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2nja45snYTCNCNicyf5g18Wibc05OItaYicgGzo2jVndgcR0ezLOwrKNWEh2g/640?wx_fmt=jpeg&tp=webp&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njanCzep5OWgz5UHQq3nGLiaaZCglOB1qjIegmRENztFrYJshMzZibicfD5g/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njanCzep5OWgz5UHQq3nGLiaaZCglOB1qjIegmRENztFrYJshMzZibicfD5g/640?wx_fmt=jpeg&tp=webp&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 604.046875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; display: inline-block; width: 604.046875px; vertical-align: top; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.66625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njamOhO5XmPKAmbu5JP5riapSib1cjYAQKqY1t2dMJ5pRic4dTJqWMAxea5w/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="677px" class="" src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njamOhO5XmPKAmbu5JP5riapSib1cjYAQKqY1t2dMJ5pRic4dTJqWMAxea5w/640?wx_fmt=jpeg&tp=webp&wxfrom=5&wx_lazy=1&wx_co=1" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: middle; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: bottom; line-height: 0; width: 28.6875px; box-sizing: border-box !important; word-wrap: break-word !important;"></section><section style="margin: 0px 0px 2px; padding: 0px 5px; max-width: 100%; display: inline-block; vertical-align: bottom; line-height: 1.2em; font-size: 14px; color: rgb(35, 35, 35); box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-shadow: rgb(255, 255, 255) 2px 0px 2px; background-color: rgb(254, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important;">左右滑动查看图片</span></p></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: bottom; line-height: 0; width: 28.6875px; box-sizing: border-box !important; word-wrap: break-word !important;"></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 16px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">展台工作人员为参观的观众现场讲解HOPPE 好博产品相关知识。</p><section style="margin: 0px; padding: 0px; max-width: 100%; text-indent: 2em; line-height: normal; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><iframe class="video_iframe rich_pages" data-vidtype="2" data-mpvid="wxv_1589119230136860673" data-cover="http%3A%2F%2Fmmbiz.qpic.cn%2Fmmbiz_jpg%2F6GqXbok17iaakkkYeYdOV44zwQSBy2njaaiaZib6lFytHpia2SzLVUM4hxZNGvE8ZXiaCOQGgGvELbxNyxWUjoKVqcg%2F0%3Fwx_fmt%3Djpeg" allowfullscreen="" frameborder="0" data-ratio="1.7777777777777777" data-w="1920" data-src="https://mp.weixin.qq.com/mp/readtemplate?t=pages/video_player_tmpl&amp;auto=0&amp;vid=wxv_1589119230136860673" width="596" height="348" data-vh="335.25" data-vw="596" scrolling="no" marginwidth="0" marginheight="0" src="https://mp.weixin.qq.com/mp/videoplayer?video_h=335.25&video_w=596&scene=0&random_num=2007&article_title=%E5%85%B1%E5%88%9B%E8%A1%8C%E4%B8%9A%E6%96%B0%E5%8A%BF%E5%A4%B4%20%7C%20%20HOPPE%20%E5%A5%BD%E5%8D%9A%E5%B1%95%E5%8F%B0%E7%B2%BE%E5%BD%A9%E5%9B%9E%E9%A1%BE&source=4&vid=wxv_1589119230136860673&mid=2650533128&idx=1&__biz=MzA3MjgzNjc0NQ==&nodetailbar=0&uin=MTYxMjMzMDU0Mw==&key=b0ef2a265df6e2d51d511f1586cc45282239456a343ca41bcff7bb317ddb77df2fc29bf409e746f11b88cfce827e865f90e5460a40f1c9c3227828070307776a00d3a367da4c9a9e4f0ace7281178ad62fa2332bf0a22db058c9736424705bf8ffaf1195d005a5fcc7c1b1ff90fc62f15d31dfbc976a46949516ac970b95a454&pass_ticket=Hcx0NYzCtZ2QfL40j9h7RDV6j0U5qRIgCX7D/sm+LzJpYOdKYFd8CiHdwuTfLqhk&version=&devicetype=iMac MacBookPro12,1 OSX OSX 10.16 build(20B29)&wxtoken=777&sessionid=svr_d91e92b8673&preview=0&is_in_pay_subscribe=0&nickname=HOPPE%E5%A5%BD%E5%8D%9A%E9%9B%86%E5%9B%A2&roundHeadImg=http://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaZqfhlvjicV1Thicrt1wSUMpoVoooekyR0OtdibnHRu7czrgu3SdobcQJ1U8Zz50YQDIAnMzVAvuzzUA/0?wx_fmt=png&enterid=1607157441&subscene=" style="margin: 0px; padding: 0px; max-width: 100%; display: block; overflow: hidden; top: 0px; box-sizing: border-box !important; word-wrap: break-word !important; width: 596px !important; height: 348px !important;"></iframe></p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">零售部大中华区负责人敖方兵先生现场演示HOPPE 好博产品的使用操作。</p></section></section><section powered-by="xiumi.us" style="margin: 8px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 308.1875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 302.015625px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.33375" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaIVibdeee7nMecHou9hosehK7wW8y15ULeY9Cg8PDCfA8fLe3ticzrWHw/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/621e4d3312417bba7188a60dcf7d8b4d.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 302.015625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="621e4d3312417bba7188a60dcf7d8b4d.jpg" alt="621e4d3312417bba7188a60dcf7d8b4d.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; vertical-align: top; width: 308.1875px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 302.015625px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1.33375" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaSVtSsG9foJIlh0vX8XwjIEKw1JeNE4aH1xKZNlgJlyAhia2icF7jeo2w/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/3e8f2bf2e08b4ee7e6190c2c7848ef31.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 302.015625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="3e8f2bf2e08b4ee7e6190c2c7848ef31.jpg" alt="3e8f2bf2e08b4ee7e6190c2c7848ef31.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 12px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 10px; max-width: 100%; text-align: justify; font-size: 14px; color: rgb(0, 0, 0); line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">并为来访嘉宾演示HOPPE 好博小程序的操作与使用方法。</p></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 320.5px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njanh1tyxACNLXpJgNDza83XqDCicIlQNVZSTexgYaaiaej8QmYH8oNrY3Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="800" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/663560dd492ad7b33e7c3d70b96a29e31.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 320.5px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="663560dd492ad7b33e7c3d70b96a29e31.jpg" alt="663560dd492ad7b33e7c3d70b96a29e3.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 13px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">👆&nbsp;<span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(168, 163, 163); box-sizing: border-box !important; word-wrap: break-word !important;">长按识别进入小程序</span>&nbsp;👆</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 2; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; text-align: center; justify-content: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 636.375px; vertical-align: top; line-height: 0; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; display: inline-block; width: 636.375px; height: 14px; vertical-align: top; overflow: hidden; box-shadow: rgb(0, 0, 0) 0px 0px 0px; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 100px; border-top-right-radius: 100px; border-bottom-right-radius: 100px; border-bottom-left-radius: 100px; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section powered-by="xiumi.us" style="margin: -16px 0px 10px; padding: 0px; max-width: 100%; text-align: center; justify-content: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 10px 10px; max-width: 100%; display: inline-block; width: 616.0625px; vertical-align: top; background-color: rgb(255, 255, 255); height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; text-align: justify; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">本次FBC展会已圆满落幕，感谢您与我们一起，度过了难忘的四天时光。未来，HOPPE 好博还将继续为市场带来覆盖更广、更先进的产品以及高质量和创新的解决方案，同时愿与您携手，共同创造精彩未来！</p></section></section><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.5455556" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaq7R3A6YcKq9DFiaYTrQ5icnAVSIDmacDmvyJkgwS0Ifa6EEbYM35kvYQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="900" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a030e47ea60b9843e2793b53a41a1585.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="a030e47ea60b9843e2793b53a41a1585.jpg" alt="a030e47ea60b9843e2793b53a41a1585.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section></section></p><p></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p></p><p><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 16px; box-sizing: border-box !important; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px 5px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.437037" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaEeslIP9FT23hEqV1XDK8cNLwrVQPR6awwHBMBOeDjMib0SbCqrCoJdg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/b2af48a17c8f744c04b6a0b01c60f3da.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="b2af48a17c8f744c04b6a0b01c60f3da.jpg" alt="b2af48a17c8f744c04b6a0b01c60f3da.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 1.8; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">请长按图片扫描下方二维码</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">关注HOPPE 好博集团官方微信公众号</span></p></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 392.65625px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaakkkYeYdOV44zwQSBy2njaNibHCo1qeErKhoLpCC90LWoQvLy80lEU59TV43Iia76iblwBsH4eGcsTA/640?wx_fmt=png" data-type="png" data-w="256" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6062f13e8264d2c61c353c93826929a2.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 392.65625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="6062f13e8264d2c61c353c93826929a2.jpg" alt="6062f13e8264d2c61c353c93826929a2.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 18px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; font-size: 14px; color: rgb(9, 9, 9); line-height: 1.8; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">请长按图片扫描下方二维码</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;">登录HOPPE 好博集团官网获取更多信息</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; width: 379.109375px; height: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaHm6ITLjlibReaIPLkkaZtIkwTnXYEJCHRganzKBfu8GReicYjoaPDUdA/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7b392ab86c560988debda262f873f6fc.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 379.109375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="7b392ab86c560988debda262f873f6fc.jpg" alt="7b392ab86c560988debda262f873f6fc.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 22px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; font-size: 14px; line-height: 1.8; letter-spacing: 0.5px; box-sizing: border-box !important; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(9, 9, 9); box-sizing: border-box !important; word-wrap: break-word !important;">www.hoppe.com</span></p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; vertical-align: middle; display: inline-block; line-height: 0; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="0.4657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaakkkYeYdOV44zwQSBy2njaFrSx1ibgiaOqTCICyAPogx6SLaz738LeX04NN62ibktD9icbN3SjQn99yQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/7c92244fd44723f240a82b08152901dd.jpg" crossorigin="anonymous" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="7c92244fd44723f240a82b08152901dd.jpg" alt="7c92244fd44723f240a82b08152901dd.jpg"/></section></section></section></p><p></p><p><br/></p>', 1, 0, 0, '2020-11-03', '2020-12-05 16:52:17'),
	(60, 'HOPPE 好博参与门窗安全标准，助力提升门窗安全性能', '/upload/home/news/QQ20210110-112736@2x副本.png', '<p><br/></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; border: 0px none rgb(62, 62, 62); border-top-left-radius: 8px; border-top-right-radius: 8px; border-bottom-right-radius: 8px; border-bottom-left-radius: 8px; overflow: hidden; background-color: rgb(244, 244, 244); height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.675" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxDr1MF1ZWxdBNHneQh1ciaFpPDTWX2mAjDWK8AuP293syjbWxhX6cHSA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/915ff8aa7cc7830a29805ff1d0ae4191.jpg" crossorigin="anonymous" alt="915ff8aa7cc7830a29805ff1d0ae4191.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="915ff8aa7cc7830a29805ff1d0ae4191.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 12px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">由中国建筑科学研究院负责编制的国家标准《建筑外门窗及百叶防非正常开启性能检测方法（送审稿）》审查会于2020年12月8日在北京举行。HOPPE 好博作为业内知名企业，参与了此项国家标准的起草编制工作。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 0px 10px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border-left-width: 3px; border-left-style: solid; border-left-color: rgb(130, 208, 246); border-bottom-left-radius: 0px; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 1; letter-spacing: 1px; font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">标准编制的意义</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 8px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; overflow: visible; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -30px 0px 15px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: left; font-size: 2px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 50px; height: 20px; vertical-align: top; overflow: hidden; line-height: 0; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: rotateZ(45deg); word-wrap: break-word !important;"><section style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 20px; height: 20px; vertical-align: top; overflow: hidden; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(254, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.75" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOx79SvgoiaGuTRdFKoEj5TDs4Ayy7J0sf1J8iaWRy8tEutTCD2e28yOib8g/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/ea2db7fb0e1d9390be1d618375eb4d17.jpg" crossorigin="anonymous" alt="ea2db7fb0e1d9390be1d618375eb4d17.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="ea2db7fb0e1d9390be1d618375eb4d17.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">该标准为首次制定，着重考虑了随机性入室盗窃的作案情况，结合我国建筑外门窗技术特点和市场情况，总结国外相关标准和经验，重点针对面板材料为玻璃的、未配备防盗锁的建筑外门窗的防非正常开启性能进行检测及分级。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">该标准填补了我国目前没有建筑外窗防盗安全性能检测和分级方法国家标准的空白，有利于健全和完善我国门窗标准体系，充分与国外先进国家和地区接轨。同时，也将对我国建筑外门窗，特别是建筑外窗防盗安全性能的提升起到促进作用，使建筑外门窗充分发挥保障室内人员生命财产安全的作用。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 0px 10px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border-left-width: 3px; border-left-style: solid; border-left-color: rgb(130, 208, 246); border-bottom-left-radius: 0px; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 1; letter-spacing: 1px; font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">主要工作过程</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 8px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; overflow: visible; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -30px 0px 15px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: left; font-size: 2px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 50px; height: 20px; vertical-align: top; overflow: hidden; line-height: 0; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: rotateZ(45deg); word-wrap: break-word !important;"><section style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 20px; height: 20px; vertical-align: top; overflow: hidden; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(254, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.75" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOx5CBgIlO9lQK8BV9ZVjWALu4kicicibzqRsUJIZRFJI5t1r4siatZShSriag/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a6b21a1727a815dae026de683900b4ef.jpg" crossorigin="anonymous" alt="a6b21a1727a815dae026de683900b4ef.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="a6b21a1727a815dae026de683900b4ef.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">1</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">2019年5月23日在北京召开编制启动，启动会介绍了标准编制背景，提出了标准编制要求，成立了标准编制组。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">2</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">标准第一次工作会议中，编制组对主编单位起草的标准草稿进行了初步讨论，对本标准的适用范围、试验设备、试件要求、分级标准等也进行了初步讨论，并讨论确定了标准的编制分工及编制进度安排。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">3</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">针对本标准的编制内容，编制组开展了国内外门窗及其组件安防性能相关标准规范的调研工作。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">4</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">研制门窗关键组件——玻璃的抗反复锤击、斧击性能检测设备。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">5</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">设计开发建筑外门、窗及百叶防非正常开启性能检测试验设备。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">6</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">主编单位在前期的工作基础上完成了标准讨论稿。标准第二次会议于2020年10月10日通过网络视频形式召开。编制组针对标准讨论稿进行了逐条讨论，对标准讨论稿的主要内容达到一致意见。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">7</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">编制组完成了标准征求意见稿，并于2020年10月面向社会公开征求意见。</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 0px 0px 15px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 611.796875px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-color: rgb(0, 47, 91); height: 1.2em; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section><section style="margin: 0px 0px 0px -0.666em; padding: 0px; max-width: 100%; box-sizing: border-box; border: 1px solid; background-color: rgb(0, 47, 91); color: rgb(255, 255, 255); display: inline-block; float: left; width: 1.33em; height: 1.33em; line-height: 1.33em; border-top-left-radius: 100%; border-top-right-radius: 100%; border-bottom-right-radius: 100%; border-bottom-left-radius: 100%; text-align: center; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">8</p></section><section style="margin: 0px; padding: 0px 0px 0.5em; max-width: 100%; box-sizing: border-box; border-left-width: 1px; border-left-style: solid; border-left-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section style="margin: 0px; padding: 8px 0px 0px 15px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -12px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px 0px 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: none; min-height: 1em; word-wrap: break-word !important;">2020年12月1日，征求意见阶段结束。编制组针对回复意见逐一进行讨论，完成标准送审稿。</p></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 0px 10px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border-left-width: 3px; border-left-style: solid; border-left-color: rgb(130, 208, 246); border-bottom-left-radius: 0px; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 1; letter-spacing: 1px; font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">关于HOPPE 好博</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 8px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; overflow: visible; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -30px 0px 15px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: left; font-size: 2px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 50px; height: 20px; vertical-align: top; overflow: hidden; line-height: 0; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: rotateZ(45deg); word-wrap: break-word !important;"><section style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 20px; height: 20px; vertical-align: top; overflow: hidden; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(254, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 619.453125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.3002183" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxxYeiaLrYw972JOT74hHWrCytuVlDniauZZdMaWUIM7yG973X5bMNib6gg/640?wx_fmt=jpeg" data-type="jpeg" data-w="916" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/244f725fa7a71eed369066ae31c61b0c.jpg" crossorigin="anonymous" alt="244f725fa7a71eed369066ae31c61b0c.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline; width: 619.453125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="244f725fa7a71eed369066ae31c61b0c.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">1952 年，弗里德里奇·好博 (Friedrich Hoppe 音译)先生在德国创立了本公司。</p></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">如今，HOPPE 好博集团业务遍及全球，总部设于瑞士。凭借着欧美七家工厂、近三千员工和拥有的国际市场，HOPPE 好博成功地发展为无论在研发、生产还是市场都处于领先的欧洲门窗五金市场领导者。</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 4px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 619.453125px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.3002183" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOx4wocMNdhasAdTNOjyQHOK5xxMicLiaicZbRR4MHRHd8EDYibVdHPjU7OXQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="916" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/eca01c9a5b11fe592eb3da399901f854.jpg" crossorigin="anonymous" alt="eca01c9a5b11fe592eb3da399901f854.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline; width: 619.453125px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="eca01c9a5b11fe592eb3da399901f854.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">感受卓越品质，是人生乐事。您一旦触摸到我们高品质的把手，会更加坚信自己的正确选择。</p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">凡带有<img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOx8fYKU90Vb5SiasuRBn9icjeCbb8cXeuU6JCueCRtQqhgr8zdSDpibnGibQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="28" height="28" width="28" _width="28px" src="https://hoppe.jzdsh.com/upload/ue/img/f39115343a6c1b09ccb3993f39f24a7a.jpg" crossorigin="anonymous" alt="f39115343a6c1b09ccb3993f39f24a7a.jpg" class="" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important; height: auto !important; width: 28px !important; visibility: visible !important;" title="f39115343a6c1b09ccb3993f39f24a7a.jpg"/>图片标识的产品，均具备 HOPPE 好博同等的10年机械功能质保。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">HOPPE 好博集团设在德国、意大利和捷克的所有生产工厂均通过DIN EN ISO 9001:2008认证。<br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 0px 10px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border-left-width: 3px; border-left-style: solid; border-left-color: rgb(130, 208, 246); border-bottom-left-radius: 0px; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 1; letter-spacing: 0px; font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博 SecuForte<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 13px; word-wrap: break-word !important;">®</sup></strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 8px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; overflow: visible; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -30px 0px 15px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: left; font-size: 2px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 50px; height: 20px; vertical-align: top; overflow: hidden; line-height: 0; letter-spacing: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: rotateZ(45deg); word-wrap: break-word !important;"><section style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 20px; height: 20px; vertical-align: top; overflow: hidden; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; background-color: rgb(254, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.9246436" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxqxM1hQEmkicObqfqmVeyDbev1h5MvqGE9fqaUyWTnm9cbCUAQPofjlw/640?wx_fmt=jpeg" data-type="jpeg" data-w="982" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5cee8d6d8be6b788f2cdf9e6bcba2138.jpg" crossorigin="anonymous" alt="5cee8d6d8be6b788f2cdf9e6bcba2138.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="5cee8d6d8be6b788f2cdf9e6bcba2138.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">HOPPE 好博研发出一种全新的防盗技术——SecuForte<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">®</sup>。当窗处在关闭或内倒状态时，窗把手和方轴相互脱离，把手自动锁闭。这种技术可以有效防止“不速之客”从室外打开窗户。</p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; border-width: 0px; min-width: 10%; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 100 100 0%; align-self: flex-start; height: auto; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 5px; width: 179.890625px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 199.890625px; vertical-align: top; border: 1px solid rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; flex: 0 0 0%; align-self: center; height: auto; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 6px; width: 6px; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 6px; width: 6px; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 100 100 0%; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: right; justify-content: flex-end; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; letter-spacing: 1px; line-height: 2; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 0em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">简单、不同、更安全</strong></p></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 0 0 0%; line-height: 0; height: auto; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 6px; width: 6px; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 6px; width: 6px; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 100 100 0%; align-self: flex-start; height: auto; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 5px; width: 179.890625px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">具有 SecuForte<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">®</sup>&nbsp;功能的窗把手让盗贼们无从下手，从本质上杜绝盗贼撬开窗户：当把手和方轴处于相互脱离状态时，无法从室外操作。不仅无法通过撬动窗系统开窗，想用刺穿玻璃密封或在型材上打孔的方法撬动把手都是无法得逞的。</p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; border-width: 0px; min-width: 10%; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 100 100 0%; align-self: flex-start; height: auto; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 93.28125px; height: 5px; vertical-align: top; overflow: hidden; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 113.28125px; vertical-align: top; border: 1px solid rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; flex: 0 0 0%; align-self: center; height: auto; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 6px; height: 6px; vertical-align: top; overflow: hidden; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 6px; height: 6px; vertical-align: top; overflow: hidden; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 100 100 0%; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: right; justify-content: flex-end; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; letter-spacing: 1px; line-height: 2; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 0em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">产品优点</strong></p></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; align-self: center; flex: 0 0 0%; line-height: 0; height: auto; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 6px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 6px; height: 6px; vertical-align: top; overflow: hidden; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 6px; height: 6px; vertical-align: top; overflow: hidden; border: 1px solid rgb(146, 146, 146); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 100 100 0%; align-self: flex-start; height: auto; line-height: 0; border-width: 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 93.28125px; height: 5px; vertical-align: top; overflow: hidden; background-color: rgba(117, 134, 178, 0.33); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 3px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; flex: 0 0 auto; align-self: flex-start; min-width: 10%; height: auto; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 7px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; overflow: hidden; height: 9px; width: 9px; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; align-self: flex-start; flex: 100 100 0%; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">有效阻止通过刺穿玻璃密封，型材上打孔或撬开窗系统的方法破窗入室</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 3px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; flex: 0 0 auto; align-self: flex-start; min-width: 10%; height: auto; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 7px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 9px; height: 9px; vertical-align: top; overflow: hidden; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; align-self: flex-start; flex: 100 100 0%; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">当窗户在关闭 (窗把手0°) 或内倒 (窗把手180°) 状态时，窗把手自动锁闭</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 3px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; flex: 0 0 auto; align-self: flex-start; min-width: 10%; height: auto; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 7px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 9px; height: 9px; vertical-align: top; overflow: hidden; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; align-self: flex-start; flex: 100 100 0%; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">通过 RAL 认证</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 3px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; flex: 0 0 auto; align-self: flex-start; min-width: 10%; height: auto; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 7px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 9px; height: 9px; vertical-align: top; overflow: hidden; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; align-self: flex-start; flex: 100 100 0%; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">结合 VarioFit<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">®</sup>&nbsp;灵活方轴技术</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px 3px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; flex: 0 0 auto; align-self: flex-start; min-width: 10%; height: auto; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 7px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 9px; height: 9px; vertical-align: top; overflow: hidden; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 10px; border-top-right-radius: 10px; border-bottom-right-radius: 10px; border-bottom-left-radius: 10px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: auto; align-self: flex-start; flex: 100 100 0%; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); letter-spacing: 0.5px; line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">有带钥匙锁闭装置版本</p></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; height: 14px; vertical-align: top; overflow: hidden; box-shadow: rgb(0, 0, 0) 0px 0px 0px; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 100px; border-top-right-radius: 100px; border-bottom-right-radius: 100px; border-bottom-left-radius: 100px; line-height: 0; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: -16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 15px 10px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 656.6875px; vertical-align: top; background-color: rgb(244, 244, 244); height: auto; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(9, 9, 9); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;">HOPPE 好博作为行业内知名企业，能够参与此次国家标准的起草编制，标志着企业的发展得到了行业的高度认可，也充分体现了HOPPE 好博在门窗五金行业的领先地位。HOPPE 好博将继续提供更优质的产品、更完善的解决方案，推动行业升级发展。</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(178, 185, 192) 1px 0px 10px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.437037" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxkfvHxnLVYtHursUrnTtmNZA78yKPXaGHN7I4gfZagZY9LZkabiaGcKA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/9fa4f98ce88ce18ace7675934764ca49.jpg" crossorigin="anonymous" alt="9fa4f98ce88ce18ace7675934764ca49.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="9fa4f98ce88ce18ace7675934764ca49.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><a target="_blank" href="http://mp.weixin.qq.com/s?__biz=MzA3MjgzNjc0NQ==&mid=2650532870&idx=1&sn=d116082a97cf53623478cef378a096a4&chksm=87177fe0b060f6f6c24ba3e5d78170020e1d91a506b7fc9853ae91d025da03bfcade63db2df6&scene=21#wechat_redirect" textvalue="你已选中了添加链接的内容" data-itemshowtype="0" tab="innerlink" data-linktype="1" hasload="1" style="margin: 0px; padding: 0px; color: rgb(87, 107, 149); text-decoration: none; cursor: pointer; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span class="js_jump_icon h5_image_link" data-positionback="static" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 0; font-size: 0px; display: inline-block; position: relative; top: auto; left: auto; right: auto; bottom: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxO0ia7hjL7ooeaEcYY7vUNemc08nWp6LtDZ9RBDiatic8a4kJwQDvCJMVw/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/640.jpg" crossorigin="anonymous" alt="640.jpg" data-fail="0" style="margin: 0px; padding: 0px; border: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="640.jpg"/></span></a></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信小程序</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 点击查看小程序使用指南</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxQOOGb9FcX3AqYVhh3wL4W0T4C9S8Nq9lSTLfhOsaDcvqtziamkzDcdw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/cd86081b154d877377be09982b7eee3f1.jpg" crossorigin="anonymous" alt="cd86081b154d877377be09982b7eee3f.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="cd86081b154d877377be09982b7eee3f1.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信公众号</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码关注我们</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxnmYXfUR3GY8OhwbVzQfNzibicXtOB2pibpfhsWClVNkY2XpLACUVjty6w/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e013f1d86ebf46f160f8ee0a62a3b36c.jpg" crossorigin="anonymous" alt="e013f1d86ebf46f160f8ee0a62a3b36c.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="e013f1d86ebf46f160f8ee0a62a3b36c.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博官网</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码进入官网</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.4657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxXm4tNuO53ZxaibqVb5Vu0UMrURbicbtxp3icHviaaP5wmk5XeYTwcYDMLQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/449e61ad524df845b8dd8b337adf730f.jpg" crossorigin="anonymous" alt="449e61ad524df845b8dd8b337adf730f.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="449e61ad524df845b8dd8b337adf730f.jpg"/></section></section></section></section></section><p></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-12-21', '2021-01-10 12:29:56'),
	(61, 'HOPPE 好博衷心祝您圣诞快乐！', '/upload/home/news/QQ20210110-112804@2x.png', '<p><br/></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; background-color: rgb(11, 97, 56); font-size: 16px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 328.5px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.5626667" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxD6hFcxTAW0kBicPkGhCHKnZl4ibTCGa6UO1iaXkVAf4fCC3iaticOEZLprQ/640?wx_fmt=png" data-type="png" data-w="375" _width="375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/d8995c3b13aa37dd720f1e5a645a4ee8.jpg" crossorigin="anonymous" alt="d8995c3b13aa37dd720f1e5a645a4ee8.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 375px !important; visibility: visible !important;" title="d8995c3b13aa37dd720f1e5a645a4ee8.jpg"/></section></section></section><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: top; width: 328.5px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.584" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOx5GqEulE3le2Zol8dERep9DalphNeZ5CB341n69GFfticNT6kicQNoKdA/640?wx_fmt=png" data-type="png" data-w="375" _width="375px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/d8995c3b13aa37dd720f1e5a645a4ee81.jpg" crossorigin="anonymous" alt="d8995c3b13aa37dd720f1e5a645a4ee8.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 375px !important; visibility: visible !important;" title="d8995c3b13aa37dd720f1e5a645a4ee81.jpg"/></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; transform: translate3d(-10px, 0px, 0px); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 330px; height: 55px; vertical-align: top; overflow: hidden; background-size: contain; background-attachment: scroll; background-image: url(" wx_fmt="png&quot;);" word-wrap:="" break-word="" background-position:="" background-repeat:="" no-repeat=""><section powered-by="xiumi.us" style="margin: 14px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 19px; line-height: 1; letter-spacing: 3px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">Merry Christ</strong></span><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">mas</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 164.25px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.4633333" data-src="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOx4trpE80JJx2A3v8U0stGmCMH55QYTPT1m7z7BPic3n3kMaBvyw6P18A/640?wx_fmt=png" data-type="png" data-w="600" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/8a8826bdb99c927265fc9dbbef4ca4b71.jpg" crossorigin="anonymous" alt="8a8826bdb99c927265fc9dbbef4ca4b7.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 164.25px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="8a8826bdb99c927265fc9dbbef4ca4b71.jpg"/></section></section><section powered-by="xiumi.us" style="margin: -10px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; font-size: 48px; letter-spacing: 5px; line-height: 1.8; color: rgb(185, 13, 13); text-shadow: rgba(247, 213, 96, 0.8) 0px 1.8px, rgb(255, 255, 255) 1.3px 1.3px, rgb(255, 255, 255) 1.8px 0px, rgb(255, 255, 255) 1.3px -1.3px, rgb(255, 255, 255) 0px -1.8px, rgb(239, 239, 224) -1.3px -1.3px, rgb(239, 239, 224) -1.8px 0px, rgb(239, 239, 224) -1.3px 1.3px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">· 圣诞快乐 ·</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px 0px 6px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 657px; vertical-align: top; background-color: rgb(185, 13, 13); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 10px 6px 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 657px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -110px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 374.09375px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.9429853" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxYuzquykw7L6QKUEpleH7SeTtO1SSNMZK4zTXFdzJ0zKTn4zPC9ibsPA/640?wx_fmt=gif" data-type="gif" data-w="1561" _width="100%" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxYuzquykw7L6QKUEpleH7SeTtO1SSNMZK4zTXFdzJ0zKTn4zPC9ibsPA/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="0" alt="图片" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 374.09375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 15px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; font-size: 15px; line-height: 2; letter-spacing: 0.8px; text-shadow: rgb(255, 255, 255) 0px 0px; color: rgb(255, 255, 255); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">叮叮当，叮叮当……</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">听，圣诞老人赶着驯鹿，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">驾着雪橇的清脆铃声越来越近了。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">伴着欢快的旋律，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">携着美好的祝福，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">圣诞节如期而至！</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">在这个温馨浪漫的节日里<span style="margin: 0px; padding: 0px; max-width: 100%; letter-spacing: 0.8px; box-sizing: border-box !important; word-wrap: break-word !important;">，</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">HOPPE 好博衷心祝愿大家：</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">圣诞快乐，平安幸福！</p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.776" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxsWUML9c0M2cibAuUH2Za5eXhxqo2wKlSa8d8RSoraqsbCYbVfFvUZNw/640?wx_fmt=jpeg" data-type="jpeg" data-w="750" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/596a1ba57398d8e67824fad9c91faca8.jpg" crossorigin="anonymous" alt="596a1ba57398d8e67824fad9c91faca8.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="596a1ba57398d8e67824fad9c91faca8.jpg"/></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: normal; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section></section><p></p><p><br/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; clear: both; min-height: 1em; box-sizing: border-box !important; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p><br/></p><p></p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(178, 185, 192) 1px 0px 10px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.437037" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxkfvHxnLVYtHursUrnTtmNZA78yKPXaGHN7I4gfZagZY9LZkabiaGcKA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/9fa4f98ce88ce18ace7675934764ca491.jpg" crossorigin="anonymous" alt="9fa4f98ce88ce18ace7675934764ca49.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="9fa4f98ce88ce18ace7675934764ca491.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><a target="_blank" href="http://mp.weixin.qq.com/s?__biz=MzA3MjgzNjc0NQ==&mid=2650532870&idx=1&sn=d116082a97cf53623478cef378a096a4&chksm=87177fe0b060f6f6c24ba3e5d78170020e1d91a506b7fc9853ae91d025da03bfcade63db2df6&scene=21#wechat_redirect" textvalue="你已选中了添加链接的内容" data-itemshowtype="0" tab="innerlink" data-linktype="1" hasload="1" style="margin: 0px; padding: 0px; color: rgb(87, 107, 149); text-decoration: none; cursor: pointer; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span class="js_jump_icon h5_image_link" data-positionback="static" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 0; font-size: 0px; display: inline-block; position: relative; top: auto; left: auto; right: auto; bottom: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxO0ia7hjL7ooeaEcYY7vUNemc08nWp6LtDZ9RBDiatic8a4kJwQDvCJMVw/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6401.jpg" crossorigin="anonymous" alt="640.jpg" data-fail="0" style="margin: 0px; padding: 0px; border: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="6401.jpg"/></span></a></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信小程序</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 点击查看小程序使用指南</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxQOOGb9FcX3AqYVhh3wL4W0T4C9S8Nq9lSTLfhOsaDcvqtziamkzDcdw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/cd86081b154d877377be09982b7eee3f2.jpg" crossorigin="anonymous" alt="cd86081b154d877377be09982b7eee3f.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="cd86081b154d877377be09982b7eee3f2.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信公众号</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码关注我们</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxnmYXfUR3GY8OhwbVzQfNzibicXtOB2pibpfhsWClVNkY2XpLACUVjty6w/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e013f1d86ebf46f160f8ee0a62a3b36c1.jpg" crossorigin="anonymous" alt="e013f1d86ebf46f160f8ee0a62a3b36c.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="e013f1d86ebf46f160f8ee0a62a3b36c1.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博官网</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码进入官网</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.4657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iaYc1MQWrdrDWBKFL61K3jOxXm4tNuO53ZxaibqVb5Vu0UMrURbicbtxp3icHviaaP5wmk5XeYTwcYDMLQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/449e61ad524df845b8dd8b337adf730f1.jpg" crossorigin="anonymous" alt="449e61ad524df845b8dd8b337adf730f.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="449e61ad524df845b8dd8b337adf730f1.jpg"/></section></section></section></section></section><p></p><p><br/></p><p><br/></p>', 1, 0, 0, '2020-12-24', '2021-01-10 12:47:33'),
	(62, '黑色系，简约与时尚的极致演绎', '/upload/home/news/QQ20210110-112822@2x.png', '<p><br/></p><p></p><p><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 10px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; word-wrap: break-word !important;"><section style="margin: 0px -23px 0px -18px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; align-self: center; min-width: 10%; flex: 0 0 auto; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: rotateZ(90deg); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 45px; vertical-align: top; background-color: rgb(0, 47, 91); flex: 0 0 auto; height: auto; line-height: 0; letter-spacing: 0px; align-self: flex-start; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 45px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.1503268" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeHiaZW9QxjCianemFRdQNmu9L5qmwBYvwibpb9pzpYINCNztGWBZPuNkGQ/640?wx_fmt=gif" data-type="gif" data-w="306" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeHiaZW9QxjCianemFRdQNmu9L5qmwBYvwibpb9pzpYINCNztGWBZPuNkGQ/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="0" alt="图片" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 45px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section><section style="margin: 0px; padding: 6px 5px 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: middle; border: 1px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; flex: 100 100 0%; align-self: center; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 16px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">黑色，最简单又最复杂的颜色，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">有时，它高贵冷艳又个性独特，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">有时，它沉稳大气又霸气十足，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;"><img data-ratio="0.6428571" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aesgGrn5HZ2tyCPnLAWkZTVF8R60wB7ibQrdnL48OO9jraX3FTaPCiaKZg/640?wx_fmt=gif" data-type="gif" data-w="700" _width="677px" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aesgGrn5HZ2tyCPnLAWkZTVF8R60wB7ibQrdnL48OO9jraX3FTaPCiaKZg/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="1" alt="图片" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 16px; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;"/></p></section></section><section powered-by="xiumi.us" style="margin: 16px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">黑色，也是最有态度和高级的颜色，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">以其不可撼动的时尚感，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">呈现出一幕幕不可复制的经典。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">这就是黑色的魔幻魅力。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0ae3QInL9VARkj0ZB7VQguUEYqWd06h1hbNNsWREHJf4qA0Cup2GPIv3g/640?wx_fmt=gif" data-type="gif" data-w="500" _width="175px" class=" __bg_gif" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0ae3QInL9VARkj0ZB7VQguUEYqWd06h1hbNNsWREHJf4qA0Cup2GPIv3g/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" data-order="2" alt="图片" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; caret-color: rgb(0, 0, 0); color: rgb(0, 0, 0); text-align: start; background-color: rgb(255, 255, 255); box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 175px !important; visibility: visible !important;"/></p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; line-height: 2; letter-spacing: 0.5px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">其实黑色的美，包容一切。</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">巧妙的色彩与材质的搭配，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">总能产生意想不到的效果，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">原来酷到骨子里的暗黑系风格，</p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: center; word-wrap: break-word !important;">也可以呈现出这么多的百变风格。</p></section></section></section><section style="margin: 0px -18px 0px -23px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: auto; align-self: center; min-width: 10%; flex: 0 0 auto; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: rotateZ(90deg); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: flex; flex-flow: row nowrap; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 45px; vertical-align: top; background-color: rgb(0, 47, 91); flex: 0 0 auto; height: auto; line-height: 0; letter-spacing: 0px; align-self: flex-start; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 45px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.1503268" data-src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeHiaZW9QxjCianemFRdQNmu9L5qmwBYvwibpb9pzpYINCNztGWBZPuNkGQ/640?wx_fmt=gif" data-type="gif" data-w="306" _width="100%" src="https://mmbiz.qpic.cn/mmbiz_gif/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeHiaZW9QxjCianemFRdQNmu9L5qmwBYvwibpb9pzpYINCNztGWBZPuNkGQ/640?wx_fmt=gif&tp=webp&wxfrom=5&wx_lazy=1" class=" __bg_gif" data-order="3" alt="图片" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 45px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;"/></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 3px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 8px; border-top-right-radius: 8px; border-bottom-right-radius: 8px; border-bottom-left-radius: 8px; height: auto; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 5px 15px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 667px; vertical-align: top; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 6px; border-top-right-radius: 6px; border-bottom-right-radius: 6px; border-bottom-left-radius: 6px; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">2021年度流行色——深灰黑</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: perspective(0px); transform-style: flat; word-wrap: break-word !important;"><section style="margin: -10px 0px -5px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; display: flex; flex-flow: row nowrap; justify-content: center; opacity: 0.99; transform: rotateX(180deg); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 0 0 0%; height: auto; line-height: 0; align-self: flex-start; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 30px; height: 12px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 0.8; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-bottom-width: 0.8em; border-bottom-style: solid; border-bottom-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; background-color: rgb(255, 255, 255); box-shadow: rgb(189, 189, 189) 0px 0px 4px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; overflow: hidden; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 663.453125px; height: 5px; background-color: rgb(254, 255, 255); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 10px 10px 20px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); word-wrap: break-word !important;">国际色彩权威机构PANTONE发布了2021年度流行色：深灰黑与亮丽黄。希望即将到来的2021，一扫阴霾，每个人都能“灰黄”腾达！</span></p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 15px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); word-wrap: break-word !important;">虽然，流行色每年都有新的变化，但无论如何变化，百搭的黑色系，始终都在潮流当中，备受大众青睐！</span></p></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="1.3254818" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeiag3cxZusZyWkFPXbVVliaHmDcV84VJp8NwjOzmSPZdggA2gQeynicl7Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="934" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/5859c61df1b7b7775daec2ae84defd99.jpg" crossorigin="anonymous" alt="5859c61df1b7b7775daec2ae84defd99.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="5859c61df1b7b7775daec2ae84defd99.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px 0px 25px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 13px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">（HOPPE 好博不同材质黑色系产品）</span></p></section></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 15px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); word-wrap: break-word !important;">HOPPE 好博五金款式丰富、设计经典，同时还具有丰富的色彩可选，在HOPPE 好博色彩系列中，就有2021年年度流行色彩——深灰黑，可以满足不同环境、不同空间的搭配需求。</span></p></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 15px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 3px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 8px; border-top-right-radius: 8px; border-bottom-right-radius: 8px; border-bottom-left-radius: 8px; height: auto; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 5px 15px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 667px; vertical-align: top; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 6px; border-top-right-radius: 6px; border-bottom-right-radius: 6px; border-bottom-left-radius: 6px; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博黑色系产品应用场景</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: perspective(0px); transform-style: flat; word-wrap: break-word !important;"><section style="margin: -10px 0px -5px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; display: flex; flex-flow: row nowrap; justify-content: center; opacity: 0.99; transform: rotateX(180deg); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 0 0 0%; height: auto; line-height: 0; align-self: flex-start; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 30px; height: 12px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 0.8; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-bottom-width: 0.8em; border-bottom-style: solid; border-bottom-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 22px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; min-width: 10%; vertical-align: top; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 80.59375px; vertical-align: top; border: 0px none rgb(62, 62, 62); border-top-left-radius: 3px; border-top-right-radius: 3px; border-bottom-right-radius: 3px; border-bottom-left-radius: 3px; overflow: hidden; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">场景一</strong></span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 1; font-size: 12px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-top-width: 1.2em; border-top-style: solid; border-top-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 30px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.1em 0.3em; max-width: 100%; box-sizing: border-box; display: inline-block; border: 2px solid rgba(255, 255, 255, 0); background-color: rgb(255, 255, 255); color: rgb(0, 47, 91); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">&nbsp; 客 厅&nbsp;&nbsp;</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 659.453125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 633.0625px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 2px; border-top-right-radius: 2px; border-bottom-right-radius: 2px; border-bottom-left-radius: 2px; overflow: hidden; height: auto; word-wrap: break-word !important;"><img data-ratio="0.635" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeMyoKgk8x8G1QicuD242cF9B5wKcGbJHT8OU0WbEYSKNO4cXnPbkOJWQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/4bc7c7381bbcc4748b5d094704c8b970.jpg" crossorigin="anonymous" alt="4bc7c7381bbcc4748b5d094704c8b970.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="4bc7c7381bbcc4748b5d094704c8b970.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">E1400Z/845-F96-1-R/F78-1-R</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 5px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 633.0625px; height: auto; word-wrap: break-word !important;"><img data-cropselx1="0" data-cropselx2="540" data-cropsely1="0" data-cropsely2="344" data-ratio="0.6140625" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0ae7pT8EPVUB1WBv0cSyQx6kPnzgwz4Z30icIdEP0E4IpMaXcjLLFnPAEw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="560px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/c7fcfa257e6f4a5d917b5146c1b5bdd6.jpg" crossorigin="anonymous" alt="c7fcfa257e6f4a5d917b5146c1b5bdd6.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 560px !important; visibility: visible !important;" title="c7fcfa257e6f4a5d917b5146c1b5bdd6.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">M1642/849N/849NS-F96-1-R</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: translate3d(1px, 0px, 0px); word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 646.25px; vertical-align: top; background-color: rgb(255, 255, 255); border: 0px none rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(82, 118, 55); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); word-wrap: break-word !important;">当黑色作为客厅环境的局部点缀，更是无处不彰显其高级格调。虽不如亮色抢眼，却也是无法忽视的存在，百搭的基调让其与空间里的其它元素相互衬托，更加升华空间美感。</span></p></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; min-width: 10%; vertical-align: top; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 80.59375px; vertical-align: top; border: 0px none rgb(62, 62, 62); border-top-left-radius: 3px; border-top-right-radius: 3px; border-bottom-right-radius: 3px; border-bottom-left-radius: 3px; overflow: hidden; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">场景二</strong></span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 1; font-size: 12px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-top-width: 1.2em; border-top-style: solid; border-top-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 30px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.1em 0.3em; max-width: 100%; box-sizing: border-box; display: inline-block; border: 2px solid rgba(255, 255, 255, 0); background-color: rgb(255, 255, 255); color: rgb(0, 47, 91); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">&nbsp; 餐 厅&nbsp;&nbsp;</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 659.453125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 633.0625px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 2px; border-top-right-radius: 2px; border-bottom-right-radius: 2px; border-bottom-left-radius: 2px; overflow: hidden; height: auto; word-wrap: break-word !important;"><img data-ratio="0.641" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeV8zvsicWZEric4TY0mWhmsZw951HMlQfUfEug24hasFT4yoV4MKA03dg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/d72aa38b30509ffd6eaeb5d3122fe474.jpg" crossorigin="anonymous" alt="d72aa38b30509ffd6eaeb5d3122fe474.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="d72aa38b30509ffd6eaeb5d3122fe474.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">E1400Z/845-F97-1-R/F84-1-R</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 5px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 633.0625px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.618" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeB7aUwIjrb4kBeUrGxBKqBSwWbOebhiakrgPDnwNYQoZcUq8kBibxnqQA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/abc6dc17d1c48a40d849ea2f0d4ab679.jpg" crossorigin="anonymous" alt="abc6dc17d1c48a40d849ea2f0d4ab679.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="abc6dc17d1c48a40d849ea2f0d4ab679.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">E1400Z/845-F97-1-R/F84-1-R</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: translate3d(1px, 0px, 0px); word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 646.25px; vertical-align: top; background-color: rgb(255, 255, 255); border: 0px none rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(82, 118, 55); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); word-wrap: break-word !important;">有时，黑色在空间中会显得过于冰冷，但百搭的黑色一旦遇上鲜明颜色的点缀，空间也就变得更加鲜活了。恰到好处的色彩点缀也为神秘色彩浓重的餐厅增添了一丝跳脱感。</span></p></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; min-width: 10%; vertical-align: top; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 80.59375px; vertical-align: top; border: 0px none rgb(62, 62, 62); border-top-left-radius: 3px; border-top-right-radius: 3px; border-bottom-right-radius: 3px; border-bottom-left-radius: 3px; overflow: hidden; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">场景三</strong></span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 1; font-size: 12px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-top-width: 1.2em; border-top-style: solid; border-top-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 30px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.1em 0.3em; max-width: 100%; box-sizing: border-box; display: inline-block; border: 2px solid rgba(255, 255, 255, 0); background-color: rgb(255, 255, 255); color: rgb(0, 47, 91); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">&nbsp; 阳&nbsp;台&nbsp;&nbsp;</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 659.453125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 633.0625px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 2px; border-top-right-radius: 2px; border-bottom-right-radius: 2px; border-bottom-left-radius: 2px; overflow: hidden; height: auto; word-wrap: break-word !important;"><img data-ratio="0.649" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeEuo4ESvyOoa69r1sDga1MMso6ibKISkT9u4Mia6E0eo5qMCcy1q8A1Eg/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/a6b552ff4145eb7a324c4ca09c0f7d64.jpg" crossorigin="anonymous" alt="a6b552ff4145eb7a324c4ca09c0f7d64.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="a6b552ff4145eb7a324c4ca09c0f7d64.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">HS-0700/431N-AS/422-F9714M</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 5px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 633.0625px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.649" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aelWb5XphXHOMFcfFPwdjlsCseNWUlLBPLBGG8yoicCB6eUxAowJZnsXA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/1e510d0a72ac982ba9dfcc11249c158a.jpg" crossorigin="anonymous" alt="1e510d0a72ac982ba9dfcc11249c158a.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="1e510d0a72ac982ba9dfcc11249c158a.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">1700FA/300LMSGL-D/NLFSGL/1700-F9714M</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: translate3d(1px, 0px, 0px); word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 646.25px; vertical-align: top; background-color: rgb(255, 255, 255); border: 0px none rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(82, 118, 55); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); word-wrap: break-word !important;">阳台黑色执手，独立存在时，不必过分强调，其与生俱来的时尚感，便足以向人们展示它的独特魅力与气质。与通透玻璃门的组合，也为居室增添了一抹纯粹性和安全感。</span></p></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; min-width: 10%; vertical-align: top; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 80.59375px; vertical-align: top; border: 0px none rgb(62, 62, 62); border-top-left-radius: 3px; border-top-right-radius: 3px; border-bottom-right-radius: 3px; border-bottom-left-radius: 3px; overflow: hidden; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">场景四</strong></span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 1; font-size: 12px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-top-width: 1.2em; border-top-style: solid; border-top-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 30px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.1em 0.3em; max-width: 100%; box-sizing: border-box; display: inline-block; border: 2px solid rgba(255, 255, 255, 0); background-color: rgb(255, 255, 255); color: rgb(0, 47, 91); font-size: 18px; letter-spacing: 2px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">&nbsp; 窗 户&nbsp;&nbsp;</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 659.453125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 633.0625px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 2px; border-top-right-radius: 2px; border-bottom-right-radius: 2px; border-bottom-left-radius: 2px; overflow: hidden; height: auto; word-wrap: break-word !important;"><img data-ratio="1.2824074" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeKxsW670C2pLQy3z7Z44Z1cyVpw7I8GYWrgRq9xYFnHBweWc2aDDoHQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/08c072c110ca40878a22d72c155af743.jpg" crossorigin="anonymous" alt="08c072c110ca40878a22d72c155af743.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="08c072c110ca40878a22d72c155af743.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">0700/UD9020-F9714M</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 5px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 633.0625px; height: auto; word-wrap: break-word !important;"><img data-ratio="1.3333333" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeLWOFMia1Er7pCeib4vxdBEzPOShlcicqKUiczaAaicQ5hJGibLSyrH5QLnLw/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/bc95aa0550bcf86a9d420b22453a87cf.jpg" crossorigin="anonymous" alt="bc95aa0550bcf86a9d420b22453a87cf.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="bc95aa0550bcf86a9d420b22453a87cf.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">0737S/US947-F9714M</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: translate3d(1px, 0px, 0px); word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 646.25px; vertical-align: top; background-color: rgb(255, 255, 255); border: 0px none rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(82, 118, 55); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); word-wrap: break-word !important;">纯粹简单的黑色，百搭又富有表现力，超越了任何色彩体现的深度，也许这正是当下人们喜欢它的理由。</span></p></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; min-width: 10%; vertical-align: top; line-height: 0; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 80.59375px; vertical-align: top; border: 0px none rgb(62, 62, 62); border-top-left-radius: 3px; border-top-right-radius: 3px; border-bottom-right-radius: 3px; border-bottom-left-radius: 3px; overflow: hidden; background-color: rgb(0, 47, 91); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px 10px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); line-height: 2; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">场景五</strong></span></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 1; font-size: 12px; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-top-width: 1.2em; border-top-style: solid; border-top-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 30px 0px 10px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: -20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0.1em 0.3em; max-width: 100%; box-sizing: border-box; display: inline-block; border: 2px solid rgba(255, 255, 255, 0); background-color: rgb(255, 255, 255); color: rgb(0, 47, 91); font-size: 18px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">&nbsp; 办公环境&nbsp;&nbsp;</strong></p></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 659.453125px; vertical-align: top; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; width: 633.0625px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 2px; border-top-right-radius: 2px; border-bottom-right-radius: 2px; border-bottom-left-radius: 2px; overflow: hidden; height: auto; word-wrap: break-word !important;"><img data-ratio="0.6398148" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeSzfiabyJjNFqo1zJJiaboFyen2c8EHFoiatUysFPNL0MN3xpoXyGgPYWQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/3256247d5114479d2057d9fb69321e84.jpg" crossorigin="anonymous" alt="3256247d5114479d2057d9fb69321e84.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="3256247d5114479d2057d9fb69321e84.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">1700/30P/30PS-F9714M</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 5px 0px 8px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 633.0625px; height: auto; word-wrap: break-word !important;"><img data-ratio="0.6175926" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aelC29aVz8P3RxdsH4T4MlPf4qDVx1T6tiachDyNGWkX1gvYg5cdtbf8Q/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e10158dc76b9cee2b0084f5f2ab0d6c2.jpg" crossorigin="anonymous" alt="e10158dc76b9cee2b0084f5f2ab0d6c2.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 633.0625px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="e10158dc76b9cee2b0084f5f2ab0d6c2.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-align: right; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; color: rgb(136, 136, 136); box-sizing: border-box !important; word-wrap: break-word !important;">E1400Z/845-F97-1-R/F84-1-R</span></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: translate3d(1px, 0px, 0px); word-wrap: break-word !important;"><section style="margin: 0px; padding: 10px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 646.25px; vertical-align: top; background-color: rgb(255, 255, 255); border: 0px none rgb(62, 62, 62); border-top-left-radius: 0px; border-top-right-radius: 0px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 16px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 14px; color: rgb(82, 118, 55); line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(9, 9, 9); word-wrap: break-word !important;">在办公环境中，经典的黑白色搭配，简约个性又不失稳重，冷峻之中透着十足魅力。从窗外投进的自然光将空间照亮，营造出一个安静但不沉闷的工作氛围。</span></p></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; justify-content: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 3px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 677px; vertical-align: top; border: 2px solid rgb(0, 47, 91); border-top-left-radius: 8px; border-top-right-radius: 8px; border-bottom-right-radius: 8px; border-bottom-left-radius: 8px; height: auto; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 5px 15px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 667px; vertical-align: top; background-color: rgb(0, 47, 91); border: 0px none rgb(62, 62, 62); border-top-left-radius: 6px; border-top-right-radius: 6px; border-bottom-right-radius: 6px; border-bottom-left-radius: 6px; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; color: rgb(255, 255, 255); font-size: 17px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博产品优势</strong></p></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; transform: perspective(0px); transform-style: flat; word-wrap: break-word !important;"><section style="margin: -10px 0px -5px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; display: flex; flex-flow: row nowrap; justify-content: center; opacity: 0.99; transform: rotateX(180deg); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px 5px; max-width: 100%; box-sizing: border-box; display: inline-block; width: auto; vertical-align: top; flex: 0 0 0%; height: auto; line-height: 0; align-self: flex-start; background-color: rgb(255, 255, 255); word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 30px; height: 12px; vertical-align: top; overflow: hidden; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 0.8; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 0px; display: inline-block; border-bottom-width: 0.8em; border-bottom-style: solid; border-bottom-color: rgb(0, 47, 91); word-wrap: break-word !important; border-left-width: 0.7em !important; border-left-style: solid !important; border-left-color: transparent !important; border-right-width: 0.7em !important; border-right-style: solid !important; border-right-color: transparent !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; background-color: rgb(255, 255, 255); box-shadow: rgb(189, 189, 189) 0px 0px 4px; border: 0px none rgb(62, 62, 62); border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; overflow: hidden; height: auto; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><img data-ratio="0.665" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeun8ZtT7Vguia5mIb1l1y1TcWxBibF4CKqJnKSVwNYkbAPzUBCmaU5R9A/640?wx_fmt=jpeg" data-type="jpeg" data-w="1000" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/443acf082d9019ec9c8b3af668e46c0b.jpg" crossorigin="anonymous" alt="443acf082d9019ec9c8b3af668e46c0b.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="443acf082d9019ec9c8b3af668e46c0b.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; width: 663.453125px; height: 5px; background-color: rgb(254, 255, 255); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 10px 10px 20px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 15px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); word-wrap: break-word !important;">HOPPE 好博产品线能够做到门把手与窗把手同颜色、同款式、同系列。现在，伴随着零售经销店产品套装的推出，真正实现为用户提供一站式解决方案。而且，基于用户对黑色系产品的需求，零售经销店也会推出全黑系列的产品套装，包括锁芯、锁体、合页、执手等，全面满足用户的多样化需求。</span></p></section><section powered-by="xiumi.us" style="margin: 15px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: justify; font-size: 15px; line-height: 2; letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); word-wrap: break-word !important;">新色彩的一大优势是其持久的表现力，即使在高强度地使用环境或恶劣天气条件下依然表现“出色”！它们带有Resista<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;">®</sup>十年表层质保，随时接受检验。新的产品都通过欧标 EN 1670 的测试。10年表层质保适用于所有的经Resista<sup style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 12px; word-wrap: break-word !important;">®</sup>表层处理工艺的HOPPE 好博五金，品质保障，安心选购！</span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; text-align: left; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); word-wrap: break-word !important;">&nbsp;&nbsp; &nbsp;<img class="rich_pages " data-backh="286" data-backw="490" data-croporisrc="https://mmbiz.qpic.cn/mmbiz_png/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aen4C1qVsCwHoP42djA8l9fENibkOPHHv4BJHuLRP6J1jzOiagNLwIPrcg/0?wx_fmt=png" data-cropx1="484.9339207048458" data-cropx2="1898.3847283406753" data-cropy1="221.79148311306903" data-cropy2="1413.4508076358297" data-ratio="0.8421875" data-s="300,640" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0ae0ZGPOEBWD4AamncZRx1ibvOZ9xM3MY1XhTQvwzOrTDhMctSmYhujJgQ/640?wx_fmt=jpeg" data-type="jpeg" data-w="1280" _width="376px" src="https://hoppe.jzdsh.com/upload/ue/img/d90049d247cffd73227ed92091ab885a.jpg" crossorigin="anonymous" alt="d90049d247cffd73227ed92091ab885a.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; font-size: 15px; text-align: center; box-sizing: border-box !important; word-wrap: break-word !important; height: auto !important; width: 376px !important; visibility: visible !important;" title="d90049d247cffd73227ed92091ab885a.jpg"/></span></p><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; text-indent: 2em; word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(9, 9, 9); word-wrap: break-word !important;"><span style="margin: 0px; padding: 0px; max-width: 100%; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">黑色有着强烈的个人风格，不管是工业风，还是现代极简，黑色的讨喜程度一直在不断升高。</span><span style="margin: 0px; padding: 0px; max-width: 100%; text-indent: 2em; box-sizing: border-box !important; word-wrap: break-word !important;">HOPPE 好博黑色系产品，百搭风格，助您打造出专属您的独特装修风格。</span></span></p></section></section></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><br style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"/></p></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; text-align: center; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; display: inline-block; width: 663.453125px; vertical-align: top; box-shadow: rgb(178, 185, 192) 1px 0px 10px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px 0px 20px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.437037" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeyvDNWeibbrkkHiaic3wQJTx0gEq7JDK1zbkicmJpAqgtia5TzyYde3CdY4A/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/9fa4f98ce88ce18ace7675934764ca492.jpg" crossorigin="anonymous" alt="9fa4f98ce88ce18ace7675934764ca49.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="9fa4f98ce88ce18ace7675934764ca492.jpg"/></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><a target="_blank" href="http://mp.weixin.qq.com/s?__biz=MzA3MjgzNjc0NQ==&mid=2650532870&idx=1&sn=d116082a97cf53623478cef378a096a4&chksm=87177fe0b060f6f6c24ba3e5d78170020e1d91a506b7fc9853ae91d025da03bfcade63db2df6&scene=21#wechat_redirect" textvalue="你已选中了添加链接的内容" data-itemshowtype="0" tab="innerlink" data-linktype="1" hasload="1" style="margin: 0px; padding: 0px; color: rgb(87, 107, 149); text-decoration: none; cursor: pointer; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><span class="js_jump_icon h5_image_link" data-positionback="static" style="margin: 0px; padding: 0px; max-width: 100%; line-height: 0; font-size: 0px; display: inline-block; position: relative; top: auto; left: auto; right: auto; bottom: auto; box-sizing: border-box !important; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aeoXlJQciaDlmLqmdfRGlCMctSwSAkVawSMzv3TfBIQTwnGgvQfQOCq7w/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/6402.jpg" crossorigin="anonymous" alt="640.jpg" data-fail="0" style="margin: 0px; padding: 0px; border: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="6402.jpg"/></span></a></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信小程序</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 点击查看小程序使用指南</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0ae4fS03z1jnKEzQG7NflZlwunjgZUEfFnH2gO4Mz8POCGBBviapJHoVyA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/cd86081b154d877377be09982b7eee3f3.jpg" crossorigin="anonymous" alt="cd86081b154d877377be09982b7eee3f.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="cd86081b154d877377be09982b7eee3f3.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博微信公众号</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码关注我们</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 10px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 253.4375px; box-shadow: rgb(0, 0, 0) 0px 0px 0px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; width: 243.4375px; word-wrap: break-word !important;"><img data-ratio="1" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0ae9Xc2rjDnwmp2MPy2z4ePDY2S8lQTmYleIf8aNicOlwn8PcuibeyvQ1JA/640?wx_fmt=jpeg" data-type="jpeg" data-w="300" _width="100%" class="" src="https://hoppe.jzdsh.com/upload/ue/img/e013f1d86ebf46f160f8ee0a62a3b36c2.jpg" crossorigin="anonymous" alt="e013f1d86ebf46f160f8ee0a62a3b36c.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; width: 243.4375px; word-wrap: break-word !important; height: auto !important; visibility: visible !important;" title="e013f1d86ebf46f160f8ee0a62a3b36c2.jpg"/></section></section></section><section style="margin: 0px; padding: 5px; max-width: 100%; box-sizing: border-box; display: inline-block; vertical-align: middle; width: 410px; word-wrap: break-word !important;"><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 15px; color: rgb(0, 47, 91); word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;"><strong style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;">HOPPE 好博官网</strong></p></section><section powered-by="xiumi.us" style="margin: 0.5em 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; border-top-width: 1px; border-top-style: dashed; border-top-color: rgb(62, 62, 62); word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box !important; word-wrap: break-word !important;"><svg viewbox="0 0 1 1" style="float:left;line-height:0;width:0;vertical-align:top;"></svg></section></section></section><section powered-by="xiumi.us" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; font-size: 14px; color: rgb(72, 72, 72); letter-spacing: 0.5px; word-wrap: break-word !important;"><p style="margin-top: 0px; margin-bottom: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; clear: both; min-height: 1em; word-wrap: break-word !important;">👈 长按识别二维码进入官网</p></section></section></section></section><section powered-by="xiumi.us" style="margin: 20px 0px 0px; padding: 0px; max-width: 100%; box-sizing: border-box; word-wrap: break-word !important;"><section style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; display: inline-block; line-height: 0; word-wrap: break-word !important;"><img data-ratio="0.4657407" data-src="https://mmbiz.qpic.cn/mmbiz_jpg/6GqXbok17iabE1LFkmy7uuVMzqN0bc0aedcYLRx0icH4iba02PtibdrECFRnedEDAoBbsG4DsDrXqawduicJlxTzfNA/640?wx_fmt=jpeg" data-type="jpeg" data-w="1080" _width="677px" class="" src="https://hoppe.jzdsh.com/upload/ue/img/449e61ad524df845b8dd8b337adf730f2.jpg" crossorigin="anonymous" alt="449e61ad524df845b8dd8b337adf730f.jpg" data-fail="0" style="margin: 0px; padding: 0px; max-width: 100%; box-sizing: border-box; vertical-align: middle; word-wrap: break-word !important; height: auto !important; width: 677px !important; visibility: visible !important;" title="449e61ad524df845b8dd8b337adf730f2.jpg"/></section></section></section></section></section></p><p></p><p><br/></p>', 1, 0, 0, '2020-12-30', '2021-01-10 13:19:30');
/*!40000 ALTER TABLE `news` ENABLE KEYS */;

-- 导出  表 hoppe.photo 结构
CREATE TABLE IF NOT EXISTS `photo` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '图册自增id',
  `title` varchar(500) DEFAULT NULL COMMENT '图册 标题',
  `img_url` varchar(500) DEFAULT NULL COMMENT '图路径',
  `detail` mediumtext COMMENT '图册信息 详情   ',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8mb4 COMMENT='资料库  > 图册资料';

-- 正在导出表  hoppe.photo 的数据：~12 rows (大约)
/*!40000 ALTER TABLE `photo` DISABLE KEYS */;
REPLACE INTO `photo` (`id`, `title`, `img_url`, `detail`, `sort`, `create_time`) VALUES
	(11, 'HCS® — HOPPE 好博整体系统', '/upload/info/photo/封面2.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-1.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-2.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-3.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-4.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-5.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-6.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-7.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-8.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-8.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-9.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-9.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-10.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-10.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-11.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-11.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-12.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-12.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-13.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-13.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-14.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-14.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-15.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-15.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-16.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-16.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-17.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-17.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-18.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-18.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-19.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-19.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-20.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-20.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-21.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-21.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-22.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-22.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-23.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-23.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-24.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-24.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-25.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-25.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-26.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-26.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-27.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-27.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-28.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-28.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-29.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-29.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-30.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-30.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-31.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-31.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-32.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-32.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-33.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-33.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-34.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-34.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-35.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-35.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-36.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-36.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-37.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-37.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-38.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-38.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-39.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-39.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2015-12-Brochure-HOPPE-HCS-CN-40.jpg" title="2015-12-Brochure-HOPPE-HCS-CN-40.jpg"/></p><p><br/></p>', 90, '2020-09-17 12:00:03'),
	(12, 'HOPPE — 质感的享受', '/upload/info/photo/11.jpg', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-1.jpg" title="好博-质感的享受(1)-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-2.jpg" title="好博-质感的享受(1)-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-3.jpg" title="好博-质感的享受(1)-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-4.jpg" title="好博-质感的享受(1)-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-5.jpg" title="好博-质感的享受(1)-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-6.jpg" title="好博-质感的享受(1)-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-7.jpg" title="好博-质感的享受(1)-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-8.jpg" title="好博-质感的享受(1)-8.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-9.jpg" title="好博-质感的享受(1)-9.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-10.jpg" title="好博-质感的享受(1)-10.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-11.jpg" title="好博-质感的享受(1)-11.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-12.jpg" title="好博-质感的享受(1)-12.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-13.jpg" title="好博-质感的享受(1)-13.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-14.jpg" title="好博-质感的享受(1)-14.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-15.jpg" title="好博-质感的享受(1)-15.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-16.jpg" title="好博-质感的享受(1)-16.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-17.jpg" title="好博-质感的享受(1)-17.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-18.jpg" title="好博-质感的享受(1)-18.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-19.jpg" title="好博-质感的享受(1)-19.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-20.jpg" title="好博-质感的享受(1)-20.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-21.jpg" title="好博-质感的享受(1)-21.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-22.jpg" title="好博-质感的享受(1)-22.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-23.jpg" title="好博-质感的享受(1)-23.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-24.jpg" title="好博-质感的享受(1)-24.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-25.jpg" title="好博-质感的享受(1)-25.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-26.jpg" title="好博-质感的享受(1)-26.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-27.jpg" title="好博-质感的享受(1)-27.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-28.jpg" title="好博-质感的享受(1)-28.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-29.jpg" title="好博-质感的享受(1)-29.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-30.jpg" title="好博-质感的享受(1)-30.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-31.jpg" title="好博-质感的享受(1)-31.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-32.jpg" title="好博-质感的享受(1)-32.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-33.jpg" title="好博-质感的享受(1)-33.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-34.jpg" title="好博-质感的享受(1)-34.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-35.jpg" title="好博-质感的享受(1)-35.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-36.jpg" title="好博-质感的享受(1)-36.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-37.jpg" title="好博-质感的享受(1)-37.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-38.jpg" title="好博-质感的享受(1)-38.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-39.jpg" title="好博-质感的享受(1)-39.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-40.jpg" title="好博-质感的享受(1)-40.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-41.jpg" title="好博-质感的享受(1)-41.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-42.jpg" title="好博-质感的享受(1)-42.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-43.jpg" title="好博-质感的享受(1)-43.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-44.jpg" title="好博-质感的享受(1)-44.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-45.jpg" title="好博-质感的享受(1)-45.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-46.jpg" title="好博-质感的享受(1)-46.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-47.jpg" title="好博-质感的享受(1)-47.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-48.jpg" title="好博-质感的享受(1)-48.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-49.jpg" title="好博-质感的享受(1)-49.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-50.jpg" title="好博-质感的享受(1)-50.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-51.jpg" title="好博-质感的享受(1)-51.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-52.jpg" title="好博-质感的享受(1)-52.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-53.jpg" title="好博-质感的享受(1)-53.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-54.jpg" title="好博-质感的享受(1)-54.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-55.jpg" title="好博-质感的享受(1)-55.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-56.jpg" title="好博-质感的享受(1)-56.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-57.jpg" title="好博-质感的享受(1)-57.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-58.jpg" title="好博-质感的享受(1)-58.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-59.jpg" title="好博-质感的享受(1)-59.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-60.jpg" title="好博-质感的享受(1)-60.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-61.jpg" title="好博-质感的享受(1)-61.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-62.jpg" title="好博-质感的享受(1)-62.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-63.jpg" title="好博-质感的享受(1)-63.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-64.jpg" title="好博-质感的享受(1)-64.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-65.jpg" title="好博-质感的享受(1)-65.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-66.jpg" title="好博-质感的享受(1)-66.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-67.jpg" title="好博-质感的享受(1)-67.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-68.jpg" title="好博-质感的享受(1)-68.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-69.jpg" title="好博-质感的享受(1)-69.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-70.jpg" title="好博-质感的享受(1)-70.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-71.jpg" title="好博-质感的享受(1)-71.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-72.jpg" title="好博-质感的享受(1)-72.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-73.jpg" title="好博-质感的享受(1)-73.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-74.jpg" title="好博-质感的享受(1)-74.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-75.jpg" title="好博-质感的享受(1)-75.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-76.jpg" title="好博-质感的享受(1)-76.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-77.jpg" title="好博-质感的享受(1)-77.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-78.jpg" title="好博-质感的享受(1)-78.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-79.jpg" title="好博-质感的享受(1)-79.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-80.jpg" title="好博-质感的享受(1)-80.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-81.jpg" title="好博-质感的享受(1)-81.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-82.jpg" title="好博-质感的享受(1)-82.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-83.jpg" title="好博-质感的享受(1)-83.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-84.jpg" title="好博-质感的享受(1)-84.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-85.jpg" title="好博-质感的享受(1)-85.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-86.jpg" title="好博-质感的享受(1)-86.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-87.jpg" title="好博-质感的享受(1)-87.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-88.jpg" title="好博-质感的享受(1)-88.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-89.jpg" title="好博-质感的享受(1)-89.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-90.jpg" title="好博-质感的享受(1)-90.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-91.jpg" title="好博-质感的享受(1)-91.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-92.jpg" title="好博-质感的享受(1)-92.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-93.jpg" title="好博-质感的享受(1)-93.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-94.jpg" title="好博-质感的享受(1)-94.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-95.jpg" title="好博-质感的享受(1)-95.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-96.jpg" title="好博-质感的享受(1)-96.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-97.jpg" title="好博-质感的享受(1)-97.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-98.jpg" title="好博-质感的享受(1)-98.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-99.jpg" title="好博-质感的享受(1)-99.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-100.jpg" title="好博-质感的享受(1)-100.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-101.jpg" title="好博-质感的享受(1)-101.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-102.jpg" title="好博-质感的享受(1)-102.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-103.jpg" title="好博-质感的享受(1)-103.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-104.jpg" title="好博-质感的享受(1)-104.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-105.jpg" title="好博-质感的享受(1)-105.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-106.jpg" title="好博-质感的享受(1)-106.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-107.jpg" title="好博-质感的享受(1)-107.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-108.jpg" title="好博-质感的享受(1)-108.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-109.jpg" title="好博-质感的享受(1)-109.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-110.jpg" title="好博-质感的享受(1)-110.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-111.jpg" title="好博-质感的享受(1)-111.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-112.jpg" title="好博-质感的享受(1)-112.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-113.jpg" title="好博-质感的享受(1)-113.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-114.jpg" title="好博-质感的享受(1)-114.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-115.jpg" title="好博-质感的享受(1)-115.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-116.jpg" title="好博-质感的享受(1)-116.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-117.jpg" title="好博-质感的享受(1)-117.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-118.jpg" title="好博-质感的享受(1)-118.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-119.jpg" title="好博-质感的享受(1)-119.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-120.jpg" title="好博-质感的享受(1)-120.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-121.jpg" title="好博-质感的享受(1)-121.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-122.jpg" title="好博-质感的享受(1)-122.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-123.jpg" title="好博-质感的享受(1)-123.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-124.jpg" title="好博-质感的享受(1)-124.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-125.jpg" title="好博-质感的享受(1)-125.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-126.jpg" title="好博-质感的享受(1)-126.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-127.jpg" title="好博-质感的享受(1)-127.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-128.jpg" title="好博-质感的享受(1)-128.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-129.jpg" title="好博-质感的享受(1)-129.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-130.jpg" title="好博-质感的享受(1)-130.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-131.jpg" title="好博-质感的享受(1)-131.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-132.jpg" title="好博-质感的享受(1)-132.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-133.jpg" title="好博-质感的享受(1)-133.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-134.jpg" title="好博-质感的享受(1)-134.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-135.jpg" title="好博-质感的享受(1)-135.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-136.jpg" title="好博-质感的享受(1)-136.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-137.jpg" title="好博-质感的享受(1)-137.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-138.jpg" title="好博-质感的享受(1)-138.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-139.jpg" title="好博-质感的享受(1)-139.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-140.jpg" title="好博-质感的享受(1)-140.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-141.jpg" title="好博-质感的享受(1)-141.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-142.jpg" title="好博-质感的享受(1)-142.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-143.jpg" title="好博-质感的享受(1)-143.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-144.jpg" title="好博-质感的享受(1)-144.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-145.jpg" title="好博-质感的享受(1)-145.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-146.jpg" title="好博-质感的享受(1)-146.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-147.jpg" title="好博-质感的享受(1)-147.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-148.jpg" title="好博-质感的享受(1)-148.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-149.jpg" title="好博-质感的享受(1)-149.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-150.jpg" title="好博-质感的享受(1)-150.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-151.jpg" title="好博-质感的享受(1)-151.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-152.jpg" title="好博-质感的享受(1)-152.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-153.jpg" title="好博-质感的享受(1)-153.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-154.jpg" title="好博-质感的享受(1)-154.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-155.jpg" title="好博-质感的享受(1)-155.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-156.jpg" title="好博-质感的享受(1)-156.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-157.jpg" title="好博-质感的享受(1)-157.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-158.jpg" title="好博-质感的享受(1)-158.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-159.jpg" title="好博-质感的享受(1)-159.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-160.jpg" title="好博-质感的享受(1)-160.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-161.jpg" title="好博-质感的享受(1)-161.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-162.jpg" title="好博-质感的享受(1)-162.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-163.jpg" title="好博-质感的享受(1)-163.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-164.jpg" title="好博-质感的享受(1)-164.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-165.jpg" title="好博-质感的享受(1)-165.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-166.jpg" title="好博-质感的享受(1)-166.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-167.jpg" title="好博-质感的享受(1)-167.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/好博-质感的享受(1)-168.jpg" title="好博-质感的享受(1)-168.jpg"/></p><p><br/></p>', 98, '2020-09-17 22:10:41'),
	(13, '窗和型材门把手', '/upload/info/photo/封面4.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-1.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-3.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-2.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-5.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-6.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-4.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-7.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-8.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-8.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-9.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-9.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-11.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-11.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-10.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-10.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-12.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-12.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-13.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-13.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-14.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-14.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-15.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-15.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-16.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-16.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-17.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-17.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-18.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-18.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-19.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-19.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-20.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-20.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-21.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-21.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-22.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-22.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-23.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-23.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-25.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-25.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-26.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-26.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-27.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-27.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-24.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-24.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-29.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-29.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-28.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-28.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-30.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-30.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-31.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-31.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-32.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-32.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-33.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-33.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-34.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-34.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-35.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-35.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-36.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-36.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-37.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-37.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-38.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-38.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-39.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-39.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-40.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-40.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-41.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-41.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-44.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-44.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-42.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-42.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-43.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-43.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-45.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-45.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-47.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-47.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-46.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-46.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-48.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-48.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-49.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-49.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-50.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-50.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-51.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-51.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-52.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-52.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-53.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-53.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-54.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-54.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-55.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-55.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-57.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-57.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-56.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-56.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-58.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-58.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-60.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-60.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-61.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-61.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-62.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-62.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-59.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-59.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-63.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-63.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-64.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-64.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-65.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-65.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-66.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-66.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-67.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-67.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-68.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-68.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-69.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-69.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-70.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-70.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-71.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-71.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-72.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-72.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-73.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-73.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-74.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-74.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-76.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-76.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-75.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-75.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-78.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-78.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-77.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-77.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-81.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-81.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-79.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-79.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-80.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-80.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-82.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-82.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-83.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-83.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-84.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-84.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-85.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-85.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-86.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-86.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-87.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-87.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-88.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-88.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-90.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-90.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-89.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-89.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-91.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-91.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-92.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-92.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-95.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-95.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-94.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-94.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-93.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-93.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-96.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-96.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-98.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-98.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-97.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-97.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-99.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-99.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-100.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-100.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-101.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-101.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-102.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-102.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-104.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-104.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-103.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-103.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-105.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-105.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-106.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-106.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-107.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-107.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-108.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-108.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-109.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-109.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-110.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-110.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-111.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-111.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-112.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-112.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-113.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-113.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-114.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-114.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-115.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-115.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-116.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-116.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-117.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-117.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-119.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-119.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-118.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-118.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-120.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-120.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-121.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-121.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-122.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-122.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-123.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-123.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-124.jpg" title="2017-02-Brochure-HOPPE-Programme-for-windows-and-profile-doors-CN-EN-124.jpg"/></p><p><br/></p>', 96, '2020-09-17 22:12:56'),
	(14, 'Austin—超薄底座，与众不同', '/upload/info/photo/封面5.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-1.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-2.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-3.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-4.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-5.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-6.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-7.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-8.jpg" title="2017-04-Brochure-HOPPE-Austin-flat-rosettes-CN-EN-8.jpg"/></p><p><br/></p>', 89, '2020-09-17 22:13:49'),
	(15, '极简主义：HOPPE 好博 mini-roses', '/upload/info/photo/封面6.png', '<p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-13.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-13.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-21.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-21.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-31.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-31.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-41.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-41.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-51.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-51.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-61.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-61.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-71.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-71.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-81.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-81.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-101.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-101.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-111.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-111.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-91.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-91.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-121.jpg"  title="2017-06-Brochure-HOPPE-Mini-Roses-CN-EN-121.jpg"/></p><p><br/></p>', 91, '2020-09-17 22:14:42'),
	(16, 'SecuSan®-新卫生标准   通过临床实践测试', '/upload/info/photo/封面7.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-1.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-2.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-3.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-6.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-4.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-5.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-7.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-8.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-8.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-9.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-9.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-10.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-10.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-11.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-11.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-12.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-12.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-14.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-14.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-15.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-15.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-13.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-13.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2017-08-Brochure-SecuSan-EN-ZH-16.jpg" title="2017-08-Brochure-SecuSan-EN-ZH-16.jpg"/></p><p><br/></p>', 95, '2020-09-17 22:15:22'),
	(17, '便捷、安全     HOPPE好博指纹开启', '/upload/info/photo/封面8.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-08-Prospect-HOPPE-Fingerscanner-CN-1.jpg" title="2018-08-Prospect-HOPPE-Fingerscanner-CN-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-08-Prospect-HOPPE-Fingerscanner-CN-2.jpg" title="2018-08-Prospect-HOPPE-Fingerscanner-CN-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-08-Prospect-HOPPE-Fingerscanner-CN-3.jpg" title="2018-08-Prospect-HOPPE-Fingerscanner-CN-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-08-Prospect-HOPPE-Fingerscanner-CN-4.jpg" title="2018-08-Prospect-HOPPE-Fingerscanner-CN-4.jpg"/></p><p><br/></p>', 94, '2020-09-17 22:16:07'),
	(18, 'SecuForte®简单、不同、更安全', '/upload/info/photo/封面9.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-09-Prospect-HOPPE-SecuForte-CN-11700725-1.jpg" title="2018-09-Prospect-HOPPE-SecuForte-CN-11700725-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-09-Prospect-HOPPE-SecuForte-CN-11700725-2.jpg" title="2018-09-Prospect-HOPPE-SecuForte-CN-11700725-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-09-Prospect-HOPPE-SecuForte-CN-11700725-4.jpg" title="2018-09-Prospect-HOPPE-SecuForte-CN-11700725-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-09-Prospect-HOPPE-SecuForte-CN-11700725-3.jpg" title="2018-09-Prospect-HOPPE-SecuForte-CN-11700725-3.jpg"/></p><p><br/></p>', 92, '2020-09-17 22:17:14'),
	(19, '新色彩与Resista® 十年表层质保  质感更出众', '/upload/info/photo/fengmian.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-17.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-17.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-21.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-21.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-41.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-41.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-31.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-31.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-51.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-51.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-61.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-61.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-71.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-71.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-81.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-81.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-91.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-91.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-101.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-101.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-111.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-111.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-121.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-121.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-131.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-131.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-141.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-141.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-151.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-151.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-161.jpg" title="2018-10-Brochure-Finishes-with-Resista-Add-some-special-touches-CN-CN-161.jpg"/></p><p><br/></p>', 93, '2020-09-17 22:18:13'),
	(21, '2019/2020 中国采购指南 HOPPE 及 ARRONE 产品', '/upload/info/photo/封面12.png', '<p><br/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-1.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-3.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-4.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-5.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-6.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-7.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-8.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-8.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-9.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-9.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-10.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-10.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-11.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-11.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-12.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-12.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-13.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-13.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-14.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-14.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-15.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-15.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-16.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-16.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-17.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-17.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-18.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-18.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-19.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-19.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-20.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-20.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-21.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-21.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-22.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-22.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-23.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-23.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-24.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-24.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-25.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-25.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-26.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-26.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-27.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-27.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-28.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-28.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-29.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-29.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-30.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-30.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-31.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-31.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-32.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-32.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-33.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-33.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-34.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-34.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-35.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-35.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-36.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-36.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-37.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-37.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-38.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-38.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-39.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-39.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-40.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-40.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-41.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-41.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-42.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-42.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-43.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-43.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-44.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-44.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-45.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-45.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-46.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-46.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-47.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-47.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-48.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-48.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-49.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-49.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-50.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-50.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-51.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-51.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-52.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-52.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-53.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-53.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-54.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-54.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-55.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-55.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-56.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-56.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-57.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-57.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-58.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-58.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-59.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-59.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-60.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-60.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-61.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-61.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-62.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-62.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-63.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-63.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-64.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-64.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-65.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-65.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-66.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-66.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-67.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-67.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-68.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-68.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-69.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-69.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-70.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-70.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-71.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-71.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-74.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-74.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-72.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-72.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-73.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-73.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-76.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-76.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-75.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-75.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-77.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-77.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-79.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-79.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-80.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-80.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-78.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-78.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-81.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-81.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-82.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-82.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-84.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-84.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-85.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-85.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-83.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-83.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-87.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-87.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-88.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-88.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-86.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-86.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-89.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-89.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-90.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-90.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-91.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-91.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-93.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-93.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-92.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-92.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-94.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-94.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-97.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-97.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-95.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-95.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-98.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-98.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-99.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-99.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-100.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-100.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-102.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-102.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-101.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-101.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-104.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-104.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-103.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-103.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-96.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-96.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-105.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-105.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-106.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-106.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-107.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-107.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-108.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-108.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-109.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-109.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-110.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-110.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-112.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-112.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-111.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-111.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-113.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-113.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-114.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-114.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-115.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-115.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-116.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-116.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-117.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-117.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-118.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-118.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-119.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-119.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-120.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-120.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-121.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-121.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-122.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-122.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-123.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-123.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-124.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-124.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-125.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-125.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-126.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-126.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-127.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-127.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-128.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-128.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-129.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-129.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-130.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-130.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-131.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-131.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-132.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-132.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-133.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-133.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-134.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-134.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-135.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-135.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-136.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-136.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-137.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-137.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-138.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-138.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-139.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-139.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-140.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-140.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-141.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-141.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-142.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-142.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-143.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-143.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-144.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-144.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-145.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-145.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-146.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-146.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-147.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-147.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-148.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-148.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-149.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-149.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-150.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-150.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-151.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-151.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-152.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-152.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-153.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-153.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-154.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-154.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-156.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-156.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-155.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-155.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-157.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-157.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-158.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-158.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-159.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-159.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-160.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-160.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-161.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-161.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-162.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-162.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-163.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-163.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-164.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-164.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-165.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-165.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-166.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-166.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-167.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-167.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-168.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-168.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-169.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-169.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-170.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-170.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-171.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-171.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-172.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-172.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-173.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-173.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-174.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-174.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-175.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-175.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-176.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-176.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-177.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-177.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-178.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-178.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-179.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-179.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-180.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-180.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-181.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-181.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-182.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-182.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-183.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-183.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-184.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-184.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-185.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-185.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-186.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-186.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-187.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-187.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-188.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-188.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-190.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-190.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-191.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-191.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-189.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-189.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-193.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-193.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-192.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-192.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-194.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-194.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-195.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-195.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-196.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-196.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-197.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-197.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-198.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-198.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-199.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-199.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-200.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-200.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-201.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-201.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-202.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-202.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-203.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-203.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-204.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-204.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-205.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-205.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-206.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-206.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-207.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-207.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-208.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-208.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-209.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-209.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-210.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-210.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-211.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-211.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-212.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-212.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-213.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-213.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-214.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-214.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-215.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-215.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-216.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-216.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-217.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-217.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-218.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-218.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-219.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-219.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-220.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-220.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-221.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-221.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-222.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-222.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-223.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-223.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-224.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-224.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-225.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-225.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-226.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-226.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-227.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-227.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-228.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-228.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-229.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-229.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-230.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-230.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-231.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-231.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-232.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-232.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-233.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-233.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-234.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-234.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-235.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-235.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-236.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-236.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-237.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-237.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-238.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-238.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-240.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-240.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-239.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-239.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-241.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-241.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-242.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-242.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-243.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-243.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-244.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-244.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-245.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-245.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-246.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-246.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-247.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-247.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-248.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-248.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-249.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-249.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-250.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-250.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-252.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-252.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-251.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-251.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-253.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-253.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-255.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-255.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-254.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-254.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-256.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-256.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-258.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-258.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-257.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-257.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-259.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-259.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-260.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-260.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-261.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-261.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-262.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-262.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-263.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-263.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-264.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-264.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-265.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-265.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-266.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-266.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-267.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-267.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-268.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-268.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-269.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-269.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-270.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-270.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-271.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-271.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-272.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-272.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-273.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-273.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-274.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-274.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-275.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-275.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-276.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-276.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-277.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-277.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-278.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-278.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-279.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-279.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-280.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-280.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-281.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-281.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-282.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-282.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-283.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-283.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-285.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-285.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-284.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-284.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-286.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-286.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-287.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-287.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-288.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-288.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-289.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-289.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-290.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-290.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-291.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-291.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-292.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-292.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-293.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-293.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-294.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-294.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-295.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-295.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-296.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-296.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-297.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-297.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-298.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-298.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-299.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-299.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-300.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-300.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-301.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-301.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-302.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-302.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-303.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-303.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-304.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-304.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-305.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-305.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-306.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-306.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-307.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-307.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-308.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-308.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-309.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-309.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-310.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-310.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-311.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-311.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-312.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-312.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-313.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-313.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-314.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-314.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-315.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-315.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-316.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-316.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-317.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-317.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-318.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-318.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-319.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-319.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-320.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-320.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-321.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-321.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-322.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-322.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-323.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-323.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-324.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-324.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-325.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-325.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-326.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-326.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-327.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-327.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-329.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-329.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-328.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-328.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-330.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-330.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-331.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-331.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-332.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-332.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-333.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-333.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-334.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-334.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-335.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-335.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-336.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-336.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-337.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-337.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-338.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-338.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-339.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-339.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-340.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-340.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-341.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-341.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-342.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-342.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-343.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-343.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-344.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-344.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-345.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-345.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-346.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-346.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-347.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-347.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-348.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-348.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-349.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-349.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-350.jpg" title="2018-12-Catalogue-HOPPE-Purchasing-Information-2019-2020-CN-EN-350.jpg"/></p><p><br/></p>', 99, '2020-09-17 22:20:56'),
	(22, '中国项目产品手册', '/upload/info/photo/封面13.png', '<p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-1.jpg" title="2018-12-HOPPE-Project-brochure-CN-1.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-2.jpg" title="2018-12-HOPPE-Project-brochure-CN-2.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-4.jpg" title="2018-12-HOPPE-Project-brochure-CN-4.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-3.jpg" title="2018-12-HOPPE-Project-brochure-CN-3.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-5.jpg" title="2018-12-HOPPE-Project-brochure-CN-5.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-6.jpg" title="2018-12-HOPPE-Project-brochure-CN-6.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-7.jpg" title="2018-12-HOPPE-Project-brochure-CN-7.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-8.jpg" title="2018-12-HOPPE-Project-brochure-CN-8.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-9.jpg" title="2018-12-HOPPE-Project-brochure-CN-9.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-10.jpg" title="2018-12-HOPPE-Project-brochure-CN-10.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-11.jpg" title="2018-12-HOPPE-Project-brochure-CN-11.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-12.jpg" title="2018-12-HOPPE-Project-brochure-CN-12.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-13.jpg" title="2018-12-HOPPE-Project-brochure-CN-13.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-14.jpg" title="2018-12-HOPPE-Project-brochure-CN-14.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-15.jpg" title="2018-12-HOPPE-Project-brochure-CN-15.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-16.jpg" title="2018-12-HOPPE-Project-brochure-CN-16.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-17.jpg" title="2018-12-HOPPE-Project-brochure-CN-17.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-18.jpg" title="2018-12-HOPPE-Project-brochure-CN-18.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-19.jpg" title="2018-12-HOPPE-Project-brochure-CN-19.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-20.jpg" title="2018-12-HOPPE-Project-brochure-CN-20.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-21.jpg" title="2018-12-HOPPE-Project-brochure-CN-21.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-22.jpg" title="2018-12-HOPPE-Project-brochure-CN-22.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-23.jpg" title="2018-12-HOPPE-Project-brochure-CN-23.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-24.jpg" title="2018-12-HOPPE-Project-brochure-CN-24.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-25.jpg" title="2018-12-HOPPE-Project-brochure-CN-25.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-26.jpg" title="2018-12-HOPPE-Project-brochure-CN-26.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-28.jpg" title="2018-12-HOPPE-Project-brochure-CN-28.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-27.jpg" title="2018-12-HOPPE-Project-brochure-CN-27.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-29.jpg" title="2018-12-HOPPE-Project-brochure-CN-29.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-30.jpg" title="2018-12-HOPPE-Project-brochure-CN-30.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-31.jpg" title="2018-12-HOPPE-Project-brochure-CN-31.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-32.jpg" title="2018-12-HOPPE-Project-brochure-CN-32.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-33.jpg" title="2018-12-HOPPE-Project-brochure-CN-33.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-34.jpg" title="2018-12-HOPPE-Project-brochure-CN-34.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-35.jpg" title="2018-12-HOPPE-Project-brochure-CN-35.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-36.jpg" title="2018-12-HOPPE-Project-brochure-CN-36.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-37.jpg" title="2018-12-HOPPE-Project-brochure-CN-37.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-38.jpg" title="2018-12-HOPPE-Project-brochure-CN-38.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-39.jpg" title="2018-12-HOPPE-Project-brochure-CN-39.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-40.jpg" title="2018-12-HOPPE-Project-brochure-CN-40.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-41.jpg" title="2018-12-HOPPE-Project-brochure-CN-41.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-42.jpg" title="2018-12-HOPPE-Project-brochure-CN-42.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-43.jpg" title="2018-12-HOPPE-Project-brochure-CN-43.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-44.jpg" title="2018-12-HOPPE-Project-brochure-CN-44.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-45.jpg" title="2018-12-HOPPE-Project-brochure-CN-45.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-46.jpg" title="2018-12-HOPPE-Project-brochure-CN-46.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-47.jpg" title="2018-12-HOPPE-Project-brochure-CN-47.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-48.jpg" title="2018-12-HOPPE-Project-brochure-CN-48.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-49.jpg" title="2018-12-HOPPE-Project-brochure-CN-49.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-50.jpg" title="2018-12-HOPPE-Project-brochure-CN-50.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-51.jpg" title="2018-12-HOPPE-Project-brochure-CN-51.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-52.jpg" title="2018-12-HOPPE-Project-brochure-CN-52.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-53.jpg" title="2018-12-HOPPE-Project-brochure-CN-53.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-54.jpg" title="2018-12-HOPPE-Project-brochure-CN-54.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-55.jpg" title="2018-12-HOPPE-Project-brochure-CN-55.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-56.jpg" title="2018-12-HOPPE-Project-brochure-CN-56.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-57.jpg" title="2018-12-HOPPE-Project-brochure-CN-57.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-58.jpg" title="2018-12-HOPPE-Project-brochure-CN-58.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-59.jpg" title="2018-12-HOPPE-Project-brochure-CN-59.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-60.jpg" title="2018-12-HOPPE-Project-brochure-CN-60.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-61.jpg" title="2018-12-HOPPE-Project-brochure-CN-61.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-62.jpg" title="2018-12-HOPPE-Project-brochure-CN-62.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-64.jpg" title="2018-12-HOPPE-Project-brochure-CN-64.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-63.jpg" title="2018-12-HOPPE-Project-brochure-CN-63.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-65.jpg" title="2018-12-HOPPE-Project-brochure-CN-65.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-66.jpg" title="2018-12-HOPPE-Project-brochure-CN-66.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-67.jpg" title="2018-12-HOPPE-Project-brochure-CN-67.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-68.jpg" title="2018-12-HOPPE-Project-brochure-CN-68.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-69.jpg" title="2018-12-HOPPE-Project-brochure-CN-69.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-70.jpg" title="2018-12-HOPPE-Project-brochure-CN-70.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-72.jpg" title="2018-12-HOPPE-Project-brochure-CN-72.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-73.jpg" title="2018-12-HOPPE-Project-brochure-CN-73.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-71.jpg" title="2018-12-HOPPE-Project-brochure-CN-71.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-74.jpg" title="2018-12-HOPPE-Project-brochure-CN-74.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-76.jpg" title="2018-12-HOPPE-Project-brochure-CN-76.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-77.jpg" title="2018-12-HOPPE-Project-brochure-CN-77.jpg"/></p><p><img src="http://hoppe.jzdsh.com/upload/ue/img/2018-12-HOPPE-Project-brochure-CN-75.jpg" title="2018-12-HOPPE-Project-brochure-CN-75.jpg"/></p><p><br/></p>', 97, '2020-09-17 22:22:02'),
	(23, 'HOPPE安装/使用说明书', '/upload/info/photo/1.jpg', '<p><br/></p><p><br/></p><p><br/></p><p><br/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/11.png" title="11.png" alt="1.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/21.png" title="21.png" alt="2.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/31.png" title="31.png" alt="3.png"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/QQ20201027-080628@2x1.png" title="QQ20201027-080628@2x1.png" alt="QQ20201027-080628@2x.png"/></p><p></p><p></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(5)1.jpg" title="1(5)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(6)1.jpg" title="1(6)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(9)1.jpg" title="1(9)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(7)1.jpg" title="1(7)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(8)1.jpg" title="1(8)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(11)1.jpg" title="1(11)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(10)1.jpg" title="1(10)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(13)1.jpg" title="1(13)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(12)1.jpg" title="1(12)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(14)1.jpg" title="1(14)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(16)1.jpg" title="1(16)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(17)1.jpg" title="1(17)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(18)1.jpg" title="1(18)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(15)1.jpg" title="1(15)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(19)1.jpg" title="1(19)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(22)1.jpg" title="1(22)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(23)1.jpg" title="1(23)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(20)1.jpg" title="1(20)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(24)1.jpg" title="1(24)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(21)1.jpg" title="1(21)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(27)1.jpg" title="1(27)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(28)1.jpg" title="1(28)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(26)1.jpg" title="1(26)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(25)1.jpg" title="1(25)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(29)1.jpg" title="1(29)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(32)1.jpg" title="1(32)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(33)1.jpg" title="1(33)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(30)1.jpg" title="1(30)1.jpg"/></p><p><img src="https://hoppe.jzdsh.com/upload/ue/img/1(31)1.jpg" title="1(31)1.jpg"/></p><p><br/></p>', 100, '2020-10-23 11:13:27');
/*!40000 ALTER TABLE `photo` ENABLE KEYS */;

-- 导出  表 hoppe.photos 结构
CREATE TABLE IF NOT EXISTS `photos` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '应用场景ID',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `img` varchar(255) DEFAULT NULL COMMENT '场景图  url',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `type` int(11) DEFAULT NULL COMMENT '1 应用场景 2门窗材质',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8mb4 COMMENT='1 应用场景 2门窗材质 ';

-- 正在导出表  hoppe.photos 的数据：~26 rows (大约)
/*!40000 ALTER TABLE `photos` DISABLE KEYS */;
REPLACE INTO `photos` (`id`, `title`, `img`, `sort`, `type`, `create_time`) VALUES
	(5, '沉静雾灰', '/upload/appscene/photos/13.jpg', 39, 2, '2020-07-11 12:45:50'),
	(6, '经典灰橡木', '/upload/appscene/photos/2.jpg', 47, 2, '2020-07-11 12:45:59'),
	(7, '天然尤加利', '/upload/appscene/photos/3.jpg', 40, 2, '2020-07-11 12:45:59'),
	(9, '天然胡桃木', '/upload/appscene/photos/51.jpg', 48, 2, '2020-07-11 12:45:59'),
	(10, '极简白桦木', '/upload/appscene/photos/6.jpg', 47, 2, '2020-07-11 12:45:59'),
	(11, '灰调胡桃木', '/upload/appscene/photos/7.jpg', 49, 2, '2020-07-11 12:45:59'),
	(12, '浅麻红豆杉', '/upload/appscene/photos/8.jpg', 42, 2, '2020-07-11 12:45:59'),
	(13, '天然柚木', '/upload/appscene/photos/9.jpg', 47, 2, '2020-07-11 12:45:59'),
	(14, '山陵枫木', '/upload/appscene/photos/10.jpg', 47, 2, '2020-07-11 12:45:59'),
	(15, '正黑胡桃木', '/upload/appscene/photos/showcolor.jpg', 50, 2, '2020-07-11 12:45:59'),
	(16, '哑光石墨黑', '/upload/appscene/photos/11.jpg', 40, 2, '2020-07-11 12:45:59'),
	(18, '典雅休息区', '/upload/appscene/photos/52.jpg', 92, 1, '2020-07-20 17:43:36'),
	(19, '居家楼梯角', '/upload/appscene/photos/4.jpg', 93, 1, '2020-07-20 17:43:43'),
	(21, '入户玄关间', '/upload/appscene/photos/31.jpg', 94, 1, '2020-07-20 17:44:08'),
	(22, '原木楼梯角', '/upload/appscene/photos/21.jpg', 95, 1, '2020-07-20 17:44:18'),
	(23, '办公司场景', '/upload/appscene/photos/151.jpg', 96, 1, '2020-07-20 17:44:27'),
	(24, '极简楼梯角', '/upload/appscene/photos/19.jpg', 97, 1, '2020-07-20 17:44:34'),
	(25, '暖调待客区', '/upload/appscene/photos/181.jpg', 98, 1, '2020-07-20 17:59:47'),
	(26, '极简风客厅', '/upload/appscene/photos/191.jpg', 99, 1, '2020-07-20 17:59:53'),
	(29, '浅灰樱桃木', '/upload/appscene/photos/1.jpg', 47, 2, '2020-08-03 12:41:40'),
	(30, '典雅铂灰', '/upload/appscene/photos/14.jpg', 41, 2, '2020-08-03 12:43:52'),
	(31, '温馨客厅角', '/upload/appscene/photos/201.jpg', 100, 1, '2020-08-13 10:27:41'),
	(32, '欧式餐厅区', '/upload/appscene/photos/61.jpg', 91, 1, '2020-08-13 10:32:16'),
	(33, '简约风过道', '/upload/appscene/photos/71.jpg', 90, 1, '2020-08-13 10:32:29'),
	(34, '室外花草园', '/upload/appscene/photos/91.jpg', 89, 1, '2020-08-13 10:32:43'),
	(35, '原木卫生间', '/upload/appscene/photos/101.jpg', 88, 1, '2020-08-13 10:32:55');
/*!40000 ALTER TABLE `photos` ENABLE KEYS */;

-- 导出  表 hoppe.product 结构
CREATE TABLE IF NOT EXISTS `product` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品ID',
  `p_title` int(11) DEFAULT NULL COMMENT '款式 id',
  `model` varchar(255) DEFAULT NULL COMMENT '型号',
  `cover_img` varchar(255) DEFAULT NULL COMMENT '封面图',
  `watermark_img` varchar(255) DEFAULT NULL COMMENT '水印图',
  `colors` varchar(255) DEFAULT NULL COMMENT '产品分类 图，标题',
  `axial` varchar(255) DEFAULT NULL COMMENT '轴长   图，标题',
  `p_type` int(11) DEFAULT NULL COMMENT '产品类型 单选',
  `p_keyhole` int(11) DEFAULT NULL COMMENT '锁孔',
  `p_color` int(11) DEFAULT NULL COMMENT '产品颜色 多选',
  `p_material` int(11) DEFAULT NULL COMMENT '产品材质',
  `p_style` int(11) DEFAULT NULL COMMENT '产品风格系列 单选',
  `p_patent` varchar(255) DEFAULT NULL COMMENT '产品专利技术 单选',
  `p_attr` varchar(255) DEFAULT NULL COMMENT '产品属性  多选',
  `content` mediumtext COMMENT '产品介绍 富文本',
  `door_thickness` varchar(50) DEFAULT NULL COMMENT '门的厚度',
  `axial_length` varchar(50) DEFAULT NULL COMMENT '轴长',
  `axial_size` varchar(50) DEFAULT NULL COMMENT '轴尺寸（窗把手）',
  `img_sample` varchar(255) DEFAULT NULL COMMENT '示例图',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `subsort` int(11) DEFAULT NULL COMMENT '子排序  同一个model 下面的排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modified_time` datetime DEFAULT NULL COMMENT '修改时间',
  `is_recommend` int(11) DEFAULT NULL COMMENT '是否推荐 0 否 1推荐 在首页显示',
  `is_app` int(11) DEFAULT '0' COMMENT '是否应用体验 0否1推荐',
  `img_knob` varchar(255) DEFAULT NULL COMMENT '3d 图片 门把手',
  `version_info` varchar(255) DEFAULT NULL COMMENT '版本信息',
  `p_code` varchar(255) DEFAULT NULL COMMENT '产品编号',
  `door_type` varchar(255) DEFAULT NULL COMMENT '门类型  hcs 用到  页面不显',
  `into_pieces` varchar(255) DEFAULT NULL COMMENT '撞片 默认：不含    hcs 用到 页面不显示',
  `hcs_config` varchar(255) DEFAULT NULL COMMENT 'hcs 配置',
  `pym_config` varchar(255) DEFAULT NULL COMMENT '平移门配置',
  `unit` varchar(255) DEFAULT NULL COMMENT '单位 （大拉手）',
  `fixed_distance` varchar(255) DEFAULT NULL COMMENT '安装距离（大拉手） 210-250',
  `center_distance` varchar(255) DEFAULT NULL COMMENT '中心距 (阳台门提升、锁体) ',
  `pedestal` varchar(255) DEFAULT NULL COMMENT '底座（窗把手）',
  `door_weight` varchar(255) DEFAULT NULL COMMENT '门重',
  `certification` varchar(255) DEFAULT NULL COMMENT '测试认证',
  `door_margin` varchar(255) DEFAULT NULL COMMENT '门边距(锁体)',
  `panel_size` varchar(255) DEFAULT NULL COMMENT '面板体积(锁体) SQ 直角  RD圆角',
  `measure` varchar(255) DEFAULT NULL COMMENT '尺寸(锁芯)',
  `opening_way` varchar(255) DEFAULT NULL COMMENT '开启方式(锁芯)',
  `volume_keys` varchar(255) DEFAULT NULL COMMENT '钥匙数量(锁芯)',
  `install_method` varchar(255) DEFAULT NULL COMMENT '安装方法   嵌入,用黏贴祸硅胶固定',
  `explain` mediumtext COMMENT '产品说明',
  `direction` varchar(255) DEFAULT NULL COMMENT '开启方向',
  `desc` varchar(50) DEFAULT NULL COMMENT '描述    废弃',
  `color_name` varchar(255) DEFAULT NULL COMMENT '颜色名称 (弃用)',
  `img_keyhole` varchar(255) DEFAULT NULL COMMENT '锁孔 (弃用)',
  `img` varchar(255) DEFAULT NULL COMMENT '图 (弃用)',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=842 DEFAULT CHARSET=utf8mb4 COMMENT='产品信息表';

-- 正在导出表  hoppe.product 的数据：~793 rows (大约)
/*!40000 ALTER TABLE `product` DISABLE KEYS */;
REPLACE INTO `product` (`id`, `p_title`, `model`, `cover_img`, `watermark_img`, `colors`, `axial`, `p_type`, `p_keyhole`, `p_color`, `p_material`, `p_style`, `p_patent`, `p_attr`, `content`, `door_thickness`, `axial_length`, `axial_size`, `img_sample`, `sort`, `subsort`, `create_time`, `modified_time`, `is_recommend`, `is_app`, `img_knob`, `version_info`, `p_code`, `door_type`, `into_pieces`, `hcs_config`, `pym_config`, `unit`, `fixed_distance`, `center_distance`, `pedestal`, `door_weight`, `certification`, `door_margin`, `panel_size`, `measure`, `opening_way`, `volume_keys`, `install_method`, `explain`, `direction`, `desc`, `color_name`, `img_keyhole`, `img`) VALUES
	(1, 8, 'M476/15', '/upload/cover_img/M476-15-F77-R.jpg', '/upload/product/watermark/1607059842381418925.jpg', NULL, NULL, 5, NULL, 27, 1, 3, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M476-15.jpg', 940, NULL, '2020-09-09 17:48:07', '2020-09-21 12:59:44', 0, 0, NULL, '', '1877322', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/cover_img/M476-15-F77-R.jpg'),
	(2, 9, 'M516', '/upload/product/product/M516-F49-F69.jpg', '/upload/product/watermark/1610439842126816970.jpg', NULL, NULL, 5, NULL, 62, 1, 3, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M5161.jpg', 980, NULL, '2020-09-09 17:48:08', '2020-09-21 12:51:26', 0, 0, NULL, '', '1894384', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/product/product/M516-F49-F691.jpg'),
	(3, 9, 'M517', '/upload/product/product/M517-F49-F69.jpg', '/upload/product/watermark/1605971726780204836.jpg', NULL, NULL, 5, NULL, 62, 1, 3, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M5171.jpg', 970, NULL, '2020-09-09 17:48:08', '2020-09-21 12:51:49', 0, 0, NULL, '', '1894675', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/product/product/M517-F49-F691.jpg'),
	(4, 47, 'SB8113', '/upload/product/product/pp1.jpg', '/upload/product/watermark/1610541730095159627.jpg', NULL, NULL, 12, 3, 4, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/gctuu.jpg', 785, NULL, '2020-09-09 17:48:08', '2020-09-29 11:47:03', 0, 0, NULL, '', '2000231', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F41 镀铬拉丝', '', '/upload/product/product/pp11.jpg'),
	(5, 47, 'SB8113', '/upload/product/product/p1.jpg', '/upload/product/watermark/1613801303602404417.jpg', NULL, NULL, 12, 1, 9, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/gctuu1.jpg', 785, NULL, '2020-09-09 17:48:08', '2020-09-29 11:47:26', 0, 0, NULL, '', '2414063', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, '', '', '/upload/product/product/p11.jpg'),
	(6, 47, 'HAKENSCHLOSS', '/upload/product/product/ppp1.jpg', '/upload/product/watermark/1614945891534768112.jpg', NULL, NULL, 12, 3, 76, 1, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/gctu.jpg', 786, NULL, '2020-09-09 17:48:08', '2020-10-13 11:48:28', 0, 0, NULL, '', '2415517', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, '50', NULL, NULL, NULL, NULL, '明装，多用螺丝', NULL, NULL, NULL, '', '', '/upload/product/product/ppp11.jpg'),
	(7, 47, 'HAKENSCHLOSS', '/upload/product/product/gctuuu.jpg', '/upload/product/watermark/1614945892344642635.jpg', NULL, NULL, 12, 3, 77, 1, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/gctu1.jpg', 786, NULL, '2020-09-09 17:48:08', '2020-10-13 11:48:35', 0, 0, NULL, '', '2415525', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, '50', NULL, NULL, NULL, NULL, '明装，多用螺丝', NULL, NULL, NULL, 'F41 镀铬拉丝', '', '/upload/product/product/gctuuu1.jpg'),
	(8, 12, 'M515LG', '/upload/product/product/M515LG-F73.jpg', '/upload/product/watermark/1610439843995992461.jpg', NULL, NULL, 5, NULL, 25, 1, 1, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M515LG.jpg', 930, NULL, '2020-09-09 17:48:08', '2020-09-21 13:01:41', 0, 0, NULL, '', '2417150', NULL, NULL, NULL, NULL, '一支', '210mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F73 古铜色', '', '/upload/product/product/M515LG-F731.jpg'),
	(9, 12, 'M515LG', '/upload/product/product/M515LG-F41-R.jpg', '/upload/product/watermark/1605795945957271219.jpg', NULL, NULL, 5, NULL, 18, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M515LG1.jpg', 930, NULL, '2020-09-09 17:48:08', '2020-09-21 13:02:01', 0, 0, NULL, '', '2417176', NULL, NULL, NULL, NULL, '一支', '210mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M515LG-F41-R1.jpg'),
	(10, 8, 'M172/15K-2/15KS-2', '/upload/product/product/M172-15K-2-15KS-2-PZ-F54.jpg', '/upload/product/watermark/1614049710166996993.jpg', NULL, NULL, 1, 1, 52, 1, 1, NULL, '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '30-66', NULL, '8', '/upload/product/product/DRW-CAT-M172-15K-2-15KS-2-PZ-SALL-AOF-V12.jpg', 836, NULL, '2020-09-09 17:48:08', '2020-09-11 15:27:44', 0, 0, NULL, '', '2451956', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F54 复古黄铜色', '/assets/img/icon_sk.png', '/upload/product/product/M172-15K-2-15KS-2-PZ-F541.jpg'),
	(11, 8, 'M172/15K-2/15KS-2', '/upload/product/product/M172-15K-2-15KS-2-PZ-F55.jpg', '/upload/product/watermark/1614049709225935768.jpg', NULL, NULL, 1, 1, 53, 1, 1, '', '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '30-66', NULL, '8', '/upload/product/product/DRW-CAT-M172-15K-2-15KS-2-PZ-SALL-AOF-V14.jpg', 836, NULL, '2020-09-09 17:48:08', '2020-09-11 15:28:09', 0, 0, NULL, '', '2451972', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F55 复古铜色', '/assets/img/icon_sk.png', '/upload/product/product/M172-15K-2-15KS-2-PZ-F551.jpg'),
	(12, 8, 'M172/15K-2/15KS-2', '/upload/product/product/M172-15K-2-15KS-2-PZ-F56.jpg', '/upload/product/watermark/1616377576187910768.jpg', NULL, NULL, 1, 1, 54, 1, 1, '', '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '30-66', NULL, '8', '/upload/product/product/DRW-CAT-M172-15K-2-15KS-2-PZ-SALL-AOF-V1.jpg', 836, 1, '2020-09-09 17:48:09', '2020-09-11 15:35:51', 0, 0, NULL, '', '2451981', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F56 复古青铜', '/assets/img/icon_sk.png', '/upload/product/product/M172-15K-2-15KS-2-PZ-F561.jpg'),
	(13, 8, 'M172/15K-2/15KS-2', '/upload/product/product/M172-15K-2-15KS-2-PZ-F76.jpg', '/upload/product/watermark/1604463844058500300.jpg', NULL, NULL, 1, 1, 55, 1, 1, '', '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '30-66', NULL, '8', '/upload/product/product/DRW-CAT-M172-15K-2-15KS-2-PZ-SALL-AOF-V11.jpg', 836, NULL, '2020-09-09 17:48:09', '2020-09-11 15:27:36', 0, 0, NULL, '', '2451999', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F76 深红古铜', '/assets/img/icon_sk.png', '/upload/product/product/M172-15K-2-15KS-2-PZ-F761.jpg'),
	(15, 8, 'M476/15', '/upload/cover_img/M476-15-F55.jpg', '/upload/product/watermark/1610439835177870498.jpg', NULL, NULL, 5, NULL, 53, 1, 3, '', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M476-15.jpg', 940, NULL, '2020-09-09 17:48:09', '2020-09-21 12:59:29', 0, 0, NULL, '', '2455965', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F55 复古铜色', '', '/upload/cover_img/M476-15-F55.jpg'),
	(16, 8, 'M476/15', '/upload/cover_img/M476-15-F56.jpg', '/upload/product/watermark/1605795934317660483.jpg', NULL, NULL, 5, NULL, 54, 1, 3, '', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M476-15.jpg', 940, NULL, '2020-09-09 17:48:10', '2020-09-21 12:58:40', 0, 0, NULL, '', '2455973', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F56 复古青铜', '', '/upload/cover_img/M476-15-F56.jpg'),
	(18, 8, 'M072/7', '/upload/cover_img/M072-7-F54.jpg', '/upload/product/watermark/1616812637903367821.jpg', NULL, NULL, 7, NULL, 52, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '35', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:11', '2020-10-13 11:56:22', 0, 0, NULL, '', '2456669', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F54 复古黄铜色', '', '/upload/cover_img/M072-7-F54.jpg'),
	(19, 8, 'M072/7', '/upload/cover_img/M072-7-F55.jpg', '/upload/product/watermark/1616812624736748511.jpg', NULL, NULL, 7, NULL, 53, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '35', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:11', '2020-10-13 11:56:29', 0, 0, NULL, '', '2456677', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F55 复古铜色', '', '/upload/cover_img/M072-7-F55.jpg'),
	(20, 8, 'M072/7', '/upload/cover_img/M072-7-F56.jpg', '/upload/product/watermark/1616812628424323320.jpg', NULL, NULL, 7, NULL, 54, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '35', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:12', '2020-10-13 11:55:29', 0, 0, NULL, '', '2456685', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F56 复古青铜', '', '/upload/cover_img/M072-7-F56.jpg'),
	(22, 8, 'M072/7', '/upload/cover_img/M072-7-F54.jpg', '/upload/product/watermark/1604479132314020810.jpg', NULL, NULL, 7, NULL, 52, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '45', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:12', '2020-10-13 11:55:49', 0, 0, NULL, '', '2456706', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F54 复古黄铜色', '', '/upload/cover_img/M072-7-F54.jpg'),
	(23, 8, 'M072/7', '/upload/cover_img/M072-7-F55.jpg', '/upload/product/watermark/1611985891819054808.jpg', NULL, NULL, 7, NULL, 53, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '45', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:12', '2020-10-13 11:55:57', 0, 0, NULL, '', '2456714', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F55 复古铜色', '', '/upload/cover_img/M072-7-F55.jpg'),
	(24, 8, 'M072/7', '/upload/cover_img/M072-7-F56.jpg', '/upload/product/watermark/1603975173938486771.jpg', NULL, NULL, 7, NULL, 54, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '45', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:12', '2020-10-13 11:56:06', 0, 0, NULL, '', '2456722', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F56 复古青铜', '', '/upload/cover_img/M072-7-F56.jpg'),
	(25, 8, 'M072/7', '/upload/cover_img/M072-7-F76.jpg', '/upload/product/watermark/1607650946081384713.jpg', NULL, NULL, 7, NULL, 55, 1, 3, '', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '45', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:12', '2020-10-13 11:56:14', 0, 0, NULL, '', '2456731', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F76 深红古铜', '', '/upload/cover_img/M072-7-F76.jpg'),
	(26, 47, 'M429', '/upload/product/product/M429-blind-F541.jpg', '/upload/product/watermark/1611749762738724007.jpg', NULL, NULL, 12, NULL, 52, 1, 1, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M429-blind2.jpg', 801, NULL, '2020-09-09 17:48:12', '2020-09-25 18:53:53', 0, 0, NULL, '光面(不开孔)', '2465098', NULL, NULL, NULL, '5 空', NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F54 复古黄铜色', '', '/upload/product/product/M429-blind-F542.jpg'),
	(27, 47, 'M429', '/upload/product/product/M429-blind-F55.jpg', '/upload/product/watermark/1610545452646660977.jpg', NULL, NULL, 12, NULL, 53, 1, 1, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M429-blind3.jpg', 801, NULL, '2020-09-09 17:48:12', '2020-09-25 18:54:06', 0, 0, NULL, '光面(不开孔)', '2465101', NULL, NULL, NULL, '5 空', NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F55 复古铜色', '', '/upload/product/product/M429-blind-F551.jpg'),
	(28, 47, 'M429', '/upload/product/product/M429-blind-F56.jpg', '/upload/product/watermark/1610545438641660073.jpg', NULL, NULL, 12, NULL, 54, 1, 1, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M429-blind.jpg', 801, NULL, '2020-09-09 17:48:13', '2020-09-21 11:00:51', 0, 0, NULL, '光面(不开孔)', '2465119', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F56 复古青铜', '', '/upload/product/product/M429-blind-F561.jpg'),
	(29, 47, 'M429', '/upload/product/product/M429-blind-F76.jpg', '/upload/product/watermark/1616145702563061681.jpg', NULL, NULL, 12, NULL, 55, 1, 1, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M429-blind1.jpg', 801, NULL, '2020-09-09 17:48:13', '2020-09-25 18:52:15', 0, 0, NULL, '光面(不开孔)', '2465127', NULL, NULL, NULL, '5 空', NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F76 深红古铜', '', '/upload/product/product/M429-blind-F761.jpg'),
	(30, 47, 'M429', '/upload/product/product/M429-OB-F54.jpg', '/upload/product/watermark/1603183998401272271.jpg', NULL, NULL, 12, 2, 52, 1, 1, '', '5', NULL, NULL, '8', NULL, '/upload/product/product/M429-OB.jpg', 801, NULL, '2020-09-09 17:48:13', '2020-09-21 11:01:20', 0, 0, NULL, '光面(不开孔)', '2465194', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F54 复古黄铜色', '/upload/product/product/konb-ob2.png', '/upload/product/product/M429-OB-F541.jpg'),
	(31, 47, 'M429', '/upload/product/product/M429-OB-F55.jpg', '/upload/product/watermark/1610352268373622191.jpg', NULL, NULL, 12, 2, 53, 1, 1, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M429-OB1.jpg', 801, NULL, '2020-09-09 17:48:13', '2020-09-21 11:01:26', 0, 0, NULL, '光面(不开孔)', '2465207', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝', NULL, NULL, NULL, 'F55 复古铜色', '/upload/product/product/konb-ob3.png', '/upload/product/product/M429-OB-F551.jpg'),
	(33, 13, 'HCS® A1530', '/upload/product/product/HCS-A1530-F1-2.jpg', '/upload/product/watermark/1612128348959609053.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1530-mit-Bohrung-TD35-43.jpg', 816, NULL, '2020-09-09 17:48:13', '2020-09-21 10:54:27', 0, 0, NULL, '', '2475907', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1530-F1-21.jpg'),
	(36, 15, 'HCS® A1880', '/upload/product/product/HCS-A1880-F1-2-F9-2.jpg', '/upload/product/watermark/1616377542354517044.jpg', NULL, NULL, 4, NULL, 44, 3, 3, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1880-TD35-43.jpg', 0, NULL, '2020-09-09 17:48:14', '2020-09-21 10:57:33', 0, 0, NULL, '', '2537119', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1880-F1-2-F9-21.jpg'),
	(37, 15, 'HCS® A1880', '/upload/product/product/HCS-A1880-SK-OL-F1-2-F9-2.jpg', '/upload/product/watermark/1611129131563276033.jpg', NULL, NULL, 4, NULL, 44, 3, 3, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1880-SK-OL-TD35-43.jpg', 0, NULL, '2020-09-09 17:48:14', '2020-09-21 10:57:40', 0, 0, NULL, '', '2537160', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1880-SK-OL-F1-2-F9-21.jpg'),
	(38, 16, 'HCS® A1885', '/upload/product/product/HCS-A1885-F1-2.jpg', '/upload/product/watermark/1616377718704800898.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1885-TD35-43.jpg', 814, NULL, '2020-09-09 17:48:14', '2020-09-21 10:54:47', 0, 0, NULL, '', '2546947', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1885-F1-21.jpg'),
	(39, 16, 'HCS® A1885', '/upload/product/product/HCS-A1885-SK-OL-F1-2.jpg', '/upload/product/watermark/1615954365269914163.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1885-SK-OL-TD35-43.jpg', 814, NULL, '2020-09-09 17:48:14', '2020-09-21 10:54:56', 0, 0, NULL, '', '2547085', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1885-SK-OL-F1-21.jpg'),
	(40, 9, 'HCS® M156S', '/upload/product/product/HCS-M156S-F49-F692.jpg', '/upload/product/watermark/1616377691220211707.jpg', NULL, NULL, 4, NULL, 62, 1, 3, '5', '5', '', '35-43', NULL, NULL, '/upload/product/product/HCS-M156S-TD35-431.jpg', 818, NULL, '2020-09-09 17:48:14', '2020-09-21 10:48:46', 0, 0, NULL, '', '2571042', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/product/product/HCS-M156S-F49-F693.jpg'),
	(41, 9, 'HCS® M156S', '/upload/product/product/HCS-M156S-SK-OL-F49-F69.jpg', '/upload/product/watermark/1609923934268783853.jpg', NULL, NULL, 4, NULL, 62, 1, 3, '5', '5', '', '35-43', NULL, NULL, '/upload/product/product/HCS-M156S-SK-OL-TD35-43.jpg', 818, NULL, '2020-09-09 17:48:14', '2020-09-21 10:49:06', 0, 0, NULL, '', '2571051', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/product/product/HCS-M156S-SK-OL-F49-F691.jpg'),
	(42, 17, 'HCS® A138S', '/upload/product/product/HCS-A138S-F1-2.jpg', '/upload/product/watermark/1615954289655445033.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A138S-TD35-43.jpg', 812, NULL, '2020-09-09 17:48:14', '2020-09-21 10:56:16', 0, 0, NULL, '', '2571940', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A138S-F1-21.jpg'),
	(43, 17, 'HCS® A138S', '/upload/product/product/HCS-A138S-SK-OL-F1-22.jpg', '/upload/product/watermark/1615954293843931877.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A138S-SK-OL-TD35-431.jpg', 812, NULL, '2020-09-09 17:48:15', '2020-09-21 10:55:47', 0, 0, NULL, '', '2572002', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A138S-SK-OL-F1-23.jpg'),
	(44, 17, 'HCS® A138S', '/upload/product/product/HCS-A138S-15-OL-F1-2.jpg', '/upload/product/watermark/1610698524600461999.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A138S-15-OL-TD35-43.jpg', 812, NULL, '2020-09-09 17:48:15', '2020-09-21 10:55:53', 0, 0, NULL, '', '2572011', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A138S-15-OL-F1-21.jpg'),
	(45, 18, 'HCS® A197S', '/upload/product/product/HCS-A197S-F9-2.jpg', '/upload/product/watermark/1616651823289777276.jpg', NULL, NULL, 4, NULL, 45, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A197S-mit-Bohrung-TD35-43.jpg', 820, NULL, '2020-09-09 17:48:15', '2020-09-21 10:46:37', 0, 0, NULL, '', '2572264', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '通过锁舌护管及装饰圈固定', NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/product/product/HCS-A197S-F9-21.jpg'),
	(46, 18, 'HCS® A197S', '/upload/product/product/HCS-A197S-SK-OL-F1-2.jpg', '/upload/product/watermark/1616651822657767365.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A197S-SK-OL-TD35-43.jpg', 820, NULL, '2020-09-09 17:48:15', '2020-09-21 10:46:46', 0, 0, NULL, '', '2572336', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '通过锁舌护管及装饰圈固定', NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A197S-SK-OL-F1-21.jpg'),
	(47, 18, 'HCS® A197S', '/upload/product/product/HCS-A197S-15-OL-F1-2.jpg', '/upload/product/watermark/1615954709745585460.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A197S-15-OL-TD35-43.jpg', 820, NULL, '2020-09-09 17:48:15', '2020-09-21 10:46:57', 0, 0, NULL, '', '2572344', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '通过锁舌护管及装饰圈固定', NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A197S-15-OL-F1-21.jpg'),
	(48, 18, 'HCS® A197S', '/upload/product/product/HCS-A197S-SK-OL-F9-2.jpg', '/upload/product/watermark/1616651732288867845.jpg', NULL, NULL, 4, NULL, 45, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A197S-SK-OL-TD35-431.jpg', 820, NULL, '2020-09-09 17:48:15', '2020-09-21 10:47:04', 0, 0, NULL, '', '2572395', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '通过锁舌护管及装饰圈固定', NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/product/product/HCS-A197S-SK-OL-F9-21.jpg'),
	(49, 18, 'HCS® A197S', '/upload/product/product/HCS-A197S-15-OL-F9-2.jpg', '/upload/product/watermark/1615955031159910669.jpg', NULL, NULL, 4, NULL, 45, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A197S-15-OL-TD35-431.jpg', 820, NULL, '2020-09-09 17:48:15', '2020-09-21 10:48:22', 0, 0, NULL, '', '2572408', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '通过锁舌护管及装饰圈固定', NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/product/product/HCS-A197S-15-OL-F9-21.jpg'),
	(50, 19, 'HCS® A113', '/upload/product/product/HCS-A113-F1-2.jpg', '/upload/product/watermark/1615955072072286469.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A113-TD35-43.jpg', 813, NULL, '2020-09-09 17:48:15', '2020-09-21 10:55:11', 0, 0, NULL, '', '2572563', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A113-F1-21.jpg'),
	(51, 19, 'HCS® A113', '/upload/product/product/HCS-A113-SK-OL-F1-2.jpg', '/upload/product/watermark/1615955679877167012.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A113-SK-OL-TD35-43.jpg', 813, NULL, '2020-09-09 17:48:15', '2020-09-21 10:55:19', 0, 0, NULL, '', '2572660', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A113-SK-OL-F1-21.jpg'),
	(52, 19, 'HCS® A113', '/upload/product/product/HCS-A113-15-OL-F1-2.jpg', '/upload/product/watermark/1607391374760890052.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A113-15-OL-TD35-43.jpg', 813, NULL, '2020-09-09 17:48:15', '2020-09-21 10:55:27', 0, 0, NULL, '', '2572723', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A113-15-OL-F1-21.jpg'),
	(53, 19, 'HCS® A113', '/upload/product/product/HCS-A113-15-OL-F9-2.jpg', '/upload/product/watermark/1611107731986308131.jpg', NULL, NULL, 4, NULL, 45, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A113-15-OL-TD35-431.jpg', 813, NULL, '2020-09-09 17:48:15', '2020-09-21 10:55:36', 0, 0, NULL, '', '2572766', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/product/product/HCS-A113-15-OL-F9-21.jpg'),
	(55, 13, 'HCS® A1530', '/upload/product/product/HCS-A1530-SK-OL-F1-2.jpg', '/upload/product/watermark/1616377705446896310.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1530-SK-OL-TD35-43.jpg', 816, NULL, '2020-09-09 17:48:16', '2020-09-21 10:53:33', 0, 0, NULL, '', '2573179', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1530-SK-OL-F1-21.jpg'),
	(56, 13, 'HCS® A1530', '/upload/product/product/HCS-A1530-SK-OL-F9-2.jpg', '/upload/product/watermark/1609923943016071018.jpg', NULL, NULL, 4, NULL, 45, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1530-SK-OL-TD35-431.jpg', 816, NULL, '2020-09-09 17:48:16', '2020-09-21 10:54:02', 0, 0, NULL, '', '2573216', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/product/product/HCS-A1530-SK-OL-F9-21.jpg'),
	(57, 13, 'HCS® A1530', '/upload/product/product/HCS-A1530-15-OL-F1-2.jpg', '/upload/product/watermark/1608576007487496130.jpg', NULL, NULL, 4, NULL, 44, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1530-15-OL-TD35-43.jpg', 816, NULL, '2020-09-09 17:48:16', '2020-09-21 10:54:11', 0, 0, NULL, '', '2573232', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/product/product/HCS-A1530-15-OL-F1-21.jpg'),
	(58, 13, 'HCS® A1530', '/upload/product/product/HCS-A1530-15-OL-F9-2.jpg', '/upload/product/watermark/1613799944884095001.jpg', NULL, NULL, 4, NULL, 45, 3, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-A1530-15-OL-TD35-431.jpg', 816, NULL, '2020-09-09 17:48:16', '2020-09-21 10:54:19', 0, 0, NULL, '', '2573275', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/product/product/HCS-A1530-15-OL-F9-21.jpg'),
	(59, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-F9005M.jpg', '/upload/product/watermark/1616574020642123253.jpg', NULL, NULL, 4, NULL, 47, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-TD35-43.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:56:27', 0, 0, NULL, '', '2573507', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9005M 乌黑哑光', '', '/upload/product/product/HCS-K138S-F9005M1.jpg'),
	(60, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-F9010M.jpg', '/upload/product/watermark/1611128575528748878.jpg', NULL, NULL, 4, NULL, 48, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-TD35-431.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:56:35', 0, 0, NULL, '', '2573515', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9010M 纯白哑光', '', '/upload/product/product/HCS-K138S-F9010M1.jpg'),
	(61, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-F7016M.jpg', '/upload/product/watermark/1616574016760673793.jpg', NULL, NULL, 4, NULL, 46, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-TD35-432.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:56:43', 0, 0, NULL, '', '2573523', '平口门', '不含', '无钥匙或紧急开启锁闭', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F7016M 烟灰哑光', '', '/upload/product/product/HCS-K138S-F7016M1.jpg'),
	(62, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-SK-OL-F9005M.jpg', '/upload/product/watermark/1614215434475001898.jpg', NULL, NULL, 4, NULL, 47, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-SK-OL-TD35-43.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:56:51', 0, 0, NULL, '', '2573611', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9005M 乌黑哑光', '', '/upload/product/product/HCS-K138S-SK-OL-F9005M1.jpg'),
	(63, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-15-OL-F9005M.jpg', '/upload/product/watermark/1616377725314485580.jpg', NULL, NULL, 4, NULL, 47, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-15-OL-TD35-43.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:56:59', 0, 0, NULL, '', '2573620', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9005M 乌黑哑光', '', '/upload/product/product/HCS-K138S-15-OL-F9005M1.jpg'),
	(64, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-SK-OL-F9010M.jpg', '/upload/product/watermark/1610613673953904033.jpg', NULL, NULL, 4, NULL, 48, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-SK-OL-TD35-431.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:57:06', 0, 0, NULL, '', '2573671', '平口门', '不含', '无钥匙锁闭，一字紧急开启/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9010M 纯白哑光', '', '/upload/product/product/HCS-K138S-SK-OL-F9010M1.jpg'),
	(65, 17, 'HCS® K138S', '/upload/product/product/HCS-K138S-15-OL-F9010M.jpg', '/upload/product/watermark/1614156257548520910.jpg', NULL, NULL, 4, NULL, 48, 4, 1, '5', NULL, '', '35-43', NULL, NULL, '/upload/product/product/HCS-K138S-15-OL-TD35-431.jpg', 810, NULL, '2020-09-09 17:48:16', '2020-09-21 10:57:13', 0, 0, NULL, '', '2573689', '平口门', '不含', '钥匙锁闭，用钥匙/旋钮', NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9010M 纯白哑光', '', '/upload/product/product/HCS-K138S-15-OL-F9010M1.jpg'),
	(66, 47, '30PS', '/upload/product/product/30PS-PZ-F1.jpg', '/upload/product/watermark/1607498698717486725.jpg', NULL, NULL, 3, 1, 2, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/30PS-PZ-50mm2.jpg', 820, NULL, '2020-09-09 17:48:16', '2020-09-25 10:45:18', 0, 0, NULL, '', '2622268', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/30PS-PZ-F11.jpg'),
	(67, 47, '30PS', '/upload/product/product/30PS-PZ-F9.jpg', '/upload/product/watermark/1606965582359335783.jpg', NULL, NULL, 3, 1, 10, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/30PS-PZ-50mm3.jpg', 820, NULL, '2020-09-09 17:48:16', '2020-09-25 10:45:23', 0, 0, NULL, '', '2622313', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/product/product/30PS-PZ-F91.jpg'),
	(72, 22, 'M1535/19K/19KS', '/upload/product/product/M1535-19K+KV-19KS+KVS-PZ-F75-R.jpg', '/upload/product/watermark/1616649952484941312.jpg', NULL, NULL, 1, 1, 57, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（非独立方轴）</p>', '32-48', NULL, '8', '/upload/img_sample/M1535-19K-19KS-OB.jpg', 886, 1, '2020-09-09 17:48:17', '2020-09-11 14:16:24', 0, 0, NULL, '', '2825727', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F75-R 铜色,抛光/丝光', '/assets/img/icon_sk.png', '/upload/product/product/M1535-19K+KV-19KS+KVS-PZ-F75-R1.jpg'),
	(73, 23, '1672/19K/19KS', '/upload/product/product/1672-19K+KV-19KS+KVS-PZ-F1-2.jpg', '/upload/product/watermark/1615949511043027598.jpg', NULL, NULL, 1, 1, 44, 3, 3, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（非独立方轴）</p>', '35-45', NULL, '8', '/upload/product/product/1672-19K-19KS-PZ.jpg', 839, NULL, '2020-09-09 17:48:17', '2020-09-11 15:02:33', 0, 0, NULL, '', '2825891', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2 哑光银色', '/assets/img/icon_sk.png', '/upload/product/product/1672-19K+KV-19KS+KVS-PZ-F1-21.jpg'),
	(74, 23, '1672/19K/19KS', '/upload/product/product/1672-19K+KV-19KS+KVS-PZ-F9-2.jpg', '/upload/product/watermark/1614049681309979917.jpg', NULL, NULL, 1, 1, 45, 3, 3, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（非独立方轴）</p>', '35-45', NULL, '8', '/upload/product/product/1672-19K-19KS-PZ1.jpg', 839, NULL, '2020-09-09 17:48:17', '2020-09-11 15:02:39', 0, 0, NULL, '', '2826033', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9-2 哑光仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1672-19K+KV-19KS+KVS-PZ-F9-21.jpg'),
	(75, 12, 'M1515/23K/23KS', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F49-R.jpg', '/upload/product/watermark/1616745710124636708.jpg', NULL, NULL, 1, 1, 21, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（非独立方轴）</p>', '32-47', NULL, '8', '/upload/product/product/M1515-23K-23KS-PZ4.jpg', 829, NULL, '2020-09-09 17:48:17', '2020-09-11 16:15:11', 0, 0, NULL, '', '2829496', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F49-R1.jpg'),
	(76, 9, 'M516/19', '/upload/product/product/M516-19-F49-F69.jpg', '/upload/product/watermark/1616025954318468011.jpg', NULL, NULL, 5, NULL, 62, 1, 3, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M516-19.jpg', 979, NULL, '2020-09-09 17:48:17', '2020-09-21 12:51:36', 0, 0, NULL, '', '2829912', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/product/product/M516-19-F49-F691.jpg'),
	(77, 9, 'M517/19', '/upload/product/product/M517-19-F49-F69.jpg', '/upload/product/watermark/1607457595717620071.jpg', NULL, NULL, 5, NULL, 62, 1, 3, '', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M517-191.jpg', 970, NULL, '2020-09-09 17:48:17', '2020-09-25 18:56:51', 0, 0, NULL, '', '2829921', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/product/product/M517-19-F49-F691.jpg'),
	(78, 12, '1515/42K/42KS', '/upload/product/product/1515-42K+KV-42KS+KVS-PZ-F4.jpg', '/upload/product/watermark/1616836782020780949.jpg', NULL, NULL, 1, 1, 8, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（非独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1515-42K-42KS-PZ2.jpg', 829, 1, '2020-09-09 17:48:18', '2020-09-11 16:07:56', 0, 0, NULL, '', '2840441', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1515-42K+KV-42KS+KVS-PZ-F41.jpg'),
	(79, 9, 'M516', '/upload/product/product/M516-F77-R-F52-R.jpg', '/upload/product/watermark/1608028641943756298.jpg', NULL, NULL, 5, NULL, 27, 1, 3, '4', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M516.jpg', 980, NULL, '2020-09-09 17:48:18', '2020-09-21 12:51:22', 0, 0, NULL, '', '3043858', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77R 铜色,抛光', '', '/upload/product/product/M516-F77-R-F52-R1.jpg'),
	(80, 9, 'M516/19', '/upload/product/product/M516-19-F77-R-F52-R.jpg', '/upload/product/watermark/1613570321705349812.jpg', NULL, NULL, 5, NULL, 27, 1, 3, '4', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M516-191.jpg', 979, NULL, '2020-09-09 17:48:18', '2020-09-21 12:51:31', 0, 0, NULL, '', '3054696', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77R 铜色,抛光', '', '/upload/product/product/M516-19-F77-R-F52-R1.jpg'),
	(81, 9, 'M517/19', '/upload/product/product/M517-19-F77-R-F52-R.jpg', '/upload/product/watermark/1610439838824397349.jpg', NULL, NULL, 5, NULL, 27, 1, 3, '4', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M517-19.jpg', 970, NULL, '2020-09-09 17:48:18', '2020-09-25 18:56:24', 0, 0, NULL, '', '3054709', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77R 铜色,抛光', '', '/upload/product/product/M517-19-F77-R-F52-R1.jpg'),
	(82, 9, 'M517', '/upload/product/product/M517-F77-R-F52-R.jpg', '/upload/product/watermark/1615517673300621855.jpg', NULL, NULL, 5, NULL, 27, 1, 3, '4', '5', NULL, NULL, NULL, NULL, '/upload/product/product/M517.jpg', 970, NULL, '2020-09-09 17:48:18', '2020-09-21 12:51:44', 0, 0, NULL, '', '3054717', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77R 铜色,抛光', '', '/upload/product/product/M517-F77-R-F52-R1.jpg'),
	(83, 8, 'M172/15K/15KS', '/upload/product/product/M172-15K+KV-15KS+KVS-PZ-F77-R.jpg', '/upload/product/watermark/1616681102511120609.jpg', NULL, NULL, 1, 1, 27, 1, 3, '4', '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '34-71', NULL, '8', '/upload/product/product/DRW-CAT-M172-15K-15KS-PZ-SALL-AOF-V1.jpg', 836, NULL, '2020-09-09 17:48:18', '2020-09-11 15:23:16', 0, 0, NULL, '', '3055242', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/product/product/M172-15K+KV-15KS+KVS-PZ-F77-R1.jpg'),
	(84, 8, 'M072/7', '/upload/cover_img/M072-7-F77-R.jpg', '/upload/product/watermark/1614772708467848165.jpg', NULL, NULL, 7, NULL, 27, 1, 3, '4', '5', '<p>HOPPE 好博实心方轴</p>', NULL, '35', '7', '/upload/img_sample/M072-7.jpg', 790, NULL, '2020-09-09 17:48:18', '2020-10-13 11:55:19', 0, 0, NULL, '', '3055277', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，需配 M5 螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/cover_img/M072-7-F77-R.jpg'),
	(85, 47, '30PS', '/upload/product/product/30PS-PZ-F9714M.jpg', '/upload/product/watermark/1611197042694978295.jpg', NULL, NULL, 3, 1, 16, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/30PS-PZ-50mm1.jpg', 820, NULL, '2020-09-09 17:48:18', '2020-09-25 10:45:11', 0, 0, NULL, '', '3133790', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/30PS-PZ-F9714M1.jpg'),
	(87, 47, 'M471', '/upload/product/product/M471-F41-R-Set22.jpg', '/upload/product/watermark/1603608820724765873.jpg', NULL, NULL, 12, 3, 18, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set28.jpg', 789, NULL, '2020-09-09 17:48:18', '2020-09-21 11:14:08', 0, 0, NULL, '光面(不开孔)', '3206477', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob224.png', '/upload/product/product/M471-F41-R-Set23.jpg'),
	(88, 47, 'M471', '/upload/product/product/M471-F49-R-Set2.jpg', '/upload/product/watermark/1603608821419635980.jpg', NULL, NULL, 12, 3, 21, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set27.jpg', 789, NULL, '2020-09-09 17:48:18', '2020-09-21 11:14:12', 0, 0, NULL, '光面(不开孔)', '3206485', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob225.png', '/upload/product/product/M471-F49-R-Set21.jpg'),
	(90, 47, 'M471', '/upload/product/product/M471-F41-R-Set5.jpg', '/upload/product/watermark/1610430759798836003.jpg', NULL, NULL, 12, NULL, 18, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set58.jpg', 789, NULL, '2020-09-09 17:48:19', '2020-09-21 11:13:54', 0, 0, NULL, '光面(不开孔)', '3206725', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M471-F41-R-Set51.jpg'),
	(91, 47, 'M471', '/upload/product/product/M471-F49-R-Set5.jpg', '/upload/product/watermark/1615995631751029589.jpg', NULL, NULL, 12, NULL, 21, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set59.jpg', 789, NULL, '2020-09-09 17:48:19', '2020-09-21 11:14:00', 0, 0, NULL, '光面(不开孔)', '3206733', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/product/product/M471-F49-R-Set51.jpg'),
	(92, 47, 'M462', '/upload/product/product/M462-F41-R-Set2.jpg', '/upload/product/watermark/1616377373205419727.jpg', NULL, NULL, 12, NULL, 18, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M462-Set2.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:05:31', 0, 0, NULL, '光面(不开孔)', '3207091', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M462-F41-R-Set21.jpg'),
	(93, 47, 'M462', '/upload/product/product/M462-F49-R-F41-R-Set2.jpg', '/upload/product/watermark/1616377369949885464.jpg', NULL, NULL, 12, NULL, 65, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M462-Set21.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:05:36', 0, 0, NULL, '光面(不开孔)', '3207111', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49R 镀铬抛光', '', '/upload/product/product/M462-F49-R-F41-R-Set21.jpg'),
	(94, 47, 'M462', '/upload/product/product/M462-F52-R-F77-R-Set2.jpg', '/upload/product/watermark/1616377371785464969.jpg', NULL, NULL, 12, NULL, 66, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M462-Set22.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:05:42', 0, 0, NULL, '光面(不开孔)', '3207120', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F52R 抛光/丝光', '', '/upload/product/product/M462-F52-R-F77-R-Set21.jpg'),
	(95, 47, 'M462', '/upload/product/product/M462-F41-R-Set7.jpg', '/upload/product/watermark/1615995627823441723.jpg', NULL, NULL, 12, NULL, 18, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M462-Set7.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:05:50', 0, 0, NULL, '光面(不开孔)', '3207138', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M462-F41-R-Set71.jpg'),
	(96, 47, 'M462', '/upload/product/product/M462-F49-R-F41-R-Set7.jpg', '/upload/product/watermark/1615871251700219761.jpg', NULL, NULL, 12, NULL, 65, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M462-Set71.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:05:58', 0, 0, NULL, '光面(不开孔)', '3207154', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49R 镀铬抛光', '', '/upload/product/product/M462-F49-R-F41-R-Set71.jpg'),
	(97, 47, 'M462', '/upload/product/product/M462-F52-R-F77-R-Set7.jpg', '/upload/product/watermark/1610430764369660242.jpg', NULL, NULL, 12, NULL, 66, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M462-Set72.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:06:04', 0, 0, NULL, '光面(不开孔)', '3207162', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F52R 抛光/丝光', '', '/upload/product/product/M462-F52-R-F77-R-Set71.jpg'),
	(98, 47, 'M462', '/upload/product/product/M462-F41-R-Set5.jpg', '/upload/product/watermark/1601296631986677017.jpg', NULL, NULL, 12, NULL, 18, 1, 3, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M462-Set5.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:06:11', 0, 0, NULL, '光面(不开孔)', '3207218', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M462-F41-R-Set51.jpg'),
	(99, 47, 'M462', '/upload/product/product/M462-F49-R-F41-R-Set5.jpg', '/upload/product/watermark/1602748092430460651.jpg', NULL, NULL, 12, NULL, 65, 1, 3, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M462-Set51.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:06:18', 0, 0, NULL, '光面(不开孔)', '3207234', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49R 镀铬抛光', '', '/upload/product/product/M462-F49-R-F41-R-Set51.jpg'),
	(100, 47, 'M462', '/upload/product/product/M462-F52-R-F77-R-Set5.jpg', '/upload/product/watermark/1602568957630442021.jpg', NULL, NULL, 12, NULL, 66, 1, 3, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M462-Set52.jpg', 795, NULL, '2020-09-09 17:48:19', '2020-09-21 11:06:24', 0, 0, NULL, '光面(不开孔)', '3207242', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F52R 抛光/丝光', '', '/upload/product/product/M462-F52-R-F77-R-Set51.jpg'),
	(101, 47, 'M472', '/upload/product/product/M472-F41-R-Set7.jpg', '/upload/product/watermark/1603608843575779779.jpg', NULL, NULL, 12, 3, 18, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set77.jpg', 787, NULL, '2020-09-09 17:48:19', '2020-09-21 11:16:47', 0, 0, NULL, '光面(不开孔)', '3207285', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob239.png', '/upload/product/product/M472-F41-R-Set71.jpg'),
	(102, 47, 'M472', '/upload/product/product/M472-F49-R-Set7.jpg', '/upload/product/watermark/1603608844096269940.jpg', NULL, NULL, 12, 3, 21, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set78.jpg', 787, NULL, '2020-09-09 17:48:19', '2020-09-21 11:16:52', 0, 0, NULL, '光面(不开孔)', '3207293', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob240.png', '/upload/product/product/M472-F49-R-Set71.jpg'),
	(103, 47, 'M472', '/upload/product/product/M472-F41-R-Set5.jpg', '/upload/product/watermark/1616482516132272242.jpg', NULL, NULL, 12, NULL, 18, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set55.jpg', 787, NULL, '2020-09-09 17:48:19', '2020-09-21 11:17:01', 0, 0, NULL, '光面(不开孔)', '3207429', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M472-F41-R-Set51.jpg'),
	(104, 47, 'M472', '/upload/product/product/M472-F49-R-Set5.jpg', '/upload/product/watermark/1602747949594212939.jpg', NULL, NULL, 12, NULL, 21, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set54.jpg', 787, NULL, '2020-09-09 17:48:20', '2020-09-21 11:16:39', 0, 0, NULL, '光面(不开孔)', '3207437', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/product/product/M472-F49-R-Set51.jpg'),
	(106, 47, 'M463', '/upload/product/product/M463-F41-R-Set7.jpg', '/upload/product/watermark/1616377367279912775.jpg', NULL, NULL, 12, NULL, 18, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M463-Set7.jpg', 793, NULL, '2020-09-09 17:48:20', '2020-09-21 11:07:24', 0, 0, NULL, '光面(不开孔)', '3207736', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M463-F41-R-Set71.jpg'),
	(107, 47, 'M463', '/upload/product/product/M463-F49-R-F41-R-Set7.jpg', '/upload/product/watermark/1616377366630927951.jpg', NULL, NULL, 12, NULL, 65, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M463-Set71.jpg', 793, NULL, '2020-09-09 17:48:20', '2020-09-21 11:07:36', 0, 0, NULL, '光面(不开孔)', '3207752', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49R 镀铬抛光', '', '/upload/product/product/M463-F49-R-F41-R-Set71.jpg'),
	(108, 47, 'M463', '/upload/product/product/M463-F52-R-F77-R-Set7.jpg', '/upload/product/watermark/1616377365521839319.jpg', NULL, NULL, 12, NULL, 66, 1, 3, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M463-Set72.jpg', 793, NULL, '2020-09-09 17:48:20', '2020-09-21 11:07:46', 0, 0, NULL, '光面(不开孔)', '3207761', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F52R 抛光/丝光', '', '/upload/product/product/M463-F52-R-F77-R-Set71.jpg'),
	(109, 47, 'M463', '/upload/product/product/M463-F41-R-Set5.jpg', '/upload/product/watermark/1602818097611934151.jpg', NULL, NULL, 12, NULL, 18, 1, 3, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M463-Set5.jpg', 793, NULL, '2020-09-09 17:48:20', '2020-09-21 11:07:52', 0, 0, NULL, '光面(不开孔)', '3207832', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M463-F41-R-Set51.jpg'),
	(110, 47, 'M463', '/upload/product/product/M463-F49-R-F41-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 65, 1, 3, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M463-Set51.jpg', 793, NULL, '2020-09-09 17:48:20', '2020-09-21 11:08:02', 0, 0, NULL, '光面(不开孔)', '3207859', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49R 镀铬抛光', '', '/upload/product/product/M463-F49-R-F41-R-Set51.jpg'),
	(111, 47, 'M463', '/upload/product/product/M463-F52-R-F77-R-Set5.jpg', '/upload/product/watermark/1604905579879348283.jpg', NULL, NULL, 12, NULL, 66, 1, 3, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M463-Set52.jpg', 793, NULL, '2020-09-09 17:48:20', '2020-09-21 11:08:08', 0, 0, NULL, '光面(不开孔)', '3207867', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F52R 抛光/丝光', '', '/upload/product/product/M463-F52-R-F77-R-Set51.jpg'),
	(112, 25, 'M1558/18K/18KS', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F41-R.jpg', '/upload/product/watermark/1616145691283163752.jpg', NULL, NULL, 1, 1, 18, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-71', NULL, '8', '/upload/product/product/M1558-18K-18KS-PZ3.jpg', 990, NULL, '2020-09-09 17:48:20', '2020-11-18 10:57:55', 0, 0, NULL, '', '3240704', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F41-R1.jpg'),
	(113, 25, 'M1558/18K/18KS', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F49-R.jpg', '/upload/product/watermark/1616745401395543195.jpg', NULL, NULL, 1, 1, 21, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-71', NULL, '8', '/upload/product/product/M1558-18K-18KS-PZ2.jpg', 990, 0, '2020-09-09 17:48:20', '2020-11-18 10:57:30', 0, 0, NULL, '', '3240721', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F49-R1.jpg'),
	(115, 9, 'M156/19K/19KS', '/upload/product/product/M156-19K+KV-19KS+KVS-PZ-F77-R-F52-R.jpg', '/upload/product/watermark/1616773843637044979.jpg', NULL, NULL, 1, 1, 28, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '58-73', NULL, '8', '/upload/product/product/M156-19K-19KS-PZ1.jpg', 896, NULL, '2020-09-09 17:48:20', '2020-10-13 11:57:07', 0, 0, NULL, '', '3240798', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F77R 铜色,抛光', '/assets/img/icon_sk.png', '/upload/product/product/M156-19K+KV-19KS+KVS-PZ-F77-R-F52-R1.jpg'),
	(116, 26, 'M1603/23K/23KS', '/upload/product/product/M1603-23K+KV-23KS+KVS-PZ-F49-R.jpg', '/upload/product/watermark/1610071528319758944.jpg', NULL, NULL, 1, 1, 21, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-80', NULL, '8', '/upload/img_sample/M1603-23K-23KS-OB.jpg', 837, NULL, '2020-09-09 17:48:20', '2020-09-11 15:12:29', 0, 0, NULL, '', '3243227', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1603-23K+KV-23KS+KVS-PZ-F49-R1.jpg'),
	(117, 27, '1400/42K/42KS', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1615529057713697962.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1400-42K-42KS-PZ1.jpg', 900, NULL, '2020-09-09 17:48:21', '2020-09-24 11:46:52', 0, 1, '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F1-Motiv1-nW.png', '', '3277081', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F11.jpg'),
	(118, 27, '1400/42K/42KS', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1610442745072225412.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1400-42K-42KS-PZ2.jpg', 900, NULL, '2020-09-09 17:48:21', '2020-09-24 11:47:04', 0, 0, NULL, '', '3277099', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F91.jpg'),
	(119, 27, '1400/42K/42KS', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F1-F69.jpg', '/upload/product/watermark/1616742664291288151.jpg', NULL, NULL, 1, 1, 5, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1400-42K-42KS-PZ3.jpg', 900, 1, '2020-09-09 17:48:21', '2020-09-24 11:47:13', 0, 0, NULL, '', '3277101', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F1-F691.jpg'),
	(120, 27, 'E1400Z/42K/42KS', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F69.jpg', '/upload/product/watermark/1616742687416337664.jpg', NULL, NULL, 1, 1, 17, 2, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/product/product/E1400Z-42K-42KS-PZ.jpg', 898, NULL, '2020-09-09 17:48:21', '2020-09-14 15:48:12', 0, 1, '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F69-Motiv1-nW.png', '', '3278690', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F691.jpg'),
	(121, 47, 'M443', '/upload/product/product/M443-F41-R-Set2.jpg', '/upload/product/watermark/1603608750177908967.jpg', NULL, NULL, 12, 3, 18, 1, 1, '4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '33-48', NULL, '8', '/upload/product/product/M443-Set28.jpg', 799, NULL, '2020-09-09 17:48:21', '2020-09-21 11:04:38', 0, 0, NULL, '光面(不开孔)', '3389841', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob27.png', '/upload/product/product/M443-F41-R-Set21.jpg'),
	(122, 47, 'M443', '/upload/product/product/M443-F49-R-Set2.jpg', '/upload/product/watermark/1603608721984881409.jpg', NULL, NULL, 12, 3, 21, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set29.jpg', 799, NULL, '2020-09-09 17:48:21', '2020-09-21 11:04:48', 0, 0, NULL, '光面(不开孔)', '3389859', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob28.png', '/upload/product/product/M443-F49-R-Set21.jpg'),
	(123, 47, 'M443', '/upload/product/product/M443-F41-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 18, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set58.jpg', 799, NULL, '2020-09-09 17:48:21', '2020-09-21 11:04:53', 0, 0, NULL, '光面(不开孔)', '3389971', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M443-F41-R-Set51.jpg'),
	(124, 47, 'M443', '/upload/product/product/M443-F49-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 21, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set59.jpg', 799, NULL, '2020-09-09 17:48:21', '2020-09-21 11:04:59', 0, 0, NULL, '光面(不开孔)', '3389980', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/product/product/M443-F49-R-Set51.jpg'),
	(125, 47, 'M464', '/upload/product/product/M464-F41-R-Set7.jpg', '/upload/product/watermark/1603608805922449613.jpg', NULL, NULL, 12, 3, 18, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set78.jpg', 791, NULL, '2020-09-09 17:48:21', '2020-09-21 11:11:11', 0, 0, NULL, '光面(不开孔)', '3390260', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob219.png', '/upload/product/product/M464-F41-R-Set71.jpg'),
	(126, 47, 'M464', '/upload/product/product/M464-F49-R-Set7.jpg', '/upload/product/watermark/1603608811629084954.jpg', NULL, NULL, 12, 3, 21, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set79.jpg', 791, NULL, '2020-09-09 17:48:22', '2020-09-21 11:10:36', 0, 0, NULL, '光面(不开孔)', '3390278', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob217.png', '/upload/product/product/M464-F49-R-Set71.jpg'),
	(127, 47, 'M464', '/upload/product/product/M464-F77-R-Set7.jpg', '/upload/product/watermark/1603608812334086901.jpg', NULL, NULL, 12, 3, 27, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set710.jpg', 791, NULL, '2020-09-09 17:48:22', '2020-09-21 11:10:42', 0, 0, NULL, '光面(不开孔)', '3390286', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/upload/product/product/knob218.png', '/upload/product/product/M464-F77-R-Set71.jpg'),
	(128, 47, 'M464', '/upload/product/product/M464-F41-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 18, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set58.jpg', 791, NULL, '2020-09-09 17:48:22', '2020-09-21 11:10:50', 0, 0, NULL, '光面(不开孔)', '3390340', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/product/product/M464-F41-R-Set51.jpg'),
	(129, 47, 'M464', '/upload/product/product/M464-F49-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 21, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set59.jpg', 791, NULL, '2020-09-09 17:48:22', '2020-09-21 11:10:57', 0, 0, NULL, '光面(不开孔)', '3390358', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/product/product/M464-F49-R-Set51.jpg'),
	(130, 47, 'M464', '/upload/product/product/M464-F77-R-Set5.jpg', '/upload/product/watermark/1602748023876387684.jpg', NULL, NULL, 12, NULL, 27, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set510.jpg', 791, NULL, '2020-09-09 17:48:22', '2020-09-21 11:11:07', 0, 0, NULL, '光面(不开孔)', '3390366', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/product/product/M464-F77-R-Set51.jpg'),
	(131, 28, 'M543', '/upload/cover_img/M543-F41-R.jpg', '/upload/product/watermark/1606290413199553271.jpg', NULL, NULL, 5, NULL, 18, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:48:22', '2020-09-21 12:54:09', 0, 0, NULL, '', '3391191', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M543-F41-R.jpg'),
	(132, 28, 'M543', '/upload/cover_img/M543-F49-R.jpg', '/upload/product/watermark/1608176067386440355.jpg', NULL, NULL, 5, NULL, 21, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:48:22', '2020-09-21 12:54:21', 0, 0, NULL, '', '3391203', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/M543-F49-R.jpg'),
	(133, 28, 'M543', '/upload/cover_img/M543-F77-R.jpg', '/upload/product/watermark/1610439804120690418.jpg', NULL, NULL, 5, NULL, 27, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:48:22', '2020-09-21 12:54:33', 0, 0, NULL, '', '3391211', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/cover_img/M543-F77-R.jpg'),
	(134, 29, 'M1623/843K/843KS', '/upload/product/product/M1623-843K+KV-843KS+KVS-PZ-F41-R.jpg', '/upload/product/watermark/1614070955206226602.jpg', NULL, NULL, 1, 1, 18, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1623-843K-843KS-PZ.jpg', 884, NULL, '2020-09-09 17:48:22', '2020-10-13 11:30:43', 0, 0, '/upload/product/product/M1623-845-F41-R-Motiv1-nW.png', '', '3392492', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1623-843K+KV-843KS+KVS-PZ-F41-R1.jpg'),
	(135, 29, 'M1623/843K/843KS', '/upload/product/product/M1623-843K+KV-843KS+KVS-PZ-F49-R.jpg', '/upload/product/watermark/1616725008773234862.jpg', NULL, NULL, 1, 1, 21, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1623-843K-843KS-PZ1.jpg', 884, 1, '2020-09-09 17:48:22', '2020-09-11 14:28:39', 0, 0, NULL, '', '3392521', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1623-843K+KV-843KS+KVS-PZ-F49-R1.jpg'),
	(136, 13, '1530/3346', '/upload/product/product/1530-3346-PZ92-F1.jpg', '/upload/product/watermark/1616816650271910887.jpg', NULL, NULL, 3, 6, 2, 3, 1, '', '3', '<p>HOPPE 好博实心方轴</p>', '77-82', NULL, '8', '/upload/product/product/1530-3346-PZ-GL78-3-Nocken-M61.jpg', 980, NULL, '2020-09-09 17:48:22', '2020-09-25 10:33:46', 0, 0, NULL, '', '3695590', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1530-3346-PZ92-F11.jpg'),
	(137, 24, 'E1140Z/42K/42KS', '/upload/product/product/E1140-42H-42HKVS-PZ-F69.jpg', '/upload/product/watermark/1616286924158050105.jpg', NULL, NULL, 1, 1, 17, 2, 1, '1', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1140Z-42K-42KS-PZ1.jpg', 833, NULL, '2020-09-09 17:48:22', '2020-09-11 15:51:44', 0, 0, NULL, '', '3704661', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '/assets/img/icon_sk.png', '/upload/product/product/E1140-42H-42HKVS-PZ-F691.jpg'),
	(138, 30, '0810/US10', '/upload/cover_img/0810-US10-F1.jpg', '/upload/product/watermark/1616978833781465468.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0810-US10.jpg', 798, NULL, '2020-09-09 17:48:22', '2020-09-25 15:01:00', 0, 0, NULL, '', '3748612', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0810-US10-F1.jpg'),
	(139, 27, '1400/42K/42KS', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F1-2-S.jpg', '/upload/product/watermark/1616742672676064038.jpg', NULL, NULL, 1, 1, 3, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1400-42K-42KS-PZ.jpg', 900, NULL, '2020-09-09 17:48:23', '2020-09-24 11:46:43', 0, 0, NULL, '', '3749025', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2-S 哑光银色', '/assets/img/icon_sk.png', '/upload/product/product/1400-42K+KV-42KS+KVS-PZ-F1-2-S1.jpg'),
	(140, 30, '0810/US10', '/upload/cover_img/0810-US10-F4.jpg', '/upload/product/watermark/1616831811282440834.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0810-US10.jpg', 798, 1, '2020-09-09 17:48:23', '2020-09-25 15:00:52', 0, 0, NULL, '', '3755222', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0810-US10-F4.jpg'),
	(141, 30, '0810/US10', '/upload/cover_img/0810-US10-F9.jpg', '/upload/product/watermark/1616567253334132149.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0810-US10.jpg', 798, NULL, '2020-09-09 17:48:23', '2020-09-25 15:00:56', 0, 0, NULL, '', '3755732', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0810-US10-F9.jpg'),
	(142, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL452.jpg', '/upload/product/watermark/1604999441430130869.jpg', NULL, NULL, 1, 3, 19, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '33-38', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4529.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:02:26', 0, 0, NULL, '', '3765447', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F42-R 镀镍丝光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL453.jpg'),
	(143, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL454.jpg', NULL, NULL, NULL, 1, 3, 19, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4530.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:02:51', 0, 0, NULL, '', '3765463', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F42-R 镀镍丝光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL455.jpg'),
	(144, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F41-R-MSK91-OL452.jpg', '/upload/product/watermark/1611538780394432271.jpg', NULL, NULL, 1, 3, 18, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '33-38', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4531.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:03:15', 0, 0, NULL, '', '3765471', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F41-R-MSK91-OL453.jpg'),
	(145, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F41-R-MSK91-OL454.jpg', NULL, NULL, NULL, 1, 3, 18, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4532.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:03:37', 0, 0, NULL, '', '3765480', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F41-R-MSK91-OL455.jpg'),
	(146, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL454.jpg', '/upload/product/watermark/1616732859369665265.jpg', NULL, NULL, 1, 3, 21, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '33-38', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4533.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:03:59', 0, 0, NULL, '', '3765498', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL455.jpg'),
	(147, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL456.jpg', NULL, NULL, NULL, 1, 3, 21, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4534.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:04:25', 0, 0, NULL, '', '3765501', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL457.jpg'),
	(148, 47, 'M846S', '/upload/product/product/M846S-PZ-F42-R.jpg', '/upload/product/watermark/1609734809945726091.jpg', NULL, NULL, 1, 1, 19, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ9.jpg', 827, NULL, '2020-09-09 17:48:23', '2020-09-15 17:14:52', 0, 0, NULL, '', '3765519', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F42-R 镀镍丝光', '/upload/product/product/icon_sk13.png', '/upload/product/product/M846S-PZ-F42-R1.jpg'),
	(149, 47, 'M846S', '/upload/product/product/M846S-PZ-F41-R.jpg', '/upload/product/watermark/1615963254123419216.jpg', NULL, NULL, 1, 1, 18, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ10.jpg', 827, NULL, '2020-09-09 17:48:23', '2020-09-15 17:14:59', 0, 0, NULL, '', '3765535', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/icon_sk14.png', '/upload/product/product/M846S-PZ-F41-R1.jpg'),
	(150, 47, 'M846S', '/upload/product/product/M846S-PZ-F49-R.jpg', '/upload/product/watermark/1609745097240629061.jpg', NULL, NULL, 1, 1, 21, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ11.jpg', 827, NULL, '2020-09-09 17:48:23', '2020-09-15 17:15:07', 0, 0, NULL, '', '3765594', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/icon_sk15.png', '/upload/product/product/M846S-PZ-F49-R1.jpg'),
	(151, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL456.jpg', NULL, NULL, NULL, 1, 3, 19, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4535.jpg', 828, NULL, '2020-09-09 17:48:23', '2020-09-15 11:04:53', 0, 0, NULL, '', '3785755', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F42-R 镀镍丝光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL457.jpg'),
	(152, 28, '1643/52K/52KS', '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1615997811186956818.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1643-52K-52KS-PZ2.jpg', 890, 1, '2020-09-09 17:48:23', '2020-09-11 13:54:10', 0, 0, NULL, '', '3819337', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F11.jpg'),
	(153, 28, '1643/52K/52KS', '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1615997815627343392.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1643-52K-52KS-PZ1.jpg', 890, NULL, '2020-09-09 17:48:24', '2020-09-11 13:54:02', 0, 0, NULL, '', '3819345', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F91.jpg'),
	(154, 24, '1140/42K/42KS', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1616560139669788040.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1140-42K-42KS-PZ2.jpg', 835, NULL, '2020-09-09 17:48:24', '2020-09-11 15:43:32', 0, 1, '/upload/product/product/1140-42K+KV+FI-42KS+KVS+FIS-OB-F1-Motiv4-nW.png', '', '3819353', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F11.jpg'),
	(155, 24, '1140/42K/42KS', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1616286824119886208.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1140-42K-42KS-PZ3.jpg', 835, NULL, '2020-09-09 17:48:24', '2020-09-11 15:43:41', 0, 1, '/upload/product/product/1140-42K+KV+FI-42KS+KVS+FIS-OB-F9-Motiv4-nW.png', '', '3819433', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F91.jpg'),
	(156, 24, '1140/42K/42KS', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F1-2-S.jpg', '/upload/product/watermark/1615997833171361118.jpg', NULL, NULL, 1, 1, 3, 3, 1, '1,3', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1140-42K-42KS-PZ4.jpg', 835, NULL, '2020-09-09 17:48:24', '2020-09-11 15:43:50', 0, 0, NULL, '', '3819441', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-2-S 哑光银色', '/assets/img/icon_sk.png', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F1-2-S1.jpg'),
	(157, 12, '1515/42K/42KS', '/upload/product/product/1515-42K+KV-42KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1616133561024065908.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1515-42K-42KS-PZ.jpg', 829, NULL, '2020-09-09 17:48:25', '2020-09-11 16:07:13', 0, 0, NULL, '', '3819450', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1515-42K+KV-42KS+KVS-PZ-F11.jpg'),
	(158, 12, '1515/42K/42KS', '/upload/product/product/1515-42K+KV-42KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1616133562020963481.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1515-42K-42KS-PZ1.jpg', 829, NULL, '2020-09-09 17:48:25', '2020-09-11 16:07:23', 0, 0, NULL, '', '3819484', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1515-42K+KV-42KS+KVS-PZ-F91.jpg'),
	(159, 13, '1530/42K/42KS', '/upload/product/product/1530-42K+KV-42KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1615995510880382978.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1530-42K-42KS-PZ1.jpg', 895, NULL, '2020-09-09 17:48:25', '2020-09-11 12:05:12', 0, 0, NULL, '', '3821613', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1530-42K+KV-42KS+KVS-PZ-F11.jpg'),
	(160, 13, '1530/42K/42KS', '/upload/product/product/1530-42K+KV-42KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1615995717813776661.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1530-42K-42KS-PZ2.jpg', 895, 1, '2020-09-09 17:48:25', '2020-09-11 12:05:20', 0, 0, NULL, '', '3821621', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1530-42K+KV-42KS+KVS-PZ-F91.jpg'),
	(161, 25, 'M1558/18K/18KS', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F45-R.jpg', '/upload/product/watermark/1616947970991223650.jpg', NULL, NULL, 1, 1, 20, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-61', NULL, '8', '/upload/product/product/M1558-18K-18KS-PZ1.jpg', 990, 0, '2020-09-09 17:48:25', '2020-11-18 10:57:10', 0, 1, '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F45-R-Motiv1-nW.png', '', '3832937', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F45-R 镀铬抛光/磨砂', '/assets/img/icon_sk.png', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F45-R1.jpg'),
	(162, 25, 'M1558/18K/18KS', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F74-R.jpg', '/upload/product/watermark/1616947959366009811.jpg', NULL, NULL, 1, 1, 26, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-61', NULL, '8', '/upload/product/product/M1558-18K-18KS-PZ.jpg', 990, 1, '2020-09-09 17:48:25', '2020-11-18 10:56:50', 0, 1, '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F74-R-Motiv2-nW.png', '', '3832945', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F74-R 铜色, 磨砂/抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1558-18K+KV-18KS+KVS-PZ-F74-R1.jpg'),
	(163, 9, 'M156/19K/19KS', '/upload/product/product/M156-19K+KV-19KS+KVS-PZ-F49-F69.jpg', '/upload/product/watermark/1616551443780679268.jpg', NULL, NULL, 1, 1, 62, 1, 3, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '48-63', NULL, '8', '/upload/product/product/M156-19K-19KS-PZ.jpg', 896, NULL, '2020-09-09 17:48:25', '2020-09-24 11:51:10', 0, 1, '/upload/product/product/M156-19K+KV-19KS+KVS-PZ-F49-F69-Motiv2-nW.png', '', '3832970', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M156-19K+KV-19KS+KVS-PZ-F49-F691.jpg'),
	(164, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F41-R.jpg', '/upload/product/watermark/1611540004769958051.jpg', NULL, NULL, 1, 1, 18, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-59', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ7.jpg', 888, NULL, '2020-09-09 17:48:25', '2020-11-18 10:41:27', 0, 0, NULL, '', '3833121', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F41-R1.jpg'),
	(165, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F49-R.jpg', '/upload/product/watermark/1610029634076195347.jpg', NULL, NULL, 1, 1, 21, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-59', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ8.jpg', 888, NULL, '2020-09-09 17:48:25', '2020-11-18 10:42:06', 0, 0, NULL, '', '3833139', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F49-R1.jpg'),
	(166, 22, 'M1535/19K/19KS', '/upload/product/product/M1535-19K+KV-19KS+KVS-PZ-F45-R.jpg', '/upload/product/watermark/1609739413869139418.jpg', NULL, NULL, 1, 1, 20, 1, 3, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-60', NULL, '8', '/upload/img_sample/M1535-19K-19KS-OB.jpg', 886, NULL, '2020-09-09 17:48:25', '2020-09-14 15:56:50', 0, 1, '/upload/product/product/M1535-19K+KV-19KS+KVS-PZ-F45-R-Motiv4-nW.png', '', '3833147', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F45-R 镀铬抛光/磨砂', '/assets/img/icon_sk.png', '/upload/product/product/M1535-19K+KV-19KS+KVS-PZ-F45-R1.jpg'),
	(167, 31, 'M1642/843K/843KS', '/upload/product/product/M1642-843K+KV-843KS+KVS-PZ-F41-R.jpg', '/upload/product/watermark/1614907408974780767.jpg', NULL, NULL, 1, 1, 18, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-59', NULL, '8', '/upload/product/product/M1642-843K-843KS-PZ1.jpg', 841, NULL, '2020-09-09 17:48:25', '2020-09-11 14:50:15', 0, 0, NULL, '', '3833163', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1642-843K+KV-843KS+KVS-PZ-F41-R1.jpg'),
	(168, 31, 'M1642/843K/843KS', '/upload/product/product/M1642-843K+KV-843KS+KVS-PZ-F49-R.jpg', '/upload/product/watermark/1614049654618939955.jpg', NULL, NULL, 1, 1, 21, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-59', NULL, '8', '/upload/product/product/M1642-843K-843KS-PZ.jpg', 841, NULL, '2020-09-09 17:48:26', '2020-09-14 16:08:59', 0, 1, '/upload/product/product/M1642-843K+KV-843KS+KVS-PZ-F49-R-Motiv3-nW.png', '', '3833171', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1642-843K+KV-843KS+KVS-PZ-F49-R1.jpg'),
	(169, 32, 'M112PL/2007', '/upload/product/product/M112PL-2007-PZ72-F73.jpg', '/upload/product/watermark/1616377569344266438.jpg', NULL, NULL, 1, 4, 25, 1, 1, '', '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '39-65', NULL, '8', '/upload/product/product/M112PL-2007-PZ1.jpg', 838, NULL, '2020-09-09 17:48:26', '2020-10-26 13:14:25', 0, 0, NULL, '', '3833198', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F73 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/M112PL-2007-PZ72-F731.jpg'),
	(170, 26, 'M1603/23K/23KS', '/upload/product/product/M1603-23K+KV-23KS+KVS-PZ-F77-R.jpg', '/upload/product/watermark/1616724878303387221.jpg', NULL, NULL, 1, 1, 27, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-60', NULL, '8', '/upload/img_sample/M1603-23K-23KS-OB.jpg', 837, NULL, '2020-09-09 17:48:26', '2020-09-11 15:12:20', 0, 0, NULL, '', '3833219', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1603-23K+KV-23KS+KVS-PZ-F77-R1.jpg'),
	(171, 12, 'M1515/23K/23KS', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F72.jpg', '/upload/product/watermark/1616745705379684376.jpg', NULL, NULL, 1, 1, 23, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '49-61', NULL, '8', '/upload/product/product/M1515-23K-23KS-PZ.jpg', 829, NULL, '2020-09-09 17:48:26', '2020-09-11 16:14:13', 0, 0, NULL, '', '3833243', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F72 铜拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F721.jpg'),
	(172, 12, 'M1515/23K/23KS', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F73.jpg', '/upload/product/watermark/1616747553659735677.jpg', NULL, NULL, 1, 1, 25, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '49-61', NULL, '8', '/upload/product/product/M1515-23K-23KS-PZ1.jpg', 829, 1, '2020-09-09 17:48:26', '2020-09-11 16:14:24', 0, 0, NULL, '', '3833251', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F73 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F731.jpg'),
	(173, 12, 'M1515/23K/23KS', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F77-R.jpg', '/upload/product/watermark/1616568883751662167.jpg', NULL, NULL, 1, 1, 27, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '49-61', NULL, '8', '/upload/product/product/M1515-23K-23KS-PZ2.jpg', 829, NULL, '2020-09-09 17:48:26', '2020-09-11 16:14:33', 0, 0, NULL, '', '3833260', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F77-R1.jpg'),
	(174, 12, 'M1515/23K/23KS', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F41-R.jpg', '/upload/product/watermark/1616745701035184152.jpg', NULL, NULL, 1, 1, 18, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '49-61', NULL, '8', '/upload/product/product/M1515-23K-23KS-PZ3.jpg', 829, NULL, '2020-09-09 17:48:26', '2020-09-11 16:14:43', 0, 0, NULL, '', '3833278', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1515-23K+KV-23KS+KVS-PZ-F41-R1.jpg'),
	(175, 12, '0515-1/U26/49PNS', '/upload/cover_img/0515-1-U26-49PNS-F4.jpg', '/upload/product/watermark/1616647669295091180.jpg', NULL, NULL, 3, 1, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '90', NULL, '7', '/upload/product/product/0515-1-U26-49PNS-PZ12.jpg', 830, NULL, '2020-09-09 17:48:26', '2020-10-13 11:15:39', 0, 0, NULL, '', '3845535', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M4螺丝配套筒', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0515-1-U26-49PNS-F4.jpg'),
	(176, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL458.jpg', NULL, NULL, NULL, 1, 3, 18, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '33-38', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4527.jpg', 828, NULL, '2020-09-09 17:48:26', '2020-09-15 11:01:12', 0, 0, NULL, '', '3881835', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL459.jpg'),
	(177, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL452.jpg', NULL, NULL, NULL, 1, 3, 21, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4528.jpg', 828, NULL, '2020-09-09 17:48:26', '2020-09-15 11:01:48', 0, 0, NULL, '', '3881860', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL453.jpg'),
	(178, 33, '1751/42K/42KS', '/upload/product/product/1751-42K+KV-42KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1616126197224943857.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1751-42K-42KS-PZ1.jpg', 891, NULL, '2020-09-09 17:48:26', '2020-10-13 11:34:13', 0, 0, NULL, '', '3886943', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1751-42K+KV-42KS+KVS-PZ-F11.jpg'),
	(179, 33, '1751/42K/42KS', '/upload/product/product/1751-42K+KV-42KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1616842287517985378.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1751-42K-42KS-PZ2.jpg', 891, NULL, '2020-09-09 17:48:26', '2020-10-13 11:34:20', 0, 0, NULL, '', '3887006', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1751-42K+KV-42KS+KVS-PZ-F91.jpg'),
	(180, 34, '1558/52K/52KS', '/upload/product/product/1558-52K+KV-52KS+KVS-PZ-F9-11-F9.jpg', '/upload/product/watermark/1616742368291263268.jpg', NULL, NULL, 1, 1, 11, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/product/product/1558-52K-52KS-PZ.jpg', 892, NULL, '2020-09-09 17:48:26', '2020-09-11 13:37:00', 0, 0, NULL, '', '3887102', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9-11 仿钢色抛光/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-52K+KV-52KS+KVS-PZ-F9-11-F91.jpg'),
	(181, 34, '1558/52K/52KS', '/upload/product/product/1558-52K+KV-52KS+KVS-PZ-F1-11-F1.jpg', '/upload/product/watermark/1616742364871782443.jpg', NULL, NULL, 1, 1, 4, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1558-52K-52KS-PZ1.jpg', 892, NULL, '2020-09-09 17:48:26', '2020-09-11 13:37:09', 0, 0, NULL, '', '3887111', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1-11 亮银色/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-52K+KV-52KS+KVS-PZ-F1-11-F11.jpg'),
	(182, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ85-F9-11.jpg', '/upload/product/watermark/1616716785194376155.jpg', NULL, NULL, 3, 5, 11, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-70', NULL, '8', '/upload/product/product/1558-2830N-PZ7.jpg', 950, NULL, '2020-09-09 17:48:26', '2020-09-25 10:35:36', 0, 0, NULL, '', '3890483', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F9-11 仿钢色抛光/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ85-F9-111.jpg'),
	(183, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ85-F1-11.jpg', '/upload/product/watermark/1616724914965818257.jpg', NULL, NULL, 3, 5, 4, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-70', NULL, '8', '/upload/product/product/1558-2830N-PZ6.jpg', 950, NULL, '2020-09-09 17:48:27', '2020-09-25 10:35:30', 0, 0, NULL, '', '3890619', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F1-11 亮银色/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ85-F1-111.jpg'),
	(184, 31, 'M1642/30P/30PS', '/upload/product/product/M1642-30P-30PS-PZ-F41-R.jpg', '/upload/product/watermark/1615527893616702228.jpg', NULL, NULL, 3, 1, 18, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ8.jpg', 890, NULL, '2020-09-09 17:48:27', '2020-09-21 16:35:31', 0, 0, NULL, '', '3894476', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/product/product/M1642-30P-30PS-PZ-F41-R1.jpg'),
	(185, 31, 'M1642/30P/30PS', '/upload/product/product/M1642-30P-30PS-PZ-F49-R.jpg', '/upload/product/watermark/1615527896526938504.jpg', NULL, NULL, 3, 1, 21, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ9.jpg', 890, NULL, '2020-09-09 17:48:27', '2020-09-21 16:35:55', 0, 0, NULL, '', '3894492', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/product/product/M1642-30P-30PS-PZ-F49-R1.jpg'),
	(186, 27, 'E1400Z/42K/42KS', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F69-S.jpg', '/upload/product/watermark/1616742688697945069.jpg', NULL, NULL, 1, 1, 49, 2, 1, '1,3', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-42K-42KS-PZ5.jpg', 898, NULL, '2020-09-09 17:48:27', '2020-09-11 11:34:27', 0, 0, NULL, '', '3898872', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69-S 不锈钢拉丝', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F69-S1.jpg'),
	(187, 47, 'AR8180', '/upload/product/product/AR8180-SSS.jpg', '/upload/product/watermark/1616732225157360386.jpg', NULL, NULL, 9, NULL, 85, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/合页公差图.jpeg', 980, NULL, '2020-09-09 17:48:27', '2021-03-24 13:17:37', 0, 0, NULL, '', '8567837', NULL, NULL, NULL, NULL, '一对', NULL, '', '', '适用于重达 120 kg 的门', '通过 BS EN 1935:2002 13 级 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防火要求 240 分钟的钢制门。', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', ''),
	(189, 47, 'AR7070', '/upload/product/product/AR7070-SB-PVD-A1.jpg', '/upload/product/watermark/1616912498865417413.jpg', NULL, NULL, 9, NULL, 82, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/合页公差图3.jpeg', 970, NULL, '2020-09-09 17:48:27', '2021-03-24 13:18:31', 0, 0, NULL, '', '50018845', NULL, NULL, NULL, NULL, '一对', NULL, '', '', '适用于重达 120 kg 的门', '通过 BS EN 1935:2002 13 级 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防火要求 240 分钟的钢制门。', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', ''),
	(191, 47, 'AR681', '/upload/product/product/AR-KD-681-60-PB.jpg', '/upload/product/watermark/1616555055368334067.jpg', NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-601.jpg', 990, 1, '2020-09-09 17:48:27', '2020-10-13 15:27:20', 0, 0, NULL, '', '89000127', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '30/30', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(192, 47, 'AR681', '/upload/product/product/AR-KD-681-60-MNP.jpg', '/upload/product/watermark/1615791021320460081.jpg', NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-602.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-10-13 15:27:34', 0, 0, NULL, '', '89000134', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '30/30', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(193, 47, 'AR681', '/upload/product/product/AR-KD-681-65-PB.jpg', NULL, NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-651.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-10-13 15:27:50', 0, 0, NULL, '', '89000141', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '32.5/32.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(194, 47, 'AR681', '/upload/product/product/AR-KD-681-65-MNP.jpg', '/upload/product/watermark/1602555814980192290.jpg', NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-652.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-10-13 15:28:13', 0, 0, NULL, '', '89000148', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '32.5/32.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(195, 47, 'AR681', '/upload/product/product/AR-KD-681-70-PB.jpg', NULL, NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-701.jpg', 990, NULL, '2020-09-09 17:48:27', '2021-01-22 14:17:51', 0, 0, NULL, '', '50018875', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '35/35', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(196, 47, 'AR681', '/upload/product/product/AR-KD-681-70-MNP.jpg', '/upload/product/watermark/1608204965994808260.jpg', NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-702.jpg', 990, NULL, '2020-09-09 17:48:27', '2021-01-22 14:18:17', 0, 0, NULL, '', '50018887', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '35/35', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(197, 47, 'AR683', '/upload/product/product/AR-SK-683-65-PB.jpg', '/upload/product/watermark/1612230164169756703.jpg', NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-AR-SK-683-65-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-10-13 15:19:20', 0, 0, NULL, '', '89000235', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, '32.5/32.5', '硬币开启（卫浴）', '无', NULL, NULL, NULL, NULL, '', '', ''),
	(198, 47, 'AR683', '/upload/product/product/AR-SK-683-65-MNP.jpg', '/upload/product/watermark/1615033755982161288.jpg', NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-AR-SK-683-65-SALL-AOF-V11.jpg', 980, NULL, '2020-09-09 17:48:27', '2021-01-22 14:18:50', 0, 0, NULL, '', '50018899', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, '32.5/32.5', '硬币开启（卫浴）', '无', NULL, NULL, NULL, NULL, '', '', ''),
	(199, 47, 'AR683', '/upload/product/product/AR-SK-683-70-PB.jpg', '/upload/product/watermark/1612854057136260152.jpg', NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-AR-SK-683-70-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-10-13 15:19:53', 0, 0, NULL, '', '89000253', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, '35/35', '硬币开启（卫浴）', '无', NULL, NULL, NULL, NULL, '', '', ''),
	(200, 47, 'AR683', '/upload/product/product/AR-SK-683-70-MNP.jpg', '/upload/product/watermark/1613800624188598253.jpg', NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-AR-SK-683-70-SALL-AOF-V11.jpg', 980, NULL, '2020-09-09 17:48:27', '2021-01-22 14:19:18', 0, 0, NULL, '', '50018905', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, '35/35', '硬币开启（卫浴）', '无', NULL, NULL, NULL, NULL, '', '', ''),
	(201, 47, 'AR810', '/upload/product/product/AR810-S-60-SSS.jpg', '/upload/product/watermark/1616738300688264184.jpg', NULL, NULL, 10, 4, 85, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR810-S-602.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-09-30 12:51:24', 0, 0, NULL, '', '89000288', NULL, NULL, NULL, NULL, NULL, NULL, '72', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '直角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '/assets/img/icon_sk.png', '/upload/product/product/AR810-S-60-SSS1.jpg'),
	(202, 37, 'AR810', '/upload/product/product/AR810-S-60-PVD.jpg', '/upload/product/watermark/1616722262821636433.jpg', NULL, NULL, 10, 4, 82, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR810-S-603.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-09-30 12:51:31', 0, 0, NULL, '', '89000295', NULL, NULL, NULL, NULL, NULL, NULL, '72', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '直角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '/assets/img/icon_sk.png', ''),
	(203, 37, 'AR810', '/upload/product/product/AR810-R-60-PSS.jpg', '/upload/product/watermark/1610084027351810035.jpg', NULL, NULL, 10, 4, 85, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR810-R-60.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-09-30 13:08:48', 0, 0, NULL, '', '89000309', NULL, NULL, NULL, NULL, NULL, NULL, '72', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '/assets/img/icon_sk.png', ''),
	(204, 47, 'AR813', '/upload/product/product/AR813-S-60-SSS.jpg', '/upload/product/watermark/1616646539710486656.jpg', NULL, NULL, 10, 3, 85, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR813-S-60.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-09-30 12:51:43', 0, 0, NULL, '', '89000330', NULL, NULL, NULL, NULL, NULL, NULL, '78', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '直角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '/assets/img/icon_sk.png', ''),
	(205, 47, 'AR813', '/upload/product/product/AR813-S-60-PVD.jpg', '/upload/product/watermark/1616638454227355492.jpg', NULL, NULL, 10, 3, 82, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR813-S-601.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-10-13 15:11:38', 0, 0, NULL, '', '89000337', NULL, NULL, NULL, NULL, NULL, NULL, '78', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '直角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F77 铜色抛光', '/assets/img/icon_sk.png', ''),
	(206, 47, 'AR813', '/upload/product/product/AR813-R-60-SSS.jpg', '/upload/product/watermark/1615033716835100059.jpg', NULL, NULL, 10, 3, 85, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR813-R-60.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-10-13 15:11:43', 0, 0, NULL, '', '89000351', NULL, NULL, NULL, NULL, NULL, NULL, '78', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '/assets/img/icon_sk.png', ''),
	(207, 47, 'AR813', '/upload/product/product/AR813-R-60-PVD.jpg', '/upload/product/watermark/1606137082315697668.jpg', NULL, NULL, 10, 3, 82, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR813-R-601.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-10-13 15:11:56', 0, 0, NULL, '', '89000358', NULL, NULL, NULL, NULL, NULL, NULL, '78', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F77 铜色抛光', '/assets/img/icon_sk.png', ''),
	(208, 47, 'AR681', '/upload/product/product/AR-KD-681-75-PB.jpg', '/upload/product/watermark/1608530220156029691.jpg', NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-754.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-10-13 15:28:48', 0, 0, NULL, '', '89002506', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '37.5/37.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(209, 47, 'AR681', '/upload/product/product/AR-KD-681-75-MNP.jpg', NULL, NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-755.jpg', 990, NULL, '2020-09-09 17:48:27', '2020-10-13 15:28:59', 0, 0, NULL, '', '89002513', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '37.5/37.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(210, 47, 'AR683', '/upload/product/product/AR-SK-683-75-PB.jpg', '/upload/product/watermark/1610442085837352005.jpg', NULL, NULL, 11, NULL, 81, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-AR-SK-683-75-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:27', '2020-10-13 15:20:18', 0, 0, NULL, '', '89002520', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, '37.5/37.5', '硬币开启（卫浴）', '无', NULL, NULL, NULL, NULL, '', '', ''),
	(211, 47, 'AR683', '/upload/product/product/AR-SK-683-75-MNP.jpg', '/upload/product/watermark/1614781399147876907.jpg', NULL, NULL, 11, NULL, 83, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-AR-SK-683-75-SALL-AOF-V11.jpg', 980, NULL, '2020-09-09 17:48:27', '2021-01-22 14:20:56', 0, 0, NULL, '', '50018917', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, '37.5/37.5', '硬币开启（卫浴）', '无', NULL, NULL, NULL, NULL, '', '', ''),
	(212, 24, 'E1140Z/42K/42KS', '/upload/product/product/E1140-42H-42HKVS-PZ-F69-S.jpg', '/upload/product/watermark/1616560137862752675.jpg', NULL, NULL, 1, 1, 49, 2, 1, '1,3', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1140Z-42K-42KS-PZ.jpg', 833, NULL, '2020-09-09 17:48:27', '2020-09-11 15:51:32', 0, 0, NULL, '', '3899648', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69-S 不锈钢拉丝', '/assets/img/icon_sk.png', '/upload/product/product/E1140-42H-42HKVS-PZ-F69-S1.jpg'),
	(213, 47, '4920', '/upload/product/product/4920-F94-1-Set5.jpg', '/upload/product/watermark/1616650993266703420.jpg', NULL, NULL, 12, NULL, 2, 3, 4, '', NULL, NULL, '最小35', NULL, NULL, '/upload/product/product/4920-Set5-ohne-Fingerhuelse1.jpg', 805, NULL, '2020-09-09 17:48:27', '2020-09-21 10:59:28', 0, 0, NULL, '光面(不开孔)', '3947865', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗转，拉手嵌入固定，指孔和手以建筑硅胶固定', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/4920-F94-1-Set51.jpg'),
	(214, 47, '4920', '/upload/product/product/4920-F4-Set5.jpg', '/upload/product/watermark/1616378023939473945.jpg', NULL, NULL, 12, NULL, 8, 3, 4, '', NULL, NULL, '最小35', NULL, NULL, '/upload/product/product/4920-Set5-ohne-Fingerhuelse.jpg', 805, NULL, '2020-09-09 17:48:28', '2020-09-21 10:58:36', 0, 0, NULL, '光面(不开孔)', '3947873', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗转，拉手嵌入固定，指孔和手以建筑硅胶固定', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/product/product/4920-F4-Set51.jpg'),
	(215, 47, '4920', '/upload/product/product/4920-F1-Set2.jpg', '/upload/product/watermark/1608028626566378310.jpg', NULL, NULL, 12, NULL, 2, 3, 4, '', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '38-48', NULL, '8', '/upload/product/product/4920-Set2.jpg', 805, NULL, '2020-09-09 17:48:28', '2020-09-21 10:59:03', 0, 0, NULL, '光面(不开孔)', '3947996', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，拉手通过 HOPPE 好博专利套筒指轴嵌入；指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/4920-F1-Set21.jpg'),
	(216, 47, '4920', '/upload/product/product/4920-F4-Set2.jpg', '/upload/product/watermark/1610616097828863344.jpg', NULL, NULL, 12, NULL, 8, 3, 4, '', NULL, NULL, '38-48', NULL, '8', '/upload/product/product/4920-Set21.jpg', 805, NULL, '2020-09-09 17:48:28', '2020-09-21 10:59:20', 0, 0, NULL, '光面(不开孔)', '3948008', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，拉手通过 HOPPE 好博专利套筒指轴嵌入；指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/product/product/4920-F4-Set21.jpg'),
	(217, 47, '4930', '/upload/product/product/4930-F1-Set5.jpg', '/upload/product/watermark/1610345305460501668.jpg', NULL, NULL, 12, NULL, 2, 3, 4, '', NULL, NULL, '最小35', NULL, NULL, '/upload/product/product/4930-Set5.jpg', 803, NULL, '2020-09-09 17:48:28', '2020-09-21 10:59:41', 0, 0, NULL, '光面(不开孔)', '3948331', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝固定拉手；指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/4930-F1-Set51.jpg'),
	(218, 47, '4930', '/upload/product/product/4930-F4-Set5.jpg', '/upload/product/watermark/1610430711171175307.jpg', NULL, NULL, 12, NULL, 8, 3, 4, '', NULL, NULL, '最小35', NULL, NULL, '/upload/product/product/4930-Set51.jpg', 803, NULL, '2020-09-09 17:48:28', '2020-09-21 10:59:48', 0, 0, NULL, '光面(不开孔)', '3948340', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '明装，多用螺丝固定拉手；指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/product/product/4930-F4-Set51.jpg'),
	(220, 32, 'M112PL/2007', '/upload/cover_img/M112PL-2007-PZ72-F77-R.jpg', '/upload/product/watermark/1616055280665016164.jpg', NULL, NULL, 1, 4, 27, 1, 1, '4', '5', '<p>HOPPE 专利空心方轴（非独立方轴）</p>', '39-65', NULL, '8', '/upload/product/product/M112PL-2007-PZ.jpg', 838, NULL, '2020-09-09 17:48:28', '2020-09-25 09:58:40', 0, 0, NULL, '', '3959372', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/cover_img/M112PL-2007-PZ72-F77-R.jpg'),
	(224, 38, '0769/USV919', '/upload/cover_img/0769-USV919-F1.jpg', '/upload/product/watermark/1616810157910231735.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-USV919+Bohrbild.jpg', 940, NULL, '2020-09-09 17:48:28', '2020-09-25 13:30:34', 0, 0, NULL, '', '3969360', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0769-USV919-F1.jpg'),
	(225, 38, '0769/USV919', '/upload/cover_img/0769-USV919-F4.jpg', '/upload/product/watermark/1611713961614807747.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-USV919+Bohrbild.jpg', 940, NULL, '2020-09-09 17:48:29', '2020-09-25 13:30:23', 0, 0, NULL, '', '3969386', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0769-USV919-F4.jpg'),
	(226, 33, '1751/42K/42KS', '/upload/product/product/1751-42K+KV-42KS+KVS-PZ-F2.jpg', '/upload/product/watermark/1616638738847897774.jpg', NULL, NULL, 1, 1, 89, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1751-42K-42KS-PZ.jpg', 891, NULL, '2020-09-09 17:48:29', '2020-10-13 11:35:31', 0, 0, NULL, '', '3969896', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F2 香槟色', '/assets/img/icon_sk.png', '/upload/product/product/1751-42K+KV-42KS+KVS-PZ-F21.jpg'),
	(227, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ85-F4-11.jpg', '/upload/product/watermark/1616658771213956930.jpg', NULL, NULL, 3, 5, 9, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-70', NULL, '8', '/upload/product/product/1558-2830N-PZ5.jpg', 950, NULL, '2020-09-09 17:48:29', '2020-09-25 10:35:19', 0, 0, NULL, '', '3971427', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F4-11 古铜光亮/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ85-F4-111.jpg'),
	(228, 33, '1751/3346', '/upload/product/product/1751-3346-PZ92-F1.jpg', '/upload/product/watermark/1616724932322631148.jpg', NULL, NULL, 3, 6, 2, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '77-82', NULL, '8', '/upload/product/product/1751-3346-PZ-GL78-3-Nocken-M61.jpg', 940, NULL, '2020-09-09 17:48:29', '2020-09-25 10:37:29', 0, 0, NULL, '', '3974126', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1751-3346-PZ92-F11.jpg'),
	(229, 33, '1751/3346', '/upload/product/product/1751-3346-PZ92-F4.jpg', '/upload/product/watermark/1616825960060717105.jpg', NULL, NULL, 3, 6, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '77-82', NULL, '8', '/upload/product/product/1751-3346-PZ-GL78-3-Nocken-M62.jpg', 940, NULL, '2020-09-09 17:48:29', '2020-09-25 10:37:33', 0, 0, NULL, '', '3974134', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1751-3346-PZ92-F41.jpg'),
	(231, 39, '0808/US10', '/upload/cover_img/0808-US10-F1.jpg', '/upload/product/watermark/1616558016573722334.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0808-US10.jpg', 890, NULL, '2020-09-09 17:48:29', '2020-09-25 13:53:39', 0, 0, NULL, '', '10704685', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0808-US10-F1.jpg'),
	(232, 39, '0808/US10', '/upload/cover_img/0808-US10-F4.jpg', '/upload/product/watermark/1616558028901003426.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0808-US10.jpg', 890, NULL, '2020-09-09 17:48:30', '2020-09-25 13:53:34', 0, 0, NULL, '', '10704693', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0808-US10-F4.jpg'),
	(233, 39, '1808/42K/42KS', '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1616125962399414350.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/img_sample/1808-42K-42KS-PZ.jpg', 891, NULL, '2020-09-09 17:48:30', '2020-09-14 15:51:01', 0, 1, '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F1-Motiv1-nW.png', '', '10706390', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F11.jpg'),
	(234, 39, '1808/42K/42KS', '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F4.jpg', '/upload/product/watermark/1616836942927688088.jpg', NULL, NULL, 1, 1, 8, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/img_sample/1808-42K-42KS-PZ.jpg', 891, 1, '2020-09-09 17:48:30', '2020-09-11 13:49:14', 0, 0, NULL, '', '10706402', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F41.jpg'),
	(235, 39, '1808/42K/42KS', '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1615623421262753259.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/img_sample/1808-42K-42KS-PZ.jpg', 891, NULL, '2020-09-09 17:48:30', '2020-09-11 13:49:27', 0, 0, NULL, '', '10706488', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1808-42K+KV-42KS+KVS-PZ-F91.jpg'),
	(236, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ92-F1-112.jpg', '/upload/product/watermark/1615862096451921722.jpg', NULL, NULL, 3, 6, 4, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-70', NULL, '8', '/upload/product/product/1558-2830N-PZ2.jpg', 950, NULL, '2020-09-09 17:48:30', '2020-09-25 10:34:59', 0, 0, NULL, '', '10707966', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F1-11 亮银色/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ92-F1-113.jpg'),
	(237, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ92-F4-112.jpg', '/upload/product/watermark/1611214913396309475.jpg', NULL, NULL, 3, 6, 9, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-70', NULL, '8', '/upload/product/product/1558-2830N-PZ3.jpg', 950, NULL, '2020-09-09 17:48:30', '2020-09-25 10:35:06', 0, 0, NULL, '', '10707982', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F4-11 古铜光亮/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ92-F4-113.jpg'),
	(238, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ92-F9-11.jpg', '/upload/product/watermark/1609986928129279367.jpg', NULL, NULL, 3, 6, 11, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-70', NULL, '8', '/upload/product/product/1558-2830N-PZ4.jpg', 950, NULL, '2020-09-09 17:48:30', '2020-09-25 10:35:11', 0, 0, NULL, '', '10707991', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F9-11 仿钢色抛光/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ92-F9-111.jpg'),
	(239, 40, '1737/843K/843KS', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1615169171514671024.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-72', NULL, '8', '/upload/product/product/1737-843K-843KS-PZ2.jpg', 831, NULL, '2020-09-09 17:48:30', '2020-09-11 16:01:07', 0, 0, NULL, '', '10732846', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F11.jpg'),
	(240, 40, '1737/843K/843KS', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1615169179113858809.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-72', NULL, '8', '/upload/product/product/1737-843K-843KS-PZ3.jpg', 831, NULL, '2020-09-09 17:48:30', '2020-09-11 16:01:11', 0, 0, NULL, '', '10732900', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F91.jpg'),
	(241, 40, '1737/844P/844PS', '/upload/cover_img/1737-844P-844PS-PZ-F1.jpg', '/upload/product/watermark/1616653885640343543.jpg', NULL, NULL, 3, 1, 2, 3, 1, '1', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-72', NULL, '8', '/upload/product/product/1737-844P-844PS-PZ2.jpg', 870, 0, '2020-09-09 17:48:30', '2020-09-21 16:42:50', 0, 0, NULL, '', '10733005', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/1737-844P-844PS-PZ-F1.jpg'),
	(242, 40, '1737/844P/844PS', '/upload/cover_img/1737-844P-844PS-PZ-F4.jpg', '/upload/product/watermark/1616817061615311673.jpg', NULL, NULL, 3, 1, 8, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-72', NULL, '8', '/upload/product/product/1737-844P-844PS-PZ3.jpg', 870, 5, '2020-09-09 17:48:30', '2020-12-04 14:19:10', 0, 0, NULL, '', '10733101', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，多用螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/1737-844P-844PS-PZ-F4.jpg'),
	(243, 41, 'PSK-0739/US954-1', '/upload/cover_img/PSK-0739-US954-1-F1.jpg', '/upload/product/watermark/1616815479388434447.jpg', NULL, NULL, 8, NULL, 2, 3, 1, '2,6', '', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0739-US954-13.jpg', 970, NULL, '2020-09-09 17:48:30', '2020-09-30 10:02:41', 0, 0, NULL, '', '10761292', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/PSK-0739-US954-1-F1.jpg'),
	(244, 41, 'PSK-0739/US954-1', '/upload/cover_img/PSK-0739-US954-1-F4.jpg', '/upload/product/watermark/1609213866245398888.jpg', NULL, NULL, 8, NULL, 8, 3, 1, '2,6', '', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0739-US954-11.jpg', 970, NULL, '2020-09-09 17:48:31', '2020-09-30 10:02:05', 0, 0, NULL, '', '10761313', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/PSK-0739-US954-1-F4.jpg'),
	(245, 41, 'PSK-0739/US954-1', '/upload/cover_img/PSK-0739-US954-1-F9.jpg', '/upload/product/watermark/1610439756181506159.jpg', NULL, NULL, 8, NULL, 10, 3, 1, '2,6', '', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0739-US954-12.jpg', 970, NULL, '2020-09-09 17:48:31', '2020-09-30 10:02:23', 0, 0, NULL, '', '10761321', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/PSK-0739-US954-1-F9.jpg'),
	(246, 23, '0672/US956', '/upload/cover_img/0672-US956-F1-2.jpg', '/upload/product/watermark/1616812567066914867.jpg', NULL, NULL, 7, NULL, 44, 3, 3, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0672-US956.jpg', 800, NULL, '2020-09-09 17:48:31', '2020-09-25 14:27:15', 0, 0, NULL, '', '10762631', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1-2 哑光银色', '', '/upload/cover_img/0672-US956-F1-2.jpg'),
	(247, 23, '0672/US956', '/upload/cover_img/0672-US956-F9-2.jpg', '/upload/product/watermark/1611715188311795821.jpg', NULL, NULL, 7, NULL, 45, 3, 3, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0672-US956.jpg', 800, NULL, '2020-09-09 17:48:31', '2020-09-25 14:27:29', 0, 0, NULL, '', '10762640', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9-2 哑光仿钢色', '', '/upload/cover_img/0672-US956-F9-2.jpg'),
	(248, 27, '0400/US956', '/upload/product/product/0400-US956-F1.jpg', '/upload/product/watermark/1616032079872189404.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0400-US956-2-fbg.jpg', 980, NULL, '2020-09-09 17:48:31', '2020-09-28 19:46:59', 0, 0, NULL, '', '10762949', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/0400-US956-F11.jpg'),
	(249, 27, '0400/US956', '/upload/cover_img/0400-US956-F9.jpg', '/upload/product/watermark/1615358799212836569.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0400-US956-2-fbg.jpg', 980, NULL, '2020-09-09 17:48:31', '2020-09-25 11:35:07', 0, 0, NULL, '', '10762957', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0400-US956-F9.jpg'),
	(250, 27, '0400/US956', '/upload/product/product/0400-US956-F1-2-S2.jpg', '/upload/product/watermark/1616025179317382274.jpg', NULL, NULL, 7, NULL, 3, 3, 1, '2,3,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0400-US956-2-fbg.jpg', 980, NULL, '2020-09-09 17:48:31', '2020-10-13 10:46:35', 0, 0, NULL, '', '10762973', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1-2-S 哑光银色', '', '/upload/product/product/0400-US956-F1-2-S3.jpg'),
	(251, 24, '0140/US956', '/upload/cover_img/0140-US956-F1-2-S.jpg', '/upload/product/watermark/1616812657093332715.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0140-US956.jpg', 780, NULL, '2020-09-09 17:48:32', '2020-09-25 14:34:14', 0, 0, NULL, '', '10763183', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0140-US956-F1-2-S.jpg'),
	(252, 24, '0140/US956', '/upload/cover_img/0140-US956-F9.jpg', '/upload/product/watermark/1616126543647512861.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0140-US956.jpg', 780, NULL, '2020-09-09 17:48:32', '2020-09-25 14:34:19', 0, 0, NULL, '', '10763191', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0140-US956-F9.jpg'),
	(253, 24, '0140/US956', '/upload/cover_img/0140-US956-F1-2-S.jpg', '/upload/product/watermark/1616763663181410087.jpg', NULL, NULL, 7, NULL, 3, 3, 1, '2,3,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0140-US956.jpg', 780, NULL, '2020-09-09 17:48:32', '2020-09-25 14:34:26', 0, 0, NULL, '', '10763212', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1-2-S 哑光银色', '', '/upload/cover_img/0140-US956-F1-2-S.jpg'),
	(254, 12, '0515/US956', '/upload/cover_img/0515-US956-F1.jpg', '/upload/product/watermark/1616982804934054213.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0515-US956.jpg', 720, NULL, '2020-09-09 17:48:32', '2020-09-25 14:59:03', 0, 0, NULL, '', '10763263', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0515-US956-F1.jpg'),
	(255, 12, '0515/US956', '/upload/cover_img/0515-US956-F9.jpg', '/upload/product/watermark/1616982783104292529.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0515-US956.jpg', 720, 1, '2020-09-09 17:48:32', '2020-09-25 14:59:09', 0, 0, NULL, '', '10763271', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0515-US956-F9.jpg'),
	(256, 28, '0643/US944', '/upload/cover_img/0643-US944-F1.jpg', '/upload/product/watermark/1616811357359928200.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0643-US9441.jpg', 870, NULL, '2020-09-09 17:48:32', '2020-10-13 11:17:42', 0, 0, NULL, '', '10763301', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0643-US944-F1.jpg'),
	(257, 28, '0643/US944', '/upload/cover_img/0643-US944-F9.jpg', '/upload/product/watermark/1616126551732649671.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0643-US9442.jpg', 870, NULL, '2020-09-09 17:48:32', '2020-10-13 11:17:49', 0, 0, NULL, '', '10763319', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0643-US944-F9.jpg'),
	(258, 28, 'PSK-0643/US944', '/upload/cover_img/PSK-0643-US944-F1.jpg', '/upload/product/watermark/1616815492610254210.jpg', NULL, NULL, 8, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0643-US944.jpg', 960, NULL, '2020-09-09 17:48:32', '2020-09-30 10:05:12', 0, 0, NULL, '', '10763415', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/PSK-0643-US944-F1.jpg'),
	(260, 28, 'PSK-0643/US944', '/upload/cover_img/PSK-0643-US944-F9.jpg', '/upload/product/watermark/1615802998674370333.jpg', NULL, NULL, 8, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0643-US9442.jpg', 960, NULL, '2020-09-09 17:48:32', '2020-09-30 10:05:48', 0, 0, NULL, '', '10763431', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/PSK-0643-US944-F9.jpg'),
	(261, 28, 'PSK-0643/US944', '/upload/cover_img/PSK-0643-US944-F9016.jpg', '/upload/product/watermark/1615441713548474797.jpg', NULL, NULL, 8, NULL, 14, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0643-US9443.jpg', 960, NULL, '2020-09-09 17:48:32', '2020-09-30 10:06:05', 0, 0, NULL, '', '10763440', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', 'HOPPE 好博实心方轴', NULL, NULL, NULL, 'F9016 交通白', '', '/upload/cover_img/PSK-0643-US944-F9016.jpg'),
	(262, 27, 'E0400/US956', '/upload/product/product/E0400-US956-F69.jpg', '/upload/product/watermark/1616378042266556808.jpg', NULL, NULL, 7, NULL, 17, 2, 1, '2,6', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0400-US956.jpg', 970, NULL, '2020-09-09 17:48:32', '2020-09-25 11:42:20', 0, 0, NULL, '', '10763520', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E0400-US956-F691.jpg'),
	(263, 27, 'E0400/US956', '/upload/product/product/E0400-US956-F69-S.jpg', '/upload/product/watermark/1616378041937322636.jpg', NULL, NULL, 7, NULL, 49, 2, 1, '2,3,6', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0400-US956.jpg', 970, NULL, '2020-09-09 17:48:33', '2020-09-25 11:39:46', 0, 0, NULL, '', '10763538', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F69-S 不锈钢拉丝', '', '/upload/product/product/E0400-US956-F69-S1.jpg'),
	(264, 24, 'E0140/US956', '/upload/product/product/E0140-US956-F69.jpg', '/upload/product/watermark/1616812673067771284.jpg', NULL, NULL, 7, NULL, 17, 2, 1, '2,6', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0140-US956.jpg', 770, NULL, '2020-09-09 17:48:33', '2020-09-25 14:36:32', 0, 0, NULL, '', '10763790', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E0140-US956-F691.jpg'),
	(265, 24, 'E0140/US956', '/upload/product/product/e98c5c2a932a9adc8da9f8d56aed8dd.jpg', '/upload/product/watermark/1616147765771367767.jpg', NULL, NULL, 7, NULL, 49, 2, 1, '2,6,3', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0140-US956.jpg', 770, NULL, '2020-09-09 17:48:33', '2020-10-13 11:46:42', 0, 0, NULL, '', '10763802', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F69-S 不锈钢拉丝', '', '/upload/cover_img/E0140-US956-F69-S.jpg'),
	(266, 47, 'AR8180', '/upload/product/product/AR8180-AB-A1.jpg', '/upload/product/watermark/1616732224277880881.jpg', NULL, NULL, 9, NULL, 80, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/合页公差图1.jpeg', 980, NULL, '2020-09-09 17:48:33', '2021-03-24 13:18:07', 0, 0, NULL, '', '50002132', NULL, NULL, NULL, NULL, '一对', NULL, '', '', '适用于重达 120 kg 的门', '通过 BS EN 1935:2002 13 级 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防火要求 240 分钟的钢制门。', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', ''),
	(267, 24, 'E1140Z/845', '/upload/product/product/E1140Z-845-F69.jpg', '/upload/product/watermark/1612376289430341572.jpg', NULL, NULL, 1, NULL, 17, 2, 1, '1', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '36-54', NULL, '8', '/upload/product/product/E1140Z-845.jpg', 832, NULL, '2020-09-09 17:48:33', '2020-10-13 19:32:33', 0, 0, NULL, '', '10781630', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '/assets/img/icon_sk.png', '/upload/product/product/E1140Z-845-F691.jpg'),
	(268, 27, 'E1400Z/845', '/upload/cover_img/E1400Z-845-F69.jpg', '/upload/product/watermark/1616079902759013259.jpg', NULL, NULL, 1, NULL, 17, 2, 1, '1,4', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '36-54', NULL, '8', '/upload/product/product/E1400Z-8455.jpg', 897, 0, '2020-09-09 17:48:33', '2020-10-13 19:28:37', 0, 0, NULL, '', '10781648', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '/assets/img/icon_sk.png', '/upload/cover_img/E1400Z-845-F69.jpg'),
	(269, 27, '0400/US956', '/upload/product/product/0400-US956-F1-F69.jpg', '/upload/product/watermark/1616809513655032441.jpg', NULL, NULL, 7, NULL, 5, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0400-US956-2-fbg.jpg', 980, 1, '2020-09-09 17:48:33', '2020-09-25 11:34:16', 0, 0, NULL, '', '10782317', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/0400-US956-F1-F691.jpg'),
	(270, 29, 'M1623/845', '/upload/cover_img/M1623-845-F41-R.jpg', '/upload/product/watermark/1616732690270783300.jpg', NULL, NULL, 1, NULL, 18, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-54', NULL, '8', '/upload/img_sample/M1623-845.jpg', 883, NULL, '2020-09-09 17:48:33', '2020-10-13 19:30:38', 0, 1, '/upload/product/product/M1623-845-F41-R-Motiv1-nW1.png', '', '10782667', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/M1623-845-F41-R.jpg'),
	(271, 31, 'M1642/845', '/upload/cover_img/M1642-845-F41-R.jpg', '/upload/product/watermark/1616733530652157344.jpg', NULL, NULL, 1, NULL, 18, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-54', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:33', '2020-10-13 19:31:55', 0, 0, NULL, '', '10782675', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-845-F41-R.jpg'),
	(272, 31, 'M1642/845', '/upload/cover_img/M1642-845-F49-R.jpg', '/upload/product/watermark/1615939250562678717.jpg', NULL, NULL, 1, NULL, 21, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-54', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:33', '2020-10-13 19:32:04', 0, 1, '/upload/product/product/M1642-845-F49-R-Motiv1-nW.png', '', '10782747', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-845-F49-R.jpg'),
	(273, 28, 'M1643/845', '/upload/cover_img/M1643-845-F41-R.jpg', '/upload/product/watermark/1616041449546250125.jpg', NULL, NULL, 1, NULL, 18, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-54', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:33', '2020-10-25 16:35:21', 0, 0, NULL, '', '10782755', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-845-F41-R.jpg'),
	(274, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 19, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '48-53', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4524.jpg', 828, NULL, '2020-09-09 17:48:33', '2020-09-15 10:59:48', 0, 0, NULL, '', '10782780', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F42-R 镀镍丝光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F42-R-MSK91-OL451.jpg'),
	(275, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F41-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 18, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '48-53', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4525.jpg', 828, NULL, '2020-09-09 17:48:33', '2020-09-15 11:00:21', 0, 0, NULL, '', '10782827', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F41-R-MSK91-OL451.jpg'),
	(276, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 21, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '48-53', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4526.jpg', 828, NULL, '2020-09-09 17:48:33', '2020-09-15 11:00:48', 0, 0, NULL, '', '10783782', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F49-R-MSK91-OL451.jpg'),
	(277, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ92-F4-11.jpg', '/upload/product/watermark/1616718004966346836.jpg', NULL, NULL, 3, 6, 9, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '85-90', NULL, '8', '/upload/product/product/1558-2830N-PZ1.jpg', 950, NULL, '2020-09-09 17:48:33', '2020-09-25 10:34:51', 0, 0, NULL, '', '10784769', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F4-11 古铜光亮/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ92-F4-111.jpg'),
	(278, 40, 'PSK-0737/US947-1', '/upload/cover_img/PSK-0737-US947-1-F1-2-S.jpg', '/upload/product/watermark/1614493560506887470.jpg', NULL, NULL, 8, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0737-US947-14.jpg', 930, NULL, '2020-09-09 17:48:33', '2020-09-30 10:18:25', 0, 0, NULL, '', '10790042', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/PSK-0737-US947-1-F1-2-S.jpg'),
	(279, 40, 'PSK-0737/US947-1', '/upload/cover_img/PSK-0737-US947-1-F4.jpg', '/upload/product/watermark/1616371182550401079.jpg', NULL, NULL, 8, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0737-US947-12.jpg', 930, NULL, '2020-09-09 17:48:34', '2020-09-30 10:17:40', 0, 0, NULL, '', '10790069', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/PSK-0737-US947-1-F4.jpg'),
	(280, 40, 'PSK-0737/US947-1', '/upload/cover_img/PSK-0737-US947-1-F9.jpg', '/upload/product/watermark/1616815537590323036.jpg', NULL, NULL, 8, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0737-US947-13.jpg', 930, NULL, '2020-09-09 17:48:34', '2020-09-30 10:18:05', 0, 0, NULL, '', '10790077', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/PSK-0737-US947-1-F9.jpg'),
	(281, 25, 'M0558/US918', '/upload/cover_img/M0558-US918-F41-R.jpg', '/upload/product/watermark/1616764523280119091.jpg', NULL, NULL, 7, NULL, 18, 1, 3, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0558-US918.jpg', 990, NULL, '2020-09-09 17:48:34', '2020-10-13 11:53:27', 0, 0, NULL, '', '10803384', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M0558-US918-F41-R.jpg'),
	(282, 25, 'M0558/US918', '/upload/cover_img/M0558-US918-F45-R.jpg', '/upload/product/watermark/1616764524536559100.jpg', NULL, NULL, 7, NULL, 20, 1, 3, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0558-US918.jpg', 990, NULL, '2020-09-09 17:48:34', '2020-10-13 11:53:31', 0, 0, NULL, '', '10803413', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F45-R 镀铬抛光/磨砂', '', '/upload/cover_img/M0558-US918-F45-R.jpg'),
	(283, 47, 'M846S', '/upload/product/product/M846S-PZ-F9714M.jpg', '/upload/product/watermark/1615787444939335099.jpg', NULL, NULL, 1, 1, 16, 1, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ13.jpg', 827, NULL, '2020-09-09 17:48:34', '2020-09-25 18:50:55', 0, 0, NULL, '', '10803827', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/icon_sk12.png', '/upload/product/product/M846S-PZ-F9714M1.jpg'),
	(284, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL456.jpg', '/upload/product/watermark/1608707277987785970.jpg', NULL, NULL, 1, 3, 16, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '33-38', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4523.jpg', 828, NULL, '2020-09-09 17:48:34', '2020-09-15 10:58:45', 0, 0, NULL, '', '10803835', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL457.jpg'),
	(285, 9, 'M056/US937', '/upload/cover_img/M056-US937-F49-F69.jpg', '/upload/product/watermark/1616567547780246770.jpg', NULL, NULL, 7, NULL, 62, 1, 3, '2,6', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M056-US937.jpg', 960, NULL, '2020-09-09 17:48:34', '2020-09-25 13:21:24', 0, 0, NULL, '', '10806729', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F49 镀铬抛光', '', '/upload/cover_img/M056-US937-F49-F69.jpg'),
	(286, 22, 'M0535/US956', '/upload/cover_img/M0535-US956-F45-R.jpg', '/upload/product/watermark/1616810341284980868.jpg', NULL, NULL, 7, NULL, 20, 1, 3, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0535-US956.jpg', 850, NULL, '2020-09-09 17:48:34', '2020-09-25 14:01:09', 0, 0, NULL, '', '10807609', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F45-R 镀铬抛光/磨砂', '', '/upload/cover_img/M0535-US956-F45-R.jpg'),
	(287, 29, 'M0623/US943', '/upload/cover_img/M0623-US943-F41-R.jpg', '/upload/product/watermark/1616812014214497960.jpg', NULL, NULL, 7, NULL, 18, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0623-US943.jpg', 830, NULL, '2020-09-09 17:48:34', '2020-09-25 14:14:31', 0, 0, NULL, '', '10807617', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M0623-US943-F41-R.jpg'),
	(288, 31, 'M0642/US943', '/upload/cover_img/M0642-US943-F41-R.jpg', '/upload/product/watermark/1616812533637157401.jpg', NULL, NULL, 7, NULL, 18, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US943.jpg', 810, NULL, '2020-09-09 17:48:34', '2020-09-25 14:18:00', 0, 0, NULL, '', '10808708', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M0642-US943-F41-R.jpg'),
	(289, 31, 'M0642/US943', '/upload/cover_img/M0642-US943-F49-R.jpg', '/upload/product/watermark/1615964051319019464.jpg', NULL, NULL, 7, NULL, 21, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US943.jpg', 810, NULL, '2020-09-09 17:48:35', '2020-09-25 14:17:55', 0, 0, NULL, '', '10808901', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/M0642-US943-F49-R.jpg'),
	(290, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F41-R.jpg', '/upload/product/watermark/1601644410361372154.jpg', NULL, NULL, 8, NULL, 18, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US94310.jpg', 950, NULL, '2020-09-09 17:48:35', '2020-09-30 10:10:57', 0, 0, NULL, '', '10808994', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/PSK-M0643-US943-F41-R.jpg'),
	(291, 12, 'M0515/US956', '/upload/cover_img/M0515-US956-F41-R.jpg', '/upload/product/watermark/1616410789296027897.jpg', NULL, NULL, 7, NULL, 18, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0515-US956.jpg', 690, NULL, '2020-09-09 17:48:35', '2020-09-25 15:09:11', 0, 0, NULL, '', '10809022', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M0515-US956-F41-R.jpg'),
	(292, 40, 'PSK-0737/US947-1', '/upload/cover_img/PSK-0737-US947-1-F9714M.jpg', '/upload/product/watermark/1615441515742582632.jpg', NULL, NULL, 8, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0737-US947-11.jpg', 930, NULL, '2020-09-09 17:48:35', '2020-09-30 10:17:24', 0, 0, NULL, '', '11506398', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/PSK-0737-US947-1-F9714M.jpg'),
	(293, 40, '1737/844P/844PS', '/upload/product/product/1737-844P-844PS-PZ-F9714M.jpg', '/upload/product/watermark/1616653601298807046.jpg', NULL, NULL, 3, 1, 16, 3, 1, '1', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-72', NULL, '8', '/upload/product/product/1737-844P-844PS-PZ1.jpg', 870, 0, '2020-09-09 17:48:35', '2020-09-21 16:42:37', 0, 0, NULL, '', '11543152', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1737-844P-844PS-PZ-F9714M1.jpg'),
	(294, 42, '0715/U34/51PNS', '/upload/cover_img/0715-U34-51PNS-PZ-F4.jpg', '/upload/product/watermark/1616489822203850257.jpg', NULL, NULL, 3, 1, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '90', NULL, '7', '/upload/product/product/0715-U34-51PNS-PZ.jpg', 939, NULL, '2020-09-09 17:48:35', '2020-09-25 10:50:16', 0, 0, NULL, '', '11554320', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M4螺丝配套筒', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0715-U34-51PNS-PZ-F4.jpg'),
	(295, 41, 'PSK-0739/US954-1', '/upload/cover_img/PSK-0739-US954-1-F9714M.jpg', '/upload/product/watermark/1608577615619813735.jpg', NULL, NULL, 8, NULL, 16, 3, 1, '2,6', '', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0739-US954-1.jpg', 970, NULL, '2020-09-09 17:48:35', '2020-09-30 10:01:42', 0, 0, NULL, '', '11557102', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/PSK-0739-US954-1-F9714M.jpg'),
	(296, 47, '844PS', '/upload/product/product/844PS-PZ-F9.jpg', '/upload/product/watermark/1610545692335584739.jpg', NULL, NULL, 3, 1, 10, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/844PS-PZ2.jpg', 810, NULL, '2020-09-09 17:48:35', '2020-12-04 14:49:22', 0, 0, NULL, '', '11667175', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，多用螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/product/product/844PS-PZ-F91.jpg'),
	(297, 47, '844PS', '/upload/product/product/844PS-PZ-F9714M.jpg', '/upload/product/watermark/1610545693007861965.jpg', NULL, NULL, 3, 1, 16, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/844PS-PZ1.jpg', 810, NULL, '2020-09-09 17:48:36', '2020-12-04 14:47:54', 0, 0, NULL, '', '11667217', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，多用螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/844PS-PZ-F9714M.jpg'),
	(298, 22, 'M0535/US956', '/upload/cover_img/M0535-US956-F75-R.jpg', '/upload/product/watermark/1616810339140223142.jpg', NULL, NULL, 7, NULL, 57, 1, 3, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0535-US956.jpg', 850, NULL, '2020-09-09 17:48:36', '2020-09-25 14:01:01', 0, 0, NULL, '', '11569207', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F75-R 铜色,抛光/丝光', '', '/upload/cover_img/M0535-US956-F75-R.jpg'),
	(299, 25, 'M0558/US918', '/upload/cover_img/M0558-US918-F49-R.jpg', '/upload/product/watermark/1616812063960467159.jpg', NULL, NULL, 7, NULL, 21, 1, 3, '2,6,4', '4,5,7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0558-US918.jpg', 990, 1, '2020-09-09 17:48:36', '2020-09-25 11:13:36', 0, 0, NULL, '', '11569323', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/M0558-US918-F49-R.jpg'),
	(300, 25, 'M0558/US918', '/upload/cover_img/M0558-US918-F74-R.jpg', '/upload/product/watermark/1616565954559072263.jpg', NULL, NULL, 7, NULL, 26, 1, 3, '2,6,4', '4,5,7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0558-US918.jpg', 990, NULL, '2020-09-09 17:48:36', '2020-09-25 11:16:42', 0, 0, NULL, '', '11569360', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F74-R 铜色, 磨砂/抛光', '', '/upload/cover_img/M0558-US918-F74-R.jpg'),
	(301, 12, 'M0515/US956', '/upload/cover_img/M0515-US956-F72.jpg', '/upload/product/watermark/1616410856567797120.jpg', NULL, NULL, 7, NULL, 23, 1, 1, '2,6', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0515-US956.jpg', 690, NULL, '2020-09-09 17:48:36', '2020-09-25 15:08:42', 0, 0, NULL, '', '11568574', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F72 铜拉丝', '', '/upload/cover_img/M0515-US956-F72.jpg'),
	(302, 12, 'M0515/US956', '/upload/cover_img/M0515-US956-F73.jpg', '/upload/product/watermark/1616813797906987594.jpg', NULL, NULL, 7, NULL, 25, 1, 1, '2,6', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0515-US956.jpg', 690, 1, '2020-09-09 17:48:36', '2020-09-25 15:08:52', 0, 0, NULL, '', '11568665', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F73 古铜色', '', '/upload/cover_img/M0515-US956-F73.jpg'),
	(303, 12, 'M0515/US956', '/upload/cover_img/M0515-US956-F77-R.jpg', '/upload/product/watermark/1616138706692313324.jpg', NULL, NULL, 7, NULL, 27, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0515-US956.jpg', 690, NULL, '2020-09-09 17:48:36', '2020-09-25 15:08:59', 0, 0, NULL, '', '11568689', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/cover_img/M0515-US956-F77-R.jpg'),
	(304, 9, 'M056/US937', '/upload/product/product/M056-US937-F77-R-F52-R.jpg', '/upload/product/watermark/1616810118305881771.jpg', NULL, NULL, 7, NULL, 28, 1, 3, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M056-US937.jpg', 960, NULL, '2020-09-09 17:48:36', '2020-10-13 11:54:39', 0, 0, NULL, '', '11569925', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F77R 铜色,抛光', '', '/upload/product/product/M056-US937-F77-R-F52-R1.jpg'),
	(305, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F77-R.jpg', '/upload/product/watermark/1615523164644984808.jpg', NULL, NULL, 7, NULL, 27, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:36', '2020-09-25 14:00:22', 0, 0, NULL, '', '11570374', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/cover_img/M0643-US943-F77-R.jpg'),
	(306, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F49-R.jpg', '/upload/product/watermark/1615297890664530701.jpg', NULL, NULL, 7, NULL, 21, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:36', '2020-09-25 14:00:27', 0, 0, NULL, '', '11570386', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/M0643-US943-F49-R.jpg'),
	(307, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F41-R.jpg', '/upload/product/watermark/1616811909293814623.jpg', NULL, NULL, 7, NULL, 18, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:37', '2020-09-25 14:00:17', 0, 0, NULL, '', '11570428', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M0643-US943-F41-R.jpg'),
	(308, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F49-R.jpg', '/upload/product/watermark/1610942348980143182.jpg', NULL, NULL, 8, NULL, 21, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9438.jpg', 950, NULL, '2020-09-09 17:48:37', '2020-09-30 10:10:20', 0, 0, NULL, '', '11570593', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/PSK-M0643-US943-F49-R.jpg'),
	(309, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F77-R.jpg', '/upload/product/watermark/1610524802316314379.jpg', NULL, NULL, 8, NULL, 27, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9439.jpg', 950, NULL, '2020-09-09 17:48:37', '2020-09-30 10:10:38', 0, 0, NULL, '', '11570660', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '', '/upload/cover_img/PSK-M0643-US943-F77-R.jpg'),
	(310, 30, '0810/US10', '/upload/cover_img/0810-US10-F9714M.jpg', '/upload/product/watermark/1616567255974303185.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0810-US10.jpg', 798, NULL, '2020-09-09 17:48:37', '2020-09-25 15:00:47', 0, 0, NULL, '', '11573582', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0810-US10-F9714M.jpg'),
	(311, 28, '0643/US944', '/upload/cover_img/0643-US944-F9714M.jpg', '/upload/product/watermark/1616910505891048451.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0643-US944.jpg', 870, 1, '2020-09-09 17:48:37', '2020-10-13 11:17:35', 0, 0, NULL, '', '11575840', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0643-US944-F9714M.jpg'),
	(312, 29, 'M0623/US943', '/upload/cover_img/M0623-US943-F49-R.jpg', '/upload/product/watermark/1616812011970275976.jpg', NULL, NULL, 7, NULL, 21, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0623-US943.jpg', 830, NULL, '2020-09-09 17:48:37', '2020-09-25 14:14:28', 0, 0, NULL, '', '11580380', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/M0623-US943-F49-R.jpg'),
	(313, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F4.jpg', '/upload/product/watermark/1616749527504455167.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0515-1-US9526.jpg', 710, NULL, '2020-09-09 17:48:37', '2020-09-25 15:03:00', 0, 0, NULL, '', '11589085', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0515-1-US952-F4.jpg'),
	(314, 27, '0400/US956', '/upload/cover_img/0400-US956-F9714M.jpg', '/upload/product/watermark/1615358795285521638.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0400-US956-2-fbg.jpg', 980, NULL, '2020-09-09 17:48:37', '2020-09-25 11:34:45', 0, 0, NULL, '', '11592679', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0400-US956-F9714M.jpg'),
	(315, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F41-R.jpg', '/upload/product/watermark/1615297323138718499.jpg', NULL, NULL, 8, NULL, 18, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9109.jpg', 940, NULL, '2020-09-09 17:48:37', '2020-09-30 10:15:22', 0, 0, NULL, '', '11595206', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/PSK-M0642-US910-F41-R.jpg'),
	(317, 13, '1530/3346', '/upload/product/product/1530-3346-PZ92-F4.jpg', '/upload/product/watermark/1616725100186767567.jpg', NULL, NULL, 3, 6, 8, 3, 1, '', '3', '<p>HOPPE 好博实心方轴</p>', '77-82', NULL, '8', '/upload/product/product/1530-3346-PZ-GL78-3-Nocken-M6.jpg', 980, NULL, '2020-09-09 17:48:38', '2020-09-25 10:33:39', 0, 0, NULL, '', '11597525', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1530-3346-PZ92-F41.jpg'),
	(318, 12, '0515-1/U26/49PNS', '/upload/cover_img/0515-1-U26-49PNS-F1.jpg', '/upload/product/watermark/1616647671853760420.jpg', NULL, NULL, 3, 1, 2, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '90', NULL, '7', '/upload/product/product/0515-1-U26-49PNS-PZ1.jpg', 830, NULL, '2020-09-09 17:48:38', '2020-10-13 11:15:29', 0, 0, NULL, '', '11600007', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M4螺丝配套筒', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0515-1-U26-49PNS-F1.jpg'),
	(319, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F1.jpg', '/upload/product/watermark/1616815175813888626.jpg', NULL, NULL, 6, 7, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-UG1.jpg', 890, NULL, '2020-09-09 17:48:38', '2020-09-25 16:45:38', 0, 0, NULL, '', '11600445', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F1.jpg'),
	(320, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F4.jpg', '/upload/product/watermark/1616815349713240318.jpg', NULL, NULL, 6, 7, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-UG2.jpg', 890, NULL, '2020-09-09 17:48:38', '2020-09-25 16:45:51', 0, 0, NULL, '', '11600482', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F4.jpg'),
	(321, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9.jpg', '/upload/product/watermark/1616140834352962318.jpg', NULL, NULL, 6, 7, 10, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-UG3.jpg', 890, NULL, '2020-09-09 17:48:38', '2020-09-25 16:46:02', 0, 0, NULL, '', '11600494', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9.jpg'),
	(322, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F1.jpg', '/upload/product/watermark/1616125671224596164.jpg', NULL, NULL, 6, 8, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-PZ1.jpg', 890, NULL, '2020-09-09 17:48:38', '2020-09-25 16:46:16', 0, 0, NULL, '', '11600548', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F1.jpg'),
	(323, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F4.jpg', '/upload/product/watermark/1604964432104200370.jpg', NULL, NULL, 6, 8, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-PZ2.jpg', 890, NULL, '2020-09-09 17:48:38', '2020-09-25 16:46:30', 0, 0, NULL, '', '11600561', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F4.jpg'),
	(324, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9.jpg', '/upload/product/watermark/1615262024672803777.jpg', NULL, NULL, 6, 8, 10, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-PZ3.jpg', 890, NULL, '2020-09-09 17:48:38', '2020-09-25 16:46:40', 0, 0, NULL, '', '11600573', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9.jpg'),
	(340, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 16, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4520.jpg', 828, NULL, '2020-09-09 17:48:38', '2020-09-15 10:57:16', 0, 0, NULL, '', '11605224', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL451.jpg'),
	(341, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F3.jpg', '/upload/product/watermark/1616661553350830879.jpg', NULL, NULL, 7, NULL, 7, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0515-1-US9525.jpg', 710, NULL, '2020-09-09 17:48:38', '2020-09-25 15:02:53', 0, 0, NULL, '', '11610578', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F3 铝金色', '', '/upload/cover_img/0515-1-US952-F3.jpg'),
	(342, 40, '1737/843K/843KS', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F9714M.jpg', '/upload/product/watermark/1610077382707874622.jpg', NULL, NULL, 1, 1, 16, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1737-843K-843KS-PZ1.jpg', 831, NULL, '2020-09-09 17:48:38', '2020-09-14 16:10:39', 0, 1, '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F9714M-Motiv1-nW.png', '', '11621199', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F9714M1.jpg'),
	(343, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL452.jpg', NULL, NULL, NULL, 1, 3, 16, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4521.jpg', 828, NULL, '2020-09-09 17:48:38', '2020-09-15 10:57:35', 0, 0, NULL, '', '11621278', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL453.jpg'),
	(344, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL454.jpg', NULL, NULL, NULL, 1, 3, 16, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '48-53', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4522.jpg', 828, NULL, '2020-09-09 17:48:38', '2020-09-15 10:58:27', 0, 0, NULL, '', '11621285', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9714M-MSK91-OL455.jpg'),
	(345, 28, '1643/845', '/upload/product/product/1643-845-F9714M.jpg', '/upload/product/watermark/1616638008244108148.jpg', NULL, NULL, 1, NULL, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/1643-845.jpg', 889, NULL, '2020-09-09 17:48:38', '2020-10-13 19:29:15', 0, 1, '/upload/product/product/1643-845-846S-PZ-F9714M-Motiv1-nW.png', '', '11621849', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1643-845-F9714M1.jpg'),
	(346, 27, 'HS-E0400F-25/431N-AS/420', '/upload/product/product/HS-E0400F-25-431N-AS-420-UG-F31-1+69.jpg', '/upload/product/watermark/1616814524320735105.jpg', NULL, NULL, 6, 7, 90, 2, 1, '', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-420-UG.jpg', 990, NULL, '2020-09-09 17:48:39', '2020-10-13 11:51:41', 0, 0, NULL, '', '11622258', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-420-UG-F31-1+691.jpg'),
	(347, 27, 'HS-E0400F-25/431N-AS/420', '/upload/product/product/HS-E0400F-25-431N-AS-420-PZ69-F31-1+69.jpg', '/upload/product/watermark/1616562029287744062.jpg', NULL, NULL, 6, 8, 90, 2, 1, '', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-420-PZ.jpg', 990, NULL, '2020-09-09 17:48:39', '2020-10-13 11:50:50', 0, 0, NULL, '', '11622265', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-420-PZ69-F31-1+691.jpg'),
	(348, 28, 'HS-M0643/419N-AS/423', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F77-R.jpg', '/upload/product/watermark/1616562034057975335.jpg', NULL, NULL, 6, 7, 27, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0643-419N-AS-423-UG.jpg', 940, NULL, '2020-09-09 17:48:39', '2020-09-25 16:16:07', 0, 0, NULL, '', '11622271', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F77-R.jpg'),
	(349, 28, 'HS-M0643/419N-AS/423', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F77-R.jpg', '/upload/product/watermark/1616814760667939250.jpg', NULL, NULL, 6, 8, 27, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0643-419N-AS-423-PZ.jpg', 940, NULL, '2020-09-09 17:48:39', '2020-09-25 16:16:26', 0, 0, NULL, '', '11622295', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F77-R.jpg'),
	(350, 28, 'HS-M0643/419N-AS/423', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F41-R.jpg', '/upload/product/watermark/1615534845695675125.jpg', NULL, NULL, 6, 7, 18, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0643-419N-AS-423-UG1.jpg', 940, NULL, '2020-09-09 17:48:39', '2020-09-25 16:16:44', 0, 0, NULL, '', '11622313', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F41-R.jpg'),
	(351, 28, 'HS-M0643/419N-AS/423', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F41-R.jpg', '/upload/product/watermark/1616814933194281487.jpg', NULL, NULL, 6, 8, 18, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0643-419N-AS-423-PZ1.jpg', 940, NULL, '2020-09-09 17:48:39', '2020-09-25 16:17:04', 0, 0, NULL, '', '11622581', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F41-R.jpg'),
	(352, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F1.jpg', '/upload/product/watermark/1616978886620920369.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0515-1-US9524.jpg', 710, NULL, '2020-09-09 17:48:39', '2020-09-25 15:02:46', 0, 0, NULL, '', '11626604', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0515-1-US952-F1.jpg'),
	(353, 47, 'AR810', '/upload/product/product/古铜色2.jpg', '/upload/product/watermark/1616722263884388890.jpg', NULL, NULL, 10, 4, 80, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR810-S-601.jpg', 990, NULL, '2020-09-09 17:48:39', '2020-10-26 11:53:10', 0, 0, NULL, '', '50010475', NULL, NULL, NULL, NULL, NULL, NULL, '72', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '直角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '/assets/img/icon_sk.png', '/upload/product/product/古铜色21.jpg'),
	(354, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL452.jpg', '/upload/product/watermark/1605239268481727849.jpg', NULL, NULL, 1, 3, 14, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '33-38', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4517.jpg', 828, NULL, '2020-09-09 17:48:39', '2020-09-15 10:56:04', 0, 0, NULL, '', '11633189', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL453.jpg'),
	(355, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL454.jpg', NULL, NULL, NULL, 1, 3, 14, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4518.jpg', 828, NULL, '2020-09-09 17:48:39', '2020-09-15 10:56:27', 0, 0, NULL, '', '11633190', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL455.jpg'),
	(356, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL456.jpg', NULL, NULL, NULL, 1, 3, 14, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '48-53', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4519.jpg', 828, NULL, '2020-09-09 17:48:39', '2020-09-15 10:56:46', 0, 0, NULL, '', '11633207', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL457.jpg'),
	(357, 47, 'M846S', '/upload/product/product/M846S-PZ-F9016M.jpg', '/upload/product/watermark/1603599487076945725.jpg', NULL, NULL, 1, 1, 14, 1, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ8.jpg', 827, NULL, '2020-09-09 17:48:39', '2020-09-15 17:14:35', 0, 0, NULL, '', '11633542', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/icon_sk11.png', '/upload/product/product/M846S-PZ-F9016M1.jpg'),
	(358, 28, '1643/845', '/upload/cover_img/1643-845-F9016M.jpg', '/upload/product/watermark/1616639085766608564.jpg', NULL, NULL, 1, NULL, 88, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/1643-845.jpg', 889, 1, '2020-09-09 17:48:39', '2020-10-13 19:29:03', 0, 1, '/upload/product/product/1643-845-846S-PZ-F9016-Motiv1-nW.png', '', '11633591', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/cover_img/1643-845-F9016M.jpg'),
	(359, 24, '1140/845', '/upload/cover_img/1140-845-F9016M.jpg', '/upload/product/watermark/1616947764434255142.jpg', NULL, NULL, 1, NULL, 88, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/1140-845.jpg', 834, NULL, '2020-09-09 17:48:39', '2020-10-13 19:32:23', 0, 1, '/upload/product/product/1140-845-F9016-Motiv1-nW.png', '', '11634054', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/cover_img/1140-845-F9016M.jpg'),
	(360, 28, 'HS-M0643/419N-AS/423', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F49-R.jpg', '/upload/product/watermark/1616653326447623398.jpg', NULL, NULL, 6, 7, 21, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0643-419N-AS-423-UG2.jpg', 940, NULL, '2020-09-09 17:48:39', '2020-09-25 16:17:21', 0, 0, NULL, '', '11639465', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0643-419N-AS-423-PZ69-F49-R.jpg'),
	(361, 31, 'HS-M0642/419N-AS/423', '/upload/cover_img/HS-M0642-419N-AS-423-UG-F41-R.jpg', '/upload/product/watermark/1616815231485378898.jpg', NULL, NULL, 6, 7, 18, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0642-419N-AS-423-UG2.jpg', 910, NULL, '2020-09-09 17:48:39', '2020-09-25 16:35:19', 0, 0, NULL, '', '11640121', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0642-419N-AS-423-UG-F41-R.jpg'),
	(362, 47, 'AR810', '/upload/product/product/AR810-S-60-BLK.jpg', '/upload/product/watermark/1616738297880899528.jpg', NULL, NULL, 10, 4, 79, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR810-S-60.jpg', 990, 1, '2020-09-09 17:48:40', '2020-09-30 13:08:39', 0, 0, NULL, '', '50010888', NULL, NULL, NULL, NULL, NULL, NULL, '72', '', NULL, '通过 BS EN1634-1。适用于30和60 分钟木制防火门。', '60', '直角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '/assets/img/icon_sk.png', ''),
	(363, 31, 'HS-M0642/419N-AS/423', '/upload/cover_img/HS-M0642-419N-AS-423-UG-F49-R.jpg', '/upload/product/watermark/1614039982546770920.jpg', NULL, NULL, 6, 7, 21, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0642-419N-AS-423-UG.jpg', 910, NULL, '2020-09-09 17:48:40', '2020-09-25 16:34:27', 0, 0, NULL, '', '11641685', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0642-419N-AS-423-UG-F49-R.jpg'),
	(364, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F1.jpg', '/upload/product/watermark/1615467250199166551.jpg', NULL, NULL, 6, 8, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-PZ1.jpg', 950, NULL, '2020-09-09 17:48:40', '2020-09-25 16:13:07', 0, 0, NULL, '', '11642185', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F1.jpg'),
	(365, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F9.jpg', '/upload/product/watermark/1616814744690151907.jpg', NULL, NULL, 6, 8, 10, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-PZ2.jpg', 950, NULL, '2020-09-09 17:48:40', '2020-09-25 16:13:23', 0, 0, NULL, '', '11642233', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F9.jpg'),
	(366, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F9.jpg', '/upload/product/watermark/1616037896713814481.jpg', NULL, NULL, 6, 7, 10, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-UG2.jpg', 950, NULL, '2020-09-09 17:48:40', '2020-09-25 16:13:42', 0, 0, NULL, '', '11642245', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F9.jpg'),
	(367, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-PZ69-F9714M.jpg', '/upload/product/watermark/1610339684304530666.jpg', NULL, NULL, 6, 7, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-UG3.jpg', 950, NULL, '2020-09-09 17:48:40', '2020-09-25 16:13:55', 0, 0, NULL, '', '11642270', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-PZ69-F9714M.jpg'),
	(368, 31, 'HS-M0642/419N-AS/423', '/upload/cover_img/HS-M0642-419N-AS-423-PZ69-F77-R.jpg', '/upload/product/watermark/1606274923727660202.jpg', NULL, NULL, 6, 7, 27, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0642-419N-AS-423-UG1.jpg', 910, NULL, '2020-09-09 17:48:40', '2020-09-25 16:34:42', 0, 0, NULL, '', '11643018', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0642-419N-AS-423-PZ69-F77-R.jpg'),
	(369, 31, 'HS-M0642/419N-AS/423', '/upload/cover_img/HS-M0642-419N-AS-423-PZ69-F77-R.jpg', '/upload/product/watermark/1604800161912173864.jpg', NULL, NULL, 6, 8, 27, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0642-419N-AS-423-PZ.jpg', 910, NULL, '2020-09-09 17:48:40', '2020-09-25 16:34:53', 0, 0, NULL, '', '11643031', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F77-R 铜色, 抛光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0642-419N-AS-423-PZ69-F77-R.jpg'),
	(370, 31, 'HS-M0642/419N-AS/423', '/upload/cover_img/HS-M0642-419N-AS-423-UG-F41-R.jpg', '/upload/product/watermark/1604964420008180352.jpg', NULL, NULL, 6, 8, 18, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-M0642-419N-AS-423-PZ1.jpg', 910, NULL, '2020-09-09 17:48:40', '2020-09-25 16:35:07', 0, 0, NULL, '', '11643079', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F41-R 镀铬拉丝', '/assets/img/icon_sk.png', '/upload/cover_img/HS-M0642-419N-AS-423-UG-F41-R.jpg'),
	(371, 27, 'E1400Z/42K/42KS', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F97-1-R.jpg', '/upload/product/watermark/1607442128869597391.jpg', NULL, NULL, 1, 1, 74, 2, 1, '1,4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-42K-42KS-PZ1.jpg', 898, NULL, '2020-09-09 17:48:40', '2020-09-14 15:45:44', 0, 1, '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F97-1-R-Motiv1-nW.png', '', '11647048', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F97-1-R1.jpg'),
	(372, 27, 'E1400Z/42K/42KS', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F78-1-R.jpg', '/upload/product/watermark/1615996617603514410.jpg', NULL, NULL, 1, 1, 71, 2, 1, '1,4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-42K-42KS-PZ2.jpg', 898, NULL, '2020-09-09 17:48:40', '2020-09-14 15:46:25', 0, 1, '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F78-1-R-Motiv2-nW.png', '', '11647061', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F78-1-R1.jpg'),
	(373, 27, 'E1400Z/42K/42KS', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F96-1-R.jpg', '/upload/product/watermark/1615996214613372857.jpg', NULL, NULL, 1, 1, 73, 2, 1, '1,4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-42K-42KS-PZ3.jpg', 898, NULL, '2020-09-09 17:48:40', '2020-09-14 15:46:45', 0, 1, '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F96-1-R-Motiv1-nW.png', '', '11647073', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F96-1-R1.jpg'),
	(374, 27, 'E1400Z/42K/42KS', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F84-1-R.jpg', '/upload/product/watermark/1616903289620931132.jpg', NULL, NULL, 1, 1, 72, 2, 1, '1,4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-42K-42KS-PZ4.jpg', 898, 1, '2020-09-09 17:48:40', '2020-09-14 15:47:05', 0, 1, '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F84-1-R-Motiv1-nW.png', '', '11647085', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-42K+KV-42KS+KVS-PZ-F84-1-R1.jpg'),
	(375, 28, '1643/52K/52KS', '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F9714M.jpg', '/upload/product/watermark/1615997816643258215.jpg', NULL, NULL, 1, 1, 16, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-65', NULL, '8', '/upload/product/product/1643-52K-52KS-PZ.jpg', 890, NULL, '2020-09-09 17:48:40', '2020-09-14 15:51:30', 0, 1, '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F9714M-Motiv1-nW.png', '', '11645349', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1643-52K+KV-52KS+KVS-PZ-F9714M1.jpg'),
	(376, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9714M.jpg', '/upload/product/watermark/1614932514401356737.jpg', NULL, NULL, 6, 7, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-UG.jpg', 890, NULL, '2020-09-09 17:48:40', '2020-09-25 16:45:02', 0, 0, NULL, '', '11645325', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9714M.jpg'),
	(377, 40, 'HS-0737/419N-AS/420', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9714M.jpg', '/upload/product/watermark/1607341288395193895.jpg', NULL, NULL, 6, 8, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0737-419N-AS-420-PZ.jpg', 890, NULL, '2020-09-09 17:48:40', '2020-09-25 16:45:23', 0, 0, NULL, '', '11645635', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0737-419N-AS-420-PZ69-F9714M.jpg'),
	(378, 24, '1140/845', '/upload/cover_img/1140-845-F9714M.jpg', '/upload/product/watermark/1616947735855040642.jpg', NULL, NULL, 1, NULL, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/1140-845.jpg', 834, 1, '2020-09-09 17:48:41', '2020-10-13 19:32:13', 1, 1, '/upload/product/product/1140-845-F9714M-Motiv1-nW1.png', '', '11650005', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1140-845-F9714M.jpg'),
	(379, 27, 'E0400/US956', '/upload/cover_img/E0400-US956-F97-1-R.jpg', '/upload/product/watermark/1614855607770294507.jpg', NULL, NULL, 7, NULL, 74, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0400-US956.jpg', 970, NULL, '2020-09-09 17:48:41', '2020-09-25 11:38:01', 0, 0, NULL, '', '11649215', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/E0400-US956-F97-1-R.jpg'),
	(380, 27, 'E0400/US956', '/upload/cover_img/E0400-US956-F78-1-R.jpg', '/upload/product/watermark/1616378041348994394.jpg', NULL, NULL, 7, NULL, 71, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0400-US956.jpg', 970, NULL, '2020-09-09 17:48:41', '2020-09-25 11:38:04', 0, 0, NULL, '', '11649227', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/E0400-US956-F78-1-R.jpg'),
	(381, 27, 'E0400/US956', '/upload/cover_img/E0400-US956-F96-1-R.jpg', '/upload/product/watermark/1614855608621257694.jpg', NULL, NULL, 7, NULL, 73, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0400-US956.jpg', 970, NULL, '2020-09-09 17:48:41', '2020-09-25 11:38:08', 0, 0, NULL, '', '11649240', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/E0400-US956-F96-1-R.jpg'),
	(382, 27, 'E0400/US956', '/upload/cover_img/E0400-US956-F84-1-R.jpg', '/upload/product/watermark/1616809532010704315.jpg', NULL, NULL, 7, NULL, 72, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/E0400-US956.jpg', 970, 1, '2020-09-09 17:48:41', '2020-09-25 11:38:13', 0, 0, NULL, '', '11649252', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/E0400-US956-F84-1-R.jpg'),
	(383, 28, 'M1643/845', '/upload/cover_img/M1643-845-F49-R.jpg', '/upload/product/watermark/1616046860995311096.jpg', NULL, NULL, 1, NULL, 21, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '30-44', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:41', '2020-10-25 16:35:16', 0, 0, NULL, '', '11651994', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-845-F49-R.jpg'),
	(384, 47, '844PS', '/upload/cover_img/844PS-PZ-F1.jpg', '/upload/product/watermark/1610545691438088373.jpg', NULL, NULL, 3, 1, 2, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/844PS-PZ.jpg', 810, NULL, '2020-09-09 17:48:41', '2020-12-04 14:31:32', 0, 0, NULL, '', '11509855', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，多用螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/844PS-PZ-F1.jpg'),
	(385, 27, 'E1400Z/845', '/upload/product/product/E1400Z-845-F97-1-R.jpg', '/upload/product/watermark/1611630885235518681.jpg', NULL, NULL, 1, NULL, 74, 2, 1, '1,4', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '36-54', NULL, '8', '/upload/product/product/E1400Z-8452.jpg', 897, NULL, '2020-09-09 17:48:41', '2020-10-13 19:28:42', 0, 0, NULL, '', '11658733', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-845-F97-1-R1.jpg'),
	(386, 27, 'E1400Z/845', '/upload/product/product/E1400Z-845-F78-1-R.jpg', '/upload/product/watermark/1616637856100149890.jpg', NULL, NULL, 1, NULL, 71, 2, 1, '1,4', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '36-54', NULL, '8', '/upload/product/product/E1400Z-8453.jpg', 897, 1, '2020-09-09 17:48:41', '2020-10-13 19:28:31', 0, 0, NULL, '', '11658757', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-845-F78-1-R1.jpg'),
	(387, 27, 'E1400Z/845', '/upload/product/product/E1400Z-845-F96-1-R.jpg', '/upload/product/watermark/1615873332375005554.jpg', NULL, NULL, 1, NULL, 73, 2, 1, '1,4', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '36-54', NULL, '8', '/upload/product/product/E1400Z-8454.jpg', 897, NULL, '2020-09-09 17:48:41', '2020-10-13 19:28:47', 0, 0, NULL, '', '11658769', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-845-F96-1-R1.jpg'),
	(388, 27, 'E1400Z/845', '/upload/product/product/E1400Z-845-F84-1-R.jpg', '/upload/product/watermark/1616079901403414968.jpg', NULL, NULL, 1, NULL, 72, 2, 1, '1,4', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '36-54', NULL, '8', '/upload/product/product/E1400Z-8451.jpg', 897, NULL, '2020-09-09 17:48:41', '2020-10-13 19:28:53', 0, 0, NULL, '', '11658794', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/E1400Z-845-F84-1-R1.jpg'),
	(389, 27, '1400/845', '/upload/cover_img/1400-845-F9714M.jpg', '/upload/product/watermark/1616947948603158307.jpg', NULL, NULL, 1, NULL, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/img_sample/1400-845.jpg', 899, 1, '2020-09-09 17:48:41', '2020-10-13 11:08:27', 0, 0, NULL, '', '11659130', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1400-845-F9714M.jpg'),
	(390, 40, '1737/843K/843KS', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F9016M.jpg', '/upload/product/watermark/1615851293704295780.jpg', NULL, NULL, 1, 1, 88, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1737-843K-843KS-PZ.jpg', 831, NULL, '2020-09-09 17:48:41', '2020-10-13 11:32:20', 0, 0, NULL, '', '11659725', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/product/product/1737-843K+KV-843KS+KVS-PZ-F9016M1.jpg'),
	(391, 39, '0808/US10', '/upload/cover_img/0808-US10-F1.jpg', '/upload/product/watermark/1616810271465604953.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0808-US10.jpg', 890, 1, '2020-09-09 17:48:41', '2020-09-25 13:53:29', 0, 0, NULL, '', '11661884', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0808-US10-F1.jpg'),
	(392, 39, '0808/US10', '/upload/cover_img/0808-US10-F4.jpg', NULL, NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0808-US10.jpg', 890, NULL, '2020-09-09 17:48:42', '2020-09-25 13:53:43', 0, 0, NULL, '', '11661896', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0808-US10-F4.jpg'),
	(393, 43, '1540/3347N', '/upload/product/product/1540-3347N-PZ92-F1.jpg', '/upload/product/watermark/1616817025415394313.jpg', NULL, NULL, 3, 1, 2, 3, 1, '1', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1540-3347N-PZ1.jpg', 900, NULL, '2020-09-09 17:48:42', '2020-09-21 16:28:45', 0, 0, NULL, '', '11669962', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1540-3347N-PZ92-F11.jpg'),
	(394, 43, '1540/3347N', '/upload/product/product/1540-3347N-PZ92-F9.jpg', '/upload/product/watermark/1614915052344409300.jpg', NULL, NULL, 3, 1, 10, 3, 1, '1', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1540-3347N-PZ2.jpg', 900, NULL, '2020-09-09 17:48:42', '2020-09-21 16:29:03', 0, 0, '/upload/product/product/1540-3347N-PZ92-F9-Motiv1-nW.png', '', '11670605', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1540-3347N-PZ92-F91.jpg'),
	(395, 43, '1540/3347N', '/upload/product/product/1540-3347N-PZ92-F9714M.jpg', '/upload/product/watermark/1614914664499433672.jpg', NULL, NULL, 3, 1, 16, 3, 1, '1', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1540-3347N-PZ3.jpg', 900, NULL, '2020-09-09 17:48:42', '2020-09-21 16:29:24', 0, 0, NULL, '', '11670861', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1540-3347N-PZ92-F9714M1.jpg'),
	(396, 30, '1810/3347N', '/upload/product/product/1810-3347N-PZ92-F1.jpg', '/upload/product/watermark/1616817044271167737.jpg', NULL, NULL, 3, 6, 2, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1810-3347N-PZ2.jpg', 880, 1, '2020-09-09 17:48:42', '2020-09-25 10:43:35', 0, 0, '/upload/product/product/1810-3347N-PZ92-F1-Motiv1-nW.png', '', '11671355', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/1810-3347N-PZ92-F1-aussen.jpg'),
	(397, 30, '1810/3347N', '/upload/product/product/1810-3347N-PZ92-F9.jpg', '/upload/product/watermark/1615250583519546353.jpg', NULL, NULL, 3, 6, 10, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1810-3347N-PZ3.jpg', 880, 0, '2020-09-09 17:48:42', '2020-09-25 10:43:40', 0, 0, NULL, '', '11671464', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1810-3347N-PZ92-F91.jpg'),
	(398, 30, '1810/3347N', '/upload/product/product/1810-3347N-PZ92-F9714M.jpg', '/upload/product/watermark/1607063113929690015.jpg', NULL, NULL, 3, 6, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1810-3347N-PZ1.jpg', 880, NULL, '2020-09-09 17:48:43', '2020-09-25 10:43:25', 0, 0, NULL, '', '11671476', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1810-3347N-PZ92-F9714M1.jpg'),
	(399, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F1.jpg', '/upload/product/watermark/1602568822481532979.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0515-1-US9523.jpg', 710, NULL, '2020-09-09 17:48:43', '2020-09-25 15:02:31', 0, 0, NULL, '', '11676814', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0515-1-US952-F1.jpg'),
	(400, 34, '0558/US945', '/upload/cover_img/0558-US945-F1-11-F1.jpg', '/upload/product/watermark/1616978877350918446.jpg', NULL, NULL, 7, NULL, 4, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '20-30', '7', '/upload/img_sample/0558-US945.jpg', 920, NULL, '2020-09-09 17:48:43', '2020-09-25 13:45:29', 0, 0, NULL, '', '11679323', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1-11 亮银色/哑光', '', '/upload/cover_img/0558-US945-F1-11-F1.jpg'),
	(401, 34, '0558/US945', '/upload/cover_img/0558-US945-F4-11-F4.jpg', '/upload/product/watermark/1616636460126859551.jpg', NULL, NULL, 7, NULL, 9, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '20-30', '7', '/upload/img_sample/0558-US945.jpg', 920, NULL, '2020-09-09 17:48:43', '2020-10-13 10:54:53', 0, 0, NULL, '', '11679414', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4-11 古铜光亮/哑光', '', '/upload/cover_img/0558-US945-F4-11-F4.jpg'),
	(402, 40, 'PSK-0737/US947-1', '/upload/cover_img/PSK-0737-US947-1-F1-2-S.jpg', '/upload/product/watermark/1610524796595459014.jpg', NULL, NULL, 8, NULL, 3, 3, 1, '2,3,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-0737-US947-1.jpg', 930, NULL, '2020-09-09 17:48:43', '2020-09-30 10:17:04', 0, 0, NULL, '', '11680143', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1-2-S 哑光银色', '', '/upload/cover_img/PSK-0737-US947-1-F1-2-S.jpg'),
	(403, 47, 'E5095', '/upload/product/product/E5095-1000-F69.jpg', '/upload/product/watermark/1615441673598559467.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-10001.jpg', 900, NULL, '2020-09-09 17:48:43', '2020-09-21 13:26:19', 0, 0, NULL, '', '11681378', NULL, NULL, NULL, NULL, '一支', '1000mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5095-1000-F691.jpg'),
	(404, 42, '0715/US945', '/upload/cover_img/0715-US945-F4.jpg', '/upload/product/watermark/1616557613762695225.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0715-US945.jpg', 880, NULL, '2020-09-09 17:48:44', '2020-09-25 13:55:58', 0, 0, NULL, '', '11681949', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0715-US945-F4.jpg'),
	(405, 47, 'E5095AC', '/upload/product/product/IMG-PRO-E5095AC-1000-F69-SALL-AIN-V1.jpg', '/upload/product/watermark/1616745610846243532.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-E5095AC-1000-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:44', '2020-10-13 20:11:12', 0, 0, NULL, '', '11681299', NULL, NULL, NULL, NULL, '套', '1000mm', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 指纹开启 – HOPPE 好博 D 型截面 U 型不锈钢拉手：</p><ul style="padding: 0px 0px 0px 20px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; list-style-position: initial; list-style-image: initial; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);" class=" list-paddingleft-2"><li><p>安装： 暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 +60 °C</p></li><li><p>相对空气湿度：耐湿度可高达 95 %</p></li><li><p>指纹扫描：线性感应器</p></li><li><p>存储量：最大 150 个指纹信息</p></li><li><p>耐用性：&gt; 2百万次</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 500 mA（最高）</p></li><li><p>安全级别：IP 65</p></li><li><p><span style="color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255);">电气连接： 通用（可选正或负控制脉冲）</span><span style="color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255);"></span></p></li><li><p>附件：供货范围内包含带电池的红外线遥控器（CR 2025 型）和带有集成控制单元的接线</p></li></ul><p><br/></p>', NULL, NULL, 'F69 不锈钢磨砂', '', ''),
	(406, 47, 'E5095AC', '/upload/product/product/IMG-PRO-E5095AC-1200-F69-SALL-AIN-V1.jpg', '/upload/product/watermark/1615468879847255722.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', NULL, NULL, NULL, '/upload/product/product/DRW-CAT-E5095AC-1200-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:44', '2020-10-13 15:06:11', 0, 0, NULL, '', '11681305', NULL, NULL, NULL, NULL, '套', '1200mm', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 指纹开启 – HOPPE 好博 D 型截面 U 型不锈钢拉手：</p><ul style="padding: 0px 0px 0px 20px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; list-style-position: initial; list-style-image: initial; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);" class=" list-paddingleft-2"><li><p>安装： 暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 +60 °C</p></li><li><p>相对空气湿度：耐湿度可高达 95 %</p></li><li><p>指纹扫描：线性感应器</p></li><li><p>存储量：最大 150 个指纹信息</p></li><li><p>耐用性：&gt; 2百万次</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 500 mA（最高）</p></li><li><p>安全级别：IP 65</p></li><li><p><span style="color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255);">电气连接： 通用（可选正或负控制脉冲）</span></p></li><li><p>附件：供货范围内包含带电池的红外线遥控器（CR 2025 型）和带有集成控制单元的接线</p></li></ul><p><br/></p>', NULL, NULL, 'F69 不锈钢磨砂', '', ''),
	(407, 47, 'E5095AC', '/upload/product/product/IMG-PRO-E5095AC-1400-F69-SALL-AIN-V1.jpg', '/upload/product/watermark/1612854009625247470.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-E5095AC-1400-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:44', '2020-10-13 15:06:18', 0, 0, NULL, '', '11681317', NULL, NULL, NULL, NULL, '套', '1400mm', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 指纹开启 – HOPPE 好博 D 型截面 U 型不锈钢拉手：</p><ul style="padding: 0px 0px 0px 20px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; list-style-position: initial; list-style-image: initial; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);" class=" list-paddingleft-2"><li><p>安装： 暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 +60 °C</p></li><li><p>相对空气湿度：耐湿度可高达 95 %</p></li><li><p>指纹扫描：线性感应器</p></li><li><p>存储量：最大 150 个指纹信息</p></li><li><p>耐用性：&gt; 2百万次</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 500 mA（最高）</p></li><li><p>安全级别：IP 65</p></li><li><p><span style="color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255);">电气连接： 通用（可选正或负控制脉冲）</span></p></li><li><p>附件：供货范围内包含带电池的红外线遥控器（CR 2025 型）和带有集成控制单元的接线</p></li></ul><p><br/></p>', NULL, NULL, 'F69 不锈钢磨砂', '', ''),
	(408, 47, 'E5095AC', '/upload/product/product/IMG-PRO-E5095AC-1600-F69-SALL-AIN-V1.jpg', '/upload/product/watermark/1615877488276122030.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/DRW-CAT-E5095AC-1600-SALL-AOF-V1.jpg', 980, NULL, '2020-09-09 17:48:44', '2020-10-13 15:06:24', 0, 0, NULL, '', '11681330', NULL, NULL, NULL, NULL, '套', '1600mm', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="margin-top: 0px; margin-bottom: 0px; padding: 0px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 指纹开启 – HOPPE 好博 D 型截面 U 型不锈钢拉手：</p><ul style="padding: 0px 0px 0px 20px; border: 0px; font-size: 13px; font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; vertical-align: baseline; list-style-position: initial; list-style-image: initial; color: rgb(80, 80, 80); white-space: normal; background-color: rgb(255, 255, 255);" class=" list-paddingleft-2"><li><p>安装： 暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 +60 °C</p></li><li><p>相对空气湿度：耐湿度可高达 95 %</p></li><li><p>指纹扫描：线性感应器</p></li><li><p>存储量：最大 150 个指纹信息</p></li><li><p>耐用性：&gt; 2百万次</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 500 mA（最高）</p></li><li><p>安全级别：IP 65</p></li><li><p><span style="color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; background-color: rgb(255, 255, 255);">电气连接： 通用（可选正或负控制脉冲）</span></p></li><li><p>附件：供货范围内包含带电池的红外线遥控器（CR 2025 型）和带有集成控制单元的接线</p></li></ul><p><br/></p>', NULL, NULL, 'F69 不锈钢磨砂', '', ''),
	(413, 47, 'E5091', '/upload/product/product/E5091-1000-700-F69.jpg', '/upload/product/watermark/1615517659901213081.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1000-7001.jpg', 910, NULL, '2020-09-09 17:48:44', '2020-09-21 13:18:55', 0, 0, NULL, '', '11681408', NULL, NULL, NULL, NULL, '一支', '700mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5091-1000-700-F691.jpg'),
	(414, 47, 'E5091', '/upload/product/product/E5091-1200-900-F69.jpg', '/upload/product/watermark/1610439816723560021.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1200-9001.jpg', 910, NULL, '2020-09-09 17:48:44', '2020-09-21 13:19:03', 0, 0, NULL, '', '11681415', NULL, NULL, NULL, NULL, '一支', '900mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5091-1200-900-F691.jpg'),
	(415, 47, 'E5091', '/upload/product/product/E5091-1400-1000-F69.jpg', '/upload/product/watermark/1609920125589971929.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1400-10001.jpg', 910, NULL, '2020-09-09 17:48:44', '2020-09-21 13:19:11', 0, 0, NULL, '', '11681421', NULL, NULL, NULL, NULL, '一支', '1000mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5091-1400-1000-F691.jpg'),
	(416, 47, 'E5095', '/upload/product/product/E5095-1200-F69.jpg', '/upload/product/watermark/1614773564304823517.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-12001.jpg', 900, NULL, '2020-09-09 17:48:44', '2020-09-21 13:24:54', 0, 0, NULL, '', '11681445', NULL, NULL, NULL, NULL, '一支', '1200mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5095-1200-F691.jpg'),
	(417, 47, 'E5095', '/upload/product/product/E5095-1400-F69.jpg', '/upload/product/watermark/1606386370696308596.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-14001.jpg', 900, NULL, '2020-09-09 17:48:44', '2020-09-21 13:25:22', 0, 0, NULL, '', '11681457', NULL, NULL, NULL, NULL, '一支', '1400mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5095-1400-F691.jpg'),
	(418, 47, 'E5095', '/upload/product/product/E5095-1600-F69.jpg', '/upload/product/watermark/1615441670838751140.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-16001.jpg', 900, NULL, '2020-09-09 17:48:44', '2020-09-21 13:25:49', 0, 0, NULL, '', '11681469', NULL, NULL, NULL, NULL, '一支', '1600mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5095-1600-F691.jpg'),
	(419, 47, 'E5091', '/upload/product/product/E5091-1600-1200-F69.jpg', '/upload/product/watermark/1607443950292160957.jpg', NULL, NULL, 5, NULL, 17, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1600-12001.jpg', 910, NULL, '2020-09-09 17:48:44', '2020-09-21 13:19:19', 0, 0, NULL, '', '11681512', NULL, NULL, NULL, NULL, '一支', '1200mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F69 不锈钢磨砂', '', '/upload/product/product/E5091-1600-1200-F691.jpg'),
	(420, 33, '0751/US952', '/upload/cover_img/0751-US952-F1.jpg', '/upload/product/watermark/1616810220242780107.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0751-US952.jpg', 910, NULL, '2020-09-09 17:48:44', '2020-09-25 13:49:02', 0, 0, NULL, '', '11686674', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0751-US952-F1.jpg'),
	(421, 27, '1400/845', '/upload/cover_img/1400-845-F9016M.jpg', '/upload/product/watermark/1616921717452728848.jpg', NULL, NULL, 1, NULL, 88, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/img_sample/1400-845.jpg', 899, NULL, '2020-09-09 17:48:44', '2020-10-13 11:26:25', 1, 0, NULL, '', '11695766', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/cover_img/1400-845-F9016M.jpg'),
	(422, 31, 'M1642/845', '/upload/cover_img/M1642-845-F42-R.jpg', '/upload/product/watermark/1616578463973977621.jpg', NULL, NULL, 1, NULL, 19, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-54', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:44', '2020-10-13 19:31:46', 0, 0, NULL, '', '11698974', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F42-R 镀镍丝光', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-845-F42-R.jpg'),
	(423, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F4.jpg', '/upload/product/watermark/1616558117011082812.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:44', '2020-09-25 14:03:36', 0, 0, NULL, '', '11702448', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0700-UD9020-F4.jpg'),
	(424, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F9714M.jpg', '/upload/product/watermark/1616910794528696284.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:45', '2020-09-25 14:02:53', 0, 0, NULL, '', '11702455', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0700-UD9020-F9714M.jpg'),
	(425, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F1.jpg', '/upload/product/watermark/1616810361621170506.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:45', '2020-09-25 14:03:05', 0, 0, NULL, '', '11702485', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0700-UD9020-F1.jpg'),
	(426, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F31-1.jpg', '/upload/product/watermark/1616901768545768585.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0700-UD9020.jpg', 840, 1, '2020-09-09 17:48:45', '2020-09-25 14:03:09', 0, 0, NULL, '', '11702497', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0700-UD9020-F31-1.jpg'),
	(427, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F9714M.jpg', '/upload/product/watermark/1604797967930356362.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:45', '2020-09-25 14:03:13', 0, 0, NULL, '', '11703684', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0700-UD9020-F9714M.jpg'),
	(428, 34, '0558/US945', '/upload/cover_img/0558-US945-F9016.jpg', '/upload/product/watermark/1616636202316270229.jpg', NULL, NULL, 7, NULL, 14, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '20-30', '7', '/upload/img_sample/0558-US945.jpg', 920, NULL, '2020-09-09 17:48:45', '2020-09-25 13:45:10', 0, 0, NULL, '', '11704044', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9016 交通白', '', '/upload/cover_img/0558-US945-F9016.jpg'),
	(429, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F1.jpg', NULL, NULL, NULL, 7, NULL, 2, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:45', '2020-09-25 14:03:20', 0, 0, NULL, '', '11702898', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0700-UD9020-F1.jpg'),
	(430, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F4.jpg', NULL, NULL, NULL, 7, NULL, 8, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:45', '2020-09-25 14:03:25', 0, 0, NULL, '', '11702941', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0700-UD9020-F4.jpg'),
	(431, 45, '0700/UD9020', '/upload/cover_img/0700-UD9020-F31-1.jpg', NULL, NULL, NULL, 7, NULL, 12, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0700-UD9020.jpg', 840, NULL, '2020-09-09 17:48:45', '2020-09-25 14:03:31', 0, 0, NULL, '', '11702953', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0700-UD9020-F31-1.jpg'),
	(432, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F1.jpg', '/upload/product/watermark/1611290827259002548.jpg', NULL, NULL, 6, 7, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-UG1.jpg', 950, NULL, '2020-09-09 17:48:45', '2020-12-04 16:05:15', 0, 0, NULL, '', '11642191', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-1-UG-F1.jpg'),
	(433, 40, '1737/645', '/upload/cover_img/1737-645-F31-1.jpg', '/upload/product/watermark/1615441517376447110.jpg', NULL, NULL, 1, NULL, 12, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-50', NULL, '8', '/upload/img_sample/1737-645.jpg', 830, NULL, '2020-09-09 17:48:45', '2020-10-13 19:33:05', 0, 1, '/upload/product/product/1737-645-F31-1-Motiv1-nW.png', '', '11704573', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1737-645-F31-1.jpg'),
	(434, 40, '1737/645', '/upload/cover_img/1737-645-F9714M.jpg', '/upload/product/watermark/1614049763644856462.jpg', NULL, NULL, 1, NULL, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-50', NULL, '8', '/upload/img_sample/1737-645.jpg', 830, NULL, '2020-09-09 17:48:45', '2020-10-13 19:33:11', 0, 0, NULL, '', '11704627', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1737-645-F9714M.jpg'),
	(435, 40, '1737/645', '/upload/cover_img/1737-645-F9016M.jpg', '/upload/product/watermark/1610375372748195313.jpg', NULL, NULL, 1, NULL, 88, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '40-50', NULL, '8', '/upload/img_sample/1737-645.jpg', 830, NULL, '2020-09-09 17:48:45', '2020-10-13 19:33:19', 0, 1, '/upload/product/product/1737-645-F9016M-Motiv1-nW.png', '', '11704639', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/cover_img/1737-645-F9016M.jpg'),
	(436, 47, '645S', '/upload/product/product/645S-SK-OL-F31-1-SK802-OL462.jpg', '/upload/product/watermark/1615615929923139450.jpg', NULL, NULL, 1, 3, 12, 3, 1, '', NULL, '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/645S-SK-OL-SK802-OL464.jpg', 826, NULL, '2020-09-09 17:48:45', '2020-09-15 11:42:38', 0, 0, NULL, '', '11704640', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/upload/product/product/knob241.png', '/upload/product/product/645S-SK-OL-F31-1-SK802-OL463.jpg'),
	(437, 47, '645S', '/upload/product/product/645S-SK-OL-F9714M-SK802-OL462.jpg', '/upload/product/watermark/1616377591652813150.jpg', NULL, NULL, 1, 3, 16, 3, 1, '', NULL, '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/645S-SK-OL-SK802-OL465.jpg', 826, NULL, '2020-09-09 17:48:45', '2020-09-15 11:42:44', 0, 0, NULL, '', '11704664', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/knob241.png', '/upload/product/product/645S-SK-OL-F9714M-SK802-OL463.jpg'),
	(438, 47, '645S', '/upload/product/product/645S-SK-OL-F9016M-SK802-OL462.jpg', '/upload/product/watermark/1610346514494300973.jpg', NULL, NULL, 1, 3, 88, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '38-43', NULL, '5-8', '/upload/product/product/645S-SK-OL-SK802-OL463.jpg', 826, NULL, '2020-09-09 17:48:46', '2020-10-13 11:45:40', 0, 0, NULL, '', '11704695', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/knob241.png', '/upload/product/product/645S-SK-OL-F9016M-SK802-OL463.jpg'),
	(439, 47, '646S', '/upload/cover_img/646S-PZ-F31-1.jpg', '/upload/product/watermark/1609984830170781542.jpg', NULL, NULL, 1, 1, 12, 3, 1, '', NULL, NULL, NULL, NULL, '', '/upload/product/product/646S-PZ.jpg', 825, NULL, '2020-09-09 17:48:46', '2020-09-15 11:07:56', 0, 0, NULL, '', '11704780', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/upload/product/product/icon_sk7.png', '/upload/cover_img/646S-PZ-F31-1.jpg'),
	(440, 47, '646S', '/upload/cover_img/646S-PZ-F9714M.jpg', '/upload/product/watermark/1615616486119086914.jpg', NULL, NULL, 1, 1, 16, 3, 1, '', NULL, NULL, NULL, NULL, '', '/upload/product/product/646S-PZ1.jpg', 825, 1, '2020-09-09 17:48:46', '2020-09-15 11:08:08', 0, 0, NULL, '', '11704925', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/icon_sk7.png', '/upload/cover_img/646S-PZ-F9714M.jpg'),
	(441, 47, '646S', '/upload/cover_img/646S-PZ-F9016M.jpg', '/upload/product/watermark/1608779895473433573.jpg', NULL, NULL, 1, 1, 88, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/646S-PZ2.jpg', 825, NULL, '2020-09-09 17:48:46', '2020-10-13 11:45:58', 0, 0, NULL, '', '11704937', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/icon_sk7.png', '/upload/cover_img/646S-PZ-F9016M.jpg'),
	(442, 28, 'M1643/845', '/upload/product/product/M1643-845-F97-R.jpg', '/upload/product/watermark/1608789506993314241.jpg', NULL, NULL, 1, NULL, 35, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:34:40', 0, 0, NULL, '', '11717130', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F97-R1.jpg'),
	(443, 28, 'M1643/845', '/upload/product/product/M1643-845-F97-1-R.jpg', '/upload/product/watermark/1604997589604604873.jpg', NULL, NULL, 1, NULL, 36, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:34:44', 0, 0, NULL, '', '11717142', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F97-1-R1.jpg'),
	(444, 28, 'M1643/845', '/upload/product/product/M1643-845-F78-R.jpg', '/upload/product/watermark/1616732670976677738.jpg', NULL, NULL, 1, NULL, 29, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, 1, '2020-09-09 17:48:46', '2020-10-25 16:34:36', 0, 0, NULL, '', '11717154', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F78-R1.jpg'),
	(445, 28, 'M1643/845', '/upload/product/product/M1643-845-F78-1-R.jpg', '/upload/product/watermark/1616399744645369748.jpg', NULL, NULL, 1, NULL, 30, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:34:48', 0, 1, '/upload/product/product/M1643-845-F78-1-R-Motiv2-nW.png', '', '11717185', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F78-1-R1.jpg'),
	(446, 28, 'M1643/845', '/upload/product/product/M1643-845-F96-R.jpg', '/upload/product/watermark/1606313479373532127.jpg', NULL, NULL, 1, NULL, 33, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:34:53', 0, 0, NULL, '', '11717191', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F96-R1.jpg'),
	(447, 28, 'M1643/845', '/upload/product/product/M1643-845-F96-1-R.jpg', '/upload/product/watermark/1608787401043809833.jpg', NULL, NULL, 1, NULL, 34, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:34:59', 0, 0, NULL, '', '11717208', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F96-1-R1.jpg'),
	(448, 28, 'M1643/845', '/upload/product/product/M1643-845-F84-R.jpg', '/upload/product/watermark/1616732676898907047.jpg', NULL, NULL, 1, NULL, 31, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:35:05', 0, 0, NULL, '', '11717215', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F84-R1.jpg'),
	(449, 28, 'M1643/845', '/upload/product/product/M1643-845-F84-1-R.jpg', '/upload/product/watermark/1616732677570115235.jpg', NULL, NULL, 1, NULL, 32, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1643-845.jpg', 887, NULL, '2020-09-09 17:48:46', '2020-10-25 16:35:12', 0, 0, NULL, '', '11717221', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1643-845-F84-1-R1.jpg'),
	(450, 47, 'M846S', '/upload/cover_img/M846S-PZ-F97-R.jpg', '/upload/product/watermark/1611285731473349429.jpg', NULL, NULL, 1, 1, 35, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ5.jpg', 827, NULL, '2020-09-09 17:48:46', '2020-09-15 17:14:07', 0, 0, NULL, '', '11717270', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/icon_sk8.png', '/upload/cover_img/M846S-PZ-F97-R.jpg'),
	(451, 47, 'M846S', '/upload/cover_img/M846S-PZ-F97-1-R.jpg', '/upload/product/watermark/1611285727452042607.jpg', NULL, NULL, 1, 1, 36, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ6.jpg', 827, NULL, '2020-09-09 17:48:46', '2020-09-15 17:14:15', 0, 0, NULL, '', '11717294', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/icon_sk9.png', '/upload/cover_img/M846S-PZ-F97-1-R.jpg'),
	(452, 47, 'M846S', '/upload/cover_img/M846S-PZ-F78-R.jpg', '/upload/product/watermark/1611238074750950219.jpg', NULL, NULL, 1, 1, 29, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ7.jpg', 827, NULL, '2020-09-09 17:48:46', '2020-09-15 17:14:24', 0, 0, NULL, '', '11717312', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/icon_sk10.png', '/upload/cover_img/M846S-PZ-F78-R.jpg'),
	(453, 47, 'M846S', '/upload/cover_img/M846S-PZ-F78-1-R.jpg', '/upload/product/watermark/1611238065918318991.jpg', NULL, NULL, 1, 1, 30, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ.jpg', 827, NULL, '2020-09-09 17:48:47', '2020-09-15 17:12:28', 0, 0, NULL, '', '11717324', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/icon_sk3.png', '/upload/cover_img/M846S-PZ-F78-1-R.jpg'),
	(454, 47, 'M846S', '/upload/cover_img/M846S-PZ-F96-R.jpg', '/upload/product/watermark/1611153820583134069.jpg', NULL, NULL, 1, 1, 33, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ1.jpg', 827, NULL, '2020-09-09 17:48:47', '2020-09-15 17:13:16', 0, 0, NULL, '', '11717336', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/icon_sk4.png', '/upload/cover_img/M846S-PZ-F96-R.jpg'),
	(455, 47, 'M846S', '/upload/cover_img/M846S-PZ-F96-1-R.jpg', '/upload/product/watermark/1608709251768564911.jpg', NULL, NULL, 1, 1, 34, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ2.jpg', 827, NULL, '2020-09-09 17:48:47', '2020-09-15 17:13:27', 0, 0, NULL, '', '11717348', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/icon_sk5.png', '/upload/cover_img/M846S-PZ-F96-1-R.jpg'),
	(456, 47, 'M846S', '/upload/cover_img/M846S-PZ-F84-R.jpg', '/upload/product/watermark/1615963250093898956.jpg', NULL, NULL, 1, 1, 31, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ3.jpg', 827, 1, '2020-09-09 17:48:47', '2020-09-15 17:13:47', 0, 0, NULL, '', '11717355', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/upload/product/product/icon_sk6.png', '/upload/cover_img/M846S-PZ-F84-R.jpg'),
	(457, 47, 'M846S', '/upload/cover_img/M846S-PZ-F84-1-R.jpg', '/upload/product/watermark/1604463839389246912.jpg', NULL, NULL, 1, 1, 32, 1, 1, '4', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/M846S-PZ4.jpg', 827, NULL, '2020-09-09 17:48:47', '2020-09-15 17:13:58', 0, 0, NULL, '', '11717361', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '嵌入，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/icon_sk7.png', '/upload/cover_img/M846S-PZ-F84-1-R.jpg'),
	(458, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F97-R.jpg', '/upload/product/watermark/1602505556530091666.jpg', NULL, NULL, 7, NULL, 35, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:47', '2020-09-25 13:59:15', 0, 0, NULL, '', '11718377', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/cover_img/M0643-US943-F97-R.jpg'),
	(459, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F97-1-R.jpg', '/upload/product/watermark/1616915130483229111.jpg', NULL, NULL, 7, NULL, 36, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, 1, '2020-09-09 17:48:47', '2020-09-25 13:59:21', 0, 0, NULL, '', '11718390', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/M0643-US943-F97-1-R.jpg'),
	(460, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F78-R.jpg', '/upload/product/watermark/1603630859920429127.jpg', NULL, NULL, 7, NULL, 29, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:47', '2020-09-25 13:59:59', 0, 0, NULL, '', '11718407', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/cover_img/M0643-US943-F78-R.jpg'),
	(461, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F78-1-R.jpg', '/upload/product/watermark/1607942546021488455.jpg', NULL, NULL, 7, NULL, 30, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:47', '2020-09-25 14:00:04', 0, 0, NULL, '', '11718419', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/M0643-US943-F78-1-R.jpg'),
	(462, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F96-R.jpg', '/upload/product/watermark/1615864487814939500.jpg', NULL, NULL, 7, NULL, 33, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:47', '2020-09-25 14:00:09', 0, 0, NULL, '', '11718420', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/cover_img/M0643-US943-F96-R.jpg'),
	(463, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F96-1-R.jpg', '/upload/product/watermark/1616126618605459171.jpg', NULL, NULL, 7, NULL, 34, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:48', '2020-09-25 13:58:49', 0, 0, NULL, '', '11718444', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/M0643-US943-F96-1-R.jpg'),
	(464, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F84-R.jpg', '/upload/product/watermark/1615534731031437651.jpg', NULL, NULL, 7, NULL, 31, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:48', '2020-09-25 13:58:57', 0, 0, NULL, '', '11718456', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/cover_img/M0643-US943-F84-R.jpg'),
	(465, 28, 'M0643/US943', '/upload/cover_img/M0643-US943-F84-1-R.jpg', '/upload/product/watermark/1615534730294960341.jpg', NULL, NULL, 7, NULL, 32, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0643-US943.jpg', 860, NULL, '2020-09-09 17:48:48', '2020-09-25 13:59:03', 0, 0, NULL, '', '11718475', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/M0643-US943-F84-1-R.jpg'),
	(466, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F97-R.jpg', '/upload/product/watermark/1607024876800545297.jpg', NULL, NULL, 8, NULL, 35, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9433.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-30 10:08:39', 0, 0, NULL, '', '11718481', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/cover_img/PSK-M0643-US943-F97-R.jpg'),
	(467, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F97-1-R.jpg', '/upload/product/watermark/1606301161119752783.jpg', NULL, NULL, 8, NULL, 36, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9434.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-30 10:08:57', 0, 0, NULL, '', '11718505', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/PSK-M0643-US943-F97-1-R.jpg'),
	(468, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F78-R.jpg', '/upload/product/watermark/1604625446526926082.jpg', NULL, NULL, 8, NULL, 29, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9435.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-30 10:09:17', 0, 0, NULL, '', '11718511', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/cover_img/PSK-M0643-US943-F78-R.jpg'),
	(469, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F78-1-R.jpg', '/upload/product/watermark/1607180869550041410.jpg', NULL, NULL, 8, NULL, 30, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9436.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-30 10:09:41', 0, 0, NULL, '', '11718535', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/PSK-M0643-US943-F78-1-R.jpg'),
	(470, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F96-R.jpg', '/upload/product/watermark/1616815508726418665.jpg', NULL, NULL, 8, NULL, 33, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9437.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-30 10:10:01', 0, 0, NULL, '', '11718547', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/cover_img/PSK-M0643-US943-F96-R.jpg'),
	(471, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-PZ69-F9714M.jpg', '/upload/product/watermark/1614932475529503810.jpg', NULL, NULL, 6, 8, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-PZ.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-25 16:12:18', 0, 0, NULL, '', '11720755', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-PZ69-F9714M.jpg'),
	(472, 31, 'M6642', '/upload/cover_img/M6642-F41-R.jpg', '/upload/product/watermark/1610439819314956437.jpg', NULL, NULL, 5, NULL, 18, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M6642.jpg', 950, NULL, '2020-09-09 17:48:48', '2020-09-21 12:57:01', 0, 0, NULL, '', '11721650', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F41-R 镀铬拉丝', '', '/upload/cover_img/M6642-F41-R.jpg'),
	(473, 31, 'M6642', '/upload/cover_img/M6642-F42-R.jpg', '/upload/product/watermark/1608035957312259954.jpg', NULL, NULL, 5, NULL, 19, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M6642.jpg', 950, NULL, '2020-09-09 17:48:49', '2020-09-21 12:56:35', 0, 0, NULL, '', '11721765', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F42-R 镀镍丝光', '', '/upload/cover_img/M6642-F42-R.jpg'),
	(474, 31, 'M6642', '/upload/cover_img/M6642-F49-R.jpg', '/upload/product/watermark/1608035891087563138.jpg', NULL, NULL, 5, NULL, 21, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M6642.jpg', 950, NULL, '2020-09-09 17:48:49', '2020-09-21 12:56:49', 0, 0, NULL, '', '11721777', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F49-R 镀铬抛光', '', '/upload/cover_img/M6642-F49-R.jpg'),
	(475, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F96-R.jpg', '/upload/product/watermark/1616126650786043683.jpg', NULL, NULL, 7, NULL, 33, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:49', '2020-09-25 14:16:58', 0, 0, NULL, '', '11722861', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/cover_img/M0642-US910-F96-R.jpg'),
	(476, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F96-1-R.jpg', '/upload/product/watermark/1616126649106182542.jpg', NULL, NULL, 7, NULL, 34, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:49', '2020-09-25 14:17:04', 0, 0, NULL, '', '11722873', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/M0642-US910-F96-1-R.jpg'),
	(477, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F84-R.jpg', '/upload/product/watermark/1607714172658711038.jpg', NULL, NULL, 7, NULL, 31, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:49', '2020-09-25 14:17:11', 0, 0, NULL, '', '11722885', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/cover_img/M0642-US910-F84-R.jpg'),
	(478, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F84-1-R.jpg', '/upload/product/watermark/1609221090944196585.jpg', NULL, NULL, 7, NULL, 32, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:49', '2020-09-25 14:17:21', 0, 0, NULL, '', '11722903', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/M0642-US910-F84-1-R.jpg'),
	(479, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F97-R.jpg', '/upload/product/watermark/1607464593947912013.jpg', NULL, NULL, 8, NULL, 35, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9107.jpg', 940, NULL, '2020-09-09 17:48:49', '2020-09-30 10:14:40', 0, 0, NULL, '', '11722927', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/cover_img/PSK-M0642-US910-F97-R.jpg'),
	(480, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F97-1-R.jpg', '/upload/product/watermark/1605558530447273567.jpg', NULL, NULL, 8, NULL, 36, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US910.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:12:26', 0, 0, NULL, '', '11722939', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/PSK-M0642-US910-F97-1-R.jpg'),
	(481, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F78-R.jpg', '/upload/product/watermark/1615297316036341299.jpg', NULL, NULL, 8, NULL, 29, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9101.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:12:43', 0, 0, NULL, '', '11722940', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/cover_img/PSK-M0642-US910-F78-R.jpg'),
	(482, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F78-1-R.jpg', '/upload/product/watermark/1610791036662326348.jpg', NULL, NULL, 8, NULL, 30, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9102.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:12:59', 0, 0, NULL, '', '11722952', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/PSK-M0642-US910-F78-1-R.jpg'),
	(483, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F96-R.jpg', '/upload/product/watermark/1604041205064746593.jpg', NULL, NULL, 8, NULL, 33, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9103.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:13:24', 0, 0, NULL, '', '11722964', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/cover_img/PSK-M0642-US910-F96-R.jpg'),
	(484, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F96-1-R.jpg', '/upload/product/watermark/1609857501491237990.jpg', NULL, NULL, 8, NULL, 34, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9104.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:13:42', 0, 0, NULL, '', '11722976', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/PSK-M0642-US910-F96-1-R.jpg'),
	(485, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F84-R.jpg', '/upload/product/watermark/1607942223046357312.jpg', NULL, NULL, 8, NULL, 31, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9105.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:14:00', 0, 0, NULL, '', '11722988', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/cover_img/PSK-M0642-US910-F84-R.jpg'),
	(486, 31, 'PSK-M0642/US910', '/upload/cover_img/PSK-M0642-US910-F84-1-R.jpg', '/upload/product/watermark/1616815522778578780.jpg', NULL, NULL, 8, NULL, 32, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活&nbsp;&nbsp;&nbsp;&nbsp;</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0642-US9106.jpg', 940, NULL, '2020-09-09 17:48:50', '2020-09-30 10:14:19', 0, 0, NULL, '', '11722995', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/PSK-M0642-US910-F84-1-R.jpg'),
	(487, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F97-R-innen.jpg', '/upload/product/watermark/1605650383236635484.jpg', NULL, NULL, 6, 7, 35, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I6.jpg', 900, NULL, '2020-09-09 17:48:50', '2020-09-25 16:43:08', 0, 0, NULL, '', '11723002', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F97-R-innen1.jpg'),
	(488, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F97-1-R-innen.jpg', '/upload/product/watermark/1610973053318317456.jpg', NULL, NULL, 6, 7, 36, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I7.jpg', 900, NULL, '2020-09-09 17:48:50', '2020-09-25 16:43:26', 0, 0, NULL, '', '11723014', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F97-1-R-innen1.jpg'),
	(489, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F97-R-MSK91-OL452.jpg', '/upload/product/watermark/1608707277107387858.jpg', NULL, NULL, 1, 3, 35, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4516.jpg', 828, NULL, '2020-09-09 17:48:50', '2020-09-15 10:53:57', 0, 0, NULL, '', '11717658', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F97-R-MSK91-OL453.jpg'),
	(490, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F97-1-R-MSK91-OL452.jpg', '/upload/product/watermark/1605533944887658797.jpg', NULL, NULL, 1, 3, 36, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL459.jpg', 828, NULL, '2020-09-09 17:48:51', '2020-09-15 10:50:14', 0, 0, NULL, '', '11717665', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F97-1-R-MSK91-OL453.jpg'),
	(491, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F78-R-MSK91-OL452.jpg', '/upload/product/watermark/1616732860827476551.jpg', NULL, NULL, 1, 3, 29, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4510.jpg', 828, 1, '2020-09-09 17:48:51', '2020-09-15 10:50:46', 0, 0, NULL, '', '11717671', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F78-R-MSK91-OL453.jpg'),
	(492, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F78-1-R-MSK91-OL452.jpg', '/upload/product/watermark/1615185189893835747.jpg', NULL, NULL, 1, 3, 30, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4511.jpg', 828, NULL, '2020-09-09 17:48:51', '2020-09-15 10:51:20', 0, 0, NULL, '', '11717683', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F78-1-R-MSK91-OL453.jpg'),
	(493, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F96-R-MSK91-OL452.jpg', '/upload/product/watermark/1603599263203954292.jpg', NULL, NULL, 1, 3, 33, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4512.jpg', 828, NULL, '2020-09-09 17:48:51', '2020-09-15 10:51:54', 0, 0, NULL, '', '11717695', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F96-R-MSK91-OL453.jpg'),
	(494, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F96-1-R-MSK91-OL452.jpg', '/upload/product/watermark/1608366078849821119.jpg', NULL, NULL, 1, 3, 34, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4513.jpg', 828, NULL, '2020-09-09 17:48:51', '2020-09-15 10:52:25', 0, 0, NULL, '', '11717701', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F96-1-R-MSK91-OL453.jpg'),
	(495, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F84-R-MSK91-OL452.jpg', '/upload/product/watermark/1611558986434614897.jpg', NULL, NULL, 1, 3, 31, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4514.jpg', 828, NULL, '2020-09-09 17:48:51', '2020-09-15 10:52:48', 0, 0, NULL, '', '11717713', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F84-R-MSK91-OL453.jpg'),
	(496, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F84-1-R-MSK91-OL452.jpg', '/upload/product/watermark/1611558984103306376.jpg', NULL, NULL, 1, 3, 32, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '38-43', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL4515.jpg', 828, NULL, '2020-09-09 17:48:51', '2020-09-15 10:53:22', 0, 0, NULL, '', '11717725', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F84-1-R-MSK91-OL453.jpg'),
	(497, 27, 'PSK-E0400Z/US956', '/upload/product/product/PSK-E0400Z-US956-F97-1-R.jpg', '/upload/product/watermark/1616815465665518489.jpg', NULL, NULL, 8, NULL, 74, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-E0400Z-US956.jpg', 990, 0, '2020-09-09 17:48:51', '2020-09-30 09:53:48', 0, 0, NULL, '', '11719655', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', ''),
	(498, 27, 'PSK-E0400Z/US956', '/upload/product/product/PSK-E0400Z-US956-F78-1-R.jpg', '/upload/product/watermark/1616661155965270726.jpg', NULL, NULL, 8, NULL, 71, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-E0400Z-US9561.jpg', 990, NULL, '2020-09-09 17:48:51', '2020-09-30 09:55:07', 0, 0, NULL, '', '11719692', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/product/product/PSK-E0400Z-US956-F78-1-R1.jpg'),
	(499, 27, 'PSK-E0400Z/US956', '/upload/product/product/PSK-E0400Z-US956-F96-1-R.jpg', '/upload/product/watermark/1615871315320457102.jpg', NULL, NULL, 8, NULL, 73, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-E0400Z-US9562.jpg', 990, NULL, '2020-09-09 17:48:51', '2020-09-30 09:55:48', 0, 0, NULL, '', '11719709', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', ''),
	(500, 27, 'PSK-E0400Z/US956', '/upload/product/product/PSK-E0400Z-US956-F84-1-R.jpg', '/upload/product/watermark/1616661154872472238.jpg', NULL, NULL, 8, NULL, 72, 2, 1, '2,6,4', '7,4,6', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '032-042', '7', '/upload/product/product/PSK-E0400Z-US9563.jpg', 990, NULL, '2020-09-09 17:48:51', '2020-09-30 09:56:24', 0, 0, NULL, '', '11719722', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', ''),
	(501, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F97-1-R-innen2.jpg', '/upload/product/watermark/1610456132187731987.jpg', NULL, NULL, 6, 7, 74, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-UG-HG-I1.jpg', 980, NULL, '2020-09-09 17:48:51', '2020-09-25 15:55:20', 0, 0, NULL, '', '11719783', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F97-1-R-innen3.jpg'),
	(502, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F78-1-R-innen2.jpg', '/upload/product/watermark/1603939602130223567.jpg', NULL, NULL, 6, 7, 71, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-UG-HG-I2.jpg', 980, NULL, '2020-09-09 17:48:51', '2020-09-25 15:55:46', 0, 0, NULL, '', '11719813', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F78-1-R-innen3.jpg'),
	(503, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F96-1-R-innen2.jpg', '/upload/product/watermark/1606848855909545434.jpg', NULL, NULL, 6, 7, 73, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-UG-HG-I3.jpg', 980, NULL, '2020-09-09 17:48:51', '2020-09-25 15:56:11', 0, 0, NULL, '', '11719825', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F96-1-R-innen3.jpg'),
	(504, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F84-1-R-innen2.jpg', '/upload/product/watermark/1610446380208107381.jpg', NULL, NULL, 6, 7, 72, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-UG-HG-I4.jpg', 980, NULL, '2020-09-09 17:48:51', '2020-09-25 15:56:34', 0, 0, NULL, '', '11719874', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F84-1-R-innen3.jpg'),
	(505, 27, 'E1400Z/30P/30PS', '/upload/cover_img/E1400Z-30P-30PS-PZ-F97-1-R.jpg', '/upload/product/watermark/1616816643359520719.jpg', NULL, NULL, 3, 1, 74, 2, 1, '4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-30P-30PS-PZ-50mm2.jpg', 990, NULL, '2020-09-09 17:48:51', '2020-09-21 14:04:49', 0, 0, NULL, '', '11720037', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/cover_img/E1400Z-30P-30PS-PZ-F97-1-R.jpg'),
	(506, 27, 'E1400Z/30P/30PS', '/upload/cover_img/E1400Z-30P-30PS-PZ-F78-1-R.jpg', '/upload/product/watermark/1611896148279796687.jpg', NULL, NULL, 3, 1, 71, 2, 1, '4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-30P-30PS-PZ-50mm3.jpg', 990, NULL, '2020-09-09 17:48:51', '2020-09-21 14:04:54', 0, 0, NULL, '', '11720128', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/cover_img/E1400Z-30P-30PS-PZ-F78-1-R.jpg'),
	(507, 27, 'E1400Z/30P/30PS', '/upload/cover_img/E1400Z-30P-30PS-PZ-F96-1-R.jpg', '/upload/product/watermark/1616814175858771298.jpg', NULL, NULL, 3, 1, 73, 2, 1, '4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-30P-30PS-PZ-50mm1.jpg', 990, NULL, '2020-09-09 17:48:52', '2020-09-21 14:04:45', 0, 0, NULL, '', '11720372', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/cover_img/E1400Z-30P-30PS-PZ-F96-1-R.jpg'),
	(508, 27, 'E1400Z/30P/30PS', '/upload/cover_img/E1400Z-30P-30PS-PZ-F84-1-R.jpg', '/upload/product/watermark/1611896147362478547.jpg', NULL, NULL, 3, 1, 72, 2, 1, '4', '3,4,6', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/E1400Z-30P-30PS-PZ-50mm.jpg', 990, NULL, '2020-09-09 17:48:54', '2020-09-21 14:04:41', 0, 0, NULL, '', '11720384', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/cover_img/E1400Z-30P-30PS-PZ-F84-1-R.jpg'),
	(509, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F96-1-R.jpg', '/upload/product/watermark/1603347421418677552.jpg', NULL, NULL, 8, NULL, 34, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US943.jpg', 950, NULL, '2020-09-09 17:48:54', '2020-09-30 10:07:30', 0, 0, NULL, '', '11718602', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/PSK-M0643-US943-F96-1-R.jpg'),
	(510, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F84-R.jpg', '/upload/product/watermark/1610942335498654076.jpg', NULL, NULL, 8, NULL, 31, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9431.jpg', 950, NULL, '2020-09-09 17:48:54', '2020-09-30 10:07:52', 0, 0, NULL, '', '11718614', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/cover_img/PSK-M0643-US943-F84-R.jpg'),
	(511, 28, 'PSK-M0643/US943', '/upload/cover_img/PSK-M0643-US943-F84-1-R.jpg', '/upload/product/watermark/1605896367055457633.jpg', NULL, NULL, 8, NULL, 32, 1, 1, '2,6,4', '5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/PSK-M0643-US9432.jpg', 950, NULL, '2020-09-09 17:48:54', '2020-09-30 10:08:13', 0, 0, NULL, '', '11718626', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/PSK-M0643-US943-F84-1-R.jpg'),
	(512, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F97-R-innen.jpg', '/upload/product/watermark/1605558540066543308.jpg', NULL, NULL, 6, 7, 35, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I1.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-10-13 11:52:39', 0, 0, NULL, '', '11718638', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F97-R-innen1.jpg'),
	(513, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F97-1-R-innen.jpg', '/upload/product/watermark/1604374742654124580.jpg', NULL, NULL, 6, 7, 36, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I2.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-09-25 16:26:15', 0, 0, NULL, '', '11718645', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F97-1-R-innen1.jpg'),
	(514, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F78-R-innen.jpg', '/upload/product/watermark/1605130584157953283.jpg', NULL, NULL, 6, 7, 29, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I3.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-09-25 16:26:48', 0, 0, NULL, '', '11718651', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F78-R-innen1.jpg'),
	(515, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F78-1-R-innen.jpg', '/upload/product/watermark/1616814775928514127.jpg', NULL, NULL, 6, 7, 30, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I4.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-09-25 16:27:17', 0, 0, NULL, '', '11718663', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F78-1-R-innen1.jpg'),
	(516, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F96-R-innen.jpg', '/upload/product/watermark/1604625432650280751.jpg', NULL, NULL, 6, 7, 33, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I5.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-09-25 16:27:46', 0, 0, NULL, '', '11718675', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F96-R-innen1.jpg'),
	(517, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F96-1-R-innen.jpg', '/upload/product/watermark/1604374745291601118.jpg', NULL, NULL, 6, 7, 34, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I6.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-09-25 16:28:15', 0, 0, NULL, '', '11718687', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F96-1-R-innen1.jpg'),
	(518, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F84-R-innen.jpg', '/upload/product/watermark/1605044718583550509.jpg', NULL, NULL, 6, 7, 31, 1, 1, '4', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I7.jpg', 930, NULL, '2020-09-09 17:48:54', '2020-09-25 16:29:24', 0, 0, NULL, '', '11718705', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F84-R-innen1.jpg'),
	(519, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-UG-F84-1-R-innen.jpg', '/upload/product/watermark/1605896388952849841.jpg', NULL, NULL, 6, 7, 32, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-UG-HG-I.jpg', 930, NULL, '2020-09-09 17:48:55', '2020-09-25 16:25:15', 0, 0, NULL, '', '11718729', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-UG-F84-1-R-innen1.jpg'),
	(520, 33, '1751/3346', '/upload/product/product/1751-3346-PZ92-F9.jpg', '/upload/product/watermark/1616816708430614394.jpg', NULL, NULL, 3, 6, 10, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '72-77', NULL, '8', '/upload/product/product/1751-3346-PZ-GL78-3-Nocken-M6.jpg', 940, NULL, '2020-09-09 17:48:55', '2020-09-25 10:37:25', 0, 0, NULL, '', '11719151', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1751-3346-PZ92-F91.jpg'),
	(521, 27, '6400', '/upload/cover_img/6400-F31-1.jpg', '/upload/product/watermark/1611728377899762229.jpg', NULL, NULL, 5, NULL, 12, 3, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/img_sample/6400.jpg', 990, NULL, '2020-09-09 17:48:55', '2020-09-21 11:49:07', 0, 0, NULL, '', '11722265', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/6400-F31-1.jpg'),
	(522, 27, '6400', '/upload/cover_img/6400-F9016M.jpg', '/upload/product/watermark/1610606054311976000.jpg', NULL, NULL, 5, NULL, 88, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/img_sample/6400.jpg', 990, NULL, '2020-09-09 17:48:55', '2020-10-13 11:44:55', 0, 0, NULL, '', '11722319', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '', '/upload/cover_img/6400-F9016M.jpg'),
	(523, 27, '6400', '/upload/cover_img/6400-F9714M.jpg', '/upload/product/watermark/1610606055879484859.jpg', NULL, NULL, 5, NULL, 16, 3, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/img_sample/6400.jpg', 990, NULL, '2020-09-09 17:48:55', '2020-09-21 11:48:59', 0, 0, NULL, '', '11722332', NULL, NULL, NULL, NULL, '一支', '220mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/6400-F9714M.jpg'),
	(524, 40, '6737', '/upload/cover_img/6737-F1.jpg', '/upload/product/watermark/1616653826005003579.jpg', NULL, NULL, 5, NULL, 2, 3, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/img_sample/6737.jpg', 920, NULL, '2020-09-09 17:48:55', '2020-09-21 13:06:09', 0, 0, NULL, '', '11722356', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/6737-F1.jpg'),
	(525, 31, 'M1642/845', '/upload/product/product/M1642-845-F97-R.jpg', '/upload/product/watermark/1612835733217835410.jpg', NULL, NULL, 1, NULL, 35, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:55', '2020-10-13 19:31:36', 0, 1, '/upload/product/product/M1642-845-F97-R-Motiv1-nW.png', '', '11722368', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F97-R1.jpg'),
	(526, 40, '6737', '/upload/cover_img/6737-F31-1.jpg', '/upload/product/watermark/1615441492555078369.jpg', NULL, NULL, 5, NULL, 12, 3, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/img_sample/6737.jpg', 920, NULL, '2020-09-09 17:48:55', '2020-09-21 13:06:28', 0, 0, NULL, '', '11722375', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/6737-F31-1.jpg'),
	(527, 40, '6737', '/upload/cover_img/6737-F9.jpg', '/upload/product/watermark/1607341291869977233.jpg', NULL, NULL, 5, NULL, 10, 3, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/img_sample/6737.jpg', 920, NULL, '2020-09-09 17:48:56', '2020-09-21 13:05:46', 0, 0, NULL, '', '11722381', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/6737-F9.jpg'),
	(528, 40, '6737', '/upload/cover_img/6737-F9714M.jpg', '/upload/product/watermark/1606313673401999414.jpg', NULL, NULL, 5, NULL, 16, 3, 1, '', NULL, NULL, NULL, NULL, NULL, '/upload/img_sample/6737.jpg', 920, NULL, '2020-09-09 17:48:56', '2020-09-21 13:06:25', 0, 0, NULL, '', '11722393', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/6737-F9714M.jpg'),
	(529, 31, 'M1642/845', '/upload/product/product/M1642-845-F97-1-R.jpg', '/upload/product/watermark/1610607846711384161.jpg', NULL, NULL, 1, NULL, 36, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:56', '2020-10-13 19:30:54', 0, 1, '/upload/product/product/M1642-845-F97-1-R-Motiv1-nW.png', '', '11722405', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F97-1-R1.jpg'),
	(530, 31, 'M1642/845', '/upload/product/product/M1642-845-F78-R.jpg', '/upload/product/watermark/1616912141637288648.jpg', NULL, NULL, 1, NULL, 29, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, 1, '2020-09-09 17:48:56', '2020-10-13 19:30:46', 0, 0, NULL, '', '11722411', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F78-R1.jpg'),
	(531, 31, 'M1642/845', '/upload/product/product/M1642-845-F78-1-R.jpg', '/upload/product/watermark/1616637573330949925.jpg', NULL, NULL, 1, NULL, 30, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:56', '2020-10-13 19:31:00', 0, 0, NULL, '', '11722423', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F78-1-R1.jpg'),
	(532, 31, 'M1642/845', '/upload/product/product/M1642-845-F96-R.jpg', '/upload/product/watermark/1616671551213492402.jpg', NULL, NULL, 1, NULL, 33, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:56', '2020-10-13 19:31:12', 0, 0, NULL, '', '11722435', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F96-R1.jpg'),
	(533, 31, 'M1642/845', '/upload/product/product/M1642-845-F96-1-R.jpg', '/upload/product/watermark/1616631888173607298.jpg', NULL, NULL, 1, NULL, 34, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:56', '2020-10-13 19:31:17', 0, 0, NULL, '', '11722447', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F96-1-R1.jpg'),
	(534, 31, 'M1642/845', '/upload/product/product/M1642-845-F84-R.jpg', '/upload/product/watermark/1616732700642182877.jpg', NULL, NULL, 1, NULL, 31, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:56', '2020-10-13 19:31:23', 0, 1, '/upload/product/product/M1642-845-F84-R-Motiv1-nW.png', '', '11722502', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F84-R1.jpg'),
	(535, 31, 'M1642/845', '/upload/product/product/M1642-845-F84-1-R.jpg', '/upload/product/watermark/1616732701661178187.jpg', NULL, NULL, 1, NULL, 32, 1, 1, '1,4', '5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-55', NULL, '8', '/upload/img_sample/M1642-845.jpg', 840, NULL, '2020-09-09 17:48:56', '2020-10-13 19:31:30', 0, 0, NULL, '', '11722526', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1642-845-F84-1-R1.jpg'),
	(536, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F97-R.jpg', '/upload/product/watermark/1615864373266662120.jpg', NULL, NULL, 7, NULL, 35, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:56', '2020-09-25 14:16:35', 0, 0, NULL, '', '11722642', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/cover_img/M0642-US910-F97-R.jpg'),
	(537, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F97-1-R.jpg', '/upload/product/watermark/1616671993340531751.jpg', NULL, NULL, 7, NULL, 36, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:56', '2020-09-25 14:16:41', 0, 0, NULL, '', '11722654', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/M0642-US910-F97-1-R.jpg'),
	(538, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F78-R.jpg', '/upload/product/watermark/1616671995038698055.jpg', NULL, NULL, 7, NULL, 29, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:56', '2020-09-25 14:16:47', 0, 0, NULL, '', '11722666', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/cover_img/M0642-US910-F78-R.jpg'),
	(539, 31, 'M0642/US910', '/upload/cover_img/M0642-US910-F78-1-R.jpg', '/upload/product/watermark/1616812066922768509.jpg', NULL, NULL, 7, NULL, 30, 1, 1, '2,6,4', '7,4,5', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/M0642-US910.jpg', 820, NULL, '2020-09-09 17:48:56', '2020-09-25 14:16:52', 0, 0, NULL, '', '11722715', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/M0642-US910-F78-1-R.jpg'),
	(540, 33, '0751/US952', '/upload/cover_img/0751-US952-F9.jpg', '/upload/product/watermark/1616662742792903118.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0751-US952.jpg', 910, NULL, '2020-09-09 17:48:56', '2020-09-25 13:48:55', 0, 0, NULL, '', '11723026', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0751-US952-F9.jpg'),
	(541, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F78-R-innen.jpg', '/upload/product/watermark/1615534890637170873.jpg', NULL, NULL, 6, 7, 29, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I.jpg', 900, NULL, '2020-09-09 17:48:57', '2020-09-25 16:41:02', 0, 0, NULL, '', '11723051', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F78-R-innen1.jpg'),
	(542, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F78-1-R-innen.jpg', '/upload/product/watermark/1606450724060254837.jpg', NULL, NULL, 6, 7, 30, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I1.jpg', 900, NULL, '2020-09-09 17:48:57', '2020-09-25 16:41:24', 0, 0, NULL, '', '11723075', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F78-1-R-innen1.jpg'),
	(543, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F96-R-innen.jpg', '/upload/product/watermark/1615534897263464881.jpg', NULL, NULL, 6, 7, 33, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I2.jpg', 900, NULL, '2020-09-09 17:48:57', '2020-09-25 16:41:46', 0, 0, NULL, '', '11723087', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F96-R-innen1.jpg'),
	(544, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F96-1-R-innen.jpg', '/upload/product/watermark/1615534894487729851.jpg', NULL, NULL, 6, 7, 34, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I3.jpg', 900, NULL, '2020-09-09 17:48:57', '2020-09-25 16:42:07', 0, 0, NULL, '', '11723099', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F96-1-R-innen1.jpg'),
	(545, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F84-R-innen.jpg', '/upload/product/watermark/1615534893556733667.jpg', NULL, NULL, 6, 7, 31, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I4.jpg', 900, NULL, '2020-09-09 17:48:57', '2020-09-25 16:42:27', 0, 0, NULL, '', '11723105', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F84-R-innen1.jpg'),
	(546, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-UG-F84-1-R-innen.jpg', '/upload/product/watermark/1615534891553759327.jpg', NULL, NULL, 6, 7, 32, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-UG-HG-I5.jpg', 900, NULL, '2020-09-09 17:48:57', '2020-09-25 16:42:49', 0, 0, NULL, '', '11723117', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-UG-F84-1-R-innen1.jpg'),
	(547, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F97-R.jpg', '/upload/product/watermark/1610025366967827208.jpg', NULL, NULL, 1, 1, 35, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ.jpg', 882, NULL, '2020-09-09 17:48:57', '2020-09-11 14:45:58', 0, 0, NULL, '', '11724444', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F97-R1.jpg'),
	(548, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F97-1-R.jpg', '/upload/product/watermark/1615881590020008737.jpg', NULL, NULL, 1, 1, 36, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ1.jpg', 882, NULL, '2020-09-09 17:48:57', '2020-09-14 16:03:04', 0, 1, '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F97-1-R-Motiv1-nW.png', '', '11724493', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F97-1-R1.jpg'),
	(549, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F78-R.jpg', '/upload/product/watermark/1612084411895873622.jpg', NULL, NULL, 1, 1, 29, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ2.jpg', 882, NULL, '2020-09-09 17:48:57', '2020-09-11 14:46:17', 0, 0, NULL, '', '11724663', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F78-R1.jpg'),
	(550, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F78-1-R.jpg', '/upload/product/watermark/1615700283636820100.jpg', NULL, NULL, 1, 1, 30, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ3.jpg', 882, NULL, '2020-09-09 17:48:57', '2021-03-24 15:11:14', 0, 1, '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F78-1-R-Motiv2-nW.png', '', '11965642', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F78-1-R1.jpg'),
	(551, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F96-R.jpg', '/upload/product/watermark/1615791709813945081.jpg', NULL, NULL, 1, 1, 33, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ4.jpg', 882, 1, '2020-09-09 17:48:57', '2020-09-11 14:46:32', 0, 0, NULL, '', '11724821', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F96-R1.jpg'),
	(552, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F96-1-R.jpg', '/upload/product/watermark/1612084410237027241.jpg', NULL, NULL, 1, 1, 34, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ5.jpg', 882, NULL, '2020-09-09 17:48:57', '2020-09-11 14:46:39', 0, 0, NULL, '', '11725011', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F96-1-R1.jpg'),
	(553, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F84-R.jpg', '/upload/product/watermark/1608621377687082948.jpg', NULL, NULL, 1, 1, 31, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ6.jpg', 882, NULL, '2020-09-09 17:48:57', '2020-09-11 14:46:47', 0, 0, NULL, '', '11725187', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F84-R1.jpg'),
	(554, 31, 'M1642/42K/42KS', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F84-1-R.jpg', '/upload/product/watermark/1615791712160329809.jpg', NULL, NULL, 1, 1, 32, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-42K-42KS-PZ7.jpg', 882, NULL, '2020-09-09 17:48:57', '2020-09-14 16:02:22', 0, 1, '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F84-1-R-Motiv2-nW.png', '', '11725254', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1642-42K+KV-42KS+KVS-PZ-F84-1-R1.jpg'),
	(555, 47, 'M423', '/upload/cover_img/M423-F78-R.jpg', '/upload/product/watermark/1611744095693343555.jpg', NULL, NULL, 6, NULL, 29, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:57', '2020-09-25 16:51:13', 0, 0, NULL, '光面(不开孔)', '11725308', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/cover_img/M423-F78-R.jpg'),
	(556, 47, 'M423', '/upload/cover_img/M423-F97-R.jpg', '/upload/product/watermark/1614932548525600076.jpg', NULL, NULL, 6, NULL, 35, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:57', '2020-09-25 16:51:22', 0, 0, NULL, '光面(不开孔)', '11725315', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/cover_img/M423-F97-R.jpg'),
	(557, 47, 'M423', '/upload/cover_img/M423-F97-1-R.jpg', '/upload/product/watermark/1609754969556542085.jpg', NULL, NULL, 6, NULL, 36, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:57', '2020-09-25 16:51:32', 0, 0, NULL, '光面(不开孔)', '11725321', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/M423-F97-1-R.jpg'),
	(558, 47, 'M423', '/upload/cover_img/M423-F78-1-R.jpg', '/upload/product/watermark/1616815190941359615.jpg', NULL, NULL, 6, NULL, 30, 1, NULL, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:58', '2020-09-25 16:50:19', 0, 0, NULL, '光面(不开孔)', '11725333', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/M423-F78-1-R.jpg'),
	(559, 47, 'M423', '/upload/cover_img/M423-F96-R.jpg', '/upload/product/watermark/1609754968333155670.jpg', NULL, NULL, 6, NULL, 33, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:58', '2020-09-25 16:50:31', 0, 0, NULL, '光面(不开孔)', '11725345', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/cover_img/M423-F96-R.jpg'),
	(560, 47, 'M423', '/upload/cover_img/M423-F96-1-R.jpg', '/upload/product/watermark/1614040007181131772.jpg', NULL, NULL, 6, NULL, 34, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:58', '2020-09-25 16:50:44', 0, 0, NULL, '光面(不开孔)', '11725357', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/M423-F96-1-R.jpg'),
	(561, 47, 'M423', '/upload/cover_img/M423-F84-R.jpg', '/upload/product/watermark/1609754965911652586.jpg', NULL, NULL, 6, NULL, 31, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:58', '2020-09-25 16:50:53', 0, 0, NULL, '光面(不开孔)', '11725369', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/cover_img/M423-F84-R.jpg'),
	(562, 47, 'M423', '/upload/cover_img/M423-F84-1-R.jpg', '/upload/product/watermark/1611714437916912536.jpg', NULL, NULL, 6, NULL, 32, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, NULL, '/upload/img_sample/M423.jpg', 880, NULL, '2020-09-09 17:48:58', '2020-09-25 16:51:04', 0, 0, NULL, '光面(不开孔)', '11725370', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，由室内侧安装， M6 螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/M423-F84-1-R.jpg'),
	(563, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F97-R.jpg', '/upload/product/watermark/1616816984225731210.jpg', NULL, NULL, 3, 1, 35, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ4.jpg', 930, NULL, '2020-09-09 17:48:58', '2020-09-21 16:06:21', 0, 0, NULL, '', '11725461', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F97-R.jpg'),
	(564, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F97-1-R.jpg', '/upload/product/watermark/1611297265401785784.jpg', NULL, NULL, 3, 1, 36, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ5.jpg', 930, NULL, '2020-09-09 17:48:58', '2020-10-13 11:57:54', 0, 0, NULL, '', '11725473', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，多用螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F97-1-R.jpg'),
	(565, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F78-R.jpg', '/upload/product/watermark/1615527902681668157.jpg', NULL, NULL, 3, 1, 29, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ6.jpg', 930, NULL, '2020-09-09 17:48:58', '2020-09-21 16:06:51', 0, 0, NULL, '', '11725485', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F78-R.jpg'),
	(566, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F78-1-R.jpg', '/upload/product/watermark/1614906756969257859.jpg', NULL, NULL, 3, 1, 30, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ7.jpg', 930, NULL, '2020-09-09 17:48:58', '2020-09-21 16:07:01', 0, 0, NULL, '', '11725497', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F78-1-R.jpg'),
	(567, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F96-R.jpg', '/upload/product/watermark/1608776112691086524.jpg', NULL, NULL, 3, 1, 33, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ.jpg', 930, NULL, '2020-09-09 17:48:59', '2020-09-21 16:05:48', 0, 0, NULL, '', '11725503', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F96-R.jpg'),
	(568, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F96-1-R.jpg', '/upload/product/watermark/1615527901311841316.jpg', NULL, NULL, 3, 1, 34, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ1.jpg', 930, NULL, '2020-09-09 17:48:59', '2020-09-21 16:05:44', 0, 0, NULL, '', '11725515', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F96-1-R.jpg'),
	(569, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F84-R.jpg', '/upload/product/watermark/1608797615559995528.jpg', NULL, NULL, 3, 1, 31, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ2.jpg', 930, NULL, '2020-09-09 17:48:59', '2020-09-21 16:05:59', 0, 0, NULL, '', '11725527', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F84-R.jpg'),
	(570, 28, 'M1643/844P/844PS', '/upload/cover_img/M1643-844P-844PS-PZ-F84-1-R.jpg', '/upload/product/watermark/1610423161305130422.jpg', NULL, NULL, 3, 1, 32, 1, 1, '1,4', '3,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-844P-844PS-PZ3.jpg', 930, NULL, '2020-09-09 17:48:59', '2020-09-21 16:06:10', 0, 0, NULL, '', '11725539', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/cover_img/M1643-844P-844PS-PZ-F84-1-R.jpg'),
	(572, 31, 'M1642/30P/30PS', '/upload/cover_img/M1642-30P-30PS-PZ-F97-R.jpg', '/upload/product/watermark/1616817167396324727.jpg', NULL, NULL, 3, 1, 35, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ5.jpg', 890, NULL, '2020-09-09 17:48:59', '2020-09-21 16:34:27', 0, 0, NULL, '', '11726605', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-30P-30PS-PZ-F97-R.jpg'),
	(573, 31, 'M1642/30P/30PS', '/upload/product/product/M1642-30P-30PS-PZ-F97-1-R.jpg', '/upload/product/watermark/1614907464703515952.jpg', NULL, NULL, 3, 1, 36, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ6.jpg', 890, NULL, '2020-09-09 17:48:59', '2020-09-21 16:34:50', 0, 0, NULL, '', '11726611', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-30P-30PS-PZ-F97-1-R1.jpg'),
	(574, 31, 'M1642/30P/30PS', '/upload/cover_img/M1642-30P-30PS-PZ-F78-R.jpg', '/upload/product/watermark/1605044698436581159.jpg', NULL, NULL, 3, 1, 29, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ7.jpg', 890, NULL, '2020-09-09 17:48:59', '2020-09-21 16:35:06', 0, 0, NULL, '', '11726623', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-30P-30PS-PZ-F78-R.jpg'),
	(575, 31, 'M1642/30P/30PS', '/upload/product/product/M1642-30P-30PS-PZ-F78-1-R2.jpg', '/upload/product/watermark/1615527895791819856.jpg', NULL, NULL, 3, 1, 30, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ1.jpg', 890, NULL, '2020-09-09 17:49:00', '2020-09-21 16:33:04', 0, 0, NULL, '', '11726635', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1642-30P-30PS-PZ-F78-1-R3.jpg'),
	(576, 47, 'AR8180', '/upload/product/product/AR8180-BLK-A1.jpg', '/upload/product/watermark/1616860903950187892.jpg', NULL, NULL, 9, NULL, 79, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/合页公差图2.jpeg', 980, 1, '2020-09-09 17:49:00', '2021-03-24 13:18:18', 0, 0, NULL, '', '50018851', NULL, NULL, NULL, NULL, '一对', NULL, '', '', '适用于重达 120 kg 的门', '通过 BS EN 1935:2002 13 级 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防火要求 240 分钟的钢制门。', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', ''),
	(577, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F97-R.jpg', '/upload/product/watermark/1616386835907423760.jpg', NULL, NULL, 1, 1, 35, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ.jpg', 888, 1, '2020-09-09 17:49:00', '2020-11-18 10:36:41', 0, 0, NULL, '', '11724754', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F97-R1.jpg'),
	(578, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F97-1-R.jpg', '/upload/product/watermark/1616647853042906488.jpg', NULL, NULL, 1, 1, 36, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ1.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:37:06', 0, 1, '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F97-1-R-Motiv2-nW.png', '', '11724785', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F97-1-R1.jpg'),
	(579, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F78-R.jpg', '/upload/product/watermark/1614141944931361349.jpg', NULL, NULL, 1, 1, 29, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ9.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:44:43', 0, 0, NULL, '', '11724815', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F78-R1.jpg'),
	(580, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F78-1-R.jpg', '/upload/product/watermark/1616660286829037150.jpg', NULL, NULL, 1, 1, 30, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ2.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:38:13', 0, 1, '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F78-1-R-Motiv2-nW.png', '', '11724857', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F78-1-R1.jpg'),
	(581, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F96-R.jpg', '/upload/product/watermark/1616647851533969875.jpg', NULL, NULL, 1, 1, 33, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ3.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:38:51', 0, 0, NULL, '', '11724882', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F96-R1.jpg'),
	(582, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F96-1-R.jpg', '/upload/product/watermark/1616386854046219784.jpg', NULL, NULL, 1, 1, 34, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ4.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:39:24', 0, 0, NULL, '', '11724912', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F96-1-R1.jpg'),
	(583, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F84-R.jpg', '/upload/product/watermark/1614141947995536493.jpg', NULL, NULL, 1, 1, 31, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ5.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:40:14', 0, 0, NULL, '', '11724955', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F84-R1.jpg'),
	(584, 28, 'M1643/843K/843KS', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F84-1-R.jpg', '/upload/product/watermark/1616647842005502635.jpg', NULL, NULL, 1, 1, 32, 1, 1, '1,4', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1643-843K-843KS-PZ6.jpg', 888, NULL, '2020-09-09 17:49:00', '2020-11-18 10:40:48', 0, 1, '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F84-1-R-Motiv1-nW.png', '', '11724985', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1643-843K+KV-843KS+KVS-PZ-F84-1-R1.jpg'),
	(585, 31, 'M1642/30P/30PS', '/upload/cover_img/M1642-30P-30PS-PZ-F96-R.jpg', '/upload/product/watermark/1610429351845120568.jpg', NULL, NULL, 3, 1, 33, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ.jpg', 890, NULL, '2020-09-09 17:49:00', '2020-09-21 16:33:16', 0, 0, NULL, '', '11726660', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-30P-30PS-PZ-F96-R.jpg'),
	(586, 31, 'M1642/30P/30PS', '/upload/product/product/M1642-30P-30PS-PZ-F96-1-R.jpg', '/upload/product/watermark/1616413215628469726.jpg', NULL, NULL, 3, 1, 34, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ2.jpg', 890, NULL, '2020-09-09 17:49:00', '2020-09-21 16:33:39', 0, 0, NULL, '', '11726672', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/M1642-30P-30PS-PZ-F96-1-R1.jpg'),
	(587, 31, 'M1642/30P/30PS', '/upload/cover_img/M1642-30P-30PS-PZ-F84-R.jpg', '/upload/product/watermark/1611297270871053284.jpg', NULL, NULL, 3, 1, 31, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ3.jpg', 890, NULL, '2020-09-09 17:49:00', '2020-09-21 16:33:51', 0, 0, NULL, '', '11726684', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/cover_img/M1642-30P-30PS-PZ-F84-R.jpg'),
	(588, 31, 'M1642/30P/30PS', '/upload/product/product/M1642-30P-30PS-PZ-F84-1-R.jpg', '/upload/product/watermark/1608948716496057401.jpg', NULL, NULL, 3, 1, 32, 1, 1, '1', '3,4,5', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-74', NULL, '8', '/upload/product/product/M1642-30P-30PS-PZ4.jpg', 890, NULL, '2020-09-09 17:49:00', '2020-09-21 16:34:14', 0, 0, NULL, '', '11726696', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/M1642-30P-30PS-PZ-F84-1-R1.jpg'),
	(589, 47, 'M471', '/upload/product/product/M471-F97-1-R-Set2.jpg', '/upload/product/watermark/1603608835173104493.jpg', NULL, NULL, 12, 3, 36, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set24.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:12:46', 0, 0, NULL, '光面(不开孔)', '11732969', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/knob221.png', '/upload/product/product/M471-F97-1-R-Set21.jpg'),
	(590, 47, 'M471', '/upload/product/product/M471-F78-1-R-Set2.jpg', '/upload/product/watermark/1603608821865406379.jpg', NULL, NULL, 12, 3, 30, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set25.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:12:53', 0, 0, NULL, '光面(不开孔)', '11732970', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/knob222.png', '/upload/product/product/M471-F78-1-R-Set21.jpg'),
	(591, 47, 'M471', '/upload/product/product/M471-F96-1-R-Set2.jpg', '/upload/product/watermark/1603608825396779274.jpg', NULL, NULL, 12, 3, 34, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set26.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:13:01', 0, 0, NULL, '光面(不开孔)', '11732982', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/knob223.png', '/upload/product/product/M471-F96-1-R-Set21.jpg'),
	(592, 47, 'M471', '/upload/product/product/M471-F84-1-R-Set2.jpg', '/upload/product/watermark/1603608823919655438.jpg', NULL, NULL, 12, 3, 32, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set29.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:13:14', 0, 0, NULL, '光面(不开孔)', '11732994', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/knob229.png', '/upload/product/product/M471-F84-1-R-Set21.jpg'),
	(593, 47, 'M471', '/upload/product/product/M471-F97-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 36, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set54.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:13:24', 0, 0, NULL, '光面(不开孔)', '11733007', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/product/product/M471-F97-1-R-Set51.jpg'),
	(594, 47, 'M471', '/upload/product/product/M471-F96-1-R-Set5.jpg', '/upload/product/watermark/1603608819394800566.jpg', NULL, NULL, 12, NULL, 34, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set55.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:13:32', 0, 0, NULL, '光面(不开孔)', '11733019', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/product/product/M471-F96-1-R-Set51.jpg'),
	(595, 47, 'M471', '/upload/product/product/M471-F84-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 32, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set56.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:13:41', 0, 0, NULL, '光面(不开孔)', '11733020', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/product/product/M471-F84-1-R-Set51.jpg'),
	(596, 47, 'M471', '/upload/product/product/M471-F78-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 30, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set57.jpg', 789, NULL, '2020-09-09 17:49:00', '2020-09-21 11:13:46', 0, 0, NULL, '光面(不开孔)', '11733032', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/product/product/M471-F78-1-R-Set51.jpg'),
	(597, 47, 'M472', '/upload/product/product/M472-F97-1-R-Set7.jpg', '/upload/product/watermark/1603608854525130881.jpg', NULL, NULL, 12, 3, 36, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set79.jpg', 787, NULL, '2020-09-09 17:49:00', '2020-09-25 18:55:18', 0, 0, NULL, '光面(不开孔)', '11733044', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/knob238.png', '/upload/product/product/M472-F97-1-R-Set71.jpg'),
	(598, 47, 'M472', '/upload/product/product/M472-F78-1-R-Set7.jpg', '/upload/product/watermark/1606450604099940034.jpg', NULL, NULL, 12, 3, 30, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set74.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:15:34', 0, 0, NULL, '光面(不开孔)', '11733056', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/knob235.png', '/upload/product/product/M472-F78-1-R-Set71.jpg'),
	(599, 47, 'M472', '/upload/product/product/M472-F96-1-R-Set7.jpg', '/upload/product/watermark/1610430727002494448.jpg', NULL, NULL, 12, 3, 34, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set75.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:15:43', 0, 0, NULL, '光面(不开孔)', '11733068', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/knob236.png', '/upload/product/product/M472-F96-1-R-Set71.jpg'),
	(600, 47, 'M472', '/upload/product/product/M472-F84-1-R-Set7.jpg', '/upload/product/watermark/1603608849416267655.jpg', NULL, NULL, 12, 3, 32, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set76.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:15:50', 0, 0, NULL, '光面(不开孔)', '11733075', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/knob237.png', '/upload/product/product/M472-F84-1-R-Set71.jpg'),
	(601, 47, 'M472', '/upload/product/product/M472-F97-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 36, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set5.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:15:58', 0, 0, NULL, '光面(不开孔)', '11733081', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/product/product/M472-F97-1-R-Set51.jpg'),
	(602, 47, 'M472', '/upload/product/product/M472-F78-1-R-Set5.jpg', '/upload/product/watermark/1609857633654281465.jpg', NULL, NULL, 12, NULL, 30, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set51.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:16:04', 0, 0, NULL, '光面(不开孔)', '11733093', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/product/product/M472-F78-1-R-Set51.jpg'),
	(603, 47, 'M472', '/upload/product/product/M472-F96-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 34, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set52.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:16:13', 0, 0, NULL, '光面(不开孔)', '11733105', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/product/product/M472-F96-1-R-Set51.jpg'),
	(604, 47, 'M472', '/upload/product/product/M472-F84-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 32, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set53.jpg', 787, NULL, '2020-09-09 17:49:01', '2020-09-21 11:16:19', 0, 0, NULL, '光面(不开孔)', '11733111', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/product/product/M472-F84-1-R-Set51.jpg'),
	(605, 47, 'M464', '/upload/product/product/M464-F97-R-Set5.jpg', '/upload/product/watermark/1616482578142373205.jpg', NULL, NULL, 12, NULL, 35, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set5.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:08:38', 0, 0, NULL, '光面(不开孔)', '11733172', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/product/product/M464-F97-R-Set51.jpg'),
	(606, 47, 'M464', '/upload/product/product/M464-F78-R-Set5.jpg', '/upload/product/watermark/1603608801993933273.jpg', NULL, NULL, 12, NULL, 29, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set51.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:08:43', 0, 0, NULL, '光面(不开孔)', '11733184', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/product/product/M464-F78-R-Set51.jpg'),
	(607, 47, 'M464', '/upload/product/product/M464-F96-R-Set5.jpg', '/upload/product/watermark/1610430731460020766.jpg', NULL, NULL, 12, NULL, 33, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set52.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:08:50', 0, 0, NULL, '光面(不开孔)', '11733196', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/product/product/M464-F96-R-Set51.jpg'),
	(608, 47, 'M464', '/upload/product/product/M464-F84-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 31, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set53.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:08:56', 0, 0, NULL, '光面(不开孔)', '11733202', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/product/product/M464-F84-R-Set51.jpg'),
	(609, 47, 'M464', '/upload/product/product/M464-F97-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 36, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set54.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:03', 0, 0, NULL, '光面(不开孔)', '11733214', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/product/product/M464-F97-1-R-Set51.jpg'),
	(610, 47, 'M464', '/upload/product/product/M464-F78-1-R-Set5.jpg', '/upload/product/watermark/1603608817085384423.jpg', NULL, NULL, 12, NULL, 30, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set55.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:08', 0, 0, NULL, '光面(不开孔)', '11733226', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/product/product/M464-F78-1-R-Set51.jpg'),
	(611, 47, 'M464', '/upload/product/product/M464-F96-1-R-Set5.jpg', '/upload/product/watermark/1606450580139637691.jpg', NULL, NULL, 12, NULL, 34, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set56.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:15', 0, 0, NULL, '光面(不开孔)', '11733238', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/product/product/M464-F96-1-R-Set51.jpg'),
	(612, 47, 'M464', '/upload/product/product/M464-F84-1-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 32, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M464-Set57.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:20', 0, 0, NULL, '光面(不开孔)', '11733245', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/product/product/M464-F84-1-R-Set51.jpg'),
	(613, 47, 'M464', '/upload/product/product/M464-F97-R-Set7.jpg', '/upload/product/watermark/1602748078844833415.jpg', NULL, NULL, 12, 3, 35, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set7.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:33', 0, 0, NULL, '光面(不开孔)', '11733251', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/knob29.png', '/upload/product/product/M464-F97-R-Set71.jpg'),
	(614, 47, 'M464', '/upload/product/product/M464-F78-R-Set7.jpg', '/upload/product/watermark/1601300087863359462.jpg', NULL, NULL, 12, 3, 29, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set71.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:40', 0, 0, NULL, '光面(不开孔)', '11733263', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/knob210.png', '/upload/product/product/M464-F78-R-Set71.jpg'),
	(615, 47, 'M464', '/upload/product/product/M464-F96-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 33, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set72.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:50', 0, 0, NULL, '光面(不开孔)', '11733275', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/knob211.png', '/upload/product/product/M464-F96-R-Set71.jpg'),
	(616, 47, 'M464', '/upload/product/product/M464-F84-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 31, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set73.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:09:57', 0, 0, NULL, '光面(不开孔)', '11733287', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/upload/product/product/knob212.png', '/upload/product/product/M464-F84-R-Set71.jpg'),
	(617, 47, 'M464', '/upload/product/product/M464-F97-1-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 36, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set74.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:10:05', 0, 0, NULL, '光面(不开孔)', '11733385', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/knob213.png', '/upload/product/product/M464-F97-1-R-Set71.jpg'),
	(618, 47, 'M464', '/upload/product/product/M464-F78-1-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 30, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set75.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:10:12', 0, 0, NULL, '光面(不开孔)', '11733391', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/knob214.png', '/upload/product/product/M464-F78-1-R-Set71.jpg'),
	(619, 47, 'M464', '/upload/product/product/M464-F96-1-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 34, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set76.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:10:21', 0, 0, NULL, '光面(不开孔)', '11733408', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/knob215.png', '/upload/product/product/M464-F96-1-R-Set71.jpg'),
	(620, 47, 'M464', '/upload/product/product/M464-F84-1-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 32, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M464-Set77.jpg', 791, NULL, '2020-09-09 17:49:01', '2020-09-21 11:10:26', 0, 0, NULL, '光面(不开孔)', '11733415', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/knob216.png', '/upload/product/product/M464-F84-1-R-Set71.jpg'),
	(621, 47, 'M443', '/upload/product/product/M443-F97-R-Set5.jpg', '/upload/product/watermark/1603608743642363587.jpg', NULL, NULL, 12, NULL, 35, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set5.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:03:35', 0, 0, NULL, '光面(不开孔)', '11733433', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/product/product/M443-F97-R-Set51.jpg'),
	(622, 47, 'M443', '/upload/product/product/M443-F78-R-Set5.jpg', '/upload/product/watermark/1610430739051826704.jpg', NULL, NULL, 12, NULL, 29, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set51.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:03:43', 0, 0, NULL, '光面(不开孔)', '11733445', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/product/product/M443-F78-R-Set51.jpg'),
	(623, 47, 'M443', '/upload/product/product/M443-F96-R-Set5.jpg', '/upload/product/watermark/1604306167167015442.jpg', NULL, NULL, 12, NULL, 33, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set52.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:03:49', 0, 0, NULL, '光面(不开孔)', '11733482', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/product/product/M443-F96-R-Set51.jpg'),
	(624, 47, 'M443', '/upload/product/product/M443-F84-R-Set5.jpg', '/upload/product/watermark/1616377379004566768.jpg', NULL, NULL, 12, NULL, 31, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set53.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:04:00', 0, 0, NULL, '光面(不开孔)', '11733494', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/product/product/M443-F84-R-Set51.jpg'),
	(625, 47, 'M443', '/upload/product/product/M443-F97-1-R-Set5.jpg', '/upload/product/watermark/1603691995181854082.jpg', NULL, NULL, 12, NULL, 36, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set54.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:04:06', 0, 0, NULL, '光面(不开孔)', '11733500', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/product/product/M443-F97-1-R-Set51.jpg'),
	(626, 47, 'M443', '/upload/product/product/M443-F78-1-R-Set5.jpg', '/upload/product/watermark/1603608748622432634.jpg', NULL, NULL, 12, NULL, 30, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set55.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:04:14', 0, 0, NULL, '光面(不开孔)', '11733512', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/product/product/M443-F78-1-R-Set51.jpg'),
	(627, 47, 'M443', '/upload/product/product/M443-F84-1-R-Set5.jpg', '/upload/product/watermark/1603608724558093258.jpg', NULL, NULL, 12, NULL, 32, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set56.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:04:19', 0, 0, NULL, '光面(不开孔)', '11733524', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/product/product/M443-F84-1-R-Set51.jpg'),
	(628, 47, 'M443', '/upload/product/product/M443-F96-1-R-Set5.jpg', '/upload/product/watermark/1603608746014008676.jpg', NULL, NULL, 12, NULL, 34, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M443-Set57.jpg', 799, NULL, '2020-09-09 17:49:01', '2020-09-21 11:04:30', 0, 0, NULL, '光面(不开孔)', '11733536', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/product/product/M443-F96-1-R-Set51.jpg'),
	(629, 40, '0737/UD9024', '/upload/cover_img/0737-UD9024-F31-1.jpg', '/upload/product/watermark/1616126533708743156.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0737-UD9024.jpg', 750, NULL, '2020-09-09 17:49:02', '2020-09-25 14:47:25', 0, 0, NULL, '', '11736015', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0737-UD9024-F31-1.jpg'),
	(630, 40, '0737/UD9024', '/upload/cover_img/0737-UD9024-F9714M.jpg', '/upload/product/watermark/1616909434471580149.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0737-UD9024.jpg', 750, 1, '2020-09-09 17:49:02', '2020-09-25 14:47:31', 0, 0, NULL, '', '11736045', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0737-UD9024-F9714M.jpg'),
	(631, 47, 'M443', '/upload/product/product/M443-F97-R-Set2.jpg', NULL, NULL, NULL, 12, 3, 35, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set2.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:02:41', 0, 0, NULL, '光面(不开孔)', '11734280', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/knob2.png', '/upload/product/product/M443-F97-R-Set21.jpg'),
	(632, 47, 'M443', '/upload/product/product/M443-F78-R-Set2.jpg', '/upload/product/watermark/1603423813338735209.jpg', NULL, NULL, 12, 3, 29, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set21.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:02:47', 0, 0, NULL, '光面(不开孔)', '11734292', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/knob21.png', '/upload/product/product/M443-F78-R-Set21.jpg'),
	(633, 47, 'M443', '/upload/product/product/M443-F96-R-Set2.jpg', NULL, NULL, NULL, 12, 3, 33, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set22.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:02:53', 0, 0, NULL, '光面(不开孔)', '11734309', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/knob22.png', '/upload/product/product/M443-F96-R-Set21.jpg'),
	(634, 47, 'M443', '/upload/product/product/M443-F84-R-Set2.jpg', NULL, NULL, NULL, 12, NULL, 31, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set23.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:02:59', 0, 0, NULL, '光面(不开孔)', '11734310', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/product/product/M443-F84-R-Set21.jpg'),
	(635, 47, 'M443', '/upload/product/product/M443-F97-1-R-Set2.jpg', '/upload/product/watermark/1602560476626375316.jpg', NULL, NULL, 12, 3, 36, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set24.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:03:04', 0, 0, NULL, '光面(不开孔)', '11734322', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/knob23.png', '/upload/product/product/M443-F97-1-R-Set21.jpg'),
	(636, 47, 'M443', '/upload/product/product/M443-F78-1-R-Set2.jpg', '/upload/product/watermark/1602818565616908840.jpg', NULL, NULL, 12, 3, 30, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set25.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:03:12', 0, 0, NULL, '光面(不开孔)', '11734334', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/knob24.png', '/upload/product/product/M443-F78-1-R-Set21.jpg'),
	(637, 47, 'M443', '/upload/product/product/M443-F96-1-R-Set2.jpg', '/upload/product/watermark/1602748115350678681.jpg', NULL, NULL, 12, 3, 34, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set26.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:03:17', 0, 0, NULL, '光面(不开孔)', '11734346', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/knob25.png', '/upload/product/product/M443-F96-1-R-Set21.jpg'),
	(638, 47, 'M443', '/upload/product/product/M443-F84-1-R-Set2.jpg', NULL, NULL, NULL, 12, 3, 32, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M443-Set27.jpg', 799, NULL, '2020-09-09 17:49:02', '2020-09-21 11:03:27', 0, 0, NULL, '光面(不开孔)', '11734358', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/knob26.png', '/upload/product/product/M443-F84-1-R-Set21.jpg'),
	(639, 24, '1140/42K/42KS', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F9714M.jpg', '/upload/product/watermark/1616560141869238323.jpg', NULL, NULL, 1, 1, 16, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '47-57', NULL, '8', '/upload/product/product/1140-42K-42KS-PZ1.jpg', 835, NULL, '2020-09-09 17:49:02', '2020-09-14 16:09:50', 0, 1, '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F9714M-Motiv1-nW.png', '', '11736367', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F9714M1.jpg'),
	(640, 47, 'M471', '/upload/product/product/M471-F97-R-Set2.jpg', '/upload/product/watermark/1603608828852522649.jpg', NULL, NULL, 12, 3, 35, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set2.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:11:44', 0, 0, NULL, '光面(不开孔)', '11739083', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/knob220.png', '/upload/product/product/M471-F97-R-Set21.jpg'),
	(641, 47, 'M471', '/upload/product/product/M471-F78-R-Set2.jpg', '/upload/product/watermark/1603684003355785559.jpg', NULL, NULL, 12, 3, 29, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set21.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:11:49', 0, 0, NULL, '光面(不开孔)', '11739095', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/knob226.png', '/upload/product/product/M471-F78-R-Set21.jpg'),
	(642, 47, 'M471', '/upload/product/product/M471-F96-R-Set2.jpg', '/upload/product/watermark/1603608834116640440.jpg', NULL, NULL, 12, 3, 33, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set22.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:12:04', 0, 0, NULL, '光面(不开孔)', '11739101', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/knob227.png', '/upload/product/product/M471-F96-R-Set21.jpg'),
	(643, 47, 'M471', '/upload/product/product/M471-F84-R-Set2.jpg', '/upload/product/watermark/1603608825011891001.jpg', NULL, NULL, 12, 3, 31, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M471-Set23.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:12:09', 0, 0, NULL, '光面(不开孔)', '11739113', NULL, NULL, NULL, '2 紧急开启钮/旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/upload/product/product/knob228.png', '/upload/product/product/M471-F84-R-Set21.jpg'),
	(644, 47, 'M471', '/upload/product/product/M471-F97-R-Set5.jpg', '/upload/product/watermark/1610516154237251282.jpg', NULL, NULL, 12, NULL, 35, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set5.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:12:16', 0, 0, NULL, '光面(不开孔)', '11739125', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/product/product/M471-F97-R-Set51.jpg'),
	(645, 47, 'M471', '/upload/product/product/M471-F78-R-Set5.jpg', '/upload/product/watermark/1607457583342502208.jpg', NULL, NULL, 12, NULL, 29, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set51.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:12:22', 0, 0, NULL, '光面(不开孔)', '11739137', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/product/product/M471-F78-R-Set51.jpg'),
	(646, 47, 'M471', '/upload/product/product/M471-F96-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 33, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set52.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:12:29', 0, 0, NULL, '光面(不开孔)', '11739149', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/product/product/M471-F96-R-Set51.jpg'),
	(647, 47, 'M471', '/upload/product/product/M471-F84-R-Set5.jpg', '/upload/product/watermark/1607073942766610283.jpg', NULL, NULL, 12, NULL, 31, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M471-Set53.jpg', 789, NULL, '2020-09-09 17:49:02', '2020-09-21 11:12:37', 0, 0, NULL, '光面(不开孔)', '11739150', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '', '/upload/product/product/M471-F84-R-Set51.jpg'),
	(648, 47, 'M472', '/upload/product/product/M472-F97-R-Set7.jpg', '/upload/product/watermark/1603608857501614390.jpg', NULL, NULL, 12, 3, 35, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set71.jpg', 787, NULL, '2020-09-09 17:49:02', '2020-09-21 11:15:09', 0, 0, NULL, '光面(不开孔)', '11739162', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/knob232.png', '/upload/product/product/M472-F97-R-Set71.jpg'),
	(649, 47, 'M472', '/upload/product/product/M472-F78-R-Set7.jpg', '/upload/product/watermark/1603608845685321121.jpg', NULL, NULL, 12, 3, 29, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set72.jpg', 787, NULL, '2020-09-09 17:49:02', '2020-09-21 11:15:15', 0, 0, NULL, '光面(不开孔)', '11739174', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/knob233.png', '/upload/product/product/M472-F78-R-Set71.jpg'),
	(650, 47, 'M472', '/upload/product/product/M472-F96-R-Set7.jpg', NULL, NULL, NULL, 12, 3, 33, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set73.jpg', 787, NULL, '2020-09-09 17:49:02', '2020-09-21 11:15:29', 0, 0, NULL, '光面(不开孔)', '11739186', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/knob234.png', '/upload/product/product/M472-F96-R-Set71.jpg'),
	(651, 47, 'M472', '/upload/product/product/M472-F84-R-Set7.jpg', '/upload/product/watermark/1606450592479637619.jpg', NULL, NULL, 12, 3, 31, 1, 1, '4', '5', NULL, '33-48', NULL, '8', '/upload/product/product/M472-Set7.jpg', 787, NULL, '2020-09-09 17:49:03', '2020-09-21 11:14:44', 0, 0, NULL, '光面(不开孔)', '11739198', NULL, NULL, NULL, '7 紧急开启钮/拉环式旋钮', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/upload/product/product/knob230.png', '/upload/product/product/M472-F84-R-Set71.jpg'),
	(652, 47, 'M472', '/upload/product/product/M472-F97-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 35, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set56.jpg', 787, NULL, '2020-09-09 17:49:03', '2020-09-21 11:14:49', 0, 0, NULL, '光面(不开孔)', '11739216', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '', '/upload/product/product/M472-F97-R-Set51.jpg'),
	(653, 47, 'M472', '/upload/product/product/M472-F78-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 29, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set57.jpg', 787, NULL, '2020-09-09 17:49:03', '2020-09-21 11:14:56', 0, 0, NULL, '光面(不开孔)', '11739228', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '', '/upload/product/product/M472-F78-R-Set51.jpg'),
	(654, 47, 'M472', '/upload/product/product/M472-F96-R-Set5.jpg', NULL, NULL, NULL, 12, NULL, 33, 1, 1, '4', '5', NULL, '最小33', NULL, NULL, '/upload/product/product/M472-Set58.jpg', 787, NULL, '2020-09-09 17:49:03', '2020-09-21 11:15:01', 0, 0, NULL, '光面(不开孔)', '11739235', NULL, NULL, NULL, '5 空', '', '', '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝固定平移拉手，指孔扣手以建筑硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '', '/upload/product/product/M472-F96-R-Set51.jpg'),
	(655, 12, '0515-2/US952-1', '/upload/cover_img/0515-2-US952-1-F1.jpg', '/upload/product/watermark/1616983442304700494.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0515-2-US-952-1.jpg', 700, NULL, '2020-09-09 17:49:03', '2020-09-25 15:07:47', 0, 0, NULL, '', '11747079', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0515-2-US952-1-F1.jpg'),
	(656, 12, '0515-2/US952-1', '/upload/cover_img/0515-2-US952-1-F4.jpg', '/upload/product/watermark/1616813780138585882.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0515-2-US-952-11.jpg', 700, NULL, '2020-09-09 17:49:03', '2020-09-25 15:07:53', 0, 0, NULL, '', '11747080', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0515-2-US952-1-F4.jpg'),
	(657, 45, '0700/U26/49PNS', '/upload/cover_img/0700-U26-49PNS-PZ-F1-innen.jpg', '/upload/product/watermark/1616389993041168469.jpg', NULL, NULL, 3, 1, 2, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, NULL, '7', '/upload/img_sample/0700-U26-49PNS-PZ.jpg', 929, NULL, '2020-09-09 17:49:03', '2020-09-25 10:58:44', 0, 0, NULL, '', '11750157', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0700-U26-49PNS-PZ-F1-innen.jpg'),
	(658, 45, '0700/U26/49PNS', '/upload/cover_img/0700-U26-49PNS-PZ-F4-innen.jpg', '/upload/product/watermark/1616390013010113855.jpg', NULL, NULL, 3, 1, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, NULL, '7', '/upload/img_sample/0700-U26-49PNS-PZ.jpg', 929, NULL, '2020-09-09 17:49:03', '2020-10-13 11:19:22', 0, 0, NULL, '', '11750182', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0700-U26-49PNS-PZ-F4-innen.jpg'),
	(659, 45, '0700/U26/49PNS', '/upload/cover_img/0700-U26-49PNS-PZ-F31-1-innen.jpg', '/upload/product/watermark/1616390004303741074.jpg', NULL, NULL, 3, 1, 12, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, NULL, '7', '/upload/img_sample/0700-U26-49PNS-PZ.jpg', 929, NULL, '2020-09-09 17:49:03', '2020-10-13 11:18:54', 0, 0, NULL, '', '11750224', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0700-U26-49PNS-PZ-F31-1-innen.jpg'),
	(660, 45, '0700/U26/49PNS', '/upload/cover_img/0700-U26-49PNS-PZ-F9714M-innen.jpg', '/upload/product/watermark/1614573760455691668.jpg', NULL, NULL, 3, 1, 16, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, NULL, '7', '/upload/img_sample/0700-U26-49PNS-PZ.jpg', 929, NULL, '2020-09-09 17:49:03', '2020-10-13 11:19:13', 0, 0, NULL, '', '11750261', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0700-U26-49PNS-PZ-F9714M-innen.jpg'),
	(661, 43, '1540/3347N', '/upload/product/product/1540-3347N-PZ92-F4.jpg', '/upload/product/watermark/1615968892644115385.jpg', NULL, NULL, 3, 1, 8, 3, 1, '1', NULL, '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1540-3347N-PZ.jpg', 900, NULL, '2020-09-09 17:49:03', '2020-09-21 16:27:31', 0, 0, NULL, '', '11750534', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1540-3347N-PZ92-F41.jpg'),
	(662, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F97-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 35, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL458.jpg', 828, NULL, '2020-09-09 17:49:03', '2020-09-15 10:49:32', 0, 0, NULL, '', '11757280', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F97-R-MSK91-OL451.jpg'),
	(663, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F97-1-R-MSK91-OL45.jpg', '/upload/product/watermark/1602509473794704169.jpg', NULL, NULL, 1, 3, 36, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL45.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:44:40', 0, 0, NULL, '', '11757292', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F97-1-R-MSK91-OL451.jpg'),
	(664, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F78-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 29, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL451.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:45:23', 0, 0, NULL, '', '11757310', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F78-R-MSK91-OL451.jpg'),
	(665, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F78-1-R-MSK91-OL45.jpg', '/upload/product/watermark/1602407694363037443.jpg', NULL, NULL, 1, 3, 30, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL452.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:46:14', 0, 0, NULL, '', '11757322', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F78-1-R-MSK91-OL451.jpg'),
	(666, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F96-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 33, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL453.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:46:39', 0, 0, NULL, '', '11757334', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F96-R 亮黑', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F96-R-MSK91-OL451.jpg'),
	(667, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F96-1-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 34, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL454.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:47:09', 0, 0, NULL, '', '11757346', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F96-1-R-MSK91-OL451.jpg'),
	(668, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F84-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 31, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL455.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:47:39', 0, 0, NULL, '', '11757358', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F84-R-MSK91-OL451.jpg'),
	(669, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F84-1-R-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 32, 1, 1, '4', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL456.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:48:01', 0, 0, NULL, '', '11757365', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F84-1-R-MSK91-OL451.jpg'),
	(670, 47, 'M845S', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL45.jpg', NULL, NULL, NULL, 1, 3, 14, 1, 1, '', '5', '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/M845S-SK-OL-MSK91-MOL457.jpg', 828, NULL, '2020-09-09 17:49:04', '2020-09-15 10:48:57', 0, 0, NULL, '', '11757383', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/knob241.png', '/upload/product/product/M845S-SK-OL-F9016M-MSK91-OL451.jpg'),
	(671, 38, '1769/645', '/upload/cover_img/1769-645-F31-1.jpg', '/upload/product/watermark/1616411295284482843.jpg', NULL, NULL, 1, NULL, 12, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/img_sample/1769-645.jpg', 893, NULL, '2020-09-09 17:49:04', '2020-10-13 19:32:49', 0, 0, NULL, '', '11760813', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1769-645-F31-1.jpg'),
	(672, 38, '1769/645', '/upload/cover_img/1769-645-F9714M.jpg', '/upload/product/watermark/1616856822708338263.jpg', NULL, NULL, 1, NULL, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/img_sample/1769-645.jpg', 893, NULL, '2020-09-09 17:49:04', '2020-10-13 19:32:54', 0, 0, NULL, '', '11760837', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1769-645-F9714M.jpg'),
	(673, 38, '1769/645', '/upload/cover_img/1769-645-F9016M.jpg', '/upload/product/watermark/1616640342913984633.jpg', NULL, NULL, 1, NULL, 88, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '35-45', NULL, '8', '/upload/img_sample/1769-645.jpg', 893, NULL, '2020-09-09 17:49:04', '2020-10-13 19:32:59', 0, 0, NULL, '', '11760849', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/cover_img/1769-645-F9016M.jpg'),
	(674, 38, '1769/843K/843KS', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F1.jpg', '/upload/product/watermark/1616856755457144359.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-67', NULL, '8', '/upload/product/product/1769-843K-843KS-PZ3.jpg', 894, NULL, '2020-09-09 17:49:04', '2020-09-11 12:17:08', 0, 0, NULL, '', '11760618', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F11.jpg'),
	(675, 38, '1769/843K/843KS', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F9.jpg', '/upload/product/watermark/1616856758262626928.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-67', NULL, '8', '/upload/product/product/1769-843K-843KS-PZ.jpg', 894, NULL, '2020-09-09 17:49:05', '2020-09-11 12:16:45', 0, 0, NULL, '', '11760655', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F91.jpg'),
	(676, 38, '1769/843K/843KS', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F31-1.jpg', '/upload/product/watermark/1616856756569243067.jpg', NULL, NULL, 1, 1, 12, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-67', NULL, '8', '/upload/product/product/1769-843K-843KS-PZ1.jpg', 894, NULL, '2020-09-09 17:49:05', '2020-09-11 12:16:55', 0, 0, NULL, '', '11760680', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F31-11.jpg'),
	(677, 38, '1769/843K/843KS', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F9714M.jpg', '/upload/product/watermark/1616856781010146886.jpg', NULL, NULL, 1, 1, 16, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '57-67', NULL, '8', '/upload/product/product/1769-843K-843KS-PZ2.jpg', 894, 1, '2020-09-09 17:49:05', '2020-09-14 15:50:23', 0, 1, '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F9714M-Motiv1-nW.png', '', '11760734', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1769-843K+KV-843KS+KVS-PZ-F9714M1.jpg'),
	(678, 47, '645S', '/upload/product/product/645S-SK-OL-F31-1-SK802-OL46.jpg', '/upload/product/watermark/1616377590175912029.jpg', NULL, NULL, 1, 3, 12, 3, 1, '', NULL, '<p>HOPPE 好博实心方轴<br/></p>', '43-48', '', '5-8', '/upload/product/product/645S-SK-OL-SK802-OL46.jpg', 826, NULL, '2020-09-09 17:49:05', '2020-09-15 17:17:04', 0, 0, NULL, '', '11761350', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/upload/product/product/knob241.png', '/upload/product/product/645S-SK-OL-F31-1-SK802-OL461.jpg'),
	(679, 47, '645S', '/upload/product/product/645S-SK-OL-F9714M-SK802-OL46.jpg', '/upload/product/watermark/1608937553494435736.jpg', NULL, NULL, 1, 3, 16, 3, 1, '', NULL, '<p>HOPPE 好博实心方轴</p>', '43-48', '', '5-8', '/upload/product/product/645S-SK-OL-SK802-OL461.jpg', 826, NULL, '2020-09-09 17:49:05', '2020-09-15 11:42:22', 0, 0, NULL, '', '11761362', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9714M 黑哑光', '/upload/product/product/knob241.png', '/upload/product/product/645S-SK-OL-F9714M-SK802-OL461.jpg'),
	(680, 47, '645S', '/upload/product/product/645S-SK-OL-F9016M-SK802-OL46.jpg', '/upload/product/watermark/1604999913199880625.jpg', NULL, NULL, 1, 3, 88, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '43-48', NULL, '5-8', '/upload/product/product/645S-SK-OL-SK802-OL462.jpg', 826, NULL, '2020-09-09 17:49:05', '2020-10-13 11:45:34', 0, 0, NULL, '', '11761374', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '沉孔螺钉，用粘合剂或硅胶固定', NULL, NULL, NULL, 'F9016M 交通白光', '/upload/product/product/knob241.png', '/upload/product/product/645S-SK-OL-F9016M-SK802-OL461.jpg'),
	(681, 47, '30PS', '/upload/product/product/30PS-PZ-F31-1.jpg', '/upload/product/watermark/1613920920524867386.jpg', NULL, NULL, 3, 1, 12, 3, 1, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/30PS-PZ-50mm.jpg', 820, NULL, '2020-09-09 17:49:05', '2020-09-25 10:45:05', 0, 0, NULL, '', '11764855', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/product/product/30PS-PZ-F31-11.jpg'),
	(682, 45, '1700/42K/42KS', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F1.jpg', '/upload/product/watermark/1616481685007576092.jpg', NULL, NULL, 1, 1, 2, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '55-65', NULL, '8', '/upload/product/product/1700-42K-42KS-PZ.jpg', 885, NULL, '2020-09-09 17:49:05', '2020-09-11 14:22:33', 0, 0, NULL, '', '11767236', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F11.jpg'),
	(683, 28, 'M543', '/upload/cover_img/M543-F97-1-R.jpg', '/upload/product/watermark/1606313654827523720.jpg', NULL, NULL, 5, NULL, 36, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:49:05', '2020-09-21 12:53:54', 0, 0, NULL, '', '11767212', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '', '/upload/cover_img/M543-F97-1-R.jpg'),
	(684, 45, '1700/42K/42KS', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F9.jpg', '/upload/product/watermark/1616049929956599894.jpg', NULL, NULL, 1, 1, 10, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '55-65', NULL, '8', '/upload/product/product/1700-42K-42KS-PZ1.jpg', 885, NULL, '2020-09-09 17:49:05', '2020-09-11 14:22:43', 0, 0, NULL, '', '11767418', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F91.jpg'),
	(685, 45, '1700/42K/42KS', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F31-1.jpg', '/upload/product/watermark/1616481686244383257.jpg', NULL, NULL, 1, 1, 12, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '55-65', NULL, '8', '/upload/product/product/1700-42K-42KS-PZ2.jpg', 885, NULL, '2020-09-09 17:49:05', '2020-09-14 15:57:21', 0, 1, '/upload/product/product/1700-42K+KV-42KS+KVS-PZ-F31-1-Motiv1-nW.png', '', '11767595', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F31-11.jpg'),
	(686, 45, '1700/42K/42KS', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F9714M.jpg', '/upload/product/watermark/1616386746036873326.jpg', NULL, NULL, 1, 1, 16, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '55-65', NULL, '8', '/upload/product/product/1700-42K-42KS-PZ3.jpg', 885, NULL, '2020-09-09 17:49:05', '2020-09-14 15:58:22', 0, 1, '/upload/product/product/1700-42K+KV-42KS+KVS-PZ-F9714M-Motiv1-nW.png', '', '11767674', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1700-42K+KV+KB-42KS+KVS+KBS-PZ-F9714M1.jpg'),
	(687, 40, '0737/UD9024', '/upload/cover_img/0737-UD9024-F1.jpg', '/upload/product/watermark/1616749501171089034.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0737-UD9024.jpg', 750, NULL, '2020-09-09 17:49:05', '2020-09-25 14:47:06', 0, 0, NULL, '', '11767832', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0737-UD9024-F1.jpg'),
	(688, 40, '0737/UD9024', '/upload/cover_img/0737-UD9024-F4.jpg', '/upload/product/watermark/1616226849061885504.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0737-UD9024.jpg', 750, NULL, '2020-09-09 17:49:05', '2020-09-25 14:47:12', 0, 0, NULL, '', '11767844', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0737-UD9024-F4.jpg'),
	(689, 40, '0737/UD9024', '/upload/cover_img/0737-UD9024-F1.jpg', NULL, NULL, NULL, 7, NULL, 2, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0737-UD9024.jpg', 750, NULL, '2020-09-09 17:49:05', '2020-09-25 14:47:17', 0, 0, NULL, '', '11767959', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0737-UD9024-F1.jpg'),
	(690, 40, '0737/UD9024', '/upload/cover_img/0737-UD9024-F4.jpg', NULL, NULL, NULL, 7, NULL, 8, 3, 1, '7,6', '7', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0737-UD9024.jpg', 750, NULL, '2020-09-09 17:49:05', '2020-09-25 14:47:21', 0, 0, NULL, '', '11767960', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0737-UD9024-F4.jpg'),
	(691, 38, '0769LVK/U74Z', '/upload/product/product/0769LVK-U74Z-F31-1-links.jpg', '/upload/product/watermark/1616810180924752954.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '63', '7', '/upload/product/product/0769LVK-U74Z-LI.jpg', 930, NULL, '2020-09-09 17:49:06', '2020-10-14 11:55:48', 0, 0, NULL, '', '11775713', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/product/product/0769LVK-U74Z-F31-1-links1.jpg'),
	(692, 38, '0769LVK/U74Z', '/upload/product/product/0769LVK-U74Z-F9-links.jpg', '/upload/product/watermark/1616496804812047483.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '63', '7', '/upload/product/product/0769LVK-U74Z-LI1.jpg', 930, NULL, '2020-09-09 17:49:06', '2020-10-14 11:56:00', 0, 0, NULL, '', '11775804', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, 'F9 仿钢色', '', '/upload/product/product/0769LVK-U74Z-F9-links1.jpg'),
	(693, 38, '0769LVK/U74Z', '/upload/product/product/0769LVK-U74Z-F9714M-links.jpg', '/upload/product/watermark/1615857877088964425.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '63', '7', '/upload/product/product/0769LVK-U74Z-LI2.jpg', 930, NULL, '2020-09-09 17:49:06', '2020-10-14 11:56:06', 0, 0, NULL, '', '11775816', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, 'F9714M 黑哑光', '', '/upload/product/product/0769LVK-U74Z-F9714M-links1.jpg'),
	(694, 38, '0769LVK/U74Z', '/upload/product/product/0769LVK-U74Z-F31-1-rechts.jpg', '/upload/product/watermark/1616555047615749085.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '63', '7', '/upload/product/product/0769LVK-U74Z-RE.jpg', 930, NULL, '2020-09-09 17:49:06', '2020-10-14 11:56:12', 0, 0, NULL, '', '11775841', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/product/product/0769LVK-U74Z-F31-1-rechts1.jpg'),
	(695, 38, '0769LVK/U74Z', '/upload/product/product/0769LVK-U74Z-F9-rechts.jpg', '/upload/product/watermark/1609989912268839731.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '63', '7', '/upload/product/product/0769LVK-U74Z-RE1.jpg', 930, NULL, '2020-09-09 17:49:06', '2020-10-14 11:56:19', 0, 0, NULL, '', '11775853', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, 'F9 仿钢色', '', '/upload/product/product/0769LVK-U74Z-F9-rechts1.jpg'),
	(696, 38, '0769LVK/U74Z', '/upload/product/product/0769LVK-U74Z-F9714M-rechts.jpg', '/upload/product/watermark/1616915121795457154.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '63', '7', '/upload/product/product/0769LVK-U74Z-RE2.jpg', 930, NULL, '2020-09-09 17:49:06', '2020-10-14 11:56:25', 0, 0, NULL, '', '11775865', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, 'F9714M 黑哑光', '', '/upload/product/product/0769LVK-U74Z-F9714M-rechts1.jpg'),
	(697, 40, '1737/844P/844PS', '/upload/product/product/哑光.jpg', '/upload/product/watermark/1616653886650423707.jpg', NULL, NULL, 3, 1, 12, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '62-72', NULL, '8', '/upload/product/product/1737-844P-844PS-PZ.jpg', 870, 0, '2020-09-09 17:49:06', '2020-10-26 11:44:06', 0, 0, NULL, '', '11775397', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，多用螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/哑光1.jpg'),
	(698, 34, '1558/2830N', '/upload/product/product/1558-2830N-PZ92-F1-11.jpg', '/upload/product/watermark/1616816689183518649.jpg', NULL, NULL, 3, 6, 4, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '85-90', NULL, '8', '/upload/product/product/1558-2830N-PZ.jpg', 950, NULL, '2020-09-09 17:49:06', '2020-09-25 10:34:44', 0, 0, NULL, '', '11780101', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M5螺丝配装饰帽', NULL, NULL, NULL, 'F1-11 亮银色/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1558-2830N-PZ92-F1-111.jpg'),
	(699, 45, '1700/3347N', '/upload/product/product/1700-3347N-PZ92-F1.jpg', '/upload/product/watermark/1616297624432408155.jpg', NULL, NULL, 3, 6, 2, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1700-3347N-PZ.jpg', 910, NULL, '2020-09-09 17:49:06', '2020-09-25 10:40:18', 0, 0, NULL, '', '11783266', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1700-3347N-PZ92-F11.jpg'),
	(700, 45, '1700/3347N', '/upload/product/product/1700-3347N-PZ92-F9.jpg', '/upload/product/watermark/1616297627674170689.jpg', NULL, NULL, 3, 6, 10, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1700-3347N-PZ1.jpg', 910, NULL, '2020-09-09 17:49:06', '2020-09-25 10:40:25', 0, 0, NULL, '', '11783285', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1700-3347N-PZ92-F91.jpg'),
	(701, 45, '1700/3347N', '/upload/product/product/1700-3347N-PZ92-F9714M.jpg', '/upload/product/watermark/1616109932203202554.jpg', NULL, NULL, 3, 6, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1700-3347N-PZ2.jpg', 910, NULL, '2020-09-09 17:49:06', '2020-09-25 10:40:34', 0, 0, NULL, '', '11783291', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1700-3347N-PZ92-F9714M1.jpg'),
	(702, 45, '1700/3347N', '/upload/product/product/1700-3347N-PZ92-F31-1.jpg', '/upload/product/watermark/1616817015157325802.jpg', NULL, NULL, 3, 6, 12, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1700-3347N-PZ3.jpg', 910, NULL, '2020-09-09 17:49:06', '2020-09-25 10:40:40', 0, 0, NULL, '', '11783315', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1700-3347N-PZ92-F31-11.jpg'),
	(703, 45, '1700/30P', '/upload/cover_img/1700-30P-F1.jpg', '/upload/product/watermark/1616661212883593429.jpg', NULL, NULL, 3, NULL, 2, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1700-30P.jpg', 920, NULL, '2020-09-09 17:49:07', '2020-09-25 10:39:09', 0, 0, NULL, '', '11783321', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/1700-30P-F1.jpg'),
	(704, 45, '1700/30P', '/upload/cover_img/1700-30P-F9.jpg', '/upload/product/watermark/1608516565328409243.jpg', NULL, NULL, 3, NULL, 10, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1700-30P1.jpg', 920, NULL, '2020-09-09 17:49:07', '2020-09-25 10:39:20', 0, 0, NULL, '', '11783333', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/cover_img/1700-30P-F9.jpg'),
	(705, 45, '1700/30P', '/upload/cover_img/1700-30P-F9714M.jpg', '/upload/product/watermark/1614907032652492279.jpg', NULL, NULL, 3, NULL, 16, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1700-30P2.jpg', 920, NULL, '2020-09-09 17:49:07', '2020-09-25 10:39:25', 0, 0, NULL, '', '11783345', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1700-30P-F9714M.jpg'),
	(706, 45, '1700/30P', '/upload/cover_img/1700-30P-F31-1.jpg', '/upload/product/watermark/1610545517833779123.jpg', NULL, NULL, 3, NULL, 12, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1700-30P3.jpg', 920, NULL, '2020-09-09 17:49:07', '2020-09-25 10:39:31', 0, 0, NULL, '', '11783369', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/1700-30P-F31-1.jpg'),
	(707, 24, '1140/42K/42KS', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F4.jpg', '/upload/product/watermark/1616742793980905582.jpg', NULL, NULL, 1, 1, 8, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（非独立方轴）</p>', '37-47', NULL, '8', '/upload/product/product/1140-42K-42KS-PZ.jpg', 835, NULL, '2020-09-09 17:49:07', '2020-09-11 15:43:10', 0, 0, NULL, '', '11781592', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1140-42K+KV-42KS+KVS-PZ-F41.jpg'),
	(708, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F4.jpg', NULL, NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0515-1-US9522.jpg', 710, NULL, '2020-09-09 17:49:07', '2020-09-25 15:02:23', 0, 0, NULL, '', '11784866', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0515-1-US952-F4.jpg'),
	(709, 38, '1769/844P', '/upload/product/product/1769-844P-F1.jpg', '/upload/product/watermark/1616814189441119166.jpg', NULL, NULL, 3, NULL, 2, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1769-844P1.jpg', 970, NULL, '2020-09-09 17:49:07', '2020-09-21 16:14:32', 0, 0, NULL, '', '11784854', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/1769-844P-F11.jpg'),
	(710, 38, '1769/844P', '/upload/product/product/1769-844P-F9.jpg', '/upload/product/watermark/1616856865456480196.jpg', NULL, NULL, 3, NULL, 10, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1769-844P2.jpg', 970, NULL, '2020-09-09 17:49:07', '2020-09-21 16:14:35', 0, 0, NULL, '', '11784908', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/product/product/1769-844P-F91.jpg'),
	(711, 38, '1769/844P', '/upload/product/product/1769-844P-F9714M.jpg', '/upload/product/watermark/1616856868197718188.jpg', NULL, NULL, 3, NULL, 16, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1769-844P3.jpg', 970, NULL, '2020-09-09 17:49:07', '2020-09-21 16:14:40', 0, 0, NULL, '', '11784915', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/1769-844P-F9714M1.jpg'),
	(712, 38, '1769/844P', '/upload/product/product/1769-844P-F31-1.jpg', '/upload/product/watermark/1614825284235021793.jpg', NULL, NULL, 3, NULL, 12, 3, 1, '1', '3', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '65-75', NULL, '8', '/upload/product/product/1769-844P.jpg', 970, NULL, '2020-09-09 17:49:08', '2020-09-21 16:14:29', 0, 0, NULL, '', '11784969', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '暗装，多用螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/product/product/1769-844P-F31-11.jpg'),
	(713, 42, '0715/US945', '/upload/cover_img/0715-US945-F4.jpg', '/upload/product/watermark/1608291240653360990.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0715-US945.jpg', 880, NULL, '2020-09-09 17:49:08', '2020-09-25 13:55:54', 0, 0, NULL, '', '11785184', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0715-US945-F4.jpg'),
	(714, 12, '0515-1/U26/49PNS', '/upload/cover_img/0515-1-U26-49PNS-F3.jpg', '/upload/product/watermark/1616647668683969260.jpg', NULL, NULL, 3, 1, 7, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', '90', NULL, '7', '/upload/product/product/0515-1-U26-49PNS-PZ.jpg', 830, NULL, '2020-09-09 17:49:08', '2020-10-13 11:15:25', 0, 0, NULL, '', '11784313', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M4螺丝配套筒', NULL, NULL, NULL, 'F3 铝金色', '', '/upload/cover_img/0515-1-U26-49PNS-F3.jpg'),
	(715, 28, 'M543', '/upload/cover_img/M543-F84-1-R.jpg', '/upload/product/watermark/1610439825386883921.jpg', NULL, NULL, 5, NULL, 32, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:49:08', '2020-09-21 12:52:54', 0, 0, NULL, '', '11785342', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '', '/upload/cover_img/M543-F84-1-R.jpg'),
	(716, 28, 'M543', '/upload/cover_img/M543-F96-1-R.jpg', '/upload/product/watermark/1607457588253164096.jpg', NULL, NULL, 5, NULL, 34, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:49:08', '2020-09-21 12:53:07', 0, 0, NULL, '', '11785354', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F96-1-R 丝光黑', '', '/upload/cover_img/M543-F96-1-R.jpg'),
	(717, 28, 'M543', '/upload/cover_img/M543-F78-1-R.jpg', '/upload/product/watermark/1606313650338527022.jpg', NULL, NULL, 5, NULL, 30, 1, 1, '4', '5', NULL, NULL, NULL, NULL, '/upload/img_sample/M543.jpg', 960, NULL, '2020-09-09 17:49:08', '2020-09-21 12:53:27', 0, 0, NULL, '', '11785366', NULL, NULL, NULL, NULL, '一支', '250mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '', '/upload/cover_img/M543-F78-1-R.jpg'),
	(718, 38, 'HS-4615/4610/461', '/upload/product/product/HS-4615-4610-461-F31-1.jpg', '/upload/product/watermark/1616919964450941987.jpg', NULL, NULL, 6, NULL, 12, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '80-85', '50', '10', '/upload/product/product/HS-4615-4610-4612.jpg', 960, NULL, '2020-09-09 17:49:08', '2020-09-25 16:08:28', 0, 0, NULL, '', '11789049', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '明装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/HS-4615-4610-461-F31-11.jpg'),
	(719, 38, 'HS-4615/4610/461', '/upload/product/product/HS-4615-4610-461-F9714M.jpg', '/upload/product/watermark/1615785509738479901.jpg', NULL, NULL, 6, NULL, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '80-85', '50', '10', '/upload/product/product/HS-4615-4610-4613.jpg', 960, NULL, '2020-09-09 17:49:08', '2020-09-25 16:09:03', 0, 0, NULL, '', '11789098', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '明装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/HS-4615-4610-461-F9714M1.jpg'),
	(720, 41, '0739/US954', '/upload/cover_img/0739-US954-F1.jpg', '/upload/product/watermark/1616810237879218975.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0739-US954.jpg', 900, NULL, '2020-09-09 17:49:08', '2020-12-04 15:29:54', 0, 0, NULL, '', '11788033', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0739-US954-F1.jpg'),
	(721, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F3.jpg', '/upload/product/watermark/1616982778844301575.jpg', NULL, NULL, 7, NULL, 7, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0515-1-US9521.jpg', 710, 1, '2020-09-09 17:49:09', '2020-09-25 15:02:16', 0, 0, NULL, '', '11788100', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F3 铝金色', '', '/upload/cover_img/0515-1-US952-F3.jpg'),
	(722, 38, 'HS-4615/4610/461', '/upload/product/product/HS-4615-4610-461-F1-1.jpg', '/upload/product/watermark/1616919965441544837.jpg', NULL, NULL, 6, NULL, 78, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '80-85', '50', '10', '/upload/product/product/HS-4615-4610-461.jpg', 960, NULL, '2020-09-09 17:49:09', '2020-09-25 16:07:45', 0, 0, NULL, '', '11791755', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '明装，对穿安装，M6螺丝', NULL, NULL, NULL, '', '/assets/img/icon_sk.png', '/upload/product/product/HS-4615-4610-461-F1-11.jpg'),
	(723, 41, '0739/US954', '/upload/product/product/0739-US954-F9.jpg', '/upload/product/watermark/1616025109003051822.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0739-US954.jpg', 900, NULL, '2020-09-09 17:49:09', '2020-09-25 13:52:11', 0, 0, NULL, '', '11799018', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/product/product/0739-US954-F91.jpg'),
	(724, 30, '1810/3347N', '/upload/product/product/古铜色22.jpg', '/upload/product/watermark/1603683563414394768.jpg', NULL, NULL, 3, 6, 8, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '72-82', NULL, '8', '/upload/product/product/1810-3347N-PZ.jpg', 880, NULL, '2020-09-09 17:49:09', '2020-10-26 11:38:23', 0, 0, NULL, '', '11798671', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/古铜色23.jpg'),
	(725, 38, 'HS-4615/4610/461', '/upload/product/product/HS-4615-4610-461-F9016M.jpg', '/upload/product/watermark/1616919940614150295.jpg', NULL, NULL, 6, NULL, 88, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '80-85', '50', '10', '/upload/product/product/HS-4615-4610-4611.jpg', 960, NULL, '2020-09-09 17:49:09', '2020-11-18 10:34:08', 0, 0, NULL, '', '11803538', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '明装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9016M 交通白光', '/assets/img/icon_sk.png', '/upload/product/product/HS-4615-4610-461-F9016M1.jpg'),
	(726, 38, '1769/2246', '/upload/product/product/1769-2246-PZ92-F31-1.jpg', '/upload/product/watermark/1616816668116052579.jpg', NULL, NULL, 3, 6, 12, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '67-72', NULL, '8', '/upload/product/product/1769-2246-PZ-GL78-3NO-M63.jpg', 960, NULL, '2020-09-09 17:49:09', '2020-09-25 10:34:20', 0, 0, NULL, '', '11807313', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/product/product/1769-2246-PZ92-F31-11.jpg'),
	(727, 33, '0751/US952', '/upload/cover_img/0751-US952-F4.jpg', '/upload/product/watermark/1616662744222769469.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0751-US952.jpg', 910, NULL, '2020-09-09 17:49:10', '2020-09-25 13:48:50', 0, 0, NULL, '', '11808299', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0751-US952-F4.jpg'),
	(728, 38, '1769/2246', '/upload/product/product/1769-2246-PZ92-F9714M.jpg', '/upload/product/watermark/1616565865334984103.jpg', NULL, NULL, 3, 6, 16, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '67-72', NULL, '8', '/upload/product/product/1769-2246-PZ-GL78-3NO-M6.jpg', 960, NULL, '2020-09-09 17:49:10', '2020-09-25 10:34:07', 0, 0, NULL, '', '11808068', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/1769-2246-PZ92-F9714M1.jpg'),
	(729, 38, '1769/2246', '/upload/product/product/1769-2246-PZ92-F1.jpg', '/upload/product/watermark/1614991618772396544.jpg', NULL, NULL, 3, 6, 2, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '67-72', NULL, '8', '/upload/product/product/1769-2246-PZ-GL78-3NO-M61.jpg', 960, NULL, '2020-09-09 17:49:10', '2020-09-25 10:34:12', 0, 0, NULL, '', '11807258', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1769-2246-PZ92-F11.jpg'),
	(730, 38, '1769/2246', '/upload/product/product/1769-2246-PZ92-F4.jpg', '/upload/product/watermark/1616565868510151330.jpg', NULL, NULL, 3, 6, 8, 3, 1, '1', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '67-72', NULL, '8', '/upload/product/product/1769-2246-PZ-GL78-3NO-M62.jpg', 960, NULL, '2020-09-09 17:49:10', '2020-09-25 10:34:16', 0, 0, NULL, '', '11807283', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1769-2246-PZ92-F41.jpg'),
	(731, 42, '0715/US945', '/upload/product/product/0715-US945-F12.jpg', '/upload/product/watermark/1616810290338813695.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0715-US945.jpg', 880, NULL, '2020-09-09 17:49:10', '2020-09-25 13:55:49', 0, 0, NULL, '', '11815188', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/0715-US945-F13.jpg'),
	(732, 40, '1737/2246', '/upload/product/product/1737-2246-PZ92-F1.jpg', '/upload/product/watermark/1610442821872656039.jpg', NULL, NULL, 3, 6, 2, 3, 1, '', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '77-82', NULL, '8', '/upload/product/product/1737-2246-PZ-GL78-3NO-M63.jpg', 860, NULL, '2020-09-09 17:49:10', '2020-09-25 10:44:16', 0, 0, NULL, '', '11819911', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/product/product/1737-2246-PZ92-F11.jpg'),
	(733, 40, '1737/2246', '/upload/product/product/1737-2246-PZ92-F9.jpg', '/upload/product/watermark/1610442816192586072.jpg', NULL, NULL, 3, 6, 10, 3, 1, '', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '77-82', NULL, '8', '/upload/product/product/1737-2246-PZ-GL78-3NO-M62.jpg', 860, NULL, '2020-09-09 17:49:11', '2020-09-25 10:44:11', 0, 0, NULL, '', '11819935', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9 仿钢色', '/assets/img/icon_sk.png', '/upload/product/product/1737-2246-PZ92-F91.jpg'),
	(734, 47, 'E5091', '/upload/product/product/E5091-1000-700-F9714M.jpg', '/upload/product/watermark/1611123650347720342.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1000-700.jpg', 910, NULL, '2020-09-09 17:49:11', '2020-09-21 13:18:28', 0, 0, NULL, '', '11827665', NULL, NULL, NULL, NULL, '一支', '700mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5091-1000-700-F9714M1.jpg'),
	(735, 47, 'E5091', '/upload/product/product/E5091-1200-900-F9714M.jpg', '/upload/product/watermark/1616653832247020794.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1200-900.jpg', 910, NULL, '2020-09-09 17:49:11', '2020-09-21 13:18:34', 0, 0, NULL, '', '11827671', NULL, NULL, NULL, NULL, '一支', '900mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5091-1200-900-F9714M1.jpg'),
	(736, 47, 'E5091', '/upload/product/product/E5091-1400-1000-F9714M.jpg', '/upload/product/watermark/1610624667387348160.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1400-1000.jpg', 910, NULL, '2020-09-09 17:49:11', '2020-09-21 13:18:40', 0, 0, NULL, '', '11827683', NULL, NULL, NULL, NULL, '一支', '1000mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5091-1400-1000-F9714M1.jpg'),
	(737, 47, 'E5091', '/upload/product/product/E5091-1600-1200-F9714M.jpg', '/upload/product/watermark/1614949063024321528.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5091-1600-1200.jpg', 910, NULL, '2020-09-09 17:49:11', '2020-09-21 13:18:48', 0, 0, NULL, '', '11827695', NULL, NULL, NULL, NULL, '一支', '1200mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5091-1600-1200-F9714M1.jpg'),
	(738, 41, '0739/US954', '/upload/cover_img/0739-US954-F4.jpg', '/upload/product/watermark/1616495273590128961.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0739-US954.jpg', 900, NULL, '2020-09-09 17:49:11', '2020-09-25 13:52:06', 0, 0, NULL, '', '11826685', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0739-US954-F4.jpg'),
	(739, 39, '1808/42K/42KS', '/upload/product/product/f8928d780c41fd046125269869e911f.jpg', '/upload/product/watermark/1616836956647665857.jpg', NULL, NULL, 1, 1, 16, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/img_sample/1808-42K-42KS-PZ.jpg', 891, NULL, '2020-09-09 17:49:11', '2020-10-13 11:40:25', 0, 0, NULL, '', '11828165', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/F9714M17.png'),
	(740, 40, '0737FL/U34FL', '/upload/product/product/0737FL-U34FL-F1.jpg', '/upload/product/watermark/1616662620212040800.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0737FL-U34FL2.jpg', 730, NULL, '2020-09-09 17:49:11', '2020-10-13 11:20:19', 0, 0, NULL, '', '11830323', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/0737FL-U34FL-F11.jpg'),
	(741, 40, '0737FL/U34FL', '/upload/product/product/0737FL-U34FL-F4.jpg', '/upload/product/watermark/1616981996898077792.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0737FL-U34FL3.jpg', 730, NULL, '2020-09-09 17:49:11', '2020-10-13 11:20:24', 0, 0, NULL, '', '11830335', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/product/product/0737FL-U34FL-F41.jpg'),
	(742, 47, 'E5095', '/upload/product/product/E5095-1000-F9714M.jpg', '/upload/product/watermark/1614773271352102950.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-1000.jpg', 900, NULL, '2020-09-09 17:49:11', '2020-09-21 13:22:39', 0, 0, NULL, '', '11829874', NULL, NULL, NULL, NULL, '一支', '1000mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5095-1000-F9714M1.jpg'),
	(743, 47, 'E5095', '/upload/product/product/E5095-1200-F9714M.jpg', '/upload/product/watermark/1614923871513324206.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-1200.jpg', 900, NULL, '2020-09-09 17:49:11', '2020-09-21 13:23:14', 0, 0, NULL, '', '11829953', NULL, NULL, NULL, NULL, '一支', '1200mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5095-1200-F9714M1.jpg'),
	(744, 47, 'E5095', '/upload/product/product/E5095-1400-F9714M.jpg', '/upload/product/watermark/1610439832083728149.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-1400.jpg', 900, NULL, '2020-09-09 17:49:11', '2020-09-21 13:23:52', 0, 0, NULL, '', '11829965', NULL, NULL, NULL, NULL, '一支', '1400mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5095-1400-F9714M1.jpg'),
	(745, 47, 'E5095', '/upload/product/product/E5095-1600-F9714M.jpg', '/upload/product/watermark/1614945978283090285.jpg', NULL, NULL, 5, NULL, 16, 2, 1, '', '6', NULL, NULL, NULL, NULL, '/upload/product/product/E5095-1600.jpg', 900, NULL, '2020-09-09 17:49:11', '2020-09-21 13:24:16', 0, 0, NULL, '', '11829977', NULL, NULL, NULL, NULL, '一支', '1600mm', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/E5095-1600-F9714M1.jpg'),
	(746, 27, 'E5091GC/414GC/1400Z', '/upload/product/product/IMG-PRO-E5091GC-414GC-1400Z-F69-1600-1200-SALL-AIN-V1.jpg', '/upload/product/watermark/1616912418725366861.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', NULL, NULL, '47', '8', '/upload/product/product/DRW-CAT-E5091GC-414GC-1400Z-1600-1200-SALL-AOF-V1.jpg', 990, NULL, '2020-09-09 17:49:11', '2020-12-04 11:13:21', 0, 0, NULL, '', '11831868', NULL, NULL, NULL, NULL, '套', '1200mm', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 感应开启不锈钢拉手：</p><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室外侧 - HOPPE 好博 D 型截面不锈钢拉手：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>拉手：带感应装置，把手底部发出 LED 射灯 (4 种颜色可选：白，蓝，绿，红）可以感应到扰动</p></li><li><p>距离：离地距离最小 20cm 最大 50 cm</p></li><li><p>支撑：圆形，直</p></li><li><p>安装：暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 + 60 °C</p></li><li><p>感应装置（无线电频率）：125 kHz / 868 MHz</p></li><li><p>加密：AES (高级加密标准)</p></li><li><p>可感应距离：约. 1 m</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 1,5 A（最高）</p></li><li><p>发射功率：6,3 mW</p></li><li><p>最大功耗：0,7 W</p></li><li><p>安全级别：IP 44</p></li><li><p>电气连接： 通用（可选正或负控制脉冲）</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室内侧 - 带控制单元的半副把手，带底座：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>把手规格：散装把手, 一体把手复位弹簧, 免维护垫圈</p></li><li><p>方轴配置：HOPPE 好博膨胀方轴，预装底座，门扇只需一侧钻孔</p></li><li><p>安装基座：金属，带螺柱; 用于木门</p></li><li><p>安装：暗装，M5 螺丝</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">附件：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>Y型电缆，用于连接到电动锁</p></li><li><p>无线钥匙：2个，（CR 2450型）</p></li><li><p>卡：1张管理员卡，1张配置卡，2张门卡，2张门卡附属卡，2张无线钥匙附属卡</p></li></ul>', NULL, NULL, 'F69 不锈钢磨砂', '', ''),
	(747, 24, '0140/US956', '/upload/cover_img/0140-US956-F9714M.jpg', '/upload/product/watermark/1616126538310025052.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0140-US956.jpg', 780, NULL, '2020-09-09 17:49:11', '2020-09-25 14:34:03', 0, 0, NULL, '', '11833051', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0140-US956-F9714M.jpg'),
	(748, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F78-1-R-innen.jpg', '/upload/product/watermark/1615266642370387205.jpg', NULL, NULL, 6, 8, 71, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-PZ-HG-I3.jpg', 980, NULL, '2020-09-09 17:49:11', '2020-09-25 15:56:49', 0, 0, NULL, '', '11834523', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F78-1-R-innen1.jpg'),
	(749, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F84-1-R-innen.jpg', '/upload/product/watermark/1613912965006626425.jpg', NULL, NULL, 6, 8, 72, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-PZ-HG-I.jpg', 980, NULL, '2020-09-09 17:49:11', '2020-09-25 15:53:56', 0, 0, NULL, '', '11834535', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F84-1-R-innen1.jpg'),
	(750, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F96-1-R-innen.jpg', '/upload/product/watermark/1614932464961759224.jpg', NULL, NULL, 6, 8, 73, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-PZ-HG-I1.jpg', 980, NULL, '2020-09-09 17:49:11', '2020-09-25 15:54:25', 0, 0, NULL, '', '11834547', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F96-1-R-innen1.jpg'),
	(751, 27, 'HS-E0400F-25/431N-AS', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F97-1-R-innen.jpg', '/upload/product/watermark/1616814520973481363.jpg', NULL, NULL, 6, 8, 74, 2, 1, '4', '6', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-E0400F-25-431N-AS-PZ-HG-I2.jpg', 980, NULL, '2020-09-09 17:49:11', '2020-09-25 15:54:50', 0, 0, NULL, '', '11834559', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-E0400F-25-431N-AS-PZ69-F97-1-R-innen1.jpg'),
	(752, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F78-R-innen.jpg', '/upload/product/watermark/1601300072014605031.jpg', NULL, NULL, 6, 8, 29, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I7.jpg', 930, NULL, '2020-09-09 17:49:11', '2020-09-25 16:24:31', 0, 0, NULL, '', '11834808', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F78-R-innen1.jpg'),
	(753, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F78-1-R-innen.jpg', NULL, NULL, NULL, 6, 8, 30, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-09-25 16:20:51', 0, 0, NULL, '', '11834815', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F78-1-R-innen1.jpg'),
	(754, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F84-R-innen.jpg', '/upload/product/watermark/1607947243810777939.jpg', NULL, NULL, 6, 8, 31, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I1.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-09-25 16:21:28', 0, 0, NULL, '', '11834821', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F84-R-innen1.jpg'),
	(755, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F84-1-R-innen.jpg', '/upload/product/watermark/1603627265016041808.jpg', NULL, NULL, 6, 8, 32, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I2.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-09-25 16:22:05', 0, 0, NULL, '', '11834833', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F84-1-R-innen1.jpg'),
	(756, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F96-R-innen.jpg', NULL, NULL, NULL, 6, 8, 33, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I3.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-09-25 16:22:35', 0, 0, NULL, '', '11834845', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F96-R-innen1.jpg'),
	(757, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F96-1-R-innen.jpg', '/upload/product/watermark/1616814929144714645.jpg', NULL, NULL, 6, 8, 34, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I4.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-09-25 16:23:06', 0, 0, NULL, '', '11834857', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F96-1-R-innen1.jpg'),
	(758, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F97-R-innen.jpg', NULL, NULL, NULL, 6, 8, 35, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I5.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-09-25 16:23:38', 0, 0, NULL, '', '11834869', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F97-R-innen1.jpg'),
	(759, 28, 'HS-M0643/419N-AS', '/upload/product/product/HS-M0643-419N-AS-PZ69-F97-R-innen2.jpg', '/upload/product/watermark/1610973044358441499.jpg', NULL, NULL, 6, 8, 36, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0643-419N-AS-PZ-HG-I6.jpg', 930, NULL, '2020-09-09 17:49:12', '2020-10-22 14:18:48', 0, 0, NULL, '', '11834870', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0643-419N-AS-PZ69-F97-1-R-innen.jpg'),
	(760, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F78-R-innen.jpg', '/upload/product/watermark/1605130555934841625.jpg', NULL, NULL, 6, 8, 29, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I1.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:38:21', 0, 0, NULL, '', '11835059', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-R 自然亮铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F78-R-innen1.jpg'),
	(761, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F78-1-R-innen.jpg', '/upload/product/watermark/1615534971498333043.jpg', NULL, NULL, 6, 8, 30, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I2.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:38:41', 0, 0, NULL, '', '11835060', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F78-1-R 自然丝光铜色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F78-1-R-innen1.jpg'),
	(762, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F84-R-innen.jpg', '/upload/product/watermark/1607464599248367274.jpg', NULL, NULL, 6, 8, 31, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I3.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:39:06', 0, 0, NULL, '', '11835072', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-R 亮玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F84-R-innen1.jpg'),
	(763, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F84-1-R-innen.jpg', NULL, NULL, NULL, 6, 8, 32, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I4.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:39:26', 0, 0, NULL, '', '11835096', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F84-1-R 丝光玫瑰金', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F84-1-R-innen1.jpg'),
	(764, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F96-R-innen.jpg', '/upload/product/watermark/1606622641633710667.jpg', NULL, NULL, 6, 8, 33, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I5.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:39:50', 0, 0, NULL, '', '11835114', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-R 亮黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F96-R-innen1.jpg'),
	(765, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F96-1-R-innen.jpg', '/upload/product/watermark/1616815287425103390.jpg', NULL, NULL, 6, 8, 34, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I6.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:40:12', 0, 0, NULL, '', '11835126', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F96-1-R 丝光黑', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F96-1-R-innen1.jpg'),
	(766, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F97-R-innen.jpg', '/upload/product/watermark/1614668166957767056.jpg', NULL, NULL, 6, 8, 35, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I7.jpg', 900, NULL, '2020-09-09 17:49:12', '2020-09-25 16:40:37', 0, 0, NULL, '', '11835138', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-R 亮烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F97-R-innen1.jpg'),
	(767, 31, 'HS-M0642/419N-AS', '/upload/product/product/HS-M0642-419N-AS-PZ69-F97-1-R-innen.jpg', '/upload/product/watermark/1616815149355637151.jpg', NULL, NULL, 6, 8, 36, 1, 1, '4', '5', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', NULL, NULL, '10', '/upload/product/product/HS-M0642-419N-AS-PZ-HG-I.jpg', 900, NULL, '2020-09-09 17:49:13', '2020-09-25 16:37:54', 0, 0, NULL, '', '11835145', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F97-1-R 丝光烟灰色', '/assets/img/icon_sk.png', '/upload/product/product/HS-M0642-419N-AS-PZ69-F97-1-R-innen1.jpg'),
	(769, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F1.jpg', '/upload/product/watermark/1616810131943661844.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:25:25', 0, 0, NULL, '', '11837032', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0769-UD9024-F1.jpg'),
	(770, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F4.jpg', '/upload/product/watermark/1616147834016916671.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:25:38', 0, 0, NULL, '', '11837056', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0769-UD9024-F4.jpg'),
	(771, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F31-1.jpg', '/upload/product/watermark/1616126577035775409.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:26:13', 0, 0, NULL, '', '11837245', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0769-UD9024-F31-1.jpg'),
	(772, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F9714M.jpg', '/upload/product/watermark/1616200389694049940.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:26:11', 0, 0, NULL, '', '11839168', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0769-UD9024-F9714M.jpg'),
	(773, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F1.jpg', '/upload/product/watermark/1615998423424107024.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:25:53', 0, 0, NULL, '', '11839175', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0769-UD9024-F1.jpg'),
	(774, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F4.jpg', '/upload/product/watermark/1616810128060393939.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:25:59', 0, 0, NULL, '', '11839181', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0769-UD9024-F4.jpg'),
	(775, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F9714M.jpg', '/upload/product/watermark/1608293474897739839.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:26:04', 0, 0, NULL, '', '11839193', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0769-UD9024-F9714M.jpg'),
	(776, 38, '0769/UD9024', '/upload/cover_img/0769-UD9024-F31-1.jpg', '/upload/product/watermark/1616495167056937918.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '7,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0769-UD9024.jpg', 950, NULL, '2020-09-09 17:49:13', '2020-09-25 13:26:08', 0, 0, NULL, '', '11839205', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0769-UD9024-F31-1.jpg'),
	(777, 40, '1737/2246', '/upload/product/product/黑哑光.jpg', '/upload/product/watermark/1610501987870033893.jpg', NULL, NULL, 3, 6, 16, 3, 1, '', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '77-82', NULL, '8', '/upload/product/product/1737-2246-PZ-GL78-3NO-M61.jpg', 860, NULL, '2020-09-09 17:49:13', '2020-10-26 11:44:28', 0, 0, NULL, '', '11839570', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/product/product/黑哑光1.jpg'),
	(778, 42, '0715/US945', '/upload/cover_img/0715-US945-F9016.jpg', '/upload/product/watermark/1616891754989820690.jpg', NULL, NULL, 7, NULL, 14, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0715-US945.jpg', 880, 1, '2020-09-09 17:49:13', '2020-09-25 13:55:45', 0, 0, NULL, '', '11842064', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9016 交通白', '', '/upload/cover_img/0715-US945-F9016.jpg'),
	(779, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F1.jpg', '/upload/product/watermark/1613913010497877626.jpg', NULL, NULL, 6, 7, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-UG2.jpg', 920, NULL, '2020-09-09 17:49:13', '2020-09-25 16:32:43', 0, 0, NULL, '', '11846872', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F1.jpg'),
	(780, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F4.jpg', '/upload/product/watermark/1615465266986414233.jpg', NULL, NULL, 6, 7, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-UG3.jpg', 920, NULL, '2020-09-09 17:49:13', '2020-09-25 16:32:52', 0, 0, NULL, '', '11846914', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F4.jpg'),
	(781, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F31-1.jpg', '/upload/product/watermark/1615465771582263313.jpg', NULL, NULL, 6, 7, 12, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-UG.jpg', 920, NULL, '2020-09-09 17:49:14', '2020-09-25 16:31:49', 0, 0, NULL, '', '11846938', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F31-1.jpg'),
	(782, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F9714M.jpg', '/upload/product/watermark/1616815064485272675.jpg', NULL, NULL, 6, 7, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-UG1.jpg', 920, NULL, '2020-09-09 17:49:14', '2020-09-25 16:31:52', 0, 0, NULL, '', '11847025', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F9714M.jpg'),
	(783, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F1.jpg', '/upload/product/watermark/1614932561441676053.jpg', NULL, NULL, 6, 8, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-PZ.jpg', 920, NULL, '2020-09-09 17:49:14', '2020-09-25 16:31:56', 0, 0, NULL, '', '11847104', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F1.jpg'),
	(784, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F4.jpg', '/upload/product/watermark/1616814793200651347.jpg', NULL, NULL, 6, 8, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-PZ1.jpg', 920, NULL, '2020-09-09 17:49:14', '2020-09-25 16:32:07', 0, 0, NULL, '', '11847220', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F4.jpg'),
	(785, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F31-1.jpg', '/upload/product/watermark/1615261997079217354.jpg', NULL, NULL, 6, 8, 12, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-PZ2.jpg', 920, NULL, '2020-09-09 17:49:14', '2020-09-25 16:32:19', 0, 0, NULL, '', '11847311', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F31-1.jpg'),
	(786, 45, 'HS-0700/431N-AS/422', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F9714M.jpg', '/upload/product/watermark/1604625426621922957.jpg', NULL, NULL, 6, 8, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0700-431N-AS-422-PZ3.jpg', 920, NULL, '2020-09-09 17:49:14', '2020-09-25 16:32:30', 0, 0, NULL, '', '11847359', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0700-431N-AS-422-PZ69-F9714M.jpg'),
	(787, 38, '0769/USV919', '/upload/cover_img/0769-USV919-F31-1.jpg', '/upload/product/watermark/1616810154553617727.jpg', NULL, NULL, 7, NULL, 12, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-USV919+Bohrbild.jpg', 940, 1, '2020-09-09 17:49:14', '2020-09-25 13:30:11', 0, 0, NULL, '', '11853001', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '', '/upload/cover_img/0769-USV919-F31-1.jpg'),
	(788, 38, '0769/USV919', '/upload/cover_img/0769-USV919-F9714M.jpg', '/upload/product/watermark/1615864444392453653.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0769-USV919+Bohrbild.jpg', 940, NULL, '2020-09-09 17:49:14', '2020-09-25 13:30:17', 0, 0, NULL, '', '11853025', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/cover_img/0769-USV919-F9714M.jpg'),
	(789, 40, '0737FL/U34FL', '/upload/product/product/0737FL-U34FL-F9016.jpg', '/upload/product/watermark/1616981994763835419.jpg', NULL, NULL, 7, NULL, 14, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0737FL-U34FL.jpg', 730, 1, '2020-09-09 17:49:14', '2020-10-13 11:20:14', 0, 0, NULL, '', '11852549', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9016 交通白', '', '/upload/product/product/0737FL-U34FL-F90161.jpg'),
	(790, 13, '1530/42K/42KS', '/upload/product/product/1530-42K+KV-42KS+KVS-PZ-F4.jpg', '/upload/product/watermark/1615995529790015659.jpg', NULL, NULL, 1, 1, 8, 3, 1, '1', '3,4', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '45-55', NULL, '8', '/upload/product/product/1530-42K-42KS-PZ.jpg', 895, NULL, '2020-09-09 17:49:14', '2020-09-11 12:04:33', 0, 0, NULL, '', '11857857', '', '', NULL, NULL, '', '', '', '', '', NULL, '', '', '', NULL, '', NULL, NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/product/product/1530-42K+KV-42KS+KVS-PZ-F41.jpg'),
	(791, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F1.jpg', '/upload/product/watermark/1616814301535244326.jpg', NULL, NULL, 6, 8, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-PZ3.jpg', 970, NULL, '2020-09-09 17:49:14', '2020-09-25 16:01:15', 0, 0, NULL, '', '11857274', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F1.jpg'),
	(792, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F4.jpg', '/upload/product/watermark/1616562488543877757.jpg', NULL, NULL, 6, 8, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-PZ.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 15:59:43', 0, 0, NULL, '', '11857286', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F4.jpg'),
	(793, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F31-1.jpg', '/upload/product/watermark/1616562486743804091.jpg', NULL, NULL, 6, 8, 12, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-PZ1.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 16:00:00', 0, 0, NULL, '', '11857304', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F31-1.jpg'),
	(794, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F9714M.jpg', '/upload/product/watermark/1604625460214714732.jpg', NULL, NULL, 6, 8, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-PZ2.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 16:00:12', 0, 0, NULL, '', '11857341', NULL, NULL, NULL, NULL, NULL, NULL, '69', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F9714M.jpg'),
	(795, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F1.jpg', '/upload/product/watermark/1606120735736357714.jpg', NULL, NULL, 6, 7, 2, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-UG.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 16:00:27', 0, 0, NULL, '', '11856816', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F1 银色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F1.jpg'),
	(796, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F4.jpg', '/upload/product/watermark/1616647873901968720.jpg', NULL, NULL, 6, 7, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-UG1.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 16:00:39', 0, 0, NULL, '', '11856828', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F4.jpg'),
	(797, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F31-1.jpg', '/upload/product/watermark/1614932472367601246.jpg', NULL, NULL, 6, 7, 12, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-UG2.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 16:00:52', 0, 0, NULL, '', '11856841', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F31-1 仿不锈钢/哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F31-1.jpg'),
	(798, 38, 'HS-0769/419N-AS/420', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F9714M.jpg', '/upload/product/watermark/1613912878286113909.jpg', NULL, NULL, 6, 7, 16, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0769-419N-AS-420-UG3.jpg', 970, NULL, '2020-09-09 17:49:15', '2020-09-25 16:01:04', 0, 0, NULL, '', '11856890', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0769-419N-AS-420-PZ69-F9714M.jpg'),
	(799, 47, 'AR681', '/upload/product/product/古铜色24.jpg', '/upload/product/watermark/1615295159243404330.jpg', NULL, NULL, 11, NULL, 92, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-752.jpg', 990, NULL, '2020-09-09 17:49:15', '2020-10-26 12:08:34', 0, 0, NULL, '', '50015643', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '37.5/37.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, 'F73 古铜色', '', '/upload/product/product/古铜色25.jpg'),
	(800, 40, '0737FL/U34FL', '/upload/product/product/0737FL-U34FL-F9005.jpg', '/upload/product/watermark/1616633121219213380.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '37', '7', '/upload/product/product/0737FL-U34FL1.jpg', 730, NULL, '2020-09-09 17:49:15', '2020-09-25 14:55:45', 0, 0, NULL, '', '11859477', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/0737FL-U34FL-F90051.jpg'),
	(801, 47, 'AR681', '/upload/product/product/AR-KD-681-75-BLK.jpg', '/upload/product/watermark/1615970037741569968.jpg', NULL, NULL, 11, NULL, 91, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-753.jpg', 990, NULL, '2020-09-09 17:49:15', '2020-10-13 15:26:18', 0, 0, NULL, '', '50015710', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '37.5/37.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(802, 47, 'AR681', '/upload/product/product/AR-KD-681-70-BLK.jpg', '/upload/product/watermark/1611134329039342518.jpg', NULL, NULL, 11, NULL, 91, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-70.jpg', 990, NULL, '2020-09-09 17:49:15', '2020-10-13 15:26:35', 0, 0, NULL, '', '50015722', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '35/35', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(803, 47, 'AR681', '/upload/product/product/AR-KD-681-65-BLK.jpg', '/upload/product/watermark/1608532042539820204.jpg', NULL, NULL, 11, NULL, 91, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-65.jpg', 990, NULL, '2020-09-09 17:49:15', '2020-10-13 15:26:45', 0, 0, NULL, '', '50015734', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '32.5/32.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', ''),
	(804, 42, '0715/US945', '/upload/product/product/0715-US945-F1.jpg', NULL, NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/img_sample/0715-US945.jpg', 880, NULL, '2020-09-09 17:49:15', '2020-09-25 13:55:15', 0, 0, NULL, '', '11865982', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/product/product/0715-US945-F11.jpg'),
	(805, 40, '0737-2/US947', '/upload/product/product/黑哑光8.jpg', '/upload/product/watermark/1616638362200037027.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0737-2-US9472.jpg', 740, NULL, '2020-09-09 17:49:15', '2020-10-26 11:51:50', 0, 0, NULL, '', '11867838', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/黑哑光9.jpg'),
	(806, 42, '0715/US945', '/upload/cover_img/0715-US945-F9016.jpg', NULL, NULL, NULL, 7, NULL, 14, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0715-US945.jpg', 880, NULL, '2020-09-09 17:49:15', '2020-09-25 13:55:41', 0, 0, NULL, '', '11868740', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9016 交通白', '', '/upload/cover_img/0715-US945-F9016.jpg'),
	(807, 12, '0515-1/US952', '/upload/cover_img/0515-1-US952-F9.jpg', '/upload/product/watermark/1616724049968757180.jpg', NULL, NULL, 7, NULL, 10, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0515-1-US952.jpg', 710, NULL, '2020-09-09 17:49:15', '2020-09-25 15:02:08', 0, 0, NULL, '', '11868752', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9 仿钢色', '', '/upload/cover_img/0515-1-US952-F9.jpg'),
	(808, 33, '0751/US952', '/upload/cover_img/0751-US952-F1.jpg', '/upload/product/watermark/1602071180425144435.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0751-US952.jpg', 910, NULL, '2020-09-09 17:49:15', '2020-09-25 13:47:47', 0, 0, NULL, '', '11869872', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0751-US952-F1.jpg'),
	(809, 33, '0751/US952', '/upload/cover_img/0751-US952-F4.jpg', '/upload/product/watermark/1616810216985586667.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0751-US952.jpg', 910, 1, '2020-09-09 17:49:15', '2020-09-25 13:48:48', 0, 0, NULL, '', '11869926', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0751-US952-F4.jpg'),
	(810, 40, '0737-2/US947', '/upload/cover_img/0737-2-US947-F1.jpg', '/upload/product/watermark/1616836493574920681.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '20-30', '7', '/upload/product/product/0737-2-US9473.jpg', 740, NULL, '2020-09-09 17:49:15', '2020-09-25 14:50:57', 0, 0, NULL, '', '11870515', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0737-2-US947-F1.jpg'),
	(811, 40, '0737-2/US947', '/upload/cover_img/0737-2-US947-F4.jpg', '/upload/product/watermark/1616836504298408846.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '20-30', '7', '/upload/product/product/0737-2-US9474.jpg', 740, NULL, '2020-09-09 17:49:15', '2020-09-25 14:51:04', 0, 0, NULL, '', '11870539', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0737-2-US947-F4.jpg'),
	(812, 40, '0737-2/US947', '/upload/product/product/黑哑光10.jpg', '/upload/product/watermark/1602568765806052187.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '20-30', '7', '/upload/product/product/0737-2-US9475.jpg', 740, NULL, '2020-09-09 17:49:15', '2020-10-26 11:52:08', 0, 0, NULL, '', '11870540', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/黑哑光11.jpg'),
	(813, 28, 'HS-0643/419N-AS/420', '/upload/cover_img/HS-0643-419N-AS-420-UG-F4.jpg', '/upload/product/watermark/1615467258088378033.jpg', NULL, NULL, 6, 7, 8, 3, 1, '', '', '<p>散装&nbsp;HOPPE&nbsp;好博实心方轴，弧形磨边</p>', '75-80', NULL, '10', '/upload/product/product/HS-0643-419N-AS-420-UG.jpg', 950, NULL, '2020-09-09 17:49:15', '2020-09-25 16:11:58', 0, 0, NULL, '', '11871745', NULL, NULL, NULL, NULL, NULL, NULL, '无', '', '', NULL, '', '', '', NULL, '', '暗装，对穿安装，M6螺丝', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/HS-0643-419N-AS-420-UG-F4.jpg'),
	(814, 40, '0737-2/US947', '/upload/cover_img/0737-2-US947-F1.jpg', '/upload/product/watermark/1616836424526832848.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0737-2-US947.jpg', 740, 1, '2020-09-09 17:49:16', '2020-09-25 14:50:34', 0, 0, NULL, '', '11875987', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F1 银色', '', '/upload/cover_img/0737-2-US947-F1.jpg'),
	(815, 40, '0737-2/US947', '/upload/cover_img/0737-2-US947-F4.jpg', NULL, NULL, NULL, 7, NULL, 8, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0737-2-US9471.jpg', 740, NULL, '2020-09-09 17:49:16', '2020-09-25 14:50:43', 0, 0, NULL, '', '11875999', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', '', NULL, '', '', '', NULL, '', '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F4 古铜色', '', '/upload/cover_img/0737-2-US947-F4.jpg'),
	(816, 40, '1737/2246', '/upload/cover_img/1737-2246-PZ92-F4.jpg', '/upload/product/watermark/1610501989942053903.jpg', NULL, NULL, 3, 6, 8, 3, 1, '', '', '<p><strong style="white-space: normal;">HOPPE好博快装方轴配置</strong>，实心方轴（独立方轴）</p>', '77-82', NULL, '8', '/upload/product/product/1737-2246-PZ-GL78-3NO-M6.jpg', 860, NULL, '2020-09-09 17:49:16', '2020-09-25 10:44:00', 0, 0, NULL, '', '11884319', NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', NULL, '', '', '', NULL, '', '对穿安装，室内侧明装螺丝，M6螺丝配装饰帽', NULL, NULL, NULL, 'F4 古铜色', '/assets/img/icon_sk.png', '/upload/cover_img/1737-2246-PZ92-F4.jpg'),
	(817, 47, 'AR681', '/upload/product/product/丝光铜色.jpg', '/upload/product/watermark/1615295182452614612.jpg', NULL, NULL, 11, NULL, 86, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-60.jpg', 990, NULL, '2020-09-09 17:49:16', '2020-10-26 12:06:55', 0, 0, NULL, '', '50015989', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '30/30', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', '/upload/product/product/丝光铜色1.jpg'),
	(818, 47, 'AR681', '/upload/product/product/丝光铜色2.jpg', '/upload/product/watermark/1612667543283536183.jpg', NULL, NULL, 11, NULL, 86, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-75.jpg', 990, NULL, '2020-09-09 17:49:16', '2020-10-26 12:07:25', 0, 0, NULL, '', '50015990', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '37.5/37.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', '/upload/product/product/丝光铜色3.jpg'),
	(819, 47, 'AR681', '/upload/product/product/丝光古铜色.jpg', '/upload/product/watermark/1615295185877350258.jpg', NULL, NULL, 11, NULL, 87, 1, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/AR-KD-681-751.jpg', 990, NULL, '2020-09-09 17:49:16', '2020-10-26 12:08:13', 0, 0, NULL, '', '50016076', NULL, NULL, NULL, NULL, NULL, NULL, '', '', NULL, '通过 BS EN 1634 第一部分测试。可用于防火要求 30、60、90 和 120 分钟的木质门和防 火要求为 240 分钟的钢制门。 ', NULL, NULL, '37.5/37.5', '专属钥匙', '3', NULL, NULL, NULL, NULL, '', '', '/upload/product/product/丝光古铜色1.jpg'),
	(820, 39, '0808/US10', '/upload/product/product/黑哑光2.jpg', '/upload/product/watermark/1614932677273463208.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/img_sample/0808-US10.jpg', 890, NULL, '2020-09-09 17:49:16', '2020-10-26 11:46:34', 0, 0, NULL, '', '11890411', NULL, NULL, NULL, NULL, NULL, NULL, '', '半盖式', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, 'F9714M 黑哑光', '', '/upload/product/product/黑哑光3.jpg'),
	(821, 12, '0515-1/US952', '/upload/product/product/哑光银色6.jpg', '/upload/product/watermark/1616723926640722354.jpg', NULL, NULL, 7, NULL, 3, 3, 1, '2,6,3', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '32-42', '7', '/upload/product/product/0515-1-US9527.jpg', 710, NULL, '2020-09-25 15:04:54', '2020-10-26 11:52:45', 0, 0, NULL, NULL, '11907587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/哑光银色7.jpg'),
	(822, 12, '0515-1/US952', '/upload/product/product/哑光银色4.jpg', '/upload/product/watermark/1602561554355287337.jpg', NULL, NULL, 7, NULL, 3, 3, 1, '2,6,3', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0515-1-US9528.jpg', 710, NULL, '2020-09-25 15:06:07', '2020-10-26 11:52:30', 0, 0, NULL, NULL, '11907599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, NULL, NULL, '/upload/product/product/哑光银色5.jpg'),
	(823, 48, '0710VK-KH/U14K', '/upload/product/product/0710VK-KH-U14K-F1-rechts.jpg', '/upload/product/watermark/1616763646155092484.jpg', NULL, NULL, 7, NULL, 2, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0710VK-KH-U14K-rechts3.jpg', 760, NULL, '2020-09-25 17:09:58', '2020-10-14 11:57:57', 0, 0, NULL, NULL, '11659890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, NULL, NULL, NULL),
	(824, 48, '0710VK-KH/U14K', '/upload/product/product/0710VK-KH-U14K-F1-links.jpg', NULL, NULL, NULL, 7, NULL, 2, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0710VK-KH-U14K-links3.jpg', 760, NULL, '2020-09-25 17:10:11', '2020-10-14 11:57:52', 0, 0, NULL, NULL, '11659907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, NULL, NULL, NULL),
	(825, 48, '0710VK-KH/U14K', '/upload/product/product/哑光银色2.jpg', '/upload/product/watermark/1616763608447503046.jpg', NULL, NULL, 7, NULL, 3, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0710VK-KH-U14K-links2.jpg', 760, NULL, '2020-09-25 17:12:40', '2020-10-26 11:51:19', 0, 0, NULL, NULL, '11913204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, NULL, NULL, '/upload/product/product/哑光银色3.jpg'),
	(826, 48, '0710VK-KH/U14K', '/upload/product/product/黑哑光6.jpg', '/upload/product/watermark/1616835871118637780.jpg', NULL, NULL, 7, NULL, 16, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '73', '7', '/upload/product/product/0710VK-KH-U14K-links1.jpg', 760, NULL, '2020-09-25 17:12:42', '2020-10-26 11:50:59', 0, 0, NULL, NULL, '11763231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, NULL, NULL, '/upload/product/product/黑哑光7.jpg'),
	(827, 48, '0710VK-KH/U14K', '/upload/product/product/黑哑光4.jpg', NULL, NULL, NULL, 7, NULL, 16, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '73', '7', '/upload/product/product/0710VK-KH-U14K-rechts2.jpg', 760, NULL, '2020-09-25 17:12:45', '2020-10-26 11:50:42', 0, 0, NULL, NULL, '11763225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, NULL, NULL, '/upload/product/product/黑哑光5.jpg'),
	(828, 48, '0710VK-KH/U14K', '/upload/product/product/哑光银色.jpg', NULL, NULL, NULL, 7, NULL, 3, 3, NULL, '3', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0710VK-KH-U14K-rechts1.jpg', 760, NULL, '2020-09-25 17:12:47', '2020-10-26 11:50:23', 0, 0, NULL, NULL, '11913216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, NULL, NULL, '/upload/product/product/哑光银色1.jpg'),
	(829, 48, '0710VK-KH/U14K', '/upload/product/product/0710VK-KH-U14K-F4-rechts.jpg', '/upload/product/watermark/1616981966216452515.jpg', NULL, NULL, 7, NULL, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0710VK-KH-U14K-rechts.jpg', 760, 1, '2020-09-25 17:12:48', '2020-10-14 11:56:59', 0, 0, NULL, NULL, '11659920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '右', NULL, NULL, NULL, NULL),
	(830, 48, '0710VK-KH/U14K', '/upload/product/product/0710VK-KH-U14K-F4-links.jpg', NULL, NULL, NULL, 7, NULL, 8, 3, 1, '', '', '<p>HOPPE 好博实心方轴</p>', NULL, '70', '7', '/upload/product/product/0710VK-KH-U14K-links.jpg', 760, NULL, '2020-09-25 17:12:56', '2020-10-14 11:57:07', 0, 0, NULL, NULL, '11659919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, '左', NULL, NULL, NULL, NULL),
	(831, 34, '0558/US945', '/upload/product/product/0558-US945-F1-11-F1.jpg', '/upload/product/watermark/1616801901211234018.jpg', NULL, NULL, 7, NULL, 4, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0558-US945.jpg', 920, NULL, '2020-10-13 10:50:26', '2020-10-13 10:55:06', 0, 0, NULL, NULL, '11869805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, NULL, NULL, NULL),
	(832, 34, '0558/US945', '/upload/product/product/0558-US945-F4-11-F4.jpg', '/upload/product/watermark/1615381479610272686.jpg', NULL, NULL, 7, NULL, 9, 3, 1, '2,6', '7,4', '<p>HOPPE 好博实心方轴，方轴长度可调范围 10mm，把手内部的特制压簧让长度调节顺畅灵活</p>', NULL, '62-72', '7', '/upload/product/product/0558-US9451.jpg', 920, NULL, '2020-10-13 10:54:33', '2020-10-13 10:54:48', 0, 0, NULL, NULL, '11786365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '暗装，需配 M5 螺丝', NULL, NULL, NULL, NULL, NULL, NULL),
	(835, 2, 'E5091GC/414GC/1400Z', '/upload/product/product/7f7207aa013a3a4a1a918881fd60b3f.jpg', '/upload/product/watermark/1616377412270365597.jpg', NULL, NULL, 2, NULL, 17, 2, NULL, '', '6', NULL, NULL, '47', '8', '/upload/product/product/1842dc09bd15f0702e2878a531acf50.jpg', 990, NULL, '2020-10-13 13:08:29', '2020-12-04 11:12:57', 0, 0, NULL, NULL, '11925371', NULL, NULL, NULL, NULL, '套', '700mm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 感应开启不锈钢拉手：</p><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室外侧 - HOPPE 好博 D 型截面不锈钢拉手：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>拉手：带感应装置，把手底部发出 LED 射灯 (4 种颜色可选：白，蓝，绿，红）可以感应到扰动</p></li><li><p>距离：离地距离最小 20cm 最大 50 cm</p></li><li><p>支撑：圆形，直</p></li><li><p>安装：暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 + 60 °C</p></li><li><p>感应装置（无线电频率）：125 kHz / 868 MHz</p></li><li><p>加密：AES (高级加密标准)</p></li><li><p>可感应距离：约. 1 m</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 1,5 A（最高）</p></li><li><p>发射功率：6,3 mW</p></li><li><p>最大功耗：0,7 W</p></li><li><p>安全级别：IP 44</p></li><li><p>电气连接： 通用（可选正或负控制脉冲）</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室内侧 - 带控制单元的半副把手，带底座：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>把手规格：散装把手, 一体把手复位弹簧, 免维护垫圈</p></li><li><p>方轴配置：HOPPE 好博膨胀方轴，预装底座，门扇只需一侧钻孔</p></li><li><p>安装基座：金属，带螺柱; 用于木门</p></li><li><p>安装：暗装，M5 螺丝</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">附件：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>Y型电缆，用于连接到电动锁</p></li><li><p>无线钥匙：2个，（CR 2450型）</p></li><li><p>卡：1张管理员卡，1张配置卡，2张门卡，2张门卡附属卡，2张无线钥匙附属卡</p></li></ul><p><br/></p>', NULL, NULL, NULL, NULL, NULL),
	(836, 27, 'E5091GC/414GC/1400Z', '/upload/product/product/13636ad8776619f0a360b9ebed61722.jpg', '/upload/product/watermark/1615190076486362741.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', NULL, NULL, '47', '8', '/upload/product/product/f75ef4a8994a89bf8c3d000a19e6c42.jpg', 990, NULL, '2020-10-13 13:14:07', '2020-12-04 11:12:30', 0, 0, NULL, NULL, '11904987', NULL, NULL, NULL, NULL, '套', '900mm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 感应开启不锈钢拉手：</p><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室外侧 - HOPPE 好博 D 型截面不锈钢拉手：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>拉手：带感应装置，把手底部发出 LED 射灯 (4 种颜色可选：白，蓝，绿，红）可以感应到扰动</p></li><li><p>距离：离地距离最小 20cm 最大 50 cm</p></li><li><p>支撑：圆形，直</p></li><li><p>安装：暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 + 60 °C</p></li><li><p>感应装置（无线电频率）：125 kHz / 868 MHz</p></li><li><p>加密：AES (高级加密标准)</p></li><li><p>可感应距离：约. 1 m</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 1,5 A（最高）</p></li><li><p>发射功率：6,3 mW</p></li><li><p>最大功耗：0,7 W</p></li><li><p>安全级别：IP 44</p></li><li><p>电气连接： 通用（可选正或负控制脉冲）</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室内侧 - 带控制单元的半副把手，带底座：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>把手规格：散装把手, 一体把手复位弹簧, 免维护垫圈</p></li><li><p>方轴配置：HOPPE 好博膨胀方轴，预装底座，门扇只需一侧钻孔</p></li><li><p>安装基座：金属，带螺柱; 用于木门</p></li><li><p>安装：暗装，M5 螺丝</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">附件：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>Y型电缆，用于连接到电动锁</p></li><li><p>无线钥匙：2个，（CR 2450型）</p></li><li><p>卡：1张管理员卡，1张配置卡，2张门卡，2张门卡附属卡，2张无线钥匙附属卡</p></li></ul><p><br/></p>', NULL, NULL, NULL, NULL, NULL),
	(837, 27, 'E5091GC/414GC/1400Z', '/upload/product/product/IMG-PRO-E5091GC-414GC-1400Z-F69-1400-1000-SALL-AIN-V11.jpg', '/upload/product/watermark/1616745606240661197.jpg', NULL, NULL, 2, NULL, 17, 2, 1, '', '6', NULL, NULL, '47', '8', '/upload/product/product/DRW-CAT-E5091GC-414GC-1400Z-1400-1000-SALL-AOF-V11.jpg', 990, NULL, '2020-10-13 13:22:10', '2020-12-04 11:12:01', 0, 0, NULL, NULL, '11925383', NULL, NULL, NULL, NULL, '套', '1000mm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '<p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">HOPPE 好博 eHandle 感应开启不锈钢拉手：</p><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室外侧 - HOPPE 好博 D 型截面不锈钢拉手：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>拉手：带感应装置，把手底部发出 LED 射灯 (4 种颜色可选：白，蓝，绿，红）可以感应到扰动</p></li><li><p>距离：离地距离最小 20cm 最大 50 cm</p></li><li><p>支撑：圆形，直</p></li><li><p>安装：暗装，标配第 11 号拉手安装螺丝</p></li><li><p>工作温度：-20 °C 到 + 60 °C</p></li><li><p>感应装置（无线电频率）：125 kHz / 868 MHz</p></li><li><p>加密：AES (高级加密标准)</p></li><li><p>可感应距离：约. 1 m</p></li><li><p>工作电压：8-24V DC</p></li><li><p>开关触点的载流量：24V DC, 1,5 A（最高）</p></li><li><p>发射功率：6,3 mW</p></li><li><p>最大功耗：0,7 W</p></li><li><p>安全级别：IP 44</p></li><li><p>电气连接： 通用（可选正或负控制脉冲）</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">室内侧 - 带控制单元的半副把手，带底座：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>把手规格：散装把手, 一体把手复位弹簧, 免维护垫圈</p></li><li><p>方轴配置：HOPPE 好博膨胀方轴，预装底座，门扇只需一侧钻孔</p></li><li><p>安装基座：金属，带螺柱; 用于木门</p></li><li><p>安装：暗装，M5 螺丝</p></li></ul><p class="proddesc" style="padding: 0px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; margin-top: 0px; margin-bottom: 0px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);">附件：</p><ul class=" list-paddingleft-2" style="padding: 0px 0px 0px 20px; border: 0px currentColor; border-image: none; color: rgb(80, 80, 80); font-family: helvetica_neue_lt_std_regular, Helvetica, Arial, sans-serif; font-size: 13px; vertical-align: baseline; white-space: normal; background-color: rgb(255, 255, 255);"><li><p>Y型电缆，用于连接到电动锁</p></li><li><p>无线钥匙：2个，（CR 2450型）</p></li><li><p>卡：1张管理员卡，1张配置卡，2张门卡，2张门卡附属卡，2张无线钥匙附属卡</p></li></ul>', NULL, NULL, NULL, NULL, NULL),
	(838, 47, 'AR3310', '/upload/product/product/镍哑光.jpg', '/upload/product/watermark/1616640159547353989.jpg', NULL, NULL, 10, 5, 93, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/d8924f43257bf15986d59b8a7519890.jpg', 970, NULL, '2020-10-13 13:32:13', '2021-01-22 14:09:57', 0, 0, NULL, NULL, '50018991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '/upload/product/product/镍哑光1.jpg'),
	(839, 47, 'AR3310', '/upload/product/product/5ee2255fb20f5762f724122518cf694.jpg', '/upload/product/watermark/1616646549883258708.jpg', NULL, NULL, 10, 5, 94, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/d8924f43257bf15986d59b8a75198901.jpg', 970, 1, '2020-10-13 13:41:05', '2021-01-22 14:21:19', 0, 0, NULL, NULL, '50019004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(840, 47, 'AR3310', '/upload/product/product/黑.jpg', '/upload/product/watermark/1616640171731517945.jpg', NULL, NULL, 10, 5, 79, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/d8924f43257bf15986d59b8a75198902.jpg', 970, NULL, '2020-10-13 13:42:18', '2021-01-22 14:21:30', 0, 0, NULL, NULL, '50019016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '/upload/product/product/黑1.jpg'),
	(841, 47, 'AR3310', '/upload/product/product/镀铜.jpg', '/upload/product/watermark/1615796181996637836.jpg', NULL, NULL, 10, 5, 82, 2, NULL, '', '', NULL, NULL, NULL, NULL, '/upload/product/product/d8924f43257bf15986d59b8a75198903.jpg', NULL, NULL, '2020-10-13 13:43:27', '2021-01-22 14:21:55', 0, 0, NULL, NULL, '50019028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '50', '圆角', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '/upload/product/product/镀铜1.jpg');
/*!40000 ALTER TABLE `product` ENABLE KEYS */;

-- 导出  表 hoppe.p_attr 结构
CREATE TABLE IF NOT EXISTS `p_attr` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '名称',
  `img` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT '属性图',
  `show` int(11) DEFAULT NULL COMMENT '0否1是    是否在前台显示属性',
  `sort` int(11) DEFAULT '0' COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='产品属性';

-- 正在导出表  hoppe.p_attr 的数据：~7 rows (大约)
/*!40000 ALTER TABLE `p_attr` DISABLE KEYS */;
REPLACE INTO `p_attr` (`id`, `name`, `img`, `show`, `sort`, `create_time`) VALUES
	(1, 'PATT-Abschliessbar-sRGB', '/upload/product/patent/PATT-Abschliessbar-sRGB.jpg', 0, 5, '2020-09-07 02:52:23'),
	(2, 'PATT-Automatisch-verriegelt-sRGB', '/upload/product/attr/PATT-Automatisch-verriegelt-sRGB.jpg', 0, 0, '2020-09-07 02:55:42'),
	(3, '应用等级DIN EN 1906，3级', '/upload/product/attr/PATT-EN1906-sRGB.jpg', 1, 99, '2020-09-11 10:19:40'),
	(4, '超高度防腐 EN 1670，4级', '/upload/product/attr/PATT-Hohe-Korrosionsbestaendigkeit-sRGB.jpg', 1, 97, '2020-09-11 10:20:30'),
	(5, '实心黄铜', '/upload/product/attr/PATT-Messing-massiv-sRGB.jpg', 1, 95, '2020-09-11 10:20:57'),
	(6, '不锈钢', '/upload/product/attr/PATT-Edelstahl-Rostfrei-sRGB.jpg', 1, 93, '2020-09-11 11:12:48'),
	(7, 'DIN EN 13126-3 窗把手标准', '/upload/product/attr/PATT-EN13126-3-sRGB.jpg', 1, 98, '2020-09-25 11:08:15');
/*!40000 ALTER TABLE `p_attr` ENABLE KEYS */;

-- 导出  表 hoppe.p_color 结构
CREATE TABLE IF NOT EXISTS `p_color` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `material_id` int(11) DEFAULT NULL COMMENT '材质',
  `code` varchar(150) DEFAULT NULL COMMENT '颜色代码',
  `color_cn` varchar(150) DEFAULT NULL COMMENT '颜色对应中文名称',
  `color_en` varchar(150) DEFAULT NULL COMMENT '颜色对应英文名称',
  `color_img` varchar(255) DEFAULT NULL COMMENT '材质颜色图 ',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=95 DEFAULT CHARSET=utf8mb4 COMMENT='颜色对应表';

-- 正在导出表  hoppe.p_color 的数据：~71 rows (大约)
/*!40000 ALTER TABLE `p_color` DISABLE KEYS */;
REPLACE INTO `p_color` (`id`, `material_id`, `code`, `color_cn`, `color_en`, `color_img`, `sort`, `create_time`) VALUES
	(2, 3, 'F1', '银色', NULL, '/upload/product/color/F11.png', 0, NULL),
	(3, 3, 'F1-2-S', '哑光银色SecuSan®', NULL, '/upload/product/color/F1-2-S1.png', 0, NULL),
	(4, 3, 'F1-11', '亮银色/哑光', NULL, '/upload/product/color/F1-111.png', 0, NULL),
	(5, 3, 'F1/F69', '银色/不锈钢磨砂', NULL, '/upload/product/color/F1 F69.png', 0, NULL),
	(6, 3, 'F2-2', '哑光香槟色', NULL, '/upload/product/color/F2-21.png', 0, NULL),
	(7, 3, 'F3', '铝金色', NULL, '/upload/product/color/F3.png', 0, NULL),
	(8, 3, 'F4', '古铜色', NULL, '/upload/product/color/F41.png', 0, NULL),
	(9, 3, 'F4-11', '古铜光亮/哑光', NULL, '/upload/product/color/F4-111.png', 0, NULL),
	(10, 3, 'F9', '仿钢色', NULL, '/upload/product/color/F91.png', 0, NULL),
	(11, 3, 'F9-11', '仿钢色抛光/哑光', NULL, '/upload/product/color/F9-111.png', 0, NULL),
	(12, 3, 'F31-1', '仿不锈钢/哑光', NULL, '/upload/product/color/F31-11.png', 0, NULL),
	(14, 3, 'F9016', '交通白', NULL, '/upload/product/color/F90162.png', 0, NULL),
	(16, 3, 'F9714M', '黑哑光', NULL, '/upload/product/color/F9714M1.png', 0, NULL),
	(17, 2, 'F69', '不锈钢磨砂', NULL, '/upload/product/color/F691.png', 0, NULL),
	(18, 1, 'F41-R', '镀铬拉丝', NULL, '/upload/product/color/F41-R1.png', 0, NULL),
	(19, 1, 'F42-R', '镀镍丝光', NULL, '/upload/product/color/F42-R1.png', 0, NULL),
	(20, 1, 'F45-R', '镀铬抛光/丝光', NULL, '/upload/product/color/F45-R1.png', 0, NULL),
	(21, 1, 'F49-R', '镀铬抛光', NULL, '/upload/product/color/F49-R1.png', 0, NULL),
	(23, 1, 'F72', '铜拉丝', NULL, '/upload/product/color/F721.png', 0, NULL),
	(25, 1, 'F73', '古铜色', NULL, '/upload/product/color/F73.png', 0, NULL),
	(26, 1, 'F74-R', '铜色, 丝光/抛光', NULL, '/upload/product/color/F74-R.png', 0, NULL),
	(27, 1, 'F77-R', '铜色, 抛光', NULL, '/upload/product/color/F77-R.png', 0, NULL),
	(28, 1, 'F77-R/F52-R', '铜色, 抛光/丝光', NULL, '/upload/product/color/F77-R F52-R.png', 0, NULL),
	(29, 1, 'F78-R', '自然亮铜色', NULL, '/upload/product/color/F78-R1.png', 0, NULL),
	(30, 1, 'F78-1-R', '自然丝光铜色', NULL, '/upload/product/color/F78-1-R 黄铜1.png', 0, NULL),
	(31, 1, 'F84-R', '亮玫瑰金', NULL, '/upload/product/color/F84-R1.png', 0, NULL),
	(32, 1, 'F84-1-R', '丝光玫瑰金', NULL, '/upload/product/color/F84-1-R 黄铜.png', 0, NULL),
	(33, 1, 'F96-R', '亮黑', NULL, '/upload/product/color/F96-R1.png', 0, NULL),
	(34, 1, 'F96-1-R', '丝光黑', NULL, '/upload/product/color/F96-1-R 黄铜.png', 0, NULL),
	(35, 1, 'F97-R', '亮烟灰色', NULL, '/upload/product/color/F97-R1.png', 0, NULL),
	(36, 1, 'F97-1-R', '丝光烟灰色', NULL, '/upload/product/color/F97-1-R 黄铜.png', 0, NULL),
	(44, 3, 'F1-2', '哑光银色', NULL, '/upload/product/color/F1-21.png', 0, NULL),
	(45, 3, 'F9-2', '哑光仿钢色', NULL, '/upload/product/color/F9-21.png', 0, NULL),
	(46, 4, 'F7016M', '烟灰哑光', NULL, '/upload/product/color/F7016M1.png', 0, NULL),
	(47, 4, 'F9005M', '乌黑哑光', NULL, '/upload/product/color/F9005M1.png', 0, NULL),
	(48, 4, 'F9010M', '纯白哑光', NULL, '/upload/product/color/F9010M1.png', 0, NULL),
	(49, 2, 'F69-S', '不锈钢拉丝SecuSan®', NULL, '/upload/product/color/F69-S1.png', 0, NULL),
	(52, 1, 'F54', '复古黄铜色', NULL, '/upload/product/color/F541.png', 0, NULL),
	(53, 1, 'F55', '复古铜色', NULL, '/upload/product/color/F551.png', 0, NULL),
	(54, 1, 'F56', '复古青铜', NULL, '/upload/product/color/F561.png', 0, NULL),
	(55, 1, 'F76', '深红古铜', NULL, '/upload/product/color/F761.png', 0, NULL),
	(57, 1, 'F75-R', '铜色,抛光/丝光', NULL, '/upload/product/color/F75-R.png', 0, NULL),
	(62, 1, 'F49/F69', '镀铬抛光/不锈钢拉丝', NULL, '/upload/product/color/F49 F69.png', 0, '2020-09-11 11:46:36'),
	(63, 1, 'F73-1', '古铜色,拉丝', NULL, '/upload/product/color/F73-1.png', 0, '2020-09-18 16:19:19'),
	(64, 1, 'F73M-1', '古铜色,拉丝,哑光', NULL, '/upload/product/color/F73M-1.png', 0, '2020-09-18 16:21:14'),
	(65, 1, 'F49-R/F41-R', '镀铬抛光/丝光', NULL, '/upload/product/color/F49-R F41R.png', 0, '2020-09-18 16:26:19'),
	(66, 1, 'F52-R/F77-R', '抛光/丝光,铜色', NULL, '/upload/product/color/F52-R F77-R.png', 0, '2020-09-18 16:27:56'),
	(71, 2, 'F78-1-R', '自然丝光铜色', NULL, '/upload/product/color/F78-1-R 不锈钢4.png', 0, '2020-09-18 16:52:24'),
	(72, 2, 'F84-1-R', '丝光玫瑰金', NULL, '/upload/product/color/F84-1-R 不锈钢.png', 0, '2020-09-18 16:53:35'),
	(73, 2, 'F96-1-R', '丝光黑', NULL, '/upload/product/color/F96-1-R 不锈钢.png', 0, '2020-09-18 16:54:44'),
	(74, 2, 'F97-1-R', '丝光烟灰色', NULL, '/upload/product/color/F97-1-R 不锈钢.png', 0, '2020-09-18 16:55:44'),
	(75, 3, 'F1-2/F9-2', '哑光银色/哑光仿钢色', NULL, '/upload/product/color/F1-2 F9-2.png', 0, '2020-09-18 16:58:47'),
	(76, 1, 'F71', '铜色', NULL, '/upload/product/color/F71-R.png', 0, '2020-09-25 10:14:36'),
	(77, 1, 'F41', '镀铬', NULL, '/upload/product/color/F411.png', 0, '2020-09-25 10:17:10'),
	(78, 3, 'F1-1', '铝合金，磨砂银色', NULL, '/upload/product/color/F1-1.png', 0, '2020-09-25 16:04:22'),
	(79, 2, 'BLK', '黑', NULL, '/upload/product/color/BLK2.png', 0, '2020-09-30 10:25:10'),
	(80, 2, 'AB', '古铜色', NULL, '/upload/product/color/F73-12.png', 0, '2020-09-30 10:26:03'),
	(81, 1, 'PB', '铜抛光', NULL, '/upload/product/color/PB1.png', 0, '2020-09-30 10:26:26'),
	(82, 2, 'PVD', 'PVD-镀铜', NULL, '/upload/product/color/PVD2.png', 0, '2020-09-30 10:26:51'),
	(83, 1, 'MNP', '镍哑光', NULL, '/upload/product/color/MNP1.png', 0, '2020-09-30 10:27:24'),
	(84, 2, 'PSS', '光亮不锈钢', NULL, '/upload/product/color/PSS1.png', 0, '2020-09-30 10:27:50'),
	(85, 2, 'SSS', '丝光不锈钢', NULL, '/upload/product/color/SSS1.png', 0, '2020-09-30 10:28:06'),
	(86, 1, 'SAT-COP', '丝光铜色', NULL, '/upload/product/color/F84-1-R 黄铜1.png', 0, '2020-09-30 11:07:51'),
	(87, 1, 'SBZ', '丝光古铜色', NULL, '/upload/product/color/F412.png', 0, '2020-09-30 11:08:11'),
	(88, 3, 'F9016M', '交通白哑光', NULL, '/upload/product/color/F9016M.png', 0, '2020-10-13 11:25:39'),
	(89, 3, 'F2', '香槟色', NULL, '/upload/product/color/F2.png', 0, '2020-10-13 11:35:23'),
	(90, 2, 'F31-1/F69', '铝合金仿不锈钢，哑光/丝光', NULL, '/upload/product/color/F31-1&F69.png', 0, '2020-10-13 11:50:33'),
	(91, 1, 'BLK', '黑', NULL, '/upload/product/color/BLK1.png', 0, '2020-10-13 12:49:54'),
	(92, 1, 'AB', '古铜色', NULL, '/upload/product/color/F73-11.png', 0, '2020-10-13 12:50:50'),
	(93, 2, 'MNP', '镍哑光', NULL, '/upload/product/color/MNP2.png', 0, '2020-10-13 13:35:58'),
	(94, 2, 'WHT', '白', NULL, '/upload/product/color/WHT1.png', 0, '2020-10-13 13:36:15');
/*!40000 ALTER TABLE `p_color` ENABLE KEYS */;

-- 导出  表 hoppe.p_keyhole 结构
CREATE TABLE IF NOT EXISTS `p_keyhole` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品自增id',
  `title` varchar(255) DEFAULT NULL COMMENT '锁标题',
  `img` varchar(255) DEFAULT NULL COMMENT '钥匙孔图片路径',
  `size` varchar(255) DEFAULT NULL COMMENT '尺寸 92-85-72 大小',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4;

-- 正在导出表  hoppe.p_keyhole 的数据：~8 rows (大约)
/*!40000 ALTER TABLE `p_keyhole` DISABLE KEYS */;
REPLACE INTO `p_keyhole` (`id`, `title`, `img`, `size`, `sort`, `create_time`) VALUES
	(1, 'PZ', '/upload/product/keyhole/icon_sk.png', NULL, 99, '2020-09-21 15:59:28'),
	(2, 'OB', '/upload/product/keyhole/konb-ob.png', NULL, 88, '2020-09-21 16:01:03'),
	(3, 'SK/OL', '/upload/product/keyhole/knob2.png', NULL, 77, '2020-09-22 14:37:22'),
	(4, 'PZ72', '/upload/product/keyhole/icon_sk1.png', '72', 0, '2020-09-25 09:57:25'),
	(5, 'PZ85', '/upload/product/keyhole/icon_sk2.png', '85', 0, '2020-09-25 10:11:26'),
	(6, 'PZ92', '/upload/product/keyhole/icon_sk3.png', '92', 0, '2020-09-25 10:11:35'),
	(7, 'UG', NULL, 'UG', 0, '2020-09-25 11:01:21'),
	(8, 'PZ69', '/upload/product/keyhole/icon_sk4.png', '69', 0, '2020-09-25 15:49:47');
/*!40000 ALTER TABLE `p_keyhole` ENABLE KEYS */;

-- 导出  表 hoppe.p_material 结构
CREATE TABLE IF NOT EXISTS `p_material` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品材质ID',
  `name` varchar(50) DEFAULT NULL COMMENT '材质名称 铝合金  啥的',
  `is_app` int(11) DEFAULT '0' COMMENT '是否设置应用体验展示0 否1 是',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='产品材质表';

-- 正在导出表  hoppe.p_material 的数据：~4 rows (大约)
/*!40000 ALTER TABLE `p_material` DISABLE KEYS */;
REPLACE INTO `p_material` (`id`, `name`, `is_app`, `sort`, `create_time`) VALUES
	(1, '黄铜', 1, 10, '2020-07-10 16:38:04'),
	(2, '不锈钢', 1, 9, '2020-07-10 16:39:26'),
	(3, '铝合金', 1, 8, '2020-07-10 16:39:34'),
	(4, '尼龙', 0, 2, '2020-09-15 13:43:47');
/*!40000 ALTER TABLE `p_material` ENABLE KEYS */;

-- 导出  表 hoppe.p_patent 结构
CREATE TABLE IF NOT EXISTS `p_patent` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品专利ID',
  `name` varchar(255) DEFAULT NULL COMMENT '专利名称',
  `logo` varchar(255) DEFAULT NULL COMMENT '专利logo',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COMMENT='产品专利';

-- 正在导出表  hoppe.p_patent 的数据：~7 rows (大约)
/*!40000 ALTER TABLE `p_patent` DISABLE KEYS */;
REPLACE INTO `p_patent` (`id`, `name`, `logo`, `sort`, `create_time`) VALUES
	(1, 'Quick-Fit', '/upload/product/patent/x15f88436c.png', 99, '2020-07-10 17:38:39'),
	(2, 'Secustik', '/upload/product/patent/SATT-Secustik.jpg', 98, '2020-07-10 17:38:52'),
	(3, 'SecuSan', '/upload/product/patent/0.png', 90, '2020-08-05 09:56:34'),
	(4, 'Resista', '/upload/product/patent/SATT-Resista.jpg', 0, '2020-09-11 10:17:43'),
	(5, 'HCS', '/upload/product/patent/SATT-HCS1.jpg', 0, '2020-09-15 11:27:48'),
	(6, 'VarioFit', '/upload/product/patent/SATT-VarioFit.jpg', 95, '2020-09-25 11:06:13'),
	(7, 'SecuForte', '/upload/product/patent/SATT-SecuForte.jpg', 97, '2020-09-25 13:24:25');
/*!40000 ALTER TABLE `p_patent` ENABLE KEYS */;

-- 导出  表 hoppe.p_style 结构
CREATE TABLE IF NOT EXISTS `p_style` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品风格系列id',
  `name` varchar(255) DEFAULT NULL COMMENT '系列标题',
  `logo` varchar(255) DEFAULT NULL COMMENT '系列图',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='产品风格系列';

-- 正在导出表  hoppe.p_style 的数据：~3 rows (大约)
/*!40000 ALTER TABLE `p_style` DISABLE KEYS */;
REPLACE INTO `p_style` (`id`, `name`, `logo`, `sort`, `create_time`) VALUES
	(1, '精致主流', '/upload/product/patent/x370df970a.png', 100, '2020-07-10 17:51:41'),
	(3, '脱俗精品', '/upload/product/patent/duravert.png', 0, '2020-09-11 11:47:42'),
	(4, '务实品质', '/upload/product/patent/duarnorm.png', 0, '2020-09-11 11:53:12');
/*!40000 ALTER TABLE `p_style` ENABLE KEYS */;

-- 导出  表 hoppe.p_title 结构
CREATE TABLE IF NOT EXISTS `p_title` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(255) DEFAULT NULL COMMENT '款式名称',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=49 DEFAULT CHARSET=utf8mb4 COMMENT='产品  款式表   标题显示';

-- 正在导出表  hoppe.p_title 的数据：~48 rows (大约)
/*!40000 ALTER TABLE `p_title` DISABLE KEYS */;
REPLACE INTO `p_title` (`id`, `name`, `sort`, `create_time`) VALUES
	(1, 'Bergen', 96, '2020-07-24 14:21:46'),
	(2, 'Amsterdam', 97, '2020-07-24 14:22:13'),
	(3, 'Dallas', 98, '2020-07-24 14:23:47'),
	(4, 'Boston', 100, '2020-07-24 14:24:01'),
	(5, 'Avignon', 99, '2020-07-24 14:24:18'),
	(6, 'Bristol', 0, '2020-08-05 11:01:08'),
	(7, 'Los Angeles', 0, '2020-08-05 11:16:59'),
	(8, 'Singapore', 0, '2020-09-06 22:38:24'),
	(9, 'Athinai', 0, '2020-09-06 22:38:24'),
	(10, 'ZETA', 0, '2020-09-06 22:38:24'),
	(11, 'Beta', 0, '2020-09-06 22:38:24'),
	(12, 'Vitória', 0, '2020-09-06 22:38:24'),
	(13, 'Atlanta', 0, '2020-09-06 22:38:24'),
	(14, 'CAPRI', 0, '2020-09-06 22:38:24'),
	(15, 'Perth', 0, '2020-09-06 22:38:24'),
	(16, 'Groningen', 0, '2020-09-06 22:38:24'),
	(17, 'Paris', 0, '2020-09-06 22:38:24'),
	(18, 'Arles', 0, '2020-09-06 22:38:24'),
	(19, 'London', 0, '2020-09-06 22:38:24'),
	(20, 'GAMMA', 0, '2020-09-06 22:38:24'),
	(21, 'Cannes', 0, '2020-09-06 22:38:24'),
	(22, 'Genova', 0, '2020-09-06 22:38:24'),
	(23, 'Melbourne', 0, '2020-09-06 22:38:25'),
	(24, 'Stockholm', 0, '2020-09-06 22:38:25'),
	(25, 'Acapulco', 0, '2020-09-06 22:38:25'),
	(26, 'Ródos', 0, '2020-09-06 22:38:25'),
	(27, 'Amsterdam', 0, '2020-09-06 22:38:25'),
	(28, 'Dallas', 0, '2020-09-06 22:38:25'),
	(29, 'Houston', 0, '2020-09-06 22:38:25'),
	(30, 'New York', 0, '2020-09-06 22:38:25'),
	(31, 'Los Angeles', 0, '2020-09-06 22:38:25'),
	(32, 'München', 0, '2020-09-06 22:38:25'),
	(33, 'Boston', 0, '2020-09-06 22:38:25'),
	(34, 'Avignon', 0, '2020-09-06 22:38:25'),
	(35, 'HINGES', 0, '2020-09-06 22:38:25'),
	(36, 'CYL', 0, '2020-09-06 22:38:25'),
	(37, 'Locks', 0, '2020-09-06 22:38:25'),
	(38, 'Austin', 0, '2020-09-06 22:38:25'),
	(39, 'Bristol', 0, '2020-09-06 22:38:25'),
	(40, 'Toulon', 0, '2020-09-06 22:38:25'),
	(41, 'Brest', 0, '2020-09-06 22:38:25'),
	(42, 'Brugge', 0, '2020-09-06 22:38:25'),
	(43, 'Liège', 0, '2020-09-06 22:38:25'),
	(44, 'Alpha', 0, '2020-09-06 22:38:25'),
	(45, 'Hamburg', 0, '2020-09-06 22:38:25'),
	(46, 'OMEGA', 0, '2020-09-06 22:38:25'),
	(47, '无', 0, '2020-09-11 16:20:13'),
	(48, 'Tokyo', 0, '2020-09-25 17:06:45');
/*!40000 ALTER TABLE `p_title` ENABLE KEYS */;

-- 导出  表 hoppe.p_type 结构
CREATE TABLE IF NOT EXISTS `p_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '产品类型ID',
  `name` varchar(255) DEFAULT NULL COMMENT '类型名称',
  `topline` varchar(255) DEFAULT NULL COMMENT '上行',
  `bottomline` varchar(255) DEFAULT NULL COMMENT '下行',
  `knob` int(11) DEFAULT NULL COMMENT '是否门把手 0否1是',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COMMENT='产品类型 表';

-- 正在导出表  hoppe.p_type 的数据：~12 rows (大约)
/*!40000 ALTER TABLE `p_type` DISABLE KEYS */;
REPLACE INTO `p_type` (`id`, `name`, `topline`, `bottomline`, `knob`, `sort`, `create_time`) VALUES
	(1, '室内门把手', '室内门把手', NULL, 1, 100, '2020-07-10 16:12:25'),
	(2, '智能家居产品', '智能家居', '产品', 0, 20, '2020-07-10 16:16:52'),
	(3, '型材门把手', '型材门把手', NULL, 0, 60, '2020-07-10 16:18:58'),
	(4, 'HCS 整体系统锁', 'HCS 整体', '系统锁', 0, 90, '2020-07-10 16:19:03'),
	(5, '大拉手', '大拉手', NULL, 0, 70, '2020-07-10 16:24:06'),
	(6, '提升推拉门把手', '提升推拉', '门把手', 0, 40, '2020-07-30 15:59:59'),
	(7, '窗把手', '窗把手', NULL, 0, 50, '2020-07-30 16:00:09'),
	(8, '内倒推拉门把手', '内倒推拉', '门把手', 0, 30, '2020-07-30 16:00:18'),
	(9, '合页', '合页', NULL, 0, 10, '2020-07-30 16:00:27'),
	(10, '锁体', '锁体', NULL, 0, 5, '2020-07-30 16:00:42'),
	(11, '锁芯', '锁芯', NULL, 0, 0, '2020-09-05 13:53:02'),
	(12, '平移门五金产品', '平移门', '五金产品', 0, 80, '2020-09-11 16:18:40');
/*!40000 ALTER TABLE `p_type` ENABLE KEYS */;

-- 导出  表 hoppe.registration_form 结构
CREATE TABLE IF NOT EXISTS `registration_form` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `openid` varchar(255) DEFAULT NULL COMMENT 'openid微信id',
  `language` int(11) DEFAULT NULL COMMENT '语言中文英文 1cn 2en',
  `company` varchar(255) DEFAULT NULL COMMENT '公司名称',
  `name` varchar(255) DEFAULT NULL COMMENT '姓名',
  `province` varchar(50) DEFAULT NULL COMMENT '省',
  `city` varchar(50) DEFAULT NULL COMMENT '市',
  `district` varchar(50) DEFAULT NULL COMMENT '县',
  `address` varchar(255) DEFAULT NULL COMMENT '联系地址',
  `country` varchar(255) DEFAULT NULL COMMENT '国家',
  `staff_size` varchar(255) DEFAULT NULL COMMENT '企业人员规模 数量 总数',
  `phone` varchar(255) DEFAULT NULL COMMENT '联系电话',
  `email` varchar(255) DEFAULT NULL COMMENT '邮箱',
  `industry` varchar(1000) DEFAULT NULL COMMENT '所属行业   ,,,,,,,,,,, 逗号隔开',
  `industry_other` varchar(1000) DEFAULT NULL COMMENT '所属行业 其他',
  `interest` varchar(1000) DEFAULT NULL COMMENT '兴趣意向   ,,,,,,,,,, 逗号隔开',
  `interest_other` varchar(1000) DEFAULT NULL COMMENT '兴趣意向 其他',
  `know_product` varchar(1000) DEFAULT NULL COMMENT '了解到产品   ,,,,,,,,,,,,, 逗号隔开',
  `create_time` datetime DEFAULT NULL COMMENT '系统创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=132 DEFAULT CHARSET=utf8mb4 COMMENT='展会登记表';

-- 正在导出表  hoppe.registration_form 的数据：~90 rows (大约)
/*!40000 ALTER TABLE `registration_form` DISABLE KEYS */;
REPLACE INTO `registration_form` (`id`, `openid`, `language`, `company`, `name`, `province`, `city`, `district`, `address`, `country`, `staff_size`, `phone`, `email`, `industry`, `industry_other`, `interest`, `interest_other`, `know_product`, `create_time`) VALUES
	(28, 'o1qmn5E-zNrmrU8chno2EYfC_fQQ', 1, '威马化工（上海）有限公司', '刘勇波', NULL, NULL, NULL, '哈尔滨道里区新航路', '中国', NULL, '13836135157', 'lyb3508@163.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuSan® 抗菌、抑菌把手', '2020-10-28 17:06:39'),
	(29, 'o1qmn5Fcbv6hlyv4aO4mA-MQbGLA', 1, '哈尔滨宇通门窗幕墙有限', '夏辉', NULL, NULL, NULL, '哈尔滨道理区', '中国', '2人', '15246765888', '408788070', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'ARRONE® 五金', '2020-10-29 06:51:16'),
	(30, 'o1qmn5BdZZPbV8FK3uqbyvKQ-voM', 1, '武汉凌云门窗公司', '胡先生', NULL, NULL, NULL, '武汉市金山大道146号', '中国', NULL, '15827194327', '27946874@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录,新产品彩页', NULL, NULL, '2020-10-29 09:07:09'),
	(31, 'o1qmn5DjWXfxQ3NY6lEVaBTfXTk8', 1, '大连建宏门窗有限公司', '陈建有', NULL, NULL, NULL, '大连开发区', '中国', '15', '13478775888', '704364079@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-29 09:23:01'),
	(32, 'o1qmn5H0cYPZG9IUmNKqM3Uc52xo', 1, '宿迁市中佳新材料科技有限公司', '王鹏', NULL, NULL, NULL, '宿迁市宿城区淮海建材城58栋', '中国', NULL, '13815790122', '401167566@qq.con', '批发/零售商', NULL, '室内门把手目录', NULL, NULL, '2020-10-29 09:26:22'),
	(33, 'o1qmn5LFQuQRoK7i4hw1vIkFyzMA', 1, '华龙', '安东', NULL, NULL, NULL, '黑龙江牡丹江', '中国', NULL, '15174660432', '514134491@qq.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, NULL, '2020-10-29 10:00:29'),
	(35, 'o1qmn5Am-45gGsD1wlt5MGGDFu3g', 1, '滨州裕阳', '刘磊', NULL, NULL, NULL, '18454361770', '中国', '6000', '18454361770', '1061539461@qq.com', '建筑师', NULL, '窗和型材门把手目录', NULL, 'SecuSan® 抗菌、抑菌把手', '2020-10-29 10:07:03'),
	(36, 'o1qmn5PE4Njc-1e_3BHylreguxTE', 1, '辽阳弘远科技有限公司', '曹金雷', NULL, NULL, NULL, '辽宁省辽阳市', '中国', NULL, '15141937676', '719520686@qq.com', '批发/零售商,系统或五金制造商（例如锁体、门窗系统等）', NULL, NULL, NULL, NULL, '2020-10-29 10:07:31'),
	(37, 'o1qmn5NLLJvBluQ9oU1LjADNMKwM', 1, '甘肃三米盈德建材有限公司', '吴尚宇', NULL, NULL, NULL, '甘肃省天水市秦州区贾家寺工业园区', '中国', NULL, '13020120186', '710092402', '装修公司,门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, 'HOPPE eHandle,Mini-Rosette 无底座门把手,ARRONE® 五金,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手', '2020-10-29 10:09:30'),
	(38, 'o1qmn5MTbWhgRA07i6Qjlk0yNIwA', 1, '裕鑫门窗', '李建宇', NULL, NULL, NULL, '大连开发区', '中国', '个体', '18940831555', '1928058941', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-29 10:43:14'),
	(39, 'o1qmn5OhFy4RLN8eqLcVr5a1nnpI', 1, '辉县市晶彩建材有限公司', '侯圣祥', NULL, NULL, NULL, '河南省辉县市南李庄商铺23号', '中国', NULL, '13598659800', '184205618@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录,新产品彩页', NULL, NULL, '2020-10-29 11:09:21'),
	(40, 'o1qmn5EdROGHxIkE4ZRblS5lG4-c', 1, '伊博莱门窗', '杜小敏', NULL, NULL, NULL, '北京市朝阳区十里河美联天地MB1一228伊博莱门窗', '中国', NULL, '13691139767', '765620419@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录,新产品彩页,HOPPE 好博官方微信', NULL, 'Resista® 10年质保新色彩系列,SecuForte®,HOPPE eHandle', '2020-10-29 11:09:34'),
	(41, 'o1qmn5NS2DYSj2b0HC7MxOYfB5dU', 1, '汉斯诺克', '刘俊义', NULL, NULL, NULL, '北京市通州区', '中国', NULL, '13683699660', '709862746@qq.com', '门、窗制造商', NULL, '室内门把手目录', NULL, NULL, '2020-10-29 11:22:34'),
	(42, 'o1qmn5KgU2Y2e41mMdKIVQst9M2U', 1, '亚尔五金', '孙高峰', NULL, NULL, NULL, '陕西省西安', '中国', NULL, '13991817179', '1113005183', '批发/零售商', NULL, '新产品彩页', NULL, 'Resista® 10年质保新色彩系列', '2020-10-29 11:23:20'),
	(43, 'o1qmn5KIDZtkKmeMarcZFS3ldQ8w', 1, '沈阳市阳光窗业有限公司', '吴琼', NULL, NULL, NULL, '沈阳经济技术开发区三号街二甲四号', '中国', NULL, '13252894867', '759319787@qq.com', '门、窗制造商', NULL, '室内门把手目录', NULL, 'HOPPE eHandle', '2020-10-29 11:23:51'),
	(44, 'o1qmn5LotC1u_EYQucJPCMnOPKOU', 1, '济南坚之朗商贸有限公司', '王俊林', NULL, NULL, NULL, '济南市天桥区', '中国', NULL, '13853157188', '40435374@qq.com', '批发/零售商', NULL, NULL, NULL, NULL, '2020-10-29 11:31:44'),
	(45, 'o1qmn5Edt0edML1M1CvdluFFSHo8', 1, '营口三三铝业', '孙连杰', NULL, NULL, NULL, '辽宁省营口市大石桥市西外环路府南大街', '中国', NULL, '15141728376', '447827966@qq.com', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-10-29 11:37:18'),
	(46, 'o1qmn5MfGP95kogcxtpSbzajC-Wc', 1, '盘锦泰实新型建材有限公司', '战国宏', NULL, NULL, NULL, '辽宁省盘锦市', '中国', '50人', '18942793888', '188126445@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录,2019-2020 中国采购指南,HOPPE 好博官方微信', NULL, 'SecuSan® 抗菌、抑菌把手', '2020-10-29 11:50:46'),
	(47, 'o1qmn5CMcCsuEeAAXf4Y44-vMDEE', 1, '唐山东方一铭家具制造有限公司', '佟童', NULL, NULL, NULL, '河北省唐山市路北区西外环', '中国', NULL, '13832539118', 'tstongisme@163.com', '门、窗制造商', NULL, '窗和型材门把手目录,室内门把手目录,新产品彩页', NULL, NULL, '2020-10-29 11:52:55'),
	(48, 'o1qmn5MRN9BWTN0cwg3B3SYBZRhQ', 1, '唐山市丰润区德意佳门窗幕墙工程有限公司', '张春亮', NULL, NULL, NULL, '唐山', '中国', '150', '13315518311', '719941004@qq.com', '门、窗制造商', NULL, '室内门把手目录', NULL, 'HOPPE eHandle', '2020-10-29 12:19:35'),
	(49, 'o1qmn5OkP_fycnRobyPepdsmRS50', 1, '烟台居佳五金有限公司', '张德强', NULL, NULL, NULL, '山东烟台', '中国', NULL, '13606387731', '616165841', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'ARRONE® 五金,HOPPE 好博快装技术升级版', '2020-10-29 12:31:16'),
	(50, 'o1qmn5Aob8RiD8MkBcbdGPHK6iD4', 1, '彦宇门窗', '顾颜来', NULL, NULL, NULL, '哈尔滨市', '中国', NULL, '17745688866', '17745688866', '门、窗制造商', NULL, '室内门把手目录,HOPPE 好博官方微信', NULL, NULL, '2020-10-29 13:32:57'),
	(51, 'o1qmn5IuvM-_TI3FD9FExTPIDL8U', 1, '明瑞丰商行', '杜晶', NULL, NULL, NULL, '大连开发区保税区家居广场后院德威克门窗系统', '中国', NULL, '13614287954', '1300480496', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, NULL, '2020-10-29 13:33:13'),
	(52, 'o1qmn5MD5QBw8A6g1lMmFPbvlam4', 1, '千和系统门窗有限公司', '孟令怡', NULL, NULL, NULL, '沈阳市浑南区白塔堡', '中国', NULL, '18309883522', '747569801@qq.com', '批发/零售商,门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, NULL, '2020-10-29 13:33:37'),
	(54, 'o1qmn5OvQzuPR6Dc06VobDGWqcG0', 1, '山东万氏禾建材科技有限公司', '万纯豹', NULL, NULL, NULL, '山东济南', '中国', '50', '15154168687', '48969543@qq.com', '装修公司', NULL, NULL, NULL, NULL, '2020-10-29 13:34:17'),
	(55, 'o1qmn5ByHH1FOD9mLLMmVNG_cpxQ', 1, '怡悦京城', '邱明涛', NULL, NULL, NULL, '河北省廊坊市大城县', '中国', '25', '18201300601', '11633935@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-29 13:34:35'),
	(56, 'o1qmn5GNbfUSwLIf_DqZSZOuAfwk', 1, '山东同金建筑科技有限公司', '殷家利', NULL, NULL, NULL, '山东省济南市高新区港兴三路北端1号楼', '中国', NULL, '15553116159', '88262096@qq.com', '装修公司', NULL, NULL, NULL, NULL, '2020-10-29 13:34:56'),
	(57, 'o1qmn5NUrrwstXOl3bohdghLRKc0', 1, '北京金鑫远航商贸有限公司', '安宝聚', NULL, NULL, NULL, '北京市朝阳区十八里店', '北京市', NULL, '18201058798', '869544281', '装修公司', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页', NULL, NULL, '2020-10-29 14:12:11'),
	(58, 'o1qmn5LgmdTufIyASqlKbyaZu79A', 1, '望美门窗', '李丽', NULL, NULL, NULL, '河北邢台市', '中国', NULL, '19912062276', 'pinpaibu@wmsyit.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-29 14:30:29'),
	(59, 'o1qmn5FoBbmD9TZfEYpZjHjleaR8', 1, '中兆海山建筑装饰工程有限公司', '张金龙', NULL, NULL, NULL, '北京市通州区张家湾开发区', '中国', '130', '18911199782', '782748539@qq.com', '装修公司', NULL, '新产品彩页,窗和型材门把手目录', NULL, NULL, '2020-10-29 14:34:32'),
	(60, 'o1qmn5Pp9N32eBHJsUtLmABuIhXU', 1, '北京富恒兴达装饰工程有限公司', '夏圣林', NULL, NULL, NULL, '北京市大兴区黄村镇孙村', '中国', NULL, '13381036788', '598097549@qq.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, 'ARRONE® 五金', '2020-10-29 14:42:10'),
	(61, 'o1qmn5Fiwgw-mhr6UoC8VYGZ-AqU', 1, '晟德斯门窗', '牟明金', NULL, NULL, NULL, '北京顺义', '中国', NULL, '15811456828', '1299826064.com', '门、窗制造商', NULL, '室内门把手目录', NULL, NULL, '2020-10-29 14:45:32'),
	(63, 'o1qmn5HPlqY5ONxqR6bCIn_GmhZE', 1, '济南三塑门窗有限公司', '顾璐璐', NULL, NULL, NULL, '济南市历下区历山路97号', '中国', '60', '13969132911', '13969132911@126.com', '门、窗制造商', NULL, '窗和型材门把手目录,室内门把手目录,新产品彩页', NULL, 'SecuForte®,HOPPE eHandle,Resista® 10年质保新色彩系列,SecuSan® 抗菌、抑菌把手,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手,HOPPE 好博快装技术升级版,HCS®,Mini-Rosette 无底座门把手,ARRONE® 五金', '2020-10-29 15:05:21'),
	(64, 'o1qmn5AbjjOh8OMW920tvBTUAVkI', 1, '个体装修', '刘本平', NULL, NULL, NULL, '东莞', '中国', NULL, '13620059914', '335743178@qq.com', '装修公司', NULL, '室内门把手目录,窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-29 15:07:50'),
	(65, 'o1qmn5AsmhKAz1VM7pUTQUwZ2_JU', 1, '安阳建工', '管永伟', NULL, NULL, NULL, '河南安阳', '中国', '200人', '15518878637', '15518878637', '门、窗制造商', NULL, NULL, NULL, 'SecuForte®', '2020-10-29 15:16:05'),
	(66, 'o1qmn5BS7o8Wa0aT3DeWHlRTfYJY', 1, '泊朗威门窗', '王荣', NULL, NULL, NULL, '大连', '中国', NULL, '13478716115', '807064482@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'Resista® 10年质保新色彩系列', '2020-10-29 16:00:47'),
	(67, 'o1qmn5LjPcE0bAKWFv3w2V2thPTc', 1, '无锡市英迈达商贸有限公司', '刘亚丽', NULL, NULL, NULL, '东风型材城', '中国', '8', '13771114129', '2728557359@qq.com', '批发/零售商', NULL, '室内门把手目录', NULL, NULL, '2020-10-29 16:10:19'),
	(68, 'o1qmn5OZfINKtukSgkxvtrFB0f8c', 1, '天元门窗', '魏长华', NULL, NULL, NULL, '山东临沂', '中国', '100', '13455962557', '742991882@qq.com', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-10-29 16:21:05'),
	(69, 'o1qmn5Dqu7XZr5br-FIk5lyN04z8', 1, '邦维斯', '高', NULL, NULL, NULL, '18706328558', '中国', NULL, '18706328558', '358822356@qq.com', '门、窗制造商', NULL, '新产品彩页,窗和型材门把手目录', NULL, 'Resista® 10年质保新色彩系列', '2020-10-30 09:18:14'),
	(70, 'o1qmn5OACgG2p3qiS_R-ka7ekhko', 1, '西安皇家金雨工程材料有限公司', '闫思敏', NULL, NULL, NULL, '陕西省西安市高新区80号1号楼1单元902', '中国', NULL, '15009204444', '306418874@qq.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页,2019-2020 中国采购指南', NULL, 'SecuForte®,HOPPE eHandle,Resista® 10年质保新色彩系列,SecuSan® 抗菌、抑菌把手,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手,HOPPE 好博快装技术升级版,Mini-Rosette 无底座门把手,HCS®,ARRONE® 五金', '2020-10-30 10:03:52'),
	(71, 'o1qmn5CjGjcHUm5MjT7h71xuDxBs', 1, '东莞智睿装饰材料有限公司', '刘生', NULL, NULL, NULL, '东莞市塘厦镇石潭布社区116号', '中国', '20', '13686421564', 'Liangzh29@163.com', '装修公司', NULL, '室内门把手目录', NULL, 'HOPPE 好博快装技术升级版', '2020-10-30 10:04:08'),
	(72, 'o1qmn5CoJqvCPZ-8iUDQgcKqgyG4', 1, '帕斯沃门窗', '丁', NULL, NULL, NULL, '临朐中欧门窗产业园', '中国', NULL, '15264445072', '57231717@qq.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, NULL, '2020-10-30 10:14:13'),
	(73, 'o1qmn5Krn4m7Qs2L-0aaM5-xvBIM', 1, '广东新河铝材', '李紫薇', NULL, NULL, NULL, '河北省邢台市桥东区国际新城', '中国', NULL, '15130978553', '1761681987', '建筑师', NULL, '室内门把手目录', NULL, 'SecuForte®', '2020-10-30 10:16:40'),
	(74, 'o1qmn5BKaCPvVP8WsVbVozbDNcok', 1, '黄梅香', '黄梅香', NULL, NULL, NULL, '门头沟', '中国', NULL, '13241531627', '23654885211@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'ARRONE® 五金', '2020-10-30 10:56:07'),
	(75, 'o1qmn5FTPNzC8ZBKH7INcNrF81S4', 1, '戴氏建材门窗有限公司', '戴逢梅', NULL, NULL, NULL, '山东济南', '中国', NULL, '13220599085', '291687361', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'Resista® 10年质保新色彩系列,Mini-Rosette 无底座门把手', '2020-10-30 11:58:11'),
	(76, 'o1qmn5EPhCmChF5BWnoH8d9nOgEU', 1, '威海高技术产业开发区实德节能门窗展销厅', '商丽侠', NULL, NULL, NULL, '山东威海高区文化西路155-12', '中国', '35', '13255648588', '772145443@qq.com', '门、窗制造商,批发/零售商', NULL, '窗和型材门把手目录,室内门把手目录', NULL, 'Resista® 10年质保新色彩系列,SecuSan® 抗菌、抑菌把手,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手,Mini-Rosette 无底座门把手', '2020-10-30 12:17:16'),
	(77, 'o1qmn5DIk3eP67kT__hr7WjzlCj8', 1, '北京煜麒装饰有限公司', '王岳鑫', NULL, NULL, NULL, '北京昌平', '中国', NULL, '13811979986', '834363719', '装修公司', NULL, '室内门把手目录,窗和型材门把手目录', NULL, NULL, '2020-10-30 12:34:28'),
	(78, 'o1qmn5GH6j4q_dOk0DNiCfc1LSD4', 1, '森亚飞系统门窗', '杨帆', NULL, NULL, NULL, '唐山市路北区红星美凯龙', '中国', '15', '18531428345', '184108853@qq.com', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-10-30 12:35:36'),
	(79, 'o1qmn5GQzVgtOByzf-VCrk1MdNd0', 1, '济南经阁门窗有限公司', '张培', NULL, NULL, NULL, '济南市槐荫区', '中国', NULL, '13256039555', 'zp7911@126.com', '门、窗制造商', NULL, '窗和型材门把手目录,HOPPE 好博官方微信', NULL, NULL, '2020-10-30 12:39:49'),
	(80, 'o1qmn5GCKJknnBRkb8nWfyySnEHE', 1, '河北', '肖东', NULL, NULL, NULL, '唐山', '中国', NULL, '18931521169', 'xsxdn@163.com', '门、窗制造商,开发商', NULL, NULL, NULL, '带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手', '2020-10-30 12:45:40'),
	(81, 'o1qmn5NrY7lj_LoPAod5ZCLESoHA', 1, '大庆永尚明门窗', '刘长永', NULL, NULL, NULL, '黑龙江大庆', '中房', NULL, '15845849111', '815811685@qq.com', '门、窗制造商', NULL, '室内门把手目录', NULL, NULL, '2020-10-30 13:03:44'),
	(82, 'o1qmn5GRNYuaE4wxV5dMpNU4eDuU', 1, '骏木门窗', '李敏', NULL, NULL, NULL, '天津市红桥区红星美凯龙', '中国', NULL, '18622302571', '58821558863@qq.com', '批发/零售商', NULL, '窗和型材门把手目录', NULL, NULL, '2020-10-30 13:24:06'),
	(86, 'o1qmn5MB2PF75jOSXV8zdXtVPvXw', 1, '北京意德鑫业', '赵志军', NULL, NULL, NULL, '顺义', '中国', NULL, '13488683380', '13488683380@139.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, 'SecuSan® 抗菌、抑菌把手,ARRONE® 五金', '2020-10-30 13:29:44'),
	(87, 'o1qmn5G_SNXFh0E3y_Gi3rQUSlN8', 1, '吉瑟门窗', '田晓东', NULL, NULL, NULL, '沈阳市', '中国', NULL, '15142076596', '774254560@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'Mini-Rosette 无底座门把手', '2020-10-30 13:33:57'),
	(88, 'o1qmn5A7ht4QLO1aFIgARef1rGls', 1, '北京西飞博雅装饰工程有限公司', '李鹏', NULL, NULL, NULL, '北京市大兴区', '中国', '99', '15833209231', '927832050@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-30 13:36:14'),
	(89, 'o1qmn5MeJ2o7IO0uyXMTNOpGSxWM', 1, '郑州蓝田经贸有限公司', '李言庆', NULL, NULL, NULL, '郑州', '中国', '200', '19937602810', '3280555632', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-10-30 14:11:02'),
	(91, 'o1qmn5EMXmJ5p9PP9KtSNPSEhaDk', 1, '金艺门窗', '高波', NULL, NULL, NULL, '山西大同', '中国', NULL, '18234218666', '1399205140', '门、窗制造商', NULL, NULL, NULL, 'ARRONE® 五金', '2020-10-30 14:21:16'),
	(92, 'o1qmn5PnjBa8zReZEdscaessy-nY', 1, '大同名邦', '贾文东', NULL, NULL, NULL, '山西省大同市', '中国', NULL, '13935289941', '2560189964@qq.com', '装修公司,门、窗制造商,批发/零售商', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页,2019-2020 中国采购指南,HOPPE 好博官方微信', NULL, 'SecuForte®,Resista® 10年质保新色彩系列,SecuSan® 抗菌、抑菌把手,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手,HOPPE 好博快装技术升级版,ARRONE® 五金,Mini-Rosette 无底座门把手', '2020-10-30 14:27:06'),
	(94, 'o1qmn5JxYvTJQD-KZJjzXiUFjL-4', 1, '望美集团', '王超杰', NULL, NULL, NULL, '河北省邢台市', '中国', '500', '19912062276', '583615907@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuSan® 抗菌、抑菌把手', '2020-10-30 14:49:36'),
	(95, 'o1qmn5Mjy0naQJZDbiKHMW0l2qEw', 1, '大连金弘鑫商贸有限公司', '张弘强', NULL, NULL, NULL, '大连市金州区', '中国', NULL, '15042466775', '314377891@qq.com', '门、窗制造商,批发/零售商', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页', NULL, NULL, '2020-10-30 15:27:05'),
	(97, 'o1qmn5MjOth4p3yLyoYOpf2gEO8w', 1, '兴源白钢门窗', '史明飞', NULL, NULL, NULL, '辽宁省凌源市北街天意广场', '中国', '5', '15842106786', '21289215@qq.com', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-10-30 15:35:03'),
	(98, 'o1qmn5MezYkXvjZst--qn9ZmUgUI', 1, '包头市金达成门窗厂', '赵清云', NULL, NULL, NULL, '内蒙古包头', '中国', '20', '18647210950', '820178709', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页,HOPPE 好博官方微信', NULL, NULL, '2020-10-30 16:33:50'),
	(99, 'o1qmn5B3DD0Lx8foV2PcZtXWsZqY', 1, '山东高格铝塑门窗有限公司', '刘进', NULL, NULL, NULL, '山东省济南市历下区解放路街道', '中国', NULL, '18888337389', '642499494@qq.com', '批发/零售商', NULL, '窗和型材门把手目录', NULL, NULL, '2020-10-30 17:21:36'),
	(100, 'o1qmn5HioNkkaht3btg4oxFsH1Ks', 1, '铸诚集团', '张明', NULL, NULL, NULL, '吉林省长春市', '中国', NULL, '13844980077', '1198407581@qq.com', '门、窗制造商,建筑师', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页,2019-2020 中国采购指南', NULL, 'Resista® 10年质保新色彩系列', '2020-10-31 09:30:18'),
	(101, 'o1qmn5MwyictJTka2Fh3o2BeUen8', 1, '晋中聚隆建安装饰有限公司', '郝智强', NULL, NULL, NULL, '山西省晋中市榆次区', '中国', '10', '13381201915', 'haozq1988@126.com', '门、窗制造商', NULL, '窗和型材门把手目录,室内门把手目录', NULL, NULL, '2020-10-31 09:38:52'),
	(102, 'o1qmn5CM9t-z-ojwf3WXkUJWCW1k', 1, '山西凯德世家房地产开发有限公司', '张大军', NULL, NULL, NULL, '大同市向阳西街98号', '中国', '3', '13994468714', '48611733@qq.com', '门、窗制造商,开发商', NULL, '室内门把手目录', NULL, NULL, '2020-10-31 09:57:09'),
	(104, 'o1qmn5Btso34hl9aEcwQNV4T8_Jk', 1, '包头市建鑫门窗有限公司', '张彪', NULL, NULL, NULL, '包头市青山区', '中国', NULL, '13384868500', '546407736@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'ARRONE® 五金', '2020-10-31 10:00:21'),
	(105, 'o1qmn5BgDwu87aInKwelsjcVJ5BE', 1, '秦皇岛铭晶源安全技术玻璃有限公司', '胡睿', NULL, NULL, NULL, '海港经济开发区', '中国', NULL, '13363356111', '709059955@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-31 10:07:50'),
	(106, 'o1qmn5IAlWKzbcmdQPiVaj9nEGzI', 1, '营口祥宝新型门窗有限公司', '李红君', NULL, NULL, NULL, '辽宁营口鲅鱼圈台州工业园', '中国', '12', '13841752678', '13841752678@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®', '2020-10-31 10:15:44'),
	(107, 'o1qmn5NMiWhIIGFFpJxD2sIs9ROI', 1, '辽宁中海门窗有限公司', '张韬', NULL, NULL, NULL, '沈阳市浑南区祝家镇沙河子村', '中国', '200', '13840277766', '172488144@qq.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, 'Resista® 10年质保新色彩系列', '2020-10-31 10:55:11'),
	(108, 'o1qmn5BUI7SLehbTjEm_aZP-J6Vg', 1, '烟台伯爵铝木门窗有限公司', '栾福歆', NULL, NULL, NULL, '山东省龙口市', '中国', '30', '15606457888', '1539136161', '门、窗制造商,批发/零售商', NULL, '窗和型材门把手目录', NULL, NULL, '2020-10-31 10:56:17'),
	(109, 'o1qmn5JjBwpaONd5YWoTZOvmtK8w', 1, '辽宁中海门窗有限公司', '阚显锋', NULL, NULL, NULL, '辽宁省沈阳市浑南新区祝家镇沙河子村', '中国', '100', '13897979714', '1078836956@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'Mini-Rosette 无底座门把手', '2020-10-31 10:57:13'),
	(110, 'o1qmn5GQqSstdjHhh7jLxPHksUzY', 1, '固立坚五金有限公司', '戴广', NULL, NULL, NULL, '温州市鹿城区南浦路', '中国', NULL, '13967709365', '3092099876@qq.com', '批发/零售商', NULL, '新产品彩页,室内门把手目录', NULL, 'Resista® 10年质保新色彩系列', '2020-10-31 10:57:57'),
	(111, 'o1qmn5BTd6Klhe_cwyKy5O2TzY7Q', 1, '郑州市盛皇智能门窗有限公司', '张建立', NULL, NULL, NULL, '新郑市集萃物流园区', '中国', '57', '13503822360', '1074185961@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'Resista® 10年质保新色彩系列', '2020-10-31 11:01:37'),
	(112, 'o1qmn5NoEntKDLwM4Ncs2yGVNhCc', 1, '天津市丰立银锚工程有限公司', '王琨', NULL, NULL, NULL, '西青区乘运道20号', '中国', NULL, '15222351350', '806449371@qq.com', '装修公司,建筑师,门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页,2019-2020 中国采购指南,HOPPE 好博官方微信', NULL, NULL, '2020-10-31 11:01:57'),
	(113, 'o1qmn5DpCqc5Cj7n7SktOWTehzgg', 1, '上海百明实业有限公司', '高俊杰', NULL, NULL, NULL, '上海市松江区新浜镇红牡丹路63号', '中国', '500', '15618117836', 'gaojunjie820@163.com', '门、窗制造商', NULL, '室内门把手目录,2019-2020 中国采购指南,HOPPE 好博官方微信', NULL, 'SecuSan® 抗菌、抑菌把手,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手', '2020-10-31 11:07:48'),
	(114, 'o1qmn5J4-myp3V7x7d39nyXRdXy8', 1, '南京悦诚建筑工程有限公司', '秦浩', NULL, NULL, NULL, '南京', '中国', NULL, '13814067283', '317024849@qq.com', '批发/零售商', NULL, '窗和型材门把手目录', NULL, 'SecuForte®,HOPPE eHandle', '2020-10-31 11:09:36'),
	(115, 'o1qmn5Frua8X4NOYyrQrEo9Q0nio', 1, '次阳宗锐门窗厂', '王志超', NULL, NULL, NULL, '沈阳市大车巨', '中国', NULL, '13898158848', '411', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'HOPPE eHandle', '2020-10-31 11:12:59'),
	(118, 'o1qmn5Gj6B5n_-uwNGQliFhdceKk', 1, '山西中德型材', '张晋', NULL, NULL, NULL, '长治市', '中国', '1000', '13903551395', '1983148346@qqC0m', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'SecuSan® 抗菌、抑菌把手', '2020-10-31 11:14:25'),
	(119, 'o1qmn5Jo4RRmeDN67osOI0Os-yKo', 1, '望美实业集团有限公司', '司立彬', NULL, NULL, NULL, '河北省沙河市', '中国', NULL, '15732939329', 'si_libin@163.com', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, 'SecuSan® 抗菌、抑菌把手', '2020-10-31 11:21:37'),
	(120, 'o1qmn5BAlcilXC1DbQvuEo_lr2ck', 1, '天驰美佳门窗有公司', '姜满意', NULL, NULL, NULL, '固安县，渠沟乡周家务村', '中国', '200', '13439784190', '1234', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录', NULL, NULL, '2020-10-31 11:22:09'),
	(121, 'o1qmn5J_GIjj7Nd3izHLg9Un7kis', 1, '天驰美佳门窗有限公司', '李凯迎', NULL, NULL, NULL, '固安县渠沟乡周家务村', '中国', '200', '17806010698', '12345', '门、窗制造商', NULL, '室内门把手目录,窗和型材门把手目录,新产品彩页,2019-2020 中国采购指南,HOPPE 好博官方微信', NULL, NULL, '2020-10-31 11:22:20'),
	(122, 'o1qmn5G0x-L79XAxilaNEeVGa-8o', 1, '伊博莱', '张', NULL, NULL, NULL, '天津宝坻', '中国', NULL, '15726043339', '623841195', '门、窗制造商', NULL, '室内门把手目录', NULL, 'SecuForte®', '2020-10-31 11:58:49'),
	(125, 'o1qmn5AR0NMel6LJVNi8cpPgHx_4', 1, '胖子门窗配件', '史云雷', NULL, NULL, NULL, '宋庄镇草寺村', '中国', '6', '13366415087', '515479043', '门、窗制造商', NULL, '室内门把手目录,HOPPE 好博官方微信', NULL, '带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手,Mini-Rosette 无底座门把手,ARRONE® 五金', '2020-10-31 12:00:09'),
	(126, 'o1qmn5PbhqDpIYQ9WuWWrISNunFs', 1, '铝塑门窗配件', '黄忠豪', NULL, NULL, NULL, '北京市顺义区张喜庄', '中国', '10', '13716652361', '2423238472', '批发/零售商', NULL, '窗和型材门把手目录', NULL, 'HOPPE 好博快装技术升级版', '2020-10-31 12:01:18'),
	(127, 'o1qmn5K0LZJeCWQh5kgOJAJXh_1s', 1, '亳州森鹰门窗代理', '董金体', NULL, NULL, NULL, '亿都国际商城', '中国', NULL, '18256727500', '2985155095@qq.com', '批发/零售商', NULL, '窗和型材门把手目录', NULL, 'HOPPE 好博快装技术升级版', '2020-10-31 13:11:54'),
	(128, 'o1qmn5PbI_6bbomQKWHKvkN_Vbl0', 1, '德派门窗', '马萌', NULL, NULL, NULL, '河北省保定安国市', '中国', NULL, '15100222228', '418991048@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录,HOPPE 好博官方微信', NULL, 'SecuSan® 抗菌、抑菌把手,带 Secustik® 安全底座和 VarioFit® 灵活方轴窗把手,HOPPE 好博快装技术升级版,Mini-Rosette 无底座门把手,ARRONE® 五金', '2020-10-31 14:58:19'),
	(129, 'o1qmn5MRPW3W7TJB01mQe8oPeEFY', 1, '信首科技', '王成', NULL, NULL, NULL, '13821778403', '中国', NULL, '13821778403', '12255541558@qq.com ', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-10-31 15:21:07'),
	(130, 'o1qmn5OZdx637lxa2qEbV2w-C_8E', 1, '德州皓安门窗有限公司', '安清德', NULL, NULL, NULL, '乐陵市市中工业园', '中国', NULL, '17753436977', '445@qq.com', '门、窗制造商', NULL, NULL, NULL, NULL, '2020-11-01 11:05:47'),
	(131, 'o1qmn5IoLHZNno-3Uj7-h_ZG5XaY', 1, '美驰门窗', '王栋梁', NULL, NULL, NULL, '北京', '中国', NULL, '13381078112', '309615911@qq.com', '门、窗制造商', NULL, '窗和型材门把手目录', NULL, 'Resista® 10年质保新色彩系列', '2020-11-01 11:16:11');
/*!40000 ALTER TABLE `registration_form` ENABLE KEYS */;

-- 导出  表 hoppe.role 结构
CREATE TABLE IF NOT EXISTS `role` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

-- 正在导出表  hoppe.role 的数据：~5 rows (大约)
/*!40000 ALTER TABLE `role` DISABLE KEYS */;
REPLACE INTO `role` (`id`, `name`) VALUES
	(1, '案列'),
	(2, '管理员'),
	(3, '3'),
	(4, '4'),
	(5, '5');
/*!40000 ALTER TABLE `role` ENABLE KEYS */;

-- 导出  表 hoppe.search_product_log 结构
CREATE TABLE IF NOT EXISTS `search_product_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `token` varchar(50) DEFAULT NULL COMMENT '搜索人token',
  `uid` int(11) DEFAULT NULL COMMENT '搜索人token对应的id',
  `keyword` varchar(50) DEFAULT NULL COMMENT '搜索内容',
  `result` int(11) DEFAULT NULL COMMENT '是否有结果',
  `create_time` datetime DEFAULT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2501 DEFAULT CHARSET=utf8mb4 COMMENT='产品搜索日志';

-- 正在导出表  hoppe.search_product_log 的数据：~2,269 rows (大约)
/*!40000 ALTER TABLE `search_product_log` DISABLE KEYS */;
REPLACE INTO `search_product_log` (`id`, `token`, `uid`, `keyword`, `result`, `create_time`) VALUES
	(232, NULL, 27, 'Amsterdam', 12, '2020-10-26 16:30:13'),
	(233, NULL, 30, 'Amsterdam', 12, '2020-10-26 17:15:37'),
	(234, NULL, 64, 'M0515', 1, '2020-10-26 20:04:29'),
	(235, NULL, 80, '0751', 2, '2020-10-26 20:25:01'),
	(236, NULL, 80, '099', 0, '2020-10-26 20:26:21'),
	(237, NULL, 85, '0515', 5, '2020-10-26 20:37:52'),
	(238, NULL, 95, '0510', 0, '2020-10-26 20:53:19'),
	(239, NULL, 119, '门把手', 78, '2020-10-27 08:00:25'),
	(240, NULL, 119, 'Amsterdam', 12, '2020-10-27 08:01:05'),
	(241, NULL, 119, '门把手', 78, '2020-10-27 11:13:08'),
	(242, NULL, 119, '门把手', 78, '2020-10-27 11:13:14'),
	(243, NULL, 119, '门把手', 78, '2020-10-27 11:13:18'),
	(244, NULL, 119, 'Amsterdam', 12, '2020-10-27 11:13:20'),
	(245, NULL, 119, '门把手', 78, '2020-10-27 11:13:24'),
	(246, NULL, 119, 'Amsterdam', 12, '2020-10-27 11:13:26'),
	(247, NULL, 64, 'M0515', 1, '2020-10-27 11:13:27'),
	(248, NULL, 64, 'M0515', 1, '2020-10-27 11:13:29'),
	(249, NULL, 119, 'Amsterdam', 12, '2020-10-27 11:13:30'),
	(250, NULL, 95, '0510', 0, '2020-10-27 11:13:31'),
	(251, NULL, 95, '0510', 0, '2020-10-27 11:13:33'),
	(252, NULL, 119, 'Amsterdam', 12, '2020-10-27 11:13:34'),
	(253, NULL, 85, '0515', 5, '2020-10-27 11:13:34'),
	(254, NULL, 85, '0515', 5, '2020-10-27 11:13:36'),
	(255, NULL, 64, 'M0515', 1, '2020-10-27 11:13:36'),
	(256, NULL, 80, '0751', 2, '2020-10-27 11:13:38'),
	(257, NULL, 64, 'M0515', 1, '2020-10-27 11:13:38'),
	(258, NULL, 80, '0751', 2, '2020-10-27 11:13:39'),
	(259, NULL, 95, '0510', 0, '2020-10-27 11:13:41'),
	(260, NULL, 80, '099', 0, '2020-10-27 11:13:41'),
	(261, NULL, 80, '099', 0, '2020-10-27 11:13:43'),
	(262, NULL, 95, '0510', 0, '2020-10-27 11:13:43'),
	(263, NULL, 85, '0515', 5, '2020-10-27 11:13:46'),
	(264, NULL, 85, '0515', 5, '2020-10-27 11:13:48'),
	(265, NULL, 80, '0751', 2, '2020-10-27 11:13:50'),
	(266, NULL, 80, '0751', 2, '2020-10-27 11:13:53'),
	(267, NULL, 80, '099', 0, '2020-10-27 11:13:55'),
	(268, NULL, 80, '099', 0, '2020-10-27 11:13:58'),
	(269, NULL, 64, 'M0515', 1, '2020-10-27 11:18:53'),
	(270, NULL, 64, 'M0515', 1, '2020-10-27 11:18:56'),
	(271, NULL, 64, 'undefined', 0, '2020-10-27 11:18:59'),
	(272, NULL, 15, 'M0515', 1, '2020-10-27 11:19:01'),
	(273, NULL, 119, 'Amsterdam', 12, '2020-10-27 11:20:31'),
	(274, NULL, 119, 'Amsterdam', 12, '2020-10-27 11:20:37'),
	(275, NULL, 119, 'undefined', 0, '2020-10-27 11:20:39'),
	(276, NULL, 15, 'Amsterdam', 12, '2020-10-27 11:20:42'),
	(277, NULL, 80, '0751', 2, '2020-10-27 11:23:33'),
	(278, NULL, 80, '0751', 2, '2020-10-27 11:23:36'),
	(279, NULL, 80, 'undefined', 0, '2020-10-27 11:23:38'),
	(280, NULL, 15, '0751', 2, '2020-10-27 11:23:40'),
	(281, NULL, 85, '0515', 5, '2020-10-27 11:25:19'),
	(282, NULL, 85, '0515', 5, '2020-10-27 11:25:21'),
	(283, NULL, 85, 'undefined', 0, '2020-10-27 11:25:24'),
	(284, NULL, 15, '0515', 5, '2020-10-27 11:25:26'),
	(285, NULL, 119, '门把手', 78, '2020-10-27 11:28:26'),
	(286, NULL, 119, '门把手', 78, '2020-10-27 11:28:33'),
	(287, NULL, 15, '门把手', 78, '2020-10-27 11:28:39'),
	(288, NULL, 119, 'undefined', 0, '2020-10-27 11:28:45'),
	(289, NULL, 80, '099', 0, '2020-10-27 11:29:55'),
	(290, NULL, 80, '099', 0, '2020-10-27 11:29:58'),
	(291, NULL, 80, 'undefined', 0, '2020-10-27 11:30:00'),
	(292, NULL, 15, '099', 0, '2020-10-27 11:30:03'),
	(293, NULL, 95, '0510', 0, '2020-10-27 11:30:15'),
	(294, NULL, 95, '0510', 0, '2020-10-27 11:30:17'),
	(295, NULL, 95, 'undefined', 0, '2020-10-27 11:30:20'),
	(296, NULL, 15, '0510', 0, '2020-10-27 11:30:22'),
	(297, NULL, 146, 'Amsterdam', 12, '2020-10-27 14:09:26'),
	(298, NULL, 145, 'Amsterdam', 12, '2020-10-27 16:10:33'),
	(299, NULL, 179, '窗把手', 32, '2020-10-27 17:23:55'),
	(300, NULL, 129, '0530', 0, '2020-10-27 18:24:34'),
	(301, NULL, 129, '952', 4, '2020-10-27 18:24:53'),
	(302, NULL, 129, '0530', 0, '2020-10-27 18:26:10'),
	(303, NULL, 129, '05', 9, '2020-10-27 18:26:25'),
	(304, NULL, 193, '0558/', 2, '2020-10-27 18:51:51'),
	(305, NULL, 14, 'f4', 0, '2020-10-27 18:52:23'),
	(306, NULL, 207, 'Amsterdam', 12, '2020-10-27 23:52:50'),
	(307, NULL, 207, '门把手', 78, '2020-10-27 23:53:00'),
	(308, NULL, 207, '锁芯', 2, '2020-10-27 23:53:10'),
	(309, NULL, 261, 'Amsterdam', 12, '2020-10-28 07:55:34'),
	(310, NULL, 261, '门把手', 78, '2020-10-28 07:55:44'),
	(311, NULL, 261, '锁芯', 2, '2020-10-28 07:55:55'),
	(312, NULL, 307, 'Amsterdam', 12, '2020-10-29 09:14:41'),
	(313, NULL, 307, '门把手', 78, '2020-10-29 09:14:51'),
	(314, NULL, 307, '锁芯', 2, '2020-10-29 09:15:01'),
	(315, NULL, 351, '0530', 0, '2020-10-29 10:34:42'),
	(316, NULL, 351, '0530/US952', 0, '2020-10-29 10:34:53'),
	(317, NULL, 351, '0530/US952', 0, '2020-10-29 10:35:02'),
	(318, NULL, 351, '0751', 2, '2020-10-29 10:35:29'),
	(319, NULL, 351, '0530/US952', 0, '2020-10-29 10:35:37'),
	(320, NULL, 350, '0515-1', 2, '2020-10-29 10:36:08'),
	(321, NULL, 350, '0738', 0, '2020-10-29 10:37:12'),
	(322, NULL, 304, '0515', 5, '2020-10-29 11:22:29'),
	(323, NULL, 304, 'M846S', 1, '2020-10-29 11:23:21'),
	(324, NULL, 280, '0515', 5, '2020-10-29 11:25:14'),
	(325, NULL, 340, '纱窗', 0, '2020-10-29 11:25:39'),
	(326, NULL, 280, 'M846s', 1, '2020-10-29 11:37:58'),
	(327, NULL, 435, '抗菌', 0, '2020-10-29 11:54:46'),
	(328, NULL, 449, '0700', 3, '2020-10-29 12:16:53'),
	(329, NULL, 452, '提升', 12, '2020-10-29 12:20:08'),
	(330, NULL, 464, '0515', 5, '2020-10-29 12:31:08'),
	(331, NULL, 304, '0739', 2, '2020-10-29 12:36:40'),
	(332, NULL, 495, '0558', 2, '2020-10-29 13:02:24'),
	(333, NULL, 280, '0515', 5, '2020-10-29 13:15:13'),
	(334, NULL, 512, '0515', 5, '2020-10-29 13:17:27'),
	(335, NULL, 552, '锁芯', 2, '2020-10-29 14:07:17'),
	(336, NULL, 304, '099kh', 0, '2020-10-29 14:25:33'),
	(337, NULL, 304, '099', 0, '2020-10-29 14:25:41'),
	(338, NULL, 80, '0700', 3, '2020-10-29 14:31:38'),
	(339, NULL, 586, '0515', 5, '2020-10-29 14:45:19'),
	(340, NULL, 673, '11719151', 0, '2020-10-29 17:21:32'),
	(341, NULL, 673, '099k', 0, '2020-10-29 17:21:58'),
	(342, NULL, 724, '门把手', 78, '2020-10-30 09:54:19'),
	(343, NULL, 723, 'm0642', 5, '2020-10-30 09:54:35'),
	(344, NULL, 724, 'US956', 9, '2020-10-30 09:55:37'),
	(345, NULL, 17, '0710', 1, '2020-10-30 10:03:42'),
	(346, NULL, 740, '0737', 5, '2020-10-30 10:15:29'),
	(347, NULL, 80, '0558', 2, '2020-10-30 10:55:33'),
	(348, NULL, 280, 'M056', 1, '2020-10-30 11:06:29'),
	(349, NULL, 1040, '0737', 5, '2020-10-30 15:46:52'),
	(350, NULL, 1054, '0515', 5, '2020-10-30 16:13:21'),
	(351, NULL, 1078, 'Amsterdam', 12, '2020-10-30 20:53:06'),
	(352, NULL, 1078, '门把手', 78, '2020-10-30 20:53:15'),
	(353, NULL, 1078, '锁芯', 2, '2020-10-30 20:53:24'),
	(354, NULL, 304, '0739', 2, '2020-10-31 00:00:26'),
	(355, NULL, 512, '0558', 2, '2020-10-31 06:21:47'),
	(356, NULL, 17, '0737', 5, '2020-10-31 09:28:16'),
	(357, NULL, 1108, '0515', 5, '2020-10-31 10:03:38'),
	(358, NULL, 1109, '0515', 5, '2020-10-31 10:04:13'),
	(359, NULL, 1111, '0515', 5, '2020-10-31 10:07:59'),
	(360, NULL, 1113, '0515', 5, '2020-10-31 10:14:42'),
	(361, NULL, 60, '0700', 3, '2020-10-31 10:40:41'),
	(362, NULL, 1145, '门把手', 78, '2020-10-31 11:10:43'),
	(363, NULL, 1145, 'Secusan', 0, '2020-10-31 11:14:01'),
	(364, NULL, 60, '0715', 2, '2020-10-31 11:30:29'),
	(365, NULL, 60, '0530', 0, '2020-10-31 11:31:52'),
	(366, NULL, 702, '86G', 0, '2020-10-31 11:49:53'),
	(367, NULL, 80, '0700', 3, '2020-10-31 13:08:11'),
	(368, NULL, 151, '0515', 5, '2020-10-31 13:41:01'),
	(369, NULL, 1209, '0558', 2, '2020-10-31 13:48:48'),
	(370, NULL, 1111, '0515', 5, '2020-10-31 15:06:46'),
	(371, NULL, 1265, '0515', 5, '2020-10-31 16:03:24'),
	(372, NULL, 1276, 'Amsterdam', 12, '2020-10-31 18:00:29'),
	(373, NULL, 1276, '门把手', 78, '2020-10-31 18:00:38'),
	(374, NULL, 1276, '锁芯', 2, '2020-10-31 18:00:47'),
	(375, NULL, 60, '0558', 2, '2020-10-31 22:31:53'),
	(376, NULL, 1280, '0700', 3, '2020-11-01 09:09:47'),
	(377, NULL, 1287, '0710', 1, '2020-11-01 10:36:51'),
	(378, NULL, 1288, '窗把手', 32, '2020-11-01 10:37:11'),
	(379, NULL, 1287, '099', 0, '2020-11-01 10:37:14'),
	(380, NULL, 1287, '0737', 5, '2020-11-01 10:37:26'),
	(381, NULL, 289, '0515', 5, '2020-11-01 10:52:08'),
	(382, NULL, 1289, '0515', 5, '2020-11-01 10:52:15'),
	(383, NULL, 1265, '0515', 5, '2020-11-01 14:50:28'),
	(384, NULL, 1313, 'Amsterdam', 12, '2020-11-01 21:48:14'),
	(385, NULL, 1313, '门把手', 78, '2020-11-01 21:48:23'),
	(386, NULL, 1313, '锁芯', 2, '2020-11-01 21:48:32'),
	(387, NULL, 140, '1140', 4, '2020-11-01 22:28:29'),
	(388, NULL, 140, '1643', 5, '2020-11-01 22:32:57'),
	(389, NULL, 1313, 'Amsterdam', 12, '2020-11-02 01:15:54'),
	(390, NULL, 1313, '门把手', 78, '2020-11-02 01:16:04'),
	(391, NULL, 1313, '锁芯', 2, '2020-11-02 01:16:12'),
	(392, NULL, 351, '0515-1', 2, '2020-11-02 09:24:01'),
	(393, NULL, 283, '013', 0, '2020-11-02 10:07:26'),
	(394, NULL, 1239, '0737-2', 1, '2020-11-02 11:02:20'),
	(395, NULL, 1239, '0700', 3, '2020-11-02 11:03:19'),
	(396, NULL, 1239, '0808', 1, '2020-11-02 12:12:04'),
	(397, NULL, 702, '0558', 2, '2020-11-02 13:55:32'),
	(398, NULL, 280, '099KH/U26', 0, '2020-11-02 14:42:59'),
	(399, NULL, 85, '0530', 0, '2020-11-02 15:02:20'),
	(400, NULL, 85, '0515', 5, '2020-11-02 15:02:43'),
	(401, NULL, 85, '05', 9, '2020-11-02 15:02:49'),
	(402, NULL, 1336, 'Amsterdam', 12, '2020-11-02 19:55:30'),
	(403, NULL, 1336, '门把手', 78, '2020-11-02 19:55:39'),
	(404, NULL, 1336, '锁芯', 2, '2020-11-02 19:55:48'),
	(405, NULL, 280, 'M1623', 2, '2020-11-02 21:12:36'),
	(406, NULL, 280, 'M846', 1, '2020-11-02 21:13:18'),
	(407, NULL, 280, 'M845', 1, '2020-11-02 21:14:27'),
	(408, NULL, 280, 'M1623', 2, '2020-11-02 21:15:51'),
	(409, NULL, 280, 'M1642', 4, '2020-11-02 21:16:08'),
	(410, NULL, 280, 'M1643', 3, '2020-11-02 21:16:46'),
	(411, NULL, 1336, 'Amsterdam', 12, '2020-11-03 02:14:34'),
	(412, NULL, 1336, '门把手', 78, '2020-11-03 02:14:43'),
	(413, NULL, 1336, '锁芯', 2, '2020-11-03 02:14:52'),
	(414, NULL, 762, 'mal', 0, '2020-11-03 11:21:41'),
	(415, NULL, 702, '1313G', 0, '2020-11-03 11:27:40'),
	(416, NULL, 702, '13G', 0, '2020-11-03 11:27:47'),
	(417, NULL, 702, '13', 5, '2020-11-03 11:27:51'),
	(418, NULL, 1340, '0643', 7, '2020-11-03 11:38:17'),
	(419, NULL, 702, '1313G', 0, '2020-11-03 11:47:18'),
	(420, NULL, 57, '1535', 1, '2020-11-03 12:53:07'),
	(421, NULL, 1239, 'HS0530', 0, '2020-11-03 13:53:02'),
	(422, NULL, 1239, '0530', 0, '2020-11-03 13:53:09'),
	(423, NULL, 512, '0515-1', 2, '2020-11-03 13:55:45'),
	(424, NULL, 512, '0515-2', 1, '2020-11-03 13:56:01'),
	(425, NULL, 1239, '0515', 5, '2020-11-03 14:01:02'),
	(426, NULL, 1239, '1751', 2, '2020-11-03 14:01:24'),
	(427, NULL, 280, 'M1623', 2, '2020-11-03 14:02:54'),
	(428, NULL, 702, '1558', 3, '2020-11-03 14:26:38'),
	(429, NULL, 702, '0515', 5, '2020-11-03 14:33:09'),
	(430, NULL, 1317, '0715', 2, '2020-11-03 15:41:26'),
	(431, NULL, 512, '0715', 2, '2020-11-03 16:30:06'),
	(432, NULL, 1354, '指纹锁', 0, '2020-11-03 16:50:37'),
	(433, NULL, 383, '内开内倒', 0, '2020-11-03 19:56:52'),
	(434, NULL, 383, '上悬', 0, '2020-11-03 19:57:08'),
	(435, NULL, 1383, 'AH201', 0, '2020-11-04 08:40:03'),
	(436, NULL, 1383, 'AH201.17.012', 0, '2020-11-04 08:40:26'),
	(437, NULL, 15, 'undefined', 0, '2020-11-04 12:23:32'),
	(438, NULL, 15, '1400/42K/42KS', 1, '2020-11-04 12:24:12'),
	(439, NULL, 15, 'Amsterdam', 12, '2020-11-04 12:24:25'),
	(440, NULL, 15, 'hhh', 0, '2020-11-04 12:24:52'),
	(441, NULL, 15, '锁芯', 2, '2020-11-04 12:24:57'),
	(442, NULL, 15, '门把手', 78, '2020-11-04 12:25:51'),
	(443, NULL, 1319, '0715', 2, '2020-11-04 14:17:50'),
	(444, NULL, 1415, '0751', 2, '2020-11-04 14:34:27'),
	(445, NULL, 304, '0515', 5, '2020-11-04 14:35:08'),
	(446, NULL, 304, '0515', 5, '2020-11-04 14:35:51'),
	(447, NULL, 1239, '0737-2', 1, '2020-11-04 14:58:25'),
	(448, NULL, 1239, '1540', 1, '2020-11-04 16:15:50'),
	(449, NULL, 1239, '1751', 2, '2020-11-04 16:16:49'),
	(450, NULL, 1239, '0751', 2, '2020-11-04 16:52:28'),
	(451, NULL, 1239, '0737-2', 1, '2020-11-04 17:02:30'),
	(452, NULL, 1239, '0700', 3, '2020-11-04 17:02:53'),
	(453, NULL, 1239, '0558', 2, '2020-11-04 17:03:18'),
	(454, NULL, 1239, '0715', 2, '2020-11-04 17:04:22'),
	(455, NULL, 1239, '0751', 2, '2020-11-04 17:04:37'),
	(456, NULL, 27, 'Amsterdam', 12, '2020-11-05 10:50:49'),
	(457, NULL, 1319, '0737', 5, '2020-11-05 11:46:09'),
	(458, NULL, 1239, '0558', 2, '2020-11-05 11:56:35'),
	(459, NULL, 1239, '0530', 0, '2020-11-05 12:22:08'),
	(460, NULL, 1239, '053', 1, '2020-11-05 12:22:17'),
	(461, NULL, 1239, '0510', 0, '2020-11-05 14:18:42'),
	(462, NULL, 15, '锁芯', 2, '2020-11-05 14:24:06'),
	(463, NULL, 15, '门把手', 78, '2020-11-05 14:24:31'),
	(464, NULL, 15, 'undefined', 0, '2020-11-05 14:25:50'),
	(465, NULL, 15, 'undefined', 0, '2020-11-05 14:26:36'),
	(466, NULL, 15, '1400/42K/42KS', 1, '2020-11-05 14:38:14'),
	(467, NULL, 1319, '0737', 5, '2020-11-05 14:38:35'),
	(468, NULL, 15, 'Amsterdam', 12, '2020-11-05 14:40:03'),
	(469, NULL, 15, 'hhh', 0, '2020-11-05 14:40:24'),
	(470, NULL, 17, 'M1642', 4, '2020-11-05 14:56:09'),
	(471, NULL, 17, 'M0642', 5, '2020-11-05 14:56:52'),
	(472, NULL, 1239, '0710', 1, '2020-11-05 14:56:57'),
	(473, NULL, 15, '门把手', 78, '2020-11-05 14:57:23'),
	(474, NULL, 15, 'Amsterdam', 12, '2020-11-05 15:01:21'),
	(475, NULL, 1538, '外悬窗', 0, '2020-11-05 15:01:56'),
	(476, NULL, 1538, '0515', 5, '2020-11-05 15:02:27'),
	(477, NULL, 1538, '0530', 0, '2020-11-05 15:02:47'),
	(478, NULL, 15, 'hhh', 0, '2020-11-05 15:07:23'),
	(479, NULL, 15, '门把手', 78, '2020-11-06 05:26:56'),
	(480, NULL, 15, '门把手', 78, '2020-11-06 08:20:44'),
	(481, NULL, 15, '锁芯', 2, '2020-11-06 08:20:54'),
	(482, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 08:20:56'),
	(483, NULL, 15, 'Amsterdam', 12, '2020-11-06 08:20:59'),
	(484, NULL, 15, 'hhh', 0, '2020-11-06 08:21:02'),
	(485, NULL, 15, 'undefined', 0, '2020-11-06 08:21:04'),
	(486, NULL, 15, 'hhh', 0, '2020-11-06 08:22:34'),
	(487, NULL, 15, '锁芯', 2, '2020-11-06 08:23:32'),
	(488, NULL, 15, 'undefined', 0, '2020-11-06 08:23:47'),
	(489, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 08:23:57'),
	(490, NULL, 15, '门把手', 78, '2020-11-06 08:24:49'),
	(491, NULL, 15, 'Amsterdam', 12, '2020-11-06 08:25:05'),
	(492, NULL, 15, '门把手', 78, '2020-11-06 09:52:51'),
	(493, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:52:57'),
	(494, NULL, 15, '门把手', 78, '2020-11-06 09:53:01'),
	(495, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:53:02'),
	(496, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:53:04'),
	(497, NULL, 15, 'undefined', 0, '2020-11-06 09:53:07'),
	(498, NULL, 15, '门把手', 78, '2020-11-06 09:53:11'),
	(499, NULL, 15, '门把手', 78, '2020-11-06 09:53:16'),
	(500, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:53:18'),
	(501, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:53:19'),
	(502, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:53:20'),
	(503, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:53:22'),
	(504, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:53:23'),
	(505, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:53:25'),
	(506, NULL, 15, 'hhh', 0, '2020-11-06 09:53:26'),
	(507, NULL, 15, 'hhh', 0, '2020-11-06 09:53:27'),
	(508, NULL, 15, 'hhh', 0, '2020-11-06 09:53:29'),
	(509, NULL, 15, 'hhh', 0, '2020-11-06 09:53:30'),
	(510, NULL, 15, '门把手', 78, '2020-11-06 09:55:03'),
	(511, NULL, 15, '门把手', 78, '2020-11-06 09:55:14'),
	(512, NULL, 15, '门把手', 78, '2020-11-06 09:55:23'),
	(513, NULL, 15, '门把手', 78, '2020-11-06 09:55:30'),
	(514, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:55:32'),
	(515, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:55:34'),
	(516, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:55:36'),
	(517, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 09:55:38'),
	(518, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:55:40'),
	(519, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:55:43'),
	(520, NULL, 15, 'hhh', 0, '2020-11-06 09:55:45'),
	(521, NULL, 15, 'hhh', 0, '2020-11-06 09:55:47'),
	(522, NULL, 15, 'hhh', 0, '2020-11-06 09:55:49'),
	(523, NULL, 15, 'hhh', 0, '2020-11-06 09:55:51'),
	(524, NULL, 15, 'hhh', 0, '2020-11-06 09:56:20'),
	(525, NULL, 15, 'hhh', 0, '2020-11-06 09:56:22'),
	(526, NULL, 15, 'hhh', 0, '2020-11-06 09:56:24'),
	(527, NULL, 15, 'undefined', 0, '2020-11-06 09:56:26'),
	(528, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:59:37'),
	(529, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:59:42'),
	(530, NULL, 15, 'Amsterdam', 12, '2020-11-06 09:59:44'),
	(531, NULL, 15, 'undefined', 0, '2020-11-06 09:59:46'),
	(532, NULL, 15, '门把手', 78, '2020-11-06 10:08:43'),
	(533, NULL, 15, '门把手', 78, '2020-11-06 10:08:53'),
	(534, NULL, 15, '门把手', 78, '2020-11-06 10:09:03'),
	(535, NULL, 15, 'undefined', 0, '2020-11-06 10:09:09'),
	(536, NULL, 15, '门把手', 78, '2020-11-06 10:15:57'),
	(537, NULL, 15, '门把手', 78, '2020-11-06 10:16:07'),
	(538, NULL, 15, '门把手', 78, '2020-11-06 10:16:17'),
	(539, NULL, 15, 'undefined', 0, '2020-11-06 10:16:22'),
	(540, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 10:20:57'),
	(541, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 10:21:00'),
	(542, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 10:21:02'),
	(543, NULL, 15, 'undefined', 0, '2020-11-06 10:21:05'),
	(544, NULL, 15, 'hhh', 0, '2020-11-06 10:28:09'),
	(545, NULL, 15, 'hhh', 0, '2020-11-06 10:28:11'),
	(546, NULL, 15, 'hhh', 0, '2020-11-06 10:28:16'),
	(547, NULL, 15, 'undefined', 0, '2020-11-06 10:28:18'),
	(548, NULL, 423, '锁芯', 2, '2020-11-06 11:09:54'),
	(549, NULL, 1584, '0710', 1, '2020-11-06 11:14:05'),
	(550, NULL, 626, '指纹锁', 0, '2020-11-06 11:14:44'),
	(551, NULL, 1606, '拉手', 13, '2020-11-06 11:54:09'),
	(552, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 15:04:42'),
	(553, NULL, 15, '1400/42K/42KS', 1, '2020-11-06 15:04:45'),
	(554, NULL, 512, '0738', 0, '2020-11-06 16:14:22'),
	(555, NULL, 512, '0738', 0, '2020-11-06 16:14:25'),
	(556, NULL, 512, '0738', 0, '2020-11-06 16:14:33'),
	(557, NULL, 1463, '0738', 0, '2020-11-06 16:17:37'),
	(558, NULL, 1463, '0558', 2, '2020-11-06 16:17:46'),
	(559, NULL, 1681, '门把手', 78, '2020-11-06 17:02:55'),
	(560, NULL, 1681, '窗把手', 32, '2020-11-06 17:03:18'),
	(561, NULL, 512, '0710', 1, '2020-11-06 17:06:08'),
	(562, NULL, 1239, '0700', 3, '2020-11-06 20:15:50'),
	(563, NULL, 1239, '0737', 5, '2020-11-06 20:16:07'),
	(564, NULL, 1239, '0558', 2, '2020-11-06 20:16:31'),
	(565, NULL, 1239, '0710', 1, '2020-11-06 20:16:48'),
	(566, NULL, 1568, 'Amsterdam', 12, '2020-11-07 00:27:08'),
	(567, NULL, 1568, '门把手', 78, '2020-11-07 00:27:18'),
	(568, NULL, 1568, '锁芯', 2, '2020-11-07 00:27:26'),
	(569, NULL, 15, '门把手', 78, '2020-11-07 07:38:23'),
	(570, NULL, 689, 'M0550/US920', 0, '2020-11-07 08:48:53'),
	(571, NULL, 512, '11661590', 0, '2020-11-07 14:34:11'),
	(572, NULL, 512, '11661590', 0, '2020-11-07 14:34:19'),
	(573, NULL, 512, '11669250', 0, '2020-11-07 14:34:50'),
	(574, NULL, 512, '11659920', 0, '2020-11-07 14:35:12'),
	(575, NULL, 1703, '门把手', 78, '2020-11-07 16:11:38'),
	(576, NULL, 1703, '整体门把手', 0, '2020-11-07 16:11:51'),
	(577, NULL, 1703, '门把手', 78, '2020-11-07 16:11:56'),
	(578, NULL, 15, '门把手', 78, '2020-11-08 09:28:11'),
	(579, NULL, 15, '门把手', 78, '2020-11-08 09:28:14'),
	(580, NULL, 1463, '0530', 0, '2020-11-08 10:42:46'),
	(581, NULL, 1463, '0530', 0, '2020-11-08 10:43:30'),
	(582, NULL, 140, 'M1643', 3, '2020-11-08 11:30:54'),
	(583, NULL, 1239, '099', 0, '2020-11-08 12:58:03'),
	(584, NULL, 1239, '099', 0, '2020-11-08 12:58:06'),
	(585, NULL, 280, 'M845s', 1, '2020-11-08 15:31:24'),
	(586, NULL, 17, '0515', 5, '2020-11-08 19:23:24'),
	(587, NULL, 1239, '0515', 5, '2020-11-08 19:28:42'),
	(588, NULL, 1712, 'Amsterdam', 12, '2020-11-08 22:24:31'),
	(589, NULL, 1712, '门把手', 78, '2020-11-08 22:24:40'),
	(590, NULL, 1712, '锁芯', 2, '2020-11-08 22:24:51'),
	(591, NULL, 15, '门把手', 78, '2020-11-09 07:19:56'),
	(592, NULL, 15, '门把手', 78, '2020-11-09 07:21:12'),
	(593, NULL, 1320, '0515', 5, '2020-11-09 10:16:28'),
	(594, NULL, 1265, '0710', 1, '2020-11-09 11:15:48'),
	(595, NULL, 1265, '07', 22, '2020-11-09 11:15:56'),
	(596, NULL, 1265, '05', 9, '2020-11-09 11:16:13'),
	(597, NULL, 1319, '1530', 3, '2020-11-09 11:36:37'),
	(598, NULL, 1319, '1530', 3, '2020-11-09 11:36:49'),
	(599, NULL, 493, '0738', 0, '2020-11-09 11:44:34'),
	(600, NULL, 1239, '0751', 2, '2020-11-09 13:36:07'),
	(601, NULL, 1294, '0515', 5, '2020-11-09 14:00:03'),
	(602, NULL, 1294, '3820', 0, '2020-11-09 14:01:18'),
	(603, NULL, 1294, '门把手', 78, '2020-11-09 14:01:30'),
	(604, NULL, 1720, '0510', 0, '2020-11-09 15:11:12'),
	(605, NULL, 1720, '门把手', 78, '2020-11-09 15:11:16'),
	(606, NULL, 1720, '0808', 1, '2020-11-09 15:12:32'),
	(607, NULL, 1720, '0738', 0, '2020-11-09 15:13:24'),
	(608, NULL, 1239, 'M0642', 5, '2020-11-09 15:29:13'),
	(609, NULL, 1239, 'M0642', 5, '2020-11-09 15:56:28'),
	(610, NULL, 881, '0738', 0, '2020-11-09 16:00:11'),
	(611, NULL, 423, '门把手', 78, '2020-11-09 16:00:22'),
	(612, NULL, 423, '门把手', 78, '2020-11-09 16:01:06'),
	(613, NULL, 959, 'f78', 0, '2020-11-09 17:06:52'),
	(614, NULL, 959, '78-1', 0, '2020-11-09 17:07:02'),
	(615, NULL, 120, '门把手', 78, '2020-11-09 18:31:38'),
	(616, NULL, 15, '门把手', 78, '2020-11-10 06:29:56'),
	(617, NULL, 15, '门把手', 78, '2020-11-10 06:30:29'),
	(618, NULL, 15, '门把手', 78, '2020-11-10 08:22:25'),
	(619, NULL, 15, '锁芯', 2, '2020-11-10 08:22:36'),
	(620, NULL, 15, '1400/42K/42KS', 1, '2020-11-10 08:22:38'),
	(621, NULL, 15, 'Amsterdam', 12, '2020-11-10 08:22:40'),
	(622, NULL, 15, 'hhh', 0, '2020-11-10 08:22:43'),
	(623, NULL, 1758, 'Amsterdam', 12, '2020-11-10 08:47:55'),
	(624, NULL, 1758, 'Amsterdam', 12, '2020-11-10 08:50:42'),
	(625, NULL, 1758, '门把手', 78, '2020-11-10 08:50:51'),
	(626, NULL, 1758, 'Amsterdam', 12, '2020-11-10 08:57:18'),
	(627, NULL, 1758, '门把手', 78, '2020-11-10 08:57:28'),
	(628, NULL, 1758, '锁芯', 2, '2020-11-10 08:57:35'),
	(629, NULL, 15, '锁芯', 2, '2020-11-10 09:21:28'),
	(630, NULL, 15, 'Amsterdam', 12, '2020-11-10 09:21:53'),
	(631, NULL, 15, '1400/42K/42KS', 1, '2020-11-10 09:22:40'),
	(632, NULL, 15, '门把手', 78, '2020-11-10 09:23:03'),
	(633, NULL, 15, 'hhh', 0, '2020-11-10 09:23:35'),
	(634, NULL, 1251, '0515', 5, '2020-11-10 11:43:30'),
	(635, NULL, 1239, '0515', 5, '2020-11-10 11:44:45'),
	(636, NULL, 304, '0400', 5, '2020-11-10 11:54:21'),
	(637, NULL, 1239, '0737', 5, '2020-11-10 12:07:21'),
	(638, NULL, 1239, 'M0642', 5, '2020-11-10 13:18:55'),
	(639, NULL, 1251, '0738', 0, '2020-11-10 14:19:43'),
	(640, NULL, 1766, '门吸', 0, '2020-11-10 15:25:58'),
	(641, NULL, 1251, '0710', 1, '2020-11-10 16:46:58'),
	(642, NULL, 1239, '0737-2', 1, '2020-11-10 19:20:44'),
	(643, NULL, 1773, '上悬铰', 0, '2020-11-10 23:58:59'),
	(644, NULL, 15, '门把手', 78, '2020-11-11 04:22:30'),
	(645, NULL, 15, '门把手', 78, '2020-11-11 04:25:19'),
	(646, NULL, 1788, '1808', 1, '2020-11-11 11:17:04'),
	(647, NULL, 139, '1515', 2, '2020-11-11 11:17:11'),
	(648, NULL, 1790, '1808', 1, '2020-11-11 11:17:22'),
	(649, NULL, 1787, '1808', 1, '2020-11-11 11:17:26'),
	(650, NULL, 1789, '1515', 2, '2020-11-11 11:17:30'),
	(651, NULL, 1788, 'F4', 0, '2020-11-11 11:17:50'),
	(652, NULL, 1789, '合页', 4, '2020-11-11 11:20:10'),
	(653, NULL, 304, '0530', 0, '2020-11-11 11:24:42'),
	(654, NULL, 304, '0810', 1, '2020-11-11 11:25:10'),
	(655, NULL, 1319, 'm0515', 1, '2020-11-11 14:00:20'),
	(656, NULL, 304, '0515', 5, '2020-11-11 14:59:25'),
	(657, NULL, 85, '013', 0, '2020-11-11 16:16:34'),
	(658, NULL, 15, '门把手', 78, '2020-11-12 04:15:31'),
	(659, NULL, 15, '门把手', 78, '2020-11-12 04:16:04'),
	(660, NULL, 15, '门把手', 78, '2020-11-12 04:17:40'),
	(661, NULL, 289, '1400/42K/42KS', 1, '2020-11-12 09:52:50'),
	(662, NULL, 1803, '140', 12, '2020-11-12 09:53:04'),
	(663, NULL, 1804, '1558', 3, '2020-11-12 09:53:29'),
	(664, NULL, 1280, '0515', 5, '2020-11-12 10:15:01'),
	(665, NULL, 1805, '1400/42K/42KS', 1, '2020-11-12 10:26:24'),
	(666, NULL, 1805, '1400', 6, '2020-11-12 10:26:39'),
	(667, NULL, 1213, '0515', 5, '2020-11-12 10:49:43'),
	(668, NULL, 1213, '门把手', 78, '2020-11-12 10:50:26'),
	(669, NULL, 1213, '锁芯', 2, '2020-11-12 10:51:08'),
	(670, NULL, 1213, '1400/42K/42KS', 1, '2020-11-12 10:51:15'),
	(671, NULL, 1213, '0558', 2, '2020-11-12 10:51:35'),
	(672, NULL, 1239, '0558', 2, '2020-11-12 11:17:23'),
	(673, NULL, 1239, '0700', 3, '2020-11-12 11:17:40'),
	(674, NULL, 1239, '0751', 2, '2020-11-12 11:17:59'),
	(675, NULL, 1239, '0737-2', 1, '2020-11-12 11:28:40'),
	(676, NULL, 1239, '0751', 2, '2020-11-12 11:48:40'),
	(677, NULL, 1239, '0515', 5, '2020-11-12 13:41:29'),
	(678, NULL, 702, '0808', 1, '2020-11-12 15:28:08'),
	(679, NULL, 702, '0751', 2, '2020-11-12 15:38:22'),
	(680, NULL, 1119, '0700', 3, '2020-11-12 15:39:25'),
	(681, NULL, 1119, '0700', 3, '2020-11-12 15:49:22'),
	(682, NULL, 80, '1751', 2, '2020-11-12 20:01:30'),
	(683, NULL, 1822, 'Amsterdam', 12, '2020-11-13 08:26:44'),
	(684, NULL, 1822, '1400/42K/42KS', 1, '2020-11-13 08:26:52'),
	(685, NULL, 1822, 'hhh', 0, '2020-11-13 08:26:56'),
	(686, NULL, 80, '0530', 0, '2020-11-13 09:35:20'),
	(687, NULL, 80, '0530', 0, '2020-11-13 09:35:25'),
	(688, NULL, 80, '0530', 0, '2020-11-13 09:35:35'),
	(689, NULL, 80, '1751', 2, '2020-11-13 09:35:42'),
	(690, NULL, 80, '1530', 3, '2020-11-13 09:36:00'),
	(691, NULL, 80, '0530', 0, '2020-11-13 09:36:12'),
	(692, NULL, 289, '1400', 6, '2020-11-13 10:08:03'),
	(693, NULL, 1834, '1400/42K/42KS', 1, '2020-11-13 10:08:13'),
	(694, NULL, 1837, '1400', 6, '2020-11-13 10:08:18'),
	(695, NULL, 1836, '1400', 6, '2020-11-13 10:08:19'),
	(696, NULL, 1834, '1400', 6, '2020-11-13 10:08:28'),
	(697, NULL, 1837, '1515', 2, '2020-11-13 11:43:12'),
	(698, NULL, 1111, '1515', 2, '2020-11-13 11:43:21'),
	(699, NULL, 1111, '1515', 2, '2020-11-13 11:44:12'),
	(700, NULL, 187, '0700', 3, '2020-11-13 12:12:58'),
	(701, NULL, 1239, '1751', 2, '2020-11-13 13:20:59'),
	(702, NULL, 1239, '1540', 1, '2020-11-13 13:22:38'),
	(703, NULL, 20, 'F78-1-R', 0, '2020-11-13 13:36:13'),
	(704, NULL, 187, '0700', 3, '2020-11-13 14:06:58'),
	(705, NULL, 1319, '1751', 2, '2020-11-13 15:59:29'),
	(706, NULL, 187, '099KH', 0, '2020-11-13 17:02:42'),
	(707, NULL, 187, '099KH', 0, '2020-11-13 17:02:59'),
	(708, NULL, 512, '1751', 2, '2020-11-13 19:26:10'),
	(709, NULL, 1770, 'Hs0530-422', 0, '2020-11-14 11:20:54'),
	(710, NULL, 1239, '0530', 0, '2020-11-14 11:22:03'),
	(711, NULL, 1851, '推拉', 19, '2020-11-14 14:03:02'),
	(712, NULL, 1720, '0515', 5, '2020-11-14 22:22:55'),
	(713, NULL, 1720, '0808', 1, '2020-11-14 22:25:17'),
	(714, NULL, 1720, '0751', 2, '2020-11-14 22:25:36'),
	(715, NULL, 1720, '0510', 0, '2020-11-14 22:26:59'),
	(716, NULL, 1720, '0510', 0, '2020-11-14 22:34:41'),
	(717, NULL, 1239, '0530', 0, '2020-11-15 08:35:55'),
	(718, NULL, 1239, '0751', 2, '2020-11-15 08:36:39'),
	(719, NULL, 470, '1540', 1, '2020-11-15 09:25:32'),
	(720, NULL, 470, '1558', 3, '2020-11-15 09:25:51'),
	(721, NULL, 470, '11313', 0, '2020-11-15 09:26:09'),
	(722, NULL, 1859, '1541', 0, '2020-11-15 09:29:26'),
	(723, NULL, 1859, '1540', 1, '2020-11-15 09:29:41'),
	(724, NULL, 1766, '带锁', 0, '2020-11-15 14:28:04'),
	(725, NULL, 1681, '带钥匙', 0, '2020-11-15 15:24:42'),
	(726, NULL, 289, 'M1623', 2, '2020-11-16 10:12:40'),
	(727, NULL, 304, '50016076', 0, '2020-11-16 11:13:52'),
	(728, NULL, 470, '0737', 5, '2020-11-16 11:22:28'),
	(729, NULL, 1111, '1400/42K/42KS', 1, '2020-11-16 11:33:13'),
	(730, NULL, 1239, '0530', 0, '2020-11-16 16:35:27'),
	(731, NULL, 1879, '0710vk kh', 0, '2020-11-16 16:56:50'),
	(732, NULL, 1879, '1400/42K/42KS', 1, '2020-11-16 16:56:57'),
	(733, NULL, 1879, 'Amsterdam', 12, '2020-11-16 16:57:00'),
	(734, NULL, 1720, '0530', 0, '2020-11-16 17:04:05'),
	(735, NULL, 1689, '苏州', 0, '2020-11-16 17:51:49'),
	(736, NULL, 289, '845s', 1, '2020-11-16 17:51:51'),
	(737, NULL, 289, '845s', 1, '2020-11-16 17:54:16'),
	(738, NULL, 289, '845s', 1, '2020-11-16 17:55:07'),
	(739, NULL, 289, 'A810', 0, '2020-11-16 17:56:05'),
	(740, NULL, 512, '0558', 2, '2020-11-16 20:13:38'),
	(741, NULL, 289, '845s', 1, '2020-11-16 21:28:11'),
	(742, NULL, 289, 'AR810', 1, '2020-11-16 21:30:02'),
	(743, NULL, 289, 'M845s', 1, '2020-11-16 21:30:55'),
	(744, NULL, 289, 'AR810', 1, '2020-11-16 21:31:34'),
	(745, NULL, 289, '10782667', 0, '2020-11-16 21:33:08'),
	(746, NULL, 289, 'M1623/845', 1, '2020-11-16 21:33:38'),
	(747, NULL, 289, 'M1642', 4, '2020-11-16 21:35:28'),
	(748, NULL, 289, '845S', 1, '2020-11-16 21:38:14'),
	(749, NULL, 289, 'AR810', 1, '2020-11-16 21:41:17'),
	(750, NULL, 289, '845S', 1, '2020-11-16 21:44:54'),
	(751, NULL, 289, 'M1642/845/845S', 0, '2020-11-16 21:46:42'),
	(752, NULL, 289, 'M1642/845/846S', 0, '2020-11-16 21:46:59'),
	(753, NULL, 15, '门把手', 78, '2020-11-17 03:23:07'),
	(754, NULL, 15, '门把手', 78, '2020-11-17 03:24:12'),
	(755, NULL, 15, '门把手', 78, '2020-11-17 04:18:48'),
	(756, NULL, 187, '0530', 0, '2020-11-17 08:42:34'),
	(757, NULL, 187, '0530执手', 0, '2020-11-17 08:42:47'),
	(758, NULL, 512, 'M172', 2, '2020-11-17 08:43:44'),
	(759, NULL, 512, 'M0224', 0, '2020-11-17 08:47:23'),
	(760, NULL, 1319, '1530', 3, '2020-11-17 14:40:19'),
	(761, NULL, 1319, '1530', 3, '2020-11-17 14:54:25'),
	(762, NULL, 16, 'M1642', 4, '2020-11-17 22:45:16'),
	(763, NULL, 16, 'M1603', 1, '2020-11-17 22:48:25'),
	(764, NULL, 16, 'M1535', 1, '2020-11-17 22:49:34'),
	(765, NULL, 16, '1880', 1, '2020-11-17 22:54:32'),
	(766, NULL, 16, '1700', 3, '2020-11-17 22:55:11'),
	(767, NULL, 15, '门把手', 78, '2020-11-18 05:20:33'),
	(768, NULL, 15, '门把手', 78, '2020-11-18 05:20:34'),
	(769, NULL, 15, '门把手', 78, '2020-11-18 05:21:44'),
	(770, NULL, 1319, 'M1643', 3, '2020-11-18 08:42:28'),
	(771, NULL, 1239, '099', 0, '2020-11-18 10:33:55'),
	(772, NULL, 283, '013', 0, '2020-11-18 12:14:45'),
	(773, NULL, 1923, '1752', 0, '2020-11-18 13:02:40'),
	(774, NULL, 1923, '1751', 2, '2020-11-18 13:02:48'),
	(775, NULL, 1923, '0515', 5, '2020-11-18 13:03:35'),
	(776, NULL, 1239, '1313G', 0, '2020-11-18 15:44:09'),
	(777, NULL, 16, 'M1642', 4, '2020-11-18 16:31:09'),
	(778, NULL, 16, '1808', 1, '2020-11-18 16:42:19'),
	(779, NULL, 16, 'M1643', 3, '2020-11-18 16:59:47'),
	(780, NULL, 16, 'Toul', 10, '2020-11-18 17:00:46'),
	(781, NULL, 16, 'Toul', 10, '2020-11-18 17:02:58'),
	(782, NULL, 16, '1400', 6, '2020-11-18 17:14:45'),
	(783, NULL, 16, 'M1530', 0, '2020-11-18 17:58:38'),
	(784, NULL, 16, 'M1530', 0, '2020-11-18 18:06:31'),
	(785, NULL, 16, 'M1530', 0, '2020-11-18 18:06:35'),
	(786, NULL, 16, 'M1672', 0, '2020-11-18 18:06:47'),
	(787, NULL, 740, '拨叉执手', 0, '2020-11-18 18:26:13'),
	(788, NULL, 1933, '0515', 5, '2020-11-19 09:55:44'),
	(789, NULL, 1294, '0515', 5, '2020-11-19 09:56:08'),
	(790, NULL, 1933, '0715', 2, '2020-11-19 09:56:17'),
	(791, NULL, 1933, '0515', 5, '2020-11-19 09:56:30'),
	(792, NULL, 1933, '0738', 0, '2020-11-19 09:59:28'),
	(793, NULL, 1933, '0738', 0, '2020-11-19 09:59:33'),
	(794, NULL, 1933, '0738', 0, '2020-11-19 09:59:50'),
	(795, NULL, 1923, '0738执手', 0, '2020-11-19 10:00:32'),
	(796, NULL, 1933, '0715', 2, '2020-11-19 10:01:28'),
	(797, NULL, 1923, '0510', 0, '2020-11-19 10:05:30'),
	(798, NULL, 1923, '0515', 5, '2020-11-19 10:06:27'),
	(799, NULL, 1319, '1540', 1, '2020-11-19 10:29:10'),
	(800, NULL, 1265, '0738', 0, '2020-11-19 11:07:56'),
	(801, NULL, 1265, '0558', 2, '2020-11-19 11:08:04'),
	(802, NULL, 1265, '0558黑色', 0, '2020-11-19 11:08:14'),
	(803, NULL, 935, '038', 0, '2020-11-19 12:16:57'),
	(804, NULL, 16, 'M1788', 0, '2020-11-19 13:58:12'),
	(805, NULL, 16, 'M1788', 0, '2020-11-19 14:01:43'),
	(806, NULL, 16, 'M123', 0, '2020-11-19 14:01:49'),
	(807, NULL, 16, 'M151', 1, '2020-11-19 14:04:28'),
	(808, NULL, 16, 'M151', 1, '2020-11-19 14:13:40'),
	(809, NULL, 16, 'M1672', 0, '2020-11-19 14:34:36'),
	(810, NULL, 16, '167', 1, '2020-11-19 14:38:35'),
	(811, NULL, 16, 'm162', 2, '2020-11-19 14:43:12'),
	(812, NULL, 1953, '门把手', 78, '2020-11-19 15:09:50'),
	(813, NULL, 1953, '断桥铝把手好博', 0, '2020-11-19 15:10:32'),
	(814, NULL, 1923, '0510', 0, '2020-11-19 19:04:39'),
	(815, NULL, 14, '1603', 1, '2020-11-19 20:36:57'),
	(816, NULL, 14, '1623', 2, '2020-11-19 20:51:19'),
	(817, NULL, 14, '1700', 3, '2020-11-19 21:25:59'),
	(818, NULL, 14, '1515', 2, '2020-11-19 21:26:15'),
	(819, NULL, 14, '1515', 2, '2020-11-19 21:31:49'),
	(820, NULL, 14, '1737', 4, '2020-11-19 21:31:55'),
	(821, NULL, 14, '1643', 5, '2020-11-19 21:32:31'),
	(822, NULL, 1319, '0808', 1, '2020-11-20 09:44:13'),
	(823, NULL, 129, '抗菌', 0, '2020-11-20 09:58:07'),
	(824, NULL, 1319, '013', 0, '2020-11-20 10:46:21'),
	(825, NULL, 1319, '013', 0, '2020-11-20 10:46:30'),
	(826, NULL, 1319, '013', 0, '2020-11-20 10:46:41'),
	(827, NULL, 1319, '013', 0, '2020-11-20 10:46:48'),
	(828, NULL, 1319, '099', 0, '2020-11-20 10:49:39'),
	(829, NULL, 1957, '0751', 2, '2020-11-20 11:33:55'),
	(830, NULL, 1957, '防钢色', 0, '2020-11-20 11:34:28'),
	(831, NULL, 1957, '防钢色', 0, '2020-11-20 11:34:32'),
	(832, NULL, 1957, '防钢色', 0, '2020-11-20 11:34:46'),
	(833, NULL, 1890, '0530', 0, '2020-11-20 12:52:34'),
	(834, NULL, 1890, 'Atlanta', 3, '2020-11-20 12:52:52'),
	(835, NULL, 1239, '0738S', 0, '2020-11-20 14:09:40'),
	(836, NULL, 129, '1140', 4, '2020-11-20 14:13:03'),
	(837, NULL, 129, '1140', 4, '2020-11-20 14:14:52'),
	(838, NULL, 129, '1140', 4, '2020-11-20 14:17:03'),
	(839, NULL, 60, '0808', 1, '2020-11-20 15:24:22'),
	(840, NULL, 60, '0558', 2, '2020-11-20 15:24:37'),
	(841, NULL, 60, '013', 0, '2020-11-20 15:24:52'),
	(842, NULL, 60, '013KH', 0, '2020-11-20 15:24:59'),
	(843, NULL, 129, '1400/42K/42KS', 1, '2020-11-20 15:25:16'),
	(844, NULL, 280, '636', 0, '2020-11-20 19:07:09'),
	(845, NULL, 187, '0530', 0, '2020-11-21 09:43:36'),
	(846, NULL, 289, 'M1643', 3, '2020-11-21 13:06:14'),
	(847, NULL, 1720, '0530', 0, '2020-11-21 13:06:50'),
	(848, NULL, 289, 'M1643', 3, '2020-11-21 13:09:28'),
	(849, NULL, 289, 'M1643', 3, '2020-11-21 13:12:28'),
	(850, NULL, 289, 'M1643', 3, '2020-11-21 13:19:54'),
	(851, NULL, 289, '1769', 4, '2020-11-21 13:33:26'),
	(852, NULL, 1978, '11899232', 0, '2020-11-21 14:44:21'),
	(853, NULL, 1213, '0515', 5, '2020-11-22 10:56:04'),
	(854, NULL, 1858, 'M123', 0, '2020-11-22 23:09:50'),
	(855, NULL, 617, '0737', 5, '2020-11-23 11:09:23'),
	(856, NULL, 14, '429', 1, '2020-11-23 11:19:07'),
	(857, NULL, 289, 'M1788', 0, '2020-11-23 12:02:44'),
	(858, NULL, 289, '845s', 1, '2020-11-23 13:02:20'),
	(859, NULL, 289, '3765471', 0, '2020-11-23 13:51:20'),
	(860, NULL, 2001, '600拉手', 0, '2020-11-23 13:51:50'),
	(861, NULL, 289, 'M845s', 1, '2020-11-23 13:54:55'),
	(862, NULL, 289, 'AR810', 1, '2020-11-23 13:55:30'),
	(863, NULL, 26, 'Amsterdam', 12, '2020-11-23 14:41:37'),
	(864, NULL, 2005, '0530', 0, '2020-11-23 15:54:05'),
	(865, NULL, 2005, '0530', 0, '2020-11-23 15:54:12'),
	(866, NULL, 2005, '0558', 2, '2020-11-23 15:54:21'),
	(867, NULL, 2005, '0530', 0, '2020-11-23 15:54:44'),
	(868, NULL, 2004, '0530', 0, '2020-11-23 15:54:45'),
	(869, NULL, 289, 'R', 55, '2020-11-23 15:57:38'),
	(870, NULL, 289, 'R', 55, '2020-11-23 15:59:58'),
	(871, NULL, 2004, '0530', 0, '2020-11-23 16:07:16'),
	(872, NULL, 2004, '0558', 2, '2020-11-23 16:07:22'),
	(873, NULL, 2006, '0558', 2, '2020-11-23 16:07:31'),
	(874, NULL, 2019, '0530', 0, '2020-11-23 16:07:50'),
	(875, NULL, 2011, '0558', 2, '2020-11-23 16:07:55'),
	(876, NULL, 2019, '0515', 5, '2020-11-23 16:08:02'),
	(877, NULL, 2011, '0558', 2, '2020-11-23 16:08:04'),
	(878, NULL, 1319, '0738', 0, '2020-11-23 16:30:43'),
	(879, NULL, 2005, '0738', 0, '2020-11-23 17:36:01'),
	(880, NULL, 2005, '门把手', 78, '2020-11-23 17:36:15'),
	(881, NULL, 2005, '0515', 5, '2020-11-23 17:36:26'),
	(882, NULL, 193, '0738S', 0, '2020-11-23 18:34:02'),
	(883, NULL, 193, '0738S', 0, '2020-11-23 18:34:24'),
	(884, NULL, 193, '0738', 0, '2020-11-23 18:36:14'),
	(885, NULL, 193, 'US945', 2, '2020-11-23 18:36:27'),
	(886, NULL, 193, 'dura', 0, '2020-11-23 18:39:19'),
	(887, NULL, 193, 'us945', 2, '2020-11-23 18:39:39'),
	(888, NULL, 1111, 'AR810', 1, '2020-11-23 20:02:58'),
	(889, NULL, 1111, 'AR819', 0, '2020-11-23 20:08:03'),
	(890, NULL, 1111, '3765471', 0, '2020-11-23 20:18:56'),
	(891, NULL, 1111, '10782827', 0, '2020-11-23 20:19:27'),
	(892, NULL, 289, 'M845s', 1, '2020-11-23 21:04:55'),
	(893, NULL, 289, 'F54', 0, '2020-11-23 21:10:40'),
	(894, NULL, 61, '门把手', 78, '2020-11-23 21:20:18'),
	(895, NULL, 2029, '门把手', 78, '2020-11-24 06:41:04'),
	(896, NULL, 2029, '锁芯', 2, '2020-11-24 06:41:15'),
	(897, NULL, 2029, '1400/42K/42KS', 1, '2020-11-24 06:41:17'),
	(898, NULL, 2029, 'Amsterdam', 12, '2020-11-24 06:41:20'),
	(899, NULL, 2029, 'hhh', 0, '2020-11-24 06:41:23'),
	(900, NULL, 2029, 'undefined', 0, '2020-11-24 06:41:25'),
	(901, NULL, 140, '交通白', 0, '2020-11-24 08:48:33'),
	(902, NULL, 1239, '0530', 0, '2020-11-24 09:30:46'),
	(903, NULL, 140, '1140', 4, '2020-11-24 10:03:11'),
	(904, NULL, 1239, '0738', 0, '2020-11-24 10:55:03'),
	(905, NULL, 289, 'AR813', 1, '2020-11-24 11:24:29'),
	(906, NULL, 289, 'AR813', 1, '2020-11-24 11:26:00'),
	(907, NULL, 289, 'AR813', 1, '2020-11-24 11:28:40'),
	(908, NULL, 289, 'M845S', 1, '2020-11-24 11:44:39'),
	(909, NULL, 289, 'M1623', 2, '2020-11-24 11:48:43'),
	(910, NULL, 289, 'M845S', 1, '2020-11-24 11:50:42'),
	(911, NULL, 289, 'AR813', 1, '2020-11-24 11:55:11'),
	(912, NULL, 289, 'M845S', 1, '2020-11-24 12:06:13'),
	(913, NULL, 1239, '0710', 1, '2020-11-24 13:06:11'),
	(914, NULL, 2059, 'Amsterdam', 12, '2020-11-24 13:58:44'),
	(915, NULL, 14, 'toulon', 10, '2020-11-24 15:06:32'),
	(916, NULL, 2082, '0818', 0, '2020-11-25 01:29:51'),
	(917, NULL, 2083, 'Amsterdam', 12, '2020-11-25 05:59:05'),
	(918, NULL, 2083, '门把手', 78, '2020-11-25 05:59:14'),
	(919, NULL, 2083, '锁芯', 2, '2020-11-25 05:59:22'),
	(920, NULL, 758, '0700', 3, '2020-11-25 09:11:22'),
	(921, NULL, 1239, '0515', 5, '2020-11-25 10:06:50'),
	(922, NULL, 1239, '0738', 0, '2020-11-25 10:51:56'),
	(923, NULL, 1239, '0738', 0, '2020-11-25 10:53:44'),
	(924, NULL, 2095, '门把手', 78, '2020-11-25 14:19:33'),
	(925, NULL, 1239, '1751', 2, '2020-11-25 14:45:32'),
	(926, NULL, 2096, '1751', 2, '2020-11-25 14:52:27'),
	(927, NULL, 304, 'M846S', 1, '2020-11-25 15:43:47'),
	(928, NULL, 304, '1540', 1, '2020-11-25 15:47:51'),
	(929, NULL, 289, 'M1788', 0, '2020-11-25 16:04:49'),
	(930, NULL, 289, 'M1788', 0, '2020-11-25 16:05:58'),
	(931, NULL, 289, '1788', 0, '2020-11-25 16:06:07'),
	(932, NULL, 289, 'M1788', 0, '2020-11-25 16:06:17'),
	(933, NULL, 289, 'M1788', 0, '2020-11-25 16:09:11'),
	(934, NULL, 289, 'M1788', 0, '2020-11-25 16:11:22'),
	(935, NULL, 2059, 'Amsterdam', 12, '2020-11-25 18:47:12'),
	(936, NULL, 13, '2571042', 0, '2020-11-25 18:57:58'),
	(937, NULL, 702, '0530', 0, '2020-11-25 21:28:05'),
	(938, NULL, 702, '0530', 0, '2020-11-25 21:28:22'),
	(939, NULL, 2029, '门把手', 78, '2020-11-25 23:14:57'),
	(940, NULL, 2029, 'undefined', 0, '2020-11-25 23:15:42'),
	(941, NULL, 2029, '1400/42K/42KS', 1, '2020-11-25 23:24:08'),
	(942, NULL, 2029, 'Amsterdam', 12, '2020-11-25 23:24:40'),
	(943, NULL, 2029, 'hhh', 0, '2020-11-25 23:44:01'),
	(944, NULL, 2029, '锁芯', 2, '2020-11-25 23:47:23'),
	(945, NULL, 2029, 'hhh', 0, '2020-11-26 00:04:02'),
	(946, NULL, 2029, '门把手', 78, '2020-11-26 00:58:27'),
	(947, NULL, 2029, '锁芯', 2, '2020-11-26 01:20:54'),
	(948, NULL, 2029, 'Amsterdam', 12, '2020-11-26 05:08:22'),
	(949, NULL, 289, '1558', 3, '2020-11-26 09:44:34'),
	(950, NULL, 2158, 'Amsterdam', 12, '2020-11-26 09:58:30'),
	(951, NULL, 2158, '门把手', 78, '2020-11-26 09:58:40'),
	(952, NULL, 2158, '锁芯', 2, '2020-11-26 09:58:50'),
	(953, NULL, 15, '门把手', 78, '2020-11-26 12:38:21'),
	(954, NULL, 15, '门把手', 78, '2020-11-26 12:38:36'),
	(955, NULL, 15, '门把手', 78, '2020-11-26 12:38:46'),
	(956, NULL, 15, '门把手', 78, '2020-11-26 12:38:50'),
	(957, NULL, 15, '锁芯', 2, '2020-11-26 12:38:53'),
	(958, NULL, 15, '锁芯', 2, '2020-11-26 12:38:55'),
	(959, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 12:38:58'),
	(960, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 12:39:01'),
	(961, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 12:39:03'),
	(962, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 12:39:05'),
	(963, NULL, 15, 'hhh', 0, '2020-11-26 12:39:07'),
	(964, NULL, 15, 'hhh', 0, '2020-11-26 12:39:09'),
	(965, NULL, 15, 'hhh', 0, '2020-11-26 12:39:11'),
	(966, NULL, 15, 'hhh', 0, '2020-11-26 12:39:14'),
	(967, NULL, 1865, '0737', 5, '2020-11-26 13:27:00'),
	(968, NULL, 15, '门把手', 78, '2020-11-26 14:17:31'),
	(969, NULL, 15, '门把手', 78, '2020-11-26 14:17:41'),
	(970, NULL, 15, '门把手', 78, '2020-11-26 14:17:47'),
	(971, NULL, 15, '门把手', 78, '2020-11-26 14:17:53'),
	(972, NULL, 15, '锁芯', 2, '2020-11-26 14:18:00'),
	(973, NULL, 15, '锁芯', 2, '2020-11-26 14:18:03'),
	(974, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 14:18:06'),
	(975, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 14:18:09'),
	(976, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 14:18:11'),
	(977, NULL, 15, '1400/42K/42KS', 1, '2020-11-26 14:18:13'),
	(978, NULL, 15, 'hhh', 0, '2020-11-26 14:18:14'),
	(979, NULL, 15, 'hhh', 0, '2020-11-26 14:18:16'),
	(980, NULL, 15, 'hhh', 0, '2020-11-26 14:18:18'),
	(981, NULL, 15, 'hhh', 0, '2020-11-26 14:18:20'),
	(982, NULL, 1865, '0738', 0, '2020-11-26 14:39:38'),
	(983, NULL, 105, '0715', 2, '2020-11-26 15:00:44'),
	(984, NULL, 1239, '013', 0, '2020-11-26 15:28:31'),
	(985, NULL, 2180, '内开内倒', 0, '2020-11-26 22:32:20'),
	(986, NULL, 702, '0700', 3, '2020-11-27 10:07:23'),
	(987, NULL, 1923, '0715', 2, '2020-11-27 11:08:21'),
	(988, NULL, 702, '1700', 3, '2020-11-27 11:24:42'),
	(989, NULL, 1923, '0515', 5, '2020-11-27 11:34:02'),
	(990, NULL, 1280, '013', 0, '2020-11-27 13:07:27'),
	(991, NULL, 1280, '0515', 5, '2020-11-27 13:07:35'),
	(992, NULL, 1586, '0515-1/US952', 1, '2020-11-27 13:33:43'),
	(993, NULL, 1550, '11899232', 0, '2020-11-27 14:06:53'),
	(994, NULL, 1550, '3833251', 0, '2020-11-27 14:07:05'),
	(995, NULL, 1550, 'M1515', 1, '2020-11-27 14:07:54'),
	(996, NULL, 1550, '1643', 5, '2020-11-27 14:09:12'),
	(997, NULL, 423, '810', 3, '2020-11-27 14:29:11'),
	(998, NULL, 1071, '1400/42K/42KS', 1, '2020-11-27 14:52:16'),
	(999, NULL, 1071, '1140', 4, '2020-11-27 14:52:19'),
	(1000, NULL, 1071, '1140', 4, '2020-11-27 14:53:41'),
	(1001, NULL, 1071, '1400/42K/42KS', 1, '2020-11-27 16:21:46'),
	(1002, NULL, 1071, '1140', 4, '2020-11-27 16:21:54'),
	(1003, NULL, 1071, '1400/42K/42KS', 1, '2020-11-27 17:10:11'),
	(1004, NULL, 1071, '1140', 4, '2020-11-27 17:10:20'),
	(1005, NULL, 2199, 'F111830323', 0, '2020-11-27 20:18:57'),
	(1006, NULL, 2199, '11830323', 0, '2020-11-27 20:19:23'),
	(1007, NULL, 2199, '扁执', 0, '2020-11-27 20:19:45'),
	(1008, NULL, 2199, '窗扁执', 0, '2020-11-27 20:20:00'),
	(1009, NULL, 2199, '窗执', 0, '2020-11-27 20:20:18'),
	(1010, NULL, 2199, '歪执', 0, '2020-11-27 23:27:49'),
	(1011, NULL, 512, '0530', 0, '2020-11-28 09:09:33'),
	(1012, NULL, 512, '0515', 5, '2020-11-28 09:09:42'),
	(1013, NULL, 289, '11528837', 0, '2020-11-28 11:27:47'),
	(1014, NULL, 1239, '1751', 2, '2020-11-28 11:43:35'),
	(1015, NULL, 1239, '0700', 3, '2020-11-28 11:43:59'),
	(1016, NULL, 1239, '0558', 2, '2020-11-28 11:44:23'),
	(1017, NULL, 758, '密码锁', 0, '2020-11-28 12:10:29'),
	(1018, NULL, 1280, '0515-1', 2, '2020-11-28 13:49:30'),
	(1019, NULL, 2204, '0510', 0, '2020-11-28 13:53:23'),
	(1020, NULL, 2204, '0510-1', 0, '2020-11-28 13:53:36'),
	(1021, NULL, 2204, '0510-1', 0, '2020-11-28 13:53:52'),
	(1022, NULL, 1280, '0515-1', 2, '2020-11-28 13:56:59'),
	(1023, NULL, 1550, '11736367', 0, '2020-11-28 15:02:21'),
	(1024, NULL, 1550, '1140', 4, '2020-11-28 15:02:31'),
	(1025, NULL, 1071, '1140', 4, '2020-11-29 17:38:53'),
	(1026, NULL, 1165, '0738', 0, '2020-11-30 08:59:25'),
	(1027, NULL, 493, '0530', 0, '2020-11-30 14:09:25'),
	(1028, NULL, 1111, '11896225', 0, '2020-11-30 15:38:19'),
	(1029, NULL, 1111, '1808', 1, '2020-11-30 15:38:53'),
	(1030, NULL, 935, '0769', 4, '2020-11-30 15:41:59'),
	(1031, NULL, 423, '5095', 2, '2020-11-30 15:50:21'),
	(1032, NULL, 423, 'Amsterdam', 12, '2020-11-30 15:54:26'),
	(1033, NULL, 398, '0715', 2, '2020-11-30 18:31:15'),
	(1034, NULL, 2239, '0715', 2, '2020-11-30 18:32:11'),
	(1035, NULL, 2239, 'Amsterdam', 12, '2020-11-30 18:34:07'),
	(1036, NULL, 2239, '1400/42K/42KS', 1, '2020-11-30 18:34:17'),
	(1037, NULL, 2239, 'hhh', 0, '2020-11-30 18:34:20'),
	(1038, NULL, 2239, '0715', 2, '2020-11-30 18:34:38'),
	(1039, NULL, 2239, '窗把手0715', 0, '2020-11-30 18:35:13'),
	(1040, NULL, 2239, '0715', 2, '2020-11-30 18:35:21'),
	(1041, NULL, 702, '0710', 1, '2020-11-30 19:06:44'),
	(1042, NULL, 1111, '3064448', 0, '2020-11-30 22:06:51'),
	(1043, NULL, 1111, '10710241', 0, '2020-11-30 22:11:10'),
	(1044, NULL, 1111, '10710233', 0, '2020-11-30 22:15:14'),
	(1045, NULL, 1111, '10710241', 0, '2020-11-30 22:15:27'),
	(1046, NULL, 1111, '10707991', 0, '2020-11-30 22:20:18'),
	(1047, NULL, 1111, '1558', 3, '2020-11-30 22:23:24'),
	(1048, NULL, 1111, '1571', 0, '2020-11-30 22:26:42'),
	(1049, NULL, 1111, '1751', 2, '2020-11-30 22:26:52'),
	(1050, NULL, 1111, '1558', 3, '2020-11-30 22:28:05'),
	(1051, NULL, 1111, '099', 0, '2020-11-30 22:28:41'),
	(1052, NULL, 1111, '11780083', 0, '2020-11-30 22:28:55'),
	(1053, NULL, 1111, '1530', 3, '2020-11-30 22:29:27'),
	(1054, NULL, 1111, 'M1643', 3, '2020-11-30 22:30:33'),
	(1055, NULL, 1111, '1530', 3, '2020-11-30 22:32:32'),
	(1056, NULL, 1111, '2573620', 0, '2020-11-30 22:33:02'),
	(1057, NULL, 1111, 'M54', 2, '2020-11-30 22:35:20'),
	(1058, NULL, 1111, '1530', 3, '2020-11-30 22:35:55'),
	(1059, NULL, 1111, '155', 3, '2020-11-30 22:37:28'),
	(1060, NULL, 1111, '1530', 3, '2020-11-30 22:39:46'),
	(1061, NULL, 1111, '1140', 4, '2020-11-30 22:41:35'),
	(1062, NULL, 1111, 'M545', 1, '2020-11-30 22:44:44'),
	(1063, NULL, 1111, '1808', 1, '2020-11-30 22:45:12'),
	(1064, NULL, 1111, 'M51', 5, '2020-11-30 22:48:04'),
	(1065, NULL, 1111, 'M1788', 0, '2020-11-30 22:48:28'),
	(1066, NULL, 1111, '1530', 3, '2020-11-30 22:50:14'),
	(1067, NULL, 1111, 'M1515', 1, '2020-11-30 22:50:51'),
	(1068, NULL, 1111, 'M1642', 4, '2020-11-30 22:53:00'),
	(1069, NULL, 1111, 'L1400', 0, '2020-11-30 22:55:05'),
	(1070, NULL, 1111, '1400', 6, '2020-11-30 22:55:13'),
	(1071, NULL, 1111, 'M1623', 2, '2020-11-30 22:57:50'),
	(1072, NULL, 1111, 'M1530', 0, '2020-11-30 23:00:15'),
	(1073, NULL, 1111, 'M1530', 0, '2020-11-30 23:00:45'),
	(1074, NULL, 1111, '2830260', 0, '2020-11-30 23:01:06'),
	(1075, NULL, 1111, 'M1688', 0, '2020-11-30 23:02:44'),
	(1076, NULL, 1111, '1808', 1, '2020-11-30 23:04:07'),
	(1077, NULL, 1111, '1140', 4, '2020-11-30 23:06:59'),
	(1078, NULL, 1111, 'M1788', 0, '2020-11-30 23:07:35'),
	(1079, NULL, 1111, 'M1623', 2, '2020-11-30 23:08:28'),
	(1080, NULL, 1111, '1643', 5, '2020-11-30 23:09:17'),
	(1081, NULL, 1280, '013', 0, '2020-12-01 08:50:02'),
	(1082, NULL, 1280, '013', 0, '2020-12-01 08:50:05'),
	(1083, NULL, 1280, '扁执手', 0, '2020-12-01 08:50:16'),
	(1084, NULL, 1280, '扁', 0, '2020-12-01 08:50:21'),
	(1085, NULL, 1280, '013', 0, '2020-12-01 08:50:33'),
	(1086, NULL, 470, '0558', 2, '2020-12-01 09:43:50'),
	(1087, NULL, 289, '11724754', 0, '2020-12-01 11:21:31'),
	(1088, NULL, 289, 'M1643', 3, '2020-12-01 11:22:03'),
	(1089, NULL, 289, '3887090', 0, '2020-12-01 11:23:21'),
	(1090, NULL, 289, '1558', 3, '2020-12-01 11:23:37'),
	(1091, NULL, 289, '1140', 4, '2020-12-01 11:24:12'),
	(1092, NULL, 289, '1808', 1, '2020-12-01 11:24:56'),
	(1093, NULL, 289, 'M1515', 1, '2020-12-01 11:25:27'),
	(1094, NULL, 289, 'M1642', 4, '2020-12-01 11:25:47'),
	(1095, NULL, 289, '1400', 6, '2020-12-01 11:26:20'),
	(1096, NULL, 289, 'M1623', 2, '2020-12-01 11:27:03'),
	(1097, NULL, 289, 'M1530', 0, '2020-12-01 11:27:30'),
	(1098, NULL, 289, '1808', 1, '2020-12-01 11:27:45'),
	(1099, NULL, 289, '1400', 6, '2020-12-01 11:29:58'),
	(1100, NULL, 289, '3887090', 0, '2020-12-01 11:36:31'),
	(1101, NULL, 289, '1558', 3, '2020-12-01 11:36:47'),
	(1102, NULL, 2244, 'm0515', 1, '2020-12-01 11:38:03'),
	(1103, NULL, 2244, '0515', 5, '2020-12-01 11:38:38'),
	(1104, NULL, 289, '11724729', 0, '2020-12-01 11:41:24'),
	(1105, NULL, 289, 'M1642', 4, '2020-12-01 11:41:45'),
	(1106, NULL, 2245, '0515', 5, '2020-12-01 11:45:09'),
	(1107, NULL, 289, '1808', 1, '2020-12-01 11:48:50'),
	(1108, NULL, 289, '11706402', 0, '2020-12-01 11:55:10'),
	(1109, NULL, 289, '11706402', 0, '2020-12-01 11:55:26'),
	(1110, NULL, 289, '3392679', 0, '2020-12-01 12:00:50'),
	(1111, NULL, 289, '1643', 5, '2020-12-01 12:01:01'),
	(1112, NULL, 289, '11724857', 0, '2020-12-01 12:03:16'),
	(1113, NULL, 289, '1751', 2, '2020-12-01 12:12:30'),
	(1114, NULL, 289, 'M463', 1, '2020-12-01 12:13:02'),
	(1115, NULL, 289, 'M1688', 0, '2020-12-01 12:13:16'),
	(1116, NULL, 289, 'M1530', 0, '2020-12-01 12:13:32'),
	(1117, NULL, 289, 'M1788', 0, '2020-12-01 12:15:35'),
	(1118, NULL, 289, 'M1642', 4, '2020-12-01 12:16:43'),
	(1119, NULL, 289, 'M1642', 4, '2020-12-01 12:18:55'),
	(1120, NULL, 289, 'M1515', 1, '2020-12-01 12:41:23'),
	(1121, NULL, 80, '0530', 0, '2020-12-01 14:27:59'),
	(1122, NULL, 80, '0530', 0, '2020-12-01 14:28:06'),
	(1123, NULL, 80, '0530', 0, '2020-12-01 14:28:18'),
	(1124, NULL, 1535, 'PSK-0530', 0, '2020-12-01 16:54:38'),
	(1125, NULL, 1535, '0530', 0, '2020-12-01 16:54:50'),
	(1126, NULL, 2251, '门把手', 78, '2020-12-01 19:40:18'),
	(1127, NULL, 2251, '0710', 1, '2020-12-01 19:41:44'),
	(1128, NULL, 1071, '安', 0, '2020-12-01 20:24:17'),
	(1129, NULL, 2253, '3969360', 0, '2020-12-01 21:04:28'),
	(1130, NULL, 2253, 'f 1', 0, '2020-12-01 21:04:54'),
	(1131, NULL, 2253, 'F1', 0, '2020-12-01 21:05:07'),
	(1132, NULL, 2253, 'F1', 0, '2020-12-01 21:05:15'),
	(1133, NULL, 1239, '0715', 2, '2020-12-02 09:23:24'),
	(1134, NULL, 1239, '0738', 0, '2020-12-02 09:23:33'),
	(1135, NULL, 1239, '0558', 2, '2020-12-02 10:25:14'),
	(1136, NULL, 2011, '0738', 0, '2020-12-02 10:40:55'),
	(1137, NULL, 105, 'm1643', 3, '2020-12-02 11:00:46'),
	(1138, NULL, 105, 'm846', 1, '2020-12-02 11:02:56'),
	(1139, NULL, 1586, '0715', 2, '2020-12-02 16:57:51'),
	(1140, NULL, 1586, 'F4', 0, '2020-12-02 16:58:15'),
	(1141, NULL, 1586, '0715', 2, '2020-12-02 17:11:13'),
	(1142, NULL, 1923, '0715', 2, '2020-12-03 11:10:23'),
	(1143, NULL, 1923, '0735', 0, '2020-12-03 11:11:05'),
	(1144, NULL, 1923, '0738', 0, '2020-12-03 11:11:13'),
	(1145, NULL, 1923, '0515', 5, '2020-12-03 11:11:23'),
	(1146, NULL, 1213, '0700', 3, '2020-12-03 13:03:25'),
	(1147, NULL, 617, '0737FT', 0, '2020-12-04 10:32:06'),
	(1148, NULL, 617, '0737', 5, '2020-12-04 10:32:26'),
	(1149, NULL, 542, 'M0515', 1, '2020-12-04 14:06:05'),
	(1150, NULL, 542, '0515', 5, '2020-12-04 14:07:04'),
	(1151, NULL, 542, '门把手', 78, '2020-12-04 14:07:34'),
	(1152, NULL, 2332, '锁芯', 2, '2020-12-04 15:19:06'),
	(1153, NULL, 2332, 'boss', 0, '2020-12-04 15:19:24'),
	(1154, NULL, 268, '0379', 0, '2020-12-04 19:34:33'),
	(1155, NULL, 268, '0739', 2, '2020-12-04 19:34:42'),
	(1156, NULL, 702, '0530', 0, '2020-12-05 10:48:04'),
	(1157, NULL, 758, '指纹', 0, '2020-12-05 11:25:43'),
	(1158, NULL, 758, '密码锁', 0, '2020-12-05 11:25:51'),
	(1159, NULL, 20, '1643/52', 1, '2020-12-05 13:37:07'),
	(1160, NULL, 20, 'K138', 1, '2020-12-05 13:37:26'),
	(1161, NULL, 2306, '1751', 2, '2020-12-05 14:23:50'),
	(1162, NULL, 1052, '1503', 0, '2020-12-05 14:54:56'),
	(1163, NULL, 2440, '门把手', 78, '2020-12-05 18:19:04'),
	(1164, NULL, 2440, '1400/42K/42KS', 1, '2020-12-05 18:19:34'),
	(1165, NULL, 2440, '锁芯', 2, '2020-12-05 18:19:38'),
	(1166, NULL, 2440, 'hhh', 0, '2020-12-05 18:19:43'),
	(1167, NULL, 2251, '0710', 1, '2020-12-06 16:52:39'),
	(1168, NULL, 702, '0515', 5, '2020-12-06 19:55:27'),
	(1169, NULL, 702, '0530', 0, '2020-12-06 19:56:01'),
	(1170, NULL, 702, '0510', 0, '2020-12-06 19:56:06'),
	(1171, NULL, 2521, '013', 0, '2020-12-06 21:03:58'),
	(1172, NULL, 2521, '0808', 1, '2020-12-06 21:04:47'),
	(1173, NULL, 2521, '013KH', 0, '2020-12-06 21:05:46'),
	(1174, NULL, 2521, '0808', 1, '2020-12-06 21:06:06'),
	(1175, NULL, 2334, '0715', 2, '2020-12-07 10:22:02'),
	(1176, NULL, 2334, '0515', 5, '2020-12-07 10:22:19'),
	(1177, NULL, 339, '099', 0, '2020-12-07 11:09:13'),
	(1178, NULL, 2528, 'PSK-0530/US952-1;', 0, '2020-12-07 11:52:27'),
	(1179, NULL, 2528, 'PSK-0530/US952-1', 0, '2020-12-07 11:52:47'),
	(1180, NULL, 2528, '1530/3346', 1, '2020-12-07 11:53:06'),
	(1181, NULL, 2529, 'Amsterdam', 12, '2020-12-07 12:02:37'),
	(1182, NULL, 2529, '门把手', 78, '2020-12-07 12:02:46'),
	(1183, NULL, 2529, '锁芯', 2, '2020-12-07 12:02:56'),
	(1184, NULL, 60, '013', 0, '2020-12-07 13:10:59'),
	(1185, NULL, 2531, '0530', 0, '2020-12-07 13:43:38'),
	(1186, NULL, 702, '0515', 5, '2020-12-07 14:35:57'),
	(1187, NULL, 2534, '0737', 5, '2020-12-07 15:49:39'),
	(1188, NULL, 17, '1515', 2, '2020-12-07 16:08:50'),
	(1189, NULL, 1239, '0715', 2, '2020-12-07 16:18:40'),
	(1190, NULL, 1239, '0715', 2, '2020-12-07 16:19:48'),
	(1191, NULL, 512, '0530', 0, '2020-12-07 17:12:47'),
	(1192, NULL, 20, '0739', 2, '2020-12-07 17:18:23'),
	(1193, NULL, 2540, '0739', 2, '2020-12-07 17:18:25'),
	(1194, NULL, 20, '1313g', 0, '2020-12-07 17:18:41'),
	(1195, NULL, 2540, '0700', 3, '2020-12-07 17:25:08'),
	(1196, NULL, 20, '0700', 3, '2020-12-07 17:25:22'),
	(1197, NULL, 2540, '0700', 3, '2020-12-07 17:25:28'),
	(1198, NULL, 2389, '外开窗执手', 0, '2020-12-07 18:42:28'),
	(1199, NULL, 2554, '0558', 2, '2020-12-08 10:30:18'),
	(1200, NULL, 2554, '0558', 2, '2020-12-08 10:31:30'),
	(1201, NULL, 2554, '0558', 2, '2020-12-08 10:33:33'),
	(1202, NULL, 617, '0710', 1, '2020-12-08 13:22:01'),
	(1203, NULL, 2528, 'PSK-0530/US952-1', 0, '2020-12-09 08:37:27'),
	(1204, NULL, 2528, '1530/3346', 1, '2020-12-09 08:37:39'),
	(1205, NULL, 2528, 'PSK-0530', 0, '2020-12-09 08:37:48'),
	(1206, NULL, 2528, 'PSK-0751', 1, '2020-12-09 08:37:54'),
	(1207, NULL, 2528, '1530/3346', 1, '2020-12-09 08:39:02'),
	(1208, NULL, 2528, 'PSK-0751', 1, '2020-12-09 08:46:07'),
	(1209, NULL, 2528, '1530/3346', 1, '2020-12-09 08:46:58'),
	(1210, NULL, 350, '0510/US952', 0, '2020-12-09 11:31:48'),
	(1211, NULL, 18, '0510', 0, '2020-12-09 11:34:28'),
	(1212, NULL, 18, '0510', 0, '2020-12-09 14:27:40'),
	(1213, NULL, 18, '0710', 1, '2020-12-09 14:32:48'),
	(1214, NULL, 493, '0510', 0, '2020-12-09 14:50:08'),
	(1215, NULL, 80, '0738', 0, '2020-12-09 15:29:52'),
	(1216, NULL, 80, '07', 22, '2020-12-09 15:30:01'),
	(1217, NULL, 2586, '1808', 1, '2020-12-09 16:52:48'),
	(1218, NULL, 758, '门把手', 78, '2020-12-09 20:11:37'),
	(1219, NULL, 758, '133', 0, '2020-12-09 20:12:52'),
	(1220, NULL, 758, 'G', 32, '2020-12-09 20:13:00'),
	(1221, NULL, 2334, '1751', 2, '2020-12-10 09:06:53'),
	(1222, NULL, 2334, '1751高低', 0, '2020-12-10 09:07:50'),
	(1223, NULL, 617, '0737', 5, '2020-12-10 09:20:49'),
	(1224, NULL, 702, '0058', 0, '2020-12-10 09:53:36'),
	(1225, NULL, 702, '0558', 2, '2020-12-10 09:53:44'),
	(1226, NULL, 2243, '0558', 2, '2020-12-10 09:55:08'),
	(1227, NULL, 2243, '0535', 1, '2020-12-10 09:56:16'),
	(1228, NULL, 2243, '072', 1, '2020-12-10 09:56:48'),
	(1229, NULL, 2243, '0737', 5, '2020-12-10 09:57:07'),
	(1230, NULL, 2243, '0558', 2, '2020-12-10 10:07:55'),
	(1231, NULL, 2243, '0515', 5, '2020-12-10 10:10:05'),
	(1232, NULL, 2243, '0515', 5, '2020-12-10 10:11:00'),
	(1233, NULL, 2243, '0558', 2, '2020-12-10 10:12:46'),
	(1234, NULL, 2243, '0535', 1, '2020-12-10 11:08:25'),
	(1235, NULL, 2243, '0737', 5, '2020-12-10 11:11:22'),
	(1236, NULL, 2243, '0737', 5, '2020-12-10 11:11:52'),
	(1237, NULL, 2243, '072', 1, '2020-12-10 11:14:58'),
	(1238, NULL, 423, '1140', 4, '2020-12-10 14:04:01'),
	(1239, NULL, 187, '0710', 1, '2020-12-10 14:18:54'),
	(1240, NULL, 187, '0808', 1, '2020-12-10 14:20:57'),
	(1241, NULL, 351, '0737', 5, '2020-12-10 16:20:25'),
	(1242, NULL, 2625, '0737-2', 1, '2020-12-10 16:21:06'),
	(1243, NULL, 2625, '0737-2', 1, '2020-12-10 16:23:16'),
	(1244, NULL, 2625, '0737', 5, '2020-12-11 09:44:10'),
	(1245, NULL, 1213, '0737', 5, '2020-12-11 11:26:35'),
	(1246, NULL, 20, 'M1642', 4, '2020-12-11 13:01:36'),
	(1247, NULL, 351, '0515/US952', 0, '2020-12-11 13:56:00'),
	(1248, NULL, 2628, '锁芯', 2, '2020-12-11 16:59:14'),
	(1249, NULL, 2239, '0558', 2, '2020-12-11 21:41:45'),
	(1250, NULL, 2657, '35252', 0, '2020-12-12 05:49:38'),
	(1251, NULL, 2657, '1240', 0, '2020-12-12 05:50:15'),
	(1252, NULL, 1239, '0515', 5, '2020-12-12 13:34:48'),
	(1253, NULL, 2660, '0530', 0, '2020-12-12 13:47:39'),
	(1254, NULL, 512, '1540', 1, '2020-12-12 14:07:39'),
	(1255, NULL, 2334, '0715', 2, '2020-12-12 14:25:58'),
	(1256, NULL, 1865, '0737', 5, '2020-12-12 14:30:43'),
	(1257, NULL, 1923, '0515', 5, '2020-12-12 15:34:54'),
	(1258, NULL, 2663, '0515', 5, '2020-12-12 15:35:05'),
	(1259, NULL, 2663, '0530', 0, '2020-12-12 15:35:18'),
	(1260, NULL, 1923, '0715', 2, '2020-12-12 15:35:20'),
	(1261, NULL, 1923, '0738', 0, '2020-12-12 15:35:55'),
	(1262, NULL, 1239, '0515', 5, '2020-12-13 12:33:16'),
	(1263, NULL, 1239, '1751', 2, '2020-12-13 12:33:44'),
	(1264, NULL, 2676, 'A35', 0, '2020-12-13 22:33:19'),
	(1265, NULL, 2676, 'C99', 0, '2020-12-13 22:35:19'),
	(1266, NULL, 2676, '锁芯', 2, '2020-12-13 22:37:43'),
	(1267, NULL, 2676, '1400/42K/42KS', 1, '2020-12-13 22:37:49'),
	(1268, NULL, 268, '0739', 2, '2020-12-14 11:15:19'),
	(1269, NULL, 85, '0738', 0, '2020-12-14 14:12:33'),
	(1270, NULL, 85, '0738', 0, '2020-12-14 14:12:38'),
	(1271, NULL, 129, '抗菌', 0, '2020-12-14 15:04:05'),
	(1272, NULL, 129, '菌', 0, '2020-12-14 15:04:18'),
	(1273, NULL, 268, '0737', 5, '2020-12-14 16:43:31'),
	(1274, NULL, 2683, '门把手', 78, '2020-12-14 18:29:20'),
	(1275, NULL, 14, '0738', 0, '2020-12-15 11:56:42'),
	(1276, NULL, 17, '0738', 0, '2020-12-15 11:57:15'),
	(1277, NULL, 17, '0738', 0, '2020-12-15 11:57:41'),
	(1278, NULL, 758, '0515', 5, '2020-12-15 13:46:03'),
	(1279, NULL, 758, '0558', 2, '2020-12-15 13:48:38'),
	(1280, NULL, 758, '双面0558', 0, '2020-12-15 13:49:12'),
	(1281, NULL, 1111, '0530', 0, '2020-12-15 15:49:16'),
	(1282, NULL, 2011, '11', 7, '2020-12-15 15:59:05'),
	(1283, NULL, 2011, '8033', 0, '2020-12-15 15:59:16'),
	(1284, NULL, 14, '0739', 2, '2020-12-15 16:48:23'),
	(1285, NULL, 1239, '1313', 0, '2020-12-15 16:56:11'),
	(1286, NULL, 2697, 'Amsterdam', 12, '2020-12-15 18:32:50'),
	(1287, NULL, 2697, '门把手', 78, '2020-12-15 18:32:57'),
	(1288, NULL, 2697, '锁芯', 2, '2020-12-15 18:33:09'),
	(1289, NULL, 2699, '外开下悬', 0, '2020-12-15 20:19:37'),
	(1290, NULL, 1239, '1751', 2, '2020-12-16 08:49:07'),
	(1291, NULL, 1319, 'M051/US956', 0, '2020-12-16 08:59:58'),
	(1292, NULL, 1319, 'M051', 1, '2020-12-16 09:00:19'),
	(1293, NULL, 1111, 'E1400', 3, '2020-12-16 09:32:33'),
	(1294, NULL, 702, 'E1400', 3, '2020-12-16 10:16:27'),
	(1295, NULL, 80, '1751', 2, '2020-12-16 11:40:40'),
	(1296, NULL, 351, 'HS-571', 0, '2020-12-16 11:54:06'),
	(1297, NULL, 1319, '0515-1*', 0, '2020-12-16 12:54:44'),
	(1298, NULL, 1319, '0515-1', 2, '2020-12-16 12:54:49'),
	(1299, NULL, 616, '0643', 7, '2020-12-16 13:33:34'),
	(1300, NULL, 1239, '0751', 2, '2020-12-16 16:27:25'),
	(1301, NULL, 14, '0738', 0, '2020-12-17 10:32:59'),
	(1302, NULL, 16, '0738', 0, '2020-12-17 10:35:20'),
	(1303, NULL, 512, '1710', 0, '2020-12-17 11:00:48'),
	(1304, NULL, 2738, '013', 0, '2020-12-17 15:33:25'),
	(1305, NULL, 127, '013KH', 0, '2020-12-17 15:33:47'),
	(1306, NULL, 1586, '86G/3358/3357N/1530G', 0, '2020-12-17 16:12:37'),
	(1307, NULL, 1586, '86G', 0, '2020-12-17 16:12:44'),
	(1308, NULL, 20, 'e1195', 0, '2020-12-17 17:00:34'),
	(1309, NULL, 1239, '099', 0, '2020-12-18 10:14:16'),
	(1310, NULL, 512, '1400/42K/42KS', 1, '2020-12-18 14:09:40'),
	(1311, NULL, 20, '1751', 2, '2020-12-18 17:48:00'),
	(1312, NULL, 512, '099', 0, '2020-12-19 10:04:56'),
	(1313, NULL, 512, '1751', 2, '2020-12-19 10:05:07'),
	(1314, NULL, 187, '013', 0, '2020-12-19 15:00:57'),
	(1315, NULL, 2586, '1140', 4, '2020-12-19 16:01:19'),
	(1316, NULL, 2586, 'm8455', 0, '2020-12-19 16:18:40'),
	(1317, NULL, 2586, 'f9714', 0, '2020-12-19 16:18:54'),
	(1318, NULL, 2586, '1140', 4, '2020-12-19 16:19:06'),
	(1319, NULL, 2586, '旋钮', 0, '2020-12-19 16:20:13'),
	(1320, NULL, 2586, 'm845s', 1, '2020-12-19 16:20:34'),
	(1321, NULL, 2586, '1140', 4, '2020-12-19 16:26:28'),
	(1322, NULL, 2586, '1808', 1, '2020-12-19 16:29:24'),
	(1323, NULL, 2586, '1140', 4, '2020-12-19 16:31:17'),
	(1324, NULL, 512, '0530', 0, '2020-12-19 17:04:43'),
	(1325, NULL, 503, '099', 0, '2020-12-19 18:42:09'),
	(1326, NULL, 2586, '1660', 0, '2020-12-20 09:14:30'),
	(1327, NULL, 2586, '16', 15, '2020-12-20 09:14:40'),
	(1328, NULL, 512, '0400', 5, '2020-12-20 15:42:42'),
	(1329, NULL, 512, '0140', 2, '2020-12-20 15:43:09'),
	(1330, NULL, 512, '86', 0, '2020-12-20 18:25:10'),
	(1331, NULL, 512, '1530', 3, '2020-12-20 18:25:19'),
	(1332, NULL, 2800, '099kh', 0, '2020-12-21 09:38:12'),
	(1333, NULL, 2800, '099', 0, '2020-12-21 09:38:19'),
	(1334, NULL, 2800, '303N', 0, '2020-12-21 09:39:31'),
	(1335, NULL, 2801, '门把手', 78, '2020-12-21 10:08:00'),
	(1336, NULL, 2801, '锁芯', 2, '2020-12-21 10:12:19'),
	(1337, NULL, 2801, 'hhh', 0, '2020-12-21 10:12:30'),
	(1338, NULL, 2251, '86g', 0, '2020-12-21 10:15:33'),
	(1339, NULL, 2251, '86', 0, '2020-12-21 10:15:41'),
	(1340, NULL, 1239, '1751', 2, '2020-12-21 10:25:18'),
	(1341, NULL, 2738, '099KH', 0, '2020-12-21 14:01:02'),
	(1342, NULL, 1239, '013', 0, '2020-12-21 14:27:42'),
	(1343, NULL, 1239, '0710', 1, '2020-12-21 14:27:53'),
	(1344, NULL, 935, '0530', 0, '2020-12-21 15:05:18'),
	(1345, NULL, 268, '0715', 2, '2020-12-21 16:07:29'),
	(1346, NULL, 1859, '0515', 5, '2020-12-21 16:24:45'),
	(1347, NULL, 1859, '0510', 0, '2020-12-21 16:30:40'),
	(1348, NULL, 1859, '0510', 0, '2020-12-21 16:30:42'),
	(1349, NULL, 1859, '0510', 0, '2020-12-21 16:31:06'),
	(1350, NULL, 1859, '0510', 0, '2020-12-21 16:40:36'),
	(1351, NULL, 1859, '0515', 5, '2020-12-21 16:40:38'),
	(1352, NULL, 2812, '锁盒', 0, '2020-12-21 17:12:06'),
	(1353, NULL, 2813, '0737-2', 1, '2020-12-21 17:28:56'),
	(1354, NULL, 2813, '0737', 5, '2020-12-21 17:37:16'),
	(1355, NULL, 2813, '0737', 5, '2020-12-21 17:37:47'),
	(1356, NULL, 2813, '0737', 5, '2020-12-21 17:38:41'),
	(1357, NULL, 935, '0400', 5, '2020-12-21 18:02:24'),
	(1358, NULL, 2242, '0737', 5, '2020-12-21 20:13:29'),
	(1359, NULL, 15, '门把手', 78, '2020-12-22 02:10:44'),
	(1360, NULL, 15, '门把手', 78, '2020-12-22 02:10:54'),
	(1361, NULL, 15, '锁芯', 2, '2020-12-22 02:11:04'),
	(1362, NULL, 15, '锁芯', 2, '2020-12-22 02:11:07'),
	(1363, NULL, 15, '锁芯', 2, '2020-12-22 02:11:08'),
	(1364, NULL, 15, '锁芯', 2, '2020-12-22 02:11:10'),
	(1365, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:11:12'),
	(1366, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:11:13'),
	(1367, NULL, 15, 'Amsterdam', 12, '2020-12-22 02:11:14'),
	(1368, NULL, 15, 'Amsterdam', 12, '2020-12-22 02:11:16'),
	(1369, NULL, 15, 'hhh', 0, '2020-12-22 02:11:19'),
	(1370, NULL, 15, 'hhh', 0, '2020-12-22 02:11:20'),
	(1371, NULL, 15, 'hhh', 0, '2020-12-22 02:11:22'),
	(1372, NULL, 15, 'hhh', 0, '2020-12-22 02:11:23'),
	(1373, NULL, 15, 'hhh', 0, '2020-12-22 02:29:15'),
	(1374, NULL, 15, 'hhh', 0, '2020-12-22 02:29:18'),
	(1375, NULL, 15, 'hhh', 0, '2020-12-22 02:29:21'),
	(1376, NULL, 15, 'undefined', 0, '2020-12-22 02:29:24'),
	(1377, NULL, 15, '门把手', 78, '2020-12-22 02:31:05'),
	(1378, NULL, 15, '门把手', 78, '2020-12-22 02:31:15'),
	(1379, NULL, 15, '锁芯', 2, '2020-12-22 02:31:25'),
	(1380, NULL, 15, '锁芯', 2, '2020-12-22 02:31:27'),
	(1381, NULL, 15, '锁芯', 2, '2020-12-22 02:31:29'),
	(1382, NULL, 15, '锁芯', 2, '2020-12-22 02:31:32'),
	(1383, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:31:34'),
	(1384, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:31:36'),
	(1385, NULL, 15, 'Amsterdam', 12, '2020-12-22 02:31:39'),
	(1386, NULL, 15, 'Amsterdam', 12, '2020-12-22 02:31:41'),
	(1387, NULL, 15, 'hhh', 0, '2020-12-22 02:31:43'),
	(1388, NULL, 15, 'hhh', 0, '2020-12-22 02:31:46'),
	(1389, NULL, 15, 'hhh', 0, '2020-12-22 02:31:48'),
	(1390, NULL, 15, 'hhh', 0, '2020-12-22 02:31:50'),
	(1391, NULL, 15, '门把手', 78, '2020-12-22 02:34:44'),
	(1392, NULL, 15, '门把手', 78, '2020-12-22 02:34:54'),
	(1393, NULL, 15, '门把手', 78, '2020-12-22 02:35:04'),
	(1394, NULL, 15, 'undefined', 0, '2020-12-22 02:35:08'),
	(1395, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:41:59'),
	(1396, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:42:02'),
	(1397, NULL, 15, '1400/42K/42KS', 1, '2020-12-22 02:42:05'),
	(1398, NULL, 15, 'undefined', 0, '2020-12-22 02:42:07'),
	(1399, NULL, 15, 'hhh', 0, '2020-12-22 02:51:52'),
	(1400, NULL, 15, 'hhh', 0, '2020-12-22 02:51:54'),
	(1401, NULL, 15, 'hhh', 0, '2020-12-22 02:51:58'),
	(1402, NULL, 15, 'undefined', 0, '2020-12-22 02:52:00'),
	(1403, NULL, 15, '锁芯', 2, '2020-12-22 03:00:30'),
	(1404, NULL, 15, '锁芯', 2, '2020-12-22 03:00:33'),
	(1405, NULL, 15, '锁芯', 2, '2020-12-22 03:00:35'),
	(1406, NULL, 15, 'undefined', 0, '2020-12-22 03:00:37'),
	(1407, NULL, 15, 'Amsterdam', 12, '2020-12-22 03:08:32'),
	(1408, NULL, 15, 'Amsterdam', 12, '2020-12-22 03:08:37'),
	(1409, NULL, 15, 'Amsterdam', 12, '2020-12-22 03:08:39'),
	(1410, NULL, 15, 'undefined', 0, '2020-12-22 03:08:41'),
	(1411, NULL, 15, '锁芯', 2, '2020-12-22 03:17:29'),
	(1412, NULL, 15, '锁芯', 2, '2020-12-22 03:17:32'),
	(1413, NULL, 15, '锁芯', 2, '2020-12-22 03:17:35'),
	(1414, NULL, 15, 'undefined', 0, '2020-12-22 03:17:38'),
	(1415, NULL, 1239, '099', 0, '2020-12-22 08:57:21'),
	(1416, NULL, 1239, '0738', 0, '2020-12-22 09:05:47'),
	(1417, NULL, 1239, '1540', 1, '2020-12-22 09:20:54'),
	(1418, NULL, 935, '1540', 1, '2020-12-22 10:35:28'),
	(1419, NULL, 2105, '0737', 5, '2020-12-22 11:51:06'),
	(1420, NULL, 2105, '0700', 3, '2020-12-22 11:51:21'),
	(1421, NULL, 935, 'psk', 7, '2020-12-22 11:52:25'),
	(1422, NULL, 2105, '0737', 5, '2020-12-22 11:52:29'),
	(1423, NULL, 1859, '1751', 2, '2020-12-22 12:58:47'),
	(1424, NULL, 2586, '1140', 4, '2020-12-22 13:09:16'),
	(1425, NULL, 105, '0710', 1, '2020-12-22 14:24:50'),
	(1426, NULL, 105, '0737fl', 1, '2020-12-22 14:25:54'),
	(1427, NULL, 351, '0738', 0, '2020-12-22 15:02:25'),
	(1428, NULL, 351, '0738/US945', 0, '2020-12-22 15:02:37'),
	(1429, NULL, 351, '0715', 2, '2020-12-22 15:02:46'),
	(1430, NULL, 351, '0738', 0, '2020-12-22 15:02:55'),
	(1431, NULL, 2857, '0738', 0, '2020-12-22 15:05:35'),
	(1432, NULL, 2857, '0530', 0, '2020-12-22 23:47:30'),
	(1433, NULL, 2857, '0515', 5, '2020-12-22 23:47:41'),
	(1434, NULL, 2857, '0510', 0, '2020-12-22 23:50:13'),
	(1435, NULL, 2857, '0510', 0, '2020-12-22 23:50:18'),
	(1436, NULL, 974, '执手', 0, '2020-12-23 09:11:49'),
	(1437, NULL, 2586, '1642', 4, '2020-12-23 12:08:52'),
	(1438, NULL, 1251, '0515', 5, '2020-12-23 13:43:42'),
	(1439, NULL, 2586, '1642', 4, '2020-12-23 14:23:02'),
	(1440, NULL, 20, 'M845S', 1, '2020-12-23 15:07:44'),
	(1441, NULL, 702, '0737', 5, '2020-12-23 16:14:35'),
	(1442, NULL, 512, '0737', 5, '2020-12-23 16:14:46'),
	(1443, NULL, 1724, '贝多芬', 0, '2020-12-23 16:18:55'),
	(1444, NULL, 268, '0738s', 0, '2020-12-23 22:12:23'),
	(1445, NULL, 268, '0738S', 0, '2020-12-23 22:12:29'),
	(1446, NULL, 268, '0738', 0, '2020-12-23 22:12:33'),
	(1447, NULL, 268, '0738', 0, '2020-12-23 22:12:40'),
	(1448, NULL, 702, '0642', 5, '2020-12-24 09:40:23'),
	(1449, NULL, 702, '0643', 7, '2020-12-24 09:40:57'),
	(1450, NULL, 46, '0530S', 0, '2020-12-24 10:11:27'),
	(1451, NULL, 935, '0550', 0, '2020-12-24 10:31:37'),
	(1452, NULL, 1859, '0515', 5, '2020-12-24 14:18:57'),
	(1453, NULL, 2243, '0515', 5, '2020-12-24 14:47:54'),
	(1454, NULL, 2105, '1751', 2, '2020-12-24 15:02:42'),
	(1455, NULL, 2105, '099KH', 0, '2020-12-24 15:03:16'),
	(1456, NULL, 2105, '1751 BOST', 0, '2020-12-24 15:03:47'),
	(1457, NULL, 2105, '1751', 2, '2020-12-24 15:03:54'),
	(1458, NULL, 2105, '303N', 0, '2020-12-24 15:05:02'),
	(1459, NULL, 268, '0737', 5, '2020-12-24 20:57:34'),
	(1460, NULL, 268, 'M0530', 0, '2020-12-24 21:13:35'),
	(1461, NULL, 268, 'M0515', 1, '2020-12-24 21:13:43'),
	(1462, NULL, 935, '0530', 0, '2020-12-25 12:10:26'),
	(1463, NULL, 2925, '门把手', 78, '2020-12-26 16:01:50'),
	(1464, NULL, 2925, '执手', 0, '2020-12-26 16:02:09'),
	(1465, NULL, 2925, '门把手', 78, '2020-12-26 16:02:11'),
	(1466, NULL, 2925, '窗把手', 32, '2020-12-26 16:02:29'),
	(1467, NULL, 2925, '窗把手', 32, '2020-12-26 16:05:13'),
	(1468, NULL, 15, 'Amsterdam', 12, '2020-12-27 03:07:17'),
	(1469, NULL, 15, 'Amsterdam', 12, '2020-12-27 03:07:22'),
	(1470, NULL, 15, 'Amsterdam', 12, '2020-12-27 03:07:25'),
	(1471, NULL, 15, 'undefined', 0, '2020-12-27 03:07:27'),
	(1472, NULL, 15, '门把手', 78, '2020-12-27 03:22:21'),
	(1473, NULL, 15, '门把手', 78, '2020-12-27 03:22:31'),
	(1474, NULL, 15, '门把手', 78, '2020-12-27 03:22:41'),
	(1475, NULL, 15, 'undefined', 0, '2020-12-27 03:22:45'),
	(1476, NULL, 15, '门把手', 78, '2020-12-27 03:39:43'),
	(1477, NULL, 15, '门把手', 78, '2020-12-27 03:39:54'),
	(1478, NULL, 15, '门把手', 78, '2020-12-27 03:40:04'),
	(1479, NULL, 15, 'undefined', 0, '2020-12-27 03:40:08'),
	(1480, NULL, 15, '1400/42K/42KS', 1, '2020-12-27 03:42:36'),
	(1481, NULL, 15, '1400/42K/42KS', 1, '2020-12-27 03:42:39'),
	(1482, NULL, 15, '1400/42K/42KS', 1, '2020-12-27 03:42:41'),
	(1483, NULL, 15, 'undefined', 0, '2020-12-27 03:42:44'),
	(1484, NULL, 15, '1400/42K/42KS', 1, '2020-12-27 03:50:34'),
	(1485, NULL, 15, '1400/42K/42KS', 1, '2020-12-27 03:50:37'),
	(1486, NULL, 15, '1400/42K/42KS', 1, '2020-12-27 03:50:40'),
	(1487, NULL, 15, 'undefined', 0, '2020-12-27 03:50:42'),
	(1488, NULL, 15, '锁芯', 2, '2020-12-27 03:53:01'),
	(1489, NULL, 15, '锁芯', 2, '2020-12-27 03:53:04'),
	(1490, NULL, 15, '锁芯', 2, '2020-12-27 03:53:06'),
	(1491, NULL, 15, 'undefined', 0, '2020-12-27 03:53:08'),
	(1492, NULL, 15, 'Amsterdam', 12, '2020-12-27 04:22:35'),
	(1493, NULL, 15, 'Amsterdam', 12, '2020-12-27 04:22:41'),
	(1494, NULL, 15, 'Amsterdam', 12, '2020-12-27 04:22:43'),
	(1495, NULL, 15, 'undefined', 0, '2020-12-27 04:22:46'),
	(1496, NULL, 2935, '1751', 2, '2020-12-27 12:50:48'),
	(1497, NULL, 1213, '门把手', 78, '2020-12-27 16:47:47'),
	(1498, NULL, 617, '0739', 2, '2020-12-27 20:11:05'),
	(1499, NULL, 617, '0739', 2, '2020-12-27 20:22:42'),
	(1500, NULL, 2949, '0738', 0, '2020-12-28 10:53:19'),
	(1501, NULL, 2949, '0515', 5, '2020-12-28 10:53:26'),
	(1502, NULL, 2949, '0710', 1, '2020-12-28 10:53:35'),
	(1503, NULL, 935, '013', 0, '2020-12-28 11:44:04'),
	(1504, NULL, 935, '0737', 5, '2020-12-28 11:44:12'),
	(1505, NULL, 935, '013kh', 0, '2020-12-28 11:44:49'),
	(1506, NULL, 702, '0700', 3, '2020-12-28 11:47:06'),
	(1507, NULL, 1239, '1313G', 0, '2020-12-28 14:35:30'),
	(1508, NULL, 2957, '0738', 0, '2020-12-28 14:40:52'),
	(1509, NULL, 2963, '1751-3346', 0, '2020-12-29 08:32:38'),
	(1510, NULL, 2963, '1751-3346', 0, '2020-12-29 08:32:52'),
	(1511, NULL, 512, '1751', 2, '2020-12-29 08:35:13'),
	(1512, NULL, 2963, '门把手', 78, '2020-12-29 08:46:03'),
	(1513, NULL, 2247, '0738', 0, '2020-12-29 10:03:35'),
	(1514, NULL, 16, '3310', 1, '2020-12-29 14:34:46'),
	(1515, NULL, 15, '门把手', 78, '2020-12-29 23:20:16'),
	(1516, NULL, 15, '锁芯', 2, '2020-12-29 23:20:26'),
	(1517, NULL, 15, '1400/42K/42KS', 1, '2020-12-29 23:20:30'),
	(1518, NULL, 15, 'Amsterdam', 12, '2020-12-29 23:20:32'),
	(1519, NULL, 15, 'hhh', 0, '2020-12-29 23:20:39'),
	(1520, NULL, 15, 'undefined', 0, '2020-12-29 23:20:41'),
	(1521, NULL, 2334, '0700', 3, '2020-12-30 09:50:05'),
	(1522, NULL, 2987, '0510', 0, '2020-12-30 09:53:14'),
	(1523, NULL, 2987, '0510执手', 0, '2020-12-30 09:53:26'),
	(1524, NULL, 2987, '0515', 5, '2020-12-30 09:53:35'),
	(1525, NULL, 935, '0642', 5, '2020-12-30 11:29:03'),
	(1526, NULL, 45, '1400', 6, '2020-12-30 12:50:27'),
	(1527, NULL, 11, 'hhh', 0, '2020-12-30 14:19:46'),
	(1528, NULL, 11, '1400/42K/42KS', 1, '2020-12-30 14:19:49'),
	(1529, NULL, 11, 'Amsterdam', 12, '2020-12-30 14:19:51'),
	(1530, NULL, 11, '锁芯', 2, '2020-12-30 14:20:09'),
	(1531, NULL, 935, '1558', 3, '2020-12-30 16:28:56'),
	(1532, NULL, 935, '1751', 2, '2020-12-30 16:30:08'),
	(1533, NULL, 2857, '纯铜执手', 0, '2020-12-30 18:32:27'),
	(1534, NULL, 2857, '0515', 5, '2020-12-30 18:39:09'),
	(1535, NULL, 350, 'M0515', 1, '2020-12-30 18:39:35'),
	(1536, NULL, 350, 'M0515', 1, '2020-12-30 18:40:15'),
	(1537, NULL, 350, 'M051', 1, '2020-12-30 18:40:55'),
	(1538, NULL, 1111, '1623', 2, '2020-12-31 12:38:20'),
	(1539, NULL, 617, '0737', 5, '2020-12-31 12:52:29'),
	(1540, NULL, 351, 'M1788', 0, '2020-12-31 14:48:50'),
	(1541, NULL, 351, 'M1558', 1, '2020-12-31 14:49:10'),
	(1542, NULL, 351, 'M172', 2, '2020-12-31 14:49:32'),
	(1543, NULL, 351, 'M L', 0, '2020-12-31 14:50:07'),
	(1544, NULL, 351, 'ML', 0, '2020-12-31 14:50:20'),
	(1545, NULL, 60, 'Dallas', 13, '2020-12-31 16:19:16'),
	(1546, NULL, 15, '门把手', 78, '2021-01-01 02:59:45'),
	(1547, NULL, 15, '门把手', 78, '2021-01-01 02:59:56'),
	(1548, NULL, 15, '门把手', 78, '2021-01-01 03:00:07'),
	(1549, NULL, 15, 'undefined', 0, '2021-01-01 03:00:11'),
	(1550, NULL, 15, '门把手', 78, '2021-01-01 03:19:56'),
	(1551, NULL, 15, '门把手', 78, '2021-01-01 03:20:06'),
	(1552, NULL, 15, '门把手', 78, '2021-01-01 03:20:16'),
	(1553, NULL, 15, 'undefined', 0, '2021-01-01 03:20:21'),
	(1554, NULL, 15, '1400/42K/42KS', 1, '2021-01-01 04:55:58'),
	(1555, NULL, 15, '1400/42K/42KS', 1, '2021-01-01 04:56:01'),
	(1556, NULL, 15, '1400/42K/42KS', 1, '2021-01-01 04:56:04'),
	(1557, NULL, 15, 'undefined', 0, '2021-01-01 04:56:06'),
	(1558, NULL, 15, 'Amsterdam', 12, '2021-01-01 04:58:22'),
	(1559, NULL, 15, 'Amsterdam', 12, '2021-01-01 04:58:28'),
	(1560, NULL, 15, 'Amsterdam', 12, '2021-01-01 04:58:30'),
	(1561, NULL, 15, 'undefined', 0, '2021-01-01 04:58:33'),
	(1562, NULL, 15, '锁芯', 2, '2021-01-01 05:15:29'),
	(1563, NULL, 15, '锁芯', 2, '2021-01-01 05:15:32'),
	(1564, NULL, 15, '锁芯', 2, '2021-01-01 05:15:34'),
	(1565, NULL, 15, 'undefined', 0, '2021-01-01 05:15:39'),
	(1566, NULL, 15, 'hhh', 0, '2021-01-01 05:16:06'),
	(1567, NULL, 15, 'hhh', 0, '2021-01-01 05:16:09'),
	(1568, NULL, 15, 'hhh', 0, '2021-01-01 05:16:11'),
	(1569, NULL, 15, 'undefined', 0, '2021-01-01 05:16:14'),
	(1570, NULL, 15, 'hhh', 0, '2021-01-01 05:52:56'),
	(1571, NULL, 15, 'hhh', 0, '2021-01-01 05:52:58'),
	(1572, NULL, 15, 'hhh', 0, '2021-01-01 05:53:01'),
	(1573, NULL, 15, 'undefined', 0, '2021-01-01 05:53:03'),
	(1574, NULL, 350, '1751', 2, '2021-01-02 15:57:43'),
	(1575, NULL, 3027, '0558', 2, '2021-01-03 09:20:24'),
	(1576, NULL, 3027, '0558', 2, '2021-01-03 09:21:01'),
	(1577, NULL, 3030, '指纹锁', 0, '2021-01-03 14:40:23'),
	(1578, NULL, 350, 'M1515', 1, '2021-01-03 16:19:43'),
	(1579, NULL, 423, 'M1642/845', 1, '2021-01-04 12:27:31'),
	(1580, NULL, 423, 'M846', 1, '2021-01-04 12:33:09'),
	(1581, NULL, 423, 'M1642', 4, '2021-01-04 15:20:31'),
	(1582, NULL, 423, '1140', 4, '2021-01-04 15:22:03'),
	(1583, NULL, 423, 'M1642', 4, '2021-01-04 15:23:04'),
	(1584, NULL, 423, 'M846S', 1, '2021-01-04 15:24:54'),
	(1585, NULL, 350, '0737', 5, '2021-01-04 15:33:00'),
	(1586, NULL, 350, '0737', 5, '2021-01-04 15:34:45'),
	(1587, NULL, 1213, '0738', 0, '2021-01-04 19:14:46'),
	(1588, NULL, 1213, '0738', 0, '2021-01-04 19:14:51'),
	(1589, NULL, 1213, '0738', 0, '2021-01-04 19:14:58'),
	(1590, NULL, 1213, '门把手', 78, '2021-01-04 19:15:05'),
	(1591, NULL, 1213, '窗把手', 32, '2021-01-04 19:16:21'),
	(1592, NULL, 350, '1530', 3, '2021-01-04 22:03:39'),
	(1593, NULL, 350, '1751', 2, '2021-01-05 10:31:26'),
	(1594, NULL, 1111, '1700', 3, '2021-01-05 11:10:00'),
	(1595, NULL, 1111, '1700', 3, '2021-01-05 11:15:05'),
	(1596, NULL, 85, '0808', 1, '2021-01-05 12:36:19'),
	(1597, NULL, 1239, '0515-1', 2, '2021-01-05 13:27:05'),
	(1598, NULL, 1239, '0515-2', 1, '2021-01-05 13:27:44'),
	(1599, NULL, 1239, '0515-1', 2, '2021-01-05 13:50:04'),
	(1600, NULL, 1239, '0515-1', 2, '2021-01-05 13:51:10'),
	(1601, NULL, 1251, '0643', 7, '2021-01-05 14:34:45'),
	(1602, NULL, 1251, '0737-2', 1, '2021-01-05 14:35:14'),
	(1603, NULL, 1251, 'M0642', 5, '2021-01-05 14:35:30'),
	(1604, NULL, 1251, '0738', 0, '2021-01-05 14:43:11'),
	(1605, NULL, 1251, '0738', 0, '2021-01-05 14:43:19'),
	(1606, NULL, 289, '1700', 3, '2021-01-05 16:25:06'),
	(1607, NULL, 289, '1700', 3, '2021-01-05 16:31:24'),
	(1608, NULL, 289, '1700', 3, '2021-01-05 19:59:46'),
	(1609, NULL, 15, 'Amsterdam', 12, '2021-01-06 04:58:00'),
	(1610, NULL, 15, 'Amsterdam', 12, '2021-01-06 04:58:05'),
	(1611, NULL, 15, 'Amsterdam', 12, '2021-01-06 04:58:08'),
	(1612, NULL, 15, 'undefined', 0, '2021-01-06 04:58:10'),
	(1613, NULL, 15, '锁芯', 2, '2021-01-06 05:06:58'),
	(1614, NULL, 15, '锁芯', 2, '2021-01-06 05:07:02'),
	(1615, NULL, 15, '锁芯', 2, '2021-01-06 05:07:04'),
	(1616, NULL, 15, 'undefined', 0, '2021-01-06 05:07:07'),
	(1617, NULL, 15, 'hhh', 0, '2021-01-06 05:23:02'),
	(1618, NULL, 15, 'hhh', 0, '2021-01-06 05:23:05'),
	(1619, NULL, 15, 'hhh', 0, '2021-01-06 05:23:07'),
	(1620, NULL, 15, 'undefined', 0, '2021-01-06 05:23:10'),
	(1621, NULL, 15, '门把手', 78, '2021-01-06 05:39:39'),
	(1622, NULL, 15, '门把手', 78, '2021-01-06 05:39:50'),
	(1623, NULL, 15, '门把手', 78, '2021-01-06 05:40:00'),
	(1624, NULL, 15, 'undefined', 0, '2021-01-06 05:40:05'),
	(1625, NULL, 15, 'Amsterdam', 12, '2021-01-06 05:44:54'),
	(1626, NULL, 15, 'Amsterdam', 12, '2021-01-06 05:45:00'),
	(1627, NULL, 15, 'Amsterdam', 12, '2021-01-06 05:45:02'),
	(1628, NULL, 15, 'undefined', 0, '2021-01-06 05:45:05'),
	(1629, NULL, 15, '锁芯', 2, '2021-01-06 05:52:12'),
	(1630, NULL, 15, '锁芯', 2, '2021-01-06 05:52:15'),
	(1631, NULL, 15, '锁芯', 2, '2021-01-06 05:52:17'),
	(1632, NULL, 15, 'undefined', 0, '2021-01-06 05:52:20'),
	(1633, NULL, 15, 'hhh', 0, '2021-01-06 05:54:39'),
	(1634, NULL, 15, 'hhh', 0, '2021-01-06 05:54:42'),
	(1635, NULL, 15, 'hhh', 0, '2021-01-06 05:54:45'),
	(1636, NULL, 15, 'undefined', 0, '2021-01-06 05:54:47'),
	(1637, NULL, 289, '1700', 3, '2021-01-06 14:29:03'),
	(1638, NULL, 289, '11887096', 0, '2021-01-06 14:29:45'),
	(1639, NULL, 20, 'E138', 0, '2021-01-06 15:11:57'),
	(1640, NULL, 1239, '1751', 2, '2021-01-06 15:22:25'),
	(1641, NULL, 1239, '1540', 1, '2021-01-06 15:23:31'),
	(1642, NULL, 1239, '1558', 3, '2021-01-06 15:24:24'),
	(1643, NULL, 350, '0530', 0, '2021-01-06 15:50:56'),
	(1644, NULL, 350, '0710', 1, '2021-01-06 15:51:11'),
	(1645, NULL, 129, '737', 10, '2021-01-07 09:29:39'),
	(1646, NULL, 129, '0737', 5, '2021-01-07 09:39:58'),
	(1647, NULL, 1111, '646', 1, '2021-01-07 09:59:17'),
	(1648, NULL, 423, '1643', 5, '2021-01-07 10:15:47'),
	(1649, NULL, 423, '1737', 4, '2021-01-07 10:16:27'),
	(1650, NULL, 423, '1642', 4, '2021-01-07 10:16:53'),
	(1651, NULL, 129, '1530', 3, '2021-01-07 10:31:40'),
	(1652, NULL, 129, '1751', 2, '2021-01-07 10:32:29'),
	(1653, NULL, 129, '1558', 3, '2021-01-07 10:35:20'),
	(1654, NULL, 129, '099', 0, '2021-01-07 10:55:56'),
	(1655, NULL, 129, '303', 0, '2021-01-07 10:56:09'),
	(1656, NULL, 129, '1751', 2, '2021-01-07 10:56:20'),
	(1657, NULL, 129, 'kh', 7, '2021-01-07 10:56:34'),
	(1658, NULL, 129, '099', 0, '2021-01-07 10:57:07'),
	(1659, NULL, 129, '013', 0, '2021-01-07 10:57:13'),
	(1660, NULL, 129, '0808', 1, '2021-01-07 10:57:20'),
	(1661, NULL, 129, '0558', 2, '2021-01-07 10:58:35'),
	(1662, NULL, 129, '0715', 2, '2021-01-07 11:00:42'),
	(1663, NULL, 129, '0751', 2, '2021-01-07 11:01:52'),
	(1664, NULL, 268, '0530', 0, '2021-01-07 11:36:31'),
	(1665, NULL, 268, '0530', 0, '2021-01-07 11:36:34'),
	(1666, NULL, 423, 'M1643', 3, '2021-01-07 12:26:08'),
	(1667, NULL, 512, '0530', 0, '2021-01-07 14:08:04'),
	(1668, NULL, 512, '1540', 1, '2021-01-07 14:18:57'),
	(1669, NULL, 935, '1540', 1, '2021-01-07 14:19:04'),
	(1670, NULL, 1239, '0510', 0, '2021-01-07 15:31:12'),
	(1671, NULL, 105, '1558', 3, '2021-01-07 16:46:50'),
	(1672, NULL, 105, '1540', 1, '2021-01-07 16:47:09'),
	(1673, NULL, 105, '3336-ug', 0, '2021-01-07 16:50:03'),
	(1674, NULL, 105, '1751', 2, '2021-01-07 16:50:11'),
	(1675, NULL, 105, '099', 0, '2021-01-07 16:51:12'),
	(1676, NULL, 105, '099kh', 0, '2021-01-07 16:51:28'),
	(1677, NULL, 105, '099kh', 0, '2021-01-07 16:51:45'),
	(1678, NULL, 105, '99kh', 0, '2021-01-07 16:52:17'),
	(1679, NULL, 1957, '0558', 2, '2021-01-07 17:48:41'),
	(1680, NULL, 1213, '0530', 0, '2021-01-07 21:19:33'),
	(1681, NULL, 1213, '0530', 0, '2021-01-07 21:19:41'),
	(1682, NULL, 129, '0737-', 1, '2021-01-08 10:04:01'),
	(1683, NULL, 129, '0737', 5, '2021-01-08 10:06:23'),
	(1684, NULL, 129, '1530/3346', 1, '2021-01-08 10:09:56'),
	(1685, NULL, 129, '099', 0, '2021-01-08 10:12:38'),
	(1686, NULL, 617, '0710', 1, '2021-01-08 10:49:03'),
	(1687, NULL, 423, '172', 2, '2021-01-08 11:13:44'),
	(1688, NULL, 423, '1737', 4, '2021-01-08 11:42:54'),
	(1689, NULL, 423, '138', 2, '2021-01-08 12:31:30'),
	(1690, NULL, 3101, '1140/845', 1, '2021-01-08 13:35:15'),
	(1691, NULL, 3101, '1140F9', 0, '2021-01-08 13:37:26'),
	(1692, NULL, 3101, '1140F9714', 0, '2021-01-08 13:37:37'),
	(1693, NULL, 3101, '门把手', 78, '2021-01-08 13:37:48'),
	(1694, NULL, 1213, '0510', 0, '2021-01-08 14:24:57'),
	(1695, NULL, 1213, '1400/42K/42KS', 1, '2021-01-08 14:29:05'),
	(1696, NULL, 1213, '0558', 2, '2021-01-08 14:30:47'),
	(1697, NULL, 289, 'M1642', 4, '2021-01-08 16:24:53'),
	(1698, NULL, 935, '43l', 0, '2021-01-08 16:35:24'),
	(1699, NULL, 935, '43', 23, '2021-01-08 16:35:28'),
	(1700, NULL, 935, '1643', 5, '2021-01-08 16:36:55'),
	(1701, NULL, 2528, '1530/3346', 1, '2021-01-08 16:42:01'),
	(1702, NULL, 2738, '099kh', 0, '2021-01-08 18:39:07'),
	(1703, NULL, 2738, '099kh', 0, '2021-01-08 19:30:07'),
	(1704, NULL, 2738, '099kh', 0, '2021-01-08 19:30:10'),
	(1705, NULL, 2738, '099kh', 0, '2021-01-08 19:30:22'),
	(1706, NULL, 512, '0510', 0, '2021-01-08 22:03:15'),
	(1707, NULL, 512, '0510', 0, '2021-01-08 22:03:28'),
	(1708, NULL, 512, '0751', 2, '2021-01-08 22:03:36'),
	(1709, NULL, 20, '1808', 1, '2021-01-09 08:37:56'),
	(1710, NULL, 2096, '0515', 5, '2021-01-09 15:44:16'),
	(1711, NULL, 2096, '1751', 2, '2021-01-09 16:39:32'),
	(1712, NULL, 3120, '锁芯', 2, '2021-01-10 15:37:20'),
	(1713, NULL, 3120, '1400/42K/42KS', 1, '2021-01-10 15:38:13'),
	(1714, NULL, 3120, 'hhh', 0, '2021-01-10 15:38:17'),
	(1715, NULL, 15, '1400/42K/42KS', 1, '2021-01-11 03:57:17'),
	(1716, NULL, 15, '1400/42K/42KS', 1, '2021-01-11 03:57:21'),
	(1717, NULL, 15, '1400/42K/42KS', 1, '2021-01-11 03:57:23'),
	(1718, NULL, 15, 'undefined', 0, '2021-01-11 03:57:26'),
	(1719, NULL, 15, 'Amsterdam', 12, '2021-01-11 04:21:28'),
	(1720, NULL, 15, 'Amsterdam', 12, '2021-01-11 04:21:34'),
	(1721, NULL, 15, 'Amsterdam', 12, '2021-01-11 04:21:37'),
	(1722, NULL, 15, 'undefined', 0, '2021-01-11 04:21:40'),
	(1723, NULL, 15, '1400/42K/42KS', 1, '2021-01-11 04:42:26'),
	(1724, NULL, 15, '1400/42K/42KS', 1, '2021-01-11 04:42:29'),
	(1725, NULL, 15, '1400/42K/42KS', 1, '2021-01-11 04:42:32'),
	(1726, NULL, 15, 'undefined', 0, '2021-01-11 04:42:35'),
	(1727, NULL, 15, '锁芯', 2, '2021-01-11 05:01:04'),
	(1728, NULL, 15, '锁芯', 2, '2021-01-11 05:01:07'),
	(1729, NULL, 15, '锁芯', 2, '2021-01-11 05:01:10'),
	(1730, NULL, 15, 'undefined', 0, '2021-01-11 05:01:14'),
	(1731, NULL, 15, 'hhh', 0, '2021-01-11 05:27:46'),
	(1732, NULL, 15, 'hhh', 0, '2021-01-11 05:27:49'),
	(1733, NULL, 15, 'hhh', 0, '2021-01-11 05:27:52'),
	(1734, NULL, 15, 'undefined', 0, '2021-01-11 05:27:55'),
	(1735, NULL, 15, '门把手', 78, '2021-01-11 05:37:34'),
	(1736, NULL, 15, '门把手', 78, '2021-01-11 05:37:45'),
	(1737, NULL, 15, '锁芯', 2, '2021-01-11 05:37:55'),
	(1738, NULL, 15, '门把手', 78, '2021-01-11 05:37:55'),
	(1739, NULL, 15, 'undefined', 0, '2021-01-11 05:38:01'),
	(1740, NULL, 15, '锁芯', 2, '2021-01-11 05:38:02'),
	(1741, NULL, 15, '锁芯', 2, '2021-01-11 05:38:04'),
	(1742, NULL, 15, 'undefined', 0, '2021-01-11 05:38:07'),
	(1743, NULL, 15, 'undefined', 0, '2021-01-11 07:17:50'),
	(1744, NULL, 289, '1643', 5, '2021-01-11 08:31:20'),
	(1745, NULL, 289, '1808', 1, '2021-01-11 08:32:16'),
	(1746, NULL, 289, 'M156', 2, '2021-01-11 08:33:33'),
	(1747, NULL, 289, 'M156', 2, '2021-01-11 09:54:39'),
	(1748, NULL, 14, '1950', 0, '2021-01-11 10:02:13'),
	(1749, NULL, 14, '0558', 2, '2021-01-11 10:14:55'),
	(1750, NULL, 14, '0558', 2, '2021-01-11 10:39:21'),
	(1751, NULL, 14, '429', 1, '2021-01-11 10:39:27'),
	(1752, NULL, 1213, '013', 0, '2021-01-11 11:30:34'),
	(1753, NULL, 17, '0530', 0, '2021-01-11 13:57:22'),
	(1754, NULL, 289, 'M1788', 0, '2021-01-11 14:24:54'),
	(1755, NULL, 1213, '1751', 2, '2021-01-11 16:45:47'),
	(1756, NULL, 1213, '0515', 5, '2021-01-11 22:24:04'),
	(1757, NULL, 289, 'M1515', 1, '2021-01-12 09:47:31'),
	(1758, NULL, 289, 'M1515', 1, '2021-01-12 09:48:37'),
	(1759, NULL, 17, '0738', 0, '2021-01-12 09:53:05'),
	(1760, NULL, 935, '0400', 5, '2021-01-12 10:13:58'),
	(1761, NULL, 935, '0140', 2, '2021-01-12 10:15:31'),
	(1762, NULL, 512, '0400', 5, '2021-01-12 10:30:01'),
	(1763, NULL, 512, '0140', 2, '2021-01-12 10:30:49'),
	(1764, NULL, 1239, '展柱', 0, '2021-01-12 10:37:41'),
	(1765, NULL, 1239, '展架', 0, '2021-01-12 10:37:50'),
	(1766, NULL, 935, 'psk', 6, '2021-01-12 10:51:15'),
	(1767, NULL, 1213, '1710', 0, '2021-01-12 11:24:02'),
	(1768, NULL, 1213, '1715', 0, '2021-01-12 11:24:17'),
	(1769, NULL, 1213, '1751', 2, '2021-01-12 11:24:42'),
	(1770, NULL, 20, 'M35', 0, '2021-01-12 13:16:18'),
	(1771, NULL, 1239, '099', 0, '2021-01-12 15:13:44'),
	(1772, NULL, 423, '1140', 4, '2021-01-12 16:16:40'),
	(1773, NULL, 423, '1643', 5, '2021-01-12 16:24:26'),
	(1774, NULL, 423, '0643', 7, '2021-01-12 16:26:58'),
	(1775, NULL, 2251, 'HS0530', 0, '2021-01-12 16:34:09'),
	(1776, NULL, 423, '0737', 5, '2021-01-12 17:37:22'),
	(1777, NULL, 423, '0737', 5, '2021-01-12 17:41:31'),
	(1778, NULL, 1239, '0558', 2, '2021-01-12 18:18:53'),
	(1779, NULL, 702, '0710', 1, '2021-01-12 20:44:57'),
	(1780, NULL, 702, '0737', 5, '2021-01-12 20:45:37'),
	(1781, NULL, 289, '1530', 3, '2021-01-13 07:09:09'),
	(1782, NULL, 289, '1530', 3, '2021-01-13 07:33:48'),
	(1783, NULL, 289, '1140', 4, '2021-01-13 07:56:23'),
	(1784, NULL, 289, 'M1643', 3, '2021-01-13 08:20:28'),
	(1785, NULL, 289, '1808', 1, '2021-01-13 08:29:31'),
	(1786, NULL, 289, '138', 2, '2021-01-13 08:48:58'),
	(1787, NULL, 289, '138', 2, '2021-01-13 08:50:03'),
	(1788, NULL, 1280, '0515', 5, '2021-01-13 12:06:06'),
	(1789, NULL, 512, '0769', 4, '2021-01-13 16:34:23'),
	(1790, NULL, 1239, '0751', 1, '2021-01-14 13:07:12'),
	(1791, NULL, 617, '门把手', 77, '2021-01-14 13:16:14'),
	(1792, NULL, 350, 'M1515', 1, '2021-01-14 15:09:50'),
	(1793, NULL, 935, '1530', 3, '2021-01-14 15:20:43'),
	(1794, NULL, 20, 'hcs', 8, '2021-01-14 16:41:10'),
	(1795, NULL, 289, 'F4', 0, '2021-01-15 12:11:33'),
	(1796, NULL, 2312, '箭形执手', 0, '2021-01-15 12:41:44'),
	(1797, NULL, 2312, '箭形执', 0, '2021-01-15 12:42:14'),
	(1798, NULL, 1865, '0700', 3, '2021-01-15 14:13:57'),
	(1799, NULL, 1251, '0710VK', 1, '2021-01-15 15:52:23'),
	(1800, NULL, 3221, '0710', 1, '2021-01-15 15:57:42'),
	(1801, NULL, 1239, '0700', 3, '2021-01-16 10:31:12'),
	(1802, NULL, 1921, '1808', 1, '2021-01-16 11:14:14'),
	(1803, NULL, 1921, '1530', 3, '2021-01-16 11:14:21'),
	(1804, NULL, 1921, '8180', 1, '2021-01-16 11:21:04'),
	(1805, NULL, 1921, '7070', 1, '2021-01-16 11:21:28'),
	(1806, NULL, 512, '0515-2', 1, '2021-01-16 11:38:20'),
	(1807, NULL, 512, '0515-1', 2, '2021-01-16 11:40:33'),
	(1808, NULL, 1239, 'M0515', 1, '2021-01-16 13:53:50'),
	(1809, NULL, 1239, 'M051', 1, '2021-01-16 13:54:58'),
	(1810, NULL, 80, '1751', 2, '2021-01-16 14:05:35'),
	(1811, NULL, 3228, '0558', 2, '2021-01-16 16:52:00'),
	(1812, NULL, 2247, '1558', 3, '2021-01-16 16:52:18'),
	(1813, NULL, 2247, '1558', 3, '2021-01-16 16:52:38'),
	(1814, NULL, 2247, '0558', 2, '2021-01-16 16:53:18'),
	(1815, NULL, 3230, '方轴执手', 0, '2021-01-17 08:27:22'),
	(1816, NULL, 3232, 'Amsterdam', 12, '2021-01-17 10:02:20'),
	(1817, NULL, 3230, '11659920', 0, '2021-01-17 10:29:58'),
	(1818, NULL, 1213, '9714', 0, '2021-01-17 13:52:45'),
	(1819, NULL, 1213, '0515', 5, '2021-01-17 13:52:56'),
	(1820, NULL, 1213, '0700', 3, '2021-01-17 13:57:11'),
	(1821, NULL, 2813, '0710', 1, '2021-01-17 21:47:26'),
	(1822, NULL, 2813, '0530', 0, '2021-01-17 21:51:27'),
	(1823, NULL, 2813, '0710', 1, '2021-01-17 21:52:03'),
	(1824, NULL, 289, 'M845', 1, '2021-01-18 12:16:11'),
	(1825, NULL, 512, '0530', 0, '2021-01-18 12:20:55'),
	(1826, NULL, 289, 'M845', 1, '2021-01-18 12:36:35'),
	(1827, NULL, 289, 'M845', 1, '2021-01-18 12:41:05'),
	(1828, NULL, 289, 'M845', 1, '2021-01-18 12:52:42'),
	(1829, NULL, 3240, '滑轮', 0, '2021-01-18 12:52:44'),
	(1830, NULL, 289, '845S', 1, '2021-01-18 14:08:45'),
	(1831, NULL, 289, '845S', 1, '2021-01-18 14:13:52'),
	(1832, NULL, 289, '845S', 1, '2021-01-18 14:39:50'),
	(1833, NULL, 1239, '0558', 2, '2021-01-18 15:02:50'),
	(1834, NULL, 1239, '0737-2', 1, '2021-01-18 15:03:55'),
	(1835, NULL, 3245, '皓涛', 0, '2021-01-18 16:55:31'),
	(1836, NULL, 46, 'M051', 1, '2021-01-18 16:58:49'),
	(1837, NULL, 2247, '1738', 0, '2021-01-19 09:35:47'),
	(1838, NULL, 80, '1738', 0, '2021-01-19 09:35:51'),
	(1839, NULL, 2247, '门把手', 77, '2021-01-19 09:35:52'),
	(1840, NULL, 1239, '0558', 2, '2021-01-19 11:26:05'),
	(1841, NULL, 1239, '0700', 3, '2021-01-19 11:26:38'),
	(1842, NULL, 1239, '0737-2', 1, '2021-01-19 11:27:09'),
	(1843, NULL, 1239, '0808', 1, '2021-01-19 11:29:07'),
	(1844, NULL, 80, '0738', 0, '2021-01-19 13:39:44'),
	(1845, NULL, 8, 'M1788', 0, '2021-01-19 19:36:31'),
	(1846, NULL, 1356, 'A113', 1, '2021-01-20 09:55:30'),
	(1847, NULL, 1356, 'A138', 1, '2021-01-20 09:56:16'),
	(1848, NULL, 1356, 'A1530', 1, '2021-01-20 09:56:52'),
	(1849, NULL, 1356, 'A197', 1, '2021-01-20 09:57:29'),
	(1850, NULL, 617, '0737', 5, '2021-01-20 10:11:14'),
	(1851, NULL, 423, '1140', 4, '2021-01-20 11:24:40'),
	(1852, NULL, 3228, '0738', 0, '2021-01-20 14:00:34'),
	(1853, NULL, 2872, 'Amsterdam', 12, '2021-01-20 15:43:34'),
	(1854, NULL, 289, '1400', 6, '2021-01-20 16:12:29'),
	(1855, NULL, 289, '1140', 4, '2021-01-20 16:14:25'),
	(1856, NULL, 16, 'los', 11, '2021-01-20 22:17:29'),
	(1857, NULL, 16, 'ham', 6, '2021-01-20 22:18:34'),
	(1858, NULL, 16, '845', 9, '2021-01-20 22:21:00'),
	(1859, NULL, 16, '1643', 5, '2021-01-20 22:21:43'),
	(1860, NULL, 16, '1700', 3, '2021-01-20 22:22:08'),
	(1861, NULL, 16, '845', 9, '2021-01-20 22:23:16'),
	(1862, NULL, 16, '843', 5, '2021-01-20 22:34:53'),
	(1863, NULL, 16, '843KS', 5, '2021-01-20 22:35:07'),
	(1864, NULL, 16, '846', 1, '2021-01-20 22:35:29'),
	(1865, NULL, 16, '845', 9, '2021-01-20 22:36:36'),
	(1866, NULL, 16, '1643', 5, '2021-01-20 22:37:58'),
	(1867, NULL, 16, 'Ar681', 1, '2021-01-20 22:39:13'),
	(1868, NULL, 16, 'Ar33', 1, '2021-01-20 22:39:49'),
	(1869, NULL, 16, '96-1', 0, '2021-01-20 22:40:59'),
	(1870, NULL, 16, '96', 0, '2021-01-20 22:41:05'),
	(1871, NULL, 16, 'Dall', 13, '2021-01-20 22:41:57'),
	(1872, NULL, 16, '846', 1, '2021-01-20 22:42:40'),
	(1873, NULL, 16, 'AR33', 1, '2021-01-20 23:19:53'),
	(1874, NULL, 16, '846', 1, '2021-01-21 00:45:20'),
	(1875, NULL, 16, '845', 9, '2021-01-21 00:45:26'),
	(1876, NULL, 80, '0530', 0, '2021-01-21 13:46:08'),
	(1877, NULL, 289, '11650005', 0, '2021-01-21 17:22:35'),
	(1878, NULL, 289, '1140/845', 1, '2021-01-21 17:22:49'),
	(1879, NULL, 289, '11651994', 0, '2021-01-21 17:25:41'),
	(1880, NULL, 289, 'M1643/845', 1, '2021-01-21 17:26:06'),
	(1881, NULL, 289, 'M1643/845', 1, '2021-01-21 17:33:15'),
	(1882, NULL, 289, 'M172', 2, '2021-01-21 18:01:19'),
	(1883, NULL, 289, 'M1788', 0, '2021-01-21 18:01:36'),
	(1884, NULL, 16, '845', 9, '2021-01-21 19:05:50'),
	(1885, NULL, 3297, '845', 9, '2021-01-21 19:08:36'),
	(1886, NULL, 16, '845', 9, '2021-01-21 19:11:35'),
	(1887, NULL, 16, '845', 9, '2021-01-21 22:04:53'),
	(1888, NULL, 16, '846s', 1, '2021-01-21 22:07:02'),
	(1889, NULL, 16, 'AR33', 1, '2021-01-21 22:08:21'),
	(1890, NULL, 16, 'AR681', 1, '2021-01-21 22:09:12'),
	(1891, NULL, 16, '845', 9, '2021-01-21 22:14:21'),
	(1892, NULL, 3299, '0515', 5, '2021-01-22 10:21:06'),
	(1893, NULL, 3299, '0515', 5, '2021-01-22 10:21:11'),
	(1894, NULL, 289, '846', 1, '2021-01-22 11:16:43'),
	(1895, NULL, 702, '0558', 2, '2021-01-22 20:08:25'),
	(1896, NULL, 289, '1515', 2, '2021-01-23 10:20:24'),
	(1897, NULL, 289, 'Kvs', 0, '2021-01-23 10:26:42'),
	(1898, NULL, 289, 'kvs', 0, '2021-01-23 10:26:54'),
	(1899, NULL, 289, 'E138', 0, '2021-01-23 10:31:36'),
	(1900, NULL, 289, 'M1642', 4, '2021-01-23 10:32:07'),
	(1901, NULL, 351, '1751/3346', 1, '2021-01-23 11:08:53'),
	(1902, NULL, 351, '0515-1/US952', 1, '2021-01-23 11:22:24'),
	(1903, NULL, 351, '0710VK-KH/U14K', 1, '2021-01-23 11:27:24'),
	(1904, NULL, 351, '1751/3346', 1, '2021-01-23 12:16:33'),
	(1905, NULL, 2251, '外开窗执手', 0, '2021-01-24 10:50:17'),
	(1906, NULL, 105, '1643', 5, '2021-01-25 09:59:55'),
	(1907, NULL, 289, 'M845S', 1, '2021-01-25 15:11:13'),
	(1908, NULL, 16, '355', 0, '2021-01-26 10:22:27'),
	(1909, NULL, 16, '855', 0, '2021-01-26 10:22:36'),
	(1910, NULL, 16, '855', 0, '2021-01-26 10:22:41'),
	(1911, NULL, 16, 'DALLAS', 13, '2021-01-26 10:22:49'),
	(1912, NULL, 3297, '845', 9, '2021-01-26 10:59:54'),
	(1913, NULL, 16, 'E1400Z', 3, '2021-01-26 11:13:45'),
	(1914, NULL, 16, '1400Z', 4, '2021-01-26 11:15:55'),
	(1915, NULL, 16, 'Amsterdam', 12, '2021-01-26 11:16:08'),
	(1916, NULL, 16, '845', 9, '2021-01-26 11:17:04'),
	(1917, NULL, 339, 'e138', 0, '2021-01-27 15:31:28'),
	(1918, NULL, 1463, '0738', 0, '2021-01-27 16:53:29'),
	(1919, NULL, 3380, '拨叉执手', 0, '2021-01-27 18:24:10'),
	(1920, NULL, 3380, '门把手', 77, '2021-01-27 23:25:31'),
	(1921, NULL, 3380, '拨叉窗把手', 0, '2021-01-27 23:25:53'),
	(1922, NULL, 3380, '窗把手', 32, '2021-01-27 23:26:00'),
	(1923, NULL, 17, 'Paris', 2, '2021-01-29 12:49:35'),
	(1924, NULL, 1111, 'M1558', 1, '2021-01-29 13:33:12'),
	(1925, NULL, 3401, '门把手', 77, '2021-01-29 14:51:43'),
	(1926, NULL, 3401, 'Amsterdam', 12, '2021-01-29 14:51:57'),
	(1927, NULL, 3401, '1400/42K/42KS', 1, '2021-01-29 14:52:00'),
	(1928, NULL, 3401, 'hhh', 0, '2021-01-29 14:52:02'),
	(1929, NULL, 3401, '锁芯', 2, '2021-01-29 14:52:04'),
	(1930, NULL, 3401, '0515', 5, '2021-01-29 14:52:16'),
	(1931, NULL, 3401, '0558', 2, '2021-01-29 14:52:24'),
	(1932, NULL, 3402, '0558', 2, '2021-01-29 14:55:04'),
	(1933, NULL, 3402, '0515', 5, '2021-01-29 14:56:37'),
	(1934, NULL, 512, '1540', 1, '2021-01-29 20:54:16'),
	(1935, NULL, 512, '1558', 3, '2021-01-29 21:00:08'),
	(1936, NULL, 512, '1313', 0, '2021-01-29 21:24:38'),
	(1937, NULL, 1239, '0515', 5, '2021-01-30 08:24:20'),
	(1938, NULL, 1239, '0715', 2, '2021-01-30 08:24:49'),
	(1939, NULL, 702, '0515-1', 2, '2021-01-30 10:17:37'),
	(1940, NULL, 702, '0700', 3, '2021-01-30 10:18:02'),
	(1941, NULL, 15, 'undefined', 0, '2021-01-31 06:14:05'),
	(1942, NULL, 289, '845s', 1, '2021-02-01 12:10:55'),
	(1943, NULL, 289, '845', 9, '2021-02-01 12:11:31'),
	(1944, NULL, 289, '1400/42K/42KS', 1, '2021-02-01 12:11:43'),
	(1945, NULL, 20, 'M846S', 1, '2021-02-01 12:11:45'),
	(1946, NULL, 1111, '846s', 1, '2021-02-01 13:06:52'),
	(1947, NULL, 702, '1623', 2, '2021-02-01 17:27:11'),
	(1948, NULL, 1921, 'M1603', 1, '2021-02-02 08:56:44'),
	(1949, NULL, 1921, 'M1535', 1, '2021-02-02 08:57:47'),
	(1950, NULL, 268, '0700', 3, '2021-02-02 11:25:47'),
	(1951, NULL, 268, '0710', 1, '2021-02-02 11:25:56'),
	(1952, NULL, 304, '0400', 5, '2021-02-02 16:11:51'),
	(1953, NULL, 304, '0140', 2, '2021-02-02 16:12:21'),
	(1954, NULL, 304, '0140', 2, '2021-02-02 16:33:10'),
	(1955, NULL, 304, '0400', 5, '2021-02-02 16:33:32'),
	(1956, NULL, 702, '0515', 5, '2021-02-02 17:58:13'),
	(1957, NULL, 3401, '－2', 0, '2021-02-03 15:54:21'),
	(1958, NULL, 2813, '1400', 6, '2021-02-03 17:25:03'),
	(1959, NULL, 350, 'M051', 1, '2021-02-04 09:56:55'),
	(1960, NULL, 350, 'M051', 1, '2021-02-04 09:57:14'),
	(1961, NULL, 350, 'M051', 1, '2021-02-04 09:58:54'),
	(1962, NULL, 935, '0642', 5, '2021-02-04 14:47:24'),
	(1963, NULL, 935, '0535', 1, '2021-02-04 14:56:06'),
	(1964, NULL, 935, '0515', 5, '2021-02-04 16:38:43'),
	(1965, NULL, 935, '0558', 2, '2021-02-04 16:43:24'),
	(1966, NULL, 935, '1558', 3, '2021-02-04 16:49:12'),
	(1967, NULL, 935, '0515-1', 2, '2021-02-04 17:09:32'),
	(1968, NULL, 935, '0700', 3, '2021-02-04 17:16:04'),
	(1969, NULL, 935, '0558', 2, '2021-02-04 18:12:09'),
	(1970, NULL, 105, 'm0643', 4, '2021-02-05 15:15:53'),
	(1971, NULL, 105, '0643', 7, '2021-02-05 15:16:33'),
	(1972, NULL, 105, '1643', 5, '2021-02-05 15:18:31'),
	(1973, NULL, 105, '643', 12, '2021-02-05 15:18:52'),
	(1974, NULL, 105, 'm1643', 3, '2021-02-06 12:51:05'),
	(1975, NULL, 105, 'm1643', 3, '2021-02-06 12:53:02'),
	(1976, NULL, 935, '0808', 1, '2021-02-07 12:18:57'),
	(1977, NULL, 2327, '锁体', 3, '2021-02-07 13:03:40'),
	(1978, NULL, 2736, '0700', 3, '2021-02-07 13:46:23'),
	(1979, NULL, 16, '8', 38, '2021-02-09 09:54:27'),
	(1980, NULL, 16, '845', 9, '2021-02-09 09:54:40'),
	(1981, NULL, 16, 'HCS', 8, '2021-02-09 09:57:32'),
	(1982, NULL, 1213, '门把手', 77, '2021-02-13 19:51:52'),
	(1983, NULL, 1213, '锁芯', 2, '2021-02-13 19:51:59'),
	(1984, NULL, 1213, '门把手', 77, '2021-02-13 19:52:08'),
	(1985, NULL, 1213, '0715', 2, '2021-02-13 19:53:42'),
	(1986, NULL, 1213, '0808', 1, '2021-02-13 19:54:18'),
	(1987, NULL, 1213, '0558', 2, '2021-02-14 16:49:49'),
	(1988, NULL, 512, '0710', 1, '2021-02-17 21:30:58'),
	(1989, NULL, 512, '0737', 5, '2021-02-18 10:37:18'),
	(1990, NULL, 512, '013', 0, '2021-02-18 10:37:42'),
	(1991, NULL, 702, '0710', 1, '2021-02-18 10:50:59'),
	(1992, NULL, 935, '0558', 2, '2021-02-19 15:03:26'),
	(1993, NULL, 289, 'AR683', 1, '2021-02-20 09:52:53'),
	(1994, NULL, 289, 'AR681', 1, '2021-02-20 09:53:01'),
	(1995, NULL, 289, 'AR683', 1, '2021-02-20 09:53:14'),
	(1996, NULL, 1550, '1140', 4, '2021-02-20 10:39:30'),
	(1997, NULL, 1550, '1535', 1, '2021-02-20 10:39:47'),
	(1998, NULL, 3521, '0515', 5, '2021-02-20 10:58:28'),
	(1999, NULL, 339, '0138', 0, '2021-02-20 13:16:09'),
	(2000, NULL, 268, '0715', 2, '2021-02-20 15:25:05'),
	(2001, NULL, 268, '0715', 2, '2021-02-20 15:27:02'),
	(2002, NULL, 3534, '门把手', 77, '2021-02-21 08:20:25'),
	(2003, NULL, 512, '0737', 5, '2021-02-21 09:37:27'),
	(2004, NULL, 471, '窗把手', 32, '2021-02-21 10:18:31'),
	(2005, NULL, 268, '013', 0, '2021-02-21 17:59:47'),
	(2006, NULL, 268, '0710', 1, '2021-02-21 17:59:53'),
	(2007, NULL, 268, '0710', 1, '2021-02-21 18:01:03'),
	(2008, NULL, 268, '0737', 5, '2021-02-21 18:01:22'),
	(2009, NULL, 2551, '0530', 0, '2021-02-21 21:09:04'),
	(2010, NULL, 2551, '431', 3, '2021-02-21 21:09:16'),
	(2011, NULL, 1319, '0737', 5, '2021-02-22 10:14:53'),
	(2012, NULL, 151, '0515', 5, '2021-02-22 11:32:33'),
	(2013, NULL, 10, '0515', 5, '2021-02-22 15:29:12'),
	(2014, NULL, 1239, '0700', 3, '2021-02-23 08:54:33'),
	(2015, NULL, 1239, '0737', 5, '2021-02-23 08:54:57'),
	(2016, NULL, 1239, '0558', 2, '2021-02-23 09:33:23'),
	(2017, NULL, 1251, '1540', 1, '2021-02-23 11:17:40'),
	(2018, NULL, 17, 'M0642', 5, '2021-02-23 11:29:58'),
	(2019, NULL, 17, 'M0643', 4, '2021-02-23 11:33:40'),
	(2020, NULL, 17, '0737', 5, '2021-02-23 11:33:50'),
	(2021, NULL, 1239, '0530', 0, '2021-02-23 11:38:31'),
	(2022, NULL, 935, '0558', 2, '2021-02-23 12:41:24'),
	(2023, NULL, 702, '0515', 5, '2021-02-23 13:19:07'),
	(2024, NULL, 304, '1769', 4, '2021-02-23 17:32:30'),
	(2025, NULL, 15, 'undefined', 0, '2021-02-24 08:23:41'),
	(2026, NULL, 2857, '0715', 2, '2021-02-24 11:22:38'),
	(2027, NULL, 268, '0751', 1, '2021-02-24 13:36:11'),
	(2028, NULL, 935, '138', 2, '2021-02-24 16:44:07'),
	(2029, NULL, 350, 'HS-0810', 0, '2021-02-25 11:10:51'),
	(2030, NULL, 512, '0737', 5, '2021-02-25 11:11:41'),
	(2031, NULL, 350, 'HS-0810', 0, '2021-02-25 11:12:35'),
	(2032, NULL, 350, 'HS-0810/431N/422', 0, '2021-02-25 11:13:25'),
	(2033, NULL, 1066, '013KH', 0, '2021-02-25 12:34:43'),
	(2034, NULL, 1066, '013KH/U34', 0, '2021-02-25 12:35:04'),
	(2035, NULL, 1251, '0737', 5, '2021-02-25 15:23:13'),
	(2036, NULL, 1251, '0737', 5, '2021-02-25 15:25:45'),
	(2037, NULL, 493, '0700', 3, '2021-02-25 15:41:21'),
	(2038, NULL, 935, '0400', 5, '2021-02-26 17:16:36'),
	(2039, NULL, 935, '0140', 2, '2021-02-26 17:23:51'),
	(2040, NULL, 935, '0140', 2, '2021-02-26 17:24:49'),
	(2041, NULL, 350, '0739s', 0, '2021-02-27 12:27:40'),
	(2042, NULL, 350, '0738', 0, '2021-02-27 12:27:48'),
	(2043, NULL, 350, '窗把手', 32, '2021-02-27 12:28:07'),
	(2044, NULL, 350, '带钥匙', 0, '2021-02-27 12:28:39'),
	(2045, NULL, 1319, '0558', 2, '2021-02-27 15:03:46'),
	(2046, NULL, 1319, '1558', 3, '2021-02-27 15:04:30'),
	(2047, NULL, 1239, '1558', 3, '2021-02-27 15:37:04'),
	(2048, NULL, 1239, '1751', 2, '2021-02-27 15:37:33'),
	(2049, NULL, 1239, '1313G', 0, '2021-02-27 15:37:55'),
	(2050, NULL, 1239, '1540', 1, '2021-02-27 16:20:34'),
	(2051, NULL, 2334, '0737', 5, '2021-02-28 14:25:53'),
	(2052, NULL, 2334, '0558', 2, '2021-02-28 14:26:57'),
	(2053, NULL, 3608, 'ATT60 AD29F', 0, '2021-02-28 15:39:51'),
	(2054, NULL, 3608, 'ATT60', 0, '2021-02-28 15:39:59'),
	(2055, NULL, 3608, 'ATT60', 0, '2021-02-28 15:40:02'),
	(2056, NULL, 3608, 'ATT60', 0, '2021-02-28 15:41:21'),
	(2057, NULL, 350, '0515', 5, '2021-03-01 09:56:19'),
	(2058, NULL, 935, '0700', 3, '2021-03-01 11:52:54'),
	(2059, NULL, 1239, '0558', 2, '2021-03-01 14:16:15'),
	(2060, NULL, 935, '0700', 3, '2021-03-01 14:32:22'),
	(2061, NULL, 935, '0738', 0, '2021-03-01 15:24:04'),
	(2062, NULL, 935, '0738', 0, '2021-03-01 15:24:10'),
	(2063, NULL, 935, '073', 7, '2021-03-01 15:24:17'),
	(2064, NULL, 512, '0738', 0, '2021-03-02 09:58:36'),
	(2065, NULL, 512, '0738', 0, '2021-03-02 09:58:40'),
	(2066, NULL, 1319, '0530', 0, '2021-03-02 10:08:04'),
	(2067, NULL, 1319, '0530', 0, '2021-03-02 10:08:08'),
	(2068, NULL, 1319, '0751', 1, '2021-03-02 10:08:13'),
	(2069, NULL, 1319, '0530', 0, '2021-03-02 10:09:06'),
	(2070, NULL, 1319, '0700', 3, '2021-03-02 10:09:12'),
	(2071, NULL, 1319, '0510', 0, '2021-03-02 10:09:46'),
	(2072, NULL, 1319, '0515', 5, '2021-03-02 10:12:02'),
	(2073, NULL, 1319, '0710', 1, '2021-03-02 10:15:26'),
	(2074, NULL, 935, '0642', 5, '2021-03-02 11:10:43'),
	(2075, NULL, 935, '0642', 5, '2021-03-02 11:13:11'),
	(2076, NULL, 1319, '0558', 2, '2021-03-02 11:39:01'),
	(2077, NULL, 1319, '099', 0, '2021-03-02 11:42:00'),
	(2078, NULL, 935, '0642', 5, '2021-03-02 11:50:20'),
	(2079, NULL, 1239, 'M0642', 5, '2021-03-02 11:56:10'),
	(2080, NULL, 2005, '0530', 0, '2021-03-02 14:16:20'),
	(2081, NULL, 2005, '0558', 2, '2021-03-02 14:18:01'),
	(2082, NULL, 2005, '0515', 5, '2021-03-02 14:18:16'),
	(2083, NULL, 17, 'M0642', 5, '2021-03-02 15:28:25'),
	(2084, NULL, 17, '0737', 5, '2021-03-02 15:30:14'),
	(2085, NULL, 1239, '0515', 5, '2021-03-02 17:09:20'),
	(2086, NULL, 1239, '0558', 2, '2021-03-02 17:09:40'),
	(2087, NULL, 1239, '0700', 3, '2021-03-02 17:10:01'),
	(2088, NULL, 17, '099', 0, '2021-03-03 13:57:54'),
	(2089, NULL, 1683, '0700', 3, '2021-03-03 19:52:22'),
	(2090, NULL, 1683, '0643', 7, '2021-03-03 19:59:52'),
	(2091, NULL, 1019, '11568124', 0, '2021-03-04 10:11:46'),
	(2092, NULL, 3638, 'm158', 0, '2021-03-04 10:35:28'),
	(2093, NULL, 350, '0751', 1, '2021-03-04 11:06:58'),
	(2094, NULL, 14, '18k', 1, '2021-03-04 11:37:20'),
	(2095, NULL, 14, '18k', 1, '2021-03-04 11:37:23'),
	(2096, NULL, 350, '0710', 1, '2021-03-04 12:43:07'),
	(2097, NULL, 1239, '0738', 0, '2021-03-04 14:24:12'),
	(2098, NULL, 3043, '1643', 5, '2021-03-04 14:28:24'),
	(2099, NULL, 350, '0515', 5, '2021-03-04 18:56:46'),
	(2100, NULL, 350, '0710', 1, '2021-03-04 18:57:40'),
	(2101, NULL, 493, '0558', 2, '2021-03-05 09:09:47'),
	(2102, NULL, 2306, '1313G/55', 0, '2021-03-05 09:10:59'),
	(2103, NULL, 2306, '1313G', 0, '2021-03-05 09:11:06'),
	(2104, NULL, 2306, 'LIVEPOOL', 0, '2021-03-05 09:11:15'),
	(2105, NULL, 2306, 'LIVERPOOL', 0, '2021-03-05 09:11:24'),
	(2106, NULL, 2306, 'Liverpool', 0, '2021-03-05 09:11:46'),
	(2107, NULL, 2306, 'M1642', 4, '2021-03-05 09:23:13'),
	(2108, NULL, 350, 'M0515', 1, '2021-03-05 14:16:02'),
	(2109, NULL, 350, 'M1515', 1, '2021-03-05 14:16:14'),
	(2110, NULL, 935, '0530', 0, '2021-03-05 14:24:02'),
	(2111, NULL, 2104, '0530', 0, '2021-03-05 14:24:50'),
	(2112, NULL, 2104, '0530', 0, '2021-03-05 14:25:10'),
	(2113, NULL, 2104, '0530', 0, '2021-03-05 14:25:14'),
	(2114, NULL, 1239, '0700', 3, '2021-03-05 14:29:22'),
	(2115, NULL, 1239, '0738S', 0, '2021-03-05 14:34:26'),
	(2116, NULL, 1239, '0530s', 0, '2021-03-05 14:34:54'),
	(2117, NULL, 3043, '0530', 0, '2021-03-05 14:58:20'),
	(2118, NULL, 3043, '0710', 1, '2021-03-05 15:01:58'),
	(2119, NULL, 3043, '0738', 0, '2021-03-05 15:14:16'),
	(2120, NULL, 3043, '0738', 0, '2021-03-05 15:14:27'),
	(2121, NULL, 3655, '1530', 3, '2021-03-05 15:16:27'),
	(2122, NULL, 56, '提升', 12, '2021-03-05 16:19:33'),
	(2123, NULL, 3656, 'US952', 3, '2021-03-05 16:23:32'),
	(2124, NULL, 187, '0530', 0, '2021-03-05 16:36:51'),
	(2125, NULL, 3299, '0558/0515', 0, '2021-03-06 10:30:41'),
	(2126, NULL, 3299, '0558', 2, '2021-03-06 10:30:56'),
	(2127, NULL, 3299, '0558', 2, '2021-03-06 10:32:00'),
	(2128, NULL, 1019, '0515', 5, '2021-03-06 12:52:41'),
	(2129, NULL, 1865, '0737', 5, '2021-03-06 14:31:50'),
	(2130, NULL, 1239, '0530', 0, '2021-03-06 14:38:16'),
	(2131, NULL, 1213, '0515', 5, '2021-03-06 15:07:23'),
	(2132, NULL, 1213, '0515', 5, '2021-03-06 19:11:20'),
	(2133, NULL, 2327, '锁体', 3, '2021-03-06 20:28:10'),
	(2134, NULL, 2327, '锁芯', 2, '2021-03-06 20:29:11'),
	(2135, NULL, 350, '0530', 0, '2021-03-07 10:18:04'),
	(2136, NULL, 350, '0515', 5, '2021-03-07 10:18:13'),
	(2137, NULL, 350, '0530', 0, '2021-03-07 10:18:38'),
	(2138, NULL, 512, '0558', 2, '2021-03-07 19:07:12'),
	(2139, NULL, 268, '0700', 3, '2021-03-08 10:03:03'),
	(2140, NULL, 268, '0715', 2, '2021-03-08 10:03:24'),
	(2141, NULL, 2306, '1737', 4, '2021-03-08 10:06:01'),
	(2142, NULL, 2306, '1710', 0, '2021-03-08 10:10:56'),
	(2143, NULL, 2306, '1710RH', 0, '2021-03-08 10:11:05'),
	(2144, NULL, 2306, '1737', 4, '2021-03-08 10:12:05'),
	(2145, NULL, 17, '0769', 4, '2021-03-08 10:36:16'),
	(2146, NULL, 1213, '0738', 0, '2021-03-08 13:44:18'),
	(2147, NULL, 268, '1558', 3, '2021-03-08 14:02:10'),
	(2148, NULL, 1213, '0737', 5, '2021-03-08 15:43:11'),
	(2149, NULL, 350, '013', 0, '2021-03-08 16:02:56'),
	(2150, NULL, 1239, '1751', 2, '2021-03-08 16:11:29'),
	(2151, NULL, 1239, '1540', 1, '2021-03-08 16:35:27'),
	(2152, NULL, 1239, '0530', 0, '2021-03-08 17:09:51'),
	(2153, NULL, 3690, '0530', 0, '2021-03-08 17:53:33'),
	(2154, NULL, 3690, '0530', 0, '2021-03-08 17:55:05'),
	(2155, NULL, 3690, '76', 9, '2021-03-08 18:00:34'),
	(2156, NULL, 3690, '76', 9, '2021-03-08 18:00:46'),
	(2157, NULL, 3690, '外开', 0, '2021-03-08 18:02:30'),
	(2158, NULL, 1239, '1810', 1, '2021-03-09 08:42:11'),
	(2159, NULL, 1239, '1810', 1, '2021-03-09 08:48:06'),
	(2160, NULL, 1239, '1540', 1, '2021-03-09 08:57:33'),
	(2161, NULL, 350, '0737', 5, '2021-03-09 10:05:06'),
	(2162, NULL, 2316, '0515', 5, '2021-03-09 10:15:29'),
	(2163, NULL, 268, '0530', 0, '2021-03-09 10:39:09'),
	(2164, NULL, 268, 'HS572', 0, '2021-03-09 10:55:14'),
	(2165, NULL, 268, 'HS-', 11, '2021-03-09 10:55:20'),
	(2166, NULL, 17, '0642', 5, '2021-03-09 10:58:33'),
	(2167, NULL, 17, '0642', 5, '2021-03-09 11:22:30'),
	(2168, NULL, 3652, '4615', 1, '2021-03-09 11:50:00'),
	(2169, NULL, 1239, '0737-2', 1, '2021-03-09 12:58:01'),
	(2170, NULL, 1239, '0737-2', 1, '2021-03-09 14:18:49'),
	(2171, NULL, 1239, '0515', 5, '2021-03-09 14:40:55'),
	(2172, NULL, 1239, '0558', 2, '2021-03-09 14:41:14'),
	(2173, NULL, 1239, '0700', 3, '2021-03-09 14:41:31'),
	(2174, NULL, 17, '0737', 5, '2021-03-09 14:41:41'),
	(2175, NULL, 1239, '0738', 0, '2021-03-09 14:42:02'),
	(2176, NULL, 1239, '0715', 2, '2021-03-09 14:42:10'),
	(2177, NULL, 1239, '1751', 2, '2021-03-09 14:46:32'),
	(2178, NULL, 17, '0737', 5, '2021-03-09 14:50:29'),
	(2179, NULL, 1923, '0530', 0, '2021-03-09 15:01:59'),
	(2180, NULL, 1923, '1400/42K/42KS', 1, '2021-03-09 15:02:06'),
	(2181, NULL, 1923, 'hhh', 0, '2021-03-09 15:02:11'),
	(2182, NULL, 1923, '锁芯', 2, '2021-03-09 15:02:14'),
	(2183, NULL, 1923, '0530', 0, '2021-03-09 15:03:20'),
	(2184, NULL, 3698, '验证真伪', 0, '2021-03-09 15:38:22'),
	(2185, NULL, 512, '0530', 0, '2021-03-09 20:41:24'),
	(2186, NULL, 268, 'HS', 11, '2021-03-10 10:08:05'),
	(2187, NULL, 268, 'HS', 11, '2021-03-10 10:09:35'),
	(2188, NULL, 2334, '0715', 2, '2021-03-10 10:41:54'),
	(2189, NULL, 582, '门把手', 77, '2021-03-10 13:21:42'),
	(2190, NULL, 582, 'Amsterdam', 12, '2021-03-10 13:22:21'),
	(2191, NULL, 582, 'Amsterdam', 12, '2021-03-10 13:22:25'),
	(2192, NULL, 582, '1400/42K/42KS', 1, '2021-03-10 13:22:27'),
	(2193, NULL, 582, 'hhh', 0, '2021-03-10 13:22:29'),
	(2194, NULL, 582, '锁芯', 2, '2021-03-10 13:22:31'),
	(2195, NULL, 17, '1530', 3, '2021-03-10 13:58:42'),
	(2196, NULL, 17, '0558', 2, '2021-03-10 14:00:25'),
	(2197, NULL, 17, '1558', 3, '2021-03-10 14:00:34'),
	(2198, NULL, 268, '0700', 3, '2021-03-10 15:34:50'),
	(2199, NULL, 268, '0710', 1, '2021-03-10 15:35:19'),
	(2200, NULL, 1280, '0515', 5, '2021-03-11 11:56:27'),
	(2201, NULL, 1280, '0515', 5, '2021-03-11 11:57:14'),
	(2202, NULL, 17, '0737', 5, '2021-03-11 13:42:17'),
	(2203, NULL, 17, '0558', 2, '2021-03-11 13:43:20'),
	(2204, NULL, 17, '558', 5, '2021-03-11 13:43:31'),
	(2205, NULL, 17, '558', 5, '2021-03-11 13:43:54'),
	(2206, NULL, 3717, '558', 5, '2021-03-11 13:44:10'),
	(2207, NULL, 17, '737', 10, '2021-03-11 13:44:44'),
	(2208, NULL, 3717, '737', 10, '2021-03-11 13:44:44'),
	(2209, NULL, 17, '515', 8, '2021-03-11 13:46:04'),
	(2210, NULL, 17, '737', 10, '2021-03-11 13:46:25'),
	(2211, NULL, 3717, '710', 1, '2021-03-11 13:47:03'),
	(2212, NULL, 17, '710', 1, '2021-03-11 13:47:18'),
	(2213, NULL, 3717, '710', 1, '2021-03-11 13:47:20'),
	(2214, NULL, 350, '0700', 3, '2021-03-11 14:07:26'),
	(2215, NULL, 350, '0710', 1, '2021-03-11 14:08:18'),
	(2216, NULL, 1239, '1751', 2, '2021-03-11 14:50:39'),
	(2217, NULL, 1280, '0515', 5, '2021-03-11 15:02:28'),
	(2218, NULL, 2306, '0700-UD', 0, '2021-03-11 17:40:41'),
	(2219, NULL, 2306, '0700-UD9020', 0, '2021-03-11 17:40:50'),
	(2220, NULL, 3652, 'Amsterdam', 12, '2021-03-11 20:10:40'),
	(2221, NULL, 17, '1530', 3, '2021-03-12 08:10:09'),
	(2222, NULL, 17, '1751', 2, '2021-03-12 08:13:39'),
	(2223, NULL, 17, '1751', 2, '2021-03-12 08:33:42'),
	(2224, NULL, 17, '0700', 3, '2021-03-12 08:33:49'),
	(2225, NULL, 1239, '099', 0, '2021-03-12 09:58:37'),
	(2226, NULL, 423, '810', 3, '2021-03-12 10:16:26'),
	(2227, NULL, 423, '681', 1, '2021-03-12 10:19:24'),
	(2228, NULL, 1319, '0515', 5, '2021-03-12 11:00:26'),
	(2229, NULL, 1319, '9005', 0, '2021-03-12 11:00:47'),
	(2230, NULL, 1319, 'F1', 0, '2021-03-12 11:00:58'),
	(2231, NULL, 1319, '0515', 5, '2021-03-12 11:03:18'),
	(2232, NULL, 1319, '0510', 0, '2021-03-12 11:03:39'),
	(2233, NULL, 1319, '0810', 1, '2021-03-12 11:03:52'),
	(2234, NULL, 1319, '013', 0, '2021-03-12 11:04:02'),
	(2235, NULL, 1319, '0530', 0, '2021-03-12 11:04:13'),
	(2236, NULL, 1319, '0710', 1, '2021-03-12 11:04:19'),
	(2237, NULL, 512, '0710', 1, '2021-03-12 12:16:14'),
	(2238, NULL, 17, 'm0545', 0, '2021-03-12 12:25:26'),
	(2239, NULL, 17, 'M0558', 1, '2021-03-12 12:26:34'),
	(2240, NULL, 17, 'M0642', 5, '2021-03-12 12:27:23'),
	(2241, NULL, 17, 'M051', 1, '2021-03-12 12:28:05'),
	(2242, NULL, 1239, '0710', 1, '2021-03-12 13:40:03'),
	(2243, NULL, 268, 'psk', 6, '2021-03-12 14:35:50'),
	(2244, NULL, 193, 'HS-0530', 0, '2021-03-12 17:41:10'),
	(2245, NULL, 350, '0700', 3, '2021-03-13 10:18:05'),
	(2246, NULL, 350, '0730', 0, '2021-03-13 10:18:49'),
	(2247, NULL, 350, '0700', 3, '2021-03-13 10:21:12'),
	(2248, NULL, 1239, '1751', 2, '2021-03-13 12:03:29'),
	(2249, NULL, 617, '013KH', 0, '2021-03-13 12:08:03'),
	(2250, NULL, 617, '013', 0, '2021-03-13 12:08:20'),
	(2251, NULL, 617, '013', 0, '2021-03-13 12:08:29'),
	(2252, NULL, 617, '013', 0, '2021-03-13 12:08:38'),
	(2253, NULL, 617, '013', 0, '2021-03-13 12:09:07'),
	(2254, NULL, 617, '013', 0, '2021-03-13 12:10:00'),
	(2255, NULL, 283, '0558', 2, '2021-03-13 17:36:21'),
	(2256, NULL, 3221, 'hs', 11, '2021-03-13 17:59:48'),
	(2257, NULL, 3221, '0530', 0, '2021-03-13 18:00:20'),
	(2258, NULL, 1251, 'HS0737', 0, '2021-03-13 18:31:58'),
	(2259, NULL, 1251, '0737', 5, '2021-03-13 18:32:06'),
	(2260, NULL, 3221, '0737', 5, '2021-03-13 18:36:19'),
	(2261, NULL, 1213, '0715', 2, '2021-03-14 12:54:36'),
	(2262, NULL, 350, '0700', 3, '2021-03-15 10:34:21'),
	(2263, NULL, 350, '0751', 1, '2021-03-15 10:35:18'),
	(2264, NULL, 350, '0515-1', 2, '2021-03-15 10:37:15'),
	(2265, NULL, 350, '0558', 2, '2021-03-15 10:39:29'),
	(2266, NULL, 935, '0515-1', 2, '2021-03-15 12:16:45'),
	(2267, NULL, 17, '4615', 1, '2021-03-15 13:18:29'),
	(2268, NULL, 935, '0738', 0, '2021-03-15 13:23:31'),
	(2269, NULL, 17, '515', 8, '2021-03-15 13:31:48'),
	(2270, NULL, 1213, '0558', 2, '2021-03-15 13:54:09'),
	(2271, NULL, 1213, '0710', 1, '2021-03-15 13:54:41'),
	(2272, NULL, 1865, '0738', 0, '2021-03-15 14:26:00'),
	(2273, NULL, 1865, '0738', 0, '2021-03-15 14:26:05'),
	(2274, NULL, 2334, '0715', 2, '2021-03-15 14:30:15'),
	(2275, NULL, 2334, '0700', 3, '2021-03-15 14:30:45'),
	(2276, NULL, 1683, '0751', 1, '2021-03-15 16:37:17'),
	(2277, NULL, 339, '1530', 3, '2021-03-15 17:12:33'),
	(2278, NULL, 3717, '558', 5, '2021-03-15 18:09:23'),
	(2279, NULL, 1213, '0738', 0, '2021-03-15 18:41:46'),
	(2280, NULL, 1213, '0715', 2, '2021-03-15 18:41:55'),
	(2281, NULL, 350, 'M051', 1, '2021-03-15 20:38:29'),
	(2282, NULL, 350, 'M0515', 1, '2021-03-15 20:39:23'),
	(2283, NULL, 17, '0737', 5, '2021-03-16 09:38:26'),
	(2284, NULL, 512, '0710', 1, '2021-03-16 10:00:11'),
	(2285, NULL, 17, '1313', 0, '2021-03-16 10:17:03'),
	(2286, NULL, 1239, '1558', 3, '2021-03-16 10:34:28'),
	(2287, NULL, 80, '0717', 0, '2021-03-16 10:53:12'),
	(2288, NULL, 2247, '0738', 0, '2021-03-16 10:55:54'),
	(2289, NULL, 350, '1530', 3, '2021-03-16 11:47:43'),
	(2290, NULL, 1239, '0710', 1, '2021-03-16 14:42:54'),
	(2291, NULL, 1239, '013', 0, '2021-03-16 14:43:09'),
	(2292, NULL, 702, '1643', 5, '2021-03-16 14:56:59'),
	(2293, NULL, 702, '1623', 2, '2021-03-16 14:57:15'),
	(2294, NULL, 617, '0515', 5, '2021-03-16 15:16:55'),
	(2295, NULL, 617, '0510', 0, '2021-03-16 15:18:41'),
	(2296, NULL, 617, '0510', 0, '2021-03-16 15:18:45'),
	(2297, NULL, 617, '0510', 0, '2021-03-16 15:19:01'),
	(2298, NULL, 1239, '099', 0, '2021-03-16 15:23:32'),
	(2299, NULL, 3811, '0738', 0, '2021-03-16 15:48:45'),
	(2300, NULL, 3811, '0738', 0, '2021-03-16 15:50:00'),
	(2301, NULL, 702, '0751', 1, '2021-03-16 16:32:03'),
	(2302, NULL, 3808, '0510', 0, '2021-03-16 17:27:44'),
	(2303, NULL, 3808, '0515', 5, '2021-03-16 17:27:53'),
	(2304, NULL, 3808, '锁芯', 2, '2021-03-16 17:28:02'),
	(2305, NULL, 3808, 'hhh', 0, '2021-03-16 17:28:19'),
	(2306, NULL, 3808, '1400/42K/42KS', 1, '2021-03-16 17:28:21'),
	(2307, NULL, 3808, '门把手', 77, '2021-03-16 17:28:24'),
	(2308, NULL, 17, '1558', 3, '2021-03-16 18:02:28'),
	(2309, NULL, 1239, '0700', 3, '2021-03-16 18:07:15'),
	(2310, NULL, 1239, '0515', 5, '2021-03-16 19:55:50'),
	(2311, NULL, 1239, '0558', 2, '2021-03-16 19:56:07'),
	(2312, NULL, 702, '1400/42K/42KS', 1, '2021-03-16 21:12:48'),
	(2313, NULL, 702, '1700', 3, '2021-03-16 21:13:54'),
	(2314, NULL, 702, '0700', 3, '2021-03-16 21:14:16'),
	(2315, NULL, 1683, '0700', 3, '2021-03-16 21:18:59'),
	(2316, NULL, 935, '0140', 2, '2021-03-17 09:28:19'),
	(2317, NULL, 3043, '0710', 1, '2021-03-17 09:30:01'),
	(2318, NULL, 350, 'M0515', 1, '2021-03-17 10:33:52'),
	(2319, NULL, 350, 'M1515', 1, '2021-03-17 10:34:01'),
	(2320, NULL, 1683, 'M1515', 1, '2021-03-17 10:38:25'),
	(2321, NULL, 3299, '0515', 5, '2021-03-17 10:52:16'),
	(2322, NULL, 17, '515', 8, '2021-03-17 11:38:01'),
	(2323, NULL, 3736, '515', 8, '2021-03-17 11:38:05'),
	(2324, NULL, 17, 'Resista', 0, '2021-03-17 11:41:06'),
	(2325, NULL, 17, 'Resista', 0, '2021-03-17 11:41:33'),
	(2326, NULL, 17, '表面处理', 0, '2021-03-17 11:59:02'),
	(2327, NULL, 17, '处理', 0, '2021-03-17 11:59:18'),
	(2328, NULL, 17, '515', 8, '2021-03-17 12:35:52'),
	(2329, NULL, 17, '558', 5, '2021-03-17 12:38:01'),
	(2330, NULL, 268, '0808', 1, '2021-03-17 13:17:02'),
	(2331, NULL, 304, 'M846s', 1, '2021-03-17 14:40:49'),
	(2332, NULL, 304, '1558/2830N', 1, '2021-03-17 14:41:15'),
	(2333, NULL, 17, '0737', 5, '2021-03-17 14:51:58'),
	(2334, NULL, 1239, '0700', 3, '2021-03-17 16:09:30'),
	(2335, NULL, 1239, '0737-2', 1, '2021-03-17 16:10:00'),
	(2336, NULL, 1239, '1558', 3, '2021-03-17 16:10:27'),
	(2337, NULL, 3051, '0738', 0, '2021-03-17 19:01:19'),
	(2338, NULL, 423, '0710', 1, '2021-03-17 20:06:00'),
	(2339, NULL, 493, '0715', 2, '2021-03-18 08:36:25'),
	(2340, NULL, 1239, '0737-2', 1, '2021-03-18 09:39:42'),
	(2341, NULL, 1239, '0710', 1, '2021-03-18 10:02:42'),
	(2342, NULL, 17, '0739', 2, '2021-03-18 10:19:57'),
	(2343, NULL, 3808, '0515F73', 0, '2021-03-18 10:56:49'),
	(2344, NULL, 3808, '黄铜执手', 0, '2021-03-18 10:57:33'),
	(2345, NULL, 350, 'm1515', 1, '2021-03-18 11:02:45'),
	(2346, NULL, 2741, 'M1643', 3, '2021-03-18 12:23:54'),
	(2347, NULL, 2741, '1643', 5, '2021-03-18 12:24:58'),
	(2348, NULL, 350, '0558', 2, '2021-03-18 12:50:36'),
	(2349, NULL, 350, '0710', 1, '2021-03-18 12:51:39'),
	(2350, NULL, 2741, 'M1643', 3, '2021-03-18 13:54:09'),
	(2351, NULL, 350, '0715', 2, '2021-03-18 13:56:05'),
	(2352, NULL, 350, '0738', 0, '2021-03-18 13:56:16'),
	(2353, NULL, 935, '0738', 0, '2021-03-18 14:56:11'),
	(2354, NULL, 935, '0751', 1, '2021-03-18 14:56:17'),
	(2355, NULL, 17, '515', 8, '2021-03-18 15:20:45'),
	(2356, NULL, 17, '558', 5, '2021-03-18 15:20:51'),
	(2357, NULL, 17, '1530', 3, '2021-03-18 15:33:32'),
	(2358, NULL, 17, '530', 3, '2021-03-18 15:33:40'),
	(2359, NULL, 17, '530', 3, '2021-03-18 15:33:50'),
	(2360, NULL, 3853, '内开内倒五金件', 0, '2021-03-18 19:32:06'),
	(2361, NULL, 280, '9010', 0, '2021-03-18 19:52:59'),
	(2362, NULL, 3853, '隐藏式上悬配件', 0, '2021-03-18 19:58:18'),
	(2363, NULL, 935, '0738', 0, '2021-03-18 20:07:45'),
	(2364, NULL, 935, '钥匙', 0, '2021-03-18 22:26:52'),
	(2365, NULL, 935, '0738s', 0, '2021-03-18 22:28:09'),
	(2366, NULL, 935, '0530s', 0, '2021-03-18 22:28:23'),
	(2367, NULL, 935, '0530', 0, '2021-03-18 22:28:31'),
	(2368, NULL, 17, '1530', 3, '2021-03-19 07:25:18'),
	(2369, NULL, 17, '3347', 3, '2021-03-19 07:25:26'),
	(2370, NULL, 17, '3347', 3, '2021-03-19 07:27:34'),
	(2371, NULL, 1239, '0700', 3, '2021-03-19 09:30:50'),
	(2372, NULL, 1239, '0751', 1, '2021-03-19 09:31:22'),
	(2373, NULL, 1239, '0737-2', 1, '2021-03-19 09:32:47'),
	(2374, NULL, 1239, '0558', 2, '2021-03-19 09:33:12'),
	(2375, NULL, 617, '0737', 5, '2021-03-19 09:56:37'),
	(2376, NULL, 1319, '1530', 3, '2021-03-19 10:00:22'),
	(2377, NULL, 1319, '1530G', 0, '2021-03-19 10:00:43'),
	(2378, NULL, 1239, '0738', 0, '2021-03-19 10:00:52'),
	(2379, NULL, 1239, '0808', 1, '2021-03-19 10:00:59'),
	(2380, NULL, 350, '0530', 0, '2021-03-19 11:47:22'),
	(2381, NULL, 350, '0515-1', 2, '2021-03-19 11:47:36'),
	(2382, NULL, 1251, '0737', 5, '2021-03-19 11:47:46'),
	(2383, NULL, 1239, '0515', 5, '2021-03-19 14:28:57'),
	(2384, NULL, 1239, '0700', 3, '2021-03-19 14:35:46'),
	(2385, NULL, 1239, '0558', 2, '2021-03-19 14:38:09'),
	(2386, NULL, 350, 'M0515', 1, '2021-03-19 15:25:00'),
	(2387, NULL, 3043, '013', 0, '2021-03-19 15:56:48'),
	(2388, NULL, 3043, '013', 0, '2021-03-19 15:56:55'),
	(2389, NULL, 512, '1558', 3, '2021-03-19 16:28:57'),
	(2390, NULL, 1239, '0515', 5, '2021-03-19 16:55:46'),
	(2391, NULL, 1865, '0738', 0, '2021-03-20 11:36:56'),
	(2392, NULL, 617, '0515', 5, '2021-03-20 15:50:51'),
	(2393, NULL, 17, '737', 10, '2021-03-20 16:41:45'),
	(2394, NULL, 17, '700', 6, '2021-03-20 16:42:07'),
	(2395, NULL, 17, '515', 8, '2021-03-20 16:42:22'),
	(2396, NULL, 1683, '572', 0, '2021-03-21 13:17:33'),
	(2397, NULL, 935, '038', 0, '2021-03-22 10:11:56'),
	(2398, NULL, 1251, '0530/U76', 0, '2021-03-22 10:52:47'),
	(2399, NULL, 1251, '0530/U76', 0, '2021-03-22 10:52:52'),
	(2400, NULL, 140, '1643', 5, '2021-03-22 12:20:25'),
	(2401, NULL, 3873, '013', 0, '2021-03-22 13:06:32'),
	(2402, NULL, 3696, '0700', 3, '2021-03-22 13:08:00'),
	(2403, NULL, 423, '810', 3, '2021-03-22 13:11:47'),
	(2404, NULL, 3873, '0700', 3, '2021-03-22 13:13:11'),
	(2405, NULL, 617, '0737', 5, '2021-03-22 15:20:05'),
	(2406, NULL, 681, '013', 0, '2021-03-22 16:33:13'),
	(2407, NULL, 1213, '0710', 1, '2021-03-22 17:40:09'),
	(2408, NULL, 3900, '门把手', 77, '2021-03-22 18:57:39'),
	(2409, NULL, 1239, '0715', 2, '2021-03-22 19:03:03'),
	(2410, NULL, 350, '0515-1', 2, '2021-03-23 16:18:18'),
	(2411, NULL, 935, '0715', 2, '2021-03-23 16:57:01'),
	(2412, NULL, 146, 'Amsterdam', 12, '2021-03-24 13:13:07'),
	(2413, NULL, 17, '0737', 5, '2021-03-24 13:47:48'),
	(2414, NULL, 17, '0558', 2, '2021-03-24 13:48:18'),
	(2415, NULL, 702, '0751', 1, '2021-03-24 14:29:22'),
	(2416, NULL, 350, 'M1515', 1, '2021-03-24 14:54:38'),
	(2417, NULL, 617, '0643', 7, '2021-03-24 15:38:25'),
	(2418, NULL, 2316, '门把手', 77, '2021-03-25 08:43:33'),
	(2419, NULL, 3873, '窗把手', 32, '2021-03-25 09:35:23'),
	(2420, NULL, 3873, '按压把手', 0, '2021-03-25 09:37:32'),
	(2421, NULL, 3873, '0530', 0, '2021-03-25 09:46:46'),
	(2422, NULL, 350, '0700', 3, '2021-03-25 11:33:28'),
	(2423, NULL, 3950, 'Amsterdam', 12, '2021-03-25 12:12:22'),
	(2424, NULL, 3950, '门把手', 77, '2021-03-25 12:12:31'),
	(2425, NULL, 3950, '锁芯', 2, '2021-03-25 12:12:36'),
	(2426, NULL, 935, '0515', 5, '2021-03-25 12:47:38'),
	(2427, NULL, 935, '0530', 0, '2021-03-25 12:50:11'),
	(2428, NULL, 268, '1737', 4, '2021-03-25 14:03:17'),
	(2429, NULL, 2242, 'Austin', 9, '2021-03-25 14:20:13'),
	(2430, NULL, 268, '1737', 4, '2021-03-25 14:26:28'),
	(2431, NULL, 193, '1737', 4, '2021-03-25 14:30:03'),
	(2432, NULL, 268, '1751', 2, '2021-03-25 14:52:07'),
	(2433, NULL, 2242, '1558', 3, '2021-03-25 15:50:17'),
	(2434, NULL, 11, 'Amsterdam', 12, '2021-03-25 16:16:46'),
	(2435, NULL, 11, '门把手', 77, '2021-03-25 16:16:52'),
	(2436, NULL, 3966, '11659920', 0, '2021-03-25 16:54:15'),
	(2437, NULL, 3966, '0710VK', 1, '2021-03-25 16:54:46'),
	(2438, NULL, 3966, '0737-2', 1, '2021-03-25 16:55:43'),
	(2439, NULL, 3966, '0737FL', 1, '2021-03-25 16:56:42'),
	(2440, NULL, 3966, 'psk-0751', 0, '2021-03-25 16:58:31'),
	(2441, NULL, 3966, '0751', 1, '2021-03-25 16:58:46'),
	(2442, NULL, 3966, '0530', 0, '2021-03-25 16:59:27'),
	(2443, NULL, 935, '0738', 0, '2021-03-25 17:20:53'),
	(2444, NULL, 17, '947', 2, '2021-03-25 19:25:22'),
	(2445, NULL, 17, '642', 10, '2021-03-25 19:25:36'),
	(2446, NULL, 17, '1558', 3, '2021-03-25 19:26:32'),
	(2447, NULL, 17, '847', 0, '2021-03-25 19:26:40'),
	(2448, NULL, 14, '844', 4, '2021-03-25 19:28:00'),
	(2449, NULL, 17, '1558', 3, '2021-03-25 19:30:34'),
	(2450, NULL, 17, '947', 2, '2021-03-25 19:32:45'),
	(2451, NULL, 17, '910', 2, '2021-03-25 19:33:11'),
	(2452, NULL, 17, '138', 2, '2021-03-25 19:57:55'),
	(2453, NULL, 17, '1400', 6, '2021-03-25 19:58:01'),
	(2454, NULL, 17, '1313', 0, '2021-03-25 19:58:11'),
	(2455, NULL, 17, '1313', 0, '2021-03-25 19:58:18'),
	(2456, NULL, 17, '138', 2, '2021-03-25 19:58:32'),
	(2457, NULL, 17, '1558', 3, '2021-03-26 07:59:37'),
	(2458, NULL, 17, '642', 10, '2021-03-26 07:59:55'),
	(2459, NULL, 17, '642', 10, '2021-03-26 08:09:22'),
	(2460, NULL, 17, '1558', 3, '2021-03-26 08:20:04'),
	(2461, NULL, 80, '0530', 0, '2021-03-26 09:23:24'),
	(2462, NULL, 423, '1530', 3, '2021-03-26 10:09:21'),
	(2463, NULL, 423, 'M1530', 0, '2021-03-26 10:09:37'),
	(2464, NULL, 423, '门把手', 77, '2021-03-26 10:09:47'),
	(2465, NULL, 268, '1751', 2, '2021-03-26 10:13:33'),
	(2466, NULL, 423, 'M1603', 1, '2021-03-26 10:14:35'),
	(2467, NULL, 423, '1623', 2, '2021-03-26 10:16:47'),
	(2468, NULL, 423, '810', 3, '2021-03-26 13:58:16'),
	(2469, NULL, 617, '0737', 5, '2021-03-26 14:38:26'),
	(2470, NULL, 1239, '0558', 2, '2021-03-26 15:23:32'),
	(2471, NULL, 1239, '0700', 3, '2021-03-26 15:24:34'),
	(2472, NULL, 17, '0710', 1, '2021-03-26 18:10:08'),
	(2473, NULL, 1683, '0175', 0, '2021-03-26 21:17:41'),
	(2474, NULL, 268, 'HS', 11, '2021-03-27 09:32:25'),
	(2475, NULL, 1683, '0728', 0, '2021-03-27 09:42:19'),
	(2476, NULL, 1683, '0769', 4, '2021-03-27 09:43:27'),
	(2477, NULL, 16, 'Amsterdam', 12, '2021-03-27 13:40:22'),
	(2478, NULL, 16, '845', 9, '2021-03-27 13:40:27'),
	(2479, NULL, 16, '845', 9, '2021-03-27 13:40:33'),
	(2480, NULL, 3997, '845', 9, '2021-03-27 13:42:46'),
	(2481, NULL, 617, '1751', 2, '2021-03-27 14:19:18'),
	(2482, NULL, 268, '0710', 1, '2021-03-27 17:04:28'),
	(2483, NULL, 2334, '0737', 5, '2021-03-27 17:13:33'),
	(2484, NULL, 1535, '031k', 0, '2021-03-28 08:22:55'),
	(2485, NULL, 1535, '031', 0, '2021-03-28 08:23:02'),
	(2486, NULL, 4005, '好博', 0, '2021-03-28 11:12:00'),
	(2487, NULL, 4005, 'hop', 0, '2021-03-28 11:13:02'),
	(2488, NULL, 4005, '门把手', 77, '2021-03-28 11:13:51'),
	(2489, NULL, 4005, 'hop', 0, '2021-03-28 11:14:10'),
	(2490, NULL, 4005, 'hoppe', 0, '2021-03-28 11:14:28'),
	(2491, NULL, 1239, '0700', 3, '2021-03-28 11:22:47'),
	(2492, NULL, 4009, '门把手', 77, '2021-03-28 12:55:43'),
	(2493, NULL, 4009, '锁芯', 2, '2021-03-28 12:55:54'),
	(2494, NULL, 4009, '1400/42K/42KS', 1, '2021-03-28 12:55:57'),
	(2495, NULL, 4009, 'Amsterdam', 12, '2021-03-28 12:56:00'),
	(2496, NULL, 4009, 'undefined', 0, '2021-03-28 12:56:08'),
	(2497, NULL, 350, '0710', 1, '2021-03-28 17:39:28'),
	(2498, NULL, 268, '0710', 1, '2021-03-29 09:39:12'),
	(2499, NULL, 268, '013', 0, '2021-03-29 09:39:46'),
	(2500, NULL, 268, '0737', 5, '2021-03-29 09:39:53');
/*!40000 ALTER TABLE `search_product_log` ENABLE KEYS */;

-- 导出  表 hoppe.search_store_log 结构
CREATE TABLE IF NOT EXISTS `search_store_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `token` varchar(50) DEFAULT NULL COMMENT '搜索人token',
  `uid` int(11) DEFAULT NULL COMMENT '搜索人token对应的id',
  `keyword` varchar(50) DEFAULT NULL COMMENT '搜索内容',
  `result` int(11) DEFAULT NULL COMMENT '是否有结果',
  `create_time` datetime DEFAULT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=410 DEFAULT CHARSET=utf8mb4 COMMENT='门店搜索 日志';

-- 正在导出表  hoppe.search_store_log 的数据：~218 rows (大约)
/*!40000 ALTER TABLE `search_store_log` DISABLE KEYS */;
REPLACE INTO `search_store_log` (`id`, `token`, `uid`, `keyword`, `result`, `create_time`) VALUES
	(192, NULL, 33, '好博五金', 0, '2020-10-26 17:59:55'),
	(193, NULL, 38, '温州', 2, '2020-10-26 18:15:39'),
	(194, NULL, 49, '好博五金', 0, '2020-10-26 19:01:05'),
	(195, NULL, 68, '西安', 0, '2020-10-26 20:08:08'),
	(196, NULL, 116, '济南', 0, '2020-10-27 06:05:27'),
	(197, NULL, 116, '济南', 0, '2020-10-27 06:05:42'),
	(198, NULL, 116, '济南', 0, '2020-10-27 06:05:48'),
	(199, NULL, 116, '济南', 0, '2020-10-27 06:05:52'),
	(200, NULL, 121, 'HOPPE 好博专卖店', 0, '2020-10-27 08:13:46'),
	(201, NULL, 121, '铁力路店', 0, '2020-10-27 08:13:53'),
	(202, NULL, 121, 'HOPPE 好博专卖店', 0, '2020-10-27 08:14:11'),
	(203, NULL, 121, '好博五金', 0, '2020-10-27 08:14:15'),
	(204, NULL, 209, 'HOPPE 好博专卖店', 0, '2020-10-27 21:25:48'),
	(205, NULL, 209, '宜兴市', 0, '2020-10-27 21:25:58'),
	(206, NULL, 219, '好博门店', 0, '2020-10-27 22:10:46'),
	(207, NULL, 219, '徐家汇店', 0, '2020-10-27 22:10:52'),
	(208, NULL, 219, '好博五金', 0, '2020-10-27 22:10:55'),
	(209, NULL, 219, 'HOPPE 好博专卖店', 0, '2020-10-27 22:10:57'),
	(210, NULL, 207, '好博五金', 0, '2020-10-27 23:55:35'),
	(211, NULL, 245, '*', 0, '2020-10-28 00:18:13'),
	(212, NULL, 261, '好博五金', 0, '2020-10-28 07:58:23'),
	(213, NULL, 275, 'HOPPE 好博专卖店', 0, '2020-10-28 12:51:37'),
	(214, NULL, 279, '济南', 0, '2020-10-28 13:50:51'),
	(215, NULL, 279, '济南', 0, '2020-10-28 13:51:13'),
	(216, NULL, 279, '济南', 0, '2020-10-28 13:51:15'),
	(217, NULL, 20, '常州', 3, '2020-10-28 13:54:40'),
	(218, NULL, 298, '好博五金', 0, '2020-10-28 19:46:23'),
	(219, NULL, 301, '北京', 0, '2020-10-28 22:16:26'),
	(220, NULL, 307, '好博五金', 0, '2020-10-29 09:17:26'),
	(221, NULL, 265, '上海', 3, '2020-10-29 10:35:12'),
	(222, NULL, 391, '佛山', 0, '2020-10-29 11:10:55'),
	(223, NULL, 391, '佛山', 0, '2020-10-29 11:11:08'),
	(224, NULL, 678, '临沂', 0, '2020-10-29 19:24:57'),
	(225, NULL, 678, '好博门店', 0, '2020-10-29 19:25:00'),
	(226, NULL, 678, '好博门店', 0, '2020-10-29 19:25:14'),
	(227, NULL, 706, '西安', 0, '2020-10-30 09:33:35'),
	(228, NULL, 719, '成都', 0, '2020-10-30 09:50:41'),
	(229, NULL, 719, '好博门店', 0, '2020-10-30 09:50:46'),
	(230, NULL, 830, '安庆', 0, '2020-10-30 11:11:50'),
	(231, NULL, 830, '合肥', 0, '2020-10-30 11:11:58'),
	(232, NULL, 813, '西安', 0, '2020-10-30 12:23:03'),
	(233, NULL, 813, '西安', 0, '2020-10-30 12:23:08'),
	(234, NULL, 1019, '好博五金', 0, '2020-10-30 15:19:07'),
	(235, NULL, 512, 'HOPPE 好博专卖店', 0, '2020-10-31 06:21:09'),
	(236, NULL, 1152, '南昌', 0, '2020-10-31 11:20:29'),
	(237, NULL, 1152, '南昌', 0, '2020-10-31 11:20:37'),
	(238, NULL, 1207, '常德', 0, '2020-10-31 13:47:05'),
	(239, NULL, 1276, '好博五金', 0, '2020-10-31 18:03:12'),
	(240, NULL, 1025, '好博五金', 0, '2020-10-31 20:31:27'),
	(241, NULL, 1313, '好博五金', 0, '2020-11-01 21:50:57'),
	(242, NULL, 1313, '好博五金', 0, '2020-11-02 01:18:41'),
	(243, NULL, 19, '上海', 3, '2020-11-02 06:40:52'),
	(244, NULL, 19, '好博门店', 0, '2020-11-02 06:41:06'),
	(245, NULL, 19, '南翔店', 0, '2020-11-02 06:41:11'),
	(246, NULL, 19, '徐家汇店', 0, '2020-11-02 06:41:14'),
	(247, NULL, 19, '好博五金', 0, '2020-11-02 06:41:16'),
	(248, NULL, 19, 'HOPPE 好博专卖店', 0, '2020-11-02 06:41:18'),
	(249, NULL, 19, '上海', 3, '2020-11-02 06:41:20'),
	(250, NULL, 19, '上海', 3, '2020-11-02 06:41:36'),
	(251, NULL, 1218, '陕西西安', 0, '2020-11-02 07:43:14'),
	(252, NULL, 1325, '南京', 0, '2020-11-02 13:46:19'),
	(253, NULL, 1325, '南京', 0, '2020-11-02 13:46:26'),
	(254, NULL, 809, '上海', 3, '2020-11-02 15:50:18'),
	(255, NULL, 1339, 'HOPPE 好博专卖店', 0, '2020-11-02 21:57:33'),
	(256, NULL, 1339, '好博门店', 0, '2020-11-02 21:57:37'),
	(257, NULL, 1339, '好博五金', 0, '2020-11-02 21:57:42'),
	(258, NULL, 1341, 'HOPPE 好博专卖店', 0, '2020-11-03 12:20:09'),
	(259, NULL, 1341, '贵阳', 0, '2020-11-03 12:27:24'),
	(260, NULL, 1341, '贵阳', 0, '2020-11-03 12:28:39'),
	(261, NULL, 1410, '好博五金', 0, '2020-11-04 12:41:52'),
	(262, NULL, 836, '好博五金', 0, '2020-11-04 14:54:32'),
	(263, NULL, 1463, '无锡', 1, '2020-11-05 14:26:26'),
	(264, NULL, 1568, '好博五金', 0, '2020-11-07 00:29:51'),
	(265, NULL, 1712, '好博五金', 0, '2020-11-08 22:27:14'),
	(266, NULL, 1739, '好博五金', 0, '2020-11-09 20:00:40'),
	(267, NULL, 1739, '临安区', 0, '2020-11-09 20:01:12'),
	(268, NULL, 1758, '好博五金', 0, '2020-11-10 08:52:01'),
	(269, NULL, 1758, '好博五金', 0, '2020-11-10 08:58:35'),
	(270, NULL, 1875, '武汉', 0, '2020-11-16 13:22:51'),
	(271, NULL, 1875, '武汉', 0, '2020-11-16 13:22:58'),
	(272, NULL, 1689, '佛山', 0, '2020-11-16 17:51:32'),
	(273, NULL, 1689, '杭州', 2, '2020-11-16 17:51:39'),
	(274, NULL, 1713, '南京', 0, '2020-11-17 23:07:01'),
	(275, NULL, 1354, '常州', 3, '2020-11-18 15:41:09'),
	(276, NULL, 1974, '南京', 0, '2020-11-21 11:35:34'),
	(277, NULL, 625, '上海', 3, '2020-11-21 13:01:29'),
	(278, NULL, 11, '福建', 3, '2020-11-21 15:12:28'),
	(279, NULL, 11, '福建', 3, '2020-11-21 15:12:47'),
	(280, NULL, 11, '浙江', 10, '2020-11-21 15:13:11'),
	(281, NULL, 1993, '北京', 0, '2020-11-22 22:28:40'),
	(282, NULL, 1993, '北京', 0, '2020-11-22 22:28:44'),
	(283, NULL, 2020, '义乌', 0, '2020-11-23 17:30:43'),
	(284, NULL, 2022, '西安', 0, '2020-11-23 19:43:34'),
	(285, NULL, 61, 'HOPPE 好博专卖店', 0, '2020-11-23 21:20:52'),
	(286, NULL, 61, '徐家汇店', 0, '2020-11-23 21:21:19'),
	(287, NULL, 2024, '好博五金', 0, '2020-11-23 21:24:36'),
	(288, NULL, 2083, '好博五金', 0, '2020-11-25 06:01:47'),
	(289, NULL, 2097, 'HOPPE 好博专卖店', 0, '2020-11-25 15:17:24'),
	(290, NULL, 2097, '好博五金', 0, '2020-11-25 15:17:44'),
	(291, NULL, 2097, '上海', 3, '2020-11-25 15:17:51'),
	(292, NULL, 2020, '宁波', 1, '2020-11-26 09:32:23'),
	(293, NULL, 2020, '金华', 0, '2020-11-26 09:32:44'),
	(294, NULL, 2020, '义乌', 0, '2020-11-26 09:32:53'),
	(295, NULL, 2020, '杭州', 2, '2020-11-26 09:33:03'),
	(296, NULL, 2020, '上海', 3, '2020-11-26 09:33:40'),
	(297, NULL, 2020, '温州', 2, '2020-11-26 09:33:56'),
	(298, NULL, 2158, '好博五金', 0, '2020-11-26 10:01:15'),
	(299, NULL, 575, '好博五金', 0, '2020-11-30 11:40:12'),
	(300, NULL, 575, '北京', 0, '2020-11-30 11:40:30'),
	(301, NULL, 2239, '石家庄', 0, '2020-11-30 18:36:03'),
	(302, NULL, 2253, '十堰市', 0, '2020-12-01 21:03:13'),
	(303, NULL, 1974, '南京', 0, '2020-12-02 11:56:50'),
	(304, NULL, 377, '好博五金', 0, '2020-12-03 09:54:38'),
	(305, NULL, 268, '南京', 0, '2020-12-04 19:30:17'),
	(306, NULL, 2480, '好博五金', 0, '2020-12-05 21:29:58'),
	(307, NULL, 2480, '好博五金', 0, '2020-12-05 21:30:30'),
	(308, NULL, 2529, '好博五金', 0, '2020-12-07 12:05:20'),
	(309, NULL, 2563, '苏州', 1, '2020-12-08 19:04:51'),
	(310, NULL, 2582, '西安', 0, '2020-12-09 12:40:14'),
	(311, NULL, 1683, '深圳', 0, '2020-12-09 16:23:18'),
	(312, NULL, 2616, '南昌', 0, '2020-12-10 11:20:45'),
	(313, NULL, 2629, '南京', 0, '2020-12-10 21:30:47'),
	(314, NULL, 2629, 'HOPPE 好博专卖店', 0, '2020-12-10 21:30:51'),
	(315, NULL, 2629, '徐家汇店', 0, '2020-12-10 21:31:06'),
	(316, NULL, 1549, '好博五金', 0, '2020-12-15 15:30:25'),
	(317, NULL, 1549, '好博门店', 0, '2020-12-15 15:30:30'),
	(318, NULL, 1549, '好博五金', 0, '2020-12-15 15:30:33'),
	(319, NULL, 2697, '好博五金', 0, '2020-12-15 18:34:09'),
	(320, NULL, 2713, '广东', 0, '2020-12-16 11:39:22'),
	(321, NULL, 2713, 'HOPPE 好博专卖店', 0, '2020-12-16 11:42:27'),
	(322, NULL, 2713, '广东', 0, '2020-12-16 11:43:29'),
	(323, NULL, 2713, 'HOPPE 好博专卖店', 0, '2020-12-16 11:43:37'),
	(324, NULL, 2713, '广东', 0, '2020-12-16 11:45:12'),
	(325, NULL, 2795, '好博五金', 0, '2020-12-21 10:18:09'),
	(326, NULL, 2802, '山东', 0, '2020-12-21 11:24:32'),
	(327, NULL, 2802, '济南', 0, '2020-12-21 11:24:55'),
	(328, NULL, 2857, '成都', 0, '2020-12-22 23:49:34'),
	(329, NULL, 2864, '北京', 0, '2020-12-23 12:17:53'),
	(330, NULL, 2864, '上海', 3, '2020-12-23 12:18:07'),
	(331, NULL, 2864, 'HOPPE 好博专卖店', 0, '2020-12-23 12:27:51'),
	(332, NULL, 2864, '大连', 0, '2020-12-23 12:28:12'),
	(333, NULL, 2875, '山东', 0, '2020-12-24 11:41:00'),
	(334, NULL, 434, '临沂', 0, '2020-12-29 08:21:37'),
	(335, NULL, 2857, '成都', 0, '2020-12-30 18:30:54'),
	(336, NULL, 2857, '富森', 0, '2020-12-30 18:31:17'),
	(337, NULL, 3002, '武汉', 0, '2020-12-31 12:08:33'),
	(338, NULL, 3002, '上海', 3, '2020-12-31 12:08:40'),
	(339, NULL, 3002, '上海', 3, '2020-12-31 12:09:05'),
	(340, NULL, 3002, '北京', 0, '2020-12-31 12:13:17'),
	(341, NULL, 3002, '北京', 0, '2020-12-31 12:13:20'),
	(342, NULL, 3002, '上海', 3, '2020-12-31 13:09:55'),
	(343, NULL, 3020, '佛山', 0, '2021-01-01 12:46:45'),
	(344, NULL, 3020, '佛山', 0, '2021-01-01 12:46:49'),
	(345, NULL, 3020, '好博门店', 0, '2021-01-01 12:46:55'),
	(346, NULL, 3021, '温江', 0, '2021-01-01 13:18:22'),
	(347, NULL, 10, '厦门', 2, '2021-01-05 20:16:51'),
	(348, NULL, 10, '厦门', 2, '2021-01-05 20:17:17'),
	(349, NULL, 10, '台州', 1, '2021-01-05 20:17:53'),
	(350, NULL, 10, '宁波', 0, '2021-01-05 20:18:30'),
	(351, NULL, 10, '厦门', 2, '2021-01-05 20:18:34'),
	(352, NULL, 10, '台州', 1, '2021-01-05 20:18:37'),
	(353, NULL, 9, '台州', 1, '2021-01-05 20:24:37'),
	(354, NULL, 10, '厦门', 2, '2021-01-05 20:25:13'),
	(355, NULL, 10, '台州', 1, '2021-01-05 20:25:39'),
	(356, NULL, 10, '宁波', 0, '2021-01-05 20:25:41'),
	(357, NULL, 9, '厦门', 0, '2021-01-05 20:32:15'),
	(358, NULL, 10, '厦门', 0, '2021-01-05 20:33:01'),
	(359, NULL, 10, '台州', 1, '2021-01-05 20:33:03'),
	(360, NULL, 10, '宁波', 0, '2021-01-05 20:33:05'),
	(361, NULL, 10, '重庆', 0, '2021-01-05 20:33:22'),
	(362, NULL, 3094, '好博五金', 0, '2021-01-07 17:34:51'),
	(363, NULL, 858, '好博五金', 0, '2021-01-09 01:02:19'),
	(364, NULL, 3111, 'HOPPE 好博专卖店', 0, '2021-01-09 10:20:43'),
	(365, NULL, 3111, '广州', 0, '2021-01-09 10:20:56'),
	(366, NULL, 2734, '好博五金', 0, '2021-01-11 18:15:18'),
	(367, NULL, 1213, '好博五金', 0, '2021-01-11 22:24:50'),
	(368, NULL, 3230, '武汉', 0, '2021-01-17 08:26:27'),
	(369, NULL, 3230, '湖北', 0, '2021-01-17 08:26:35'),
	(370, NULL, 3230, '武汉', 0, '2021-01-17 08:26:47'),
	(371, NULL, 3249, '深圳', 0, '2021-01-18 20:02:10'),
	(372, NULL, 3256, 'HOPPE 好博专卖店', 0, '2021-01-19 08:34:09'),
	(373, NULL, 3062, '上海', 3, '2021-01-20 12:57:17'),
	(374, NULL, 20, '常州', 3, '2021-01-21 10:20:28'),
	(375, NULL, 20, '常州', 3, '2021-01-21 10:21:43'),
	(376, NULL, 10, '德', 4, '2021-01-21 10:21:56'),
	(377, NULL, 10, '德', 4, '2021-01-21 11:18:43'),
	(378, NULL, 1686, '南京', 0, '2021-01-25 10:18:51'),
	(379, NULL, 3335, '徐家汇店', 0, '2021-01-25 19:28:30'),
	(380, NULL, 757, '南京', 0, '2021-01-26 14:04:12'),
	(381, NULL, 1866, '好博五金', 0, '2021-01-26 15:48:21'),
	(382, NULL, 3357, '好博五金', 0, '2021-01-27 05:02:48'),
	(383, NULL, 3359, '好博五金', 0, '2021-01-27 08:34:51'),
	(384, NULL, 1463, '上海', 3, '2021-01-27 16:50:13'),
	(385, NULL, 3383, '成都', 0, '2021-01-27 22:39:51'),
	(386, NULL, 3410, '好博五金', 0, '2021-01-30 09:45:17'),
	(387, NULL, 3532, '江苏', 5, '2021-02-20 22:43:10'),
	(388, NULL, 140, '淮安', 0, '2021-02-21 20:48:10'),
	(389, NULL, 140, '淮安', 0, '2021-02-21 20:48:20'),
	(390, NULL, 140, '盐城', 0, '2021-02-21 20:48:31'),
	(391, NULL, 2551, '深圳', 0, '2021-02-21 21:17:35'),
	(392, NULL, 3534, 'HOPPE 好博专卖店', 0, '2021-02-22 12:07:23'),
	(393, NULL, 3549, 'HOPPE 好博专卖店', 0, '2021-02-23 13:07:45'),
	(394, NULL, 3554, '广州', 0, '2021-02-23 16:28:28'),
	(395, NULL, 971, '上海', 3, '2021-02-23 19:59:56'),
	(396, NULL, 3588, '好博五金', 0, '2021-02-27 15:40:27'),
	(397, NULL, 582, '好博五金', 0, '2021-03-10 13:44:44'),
	(398, NULL, 582, '好博五金', 0, '2021-03-10 13:44:49'),
	(399, NULL, 3808, '佛山市南海区大沥镇凤池市场', 0, '2021-03-16 17:27:04'),
	(400, NULL, 3830, 'HOPPE 好博专卖店', 0, '2021-03-17 13:51:05'),
	(401, NULL, 3855, '无锡', 1, '2021-03-19 09:39:35'),
	(402, NULL, 3877, '沈阳', 0, '2021-03-21 12:52:26'),
	(403, NULL, 3877, '北京', 0, '2021-03-21 12:52:32'),
	(404, NULL, 2713, '广', 2, '2021-03-22 17:44:44'),
	(405, NULL, 3971, '苏州工业园区', 0, '2021-03-29 08:22:11'),
	(406, NULL, 3971, '苏州工业园区', 0, '2021-03-29 08:22:20'),
	(407, NULL, 3971, '苏州', 1, '2021-03-29 08:22:29'),
	(408, NULL, 3971, '无锡', 1, '2021-03-29 08:23:27'),
	(409, NULL, 3877, '上海', 3, '2021-03-29 08:33:50');
/*!40000 ALTER TABLE `search_store_log` ENABLE KEYS */;

-- 导出  表 hoppe.seller 结构
CREATE TABLE IF NOT EXISTS `seller` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `job` varchar(50) DEFAULT NULL COMMENT '职位',
  `area` varchar(50) DEFAULT NULL COMMENT '地区',
  `email` varchar(50) DEFAULT NULL COMMENT '邮箱',
  `photo` varchar(255) DEFAULT NULL COMMENT '照片',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `type` int(11) DEFAULT NULL COMMENT '部门类型',
  `create_time` date DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COMMENT='销售员 信息';

-- 正在导出表  hoppe.seller 的数据：~10 rows (大约)
/*!40000 ALTER TABLE `seller` DISABLE KEYS */;
REPLACE INTO `seller` (`id`, `name`, `job`, `area`, `email`, `photo`, `sort`, `type`, `create_time`) VALUES
	(1, '敖方兵', '大中华区', '大中华区', 'bruce.ao@hoppe.com', '/upload/sys/seller/x4393f0083a.png', 100, 19, '2020-07-09'),
	(7, '曹克非', '华东区', '华东区', 'ken.cao@hoppe.com', '/upload/sys/seller/x43a30412de.png', 79, 18, '2020-07-11'),
	(9, '熊熠', '华北区', '华北区', 'luke.xiong@hoppe.com', '/upload/sys/seller/x43c7f03992.png', 78, 18, '2020-07-11'),
	(10, '胡姚文', '大中华区', '大中华区', 'daniel.hu@hoppe.com', '/upload/sys/seller/huyaowen.jpg', 81, 18, '2020-07-11'),
	(11, '刘文忠', '华南区', '华南区', 'luis.liu@hoppe.com', '/upload/sys/seller/x4376c16fa0.png', 97, 17, '2020-07-11'),
	(14, '罗敏', '华东区', '华东区', 'amy.luo@hoppe.com', '/upload/sys/seller/luomin1.jpg', 99, 17, '2020-07-11'),
	(15, '杨杰', '华北区', '华北区', 'jakey.yang@hoppe.com', '/upload/sys/seller/x437fd9e241.png', 100, 17, '2020-07-11'),
	(16, '贾冬发', '西南区', '西南区', 'kent.jia@hoppe.com', '/upload/sys/seller/12.jpg', 95, 17, '2020-07-11'),
	(19, '邓可长', NULL, '华南区', 'kevin.deng@hoppe.com', '/upload/sys/seller/WechatIMG1223.png', 96, 17, '2021-01-18'),
	(20, '潘修江', NULL, '华南区', 'simon.pan@hoppe.com', '/upload/sys/seller/WechatIMG1341.jpeg', 0, 18, '2021-03-25');
/*!40000 ALTER TABLE `seller` ENABLE KEYS */;

-- 导出  表 hoppe.store 结构
CREATE TABLE IF NOT EXISTS `store` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(255) DEFAULT NULL COMMENT '门店名称',
  `img` varchar(255) DEFAULT NULL COMMENT '门店图片',
  `alias_search` varchar(500) DEFAULT NULL COMMENT '别名搜索    地址，门店, 还有别名这个三个字段一块模糊查询',
  `province` varchar(50) DEFAULT NULL COMMENT '省',
  `city` varchar(50) DEFAULT NULL COMMENT '市',
  `district` varchar(50) DEFAULT NULL COMMENT '区',
  `address` varchar(500) DEFAULT NULL COMMENT '地址',
  `door_number` varchar(100) DEFAULT NULL COMMENT '门牌号',
  `tel` varchar(50) DEFAULT NULL COMMENT '电话',
  `shelf` int(11) DEFAULT NULL COMMENT '0上架 1下架   默认0',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `last_address` varchar(600) DEFAULT NULL COMMENT '省市区 + 地址+ 门牌号',
  `font_address` varchar(600) DEFAULT NULL COMMENT '小程序展示 区 + 地址+ 门牌号',
  `longitude` varchar(50) DEFAULT NULL COMMENT '经纬度 经度',
  `latitude` varchar(50) DEFAULT NULL COMMENT '经纬度 维度',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COMMENT='附近门店 , 店铺';

-- 正在导出表  hoppe.store 的数据：~15 rows (大约)
/*!40000 ALTER TABLE `store` DISABLE KEYS */;
REPLACE INTO `store` (`id`, `name`, `img`, `alias_search`, `province`, `city`, `district`, `address`, `door_number`, `tel`, `shelf`, `sort`, `last_address`, `font_address`, `longitude`, `latitude`, `create_time`) VALUES
	(9, '温州市欧鑫建材有限公司', '/upload/home/store/鑫盛行五金1.png', '鑫盛行五金', '100011', '330300', '330382', '千帆西路金茂商务广场	', '2楼248号', '13626551919', 0, 0, '浙江省温州市乐清市千帆西路金茂商务广场	2楼248号', '乐清市千帆西路金茂商务广场	2楼248号', '120.968808', '28.095742', '2020-09-12 15:51:30'),
	(10, '温州市欧鑫建材有限公司', '/upload/home/store/鑫盛行五金.png', '鑫盛行五金', '100011', '330300', '330382', '虹桥镇城南大道188号', '红星美凯龙1楼A8063', '1362655191', 0, 0, '浙江省温州市乐清市虹桥镇城南大道188号红星美凯龙1楼A8063', '乐清市虹桥镇城南大道188号红星美凯龙1楼A8063', '121.038015', '28.201776', '2020-09-12 16:03:12'),
	(11, '台州鼎丞建材有限公司	', '/upload/home/store/摩登五金.png', '摩登五金', '100011', '331000', '331082', '靖江南路87号', NULL, '13486238880', 0, 0, '浙江省台州市临海市靖江南路87号', '临海市靖江南路87号', '121.150261', '28.827283', '2020-09-12 16:04:22'),
	(12, '杭州朗高建材有限公司	', '/upload/home/store/杭州朗高1.jpg', NULL, '100011', '330100', '330108', '江南大道1090号', '第六空间定制馆三楼D3-10', '18268874545', 0, 0, '浙江省杭州市滨江区江南大道1090号第六空间定制馆三楼D3-10', '滨江区江南大道1090号第六空间定制馆三楼D3-10', '120.193135', '30.195414', '2020-09-12 16:05:40'),
	(13, '杭州朗高建材有限公司', '/upload/home/store/杭州朗高.jpg', NULL, '100011', '330100', '330104', '秋涛北路118号	', '佳好佳市场D102', '18268874545', 0, 0, '浙江省杭州市江干区秋涛北路118号	佳好佳市场D102', '江干区秋涛北路118号	佳好佳市场D102', '120.200522', '30.265958', '2020-09-12 16:06:39'),
	(14, '常州市德运世家五金有限公司', '/upload/home/store/WechatIMG12552.jpeg', NULL, '100010', '320200', '320213', '锡沪路280号	', '华夏家居港北门一楼左侧', '13382881999', 0, 0, '江苏省无锡市梁溪区锡沪路280号	华夏家居港北门一楼左侧', '梁溪区锡沪路280号	华夏家居港北门一楼左侧', '120.342010', '31.585360', '2020-09-12 16:07:58'),
	(15, '常州市德运世家五金有限公司', '/upload/home/store/WechatIMG12551.jpeg', NULL, '100010', '320400', '320402', '飞龙东路68号', '红星美凯龙1楼A8001', '13506128160', 0, 0, '江苏省常州市天宁区飞龙东路68号红星美凯龙1楼A8001', '天宁区飞龙东路68号红星美凯龙1楼A8001', '119.983020', '31.785959', '2020-09-12 16:09:00'),
	(16, '常州市德运世家五金有限公司', '/upload/home/store/WechatIMG1255.jpeg', NULL, '100010', '321100', '321102', '天桥路8号	', '月星九润国际家居广场2楼B005', '13506128160', 0, 0, '江苏省镇江市京口区天桥路8号	月星九润国际家居广场2楼B005', '京口区天桥路8号	月星九润国际家居广场2楼B005', '119.466011', '32.192975', '2020-09-12 16:10:08'),
	(17, '张家港市慧凯装饰材料有限公司', '/upload/home/store/张家港慧凯.png', NULL, '100010', '320500', '320582', '九洲国际独立馆14幢	', NULL, '18606281022', 0, 0, '江苏省苏州市张家港市九洲国际独立馆14幢	', '张家港市九洲国际独立馆14幢	', '120.548145', '31.836971', '2020-09-12 16:11:41'),
	(18, '上海帕尼建材有限公司', '/upload/home/store/上海帕尼.jpg', NULL, '100009', '310100', '310104', '宜山路450号', '家饰佳商场B1042号', '18621933565', 0, 0, '上海市上海市徐汇区宜山路450号家饰佳商场B1042号', '徐汇区宜山路450号家饰佳商场B1042号', '121.426003', '31.184278', '2020-09-12 16:17:13'),
	(19, '上海帕尼建材有限公司', '/upload/home/store/上海帕尼1.jpg', NULL, '100009', '310100', '310107', '澳门路168号', '月星国际家居一层A210', '18621933565', 0, 0, '上海市上海市普陀区澳门路168号月星国际家居一层A210', '普陀区澳门路168号月星国际家居一层A210', '121.445380', '31.247594', '2020-09-12 16:18:13'),
	(20, '上海佐梅实业有限公司', '/upload/home/store/佐梅实业.png', '佐梅实业', '100009', '310100', '310107', '真北路1028号', '红星美凯龙北馆二楼B8017', '13917503210', 0, 0, '上海市上海市普陀区真北路1028号红星美凯龙北馆二楼B8017', '普陀区真北路1028号红星美凯龙北馆二楼B8017', '121.385264', '31.237840', '2020-09-12 16:19:44'),
	(21, '湖南铜尚品五金超市有限公司', '/upload/home/store/湖南铜尚品.jpg', '铜尚品世界名锁中心', '100018', '430100', '430111', '万家丽中路三段36号', '喜盈门范城三楼1125501', '17700795002', 0, 0, '湖南省长沙市雨花区万家丽中路三段36号喜盈门范城三楼1125501', '雨花区万家丽中路三段36号喜盈门范城三楼1125501', '113.034826', '28.132855', '2020-09-12 16:21:44'),
	(24, '莆田德蒙斯建材贸易有限公司', '/upload/home/store/德蒙斯.png', '德蒙斯建材', '100013', '350300', '350304', '东圳东路199号', '红星美凯龙B1层F8096', '13905941620', 0, 0, '福建省莆田市荔城区东圳东路199号红星美凯龙B1层F8096', '荔城区东圳东路199号红星美凯龙B1层F8096', '119.025278', '25.447781', '2020-09-12 16:25:52'),
	(26, '徐州东驰科技有限公司', '/upload/home/store/东驰科技.png', '东驰科技', '100010', '320300', '320302', '复兴北路188号', '红星美凯龙三期一楼', '18205166688', 0, 0, '江苏省徐州市鼓楼区复兴北路188号红星美凯龙三期一楼', '鼓楼区复兴北路188号红星美凯龙三期一楼', '117.217560', '34.303834', '2020-09-14 20:06:35');
/*!40000 ALTER TABLE `store` ENABLE KEYS */;

-- 导出  表 hoppe.types 结构
CREATE TABLE IF NOT EXISTS `types` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(50) DEFAULT NULL COMMENT '类型名称',
  `type` int(11) DEFAULT NULL COMMENT '分类 1 应用案列 1xxx 2xxx 3xxx',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `active` int(11) DEFAULT NULL COMMENT '选中状态 0 否1 是',
  `create_time` date DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8mb4 COMMENT='类型表';

-- 正在导出表  hoppe.types 的数据：~10 rows (大约)
/*!40000 ALTER TABLE `types` DISABLE KEYS */;
REPLACE INTO `types` (`id`, `name`, `type`, `sort`, `active`, `create_time`) VALUES
	(1, '商贸建筑', 1, 4, 1, '2020-07-08'),
	(2, '医疗机构', 1, 2, 0, '2020-07-08'),
	(3, '运动文化', 1, 1, 0, '2020-07-08'),
	(4, '酒店公寓', 1, 3, 0, '2020-07-08'),
	(14, 'VR展馆', 2, 0, 0, '2020-07-09'),
	(15, '技术视频', 2, 0, 1, '2020-07-09'),
	(16, '图册资料', 2, 0, 0, '2020-07-09'),
	(17, '销售部', 3, 6, 0, '2020-07-17'),
	(18, '企业部', 3, 5, 1, '2020-07-17'),
	(19, '零售部', 3, 0, 0, '2020-07-17');
/*!40000 ALTER TABLE `types` ENABLE KEYS */;

-- 导出  表 hoppe.video 结构
CREATE TABLE IF NOT EXISTS `video` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键自增id',
  `title` varchar(500) DEFAULT NULL COMMENT '视频标题',
  `subtitle` varchar(500) DEFAULT NULL COMMENT '子标题',
  `poster_url` varchar(255) DEFAULT NULL COMMENT '视频海报路径',
  `video_url` varchar(255) DEFAULT NULL COMMENT '视频路径',
  `sort` int(11) DEFAULT NULL COMMENT '视频排序',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb4 COMMENT='资料库  > 视频技术 ';

-- 正在导出表  hoppe.video 的数据：~7 rows (大约)
/*!40000 ALTER TABLE `video` DISABLE KEYS */;
REPLACE INTO `video` (`id`, `title`, `subtitle`, `poster_url`, `video_url`, `sort`, `create_time`) VALUES
	(4, 'HOPPE 好博集团故事', 'HOPPE 好博集团故事', '/upload/info/video/11.jpg', '/upload/info/video/HOPPE 好博集团故事.mp4', 99, '2020-09-17 09:59:09'),
	(5, 'Quick-Fit快装方轴技术', 'Quick-Fit快装方轴技术', '/upload/info/video/2.jpg', '/upload/info/video/Quick-Fit快装方轴技术.mp4', 98, '2020-09-17 10:00:52'),
	(6, 'SecuForte®创新防盗原理', 'SecuForte®创新防盗原理', '/upload/info/video/3.jpg', '/upload/info/video/SecuForte创新防盗原理.mp4', 97, '2020-09-17 10:01:25'),
	(7, 'SecuSan®新卫生标准', 'SecuSan®新卫生标准', '/upload/info/video/4.jpg', '/upload/info/video/SecuSan新卫生标准.mp4', 96, '2020-09-17 10:02:01'),
	(8, 'Secustik®防盗联动装置', 'Secustik®防盗联动装置', '/upload/info/video/5.jpg', '/upload/info/video/Secustik防盗联动装置.mp4', 94, '2020-09-17 10:03:48'),
	(9, 'VarioFit®可调节灵活方轴', 'VarioFit®可调节灵活方轴', '/upload/info/video/6.jpg', '/upload/info/video/VarioFit可调节灵活方轴.mp4', 93, '2020-09-17 10:04:29'),
	(10, '窗执手更换操作演示', '窗执手更换操作演示', '/upload/info/video/7.jpg', '/upload/info/video/窗执手更换操作演示.mp4', 92, '2020-09-17 10:04:48');
/*!40000 ALTER TABLE `video` ENABLE KEYS */;

-- 导出  表 hoppe.vr 结构
CREATE TABLE IF NOT EXISTS `vr` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `title` varchar(255) DEFAULT NULL COMMENT '展馆标题',
  `img_url` varchar(255) DEFAULT NULL COMMENT '图',
  `sort` int(11) DEFAULT NULL COMMENT '排序',
  `link` varchar(255) DEFAULT NULL COMMENT '链接',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='资料库 > VR 展馆';

-- 正在导出表  hoppe.vr 的数据：~2 rows (大约)
/*!40000 ALTER TABLE `vr` DISABLE KEYS */;
REPLACE INTO `vr` (`id`, `title`, `img_url`, `sort`, `link`, `create_time`) VALUES
	(2, 'HOPPE 好博 广州分公司VR全景', '/upload/info/vr/WX20200916-133527@2x.png', 44, 'https://hoppevr.jzdsh.com', '2020-07-24 13:38:37'),
	(3, 'HOPPE 好博【2020FBC】VR全景', '/upload/info/vr/111.jpg', 55, 'https://fbc2020.jzdsh.cn', '2020-12-01 19:04:15');
/*!40000 ALTER TABLE `vr` ENABLE KEYS */;

-- 导出  表 hoppe.wx_user 结构
CREATE TABLE IF NOT EXISTS `wx_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键自增id',
  `openid` varchar(255) DEFAULT NULL COMMENT '微信开放id',
  `logins` int(11) DEFAULT NULL COMMENT '登录次数',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `login_time` datetime DEFAULT NULL COMMENT '最新登录时间',
  `avatar` varchar(500) DEFAULT NULL COMMENT '微信头像',
  `nickname` varchar(500) DEFAULT NULL COMMENT '微信昵称',
  `mobile` varchar(20) DEFAULT NULL COMMENT '手机号码',
  `email` varchar(255) DEFAULT NULL COMMENT '电子邮箱',
  `company` varchar(255) DEFAULT NULL COMMENT '所在公司',
  `job` varchar(255) DEFAULT NULL COMMENT '职务',
  `lock` int(11) DEFAULT '0' COMMENT '冻结 0否 1是',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4021 DEFAULT CHARSET=utf8mb4 COMMENT='微信用户';

-- 正在导出表  hoppe.wx_user 的数据：~4,007 rows (大约)
/*!40000 ALTER TABLE `wx_user` DISABLE KEYS */;
REPLACE INTO `wx_user` (`id`, `openid`, `logins`, `create_time`, `login_time`, `avatar`, `nickname`, `mobile`, `email`, `company`, `job`, `lock`) VALUES
	(1, 'result.data.openid', 0, '2020-07-31 17:14:44', '2020-07-31 17:14:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2, 'or8ea5Vvplr4c2W9_Wb7tHThauXk', 786, '2020-07-31 17:15:28', '2020-08-14 15:24:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3, 'or8ea5X0wbBayflSCQa4XeojO8ng', 16, '2020-08-03 12:54:42', '2020-08-06 09:56:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4, 'or8ea5TV1u_8xo-egUbm91yLrJk8', 1, '2020-08-03 18:21:26', '2020-08-04 16:57:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(5, 'or8ea5WB7F1ZGMxbAE_9pJH2OC68', 3, '2020-08-03 18:45:03', '2020-08-05 18:20:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(6, 'or8ea5ZtZlScEnhaVenmW4xrG2Ak', 0, '2020-08-03 21:46:11', '2020-08-03 21:46:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(7, 'o1qmn5D4tJR4vUdNAPxQR1DPSGFI', 3452, '2020-08-07 14:12:17', '2021-03-24 11:05:54', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTJUcmfzbuXU0l4OVNSN70R7kCVibCBGqVD3ZBBr0MC3JjI9KicvdK8h7TcBibXH2W3tm8ia87WuhwbGug/132', '蜗牛', '15238672837', '549382633@qq.com', '上海杰网络', '哈哈', 0),
	(8, 'o1qmn5EHk5uN-FDvQedCnvg5qQbw', 77, '2020-08-07 15:01:12', '2021-03-26 12:34:39', 'https://thirdwx.qlogo.cn/mmopen/vi_32/ajNVdqHZLLBQ3XBia7Sgvv1ADEPNmcu4fAHDlUHS3Lb0ialK6icPrSTvCdjU3yeGQ1P0HicH9dEhmA4ibpwyZaib4H6Q/132', 'Rubino🐰', NULL, NULL, NULL, NULL, 0),
	(9, 'o1qmn5K0eOuFtPpmadG6a8QhYrZk', 128, '2020-08-07 15:10:03', '2021-03-26 08:35:49', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTJzerWVMvwVmO7L11I2zJArxeGzfMsn3WFMB6BIM0dicBepbz2InY9W3TVc3rloKV8aUoGqU6Lvh2g/132', 'Andy-陈刚', NULL, NULL, NULL, NULL, 0),
	(10, 'o1qmn5HnlDSngUEAb4yt3S7V2t4c', 137, '2020-08-10 09:02:19', '2021-03-26 23:15:20', 'https://thirdwx.qlogo.cn/mmopen/vi_32/DYAIOgq83ep28UCmqmJIMaTjM6vGESRMSO3B6rnRxEeXSmpaicPITAHOcSY8qpEByQiaCKCqCxwsu38zjcRBEOOg/132', 'Ruby｜HOPPE好博🇩🇪', NULL, NULL, NULL, NULL, 0),
	(11, 'o1qmn5DKOijIlOKOabSm_SJcl4uA', 191, '2020-08-13 11:26:37', '2021-03-26 15:40:46', 'https://thirdwx.qlogo.cn/mmopen/vi_32/DYAIOgq83eo4NibMvSgRokOsvbcCEx2tcoEpTNJqIvbMCPOvEiccJ2O0FIAOkrPLdtEfYgAEbiaQQsAY6KYdhRx0w/132', '飘零', '17621581595', '895296059@163.com', '上海银行', '软件开发', 0),
	(12, 'o1qmn5EZUZXeSWlRXWd-3aOtN-i8', 31, '2020-08-13 14:52:35', '2021-03-23 13:09:29', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTLiaodIicJoZEJicOFknwoY9ibicC9aTWR0IWq9wX9eZdxtpm9WNB8SKl8xzdDSDydyjEqiaFBNvmNRYdww/132', 'Hollowの', NULL, NULL, NULL, NULL, 0),
	(13, 'o1qmn5KDWGKqYg8wwmQMjbcJ3gu0', 36, '2020-08-13 15:07:39', '2021-03-06 16:57:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(14, 'o1qmn5CnJLF0TY7nKHG5f6TlCy_M', 212, '2020-08-24 14:33:57', '2021-03-26 15:29:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(15, 'undefined', 21, '2020-09-06 23:15:18', '2020-12-10 02:40:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(16, 'o1qmn5CyLz1XUTu1IDhBT8MtaU3c', 40, '2020-09-16 09:46:01', '2021-03-27 13:39:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(17, 'o1qmn5DctVW35dYqgEcDAaK7phVw', 135, '2020-09-16 09:50:09', '2021-03-26 18:09:59', 'https://thirdwx.qlogo.cn/mmopen/vi_32/DYAIOgq83eqHEJ5hhTkXia1E3jA37aXPmh145OlaUqzFuDjIicdL0ZZ8fHJGe5bTLXEwFoib3Xy8QIKqpBjSdsgIQ/132', 'Amy L🔅', NULL, NULL, NULL, NULL, 0),
	(18, 'o1qmn5FvTidUNuNnlQkQuAM74RTA', 15, '2020-09-16 09:50:11', '2021-03-03 10:14:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(19, 'o1qmn5MnpenH7wDHiLxnBzSBCDpQ', 19, '2020-09-16 10:03:59', '2021-03-25 10:44:58', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTIAtmdf6tQVVIFczjm2AqbSNquzsUfEHPgYibxkdDYEyDO1T5S6yg3rl935YiaLbtnPD5S7QO3icoZ3Q/132', 'HOPPE Luis.liu', NULL, NULL, NULL, NULL, 0),
	(20, 'o1qmn5ABemeN3ro0yBqsWT0v5e0A', 135, '2020-09-16 13:44:04', '2021-03-27 21:31:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(21, 'o1qmn5CKe3_M2bNjwzTtKpkfBE3k', 2, '2020-09-18 14:35:47', '2020-11-23 16:05:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(22, 'o1qmn5FOye3_3xXu8oUshuDqQHfY', 77, '2020-09-22 09:36:12', '2021-03-27 13:50:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(23, 'o1qmn5Cw_iIRufAMcNW7kRvmB0i8', 2, '2020-09-23 19:12:48', '2020-09-23 19:46:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(24, 'o1qmn5HVk66C9arcs64MqxeOpDGA', 0, '2020-09-23 19:47:04', '2020-09-23 19:47:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(25, 'o1qmn5DrkQozYmbn3e5RgcBwH-2k', 0, '2020-10-14 20:07:34', '2020-10-14 20:07:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(26, 'o1qmn5FTUwO8zomHHkdRNx-uNnCU', 2, '2020-10-26 16:29:59', '2020-11-23 14:41:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(27, 'o1qmn5APZxK6MY46DC9KBzNoC5nk', 2, '2020-10-26 16:29:59', '2020-11-05 10:50:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(28, 'o1qmn5NONweGYtwS75Y9cx-jLjq4', 2, '2020-10-26 16:53:15', '2021-02-11 14:45:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(29, 'o1qmn5PtzmiyLUXIFPuNpzAY_4W4', 6, '2020-10-26 17:07:15', '2021-02-07 15:50:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(30, 'o1qmn5EesQ-HAYC9Gkji_ZvjupbY', 0, '2020-10-26 17:15:23', '2020-10-26 17:15:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(31, 'o1qmn5EesQ-HAYC9Gkji_ZvjupbY', 0, '2020-10-26 17:15:23', '2020-10-26 17:15:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(32, 'o1qmn5C-ImBrzFWc3SPDgZT1UAdQ', 2, '2020-10-26 17:53:32', '2020-10-31 12:24:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(33, 'o1qmn5F5uljNuQaRy5SiNypTlgcY', 2, '2020-10-26 17:59:43', '2020-10-30 10:59:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(34, 'o1qmn5J9KCGiz4BaMsSC0-IhsHO4', 9, '2020-10-26 18:01:25', '2020-10-31 14:51:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(35, 'o1qmn5PvTs1BCj4UwPuK06htlGqI', 0, '2020-10-26 18:02:51', '2020-10-26 18:02:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(36, 'o1qmn5KWDePNRJp_wAK_b2q72Wzc', 14, '2020-10-26 18:10:36', '2020-10-28 01:49:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(37, 'o1qmn5BBZA-oKDfDOnJ4D1C8DOiM', 4, '2020-10-26 18:13:51', '2021-02-28 10:20:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(38, 'o1qmn5OGMVii8PaSOdCi9hqq1F0M', 0, '2020-10-26 18:13:52', '2020-10-26 18:13:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(39, 'o1qmn5OckmdutJiA9WTuAREGeYys', 16, '2020-10-26 18:14:09', '2021-02-08 04:34:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(40, 'o1qmn5JsHUt1_NyvzulLicy0FqXs', 14, '2020-10-26 18:16:15', '2020-10-30 15:16:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(41, 'o1qmn5A8nEN7LuF7Z9eYw7TuMNg0', 0, '2020-10-26 18:21:50', '2020-10-26 18:21:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(42, 'o1qmn5GY_NBOUmnuvG3yLwdQeMvM', 0, '2020-10-26 18:25:28', '2020-10-26 18:25:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(43, 'o1qmn5O8DsNMtN_J4JDBEKfqgIHI', 0, '2020-10-26 18:32:59', '2020-10-26 18:32:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(44, 'o1qmn5GVKAGCYnkWENy0g4dxRZgc', 0, '2020-10-26 18:37:49', '2020-10-26 18:37:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(45, 'o1qmn5FhBFSg-cfqh6ZNJx9xFYko', 18, '2020-10-26 18:40:09', '2021-01-29 11:09:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(46, 'o1qmn5BEF25erbWjjoFIgUnBRf1s', 8, '2020-10-26 18:42:57', '2021-03-15 08:53:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(47, 'o1qmn5P19SGLMX6JMLPY4ClTJ6M4', 5, '2020-10-26 18:44:01', '2020-11-04 12:23:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(48, 'o1qmn5OrT8MQ3P0XhnpOt0x8iSio', 4, '2020-10-26 18:55:46', '2021-03-16 19:18:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(49, 'o1qmn5NDKsuSP4r48TnPcnEXZHpA', 2, '2020-10-26 19:00:55', '2021-03-28 12:12:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(50, 'o1qmn5AJzRLKfZMZhpL4Zh0WKht8', 7, '2020-10-26 19:02:37', '2020-10-27 19:20:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(51, 'o1qmn5CsNSb256sjIPsvDVRH1CTw', 1, '2020-10-26 19:06:21', '2020-12-31 12:00:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(52, 'o1qmn5MQ_U5993_TdXXXdkJ5vK_Y', 6, '2020-10-26 19:07:41', '2021-03-10 16:38:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(53, 'o1qmn5LUExo57D1EFVNzzUuYZelc', 2, '2020-10-26 19:08:32', '2020-10-26 19:08:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(54, 'o1qmn5FzueH41HOP2BrnkHLDwf5U', 0, '2020-10-26 19:14:31', '2020-10-26 19:14:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(55, 'o1qmn5Km7g1x7bjiS60cJ_GB8AYg', 4, '2020-10-26 19:16:59', '2021-02-10 00:09:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(56, 'o1qmn5PtZBIgX-4RR_luQAdawikE', 13, '2020-10-26 19:34:41', '2021-03-05 16:19:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(57, 'o1qmn5ICQHHC2Q1kyjh-d-Ob6dtQ', 1, '2020-10-26 19:37:06', '2020-11-03 12:52:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(58, 'o1qmn5FDAktaOoDw0fkC8z7Ba1q0', 0, '2020-10-26 19:39:49', '2020-10-26 19:39:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(59, 'o1qmn5LgUr8IXE6NEeUcsGpgDM_U', 3, '2020-10-26 19:42:27', '2020-10-31 11:35:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(60, 'o1qmn5L9wCLu4VPOFcu7SHD7JStA', 44, '2020-10-26 19:53:07', '2021-03-25 15:40:32', 'https://thirdwx.qlogo.cn/mmopen/vi_32/QfTcMXPKxqQ3mib9h31GiamBaEzxUoSf5XHWCVQIVEt70KFdEQqkXT6yc1qakFoM8YrHtwt5SrmD9SaVZVj41a7g/132', '德国HOPPE门窗五金曹克非', NULL, NULL, NULL, NULL, 0),
	(61, 'o1qmn5DEbyZbebtJBfOymfZa7Co0', 1, '2020-10-26 19:55:06', '2020-11-23 21:19:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(62, 'o1qmn5IpD-mLZS-buhgcx_OZiNWY', 1, '2020-10-26 19:55:14', '2021-03-15 08:50:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(63, 'o1qmn5EOLGcg9arCjcOQtXxkzYaA', 2, '2020-10-26 19:56:17', '2021-01-27 12:03:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(64, 'o1qmn5O-zx1lJLk0HsdGB0ZA8p8M', 0, '2020-10-26 19:57:23', '2020-10-26 19:57:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(65, 'o1qmn5Lql5ELOAvLRkYrUjOpGMSU', 1, '2020-10-26 19:58:33', '2020-10-27 20:23:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(66, 'o1qmn5N-6tgJE02VC_AIWlsIaJmI', 2, '2020-10-26 19:59:54', '2020-11-13 10:07:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(67, 'o1qmn5FwzFOclLHSh-gINv1Gojho', 3, '2020-10-26 20:04:30', '2020-10-26 20:04:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(68, 'o1qmn5HPxL-FAoDBExf3f4SlYdJ8', 2, '2020-10-26 20:06:30', '2021-01-03 09:27:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(69, 'o1qmn5E3oOJvY_SJh3vzmt9jINng', 0, '2020-10-26 20:12:19', '2020-10-26 20:12:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(70, 'o1qmn5An3QXk9PoF8qOt6mHfCTp0', 2, '2020-10-26 20:16:19', '2020-10-26 20:16:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(71, 'o1qmn5Nh_82sMxsZKo5q7k4ePAWo', 1, '2020-10-26 20:21:56', '2020-11-04 12:26:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(72, 'o1qmn5AohzV9uQEwCdtqfIioszx4', 3, '2020-10-26 20:22:02', '2021-02-07 15:46:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(73, 'o1qmn5Px6zieUxzldqWX-u3MyGK4', 0, '2020-10-26 20:22:29', '2020-10-26 20:22:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(74, 'o1qmn5Poyfg5XKUG6XBo0l_nAdk0', 0, '2020-10-26 20:22:50', '2020-10-26 20:22:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(75, 'o1qmn5BZCO6uq13ySIxKQWNSQkcA', 1, '2020-10-26 20:23:37', '2020-10-27 17:21:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(76, 'o1qmn5J-0TKxwYNIoDtydDCKmj9c', 2, '2020-10-26 20:23:46', '2020-11-04 09:14:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(77, 'o1qmn5JQoP9S7pEIaSLW6I9fLGh4', 2, '2020-10-26 20:23:47', '2020-11-04 12:25:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(78, 'o1qmn5A7LlqRJddwVd7-jmEFSptw', 2, '2020-10-26 20:24:22', '2020-11-04 12:23:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(79, 'o1qmn5MkXcIjr-hxcG3T6quqV70k', 0, '2020-10-26 20:24:22', '2020-10-26 20:24:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(80, 'o1qmn5O7kZ6oT_vhmORlu8Yxt81o', 20, '2020-10-26 20:24:42', '2021-03-26 09:23:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(81, 'o1qmn5J3ZMTxGZVUddDFR-S0GSqE', 1, '2020-10-26 20:25:33', '2021-02-04 02:18:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(82, 'o1qmn5F_sH9Hm4PZXqt1VsDrMbxg', 1, '2020-10-26 20:26:39', '2021-02-04 03:13:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(83, 'o1qmn5EnW-Z8xn2AsUhrZZfoiSsE', 1, '2020-10-26 20:28:04', '2020-11-04 09:12:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(84, 'o1qmn5NDWPH0iht5lq4FaOsw0MdY', 1, '2020-10-26 20:32:22', '2020-11-04 09:14:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(85, 'o1qmn5MhEp0busTHHy3yrWeOX2vQ', 5, '2020-10-26 20:36:28', '2021-01-05 12:36:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(86, 'o1qmn5LmURi1S16wbp6PRMgs4l5s', 1, '2020-10-26 20:36:36', '2020-11-04 09:13:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(87, 'o1qmn5C8Bz4VodqDF08iwWCiCMYg', 3, '2020-10-26 20:36:40', '2021-02-06 18:50:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(88, 'o1qmn5AaldgDTTYyS9S7qImyDXgs', 1, '2020-10-26 20:36:48', '2020-10-31 12:23:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(89, 'o1qmn5AQ5o33x-xgGz7M7v9t8llU', 3, '2020-10-26 20:39:40', '2021-02-06 08:11:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(90, 'o1qmn5I0RMFjw0r_DfzCeluDw97I', 0, '2020-10-26 20:39:46', '2020-10-26 20:39:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(91, 'o1qmn5AlRgYsHpKT9KfmZli2_anQ', 2, '2020-10-26 20:40:03', '2021-02-04 02:17:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(92, 'o1qmn5KX13gNuOfRlCcpHrCfL_G4', 1, '2020-10-26 20:41:15', '2020-11-04 09:13:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(93, 'o1qmn5GOSi2SFGuAFbpoUaiVXvCo', 0, '2020-10-26 20:42:02', '2020-10-26 20:42:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(94, 'o1qmn5KDAHRgpJYZEqzvlkvIzVOw', 1, '2020-10-26 20:42:02', '2020-10-27 17:19:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(95, 'o1qmn5PvYplyIFRkMakvXBmFRkx0', 0, '2020-10-26 20:49:05', '2020-10-26 20:49:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(96, 'o1qmn5MDPfFQcTfr6zC6vneSzYAM', 0, '2020-10-26 21:18:45', '2020-10-26 21:18:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(97, 'o1qmn5HL8DxAKqQbv5dy4t2hI3mc', 16, '2020-10-26 21:23:40', '2020-11-04 08:02:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(98, 'o1qmn5DFrXxdUl5Yiu0dEMwaPw90', 2, '2020-10-26 21:30:40', '2020-10-26 21:30:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(99, 'o1qmn5DXInO9S_N4OsgtUIfhp7pg', 0, '2020-10-26 21:32:10', '2020-10-26 21:32:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(100, 'o1qmn5Nze7kbo_RfkKerLc4nWrKg', 0, '2020-10-26 21:34:41', '2020-10-26 21:34:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(101, 'o1qmn5C5qEmvMH9-YotzNCRPSLU4', 5, '2020-10-26 21:39:37', '2021-02-20 13:39:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(102, 'o1qmn5FRLxWgQtAcRKxKrsRXlOmc', 2, '2020-10-26 21:40:16', '2021-03-21 15:29:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(103, 'o1qmn5EKSkn875UPlE0cTR3YQnRY', 0, '2020-10-26 21:55:04', '2020-10-26 21:55:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(104, 'o1qmn5BAyrmYzYVUq_p3P_xuisjk', 0, '2020-10-26 22:08:17', '2020-10-26 22:08:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(105, 'o1qmn5E2LI0PXuTRMd70Ksao0Q5I', 13, '2020-10-26 22:09:29', '2021-03-05 20:01:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(106, 'o1qmn5Fs-5hNkNvMoMJ-p9WGR1r8', 0, '2020-10-26 22:09:47', '2020-10-26 22:09:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(107, 'o1qmn5O47NdMBFyoXvM2Sk5PyLNE', 0, '2020-10-26 22:36:43', '2020-10-26 22:36:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(108, 'o1qmn5Cg_kZaNL0tSD8toCXteBJY', 3, '2020-10-26 23:03:56', '2020-10-27 19:31:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(109, 'o1qmn5COGmaSD1q1uQb59Y8n1T-w', 0, '2020-10-26 23:33:02', '2020-10-26 23:33:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(110, 'o1qmn5AkKk3F7bwB8_c1rog0Vzxc', 2, '2020-10-26 23:39:28', '2020-10-26 23:39:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(111, 'o1qmn5BnLQQS0TjqXDiwHy2ncfc8', 0, '2020-10-26 23:42:19', '2020-10-26 23:42:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(112, 'o1qmn5DtTYYdebauuY6zp4LVIQ-g', 1, '2020-10-27 00:02:29', '2021-01-05 11:38:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(113, 'o1qmn5Pu5_zjxHhQ4mP9p0FjdFMY', 1, '2020-10-27 01:38:39', '2020-10-30 12:08:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(114, 'o1qmn5LOCKYAfOU33xrWZiCUt0Ew', 17, '2020-10-27 01:50:58', '2020-11-04 09:14:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(115, 'o1qmn5MUmq6WhBTLRQxkv1Ie15co', 4, '2020-10-27 03:37:20', '2021-02-11 13:38:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(116, 'o1qmn5I5_wBjIcZpUuDSZ1CwVwU0', 0, '2020-10-27 06:03:41', '2020-10-27 06:03:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(117, 'o1qmn5JHPjlWxdVZSYExbHl3yVEk', 2, '2020-10-27 06:47:26', '2020-11-04 09:14:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(118, 'o1qmn5LQoNFt2Jn4x46OnvzaOTGE', 2, '2020-10-27 07:46:48', '2021-02-10 06:58:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(119, 'o1qmn5COvgmlJ4MC5Go7YGOc3afs', 10, '2020-10-27 07:59:31', '2021-03-23 08:14:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(120, 'o1qmn5NnQtkjVlREEDe5Ji2FCeA4', 3, '2020-10-27 08:09:33', '2021-02-21 02:08:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(121, 'o1qmn5H9yfH0KSk7nIAIB13u6iiA', 0, '2020-10-27 08:12:07', '2020-10-27 08:12:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(122, 'o1qmn5O6YRJo-peUAE_M0H32mWbU', 1, '2020-10-27 08:34:28', '2020-12-16 09:32:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(123, 'o1qmn5MZYuciE4V4hNR6fGDs6NWw', 0, '2020-10-27 08:35:37', '2020-10-27 08:35:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(124, 'o1qmn5NSleVVGSinxpAEaK_zhikc', 9, '2020-10-27 08:46:53', '2021-02-25 09:56:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(125, 'o1qmn5DobBJ1v3AdoPVE7S1g4XyQ', 0, '2020-10-27 09:10:54', '2020-10-27 09:10:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(126, 'o1qmn5P8FkGw2TXZ8zTBhNjNve-c', 1, '2020-10-27 09:15:12', '2020-12-31 11:42:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(127, 'o1qmn5JN76ymomXEYJvImplI71d4', 6, '2020-10-27 09:49:35', '2020-12-24 14:55:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(128, 'o1qmn5BM8fqEk9hvng595fovnQYQ', 1, '2020-10-27 10:01:34', '2020-10-27 10:26:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(129, 'o1qmn5DlAV68aGegEXRQqLHAdR38', 25, '2020-10-27 10:14:47', '2021-03-08 16:17:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(130, 'o1qmn5HVnP3_-XsCFSNu9-uWYTK0', 0, '2020-10-27 10:32:03', '2020-10-27 10:32:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(131, 'o1qmn5Gd2myNWDsvsGFcAMExhrzs', 0, '2020-10-27 10:50:15', '2020-10-27 10:50:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(132, 'o1qmn5LhZrrmd-8HWjfMQJw8akpQ', 0, '2020-10-27 11:13:08', '2020-10-27 11:13:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(133, 'o1qmn5JOkVlwrvYIgIpBMrrFEG-A', 14, '2020-10-27 11:13:17', '2020-10-27 11:13:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(134, 'o1qmn5DHO7YsKW6Z6iJIsSssxIM4', 4, '2020-10-27 11:18:53', '2020-10-27 11:19:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(135, 'o1qmn5EAMvhw3UeGMsdSpWhk2DSA', 1, '2020-10-27 11:20:15', '2020-11-24 21:15:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(136, 'o1qmn5Im4lFezkLVL8bEGspml0zk', 4, '2020-10-27 11:20:31', '2020-10-27 11:20:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(137, 'o1qmn5NhFRf93t47VfAjHWqHWybY', 15, '2020-10-27 11:23:33', '2020-11-04 08:01:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(138, 'o1qmn5INb1c2F8bKsqna1iTZBwK4', 13, '2020-10-27 11:25:19', '2021-02-04 01:17:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(139, 'o1qmn5KpQKctAcgC58UduuYEZpUU', 7, '2020-10-27 11:26:34', '2021-03-11 14:12:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(140, 'o1qmn5HoxAbx-5i0o_FaISLI9r84', 91, '2020-10-27 11:54:30', '2021-03-22 12:18:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(141, 'o1qmn5Czg9NLKGY7m7bH_bEAZXbY', 0, '2020-10-27 12:04:34', '2020-10-27 12:04:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(142, 'o1qmn5BGch-3cnchdVeGPWRXXufE', 0, '2020-10-27 12:42:35', '2020-10-27 12:42:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(143, 'o1qmn5IsvdaaEqEu5sLQqQpkUbe8', 1, '2020-10-27 13:37:09', '2020-11-04 09:12:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(144, 'o1qmn5HnJSil68Qkx-kZgdP26MNg', 2, '2020-10-27 13:39:16', '2021-02-04 02:17:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(145, 'o1qmn5IhA2mRj2YwVOzAxg9KQWF0', 3, '2020-10-27 14:09:13', '2020-11-24 13:58:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(146, 'o1qmn5J2WCwuIxQ4geeZOKdekH5k', 1, '2020-10-27 14:09:13', '2021-03-24 13:12:54', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTJS66dYPvGj0ZqbrBBVjnEy1iaAGOPgiaBhebf1B5ESOZibichKBKsJYFYqygBn0jZjL6r2kSDqo5TSWg/132', '10.11', NULL, NULL, NULL, NULL, 0),
	(147, 'o1qmn5CjxiehHxxhFpWpuMCVjGbE', 7, '2020-10-27 14:59:36', '2020-11-17 13:37:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(148, 'o1qmn5EPV1f3ldH4hKmApwEYw_Y8', 3, '2020-10-27 15:01:40', '2020-11-11 22:25:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(149, 'o1qmn5D05OnCuUhkP2sAMlQT-Blw', 2, '2020-10-27 15:11:40', '2020-11-19 22:57:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(150, 'o1qmn5Hnz-qc582-vDfuUQA3GWG8', 5, '2020-10-27 15:58:18', '2020-11-05 16:05:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(151, 'o1qmn5EX2t45Y14HrWS_iZQ2LI8c', 30, '2020-10-27 16:10:53', '2021-02-23 15:05:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(152, 'o1qmn5KRTwqOPQlbPAcikTkrwdFo', 4, '2020-10-27 16:24:42', '2021-01-02 18:25:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(153, 'o1qmn5Mj9ds6VQ-mbc3SURZGWQpA', 1, '2020-10-27 16:30:33', '2021-02-10 17:12:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(154, 'o1qmn5D0I6YpqxmgcEEU4M-8xDTo', 0, '2020-10-27 16:38:12', '2020-10-27 16:38:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(155, 'o1qmn5J3sM28S9RDdti2E_dmBxQg', 0, '2020-10-27 16:58:40', '2020-10-27 16:58:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(156, 'o1qmn5L2wPKYjN2VEjxaoe8pcxPA', 0, '2020-10-27 17:15:11', '2020-10-27 17:15:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(157, 'o1qmn5GE10WG8nGksEbUXcWNQCBo', 1, '2020-10-27 17:15:32', '2020-10-31 15:04:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(158, 'o1qmn5IxEjgFpvIbIhRXag-AQ7X0', 0, '2020-10-27 17:15:47', '2020-10-27 17:15:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(159, 'o1qmn5Fb5bXqrcJ7WGPY6zo31-ec', 0, '2020-10-27 17:16:28', '2020-10-27 17:16:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(160, 'o1qmn5L1EMmcEUTLIf59lzLnLrXQ', 0, '2020-10-27 17:16:45', '2020-10-27 17:16:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(161, 'o1qmn5CV6uVaVzcqeEQl4FpFYN88', 0, '2020-10-27 17:17:33', '2020-10-27 17:17:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(162, 'o1qmn5HQy85JnP0gq54lnI3wnudY', 0, '2020-10-27 17:18:13', '2020-10-27 17:18:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(163, 'o1qmn5ALvujk2Wjz9U5UvI89ISU0', 5, '2020-10-27 17:18:17', '2020-10-31 14:49:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(164, 'o1qmn5AHT5Daxi8XjM8bLKtAoXT0', 5, '2020-10-27 17:18:18', '2020-10-31 12:23:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(165, 'o1qmn5GW39Ue27LmmYXIU7lz6Q2Y', 1, '2020-10-27 17:18:38', '2020-10-27 20:54:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(166, 'o1qmn5IyOT3hKIBEit5E6rfl8CAs', 1, '2020-10-27 17:18:53', '2020-11-04 09:14:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(167, 'o1qmn5F0YGZrmpnwtk5Zl76mvtYw', 0, '2020-10-27 17:19:14', '2020-10-27 17:19:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(168, 'o1qmn5MFpenEJZmyGR261LzVoG0A', 3, '2020-10-27 17:19:29', '2020-10-31 17:32:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(169, 'o1qmn5B_wgPRJdGydx8Bo-1rAbqo', 2, '2020-10-27 17:19:36', '2020-11-04 12:25:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(170, 'o1qmn5PsyuBmZD43BTdllIsZugVw', 0, '2020-10-27 17:20:19', '2020-10-27 17:20:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(171, 'o1qmn5IEGJ0pwhVMzmMbmw_saq6I', 0, '2020-10-27 17:20:46', '2020-10-27 17:20:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(172, 'o1qmn5BacM1IVLq925YxGse5r8V0', 1, '2020-10-27 17:21:09', '2020-11-04 12:23:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(173, 'o1qmn5PDHohf1DyCibVZ_89zQjMM', 0, '2020-10-27 17:21:25', '2020-10-27 17:21:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(174, 'o1qmn5FpMkDbtiw2rr2WvbG3xQ4I', 1, '2020-10-27 17:21:38', '2021-02-07 23:29:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(175, 'o1qmn5DP8pw5fJayHwM_cbIAqeGI', 1, '2020-10-27 17:21:42', '2021-02-06 08:08:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(176, 'o1qmn5Ger7f1F1nDTTZnJD6YsOaI', 0, '2020-10-27 17:22:16', '2020-10-27 17:22:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(177, 'o1qmn5MjhsPvB2I5Rqy-YV8Sosos', 0, '2020-10-27 17:22:51', '2020-10-27 17:22:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(178, 'o1qmn5BQ3CrlMTdZEmldyoDorjMo', 0, '2020-10-27 17:23:09', '2020-10-27 17:23:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(179, 'o1qmn5P_BUr_93O5B1QNfeiv19bY', 0, '2020-10-27 17:23:31', '2020-10-27 17:23:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(180, 'o1qmn5Cj415uS9kTLw2I9xB-X5gU', 1, '2020-10-27 17:24:28', '2020-11-24 10:34:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(181, 'o1qmn5NhfEb65163OqYsvrQm4CYA', 0, '2020-10-27 17:25:29', '2020-10-27 17:25:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(182, 'o1qmn5DjOihC7EsYztyEIwZfWW38', 0, '2020-10-27 17:31:04', '2020-10-27 17:31:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(183, 'o1qmn5AfCPj0AbM5HZw6fDWds0ds', 1, '2020-10-27 17:31:34', '2021-02-09 17:04:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(184, 'o1qmn5Ma_g8KdNdOn0g7BsWDuo-0', 1, '2020-10-27 17:35:03', '2020-11-23 16:05:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(185, 'o1qmn5FdnfY7McDg76isUkT3zwks', 0, '2020-10-27 17:43:32', '2020-10-27 17:43:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(186, 'o1qmn5F1kpoZg6U5ogYh52akZ9vg', 1, '2020-10-27 17:52:55', '2020-11-12 15:45:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(187, 'o1qmn5CXVKwvRoxDDJ4yZAiAVMvk', 15, '2020-10-27 17:54:54', '2021-03-28 15:05:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(188, 'o1qmn5M5Z4NNpi1hMvqgBSjeeqiE', 1, '2020-10-27 17:55:08', '2020-10-27 20:42:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(189, 'o1qmn5JZk2nedvV3gy-mQ18jB4zw', 0, '2020-10-27 17:57:14', '2020-10-27 17:57:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(190, 'o1qmn5PF3kp2JK2v-FVqUnr8-beY', 0, '2020-10-27 18:10:25', '2020-10-27 18:10:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(191, 'o1qmn5AYSws2J_JSVA2t7cEz4R-0', 0, '2020-10-27 18:11:42', '2020-10-27 18:11:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(192, 'o1qmn5DGTt1zkUpzEDY3mfVt7-08', 14, '2020-10-27 18:12:48', '2020-11-04 08:02:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(193, 'o1qmn5NIfm101MBc8JuCzGkaXq2c', 7, '2020-10-27 18:50:24', '2021-03-25 14:29:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(194, 'o1qmn5NhgbJsLjs3ei38ecFh6zXw', 1, '2020-10-27 19:17:21', '2021-02-10 05:22:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(195, 'o1qmn5MzoxvO3R1thMqZT0uovAv8', 8, '2020-10-27 19:18:37', '2021-02-09 04:48:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(196, 'o1qmn5MMIwzMxcoYuH_I39EzHeXU', 3, '2020-10-27 19:19:33', '2021-02-03 23:41:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(197, 'o1qmn5HhsMsb_yno0rzkQmH-vwK0', 3, '2020-10-27 19:21:34', '2021-02-08 11:13:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(198, 'o1qmn5CKOsAJwy1DBVMa-Em8jt2g', 0, '2020-10-27 19:22:01', '2020-10-27 19:22:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(199, 'o1qmn5HdaXZvGNPy65GD5_7vMcAQ', 1, '2020-10-27 19:22:18', '2021-02-06 20:08:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(200, 'o1qmn5L7sZFyOXdvqi87YDkx8E2w', 0, '2020-10-27 19:22:43', '2020-10-27 19:22:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(201, 'o1qmn5LLoZHdaCZzAQVFeLbcC8jE', 0, '2020-10-27 19:22:52', '2020-10-27 19:22:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(202, 'o1qmn5ErlPbhkQfXjxNHLCwlpD40', 0, '2020-10-27 19:27:29', '2020-10-27 19:27:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(203, 'o1qmn5MZ8oaFS1VN7i312nUvplPE', 0, '2020-10-27 19:29:10', '2020-10-27 19:29:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(204, 'o1qmn5OoZ4DznJMX_-eeIW7fz93Y', 1, '2020-10-27 19:31:34', '2021-02-17 20:05:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(205, 'o1qmn5JeNUhCrDeWG8Eoe5SgHZtM', 0, '2020-10-27 19:33:31', '2020-10-27 19:33:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(206, 'o1qmn5CJJXFYymV7P3QijhCgNXYM', 0, '2020-10-27 19:34:00', '2020-10-27 19:34:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(207, 'o1qmn5G7OIGRmWckYpkyrhyQp4G8', 1, '2020-10-27 19:39:43', '2020-10-27 23:50:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(208, 'o1qmn5IBkrgut8ZIkBImYT2C14Rw', 0, '2020-10-27 20:18:13', '2020-10-27 20:18:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(209, 'o1qmn5Iq1-1lD_o40tqyuaszi0XI', 0, '2020-10-27 21:24:11', '2020-10-27 21:24:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(210, 'o1qmn5IqJ18Ba7E3NUC0idmKIedA', 2, '2020-10-27 21:52:43', '2020-11-29 19:51:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(211, 'o1qmn5B3FQZQH54btzyKI-_E0mM8', 0, '2020-10-27 21:59:35', '2020-10-27 21:59:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(212, 'o1qmn5BrWDo024nqnN1H-iNTW33c', 0, '2020-10-27 22:01:31', '2020-10-27 22:01:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(213, 'o1qmn5C1VZS9qR4fmHF7SQJAJfIM', 0, '2020-10-27 22:01:31', '2020-10-27 22:01:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(214, 'o1qmn5BzaLC6eNdUfbhwEHE0NHSI', 0, '2020-10-27 22:04:03', '2020-10-27 22:04:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(215, 'o1qmn5JxI-eiQ_3Du4BrBQ_tWDfI', 3, '2020-10-27 22:05:02', '2021-01-11 09:01:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(216, 'o1qmn5PvS5CmIrJZ79VG0Y-vZQVI', 0, '2020-10-27 22:05:09', '2020-10-27 22:05:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(217, 'o1qmn5Ms1jtywA7Jzk1orAhY4WME', 0, '2020-10-27 22:07:35', '2020-10-27 22:07:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(218, 'o1qmn5PMZNumgxelOt1BngjH5QRs', 1, '2020-10-27 22:09:27', '2020-11-07 11:55:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(219, 'o1qmn5PUvr09YEpmwfT1o9JUZMY8', 0, '2020-10-27 22:09:32', '2020-10-27 22:09:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(220, 'o1qmn5JSNrFtdfek2_uPnaBmK1bI', 0, '2020-10-27 22:11:46', '2020-10-27 22:11:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(221, 'o1qmn5FFLGmD0YpXYDGN2yxp5XXc', 0, '2020-10-27 22:14:30', '2020-10-27 22:14:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(222, 'o1qmn5BIgmbUr0It-S2c-zKJAIrs', 0, '2020-10-27 22:14:55', '2020-10-27 22:14:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(223, 'o1qmn5D5ES94y7Ih8XuTiQ7Z1ED8', 1, '2020-10-27 22:15:52', '2021-01-27 10:20:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(224, 'o1qmn5Ksl9mhx0X2VYntcT1DXxcs', 0, '2020-10-27 22:18:02', '2020-10-27 22:18:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(225, 'o1qmn5EQJeJq7z9j2X4NsNwScR_I', 0, '2020-10-27 22:23:00', '2020-10-27 22:23:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(226, 'o1qmn5FvaeAeWCk-Xpw9gjcwrVf8', 5, '2020-10-27 22:23:18', '2021-02-08 11:11:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(227, 'o1qmn5Gg7jVqXrekVCn-u7tfFvAo', 0, '2020-10-27 22:23:38', '2020-10-27 22:23:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(228, 'o1qmn5GE0OAyaOeqNVOM7HWc2yiU', 3, '2020-10-27 22:23:50', '2020-10-27 22:23:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(229, 'o1qmn5JEP0CD_2wovG7UE520FPlk', 0, '2020-10-27 22:23:58', '2020-10-27 22:23:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(230, 'o1qmn5M_Lb8kCba85IXcXFBooGTw', 0, '2020-10-27 22:29:13', '2020-10-27 22:29:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(231, 'o1qmn5Hpy30eRfxIdPz7XJV2IGrc', 2, '2020-10-27 22:31:25', '2021-01-03 09:06:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(232, 'o1qmn5JwOnWb5_7MVvI9Br27lreo', 0, '2020-10-27 22:34:02', '2020-10-27 22:34:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(233, 'o1qmn5PnF1rx4HBLEO2lCjQyVs1I', 0, '2020-10-27 22:34:48', '2020-10-27 22:34:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(234, 'o1qmn5Nfxk2whCnB3Oibq2grsXDY', 1, '2020-10-27 22:38:08', '2020-11-14 14:43:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(235, 'o1qmn5DIVTH54wvaFtruK1VgejsQ', 5, '2020-10-27 22:56:19', '2020-11-04 12:25:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(236, 'o1qmn5LMh43UJ40tzhtHQUL6dzVg', 3, '2020-10-27 23:03:16', '2020-10-27 23:03:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(237, 'o1qmn5IkTwkI9jBuCQHeuhk3TQ8k', 0, '2020-10-27 23:03:33', '2020-10-27 23:03:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(238, 'o1qmn5AyrK5K444qIDHCRid2W8Es', 5, '2020-10-27 23:12:04', '2021-02-18 15:44:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(239, 'o1qmn5GvLFQ19j7QciE8OhllZJsY', 0, '2020-10-27 23:15:17', '2020-10-27 23:15:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(240, 'o1qmn5KgEGnQFj-B7hs2_92sXojk', 0, '2020-10-27 23:24:38', '2020-10-27 23:24:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(241, 'o1qmn5CPqjM4beFGc7uoZQHa-raE', 0, '2020-10-27 23:32:38', '2020-10-27 23:32:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(242, 'o1qmn5G_plXgK4rKUgy8nWj0YAXw', 0, '2020-10-27 23:53:06', '2020-10-27 23:53:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(243, 'o1qmn5JfU5WSNydJGINV93DJYcbk', 1, '2020-10-28 00:01:06', '2020-11-09 12:18:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(244, 'o1qmn5D2cyAoM18U1n11afDCXUis', 0, '2020-10-28 00:05:44', '2020-10-28 00:05:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(245, 'o1qmn5LDL3cKdAN88Q3JYw_3LEps', 0, '2020-10-28 00:17:14', '2020-10-28 00:17:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(246, 'o1qmn5CKTLKYFCrQQ_929JMPWszU', 0, '2020-10-28 00:18:55', '2020-10-28 00:18:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(247, 'o1qmn5FfUY6x3cje6G0ED6vxM9m0', 0, '2020-10-28 00:30:35', '2020-10-28 00:30:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(248, 'o1qmn5FOc3Dfps9hDSBARfcfYFy4', 2, '2020-10-28 00:43:50', '2020-10-28 00:43:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(249, 'o1qmn5AfB4fOgDDu4jNkucVc0mlc', 4, '2020-10-28 00:56:40', '2021-02-11 18:56:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(250, 'o1qmn5GullyILHCCwzW2y1Y86FgA', 0, '2020-10-28 04:05:00', '2020-10-28 04:05:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(251, 'o1qmn5NBET3Rf-tTEtkxzFp8--po', 3, '2020-10-28 04:43:10', '2020-11-04 09:14:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(252, 'o1qmn5OYMjBsY5c8Z-FykZjLooNk', 4, '2020-10-28 04:49:47', '2021-02-08 11:14:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(253, 'o1qmn5Ngs4G6FJ0DoFEQldu9S-b0', 1, '2020-10-28 04:55:43', '2021-02-04 01:18:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(254, 'o1qmn5PISeIi9TjUlfTIzxyKakuw', 20, '2020-10-28 05:02:08', '2020-11-04 12:23:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(255, 'o1qmn5KmS6uCHeMU0-y4ytmvILK4', 3, '2020-10-28 05:13:22', '2020-10-28 05:13:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(256, 'o1qmn5OZs6LyZYpP4uaUpDULEjXk', 3, '2020-10-28 06:07:24', '2021-02-04 02:17:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(257, 'o1qmn5O4OrtkSjdshydQJcLV1r6s', 0, '2020-10-28 06:39:47', '2020-10-28 06:39:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(258, 'o1qmn5HcJv7wujAcE5N7zF7i_O-w', 0, '2020-10-28 06:40:51', '2020-10-28 06:40:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(259, 'o1qmn5MV1dK0_RC7y4VrKCv_mVNE', 0, '2020-10-28 06:53:17', '2020-10-28 06:53:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(260, 'o1qmn5Jt7vqU3dyVDKLRkU2JZ5U8', 2, '2020-10-28 07:00:25', '2020-11-29 07:30:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(261, 'o1qmn5KJAxeiSI-6x1ju2xThSQgE', 0, '2020-10-28 07:52:35', '2020-10-28 07:52:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(262, 'o1qmn5MwwGzPbQXJclPuqY5YwnQI', 0, '2020-10-28 07:55:33', '2020-10-28 07:55:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(263, 'o1qmn5NwG28xYLSTGfGuUiopq_F0', 0, '2020-10-28 08:10:42', '2020-10-28 08:10:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(264, 'o1qmn5JgpXQLF0m7s2gnqSRpivnY', 5, '2020-10-28 08:22:25', '2021-02-06 20:45:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(265, 'o1qmn5FteO6SUU4_XNrU1yZFWZR0', 4, '2020-10-28 08:40:45', '2021-03-08 10:03:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(266, 'o1qmn5MEWjWcMliVQvLbljN5cH9U', 0, '2020-10-28 09:08:01', '2020-10-28 09:08:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(267, 'o1qmn5H97O4C0sgBhJfYv5xxsIOQ', 0, '2020-10-28 09:18:50', '2020-10-28 09:18:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(268, 'o1qmn5MAfAMyEvdOyHT46mZtM-q4', 25, '2020-10-28 10:14:08', '2021-03-29 09:39:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(269, 'o1qmn5Fg3be-tX6fu1ci9fiGTCK8', 11, '2020-10-28 10:20:48', '2021-03-05 13:46:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(270, 'o1qmn5GHcC1eS9DT2dZWqL4r1Q0s', 0, '2020-10-28 10:39:57', '2020-10-28 10:39:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(271, 'o1qmn5I1aWmTh_iDbjADbe97is44', 0, '2020-10-28 11:09:38', '2020-10-28 11:09:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(272, 'o1qmn5M_5idKq54tHMnzTVLqiUQM', 0, '2020-10-28 11:11:26', '2020-10-28 11:11:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(273, 'o1qmn5PUtSxiUFXQxktzC4Jt0zXI', 0, '2020-10-28 11:31:57', '2020-10-28 11:31:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(274, 'o1qmn5MTTB4LFuG3rHhRu7aHldGQ', 0, '2020-10-28 12:09:18', '2020-10-28 12:09:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(275, 'o1qmn5EgyItdS4YkqBFje7M07Ik4', 1, '2020-10-28 12:50:13', '2020-10-29 11:12:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(276, 'o1qmn5Do0KgU-1Vy9ZynD669IL5A', 1, '2020-10-28 12:56:13', '2020-11-20 13:40:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(277, 'o1qmn5HEN8wZ2isXeUgJ--qztKOs', 1, '2020-10-28 13:02:20', '2020-10-28 14:51:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(278, 'o1qmn5HiwUKv5K-20-MjvRHcQa9A', 1, '2020-10-28 13:44:19', '2020-10-28 23:40:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(279, 'o1qmn5GLxlzUqwXbjBC53bMqf7IQ', 0, '2020-10-28 13:49:29', '2020-10-28 13:49:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(280, 'o1qmn5NziSoHSSgxP_YqxWqrJ5m0', 34, '2020-10-28 14:33:43', '2021-03-18 19:52:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(281, 'o1qmn5CK1IW_z8izDnNFHLQ75maQ', 4, '2020-10-28 14:43:18', '2021-03-19 18:48:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(282, 'o1qmn5GoKUtZVSqkHaRmxVmvSO_Q', 0, '2020-10-28 14:43:20', '2020-10-28 14:43:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(283, 'o1qmn5EeHOhT-XVKITX6XZ1gHtOM', 44, '2020-10-28 15:10:03', '2021-03-29 10:26:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(284, 'o1qmn5HAUlQyoQ8ap9W2GzG5rXwc', 11, '2020-10-28 15:11:21', '2020-12-12 05:21:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(285, 'o1qmn5Khy6Ntc6TeuC-_1Ec7hubs', 0, '2020-10-28 15:21:15', '2020-10-28 15:21:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(286, 'o1qmn5GNfp43MJ7CLlqQmVASHCWo', 0, '2020-10-28 16:24:55', '2020-10-28 16:24:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(287, 'o1qmn5GezIndgOr-fm5_VL3_BjnQ', 2, '2020-10-28 16:27:32', '2020-10-31 14:48:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(288, 'o1qmn5GjXmg1aB9k3gpmPDfoHx38', 0, '2020-10-28 16:28:07', '2020-10-28 16:28:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(289, 'o1qmn5Jv7UtJc4w48l85J8M1e2xw', 58, '2020-10-28 16:45:34', '2021-02-20 09:52:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(290, 'o1qmn5CB-LPpjbv57w7nUo_CRw3g', 0, '2020-10-28 16:55:16', '2020-10-28 16:55:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(291, 'o1qmn5KtduUa96h_JSfIhkJEjL2U', 0, '2020-10-28 16:57:37', '2020-10-28 16:57:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(292, 'o1qmn5AqGbfEhieF47uaoPQH2hUc', 0, '2020-10-28 16:58:54', '2020-10-28 16:58:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(293, 'o1qmn5E-zNrmrU8chno2EYfC_fQQ', 0, '2020-10-28 17:04:14', '2020-10-28 17:04:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(294, 'o1qmn5CZDBq2Nmwvq92D-apQ5s0s', 0, '2020-10-28 17:20:56', '2020-10-28 17:20:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(295, 'o1qmn5A5HW2X3z4KL2rr-MNRPfT4', 0, '2020-10-28 17:32:56', '2020-10-28 17:32:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(296, 'o1qmn5JtQ4U8C1X55gxN_mFBlcuU', 0, '2020-10-28 17:34:17', '2020-10-28 17:34:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(297, 'o1qmn5MiBvGZ1e0L_ta7abzbvk9Q', 0, '2020-10-28 17:57:25', '2020-10-28 17:57:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(298, 'o1qmn5GeZUFc5vG_3hAUNJ6phwX4', 0, '2020-10-28 19:45:53', '2020-10-28 19:45:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(299, 'o1qmn5Fcbv6hlyv4aO4mA-MQbGLA', 2, '2020-10-28 21:47:43', '2020-10-29 08:47:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(300, 'o1qmn5MDkp_NyP2WuH7vXddWy_64', 0, '2020-10-28 22:08:14', '2020-10-28 22:08:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(301, 'o1qmn5IUaz6_OCdhHJmbaJlGk_II', 0, '2020-10-28 22:16:00', '2020-10-28 22:16:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(302, 'o1qmn5N_j3S5Wmow-AQp7DuNE6Kw', 0, '2020-10-28 23:06:26', '2020-10-28 23:06:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(303, 'o1qmn5FpkCL2_Ko1CXPIZvFtKec4', 0, '2020-10-29 06:43:49', '2020-10-29 06:43:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(304, 'o1qmn5Lo6FbH1pbsURvp9Xt-EgRU', 49, '2020-10-29 09:04:05', '2021-03-20 12:09:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(305, 'o1qmn5KtuiPBtWLkeFDSoboH2AM8', 0, '2020-10-29 09:04:54', '2020-10-29 09:04:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(306, 'o1qmn5BdZZPbV8FK3uqbyvKQ-voM', 0, '2020-10-29 09:05:43', '2020-10-29 09:05:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(307, 'o1qmn5Na1LDltfU3GwJb0frQlkE0', 0, '2020-10-29 09:11:48', '2020-10-29 09:11:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(308, 'o1qmn5OBJVUUvRlttAUrY1UGdw34', 2, '2020-10-29 09:18:35', '2020-10-31 08:30:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(309, 'o1qmn5DjWXfxQ3NY6lEVaBTfXTk8', 0, '2020-10-29 09:20:38', '2020-10-29 09:20:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(310, 'o1qmn5H0cYPZG9IUmNKqM3Uc52xo', 0, '2020-10-29 09:23:57', '2020-10-29 09:23:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(311, 'o1qmn5JFkoEVoH3xSAOHZei-FHSo', 0, '2020-10-29 09:28:43', '2020-10-29 09:28:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(312, 'o1qmn5GEvD5cCqGkqHNK5qDnkk6E', 0, '2020-10-29 09:30:00', '2020-10-29 09:30:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(313, 'o1qmn5CThytM-jgAil0f97wzXwb8', 2, '2020-10-29 09:32:37', '2020-10-30 10:14:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(314, 'o1qmn5ODkeOkd2Fu8h6_Uqw00h2o', 1, '2020-10-29 09:37:43', '2020-11-03 08:52:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(315, 'o1qmn5LbgzTzJIzUg8_JaVtagl-8', 0, '2020-10-29 09:41:13', '2020-10-29 09:41:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(316, 'o1qmn5EOk2kIvnTbpCYfHAgmji94', 0, '2020-10-29 09:45:07', '2020-10-29 09:45:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(317, 'o1qmn5KSxffv13C-kGD5ssX37-sA', 0, '2020-10-29 09:48:00', '2020-10-29 09:48:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(318, 'o1qmn5InnPZByDafkasMAd21yH-8', 1, '2020-10-29 09:49:49', '2020-11-30 15:10:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(319, 'o1qmn5AM30CeH2RflJg--QXp2RRQ', 1, '2020-10-29 09:52:54', '2020-12-07 14:40:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(320, 'o1qmn5FKAx3z1iNt0voDpnrlyRcM', 0, '2020-10-29 09:53:02', '2020-10-29 09:53:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(321, 'o1qmn5EUsLGZAhzgPQ8jiS0QRS8o', 0, '2020-10-29 09:56:15', '2020-10-29 09:56:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(322, 'o1qmn5LFQuQRoK7i4hw1vIkFyzMA', 0, '2020-10-29 09:59:26', '2020-10-29 09:59:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(323, 'o1qmn5PE4Njc-1e_3BHylreguxTE', 1, '2020-10-29 10:01:30', '2020-10-30 15:55:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(324, 'o1qmn5J8B3dM_dHK1x56pS_yIGdg', 2, '2020-10-29 10:01:30', '2020-10-30 15:55:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(325, 'o1qmn5Am-45gGsD1wlt5MGGDFu3g', 0, '2020-10-29 10:03:19', '2020-10-29 10:03:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(326, 'o1qmn5DmTL5MUQZveuSBaEFj1VJ0', 0, '2020-10-29 10:04:50', '2020-10-29 10:04:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(327, 'o1qmn5Goki7m2mUybTf0OpBLPhqo', 0, '2020-10-29 10:05:37', '2020-10-29 10:05:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(328, 'o1qmn5M52QVdc_WtMxbBC6Plh5rI', 0, '2020-10-29 10:05:42', '2020-10-29 10:05:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(329, 'o1qmn5DB27VaSTVEbCOslB4ZXK-8', 0, '2020-10-29 10:06:18', '2020-10-29 10:06:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(330, 'o1qmn5NLLJvBluQ9oU1LjADNMKwM', 0, '2020-10-29 10:07:27', '2020-10-29 10:07:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(331, 'o1qmn5ImVpUP1jYe-i3qP7SBUR7U', 1, '2020-10-29 10:12:04', '2020-12-06 07:05:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(332, 'o1qmn5ELGTQLKkyA71XLOc2KoLkQ', 0, '2020-10-29 10:14:58', '2020-10-29 10:14:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(333, 'o1qmn5KSu5IkYD07mSA3ag7Yilzw', 0, '2020-10-29 10:15:07', '2020-10-29 10:15:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(334, 'o1qmn5AF9mq0k8HclJvjfznJEwJI', 0, '2020-10-29 10:15:40', '2020-10-29 10:15:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(335, 'o1qmn5BhwcuOlsAep2HdneHNsI7Q', 0, '2020-10-29 10:15:43', '2020-10-29 10:15:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(336, 'o1qmn5OgKfZy_qirRK93mpnhH9e4', 0, '2020-10-29 10:16:41', '2020-10-29 10:16:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(337, 'o1qmn5H6WMwie5KfBZqGptdIiqFE', 1, '2020-10-29 10:16:50', '2020-11-06 11:01:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(338, 'o1qmn5NP-c7eCsEnLTuWUPz-uk9A', 0, '2020-10-29 10:19:52', '2020-10-29 10:19:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(339, 'o1qmn5NcaTW21UakKxMfLZxt_m6I', 35, '2020-10-29 10:20:16', '2021-03-24 13:14:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(340, 'o1qmn5GqBrJ1hKDzSCEK94KDl2Eo', 2, '2020-10-29 10:21:53', '2020-11-02 21:39:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(341, 'o1qmn5DmAcL7GHTykUXfeakCILXo', 0, '2020-10-29 10:28:32', '2020-10-29 10:28:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(342, 'o1qmn5HTgE4kQ6bG6BQs3K7gno9M', 0, '2020-10-29 10:28:40', '2020-10-29 10:28:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(343, 'o1qmn5IxbGMMRRRkbQkjBIfe4fOo', 1, '2020-10-29 10:28:50', '2021-02-26 13:15:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(344, 'o1qmn5EO_RVT0vCoBZFWj1OU4f-s', 0, '2020-10-29 10:28:53', '2020-10-29 10:28:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(345, 'o1qmn5HLZ0uJvkTzjk2dwDXwtyO0', 0, '2020-10-29 10:29:07', '2020-10-29 10:29:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(346, 'o1qmn5JGfGNgKykQi9_SD2Z0fMEE', 0, '2020-10-29 10:30:31', '2020-10-29 10:30:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(347, 'o1qmn5HAnxKgQvzO59_0N_Gf3n3I', 1, '2020-10-29 10:30:49', '2021-01-25 08:53:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(348, 'o1qmn5PIj_7hnUrloDBx3gDbTgT4', 0, '2020-10-29 10:30:53', '2020-10-29 10:30:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(349, 'o1qmn5IyfuXErYa2HKhZHdkbhDlQ', 0, '2020-10-29 10:32:32', '2020-10-29 10:32:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(350, 'o1qmn5Mhx5JYfuDPF9GJlzn79jPI', 36, '2020-10-29 10:34:21', '2021-03-28 17:39:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(351, 'o1qmn5CAp81SPBwh6NFSwPs5gy9A', 9, '2020-10-29 10:34:34', '2021-01-23 12:16:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(352, 'o1qmn5JgE3xlALClrgWzUyMr-1Y8', 0, '2020-10-29 10:34:51', '2020-10-29 10:34:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(353, 'o1qmn5Iv8xero7EymfGTWgp3uJd8', 0, '2020-10-29 10:34:52', '2020-10-29 10:34:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(354, 'o1qmn5Jf6ViF_hiV-rOKOI2IVkTY', 1, '2020-10-29 10:35:42', '2021-03-19 15:52:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(355, 'o1qmn5DtaBLdzuTJ25phW8v9P0K8', 0, '2020-10-29 10:39:30', '2020-10-29 10:39:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(356, 'o1qmn5FI_OdSSrECMItefgiCWlas', 0, '2020-10-29 10:39:42', '2020-10-29 10:39:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(357, 'o1qmn5MTbWhgRA07i6Qjlk0yNIwA', 0, '2020-10-29 10:41:42', '2020-10-29 10:41:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(358, 'o1qmn5EWIOekVDy6KvShFKg2KhYs', 0, '2020-10-29 10:42:14', '2020-10-29 10:42:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(359, 'o1qmn5H460OyQllkEa623Rahd3jY', 0, '2020-10-29 10:42:27', '2020-10-29 10:42:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(360, 'o1qmn5Iu7ynJVGXT3ONYpvmEKTD8', 0, '2020-10-29 10:42:54', '2020-10-29 10:42:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(361, 'o1qmn5MTbygi0G6Gqtlw4mmHxEz8', 1, '2020-10-29 10:42:55', '2020-11-19 08:00:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(362, 'o1qmn5Cy2P4td2zdnRsTrKMq6jLc', 0, '2020-10-29 10:44:32', '2020-10-29 10:44:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(363, 'o1qmn5OWouCyE6K6eXKv3_IO-MzQ', 0, '2020-10-29 10:45:06', '2020-10-29 10:45:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(364, 'o1qmn5KZGujUyKn4kGk59FYtVeNQ', 0, '2020-10-29 10:45:15', '2020-10-29 10:45:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(365, 'o1qmn5Cba6GZDx36q8gts0LqyYmg', 0, '2020-10-29 10:45:38', '2020-10-29 10:45:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(366, 'o1qmn5J22su_VyhJQQ4am8OQy18g', 0, '2020-10-29 10:46:02', '2020-10-29 10:46:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(367, 'o1qmn5OfDkHWYEULdzvkp4m1dTgk', 0, '2020-10-29 10:46:03', '2020-10-29 10:46:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(368, 'o1qmn5GmnRibGRnH8juGkxG52394', 0, '2020-10-29 10:47:09', '2020-10-29 10:47:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(369, 'o1qmn5MYm1uxKqkSDQ2nJfZFKMZo', 2, '2020-10-29 10:50:00', '2020-11-03 18:16:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(370, 'o1qmn5Ig-oztIG-SPD9LIQUMt6u4', 0, '2020-10-29 10:51:04', '2020-10-29 10:51:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(371, 'o1qmn5MZCbGAGYq_K6pt4tO258jg', 0, '2020-10-29 10:51:04', '2020-10-29 10:51:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(372, 'o1qmn5BxkULg7FWEO4xFyrUmVezo', 1, '2020-10-29 10:52:59', '2020-12-06 22:39:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(373, 'o1qmn5DrG7MpTyjdWYsJCBmhIb30', 0, '2020-10-29 10:55:02', '2020-10-29 10:55:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(374, 'o1qmn5NY-Nfpqj5Zw5xRM0i5QTis', 12, '2020-10-29 10:55:10', '2021-03-08 10:37:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(375, 'o1qmn5ALMYwxL5or0vb4E2iIFh-g', 0, '2020-10-29 10:55:25', '2020-10-29 10:55:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(376, 'o1qmn5FobKbq0HrSYuyycSBgx2Qc', 0, '2020-10-29 10:55:41', '2020-10-29 10:55:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(377, 'o1qmn5CEC1WTNOBUZBTxP7zoqawI', 6, '2020-10-29 10:56:43', '2020-12-03 10:06:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(378, 'o1qmn5EwWQ_HTxbOistkYo4T8mYA', 3, '2020-10-29 11:01:07', '2021-03-19 16:25:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(379, 'o1qmn5Ha5CIuxZZ1ymkekwPjRs30', 0, '2020-10-29 11:05:09', '2020-10-29 11:05:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(380, 'o1qmn5HGgpczTaeDXhUw9YqiBARw', 0, '2020-10-29 11:05:20', '2020-10-29 11:05:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(381, 'o1qmn5GIfjoHQIplEVD4VqyMbz7Q', 0, '2020-10-29 11:05:29', '2020-10-29 11:05:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(382, 'o1qmn5POFRxn6uzpoSx_wMkmSwlk', 0, '2020-10-29 11:05:52', '2020-10-29 11:05:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(383, 'o1qmn5JMaH64ygCVh8UwMuzqlK74', 1, '2020-10-29 11:06:40', '2020-11-03 19:55:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(384, 'o1qmn5EdROGHxIkE4ZRblS5lG4-c', 0, '2020-10-29 11:06:41', '2020-10-29 11:06:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(385, 'o1qmn5PsjpEiDrdd5TPNFJ3dLtec', 0, '2020-10-29 11:06:45', '2020-10-29 11:06:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(386, 'o1qmn5CkXWdRoPUHPjoUuMAnLco4', 0, '2020-10-29 11:06:55', '2020-10-29 11:06:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(387, 'o1qmn5Lz3Pr6EonSSSJx1hu1siCs', 1, '2020-10-29 11:07:01', '2020-12-05 22:30:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(388, 'o1qmn5OhFy4RLN8eqLcVr5a1nnpI', 0, '2020-10-29 11:07:06', '2020-10-29 11:07:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(389, 'o1qmn5HqP-nwoK0ivtJ1si9zXkzo', 2, '2020-10-29 11:08:27', '2021-03-07 12:58:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(390, 'o1qmn5KMaHI5Y7ta-79_wKlJbb1M', 0, '2020-10-29 11:09:25', '2020-10-29 11:09:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(391, 'o1qmn5HtHqccGJ2bMGz1T2Cps4wI', 1, '2020-10-29 11:10:41', '2020-11-14 11:40:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(392, 'o1qmn5EFsJ38h-v2j0JDiWhaXgbk', 0, '2020-10-29 11:10:53', '2020-10-29 11:10:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(393, 'o1qmn5Fw8Ztt-8DMOm5mRaInVgTk', 0, '2020-10-29 11:11:15', '2020-10-29 11:11:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(394, 'o1qmn5FU23pz84iv6ZRxvKGHxUpg', 0, '2020-10-29 11:11:37', '2020-10-29 11:11:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(395, 'o1qmn5HxPNKL_Wi1diyrP1ZUSxto', 0, '2020-10-29 11:13:18', '2020-10-29 11:13:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(396, 'o1qmn5MOXmzI6yZNpqW8bCrwPTgE', 0, '2020-10-29 11:13:55', '2020-10-29 11:13:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(397, 'o1qmn5Hmsm5P7FfnLtID0oq4l4mc', 0, '2020-10-29 11:14:02', '2020-10-29 11:14:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(398, 'o1qmn5DRoMHU_Za_MVGTq8YUuPjg', 1, '2020-10-29 11:15:59', '2020-11-30 18:31:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(399, 'o1qmn5KZgagy7raw_19tPBIGAucY', 0, '2020-10-29 11:16:35', '2020-10-29 11:16:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(400, 'o1qmn5Pj4iSD_EtNyECt-zLxsHB0', 1, '2020-10-29 11:16:55', '2020-12-15 18:26:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(401, 'o1qmn5PPq7ahnR0eBVf9MPoE_pxc', 1, '2020-10-29 11:17:05', '2021-01-17 08:04:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(402, 'o1qmn5JiZ2Tl7zsfBRCkR877LRNA', 0, '2020-10-29 11:17:24', '2020-10-29 11:17:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(403, 'o1qmn5B7FpAKwH3A5VY3EP-Zlxl8', 0, '2020-10-29 11:17:39', '2020-10-29 11:17:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(404, 'o1qmn5FImtFecWPVaifanweboGVw', 0, '2020-10-29 11:17:43', '2020-10-29 11:17:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(405, 'o1qmn5ErLUy3T_DJNY_LJgbS-R8o', 2, '2020-10-29 11:17:46', '2020-11-04 13:57:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(406, 'o1qmn5B-CVVThg2Uvip_MgudMxGc', 2, '2020-10-29 11:19:54', '2020-10-30 23:49:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(407, 'o1qmn5A45II_i1rVpQl9FWTvinBA', 0, '2020-10-29 11:20:13', '2020-10-29 11:20:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(408, 'o1qmn5MNB9779BMBUBSJN5Z4_HFQ', 0, '2020-10-29 11:20:44', '2020-10-29 11:20:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(409, 'o1qmn5NS2DYSj2b0HC7MxOYfB5dU', 0, '2020-10-29 11:20:45', '2020-10-29 11:20:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(410, 'o1qmn5KgU2Y2e41mMdKIVQst9M2U', 0, '2020-10-29 11:21:36', '2020-10-29 11:21:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(411, 'o1qmn5KIDZtkKmeMarcZFS3ldQ8w', 0, '2020-10-29 11:22:55', '2020-10-29 11:22:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(412, 'o1qmn5KqnUIt5yZ_dyELmvHpgQA8', 0, '2020-10-29 11:24:22', '2020-10-29 11:24:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(413, 'o1qmn5MhPv4AH85I6JD8TayOBCDs', 2, '2020-10-29 11:24:47', '2020-12-10 18:14:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(414, 'o1qmn5DQXGcSG6m36sgAoM0N0BPY', 0, '2020-10-29 11:24:56', '2020-10-29 11:24:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(415, 'o1qmn5A4nQD-zYjl9PWAC986kcZE', 0, '2020-10-29 11:26:35', '2020-10-29 11:26:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(416, 'o1qmn5MleVx9TFD8TAP539vQVzjM', 0, '2020-10-29 11:26:36', '2020-10-29 11:26:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(417, 'o1qmn5NW3JsIn9sSyZ8UtWHHTdnw', 0, '2020-10-29 11:26:42', '2020-10-29 11:26:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(418, 'o1qmn5AcZ5cECZSunELorfg7M77w', 0, '2020-10-29 11:26:48', '2020-10-29 11:26:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(419, 'o1qmn5C7hWTWp9df24fnNAofsa2U', 0, '2020-10-29 11:26:51', '2020-10-29 11:26:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(420, 'o1qmn5LotC1u_EYQucJPCMnOPKOU', 0, '2020-10-29 11:30:32', '2020-10-29 11:30:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(421, 'o1qmn5Edt0edML1M1CvdluFFSHo8', 1, '2020-10-29 11:35:50', '2020-10-29 16:05:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(422, 'o1qmn5HPeF8dpJnfAyr0tfh9w0QI', 0, '2020-10-29 11:36:15', '2020-10-29 11:36:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(423, 'o1qmn5AH2-Xsso4LSw3Z2SRHTa5o', 26, '2020-10-29 11:37:42', '2021-03-26 13:58:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(424, 'o1qmn5M88L-hISFPgor-skyi9S_U', 3, '2020-10-29 11:39:04', '2020-10-30 21:00:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(425, 'o1qmn5C8rAPCbwgOff1jnp9gzQW4', 0, '2020-10-29 11:44:23', '2020-10-29 11:44:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(426, 'o1qmn5N14gtMVCgw6PhUEZP05mkE', 0, '2020-10-29 11:44:30', '2020-10-29 11:44:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(427, 'o1qmn5FZUrhTz81hUgbwUrQiJBv0', 0, '2020-10-29 11:45:03', '2020-10-29 11:45:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(428, 'o1qmn5E8eISLOF6qtznqU__Gt0Cw', 0, '2020-10-29 11:47:45', '2020-10-29 11:47:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(429, 'o1qmn5MSr5ZVo5k5O8z4pAeq-9Dw', 0, '2020-10-29 11:48:05', '2020-10-29 11:48:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(430, 'o1qmn5MfGP95kogcxtpSbzajC-Wc', 0, '2020-10-29 11:48:32', '2020-10-29 11:48:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(431, 'o1qmn5HoY0gOqUdzbjvAGeFXG0BU', 1, '2020-10-29 11:49:18', '2020-10-29 18:51:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(432, 'o1qmn5H4hxTCOZu9AoDG_phwCDAU', 0, '2020-10-29 11:49:29', '2020-10-29 11:49:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(433, 'o1qmn5CMcCsuEeAAXf4Y44-vMDEE', 0, '2020-10-29 11:51:33', '2020-10-29 11:51:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(434, 'o1qmn5JBQpiNj837LeunX31MurKI', 2, '2020-10-29 11:52:14', '2021-01-07 20:01:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(435, 'o1qmn5OUbV2-JzeniIhDDNF_CQXE', 0, '2020-10-29 11:54:21', '2020-10-29 11:54:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(436, 'o1qmn5FdLr5czzJf3NlK-5b96U6o', 0, '2020-10-29 11:54:34', '2020-10-29 11:54:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(437, 'o1qmn5PPmTLll2ikPAieG57kqt6k', 0, '2020-10-29 11:55:34', '2020-10-29 11:55:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(438, 'o1qmn5Oex8gxnUs_yFLyoA6DRjBM', 0, '2020-10-29 11:55:41', '2020-10-29 11:55:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(439, 'o1qmn5DU-78uHKXAvXg8QQtHPpL0', 0, '2020-10-29 11:55:50', '2020-10-29 11:55:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(440, 'o1qmn5NF1WngX3wdvh1gLqLT6Meo', 0, '2020-10-29 11:56:16', '2020-10-29 11:56:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(441, 'o1qmn5Mz-xF_tCbKm4pj8Mbvqol0', 0, '2020-10-29 11:57:56', '2020-10-29 11:57:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(442, 'o1qmn5IIbgD-V8RrYsBNlLZY8eIk', 0, '2020-10-29 12:01:07', '2020-10-29 12:01:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(443, 'o1qmn5CV5TDHpN9Yv-Z8jjT2OMIM', 0, '2020-10-29 12:02:09', '2020-10-29 12:02:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(444, 'o1qmn5ItS6lTMuzAnfNSHyBwHz5g', 0, '2020-10-29 12:03:56', '2020-10-29 12:03:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(445, 'o1qmn5GwNawE4Og9GCKBb4vcrz04', 0, '2020-10-29 12:04:35', '2020-10-29 12:04:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(446, 'o1qmn5J4Sh8c4CoKLSCgl7M-3X0E', 0, '2020-10-29 12:04:57', '2020-10-29 12:04:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(447, 'o1qmn5DAi01SPw-bNtXwq1Nz0pgI', 0, '2020-10-29 12:05:21', '2020-10-29 12:05:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(448, 'o1qmn5NxmGe0vJABrx6bf1_0m1iY', 0, '2020-10-29 12:09:44', '2020-10-29 12:09:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(449, 'o1qmn5F6G05rmtNFhB2g86DhSm80', 0, '2020-10-29 12:16:23', '2020-10-29 12:16:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(450, 'o1qmn5OqWpoUpgT1R44Iv8JCAN34', 5, '2020-10-29 12:16:25', '2020-12-01 17:52:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(451, 'o1qmn5MRN9BWTN0cwg3B3SYBZRhQ', 2, '2020-10-29 12:17:25', '2021-01-18 14:21:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(452, 'o1qmn5CnBRE_4fq-R_65N3QyDLnQ', 0, '2020-10-29 12:19:46', '2020-10-29 12:19:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(453, 'o1qmn5LBtX6bv8npgBPeRcLN5TyY', 2, '2020-10-29 12:19:56', '2021-03-19 10:11:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(454, 'o1qmn5O7wsNC6ACQIsB2CR1t1DlQ', 0, '2020-10-29 12:20:10', '2020-10-29 12:20:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(455, 'o1qmn5OVQg5U4RFRQ_y7Pl5uAJ_E', 1, '2020-10-29 12:20:16', '2020-11-13 15:49:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(456, 'o1qmn5B3vWNFWLiSa0O7qTezJ7_Y', 0, '2020-10-29 12:21:54', '2020-10-29 12:21:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(457, 'o1qmn5JrGdRccd1xc3urKIbTMkbU', 0, '2020-10-29 12:24:08', '2020-10-29 12:24:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(458, 'o1qmn5IcL145NBRB6MMhi2n4jV9M', 0, '2020-10-29 12:24:45', '2020-10-29 12:24:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(459, 'o1qmn5GqkmTV3bEQlc7o2XQyh2_E', 0, '2020-10-29 12:24:49', '2020-10-29 12:24:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(460, 'o1qmn5CXGPtodmfNcy1WBubXa5oI', 0, '2020-10-29 12:25:43', '2020-10-29 12:25:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(461, 'o1qmn5N9lbH7RMDbZCHThuvK3d3g', 0, '2020-10-29 12:25:49', '2020-10-29 12:25:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(462, 'o1qmn5OkP_fycnRobyPepdsmRS50', 0, '2020-10-29 12:29:21', '2020-10-29 12:29:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(463, 'o1qmn5Gyyt9v2Q1nqHed7LoAYiv8', 0, '2020-10-29 12:30:30', '2020-10-29 12:30:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(464, 'o1qmn5PrNW3BpxM-c07GfpoyRbjA', 1, '2020-10-29 12:30:49', '2021-03-22 06:15:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(465, 'o1qmn5B0GEE-eSuHF5kjz20vQaDg', 0, '2020-10-29 12:32:31', '2020-10-29 12:32:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(466, 'o1qmn5L1lzG2Jlz3lfwwcFCnfj-k', 0, '2020-10-29 12:32:43', '2020-10-29 12:32:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(467, 'o1qmn5PnfaR0jL6bW_WMKNmmuFvg', 0, '2020-10-29 12:33:17', '2020-10-29 12:33:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(468, 'o1qmn5ENte-S5YERv6ZysV5zly1A', 0, '2020-10-29 12:35:53', '2020-10-29 12:35:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(469, 'o1qmn5M1EcFAzZRUwdcgQa33NGFA', 0, '2020-10-29 12:35:57', '2020-10-29 12:35:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(470, 'o1qmn5PU6MGh1-2EJ3MYomHpxYsI', 4, '2020-10-29 12:36:19', '2021-01-29 13:44:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(471, 'o1qmn5MxtrKhBo-qxqhyjMiA8bgc', 2, '2020-10-29 12:36:29', '2021-03-22 23:39:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(472, 'o1qmn5BWVC8-MpNPWzLpyCewb0uI', 0, '2020-10-29 12:36:30', '2020-10-29 12:36:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(473, 'o1qmn5Ha6WPpTNl2RWK1AYtn4dA8', 0, '2020-10-29 12:38:11', '2020-10-29 12:38:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(474, 'o1qmn5M6qJNX_-r6VIaXAKBTYu-4', 1, '2020-10-29 12:38:35', '2020-10-30 14:51:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(475, 'o1qmn5AwoE7XLuPGEUlLlfMgb4oQ', 0, '2020-10-29 12:38:43', '2020-10-29 12:38:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(476, 'o1qmn5JIIChWzyYNtInb-ui4VOrg', 0, '2020-10-29 12:39:26', '2020-10-29 12:39:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(477, 'o1qmn5OGRo7uL2pvx5GhfboaYABA', 1, '2020-10-29 12:44:23', '2020-10-29 23:06:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(478, 'o1qmn5ON-KebwXUhjiWL67jUy9Hw', 0, '2020-10-29 12:46:00', '2020-10-29 12:46:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(479, 'o1qmn5J4tTNOo-2vqKZL7jzSIVUA', 3, '2020-10-29 12:47:40', '2020-11-30 13:54:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(480, 'o1qmn5HPbWLPHIJBnjv5cwmHN-gY', 1, '2020-10-29 12:47:55', '2020-12-22 05:11:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(481, 'o1qmn5LZkfqzGtLMewNC_PbfEnFo', 0, '2020-10-29 12:48:03', '2020-10-29 12:48:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(482, 'o1qmn5EQUy1PdgDQfnqIPSgw89SQ', 0, '2020-10-29 12:48:10', '2020-10-29 12:48:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(483, 'o1qmn5MZLilxPzrFih8YhWIzXAhY', 0, '2020-10-29 12:50:30', '2020-10-29 12:50:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(484, 'o1qmn5MuaJ7NpzcV8-JeMNlkxTrc', 0, '2020-10-29 12:50:45', '2020-10-29 12:50:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(485, 'o1qmn5Bbo3HFx0kjjdyKPuG2AShs', 0, '2020-10-29 12:50:49', '2020-10-29 12:50:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(486, 'o1qmn5LOrESU-IuADeZ5CeoAcJmA', 0, '2020-10-29 12:51:00', '2020-10-29 12:51:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(487, 'o1qmn5KfOks65JzkRyUJntvT9OSI', 0, '2020-10-29 12:51:02', '2020-10-29 12:51:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(488, 'o1qmn5NtN5QF8bPV6GB9RRjLirpM', 0, '2020-10-29 12:52:52', '2020-10-29 12:52:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(489, 'o1qmn5IXjfXOyOmuWvE8jBhCK5Hk', 0, '2020-10-29 12:53:47', '2020-10-29 12:53:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(490, 'o1qmn5OGQXg8D_8Jg-fvKop1OPxY', 0, '2020-10-29 12:53:53', '2020-10-29 12:53:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(491, 'o1qmn5MHVPVmPbmYc5g9TXTwJT9s', 0, '2020-10-29 12:54:40', '2020-10-29 12:54:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(492, 'o1qmn5CqLeRDLhQM3gtDKb4uto-Y', 1, '2020-10-29 12:55:43', '2020-10-30 17:51:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(493, 'o1qmn5MQ8LOBsiRBpUmd_A2hun4E', 17, '2020-10-29 12:56:06', '2021-03-18 08:36:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(494, 'o1qmn5MMXyaQARlpIyAOMaatSHWI', 0, '2020-10-29 12:58:39', '2020-10-29 12:58:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(495, 'o1qmn5ARo-KA6AsyjaS9hbr-ClrA', 0, '2020-10-29 13:02:04', '2020-10-29 13:02:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(496, 'o1qmn5J5mSrIAY7VH_iFKorZe_PQ', 0, '2020-10-29 13:03:20', '2020-10-29 13:03:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(497, 'o1qmn5Bae57EjLBIQkkF4yiPw-4M', 0, '2020-10-29 13:03:38', '2020-10-29 13:03:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(498, 'o1qmn5NrFzDnL9cN4IKcf4dmxdMs', 0, '2020-10-29 13:04:37', '2020-10-29 13:04:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(499, 'o1qmn5DwI5kReiN_7A1um_mpqtJA', 0, '2020-10-29 13:04:48', '2020-10-29 13:04:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(500, 'o1qmn5CMWTZ_53h3j56zsKvYvIas', 1, '2020-10-29 13:04:49', '2020-10-30 11:08:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(501, 'o1qmn5HKw_HbGsZatB8WTOnu9n4Y', 9, '2020-10-29 13:05:16', '2021-02-18 12:23:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(502, 'o1qmn5B3idFKFkIwZwpB7dadLRvQ', 0, '2020-10-29 13:05:21', '2020-10-29 13:05:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(503, 'o1qmn5I2zSSR4AIvd0gysj6hh4I8', 3, '2020-10-29 13:07:08', '2020-12-19 18:41:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(504, 'o1qmn5KDBnaJAmDdtJKzUvUKRKxw', 0, '2020-10-29 13:07:10', '2020-10-29 13:07:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(505, 'o1qmn5IuHlCDGA4xZPjj0H6-FIy8', 0, '2020-10-29 13:07:32', '2020-10-29 13:07:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(506, 'o1qmn5Lo5fT2x1ObDH4pWyDu4z6E', 0, '2020-10-29 13:07:42', '2020-10-29 13:07:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(507, 'o1qmn5BuMFYb2WeMvyKFp0U3Tjik', 0, '2020-10-29 13:12:28', '2020-10-29 13:12:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(508, 'o1qmn5Kj3yCpkJb7Z6VnTkfDvTEs', 0, '2020-10-29 13:13:48', '2020-10-29 13:13:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(509, 'o1qmn5GtXoDwYf7Hf5MwjEvM52N8', 0, '2020-10-29 13:14:00', '2020-10-29 13:14:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(510, 'o1qmn5H6rOT4qgTb0NpqITYq_YLg', 0, '2020-10-29 13:14:11', '2020-10-29 13:14:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(511, 'o1qmn5HFQtu_aEx9Yf2vpJfX6WBU', 0, '2020-10-29 13:16:06', '2020-10-29 13:16:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(512, 'o1qmn5CnsikfdPzcNJEgZj9UA9pk', 58, '2020-10-29 13:17:11', '2021-03-20 18:53:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(513, 'o1qmn5LfHKgEvpzPlc7zpgICxkVU', 0, '2020-10-29 13:23:27', '2020-10-29 13:23:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(514, 'o1qmn5NeN2WCe1_gpQIms83-I5jA', 0, '2020-10-29 13:24:09', '2020-10-29 13:24:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(515, 'o1qmn5Ej7pOjIneyjpH1hx20x7ug', 2, '2020-10-29 13:26:43', '2020-11-11 08:46:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(516, 'o1qmn5MK0cgbTXTNcE8YLQA0a6bI', 0, '2020-10-29 13:27:40', '2020-10-29 13:27:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(517, 'o1qmn5M_vEZRdeHd9uSzMoaw5VKo', 0, '2020-10-29 13:28:25', '2020-10-29 13:28:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(518, 'o1qmn5H-0XeiHPOzC8RX-u5drSVY', 0, '2020-10-29 13:28:26', '2020-10-29 13:28:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(519, 'o1qmn5Aob8RiD8MkBcbdGPHK6iD4', 0, '2020-10-29 13:30:59', '2020-10-29 13:30:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(520, 'o1qmn5CC-bcgvjvWL2BxAYza1Wrk', 0, '2020-10-29 13:31:00', '2020-10-29 13:31:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(521, 'o1qmn5GeclkxGibxqtMEaStdjkek', 1, '2020-10-29 13:31:02', '2021-03-16 17:34:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(522, 'o1qmn5IuvM-_TI3FD9FExTPIDL8U', 0, '2020-10-29 13:32:00', '2020-10-29 13:32:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(523, 'o1qmn5D94r0-1_E7pqpY_sINQeuw', 0, '2020-10-29 13:32:02', '2020-10-29 13:32:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(524, 'o1qmn5MD5QBw8A6g1lMmFPbvlam4', 0, '2020-10-29 13:32:19', '2020-10-29 13:32:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(525, 'o1qmn5OvQzuPR6Dc06VobDGWqcG0', 0, '2020-10-29 13:32:21', '2020-10-29 13:32:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(526, 'o1qmn5GNbfUSwLIf_DqZSZOuAfwk', 0, '2020-10-29 13:33:23', '2020-10-29 13:33:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(527, 'o1qmn5ByHH1FOD9mLLMmVNG_cpxQ', 1, '2020-10-29 13:33:32', '2020-10-30 17:53:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(528, 'o1qmn5KMvf5rLiU_cKAJlCGqeqR0', 0, '2020-10-29 13:34:11', '2020-10-29 13:34:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(529, 'o1qmn5N_9oEPZcZHr7sqTNUh9zQs', 0, '2020-10-29 13:38:55', '2020-10-29 13:38:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(530, 'o1qmn5HmgP2Wlq9phIUK9Ip2g7ko', 0, '2020-10-29 13:39:03', '2020-10-29 13:39:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(531, 'o1qmn5P_u_siXIWcTZU4JhxGFFY8', 0, '2020-10-29 13:39:06', '2020-10-29 13:39:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(532, 'o1qmn5NfpZfUKaYVOm9zsSQHObTI', 1, '2020-10-29 13:45:43', '2020-11-26 10:42:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(533, 'o1qmn5J0Tcm0zH05UFljnAQoVDvI', 0, '2020-10-29 13:46:08', '2020-10-29 13:46:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(534, 'o1qmn5PBY7IuPbiNPrLrf9WbcSTw', 1, '2020-10-29 13:46:10', '2020-10-30 09:59:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(535, 'o1qmn5BM8l0DKPdDviFJJnTv9mPA', 0, '2020-10-29 13:47:02', '2020-10-29 13:47:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(536, 'o1qmn5DJPuNq9U-qV991of9li8yM', 0, '2020-10-29 13:47:15', '2020-10-29 13:47:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(537, 'o1qmn5N5uIOQPtRlRYlbsL0n4xpE', 1, '2020-10-29 13:48:25', '2020-10-31 13:12:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(538, 'o1qmn5ME-3r4eHBBbq5KABLvZ_O4', 0, '2020-10-29 13:48:53', '2020-10-29 13:48:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(539, 'o1qmn5Ko8qBWUc39G4T0dMQ0ia-o', 2, '2020-10-29 13:49:55', '2020-10-29 23:40:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(540, 'o1qmn5P05eYK5-DGtBII99bNG344', 0, '2020-10-29 13:55:06', '2020-10-29 13:55:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(541, 'o1qmn5AsLsY9ed8B5Xw9lNDOePCo', 0, '2020-10-29 13:56:34', '2020-10-29 13:56:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(542, 'o1qmn5DtvQSww4SsdaB1E76bfUJM', 1, '2020-10-29 13:58:03', '2020-12-04 14:04:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(543, 'o1qmn5JoC4FP1TvyJSU3bDpTQfdU', 0, '2020-10-29 13:58:28', '2020-10-29 13:58:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(544, 'o1qmn5I0jbHrYnAN9kzqAdHi8aeM', 0, '2020-10-29 13:59:59', '2020-10-29 13:59:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(545, 'o1qmn5IxbOEqdNvaXCZ6WFUnpDzs', 0, '2020-10-29 14:00:57', '2020-10-29 14:00:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(546, 'o1qmn5G_TKbc2iXNeDix1DxL-pN0', 0, '2020-10-29 14:01:23', '2020-10-29 14:01:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(547, 'o1qmn5MKCAO97EfvAdkLgOzI5CLY', 0, '2020-10-29 14:01:53', '2020-10-29 14:01:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(548, 'o1qmn5IpLbOQoxYPtIFdyVh9pbPI', 0, '2020-10-29 14:01:55', '2020-10-29 14:01:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(549, 'o1qmn5CmSws43l7Ilk7QAqb8XulM', 0, '2020-10-29 14:02:06', '2020-10-29 14:02:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(550, 'o1qmn5EsKe0_dcmAFLe5LqSSQHgU', 0, '2020-10-29 14:02:35', '2020-10-29 14:02:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(551, 'o1qmn5MKLQ0zwGYhb1t9WjmsfQLo', 0, '2020-10-29 14:05:26', '2020-10-29 14:05:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(552, 'o1qmn5OQSBw58G8BEAyRaJ6_zhS0', 1, '2020-10-29 14:07:08', '2020-11-12 19:12:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(553, 'o1qmn5FZgsKBPswN1xQQGowbubro', 0, '2020-10-29 14:07:09', '2020-10-29 14:07:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(554, 'o1qmn5M9gv6h29XmpMrlQ46J9PVQ', 0, '2020-10-29 14:07:33', '2020-10-29 14:07:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(555, 'o1qmn5DY7S1EE3yYGvdw_Vq_Cgs8', 0, '2020-10-29 14:08:26', '2020-10-29 14:08:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(556, 'o1qmn5B-lvM8HQTubUu7I1ztjg9k', 6, '2020-10-29 14:08:30', '2021-03-25 11:34:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(557, 'o1qmn5B9AoV9DoRQffY_F8JJ5MwA', 1, '2020-10-29 14:08:43', '2020-10-29 16:17:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(558, 'o1qmn5NUrrwstXOl3bohdghLRKc0', 0, '2020-10-29 14:09:58', '2020-10-29 14:09:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(559, 'o1qmn5N1sUIIuYVYdoytVRSsYp-M', 0, '2020-10-29 14:14:31', '2020-10-29 14:14:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(560, 'o1qmn5LxYyzw75EyvAnFwrhpBrGI', 0, '2020-10-29 14:15:09', '2020-10-29 14:15:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(561, 'o1qmn5GH7JHhrPWox5HQk2e5G-sY', 0, '2020-10-29 14:16:05', '2020-10-29 14:16:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(562, 'o1qmn5FghNJCRrMapmoaJyqFYdSo', 0, '2020-10-29 14:20:26', '2020-10-29 14:20:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(563, 'o1qmn5EZWExvp9qfnY0PLw5axcEU', 0, '2020-10-29 14:20:40', '2020-10-29 14:20:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(564, 'o1qmn5IkKKRml95Ota6WsfScWXNg', 0, '2020-10-29 14:21:57', '2020-10-29 14:21:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(565, 'o1qmn5Cf_ZR2uokwBT7QY9EdzfFg', 1, '2020-10-29 14:22:28', '2020-10-30 12:04:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(566, 'o1qmn5Ddqnc2KAXFry-KHAVr_ToU', 0, '2020-10-29 14:23:01', '2020-10-29 14:23:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(567, 'o1qmn5JGndYuiprGhiaXFt5jr63A', 0, '2020-10-29 14:23:40', '2020-10-29 14:23:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(568, 'o1qmn5PBMukrRfQN25WJZQ93yQ5k', 0, '2020-10-29 14:24:28', '2020-10-29 14:24:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(569, 'o1qmn5G3N5cFjTXxmmV0wfqWBboE', 0, '2020-10-29 14:25:19', '2020-10-29 14:25:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(570, 'o1qmn5JXYMv8AOD6ZAPvP5XPF27o', 0, '2020-10-29 14:27:10', '2020-10-29 14:27:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(571, 'o1qmn5OooUqCGGYNSJ3sU3Ww9kGI', 0, '2020-10-29 14:27:42', '2020-10-29 14:27:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(572, 'o1qmn5LgmdTufIyASqlKbyaZu79A', 0, '2020-10-29 14:29:08', '2020-10-29 14:29:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(573, 'o1qmn5KbC5yyt_DLZ7L7QkkBbe-4', 2, '2020-10-29 14:30:38', '2021-03-19 11:58:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(574, 'o1qmn5FoBbmD9TZfEYpZjHjleaR8', 0, '2020-10-29 14:31:40', '2020-10-29 14:31:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(575, 'o1qmn5GwxsO93Ry6YrYUCnjAW1Ls', 3, '2020-10-29 14:33:14', '2020-11-30 11:22:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(576, 'o1qmn5N9N09OEjL1Y9esd-XHpmxM', 0, '2020-10-29 14:34:25', '2020-10-29 14:34:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(577, 'o1qmn5E3K5a8PBCgH4Fpck0sEYu0', 1, '2020-10-29 14:34:25', '2021-01-17 16:16:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(578, 'o1qmn5GdkXxCQMS54BqA9ORPQtoU', 0, '2020-10-29 14:34:45', '2020-10-29 14:34:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(579, 'o1qmn5M-IfycfKhpXWARPLgrT980', 1, '2020-10-29 14:34:48', '2020-11-01 21:59:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(580, 'o1qmn5IVNwmj1xBtZ2zwiXQPqZh4', 0, '2020-10-29 14:35:54', '2020-10-29 14:35:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(581, 'o1qmn5OGMLVJATHrX1nkhjIut3vk', 0, '2020-10-29 14:36:34', '2020-10-29 14:36:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(582, 'o1qmn5AtiNv7qrLIsk9LDcw4Natg', 6, '2020-10-29 14:39:14', '2021-03-10 13:21:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(583, 'o1qmn5Pp9N32eBHJsUtLmABuIhXU', 0, '2020-10-29 14:40:27', '2020-10-29 14:40:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(584, 'o1qmn5Fiwgw-mhr6UoC8VYGZ-AqU', 0, '2020-10-29 14:41:50', '2020-10-29 14:41:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(585, 'o1qmn5Ih_WzYx1ATfyJi4a_xMh_8', 1, '2020-10-29 14:42:41', '2020-12-09 14:30:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(586, 'o1qmn5I_TiHmy6ccQ9OnReEnhU5k', 0, '2020-10-29 14:44:49', '2020-10-29 14:44:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(587, 'o1qmn5EfMdgMio5moRfi6HE9kNCs', 0, '2020-10-29 14:44:58', '2020-10-29 14:44:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(588, 'o1qmn5AsmhKAz1VM7pUTQUwZ2_JU', 0, '2020-10-29 14:45:22', '2020-10-29 14:45:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(589, 'o1qmn5KER0JE7S_eaywoOBrWEvkY', 0, '2020-10-29 14:48:44', '2020-10-29 14:48:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(590, 'o1qmn5Pu-2_31e4mpVrcMmNCI9uA', 0, '2020-10-29 14:49:04', '2020-10-29 14:49:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(591, 'o1qmn5Gfjh1nT786rPRWOQzGGrv0', 0, '2020-10-29 14:49:59', '2020-10-29 14:49:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(592, 'o1qmn5HLxTj7USR12colME__fLHg', 0, '2020-10-29 14:50:29', '2020-10-29 14:50:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(593, 'o1qmn5NvFMN5hXpHDLRL6_u5rHIg', 0, '2020-10-29 14:50:41', '2020-10-29 14:50:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(594, 'o1qmn5EHycuV4GiruHiLEH15acyw', 0, '2020-10-29 14:53:54', '2020-10-29 14:53:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(595, 'o1qmn5EGVO3JWCFQVQUol_fQjrmc', 0, '2020-10-29 14:53:59', '2020-10-29 14:53:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(596, 'o1qmn5PYec30JHd8d_IVmpJQzxZ8', 0, '2020-10-29 14:54:30', '2020-10-29 14:54:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(597, 'o1qmn5Db-K7jWdpZzZRFzz5N--Wg', 0, '2020-10-29 14:55:27', '2020-10-29 14:55:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(598, 'o1qmn5JTMvuQ9mDKrgrexHAqeZHA', 1, '2020-10-29 14:55:51', '2020-11-03 11:29:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(599, 'o1qmn5ANd5FYSQPUxi64JUjlub3I', 2, '2020-10-29 14:56:04', '2020-10-30 08:18:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(600, 'o1qmn5Ec9N9ES60qXfnG6ZT1QxBc', 0, '2020-10-29 14:56:27', '2020-10-29 14:56:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(601, 'o1qmn5Pw8j1xMyFTz7AYsS6d6qCo', 0, '2020-10-29 14:57:08', '2020-10-29 14:57:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(602, 'o1qmn5AjXxhS5rkra3n_8_GZUeT4', 1, '2020-10-29 14:58:28', '2020-10-29 16:19:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(603, 'o1qmn5ElWtgaefTJN-Jsd9jVYQBY', 0, '2020-10-29 14:59:27', '2020-10-29 14:59:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(604, 'o1qmn5C_qaXN93vSTZCKr5Yei3Kw', 0, '2020-10-29 15:00:05', '2020-10-29 15:00:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(605, 'o1qmn5Bgr9OUMpqu3n0cLuRE5JS0', 0, '2020-10-29 15:00:53', '2020-10-29 15:00:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(606, 'o1qmn5JCksfErP031G2r5skEvw4I', 1, '2020-10-29 15:01:39', '2020-12-22 15:11:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(607, 'o1qmn5HPlqY5ONxqR6bCIn_GmhZE', 0, '2020-10-29 15:03:53', '2020-10-29 15:03:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(608, 'o1qmn5BIv8D4PoBo04o2_vCFdOH4', 0, '2020-10-29 15:04:57', '2020-10-29 15:04:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(609, 'o1qmn5AbjjOh8OMW920tvBTUAVkI', 0, '2020-10-29 15:05:58', '2020-10-29 15:05:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(610, 'o1qmn5Lz71R5Q8grVykCplGrci3I', 0, '2020-10-29 15:06:37', '2020-10-29 15:06:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(611, 'o1qmn5HG4GY9d9ZBHl_wpkl21sXo', 0, '2020-10-29 15:07:11', '2020-10-29 15:07:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(612, 'o1qmn5HpQd6b2Ali8Al4LZ4fQCPI', 0, '2020-10-29 15:07:33', '2020-10-29 15:07:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(613, 'o1qmn5CChX1ZZAexwIZZwnZVxhzw', 0, '2020-10-29 15:08:10', '2020-10-29 15:08:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(614, 'o1qmn5FGRlk8SMOdkwIoDjIuNe7E', 0, '2020-10-29 15:16:47', '2020-10-29 15:16:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(615, 'o1qmn5GbJU5M04xg183F9OQeYuM4', 1, '2020-10-29 15:17:12', '2020-12-24 12:03:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(616, 'o1qmn5EyEoJUQJoAFRLJtu6WYBrg', 12, '2020-10-29 15:17:27', '2021-03-24 14:04:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(617, 'o1qmn5OxDNJGra0vGxTWYdaDK4mQ', 24, '2020-10-29 15:18:57', '2021-03-27 14:19:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(618, 'o1qmn5FbPmrJ7G25357cVST416KA', 0, '2020-10-29 15:20:43', '2020-10-29 15:20:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(619, 'o1qmn5CEhgFuhP8fGfIOWhlnpvMk', 0, '2020-10-29 15:22:19', '2020-10-29 15:22:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(620, 'o1qmn5IzjP88YU65QYylrtUPazf8', 0, '2020-10-29 15:26:06', '2020-10-29 15:26:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(621, 'o1qmn5PfZ6AxOp43xo0lv8szyY-M', 2, '2020-10-29 15:27:02', '2020-10-31 13:03:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(622, 'o1qmn5NNEiqbMpPBLjH459dAZk6g', 1, '2020-10-29 15:27:23', '2020-10-30 15:34:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(623, 'o1qmn5Jq9z_SSr4KhlwgX3O8kGpc', 0, '2020-10-29 15:30:45', '2020-10-29 15:30:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(624, 'o1qmn5Ah0UcEtPTym9QPg1C2oRqM', 0, '2020-10-29 15:33:10', '2020-10-29 15:33:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(625, 'o1qmn5C6w-aXCGYt3KyL9zsTpCvk', 6, '2020-10-29 15:34:37', '2021-03-09 21:39:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(626, 'o1qmn5IxhKHM5AqOBXTLeA9IlhDo', 2, '2020-10-29 15:34:40', '2021-03-15 08:17:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(627, 'o1qmn5E8wpIpAEcoQtoASoFJqrf0', 0, '2020-10-29 15:35:01', '2020-10-29 15:35:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(628, 'o1qmn5JjKPW8iYwrMRHUs57HWNO4', 0, '2020-10-29 15:35:41', '2020-10-29 15:35:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(629, 'o1qmn5JjxJ3YCxEQ1uIOyOWtctJE', 0, '2020-10-29 15:35:45', '2020-10-29 15:35:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(630, 'o1qmn5BdzXcH8NYutBBkM57skBA0', 0, '2020-10-29 15:41:04', '2020-10-29 15:41:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(631, 'o1qmn5HXsKX1FN6GPjota8lCPm5M', 0, '2020-10-29 15:42:17', '2020-10-29 15:42:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(632, 'o1qmn5Ja8hNa-p6ugxJK-ANcUkDg', 0, '2020-10-29 15:42:40', '2020-10-29 15:42:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(633, 'o1qmn5IHqErhhkNl6sZiLhVM0dCE', 0, '2020-10-29 15:42:40', '2020-10-29 15:42:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(634, 'o1qmn5LjQ5cmFb88EHDbcYEIMVww', 1, '2020-10-29 15:43:08', '2020-12-06 22:07:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(635, 'o1qmn5P_7lhEqvBiGkCX_tS4ZNfA', 0, '2020-10-29 15:46:27', '2020-10-29 15:46:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(636, 'o1qmn5MDb22Tkm7gGtL_4FU83xZI', 0, '2020-10-29 15:46:37', '2020-10-29 15:46:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(637, 'o1qmn5LSZdFmTbdRL5xBxObkBe3c', 0, '2020-10-29 15:49:34', '2020-10-29 15:49:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(638, 'o1qmn5INuwxbvNTerywrIZq_2L9o', 0, '2020-10-29 15:51:26', '2020-10-29 15:51:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(639, 'o1qmn5MkLx5JRJVipmphCjm7KEqU', 0, '2020-10-29 15:52:36', '2020-10-29 15:52:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(640, 'o1qmn5BS7o8Wa0aT3DeWHlRTfYJY', 0, '2020-10-29 15:59:16', '2020-10-29 15:59:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(641, 'o1qmn5IDI43o1kug5SLhjYrPWh1M', 0, '2020-10-29 16:00:55', '2020-10-29 16:00:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(642, 'o1qmn5D0zX9ea5kj0-54g-2r04K8', 7, '2020-10-29 16:01:12', '2021-02-02 12:03:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(643, 'o1qmn5L1JDXJkMgz3BCXTkEqd4X4', 0, '2020-10-29 16:01:42', '2020-10-29 16:01:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(644, 'o1qmn5Ezvc27nswY_6_q3Wn-VzGQ', 0, '2020-10-29 16:02:42', '2020-10-29 16:02:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(645, 'o1qmn5ADUTurNegHI1Ksl4xxdlr8', 0, '2020-10-29 16:04:48', '2020-10-29 16:04:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(646, 'o1qmn5HWD8lux1iHtvTBNs4xYyGY', 0, '2020-10-29 16:05:19', '2020-10-29 16:05:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(647, 'o1qmn5FT302S2LxpoarqbDckV2lA', 0, '2020-10-29 16:05:28', '2020-10-29 16:05:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(648, 'o1qmn5Dke_hXNNZRLCfbKHITOSoQ', 0, '2020-10-29 16:05:45', '2020-10-29 16:05:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(649, 'o1qmn5LjPcE0bAKWFv3w2V2thPTc', 1, '2020-10-29 16:08:41', '2020-10-30 12:04:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(650, 'o1qmn5PWgvRq0lEiXUMcqZrOS6g0', 0, '2020-10-29 16:10:09', '2020-10-29 16:10:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(651, 'o1qmn5O8dod7QiaNax-69X-FQLhY', 0, '2020-10-29 16:10:52', '2020-10-29 16:10:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(652, 'o1qmn5NFEQ-7XmWMp04-LiVQDaLA', 0, '2020-10-29 16:16:57', '2020-10-29 16:16:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(653, 'o1qmn5LFCZIpQFqi0jteLdYsA0Z0', 0, '2020-10-29 16:17:22', '2020-10-29 16:17:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(654, 'o1qmn5NIQBdZl_FHLlPkwRI4thkA', 0, '2020-10-29 16:18:31', '2020-10-29 16:18:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(655, 'o1qmn5HstcMOpiuVU-bbf8QZK3hE', 0, '2020-10-29 16:19:08', '2020-10-29 16:19:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(656, 'o1qmn5OZfINKtukSgkxvtrFB0f8c', 0, '2020-10-29 16:19:13', '2020-10-29 16:19:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(657, 'o1qmn5KNm5T_2KJ6qih30ItEslbY', 0, '2020-10-29 16:19:58', '2020-10-29 16:19:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(658, 'o1qmn5ClWKBMbGvM7hPK-V8SRBq4', 1, '2020-10-29 16:22:09', '2020-10-30 10:09:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(659, 'o1qmn5Jl_3f5mtr-qIPHwgP2KzAc', 0, '2020-10-29 16:26:23', '2020-10-29 16:26:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(660, 'o1qmn5GLGJ6nygY1V3MMwfnq54VU', 1, '2020-10-29 16:26:46', '2021-02-15 15:06:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(661, 'o1qmn5PUgydOI4A61TT2fULV9rww', 0, '2020-10-29 16:29:34', '2020-10-29 16:29:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(662, 'o1qmn5IEBsJZ8cNuoBITtaAlT_jA', 0, '2020-10-29 16:29:43', '2020-10-29 16:29:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(663, 'o1qmn5GGYt82dlhgQOD4k56Uzf0g', 0, '2020-10-29 16:30:05', '2020-10-29 16:30:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(664, 'o1qmn5MO4UbdJiwOIx4FtfxHTYGo', 3, '2020-10-29 16:38:20', '2021-03-27 07:54:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(665, 'o1qmn5L32LtNnC6C_KlqSK_TNka4', 0, '2020-10-29 16:39:09', '2020-10-29 16:39:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(666, 'o1qmn5EmDajB9wnEA6C0ufImWn3s', 0, '2020-10-29 16:43:39', '2020-10-29 16:43:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(667, 'o1qmn5L1STr9WNdEwgo1WNvmiaYs', 5, '2020-10-29 16:46:11', '2021-02-25 12:13:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(668, 'o1qmn5MPb69hPeF5nvn8QpIh8aUc', 0, '2020-10-29 16:46:30', '2020-10-29 16:46:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(669, 'o1qmn5H79yMYfqkEeBBBbTMlzq0k', 0, '2020-10-29 16:56:58', '2020-10-29 16:56:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(670, 'o1qmn5HIrLY8PdXi4Pbau7_6NmcA', 1, '2020-10-29 16:58:29', '2020-10-30 22:48:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(671, 'o1qmn5GcKvK-6s4hB_ZJdwYcIAzQ', 10, '2020-10-29 17:05:03', '2020-12-30 20:18:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(672, 'o1qmn5PfSWEwBLlH-y-TGXz44Z1I', 0, '2020-10-29 17:13:34', '2020-10-29 17:13:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(673, 'o1qmn5GwI-pTlhaTlwGEszFJRaxs', 0, '2020-10-29 17:13:58', '2020-10-29 17:13:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(674, 'o1qmn5P9IX3nixISJYivIWlvoX9Y', 0, '2020-10-29 17:50:11', '2020-10-29 17:50:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(675, 'o1qmn5N7CkeZw68VdjgyzAd7evdA', 4, '2020-10-29 17:51:42', '2021-03-27 22:26:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(676, 'o1qmn5JyYdDiQde1O6ZiPWw_onpg', 0, '2020-10-29 17:55:11', '2020-10-29 17:55:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(677, 'o1qmn5GqQKIgzAIU4y3tXIT4RmLs', 0, '2020-10-29 19:15:13', '2020-10-29 19:15:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(678, 'o1qmn5MIYGxGLaZnohkKQ2SJAp80', 0, '2020-10-29 19:21:11', '2020-10-29 19:21:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(679, 'o1qmn5DepO5wrB8ityBp-oeobKEE', 2, '2020-10-29 19:24:18', '2021-03-25 11:03:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(680, 'o1qmn5KHCM7v0VkVau2a5CVqbAdE', 0, '2020-10-29 20:42:16', '2020-10-29 20:42:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(681, 'o1qmn5K_uIFdDWpe0azr2FqHsUrY', 24, '2020-10-29 20:53:19', '2021-03-29 08:47:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(682, 'o1qmn5IGa6udvIas1lcjJWOXLokw', 0, '2020-10-29 21:46:03', '2020-10-29 21:46:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(683, 'o1qmn5OSrU_Jw8Hkw1IL97az_SfU', 0, '2020-10-29 22:34:58', '2020-10-29 22:34:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(684, 'o1qmn5BSd1PO01epbKcLH2GC4hGs', 1, '2020-10-30 00:01:31', '2020-11-05 20:10:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(685, 'o1qmn5GomFnnIhX0e57znWhKw7mk', 0, '2020-10-30 00:09:23', '2020-10-30 00:09:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(686, 'o1qmn5HOMBMyZ_WunnSbiQRrd1Cw', 1, '2020-10-30 08:23:03', '2020-11-27 21:21:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(687, 'o1qmn5NkjS-CDLz0SpQ6IzypZr0M', 0, '2020-10-30 08:24:09', '2020-10-30 08:24:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(688, 'o1qmn5BcB3taSlh-wgKzNwRirid4', 1, '2020-10-30 08:24:30', '2020-10-30 17:03:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(689, 'o1qmn5NO0aS5Pl35Kx7P46INhWMQ', 6, '2020-10-30 08:29:09', '2021-03-19 09:42:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(690, 'o1qmn5Eelu-TuwnLdBHiioWLR1Og', 0, '2020-10-30 09:06:08', '2020-10-30 09:06:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(691, 'o1qmn5D_Jxwz3iizmBtiz0I5KKoE', 0, '2020-10-30 09:09:59', '2020-10-30 09:09:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(692, 'o1qmn5AFg6fQiAtHOfOiF2X92c3Q', 0, '2020-10-30 09:16:22', '2020-10-30 09:16:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(693, 'o1qmn5Iu9D3xUq4tmDqlZOLWTscA', 1, '2020-10-30 09:16:36', '2020-12-28 20:36:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(694, 'o1qmn5OTTx1AJxlZegr6amndZ7KQ', 0, '2020-10-30 09:16:40', '2020-10-30 09:16:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(695, 'o1qmn5EbTM1-VBaRcdRWpylMTOlM', 0, '2020-10-30 09:16:41', '2020-10-30 09:16:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(696, 'o1qmn5NVOcRHhKOqkwmNjjUsrZXI', 0, '2020-10-30 09:16:47', '2020-10-30 09:16:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(697, 'o1qmn5Dqu7XZr5br-FIk5lyN04z8', 0, '2020-10-30 09:16:59', '2020-10-30 09:16:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(698, 'o1qmn5HFXDPaRC4eVp0FSeHE_9n4', 0, '2020-10-30 09:24:22', '2020-10-30 09:24:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(699, 'o1qmn5O8igNgT4YFAYTEkWxu44sk', 0, '2020-10-30 09:25:43', '2020-10-30 09:25:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(700, 'o1qmn5JRCLi5Oo5-WtO5xsGWu3BY', 1, '2020-10-30 09:27:13', '2021-01-18 10:39:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(701, 'o1qmn5FWRBAFTcTcXybhXphVl-Hc', 0, '2020-10-30 09:28:22', '2020-10-30 09:28:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(702, 'o1qmn5ARKSuaQ8tnM6WUjH06wGuM', 71, '2020-10-30 09:30:53', '2021-03-29 09:15:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(703, 'o1qmn5AY6x9ZTzbSFwuWZSaiEZKI', 1, '2020-10-30 09:32:29', '2020-10-30 12:14:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(704, 'o1qmn5M6OVLfcLYEBqsf7sRJoUGc', 0, '2020-10-30 09:32:33', '2020-10-30 09:32:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(705, 'o1qmn5PoakACYd4asVgoXihT0Nzk', 0, '2020-10-30 09:32:33', '2020-10-30 09:32:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(706, 'o1qmn5ATLPAjomxFy6xzi3_h1BI8', 0, '2020-10-30 09:33:11', '2020-10-30 09:33:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(707, 'o1qmn5A4srXRzChljM-YiRH3FRyY', 2, '2020-10-30 09:34:50', '2020-11-01 01:57:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(708, 'o1qmn5EA3vxOTXQkP8I9vtPIiPPU', 1, '2020-10-30 09:35:02', '2020-11-04 11:54:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(709, 'o1qmn5MpKAVjn6ceHAoGV7EEFFQE', 0, '2020-10-30 09:36:52', '2020-10-30 09:36:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(710, 'o1qmn5AgDn6_kYlpQYIckeDNa3IU', 0, '2020-10-30 09:39:53', '2020-10-30 09:39:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(711, 'o1qmn5CCCX2G5qIFQKwOoxpZ_pVc', 0, '2020-10-30 09:41:56', '2020-10-30 09:41:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(712, 'o1qmn5Omxlu9deEVGd4-ZwXm33EQ', 0, '2020-10-30 09:42:03', '2020-10-30 09:42:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(713, 'o1qmn5NWPaRuXNFEM-COIUR82L9I', 0, '2020-10-30 09:43:18', '2020-10-30 09:43:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(714, 'o1qmn5G_DRdO7-oaTNJXO58hjBDQ', 0, '2020-10-30 09:43:38', '2020-10-30 09:43:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(715, 'o1qmn5Nt__Yq53d_QoZ1CyIflq74', 0, '2020-10-30 09:47:39', '2020-10-30 09:47:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(716, 'o1qmn5K0rI5GSNPwgj3P66LQu6J4', 0, '2020-10-30 09:47:43', '2020-10-30 09:47:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(717, 'o1qmn5HJ4GE7sye3ZFrqf4jOpRHI', 0, '2020-10-30 09:48:03', '2020-10-30 09:48:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(718, 'o1qmn5D0As45v8ILQxN_xflm2W88', 0, '2020-10-30 09:48:55', '2020-10-30 09:48:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(719, 'o1qmn5JuFjXqymHbtozH6ymG6UVE', 0, '2020-10-30 09:49:56', '2020-10-30 09:49:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(720, 'o1qmn5EIaVuFrmuerrukAafjv8eU', 2, '2020-10-30 09:51:14', '2020-11-03 09:32:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(721, 'o1qmn5DAhtR6ictgb0erLhn8QY3A', 0, '2020-10-30 09:52:34', '2020-10-30 09:52:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(722, 'o1qmn5PdYpbBIk5lmUs1Cv1edn_o', 0, '2020-10-30 09:52:54', '2020-10-30 09:52:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(723, 'o1qmn5MwITrBvmXy2Aceuy9sQ6yU', 0, '2020-10-30 09:53:50', '2020-10-30 09:53:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(724, 'o1qmn5E64Fx3iKFV7rzHw1ueVSMc', 0, '2020-10-30 09:53:53', '2020-10-30 09:53:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(725, 'o1qmn5KspZ5atJ0DAWaVfVSfyUUM', 0, '2020-10-30 09:53:57', '2020-10-30 09:53:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(726, 'o1qmn5K0DeIAW5n8egLvFmqDgqE4', 0, '2020-10-30 09:53:58', '2020-10-30 09:53:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(727, 'o1qmn5BWQE7wUbi-CgaiT54CUktI', 1, '2020-10-30 09:56:42', '2020-11-11 10:45:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(728, 'o1qmn5DQpWXfxvacfym4C8lryPEw', 0, '2020-10-30 09:58:47', '2020-10-30 09:58:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(729, 'o1qmn5JygkrN2rA4G6E4Jm-hQ_bQ', 0, '2020-10-30 09:59:00', '2020-10-30 09:59:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(730, 'o1qmn5EjUYXWBYfKyRxnV-rYEwYs', 0, '2020-10-30 10:00:58', '2020-10-30 10:00:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(731, 'o1qmn5Bj83YmE_DkO5__cMjupV7o', 0, '2020-10-30 10:01:00', '2020-10-30 10:01:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(732, 'o1qmn5EEIXA3zt_hCltcr4S5X5FM', 0, '2020-10-30 10:01:01', '2020-10-30 10:01:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(733, 'o1qmn5FLw1p5k3Jr_kMPYBqy0C5s', 0, '2020-10-30 10:01:58', '2020-10-30 10:01:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(734, 'o1qmn5EOqarqQjpQIi3tS3zgQ54M', 0, '2020-10-30 10:02:11', '2020-10-30 10:02:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(735, 'o1qmn5CjGjcHUm5MjT7h71xuDxBs', 0, '2020-10-30 10:02:35', '2020-10-30 10:02:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(736, 'o1qmn5BxIsn8i16KT7hNByG4ebEc', 0, '2020-10-30 10:02:37', '2020-10-30 10:02:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(737, 'o1qmn5OACgG2p3qiS_R-ka7ekhko', 0, '2020-10-30 10:02:38', '2020-10-30 10:02:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(738, 'o1qmn5AFYA45V-jCjRf5ptShIr38', 0, '2020-10-30 10:02:51', '2020-10-30 10:02:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(739, 'o1qmn5E1pWs5PjcGhpzaBLsgS8bo', 0, '2020-10-30 10:03:56', '2020-10-30 10:03:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(740, 'o1qmn5C8B4f-GSZ7gXRXTisXDzHU', 10, '2020-10-30 10:04:06', '2021-01-17 13:26:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(741, 'o1qmn5L-HAm-RskPeLtM0z8h1P6o', 0, '2020-10-30 10:04:12', '2020-10-30 10:04:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(742, 'o1qmn5GBGVmfSiIri-20lVDjyoB4', 0, '2020-10-30 10:09:30', '2020-10-30 10:09:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(743, 'o1qmn5FnGNKbaMHsV0utjdw6SfPY', 1, '2020-10-30 10:09:37', '2020-11-17 14:18:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(744, 'o1qmn5MvQNsyS-a8j2geTYS6RhxY', 1, '2020-10-30 10:09:48', '2020-10-30 16:57:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(745, 'o1qmn5C__ok70L0-GHwSmFtyeAtQ', 1, '2020-10-30 10:10:08', '2020-12-22 11:27:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(746, 'o1qmn5AkFKYmRTexzkEPAwMxD97A', 3, '2020-10-30 10:10:33', '2021-02-25 21:54:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(747, 'o1qmn5CoJqvCPZ-8iUDQgcKqgyG4', 1, '2020-10-30 10:12:06', '2020-11-23 16:17:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(748, 'o1qmn5KJcPxoOaEZvNBQisKtrrV4', 0, '2020-10-30 10:13:44', '2020-10-30 10:13:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(749, 'o1qmn5B9zNGgiPKNOLgeeUCVSTh0', 0, '2020-10-30 10:13:47', '2020-10-30 10:13:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(750, 'o1qmn5LLfHczdl0a3KWCmzJvqAq8', 1, '2020-10-30 10:14:00', '2020-10-30 12:30:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(751, 'o1qmn5PwsVYhAvkMFIqkM7a8P9rE', 1, '2020-10-30 10:14:33', '2020-12-31 13:35:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(752, 'o1qmn5J4u26Vi9XJx_Ry9l3lq6No', 0, '2020-10-30 10:14:57', '2020-10-30 10:14:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(753, 'o1qmn5Gvvd57JUgLADEBMoZMLXh8', 1, '2020-10-30 10:15:22', '2021-01-13 15:07:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(754, 'o1qmn5PnE7tH3sWVe2wRDoYL6EJE', 0, '2020-10-30 10:15:22', '2020-10-30 10:15:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(755, 'o1qmn5Krn4m7Qs2L-0aaM5-xvBIM', 0, '2020-10-30 10:15:39', '2020-10-30 10:15:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(756, 'o1qmn5HnjVBuB22rUI0Tcd2vlhy8', 3, '2020-10-30 10:16:06', '2020-11-25 09:10:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(757, 'o1qmn5AQpTUs434WutmwqVikN_F0', 3, '2020-10-30 10:18:16', '2021-01-27 17:29:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(758, 'o1qmn5BqFz6k73q5iDw-6Lqh3Ses', 9, '2020-10-30 10:18:33', '2021-02-24 16:32:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(759, 'o1qmn5PIdkwDS0vgBd0Y-0eMBVlo', 0, '2020-10-30 10:18:55', '2020-10-30 10:18:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(760, 'o1qmn5JrZX2qYQcv_PlYg3DTzJcs', 0, '2020-10-30 10:18:56', '2020-10-30 10:18:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(761, 'o1qmn5MO58Gilze2YAqJcQaQaD8A', 0, '2020-10-30 10:19:52', '2020-10-30 10:19:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(762, 'o1qmn5LkFfQJYbELhlnCGw9fC5g8', 1, '2020-10-30 10:21:07', '2020-11-03 11:21:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(763, 'o1qmn5LykWM5WdwinVCudmcoFW1k', 0, '2020-10-30 10:21:08', '2020-10-30 10:21:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(764, 'o1qmn5M9IieAyEzjf7aUP2nsMjRY', 0, '2020-10-30 10:21:40', '2020-10-30 10:21:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(765, 'o1qmn5LA8av3ShUGPb4dFXddTnJw', 0, '2020-10-30 10:23:22', '2020-10-30 10:23:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(766, 'o1qmn5P1YootswLW0TPdOo1Ch8W4', 0, '2020-10-30 10:25:08', '2020-10-30 10:25:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(767, 'o1qmn5EpPbXL6iz5QPVVtgRioE2U', 0, '2020-10-30 10:26:01', '2020-10-30 10:26:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(768, 'o1qmn5CREBD8sygZdJBoO9qX8MKE', 1, '2020-10-30 10:26:30', '2020-10-31 13:00:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(769, 'o1qmn5HrDB4QW7fhghXHrhr7ohBQ', 0, '2020-10-30 10:26:39', '2020-10-30 10:26:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(770, 'o1qmn5IG6Wzu3U4ggtXTSRty5EVY', 0, '2020-10-30 10:26:40', '2020-10-30 10:26:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(771, 'o1qmn5B1vM239ANcCUjzqP69ZpEU', 0, '2020-10-30 10:27:02', '2020-10-30 10:27:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(772, 'o1qmn5PSLvdAsjo9rkeV5Wk-M1Ps', 1, '2020-10-30 10:29:27', '2020-12-22 18:05:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(773, 'o1qmn5KbinlwH0H7yp6ezCYQ4pKI', 0, '2020-10-30 10:31:59', '2020-10-30 10:31:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(774, 'o1qmn5FmSjZ4xdYVyBXM61--dpX8', 1, '2020-10-30 10:32:26', '2020-12-28 17:01:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(775, 'o1qmn5E4Z3t55-kVuolCvJA00nNk', 0, '2020-10-30 10:32:29', '2020-10-30 10:32:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(776, 'o1qmn5EoIOFjpm66fAgwYI1p_nv0', 1, '2020-10-30 10:33:14', '2020-11-21 12:51:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(777, 'o1qmn5Al2JSkHthPvP-MbOJ4utsQ', 0, '2020-10-30 10:33:14', '2020-10-30 10:33:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(778, 'o1qmn5HO4P-TTp1Nbsljq27rhS9I', 0, '2020-10-30 10:33:18', '2020-10-30 10:33:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(779, 'o1qmn5C4C3Y77ckMnpMu7fFPtSo8', 0, '2020-10-30 10:33:56', '2020-10-30 10:33:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(780, 'o1qmn5GyvfHaFOw44sqaOAuisu6M', 0, '2020-10-30 10:34:09', '2020-10-30 10:34:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(781, 'o1qmn5PIwcQYHRPLi3zZQTxDlkHo', 0, '2020-10-30 10:35:22', '2020-10-30 10:35:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(782, 'o1qmn5F-u8e8-2YNGOtA5XhQ8L-k', 0, '2020-10-30 10:35:22', '2020-10-30 10:35:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(783, 'o1qmn5I7jdpbXUnBXzSiRkaI1XFg', 2, '2020-10-30 10:42:00', '2020-11-07 11:51:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(784, 'o1qmn5HjIVXd5toGJ_5nyAoGZWxQ', 0, '2020-10-30 10:42:35', '2020-10-30 10:42:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(785, 'o1qmn5OfnnJAEMpYNAy4KbEXyvug', 0, '2020-10-30 10:43:19', '2020-10-30 10:43:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(786, 'o1qmn5CA8_MduSx6tPpL7rB2CwkQ', 0, '2020-10-30 10:43:52', '2020-10-30 10:43:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(787, 'o1qmn5MQD2qbR5dX00kdwQy6y6Js', 1, '2020-10-30 10:46:30', '2020-10-30 15:50:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(788, 'o1qmn5K8CmqLNdyK4grPFbQdwH5I', 0, '2020-10-30 10:46:41', '2020-10-30 10:46:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(789, 'o1qmn5EBEgK7BnEkTji_c9tfrTsg', 0, '2020-10-30 10:47:01', '2020-10-30 10:47:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(790, 'o1qmn5C_AeWckknQxeXoQkULhJv8', 0, '2020-10-30 10:47:55', '2020-10-30 10:47:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(791, 'o1qmn5Al5wTvA7T_M_YgjW0Cjtyo', 1, '2020-10-30 10:47:59', '2020-11-26 14:30:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(792, 'o1qmn5GuUpf_i9VvyaguOl1kBgw8', 0, '2020-10-30 10:50:18', '2020-10-30 10:50:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(793, 'o1qmn5NELUTm7ollsc8Q1UMSmWIk', 0, '2020-10-30 10:50:32', '2020-10-30 10:50:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(794, 'o1qmn5J7qiuO9IXQRi0mVY0NHZrM', 1, '2020-10-30 10:50:41', '2020-10-30 12:03:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(795, 'o1qmn5JhR-Z9dSeIk8q_JuCfbvNs', 0, '2020-10-30 10:50:48', '2020-10-30 10:50:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(796, 'o1qmn5Pw4MjCnKPJKvSTBsZWpOFQ', 0, '2020-10-30 10:51:09', '2020-10-30 10:51:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(797, 'o1qmn5MoJmi8kqUp2oDl2qod9EsI', 0, '2020-10-30 10:51:34', '2020-10-30 10:51:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(798, 'o1qmn5GA0vGzTAox7OFSiMmmG-Ic', 0, '2020-10-30 10:51:42', '2020-10-30 10:51:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(799, 'o1qmn5AbfQtqyvwMndqTU8Xgu_4Q', 1, '2020-10-30 10:51:45', '2020-10-31 13:33:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(800, 'o1qmn5FrSkZPbwCj1YMJH9m4eTag', 0, '2020-10-30 10:52:34', '2020-10-30 10:52:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(801, 'o1qmn5KKH3rZkaf_FO6D1YtUkpik', 0, '2020-10-30 10:52:36', '2020-10-30 10:52:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(802, 'o1qmn5BKaCPvVP8WsVbVozbDNcok', 0, '2020-10-30 10:52:58', '2020-10-30 10:52:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(803, 'o1qmn5DP9yd_XdMoOl7dOZIcNBgQ', 0, '2020-10-30 10:53:18', '2020-10-30 10:53:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(804, 'o1qmn5EJMzetyDRfFwMUO7IlAvHo', 0, '2020-10-30 10:53:26', '2020-10-30 10:53:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(805, 'o1qmn5PlS6vPBCEFO7a0v_rq3KdA', 0, '2020-10-30 10:53:51', '2020-10-30 10:53:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(806, 'o1qmn5JayZWaCSDIhmUZP1ifHfz0', 0, '2020-10-30 10:54:00', '2020-10-30 10:54:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(807, 'o1qmn5LyDC4dAVDsuVfmBm3Pg-0s', 0, '2020-10-30 10:54:13', '2020-10-30 10:54:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(808, 'o1qmn5A4xPUhTbkIke5XIsGYg180', 0, '2020-10-30 10:54:24', '2020-10-30 10:54:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(809, 'o1qmn5BrAjGb5EHDsv9TBgsmUaUE', 2, '2020-10-30 10:54:34', '2020-11-05 09:07:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(810, 'o1qmn5MaTOgFgvYOWZay_pLBeH0c', 0, '2020-10-30 10:54:36', '2020-10-30 10:54:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(811, 'o1qmn5Cw-JHV4LR6kQb4MbESt1Wc', 0, '2020-10-30 10:54:39', '2020-10-30 10:54:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(812, 'o1qmn5J2aCzzzW17Q1iF272I5mmg', 0, '2020-10-30 10:54:44', '2020-10-30 10:54:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(813, 'o1qmn5GXgb0mqsqlc9GjVHYDUvN8', 1, '2020-10-30 10:55:22', '2021-03-15 16:39:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(814, 'o1qmn5EJpRnLEyt1oY3dLPrgIEFU', 1, '2020-10-30 10:55:29', '2020-11-11 23:05:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(815, 'o1qmn5Cc3WuL6ReC7dls1pdv8pIw', 2, '2020-10-30 10:55:37', '2020-11-03 14:08:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(816, 'o1qmn5KAmatUUfEwPIO59Q2i74F0', 1, '2020-10-30 10:56:28', '2020-11-04 09:15:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(817, 'o1qmn5DZlwYcEzMZYimysrxTF6LU', 1, '2020-10-30 10:58:56', '2020-11-04 11:46:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(818, 'o1qmn5FSUArpG1UcrOX5lUIqqN28', 0, '2020-10-30 10:59:05', '2020-10-30 10:59:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(819, 'o1qmn5MFVef7nbnQmBTPKyELb1hs', 0, '2020-10-30 11:00:22', '2020-10-30 11:00:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(820, 'o1qmn5CZDK482oySb-Pie_2X0D8g', 0, '2020-10-30 11:00:33', '2020-10-30 11:00:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(821, 'o1qmn5DlTZGhUHhRVVXwyaw02jrE', 0, '2020-10-30 11:02:43', '2020-10-30 11:02:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(822, 'o1qmn5BOCWqbfV6TbnYqaWCYFPNQ', 0, '2020-10-30 11:05:09', '2020-10-30 11:05:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(823, 'o1qmn5GXKO3FQWXTXfRY-DXkQWx0', 0, '2020-10-30 11:05:41', '2020-10-30 11:05:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(824, 'o1qmn5G4cqziVekG9uWuy3XzItBU', 0, '2020-10-30 11:05:51', '2020-10-30 11:05:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(825, 'o1qmn5OAxmKcAYLgJdz56vEkakgs', 0, '2020-10-30 11:06:01', '2020-10-30 11:06:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(826, 'o1qmn5PPaxBZyonBonKN3p8zWJbA', 0, '2020-10-30 11:06:04', '2020-10-30 11:06:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(827, 'o1qmn5Ni-g8T_QdNYxKi6fWym5MI', 0, '2020-10-30 11:06:31', '2020-10-30 11:06:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(828, 'o1qmn5HJVthZud5RVUKCEpPZsuQA', 2, '2020-10-30 11:07:17', '2021-01-19 08:59:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(829, 'o1qmn5AypNseptScj1ryoLS6ytks', 3, '2020-10-30 11:09:09', '2020-11-02 11:23:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(830, 'o1qmn5JnoayH8Z_Itx-fiwvE-WNo', 1, '2020-10-30 11:11:30', '2020-10-30 11:18:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(831, 'o1qmn5F_t12YWd8-9KWVNZ5z5KTk', 2, '2020-10-30 11:12:22', '2020-12-03 10:33:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(832, 'o1qmn5N2diAnc7gUf6L7Vl9aqXWk', 2, '2020-10-30 11:13:56', '2020-11-19 17:56:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(833, 'o1qmn5F2FE9HT0UwLuH6INt9gibg', 1, '2020-10-30 11:14:11', '2021-03-21 17:43:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(834, 'o1qmn5Ezi7Ne8nq7u1qTScVPiTog', 2, '2020-10-30 11:14:16', '2021-02-20 10:25:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(835, 'o1qmn5Pg6Kpy-BjIg4wWowBr1dJA', 0, '2020-10-30 11:14:17', '2020-10-30 11:14:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(836, 'o1qmn5JHQTUm0bt9XLTDwGfpT3VI', 2, '2020-10-30 11:14:19', '2020-11-04 14:53:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(837, 'o1qmn5GRsz6f2j_sbjCPEZJeR5Mo', 5, '2020-10-30 11:14:32', '2020-11-26 20:47:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(838, 'o1qmn5BWQ0wd4jfY10L6MQcxiZMo', 0, '2020-10-30 11:16:00', '2020-10-30 11:16:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(839, 'o1qmn5Fbu4f3-thlN_lDgiAyqxmo', 1, '2020-10-30 11:16:05', '2020-11-22 23:17:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(840, 'o1qmn5O3PudS5S7Qy8OmDtpRWEXI', 2, '2020-10-30 11:17:07', '2020-11-02 11:05:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(841, 'o1qmn5F-qlZb9R2Z_5ctese6eMHI', 0, '2020-10-30 11:18:56', '2020-10-30 11:18:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(842, 'o1qmn5GskybIor1mqCphLLag8ecI', 0, '2020-10-30 11:23:37', '2020-10-30 11:23:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(843, 'o1qmn5CPlDCQ8InWdNdUvMIZyYfg', 0, '2020-10-30 11:26:16', '2020-10-30 11:26:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(844, 'o1qmn5AkDReWDVOG6JcNIBQ7u1_A', 0, '2020-10-30 11:27:35', '2020-10-30 11:27:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(845, 'o1qmn5B9fKI4n5K-joTtrYG-H8lc', 0, '2020-10-30 11:29:03', '2020-10-30 11:29:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(846, 'o1qmn5IVe4_lQxIkU3zUEXlB_JDE', 0, '2020-10-30 11:29:12', '2020-10-30 11:29:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(847, 'o1qmn5I4FUU1JImnvr0-VFgR2ntE', 0, '2020-10-30 11:29:22', '2020-10-30 11:29:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(848, 'o1qmn5MIc6XvJPfp2-BqR_5kgGL4', 1, '2020-10-30 11:29:23', '2021-03-18 22:24:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(849, 'o1qmn5FfkPy2M7R074s7GQ-oZ7s8', 0, '2020-10-30 11:29:35', '2020-10-30 11:29:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(850, 'o1qmn5DvP2Kxtl-sRcrOCi7K3kVM', 0, '2020-10-30 11:30:38', '2020-10-30 11:30:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(851, 'o1qmn5P-5Vm85A2WJ669Upr11m3Y', 0, '2020-10-30 11:31:58', '2020-10-30 11:31:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(852, 'o1qmn5BvFpXerMuCoJ9TywkxBRds', 0, '2020-10-30 11:33:13', '2020-10-30 11:33:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(853, 'o1qmn5Kmde001t1h4nrmvG01cgjs', 0, '2020-10-30 11:33:34', '2020-10-30 11:33:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(854, 'o1qmn5IBbODHm6LGX-orU8ABhQWI', 0, '2020-10-30 11:33:47', '2020-10-30 11:33:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(855, 'o1qmn5Fhur4BR_5wNh4y3BLsfgIE', 0, '2020-10-30 11:34:42', '2020-10-30 11:34:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(856, 'o1qmn5IOqAaRIICgEhs_4WcBCZMc', 0, '2020-10-30 11:37:58', '2020-10-30 11:37:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(857, 'o1qmn5IcbVogr6UEYBjm2hu1872U', 0, '2020-10-30 11:38:05', '2020-10-30 11:38:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(858, 'o1qmn5EGd3yXMdj5tYi2f6iGScVE', 1, '2020-10-30 11:38:20', '2021-01-09 00:58:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(859, 'o1qmn5Ov2-jPnJ_kvHU39bvFNzdg', 0, '2020-10-30 11:39:45', '2020-10-30 11:39:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(860, 'o1qmn5IdRRhfjd43DjjSF9jVVxl0', 0, '2020-10-30 11:41:07', '2020-10-30 11:41:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(861, 'o1qmn5PxLXIEAsuyYS9J9_khCyak', 0, '2020-10-30 11:42:20', '2020-10-30 11:42:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(862, 'o1qmn5CRJLH1TMS06Uw6Lk_rT1Bs', 0, '2020-10-30 11:44:40', '2020-10-30 11:44:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(863, 'o1qmn5O0NgLRxFv_IQpoRdWn743Y', 0, '2020-10-30 11:44:54', '2020-10-30 11:44:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(864, 'o1qmn5OJJjJNarJgR2hRSyVKTdVA', 0, '2020-10-30 11:46:45', '2020-10-30 11:46:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(865, 'o1qmn5I_sNHv4Yx7L8S4X1dqABPw', 0, '2020-10-30 11:47:56', '2020-10-30 11:47:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(866, 'o1qmn5Ej7VnGdTWJ9y39KeaWFSLc', 0, '2020-10-30 11:53:08', '2020-10-30 11:53:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(867, 'o1qmn5Jwx1FbIIFUDpHnTAZmTkjs', 0, '2020-10-30 11:53:34', '2020-10-30 11:53:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(868, 'o1qmn5COcrmkjA5PNYQo5WB_sSqQ', 0, '2020-10-30 11:53:46', '2020-10-30 11:53:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(869, 'o1qmn5PIVMjkHPkWGL0BkU-7keKU', 1, '2020-10-30 11:53:59', '2021-01-08 15:55:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(870, 'o1qmn5HQ9MJVcUlxwlItzpOFnWIQ', 1, '2020-10-30 11:54:40', '2021-03-25 16:30:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(871, 'o1qmn5FTPNzC8ZBKH7INcNrF81S4', 0, '2020-10-30 11:55:45', '2020-10-30 11:55:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(872, 'o1qmn5B3DD0Lx8foV2PcZtXWsZqY', 1, '2020-10-30 11:55:56', '2020-10-30 17:18:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(873, 'o1qmn5IxEu6cS5VGP4Afz9IuGM6Y', 0, '2020-10-30 11:57:43', '2020-10-30 11:57:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(874, 'o1qmn5OjlK3RNyDhR4lClpdLr2Ic', 0, '2020-10-30 11:59:47', '2020-10-30 11:59:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(875, 'o1qmn5MR6ZdyMQdnIzOMdHQ3Hd3M', 0, '2020-10-30 12:04:48', '2020-10-30 12:04:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(876, 'o1qmn5MKjYxwsiwnbWrbU6D1SGJ4', 2, '2020-10-30 12:05:18', '2020-11-01 20:23:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(877, 'o1qmn5DAVyuTY27qdd0dyXrP4ZMI', 0, '2020-10-30 12:05:38', '2020-10-30 12:05:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(878, 'o1qmn5MSSov0CY99VXywsw7CjM2Q', 0, '2020-10-30 12:07:03', '2020-10-30 12:07:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(879, 'o1qmn5GKj9gPUJMECsAxSsrDD8IQ', 1, '2020-10-30 12:07:05', '2020-11-11 09:11:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(880, 'o1qmn5CrS6n5BNhdINj1OcHIb1eU', 0, '2020-10-30 12:07:22', '2020-10-30 12:07:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(881, 'o1qmn5It2sM0dV-eSBKh0A_8hab4', 3, '2020-10-30 12:09:52', '2021-03-10 09:24:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(882, 'o1qmn5LOWYoZ6w8_n_elCDNKHTjk', 0, '2020-10-30 12:10:23', '2020-10-30 12:10:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(883, 'o1qmn5EwRJRCGs9nSpSUVkEYDJHQ', 1, '2020-10-30 12:11:27', '2021-02-15 20:25:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(884, 'o1qmn5NxgRtAlC5zJGXcjW4CScmE', 0, '2020-10-30 12:14:23', '2020-10-30 12:14:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(885, 'o1qmn5EPhCmChF5BWnoH8d9nOgEU', 4, '2020-10-30 12:15:52', '2021-02-02 14:25:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(886, 'o1qmn5L25bEzKFviqXSYaqKoo18g', 0, '2020-10-30 12:15:54', '2020-10-30 12:15:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(887, 'o1qmn5CKA21JJfiV_vBfYcg2FPFo', 0, '2020-10-30 12:16:01', '2020-10-30 12:16:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(888, 'o1qmn5LJfzjp2UUM0gqMBTDRvNBo', 1, '2020-10-30 12:16:54', '2020-10-31 12:37:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(889, 'o1qmn5Al_XfHyHcpqDNBvt63BwNU', 0, '2020-10-30 12:16:55', '2020-10-30 12:16:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(890, 'o1qmn5NnSoM7NgMe_kKcYEl2Icpc', 4, '2020-10-30 12:17:02', '2021-03-28 11:29:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(891, 'o1qmn5J_rpTdxZA-TPnqMgbENZ0M', 0, '2020-10-30 12:18:09', '2020-10-30 12:18:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(892, 'o1qmn5MQggg6YbFC0CsXByoKhJK4', 0, '2020-10-30 12:18:10', '2020-10-30 12:18:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(893, 'o1qmn5MW8IlsmBP9xmeo5TDnCkRQ', 0, '2020-10-30 12:18:38', '2020-10-30 12:18:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(894, 'o1qmn5F7w28N3yoNer2yU3KtVzB8', 0, '2020-10-30 12:21:10', '2020-10-30 12:21:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(895, 'o1qmn5FJmRfGM3fdQ8rnlGA8fDWo', 3, '2020-10-30 12:26:23', '2021-03-10 09:51:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(896, 'o1qmn5LYanSMj1bHckC9_BjcyEFk', 0, '2020-10-30 12:29:09', '2020-10-30 12:29:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(897, 'o1qmn5Cu1ow5yDclEw-im9RQyE60', 1, '2020-10-30 12:31:10', '2020-11-15 16:20:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(898, 'o1qmn5LPDETWZnFOOiJV3LZk3jFk', 0, '2020-10-30 12:31:27', '2020-10-30 12:31:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(899, 'o1qmn5DIk3eP67kT__hr7WjzlCj8', 3, '2020-10-30 12:33:08', '2021-02-05 18:45:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(900, 'o1qmn5GH6j4q_dOk0DNiCfc1LSD4', 0, '2020-10-30 12:34:25', '2020-10-30 12:34:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(901, 'o1qmn5N7lNLKnnOrHlQm4T8D0_84', 1, '2020-10-30 12:38:08', '2020-10-30 17:01:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(902, 'o1qmn5GQzVgtOByzf-VCrk1MdNd0', 1, '2020-10-30 12:38:22', '2020-11-29 15:15:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(903, 'o1qmn5P3LMbzLouZdlk1rcWUAqms', 0, '2020-10-30 12:38:50', '2020-10-30 12:38:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(904, 'o1qmn5OIM5fIk8x-IFWWVT4ZvyYg', 0, '2020-10-30 12:38:50', '2020-10-30 12:38:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(905, 'o1qmn5EbxTcSK9xXdZ7AzL2oypd0', 1, '2020-10-30 12:42:07', '2020-11-05 10:18:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(906, 'o1qmn5CU6_MnuVsyz8HUUJCnsUJ8', 0, '2020-10-30 12:43:05', '2020-10-30 12:43:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(907, 'o1qmn5H4CL-VWwLv2H4WUONelVu0', 0, '2020-10-30 12:43:54', '2020-10-30 12:43:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(908, 'o1qmn5KcQuIMZAuL-v3ymjVtWxAg', 0, '2020-10-30 12:44:10', '2020-10-30 12:44:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(909, 'o1qmn5J0OD7zs_DIF-Lamk7VRoTw', 0, '2020-10-30 12:44:22', '2020-10-30 12:44:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(910, 'o1qmn5GCKJknnBRkb8nWfyySnEHE', 0, '2020-10-30 12:44:31', '2020-10-30 12:44:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(911, 'o1qmn5A-lFWBnA-4i0DOnjVO2Fs0', 0, '2020-10-30 12:44:33', '2020-10-30 12:44:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(912, 'o1qmn5GGqdMszdus5m8l7HF9wyu4', 0, '2020-10-30 12:44:56', '2020-10-30 12:44:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(913, 'o1qmn5ANHYOHQTzj4CCyLaIOs9do', 0, '2020-10-30 12:45:26', '2020-10-30 12:45:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(914, 'o1qmn5FpTWPQdqNwJ0k9mQe77oCg', 1, '2020-10-30 12:46:59', '2020-11-16 11:09:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(915, 'o1qmn5DuyB7wuavTFW2YA4pbq1IY', 0, '2020-10-30 12:47:03', '2020-10-30 12:47:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(916, 'o1qmn5PUw9jsIGAy090uLYe_85zI', 0, '2020-10-30 12:47:20', '2020-10-30 12:47:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(917, 'o1qmn5GCsIDLM6TAnolKIqLrMadU', 0, '2020-10-30 12:50:40', '2020-10-30 12:50:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(918, 'o1qmn5DJGilMFwjwIZ5rIep_JNk8', 0, '2020-10-30 12:52:33', '2020-10-30 12:52:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(919, 'o1qmn5KA3VcvW-kK7BTZD0ds1KCU', 0, '2020-10-30 12:57:42', '2020-10-30 12:57:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(920, 'o1qmn5KkqTQn3tyLMchSCOg9ZVLg', 0, '2020-10-30 12:58:10', '2020-10-30 12:58:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(921, 'o1qmn5CmzootgzlOU3Hm89CsBNy4', 1, '2020-10-30 12:58:50', '2020-11-25 10:14:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(922, 'o1qmn5JiBZ5cQEKt6sEePsoIAEbE', 1, '2020-10-30 13:00:39', '2021-01-04 11:55:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(923, 'o1qmn5F73yRnwLYmB2RfurB2aZ6s', 8, '2020-10-30 13:01:09', '2020-11-25 19:14:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(924, 'o1qmn5F9ybObmP1vj5nJlmkunCH4', 3, '2020-10-30 13:01:10', '2021-03-10 19:22:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(925, 'o1qmn5ONjn2ptT7igebv43TwUyDw', 0, '2020-10-30 13:01:14', '2020-10-30 13:01:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(926, 'o1qmn5NrY7lj_LoPAod5ZCLESoHA', 0, '2020-10-30 13:02:19', '2020-10-30 13:02:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(927, 'o1qmn5FuvxzBH7J5uJfg3HRYznZU', 0, '2020-10-30 13:02:44', '2020-10-30 13:02:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(928, 'o1qmn5DjFe1YP0SRcvd9sAl7m8FE', 0, '2020-10-30 13:02:54', '2020-10-30 13:02:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(929, 'o1qmn5MfyCJp_FzwY49ej_a38yT4', 0, '2020-10-30 13:08:50', '2020-10-30 13:08:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(930, 'o1qmn5HLPGSFFo3W_u51jHNxdkOQ', 1, '2020-10-30 13:09:24', '2020-11-12 08:04:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(931, 'o1qmn5C0d9o8p0t6OtGIYnHiBq3k', 0, '2020-10-30 13:09:57', '2020-10-30 13:09:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(932, 'o1qmn5Jec-n-n4fVlCSO29WEi-Zo', 0, '2020-10-30 13:10:14', '2020-10-30 13:10:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(933, 'o1qmn5ClPKURSkoUuuMQC-P5dITk', 0, '2020-10-30 13:10:16', '2020-10-30 13:10:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(934, 'o1qmn5KZFdD1JXW4_NLd4lRfSJ5g', 0, '2020-10-30 13:11:30', '2020-10-30 13:11:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(935, 'o1qmn5OzkmuERppj6wKxVcKIw5Pk', 61, '2020-10-30 13:13:25', '2021-03-25 17:20:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(936, 'o1qmn5DOVTE0gwUa9rwcekbG08mU', 0, '2020-10-30 13:13:41', '2020-10-30 13:13:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(937, 'o1qmn5OKUHhCbFBZ0EtF7jmbC2II', 0, '2020-10-30 13:16:28', '2020-10-30 13:16:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(938, 'o1qmn5ElBw4_bK26dr7DXg5MX8uA', 0, '2020-10-30 13:17:50', '2020-10-30 13:17:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(939, 'o1qmn5DwOhaEL4QX4GcoajS5mQvU', 0, '2020-10-30 13:20:00', '2020-10-30 13:20:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(940, 'o1qmn5GNp3FWjQU01bzcIgNK6XXQ', 0, '2020-10-30 13:20:26', '2020-10-30 13:20:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(941, 'o1qmn5GRNYuaE4wxV5dMpNU4eDuU', 0, '2020-10-30 13:22:21', '2020-10-30 13:22:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(942, 'o1qmn5D_a9RIVFx5WucxkvqGv13w', 0, '2020-10-30 13:23:33', '2020-10-30 13:23:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(943, 'o1qmn5G_SNXFh0E3y_Gi3rQUSlN8', 0, '2020-10-30 13:25:56', '2020-10-30 13:25:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(944, 'o1qmn5MB2PF75jOSXV8zdXtVPvXw', 0, '2020-10-30 13:27:24', '2020-10-30 13:27:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(945, 'o1qmn5BSzOMyyK6UfsM-svyd7ORs', 1, '2020-10-30 13:28:28', '2020-12-23 20:51:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(946, 'o1qmn5NxTL_liRJAoqYhj7DkJC_g', 0, '2020-10-30 13:30:33', '2020-10-30 13:30:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(947, 'o1qmn5A7ht4QLO1aFIgARef1rGls', 0, '2020-10-30 13:34:42', '2020-10-30 13:34:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(948, 'o1qmn5Et8i6sn8KyffHqdt-Nd2MQ', 1, '2020-10-30 13:39:35', '2020-10-30 20:14:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(949, 'o1qmn5H09va8-Vf1f4isYwBK6aDc', 0, '2020-10-30 13:39:40', '2020-10-30 13:39:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(950, 'o1qmn5NI3m_oJwdV_yBiyieonIH8', 0, '2020-10-30 13:41:05', '2020-10-30 13:41:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(951, 'o1qmn5IQBvVP9sJc4dLdOkAI60aI', 0, '2020-10-30 13:43:09', '2020-10-30 13:43:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(952, 'o1qmn5LjgWzBDfXq2OjZ_nxO2LS8', 1, '2020-10-30 13:46:03', '2020-11-29 17:08:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(953, 'o1qmn5BiTJENEoBFfJpA1BgbKLFk', 1, '2020-10-30 13:46:59', '2020-10-30 17:27:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(954, 'o1qmn5IrajeOmmx4f3nEYvJoO7OE', 3, '2020-10-30 13:49:42', '2021-03-16 21:08:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(955, 'o1qmn5IL_7LEg1AAAfsp_75bOVAI', 0, '2020-10-30 13:55:30', '2020-10-30 13:55:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(956, 'o1qmn5D1vBjOUrICfHq3uKW2iB24', 1, '2020-10-30 13:56:50', '2020-10-30 22:35:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(957, 'o1qmn5GPnsLPZUVZ_BVK7-X40nE4', 0, '2020-10-30 13:56:53', '2020-10-30 13:56:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(958, 'o1qmn5LM6se1XwNt5TJXERooIMbc', 0, '2020-10-30 13:57:38', '2020-10-30 13:57:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(959, 'o1qmn5EXg7leDhsrrbJdmUFaw3Ag', 2, '2020-10-30 13:58:44', '2020-11-09 17:06:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(960, 'o1qmn5IEWYCFnt1GnW8tmmxLau-8', 0, '2020-10-30 14:00:51', '2020-10-30 14:00:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(961, 'o1qmn5HOu_OVABexylOkFndGPeaQ', 0, '2020-10-30 14:02:45', '2020-10-30 14:02:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(962, 'o1qmn5Ep9NDau4i58_4g1fwAtbok', 1, '2020-10-30 14:02:56', '2020-10-30 14:05:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(963, 'o1qmn5JJ6wzqWIHC9HFHxttqfUA8', 0, '2020-10-30 14:03:16', '2020-10-30 14:03:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(964, 'o1qmn5BT9S5j8S1gUmNRqq_nHMWg', 0, '2020-10-30 14:03:40', '2020-10-30 14:03:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(965, 'o1qmn5Mrk6W1eLlUwwns-BeUteDQ', 0, '2020-10-30 14:05:20', '2020-10-30 14:05:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(966, 'o1qmn5FExWQ97K9o7I8pc9oPqghQ', 0, '2020-10-30 14:06:24', '2020-10-30 14:06:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(967, 'o1qmn5MeJ2o7IO0uyXMTNOpGSxWM', 1, '2020-10-30 14:06:47', '2020-10-30 20:52:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(968, 'o1qmn5I685RV4TgKbVvFkdJ3XHUo', 0, '2020-10-30 14:08:05', '2020-10-30 14:08:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(969, 'o1qmn5IhPNA34c1G22MAVyxa1wls', 0, '2020-10-30 14:08:49', '2020-10-30 14:08:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(970, 'o1qmn5Ph2HyhVDH0y3-NmYrViAeI', 3, '2020-10-30 14:11:39', '2020-10-30 21:29:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(971, 'o1qmn5FwKpy6Gf-LpOLyW-mZxd7k', 7, '2020-10-30 14:11:48', '2021-02-24 16:47:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(972, 'o1qmn5LyS9vAiUkcMXqTP3sJLoPg', 0, '2020-10-30 14:11:53', '2020-10-30 14:11:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(973, 'o1qmn5DVzoGmOJA3-o_xf7ECk0-4', 0, '2020-10-30 14:12:44', '2020-10-30 14:12:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(974, 'o1qmn5M0dCJmGIBS-uAgYX9vHea8', 2, '2020-10-30 14:15:07', '2020-12-23 09:11:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(975, 'o1qmn5FQH5gVnXWE-ezjJ2yjtBkU', 0, '2020-10-30 14:15:25', '2020-10-30 14:15:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(976, 'o1qmn5Lny5o3YWH-Liw-U6iSPfeI', 0, '2020-10-30 14:16:38', '2020-10-30 14:16:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(977, 'o1qmn5ArAXjWirOAuvkRkEYZQrPk', 0, '2020-10-30 14:17:08', '2020-10-30 14:17:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(978, 'o1qmn5OvUplplpLGMN8eQ09MIvkc', 0, '2020-10-30 14:17:19', '2020-10-30 14:17:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(979, 'o1qmn5EMXmJ5p9PP9KtSNPSEhaDk', 0, '2020-10-30 14:18:33', '2020-10-30 14:18:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(980, 'o1qmn5EiJeD9bw6fLUh1GsduPMoo', 0, '2020-10-30 14:18:54', '2020-10-30 14:18:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(981, 'o1qmn5AlFUDHgl49UQ3wpPtnbi60', 0, '2020-10-30 14:19:59', '2020-10-30 14:19:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(982, 'o1qmn5B_ZtMkfCMUT_neQptCqr0U', 0, '2020-10-30 14:21:42', '2020-10-30 14:21:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(983, 'o1qmn5J_Yu2DnvUWXIcPJ_aQm2X8', 0, '2020-10-30 14:22:04', '2020-10-30 14:22:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(984, 'o1qmn5D6N6mkLrlfY8OkvEWD5qi4', 0, '2020-10-30 14:22:30', '2020-10-30 14:22:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(985, 'o1qmn5FGX_yUomsP_vwp8VL3-pv8', 1, '2020-10-30 14:23:44', '2020-11-27 17:37:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(986, 'o1qmn5PnjBa8zReZEdscaessy-nY', 0, '2020-10-30 14:24:04', '2020-10-30 14:24:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(987, 'o1qmn5H2PINHRU2EStmPQPasnS3M', 0, '2020-10-30 14:25:18', '2020-10-30 14:25:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(988, 'o1qmn5Ez4SxjreywTbuzi5OzHL4E', 0, '2020-10-30 14:25:24', '2020-10-30 14:25:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(989, 'o1qmn5ANSG6IZPIHUU8DcBgKYMdU', 3, '2020-10-30 14:27:22', '2021-03-16 17:37:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(990, 'o1qmn5H6Y9Nh9OTSccRH6rzRdGa4', 0, '2020-10-30 14:28:13', '2020-10-30 14:28:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(991, 'o1qmn5A74tLKyZmfpSfqYv0_qaq0', 0, '2020-10-30 14:28:40', '2020-10-30 14:28:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(992, 'o1qmn5HUd-8q5IATW3mq0m0tyuvw', 0, '2020-10-30 14:30:40', '2020-10-30 14:30:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(993, 'o1qmn5KfhRRhRuQH3HW9U7zO71pM', 0, '2020-10-30 14:32:49', '2020-10-30 14:32:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(994, 'o1qmn5JivZRxHAy92IUUqA5kjmRE', 2, '2020-10-30 14:33:28', '2020-10-30 18:32:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(995, 'o1qmn5JAmEiI9R3X9T4y406EOCJQ', 0, '2020-10-30 14:33:39', '2020-10-30 14:33:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(996, 'o1qmn5DW6ANEdKH8JH2gfRxLhsmk', 0, '2020-10-30 14:34:46', '2020-10-30 14:34:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(997, 'o1qmn5Gvg77au-rCCqf8S8A9-HUQ', 4, '2020-10-30 14:38:44', '2021-01-05 11:07:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(998, 'o1qmn5LXlBDcPnExER8pRGoavdOs', 0, '2020-10-30 14:42:58', '2020-10-30 14:42:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(999, 'o1qmn5OAAeBBH5-PW756jBR8Ob7s', 5, '2020-10-30 14:48:06', '2021-03-20 20:25:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1000, 'o1qmn5N8IMJofvAZ2H2iBxk9BMRw', 0, '2020-10-30 14:48:29', '2020-10-30 14:48:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1001, 'o1qmn5JxYvTJQD-KZJjzXiUFjL-4', 0, '2020-10-30 14:48:35', '2020-10-30 14:48:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1002, 'o1qmn5DOD5uZlZ5d75cQrGmY2QTQ', 0, '2020-10-30 14:50:32', '2020-10-30 14:50:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1003, 'o1qmn5ADG6fiP8O7tngQFXPPT-6Q', 0, '2020-10-30 14:50:57', '2020-10-30 14:50:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1004, 'o1qmn5JaZaUIl8QtMsN7nH6TwcKw', 0, '2020-10-30 14:51:06', '2020-10-30 14:51:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1005, 'o1qmn5NBaJCiWkavGzC6Ra8UIZp8', 0, '2020-10-30 14:51:21', '2020-10-30 14:51:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1006, 'o1qmn5A7hrbO1e4WiGH0kEsZJAWo', 0, '2020-10-30 14:51:21', '2020-10-30 14:51:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1007, 'o1qmn5FdBu20KQ5AdBgjdmcz-r9w', 0, '2020-10-30 14:51:38', '2020-10-30 14:51:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1008, 'o1qmn5GxJBsiHy9yR0sUyLQTsO4g', 1, '2020-10-30 14:53:51', '2021-02-20 22:00:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1009, 'o1qmn5HZ_zmCLeVkC1BDszALYh3o', 0, '2020-10-30 14:56:14', '2020-10-30 14:56:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1010, 'o1qmn5BQXHmNiTzCqGprld4lx4c0', 0, '2020-10-30 15:00:57', '2020-10-30 15:00:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1011, 'o1qmn5LGasmOyfrxZAkHh7EMQXSw', 0, '2020-10-30 15:02:17', '2020-10-30 15:02:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1012, 'o1qmn5LnUiHnStHUQHmvpuMaxaTk', 0, '2020-10-30 15:02:53', '2020-10-30 15:02:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1013, 'o1qmn5NB8ZKJGKHIOpsm7RghLMV0', 0, '2020-10-30 15:08:37', '2020-10-30 15:08:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1014, 'o1qmn5J5n4JAlSyeQACdzSt6JLoI', 0, '2020-10-30 15:10:06', '2020-10-30 15:10:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1015, 'o1qmn5DqAPLnzYwrxiLDNugMd6gQ', 0, '2020-10-30 15:11:44', '2020-10-30 15:11:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1016, 'o1qmn5I_GTGcwQoB4p1SbWqk1P8I', 0, '2020-10-30 15:13:55', '2020-10-30 15:13:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1017, 'o1qmn5C0FJmkqQXBmWCr98z7urjs', 1, '2020-10-30 15:17:07', '2020-12-05 22:04:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1018, 'o1qmn5FF7hQ950S_aYJr7Vzb_RyY', 0, '2020-10-30 15:17:20', '2020-10-30 15:17:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1019, 'o1qmn5FcS8M2Zmx1PGBJuHX15qnw', 4, '2020-10-30 15:17:21', '2021-03-06 12:52:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1020, 'o1qmn5D-bwj8-TW3oGn8ILphOnZY', 0, '2020-10-30 15:18:00', '2020-10-30 15:18:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1021, 'o1qmn5OSMGgtry8v81h2H4b2Wg1Y', 0, '2020-10-30 15:18:41', '2020-10-30 15:18:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1022, 'o1qmn5OcjajHUB0oJOM34UjX-byw', 4, '2020-10-30 15:20:01', '2020-11-04 17:33:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1023, 'o1qmn5OFz3ZsaRIAKXNzV6SCi3i0', 0, '2020-10-30 15:20:10', '2020-10-30 15:20:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1024, 'o1qmn5F2WKzodqXox2iLONEVGNS4', 0, '2020-10-30 15:20:46', '2020-10-30 15:20:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1025, 'o1qmn5CsSgKidJi1S9XTaSgOKDtg', 3, '2020-10-30 15:22:39', '2020-11-03 16:08:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1026, 'o1qmn5C4WOXMIpb-joSYDcJySZ34', 1, '2020-10-30 15:22:56', '2020-12-01 14:37:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1027, 'o1qmn5CmVMQ8MfoClWSaZA4nf-4E', 1, '2020-10-30 15:24:53', '2020-11-24 15:09:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1028, 'o1qmn5BhdEgzxbkX8Kjp0mhYxvVA', 0, '2020-10-30 15:25:09', '2020-10-30 15:25:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1029, 'o1qmn5Mjy0naQJZDbiKHMW0l2qEw', 0, '2020-10-30 15:25:37', '2020-10-30 15:25:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1030, 'o1qmn5PDHRVZd4wCLPd4D7HKpGh0', 1, '2020-10-30 15:30:40', '2020-11-19 17:13:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1031, 'o1qmn5G6R5vpQby9o8hn2K7rOnuM', 1, '2020-10-30 15:30:41', '2021-02-03 09:21:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1032, 'o1qmn5MjOth4p3yLyoYOpf2gEO8w', 0, '2020-10-30 15:32:16', '2020-10-30 15:32:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1033, 'o1qmn5Jebp9qx-IlOSIeecFm-Fb8', 0, '2020-10-30 15:34:28', '2020-10-30 15:34:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1034, 'o1qmn5LwiOGfuOKacjZChuccPmRY', 0, '2020-10-30 15:39:03', '2020-10-30 15:39:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1035, 'o1qmn5GNDRaTdrCAjJ8z-g-ANGo0', 0, '2020-10-30 15:39:08', '2020-10-30 15:39:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1036, 'o1qmn5OiEO5L3hIfcchnY6Zpg4c8', 0, '2020-10-30 15:39:21', '2020-10-30 15:39:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1037, 'o1qmn5EIGme9XNkTBcB_ihBId7N4', 0, '2020-10-30 15:39:40', '2020-10-30 15:39:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1038, 'o1qmn5Kl6sRENN_Z_6aOU3KrR62E', 0, '2020-10-30 15:41:26', '2020-10-30 15:41:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1039, 'o1qmn5CRN2XVmZc4fjhkpmSZynAE', 0, '2020-10-30 15:45:49', '2020-10-30 15:45:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1040, 'o1qmn5En-yZ41BqAZGnigmH0jwlM', 1, '2020-10-30 15:46:31', '2020-11-04 11:42:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1041, 'o1qmn5Pv562-5OZjVtzOTQDnrNJQ', 0, '2020-10-30 15:52:43', '2020-10-30 15:52:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1042, 'o1qmn5ADLdJtXriMXkV7Lpju1uNs', 0, '2020-10-30 15:54:52', '2020-10-30 15:54:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1043, 'o1qmn5G4W8bVrXYJNfCuqtiMHilg', 0, '2020-10-30 15:56:50', '2020-10-30 15:56:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1044, 'o1qmn5EuiV5X2MTkJrW-vDNtu_Kk', 1, '2020-10-30 15:57:20', '2021-03-05 09:47:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1045, 'o1qmn5BlDX-RYoq05KROhfWeXwDg', 0, '2020-10-30 15:58:17', '2020-10-30 15:58:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1046, 'o1qmn5LA4Uc5KoFKrOQyvxqA_s4M', 0, '2020-10-30 15:58:55', '2020-10-30 15:58:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1047, 'o1qmn5Opd-JMSmpaGb7lkxWqraNE', 0, '2020-10-30 15:59:04', '2020-10-30 15:59:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1048, 'o1qmn5DbcIso0976VcfA_94eCgQk', 0, '2020-10-30 16:04:23', '2020-10-30 16:04:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1049, 'o1qmn5LBmz2ZS1Hhj2-s8i7r8yCE', 2, '2020-10-30 16:04:46', '2020-12-08 14:20:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1050, 'o1qmn5AIxXsbl1G2kLCtBjtR7rG0', 2, '2020-10-30 16:05:21', '2020-12-02 15:45:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1051, 'o1qmn5NGLOYOxehQCBM7yWpXkWOI', 0, '2020-10-30 16:06:52', '2020-10-30 16:06:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1052, 'o1qmn5MmuHACuXX9X96ysPYwNJcY', 5, '2020-10-30 16:07:48', '2020-12-05 14:54:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1053, 'o1qmn5GAECIvI0F5FNn1gqrA5sNU', 0, '2020-10-30 16:08:03', '2020-10-30 16:08:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1054, 'o1qmn5MfoyLVTSs7zNZMYvfFzNuo', 0, '2020-10-30 16:11:38', '2020-10-30 16:11:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1055, 'o1qmn5N7it_2SThDVHQYtXeDCcx4', 0, '2020-10-30 16:20:00', '2020-10-30 16:20:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1056, 'o1qmn5BaXb2RrkzlEPeEcpUKP4ew', 2, '2020-10-30 16:20:44', '2020-11-10 17:07:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1057, 'o1qmn5Dzt5q-yxnPDyarEbez1TQw', 0, '2020-10-30 16:24:19', '2020-10-30 16:24:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1058, 'o1qmn5Jt9YR7eZn_rb6TMQ5GqQeA', 12, '2020-10-30 16:24:27', '2020-12-20 13:39:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1059, 'o1qmn5DyFAjLEYtemF9FxsEzvfFo', 0, '2020-10-30 16:27:45', '2020-10-30 16:27:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1060, 'o1qmn5JqpxpbNSD2x0X7jQtF2kPc', 1, '2020-10-30 16:28:37', '2020-12-30 21:41:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1061, 'o1qmn5ND9JR3jopiVzQ1UcAT5yEY', 6, '2020-10-30 16:31:06', '2021-01-12 17:28:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1062, 'o1qmn5MezYkXvjZst--qn9ZmUgUI', 0, '2020-10-30 16:31:55', '2020-10-30 16:31:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1063, 'o1qmn5LoovmS17lzhBhsIofaxkd8', 1, '2020-10-30 16:32:05', '2020-10-31 14:17:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1064, 'o1qmn5JS42pAJAkioLmB7lyTCAxs', 0, '2020-10-30 16:36:19', '2020-10-30 16:36:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1065, 'o1qmn5CUwmIJZW-hEklvW0ZKGoFI', 1, '2020-10-30 16:36:49', '2020-11-16 18:18:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1066, 'o1qmn5EqWpd_5eqfLMhIurocvIfw', 5, '2020-10-30 16:37:52', '2021-02-25 14:23:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1067, 'o1qmn5Af6ppKwbDbEWP6mNpJYWBM', 0, '2020-10-30 16:38:09', '2020-10-30 16:38:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1068, 'o1qmn5KPbGDuIsa6MLB3c7mvrST4', 2, '2020-10-30 16:38:35', '2020-10-30 16:39:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1069, 'o1qmn5PbOt5qJR-SEIOO-vHN8u3U', 0, '2020-10-30 16:43:23', '2020-10-30 16:43:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1070, 'o1qmn5M8gI_WN9vfs5BY3YOT8FcY', 0, '2020-10-30 16:49:05', '2020-10-30 16:49:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1071, 'o1qmn5MxF915ah9B6Kkl7d430uZc', 7, '2020-10-30 17:46:12', '2020-12-01 20:24:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1072, 'o1qmn5Ed4AeFaUt28MCBvOwXXKjk', 1, '2020-10-30 17:47:13', '2021-01-12 16:07:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1073, 'o1qmn5NO5TfPdPd9f62Uv17-ti8k', 1, '2020-10-30 19:14:19', '2020-10-30 19:59:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1074, 'o1qmn5JRManygGIMlR35dc-uhO1U', 0, '2020-10-30 19:38:49', '2020-10-30 19:38:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1075, 'o1qmn5OF3QEZx97EVhz6tE_ajbWo', 0, '2020-10-30 20:16:16', '2020-10-30 20:16:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1076, 'o1qmn5M_4LnQ2vUzi2TKcUt-xcjE', 0, '2020-10-30 20:33:25', '2020-10-30 20:33:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1077, 'o1qmn5MpmvWDWVGKtrZ7NI8kF39U', 0, '2020-10-30 20:43:44', '2020-10-30 20:43:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1078, 'o1qmn5OhI6LNBNXU2lqTTiWDTtNw', 2, '2020-10-30 20:50:13', '2020-10-31 03:13:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1079, 'o1qmn5L4dB3mKG3Uf4oLz7UnQTdk', 2, '2020-10-30 21:54:04', '2020-11-04 21:14:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1080, 'o1qmn5GzPZ5rJH3XT7YS1Ef2z_1Y', 0, '2020-10-31 03:51:03', '2020-10-31 03:51:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1081, 'o1qmn5DjCBskBaVRwymcqrHCyVH4', 0, '2020-10-31 08:49:21', '2020-10-31 08:49:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1082, 'o1qmn5LjM6ffFf1fQVxqSuRl6sgo', 0, '2020-10-31 08:50:56', '2020-10-31 08:50:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1083, 'o1qmn5Lzmz9c_uk61zkzAB95jrxA', 0, '2020-10-31 08:51:02', '2020-10-31 08:51:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1084, 'o1qmn5FfSMivVqYlsQOA2yW_ZSy4', 0, '2020-10-31 08:53:03', '2020-10-31 08:53:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1085, 'o1qmn5A7GAwopPt_kZTQ6hMG8DlM', 0, '2020-10-31 08:55:35', '2020-10-31 08:55:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1086, 'o1qmn5HAY_1WPsIu60vYT46s-WeA', 0, '2020-10-31 09:14:33', '2020-10-31 09:14:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1087, 'o1qmn5NcS66xbmz60yJLyOkjmXXo', 0, '2020-10-31 09:18:36', '2020-10-31 09:18:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1088, 'o1qmn5A4hODxzSkNpADmE8C_TkdA', 0, '2020-10-31 09:19:01', '2020-10-31 09:19:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1089, 'o1qmn5OpDTC0JeTUGnuTnWvcpePQ', 0, '2020-10-31 09:20:39', '2020-10-31 09:20:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1090, 'o1qmn5My_qn6-gcr-y4YehZ77gz4', 0, '2020-10-31 09:22:01', '2020-10-31 09:22:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1091, 'o1qmn5HioNkkaht3btg4oxFsH1Ks', 0, '2020-10-31 09:27:50', '2020-10-31 09:27:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1092, 'o1qmn5Jsdl3ju65j6cbits9HEdak', 0, '2020-10-31 09:34:28', '2020-10-31 09:34:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1093, 'o1qmn5IC46UYqBDtsBPNg76Vc2KA', 0, '2020-10-31 09:34:52', '2020-10-31 09:34:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1094, 'o1qmn5HqExt_wR_lEEJET_NURWEc', 0, '2020-10-31 09:35:15', '2020-10-31 09:35:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1095, 'o1qmn5DBfVkdqECGBm6_ASesSOoA', 0, '2020-10-31 09:35:31', '2020-10-31 09:35:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1096, 'o1qmn5NwM8oSNeMBctm3AtYwZ10A', 0, '2020-10-31 09:36:03', '2020-10-31 09:36:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1097, 'o1qmn5MwyictJTka2Fh3o2BeUen8', 0, '2020-10-31 09:37:31', '2020-10-31 09:37:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1098, 'o1qmn5BRIkUTzIp-5rVblEgwXi2o', 0, '2020-10-31 09:37:33', '2020-10-31 09:37:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1099, 'o1qmn5KnCxkT2Qj-90ncjw2dZz3Y', 0, '2020-10-31 09:37:48', '2020-10-31 09:37:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1100, 'o1qmn5FIXfMVfZ7ITUBMJ5mx8o4o', 0, '2020-10-31 09:38:08', '2020-10-31 09:38:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1101, 'o1qmn5PSESwlnd0wHxjOCxsa2xcE', 0, '2020-10-31 09:41:18', '2020-10-31 09:41:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1102, 'o1qmn5MTMnSJRnCCw2xXFCmy6dtY', 1, '2020-10-31 09:45:08', '2020-10-31 11:48:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1103, 'o1qmn5CM9t-z-ojwf3WXkUJWCW1k', 1, '2020-10-31 09:53:55', '2020-11-20 15:21:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1104, 'o1qmn5F9cRxh1cdTVEqsj8D_AakM', 0, '2020-10-31 09:53:58', '2020-10-31 09:53:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1105, 'o1qmn5OoZvYvvnC4uZDMH9r0y4A8', 0, '2020-10-31 09:55:31', '2020-10-31 09:55:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1106, 'o1qmn5D94WLo91w5Rpa37p_qbFCs', 1, '2020-10-31 09:55:45', '2021-01-23 09:28:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1107, 'o1qmn5Btso34hl9aEcwQNV4T8_Jk', 0, '2020-10-31 09:58:37', '2020-10-31 09:58:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1108, 'o1qmn5A30M1MqNXFC8RGNfJPcIe4', 1, '2020-10-31 10:02:20', '2020-11-01 16:00:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1109, 'o1qmn5A2EQYOP-4XvnYBSabSqUJ0', 0, '2020-10-31 10:03:26', '2020-10-31 10:03:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1110, 'o1qmn5BgDwu87aInKwelsjcVJ5BE', 0, '2020-10-31 10:06:22', '2020-10-31 10:06:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1111, 'o1qmn5BgicMujwuBhAbRfflRnUQw', 21, '2020-10-31 10:07:46', '2021-02-01 13:06:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1112, 'o1qmn5IAlWKzbcmdQPiVaj9nEGzI', 0, '2020-10-31 10:12:52', '2020-10-31 10:12:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1113, 'o1qmn5BhDKl9BBp5HjLv9jocrBPk', 1, '2020-10-31 10:14:13', '2020-11-13 16:48:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1114, 'o1qmn5BOTgSGW-wErMAYSoN56IG4', 0, '2020-10-31 10:16:53', '2020-10-31 10:16:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1115, 'o1qmn5BVltUvifVVGfwsR8OVKGP8', 3, '2020-10-31 10:19:10', '2020-12-08 10:10:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1116, 'o1qmn5IVSo6iYIIURXAkHv7NajT8', 0, '2020-10-31 10:19:30', '2020-10-31 10:19:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1117, 'o1qmn5IoDGKdMYXrBPyO4hTW9S40', 0, '2020-10-31 10:20:04', '2020-10-31 10:20:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1118, 'o1qmn5FhtMLG_T_48DxFAQQKHlds', 1, '2020-10-31 10:21:13', '2020-11-28 17:15:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1119, 'o1qmn5BraNJ6f7j8NDYkHlHuxXCc', 8, '2020-10-31 10:24:54', '2021-03-16 16:29:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1120, 'o1qmn5M0RcV9hy0WbPRldYETbfzk', 0, '2020-10-31 10:25:56', '2020-10-31 10:25:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1121, 'o1qmn5KeKzSdhtDIunwFqk8ipomM', 1, '2020-10-31 10:31:20', '2020-11-05 19:19:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1122, 'o1qmn5GP-PV5rTq7zRKijLnUu98Y', 0, '2020-10-31 10:31:32', '2020-10-31 10:31:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1123, 'o1qmn5BvbFmY6iUSp_exFSjdac8Y', 0, '2020-10-31 10:35:07', '2020-10-31 10:35:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1124, 'o1qmn5AlmxRsuuFHRTVlOxN0RbiQ', 0, '2020-10-31 10:41:59', '2020-10-31 10:41:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1125, 'o1qmn5KYQl5uK27LWckHgpi3kB8E', 0, '2020-10-31 10:42:27', '2020-10-31 10:42:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1126, 'o1qmn5JFx1wNz8Q4FzymEXDkhmok', 4, '2020-10-31 10:43:29', '2021-03-07 22:01:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1127, 'o1qmn5B_7DYzdg_JAAd1fItILJDc', 0, '2020-10-31 10:45:17', '2020-10-31 10:45:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1128, 'o1qmn5AoI4r_7ZKKOFzx5Z4dU85g', 0, '2020-10-31 10:45:54', '2020-10-31 10:45:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1129, 'o1qmn5BUI7SLehbTjEm_aZP-J6Vg', 1, '2020-10-31 10:46:03', '2020-10-31 10:54:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1130, 'o1qmn5Fvz_fAxWZMjOLPFvF9haX0', 0, '2020-10-31 10:48:21', '2020-10-31 10:48:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1131, 'o1qmn5Cg8W7F3xIigU8uzY2FWqGo', 1, '2020-10-31 10:48:38', '2020-11-04 08:12:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1132, 'o1qmn5JjBwpaONd5YWoTZOvmtK8w', 0, '2020-10-31 10:53:11', '2020-10-31 10:53:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1133, 'o1qmn5NMiWhIIGFFpJxD2sIs9ROI', 0, '2020-10-31 10:53:51', '2020-10-31 10:53:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1134, 'o1qmn5NoEntKDLwM4Ncs2yGVNhCc', 0, '2020-10-31 10:55:02', '2020-10-31 10:55:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1135, 'o1qmn5GQqSstdjHhh7jLxPHksUzY', 0, '2020-10-31 10:56:26', '2020-10-31 10:56:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1136, 'o1qmn5JBtwF8ipZkDmHgKbg_sKPE', 1, '2020-10-31 10:59:00', '2020-11-16 13:40:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1137, 'o1qmn5BTd6Klhe_cwyKy5O2TzY7Q', 0, '2020-10-31 10:59:41', '2020-10-31 10:59:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1138, 'o1qmn5EEtaFA_T5GfFZTHwAcqEi0', 0, '2020-10-31 11:02:10', '2020-10-31 11:02:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1139, 'o1qmn5DpCqc5Cj7n7SktOWTehzgg', 0, '2020-10-31 11:05:38', '2020-10-31 11:05:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1140, 'o1qmn5CxIxazY6vtkRlzwIFikVnE', 0, '2020-10-31 11:06:36', '2020-10-31 11:06:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1141, 'o1qmn5J4-myp3V7x7d39nyXRdXy8', 2, '2020-10-31 11:07:27', '2021-03-03 10:11:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1142, 'o1qmn5PAmcw5Atk9ypYxwopOmRJI', 0, '2020-10-31 11:09:38', '2020-10-31 11:09:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1143, 'o1qmn5CZWyAqg5YV80x-x8Z0Sqik', 0, '2020-10-31 11:10:21', '2020-10-31 11:10:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1144, 'o1qmn5Frua8X4NOYyrQrEo9Q0nio', 0, '2020-10-31 11:10:23', '2020-10-31 11:10:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1145, 'o1qmn5Gj6B5n_-uwNGQliFhdceKk', 1, '2020-10-31 11:10:28', '2021-01-19 17:13:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1146, 'o1qmn5OF2BCWytv5Ub0maed_hJlA', 0, '2020-10-31 11:10:45', '2020-10-31 11:10:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1147, 'o1qmn5Da5IBv-dJL2Y38dutTn-Ac', 2, '2020-10-31 11:11:46', '2020-11-27 18:46:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1148, 'o1qmn5AvMaSURrxad8BHPC1jR-9I', 2, '2020-10-31 11:15:42', '2021-01-02 16:37:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1149, 'o1qmn5J_GIjj7Nd3izHLg9Un7kis', 0, '2020-10-31 11:17:12', '2020-10-31 11:17:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1150, 'o1qmn5Jo4RRmeDN67osOI0Os-yKo', 0, '2020-10-31 11:17:26', '2020-10-31 11:17:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1151, 'o1qmn5BAlcilXC1DbQvuEo_lr2ck', 1, '2020-10-31 11:17:53', '2020-11-02 13:11:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1152, 'o1qmn5DfKFtHePCczHJF9FbAkruU', 0, '2020-10-31 11:19:36', '2020-10-31 11:19:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1153, 'o1qmn5OvLSVu5m6iCHitHaJi1SYg', 0, '2020-10-31 11:22:42', '2020-10-31 11:22:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1154, 'o1qmn5HWZ7DF_fclgIVUFLvt8FNw', 0, '2020-10-31 11:26:02', '2020-10-31 11:26:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1155, 'o1qmn5ObepiYdKVf_bndWQrhl1VQ', 0, '2020-10-31 11:27:06', '2020-10-31 11:27:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1156, 'o1qmn5NgHbzl8e-L4CQ7vGdZxs9M', 1, '2020-10-31 11:27:28', '2020-12-21 15:33:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1157, 'o1qmn5Bz53-fy74-L8U5FdD9dGnQ', 1, '2020-10-31 11:30:07', '2020-11-05 09:21:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1158, 'o1qmn5EBZvN3UsKzZz_FeEJiU4dU', 0, '2020-10-31 11:30:28', '2020-10-31 11:30:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1159, 'o1qmn5AHdA9TaupqqfcmAM3-nF1w', 0, '2020-10-31 11:34:36', '2020-10-31 11:34:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1160, 'o1qmn5JUbpO6ettWQWQskPo0wlVc', 0, '2020-10-31 11:36:50', '2020-10-31 11:36:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1161, 'o1qmn5DUfusJ3xWAebg21hXuG568', 1, '2020-10-31 11:41:04', '2020-11-10 15:57:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1162, 'o1qmn5D_SSqLxi2I5f7gqNfKO-d4', 1, '2020-10-31 11:53:11', '2020-11-02 15:16:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1163, 'o1qmn5HcvrvP7vGuLkrOX8fxAF44', 0, '2020-10-31 11:54:26', '2020-10-31 11:54:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1164, 'o1qmn5CZ2WApH87lzGyPMbmCoshE', 0, '2020-10-31 11:57:27', '2020-10-31 11:57:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1165, 'o1qmn5G0x-L79XAxilaNEeVGa-8o', 7, '2020-10-31 11:57:38', '2020-11-30 08:58:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1166, 'o1qmn5HV4pB5E5mXf-jNQm3i4Ha4', 2, '2020-10-31 11:57:56', '2021-01-29 12:48:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1167, 'o1qmn5AR0NMel6LJVNi8cpPgHx_4', 2, '2020-10-31 11:57:57', '2020-12-22 15:54:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1168, 'o1qmn5PbhqDpIYQ9WuWWrISNunFs', 3, '2020-10-31 11:58:00', '2020-11-15 21:36:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1169, 'o1qmn5L1gCGxHB92_WBx0XPjrudE', 0, '2020-10-31 12:05:37', '2020-10-31 12:05:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1170, 'o1qmn5C0F8pO9yINOV37O1e7PMUY', 0, '2020-10-31 12:09:11', '2020-10-31 12:09:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1171, 'o1qmn5ELd9JogfBn-dCGyshZwBF0', 0, '2020-10-31 12:09:49', '2020-10-31 12:09:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1172, 'o1qmn5C01xgu7nCcH-5Z7ZkzxdM0', 5, '2020-10-31 12:12:58', '2020-12-17 20:02:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1173, 'o1qmn5J7yjk3MU4oRP0qgcZU8GOU', 0, '2020-10-31 12:19:08', '2020-10-31 12:19:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1174, 'o1qmn5Ef2VAQ1h3Gnp2d0TvoMhKM', 1, '2020-10-31 12:22:18', '2020-11-24 21:22:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1175, 'o1qmn5AbsbSmM9aKaSv7v7CT0w70', 0, '2020-10-31 12:22:43', '2020-10-31 12:22:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1176, 'o1qmn5POe_xDLE8PFXuEN5rb_Qzk', 1, '2020-10-31 12:22:54', '2020-11-04 12:23:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1177, 'o1qmn5Pv6G-OXnglC4eByn1g0Q-s', 2, '2020-10-31 12:23:04', '2021-02-08 04:39:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1178, 'o1qmn5GTtNgaGo8S19narDi7pKR0', 1, '2020-10-31 12:23:24', '2021-02-12 06:27:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1179, 'o1qmn5JLhq_vlRRXxuO1t0ieLOvo', 1, '2020-10-31 12:23:36', '2021-02-09 16:54:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1180, 'o1qmn5HjfNE87yU-JYUE0US4kEeU', 1, '2020-10-31 12:23:48', '2021-02-12 02:13:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1181, 'o1qmn5LAATANSMMKdHp_RNYXYU2c', 15, '2020-10-31 12:24:15', '2020-10-31 14:46:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1182, 'o1qmn5CTtCPUh03GH21BRTxCtE5s', 1, '2020-10-31 12:24:20', '2021-02-06 08:16:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1183, 'o1qmn5H8SjJKBKmbaiFWL66nNcxE', 5, '2020-10-31 12:24:22', '2020-11-04 09:14:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1184, 'o1qmn5FVTMgzrr0mI_ip23ghyJJI', 0, '2020-10-31 12:24:36', '2020-10-31 12:24:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1185, 'o1qmn5G3ob5I_ecPPC6rSkGXocZ0', 1, '2020-10-31 12:25:56', '2021-03-20 14:12:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1186, 'o1qmn5MzU2gx5UWLFQuor1DshXd0', 3, '2020-10-31 12:26:40', '2020-11-04 12:24:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1187, 'o1qmn5K025M8qtr07zXWBVPr7x0Q', 0, '2020-10-31 12:37:19', '2020-10-31 12:37:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1188, 'o1qmn5K9LGiu5DRAOXNbbyV_gGzw', 0, '2020-10-31 12:38:26', '2020-10-31 12:38:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1189, 'o1qmn5KXsFcsf9uR-TunB35pJBiI', 0, '2020-10-31 12:41:30', '2020-10-31 12:41:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1190, 'o1qmn5CXBYrSQbwEYWwNdeUDZOOA', 0, '2020-10-31 12:57:34', '2020-10-31 12:57:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1191, 'o1qmn5E2DzRWIh0F0GvgIwsabbUI', 0, '2020-10-31 12:58:19', '2020-10-31 12:58:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1192, 'o1qmn5D538Q74rvg4Nwj5rN54LdE', 0, '2020-10-31 13:04:04', '2020-10-31 13:04:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1193, 'o1qmn5EjvRaRmAm0w2y4W8J3NRo0', 0, '2020-10-31 13:05:13', '2020-10-31 13:05:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1194, 'o1qmn5K0LZJeCWQh5kgOJAJXh_1s', 0, '2020-10-31 13:08:10', '2020-10-31 13:08:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1195, 'o1qmn5P6fIWKaybtX3FwCelrNzRA', 0, '2020-10-31 13:09:48', '2020-10-31 13:09:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1196, 'o1qmn5HEz5XrKwoOIh7RcgCPI6-0', 0, '2020-10-31 13:10:08', '2020-10-31 13:10:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1197, 'o1qmn5ODNfhXZyRHDma0InEXUUAE', 1, '2020-10-31 13:11:39', '2020-12-06 07:02:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1198, 'o1qmn5OWtZ2i1zAwODMpmgBya0wc', 0, '2020-10-31 13:25:35', '2020-10-31 13:25:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1199, 'o1qmn5KgdZRMF822PFu3UU1Xx0yg', 0, '2020-10-31 13:29:30', '2020-10-31 13:29:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1200, 'o1qmn5IwoOrUfafJxJEcTu_YxtVc', 0, '2020-10-31 13:32:47', '2020-10-31 13:32:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1201, 'o1qmn5AMnFbA4vYHv4ZNx5mxu8dc', 0, '2020-10-31 13:33:53', '2020-10-31 13:33:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1202, 'o1qmn5Cjvq9pw3YfRvuxakLs46EE', 1, '2020-10-31 13:39:12', '2020-10-31 15:09:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1203, 'o1qmn5HlvS0tzXY5pKpYRbkocBLY', 1, '2020-10-31 13:39:14', '2020-11-29 15:56:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1204, 'o1qmn5OeM914Jm4rGirusOK4LvH8', 0, '2020-10-31 13:41:24', '2020-10-31 13:41:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1205, 'o1qmn5FUMXs4IDczIrf6p3tsVmcw', 1, '2020-10-31 13:41:30', '2020-11-16 17:54:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1206, 'o1qmn5K5rJ3Z56tLXxHIhNWyuDFk', 0, '2020-10-31 13:44:46', '2020-10-31 13:44:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1207, 'o1qmn5LPMZSekU8FgA_JHl_sPxeI', 0, '2020-10-31 13:46:01', '2020-10-31 13:46:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1208, 'o1qmn5AjUkKyVEsF2sH8eCCkxpYk', 0, '2020-10-31 13:46:21', '2020-10-31 13:46:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1209, 'o1qmn5HzUZLSYYRk2KoqddgPi6G8', 0, '2020-10-31 13:48:21', '2020-10-31 13:48:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1210, 'o1qmn5I6oYp9u-JFYVnZXcUOj7lI', 0, '2020-10-31 13:49:11', '2020-10-31 13:49:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1211, 'o1qmn5Oj0RVefXvjIZpoEX09M2Mk', 0, '2020-10-31 13:50:10', '2020-10-31 13:50:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1212, 'o1qmn5AhriKqIdAr0IuHX5pnPMcw', 0, '2020-10-31 13:52:14', '2020-10-31 13:52:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1213, 'o1qmn5L2u5cIYlQ0QsJl8EfO39yo', 35, '2020-10-31 13:56:28', '2021-03-22 17:40:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1214, 'o1qmn5LyTA058Z_RAHQOj3DbjKXA', 0, '2020-10-31 13:56:55', '2020-10-31 13:56:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1215, 'o1qmn5DcyjZs3nZFegrb118nzvoc', 0, '2020-10-31 13:57:15', '2020-10-31 13:57:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1216, 'o1qmn5MkbB0SffqWT59o3VREw1MY', 0, '2020-10-31 14:00:35', '2020-10-31 14:00:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1217, 'o1qmn5MPN4faHBIQUObxpGH5bW-M', 1, '2020-10-31 14:04:52', '2021-01-28 16:21:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1218, 'o1qmn5J0x1JkKi6GeuVegidqs384', 1, '2020-10-31 14:09:00', '2020-11-02 07:42:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1219, 'o1qmn5Pd5wiJsq31lw3CHoioC3Zw', 0, '2020-10-31 14:10:00', '2020-10-31 14:10:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1220, 'o1qmn5MEiR0bVjDxLqRleE3fB874', 0, '2020-10-31 14:18:40', '2020-10-31 14:18:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1221, 'o1qmn5Gh_3YeIyxYYrA3MU35a9g8', 1, '2020-10-31 14:25:20', '2020-11-02 19:36:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1222, 'o1qmn5BGPFgYJvo6FZLyJ4rSRrRI', 0, '2020-10-31 14:25:20', '2020-10-31 14:25:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1223, 'o1qmn5IRoXRpqCzwU5vUBMGt_PhU', 1, '2020-10-31 14:25:43', '2020-12-31 09:24:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1224, 'o1qmn5HV_qRhCBAuj5CFr2hQ1xCY', 0, '2020-10-31 14:25:46', '2020-10-31 14:25:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1225, 'o1qmn5ChkVHw41W0HaH8I5DW31hc', 0, '2020-10-31 14:28:46', '2020-10-31 14:28:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1226, 'o1qmn5D51h-NUueNPhLZ-BnPGF5Q', 4, '2020-10-31 14:29:45', '2020-12-13 06:46:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1227, 'o1qmn5IC1kr-9_VwjQ1rgYXnQsvo', 0, '2020-10-31 14:30:08', '2020-10-31 14:30:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1228, 'o1qmn5Jz7HVAhASzVlkSgPBZlth0', 0, '2020-10-31 14:35:19', '2020-10-31 14:35:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1229, 'o1qmn5PDr69MUPsvdOH77xP1MFZ8', 0, '2020-10-31 14:35:50', '2020-10-31 14:35:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1230, 'o1qmn5GA97U12xsCswdyARWzh5_A', 5, '2020-10-31 14:36:30', '2021-01-12 18:43:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1231, 'o1qmn5ICI_a8cDiWWY3b6cn83tyM', 0, '2020-10-31 14:40:46', '2020-10-31 14:40:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1232, 'o1qmn5I3LrTQurSKUtg2QjZGX0GQ', 0, '2020-10-31 14:43:04', '2020-10-31 14:43:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1233, 'o1qmn5Ed8MkSCOtA6jYVmJAtnCTA', 0, '2020-10-31 14:45:33', '2020-10-31 14:45:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1234, 'o1qmn5CJmgawhOlfJkvI8Uut-DPI', 0, '2020-10-31 14:50:26', '2020-10-31 14:50:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1235, 'o1qmn5K4We1qo_T_cmikAjdz8lM4', 4, '2020-10-31 14:51:38', '2020-11-04 12:23:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1236, 'o1qmn5MklrkrDqxp0f3QOgQ_Jus0', 0, '2020-10-31 14:51:48', '2020-10-31 14:51:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1237, 'o1qmn5Ju-uJHtmzAQT_O-EAgXrmM', 1, '2020-10-31 14:55:19', '2020-11-26 16:28:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1238, 'o1qmn5PbI_6bbomQKWHKvkN_Vbl0', 0, '2020-10-31 14:56:53', '2020-10-31 14:56:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1239, 'o1qmn5KrrAqjGCudII2igfUI_LX4', 124, '2020-10-31 14:57:31', '2021-03-28 11:22:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1240, 'o1qmn5Ip9gALvLQPnBK2KZqTKWTk', 0, '2020-10-31 15:02:32', '2020-10-31 15:02:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1241, 'o1qmn5B3Wgei-iIk9iTC2vaeEK3Q', 0, '2020-10-31 15:04:58', '2020-10-31 15:04:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1242, 'o1qmn5NkYVTIzK2aEoKMjZlxc00Q', 0, '2020-10-31 15:06:15', '2020-10-31 15:06:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1243, 'o1qmn5EQFxQJ9S9sbAEHi0TPZ8JQ', 0, '2020-10-31 15:07:49', '2020-10-31 15:07:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1244, 'o1qmn5C1gJuE1yr1IrI7L5nLWo54', 0, '2020-10-31 15:10:24', '2020-10-31 15:10:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1245, 'o1qmn5FWC21XwySRN5SHyT-Iko3s', 0, '2020-10-31 15:12:39', '2020-10-31 15:12:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1246, 'o1qmn5An-wjrmyLrSc0EZ4eG8dpU', 2, '2020-10-31 15:13:41', '2020-11-09 14:42:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1247, 'o1qmn5IpgH_EfhoEwjhRDiY4U6TY', 0, '2020-10-31 15:14:27', '2020-10-31 15:14:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1248, 'o1qmn5MWereU4smtgV19KhcFsWxE', 1, '2020-10-31 15:15:18', '2020-11-18 11:22:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1249, 'o1qmn5HzA9KxeecBzU3ejfxrZeXg', 1, '2020-10-31 15:17:10', '2020-11-02 11:04:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1250, 'o1qmn5MRPW3W7TJB01mQe8oPeEFY', 1, '2020-10-31 15:18:49', '2020-12-11 13:58:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1251, 'o1qmn5IaPtcFC60JdedfS9bIWC8c', 14, '2020-10-31 15:24:38', '2021-03-22 10:52:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1252, 'o1qmn5KJq729yP-wPc0vHeUzcX6Y', 1, '2020-10-31 15:26:38', '2021-01-03 14:39:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1253, 'o1qmn5EjtTsvzZ9bCd6iphAL1fmw', 0, '2020-10-31 15:30:25', '2020-10-31 15:30:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1254, 'o1qmn5EFhQZpT5754kknrhjkKUb0', 0, '2020-10-31 15:30:40', '2020-10-31 15:30:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1255, 'o1qmn5PwyPZgimxDSHilzROciaP0', 1, '2020-10-31 15:47:38', '2020-11-14 15:13:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1256, 'o1qmn5EJed-efPJUeF9QEqzZWWRM', 0, '2020-10-31 15:47:58', '2020-10-31 15:47:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1257, 'o1qmn5Ji-TXEU9HkkBMGRDPNaM1U', 0, '2020-10-31 15:51:02', '2020-10-31 15:51:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1258, 'o1qmn5A45YTZAv7PYZksETA84gZQ', 1, '2020-10-31 15:52:34', '2020-11-01 17:42:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1259, 'o1qmn5GVokqZMU_dDp_azawSGdMA', 2, '2020-10-31 15:57:11', '2021-03-28 10:57:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1260, 'o1qmn5F7f2SBmxRc5IdPU-7juPfQ', 0, '2020-10-31 15:57:22', '2020-10-31 15:57:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1261, 'o1qmn5EYI2qSD2YFsPQFlPAP6-YM', 0, '2020-10-31 15:58:17', '2020-10-31 15:58:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1262, 'o1qmn5FGQ8tqtWMFl7P5_2t6z_-Q', 2, '2020-10-31 15:58:50', '2021-01-26 08:22:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1263, 'o1qmn5FjqyOiqbahMmUCN9wfP8ks', 0, '2020-10-31 15:59:48', '2020-10-31 15:59:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1264, 'o1qmn5DeaF3kNrpDZ7w4bMhCgubA', 0, '2020-10-31 16:01:59', '2020-10-31 16:01:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1265, 'o1qmn5Holkd1ndofsgtq0W_KTU-w', 3, '2020-10-31 16:03:12', '2020-11-19 11:07:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1266, 'o1qmn5LouP3ZeFJ3xInPiud_aNdo', 0, '2020-10-31 16:05:53', '2020-10-31 16:05:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1267, 'o1qmn5Isa1CCKTr13B6beZrj3en8', 0, '2020-10-31 16:07:02', '2020-10-31 16:07:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1268, 'o1qmn5Cmub25WOEcazBYJ9b_IlYg', 1, '2020-10-31 16:09:38', '2020-11-01 08:55:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1269, 'o1qmn5PZXdWnDXm72ciY5vzxqOAs', 0, '2020-10-31 16:10:46', '2020-10-31 16:10:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1270, 'o1qmn5KgmFAb_0ZRx0SgF2o34E-Y', 0, '2020-10-31 16:14:34', '2020-10-31 16:14:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1271, 'o1qmn5KNCn8V8Ggv58Gl6umfIlXc', 0, '2020-10-31 16:16:36', '2020-10-31 16:16:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1272, 'o1qmn5LpXlkbb2ncSoOZHL0CAYB0', 1, '2020-10-31 16:23:33', '2020-11-29 10:18:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1273, 'o1qmn5NmtWIGxvWoweP8CimiUehY', 0, '2020-10-31 16:23:41', '2020-10-31 16:23:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1274, 'o1qmn5JliLXkZ_GNVyshxTwI4vSI', 1, '2020-10-31 16:23:53', '2020-10-31 16:23:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1275, 'o1qmn5FpMy5RR02VuY0Oi14-eQ6g', 0, '2020-10-31 17:53:11', '2020-10-31 17:53:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1276, 'o1qmn5PyJKlJ2eh6XsxuzSTFEnlc', 0, '2020-10-31 17:57:35', '2020-10-31 17:57:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1277, 'o1qmn5HZQQl8v7CxS_TEE9GCTK38', 0, '2020-10-31 19:26:35', '2020-10-31 19:26:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1278, 'o1qmn5NRfV3q9D5zosaQqNxNGgjM', 1, '2020-10-31 22:29:36', '2020-10-31 22:32:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1279, 'o1qmn5O0X22KV4xbwIRrFOCpaHB0', 0, '2020-11-01 07:59:48', '2020-11-01 07:59:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1280, 'o1qmn5H_QGIitCS_OXHjE7BBndEs', 12, '2020-11-01 09:09:33', '2021-03-11 15:02:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1281, 'o1qmn5Ingt7kLNw3FZOruWklCrAk', 0, '2020-11-01 09:13:20', '2020-11-01 09:13:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1282, 'o1qmn5GfoI5rAysLgUkCYg2ep_4I', 1, '2020-11-01 09:29:51', '2020-11-01 09:32:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1283, 'o1qmn5LKf9nmbtza8P0mfbrUit7U', 2, '2020-11-01 10:06:02', '2020-11-09 12:13:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1284, 'o1qmn5Ilg4lZ6_PDvp_EC74aU2t4', 1, '2020-11-01 10:19:09', '2020-12-24 11:19:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1285, 'o1qmn5DD7xGqk3QpfHh2ob_vl2mY', 0, '2020-11-01 10:25:47', '2020-11-01 10:25:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1286, 'o1qmn5PvL0QGFaDqpLkePP_efjlc', 0, '2020-11-01 10:29:19', '2020-11-01 10:29:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1287, 'o1qmn5JQGY2OBDeIHV4rxeuX4PR8', 0, '2020-11-01 10:36:16', '2020-11-01 10:36:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1288, 'o1qmn5PupKfCdBG97w2lhB_zHsY8', 0, '2020-11-01 10:36:31', '2020-11-01 10:36:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1289, 'o1qmn5Eqy17HVakuetCd1CDg6z6o', 1, '2020-11-01 10:51:55', '2020-11-25 19:11:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1290, 'o1qmn5OZdx637lxa2qEbV2w-C_8E', 0, '2020-11-01 11:04:23', '2020-11-01 11:04:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1291, 'o1qmn5NmmU1_-89JqPoq-FbkQzBA', 0, '2020-11-01 11:06:24', '2020-11-01 11:06:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1292, 'o1qmn5PFboaMlbzp0bKCMet1E58E', 0, '2020-11-01 11:12:43', '2020-11-01 11:12:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1293, 'o1qmn5PXrMbChfQPqlcRzNdQbUJo', 0, '2020-11-01 11:13:28', '2020-11-01 11:13:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1294, 'o1qmn5IoLHZNno-3Uj7-h_ZG5XaY', 2, '2020-11-01 11:14:27', '2020-11-19 09:55:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1295, 'o1qmn5C5dv3ZG5wEyfJpmWA_wXiI', 0, '2020-11-01 11:18:44', '2020-11-01 11:18:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1296, 'o1qmn5Nygo1COacFrUO_t4nQRH24', 1, '2020-11-01 11:18:44', '2020-11-18 10:34:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1297, 'o1qmn5Hq8RRtmvCAtPTEtkTYlgCE', 0, '2020-11-01 11:23:29', '2020-11-01 11:23:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1298, 'o1qmn5OslWEB4Jvgq3Cvvp2YDERY', 0, '2020-11-01 11:53:41', '2020-11-01 11:53:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1299, 'o1qmn5MyDYqF9InjvWDuoM-hEZcs', 0, '2020-11-01 11:56:28', '2020-11-01 11:56:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1300, 'o1qmn5C8Y0tm32V50mbC36JE7Zok', 1, '2020-11-01 12:06:17', '2020-11-02 09:28:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1301, 'o1qmn5AQ4jO-PiMi9OBYaeyHGfgQ', 0, '2020-11-01 12:07:44', '2020-11-01 12:07:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1302, 'o1qmn5A7HkD9A_cgFu96e8CloCT4', 0, '2020-11-01 12:09:25', '2020-11-01 12:09:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1303, 'o1qmn5IBjrvwvc6w5RdHoF3IXJo4', 4, '2020-11-01 12:42:21', '2021-01-13 12:07:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1304, 'o1qmn5HkLNTGRcR5Z2LR-Yk574fE', 0, '2020-11-01 12:58:58', '2020-11-01 12:58:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1305, 'o1qmn5OGx6vJP0Cpt73w0LOld2dk', 1, '2020-11-01 15:04:13', '2021-03-23 08:51:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1306, 'o1qmn5EjjF63MSdC-EOTpDl6X15I', 1, '2020-11-01 15:43:58', '2020-11-09 17:32:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1307, 'o1qmn5BaaiC3u0-3re5AdqoamPNg', 0, '2020-11-01 15:46:55', '2020-11-01 15:46:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1308, 'o1qmn5Goypfth0PuELsXcNmz6f6k', 1, '2020-11-01 16:44:09', '2020-11-04 15:03:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1309, 'o1qmn5AfoN72EPOMZWG-jrJ8iSGw', 2, '2020-11-01 17:20:39', '2020-11-28 13:11:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1310, 'o1qmn5D2JG_l6UZt4On6pl7fO-m4', 0, '2020-11-01 18:27:03', '2020-11-01 18:27:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1311, 'o1qmn5IW0S3DrSojRzvNKEYskz30', 24, '2020-11-01 19:41:28', '2021-03-22 10:06:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1312, 'o1qmn5EfDGcFQsLGdfzfv-Z5rPcQ', 1, '2020-11-01 19:42:28', '2020-11-07 17:03:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1313, 'o1qmn5JcLHQmGfQQgHJIdzLktJ44', 2, '2020-11-01 19:57:13', '2020-11-02 01:12:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1314, 'o1qmn5O6H4Qb8V4OuLBRubMrRlhU', 0, '2020-11-02 00:08:57', '2020-11-02 00:08:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1315, 'o1qmn5FIx2E8EAbdtBup61sjhkyw', 0, '2020-11-02 03:52:14', '2020-11-02 03:52:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1316, 'o1qmn5AvQAtZPW00Px3W5xvow3mU', 2, '2020-11-02 09:31:02', '2020-11-02 12:29:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1317, 'o1qmn5G1OZvQU7GTxkgCjEJJkyns', 2, '2020-11-02 10:44:05', '2020-11-03 15:40:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1318, 'o1qmn5GK_iml_cr8LXEh_Ar0p8M4', 2, '2020-11-02 11:03:01', '2020-11-02 11:07:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1319, 'o1qmn5EXD_ygmwohCN57UyZzNh_E', 26, '2020-11-02 11:59:01', '2021-03-19 10:00:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1320, 'o1qmn5EzuuJXTkxZ9uJxvpnx-K4M', 2, '2020-11-02 12:01:10', '2020-11-23 20:55:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1321, 'o1qmn5GhnI6mJAwHL6-HqIhAugUA', 1, '2020-11-02 12:05:21', '2020-11-09 10:16:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1322, 'o1qmn5MwC4YI6bQqDVbYEJ8eW-pI', 1, '2020-11-02 12:22:15', '2020-11-03 09:59:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1323, 'o1qmn5FPcfiHya2Kt-C7BJ_2eXPE', 2, '2020-11-02 12:22:50', '2021-02-13 00:49:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1324, 'o1qmn5Flcz1Yc-JpCyrzSF-frKDA', 2, '2020-11-02 12:25:55', '2020-11-02 16:07:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1325, 'o1qmn5KNnwJOunZFnAOz_2yIJx6U', 0, '2020-11-02 13:46:02', '2020-11-02 13:46:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1326, 'o1qmn5Fo5f6aZ6pdmBLDGNdKck8A', 3, '2020-11-02 14:07:53', '2021-01-13 12:35:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1327, 'o1qmn5HCceKx_zcB10SbLNGAp_xY', 1, '2020-11-02 15:05:40', '2020-12-03 11:30:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1328, 'o1qmn5GX-as084Ar23iYR0zfdlu4', 0, '2020-11-02 15:06:10', '2020-11-02 15:06:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1329, 'o1qmn5JmyaG7myQLY1y6TMcpxf_Q', 0, '2020-11-02 15:07:38', '2020-11-02 15:07:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1330, 'o1qmn5MY-zFvWpcdUAqRJ77bUFJM', 0, '2020-11-02 15:34:35', '2020-11-02 15:34:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1331, 'o1qmn5GjbqaqJ0QvmU0EloTb6H-8', 1, '2020-11-02 15:35:30', '2021-03-21 15:41:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1332, 'o1qmn5Fs8NrMlGuDGVmnO_CgPMHQ', 3, '2020-11-02 15:44:13', '2020-11-02 15:51:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1333, 'o1qmn5Gv-DU3xPXtLIIZ036759VA', 0, '2020-11-02 16:13:58', '2020-11-02 16:13:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1334, 'o1qmn5FHLYDaomkI55UHQ4EFajwE', 0, '2020-11-02 16:28:41', '2020-11-02 16:28:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1335, 'o1qmn5MKZrIDorDXec-IyxZ_dVps', 0, '2020-11-02 17:33:17', '2020-11-02 17:33:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1336, 'o1qmn5CEbIt_OFBMWZuHdJCTJVMY', 3, '2020-11-02 19:52:44', '2020-11-03 02:11:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1337, 'o1qmn5LKUAb8jqUoFcxyL39rptnU', 1, '2020-11-02 20:00:38', '2021-03-10 17:31:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1338, 'o1qmn5KoJEOJx4_KTmlwKS4lS0i4', 0, '2020-11-02 20:01:38', '2020-11-02 20:01:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1339, 'o1qmn5EJm8BJ41fbCPAERfdjajg8', 1, '2020-11-02 21:57:03', '2021-01-25 21:40:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1340, 'o1qmn5FHCImT3vlW9HblsHiNuZe0', 1, '2020-11-03 08:48:11', '2020-11-03 11:37:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1341, 'o1qmn5BSMD7rb6ato7uLlenaWsS8', 0, '2020-11-03 12:19:36', '2020-11-03 12:19:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1342, 'o1qmn5GdAJ0MUg1TiEwxzhmiP8TM', 4, '2020-11-03 12:46:17', '2021-03-15 09:00:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1343, 'o1qmn5G7w5q3v5wxRKxQgbDVsyxM', 2, '2020-11-03 13:14:22', '2021-02-25 18:06:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1344, 'o1qmn5CLK7mB2cir4ezl4JCUncug', 0, '2020-11-03 14:02:04', '2020-11-03 14:02:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1345, 'o1qmn5PM42KrTkPcchQk3Wi5g69Y', 0, '2020-11-03 14:02:09', '2020-11-03 14:02:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1346, 'o1qmn5GUZKhdFiGYkv1_4OG-6k_k', 1, '2020-11-03 14:06:17', '2020-11-04 22:25:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1347, 'o1qmn5MPdbtPU0IyF1Mp8mpc1jf8', 0, '2020-11-03 14:16:10', '2020-11-03 14:16:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1348, 'o1qmn5ItjfrMgc6jjtpHaZZNLXMM', 0, '2020-11-03 14:16:47', '2020-11-03 14:16:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1349, 'o1qmn5ILM5kWrZgKOBII0yxayqJs', 1, '2020-11-03 15:32:05', '2020-11-03 18:46:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1350, 'o1qmn5DMWtN_VN4uZ9E41SeUtho8', 0, '2020-11-03 15:33:52', '2020-11-03 15:33:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1351, 'o1qmn5OaEPb8hw8ya1WlQ_r7iFoY', 0, '2020-11-03 16:06:50', '2020-11-03 16:06:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1352, 'o1qmn5Mg-neqyptoVPVDC34zPfvE', 0, '2020-11-03 16:07:09', '2020-11-03 16:07:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1353, 'o1qmn5Npa7CO-h1hLhiVEVlBjpkI', 1, '2020-11-03 16:26:40', '2020-12-03 08:13:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1354, 'o1qmn5Bolcsi5mjxXZmZKUn1QtUc', 3, '2020-11-03 16:48:10', '2020-11-24 16:12:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1355, 'o1qmn5LC8HrtfckrzEr8ufAeW4bo', 0, '2020-11-03 16:52:02', '2020-11-03 16:52:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1356, 'o1qmn5CmCRTuaqf_1aGaRLz5Z-m4', 18, '2020-11-03 16:52:13', '2021-03-03 10:51:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1357, 'o1qmn5IV-gWBDt5wmFAg2bjITUnI', 0, '2020-11-03 18:10:55', '2020-11-03 18:10:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1358, 'o1qmn5PJ1GJc7fDqMqpR6pwaNWBs', 0, '2020-11-03 19:03:40', '2020-11-03 19:03:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1359, 'o1qmn5LIgFfGzBEzMYpMY2txo1RI', 0, '2020-11-03 21:43:40', '2020-11-03 21:43:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1360, 'o1qmn5CY0jQ-B-dEgWL8nABPVFsA', 0, '2020-11-03 23:35:12', '2020-11-03 23:35:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1361, 'o1qmn5JRB9u9lE_8AhA9oU9yFjuc', 0, '2020-11-04 05:27:38', '2020-11-04 05:27:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1362, 'o1qmn5HM_ZWDTURPrv9SP1aJ-Jco', 1, '2020-11-04 05:27:55', '2020-11-04 12:24:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1363, 'o1qmn5LAOkSdN0Pb2kFribY5MVJI', 1, '2020-11-04 07:12:54', '2020-11-04 12:39:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1364, 'o1qmn5Pvq1pNHdCoX3juCW06FIng', 2, '2020-11-04 07:22:47', '2020-11-17 11:38:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1365, 'o1qmn5AHlwMsJIBp_zFsTVc7_te4', 8, '2020-11-04 08:02:08', '2020-11-10 05:09:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1366, 'o1qmn5KMPyfUTLltwin4dWWACdkc', 7, '2020-11-04 08:02:14', '2020-11-12 05:35:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1367, 'o1qmn5Gs9lv6Dw6aU6KONUR26z18', 5, '2020-11-04 08:04:11', '2020-11-05 14:26:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1368, 'o1qmn5KbP0MZr2gtDNHMFt-60moU', 8, '2020-11-04 08:04:15', '2021-02-19 23:09:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1369, 'o1qmn5LYVmY7jxQw7K_cRg0cHlWA', 7, '2020-11-04 08:04:24', '2021-02-15 11:42:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1370, 'o1qmn5KP-Bi7Nh1MYRjkQaiF5a4c', 5, '2020-11-04 08:06:11', '2020-11-05 14:33:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1371, 'o1qmn5ENDxPYssSHoNiwVM6jZYns', 4, '2020-11-04 08:06:12', '2021-02-12 23:37:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1372, 'o1qmn5DgYIrfp2BXcPuBjMC1e6rY', 16, '2020-11-04 08:10:36', '2020-11-13 09:02:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1373, 'o1qmn5PEktGBbphpzoElM56C5m2E', 6, '2020-11-04 08:10:48', '2021-02-16 09:03:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1374, 'o1qmn5CuBDCb3aXTGS6uP1ef3IbY', 5, '2020-11-04 08:10:49', '2020-11-12 03:14:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1375, 'o1qmn5IlJRJmugFiZ_enwFRaS9Pk', 7, '2020-11-04 08:10:49', '2021-02-19 23:07:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1376, 'o1qmn5PVS2flMvz_f4qkND7Q9Pms', 3, '2020-11-04 08:10:52', '2020-11-04 08:11:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1377, 'o1qmn5NewAVWEeOlC7pK5pJwJx9s', 7, '2020-11-04 08:11:06', '2020-11-10 05:17:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1378, 'o1qmn5HwhC08cT74IQBOcgdx88uI', 6, '2020-11-04 08:11:06', '2020-11-04 08:11:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1379, 'o1qmn5I-3CI2DOSNTVmenQ4aCwjQ', 12, '2020-11-04 08:11:06', '2020-11-06 11:15:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1380, 'o1qmn5Hh6IMRMvbfJaAUITWnQuo0', 6, '2020-11-04 08:21:11', '2020-11-10 04:43:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1381, 'o1qmn5E-jQeCi--D6Qzd1LbFtv3I', 5, '2020-11-04 08:21:12', '2020-11-10 15:55:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1382, 'o1qmn5GZ1F7s09GXRtpcl7bJ6rHc', 3, '2020-11-04 08:24:32', '2020-11-04 08:24:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1383, 'o1qmn5O4hXQOnEG_XobEn8PmpkHM', 0, '2020-11-04 08:36:52', '2020-11-04 08:36:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1384, 'o1qmn5GAiXOjSOv1EpR9gtKyXdm8', 0, '2020-11-04 09:12:45', '2020-11-04 09:12:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1385, 'o1qmn5NMSZXx5FEkbkfpCeXiJUCU', 0, '2020-11-04 09:12:48', '2020-11-04 09:12:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1386, 'o1qmn5LxRxolMCQQIw6UclrU4uy0', 0, '2020-11-04 09:12:52', '2020-11-04 09:12:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1387, 'o1qmn5JfX1Q4w4TP9SeJpC0qvj18', 1, '2020-11-04 09:12:56', '2020-11-04 12:25:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1388, 'o1qmn5EKyKI9BfKuZuMuuf9fGQYc', 0, '2020-11-04 09:13:23', '2020-11-04 09:13:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1389, 'o1qmn5KHogNRWDBFJCLaxx9VxJ20', 1, '2020-11-04 09:13:27', '2021-02-12 05:03:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1390, 'o1qmn5COcibQkhOlDIAMUEntxKJY', 0, '2020-11-04 09:13:43', '2020-11-04 09:13:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1391, 'o1qmn5JfM_dLCpt2nnusLJQScgbM', 0, '2020-11-04 09:14:25', '2020-11-04 09:14:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1392, 'o1qmn5B4WlMlthY4wsZqsdwsjS_Q', 2, '2020-11-04 09:14:33', '2020-11-04 12:23:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1393, 'o1qmn5C0RGamyn8S1L31MBdgCOFg', 0, '2020-11-04 09:38:46', '2020-11-04 09:38:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1394, 'o1qmn5KFfE2xxerwxYUvR4Gt2Gio', 2, '2020-11-04 10:18:59', '2020-11-23 11:12:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1395, 'o1qmn5Ekzpa3soe1JEY_4lA2FuKM', 5, '2020-11-04 11:55:17', '2021-02-12 12:02:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1396, 'o1qmn5GkeGka05Op4SyrD2eiuv4w', 2, '2020-11-04 12:03:51', '2020-11-05 15:00:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1397, 'o1qmn5OOY7QEapD4fKqIB78VPQQ0', 3, '2020-11-04 12:12:31', '2021-02-19 23:09:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1398, 'o1qmn5Dhvfy0Bxke_z8eXFkN1fOY', 0, '2020-11-04 12:23:16', '2020-11-04 12:23:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1399, 'o1qmn5FsG0qGuGzKz4nXsdCi9NMI', 2, '2020-11-04 12:23:32', '2020-11-05 15:14:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1400, 'o1qmn5GMKwZLCm1tM90--1dyU-EU', 0, '2020-11-04 12:23:37', '2020-11-04 12:23:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1401, 'o1qmn5DE9E1NRDCgpNwh7NRZoWHY', 1, '2020-11-04 12:24:03', '2021-02-08 11:22:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1402, 'o1qmn5BW-VXi6bsdH_ltpR86HPxQ', 12, '2020-11-04 12:24:12', '2021-02-13 19:11:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1403, 'o1qmn5Mvke475ddmnFvOn4ZCWESE', 0, '2020-11-04 12:24:22', '2020-11-04 12:24:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1404, 'o1qmn5FMYvbGvoU4gdd5VyEZTDf8', 0, '2020-11-04 12:24:25', '2020-11-04 12:24:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1405, 'o1qmn5Og_AKkiKn2C1OUgj9jmvAU', 5, '2020-11-04 12:24:53', '2020-11-05 14:55:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1406, 'o1qmn5JcoUjTUISIg5LOQLrGAfXQ', 0, '2020-11-04 12:24:55', '2020-11-04 12:24:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1407, 'o1qmn5ChCyFE9N95l4RrlOG0VUTg', 0, '2020-11-04 12:25:49', '2020-11-04 12:25:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1408, 'o1qmn5AZUZaQhWw-GItqRoHGVw-8', 1, '2020-11-04 12:25:51', '2020-11-05 14:40:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1409, 'o1qmn5AM1AoCgThY-iWrpra6CTv8', 0, '2020-11-04 12:26:21', '2020-11-04 12:26:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1410, 'o1qmn5DRxol6GhBbihCFWGff8ATo', 0, '2020-11-04 12:41:31', '2020-11-04 12:41:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1411, 'o1qmn5CKaibWWQPCOSGl6aprFe2w', 10, '2020-11-04 13:20:02', '2021-02-19 23:09:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1412, 'o1qmn5HOt2gIB66PYuJIar_BIS2U', 2, '2020-11-04 13:20:18', '2020-11-05 14:48:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1413, 'o1qmn5LCG5YcbY-bxwVannrKPNBo', 3, '2020-11-04 14:26:38', '2020-11-05 15:14:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1414, 'o1qmn5OJ5kASivZlyIbp1WirnBiE', 4, '2020-11-04 14:30:10', '2021-02-14 04:35:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1415, 'o1qmn5NIGomoVkpjPjC7jK85Yaqk', 0, '2020-11-04 14:33:26', '2020-11-04 14:33:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1416, 'o1qmn5E3JwoLD4ZQSQC6YfaYEumU', 0, '2020-11-04 14:35:36', '2020-11-04 14:35:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1417, 'o1qmn5CYW26SmmUQ3E8ptXGS6t_k', 2, '2020-11-04 14:45:51', '2021-01-08 19:27:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1418, 'o1qmn5OJOtcVSPEe2yDhOiJiVzA8', 0, '2020-11-04 14:52:57', '2020-11-04 14:52:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1419, 'o1qmn5M5nxPB9LX7AE0tWl4QunQ4', 4, '2020-11-04 14:55:41', '2021-03-23 13:34:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1420, 'o1qmn5JX9KHUAwyie6-JyqaCB2qI', 1, '2020-11-04 14:58:55', '2020-11-04 22:59:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1421, 'o1qmn5B_VrU49XjIUG3BHkzuKL1c', 0, '2020-11-04 15:08:06', '2020-11-04 15:08:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1422, 'o1qmn5Gk3gU09h-VwCmfWY1TISoU', 5, '2020-11-04 15:10:27', '2020-11-05 14:54:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1423, 'o1qmn5DcOxp0uwIIWFc2j-5855e8', 0, '2020-11-04 15:12:00', '2020-11-04 15:12:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1424, 'o1qmn5JfADFOi87ULTFEgejLLnqE', 5, '2020-11-04 15:13:20', '2021-02-16 09:32:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1425, 'o1qmn5EPyoJA1hicAp_1v__2f6FA', 4, '2020-11-04 15:13:21', '2020-11-05 14:54:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1426, 'o1qmn5DD0tQqF_LlRUK_PvdnTOio', 3, '2020-11-04 15:13:22', '2020-11-04 15:13:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1427, 'o1qmn5DN8-Dl79_yIRoajMKYo9jU', 8, '2020-11-04 15:13:32', '2020-11-10 12:31:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1428, 'o1qmn5CKO_cAoEi9LdXKg2mRY8c4', 13, '2020-11-04 15:13:34', '2021-02-14 11:15:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1429, 'o1qmn5Jh25CXbL-5xdXlFHhyhkeo', 15, '2020-11-04 15:16:38', '2020-11-05 14:39:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1430, 'o1qmn5Fvw4CA68jkHPYfncSW1Q4Y', 2, '2020-11-04 15:16:57', '2020-11-09 07:22:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1431, 'o1qmn5GQpShUxVDCnEyrhYVAwusg', 0, '2020-11-04 15:19:40', '2020-11-04 15:19:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1432, 'o1qmn5H1RKYgKuG-dF80SkyVCEk8', 6, '2020-11-04 15:23:20', '2020-11-07 07:38:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1433, 'o1qmn5FkNxWXgjCLriITu41_UeS8', 0, '2020-11-04 15:42:15', '2020-11-04 15:42:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1434, 'o1qmn5Jw_2Vnky8fFKbBKp5ss9Tk', 6, '2020-11-04 16:11:24', '2021-02-08 13:14:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1435, 'o1qmn5PPKuHn9JgqCbEVPfsBD6Vs', 6, '2020-11-04 16:56:57', '2021-03-19 10:01:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1436, 'o1qmn5B-kuzGZKAA6ndCdjNwmSSA', 2, '2020-11-04 17:03:33', '2020-11-04 17:05:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1437, 'o1qmn5MqF804a_fK2XgDgfOIb6ZQ', 0, '2020-11-04 17:04:45', '2020-11-04 17:04:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1438, 'o1qmn5Lc2ZllgXlrEFDvay3cL8iM', 0, '2020-11-04 17:42:43', '2020-11-04 17:42:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1439, 'o1qmn5OkZu8srcWQebpLceO3lC0s', 0, '2020-11-04 19:28:59', '2020-11-04 19:28:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1440, 'o1qmn5MC1QBYh3BINNxGSDu8zovQ', 0, '2020-11-04 20:55:36', '2020-11-04 20:55:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1441, 'o1qmn5LvXASJh06reH0pgMUhux2A', 0, '2020-11-04 21:00:27', '2020-11-04 21:00:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1442, 'o1qmn5NonCK8cttcHpPZbn5vtDyM', 1, '2020-11-04 21:12:27', '2020-11-06 17:49:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1443, 'o1qmn5BOBcFpf4jqIwAb5MsHHowU', 0, '2020-11-04 23:38:13', '2020-11-04 23:38:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1444, 'o1qmn5K-9mcZOMNtKACmxWnj68xA', 2, '2020-11-05 05:30:50', '2020-11-10 07:01:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1445, 'o1qmn5FfEaooXsaGPrfXkQkHNjco', 1, '2020-11-05 05:33:05', '2020-11-09 07:19:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1446, 'o1qmn5C4wXKEYvhXS9dYb15cyhnE', 0, '2020-11-05 05:47:09', '2020-11-05 05:47:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1447, 'o1qmn5JDZZJ9gnOchaEMtq7LvPz4', 0, '2020-11-05 07:22:57', '2020-11-05 07:22:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1448, 'o1qmn5PNwe5rp47UTKLly1xXPsHQ', 2, '2020-11-05 07:22:58', '2020-11-10 06:44:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1449, 'o1qmn5BX_5W8cew7KX6fwGoy3zCM', 6, '2020-11-05 07:23:42', '2020-11-12 04:16:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1450, 'o1qmn5NOC_Jn6DSH_dupB3gpvH54', 4, '2020-11-05 07:24:01', '2020-11-06 12:18:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1451, 'o1qmn5IsPrvDcEsx6Rk7xKjTsw84', 2, '2020-11-05 07:24:42', '2020-11-13 05:08:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1452, 'o1qmn5HaDcJ4rEONPThzObJ0ixh8', 0, '2020-11-05 08:33:28', '2020-11-05 08:33:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1453, 'o1qmn5NICluo3PWOooaobi_uebNI', 0, '2020-11-05 08:53:29', '2020-11-05 08:53:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1454, 'o1qmn5NkH3fDha-rM_aEcCcnY-W0', 3, '2020-11-05 11:03:35', '2021-02-14 11:24:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1455, 'o1qmn5AoIfSt_yKpEtlhjTgNIGQc', 0, '2020-11-05 11:40:17', '2020-11-05 11:40:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1456, 'o1qmn5Nem2gDTxwW5Bv4dgHd0v0A', 0, '2020-11-05 12:28:30', '2020-11-05 12:28:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1457, 'o1qmn5Ex4e266NUEYxzuRv4ecYO0', 0, '2020-11-05 12:52:46', '2020-11-05 12:52:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1458, 'o1qmn5BnKWCFCMu1zGrDydiQUOOk', 0, '2020-11-05 13:54:34', '2020-11-05 13:54:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1459, 'o1qmn5JsZ4tfD-2iC5Lvn-9OnsmE', 1, '2020-11-05 14:10:22', '2020-11-05 14:25:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1460, 'o1qmn5IrMeeGbgt1-AOV6_MGnBmA', 3, '2020-11-05 14:24:06', '2021-02-13 03:51:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1461, 'o1qmn5Iiu3zdyUZPkANYgJxfiy5k', 1, '2020-11-05 14:24:07', '2021-02-14 01:04:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1462, 'o1qmn5NPTUuvRCtk539QVyTeNtbI', 4, '2020-11-05 14:24:31', '2020-11-13 07:12:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1463, 'o1qmn5GvVFxK3mc6-j4rj_IheJDA', 5, '2020-11-05 14:25:39', '2021-01-29 12:15:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1464, 'o1qmn5AFEb-GfBh9u6jW4wtYkN6s', 2, '2020-11-05 14:25:49', '2020-11-10 07:01:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1465, 'o1qmn5CTmSfJy368fTJ0byWk_Vgs', 1, '2020-11-05 14:25:50', '2020-11-05 14:54:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1466, 'o1qmn5ASqTWMHTGgM9EAnp5ejm5E', 3, '2020-11-05 14:26:01', '2020-11-11 03:15:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1467, 'o1qmn5MmBEedbcjzvFhqqGeVDDc4', 8, '2020-11-05 14:26:36', '2021-02-21 04:49:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1468, 'o1qmn5Pe4CqryrKCVhEFPyrJj4LA', 4, '2020-11-05 14:29:05', '2020-11-12 08:13:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1469, 'o1qmn5PB3febC1TTEBiUiLxBR4i0', 2, '2020-11-05 14:29:07', '2020-11-05 14:41:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1470, 'o1qmn5LeQCie9CbNxNZM_v726Sls', 2, '2020-11-05 14:29:19', '2020-11-10 04:59:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1471, 'o1qmn5CNqe3MHf7i2GSL2nQ7xGP8', 4, '2020-11-05 14:29:31', '2021-02-18 16:10:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1472, 'o1qmn5JCeRs7lyYBYwIfoYKY_MgY', 2, '2020-11-05 14:29:32', '2021-02-14 00:02:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1473, 'o1qmn5O5F0bfkF1LvHq88kLJUJ7E', 3, '2020-11-05 14:29:33', '2020-11-10 06:47:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1474, 'o1qmn5J1pjRpiWPmz1xiNWI1Myis', 2, '2020-11-05 14:29:46', '2020-11-10 04:42:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1475, 'null', 1, '2020-11-05 14:30:03', '2021-01-11 05:37:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1476, 'o1qmn5Nat8QImRVRj369959NlAz4', 2, '2020-11-05 14:30:08', '2020-11-05 15:00:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1477, 'o1qmn5CYhkviq4EKx3HBMAEC5r7o', 1, '2020-11-05 14:30:57', '2020-11-12 08:19:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1478, 'o1qmn5Cf76aBrQ213nEyk4MrIg9I', 1, '2020-11-05 14:31:06', '2020-11-06 07:10:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1479, 'o1qmn5DgWWfYZXHSMUB_q0f4WQxs', 2, '2020-11-05 14:31:12', '2021-02-18 22:54:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1480, 'o1qmn5B-rjzLBz1CV-TVPb6fgt3A', 0, '2020-11-05 14:31:22', '2020-11-05 14:31:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1481, 'o1qmn5Jp4yai5ql0UArFXr3rIuxA', 2, '2020-11-05 14:32:59', '2020-11-06 08:19:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1482, 'o1qmn5FOmZwhSPsekG0jr4tgdOTs', 1, '2020-11-05 14:33:19', '2020-11-08 09:28:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1483, 'o1qmn5GRujo15bv15owpL61cx2qI', 4, '2020-11-05 14:33:55', '2021-02-12 11:07:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1484, 'o1qmn5NxQ2Xjl9vWVaLbdrXjH0lw', 2, '2020-11-05 14:34:05', '2020-11-10 06:29:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1485, 'o1qmn5IaYm8kuV05DBQkukc6-ans', 0, '2020-11-05 14:34:14', '2020-11-05 14:34:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1486, 'o1qmn5B8RgCGBV1b8wFGWJp2mXc4', 1, '2020-11-05 14:34:15', '2020-11-09 08:21:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1487, 'o1qmn5Js7qK16EkHS3G-zxnJ1FH0', 4, '2020-11-05 14:34:15', '2021-02-22 00:14:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1488, 'o1qmn5OsrmNgtqex3usOePLOMd8I', 1, '2020-11-05 14:34:16', '2020-11-06 07:08:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1489, 'o1qmn5K3m7nn0u-0dwm6wO6DIw8Y', 6, '2020-11-05 14:34:35', '2020-11-06 11:15:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1490, 'o1qmn5BH5Vmvy9vGB1KSDNA0vGMo', 1, '2020-11-05 14:36:13', '2020-11-05 14:36:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1491, 'o1qmn5E_CG0nYIR875ZpnZk0fths', 3, '2020-11-05 14:36:14', '2021-02-17 17:05:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1492, 'o1qmn5Lxe0tqyIY-w6gU9JL_cTzc', 1, '2020-11-05 14:36:42', '2020-11-05 14:40:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1493, 'o1qmn5ARBhx00khVSkO6BE72_tUY', 5, '2020-11-05 14:36:48', '2021-02-15 11:47:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1494, 'o1qmn5Kz2kzoJS6Fp-1TP_OHv6BU', 2, '2020-11-05 14:36:54', '2021-02-19 23:05:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1495, 'o1qmn5OAYUVWgJD2n5rN29X2NLDU', 0, '2020-11-05 14:37:35', '2020-11-05 14:37:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1496, 'o1qmn5EphUiyFYkR3gYh90lxkFpM', 1, '2020-11-05 14:38:08', '2021-02-12 17:51:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1497, 'o1qmn5L24_D11Ui7zii_c4NZSoN0', 0, '2020-11-05 14:38:14', '2020-11-05 14:38:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1498, 'o1qmn5PIUGdkHLq3ntMN6fgkXsO8', 2, '2020-11-05 14:38:36', '2020-11-10 06:31:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1499, 'o1qmn5OxMF7ZHp0fWSwsG4ADOPbQ', 2, '2020-11-05 14:38:54', '2020-11-10 07:26:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1500, 'o1qmn5K18wfVqZoVtSwLpmxnx9_c', 3, '2020-11-05 14:38:55', '2020-11-11 03:15:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1501, 'o1qmn5BCKlBDJVTVcfbuNhbcKZY0', 2, '2020-11-05 14:39:32', '2021-02-13 05:02:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1502, 'o1qmn5KQJk4ljLHIuRu45CLXomug', 0, '2020-11-05 14:40:02', '2020-11-05 14:40:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1503, 'o1qmn5K4ONzsl-FDolWjmX8YIyxo', 3, '2020-11-05 14:40:03', '2021-02-17 23:35:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1504, 'o1qmn5CMUhV8rTTbD4qAA_rvyUbI', 3, '2020-11-05 14:40:03', '2020-11-08 09:28:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1505, 'o1qmn5OZluq4OmYiqBC7w_6UPAig', 0, '2020-11-05 14:40:24', '2020-11-05 14:40:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1506, 'o1qmn5C7lYI4h9YyKV3d11U3bfb0', 4, '2020-11-05 14:40:50', '2020-11-06 17:02:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1507, 'o1qmn5C2A9Ec5Bi_h4eL43Bd4gBo', 8, '2020-11-05 14:40:53', '2021-02-16 19:46:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1508, 'o1qmn5NfmLEGW4nuBcSQK7us7mS4', 0, '2020-11-05 14:41:52', '2020-11-05 14:41:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1509, 'o1qmn5DGKcSzAKhoL0iW1v0A47sY', 3, '2020-11-05 14:42:33', '2021-02-19 04:37:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1510, 'o1qmn5Fcmp8-jY0OrqmOND_Y3Tjk', 5, '2020-11-05 14:42:40', '2021-02-16 23:44:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1511, 'o1qmn5Cm-FNPGQxjAF0RqRTRgvJY', 1, '2020-11-05 14:42:45', '2020-11-10 07:30:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1512, 'o1qmn5FrJDlKLWdmIWgyaA77Kf2g', 4, '2020-11-05 14:42:52', '2021-02-17 10:10:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1513, 'o1qmn5LfV9XdV82MdyKOzpPgeTbI', 9, '2020-11-05 14:43:12', '2021-02-22 04:29:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1514, 'o1qmn5GjZLDIx6FpMnfDcwKm0dOs', 2, '2020-11-05 14:43:12', '2020-11-12 03:14:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1515, 'o1qmn5B2ckBb8W4tuaHQptMsfS-M', 1, '2020-11-05 14:43:32', '2020-11-05 14:50:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1516, 'o1qmn5Oo6yFlwu2NYsR-Tqirpcdc', 1, '2020-11-05 14:43:32', '2020-11-11 04:25:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1517, 'o1qmn5BpCvn8GTETqQFJ7xBdykVY', 2, '2020-11-05 14:44:03', '2021-02-14 11:15:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1518, 'o1qmn5BORKC9qjmBZTooa0W_Suts', 0, '2020-11-05 14:45:08', '2020-11-05 14:45:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1519, 'o1qmn5P3lL4SszuOiuXPIWUHuaKw', 1, '2020-11-05 14:45:09', '2021-02-14 22:18:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1520, 'o1qmn5DykHDl4-ke8wW9KzY9cWSs', 2, '2020-11-05 14:46:18', '2020-11-10 07:11:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1521, 'o1qmn5Ppk_rDfO8GpD_ii-V_sw5s', 3, '2020-11-05 14:46:35', '2020-11-12 10:51:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1522, 'o1qmn5NlZcdHQa7z6mPkoWpUyWrU', 1, '2020-11-05 14:46:36', '2020-11-12 04:17:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1523, 'o1qmn5J8fWNGnaWd5APyLKMybj6Y', 1, '2020-11-05 14:46:37', '2020-11-10 06:37:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1524, 'o1qmn5AUVLJJ00KMuONL3r3rbAJs', 1, '2020-11-05 14:46:42', '2021-02-18 23:52:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1525, 'o1qmn5MA15CTi97INi_-FElYOFDc', 15, '2020-11-05 14:46:49', '2020-11-10 06:30:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1526, 'o1qmn5NV6W_hLAkQbGt1eZ7iny_0', 18, '2020-11-05 14:47:04', '2020-11-12 08:16:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1527, 'o1qmn5Ca8kjv5F8TbGfWnmWie2vA', 0, '2020-11-05 14:47:51', '2020-11-05 14:47:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1528, 'o1qmn5Ocx9YSmN2MqOTiO0r2qEXY', 0, '2020-11-05 14:47:59', '2020-11-05 14:47:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1529, 'o1qmn5MVfNVGYlGVKgAJ1MQHfEe4', 0, '2020-11-05 14:48:42', '2020-11-05 14:48:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1530, 'o1qmn5ILJHAgqCTUBU5c9Gs83ZCQ', 2, '2020-11-05 14:49:36', '2020-11-10 07:36:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1531, 'o1qmn5LVOMONZdeDDKCUpoXj5vFA', 1, '2020-11-05 14:54:05', '2021-02-14 11:35:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1532, 'o1qmn5CbN9tflBIQQzVs6yLGDeSw', 1, '2020-11-05 14:57:23', '2021-02-12 20:22:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1533, 'o1qmn5EhvqXgnSihIPK_vevKCyBM', 1, '2020-11-05 14:57:45', '2020-11-10 09:28:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1534, 'o1qmn5F41dC5qz1CrAOgiLPuODqI', 1, '2020-11-05 14:57:47', '2021-02-16 18:01:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1535, 'o1qmn5LznCjVxgL8lnco0EmnSuUc', 7, '2020-11-05 14:57:52', '2021-03-28 08:22:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1536, 'o1qmn5P40FBartefvB3EhmIY2vb8', 0, '2020-11-05 14:58:28', '2020-11-05 14:58:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1537, 'o1qmn5DkviZ-_bY6_1q36d1ytoYY', 2, '2020-11-05 15:00:21', '2020-12-31 13:14:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1538, 'o1qmn5Fs899h6iyibinu4Mkv4mEI', 0, '2020-11-05 15:01:32', '2020-11-05 15:01:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1539, 'o1qmn5D8ckVT45gnoGoozIAG8XzA', 2, '2020-11-05 15:03:01', '2021-03-17 10:45:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1540, 'o1qmn5Ow2bIXITdlnE_Q1sPdVd0Y', 1, '2020-11-05 15:05:50', '2021-02-13 04:07:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1541, 'o1qmn5EYRBZukEts7Hz4hwzDrcgo', 2, '2020-11-05 15:06:25', '2021-02-17 04:19:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1542, 'o1qmn5DvLec2L1lt9zAZF-L2wzoU', 1, '2020-11-05 15:07:23', '2020-11-10 06:26:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1543, 'o1qmn5DMNetSTuweaUdtACf_oGcs', 0, '2020-11-05 15:07:33', '2020-11-05 15:07:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1544, 'o1qmn5B0yOCfjy13qb9PrIKZ8aSs', 0, '2020-11-05 15:07:55', '2020-11-05 15:07:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1545, 'o1qmn5JnF6b4oyGX805ho1R1JGg0', 2, '2020-11-05 15:08:26', '2020-11-09 09:23:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1546, 'o1qmn5JZw1aRyNKjfatJBrX23ulk', 0, '2020-11-05 15:09:11', '2020-11-05 15:09:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1547, 'o1qmn5Cmn5AO-EEf4DllhLeLfYMw', 0, '2020-11-05 15:14:55', '2020-11-05 15:14:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1548, 'o1qmn5OtKmcPFqAjE8gYa1_uLNnU', 4, '2020-11-05 15:28:30', '2020-11-13 06:37:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1549, 'o1qmn5Ge-yUSFJppFNO0hnSmXl18', 3, '2020-11-05 15:47:08', '2020-12-15 15:30:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1550, 'o1qmn5HTFwPTSllIb-o4viWjGJ_o', 20, '2020-11-05 16:10:31', '2021-03-26 12:24:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1551, 'o1qmn5P1ZKhzmoxNjtVZxNY3401o', 11, '2020-11-05 16:28:09', '2021-03-21 11:45:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1552, 'o1qmn5KkdEb-1e7G7I0_ftZ4jtvY', 0, '2020-11-05 16:52:18', '2020-11-05 16:52:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1553, 'o1qmn5CESJNxSfMcoL0xKXarv51Q', 0, '2020-11-05 16:54:12', '2020-11-05 16:54:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1554, 'o1qmn5H2w_pudZqwZzT9GRNz6HUM', 2, '2020-11-05 18:18:42', '2020-12-23 15:38:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1555, 'o1qmn5Bv6OORgTkZg-GN9KqqPMnw', 0, '2020-11-05 18:33:15', '2020-11-05 18:33:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1556, 'o1qmn5PRQX0SoG4SKQyZLdx4nfVU', 1, '2020-11-05 18:33:21', '2020-12-23 16:07:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1557, 'o1qmn5Mti1UI005GHhJ9lbcqVP_I', 2, '2020-11-05 18:33:25', '2020-12-23 16:06:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1558, 'o1qmn5OdSc6NaRtQMoct4u-4_od4', 0, '2020-11-05 19:20:23', '2020-11-05 19:20:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1559, 'o1qmn5AIYcH0kkSENvh2l5bvvqOo', 0, '2020-11-05 19:49:19', '2020-11-05 19:49:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1560, 'o1qmn5A73LWCBDm9QpkRaG3OEx8c', 3, '2020-11-05 22:10:57', '2020-11-06 14:00:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1561, 'o1qmn5JGIMUKyjJQ59sNeOA8Z6LA', 1, '2020-11-06 00:08:47', '2020-12-11 14:20:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1562, 'o1qmn5HNK1TlFyVCdPKTvhW5NkTs', 2, '2020-11-06 05:25:54', '2021-02-16 01:38:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1563, 'o1qmn5OkCdjyJgsxM-N2-gIjz4Ew', 0, '2020-11-06 05:26:56', '2020-11-06 05:26:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1564, 'o1qmn5N8K-Dmg3ewvAJ2S557mkuc', 0, '2020-11-06 06:24:12', '2020-11-06 06:24:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1565, 'o1qmn5CxjsdeNZ2DAv6sTpgjuEhI', 2, '2020-11-06 06:25:44', '2021-02-18 15:00:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1566, 'o1qmn5MflDj_7wsFeRb1h1TInLxw', 1, '2020-11-06 07:07:37', '2020-11-11 05:43:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1567, 'o1qmn5G_MT0b4KXmRRANMAzJqUY4', 1, '2020-11-06 07:09:39', '2020-11-09 08:21:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1568, 'o1qmn5DO4fScGyjNMK88qp-0AQaM', 2, '2020-11-06 07:45:01', '2020-11-07 00:50:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1569, 'o1qmn5ARPb3LdY_3pforbh_WnF1U', 0, '2020-11-06 08:23:57', '2020-11-06 08:23:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1570, 'o1qmn5EWCgNZHXlMpkV8g27YDfI0', 1, '2020-11-06 08:24:49', '2020-11-13 05:38:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1571, 'o1qmn5Kbaf9fHHm1f81HfG_KUCC0', 1, '2020-11-06 08:25:05', '2020-11-10 04:46:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1572, 'o1qmn5Dks9gMR6OZfcEdm3ZAuVZI', 0, '2020-11-06 09:11:21', '2020-11-06 09:11:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1573, 'o1qmn5G9s0F8WTxc5u1Nlpx4_X4k', 4, '2020-11-06 09:16:56', '2020-11-12 08:28:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1574, 'o1qmn5GU3CtKKsEe1s29uzBh1ejs', 1, '2020-11-06 09:18:39', '2021-02-19 23:09:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1575, 'o1qmn5ICopoVcdlBWcDmfHtpge9k', 0, '2020-11-06 09:20:13', '2020-11-06 09:20:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1576, 'o1qmn5Knr-nMy4qCd8AFYAeM6VEQ', 3, '2020-11-06 09:52:51', '2020-11-12 08:18:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1577, 'o1qmn5N72eMZRFmPAgFQPrfusmpo', 14, '2020-11-06 09:55:01', '2020-11-06 09:55:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1578, 'o1qmn5OCn5IoMSvb6n8GTjeL06ls', 3, '2020-11-06 09:59:37', '2020-11-06 09:59:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1579, 'o1qmn5ETLXt1y1AztfYbS2VGx7C8', 6, '2020-11-06 10:15:56', '2020-11-10 05:39:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1580, 'o1qmn5IBuLUGEkAQ8ixL6SVVIHWQ', 4, '2020-11-06 10:28:09', '2021-02-15 12:14:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1581, 'o1qmn5O5hskpyW6w9sXad_4aI904', 0, '2020-11-06 10:32:50', '2020-11-06 10:32:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1582, 'o1qmn5KnOPrhdGEOM8qweioNGMcQ', 15, '2020-11-06 10:52:25', '2021-03-24 14:17:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1583, 'o1qmn5B6GEL9fm4lhQ3aHDhh3Dck', 4, '2020-11-06 11:13:14', '2020-11-12 04:28:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1584, 'o1qmn5BjQJKTzQiW6nnaJhG_ri0A', 0, '2020-11-06 11:13:44', '2020-11-06 11:13:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1585, 'o1qmn5IP94KUy77N_8Yznr7v1FWE', 4, '2020-11-06 11:14:57', '2020-11-06 11:15:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1586, 'o1qmn5PobvFR92M6OMvGbIU38nlo', 5, '2020-11-06 11:16:26', '2021-03-25 09:44:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1587, 'o1qmn5MoMUEvtcGmQDCLPs5DwTJc', 1, '2020-11-06 11:16:34', '2020-12-05 17:55:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1588, 'o1qmn5EdhxNLQFiWnILQOORg4oew', 0, '2020-11-06 11:16:38', '2020-11-06 11:16:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1589, 'o1qmn5JJq_jFpvwSLWNc3cywpHJc', 33, '2020-11-06 11:20:06', '2021-03-26 17:34:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1590, 'o1qmn5FzQWJ_OA8XNxvQuD5aRMe4', 0, '2020-11-06 11:28:39', '2020-11-06 11:28:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1591, 'o1qmn5KHlFASqm_AjAGr-jGB6KOQ', 0, '2020-11-06 11:49:18', '2020-11-06 11:49:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1592, 'o1qmn5Bp2jXVFSUgVa_0YK7e76aA', 0, '2020-11-06 11:51:12', '2020-11-06 11:51:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1593, 'o1qmn5B7SQckisgw89u5Vqeubd6o', 1, '2020-11-06 11:53:17', '2020-11-07 00:36:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1594, 'o1qmn5DfRPvl_U4xeI4zetEZk9_w', 4, '2020-11-06 11:53:34', '2020-11-22 10:08:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1595, 'o1qmn5FnQv56sBKkuUyIELQL22d4', 0, '2020-11-06 11:53:36', '2020-11-06 11:53:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1596, 'o1qmn5PWagtMn3OhSnxLmJqRpCDY', 0, '2020-11-06 11:53:37', '2020-11-06 11:53:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1597, 'o1qmn5MQssB6FRdy2REqqwRIdkP4', 0, '2020-11-06 11:53:37', '2020-11-06 11:53:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1598, 'o1qmn5Pqu3XQA8tVTs1K6mtMRoUk', 0, '2020-11-06 11:53:38', '2020-11-06 11:53:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1599, 'o1qmn5KclQjst3-XgklKsyMzI9T8', 0, '2020-11-06 11:53:38', '2020-11-06 11:53:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1600, 'o1qmn5OdVNP--W2s9pZnwSzwVxsw', 0, '2020-11-06 11:53:39', '2020-11-06 11:53:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1601, 'o1qmn5MsrIrhrjy_cxp1QtcdP4EA', 0, '2020-11-06 11:53:41', '2020-11-06 11:53:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1602, 'o1qmn5CUOKVt0UC8oSYmExD_XVEI', 0, '2020-11-06 11:53:41', '2020-11-06 11:53:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1603, 'o1qmn5IzmDgB2NdziZ2G3TZV3NEM', 0, '2020-11-06 11:53:41', '2020-11-06 11:53:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1604, 'o1qmn5AHw_FmNWv9krmxhZM1cF_k', 1, '2020-11-06 11:53:42', '2020-11-06 11:58:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1605, 'o1qmn5EFdzzCONRfEzia8-L6r7so', 0, '2020-11-06 11:53:42', '2020-11-06 11:53:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1606, 'o1qmn5BT3ItjGdNzjDOeGAK02nJY', 0, '2020-11-06 11:53:43', '2020-11-06 11:53:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1607, 'o1qmn5NsvDbYkIMpT4yNWJFX_7a0', 0, '2020-11-06 11:53:43', '2020-11-06 11:53:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1608, 'o1qmn5D3-xTmw61tBXq_r3Lp4FZ8', 0, '2020-11-06 11:53:43', '2020-11-06 11:53:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1609, 'o1qmn5ODUDpcXL9ZEHuQS08B7Dlw', 0, '2020-11-06 11:53:43', '2020-11-06 11:53:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1610, 'o1qmn5PcT-e6pfsrpE2RXQxR8ViI', 0, '2020-11-06 11:53:44', '2020-11-06 11:53:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1611, 'o1qmn5OttbVoT548ZH1tIl6wjWLE', 1, '2020-11-06 11:53:44', '2020-11-23 19:08:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1612, 'o1qmn5JzEVRRJZkt95q7dpiUmxHs', 0, '2020-11-06 11:53:44', '2020-11-06 11:53:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1613, 'o1qmn5NL-qNGe1T6jh5cWWYP6Zk4', 0, '2020-11-06 11:53:44', '2020-11-06 11:53:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1614, 'o1qmn5GN76ZWCzgWe7yeU9D0vibY', 0, '2020-11-06 11:53:45', '2020-11-06 11:53:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1615, 'o1qmn5IyMMkLK97JKtiNxvE62p78', 0, '2020-11-06 11:53:45', '2020-11-06 11:53:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1616, 'o1qmn5AoDTsSS6cTjlJObqTqhbP0', 0, '2020-11-06 11:53:46', '2020-11-06 11:53:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1617, 'o1qmn5CcKwz9qoUZhUWoo-CNYxj4', 1, '2020-11-06 11:53:48', '2021-02-08 16:12:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1618, 'o1qmn5HoWJOwI9iBaCeYRODMrCy4', 0, '2020-11-06 11:53:48', '2020-11-06 11:53:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1619, 'o1qmn5MomFZl-9MTkGkjyEH3Flzg', 0, '2020-11-06 11:53:48', '2020-11-06 11:53:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1620, 'o1qmn5PnNbmq7WPCG-StYGtV-5Zw', 0, '2020-11-06 11:53:49', '2020-11-06 11:53:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1621, 'o1qmn5AlczcTkSPD0BBl3xSrShPQ', 0, '2020-11-06 11:53:49', '2020-11-06 11:53:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1622, 'o1qmn5AXbX_iuaVjIi_MzrhLfs6E', 0, '2020-11-06 11:53:49', '2020-11-06 11:53:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1623, 'o1qmn5DViIlK6yuAmdjr-BIkNO7Y', 0, '2020-11-06 11:53:50', '2020-11-06 11:53:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1624, 'o1qmn5BZ6IJMe62UvDlrNA2aXnpY', 1, '2020-11-06 11:53:50', '2020-11-06 18:05:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1625, 'o1qmn5Fwn5Feuvj-wgSSxyVAVEDA', 0, '2020-11-06 11:53:50', '2020-11-06 11:53:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1626, 'o1qmn5LWp2e2Eo5cqQ5emd_ObugM', 0, '2020-11-06 11:53:50', '2020-11-06 11:53:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1627, 'o1qmn5JiemAg_BnHWDO9pwx4cJUI', 0, '2020-11-06 11:53:50', '2020-11-06 11:53:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1628, 'o1qmn5NCZZ4bt33T7XQJIfPkLomU', 0, '2020-11-06 11:53:51', '2020-11-06 11:53:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1629, 'o1qmn5Ksmh7byEY0enMJs2h451cw', 0, '2020-11-06 11:53:52', '2020-11-06 11:53:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1630, 'o1qmn5A6ZXWPO1ha8pdwdGQyx7ug', 0, '2020-11-06 11:53:52', '2020-11-06 11:53:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1631, 'o1qmn5LhdTFycTg8ZlYq-Llu_m98', 0, '2020-11-06 11:53:53', '2020-11-06 11:53:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1632, 'o1qmn5KFygKZHlqXrsc1pYkyw77w', 2, '2020-11-06 11:53:53', '2020-12-29 08:10:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1633, 'o1qmn5O4XBnrzF0-jDWo3SMcmhYk', 0, '2020-11-06 11:53:53', '2020-11-06 11:53:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1634, 'o1qmn5GsS3_B6XeAv0UnCLhfk-B0', 0, '2020-11-06 11:53:54', '2020-11-06 11:53:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1635, 'o1qmn5G6G6MyN4af-hMij4xSlH_c', 0, '2020-11-06 11:53:54', '2020-11-06 11:53:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1636, 'o1qmn5PIcdkSONJqOr0R2O9_rfdE', 0, '2020-11-06 11:53:54', '2020-11-06 11:53:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1637, 'o1qmn5Ou8Ppotnqz0NnUnoThmA6E', 0, '2020-11-06 11:53:55', '2020-11-06 11:53:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1638, 'o1qmn5Lmqq-SJO--MwiiPx8ze7CA', 0, '2020-11-06 11:53:56', '2020-11-06 11:53:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1639, 'o1qmn5KSB3rZUEg1OBdEkFmJ2N1c', 0, '2020-11-06 11:53:57', '2020-11-06 11:53:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1640, 'o1qmn5BP6TKGazHwdJPXDIHscPBY', 0, '2020-11-06 11:53:58', '2020-11-06 11:53:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1641, 'o1qmn5NZjjmoHziOTh5QcNYDUVS8', 0, '2020-11-06 11:53:59', '2020-11-06 11:53:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1642, 'o1qmn5IdtzJuRJKg75pOnvwrb_Z4', 0, '2020-11-06 11:54:03', '2020-11-06 11:54:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1643, 'o1qmn5Ng7ty0xW-omPiDnPSN4nag', 0, '2020-11-06 11:54:04', '2020-11-06 11:54:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1644, 'o1qmn5Kqby9r7acrXVHtm2UmTRCU', 0, '2020-11-06 11:54:05', '2020-11-06 11:54:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1645, 'o1qmn5PsjZ4en109QDWUdWeT3FU4', 0, '2020-11-06 11:54:06', '2020-11-06 11:54:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1646, 'o1qmn5MHwEf7rcl8icw8OS-74VLs', 0, '2020-11-06 11:54:10', '2020-11-06 11:54:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1647, 'o1qmn5CnpuMTIT9cQSubXaWKT7us', 0, '2020-11-06 11:54:13', '2020-11-06 11:54:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1648, 'o1qmn5OtZMvokzZm_CUbGGTJpyZ8', 0, '2020-11-06 11:54:22', '2020-11-06 11:54:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1649, 'o1qmn5PYM86cXs1zj0OQXSJJO7bg', 0, '2020-11-06 11:54:23', '2020-11-06 11:54:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1650, 'o1qmn5LDWp1B5Ec8Ob-ZrL-hbvDM', 0, '2020-11-06 11:54:40', '2020-11-06 11:54:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1651, 'o1qmn5IOexxDKmoEFyhdogDCiv8A', 0, '2020-11-06 11:54:48', '2020-11-06 11:54:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1652, 'o1qmn5PkWIBTg0OpsMNl1piBtIg8', 0, '2020-11-06 11:55:25', '2020-11-06 11:55:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1653, 'o1qmn5FLLTGj1LZnebXdNnvq6Tx8', 0, '2020-11-06 11:55:37', '2020-11-06 11:55:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1654, 'o1qmn5IRBbxCha3r4fKH2xZEVI9c', 1, '2020-11-06 11:56:10', '2020-11-06 11:56:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1655, 'o1qmn5NXDPGx90TUaAH1Qc6DLHRc', 0, '2020-11-06 11:56:55', '2020-11-06 11:56:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1656, 'o1qmn5KVdh_YSGpvmE1mYokdHVUM', 0, '2020-11-06 11:57:42', '2020-11-06 11:57:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1657, 'o1qmn5CiM4qxCBuTXBiss-AdJbnA', 2, '2020-11-06 11:58:53', '2020-11-06 16:34:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1658, 'o1qmn5Fg0x1ZpqSbpcCxxkbHtnr4', 0, '2020-11-06 11:59:30', '2020-11-06 11:59:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1659, 'o1qmn5CwtwUelDZKWh6nAH1XV4sk', 2, '2020-11-06 11:59:54', '2020-11-06 13:56:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1660, 'o1qmn5ER9JBHEORca4vsx-cZBHq4', 0, '2020-11-06 12:00:09', '2020-11-06 12:00:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1661, 'o1qmn5Brx-7tiRMzQLs1Vo9GaFXI', 0, '2020-11-06 12:00:27', '2020-11-06 12:00:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1662, 'o1qmn5CDIsWCpe2LqMEOnteb4FFE', 1, '2020-11-06 12:01:50', '2020-11-19 10:25:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1663, 'o1qmn5MDFJZuAO2Rmqsmsb1Xcp7E', 2, '2020-11-06 12:02:13', '2020-11-06 13:10:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1664, 'o1qmn5Eiqlduuy4nWyHtwcXaOnaw', 0, '2020-11-06 12:03:18', '2020-11-06 12:03:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1665, 'o1qmn5NGCGIaZPqsmwRjGfLKTPbM', 0, '2020-11-06 12:07:39', '2020-11-06 12:07:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1666, 'o1qmn5AWEihVMDu1n4u4Nk227PU0', 1, '2020-11-06 12:29:51', '2020-11-07 10:05:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1667, 'o1qmn5OYurPjw361FPTjUadBItG4', 0, '2020-11-06 12:55:11', '2020-11-06 12:55:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1668, 'o1qmn5HFCSZgy33mH9BkSSTwzI9k', 4, '2020-11-06 12:55:18', '2020-11-11 14:59:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1669, 'o1qmn5GpPyH-Aaf_5k6usMpwQUmQ', 0, '2020-11-06 13:54:35', '2020-11-06 13:54:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1670, 'o1qmn5CTzFglW7UqF642qxh5ThMw', 0, '2020-11-06 13:54:50', '2020-11-06 13:54:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1671, 'o1qmn5BthtIF4tkSZ5kYtWhXRDfE', 0, '2020-11-06 13:54:53', '2020-11-06 13:54:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1672, 'o1qmn5NmCDLbsfWkW3lwAJ5fMaTo', 0, '2020-11-06 13:55:04', '2020-11-06 13:55:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1673, 'o1qmn5F0KAKZo-iB9yXVxFE5lYWw', 0, '2020-11-06 13:55:19', '2020-11-06 13:55:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1674, 'o1qmn5I6tJrPgGf9G2hK28XMbScY', 0, '2020-11-06 13:56:01', '2020-11-06 13:56:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1675, 'o1qmn5ElOdrkO9LLfSZc4ZK9i6a0', 0, '2020-11-06 14:01:08', '2020-11-06 14:01:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1676, 'o1qmn5JklrzndAfBuX68rb-rcRHo', 0, '2020-11-06 14:17:48', '2020-11-06 14:17:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1677, 'o1qmn5Gt37jDwb7kZMzILwuk50Rs', 3, '2020-11-06 14:37:18', '2021-03-03 11:11:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1678, 'o1qmn5PqrtTaYL_tQz8DJzY288Qs', 0, '2020-11-06 14:38:19', '2020-11-06 14:38:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1679, 'o1qmn5KhskmzblROCi-XxAIqtN48', 0, '2020-11-06 14:43:00', '2020-11-06 14:43:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1680, 'o1qmn5DVN_4PzFP2Aqv20nRUpbJ0', 0, '2020-11-06 14:53:08', '2020-11-06 14:53:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1681, 'o1qmn5Cv7-m7LBItI_R1c2njYJgg', 3, '2020-11-06 16:17:11', '2021-01-19 08:15:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1682, 'o1qmn5Fr5ABhNcgoB4HRPxk8032w', 0, '2020-11-06 16:23:23', '2020-11-06 16:23:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1683, 'o1qmn5KqmSl3l-yx7R7otkcg0-Ho', 170, '2020-11-06 16:40:47', '2021-03-28 23:39:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1684, 'o1qmn5PdrbIgzuC6-LGVQdZRyu7M', 0, '2020-11-06 16:42:59', '2020-11-06 16:42:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1685, 'o1qmn5JH-GFYjvCcUP3HN1pvPWy0', 1, '2020-11-06 16:49:24', '2021-01-04 12:27:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1686, 'o1qmn5P1lsHIzrYi0r2m0-iRvToA', 8, '2020-11-06 17:09:07', '2021-03-12 09:14:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1687, 'o1qmn5N6RNRsepFeUCJ4-kM6FxkU', 0, '2020-11-06 17:20:40', '2020-11-06 17:20:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1688, 'o1qmn5F2aoeBB1DmumlvLU0o58qU', 0, '2020-11-06 17:36:38', '2020-11-06 17:36:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1689, 'o1qmn5C4by_3fyTrcmT4V973FnQA', 3, '2020-11-06 17:36:52', '2020-11-16 17:44:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1690, 'o1qmn5Pr0J1dqScZRZl_E1RCLUA4', 1, '2020-11-06 18:21:13', '2020-11-18 13:36:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1691, 'o1qmn5LpOkslNnx3LYNOlT-xZV4M', 14, '2020-11-06 18:30:25', '2021-03-26 18:21:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1692, 'o1qmn5PKE2B7pcAmm8TN30tc5yiI', 0, '2020-11-06 20:16:34', '2020-11-06 20:16:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1693, 'o1qmn5IXk9ZXYQYCZBJ8R4JxKy9E', 0, '2020-11-06 21:16:13', '2020-11-06 21:16:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1694, 'o1qmn5ONwcxbLY34Rxdhss6DyJRA', 0, '2020-11-06 21:34:23', '2020-11-06 21:34:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1695, 'o1qmn5K4bLMJaJ2zEk8XGRqKPqlQ', 0, '2020-11-06 23:02:32', '2020-11-06 23:02:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1696, 'o1qmn5MCaoouAHecMew5FQcPc2lM', 0, '2020-11-07 01:04:08', '2020-11-07 01:04:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1697, 'o1qmn5IcM9Abhpnch3VltrysaZCA', 0, '2020-11-07 07:37:13', '2020-11-07 07:37:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1698, 'o1qmn5CCEkLJzcwaceGji2ymy6PQ', 3, '2020-11-07 07:37:52', '2020-11-12 08:28:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1699, 'o1qmn5N9vlQdknNzoDMOmCoS5t9c', 0, '2020-11-07 13:50:01', '2020-11-07 13:50:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1700, 'o1qmn5L-KNYjyYerSQfZFwtSZuzw', 1, '2020-11-07 15:17:55', '2021-03-11 10:47:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1701, 'o1qmn5O_ifGCsOEbkxXSzSsf8tpY', 0, '2020-11-07 15:29:08', '2020-11-07 15:29:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1702, 'o1qmn5KMtiOIUzyqwiMJ-Mh5ITk8', 0, '2020-11-07 15:37:23', '2020-11-07 15:37:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1703, 'o1qmn5LuByf2DeTnluxallSCx61c', 4, '2020-11-07 16:10:52', '2021-01-11 20:35:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1704, 'o1qmn5LNtNdRRj-oUyBiW2LpzxVc', 2, '2020-11-07 16:27:55', '2020-11-17 20:31:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1705, 'o1qmn5H-pWnCruqPzHdqZQlPMOFg', 0, '2020-11-07 17:06:31', '2020-11-07 17:06:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1706, 'o1qmn5LUpmJrV8bLZ-5xT4geTufE', 0, '2020-11-07 20:06:52', '2020-11-07 20:06:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1707, 'o1qmn5N9rSlUQD6MBq3jpkiQSYaI', 0, '2020-11-07 22:04:06', '2020-11-07 22:04:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1708, 'o1qmn5PVduSOkNb3KIsV_7Y6k6bY', 1, '2020-11-08 09:28:22', '2020-11-10 05:15:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1709, 'o1qmn5PUbXGGyL7iLGZLYTzvzXQo', 5, '2020-11-08 10:36:06', '2020-12-16 19:08:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1710, 'o1qmn5KTUo24H8d1HZB78ARThtSQ', 3, '2020-11-08 11:21:38', '2021-03-24 10:17:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1711, 'o1qmn5CITT2j1t2aU3U_Dew0D41Q', 5, '2020-11-08 11:32:18', '2020-12-23 14:51:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1712, 'o1qmn5BUE4OoFwc4t-j6iHJ9Zx6c', 1, '2020-11-08 11:47:09', '2020-11-08 22:21:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1713, 'o1qmn5HPAH8zQFMNm5JbMY97tEn8', 35, '2020-11-08 12:06:54', '2021-03-27 22:54:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1714, 'o1qmn5OdWHJhr42xeLS2eeqbNm70', 3, '2020-11-08 12:08:05', '2020-11-13 09:41:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1715, 'o1qmn5KCxA6HwTY8L0TH0MJUCUzI', 4, '2020-11-08 12:43:59', '2020-11-22 14:31:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1716, 'o1qmn5AHvWjsxxGCDKhb3-jBiEvA', 0, '2020-11-08 16:35:15', '2020-11-08 16:35:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1717, 'o1qmn5JDArgQc39yQoO2rhnnJErs', 3, '2020-11-09 07:19:54', '2021-02-18 07:28:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1718, 'o1qmn5Et1z16CANN2nmtabrwcou4', 3, '2020-11-09 07:21:12', '2021-02-15 00:28:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1719, 'o1qmn5Hm07_7Feb_BDDhSUUMIJhk', 3, '2020-11-09 08:20:46', '2020-11-12 08:21:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1720, 'o1qmn5Nr01S1Lp3NlVgYH2JwbjYg', 7, '2020-11-09 10:18:03', '2021-03-17 20:03:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1721, 'o1qmn5B1W-8NDu6bIyySok07F5is', 0, '2020-11-09 13:36:34', '2020-11-09 13:36:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1722, 'o1qmn5M5KmOG_zVm4fEmdcUZEPC4', 1, '2020-11-09 13:44:12', '2021-03-16 18:07:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1723, 'o1qmn5FBKEEJ2Lo9vPZBimXI83yU', 1, '2020-11-09 13:47:23', '2020-11-13 13:35:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1724, 'o1qmn5PcQUFg_TOJhZ5G2zrs2rek', 1, '2020-11-09 13:48:11', '2020-12-23 16:18:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1725, 'o1qmn5Pv21Ps3c_jJHZOwLUzNVWo', 0, '2020-11-09 14:52:26', '2020-11-09 14:52:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1726, 'o1qmn5F5PN94DxwOQklMISqhaYgQ', 0, '2020-11-09 15:17:07', '2020-11-09 15:17:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1727, 'o1qmn5GT90qq-K4Rct3bhEgHRW7k', 0, '2020-11-09 15:32:15', '2020-11-09 15:32:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1728, 'o1qmn5EjGvVuxc_7K0FjLxjDSq3E', 3, '2020-11-09 16:24:48', '2021-01-12 19:05:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1729, 'o1qmn5CljucCTiNbOWZz_eQ7WIhw', 0, '2020-11-09 16:54:06', '2020-11-09 16:54:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1730, 'o1qmn5PwMRzKoW-h-DT9wvNLOums', 0, '2020-11-09 17:01:55', '2020-11-09 17:01:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1731, 'o1qmn5F4LkmGbaYocM1ZjXTVtz0g', 1, '2020-11-09 17:02:30', '2020-11-09 17:04:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1732, 'o1qmn5GtRIZCIM-Lx8k_zgiUV3dY', 1, '2020-11-09 17:08:24', '2020-11-09 17:09:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1733, 'o1qmn5AOZ0aQa0vbOVL6W_O6EMtM', 0, '2020-11-09 18:06:17', '2020-11-09 18:06:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1734, 'o1qmn5L4RE67FB31kkd1IsVqXHOc', 0, '2020-11-09 18:11:00', '2020-11-09 18:11:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1735, 'o1qmn5GhKBFVwvJtTxpyMAMHLREA', 0, '2020-11-09 18:11:58', '2020-11-09 18:11:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1736, 'o1qmn5NwuM1Zp5q3bU0trn2m-eUA', 2, '2020-11-09 18:15:44', '2020-11-22 11:05:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1737, 'o1qmn5CSFg9c9ojvZjxNdk6v52C4', 0, '2020-11-09 18:41:54', '2020-11-09 18:41:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1738, 'o1qmn5BQs2DF9lYV1w6Ee1RA1LWI', 0, '2020-11-09 19:38:31', '2020-11-09 19:38:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1739, 'o1qmn5EHoGzolM5nmMGURsK19Nmc', 0, '2020-11-09 20:00:11', '2020-11-09 20:00:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1740, 'o1qmn5FUV30EJbJGqTDyP7qdAkm8', 1, '2020-11-09 21:26:10', '2021-03-11 17:22:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1741, 'o1qmn5D-cs-NHng6vxX_ykzIIe_g', 1, '2020-11-09 21:28:01', '2020-11-10 12:38:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1742, 'o1qmn5PYALjzisG7p2-nq8aC7LkA', 0, '2020-11-09 21:28:17', '2020-11-09 21:28:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1743, 'o1qmn5PQI5SbFZ8tfaZGW4tjWz1E', 0, '2020-11-09 21:28:29', '2020-11-09 21:28:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1744, 'o1qmn5CGv-768pFEjJApT946R7Hk', 0, '2020-11-09 21:49:45', '2020-11-09 21:49:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1745, 'o1qmn5M-kKeSdoe-L33mF3Z17c3Y', 0, '2020-11-09 21:58:04', '2020-11-09 21:58:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1746, 'o1qmn5GOsOrSOPbpcZYZyCe_8PrM', 0, '2020-11-09 22:49:20', '2020-11-09 22:49:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1747, 'o1qmn5FH7uL2U-ZECG9FhOD_CYZA', 0, '2020-11-09 22:58:22', '2020-11-09 22:58:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1748, 'o1qmn5LY86Gg-x41-HK8xtZrQy4A', 0, '2020-11-10 03:24:02', '2020-11-10 03:24:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1749, 'o1qmn5J5Z1pbbZPz4duDwgHLvHOk', 1, '2020-11-10 05:04:14', '2021-02-16 01:07:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1750, 'o1qmn5OmxFUUm-qXB1GCgDE8Y6lg', 2, '2020-11-10 05:37:56', '2020-11-11 03:15:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1751, 'o1qmn5NVD-7RrOsuQb5eZMpS_ziU', 4, '2020-11-10 05:51:47', '2021-02-15 04:05:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1752, 'o1qmn5Bof-UOg6_VKan9vtUH_1w4', 0, '2020-11-10 06:27:41', '2020-11-10 06:27:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1753, 'o1qmn5FoQOWX89aoK3mWuhMxpDQs', 3, '2020-11-10 06:29:56', '2021-02-16 22:56:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1754, 'o1qmn5MN97pz-BzrFeb8Czk1hEIA', 0, '2020-11-10 06:52:20', '2020-11-10 06:52:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1755, 'o1qmn5OQN9B0f0QGXkJhZpmwIijY', 0, '2020-11-10 07:30:23', '2020-11-10 07:30:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1756, 'o1qmn5B9m71eg3K9CdXSJD7YCW0Y', 0, '2020-11-10 07:34:51', '2020-11-10 07:34:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1757, 'o1qmn5JLxjO6dFcCpkxe0O-k7JGo', 1, '2020-11-10 08:25:00', '2020-11-10 15:48:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1758, 'o1qmn5Pf94i1x2wMkCHXcCOZhoaA', 3, '2020-11-10 08:46:32', '2020-11-10 08:55:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1759, 'o1qmn5LBsPC7qo-OYlzS7ZktYkK0', 0, '2020-11-10 08:56:00', '2020-11-10 08:56:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1760, 'o1qmn5CIK5tWcjvhqaM74FbqgSrE', 2, '2020-11-10 09:21:54', '2021-02-19 23:09:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1761, 'o1qmn5PcbquQds6j4DfD70oLtwH8', 0, '2020-11-10 09:48:09', '2020-11-10 09:48:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1762, 'o1qmn5ApC6IseoNYENTp3sKgAaJ4', 2, '2020-11-10 10:53:57', '2021-03-05 23:32:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1763, 'o1qmn5AQmYVPc03nvt_-jBPcPbys', 9, '2020-11-10 11:27:51', '2020-12-08 10:58:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1764, 'o1qmn5BqTQJjs1pBmdCcKHEiv3_0', 1, '2020-11-10 11:46:12', '2021-01-30 08:24:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1765, 'o1qmn5O26Hva3TmwqUUHTo4H339Q', 3, '2020-11-10 15:22:12', '2021-03-18 09:50:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1766, 'o1qmn5PQmhr-4nPyLcFbGr6-c1ms', 2, '2020-11-10 15:24:37', '2021-03-26 09:07:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1767, 'o1qmn5PlGGVRgHgAq43skJHFoAVs', 0, '2020-11-10 16:24:52', '2020-11-10 16:24:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1768, 'o1qmn5AZcF4HHClHUTbMgqFBKV00', 3, '2020-11-10 16:35:26', '2021-03-18 21:47:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1769, 'o1qmn5N4eSm8skInuUlVYn6llDNM', 2, '2020-11-10 17:11:59', '2021-01-25 10:08:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1770, 'o1qmn5DjKaq7qJLMgRTO9l0JS75A', 1, '2020-11-10 17:43:58', '2020-11-14 11:20:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1771, 'o1qmn5OTp5fASTDfKhSXtIyBsE4o', 1, '2020-11-10 18:04:35', '2020-11-11 18:28:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1772, 'o1qmn5Ksu2E18dRTJerEWNir_aeI', 1, '2020-11-10 21:35:07', '2020-12-23 14:43:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1773, 'o1qmn5CfXczxu5VK_qfUdBxMO-ps', 1, '2020-11-10 23:58:07', '2020-11-20 23:03:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1774, 'o1qmn5F5p09AXuX7q-nnPKGOGX84', 0, '2020-11-11 00:17:09', '2020-11-11 00:17:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1775, 'o1qmn5BhZ_3yUheLDObEqPFlbbBI', 2, '2020-11-11 00:21:32', '2020-11-11 00:22:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1776, 'o1qmn5CyuK4T6VzDCO6B5fSLtAjo', 0, '2020-11-11 00:49:32', '2020-11-11 00:49:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1777, 'o1qmn5CZCISIUUSMOHyg1OtwsD4A', 0, '2020-11-11 00:57:42', '2020-11-11 00:57:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1778, 'o1qmn5CCQiRNfERi_IQQsjs67_Fg', 0, '2020-11-11 01:11:21', '2020-11-11 01:11:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1779, 'o1qmn5NUbFjfkfTHSoCvKne18XHw', 1, '2020-11-11 04:22:30', '2021-02-16 09:53:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1780, 'o1qmn5BryWcOf7jthfAA-8iurrFg', 0, '2020-11-11 07:11:02', '2020-11-11 07:11:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1781, 'o1qmn5DQ2WyLxqnT6sMn5DudSKVo', 0, '2020-11-11 07:26:37', '2020-11-11 07:26:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1782, 'o1qmn5F4hUjltwvuviVi17hijkF0', 0, '2020-11-11 08:34:13', '2020-11-11 08:34:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1783, 'o1qmn5JjMHzmDC3ULpQiyfDEwq2g', 0, '2020-11-11 09:33:41', '2020-11-11 09:33:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1784, 'o1qmn5DjTmUQsyHHAumgQQW0QwjU', 4, '2020-11-11 10:10:52', '2021-02-22 18:21:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1785, 'o1qmn5L4Tou3g60pst780l6lGSFo', 0, '2020-11-11 10:32:49', '2020-11-11 10:32:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1786, 'o1qmn5EoScZJPF0ARY-OUvm5Ceus', 1, '2020-11-11 10:44:39', '2020-11-16 13:12:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1787, 'o1qmn5LBwR2hPPWkT43QVPHht-hM', 2, '2020-11-11 10:55:54', '2021-03-11 14:09:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1788, 'o1qmn5BvwI0uAMN2zwSiByzVgI1E', 1, '2020-11-11 10:56:12', '2020-11-11 11:01:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1789, 'o1qmn5DWEk6TSNP89jIQm7QCUpsY', 2, '2020-11-11 10:57:15', '2021-03-11 14:09:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1790, 'o1qmn5FkFzV5lgDfPd-SIBVhT-DI', 6, '2020-11-11 10:57:43', '2020-12-21 14:45:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1791, 'o1qmn5AwHC7bDjQ1KMtGcj1B6J-Q', 0, '2020-11-11 11:14:56', '2020-11-11 11:14:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1792, 'o1qmn5CULIhsSBP--hnNjUok-d6k', 0, '2020-11-11 11:37:39', '2020-11-11 11:37:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1793, 'o1qmn5EQ-5IIKlJF1PJE3-B84U4o', 0, '2020-11-11 14:16:42', '2020-11-11 14:16:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1794, 'o1qmn5LH2c1JQb85A6xnPZrGH7NY', 0, '2020-11-11 18:32:54', '2020-11-11 18:32:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1795, 'o1qmn5COcrBtIFynDEa9zHS2ndSY', 0, '2020-11-11 18:37:45', '2020-11-11 18:37:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1796, 'o1qmn5IiPJBFMuG2_GvZUr3tDhUA', 0, '2020-11-11 22:50:39', '2020-11-11 22:50:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1797, 'o1qmn5NBPo5NYl_7a2p9bEVYDqrk', 0, '2020-11-11 23:23:31', '2020-11-11 23:23:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1798, 'o1qmn5JkLzHK21jbGXjK7tViqpo4', 0, '2020-11-12 03:14:49', '2020-11-12 03:14:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1799, 'o1qmn5EXdpbEGaAl0qz4xHcwjIV4', 0, '2020-11-12 04:15:31', '2020-11-12 04:15:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1800, 'o1qmn5KBK2r6VAOQtyiSbrIASPk8', 3, '2020-11-12 04:15:39', '2021-02-12 11:50:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1801, 'o1qmn5DCoGADnbllnHlI2gaBCGPk', 2, '2020-11-12 04:16:04', '2021-02-18 05:30:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1802, 'o1qmn5CdED4hdSuKoD5AxX1ulG2Q', 3, '2020-11-12 08:33:55', '2021-02-17 11:55:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1803, 'o1qmn5BLYocqpVSj2X4jkB2HooCA', 3, '2020-11-12 09:41:02', '2020-12-10 14:07:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1804, 'o1qmn5JZtGgnQQ8BcdChxZdoLZzM', 9, '2020-11-12 09:41:08', '2021-03-27 14:21:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1805, 'o1qmn5NaD00DwpXJEvEKvo-hykqY', 0, '2020-11-12 10:14:35', '2020-11-12 10:14:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1806, 'o1qmn5CtqcH98RvtZWVRWf-BC-AQ', 3, '2020-11-12 10:46:04', '2021-02-21 14:58:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1807, 'o1qmn5AbEm6dzxL6L6r3PHTtfrcU', 2, '2020-11-12 10:47:15', '2020-12-15 17:44:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1808, 'o1qmn5PvNKv-UjvGheQeKfAUfDT8', 0, '2020-11-12 11:44:39', '2020-11-12 11:44:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1809, 'o1qmn5AAVD0zrKLRS5WuC7OOGI1Y', 0, '2020-11-12 11:46:50', '2020-11-12 11:46:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1810, 'o1qmn5Ksqf5R7XavdIhHdLu02R9Y', 0, '2020-11-12 11:50:03', '2020-11-12 11:50:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1811, 'o1qmn5FCdEfvd9QgNvb5QVK0piYA', 15, '2020-11-12 12:13:56', '2021-03-29 10:24:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1812, 'o1qmn5MR7ci_A_mnZUPwml4-Lkp4', 1, '2020-11-12 12:44:41', '2020-12-12 14:08:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1813, 'o1qmn5Mt6isMA7uglkWcjKVCoyio', 0, '2020-11-12 13:26:36', '2020-11-12 13:26:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1814, 'o1qmn5B7sn4bvEbNdKKCFdXffJ5I', 0, '2020-11-12 13:39:18', '2020-11-12 13:39:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1815, 'o1qmn5EU6LQMTESQsnC6m9orKBVw', 0, '2020-11-12 13:43:27', '2020-11-12 13:43:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1816, 'o1qmn5OAT9yhpzZBpREBnvTRBNb0', 1, '2020-11-12 14:24:42', '2020-11-19 11:29:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1817, 'o1qmn5MZEhBCOOpPVu_ePZ4DwB7k', 2, '2020-11-12 14:51:19', '2020-11-15 19:15:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1818, 'o1qmn5AQd-mYpzNKhfgR33lK_ink', 1, '2020-11-12 15:38:31', '2020-11-12 15:39:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1819, 'o1qmn5H6L21PVhdxCRhHsqLOAj4A', 0, '2020-11-12 16:12:29', '2020-11-12 16:12:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1820, 'o1qmn5BaLtFLWapKRRq5CDSoBoGE', 0, '2020-11-12 19:39:17', '2020-11-12 19:39:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1821, 'o1qmn5KhHHbR1csgsR7cdHpHlycs', 0, '2020-11-12 20:43:57', '2020-11-12 20:43:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1822, 'o1qmn5EPpFomkklu3kTjRK00ch5M', 0, '2020-11-13 08:23:59', '2020-11-13 08:23:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1823, 'o1qmn5FcyFUdXPUmxF3_L356W3Ks', 0, '2020-11-13 08:42:13', '2020-11-13 08:42:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1824, 'o1qmn5Ln3hzYX9dtpKs8VSLY6ZiE', 0, '2020-11-13 08:49:10', '2020-11-13 08:49:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1825, 'o1qmn5Fy_V18Rq0QVh8rycot5VrI', 0, '2020-11-13 08:49:12', '2020-11-13 08:49:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1826, 'o1qmn5KPGLauSehiRUWpLIpYJKyQ', 1, '2020-11-13 09:33:08', '2020-11-14 06:52:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1827, 'o1qmn5DGhJnGzoTpgqFL5qd4mLH8', 4, '2020-11-13 09:39:37', '2020-11-13 09:46:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1828, 'o1qmn5AFbDCXP3mvoVY6eGCiblnY', 1, '2020-11-13 09:43:28', '2020-11-13 09:44:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1829, 'o1qmn5L6ykeiVkHkZkIyw8TcOvM4', 1, '2020-11-13 09:43:40', '2020-11-13 09:57:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1830, 'o1qmn5FhWWokN0RgYsQlWBinlxTk', 2, '2020-11-13 09:44:39', '2021-01-17 16:56:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1831, 'o1qmn5L8yqNJTDT6ujWrKcr6jJdI', 0, '2020-11-13 09:47:03', '2020-11-13 09:47:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1832, 'o1qmn5KLkbWbMc15QbG1csfSkJ6s', 0, '2020-11-13 09:51:43', '2020-11-13 09:51:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1833, 'o1qmn5A-ngg2p0iZy004aY8zsByo', 1, '2020-11-13 09:52:22', '2020-11-13 09:53:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1834, 'o1qmn5LyCcBoTj5vhoDkBOmyM6sE', 4, '2020-11-13 09:52:24', '2021-01-22 16:14:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1835, 'o1qmn5GRwkN56smg2fQdhTF3b_J4', 1, '2020-11-13 09:52:26', '2021-03-25 22:04:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1836, 'o1qmn5AFJzkLKMBoOAB8ihGzfqiw', 0, '2020-11-13 09:52:35', '2020-11-13 09:52:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1837, 'o1qmn5AUhRTCnLvxvblTDhU6ZNoY', 1, '2020-11-13 09:54:18', '2021-01-09 14:19:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1838, 'o1qmn5NUSdc928q5e19mtOGBygiI', 0, '2020-11-13 10:26:01', '2020-11-13 10:26:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1839, 'o1qmn5EmfD_7Zr0s5mAZhWkZ7Ias', 0, '2020-11-13 10:59:38', '2020-11-13 10:59:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1840, 'o1qmn5Ie-F_uxcPFcSbfHYfxwUrw', 1, '2020-11-13 11:03:31', '2020-11-15 13:02:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1841, 'o1qmn5Ge-sDb893hLqLGdSNTNpC8', 0, '2020-11-13 11:16:28', '2020-11-13 11:16:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1842, 'o1qmn5D-xvNY_wAVG8j5W5oaTT-c', 0, '2020-11-13 11:38:29', '2020-11-13 11:38:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1843, 'o1qmn5JBbYFUGzXXkqv5QtLfxFJU', 0, '2020-11-13 12:12:49', '2020-11-13 12:12:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1844, 'o1qmn5O9e686S2HxN1lc3wxDoaPw', 0, '2020-11-13 13:24:59', '2020-11-13 13:24:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1845, 'o1qmn5L8_AOQBKaDYprwAuGRv57I', 0, '2020-11-13 15:00:51', '2020-11-13 15:00:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1846, 'o1qmn5GcJOHwhye5RH15rWMb75Yc', 1, '2020-11-13 15:15:01', '2020-11-13 15:34:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1847, 'o1qmn5EHswWdPfgFWX8VLFyVbd28', 0, '2020-11-13 16:53:03', '2020-11-13 16:53:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1848, 'o1qmn5CEnWWS-PsEMwhcNgawR8xQ', 0, '2020-11-13 19:47:42', '2020-11-13 19:47:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1849, 'o1qmn5PnszlyPVBJRr_-UlaugcvU', 0, '2020-11-14 05:51:17', '2020-11-14 05:51:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1850, 'o1qmn5N0qTsZ5zpkGogGcymdAObo', 1, '2020-11-14 09:41:34', '2020-11-19 22:59:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1851, 'o1qmn5AnX5UdWo0obutQsBbZOV98', 0, '2020-11-14 14:02:43', '2020-11-14 14:02:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1852, 'o1qmn5C8eJf8QSlamXjYlRubu23Y', 0, '2020-11-14 14:40:32', '2020-11-14 14:40:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1853, 'o1qmn5E3aht-9iYa9qOwb72GkYHg', 0, '2020-11-14 14:50:47', '2020-11-14 14:50:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1854, 'o1qmn5LRDPJPcxH5XKlZ2WRYpoag', 0, '2020-11-14 15:14:55', '2020-11-14 15:14:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1855, 'o1qmn5PpQJ0uKS_rob-sy_vb5F3E', 1, '2020-11-14 15:56:41', '2020-11-14 16:02:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1856, 'o1qmn5KLoSz0ic_KbPWRGJ0Yyj2Q', 1, '2020-11-14 16:14:34', '2020-11-15 09:39:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1857, 'o1qmn5Db7BCsNiCupc-tquv5qxIQ', 1, '2020-11-14 20:13:47', '2020-12-02 11:43:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1858, 'o1qmn5DoXH2gZPe-aIVxqWAHS0TM', 14, '2020-11-14 21:29:18', '2021-03-19 13:58:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1859, 'o1qmn5NY-UGTAoAVtODzVLOaWV_k', 4, '2020-11-15 09:28:23', '2020-12-24 14:18:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1860, 'o1qmn5Pa1vHAwGIpPGGgJEcVZKB4', 1, '2020-11-15 09:41:53', '2020-11-16 12:10:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1861, 'o1qmn5KGb3jk6JujFg-v-Tl50ZVo', 0, '2020-11-15 11:13:29', '2020-11-15 11:13:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1862, 'o1qmn5Ka6NN1rdVrYMYGB5VKj8gg', 6, '2020-11-15 11:15:26', '2020-11-23 09:08:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1863, 'o1qmn5GpdfjuPAVpccfpGkhvsX4Y', 2, '2020-11-15 11:17:35', '2020-11-18 06:34:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1864, 'o1qmn5BmUhlcoqfLU_BmUVEAMFfg', 0, '2020-11-15 11:21:04', '2020-11-15 11:21:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1865, 'o1qmn5LiffgmBY6c7HwJOKRDAgLg', 12, '2020-11-15 11:30:45', '2021-03-20 11:36:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1866, 'o1qmn5P4IcPmUnmuZ-KMR-UccYro', 3, '2020-11-15 14:47:17', '2021-01-26 15:48:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1867, 'o1qmn5ExiZm8YX1d45mlqH5qhuNI', 0, '2020-11-15 14:48:43', '2020-11-15 14:48:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1868, 'o1qmn5IybbcxS-18f1xpq1nDtjKo', 0, '2020-11-15 16:21:15', '2020-11-15 16:21:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1869, 'o1qmn5Pe4GAHMy-YLIkuV9KeKX6M', 0, '2020-11-15 19:22:30', '2020-11-15 19:22:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1870, 'o1qmn5Ckurj6JvdvjBjnW28QwKhM', 4, '2020-11-15 19:29:50', '2020-11-28 17:46:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1871, 'o1qmn5K_3iOZplVqb0eUHxP9KNjA', 0, '2020-11-15 21:31:41', '2020-11-15 21:31:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1872, 'o1qmn5OfRC5cVb_xhBHMGH-LER5I', 0, '2020-11-16 05:34:11', '2020-11-16 05:34:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1873, 'o1qmn5Jx_2oAw9opkRKI8v9DOwKY', 0, '2020-11-16 08:53:36', '2020-11-16 08:53:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1874, 'o1qmn5AvJuJ2qtkuohH6DH9_keIA', 1, '2020-11-16 12:26:29', '2021-03-11 23:48:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1875, 'o1qmn5GW9yjDodLQv70KUqesAPwY', 0, '2020-11-16 13:18:48', '2020-11-16 13:18:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1876, 'o1qmn5EYknu_kvh6sqsK-SeRRJCY', 0, '2020-11-16 14:29:40', '2020-11-16 14:29:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1877, 'o1qmn5JsIdMisgsj2GAQzt1vJfbA', 0, '2020-11-16 14:46:57', '2020-11-16 14:46:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1878, 'o1qmn5JYlOFinRwFYw96FHvouWjM', 0, '2020-11-16 16:40:42', '2020-11-16 16:40:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1879, 'o1qmn5DG5iJfZvd81xiciiEctBK0', 2, '2020-11-16 16:55:36', '2021-03-01 10:01:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1880, 'o1qmn5KJgWnSNHXWZxR0HVXgGxkI', 0, '2020-11-16 17:16:54', '2020-11-16 17:16:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1881, 'o1qmn5GCAB7hslgo75CCymfbUVyI', 0, '2020-11-17 03:23:07', '2020-11-17 03:23:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1882, 'o1qmn5DyYi02Ezbvd9pPaqBdt0TE', 0, '2020-11-17 03:24:13', '2020-11-17 03:24:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1883, 'o1qmn5HGEsGh7sp62PRH0kq90kv8', 0, '2020-11-17 03:40:25', '2020-11-17 03:40:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1884, 'o1qmn5Oihod7Kb2810IFh2sr2uuo', 1, '2020-11-17 04:17:22', '2021-02-24 07:56:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1885, 'o1qmn5FlVefFKe-oW_-TedOVSDOk', 1, '2020-11-17 04:18:15', '2021-02-24 09:06:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1886, 'o1qmn5Goqlh-qDOEbGLlo74mdr_I', 0, '2020-11-17 04:18:44', '2020-11-17 04:18:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1887, 'o1qmn5BZGiF_V0c_RbhJy2cXXLEQ', 0, '2020-11-17 04:18:48', '2020-11-17 04:18:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1888, 'o1qmn5IbDABWCN4J-nMim3QDVUhk', 0, '2020-11-17 04:28:38', '2020-11-17 04:28:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1889, 'o1qmn5Ojz2PMMYsjuj48hzyyKa00', 1, '2020-11-17 05:24:39', '2021-02-23 05:31:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1890, 'o1qmn5MTL-fsFpS_NZ6VBfIWnIK8', 28, '2020-11-17 07:34:56', '2021-03-17 13:34:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1891, 'o1qmn5HVcVIDfTc0pJQHXP7Pegqs', 2, '2020-11-17 09:05:43', '2021-02-25 08:21:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1892, 'o1qmn5OlN2weY_ld-ke6Jj5U-R18', 1, '2020-11-17 09:09:34', '2020-11-17 09:22:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1893, 'o1qmn5ArnxxY45rpjyTuOdw0L0SU', 0, '2020-11-17 09:10:26', '2020-11-17 09:10:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1894, 'o1qmn5GoovxSSPeBo3nWCm15Q-ag', 0, '2020-11-17 09:13:56', '2020-11-17 09:13:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1895, 'o1qmn5CiGZuyuSpn1ml4n9gSiksQ', 0, '2020-11-17 09:15:02', '2020-11-17 09:15:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1896, 'o1qmn5O0649jcG_mhCmxfZW1JE_M', 0, '2020-11-17 09:18:09', '2020-11-17 09:18:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1897, 'o1qmn5NuQT21nT4r1FStMZN4rxmE', 0, '2020-11-17 09:18:37', '2020-11-17 09:18:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1898, 'o1qmn5AECzS-D_-ALDlQy4dGlbnI', 0, '2020-11-17 09:25:34', '2020-11-17 09:25:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1899, 'o1qmn5FHXS-tg5_GBk-6V5sv_6N0', 0, '2020-11-17 09:33:42', '2020-11-17 09:33:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1900, 'o1qmn5K9z7OETY1bkuB-nvCoLF1A', 1, '2020-11-17 09:40:11', '2020-12-05 20:56:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1901, 'o1qmn5Jv6HpeY31A7H-fVisM6Wcw', 0, '2020-11-17 09:47:47', '2020-11-17 09:47:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1902, 'o1qmn5HeVSze_PoKbXsaPm57rYTk', 1, '2020-11-17 10:23:39', '2021-02-20 11:57:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1903, 'o1qmn5D--hGg-_KSvpo2Cjc_abSk', 4, '2020-11-17 12:32:57', '2020-12-17 15:07:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1904, 'o1qmn5IFXB0e2hBG1KLGkOT1XFEM', 1, '2020-11-17 12:49:53', '2020-11-26 16:39:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1905, 'o1qmn5DV0qmyrUsxZkUBu6YFLuD8', 1, '2020-11-17 14:35:08', '2020-11-24 15:50:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1906, 'o1qmn5Mxhjd9KZu9PBClc7kxTPYE', 6, '2020-11-17 16:13:27', '2021-03-28 15:41:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1907, 'o1qmn5BD7njKFYXPNahzEhWRa1Fw', 0, '2020-11-17 20:32:04', '2020-11-17 20:32:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1908, 'o1qmn5HQxmPavtmm9P8bLYEUOpHE', 6, '2020-11-17 20:51:49', '2020-12-16 17:04:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1909, 'o1qmn5Cxh1Z0rLb8uWUr0Fo6PICE', 0, '2020-11-17 20:58:57', '2020-11-17 20:58:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1910, 'o1qmn5OAALSSXpmgBSvtmsdHMG0Y', 0, '2020-11-18 03:18:35', '2020-11-18 03:18:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1911, 'o1qmn5MpxM9qhnbJgN8LMmHgAQh8', 15, '2020-11-18 03:28:22', '2021-02-24 08:22:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1912, 'o1qmn5AboCmH4Baenp4VJ_Wr8GkU', 0, '2020-11-18 05:20:14', '2020-11-18 05:20:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1913, 'o1qmn5Ik3otYWwJ9Po27istqHeOw', 1, '2020-11-18 05:20:33', '2021-02-27 05:56:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1914, 'o1qmn5CVi77k5tX1LtiNssgS6H-U', 0, '2020-11-18 05:20:34', '2020-11-18 05:20:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1915, 'o1qmn5EAw4kzqsSWNJR4sAxhCa-Q', 0, '2020-11-18 05:20:39', '2020-11-18 05:20:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1916, 'o1qmn5PlQobH6dlv0-6s5837uZwQ', 0, '2020-11-18 05:21:44', '2020-11-18 05:21:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1917, 'o1qmn5EG4LvORO-BDC47sc9z9J-g', 0, '2020-11-18 05:22:02', '2020-11-18 05:22:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1918, 'o1qmn5FlcFWTVQvN4d_KnDOeehfk', 0, '2020-11-18 05:24:52', '2020-11-18 05:24:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1919, 'o1qmn5F1He0fG7K87lIQ7nd6FDCA', 0, '2020-11-18 05:59:36', '2020-11-18 05:59:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1920, 'o1qmn5AppATq2bH9523wMADAiA-k', 8, '2020-11-18 11:21:42', '2021-03-23 12:09:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1921, 'o1qmn5P0V-OHrP9MQMN8czS2T2F8', 8, '2020-11-18 11:23:16', '2021-03-13 14:08:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1922, 'o1qmn5DkvbOci0S0l1ZbDw3cKTpg', 1, '2020-11-18 11:37:32', '2020-12-05 12:33:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1923, 'o1qmn5IXug9derkJULgvBAfz5QGQ', 10, '2020-11-18 13:02:28', '2021-03-09 15:01:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1924, 'o1qmn5NKTdXux8RyfmToC4LFOGk8', 0, '2020-11-18 16:59:39', '2020-11-18 16:59:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1925, 'o1qmn5BQC1dNgrYkyPcE0IirwHew', 0, '2020-11-18 20:52:03', '2020-11-18 20:52:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1926, 'o1qmn5OHlakWb9Ll2chI8DZLZ09I', 0, '2020-11-18 23:08:37', '2020-11-18 23:08:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1927, 'o1qmn5FQEfdeoLZx01jmA6xUnDUM', 13, '2020-11-19 03:05:06', '2020-11-19 03:05:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1928, 'o1qmn5H994yTEuhk4Kt2nMeaHobg', 1, '2020-11-19 03:50:16', '2020-11-21 02:19:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1929, 'o1qmn5KDixwvzpEhBQq-tFgzP680', 0, '2020-11-19 08:47:21', '2020-11-19 08:47:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1930, 'o1qmn5EGxEuU6QQxhTM8rJnCfmD8', 0, '2020-11-19 08:59:07', '2020-11-19 08:59:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1931, 'o1qmn5KGyogN3MyzZy-ZQToyTR-w', 10, '2020-11-19 09:14:43', '2021-03-18 23:02:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1932, 'o1qmn5MoIiNq3ytBkKI45a6eSD-4', 0, '2020-11-19 09:23:07', '2020-11-19 09:23:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1933, 'o1qmn5IXbZfzcNJpycHZATHQpvxk', 0, '2020-11-19 09:55:29', '2020-11-19 09:55:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1934, 'o1qmn5M-f5eui5aJPtcR89lc3MLs', 0, '2020-11-19 10:14:10', '2020-11-19 10:14:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1935, 'o1qmn5OP4JZgzlC2Qkcyf3XE1_io', 0, '2020-11-19 11:11:07', '2020-11-19 11:11:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1936, 'o1qmn5N2d2l17_QiBAKFNDtPyE7I', 3, '2020-11-19 11:27:00', '2020-11-22 16:57:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1937, 'o1qmn5Fw1pz6OO2EqE0XVwkYoxyY', 0, '2020-11-19 11:33:06', '2020-11-19 11:33:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1938, 'o1qmn5N0vgC_73--mEUWqRgdC9JM', 0, '2020-11-19 11:34:28', '2020-11-19 11:34:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1939, 'o1qmn5DorSYvrWsV6z-UUUriFN20', 0, '2020-11-19 12:00:11', '2020-11-19 12:00:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1940, 'o1qmn5LwBQqBeJnHT4zMnW3k8554', 2, '2020-11-19 12:25:01', '2020-11-19 12:27:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1941, 'o1qmn5Bg4gsy2wH86nOXKyqFSkEg', 1, '2020-11-19 12:25:46', '2020-11-22 16:00:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1942, 'o1qmn5Go2-QM7sKdXAx0u8kK2nvw', 0, '2020-11-19 12:54:51', '2020-11-19 12:54:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1943, 'o1qmn5NNp5jc00XvEZC0dpEAWbKQ', 0, '2020-11-19 12:57:01', '2020-11-19 12:57:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1944, 'o1qmn5N0sEDZvr-r-RQ5uu0C4zAE', 0, '2020-11-19 12:57:04', '2020-11-19 12:57:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1945, 'o1qmn5I1KbFOPZl-HewcgqGDhyG8', 1, '2020-11-19 12:57:05', '2020-11-30 17:05:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1946, 'o1qmn5OjGhzT-xzraVQ3xou1W214', 1, '2020-11-19 12:57:26', '2020-11-19 13:46:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1947, 'o1qmn5KELgjn6VipuIVSIT5zSMCE', 0, '2020-11-19 13:23:18', '2020-11-19 13:23:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1948, 'o1qmn5JmlV6lL5TluWmV0Zb9Wdno', 0, '2020-11-19 13:52:03', '2020-11-19 13:52:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1949, 'o1qmn5LbV8FaRUkafA1ge9SValXs', 2, '2020-11-19 14:08:49', '2020-11-26 09:50:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1950, 'o1qmn5Kf6taI5Xcwwk6iCGhTxQAU', 0, '2020-11-19 14:18:24', '2020-11-19 14:18:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1951, 'o1qmn5BkFy2gTM-p8ubUSiyO9fz0', 1, '2020-11-19 14:41:42', '2020-11-19 16:52:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1952, 'o1qmn5Hivymxdy3WxE7croFz_KUE', 0, '2020-11-19 15:07:15', '2020-11-19 15:07:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1953, 'o1qmn5PrdUeUT5F580ngngfZt9EE', 0, '2020-11-19 15:08:50', '2020-11-19 15:08:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1954, 'o1qmn5Og14KdnfxAVAiuVvZMGdog', 0, '2020-11-19 15:59:33', '2020-11-19 15:59:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1955, 'o1qmn5G-kkVKR-O9Nyg2DPdqzEbo', 1, '2020-11-19 20:45:35', '2021-03-22 19:41:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1956, 'o1qmn5DuHnOLiqAFTfBpDNLPnBm4', 4, '2020-11-20 11:13:05', '2021-01-18 10:59:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1957, 'o1qmn5Ibk-UVBiQWAOeYhQugJigg', 3, '2020-11-20 11:33:33', '2021-01-07 17:48:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1958, 'o1qmn5FHMM3i5L9k774bfX49ItsY', 0, '2020-11-20 12:16:35', '2020-11-20 12:16:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1959, 'o1qmn5II7YsqjCpXdDCWS2fKVhjM', 0, '2020-11-20 13:27:07', '2020-11-20 13:27:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1960, 'o1qmn5NcucqhwHf1ciTaTwwRQ2x4', 0, '2020-11-20 15:07:29', '2020-11-20 15:07:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1961, 'o1qmn5Cd6RkO4gaYJlVBNw9chNhs', 0, '2020-11-20 15:53:17', '2020-11-20 15:53:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1962, 'o1qmn5IqZig8fZJouDEe8w12FbT0', 0, '2020-11-20 18:03:26', '2020-11-20 18:03:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1963, 'o1qmn5N2Dunh-e4raLPqX6k7wgG8', 0, '2020-11-20 22:09:26', '2020-11-20 22:09:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1964, 'o1qmn5Ozx_OktRJAsFapMZt-O5kg', 0, '2020-11-20 22:17:12', '2020-11-20 22:17:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1965, 'o1qmn5HIgp6tEO4f04HhPBPJObYo', 0, '2020-11-20 23:58:32', '2020-11-20 23:58:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1966, 'o1qmn5AtGxFHVSMdXdWUZTKqwt0o', 1, '2020-11-21 00:02:28', '2020-11-21 00:02:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1967, 'o1qmn5CDm-F3Shz7RYcFf3wsMOHA', 0, '2020-11-21 00:06:46', '2020-11-21 00:06:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1968, 'o1qmn5IRp-Pli1a8jBaK_PTgZ8zk', 0, '2020-11-21 00:18:48', '2020-11-21 00:18:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1969, 'o1qmn5AdIBUzGStxtdUg7zWxBJCo', 14, '2020-11-21 02:07:18', '2020-11-21 02:08:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1970, 'o1qmn5NI5YBEo_zap69_AWDWP33Q', 14, '2020-11-21 02:15:45', '2020-11-21 02:21:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1971, 'o1qmn5FlYLeSgrZwcEgbLmaLODes', 0, '2020-11-21 02:27:26', '2020-11-21 02:27:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1972, 'o1qmn5HIyqcyAwsd9Qqj1NZhLTHY', 14, '2020-11-21 02:30:44', '2020-11-21 02:31:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1973, 'o1qmn5LLNJ287t8xVQ217pnWyMF4', 1, '2020-11-21 02:35:35', '2020-11-30 22:06:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1974, 'o1qmn5FoznpCCw5mlpo7aIg-qD9c', 7, '2020-11-21 11:35:07', '2020-12-14 13:13:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1975, 'o1qmn5OWyh-KanbCkAHVrtmz8X7g', 0, '2020-11-21 12:46:53', '2020-11-21 12:46:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1976, 'o1qmn5KQYe9sH1fTXWagTAdvs9DQ', 0, '2020-11-21 13:47:04', '2020-11-21 13:47:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1977, 'o1qmn5P6V8j438AE7kayom4VpV1M', 0, '2020-11-21 14:31:24', '2020-11-21 14:31:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1978, 'o1qmn5NinxQ0LYuOZqvpdd10h854', 1, '2020-11-21 14:43:24', '2020-12-19 15:07:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1979, 'o1qmn5J0zeVdpTydj41gtMWln1Rw', 5, '2020-11-21 14:48:13', '2021-02-26 15:32:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1980, 'o1qmn5FNgDUY7CgyZZEKnNU2aDQE', 0, '2020-11-21 15:06:55', '2020-11-21 15:06:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1981, 'o1qmn5I6pL2jQZP_uRgORKkm9JeQ', 0, '2020-11-21 18:14:54', '2020-11-21 18:14:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1982, 'o1qmn5GArZ0vSjyfqYpcHH4CX0r4', 0, '2020-11-21 22:14:33', '2020-11-21 22:14:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1983, 'o1qmn5OVltM_2xAE_km_nzylRHaQ', 2, '2020-11-21 23:04:04', '2021-01-02 23:25:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1984, 'o1qmn5NRqc6ylgZ8iY3R0NP-nlpQ', 0, '2020-11-21 23:14:06', '2020-11-21 23:14:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1985, 'o1qmn5BknkCr2bj4t6l1d1wDnlAM', 0, '2020-11-22 06:45:51', '2020-11-22 06:45:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1986, 'o1qmn5GSAjvOz_uTNPYlXm_ZkF2w', 0, '2020-11-22 11:47:49', '2020-11-22 11:47:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1987, 'o1qmn5Ep4cvUpz2a1VlesIzX28fQ', 0, '2020-11-22 11:51:05', '2020-11-22 11:51:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1988, 'o1qmn5ME9PYM9O9bNyEvuS37CMrQ', 0, '2020-11-22 15:59:59', '2020-11-22 15:59:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1989, 'o1qmn5Pc42ujkZhn7Iejj71MBrPg', 0, '2020-11-22 16:00:04', '2020-11-22 16:00:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1990, 'o1qmn5A7YS5HPMYKsxD_E_dAiH54', 0, '2020-11-22 16:00:18', '2020-11-22 16:00:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1991, 'o1qmn5AycZwjTuf5QoIQUkYfXT8A', 2, '2020-11-22 16:27:31', '2021-02-05 14:14:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1992, 'o1qmn5N-xA1v25sbmeD_ZI0q1xYk', 0, '2020-11-22 20:06:23', '2020-11-22 20:06:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1993, 'o1qmn5NNR9rjvK2_ulGTwv6-mYgA', 0, '2020-11-22 22:27:48', '2020-11-22 22:27:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1994, 'o1qmn5DAFYnbFjhqhSPn-HUYxNzw', 0, '2020-11-23 02:29:12', '2020-11-23 02:29:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1995, 'o1qmn5CCZfy69P-7pk5xPShq8QeM', 14, '2020-11-23 02:34:15', '2021-02-24 05:36:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1996, 'o1qmn5BTlXkjGzVn04TpPtJ4oHxw', 0, '2020-11-23 06:17:57', '2020-11-23 06:17:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1997, 'o1qmn5Pcn95M2QkY33rMjxXlNyts', 0, '2020-11-23 09:57:29', '2020-11-23 09:57:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1998, 'o1qmn5OB3ScJ5cDdFKztJdc_u3Cs', 0, '2020-11-23 11:15:51', '2020-11-23 11:15:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(1999, 'o1qmn5NrjdFRMnutxkwnO4Dnlj4o', 0, '2020-11-23 11:46:14', '2020-11-23 11:46:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2000, 'o1qmn5FWGloldMCRSFzLG4-OrHcM', 7, '2020-11-23 12:32:20', '2020-11-29 16:18:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2001, 'o1qmn5LZ_YyK_b3pc5Hccu6EagU4', 0, '2020-11-23 13:51:34', '2020-11-23 13:51:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2002, 'o1qmn5OqiIFN_NtpqN9o8uY4aI_s', 4, '2020-11-23 14:14:25', '2021-03-12 13:04:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2003, 'o1qmn5ONIOJKIsj-zQdaHzjHxHHE', 0, '2020-11-23 15:36:49', '2020-11-23 15:36:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2004, 'o1qmn5Dq1vsceu4wWWFJg7_7RYxY', 0, '2020-11-23 15:53:29', '2020-11-23 15:53:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2005, 'o1qmn5ADvH1j780m_JFKmEtldLZI', 3, '2020-11-23 15:53:42', '2021-03-02 15:06:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2006, 'o1qmn5LEOwNNHNoYmiBVRe2n3x1M', 2, '2020-11-23 15:57:22', '2020-11-24 09:31:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2007, 'o1qmn5J1hbZnjOPKwuu2SQ6FsQWA', 0, '2020-11-23 15:57:54', '2020-11-23 15:57:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2008, 'o1qmn5Jc1Xppi08o9SvxjALiyf1g', 0, '2020-11-23 15:57:55', '2020-11-23 15:57:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2009, 'o1qmn5PBQyDxVRv7dmJoq8PPpb_g', 1, '2020-11-23 15:58:01', '2020-11-23 16:38:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2010, 'o1qmn5FfKq1yLpD37hSorV5s5c9s', 0, '2020-11-23 15:58:14', '2020-11-23 15:58:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2011, 'o1qmn5OJ8fFdFOaA_uGwGBVlfpuw', 7, '2020-11-23 15:58:20', '2021-01-08 16:42:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2012, 'o1qmn5Gq7Ea0cQT6IhuaJrKTuvxo', 1, '2020-11-23 15:58:45', '2020-11-23 15:59:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2013, 'o1qmn5HJ8lfL4-sTZ2okngsxfir4', 0, '2020-11-23 15:58:58', '2020-11-23 15:58:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2014, 'o1qmn5HdI9CDeqQ69P6x04B8y_Rk', 1, '2020-11-23 15:58:58', '2020-11-23 15:59:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2015, 'o1qmn5Pl2m4CbKVxcvF9h-fuOJ-s', 1, '2020-11-23 15:59:01', '2020-11-23 16:00:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2016, 'o1qmn5DWLMCxjDZBjobIGTgpN_Ao', 2, '2020-11-23 15:59:25', '2020-12-28 11:03:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2017, 'o1qmn5KGLeg_HsVkEM9V7yE1xwvI', 1, '2020-11-23 15:59:44', '2020-11-23 16:37:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2018, 'o1qmn5PTfsGThGMI12Q5Hjoq-25w', 0, '2020-11-23 16:03:52', '2020-11-23 16:03:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2019, 'o1qmn5NQUxqqQqo4qB71TDW3jHRc', 1, '2020-11-23 16:06:27', '2020-11-23 16:07:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2020, 'o1qmn5PTc79dprXIIiwAGqrqjajM', 5, '2020-11-23 17:21:15', '2020-11-26 09:32:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2021, 'o1qmn5Mc4F5lmjpXiVXwr4deZ3ss', 3, '2020-11-23 17:49:08', '2021-03-07 19:56:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2022, 'o1qmn5DsVtIlCK9gtZxyEscHIpMo', 1, '2020-11-23 19:41:22', '2021-03-20 18:59:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2023, 'o1qmn5MxJXcBDo3IKvOGFFfQ2r4M', 2, '2020-11-23 20:56:13', '2020-11-23 21:01:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2024, 'o1qmn5Oun6xNUfai21VtL-qukbSE', 0, '2020-11-23 21:23:53', '2020-11-23 21:23:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2025, 'o1qmn5J1TWGXO7pX9ODz6G9BN_KE', 0, '2020-11-23 21:44:20', '2020-11-23 21:44:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2026, 'o1qmn5Oqk2GvPbjjNiWADZ64u7JE', 1, '2020-11-23 22:16:28', '2020-12-16 11:19:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2027, 'o1qmn5EdD9pN4bk7knRajCCj2yyk', 0, '2020-11-24 04:33:23', '2020-11-24 04:33:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2028, 'o1qmn5C797O55lMP_sbyCIqNUY5Y', 0, '2020-11-24 05:16:46', '2020-11-24 05:16:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2029, 'o1qmn5MCkhgb85Vyp5iiTe0I_aF8', 1, '2020-11-24 05:16:47', '2021-02-24 08:20:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2030, 'o1qmn5Ha8Fn54lBeY_n-qi4fJwKE', 0, '2020-11-24 05:17:03', '2020-11-24 05:17:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2031, 'o1qmn5Ffgr4EmWrwqbaqo33I9kJg', 0, '2020-11-24 05:17:22', '2020-11-24 05:17:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2032, 'o1qmn5Ap4ujzRa26cV41GTW1yByo', 0, '2020-11-24 05:18:17', '2020-11-24 05:18:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2033, 'o1qmn5MHLU0P2Wb4vWZM_M0kVSj0', 0, '2020-11-24 06:22:57', '2020-11-24 06:22:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2034, 'o1qmn5LZUFCDLWHO3dAAlaNPcb4A', 5, '2020-11-24 06:41:04', '2020-11-24 06:41:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2035, 'o1qmn5I6aUr9JDTot3PcwFdhrddY', 0, '2020-11-24 08:23:32', '2020-11-24 08:23:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2036, 'o1qmn5OnajmBOq2IRQUcKew63TZw', 0, '2020-11-24 09:02:13', '2020-11-24 09:02:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2037, 'o1qmn5IZJu7p9tplkC0j34j1AAL8', 0, '2020-11-24 09:06:49', '2020-11-24 09:06:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2038, 'o1qmn5G-kFoZpEka7XTB1D0GOyzk', 1, '2020-11-24 09:35:53', '2020-11-24 09:45:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2039, 'o1qmn5M_hokqcEx-CKOKU_5P1Oy8', 0, '2020-11-24 09:38:33', '2020-11-24 09:38:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2040, 'o1qmn5DazNEOyikY6HkVrmNMSUQ0', 0, '2020-11-24 09:39:37', '2020-11-24 09:39:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2041, 'o1qmn5EHiVAnLNk4Stir1UEoWrzU', 0, '2020-11-24 09:44:24', '2020-11-24 09:44:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2042, 'o1qmn5NOnxE-QTkR3KTXwSVL-4Gk', 0, '2020-11-24 09:45:51', '2020-11-24 09:45:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2043, 'o1qmn5G1bkkGK4wpupvhK50PdeSA', 0, '2020-11-24 09:46:01', '2020-11-24 09:46:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2044, 'o1qmn5BJ3FzoKaNHAUJhqVxNmQsM', 0, '2020-11-24 09:48:12', '2020-11-24 09:48:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2045, 'o1qmn5NNkzqN7DYBC6os077UzGN4', 0, '2020-11-24 09:49:54', '2020-11-24 09:49:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2046, 'o1qmn5Jlm1gqKmgkW56O8sPskjaY', 1, '2020-11-24 09:50:24', '2020-11-27 10:31:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2047, 'o1qmn5MnXCkXffH6ZepMrP2IX-_A', 0, '2020-11-24 09:51:36', '2020-11-24 09:51:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2048, 'o1qmn5FjMk9IzWUJniuYgM4-t-qM', 0, '2020-11-24 10:04:29', '2020-11-24 10:04:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2049, 'o1qmn5Hf7TcrgiEeBWWRWK62XeZY', 0, '2020-11-24 10:08:38', '2020-11-24 10:08:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2050, 'o1qmn5K9O4ivmeVTR00KClQoOrLY', 0, '2020-11-24 10:47:39', '2020-11-24 10:47:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2051, 'o1qmn5J3MLRB3rWGOpYF2FUeCu9A', 1, '2020-11-24 10:48:07', '2020-11-24 11:53:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2052, 'o1qmn5Aia4p2UsicUYWnwSLMgzmo', 0, '2020-11-24 10:53:05', '2020-11-24 10:53:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2053, 'o1qmn5HRSdGHkM3NCCfbrUwQKyK4', 0, '2020-11-24 10:58:57', '2020-11-24 10:58:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2054, 'o1qmn5EzqsIrYH_IK5-yyXqNjDUY', 0, '2020-11-24 11:57:06', '2020-11-24 11:57:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2055, 'o1qmn5BP96Vyo50vWjv_gRCWiQ3A', 0, '2020-11-24 12:06:32', '2020-11-24 12:06:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2056, 'o1qmn5GKvX7L2Q1oE1M7Mg0WajRY', 0, '2020-11-24 12:42:11', '2020-11-24 12:42:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2057, 'o1qmn5Mkz3cq1TpLyT7aAtTZaMUo', 2, '2020-11-24 12:42:34', '2020-12-19 18:58:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2058, 'o1qmn5BM4zc6cE3Ehao3l5Od-K0g', 0, '2020-11-24 13:44:11', '2020-11-24 13:44:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2059, 'o1qmn5ICjPq550tm39zgWo7L4JY8', 1, '2020-11-24 13:58:31', '2020-11-25 18:46:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2060, 'o1qmn5NRg4TOM4rLgu3qh1UvgG4M', 1, '2020-11-24 14:22:47', '2020-11-25 22:49:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2061, 'o1qmn5DtBp98e8toBW_Oh04f78-E', 0, '2020-11-24 14:23:38', '2020-11-24 14:23:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2062, 'o1qmn5D3pGrCzPOBISMx20vWRMhA', 0, '2020-11-24 14:39:38', '2020-11-24 14:39:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2063, 'o1qmn5NXbgYaZxCU8UGdiXvqmC6Q', 0, '2020-11-24 14:41:42', '2020-11-24 14:41:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2064, 'o1qmn5BesUJrZFp78Gg30uMVzj4w', 30, '2020-11-24 14:52:45', '2020-11-26 18:26:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2065, 'o1qmn5GfDKnZt4swuzq92YNI0fiM', 1, '2020-11-24 14:57:31', '2020-11-27 16:06:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2066, 'o1qmn5LHz2Ei8smF01RDzimWBtf8', 2, '2020-11-24 15:02:38', '2020-11-26 00:30:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2067, 'o1qmn5HyEjdL_5bKwpdvonGMr9-A', 0, '2020-11-24 15:06:12', '2020-11-24 15:06:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2068, 'o1qmn5C1gv6q9RALVxkoJxrHJTG0', 1, '2020-11-24 15:07:05', '2020-11-25 23:54:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2069, 'o1qmn5CK7GBohbpuXqATDvnW5KCY', 1, '2020-11-24 15:30:30', '2020-11-25 23:13:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2070, 'o1qmn5H5LLm3ie-b_CRuEPD3Pjss', 1, '2020-11-24 16:31:55', '2020-11-25 23:06:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2071, 'o1qmn5IO_k0YjSAxX5C0jfZX8CW0', 0, '2020-11-24 17:01:39', '2020-11-24 17:01:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2072, 'o1qmn5N9fU6nLY8L322gteXe0t-w', 0, '2020-11-24 17:15:28', '2020-11-24 17:15:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2073, 'o1qmn5E1tHsVg85lwk0wqR77t3mI', 0, '2020-11-24 18:24:40', '2020-11-24 18:24:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2074, 'o1qmn5IYgQBdc1mKlGb-6lKEmfcs', 1, '2020-11-24 18:53:57', '2020-11-24 19:40:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2075, 'o1qmn5OqN2uarI2clC4bJaSAyq5k', 1, '2020-11-24 19:12:38', '2020-11-26 00:56:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2076, 'o1qmn5I4_3hPvL5Hg32Bvu_y_LiU', 1, '2020-11-24 19:18:03', '2021-03-06 05:23:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2077, 'o1qmn5AqfQhNAvNS6L8YyROkE9FI', 3, '2020-11-24 19:20:34', '2021-03-08 04:54:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2078, 'o1qmn5LX_U7LvHwBoyH_qxOk9uv8', 2, '2020-11-24 19:33:20', '2020-11-26 00:06:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2079, 'o1qmn5GnGacL5QK0QYXB0mMmTj2A', 1, '2020-11-24 20:01:05', '2020-11-25 23:55:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2080, 'o1qmn5E54_8GISob5SmSQithUeCQ', 15, '2020-11-24 20:15:14', '2020-11-26 05:26:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2081, 'o1qmn5Bnuy9eMeMGeJ3aEH0qdDAU', 0, '2020-11-24 21:40:15', '2020-11-24 21:40:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2082, 'o1qmn5MV-WxJMCRuocpQnETNXfSw', 0, '2020-11-25 01:27:56', '2020-11-25 01:27:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2083, 'o1qmn5H_vhM8BmewVsY15_w8ivrQ', 0, '2020-11-25 05:56:14', '2020-11-25 05:56:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2084, 'o1qmn5BpvgqkNKFz9iKYV_DqblkY', 0, '2020-11-25 07:44:51', '2020-11-25 07:44:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2085, 'o1qmn5Ffx8jk15F_zBtk3efIPVBk', 0, '2020-11-25 10:48:08', '2020-11-25 10:48:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2086, 'o1qmn5GjK5sbdGauygSEDB2_JzJM', 0, '2020-11-25 10:57:31', '2020-11-25 10:57:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2087, 'o1qmn5CoCzzbpS6PoXdgDsNu6blg', 1, '2020-11-25 11:21:14', '2021-01-19 10:36:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2088, 'o1qmn5Jpk9UR41N7XG1KXJwoew0o', 3, '2020-11-25 11:26:17', '2021-02-02 09:31:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2089, 'o1qmn5EkpN-mehuY6U9ENmm8Fwps', 0, '2020-11-25 11:29:54', '2020-11-25 11:29:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2090, 'o1qmn5MiAQWfvkSqfuP9m37dltBQ', 2, '2020-11-25 11:31:10', '2020-11-26 03:49:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2091, 'o1qmn5E-KJwNf_YnYTf-HwM5pNBM', 0, '2020-11-25 12:19:38', '2020-11-25 12:19:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2092, 'o1qmn5D-fRKJpucZ5MbjIBpPpOmU', 0, '2020-11-25 13:00:42', '2020-11-25 13:00:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2093, 'o1qmn5DpUPgSR10l7F54alLuHGpk', 0, '2020-11-25 13:24:20', '2020-11-25 13:24:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2094, 'o1qmn5IeDsrOfbwBP_j9gbyPJsVQ', 0, '2020-11-25 13:26:33', '2020-11-25 13:26:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2095, 'o1qmn5DhGW2wNsgIWVjZzTMKWqVI', 0, '2020-11-25 14:19:13', '2020-11-25 14:19:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2096, 'o1qmn5GVb6YOKp2ICde9D04MrPVw', 2, '2020-11-25 14:45:23', '2021-01-09 16:24:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2097, 'o1qmn5LDoKXFPWw1VpUbhkIDCtTk', 0, '2020-11-25 15:16:39', '2020-11-25 15:16:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2098, 'o1qmn5O_GA8CfEQPF9hcgw8Wdst8', 2, '2020-11-25 15:40:52', '2020-12-01 15:45:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2099, 'o1qmn5LFpit5H4zX5n6mMrdIX-kw', 2, '2020-11-25 18:12:21', '2020-11-25 19:05:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2100, 'o1qmn5OX_vssRxayJFDIdiLwA34k', 3, '2020-11-25 18:13:36', '2020-11-25 18:33:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2101, 'o1qmn5I3_3o5GQe-Z_XIlImytwcY', 1, '2020-11-25 18:46:59', '2021-03-24 13:12:54', 'https://thirdwx.qlogo.cn/mmopen/vi_32/TmXRGRVvfTK8thMvOU1lQLziaDnUiakG2ibylXVUlicgpqYicAtkz6TQyGcg4Yu5sLRmYT6CMEzjP8qaMNpDVadzHLw/132', '超_越梦想', NULL, NULL, NULL, NULL, 0),
	(2102, 'o1qmn5AelZhIK2fY9AVuIzOMYID0', 0, '2020-11-25 18:51:00', '2020-11-25 18:51:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2103, 'o1qmn5POtmoApbX1HBbOjjuZVr8s', 0, '2020-11-25 18:56:35', '2020-11-25 18:56:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2104, 'o1qmn5EFemP0Nau4lNn1qczbYVqE', 39, '2020-11-25 19:35:57', '2021-03-24 09:40:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2105, 'o1qmn5LPZ2iSUuz85ZKh3qrVOvtY', 9, '2020-11-25 22:05:30', '2021-03-23 10:04:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2106, 'o1qmn5LujQjVW5L_OUZNxif52-ow', 0, '2020-11-25 22:33:48', '2020-11-25 22:33:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2107, 'o1qmn5IrQf6eGhTItBES4Ap-5Lc0', 1, '2020-11-25 22:34:49', '2020-11-26 05:08:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2108, 'o1qmn5N9FoPpVJ5LrAcP69OesLOs', 1, '2020-11-25 22:37:59', '2020-11-25 23:47:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2109, 'o1qmn5DKZ-OTxvv3M8gSzFxvajc8', 2, '2020-11-25 22:41:15', '2020-11-26 00:58:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2110, 'o1qmn5CVQ79W5YphiLVnHygPxWeM', 0, '2020-11-25 22:44:00', '2020-11-25 22:44:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2111, 'o1qmn5KBIezt-NsM7A4P5qmbIzkY', 1, '2020-11-25 22:54:49', '2020-12-01 05:39:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2112, 'o1qmn5CSBKDTZkSIcxDvvb14C-HQ', 2, '2020-11-25 22:58:10', '2020-12-02 19:05:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2113, 'o1qmn5ESoyPz1PmJr4mKOMDjx8Vo', 4, '2020-11-25 23:04:03', '2020-12-02 23:05:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2114, 'o1qmn5N74paw3h26QGqvBrVzyFYg', 10, '2020-11-25 23:07:39', '2020-12-02 18:05:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2115, 'o1qmn5PG6Ojc9bKjHBFz-zwwu8KY', 0, '2020-11-25 23:11:38', '2020-11-25 23:11:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2116, 'o1qmn5CIraNnvZHMB7XMynNpW1zU', 0, '2020-11-25 23:11:46', '2020-11-25 23:11:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2117, 'o1qmn5MI1gykuuuhMjRS_YCL0pog', 5, '2020-11-25 23:12:55', '2021-03-12 08:24:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2118, 'o1qmn5O5P23nvISgTlIDs6U1OiHg', 0, '2020-11-25 23:13:46', '2020-11-25 23:13:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2119, 'o1qmn5DfhBg6m5ToawH_ZFKJbDsg', 1, '2020-11-25 23:14:57', '2021-03-12 08:25:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2120, 'o1qmn5LOI4nA0Armm4J6UTUXXzPM', 0, '2020-11-25 23:15:42', '2020-11-25 23:15:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2121, 'o1qmn5CHrOuTECn_szpo2OSDsuyk', 0, '2020-11-25 23:18:28', '2020-11-25 23:18:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2122, 'o1qmn5AAPpEn_hBkXjfJA6yTs-uo', 14, '2020-11-25 23:19:42', '2020-11-26 11:04:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2123, 'o1qmn5PiGTqbswWCjh8UKHYfaWlg', 0, '2020-11-25 23:22:39', '2020-11-25 23:22:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2124, 'o1qmn5AIOhfTvBWT8C6onYbw93Zo', 0, '2020-11-25 23:24:08', '2020-11-25 23:24:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2125, 'o1qmn5OUQP5lwGFMAG64aoD94Rl8', 28, '2020-11-25 23:24:40', '2020-11-26 18:54:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2126, 'o1qmn5MoHOrO1YcJJNOpx-7wbr9M', 1, '2020-11-25 23:26:23', '2020-11-25 23:44:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2127, 'o1qmn5B8sOVq_vWQtGqaVJE1PklA', 0, '2020-11-25 23:31:34', '2020-11-25 23:31:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2128, 'o1qmn5M0KFXsyhFzb4Bs5Mo7oElY', 30, '2020-11-25 23:33:11', '2020-11-26 11:59:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2129, 'o1qmn5JFHOaP3cZgrjckQ8whGGJA', 1, '2020-11-25 23:43:39', '2020-11-26 00:24:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2130, 'o1qmn5CFHcgenX5qt7Tbxpt5VcIc', 0, '2020-11-25 23:45:38', '2020-11-25 23:45:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2131, 'o1qmn5D1Dtun-GSXfZFW0RnNltcU', 0, '2020-11-25 23:49:25', '2020-11-25 23:49:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2132, 'o1qmn5DlaWaJGjOdBLCDcTA37wRo', 0, '2020-11-25 23:51:44', '2020-11-25 23:51:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2133, 'o1qmn5MW89pv0AWz7NGevLgDQRgU', 1, '2020-11-26 00:04:03', '2020-11-26 00:27:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2134, 'o1qmn5M_iXsenmb1yUoGYXoN8AIM', 3, '2020-11-26 00:15:42', '2020-12-02 20:00:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2135, 'o1qmn5FwoSs-eZa_-i0Q8JQHiMjc', 1, '2020-11-26 00:17:04', '2021-03-08 06:46:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2136, 'o1qmn5Kal0esXDTk3Xrn2MH8pS-w', 0, '2020-11-26 00:17:58', '2020-11-26 00:17:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2137, 'o1qmn5MZikf3VsPbFYIDnLtlfINc', 0, '2020-11-26 00:17:59', '2020-11-26 00:17:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2138, 'o1qmn5I2BGAoMRL3RVEYbjnb1RtE', 1, '2020-11-26 00:23:02', '2021-03-13 05:02:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2139, 'o1qmn5KD_O1beq2521Zs2pViLIuk', 0, '2020-11-26 00:24:00', '2020-11-26 00:24:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2140, 'o1qmn5GYWpTjYHRRpRe0ees9y6cc', 0, '2020-11-26 00:29:20', '2020-11-26 00:29:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2141, 'o1qmn5POALLx3qYolIVLgNsAg-pE', 1, '2020-11-26 00:32:28', '2020-12-02 07:18:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2142, 'o1qmn5M6c5k97XJQB5mO1alumfI0', 0, '2020-11-26 00:49:17', '2020-11-26 00:49:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2143, 'o1qmn5LPTdHZqiUnFiOpzOdy8x9o', 0, '2020-11-26 00:49:17', '2020-11-26 00:49:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2144, 'o1qmn5E5t3jNaxuHyQTfAugSmrGQ', 2, '2020-11-26 00:50:37', '2021-03-07 06:11:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2145, 'o1qmn5KCq0miQoE5bpBGzmOgK06g', 0, '2020-11-26 00:50:40', '2020-11-26 00:50:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2146, 'o1qmn5ODVWQ9ouasFu2w1FugDht0', 0, '2020-11-26 00:54:54', '2020-11-26 00:54:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2147, 'o1qmn5OgWr5UOKeef3WGVqWYm3vM', 0, '2020-11-26 00:58:27', '2020-11-26 00:58:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2148, 'o1qmn5HQE48iwxNkTWpTW1O7EmJM', 0, '2020-11-26 01:04:57', '2020-11-26 01:04:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2149, 'o1qmn5KFRLWMKTe4UG2WI_-HPHsY', 4, '2020-11-26 01:20:54', '2020-12-02 22:26:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2150, 'o1qmn5L1tcVlqM4Bw2CO9418hgVE', 0, '2020-11-26 01:24:43', '2020-11-26 01:24:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2151, 'o1qmn5BGsECWfGuwwFsvAxOjRdMM', 1, '2020-11-26 02:47:49', '2020-11-26 14:17:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2152, 'o1qmn5P4MQD3PuU6b0tcm3VPbpys', 0, '2020-11-26 02:57:38', '2020-11-26 02:57:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2153, 'o1qmn5FsL1NhA4Hy7iindZeRmtaY', 2, '2020-11-26 03:24:39', '2021-02-19 23:37:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2154, 'o1qmn5BXHzJjj9sJkxe2tgdMxoIg', 1, '2020-11-26 04:02:14', '2020-12-02 08:19:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2155, 'o1qmn5FbZABVM9UOSKqtQomsOoNc', 0, '2020-11-26 06:23:49', '2020-11-26 06:23:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2156, 'o1qmn5BmdaH0NPwR96jXUZfKTdCE', 0, '2020-11-26 08:34:48', '2020-11-26 08:34:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2157, 'o1qmn5J6QAYjHW4NZfNeUOtsih98', 0, '2020-11-26 09:16:03', '2020-11-26 09:16:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2158, 'o1qmn5HRV0h7c0qzAKyFltJMuwuQ', 0, '2020-11-26 09:55:43', '2020-11-26 09:55:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2159, 'o1qmn5HtlnQPyvyT4lEY9PASLNBs', 0, '2020-11-26 10:09:53', '2020-11-26 10:09:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2160, 'o1qmn5Gol5lqBB319aph_ONoyUgM', 0, '2020-11-26 11:03:01', '2020-11-26 11:03:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2161, 'o1qmn5M8I1cCZdfP508syxSjEgjQ', 0, '2020-11-26 11:35:30', '2020-11-26 11:35:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2162, 'o1qmn5PHqXWKkFdUqexO4Ae2pgSI', 0, '2020-11-26 11:37:36', '2020-11-26 11:37:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2163, 'o1qmn5JRnYBfxxpvOoskHseV3WXs', 0, '2020-11-26 11:47:23', '2020-11-26 11:47:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2164, 'o1qmn5OjzU0FQxJ8bJ6JaHjGdUQ0', 0, '2020-11-26 11:53:08', '2020-11-26 11:53:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2165, 'o1qmn5A9WolTxs5km5b96R_mt1sc', 13, '2020-11-26 11:55:21', '2020-11-26 11:56:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2166, 'o1qmn5O-aRG3Fo7MSu-5Eo7afAYs', 14, '2020-11-26 12:21:15', '2020-11-26 12:22:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2167, 'o1qmn5KmyFZoHmvY3zejjygH9jZU', 14, '2020-11-26 12:21:30', '2020-11-26 12:22:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2168, 'o1qmn5JxvTHLioB5UL6mSiC1aa0U', 15, '2020-11-26 12:38:20', '2021-03-12 05:38:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2169, 'o1qmn5Ivqf2nqT1hqNp4oKnKhg3w', 0, '2020-11-26 12:45:31', '2020-11-26 12:45:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2170, 'o1qmn5E8xPd2n3TswBvK-F9Z3RPY', 0, '2020-11-26 12:48:09', '2020-11-26 12:48:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2171, 'o1qmn5J557tFiWsZDrNR8E8Gjj-c', 1, '2020-11-26 12:57:55', '2020-12-04 04:01:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2172, 'o1qmn5C-yDpzB6_dl-9XVmGEp-dY', 13, '2020-11-26 13:06:21', '2020-11-26 13:06:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2173, 'o1qmn5Ct1xCsUfQr6xiJ1UMkqpS0', 0, '2020-11-26 13:16:16', '2020-11-26 13:16:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2174, 'o1qmn5CKrEMqCwhjdZjz1hCTk3BQ', 0, '2020-11-26 16:49:44', '2020-11-26 16:49:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2175, 'o1qmn5Pbl9WzyeTHRJdZiLGFc0FM', 0, '2020-11-26 16:52:26', '2020-11-26 16:52:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2176, 'o1qmn5IVAvYfRK6w6i6pl4cFEGh8', 0, '2020-11-26 17:17:03', '2020-11-26 17:17:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2177, 'o1qmn5LbD9OhgThw_VrPOJmvv1AQ', 1, '2020-11-26 17:22:09', '2020-12-21 10:51:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2178, 'o1qmn5ERGcD05D9Osgj_QZotG-dE', 0, '2020-11-26 18:03:50', '2020-11-26 18:03:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2179, 'o1qmn5DrzcT5I6LtlsiFBDDcVIeo', 0, '2020-11-26 19:56:12', '2020-11-26 19:56:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2180, 'o1qmn5Gm5wCVMAQ7eNCV5aKS_AkQ', 0, '2020-11-26 22:24:36', '2020-11-26 22:24:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2181, 'o1qmn5DpupPVXjbtlPRBXQILKgTY', 0, '2020-11-26 22:51:01', '2020-11-26 22:51:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2182, 'o1qmn5NqJaOw9ktY1YXhKfYpcJUs', 1, '2020-11-27 08:39:03', '2021-03-20 14:38:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2183, 'o1qmn5DWASo03GTLezQlufiIfZ68', 2, '2020-11-27 08:57:53', '2021-01-08 16:42:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2184, 'o1qmn5NvCBAi2TU2VDbR1B4lUH0o', 3, '2020-11-27 09:16:09', '2020-12-22 12:06:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2185, 'o1qmn5CHFkQwx9BHV_RYlE_U8oMs', 0, '2020-11-27 09:23:47', '2020-11-27 09:23:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2186, 'o1qmn5JyZd_M-6hTNBrC_qpI6alQ', 0, '2020-11-27 09:23:51', '2020-11-27 09:23:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2187, 'o1qmn5AEO_2RkplexkB2XdeBtDwM', 1, '2020-11-27 10:50:39', '2020-12-24 10:08:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2188, 'o1qmn5AEb392LhTJ-0-fw7UpT2OA', 0, '2020-11-27 12:13:04', '2020-11-27 12:13:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2189, 'o1qmn5HcAsujX7PiWVdsx1CZyyMs', 0, '2020-11-27 12:15:19', '2020-11-27 12:15:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2190, 'o1qmn5AFdAHGqYvB23zfkwrIiRbA', 0, '2020-11-27 16:44:02', '2020-11-27 16:44:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2191, 'o1qmn5H3Jj6pPSdF8QIcApARtev8', 1, '2020-11-27 16:49:50', '2020-11-27 17:00:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2192, 'o1qmn5DpF8xNyOsF57lFyzU30Wl8', 0, '2020-11-27 16:52:12', '2020-11-27 16:52:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2193, 'o1qmn5MsxO6hmsI1-mOT1cberuHU', 0, '2020-11-27 16:52:15', '2020-11-27 16:52:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2194, 'o1qmn5Oun5cak4YDaWTVJxGk4ZsE', 0, '2020-11-27 16:52:28', '2020-11-27 16:52:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2195, 'o1qmn5IrziWQ5umkrYKGNMzi0RYg', 0, '2020-11-27 16:58:12', '2020-11-27 16:58:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2196, 'o1qmn5M4oUjCYcWBrWE3nqr61o5Q', 0, '2020-11-27 17:03:11', '2020-11-27 17:03:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2197, 'o1qmn5EBamHKlz889-xGYo7YCbW0', 0, '2020-11-27 17:40:19', '2020-11-27 17:40:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2198, 'o1qmn5FSvC59ECBw2-llNJuAsTus', 0, '2020-11-27 19:01:25', '2020-11-27 19:01:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2199, 'o1qmn5KpwD5O5DO5NHHPl-bRGAgM', 1, '2020-11-27 20:08:41', '2020-11-27 23:05:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2200, 'o1qmn5KtWcd916dpZpyZ7ZlTtgdw', 0, '2020-11-28 01:43:41', '2020-11-28 01:43:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2201, 'o1qmn5KsnukEgkMbJmqeRm3AAin8', 0, '2020-11-28 05:45:52', '2020-11-28 05:45:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2202, 'o1qmn5EO-oravZtztTalrxHKn_6c', 1, '2020-11-28 07:48:32', '2021-03-12 09:13:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2203, 'o1qmn5KTwsQ0-emOkNCqTSqHDpgE', 4, '2020-11-28 11:50:13', '2021-01-07 18:02:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2204, 'o1qmn5J1ZuXtbxQftBRmMjc74Dcs', 3, '2020-11-28 13:47:49', '2020-11-28 13:53:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2205, 'o1qmn5EBIroQ7t7ibtV8qsLU6qOw', 0, '2020-11-28 14:45:56', '2020-11-28 14:45:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2206, 'o1qmn5Nr4LjZ0LouF5v8-BmJ6SUw', 10, '2020-11-28 16:06:09', '2020-12-05 16:51:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2207, 'o1qmn5ChrMIoElBuYTVBbz4zCUl0', 1, '2020-11-28 17:14:03', '2020-12-24 16:28:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2208, 'o1qmn5FtaIOHT3ZqSI62Qsko0gkM', 0, '2020-11-28 17:15:44', '2020-11-28 17:15:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2209, 'o1qmn5DKWWV5rkW6diAn4Fh4SsgE', 0, '2020-11-28 17:50:44', '2020-11-28 17:50:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2210, 'o1qmn5OByHoI5FHrLBZsZgt8Hj7I', 0, '2020-11-29 05:38:06', '2020-11-29 05:38:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2211, 'o1qmn5JInKQrORi-tKzdv-muL8FI', 4, '2020-11-29 10:45:15', '2021-03-26 16:39:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2212, 'o1qmn5J-ZRZgmngRA7M7THLkY1OY', 1, '2020-11-29 12:03:08', '2020-12-11 13:43:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2213, 'o1qmn5A1qUABFNUZ50Hfo0aihbk0', 0, '2020-11-29 14:53:24', '2020-11-29 14:53:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2214, 'o1qmn5M87TxTuMZUzPJ1QhlkTzdA', 2, '2020-11-29 15:42:05', '2021-03-22 19:33:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2215, 'o1qmn5KQS8Amd9v2LvtY6E3DSUBk', 0, '2020-11-29 16:09:35', '2020-11-29 16:09:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2216, 'o1qmn5D7nwtdvk03DtoCXRugywHw', 0, '2020-11-29 20:33:00', '2020-11-29 20:33:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2217, 'o1qmn5DK-40GLJTIUnzRCS9dTPh0', 1, '2020-11-29 22:33:30', '2021-03-22 14:40:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2218, 'o1qmn5KX-p_K812CAqDCBPwbizWU', 0, '2020-11-29 23:51:59', '2020-11-29 23:51:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2219, 'o1qmn5DcFcKIGOUObhhRkvl9TPOI', 1, '2020-11-30 00:15:12', '2020-12-03 18:51:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2220, 'o1qmn5LirbchKv3E7nN2O-DH-ag8', 0, '2020-11-30 03:56:28', '2020-11-30 03:56:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2221, 'o1qmn5Kmt1whB1pAi4TR5NKZJ7yQ', 0, '2020-11-30 06:16:14', '2020-11-30 06:16:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2222, 'o1qmn5C8EZW_eqU-QM9i29XOJi3k', 0, '2020-11-30 08:46:06', '2020-11-30 08:46:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2223, 'o1qmn5JRtCtOJtqjr9lvJNPM-7sI', 0, '2020-11-30 08:46:10', '2020-11-30 08:46:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2224, 'o1qmn5PMiXXWq1sfoIcGfJ__-H5w', 1, '2020-11-30 08:51:33', '2021-03-08 15:54:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2225, 'o1qmn5JmfeJW2X9U6xRclYzoEbFg', 0, '2020-11-30 08:54:02', '2020-11-30 08:54:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2226, 'o1qmn5LE19b0k4pfqW8AN6Rzud54', 0, '2020-11-30 09:01:29', '2020-11-30 09:01:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2227, 'o1qmn5C45O0EDOi2Bav-lfdaJJZI', 0, '2020-11-30 09:14:30', '2020-11-30 09:14:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2228, 'o1qmn5NPwtWCqE9TCC8Fx3EIqq3w', 0, '2020-11-30 09:22:46', '2020-11-30 09:22:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2229, 'o1qmn5LUrsT76a4_huzrdn52D2VE', 0, '2020-11-30 10:17:07', '2020-11-30 10:17:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2230, 'o1qmn5Pp1biPR7_VODmwFtQDOTgQ', 1, '2020-11-30 11:14:54', '2020-12-01 15:20:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2231, 'o1qmn5KMTIeB4HbyO6oBsf27czGA', 4, '2020-11-30 11:42:48', '2021-01-06 16:39:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2232, 'o1qmn5EUWzZd3mkiXlF9GC7gf-rc', 12, '2020-11-30 13:36:02', '2021-03-24 18:37:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2233, 'o1qmn5GizdNSMI_Fs9zDMERYfz54', 0, '2020-11-30 14:17:22', '2020-11-30 14:17:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2234, 'o1qmn5IpcOcb8XfxdE4y8zIYMHw8', 0, '2020-11-30 14:17:33', '2020-11-30 14:17:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2235, 'o1qmn5O9uDv6A3VTaikdixi1VhIg', 0, '2020-11-30 14:18:59', '2020-11-30 14:18:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2236, 'o1qmn5FKduW34itK2-Md8oODyqHM', 0, '2020-11-30 14:52:53', '2020-11-30 14:52:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2237, 'o1qmn5KUcRBYXxcA-V-Oyvzr0TvM', 0, '2020-11-30 15:21:18', '2020-11-30 15:21:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2238, 'o1qmn5OscWmbfBu6SiGVxoENy1Gs', 0, '2020-11-30 17:32:50', '2020-11-30 17:32:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2239, 'o1qmn5I_MleLCj78NV3617tuhqiE', 3, '2020-11-30 18:32:02', '2021-03-20 18:20:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2240, 'o1qmn5FdfrOG4nBPZtz9dy8cdP8Q', 0, '2020-11-30 19:25:45', '2020-11-30 19:25:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2241, 'o1qmn5HywUj_-D7NE6XEZrdL1Tqw', 1, '2020-12-01 09:20:28', '2020-12-01 09:21:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2242, 'o1qmn5B0y8x6K3r7iyE7NzPgy1to', 3, '2020-12-01 10:29:10', '2021-03-25 15:50:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2243, 'o1qmn5IK3OkbcjkWRncs3xZO34Y0', 3, '2020-12-01 10:57:38', '2020-12-24 14:42:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2244, 'o1qmn5C5WBa9RFy2fNaPTF_meZqU', 3, '2020-12-01 11:30:24', '2020-12-01 15:40:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2245, 'o1qmn5MeIqHmpClge7dF28mvSqgc', 1, '2020-12-01 11:44:43', '2020-12-01 22:01:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2246, 'o1qmn5CnALrCQ6Wzgy6MEDVcRztg', 0, '2020-12-01 12:31:19', '2020-12-01 12:31:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2247, 'o1qmn5IW8qMElFqHJmGm5kIsG5Dk', 8, '2020-12-01 14:18:58', '2021-03-28 16:24:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2248, 'o1qmn5KGs8pU8x9OEqmZpnQ8x8qY', 1, '2020-12-01 14:46:13', '2020-12-01 14:47:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2249, 'o1qmn5AWhlKQexvYFXKeLfkid7-E', 0, '2020-12-01 16:13:16', '2020-12-01 16:13:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2250, 'o1qmn5P8WmDd4wNzU8uTi1lIrVAU', 0, '2020-12-01 18:43:29', '2020-12-01 18:43:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2251, 'o1qmn5JvVTqcotXWSZ_BsgfTJl7w', 5, '2020-12-01 19:38:33', '2021-01-24 10:47:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2252, 'o1qmn5KKdU5q6pYw6hiKV-4wxpTM', 3, '2020-12-01 20:59:54', '2020-12-06 18:50:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2253, 'o1qmn5Ef3v_xkG5JtawoaySbQYzM', 0, '2020-12-01 21:00:37', '2020-12-01 21:00:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2254, 'o1qmn5A5mSf_fReMs5J6vvo6c84c', 0, '2020-12-02 02:53:47', '2020-12-02 02:53:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2255, 'o1qmn5L84NHRdcszQQ2UmmDUU3RY', 0, '2020-12-02 07:17:49', '2020-12-02 07:17:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2256, 'o1qmn5D2Lhm6OSpKVbJdiEvFquYA', 0, '2020-12-02 07:18:31', '2020-12-02 07:18:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2257, 'o1qmn5MNBWya2MCUCj2fiAd2h4Ms', 0, '2020-12-02 07:19:00', '2020-12-02 07:19:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2258, 'o1qmn5MKBqZE3ctfArYQzHrns9A0', 0, '2020-12-02 07:19:44', '2020-12-02 07:19:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2259, 'o1qmn5PjxJiMoZfH_oV3YkYQX17M', 1, '2020-12-02 07:19:55', '2020-12-02 07:20:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2260, 'o1qmn5Acq0neADXxlQ-XAzfZrWzw', 0, '2020-12-02 07:20:05', '2020-12-02 07:20:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2261, 'o1qmn5GyJFWwi_Y7N9JO4l_1ztq4', 0, '2020-12-02 07:20:18', '2020-12-02 07:20:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2262, 'o1qmn5K4PnSrPP0-_6TIDRWHuBDE', 0, '2020-12-02 07:21:02', '2020-12-02 07:21:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2263, 'o1qmn5DGp2cEnwWL9A3KschvsWiI', 1, '2020-12-02 08:20:09', '2021-03-12 08:25:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2264, 'o1qmn5CPIPY3iPBrTm3RlquPChyQ', 0, '2020-12-02 08:21:07', '2020-12-02 08:21:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2265, 'o1qmn5Hc-tObVX_bzvI7blJ7sC_w', 0, '2020-12-02 09:30:12', '2020-12-02 09:30:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2266, 'o1qmn5NS7m1gIsZSBKpGWp5juXV8', 0, '2020-12-02 10:51:33', '2020-12-02 10:51:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2267, 'o1qmn5LKcsSDUhjcH1lk3-P4e9AE', 0, '2020-12-02 11:31:10', '2020-12-02 11:31:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2268, 'o1qmn5AlaYFvHeIoUaTa2F2Fv9Xc', 0, '2020-12-02 11:37:38', '2020-12-02 11:37:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2269, 'o1qmn5KOxUmZXXHd6ynbBxjhJGMY', 2, '2020-12-02 11:46:07', '2021-01-22 17:04:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2270, 'o1qmn5PkOJ-QzLPOqxEjngi0BGzY', 0, '2020-12-02 11:47:03', '2020-12-02 11:47:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2271, 'o1qmn5GxUAEgoKCAoSteIbw8REo4', 2, '2020-12-02 11:48:04', '2020-12-02 12:22:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2272, 'o1qmn5Kg4V-H0_6eOqAv1Yh6xkIE', 0, '2020-12-02 12:09:01', '2020-12-02 12:09:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2273, 'o1qmn5AGLVcvQ05gOYcG_Gp5MDbs', 0, '2020-12-02 12:26:40', '2020-12-02 12:26:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2274, 'o1qmn5M9ZuMirb1LHddzgCeuNFnI', 0, '2020-12-02 12:55:43', '2020-12-02 12:55:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2275, 'o1qmn5DVovPn5-RVFvDU2C4IXQ8A', 0, '2020-12-02 13:00:01', '2020-12-02 13:00:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2276, 'o1qmn5DmBy-fbE5ucpmX2omwFrSQ', 0, '2020-12-02 13:05:38', '2020-12-02 13:05:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2277, 'o1qmn5NR_r_7sv71_JivLBFdXcHE', 0, '2020-12-02 13:17:59', '2020-12-02 13:17:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2278, 'o1qmn5DxZrJbsXuTI6BmNECnkeL8', 1, '2020-12-02 13:44:22', '2021-01-18 15:12:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2279, 'o1qmn5HOaau50FmPYmR8_mKj3Rh0', 5, '2020-12-02 15:21:40', '2021-03-26 11:47:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2280, 'o1qmn5FW9qnQm1rm9QGVkyxqubYM', 1, '2020-12-02 15:32:14', '2020-12-03 09:34:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2281, 'o1qmn5Csgn3s6dVR-bKlUUZlIg84', 0, '2020-12-02 15:49:25', '2020-12-02 15:49:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2282, 'o1qmn5NqG_cJjzcwR7KXobcyg89A', 0, '2020-12-02 15:49:55', '2020-12-02 15:49:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2283, 'o1qmn5Nq2WVmYA_1v_2dyO2A0Pz4', 0, '2020-12-02 15:52:45', '2020-12-02 15:52:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2284, 'o1qmn5AsJljosjVaV2yK7NSb-qBQ', 0, '2020-12-02 15:58:23', '2020-12-02 15:58:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2285, 'o1qmn5IVC2qiLrzeROLbTdz_loqQ', 0, '2020-12-02 15:58:32', '2020-12-02 15:58:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2286, 'o1qmn5JTnKBv9_aT5k-hjQ5fTo1g', 0, '2020-12-02 15:58:40', '2020-12-02 15:58:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2287, 'o1qmn5M2qfvxWNvNzCPbE2Fb-8j8', 0, '2020-12-02 16:01:11', '2020-12-02 16:01:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2288, 'o1qmn5GH2uL0Gzol9IFrTO1UviFY', 0, '2020-12-02 16:07:05', '2020-12-02 16:07:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2289, 'o1qmn5JkOW9Avc_vAcswkkP1X-Sg', 0, '2020-12-02 16:43:08', '2020-12-02 16:43:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2290, 'o1qmn5IZuWN_rTlOhzGaLxnomyv8', 0, '2020-12-02 16:43:34', '2020-12-02 16:43:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2291, 'o1qmn5OtCC3pmyAXD-6tmc9_cQLs', 1, '2020-12-02 17:08:22', '2020-12-10 12:18:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2292, 'o1qmn5MNz-x5_OH3RscKneQthPoY', 0, '2020-12-02 17:10:15', '2020-12-02 17:10:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2293, 'o1qmn5ISQyi3bPd00BnSPxPF8Hrk', 0, '2020-12-02 17:26:09', '2020-12-02 17:26:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2294, 'o1qmn5NFpQYKGlLqk0Dm_HYQOz8I', 0, '2020-12-02 17:28:35', '2020-12-02 17:28:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2295, 'o1qmn5D6u1y_Hrxf669qkN-eQTj8', 0, '2020-12-02 17:43:15', '2020-12-02 17:43:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2296, 'o1qmn5JUKYgSVOWYG6xzxIW9iLhU', 2, '2020-12-02 18:21:40', '2020-12-02 18:21:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2297, 'o1qmn5LP2-sk5jZfUgEyDt9bVpWA', 3, '2020-12-02 18:58:26', '2020-12-02 18:58:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2298, 'o1qmn5NZMN2zkVPxezuaFBn_ohc4', 2, '2020-12-02 20:13:55', '2021-03-05 11:46:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2299, 'o1qmn5LSYsIWk5kwBLOZDbcK9oRI', 0, '2020-12-03 00:10:26', '2020-12-03 00:10:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2300, 'o1qmn5G0Tf9iZ7CYR1OJeIqyiR3k', 1, '2020-12-03 00:29:40', '2020-12-07 07:48:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2301, 'o1qmn5Mxu1LDzrPGvE6iKQBIfMu4', 0, '2020-12-03 09:58:54', '2020-12-03 09:58:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2302, 'o1qmn5J9Za-Drvq_jrew2hgmFBHk', 0, '2020-12-03 10:22:38', '2020-12-03 10:22:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2303, 'o1qmn5J6J-3lkmploV2IX75dwlp4', 1, '2020-12-03 10:28:47', '2021-03-12 13:37:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2304, 'o1qmn5NRp4_fAdUB8yYxhSdJRa5o', 0, '2020-12-03 10:51:32', '2020-12-03 10:51:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2305, 'o1qmn5LiB5uPvvNnsTNsS7JhxTkc', 1, '2020-12-03 11:09:18', '2020-12-12 10:48:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2306, 'o1qmn5FQ1rxJepyFKY721EHG_SVE', 18, '2020-12-03 11:13:42', '2021-03-11 17:40:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2307, 'o1qmn5Cgk40uyJm8t5zMqx1kpCUA', 0, '2020-12-03 11:25:04', '2020-12-03 11:25:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2308, 'o1qmn5L9gUmu9NpuUSm2lLDJYMoo', 1, '2020-12-03 19:12:53', '2020-12-04 10:36:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2309, 'o1qmn5LO1OrXrDp5jDBhxMv_G22M', 0, '2020-12-03 22:02:50', '2020-12-03 22:02:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2310, 'o1qmn5JfA5J1saBN9a86QMxYSkDg', 0, '2020-12-03 22:29:16', '2020-12-03 22:29:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2311, 'o1qmn5FmgLInawR5Y6LcRzELE5h0', 0, '2020-12-04 03:47:51', '2020-12-04 03:47:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2312, 'o1qmn5BXYfAYJF3ygJp1e1BT_6hI', 2, '2020-12-04 05:27:14', '2021-01-15 12:39:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2313, 'o1qmn5EX9SPMcNXd-ict-ARAA1f8', 0, '2020-12-04 08:09:46', '2020-12-04 08:09:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2314, 'o1qmn5MQVQwKZh2bm9OwFkni42GY', 0, '2020-12-04 08:55:23', '2020-12-04 08:55:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2315, 'o1qmn5OJkKAguAT5YBf3bVecnYII', 0, '2020-12-04 08:59:50', '2020-12-04 08:59:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2316, 'o1qmn5AqOF59iofUwUGXKtOzzPvY', 15, '2020-12-04 09:11:24', '2021-03-25 08:43:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2317, 'o1qmn5CwIdoN0ufATZtA5otGik3s', 0, '2020-12-04 09:30:20', '2020-12-04 09:30:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2318, 'o1qmn5NtBjMId_ieuzCfy9jDhMGI', 0, '2020-12-04 09:47:11', '2020-12-04 09:47:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2319, 'o1qmn5COkSVNjA1xxkbYX3cu-__w', 6, '2020-12-04 09:55:08', '2021-03-12 15:35:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2320, 'o1qmn5Aba7IoKjB8BPX505iHjJQw', 0, '2020-12-04 10:40:07', '2020-12-04 10:40:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2321, 'o1qmn5CLfmeToQEFifAWkQ19h_DM', 0, '2020-12-04 10:40:58', '2020-12-04 10:40:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2322, 'o1qmn5MZOKnIqlu7X0c6Fiqb2MU0', 0, '2020-12-04 10:42:15', '2020-12-04 10:42:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2323, 'o1qmn5JZp6ORvUH1rS2fEBWHhozU', 2, '2020-12-04 10:44:27', '2020-12-04 14:20:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2324, 'o1qmn5FnaDOGaXt5qleVzMl2ud04', 0, '2020-12-04 12:08:21', '2020-12-04 12:08:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2325, 'o1qmn5AXgy0EusDQiDYUbBl1ozCY', 0, '2020-12-04 12:09:28', '2020-12-04 12:09:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2326, 'o1qmn5DHKzipHgSKDgBOJplRZABQ', 0, '2020-12-04 12:59:06', '2020-12-04 12:59:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2327, 'o1qmn5GYu2A0nDTLODGVgeoG6wnI', 10, '2020-12-04 13:21:08', '2021-03-06 20:27:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2328, 'o1qmn5KVzUUqJ9-PmndssFO_E3tc', 2, '2020-12-04 13:58:53', '2020-12-31 15:35:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2329, 'o1qmn5J9tUB4aPdstwQS2-ZiCyvo', 0, '2020-12-04 14:19:08', '2020-12-04 14:19:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2330, 'o1qmn5Oq-mNzgiKqFLYTah9Mn_1k', 0, '2020-12-04 14:23:52', '2020-12-04 14:23:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2331, 'o1qmn5AiSCQZ-IR2yxU3JKKFacLI', 0, '2020-12-04 14:58:09', '2020-12-04 14:58:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2332, 'o1qmn5IDlKwlTz_UHSXewBV8eWh0', 0, '2020-12-04 15:18:57', '2020-12-04 15:18:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2333, 'o1qmn5Cq4WvDJp4dgeZrLMkzRjas', 1, '2020-12-04 17:25:25', '2021-03-19 06:18:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2334, 'o1qmn5FXEiFZcDYJ7iHjzAG7hhl4', 9, '2020-12-04 19:30:08', '2021-03-27 17:00:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2335, 'o1qmn5EfnQzTOKDtqDSMFQZxZvsU', 3, '2020-12-04 19:59:59', '2020-12-07 17:07:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2336, 'o1qmn5I-6kPxngwdAlOJkRZOarik', 0, '2020-12-04 20:12:49', '2020-12-04 20:12:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2337, 'o1qmn5At1rFxUXIlS5rKAzECzKCI', 0, '2020-12-04 20:39:07', '2020-12-04 20:39:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2338, 'o1qmn5MqhyIQh8U_19yJiJ2ZSDvA', 0, '2020-12-04 21:15:32', '2020-12-04 21:15:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2339, 'o1qmn5BkDPngy6WGXgIh38ELgtYk', 0, '2020-12-04 21:32:48', '2020-12-04 21:32:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2340, 'o1qmn5AUfQN5o_s_BGK6k8xWTZOM', 5, '2020-12-04 23:28:59', '2020-12-10 02:16:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2341, 'o1qmn5Gomk8Vsxxo-b8IJuxGC3fw', 2, '2020-12-05 02:02:55', '2020-12-05 02:03:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2342, 'o1qmn5F4oCBSExYVFoWs0Rgz3nDU', 2, '2020-12-05 02:03:24', '2020-12-05 02:03:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2343, 'o1qmn5On4-RbsBGPcaShzGIFZzSY', 3, '2020-12-05 02:09:26', '2020-12-06 04:17:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2344, 'o1qmn5BmeFN4byrPfFHOFpkFAeE8', 2, '2020-12-05 02:22:54', '2020-12-05 02:23:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2345, 'o1qmn5MILbiK_-Wt1dTMseYUOvYY', 3, '2020-12-05 02:48:17', '2020-12-10 02:39:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2346, 'o1qmn5FHRLcZk86fL3dp7HcPendc', 2, '2020-12-05 02:58:14', '2020-12-05 02:58:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2347, 'o1qmn5FNzUo35QIFc3OhWYdKIIEQ', 3, '2020-12-05 03:01:18', '2020-12-05 03:01:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2348, 'o1qmn5E6wJWM2Ev9D-drMbrZJeZ4', 5, '2020-12-05 04:32:21', '2020-12-12 17:00:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2349, 'o1qmn5Gss49nytHI_Dg0L61vQjGI', 5, '2020-12-05 06:00:01', '2020-12-12 03:12:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2350, 'o1qmn5FrJDV5eBcyEFloKgJ19lsc', 0, '2020-12-05 10:47:47', '2020-12-05 10:47:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2351, 'o1qmn5PoYVgOiute-c20PnvjyYTE', 1, '2020-12-05 10:48:23', '2020-12-16 14:25:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2352, 'o1qmn5PqZSmZe6WJ6ERXZP6Zd440', 0, '2020-12-05 10:49:32', '2020-12-05 10:49:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2353, 'o1qmn5GQ_qmtyXe7QaiI4rgGSV4s', 0, '2020-12-05 10:51:53', '2020-12-05 10:51:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2354, 'o1qmn5GKPEQib0E2BLFjvXBtkD-Y', 1, '2020-12-05 11:02:01', '2020-12-07 08:09:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2355, 'o1qmn5DRD9gkMv_fa_m_QoittgHM', 2, '2020-12-05 11:11:20', '2020-12-20 16:13:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2356, 'o1qmn5LhFIr533UK2bUYKVGaDXlI', 0, '2020-12-05 12:16:38', '2020-12-05 12:16:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2357, 'o1qmn5OfgKsaCq14qTLGaV-SpGD8', 0, '2020-12-05 13:37:40', '2020-12-05 13:37:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2358, 'o1qmn5P3aKKINHbG-s09WWvCOSe8', 3, '2020-12-05 13:40:06', '2021-02-25 09:03:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2359, 'o1qmn5NBID9xzDbNqVxf7zjuQrzo', 2, '2020-12-05 14:07:55', '2021-01-15 10:56:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2360, 'o1qmn5DjkPihmsiFMnM6TDUUIHsU', 2, '2020-12-05 15:28:08', '2021-03-20 05:44:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2361, 'o1qmn5Dhi0nmZ9p0X_-GBXs6YoKA', 2, '2020-12-05 17:42:29', '2021-03-25 10:48:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2362, 'o1qmn5JRau01fu82SBowDqxI1a-o', 0, '2020-12-05 17:45:33', '2020-12-05 17:45:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2363, 'o1qmn5KlEN21rKyoI5GcX4nIwYGo', 0, '2020-12-05 17:45:37', '2020-12-05 17:45:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2364, 'o1qmn5ChwPqMd_25ePGcSKNMsw8k', 0, '2020-12-05 17:45:59', '2020-12-05 17:45:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2365, 'o1qmn5HCpxvYu3exhVWCBAHGRiPo', 1, '2020-12-05 17:46:08', '2021-03-19 16:53:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2366, 'o1qmn5ItllV8HPuEF7JclRSQKPww', 0, '2020-12-05 17:46:24', '2020-12-05 17:46:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2367, 'o1qmn5J0aXQAjNqSjL2TCyZbW7vg', 0, '2020-12-05 17:46:43', '2020-12-05 17:46:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2368, 'o1qmn5MqJOj1VbcmgAFtgSdLW7rk', 0, '2020-12-05 17:47:00', '2020-12-05 17:47:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2369, 'o1qmn5PA_vTWNiw2wRcn5hr8Modg', 0, '2020-12-05 17:47:06', '2020-12-05 17:47:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2370, 'o1qmn5K--6EjefT_Jg7kI53MG0fA', 0, '2020-12-05 17:47:14', '2020-12-05 17:47:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2371, 'o1qmn5Gwq4ckVGE200AI3kz1vk-4', 0, '2020-12-05 17:47:19', '2020-12-05 17:47:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2372, 'o1qmn5NE_zOzW-t1UCmBdLvtdstk', 0, '2020-12-05 17:47:22', '2020-12-05 17:47:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2373, 'o1qmn5E8IX9jgmIWmvFqspdhBKxk', 0, '2020-12-05 17:47:26', '2020-12-05 17:47:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2374, 'o1qmn5Eek2RgENt0GDhtQ9175-mQ', 0, '2020-12-05 17:47:27', '2020-12-05 17:47:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2375, 'o1qmn5I2RT3UQl_sfr8dG8XifQH0', 0, '2020-12-05 17:47:28', '2020-12-05 17:47:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2376, 'o1qmn5FREhs-vUl5ADLSnnhUZvCs', 2, '2020-12-05 17:47:30', '2020-12-16 14:31:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2377, 'o1qmn5GgZPuDeVdlPr61h-xLP28U', 1, '2020-12-05 17:47:40', '2021-01-27 07:47:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2378, 'o1qmn5BKbcX6jv-SSqhDdwjhD8iM', 0, '2020-12-05 17:47:40', '2020-12-05 17:47:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2379, 'o1qmn5E2e3kdNKXWZ-1fHBO6ALRw', 0, '2020-12-05 17:47:45', '2020-12-05 17:47:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2380, 'o1qmn5EbFLs6H2v42tNh32s4gqUM', 0, '2020-12-05 17:47:45', '2020-12-05 17:47:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2381, 'o1qmn5DfK55LU2dshmcp3lksuSVU', 0, '2020-12-05 17:47:48', '2020-12-05 17:47:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2382, 'o1qmn5CJ-qd0wdCRmOeUtLQEMtUM', 0, '2020-12-05 17:47:51', '2020-12-05 17:47:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2383, 'o1qmn5ALiA44LRifJ4VhTPKqOLv0', 0, '2020-12-05 17:47:59', '2020-12-05 17:47:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2384, 'o1qmn5OnSq7D91-vme13coHV-Kxs', 0, '2020-12-05 17:48:10', '2020-12-05 17:48:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2385, 'o1qmn5KAHECtnHb9mpDjXqTdvcpQ', 1, '2020-12-05 17:48:16', '2020-12-05 21:55:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2386, 'o1qmn5GUbKTGDX9RQA02k2vEKzCw', 3, '2020-12-05 17:48:17', '2021-01-12 10:54:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2387, 'o1qmn5JwxPTEXEUaaETbUK3nyXWM', 0, '2020-12-05 17:48:20', '2020-12-05 17:48:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2388, 'o1qmn5L149IEzril_NDGzqB2W6FQ', 0, '2020-12-05 17:48:30', '2020-12-05 17:48:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2389, 'o1qmn5DYzy2hKEiEoiSp9S29nPuQ', 7, '2020-12-05 17:48:57', '2020-12-18 14:49:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2390, 'o1qmn5Pdo0NKVwB79rxENWVYJIb4', 0, '2020-12-05 17:49:03', '2020-12-05 17:49:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2391, 'o1qmn5IEpop14H0V591dLXpSbdVU', 0, '2020-12-05 17:49:20', '2020-12-05 17:49:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2392, 'o1qmn5CKbfs4nCg9QqHZqX16V0ps', 0, '2020-12-05 17:49:22', '2020-12-05 17:49:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2393, 'o1qmn5CqHjd_0QccTqYZgMVqrn2Y', 0, '2020-12-05 17:49:29', '2020-12-05 17:49:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2394, 'o1qmn5N93h8bQTkdB49vb5_6twwk', 0, '2020-12-05 17:49:29', '2020-12-05 17:49:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2395, 'o1qmn5EToIDgHFFbkygoeekEHKis', 0, '2020-12-05 17:49:47', '2020-12-05 17:49:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2396, 'o1qmn5NZ0eLAuQwAp0uAFsF_mOQk', 0, '2020-12-05 17:49:54', '2020-12-05 17:49:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2397, 'o1qmn5Kh7ovpbnGjARbSlO8mOXBE', 0, '2020-12-05 17:50:10', '2020-12-05 17:50:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2398, 'o1qmn5Kq91WpfQChzzyzbmR8fyWg', 0, '2020-12-05 17:50:12', '2020-12-05 17:50:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2399, 'o1qmn5K1nd5dxaSxsfIx1QAiuihs', 0, '2020-12-05 17:50:19', '2020-12-05 17:50:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2400, 'o1qmn5E2xP1OqtZb5wWLS6xpF9AY', 1, '2020-12-05 17:50:31', '2021-01-12 10:54:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2401, 'o1qmn5GEUgeW43enlwA6jPkzWwrM', 1, '2020-12-05 17:50:32', '2020-12-07 14:30:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2402, 'o1qmn5OmRinKPKmCd8oHIxU2uqw0', 0, '2020-12-05 17:50:33', '2020-12-05 17:50:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2403, 'o1qmn5NPIHbeyUJ30rWvGEU7mpKs', 0, '2020-12-05 17:50:49', '2020-12-05 17:50:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2404, 'o1qmn5DP7FmESn3_5eEeNZ7cJ4xU', 0, '2020-12-05 17:50:49', '2020-12-05 17:50:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2405, 'o1qmn5IREKbArw8rmN6a4OJIQkls', 0, '2020-12-05 17:50:57', '2020-12-05 17:50:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2406, 'o1qmn5Gdx6HGVWX86eOhgRysBrAE', 0, '2020-12-05 17:51:39', '2020-12-05 17:51:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2407, 'o1qmn5BarcguDSe74cpNS4XzSoMI', 0, '2020-12-05 17:51:40', '2020-12-05 17:51:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2408, 'o1qmn5H9ZgPixJsGdhQTE3MEHn-g', 0, '2020-12-05 17:51:46', '2020-12-05 17:51:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2409, 'o1qmn5DRBVWWNr5j_H305wE2mzbs', 0, '2020-12-05 17:51:54', '2020-12-05 17:51:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2410, 'o1qmn5GrMwOXc4O8lcZozJotKRxw', 0, '2020-12-05 17:52:10', '2020-12-05 17:52:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2411, 'o1qmn5Dw8uiTxW83ZE769EmeeVBo', 4, '2020-12-05 17:52:34', '2021-03-10 16:53:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2412, 'o1qmn5DoRWWTTlGq1--LIvwl1Iac', 0, '2020-12-05 17:53:26', '2020-12-05 17:53:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2413, 'o1qmn5NcXHNkp6Ul-JuNHn22wl-w', 0, '2020-12-05 17:54:55', '2020-12-05 17:54:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2414, 'o1qmn5DVbI0JTn_eqhFYpUQzQlq0', 0, '2020-12-05 17:55:25', '2020-12-05 17:55:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2415, 'o1qmn5G5p9FgFjtTgTX_2DpzJNMA', 0, '2020-12-05 17:55:51', '2020-12-05 17:55:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2416, 'o1qmn5F3Ig4IwwfuKuhAf9cKtwf4', 0, '2020-12-05 17:56:20', '2020-12-05 17:56:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2417, 'o1qmn5KM6DAnjxBh6Cav8t-4A-oM', 0, '2020-12-05 17:56:21', '2020-12-05 17:56:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2418, 'o1qmn5NjSICOmEsoKQndq11VIY9I', 0, '2020-12-05 17:56:27', '2020-12-05 17:56:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2419, 'o1qmn5MeFL71xxErVTDGRYoB4kmo', 0, '2020-12-05 17:56:46', '2020-12-05 17:56:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2420, 'o1qmn5DNCTULu96jSnkZBpn3pl1s', 0, '2020-12-05 17:57:19', '2020-12-05 17:57:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2421, 'o1qmn5KkrbJqcZeOCYVgSc4lIlzw', 0, '2020-12-05 17:57:26', '2020-12-05 17:57:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2422, 'o1qmn5OfLbM7uZx37j78Dvgdp3Jc', 0, '2020-12-05 17:57:38', '2020-12-05 17:57:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2423, 'o1qmn5Jue2D957VPQnxNUpBuxyfg', 0, '2020-12-05 17:58:23', '2020-12-05 17:58:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2424, 'o1qmn5BtUPb2k1pI9brqcdThczeQ', 1, '2020-12-05 17:58:27', '2020-12-18 17:59:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2425, 'o1qmn5HHbVMtiFSeAZKFfx1oJZyY', 1, '2020-12-05 18:00:34', '2021-03-03 17:13:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2426, 'o1qmn5CZCvUX6PWDarwmBu-7SNfs', 0, '2020-12-05 18:01:17', '2020-12-05 18:01:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2427, 'o1qmn5P7Ax1i5nPcXBM9VvajTWG4', 0, '2020-12-05 18:03:14', '2020-12-05 18:03:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2428, 'o1qmn5Mq9lyBa-1cf2pAJNTCGeMk', 0, '2020-12-05 18:03:43', '2020-12-05 18:03:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2429, 'o1qmn5F4PD-ik7-BNhcZ9Db8NNug', 0, '2020-12-05 18:03:51', '2020-12-05 18:03:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2430, 'o1qmn5NbFaHoHtkxNQT-9fTXra2Q', 0, '2020-12-05 18:04:02', '2020-12-05 18:04:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2431, 'o1qmn5JWB3Yq328n_6ZMop9JkeCc', 0, '2020-12-05 18:05:26', '2020-12-05 18:05:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2432, 'o1qmn5J53-eMt3w79ZiAoqFGCP4w', 0, '2020-12-05 18:05:29', '2020-12-05 18:05:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2433, 'o1qmn5PUWh3fO8V6Z5s1GKtTKIjk', 0, '2020-12-05 18:05:51', '2020-12-05 18:05:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2434, 'o1qmn5HINdPR26Gy-7RT9oCaEiJE', 0, '2020-12-05 18:06:42', '2020-12-05 18:06:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2435, 'o1qmn5LBOiMszqIkSIYDli3yb73s', 0, '2020-12-05 18:06:53', '2020-12-05 18:06:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2436, 'o1qmn5Ej0-kq0YYDfe8PCsltkIsw', 0, '2020-12-05 18:06:54', '2020-12-05 18:06:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2437, 'o1qmn5Gzw_ScwQ_2XrGF-g2r4sNc', 0, '2020-12-05 18:07:58', '2020-12-05 18:07:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2438, 'o1qmn5H21jEvpH9w-xRzi5WU2Ajw', 0, '2020-12-05 18:08:57', '2020-12-05 18:08:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2439, 'o1qmn5OP5OnppEl0_3SbapfDfs6w', 0, '2020-12-05 18:14:24', '2020-12-05 18:14:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2440, 'o1qmn5BzEhxI-9i0LtmlKY_EjAuk', 1, '2020-12-05 18:17:15', '2021-01-12 10:53:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2441, 'o1qmn5PgfIos9XyzogiU_gO9L7KY', 0, '2020-12-05 18:18:08', '2020-12-05 18:18:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2442, 'o1qmn5BQTvADNwuenq5K8cUK5xvk', 0, '2020-12-05 18:18:14', '2020-12-05 18:18:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2443, 'o1qmn5GTvTCJdPOyu6gJB1M0JcP0', 1, '2020-12-05 18:20:24', '2020-12-05 21:53:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2444, 'o1qmn5DcJ5bhem9DVQQkOSqkbvko', 0, '2020-12-05 18:20:36', '2020-12-05 18:20:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2445, 'o1qmn5LKNXHSnplONYhC0dnkMb-8', 0, '2020-12-05 18:20:59', '2020-12-05 18:20:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2446, 'o1qmn5MP_Uqi7CbQ2-Wmr4BlmATg', 0, '2020-12-05 18:21:30', '2020-12-05 18:21:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2447, 'o1qmn5Lnt2yqzxzSrjrWDU0l9_7w', 1, '2020-12-05 18:21:44', '2020-12-05 22:55:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2448, 'o1qmn5E3ifH8cAyQZZoVE6a4d5Io', 0, '2020-12-05 18:22:37', '2020-12-05 18:22:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2449, 'o1qmn5CxrkQ5IIQvsfbMcpdwL238', 0, '2020-12-05 18:23:24', '2020-12-05 18:23:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2450, 'o1qmn5BhQd_QKrcyzwpBC_T-2Vp0', 1, '2020-12-05 18:24:09', '2020-12-05 22:05:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2451, 'o1qmn5HpvoP49vF3ctacQ8Czvr88', 0, '2020-12-05 18:26:32', '2020-12-05 18:26:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2452, 'o1qmn5Ha8lD6arUUTwqgo-lol5Ew', 0, '2020-12-05 18:27:05', '2020-12-05 18:27:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2453, 'o1qmn5Hzwa5sxv88Ak3zNTCuIprU', 1, '2020-12-05 18:27:17', '2020-12-06 08:18:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2454, 'o1qmn5I3aaxgEzB5QjEZeOlvvHeQ', 0, '2020-12-05 18:28:35', '2020-12-05 18:28:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2455, 'o1qmn5AZ0mnrhV6UKRckyNdthA3Q', 0, '2020-12-05 18:29:57', '2020-12-05 18:29:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2456, 'o1qmn5Be5p5zZUdFTJOv--jCJ1aU', 1, '2020-12-05 18:30:18', '2020-12-05 21:50:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2457, 'o1qmn5FQy59mWYNiD3nVTCy8xQvo', 1, '2020-12-05 18:31:42', '2020-12-06 07:26:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2458, 'o1qmn5Ocu6l_1GyP75u0_0je6EUo', 0, '2020-12-05 18:35:33', '2020-12-05 18:35:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2459, 'o1qmn5BSN8FDZwXciJTgfIrHHmgQ', 1, '2020-12-05 18:46:03', '2020-12-17 21:45:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2460, 'o1qmn5InXttL4TbRJOPIvYubzYNo', 0, '2020-12-05 18:51:04', '2020-12-05 18:51:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2461, 'o1qmn5K4v9iyhJVKpxJODqP0-j_s', 0, '2020-12-05 18:52:45', '2020-12-05 18:52:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2462, 'o1qmn5EGck9s2QcxCO_jjJVdJWJc', 1, '2020-12-05 18:55:48', '2020-12-05 21:42:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2463, 'o1qmn5G_bcruITNbGZwNXD_1qktc', 0, '2020-12-05 19:10:39', '2020-12-05 19:10:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2464, 'o1qmn5Py-AyBYsVg_zwCFU_ECcK8', 1, '2020-12-05 19:10:48', '2020-12-08 15:35:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2465, 'o1qmn5NaKKBWJkGM-sYXLwef9dxk', 0, '2020-12-05 19:13:12', '2020-12-05 19:13:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2466, 'o1qmn5CaYTxNFSnzu7-K1fcHTHps', 0, '2020-12-05 19:19:27', '2020-12-05 19:19:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2467, 'o1qmn5PmIEcqpGbpCnm4UPoaq1T8', 2, '2020-12-05 19:28:47', '2020-12-14 05:41:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2468, 'o1qmn5Mify19AXP7a36ni9cfzsZQ', 0, '2020-12-05 19:44:36', '2020-12-05 19:44:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2469, 'o1qmn5O8SMXMaaaQ5FwIgCbuHHN8', 0, '2020-12-05 19:46:44', '2020-12-05 19:46:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2470, 'o1qmn5H369csvyVzK74oDGDvTJEY', 0, '2020-12-05 19:50:46', '2020-12-05 19:50:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2471, 'o1qmn5DP8HxCkC8i0XPHBV-ErfXM', 0, '2020-12-05 19:52:26', '2020-12-05 19:52:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2472, 'o1qmn5IcrjaFngr4-Cu18sODacUo', 0, '2020-12-05 20:18:55', '2020-12-05 20:18:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2473, 'o1qmn5Ha_2ySZbV4U_OZJr1wrbcM', 0, '2020-12-05 20:21:01', '2020-12-05 20:21:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2474, 'o1qmn5Mtpbh6zuVT0u0jlaw2kPRs', 0, '2020-12-05 20:31:58', '2020-12-05 20:31:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2475, 'o1qmn5CGh_Zr6hEEHGDtkEHaJBNU', 0, '2020-12-05 20:57:52', '2020-12-05 20:57:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2476, 'o1qmn5I8yOnGsIpTEy-u7UP6W7iQ', 0, '2020-12-05 21:01:09', '2020-12-05 21:01:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2477, 'o1qmn5OVKrQA8QR4EVi791nl0ejY', 0, '2020-12-05 21:09:23', '2020-12-05 21:09:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2478, 'o1qmn5PjIH2Mg45N-9vTspQQ1JfU', 0, '2020-12-05 21:20:03', '2020-12-05 21:20:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2479, 'o1qmn5H-mDx_wSMIc8t5GD_sxsec', 0, '2020-12-05 21:23:38', '2020-12-05 21:23:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2480, 'o1qmn5O1ZQ3lIiE-51-HaceW2vC4', 0, '2020-12-05 21:28:54', '2020-12-05 21:28:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2481, 'o1qmn5PwnjT-_ebPdLmHIF8yjyM0', 0, '2020-12-05 21:30:46', '2020-12-05 21:30:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2482, 'o1qmn5CNgR6vd7z9PISUnQPw4Mdc', 0, '2020-12-05 21:37:11', '2020-12-05 21:37:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2483, 'o1qmn5AI5US3DDPtqBSr_XrU93rM', 0, '2020-12-05 21:42:57', '2020-12-05 21:42:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2484, 'o1qmn5MjtCLlxzi2Jc_YIn6Lm0Cc', 0, '2020-12-05 21:49:37', '2020-12-05 21:49:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2485, 'o1qmn5Kj3_mD6ySc-BvL-qyzfL7A', 0, '2020-12-05 21:54:17', '2020-12-05 21:54:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2486, 'o1qmn5Ozg60yoKhdrQeGmP0FF3XI', 0, '2020-12-05 21:54:52', '2020-12-05 21:54:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2487, 'o1qmn5HvoCZ3NqmtIMnR7ovF_5BA', 0, '2020-12-05 21:55:09', '2020-12-05 21:55:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2488, 'o1qmn5DUI-iUdjadDhKr2K4dM2Fc', 0, '2020-12-05 22:17:35', '2020-12-05 22:17:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2489, 'o1qmn5FvZQlUdwe28NLG7u7yp7YU', 0, '2020-12-05 22:27:24', '2020-12-05 22:27:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2490, 'o1qmn5HHca-Y2_H6e8aplKFb0YwE', 4, '2020-12-05 22:28:19', '2020-12-06 22:11:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2491, 'o1qmn5C3XSZeCDXK1so0dJOy72ao', 0, '2020-12-05 22:47:55', '2020-12-05 22:47:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2492, 'o1qmn5JJzJ3iUHk_mfitFnKRsmJE', 1, '2020-12-05 23:00:35', '2020-12-06 05:00:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2493, 'o1qmn5BTx99J5tP3aurlaa1K5_do', 2, '2020-12-05 23:07:47', '2020-12-09 07:37:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2494, 'o1qmn5JJbx1DaPvD8AzcFwbHf3yI', 0, '2020-12-05 23:13:12', '2020-12-05 23:13:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2495, 'o1qmn5ISpnZFxQNGVcuhuNd2zq8w', 0, '2020-12-05 23:23:56', '2020-12-05 23:23:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2496, 'o1qmn5OOXop7y5xrODbv4G8TBJZA', 0, '2020-12-05 23:33:03', '2020-12-05 23:33:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2497, 'o1qmn5BTDHvrqKZSx14LSOXAkbXQ', 0, '2020-12-06 00:08:52', '2020-12-06 00:08:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2498, 'o1qmn5C6KFDje5_PaSMw3Wk0jr-0', 0, '2020-12-06 00:31:59', '2020-12-06 00:31:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2499, 'o1qmn5LQ-4vB6dcFpmiVQXKRnVtc', 0, '2020-12-06 01:44:44', '2020-12-06 01:44:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2500, 'o1qmn5OLF4hp400akPdBGA1KA7yM', 0, '2020-12-06 02:21:09', '2020-12-06 02:21:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2501, 'o1qmn5EGLcOqswHJeSW22XmBSbdw', 0, '2020-12-06 02:53:29', '2020-12-06 02:53:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2502, 'o1qmn5Gku6ovlGDTutwT6No5IIxA', 0, '2020-12-06 03:40:42', '2020-12-06 03:40:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2503, 'o1qmn5C70aTewC-SqxpqLrTvJcmg', 1, '2020-12-06 04:17:45', '2020-12-07 02:26:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2504, 'o1qmn5KOmgvm7OcvBq2srVMmyAzc', 0, '2020-12-06 04:18:14', '2020-12-06 04:18:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2505, 'o1qmn5AbIjNxE_MpZwnAsuHjSBXw', 0, '2020-12-06 04:20:12', '2020-12-06 04:20:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2506, 'o1qmn5KMPKvcCi3FqUBz1ZElaGnw', 0, '2020-12-06 04:20:36', '2020-12-06 04:20:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2507, 'o1qmn5J4vBLWg5ba7fE8FHTO8wFs', 5, '2020-12-06 05:00:35', '2020-12-09 02:57:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2508, 'o1qmn5HP4WWmZug3mT_p-a6bcrso', 0, '2020-12-06 05:11:06', '2020-12-06 05:11:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2509, 'o1qmn5D-n4zonlNkqumCTDkvXjNg', 0, '2020-12-06 07:48:37', '2020-12-06 07:48:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2510, 'o1qmn5BItRFFpD67-OcW_nnea90Q', 0, '2020-12-06 07:53:52', '2020-12-06 07:53:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2511, 'o1qmn5EOJoiKCtvIlHyI8enymcqI', 0, '2020-12-06 07:54:41', '2020-12-06 07:54:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2512, 'o1qmn5OKXFXTcWw7OQaRArYoMwZo', 0, '2020-12-06 08:13:45', '2020-12-06 08:13:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2513, 'o1qmn5HpNYlh-vb2iv0Yh8XQAyO8', 0, '2020-12-06 08:15:49', '2020-12-06 08:15:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2514, 'o1qmn5GUYi1Jo1PrHbjSvucwq9Ek', 0, '2020-12-06 08:19:31', '2020-12-06 08:19:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2515, 'o1qmn5D5om3t1IuiipQxDx-fEsPw', 0, '2020-12-06 08:48:56', '2020-12-06 08:48:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2516, 'o1qmn5BL7Q8UX-vJjBc07ynijGsY', 3, '2020-12-06 09:42:57', '2020-12-09 03:46:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2517, 'o1qmn5E9Vdd33hhnM4MDiZECypZA', 4, '2020-12-06 10:29:50', '2021-01-21 10:07:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2518, 'o1qmn5Cnyeje3AXL4DRT-xQjmElw', 0, '2020-12-06 14:01:33', '2020-12-06 14:01:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2519, 'o1qmn5NygCjDIqaHdAC4hbpUYRm8', 2, '2020-12-06 17:13:09', '2021-03-18 14:42:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2520, 'o1qmn5DZCIpJkQtWs4qpuLOGjaHM', 0, '2020-12-06 19:18:18', '2020-12-06 19:18:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2521, 'o1qmn5NMZY2BEjxEdCnt8x0eHDe4', 0, '2020-12-06 21:02:09', '2020-12-06 21:02:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2522, 'o1qmn5LDH32t8I_LIF6IoY91D_KU', 0, '2020-12-06 21:07:47', '2020-12-06 21:07:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2523, 'o1qmn5Fq7GmTf2afqObzNw4hB5yo', 0, '2020-12-06 21:58:52', '2020-12-06 21:58:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2524, 'o1qmn5IFAj0e0wRN04QDCNG1Ygng', 0, '2020-12-07 00:29:57', '2020-12-07 00:29:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2525, 'o1qmn5O_3x2bi2BYeQpTzJQkf_30', 0, '2020-12-07 04:56:28', '2020-12-07 04:56:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2526, 'o1qmn5FnwZXpyGFX5wqDtfOiZ1LA', 0, '2020-12-07 08:12:54', '2020-12-07 08:12:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2527, 'o1qmn5MxLyJlSbAs7y2B5Nuo4sG4', 5, '2020-12-07 11:18:19', '2021-03-24 05:29:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2528, 'o1qmn5FSXQWqsKSiDILVGbNG650o', 5, '2020-12-07 11:51:51', '2021-01-08 16:41:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2529, 'o1qmn5Bw9ErZwL3oQ1RAD6i3pbvU', 0, '2020-12-07 11:59:44', '2020-12-07 11:59:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2530, 'o1qmn5BZ8H_yWmINDU8fjcn6bUCQ', 1, '2020-12-07 12:25:46', '2021-01-24 20:38:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2531, 'o1qmn5DQPRb2Egx8Hu6JjB-OucdQ', 0, '2020-12-07 13:43:25', '2020-12-07 13:43:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2532, 'o1qmn5NMPqM5ULrKy8lWUKSLtDlk', 4, '2020-12-07 13:58:04', '2020-12-12 03:30:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2533, 'o1qmn5AtskNXP2mrLekVdAQRIjlA', 3, '2020-12-07 15:44:24', '2020-12-10 10:14:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2534, 'o1qmn5G9IS-XvJUlXamN_74vmcZM', 0, '2020-12-07 15:44:57', '2020-12-07 15:44:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2535, 'o1qmn5LAtkwJ-DtHotfh7j6Yfm8k', 1, '2020-12-07 16:32:18', '2021-02-23 14:47:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2536, 'o1qmn5N2g8feriAywG1um04GoP3w', 0, '2020-12-07 16:51:24', '2020-12-07 16:51:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2537, 'o1qmn5GtvT8tXRcqaAfXNDprKR_A', 3, '2020-12-07 17:07:38', '2020-12-07 17:07:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2538, 'o1qmn5C9Fpft6OciG0zGx5unjyrM', 3, '2020-12-07 17:08:00', '2020-12-07 17:08:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2539, 'o1qmn5K2P8EKqDPWJ-2M3zz4T6cU', 2, '2020-12-07 17:12:41', '2020-12-07 17:12:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2540, 'o1qmn5IYCS6mNW0ebiCveDC0sZVo', 0, '2020-12-07 17:15:37', '2020-12-07 17:15:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2541, 'o1qmn5AYxlH6A9GIOEIfC8Xsoiko', 3, '2020-12-07 17:17:06', '2020-12-07 17:17:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2542, 'o1qmn5BONnaEGkCqpkh9NIhg7RaQ', 0, '2020-12-07 17:24:32', '2020-12-07 17:24:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2543, 'o1qmn5Pv2PADXTKiCbBmYDNAYn9k', 3, '2020-12-07 17:26:01', '2020-12-07 17:26:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2544, 'o1qmn5KG7sjO5yaFBZAoCh1hQLKI', 3, '2020-12-07 17:29:38', '2020-12-11 05:19:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2545, 'o1qmn5ECMgdTpu5BujGlZ4DdD_so', 0, '2020-12-07 17:33:44', '2020-12-07 17:33:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2546, 'o1qmn5M9g6ZmNvdSmnMiQNY0Twik', 0, '2020-12-07 19:41:22', '2020-12-07 19:41:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2547, 'o1qmn5M5fRv5eknQqRm6UhDxFtJ8', 0, '2020-12-07 20:17:06', '2020-12-07 20:17:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2548, 'o1qmn5B33HfXgGtKEzyelBbSSC9Q', 0, '2020-12-07 20:48:36', '2020-12-07 20:48:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2549, 'o1qmn5IgwXKF4-3AttuoazSlkOus', 0, '2020-12-07 21:31:26', '2020-12-07 21:31:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2550, 'o1qmn5IfXTcnTlU1Am40S1dNCy2o', 0, '2020-12-07 23:13:51', '2020-12-07 23:13:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2551, 'o1qmn5N0Bw0RF3OPN2EEAP8zHZys', 11, '2020-12-07 23:23:13', '2021-03-29 09:52:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2552, 'o1qmn5I2622syNY4FCH8wuyIoS1g', 1, '2020-12-08 03:51:48', '2020-12-11 07:14:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2553, 'o1qmn5GNpIbz7TGrt_A939AUN_4o', 0, '2020-12-08 04:03:04', '2020-12-08 04:03:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2554, 'o1qmn5Pep_JdLgAe9YGlAEHE3DVg', 2, '2020-12-08 10:30:02', '2021-01-04 19:08:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2555, 'o1qmn5DpW9jkk_-QICWk_Rvlmj3I', 1, '2020-12-08 10:42:03', '2021-03-15 09:25:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2556, 'o1qmn5MfD6b-yhvciYkBDCUqjJVI', 1, '2020-12-08 10:43:04', '2020-12-08 11:01:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2557, 'o1qmn5FkX86inIWdMWNh648OclaE', 7, '2020-12-08 11:10:34', '2021-02-26 14:54:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2558, 'o1qmn5IYyY86jsgUzDh0RlCAfN2g', 0, '2020-12-08 11:13:05', '2020-12-08 11:13:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2559, 'o1qmn5GchZmpFOGAgXi0xowaLjQQ', 0, '2020-12-08 11:34:47', '2020-12-08 11:34:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2560, 'o1qmn5LJUqOJuKxIfY2pylFBZts8', 0, '2020-12-08 14:57:36', '2020-12-08 14:57:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2561, 'o1qmn5Pu7ZPeY8owlqAoexgxi8n4', 0, '2020-12-08 17:06:13', '2020-12-08 17:06:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2562, 'o1qmn5He1lTHc9ADih9770t-nHjw', 0, '2020-12-08 17:36:06', '2020-12-08 17:36:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2563, 'o1qmn5PEGMO7sgT_aYINuFmU1lbo', 0, '2020-12-08 19:04:27', '2020-12-08 19:04:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2564, 'o1qmn5Kd4B2mMwMTvHKrl17T2MwQ', 4, '2020-12-09 02:46:30', '2020-12-12 05:52:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2565, 'o1qmn5Lm3TThpmwX2PiiL7bjITAc', 2, '2020-12-09 02:55:35', '2020-12-09 02:55:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2566, 'o1qmn5N83hdKry0TmAk63yLfcN48', 4, '2020-12-09 02:58:32', '2020-12-09 02:58:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2567, 'o1qmn5BxE33S-10vw3ENFW7NmPmc', 2, '2020-12-09 03:13:25', '2020-12-09 03:13:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2568, 'o1qmn5CpvgiA_CtqPx83FcW62c8c', 3, '2020-12-09 03:14:31', '2020-12-09 03:14:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2569, 'o1qmn5M98zKx7Sokcuu-XNE510Dk', 4, '2020-12-09 03:16:26', '2020-12-09 03:16:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2570, 'o1qmn5JqdJEt6oDAOOy2SvTn-t4Q', 3, '2020-12-09 03:24:30', '2020-12-09 03:24:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2571, 'o1qmn5BJlSocHoICggW1fZSkbqQg', 2, '2020-12-09 03:47:04', '2020-12-09 03:47:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2572, 'o1qmn5LSk4QIREAUghAr-u5Tbqdo', 1, '2020-12-09 03:59:43', '2020-12-10 21:07:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2573, 'o1qmn5D9LFRsFYzqTlLI-qU7wWaU', 5, '2020-12-09 04:07:38', '2021-03-16 06:50:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2574, 'o1qmn5EHe4RKP-UWSrXVJzY1R_Ag', 2, '2020-12-09 04:10:07', '2020-12-09 04:10:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2575, 'o1qmn5BEgLYmZQJLF2vYnkNSYO1s', 3, '2020-12-09 04:10:28', '2020-12-09 04:10:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2576, 'o1qmn5IDVcGW3-8AfLCu0k0jDVcE', 8, '2020-12-09 04:18:57', '2021-03-20 10:53:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2577, 'o1qmn5E52f34LrrO8jp-RGyTyoyU', 1, '2020-12-09 05:56:21', '2021-03-23 05:59:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2578, 'o1qmn5IL0ABqzCTAtku5t6L0jeOs', 2, '2020-12-09 07:37:27', '2021-03-22 05:46:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2579, 'o1qmn5E62VveA-s2k0Pzij5Z6Gdg', 1, '2020-12-09 07:42:15', '2020-12-09 07:42:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2580, 'o1qmn5LRMdjfii8Lt2AP4Wp6GMxs', 1, '2020-12-09 07:44:58', '2020-12-09 07:45:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2581, 'o1qmn5KM1QFQUf6v6yyEHn1nHGv0', 5, '2020-12-09 07:57:11', '2020-12-12 16:35:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2582, 'o1qmn5EX66BSqmqGUVb1zJpfkOco', 0, '2020-12-09 12:39:48', '2020-12-09 12:39:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2583, 'o1qmn5KNAWgyw0EEe4knhSgij1aY', 0, '2020-12-09 13:08:17', '2020-12-09 13:08:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2584, 'o1qmn5AbwJzC7blhVru4ppTHbfCE', 1, '2020-12-09 13:51:43', '2020-12-11 10:11:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2585, 'o1qmn5JKnmsYs54tPpqTYyRmSbOY', 0, '2020-12-09 15:54:30', '2020-12-09 15:54:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2586, 'o1qmn5I1_xyJUWYUFoV0qJ30yqhE', 6, '2020-12-09 16:33:45', '2020-12-23 16:43:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2587, 'o1qmn5KLP-K5x-IdsqU0Fl0zZ6zk', 2, '2020-12-09 16:39:16', '2021-01-27 11:24:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2588, 'o1qmn5FRBEaVDpZ_DQyey5-0wUWw', 0, '2020-12-09 16:55:56', '2020-12-09 16:55:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2589, 'o1qmn5PnK21lAz-SYFqKoroYdAJI', 0, '2020-12-09 19:24:41', '2020-12-09 19:24:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2590, 'o1qmn5Er7O8vlqgbBpMkWUfgWIi8', 1, '2020-12-09 21:30:52', '2020-12-10 19:53:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2591, 'o1qmn5Ds0XQZ5tPGqSgRAIQLtEMY', 0, '2020-12-09 21:56:20', '2020-12-09 21:56:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2592, 'o1qmn5MbGFWJk76djsk8IynR87oo', 0, '2020-12-09 22:35:17', '2020-12-09 22:35:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2593, 'o1qmn5BcnR599HgElPdgyEH1oAkQ', 0, '2020-12-10 02:10:39', '2020-12-10 02:10:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2594, 'o1qmn5DidcgjcNph0hnM7SsY0p5I', 4, '2020-12-10 02:19:57', '2021-03-18 04:59:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2595, 'o1qmn5NjucQjoKZzT51u-w3VjhfE', 3, '2020-12-10 02:21:07', '2020-12-10 02:21:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2596, 'o1qmn5K118Z6D3yDlP-2-JOUgEfc', 4, '2020-12-10 02:22:54', '2020-12-10 02:23:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2597, 'o1qmn5Bh1Kt6bSkTwiUNJOuoIQsY', 3, '2020-12-10 02:25:54', '2020-12-10 02:26:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2598, 'o1qmn5N0GUChqLbK6ATfRsYPB5TA', 3, '2020-12-10 02:26:41', '2020-12-10 02:26:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2599, 'o1qmn5NaJBKu-XuCJIKncgsE5QWA', 3, '2020-12-10 02:28:08', '2020-12-10 02:28:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2600, 'o1qmn5GjEha6JfCeBeYlaGBlnpIY', 4, '2020-12-10 02:32:42', '2020-12-10 16:51:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2601, 'o1qmn5GC0l5MyyZf6dfMlk-l5Mqc', 5, '2020-12-10 02:36:37', '2021-03-17 06:13:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2602, 'o1qmn5A1SscT3Mha1va022hiQl3k', 4, '2020-12-10 02:41:24', '2020-12-10 02:41:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2603, 'o1qmn5A2ysCT0StvZB9Zr2amAFIY', 3, '2020-12-10 02:50:37', '2020-12-10 02:50:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2604, 'o1qmn5AKzpd67d0lCqk01SCZ2uzQ', 2, '2020-12-10 02:52:08', '2020-12-10 02:52:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2605, 'o1qmn5I-sTohXvHzQGuDz0uv3_aA', 3, '2020-12-10 02:57:16', '2020-12-10 02:57:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2606, 'o1qmn5BKIcKYaNLyGrWyhKVh3eJw', 1, '2020-12-10 04:41:27', '2020-12-10 04:41:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2607, 'o1qmn5GVyYfjaAMDkzortBvCm15o', 1, '2020-12-10 04:48:26', '2020-12-10 04:48:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2608, 'o1qmn5NA-1hKk1chmwDf9PM_4xKs', 0, '2020-12-10 10:48:05', '2020-12-10 10:48:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2609, 'o1qmn5M8a5Ob8BgkpdjoDjx411uE', 0, '2020-12-10 10:49:04', '2020-12-10 10:49:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2610, 'o1qmn5Bgzp6f9e4ADb4g5I8FHl1c', 0, '2020-12-10 10:51:22', '2020-12-10 10:51:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2611, 'o1qmn5F9Kl5UktuWoXewsuuIuPOc', 0, '2020-12-10 10:57:54', '2020-12-10 10:57:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2612, 'o1qmn5Arrj2stuli1aaOEPw00bKo', 0, '2020-12-10 11:05:07', '2020-12-10 11:05:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2613, 'o1qmn5IBEYaQNm7zsYOGTl4NcVwM', 0, '2020-12-10 11:08:42', '2020-12-10 11:08:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2614, 'o1qmn5ACd7WNYf9kuuxK-Qqrd6R4', 0, '2020-12-10 11:17:39', '2020-12-10 11:17:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2615, 'o1qmn5I789PX-z-PB9TGXfBZpynw', 0, '2020-12-10 11:19:14', '2020-12-10 11:19:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2616, 'o1qmn5KrmEoA3bniva1EBVOhIqCA', 0, '2020-12-10 11:20:17', '2020-12-10 11:20:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2617, 'o1qmn5P6-_LAgwLnXB31fiku15ws', 2, '2020-12-10 11:47:46', '2021-01-18 11:00:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2618, 'o1qmn5Axo-WlQBRgCByCPxOgCZfo', 0, '2020-12-10 11:58:49', '2020-12-10 11:58:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2619, 'o1qmn5I_UZhjmaDNtDRbE13QJsaY', 0, '2020-12-10 11:59:45', '2020-12-10 11:59:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2620, 'o1qmn5D0KSbccOX8_VS62ORlrTqY', 0, '2020-12-10 12:12:19', '2020-12-10 12:12:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2621, 'o1qmn5OSLrnOwc3qcYt_bwwC-1QI', 1, '2020-12-10 12:39:24', '2020-12-10 15:51:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2622, 'o1qmn5Coh8FXE7nBqopzXVeVgas8', 0, '2020-12-10 14:36:19', '2020-12-10 14:36:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2623, 'o1qmn5Mp5g6HDNtqXW3AHS6kOUFo', 0, '2020-12-10 14:51:46', '2020-12-10 14:51:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2624, 'o1qmn5EDPJOLbyBR5e8fYMXMgyjA', 1, '2020-12-10 15:25:49', '2020-12-11 09:40:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2625, 'o1qmn5O_PNTCrus2V69v-LISj2Os', 1, '2020-12-10 16:20:44', '2020-12-11 09:43:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2626, 'o1qmn5A_P4pMShOUm191XyouGSX8', 0, '2020-12-10 16:49:18', '2020-12-10 16:49:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2627, 'o1qmn5N6qiy4hB-064_01UI5pQvk', 0, '2020-12-10 17:16:12', '2020-12-10 17:16:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2628, 'o1qmn5NWYURgeCJiqzwvCl7INz9s', 5, '2020-12-10 17:17:35', '2021-01-07 11:36:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2629, 'o1qmn5I39jC4ZNnGsSCwX8_y-VHc', 0, '2020-12-10 21:30:27', '2020-12-10 21:30:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2630, 'o1qmn5MivA5WDZAb7ALs4W5gaObY', 0, '2020-12-10 21:55:33', '2020-12-10 21:55:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2631, 'o1qmn5FgAV0rIuWj4kP6BbXpe918', 0, '2020-12-11 01:03:46', '2020-12-11 01:03:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2632, 'o1qmn5L99j06dFAaHzorQvONR1Wo', 1, '2020-12-11 02:20:44', '2021-03-15 01:27:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2633, 'o1qmn5CN6lkzk-q0AuvEXYn-E3P4', 1, '2020-12-11 02:50:02', '2020-12-21 21:56:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2634, 'o1qmn5CAOwvfx_xt-cPJMGsDY41w', 0, '2020-12-11 05:14:57', '2020-12-11 05:14:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2635, 'o1qmn5FirraC_YwnhO_C05CGrJ0g', 5, '2020-12-11 09:54:43', '2021-01-12 19:35:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2636, 'o1qmn5IheCI-v1DBmlbenQTcIXz0', 9, '2020-12-11 12:28:28', '2020-12-15 20:23:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2637, 'o1qmn5P-WBQuhIwaGASdH8cZFWsg', 1, '2020-12-11 13:02:09', '2020-12-11 13:02:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2638, 'o1qmn5GTh_UGDe9avruXXdTgBsFw', 0, '2020-12-11 13:42:26', '2020-12-11 13:42:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2639, 'o1qmn5JIjFM1_wFYQrM9gG1Q6twk', 8, '2020-12-11 13:44:53', '2021-03-02 10:44:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2640, 'o1qmn5NpkzBg_q09mM71Sd0CXzAs', 0, '2020-12-11 14:19:10', '2020-12-11 14:19:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2641, 'o1qmn5M6EjeMPnSFbYTaKBC8gWW4', 1, '2020-12-11 15:00:35', '2020-12-11 15:01:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2642, 'o1qmn5INNn-sq765tvHKMPk8wot8', 0, '2020-12-11 15:06:55', '2020-12-11 15:06:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2643, 'o1qmn5PkgQjRCALtzmpO8lkLvuMU', 0, '2020-12-11 15:45:02', '2020-12-11 15:45:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2644, 'o1qmn5AgCkwQ8g8V7cV8gZTWofOM', 0, '2020-12-11 17:13:58', '2020-12-11 17:13:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2645, 'o1qmn5KHbtD0m5DU4A-_vK9QPs1E', 0, '2020-12-11 17:51:30', '2020-12-11 17:51:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2646, 'o1qmn5IKaifS9m2b4NmM3L31iSjM', 0, '2020-12-11 19:32:26', '2020-12-11 19:32:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2647, 'o1qmn5EODee-x3Rj5BBEKRPBo7YQ', 0, '2020-12-11 20:27:24', '2020-12-11 20:27:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2648, 'o1qmn5JHa2r0FDuKPKqie7xaJxEc', 1, '2020-12-11 20:36:17', '2020-12-14 15:01:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2649, 'o1qmn5Ippq0J9WiHlk_16x9YvLOg', 0, '2020-12-11 20:52:26', '2020-12-11 20:52:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2650, 'o1qmn5FgB8Ckc3tsH8Lzzn3jBKhU', 0, '2020-12-11 22:31:59', '2020-12-11 22:31:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2651, 'o1qmn5HuwPHEG40AkaDTnK9LQtE0', 0, '2020-12-12 02:08:27', '2020-12-12 02:08:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2652, 'o1qmn5OxapSNSArY0vOkLpIT6RCQ', 2, '2020-12-12 03:02:51', '2020-12-12 03:02:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2653, 'o1qmn5H7CupMldrQgwkf21wyrp7Y', 3, '2020-12-12 03:16:03', '2020-12-12 03:16:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2654, 'o1qmn5GA6pPfrYjTuqSFAQnDIWeE', 2, '2020-12-12 03:24:36', '2020-12-12 03:24:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2655, 'o1qmn5DQkEO-by7SHS_r4e3c0Y-E', 3, '2020-12-12 03:45:05', '2020-12-12 03:45:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2656, 'o1qmn5JgwSGNRbUqUUBeFyD01M9k', 2, '2020-12-12 03:54:24', '2020-12-12 03:54:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2657, 'o1qmn5NQTCTVSveU09HXX11hsxCw', 0, '2020-12-12 05:47:50', '2020-12-12 05:47:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2658, 'o1qmn5FqOz03xEUSMKRQR1FWv3Os', 2, '2020-12-12 11:02:49', '2020-12-13 12:34:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2659, 'o1qmn5C5P5nYb3yxnFzCL2mjD6Uw', 2, '2020-12-12 13:45:01', '2021-03-20 14:20:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2660, 'o1qmn5EtXQVi8cemx36UqxHlZ_5o', 0, '2020-12-12 13:46:09', '2020-12-12 13:46:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2661, 'o1qmn5P9kHWQUtF6r-_V2GzsiXdM', 1, '2020-12-12 14:18:23', '2020-12-16 16:03:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2662, 'o1qmn5L5feNK3MQmsrPSqZmy0Mi8', 0, '2020-12-12 15:25:45', '2020-12-12 15:25:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2663, 'o1qmn5PuCFUAjWnkd4_qu33vHG3Y', 1, '2020-12-12 15:34:46', '2021-01-12 11:37:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2664, 'o1qmn5MloIw2TVK4lYvMwY5apNKs', 2, '2020-12-12 17:22:11', '2020-12-12 17:22:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2665, 'o1qmn5IYBltbmz22s1dCxs7W2J8E', 3, '2020-12-12 17:41:09', '2020-12-12 17:41:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2666, 'o1qmn5K74Hw-UXsimrrMhVDrRtPQ', 3, '2020-12-12 17:45:35', '2020-12-12 17:45:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2667, 'o1qmn5K9nUIgNHkuKlLvVg-g25L4', 0, '2020-12-12 18:33:27', '2020-12-12 18:33:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2668, 'o1qmn5FFqnhvdt73-3KX3bYWcr8M', 1, '2020-12-12 19:41:34', '2020-12-12 19:41:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2669, 'o1qmn5C-UYo4fl8UQjCO_LF_gHJI', 0, '2020-12-13 01:02:37', '2020-12-13 01:02:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2670, 'o1qmn5P4P6DTVGmY9Fx71_Wt_eb4', 0, '2020-12-13 17:14:04', '2020-12-13 17:14:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2671, 'o1qmn5Dfz5HyKF00Yc12lENUr0Rw', 0, '2020-12-13 17:25:27', '2020-12-13 17:25:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2672, 'o1qmn5Ah-m5f3fpThlPlzdFExO34', 0, '2020-12-13 17:27:10', '2020-12-13 17:27:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2673, 'o1qmn5LGX-scWpxVkzcvSmGyTcTg', 0, '2020-12-13 17:58:41', '2020-12-13 17:58:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2674, 'o1qmn5LH8sD6Sr4RQtOyTcIycUVI', 0, '2020-12-13 18:31:14', '2020-12-13 18:31:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2675, 'o1qmn5IppGCWho20NU290nRaKGmA', 0, '2020-12-13 18:53:24', '2020-12-13 18:53:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2676, 'o1qmn5Et75-4SS94BKtD_Tz_0OC4', 0, '2020-12-13 22:30:58', '2020-12-13 22:30:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2677, 'o1qmn5CHYVCLmlUwzUedOpjw0u6E', 0, '2020-12-14 01:52:59', '2020-12-14 01:52:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2678, 'o1qmn5FNIhLv7ulggdX_GuDuCPXY', 3, '2020-12-14 09:35:27', '2021-02-24 13:11:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2679, 'o1qmn5LQZHB1ECnOgHwll8HmKkTs', 0, '2020-12-14 15:14:23', '2020-12-14 15:14:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2680, 'o1qmn5JsNGnd-yiaA_A67ajA_FWY', 0, '2020-12-14 15:26:30', '2020-12-14 15:26:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2681, 'o1qmn5PsXHT6kkkmYuEgv6bjWxqI', 0, '2020-12-14 15:48:24', '2020-12-14 15:48:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2682, 'o1qmn5LcuZqhSBFiYlG9FK4uw1Tw', 0, '2020-12-14 16:35:40', '2020-12-14 16:35:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2683, 'o1qmn5KI2uiI-AbFKNUncecqwcNI', 0, '2020-12-14 18:20:46', '2020-12-14 18:20:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2684, 'o1qmn5BcKHT0bmXUMLrzCmo5kKs0', 5, '2020-12-14 18:26:29', '2021-01-14 19:26:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2685, 'o1qmn5CIdXfu2RvKLsbkzytHhjAc', 0, '2020-12-14 18:29:08', '2020-12-14 18:29:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2686, 'o1qmn5ItKwgYIqTuyvZYCcBGG2ko', 0, '2020-12-14 19:40:59', '2020-12-14 19:40:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2687, 'o1qmn5F3IWK0HIi7_ttxsrya43JE', 14, '2020-12-14 20:00:35', '2020-12-22 02:11:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2688, 'o1qmn5EX0Vgcxo2g4xmIWKLj4yOg', 0, '2020-12-15 05:36:18', '2020-12-15 05:36:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2689, 'o1qmn5GURjUUvCKHwanBsTSpK1BY', 0, '2020-12-15 13:11:02', '2020-12-15 13:11:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2690, 'o1qmn5O_NTofZJBr7p4IJyAwXC3A', 1, '2020-12-15 14:36:08', '2021-01-02 15:48:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2691, 'o1qmn5PH8ki0fKwnkaR145Yt3Efk', 1, '2020-12-15 15:28:14', '2021-01-04 10:33:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2692, 'o1qmn5ObHNRLc5_ISoha8GuhFwxQ', 2, '2020-12-15 15:29:18', '2021-01-13 18:49:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2693, 'o1qmn5If_g-Rsq6gm4UXyKlXWGSY', 0, '2020-12-15 17:13:12', '2020-12-15 17:13:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2694, 'o1qmn5Gqw78u4ZRGr6DxCTDxxgpw', 0, '2020-12-15 17:15:05', '2020-12-15 17:15:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2695, 'o1qmn5GXXOrQsuJnh4T5pm9TWh3c', 5, '2020-12-15 17:41:07', '2020-12-26 14:03:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2696, 'o1qmn5HpFkmXfKCtdXSHdlSMJ8B0', 0, '2020-12-15 17:46:49', '2020-12-15 17:46:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2697, 'o1qmn5EtMpUiTEJNQFrwhjvfug3o', 0, '2020-12-15 18:31:00', '2020-12-15 18:31:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2698, 'o1qmn5JMWMqax4Yxlo4QkAtKyQGI', 0, '2020-12-15 19:39:24', '2020-12-15 19:39:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2699, 'o1qmn5GRKX2lge_9_kZBIRHDyKgY', 0, '2020-12-15 20:19:15', '2020-12-15 20:19:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2700, 'o1qmn5GRFpqIsUwGzdkCd5-mgTN4', 0, '2020-12-15 21:14:00', '2020-12-15 21:14:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2701, 'o1qmn5D6eST4XHeMtnSxUzofrHYY', 0, '2020-12-15 22:51:57', '2020-12-15 22:51:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2702, 'o1qmn5HTzjN_f4DjssU0SZwkgmCo', 0, '2020-12-15 23:25:10', '2020-12-15 23:25:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2703, 'o1qmn5PH0GGRYAZjuADIK6JXDbt0', 9, '2020-12-16 02:48:24', '2020-12-22 02:28:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2704, 'o1qmn5LP02wvRkEvmynD3NkaGOxc', 3, '2020-12-16 02:53:07', '2020-12-16 02:53:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2705, 'o1qmn5BGfdQ3e6QJr1RM0yor5Ue8', 3, '2020-12-16 03:00:37', '2020-12-16 03:00:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2706, 'o1qmn5Ng3u9Ub9N5WoIDmXaoUAzQ', 10, '2020-12-16 03:10:52', '2020-12-22 02:29:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2707, 'o1qmn5KOFNKd_pVRhzj-XhdLxV7w', 6, '2020-12-16 03:27:43', '2020-12-20 05:30:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2708, 'o1qmn5L0iRfd1hrFq3PMlLHe8IHM', 5, '2020-12-16 03:31:17', '2021-03-28 12:55:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2709, 'o1qmn5Iz10chE4bWtXqAi_xYEMek', 1, '2020-12-16 03:57:18', '2020-12-21 01:16:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2710, 'o1qmn5JPxgMkG3ucXM7iLfrlWxoo', 0, '2020-12-16 04:51:12', '2020-12-16 04:51:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2711, 'o1qmn5CRrj4KBIxJWCE-rX3St9AY', 12, '2020-12-16 05:59:11', '2021-03-28 12:30:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2712, 'o1qmn5Ow4utg0KTCvdiXfrMEvwJE', 0, '2020-12-16 08:56:55', '2020-12-16 08:56:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2713, 'o1qmn5JBi1gOnX-bWGL2NbJWEqsk', 6, '2020-12-16 11:38:46', '2021-03-22 17:35:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2714, 'o1qmn5KXhiaGlnSjdLbFuyI99BV8', 0, '2020-12-16 14:28:16', '2020-12-16 14:28:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2715, 'o1qmn5BK8djQi1TLz6E8JyrYoOB0', 0, '2020-12-16 15:22:14', '2020-12-16 15:22:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2716, 'o1qmn5KWkgvk9xYEennxUTFlJDW0', 1, '2020-12-16 16:27:43', '2021-01-09 16:42:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2717, 'o1qmn5FlCd2NOuDIoz1QY_yzTjdM', 0, '2020-12-16 16:36:39', '2020-12-16 16:36:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2718, 'o1qmn5NQr_EL9cJAiLMz27jqFTUc', 1, '2020-12-16 17:13:35', '2021-03-28 12:28:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2719, 'o1qmn5L37xXlBMPr2i65-rxIhu3c', 0, '2020-12-16 17:33:29', '2020-12-16 17:33:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2720, 'o1qmn5Mh3nKfct_QDrl5Y4JnvITA', 0, '2020-12-16 17:41:46', '2020-12-16 17:41:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2721, 'o1qmn5Eqap4ByuXJy9f8HGatA-vw', 0, '2020-12-16 18:35:09', '2020-12-16 18:35:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2722, 'o1qmn5ASyLbb03n6nXei79bkYr-8', 0, '2020-12-16 18:45:38', '2020-12-16 18:45:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2723, 'o1qmn5MiU6q-GswLfBIXY_gn32RM', 0, '2020-12-16 18:57:52', '2020-12-16 18:57:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2724, 'o1qmn5GyKaBXmfQzZGsEi9c1sCvM', 1, '2020-12-16 18:58:15', '2020-12-17 08:40:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2725, 'o1qmn5MAvH7k0ZLKZalpq9YTBsUg', 0, '2020-12-16 21:25:38', '2020-12-16 21:25:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2726, 'o1qmn5No3HuQWBwwp8GdK1hhSPqk', 0, '2020-12-16 22:41:06', '2020-12-16 22:41:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2727, 'o1qmn5ODdXvSSSWYJb1xKMnLm-gU', 2, '2020-12-16 23:30:41', '2020-12-22 05:42:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2728, 'o1qmn5DEW8iysbFtMyUNg0W1WlMw', 0, '2020-12-17 05:47:16', '2020-12-17 05:47:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2729, 'o1qmn5H06YQmK3jMyfWNVkupaTJY', 2, '2020-12-17 07:17:02', '2021-03-07 19:36:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2730, 'o1qmn5BDbQfNOpvUzC-qnxeG6Lac', 0, '2020-12-17 08:56:45', '2020-12-17 08:56:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2731, 'o1qmn5CwvME6f-eNgmvvZGjbSpns', 1, '2020-12-17 08:57:27', '2021-03-23 07:42:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2732, 'o1qmn5IuoLgti4HLgcUqst273miM', 11, '2020-12-17 11:34:27', '2020-12-22 02:16:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2733, 'o1qmn5NRz6B_PTv84WOMGi5NnkHY', 0, '2020-12-17 14:42:30', '2020-12-17 14:42:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2734, 'o1qmn5AwC7OnLn23wPsWWuYzBdj0', 12, '2020-12-17 14:42:36', '2021-01-12 10:06:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2735, 'o1qmn5AGtsfAi7MP2lbeHFQBo9Xw', 0, '2020-12-17 14:42:45', '2020-12-17 14:42:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2736, 'o1qmn5CtyvEgsrVGAxX8wERFFsxw', 1, '2020-12-17 14:45:13', '2021-02-07 13:46:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2737, 'o1qmn5D-76itweJgJQGxb6QLDQqU', 1, '2020-12-17 15:27:27', '2021-01-07 14:08:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2738, 'o1qmn5P6JRtqReqEBXpGc1T-DQ-I', 3, '2020-12-17 15:33:02', '2021-01-11 17:45:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2739, 'o1qmn5O8eitPb2lcrXqLURkGx-xg', 1, '2020-12-17 16:38:18', '2021-03-03 20:00:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2740, 'o1qmn5NqM8g6BjGsUJuLJEXuDIwY', 0, '2020-12-17 18:06:59', '2020-12-17 18:06:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2741, 'o1qmn5NiSRjM8zzd5u55NwCyYpDc', 6, '2020-12-17 20:37:23', '2021-03-18 13:53:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2742, 'o1qmn5LVHrtvx_FNVhANS6RRX7OA', 1, '2020-12-17 21:32:44', '2020-12-22 03:23:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2743, 'o1qmn5FJvpaSKWy1mlUe4Pr0La8I', 0, '2020-12-18 00:40:49', '2020-12-18 00:40:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2744, 'o1qmn5BLN2wkuVty7JNCXhj0n5rk', 6, '2020-12-18 02:49:43', '2020-12-20 21:23:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2745, 'o1qmn5JZ5WlEqMMoO4H_mREvHzQc', 0, '2020-12-18 02:49:56', '2020-12-18 02:49:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2746, 'o1qmn5PSbtGOtERJ5X5E4sodPiZc', 22, '2020-12-18 05:08:01', '2020-12-22 02:54:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2747, 'o1qmn5I6i6LggMrVdGt41wk0XLSg', 0, '2020-12-18 10:28:20', '2020-12-18 10:28:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2748, 'o1qmn5JRkpK2KsygkHZVxlkfRHtU', 1, '2020-12-18 10:49:50', '2020-12-19 14:21:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2749, 'o1qmn5D6lqxZHGVZYmnG-JzMnTeU', 1, '2020-12-18 12:52:32', '2020-12-19 12:54:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2750, 'o1qmn5JhMbiVtxtsk01GEBP0SXb0', 2, '2020-12-18 17:42:40', '2021-01-16 23:00:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2751, 'o1qmn5Bw3UEvunQyohMWFNDLk0hY', 0, '2020-12-18 18:05:36', '2020-12-18 18:05:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2752, 'o1qmn5NORB-I46-dEW17gv3yvNmo', 1, '2020-12-18 19:33:50', '2020-12-22 18:32:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2753, 'o1qmn5O68XS_4cw6bN0w-ZN5Pa3s', 13, '2020-12-19 02:20:12', '2020-12-19 02:21:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2754, 'o1qmn5AIJ4tjJRmpABLR-hfZFC-4', 5, '2020-12-19 02:25:32', '2021-03-29 01:20:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2755, 'o1qmn5BAAxpxmnmdZz1vCW7zUAOc', 0, '2020-12-19 07:22:39', '2020-12-19 07:22:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2756, 'o1qmn5DUP6S0Ar1ovQldcFJ4Mg1g', 0, '2020-12-19 09:52:27', '2020-12-19 09:52:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2757, 'o1qmn5MbxD51gsvzqR1ms8h2k_TY', 1, '2020-12-19 11:03:33', '2020-12-21 09:30:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2758, 'o1qmn5HffpNnhXlOQA6fx0Q7cT0k', 1, '2020-12-19 11:07:59', '2020-12-24 12:32:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2759, 'o1qmn5KtEQ8KzuEnbHdZitNjiIB4', 0, '2020-12-19 13:17:09', '2020-12-19 13:17:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2760, 'o1qmn5AqAwPbWx1VbLrZwJXBZNA0', 0, '2020-12-19 13:18:20', '2020-12-19 13:18:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2761, 'o1qmn5Bc2ibtbj1TwhYg5u6j4AGY', 0, '2020-12-19 15:07:31', '2020-12-19 15:07:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2762, 'o1qmn5Err1ep7PeqhkQos4sGTzSQ', 2, '2020-12-19 20:51:09', '2021-03-28 12:55:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2763, 'o1qmn5C-0Bs6DqlAdOr3mvGztKBg', 0, '2020-12-19 21:28:23', '2020-12-19 21:28:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2764, 'o1qmn5KPgUVIKGyk1mF4vvuxO-8I', 5, '2020-12-20 02:03:07', '2021-03-28 12:55:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2765, 'o1qmn5PTolQInsoLqO5QtxDE97L4', 4, '2020-12-20 02:05:36', '2020-12-20 02:05:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2766, 'o1qmn5Ooa0ceavqt5hZMdOnxDxMo', 3, '2020-12-20 02:08:50', '2020-12-20 02:08:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2767, 'o1qmn5IyB5XtjmFMdV2bH8by1lHw', 12, '2020-12-20 02:09:58', '2020-12-20 02:20:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2768, 'o1qmn5Gb8TUMc2I9dUusnRKZv4Xw', 3, '2020-12-20 02:35:58', '2020-12-20 02:36:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2769, 'o1qmn5LkOPUp2V86jZhF8azc3UcM', 8, '2020-12-20 02:36:03', '2020-12-22 02:35:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2770, 'o1qmn5BtQCA4yr41DTQYNS6U-PtI', 3, '2020-12-20 02:47:35', '2020-12-20 02:47:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2771, 'o1qmn5L8dW5W70x100oOnRZECIaM', 4, '2020-12-20 02:49:03', '2020-12-20 02:49:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2772, 'o1qmn5C0YakIfCqNl2TuyaFygPbk', 5, '2020-12-20 02:49:32', '2020-12-20 02:49:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2773, 'o1qmn5N99Vd2JWOUwNzIOVp177QY', 4, '2020-12-20 02:49:46', '2020-12-20 02:50:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2774, 'o1qmn5MYVzEDCqnHVf5j2xf2MlwI', 4, '2020-12-20 02:54:57', '2020-12-20 02:55:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2775, 'o1qmn5GA1FdnnO4KsE82JuSMRspQ', 5, '2020-12-20 02:54:58', '2020-12-20 02:55:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2776, 'o1qmn5O_s-x6nv8r0W29ObNuT9GA', 6, '2020-12-20 02:57:01', '2020-12-20 02:57:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2777, 'o1qmn5PoSFu3KYT5vtvTSLY0sIyU', 7, '2020-12-20 02:57:06', '2020-12-20 02:57:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2778, 'o1qmn5KfW2zxkWA-FUZOjU92jPHA', 7, '2020-12-20 02:57:48', '2020-12-20 02:58:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2779, 'o1qmn5GGlPWtOfaE8T4w2YQ4bAR0', 5, '2020-12-20 02:58:58', '2021-03-28 04:12:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2780, 'o1qmn5OPD66DQ5lE23XfzWOD5sTg', 6, '2020-12-20 03:02:23', '2020-12-20 03:02:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2781, 'o1qmn5A6WK_w4CiKxPrifbPgQeB0', 9, '2020-12-20 03:03:21', '2020-12-22 03:26:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2782, 'o1qmn5HM_aIdJE6bzALq8Hx4z-Mw', 4, '2020-12-20 03:04:03', '2020-12-22 19:19:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2783, 'o1qmn5PIqFSbSue7fW-jt-wHy2LE', 5, '2020-12-20 03:04:21', '2020-12-20 03:04:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2784, 'o1qmn5KKjQ32mxCeGFehRS-hgulk', 4, '2020-12-20 03:05:35', '2020-12-20 03:05:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2785, 'o1qmn5LGNXEvJPyvO3uCMRpAwyu4', 5, '2020-12-20 03:05:38', '2020-12-20 03:05:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2786, 'o1qmn5BEn-L7XaAWc_Y-0SG4yHBk', 3, '2020-12-20 03:07:37', '2020-12-20 03:07:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2787, 'o1qmn5MZZXVoPfW13DntzlLkSmW0', 1, '2020-12-20 05:21:00', '2020-12-20 05:21:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2788, 'o1qmn5MBNuUGC5t5RnkWlwqWA-Qk', 3, '2020-12-20 05:25:47', '2020-12-20 05:27:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2789, 'o1qmn5LYtMdQWkHsF8Ikuh6CBf48', 1, '2020-12-20 05:27:26', '2020-12-20 05:27:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2790, 'o1qmn5PHI1i2kJM3LTpTl11Ru6aE', 1, '2020-12-20 05:27:35', '2020-12-20 05:27:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2791, 'o1qmn5EhlkFTxw9FI5f-mbuQsw98', 3, '2020-12-20 05:37:04', '2021-03-25 05:18:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2792, 'o1qmn5IuHDx6AWgXcxf4ftz0P8YU', 1, '2020-12-20 05:40:14', '2020-12-20 05:40:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2793, 'o1qmn5IJBELIzjK-m10O8wR8pJe8', 3, '2020-12-20 12:31:06', '2020-12-21 13:33:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2794, 'o1qmn5KT6c5B89bNlaSaQvM7okbI', 1, '2020-12-20 12:31:23', '2020-12-20 16:18:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2795, 'o1qmn5J3eSh6VlGs8oDUXYvhaQNo', 2, '2020-12-20 12:33:49', '2020-12-21 10:16:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2796, 'o1qmn5NLk0kE4en2N4po9he2jmuY', 0, '2020-12-20 13:20:39', '2020-12-20 13:20:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2797, 'o1qmn5A4Sgk7pZpjVUdqw6GeHV98', 0, '2020-12-20 18:49:47', '2020-12-20 18:49:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2798, 'o1qmn5JOgX9EoZBbE0u46YkZoKIo', 1, '2020-12-20 21:56:18', '2020-12-23 19:41:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2799, 'o1qmn5OrmKKcfwtGuMexkXiwIkQ8', 1, '2020-12-21 03:19:23', '2020-12-22 02:22:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2800, 'o1qmn5Alr8PpUgjDMbIZJwP6WUgE', 0, '2020-12-21 09:37:42', '2020-12-21 09:37:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2801, 'o1qmn5OYL3O9r0u0kZqJxPg55Ax8', 2, '2020-12-21 10:06:13', '2020-12-24 19:14:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2802, 'o1qmn5LcDNSx5Ts_mhv67SqI2lqw', 3, '2020-12-21 11:21:09', '2020-12-22 11:33:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2803, 'o1qmn5EFCfGbRtd_0gDmwXPVyCPw', 0, '2020-12-21 11:34:45', '2020-12-21 11:34:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2804, 'o1qmn5NZfWoBNFaDBnxkS5QMD-Xg', 0, '2020-12-21 11:36:00', '2020-12-21 11:36:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2805, 'o1qmn5I4yScsDHJpLh2-9QyfInfM', 1, '2020-12-21 12:27:46', '2021-01-01 16:17:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2806, 'o1qmn5FP0-vD883X1HZhuwkVzeRQ', 2, '2020-12-21 13:17:59', '2020-12-22 18:49:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2807, 'o1qmn5J4Gd7C9kZb4pgBu2yrFw6A', 0, '2020-12-21 13:18:36', '2020-12-21 13:18:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2808, 'o1qmn5JJfyPNSiBLvN_VH1BHgtcA', 1, '2020-12-21 13:21:24', '2020-12-22 15:25:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2809, 'o1qmn5HHFBH3ox6aNa0ioFs8EE98', 0, '2020-12-21 13:40:29', '2020-12-21 13:40:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2810, 'o1qmn5B_c0I0PZWPlHjTVZj96U6w', 0, '2020-12-21 14:27:05', '2020-12-21 14:27:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2811, 'o1qmn5KtCbyBIs1TpNFVOwciycHM', 0, '2020-12-21 14:28:12', '2020-12-21 14:28:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2812, 'o1qmn5KtJ-BitLnNKj6zTzKVX1JA', 0, '2020-12-21 17:10:35', '2020-12-21 17:10:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2813, 'o1qmn5Mxoc9yKQul8soO46UfM2H4', 4, '2020-12-21 17:28:17', '2021-02-06 11:52:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2814, 'o1qmn5Htio9aCspXJhvR5vjrIjGI', 0, '2020-12-21 18:41:17', '2020-12-21 18:41:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2815, 'o1qmn5CqQaxTjf8UU57BM0ETIAr0', 0, '2020-12-21 19:28:40', '2020-12-21 19:28:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2816, 'o1qmn5CTC7tZqXIOdw0QS84pT1vI', 0, '2020-12-21 21:39:39', '2020-12-21 21:39:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2817, 'o1qmn5Asgu_4BFta9NF0M3wMagss', 0, '2020-12-21 21:40:48', '2020-12-21 21:40:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2818, 'o1qmn5KAYfjcpQTZXilqx31PaAfs', 0, '2020-12-21 23:08:43', '2020-12-21 23:08:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2819, 'o1qmn5GV9wNiREnJVOnfuq5LIqOk', 0, '2020-12-21 23:42:31', '2020-12-21 23:42:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2820, 'o1qmn5J9hF6AkqwnkdsddMzOQJpY', 0, '2020-12-22 01:52:23', '2020-12-22 01:52:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2821, 'o1qmn5PVKNGEheMwEt7eEtXvXgF8', 14, '2020-12-22 02:04:22', '2020-12-22 02:05:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2822, 'o1qmn5O2muEqUklUu-OMlJXj6-C4', 0, '2020-12-22 02:05:56', '2020-12-22 02:05:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2823, 'o1qmn5NfBrLi4Av2OvfW4TIePzBE', 13, '2020-12-22 02:07:48', '2020-12-22 02:08:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2824, 'o1qmn5DShuWNFq0iwGXsamkB8Q4A', 14, '2020-12-22 02:07:59', '2020-12-22 02:36:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2825, 'o1qmn5APbvZs5f7QD_rKnxoKj_zU', 28, '2020-12-22 02:10:25', '2020-12-22 02:40:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2826, 'o1qmn5N02EKol64XXg7ooCYzJcw0', 0, '2020-12-22 02:10:44', '2020-12-22 02:10:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2827, 'o1qmn5BNgCy8Qm80dY7uNh-VHbEU', 0, '2020-12-22 02:18:49', '2020-12-22 02:18:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2828, 'o1qmn5Lp4_nY1UVS5JsxuNGsSNBM', 0, '2020-12-22 02:19:46', '2020-12-22 02:19:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2829, 'o1qmn5OQi5hlqFRViK59BLKheA-k', 2, '2020-12-22 02:21:30', '2020-12-24 05:49:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2830, 'o1qmn5EzfRJjts9AwmDF5PiSfPQs', 0, '2020-12-22 02:23:55', '2020-12-22 02:23:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2831, 'o1qmn5DWxdzoCeg9ZIUKyeh3XEv0', 1, '2020-12-22 02:26:58', '2020-12-23 03:35:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2832, 'o1qmn5MjxG9lFe48aJdO6f8B419g', 19, '2020-12-22 02:28:04', '2020-12-22 02:42:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2833, 'o1qmn5JbvfbvfLZQ5Kf9WHXJYQvw', 13, '2020-12-22 02:31:05', '2020-12-22 02:31:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2834, 'o1qmn5J1lRZK4FDcEILq0rB3Z4kU', 14, '2020-12-22 02:35:50', '2020-12-22 02:37:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2835, 'o1qmn5KGw2qmz0oh74rwwF116fRE', 1, '2020-12-22 02:38:35', '2020-12-22 04:55:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2836, 'o1qmn5N7J8BzXLnVhS_W5iPiDDXo', 15, '2020-12-22 02:43:36', '2021-03-26 06:33:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2837, 'o1qmn5EhCcZmLw6-nyc-fg-SFObg', 5, '2020-12-22 02:50:47', '2020-12-23 16:16:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2838, 'o1qmn5Kd_xqeLB7oQWV-dXREGfPo', 13, '2020-12-22 02:51:49', '2020-12-22 02:53:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2839, 'o1qmn5ON01JN6gvAtIYp3Ro9djgQ', 3, '2020-12-22 02:51:52', '2020-12-22 02:52:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2840, 'o1qmn5KCMGUpcBjIjC0qu1515rzE', 4, '2020-12-22 02:55:51', '2020-12-22 02:56:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2841, 'o1qmn5K8ON7NMOeuqL8fybmauXhg', 4, '2020-12-22 03:00:30', '2020-12-23 05:47:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2842, 'o1qmn5OUy7HEO7sHKaeD9nr6DYTI', 3, '2020-12-22 03:03:55', '2020-12-22 03:04:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2843, 'o1qmn5AzML50Zi0yZdrGut6dAIoY', 13, '2020-12-22 03:06:30', '2020-12-22 03:07:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2844, 'o1qmn5NASRUhz3ZvTF6MhFvyFv7M', 4, '2020-12-22 03:08:31', '2020-12-22 03:08:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2845, 'o1qmn5F9lREE_ENYbgWSgDR6Fh9g', 3, '2020-12-22 03:15:44', '2020-12-22 03:16:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2846, 'o1qmn5Gj3CCJZ8RT5TAINioCdJCo', 3, '2020-12-22 03:17:30', '2020-12-22 03:17:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2847, 'o1qmn5LGjgAAIky5z_RasZQornpU', 0, '2020-12-22 03:33:14', '2020-12-22 03:33:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2848, 'o1qmn5Du969ohY3sTo_Zj5wWQ9gs', 0, '2020-12-22 05:47:47', '2020-12-22 05:47:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2849, 'o1qmn5C86d41vrZvYTWxMXUXdKsc', 6, '2020-12-22 09:50:31', '2021-03-27 08:13:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2850, 'o1qmn5JT4hMhZfakeQIxZNx4l9pc', 0, '2020-12-22 11:37:58', '2020-12-22 11:37:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2851, 'o1qmn5PY2ido_Arpx_0yT4PDUX-s', 5, '2020-12-22 11:57:59', '2021-03-22 22:54:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2852, 'o1qmn5ItWJB8NotnusXnpPmNUbCI', 2, '2020-12-22 12:14:06', '2020-12-22 16:21:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2853, 'o1qmn5KvgfHcRAtpc0g8hDn1pLso', 0, '2020-12-22 13:25:03', '2020-12-22 13:25:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2854, 'o1qmn5PcIQwiN7sSMZOneZG78p3I', 0, '2020-12-22 14:10:54', '2020-12-22 14:10:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2855, 'o1qmn5AB9WoWJSta70us6t2DVRs4', 0, '2020-12-22 15:02:56', '2020-12-22 15:02:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2856, 'o1qmn5B-RQ0LaWRZ4RvOANAy5YQE', 0, '2020-12-22 15:03:43', '2020-12-22 15:03:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2857, 'o1qmn5Lc1i81FhTHnZKbBEk5CaCU', 5, '2020-12-22 15:05:23', '2021-03-20 22:19:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2858, 'o1qmn5IWbvGllcOte_5jIVJ95CDE', 1, '2020-12-22 15:06:56', '2020-12-26 15:01:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2859, 'o1qmn5CZZybFaVOaU1YZw1y7Y01Y', 1, '2020-12-22 15:39:48', '2020-12-22 16:20:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2860, 'o1qmn5N5Y1tPKeGmMIb8zR_DAvfQ', 0, '2020-12-22 16:47:37', '2020-12-22 16:47:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2861, 'o1qmn5HvKsxsG1dAfP8ElHLEUjX0', 0, '2020-12-22 16:56:06', '2020-12-22 16:56:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2862, 'o1qmn5G4l-ekUHlxmcIaJ9v3fiB0', 0, '2020-12-22 19:32:36', '2020-12-22 19:32:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2863, 'o1qmn5A5yvpwjnP4X6IAuAYn_wiM', 1, '2020-12-23 11:39:35', '2020-12-23 12:12:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2864, 'o1qmn5NDvmBCAL0VsdUOitYUy8p8', 0, '2020-12-23 12:14:14', '2020-12-23 12:14:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2865, 'o1qmn5Gk7nKVzyIdrWUDoutarzh8', 0, '2020-12-23 12:39:31', '2020-12-23 12:39:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2866, 'o1qmn5HpDIbRQecsF6T6wDU4yCW4', 0, '2020-12-23 13:44:22', '2020-12-23 13:44:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2867, 'o1qmn5OaAjh9HVC9CLPx27KMoopo', 5, '2020-12-23 13:50:48', '2021-03-17 14:54:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2868, 'o1qmn5BSGLSgpY0an1gq5ad-t6jw', 0, '2020-12-23 14:46:21', '2020-12-23 14:46:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2869, 'o1qmn5Ig2uzNhWTHUWdcXm90nl40', 1, '2020-12-23 17:17:14', '2020-12-25 17:08:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2870, 'o1qmn5MZui89spmDE1pppACgOGWw', 0, '2020-12-24 08:40:02', '2020-12-24 08:40:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2871, 'o1qmn5CIUd7wzdhrVUdBAv-PhO_Y', 0, '2020-12-24 09:24:05', '2020-12-24 09:24:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2872, 'o1qmn5MViWJV0Dle7DSdkz1foPV8', 4, '2020-12-24 09:54:58', '2021-01-20 15:42:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2873, 'o1qmn5GhxuG6nooALzPhNdpcmUd4', 0, '2020-12-24 10:25:42', '2020-12-24 10:25:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2874, 'o1qmn5HjIqSsSZXoDqTfC4ucQqG0', 1, '2020-12-24 11:32:42', '2020-12-27 20:24:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2875, 'o1qmn5JM1UpVk_yvi8ukGgFEh2K4', 0, '2020-12-24 11:39:46', '2020-12-24 11:39:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2876, 'o1qmn5Hp1rhW5oxxWcotQPAF1vq8', 0, '2020-12-24 11:46:40', '2020-12-24 11:46:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2877, 'o1qmn5GkLnBdNUET6oyu40h70BeU', 0, '2020-12-24 12:27:41', '2020-12-24 12:27:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2878, 'o1qmn5IMe3yOCUEWtT55-taOpw28', 0, '2020-12-24 12:32:07', '2020-12-24 12:32:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2879, 'o1qmn5L6HZE7SyyzPvaqcDtJupNo', 0, '2020-12-24 12:52:09', '2020-12-24 12:52:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2880, 'o1qmn5GO8Pt06ghEgcP9lN2jxCWo', 0, '2020-12-24 13:47:48', '2020-12-24 13:47:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2881, 'o1qmn5B-4kN47hXbWTs0kB9r1G-Q', 1, '2020-12-24 15:18:30', '2020-12-25 14:34:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2882, 'o1qmn5AZdArgjJg4qYLDR62kSUuo', 0, '2020-12-24 15:23:57', '2020-12-24 15:23:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2883, 'o1qmn5AqLOyD_EY09Bg7EYqbgWnY', 1, '2020-12-24 16:13:26', '2020-12-28 02:07:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2884, 'o1qmn5DAlICJo8DY4nVAAkEQ5L9U', 0, '2020-12-24 19:23:06', '2020-12-24 19:23:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2885, 'o1qmn5AggGocTZlkeSfu00wPorfc', 2, '2020-12-24 19:24:09', '2020-12-24 19:24:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2886, 'o1qmn5CJmhPFAhe-eELKeLfGdvo8', 0, '2020-12-24 22:11:30', '2020-12-24 22:11:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2887, 'o1qmn5NqnqDMwabkrSHbS_BX3k34', 1, '2020-12-25 05:55:21', '2020-12-27 06:05:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2888, 'o1qmn5GTLZI1Cj1f7uaxOne-zqpQ', 11, '2020-12-25 11:46:47', '2021-03-28 14:15:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2889, 'o1qmn5G1qk7vS_2iEF8qIoejFuPE', 0, '2020-12-25 11:51:58', '2020-12-25 11:51:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2890, 'o1qmn5LOqjt0r6xYUT5tzmarAwwA', 1, '2020-12-25 14:33:38', '2020-12-25 15:02:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2891, 'o1qmn5IWQpWhJ-0riFUrfDJ_g9Co', 0, '2020-12-25 15:53:22', '2020-12-25 15:53:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2892, 'o1qmn5EbIxZ4mcEULUo76OmO6N_A', 0, '2020-12-25 20:10:40', '2020-12-25 20:10:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2893, 'o1qmn5IRaB-h2qOrxjjm8o3v7Wxg', 0, '2020-12-26 05:47:16', '2020-12-26 05:47:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2894, 'o1qmn5H2q3otegkaZolzeGO4s8dc', 0, '2020-12-26 06:19:04', '2020-12-26 06:19:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2895, 'o1qmn5CgrKLzB9XwzsC_ZsO3bick', 0, '2020-12-26 06:19:41', '2020-12-26 06:19:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2896, 'o1qmn5DvADiQZTMjX4KSr0f9jBx4', 0, '2020-12-26 06:19:45', '2020-12-26 06:19:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2897, 'o1qmn5JJezrw_TfWxkttJ_YbQbDU', 0, '2020-12-26 06:20:17', '2020-12-26 06:20:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2898, 'o1qmn5A3_8AoDIdsPt3vDbh7DDl4', 4, '2020-12-26 06:20:45', '2021-01-01 04:58:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2899, 'o1qmn5OgPQS-5EY-O0IbWr39sOVE', 0, '2020-12-26 06:21:00', '2020-12-26 06:21:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2900, 'o1qmn5Aywt6VmEIv5uzz0Z9hnMjI', 14, '2020-12-26 06:55:32', '2020-12-26 09:55:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2901, 'o1qmn5C4M1_tywtbGy0FJqk9PwaA', 0, '2020-12-26 07:03:38', '2020-12-26 07:03:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2902, 'o1qmn5IqDPDbAeJ2eG_i6LaACyNM', 0, '2020-12-26 07:05:16', '2020-12-26 07:05:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2903, 'o1qmn5M1iZVHaAkyrgZcy_BVK4Vo', 0, '2020-12-26 07:06:10', '2020-12-26 07:06:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2904, 'o1qmn5NGcc7CpvnKm1BcgI1DyCGk', 0, '2020-12-26 07:06:20', '2020-12-26 07:06:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2905, 'o1qmn5NaeQrsLNbyoiDcVRBwOnp0', 0, '2020-12-26 07:06:32', '2020-12-26 07:06:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2906, 'o1qmn5LP__jdbDy-BqLBvuom55zA', 4, '2020-12-26 07:06:41', '2021-01-01 03:20:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2907, 'o1qmn5DKHF4XPfHTWAkSMEvNxebw', 0, '2020-12-26 07:07:04', '2020-12-26 07:07:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2908, 'o1qmn5F1Ptf13zmgbyAz9h2vLDKY', 0, '2020-12-26 07:07:35', '2020-12-26 07:07:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2909, 'o1qmn5D4XYmIa0vowKqB0aKGptE4', 0, '2020-12-26 08:03:52', '2020-12-26 08:03:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2910, 'o1qmn5MjtQlihc7FeCL9C4l1HH-g', 0, '2020-12-26 09:51:26', '2020-12-26 09:51:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2911, 'o1qmn5Cr0VSNR_B6XE0iaFsl_EXo', 5, '2020-12-26 09:58:43', '2020-12-26 09:58:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2912, 'o1qmn5JuSUnWlnKyMNdp-GhOmntU', 4, '2020-12-26 10:02:15', '2020-12-26 10:02:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2913, 'o1qmn5NSIwnwNXJe9hKI1jQPMwSs', 5, '2020-12-26 10:03:51', '2020-12-26 10:04:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2914, 'o1qmn5KXPrBcVtMlKwtx5S4iUj4o', 4, '2020-12-26 10:03:51', '2020-12-26 10:04:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2915, 'o1qmn5LwrFrXy4Ew7gm4MnI3lndU', 5, '2020-12-26 10:03:52', '2020-12-31 00:22:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2916, 'o1qmn5OusWWnu7GddUKdI4bGn5I8', 5, '2020-12-26 10:08:50', '2020-12-29 23:15:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2917, 'o1qmn5Jq9fMQI4_5iJjuifIcQfTA', 4, '2020-12-26 10:14:51', '2020-12-26 10:15:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2918, 'o1qmn5DJSEW-ep11FrLgC69n7J80', 2, '2020-12-26 12:02:02', '2020-12-28 03:01:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2919, 'o1qmn5AS58XT7H-oBdKscmY3qRAA', 1, '2020-12-26 13:21:52', '2020-12-26 14:58:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2920, 'o1qmn5NULO64m59-Asd04f3OFmJY', 0, '2020-12-26 14:42:34', '2020-12-26 14:42:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2921, 'o1qmn5ByZvwAgsGCaBGNHT-aVPi8', 0, '2020-12-26 15:01:02', '2020-12-26 15:01:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2922, 'o1qmn5A9SlWaxV13SFlKyL8vNsRk', 0, '2020-12-26 15:02:58', '2020-12-26 15:02:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2923, 'o1qmn5KaDBQuGDqCjaNEE6-0bl6Q', 0, '2020-12-26 15:08:31', '2020-12-26 15:08:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2924, 'o1qmn5PTakh8GjsLwQW806Gbb-Cc', 0, '2020-12-26 15:21:30', '2020-12-26 15:21:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2925, 'o1qmn5BFkmKzrKkVNFKZR-6J9V_U', 0, '2020-12-26 15:27:26', '2020-12-26 15:27:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2926, 'o1qmn5GXOS4eX4N621F05nBmZeos', 0, '2020-12-26 23:16:59', '2020-12-26 23:16:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2927, 'o1qmn5LQ6gJFxykJ93LtZL78psDA', 3, '2020-12-27 03:07:17', '2020-12-27 03:07:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2928, 'o1qmn5O8s2UN0sVfz2OmF8_963HI', 3, '2020-12-27 03:22:21', '2020-12-27 03:22:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2929, 'o1qmn5JPioP6XyCUP2UtfcRUm_eY', 3, '2020-12-27 03:39:43', '2020-12-27 03:40:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2930, 'o1qmn5F0rxxkfPSO3Hni84FWmvjM', 4, '2020-12-27 03:42:36', '2020-12-27 03:42:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2931, 'o1qmn5J-zvVSPcr4Uo30qNrM1hTM', 4, '2020-12-27 03:50:33', '2020-12-27 03:50:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2932, 'o1qmn5CpP0OMbbkiWNKehTjBR2QY', 4, '2020-12-27 03:53:01', '2020-12-29 17:49:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2933, 'o1qmn5PK5LdyHT67ec4AF92Ck12o', 3, '2020-12-27 04:22:35', '2020-12-27 04:22:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2934, 'o1qmn5MxGKJEJDzx9ALMKlv1oxv4', 0, '2020-12-27 10:20:37', '2020-12-27 10:20:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2935, 'o1qmn5OAEvKvOJWGHSGp5_WibH2c', 0, '2020-12-27 12:50:34', '2020-12-27 12:50:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2936, 'o1qmn5HQgAiJe8HEV7PLJPNOZjFM', 0, '2020-12-27 18:44:16', '2020-12-27 18:44:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2937, 'o1qmn5JP4muvn0gkCEGNPOxF4quk', 3, '2020-12-28 02:13:38', '2020-12-28 02:14:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2938, 'o1qmn5OnMRJb-AggrZ7wCtYfm1EY', 2, '2020-12-28 02:18:21', '2020-12-28 02:18:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2939, 'o1qmn5MMurqQKrUuntARdaLxinU0', 0, '2020-12-28 02:29:43', '2020-12-28 02:29:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2940, 'o1qmn5LnAidJIbf9CaVg8DIZTFUo', 13, '2020-12-28 02:48:07', '2020-12-28 02:48:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2941, 'o1qmn5P9bSmnOLj29P2ctDdOYc-M', 3, '2020-12-28 03:17:02', '2020-12-28 03:17:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2942, 'o1qmn5H7sNU8zoPYd5Ksi3uibego', 3, '2020-12-28 03:19:01', '2020-12-28 03:19:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2943, 'o1qmn5JX2fXCc6klY5Hn6zijMVYg', 2, '2020-12-28 03:38:59', '2020-12-28 03:39:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2944, 'o1qmn5C_XdO7HfXK96k3NUf_G2eI', 2, '2020-12-28 03:55:20', '2020-12-28 03:55:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2945, 'o1qmn5KKOps3YV4V4pMYOuuWSW0A', 2, '2020-12-28 04:03:11', '2020-12-28 04:03:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2946, 'o1qmn5EAAD_E4CGjOxzZ9I6gCOuk', 0, '2020-12-28 05:45:06', '2020-12-28 05:45:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2947, 'o1qmn5Kn3kJXvnBw33WV7F8l-sOY', 1, '2020-12-28 05:55:22', '2020-12-28 05:55:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2948, 'o1qmn5FYDbAaL6b7N12mDj2Qyan8', 1, '2020-12-28 07:00:48', '2020-12-28 07:00:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2949, 'o1qmn5G7jBSiuPnVx3spmabGhwxc', 1, '2020-12-28 10:37:18', '2020-12-28 10:53:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2950, 'o1qmn5DS91s9nfZcvOe8bPGaOyxs', 0, '2020-12-28 11:17:26', '2020-12-28 11:17:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2951, 'o1qmn5Bh81fiubidierS9loVEHM0', 0, '2020-12-28 11:42:46', '2020-12-28 11:42:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2952, 'o1qmn5JEiAMG2SeArWrYXOjpcF1Y', 0, '2020-12-28 12:04:13', '2020-12-28 12:04:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2953, 'o1qmn5LtHCP4MzkpMOBhUo-Be09M', 0, '2020-12-28 12:22:20', '2020-12-28 12:22:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2954, 'o1qmn5ONj4ellToCh1RPFGTjMIZU', 0, '2020-12-28 13:13:44', '2020-12-28 13:13:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2955, 'o1qmn5Lc6HzyxZ03hmfr8njDHO1Y', 0, '2020-12-28 13:29:31', '2020-12-28 13:29:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2956, 'o1qmn5D4VFOJKoZRzZgJoQhFqOfY', 0, '2020-12-28 14:22:15', '2020-12-28 14:22:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2957, 'o1qmn5I10WZutJDCRpf4Xw5Hm8Ts', 0, '2020-12-28 14:39:11', '2020-12-28 14:39:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2958, 'o1qmn5GgyHHoRU_i53mlDw5i-Dng', 0, '2020-12-28 15:28:56', '2020-12-28 15:28:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2959, 'o1qmn5ISS_31FgqsSm48tZW-GGPI', 0, '2020-12-28 15:43:00', '2020-12-28 15:43:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2960, 'o1qmn5BGx5UZbvbesJT0rufMuWLI', 0, '2020-12-28 16:01:27', '2020-12-28 16:01:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2961, 'o1qmn5E-bhJyqAuRIHoVdvrfbAXQ', 0, '2020-12-28 18:11:25', '2020-12-28 18:11:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2962, 'o1qmn5AldoWRUeOU9Yj6lUpRZBwk', 0, '2020-12-29 05:36:02', '2020-12-29 05:36:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2963, 'o1qmn5GIne6JptnFLdGMQDmtvKuU', 0, '2020-12-29 08:32:04', '2020-12-29 08:32:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2964, 'o1qmn5KQowuU9D7PSRDcYcqm9RTo', 0, '2020-12-29 08:49:39', '2020-12-29 08:49:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2965, 'o1qmn5Gld0zBG9Yy3UcZ4V56KiFA', 5, '2020-12-29 09:33:04', '2021-01-01 05:16:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2966, 'o1qmn5HWD_ymwm4s56G7cd8XeboI', 2, '2020-12-29 10:02:42', '2021-01-02 13:30:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2967, 'o1qmn5Cs9Kf6dIQBeWoupNyum7io', 1, '2020-12-29 10:43:12', '2021-01-08 13:51:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2968, 'o1qmn5ADJZIy4nEYAX7cit-BkZBw', 2, '2020-12-29 11:08:18', '2021-03-19 17:06:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2969, 'o1qmn5IyI12JBFuxJK5_wZL4_ZNY', 1, '2020-12-29 11:33:59', '2020-12-29 23:15:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2970, 'o1qmn5CGLYwuRVSRbH-U3UkkFQXQ', 1, '2020-12-29 11:43:02', '2020-12-29 11:48:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2971, 'o1qmn5OGy17kWPbdVaSt20Y2BCdM', 4, '2020-12-29 13:47:03', '2021-01-05 16:01:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2972, 'o1qmn5Nouj2B8l6vuv9sZ_eErBmg', 0, '2020-12-29 13:50:43', '2020-12-29 13:50:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2973, 'o1qmn5AcGRuGQsiRZiy6Ln-oRLpI', 0, '2020-12-29 15:15:45', '2020-12-29 15:15:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2974, 'o1qmn5LbDvXjlMmX6A7NiNH6DON4', 0, '2020-12-29 15:27:27', '2020-12-29 15:27:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2975, 'o1qmn5MP265Nsho4AlM5cmFNYXnA', 0, '2020-12-29 18:13:48', '2020-12-29 18:13:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2976, 'o1qmn5JHAReQ4oK_Vu45f19PA8M4', 0, '2020-12-29 19:25:56', '2020-12-29 19:25:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2977, 'o1qmn5DMJfl3k3BTd-FXUz5jrAcY', 0, '2020-12-29 23:10:32', '2020-12-29 23:10:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2978, 'o1qmn5FfqiJXkAuJD6TW9SKYSfII', 0, '2020-12-29 23:14:41', '2020-12-29 23:14:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2979, 'o1qmn5DudT2aP-PpI3fTaFAQnMsc', 1, '2020-12-29 23:15:08', '2020-12-31 09:13:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2980, 'o1qmn5Cv9DYqPXGiD_xQKwsnc6K0', 0, '2020-12-29 23:15:21', '2020-12-29 23:15:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2981, 'o1qmn5HaR0j6UMeNdGy_wRGPRw-8', 0, '2020-12-29 23:15:43', '2020-12-29 23:15:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2982, 'o1qmn5NZLPSZmhjwn77hTxyqKbyc', 0, '2020-12-29 23:16:09', '2020-12-29 23:16:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2983, 'o1qmn5DMO5v8wCL8JT7W2f31Xjok', 0, '2020-12-29 23:16:15', '2020-12-29 23:16:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2984, 'o1qmn5MbHzTkYEjEA1rsCZgEUI2U', 0, '2020-12-29 23:20:01', '2020-12-29 23:20:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2985, 'o1qmn5GBBxsEn5pkt7Q3v5VN8uoA', 6, '2020-12-29 23:20:15', '2020-12-29 23:20:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2986, 'o1qmn5EuOXXN4OtaVmQBwLiwrr1o', 0, '2020-12-30 04:54:08', '2020-12-30 04:54:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2987, 'o1qmn5B9imxSMQrisfH5C8_vPSf0', 1, '2020-12-30 09:52:50', '2021-03-16 11:56:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2988, 'o1qmn5DbLUGN6IJF3gvJMnHH8fH4', 1, '2020-12-30 11:30:03', '2021-01-02 20:13:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2989, 'o1qmn5DCm72WCgQTuAABiQTtcRbs', 0, '2020-12-30 14:17:10', '2020-12-30 14:17:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2990, 'o1qmn5J2ICVASCM_tq-LTpn8i8CY', 5, '2020-12-30 17:02:44', '2021-03-05 19:18:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2991, 'o1qmn5LxGomxSc4PoypVive_SLXo', 0, '2020-12-30 17:08:24', '2020-12-30 17:08:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2992, 'o1qmn5DvdmT4GPPkMm7VZrAMgGv0', 0, '2020-12-30 17:10:57', '2020-12-30 17:10:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2993, 'o1qmn5KpBBJ3fx9ZrM5r2lGR5dyA', 0, '2020-12-30 17:51:20', '2020-12-30 17:51:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2994, 'o1qmn5Maf8-yHQBxr1MaMBouyBhw', 1, '2020-12-30 20:22:01', '2020-12-30 20:37:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2995, 'o1qmn5NBxd150my5kbjt44BgXQAI', 0, '2020-12-30 21:34:53', '2020-12-30 21:34:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2996, 'o1qmn5GQvuzJdUxYSTiWvn5syDKA', 0, '2020-12-30 21:50:02', '2020-12-30 21:50:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2997, 'o1qmn5NoCxFUowkJAcAnx1NKpqgU', 0, '2020-12-30 22:35:26', '2020-12-30 22:35:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2998, 'o1qmn5B1zmF2XrNpI1OdYuArDk3Q', 0, '2020-12-30 23:05:01', '2020-12-30 23:05:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(2999, 'o1qmn5OCMnv39qO6n4ZUD8LpJlOY', 0, '2020-12-30 23:38:48', '2020-12-30 23:38:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3000, 'o1qmn5EIGnSPSJXOmLsONonMnlhk', 1, '2020-12-31 00:12:19', '2020-12-31 02:34:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3001, 'o1qmn5BBf-l6iRLF_6wVI3lqsRdE', 0, '2020-12-31 00:27:25', '2020-12-31 00:27:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3002, 'o1qmn5PUZYURjAXypdGg-ZAByBsw', 3, '2020-12-31 08:13:24', '2020-12-31 13:09:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3003, 'o1qmn5FRO7EEWz9I8xqaRS69VI_U', 0, '2020-12-31 12:11:35', '2020-12-31 12:11:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3004, 'o1qmn5FZUdySznxndCP0CFQfJxCM', 1, '2020-12-31 12:18:48', '2021-01-04 14:16:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3005, 'o1qmn5NejYiSqu7S1HDhp6SP-m_k', 0, '2020-12-31 13:39:43', '2020-12-31 13:39:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3006, 'o1qmn5Lx7hpznDcKcZ06YYnHGF7o', 0, '2020-12-31 17:09:39', '2020-12-31 17:09:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3007, 'o1qmn5KvsR2lOs95xBAAqyRWTkUg', 1, '2020-12-31 19:09:43', '2021-01-05 22:33:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3008, 'o1qmn5OnQQg6wDJkBRgpce3xHXbQ', 1, '2020-12-31 22:55:32', '2021-01-03 23:35:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3009, 'o1qmn5OWZQWfWCh6P1PfoBomnqEY', 0, '2020-12-31 23:17:09', '2020-12-31 23:17:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3010, 'o1qmn5J1KiuRujJ1xEq6SkdcCieA', 0, '2021-01-01 00:13:30', '2021-01-01 00:13:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3011, 'o1qmn5Nnqy0ZoFgQnA1aR_qzUAY0', 1, '2021-01-01 01:47:14', '2021-01-02 14:35:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3012, 'o1qmn5BcXhK0HRcZp6ysYxupLv0A', 0, '2021-01-01 02:55:37', '2021-01-01 02:55:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3013, 'o1qmn5EI85wO82Q4_c4DdIGK4NVM', 4, '2021-01-01 02:59:45', '2021-01-01 03:00:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3014, 'o1qmn5Mbi6w-RDeXSHuMuw53zTA0', 0, '2021-01-01 04:04:51', '2021-01-01 04:04:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3015, 'o1qmn5MBbQkfnfa4YpFywjMPH4Yo', 3, '2021-01-01 04:55:58', '2021-01-01 04:56:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3016, 'o1qmn5JoyKnqLutJWZr72geKIJQc', 4, '2021-01-01 05:15:28', '2021-01-01 05:15:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3017, 'o1qmn5DK4IkIBiWX8l2HliI6XThE', 0, '2021-01-01 05:35:15', '2021-01-01 05:35:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3018, 'o1qmn5Kydv5cRxqHYfR_odS-Rac0', 3, '2021-01-01 05:52:56', '2021-01-01 05:53:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3019, 'o1qmn5MrFBsW4B6gVnIKVgEDUiwc', 0, '2021-01-01 09:18:59', '2021-01-01 09:18:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3020, 'o1qmn5HEvRqM6CiIsIfUABtEOhjg', 0, '2021-01-01 12:44:13', '2021-01-01 12:44:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3021, 'o1qmn5NLHLcfl1MQP-_FEBR2ukWI', 0, '2021-01-01 13:17:46', '2021-01-01 13:17:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3022, 'o1qmn5GV6mATFUI8XsZ5nLjZMT2g', 0, '2021-01-01 15:01:15', '2021-01-01 15:01:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3023, 'o1qmn5FGoCeIzJxvhQT4HunTLvn4', 0, '2021-01-02 03:07:15', '2021-01-02 03:07:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3024, 'o1qmn5AWSw_3G3gOjFebywsjDKI4', 0, '2021-01-02 14:23:15', '2021-01-02 14:23:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3025, 'o1qmn5IvZsFFaXJU2YmS_3URyE8s', 0, '2021-01-02 19:56:45', '2021-01-02 19:56:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3026, 'o1qmn5JG2PGo2UOxITwui2OJs5Vc', 0, '2021-01-02 23:37:52', '2021-01-02 23:37:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3027, 'o1qmn5NqkCzJCOXMni6TmAr4OZN0', 0, '2021-01-03 09:20:06', '2021-01-03 09:20:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3028, 'o1qmn5KkLgT5tT3NNO-khdy4i06Q', 0, '2021-01-03 10:49:25', '2021-01-03 10:49:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3029, 'o1qmn5KsKb6NwullJpPcOtIhfvoc', 1, '2021-01-03 13:29:35', '2021-01-12 09:01:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3030, 'o1qmn5JuaHfFtonZyJt0PHxrdt-I', 0, '2021-01-03 14:40:08', '2021-01-03 14:40:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3031, 'o1qmn5Jbd7Q1QuwtmtILQ3vg_d88', 0, '2021-01-03 15:32:08', '2021-01-03 15:32:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3032, 'o1qmn5J6rNyuJZ3942jVHQzAzptw', 0, '2021-01-03 15:45:08', '2021-01-03 15:45:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3033, 'o1qmn5HhaOuoXFccyUW0LKA_xvhY', 1, '2021-01-03 21:15:45', '2021-01-04 17:39:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3034, 'o1qmn5PlBzMU5yFG80e4FV6RMTVY', 0, '2021-01-04 05:49:46', '2021-01-04 05:49:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3035, 'o1qmn5J7yUPiVhpuR9MlpsuPDmCg', 0, '2021-01-04 06:29:11', '2021-01-04 06:29:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3036, 'o1qmn5EYU52s5hrJ2Bgxyd0-hpPE', 1, '2021-01-04 09:58:06', '2021-03-27 10:27:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3037, 'o1qmn5GU9scCUlTai_-CFiEZD47I', 6, '2021-01-04 10:14:48', '2021-01-11 18:09:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3038, 'o1qmn5PE98999qIauL9NC4ZHtanM', 0, '2021-01-04 13:13:04', '2021-01-04 13:13:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3039, 'o1qmn5HNewSvqXh5YAbO3gi4r_44', 1, '2021-01-04 15:30:12', '2021-01-04 15:32:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3040, 'o1qmn5LkyvOVZuqFHGIPSFveKafQ', 0, '2021-01-04 18:07:49', '2021-01-04 18:07:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3041, 'o1qmn5CnGx9zK2L-R183c7KhK1_o', 0, '2021-01-04 23:32:48', '2021-01-04 23:32:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3042, 'o1qmn5AYIKTHvuRWsQDRLK4jAe_I', 1, '2021-01-05 04:46:25', '2021-01-12 17:41:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3043, 'o1qmn5DtfHeuYNzsaYrEGWclWFOw', 72, '2021-01-05 08:15:28', '2021-03-26 09:57:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3044, 'o1qmn5El7QklPmAnbcM7wBnLYwIw', 0, '2021-01-05 08:34:22', '2021-01-05 08:34:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3045, 'o1qmn5FotCFLwqcro2ZQC3TR3txQ', 0, '2021-01-05 10:52:52', '2021-01-05 10:52:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3046, 'o1qmn5L6co4LWg0eCX2qSpcicqZ4', 0, '2021-01-05 11:37:18', '2021-01-05 11:37:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3047, 'o1qmn5I9SOz-DCXceQ1q1oYF1J34', 0, '2021-01-05 13:51:44', '2021-01-05 13:51:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3048, 'o1qmn5J6Cmiz5to7c6mwvBYIQwY4', 1, '2021-01-05 16:33:37', '2021-01-05 20:01:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3049, 'o1qmn5PTI05q1qcu4J2PBkHr7R0M', 0, '2021-01-05 17:47:03', '2021-01-05 17:47:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3050, 'o1qmn5KTToNyK6Mw-Z2zG3NnjKes', 0, '2021-01-05 21:26:57', '2021-01-05 21:26:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3051, 'o1qmn5LpqO5JfdLH7QHpIgqH9-zA', 1, '2021-01-05 22:33:36', '2021-03-17 18:58:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3052, 'o1qmn5IYFIHRkbWXEZ_Cd5H7Lttw', 2, '2021-01-05 22:35:07', '2021-01-07 22:25:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3053, 'o1qmn5MUk45BuvLKKl3KKv-JE11s', 4, '2021-01-06 04:57:59', '2021-01-06 04:58:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3054, 'o1qmn5HzcRXIC018fTUJM9DJv2bg', 4, '2021-01-06 05:06:57', '2021-01-06 05:07:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3055, 'o1qmn5F0NRUs-RRl7MBeNJriOYcQ', 9, '2021-01-06 05:23:02', '2021-01-11 04:21:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3056, 'o1qmn5Emekm4TCkQipngObjwkplo', 3, '2021-01-06 05:39:39', '2021-01-06 05:40:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3057, 'o1qmn5D3y6QfTXuZOG06ZNV9lf8o', 4, '2021-01-06 05:44:54', '2021-01-06 05:45:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3058, 'o1qmn5M1Nv7Wby2_f850EWSobTTE', 0, '2021-01-06 05:46:11', '2021-01-06 05:46:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3059, 'o1qmn5KEffY3hE4Ly_Qh-DyrwM4c', 3, '2021-01-06 05:52:12', '2021-01-06 05:52:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3060, 'o1qmn5F6P_3mebRZdRO6_bY_th7E', 5, '2021-01-06 05:54:38', '2021-01-07 06:56:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3061, 'o1qmn5I3gELisWeq1GwPtON-TGTo', 0, '2021-01-06 07:53:45', '2021-01-06 07:53:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3062, 'o1qmn5BLFoirdZo94VRrbadW7Shw', 2, '2021-01-06 10:59:13', '2021-01-20 12:56:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3063, 'o1qmn5LM5ndeG-kBetL97rJOaS8k', 0, '2021-01-06 12:43:38', '2021-01-06 12:43:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3064, 'o1qmn5OxAYv66ei6m4rttTOMv-X0', 0, '2021-01-06 12:44:10', '2021-01-06 12:44:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3065, 'o1qmn5JPnaONgXa915rUCJunwh5M', 1, '2021-01-06 12:49:33', '2021-01-06 19:44:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3066, 'o1qmn5OmTNvIRMvN_U8yZ1xUeqk8', 1, '2021-01-06 13:16:42', '2021-01-06 17:20:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3067, 'o1qmn5MENDThhDgJ8aXY9tgOL_9g', 1, '2021-01-06 13:26:11', '2021-01-20 13:33:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3068, 'o1qmn5DyAEG1OI5dTHxtrg2VHyDE', 3, '2021-01-06 13:27:32', '2021-01-06 13:34:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3069, 'o1qmn5HkcePIZD4FbOoFV8k5vxRw', 0, '2021-01-06 13:57:23', '2021-01-06 13:57:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3070, 'o1qmn5N4AVCpGyS50vt1YhLUgcPw', 1, '2021-01-06 15:22:49', '2021-03-23 21:12:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3071, 'o1qmn5D58HIa3oYU-IoVWzjdihOs', 1, '2021-01-06 16:52:18', '2021-01-24 20:15:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3072, 'o1qmn5PxHW1CqW7_pOSoytMkvFrY', 0, '2021-01-06 17:05:30', '2021-01-06 17:05:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3073, 'o1qmn5AsxjnBwNHaab_AwlArjWzo', 1, '2021-01-06 18:15:26', '2021-03-09 10:12:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3074, 'o1qmn5KsOqBK3f9SebfQKKsX9zdM', 0, '2021-01-06 18:38:19', '2021-01-06 18:38:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3075, 'o1qmn5NmC5s-FXIJWVynJuphQMjY', 0, '2021-01-07 06:05:11', '2021-01-07 06:05:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3076, 'o1qmn5EypEkQ5nYGC0Cg1Y4bXKCU', 0, '2021-01-07 11:04:59', '2021-01-07 11:04:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3077, 'o1qmn5HLHJwubKN6czixXTOk7EFk', 1, '2021-01-07 11:36:54', '2021-01-07 11:37:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3078, 'o1qmn5KP8vjDK-D9kICV0Fx3g5Qw', 0, '2021-01-07 11:38:54', '2021-01-07 11:38:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3079, 'o1qmn5EjgEwX05oVklm2tiAVTmSk', 1, '2021-01-07 12:02:41', '2021-01-28 16:28:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3080, 'o1qmn5C8_-zwcRBfqVXQ_T0DeO44', 0, '2021-01-07 12:02:50', '2021-01-07 12:02:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3081, 'o1qmn5DGNt2KmgWJ-ruuPzIMJ-JE', 0, '2021-01-07 12:15:47', '2021-01-07 12:15:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3082, 'o1qmn5BE0q5UJdEnJECWfn5LLQRM', 4, '2021-01-07 12:29:33', '2021-01-12 16:43:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3083, 'o1qmn5Adgu4LEpHRoDdnTkV8PEgQ', 0, '2021-01-07 12:46:31', '2021-01-07 12:46:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3084, 'o1qmn5C1ZfG1w2DzedmRaWChu4Nk', 0, '2021-01-07 12:49:57', '2021-01-07 12:49:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3085, 'o1qmn5PepZTjFblilsl0MuuifbaQ', 0, '2021-01-07 14:01:44', '2021-01-07 14:01:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3086, 'o1qmn5DLDt5XB9AQ17Q24we18vEA', 4, '2021-01-07 14:51:41', '2021-01-14 15:02:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3087, 'o1qmn5PDoJTcbRvtP-slELkzUNvw', 0, '2021-01-07 14:54:49', '2021-01-07 14:54:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3088, 'o1qmn5LkinP-Du3iCaUvHynC3ilM', 0, '2021-01-07 14:57:43', '2021-01-07 14:57:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3089, 'o1qmn5LTXxzgnfMtS5eHdqgzed1w', 1, '2021-01-07 15:03:50', '2021-01-07 17:10:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3090, 'o1qmn5Fbs4ZAtPVhnvl8TUDhXWww', 0, '2021-01-07 15:20:51', '2021-01-07 15:20:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3091, 'o1qmn5P_O4m90i6tnA3oiHM-5SUI', 0, '2021-01-07 16:09:39', '2021-01-07 16:09:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3092, 'o1qmn5IpVgUQg4NDqIqUz5yWHg98', 0, '2021-01-07 17:09:33', '2021-01-07 17:09:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3093, 'o1qmn5AHHnsegeNEwLEHF_FqvxwI', 0, '2021-01-07 17:19:04', '2021-01-07 17:19:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3094, 'o1qmn5CwMpKoqaEL8P0wECQRzP38', 0, '2021-01-07 17:34:22', '2021-01-07 17:34:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3095, 'o1qmn5FwLC6xWOHujHz8XmWVH3H8', 0, '2021-01-07 18:27:33', '2021-01-07 18:27:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3096, 'o1qmn5CVUxTg2HsyZUodsOOuJypU', 0, '2021-01-07 20:20:24', '2021-01-07 20:20:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3097, 'o1qmn5GonQTL3xI8D_SRqtU0M360', 0, '2021-01-07 23:57:11', '2021-01-07 23:57:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3098, 'o1qmn5MKN4ygulM0zyDD8EqJuprY', 0, '2021-01-08 05:33:29', '2021-01-08 05:33:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3099, 'o1qmn5Kt_aDrG99i4uL41zOpdgT8', 0, '2021-01-08 08:04:21', '2021-01-08 08:04:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3100, 'o1qmn5BEjpANVfkg4llQh1Dx6vvc', 0, '2021-01-08 11:17:12', '2021-01-08 11:17:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3101, 'o1qmn5ETceg3dvec6F2ohcJ_5kSs', 2, '2021-01-08 12:07:01', '2021-03-11 09:13:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3102, 'o1qmn5IBkFv1AaD46kLL1ay_YVQo', 0, '2021-01-08 12:08:36', '2021-01-08 12:08:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3103, 'o1qmn5DNGsAy-fTG6X5q6W_a1MYc', 1, '2021-01-08 13:33:30', '2021-01-08 13:39:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3104, 'o1qmn5H2Udcs2L74FI7b6lEsubmI', 0, '2021-01-08 13:59:59', '2021-01-08 13:59:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3105, 'o1qmn5L101303Zk7Z1p1ONWtuaak', 9, '2021-01-08 17:14:22', '2021-01-14 13:14:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3106, 'o1qmn5K4B61D3M7pKGSar-k4zXdg', 0, '2021-01-08 17:15:43', '2021-01-08 17:15:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3107, 'o1qmn5JbVHbqKU9HwespM8KhuMV4', 0, '2021-01-08 19:52:15', '2021-01-08 19:52:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3108, 'o1qmn5DkNICxXqcxdQjbM2ZKHXnU', 0, '2021-01-09 05:15:26', '2021-01-09 05:15:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3109, 'o1qmn5LKBTNAeAzOZczAlAh6rI7k', 1, '2021-01-09 05:39:20', '2021-01-11 05:59:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3110, 'o1qmn5Ja7suA2olm8L4ycOvjZwSM', 0, '2021-01-09 10:03:15', '2021-01-09 10:03:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3111, 'o1qmn5NTvKR_4GMPq1OOd9lZxpGA', 2, '2021-01-09 10:20:22', '2021-03-15 18:54:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3112, 'o1qmn5HBqdLrfiNPSo-7T3rk5hI8', 0, '2021-01-09 11:15:33', '2021-01-09 11:15:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3113, 'o1qmn5Mof2pzcc7CUORIc_IBopfc', 0, '2021-01-09 12:04:08', '2021-01-09 12:04:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3114, 'o1qmn5KoTxRq58Twcsd_kIehlW34', 0, '2021-01-09 13:47:38', '2021-01-09 13:47:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3115, 'o1qmn5P5z-CeuMjeY1779iKQVaBc', 0, '2021-01-09 14:17:36', '2021-01-09 14:17:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3116, 'o1qmn5HPxabdBUCDQnRsAyu0mxLY', 0, '2021-01-09 20:01:59', '2021-01-09 20:01:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3117, 'o1qmn5AamfKF4PwqysBfeRwXALfE', 2, '2021-01-09 20:39:26', '2021-03-25 16:58:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3118, 'o1qmn5LSzqFKVKMXvkWGMWaK2DIA', 1, '2021-01-10 05:54:07', '2021-01-11 13:50:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3119, 'o1qmn5LSGNZwoH0ApQwLXr7Bq3js', 1, '2021-01-10 13:02:01', '2021-01-11 11:43:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3120, 'o1qmn5Mtn_XNMs-F2WCfC1gwukKc', 0, '2021-01-10 15:37:16', '2021-01-10 15:37:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3121, 'o1qmn5BO_AjYFV-k0OmhYL2HnWWc', 1, '2021-01-10 17:48:13', '2021-03-11 20:48:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3122, 'o1qmn5PK7CFCD4MjqdfxTF0XE_cM', 0, '2021-01-10 20:29:50', '2021-01-10 20:29:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3123, 'o1qmn5HuaXu7cskohi0SGe-THdMg', 0, '2021-01-11 01:08:41', '2021-01-11 01:08:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3124, 'o1qmn5Irc5liKkUmhVNXu8imp9YA', 4, '2021-01-11 03:57:16', '2021-01-11 03:57:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3125, 'o1qmn5MFjuC0UnRecO0y8o4Y9ryI', 4, '2021-01-11 04:42:25', '2021-01-11 04:42:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3126, 'o1qmn5DhI97Yqltz5YkKFhHksppQ', 4, '2021-01-11 05:01:03', '2021-01-11 05:01:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3127, 'o1qmn5CpBXiygPDonRtBBZverPYU', 0, '2021-01-11 05:03:10', '2021-01-11 05:03:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3128, 'o1qmn5DbpnX4LRDBQ58CpPWJSEtc', 3, '2021-01-11 05:27:47', '2021-01-11 05:27:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3129, 'o1qmn5NeYIkI5ek7D0vHyutxMzzQ', 0, '2021-01-11 05:29:31', '2021-01-11 05:29:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3130, 'o1qmn5Lk2mCnUK4546VVLb0ZcSF8', 3, '2021-01-11 05:37:33', '2021-01-11 05:38:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3131, 'o1qmn5Js3llPoXPt5fdJhp3n7ejM', 4, '2021-01-11 05:37:54', '2021-01-11 05:38:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3132, 'o1qmn5GJ6iYPIcdBIb3gb3St7A7M', 0, '2021-01-11 06:19:13', '2021-01-11 06:19:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3133, 'o1qmn5Nas_FPSlJWyB5br64JWahg', 0, '2021-01-11 06:19:24', '2021-01-11 06:19:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3134, 'o1qmn5GjMKFsLF4i69rcMG7Tm0Vw', 0, '2021-01-11 06:20:23', '2021-01-11 06:20:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3135, 'o1qmn5GSO7g0bOmVGDer5svsbQHQ', 1, '2021-01-11 06:20:41', '2021-01-11 17:48:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3136, 'o1qmn5OXM7AuCzKxOrO3wJD3o2i4', 0, '2021-01-11 06:20:48', '2021-01-11 06:20:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3137, 'o1qmn5EqWv7XrIcpFUoQvXSj1oGU', 0, '2021-01-11 06:21:50', '2021-01-11 06:21:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3138, 'o1qmn5IxcLGyUciPVMbV0E9w4JEY', 1, '2021-01-11 07:17:48', '2021-01-11 07:17:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3139, 'o1qmn5AbYCMqjAr3IOhVv47Cty0A', 1, '2021-01-11 07:18:38', '2021-01-13 05:51:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3140, 'o1qmn5N0ef2-1R5-n7tNLIjIjAL4', 0, '2021-01-11 09:37:06', '2021-01-11 09:37:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3141, 'o1qmn5O8KZYYHjFD_6vQYDI9l_DI', 0, '2021-01-11 09:41:38', '2021-01-11 09:41:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3142, 'o1qmn5PzmBnM-InWAApDMmKSeY28', 0, '2021-01-11 12:36:37', '2021-01-11 12:36:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3143, 'o1qmn5GeN8CcgHYztdIqwCTmL1HA', 0, '2021-01-11 12:44:34', '2021-01-11 12:44:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3144, 'o1qmn5Ou1vvxdU0ycdhw9jUuEIag', 0, '2021-01-11 13:40:33', '2021-01-11 13:40:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3145, 'o1qmn5EPCKzO7mWWyabq9-bBA8eI', 0, '2021-01-11 13:48:45', '2021-01-11 13:48:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3146, 'o1qmn5GFW4HvPatyT-mqWPBPSJNI', 0, '2021-01-11 13:51:20', '2021-01-11 13:51:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3147, 'o1qmn5NKyqKiz3ET0Hq60mJmBXNI', 0, '2021-01-11 13:51:48', '2021-01-11 13:51:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3148, 'o1qmn5E7_e0BZ0SgYluOcKnPLdQ8', 0, '2021-01-11 14:08:25', '2021-01-11 14:08:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3149, 'o1qmn5Blie3w_WCoRoYEe-FKMbwk', 0, '2021-01-11 14:46:37', '2021-01-11 14:46:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3150, 'o1qmn5CKcMuIq-SERieDZFLAjojQ', 0, '2021-01-11 16:04:28', '2021-01-11 16:04:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3151, 'o1qmn5AoiUBWoP50zomPrnSknRos', 2, '2021-01-11 17:26:08', '2021-01-12 11:21:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3152, 'o1qmn5B3KNvTIhpKZhcntOjGkkQc', 0, '2021-01-11 20:06:35', '2021-01-11 20:06:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3153, 'o1qmn5NtEbc3SGbK4VBcz2pjkgFs', 0, '2021-01-11 22:29:17', '2021-01-11 22:29:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3154, 'o1qmn5AyX-p0RiWtFzqdyCuI599o', 1, '2021-01-12 09:30:03', '2021-02-12 17:04:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3155, 'o1qmn5CqDcOk89yc5Uwzio88S4AI', 0, '2021-01-12 09:39:47', '2021-01-12 09:39:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3156, 'o1qmn5NhtxpQQgBc4A-ijwQVAajo', 0, '2021-01-12 10:29:34', '2021-01-12 10:29:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3157, 'o1qmn5B_Oyk2AdgzQF9Z_6ZDZ0Gg', 0, '2021-01-12 10:51:06', '2021-01-12 10:51:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3158, 'o1qmn5FBcH88m3Us4N_oBjTxP_hs', 0, '2021-01-12 10:54:23', '2021-01-12 10:54:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3159, 'o1qmn5Od4q-UzIJYzGqqT4Pynn3s', 0, '2021-01-12 10:54:31', '2021-01-12 10:54:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3160, 'o1qmn5Nw1NhgYkLAVPwhnki8gnk4', 1, '2021-01-12 10:59:05', '2021-01-12 14:36:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3161, 'o1qmn5DatXarHN3ejDTdMRM7Zk5A', 0, '2021-01-12 11:21:54', '2021-01-12 11:21:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3162, 'o1qmn5IyvSAQO8OwweIrPDcD5kCI', 0, '2021-01-12 13:51:43', '2021-01-12 13:51:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3163, 'o1qmn5O5p9S1wrFKTPH1HerBVsWA', 0, '2021-01-12 14:04:50', '2021-01-12 14:04:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3164, 'o1qmn5JLHgyaoq7aSGqUXNh34eZA', 2, '2021-01-12 16:18:31', '2021-01-14 16:59:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3165, 'o1qmn5Gh31H7Hia8Ngy7-GLx7CbI', 1, '2021-01-12 16:21:05', '2021-01-15 16:02:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3166, 'o1qmn5Fa2Apnvbk5nyBxnmp7Ec4w', 0, '2021-01-12 16:23:23', '2021-01-12 16:23:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3167, 'o1qmn5IUMJvrrUB2d0gFKdaBzPvE', 1, '2021-01-12 16:44:34', '2021-01-12 16:50:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3168, 'o1qmn5Kl1_MYaqz3JMaJElfkN3aI', 0, '2021-01-12 18:16:13', '2021-01-12 18:16:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3169, 'o1qmn5GrEulGuLqLyo5rsCsv5BqI', 0, '2021-01-12 18:44:18', '2021-01-12 18:44:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3170, 'o1qmn5M0kSFF_2B-IqjRvRHDmYNs', 0, '2021-01-12 20:13:51', '2021-01-12 20:13:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3171, 'o1qmn5CHw-wXmW0kqUDQ9-YFrh50', 0, '2021-01-13 12:28:27', '2021-01-13 12:28:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3172, 'o1qmn5LLydzHJJKsbEp4_C47S30o', 0, '2021-01-13 13:35:51', '2021-01-13 13:35:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3173, 'o1qmn5NlzPO1bxHFqUjoxhqQdy1I', 1, '2021-01-13 15:58:49', '2021-03-09 14:48:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3174, 'o1qmn5MzoN2fORvB6v4G0daT7XgY', 0, '2021-01-13 17:34:37', '2021-01-13 17:34:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3175, 'o1qmn5FA1ocLT07D3HZC88sQVFZI', 1, '2021-01-13 19:36:39', '2021-01-23 06:50:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3176, 'o1qmn5F0PtfrZCKv0ZlnUs-Q9eZI', 0, '2021-01-13 20:41:32', '2021-01-13 20:41:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3177, 'o1qmn5MZFqQtNXyoPWRN_mgd84u0', 0, '2021-01-13 23:32:20', '2021-01-13 23:32:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3178, 'o1qmn5EYbJVtLSKnOXkc1okIrzb4', 13, '2021-01-14 02:01:36', '2021-01-14 02:02:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3179, 'o1qmn5PrgPiAiluXvm5X1vrr5qD8', 0, '2021-01-14 02:02:12', '2021-01-14 02:02:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3180, 'o1qmn5CvGS4E_ZBiHb81X1uNNgnE', 1, '2021-01-14 02:42:14', '2021-01-22 06:17:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3181, 'o1qmn5LEogtC6AxDHpFM3Trcd7Mg', 0, '2021-01-14 06:18:26', '2021-01-14 06:18:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3182, 'o1qmn5JUevuf859ZdZJ3hyI5qj94', 0, '2021-01-14 09:04:01', '2021-01-14 09:04:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3183, 'o1qmn5FbrW-nf8LLLKLIMNSwLJNg', 0, '2021-01-14 09:53:08', '2021-01-14 09:53:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3184, 'o1qmn5DXP62o6M4UggThHYraUwuk', 1, '2021-01-14 10:25:47', '2021-01-14 11:23:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3185, 'o1qmn5BuBNTZ0SRTRF6iTCXtgPy8', 1, '2021-01-14 10:25:53', '2021-01-24 18:02:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3186, 'o1qmn5DXWCv0phueDwKrsF8dsjUk', 0, '2021-01-14 10:26:01', '2021-01-14 10:26:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3187, 'o1qmn5NjlVEEOG8XrrISaE0d9h-k', 0, '2021-01-14 10:35:18', '2021-01-14 10:35:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3188, 'o1qmn5EgycKfC0nqGmng0EDeqPew', 0, '2021-01-14 10:38:38', '2021-01-14 10:38:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3189, 'o1qmn5Ah0XgRj4sXIMtn1W_t9wqk', 5, '2021-01-14 11:02:18', '2021-03-28 11:46:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3190, 'o1qmn5Mk1_bcZp8HK_plfGvAyKJg', 0, '2021-01-14 11:21:32', '2021-01-14 11:21:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3191, 'o1qmn5ApkTtcMhmwA13SxZ3Wk6Gc', 0, '2021-01-14 11:25:06', '2021-01-14 11:25:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3192, 'o1qmn5F8HIaQgX1xVGsb9NeW0QKM', 2, '2021-01-14 11:25:36', '2021-03-16 14:51:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3193, 'o1qmn5IgOhI0kiy6pNvw2kF6MZBk', 0, '2021-01-14 11:25:40', '2021-01-14 11:25:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3194, 'o1qmn5HvhMNSOLZCYvGSR6knjsd8', 0, '2021-01-14 11:25:46', '2021-01-14 11:25:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3195, 'o1qmn5PdZ2kfOik6DPk1M3WdQ8cE', 0, '2021-01-14 11:29:30', '2021-01-14 11:29:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3196, 'o1qmn5CWgm6cgmerg7yr0NGvTO7s', 2, '2021-01-14 11:31:03', '2021-02-23 14:50:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3197, 'o1qmn5JS_AThFPAceE_OSkL1QzxY', 0, '2021-01-14 11:31:13', '2021-01-14 11:31:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3198, 'o1qmn5FVEkzoxYpk67Rr7SXEI2rU', 0, '2021-01-14 11:40:48', '2021-01-14 11:40:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3199, 'o1qmn5IBpgvrpywUm1BE54fZcgKw', 0, '2021-01-14 11:42:12', '2021-01-14 11:42:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3200, 'o1qmn5LKzxqcrYYRw4MrfWUvL3h0', 0, '2021-01-14 13:00:37', '2021-01-14 13:00:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3201, 'o1qmn5OT7864u3gIiR8wzAhqPGhY', 0, '2021-01-14 14:31:47', '2021-01-14 14:31:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3202, 'o1qmn5GVzi7LYBuhj4XzBtLa34sQ', 1, '2021-01-14 15:36:29', '2021-01-14 15:38:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3203, 'o1qmn5J3YYVV8v0Cr5GHnPOqozps', 0, '2021-01-14 16:03:59', '2021-01-14 16:03:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3204, 'o1qmn5BmJTjkROEKyvrO-ncfgQJY', 1, '2021-01-14 16:21:24', '2021-01-21 15:10:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3205, 'o1qmn5MM_5SUF6lo8GwMBijvpg-w', 0, '2021-01-14 17:21:16', '2021-01-14 17:21:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3206, 'o1qmn5J_m5_GBXos99Yf0hFckZJk', 0, '2021-01-14 17:21:38', '2021-01-14 17:21:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3207, 'o1qmn5BA37PgtmZAs-1kMO0x5UmQ', 2, '2021-01-14 17:36:34', '2021-01-19 07:41:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3208, 'o1qmn5JmoXlW-Tfv4HGVBxmxIqHg', 0, '2021-01-14 19:44:20', '2021-01-14 19:44:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3209, 'o1qmn5LCpik6mKrNUOsYToyB4IME', 0, '2021-01-14 22:39:51', '2021-01-14 22:39:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3210, 'o1qmn5BQ3POVnjCTUBp2t6lE-Bp0', 0, '2021-01-15 02:31:03', '2021-01-15 02:31:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3211, 'o1qmn5G6WAzsaHUrD2GB0siBu3cE', 0, '2021-01-15 02:34:42', '2021-01-15 02:34:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3212, 'o1qmn5F4-Q9kT4HFHuVSneTY6X8w', 0, '2021-01-15 04:26:21', '2021-01-15 04:26:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3213, 'o1qmn5LA3ivPzTBb03kTG4qLowv8', 0, '2021-01-15 04:26:28', '2021-01-15 04:26:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3214, 'o1qmn5G-E6xQ195fbS0wBhLHx8yY', 0, '2021-01-15 04:27:20', '2021-01-15 04:27:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3215, 'o1qmn5P5KKMJw9et1wDkn52kIn4M', 0, '2021-01-15 04:27:37', '2021-01-15 04:27:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3216, 'o1qmn5Md16XHPUTPDVfoZ3d2nS8k', 0, '2021-01-15 04:28:20', '2021-01-15 04:28:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3217, 'o1qmn5NaRSgu_J0QbOZr_kLXEAIE', 0, '2021-01-15 06:03:07', '2021-01-15 06:03:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3218, 'o1qmn5HNoACcw5wtp9JL-fUcdMV0', 0, '2021-01-15 06:58:29', '2021-01-15 06:58:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3219, 'o1qmn5FrHbGU1HZLzjITUzRAp61k', 0, '2021-01-15 09:48:24', '2021-01-15 09:48:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3220, 'o1qmn5HaFDBTyH-0MhbqyXmEIUIE', 0, '2021-01-15 12:15:30', '2021-01-15 12:15:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3221, 'o1qmn5GVBX0YtKXTkyH7is0wqz1U', 2, '2021-01-15 15:57:28', '2021-03-25 15:14:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3222, 'o1qmn5GA17dT7foxSWcDAj4XY_L0', 1, '2021-01-15 16:15:21', '2021-01-23 00:19:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3223, 'o1qmn5GFkIv_u8y8Z4c3bsqAcKr0', 0, '2021-01-15 22:50:20', '2021-01-15 22:50:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3224, 'o1qmn5NCOPwZiK6KiGUcZHoLI-zM', 0, '2021-01-16 11:38:38', '2021-01-16 11:38:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3225, 'o1qmn5Cyr6maS2ltqfWBqk-TSeHQ', 0, '2021-01-16 13:25:48', '2021-01-16 13:25:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3226, 'o1qmn5GfaqxhUwA_g_AAsCHDGDz0', 0, '2021-01-16 13:38:41', '2021-01-16 13:38:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3227, 'o1qmn5FK21ZZTKmNI_BkKtshuNV8', 0, '2021-01-16 16:22:30', '2021-01-16 16:22:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3228, 'o1qmn5P9QyvH6-BjERfTGF2utA0Y', 5, '2021-01-16 16:51:27', '2021-01-20 14:00:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3229, 'o1qmn5KtdkGANM_i6HLHYNatWS5E', 3, '2021-01-16 17:56:43', '2021-01-16 17:58:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3230, 'o1qmn5JPmV5zIwkmyZMUMHO_jiIE', 1, '2021-01-17 08:25:53', '2021-01-17 09:44:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3231, 'o1qmn5BrizDfDaKx3ZlU4KtIHqGQ', 0, '2021-01-17 08:32:03', '2021-01-17 08:32:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3232, 'o1qmn5CTtz1JGj6xaqZIMhHQrIEw', 0, '2021-01-17 10:02:12', '2021-01-17 10:02:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3233, 'o1qmn5PforlSAmrhhfQyAViF63qc', 0, '2021-01-17 10:41:07', '2021-01-17 10:41:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3234, 'o1qmn5HctfLFeGa0t3HWbGQ9dHGM', 0, '2021-01-18 00:14:54', '2021-01-18 00:14:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3235, 'o1qmn5EBE48b4pvdXYE4iB4qu-Q0', 0, '2021-01-18 05:45:19', '2021-01-18 05:45:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3236, 'o1qmn5AGKolUPs7cdbKgA2LmCjuw', 0, '2021-01-18 06:25:08', '2021-01-18 06:25:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3237, 'o1qmn5LCLuktPoCO7GOPZMvmT9n4', 0, '2021-01-18 10:23:32', '2021-01-18 10:23:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3238, 'o1qmn5Mqa1cBx7XaTd_zu959LfX4', 1, '2021-01-18 11:12:23', '2021-03-24 13:51:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3239, 'o1qmn5F-I6zRCaSI2IMsA8tP95Y4', 0, '2021-01-18 11:53:27', '2021-01-18 11:53:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3240, 'o1qmn5E5U0zelrMO_AU7qoOaQbfc', 0, '2021-01-18 12:46:49', '2021-01-18 12:46:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3241, 'o1qmn5LDGOgewMvcOYDlAigsq9Os', 0, '2021-01-18 12:59:50', '2021-01-18 12:59:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3242, 'o1qmn5BJq8Tp4uoP81DmnAg9Sumc', 1, '2021-01-18 15:25:02', '2021-01-19 00:07:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3243, 'o1qmn5JyspFLgh3owFTM5QhtGuwI', 0, '2021-01-18 16:12:27', '2021-01-18 16:12:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3244, 'o1qmn5NAJggA9I2A8-sF1RrMPSsU', 0, '2021-01-18 16:14:20', '2021-01-18 16:14:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3245, 'o1qmn5GGrvGeQhmWKanZKjGKEYL4', 0, '2021-01-18 16:54:31', '2021-01-18 16:54:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3246, 'o1qmn5C0sEL2yb-IVqlHIY2BNkvc', 1, '2021-01-18 17:57:58', '2021-01-19 09:15:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3247, 'o1qmn5AZqbrvlOSWEr8F90_7LPWg', 0, '2021-01-18 18:43:59', '2021-01-18 18:43:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3248, 'o1qmn5HgLuR_Wuuz4QqSPUJqe450', 0, '2021-01-18 19:15:57', '2021-01-18 19:15:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3249, 'o1qmn5L2DerU7EHj36bvQzCL3Hio', 0, '2021-01-18 19:57:58', '2021-01-18 19:57:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3250, 'o1qmn5DpkhSrso7fPDk8xnMaOqkM', 2, '2021-01-18 22:07:30', '2021-01-29 16:38:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3251, 'o1qmn5E7R0NLf5k1XQ8c64rSk47U', 0, '2021-01-18 23:15:11', '2021-01-18 23:15:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3252, 'o1qmn5Cyozc18clGtZRYLJoBXiyk', 0, '2021-01-18 23:25:46', '2021-01-18 23:25:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3253, 'o1qmn5OEzO-T5cW3F8o6_sWmTVec', 0, '2021-01-19 05:50:26', '2021-01-19 05:50:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3254, 'o1qmn5NNLpcXA9ZJoOcTyiWDtlo0', 0, '2021-01-19 07:57:00', '2021-01-19 07:57:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3255, 'o1qmn5L-3wNO4YBQKmZ4-LOx1OIk', 0, '2021-01-19 08:01:58', '2021-01-19 08:01:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3256, 'o1qmn5JvyqtWWq5sRd86VcyJld-E', 2, '2021-01-19 08:30:20', '2021-03-03 08:32:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3257, 'o1qmn5KcH6GomFEVjTKzG_g13Z58', 0, '2021-01-19 09:59:38', '2021-01-19 09:59:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3258, 'o1qmn5Cs5aOn7EawXykMkSyht8JQ', 1, '2021-01-19 14:16:04', '2021-01-19 16:27:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3259, 'o1qmn5F4cvGf3rhAs5AyFLxxNYw8', 1, '2021-01-19 15:35:31', '2021-02-03 12:02:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3260, 'o1qmn5B6ta_3xdKkiFvT1Qrcmns0', 0, '2021-01-19 16:32:47', '2021-01-19 16:32:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3261, 'o1qmn5OA2zb18iWStd2seWtn6ZPI', 0, '2021-01-19 16:33:30', '2021-01-19 16:33:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3262, 'o1qmn5M_n1LlrKZiSlMaO2-J89zA', 0, '2021-01-19 16:34:31', '2021-01-19 16:34:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3263, 'o1qmn5EhOpTaNiB7Lzjt-o3f6NBQ', 0, '2021-01-19 16:34:37', '2021-01-19 16:34:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3264, 'o1qmn5CzqkMs6TiIUJDYPfljURAY', 2, '2021-01-19 16:34:46', '2021-01-20 15:17:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3265, 'o1qmn5Ad6NL28Txiqgg4uw18r5Pg', 1, '2021-01-19 16:37:59', '2021-01-24 05:07:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3266, 'o1qmn5OMpjvEZUMaHT-AuK82Umr0', 0, '2021-01-19 16:53:01', '2021-01-19 16:53:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3267, 'o1qmn5FYgLQlTL03epPZOYTEYmKg', 0, '2021-01-19 19:58:15', '2021-01-19 19:58:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3268, 'o1qmn5HfOHFvcOPFW6oljzSabbDM', 0, '2021-01-19 21:00:05', '2021-01-19 21:00:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3269, 'o1qmn5Dl9JEHAPsAgv-QttWauZHM', 0, '2021-01-19 22:02:37', '2021-01-19 22:02:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3270, 'o1qmn5A4bieqdwIS7Y3kgbQwhJIE', 0, '2021-01-19 22:40:39', '2021-01-19 22:40:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3271, 'o1qmn5OEI96LZI0cXGdSMIK8vozY', 0, '2021-01-20 00:34:03', '2021-01-20 00:34:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3272, 'o1qmn5Mo9l3PqICCZEnZ_lUWGjhI', 0, '2021-01-20 05:21:41', '2021-01-20 05:21:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3273, 'o1qmn5CLk-Te7Dsfal5TSEaHOKGA', 0, '2021-01-20 09:20:55', '2021-01-20 09:20:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3274, 'o1qmn5CZ9e8uQCOoqmk7FlknEX-A', 3, '2021-01-20 10:17:49', '2021-01-21 12:58:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3275, 'o1qmn5ATnTLrtjRtX7cQ7GhbyvwI', 0, '2021-01-20 10:18:23', '2021-01-20 10:18:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3276, 'o1qmn5KfuT8cQIo4WL8jtXiR_Yg4', 0, '2021-01-20 12:40:25', '2021-01-20 12:40:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3277, 'o1qmn5OvjRL6-xjqWPu8_DH0hHtg', 1, '2021-01-20 13:24:43', '2021-01-21 20:45:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3278, 'o1qmn5NjfcakGmuIErM2m3n-mslg', 2, '2021-01-20 14:00:35', '2021-03-25 10:29:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3279, 'o1qmn5M5X83SFWb75-plkMBScP4E', 1, '2021-01-20 14:25:16', '2021-01-22 12:37:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3280, 'o1qmn5CbT_DSkL7N1WjZFqlnKr8U', 2, '2021-01-20 18:16:45', '2021-01-20 18:18:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3281, 'o1qmn5MPsD3__nXsZXnRlr4RsQp8', 0, '2021-01-20 20:03:39', '2021-01-20 20:03:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3282, 'o1qmn5DWLuyAv3sFIg8I6VHnkt6k', 0, '2021-01-20 21:19:27', '2021-01-20 21:19:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3283, 'o1qmn5KT1hCmcag86pXjGLCPifyo', 0, '2021-01-20 23:30:23', '2021-01-20 23:30:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3284, 'o1qmn5Mp9jlCBP3IiegpG0xuZ8po', 0, '2021-01-21 00:18:05', '2021-01-21 00:18:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3285, 'o1qmn5F0_kDDgVe5gwtM8Kdqr2_A', 0, '2021-01-21 04:14:42', '2021-01-21 04:14:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3286, 'o1qmn5Fu50zWOWssv2K1WXG9rkYY', 0, '2021-01-21 05:03:32', '2021-01-21 05:03:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3287, 'o1qmn5N3YaZS-jGDkYI1YE-4ZmZE', 0, '2021-01-21 05:53:41', '2021-01-21 05:53:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3288, 'o1qmn5IfMtX2KvpC-Qqisqq7QDCU', 0, '2021-01-21 07:09:21', '2021-01-21 07:09:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3289, 'o1qmn5Gidjj_uTirT1ZwKLQg4TBM', 0, '2021-01-21 08:21:36', '2021-01-21 08:21:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3290, 'o1qmn5LyWqEGVuz-OAkjFaYg3nZY', 1, '2021-01-21 11:56:36', '2021-03-04 06:38:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3291, 'o1qmn5OdQKgcsPLDSGIevM9d3_d0', 0, '2021-01-21 13:41:38', '2021-01-21 13:41:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3292, 'o1qmn5ABSw_V8zKnHmStngA5Wipk', 0, '2021-01-21 14:06:30', '2021-01-21 14:06:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3293, 'o1qmn5MEFCjkfu6yUhmbrTV_B2QE', 1, '2021-01-21 14:48:20', '2021-03-28 09:39:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3294, 'o1qmn5PEs5avfrWlLSEUZrmSPMKA', 0, '2021-01-21 15:31:48', '2021-01-21 15:31:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3295, 'o1qmn5DtSpoAvxK7LthlGQk66Hz0', 7, '2021-01-21 15:43:33', '2021-02-25 10:33:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3296, 'o1qmn5AhSmxr4xfKJn2a8-RMzzE4', 0, '2021-01-21 15:45:00', '2021-01-21 15:45:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3297, 'o1qmn5C5qRNnLX1_OYRJSN8OJFYw', 4, '2021-01-21 19:05:50', '2021-01-27 16:21:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3298, 'o1qmn5ItSj8SI331toVDWmqLZtrw', 0, '2021-01-21 20:43:05', '2021-01-21 20:43:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3299, 'o1qmn5P10-XdsQ15TXCuGe2WJIvA', 11, '2021-01-22 10:19:05', '2021-03-17 10:52:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3300, 'o1qmn5MdlyJd7R-FccMHU7odfebQ', 0, '2021-01-22 10:24:34', '2021-01-22 10:24:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3301, 'o1qmn5AAAAujAmslgB4T2EwXHY7Y', 0, '2021-01-22 10:28:09', '2021-01-22 10:28:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3302, 'o1qmn5HRFwmFoLG-Q6nwpBmAyi-0', 0, '2021-01-22 11:33:33', '2021-01-22 11:33:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3303, 'o1qmn5Bju6QTlm1_ZzbApZu3JUV0', 0, '2021-01-22 11:35:04', '2021-01-22 11:35:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3304, 'o1qmn5J5w8lcPD34RDYf1k588Uik', 0, '2021-01-22 12:47:07', '2021-01-22 12:47:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3305, 'o1qmn5LGIRQhBXVoxFw56ZtOKcRU', 3, '2021-01-22 13:25:29', '2021-01-22 13:31:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3306, 'o1qmn5Icvywtz5fDFmnvS4k-bzCI', 0, '2021-01-22 13:57:17', '2021-01-22 13:57:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3307, 'o1qmn5JrttSN-UTAMv8qtWhNzl48', 0, '2021-01-22 13:57:59', '2021-01-22 13:57:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3308, 'o1qmn5E_AzzBxxtRDPG-LmWFyqSI', 1, '2021-01-22 14:25:13', '2021-01-31 22:06:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3309, 'o1qmn5K-agB9HATvtuQqwjxf-xro', 1, '2021-01-22 14:25:51', '2021-01-22 14:37:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3310, 'o1qmn5Pa6X62Tuff7u7PISfpCZs0', 0, '2021-01-22 14:34:25', '2021-01-22 14:34:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3311, 'o1qmn5MJzyfAcexQxfxtJifqVQ_w', 0, '2021-01-22 14:37:58', '2021-01-22 14:37:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3312, 'o1qmn5M-j3SZpVZ2vHdFfXar0A7E', 0, '2021-01-22 16:08:01', '2021-01-22 16:08:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3313, 'o1qmn5M4yuUqw4AtUJe-W7jzuCH0', 1, '2021-01-22 17:19:33', '2021-01-22 20:30:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3314, 'o1qmn5F4mQgy87_IPAV0i77slTKY', 0, '2021-01-22 18:34:11', '2021-01-22 18:34:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3315, 'o1qmn5FRbMtgvn08-MNFIzcrsdAs', 0, '2021-01-22 19:12:25', '2021-01-22 19:12:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3316, 'o1qmn5L_R1EN5Zi-aqmMTar3xXnI', 0, '2021-01-22 22:47:13', '2021-01-22 22:47:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3317, 'o1qmn5JGtJQnr9posxOMR1E4Yq-A', 0, '2021-01-23 02:06:15', '2021-01-23 02:06:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3318, 'o1qmn5OO9EyaHbeDRqwfmRDNoQQs', 0, '2021-01-23 02:43:19', '2021-01-23 02:43:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3319, 'o1qmn5Ny9fu0nsTARIuTAFncxLoE', 0, '2021-01-23 05:31:32', '2021-01-23 05:31:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3320, 'o1qmn5Jm82Fg5mQFPdMmo-Xw9Eyg', 0, '2021-01-23 08:32:48', '2021-01-23 08:32:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3321, 'o1qmn5BzNDe8rtztdxEg2lbDz1s4', 3, '2021-01-23 10:58:02', '2021-03-28 11:06:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3322, 'o1qmn5B3CHMIANzwUUt0MYzXb39w', 1, '2021-01-23 13:32:29', '2021-01-24 14:47:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3323, 'o1qmn5FBzagL9Lb6O-X6WhyK3z0E', 0, '2021-01-23 16:12:57', '2021-01-23 16:12:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3324, 'o1qmn5CGVTQMT-4G3NhwNnSOZEb4', 0, '2021-01-23 19:50:05', '2021-01-23 19:50:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3325, 'o1qmn5IZNxGv5ApW4lQyKYr3M4S8', 0, '2021-01-23 19:59:25', '2021-01-23 19:59:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3326, 'o1qmn5DeP3f8bU2XVyl5uy_hwBJg', 0, '2021-01-24 05:46:21', '2021-01-24 05:46:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3327, 'o1qmn5I5UNIocv6LYZynG79a_j2M', 1, '2021-01-24 12:30:47', '2021-03-17 15:33:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3328, 'o1qmn5KZWmSHtHqNW4CxHFPWfVfo', 0, '2021-01-24 12:32:12', '2021-01-24 12:32:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3329, 'o1qmn5LdKSHIYvnNdU3No-lDmNXA', 0, '2021-01-24 16:28:49', '2021-01-24 16:28:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3330, 'o1qmn5H-WfifroQcjNST7etzutlA', 3, '2021-01-24 21:05:08', '2021-03-26 10:14:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3331, 'o1qmn5PAJZshy2xqKSBJqpH5WJnQ', 0, '2021-01-25 00:01:34', '2021-01-25 00:01:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3332, 'o1qmn5Ma1QMwFFF2-KemMBMJColc', 0, '2021-01-25 01:42:08', '2021-01-25 01:42:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3333, 'o1qmn5KiEl3PHGvjqbNSLEBxXfI8', 1, '2021-01-25 05:15:44', '2021-01-25 22:18:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3334, 'o1qmn5CgEs19mByiAYqFjKt5dyv0', 16, '2021-01-25 08:48:35', '2021-03-05 15:37:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3335, 'o1qmn5Dcl3Vk-ayEskh2J3AewY24', 0, '2021-01-25 19:27:26', '2021-01-25 19:27:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3336, 'o1qmn5M6az_E3Jzxyn-vejsC7jJ4', 0, '2021-01-25 20:39:43', '2021-01-25 20:39:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3337, 'o1qmn5NXoY6fyvUwmT5ESu1mIYvw', 2, '2021-01-25 22:02:17', '2021-01-27 21:45:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3338, 'o1qmn5ONcPlQR5ull7r0_YOwi2sY', 0, '2021-01-26 03:53:46', '2021-01-26 03:53:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3339, 'o1qmn5MKer16Q6yyi6EpKG_IG78A', 0, '2021-01-26 05:43:34', '2021-01-26 05:43:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3340, 'o1qmn5FLS7yR9y2b2_8R1kA5jbMw', 0, '2021-01-26 10:06:55', '2021-01-26 10:06:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3341, 'o1qmn5F7nawiWoRYR73VHoHcycQk', 0, '2021-01-26 11:21:18', '2021-01-26 11:21:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3342, 'o1qmn5Cfplg_2IvNYGRnciQSxZjQ', 0, '2021-01-26 11:21:47', '2021-01-26 11:21:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3343, 'o1qmn5Fg6ONBW7YJ8wCjMgYPNiwI', 0, '2021-01-26 14:47:48', '2021-01-26 14:47:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3344, 'o1qmn5BIVuFy1CtwOBQ-P8ciq0UQ', 1, '2021-01-26 15:13:14', '2021-01-26 17:49:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3345, 'o1qmn5DPPpTr8Hut6r2Dah0D2w-g', 0, '2021-01-26 15:31:50', '2021-01-26 15:31:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3346, 'o1qmn5KgHDhkvwNJvrC3w1MvDtkE', 0, '2021-01-26 15:44:52', '2021-01-26 15:44:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3347, 'o1qmn5G4izk_19x3SbJmjmwdJtkY', 0, '2021-01-26 16:08:54', '2021-01-26 16:08:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3348, 'o1qmn5PsTjooA4xtwFCaSzMUCODE', 0, '2021-01-26 16:13:22', '2021-01-26 16:13:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3349, 'o1qmn5EqmCGPE4amQfGWx9yamiEs', 0, '2021-01-26 16:29:38', '2021-01-26 16:29:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3350, 'o1qmn5GJJkF2qJt_IrXrpHrnKWys', 0, '2021-01-26 16:44:58', '2021-01-26 16:44:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3351, 'o1qmn5JUjh6oXLu-qA0cxUM2tSS8', 0, '2021-01-26 20:26:00', '2021-01-26 20:26:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3352, 'o1qmn5P6_jGmWf_tLA75gWrwMyKc', 0, '2021-01-26 20:28:11', '2021-01-26 20:28:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3353, 'o1qmn5ByHp_GZZWPshvZuI0kyZMw', 0, '2021-01-26 21:14:44', '2021-01-26 21:14:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3354, 'o1qmn5IgpsIewcz2y3OEIoRV2T-Y', 0, '2021-01-26 21:58:25', '2021-01-26 21:58:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3355, 'o1qmn5LTdGUSk8pGqO3FLZZh1MUE', 0, '2021-01-27 00:13:48', '2021-01-27 00:13:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3356, 'o1qmn5GGcVHntkja2Al0h07j32lw', 0, '2021-01-27 03:33:42', '2021-01-27 03:33:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3357, 'o1qmn5GbyWgB9I29F4bKcN6bNQb4', 0, '2021-01-27 05:02:02', '2021-01-27 05:02:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3358, 'o1qmn5MiSSgHEeh9dihC5R-cb40I', 0, '2021-01-27 06:38:21', '2021-01-27 06:38:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3359, 'o1qmn5MQQ7MWjvfDNIkttE2IWMcw', 0, '2021-01-27 08:34:41', '2021-01-27 08:34:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3360, 'o1qmn5Nw3u5sD-9XBg1FBDdXseZQ', 0, '2021-01-27 10:24:07', '2021-01-27 10:24:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3361, 'o1qmn5PQFHE7KlJ0b4NQ5i6aOPYY', 0, '2021-01-27 11:33:05', '2021-01-27 11:33:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3362, 'o1qmn5DmfM2GvT8mXFftkTZwwpU4', 0, '2021-01-27 11:39:06', '2021-01-27 11:39:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3363, 'o1qmn5D5lxJn5yusrVyvd6ii_dC8', 0, '2021-01-27 12:01:12', '2021-01-27 12:01:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3364, 'o1qmn5MAixU2PNBP-w6FvAKQKeyY', 0, '2021-01-27 12:03:17', '2021-01-27 12:03:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3365, 'o1qmn5NlKsydZUUwWE7P4ToJiHLM', 1, '2021-01-27 14:08:44', '2021-01-28 08:27:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3366, 'o1qmn5Jvyl5sFTd4Lxbufu-gviS4', 0, '2021-01-27 14:10:31', '2021-01-27 14:10:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3367, 'o1qmn5NnLj33Ie8Y_zCl7P8X5A5Y', 0, '2021-01-27 14:10:42', '2021-01-27 14:10:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3368, 'o1qmn5EV8g7jZBHRXvb8dBHYLPmU', 1, '2021-01-27 14:10:42', '2021-01-27 14:14:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3369, 'o1qmn5DIUA1qUy5vCWMLyKT-GMKk', 0, '2021-01-27 14:10:50', '2021-01-27 14:10:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3370, 'o1qmn5N4CCjkqoaOKxacOzQjN9IE', 1, '2021-01-27 14:10:56', '2021-01-27 14:13:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3371, 'o1qmn5KuKZ29XmFd3ENIrZgj21A0', 1, '2021-01-27 14:17:42', '2021-01-27 14:18:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3372, 'o1qmn5IPSudEzGIZhEzXYWeHiRaM', 1, '2021-01-27 14:19:06', '2021-01-28 19:22:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3373, 'o1qmn5AKTB6V4u5sPwTFQT6LVlJo', 0, '2021-01-27 14:24:59', '2021-01-27 14:24:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3374, 'o1qmn5Efy7W8ncmHDMoUzTvmZkEA', 0, '2021-01-27 14:26:42', '2021-01-27 14:26:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3375, 'o1qmn5OxBUlEz_i4_BAMe2_I1thw', 0, '2021-01-27 14:27:31', '2021-01-27 14:27:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3376, 'o1qmn5B99pdsYxuWDdORtsvIXr4Y', 1, '2021-01-27 14:42:22', '2021-02-23 18:10:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3377, 'o1qmn5H8ltRAAj2sBb627-w4IIZE', 0, '2021-01-27 14:44:58', '2021-01-27 14:44:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3378, 'o1qmn5J1cDzJrLGKnXEqYzcx7pf8', 0, '2021-01-27 15:16:56', '2021-01-27 15:16:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3379, 'o1qmn5NDBuXQsUjigU6pl2Y0K6eE', 0, '2021-01-27 18:07:59', '2021-01-27 18:07:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3380, 'o1qmn5IEDikrTL6FItl_HwgED23Y', 4, '2021-01-27 18:20:24', '2021-02-03 13:34:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3381, 'o1qmn5Kr0oFqtMcQTt1n2etOx9Ws', 0, '2021-01-27 18:41:23', '2021-01-27 18:41:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3382, 'o1qmn5A0h5UB8VFY3lPxuuqjiFMU', 0, '2021-01-27 20:15:45', '2021-01-27 20:15:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3383, 'o1qmn5HI6NmPShqQLn0-mMHzZS10', 0, '2021-01-27 22:39:38', '2021-01-27 22:39:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3384, 'o1qmn5BtNSuU76V8SiUsDBeN7rRs', 3, '2021-01-27 22:53:47', '2021-01-29 20:42:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3385, 'o1qmn5M1V6XRWiTi5VdqM55o3eFE', 1, '2021-01-27 22:58:29', '2021-01-31 04:18:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3386, 'o1qmn5J_o7Cdeqn_jSGoS3phrffM', 0, '2021-01-27 23:59:57', '2021-01-27 23:59:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3387, 'o1qmn5KupawpO-9J3chXkofS60Us', 0, '2021-01-28 05:26:06', '2021-01-28 05:26:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3388, 'o1qmn5Nrnz3q_P7MbWKiTCLdYZAE', 0, '2021-01-28 11:24:40', '2021-01-28 11:24:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3389, 'o1qmn5CRDoDSA7IuGveuS1ce_bhw', 1, '2021-01-28 13:39:26', '2021-02-08 13:08:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3390, 'o1qmn5CKQ5Frudt4PHuuWWzuxeMU', 2, '2021-01-28 15:31:17', '2021-01-31 17:56:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3391, 'o1qmn5Jg4tsZStOeoRVqbvLPUvss', 0, '2021-01-28 16:16:05', '2021-01-28 16:16:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3392, 'o1qmn5AvJ9MB69VVlzltmH0HP1Rw', 0, '2021-01-28 19:14:44', '2021-01-28 19:14:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3393, 'o1qmn5Om84uTPFdrtDTgEY3iDZ0I', 0, '2021-01-28 22:02:59', '2021-01-28 22:02:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3394, 'o1qmn5DXe3eVTTeyCq5-uLtIsH38', 1, '2021-01-29 05:03:52', '2021-02-02 17:53:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3395, 'o1qmn5DRdt6--S6vd6LaUPsOVWaA', 0, '2021-01-29 08:41:07', '2021-01-29 08:41:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3396, 'o1qmn5GDC7ScHeAKKHJ65SyvcG-o', 0, '2021-01-29 12:47:22', '2021-01-29 12:47:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3397, 'o1qmn5Gg7Ch8TiN88dxg1e15YQTQ', 2, '2021-01-29 12:55:30', '2021-02-27 00:58:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3398, 'o1qmn5D0vjSIeF5l2q9zgJqCHtzY', 0, '2021-01-29 13:11:49', '2021-01-29 13:11:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3399, 'o1qmn5NtFHPxOMuahy7KbhhGjapQ', 0, '2021-01-29 13:11:58', '2021-01-29 13:11:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3400, 'o1qmn5PCqoQ1nVFSktcgOkd22nOQ', 0, '2021-01-29 13:52:15', '2021-01-29 13:52:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3401, 'o1qmn5JEbPvbEXsxWEVfayOev2-0', 1, '2021-01-29 14:34:12', '2021-02-03 15:53:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3402, 'o1qmn5Ep9qn48uoFbL7apPLEpBdo', 0, '2021-01-29 14:35:41', '2021-01-29 14:35:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3403, 'o1qmn5J_hu6on0c6CllLmE20o7eo', 0, '2021-01-29 16:10:49', '2021-01-29 16:10:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3404, 'o1qmn5Ab3peGJXkddZOq5vesZqAk', 0, '2021-01-29 16:30:58', '2021-01-29 16:30:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3405, 'o1qmn5KilVav4rUA44S6NJR14nFI', 0, '2021-01-29 18:04:13', '2021-01-29 18:04:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3406, 'o1qmn5IMwBve1dy23RCWX2DsMzis', 0, '2021-01-29 18:16:04', '2021-01-29 18:16:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3407, 'o1qmn5EqT2cnukMdutu6_aTZkQtA', 1, '2021-01-29 20:18:11', '2021-01-29 20:55:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3408, 'o1qmn5P9SDwVYPj55fzziT8W6uM4', 0, '2021-01-30 05:29:43', '2021-01-30 05:29:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3409, 'o1qmn5NQS-Xue43yflEzxAaFYL7s', 0, '2021-01-30 05:31:50', '2021-01-30 05:31:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3410, 'o1qmn5C8A4PKbHv6x6otEcXRTi4o', 0, '2021-01-30 09:26:15', '2021-01-30 09:26:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3411, 'o1qmn5LEyJhOPGNd5PlD-cPx9pRQ', 0, '2021-01-31 04:01:33', '2021-01-31 04:01:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3412, 'o1qmn5AP4K_wbc36rVFidFziH8g4', 0, '2021-01-31 04:19:19', '2021-01-31 04:19:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3413, 'o1qmn5OeQDzfBtPIerHPBN51IX_k', 0, '2021-01-31 04:19:26', '2021-01-31 04:19:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3414, 'o1qmn5KLr3jZYsqpi4w1L-7ibV1Q', 0, '2021-01-31 04:19:31', '2021-01-31 04:19:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3415, 'o1qmn5BkSo04qIdLiFBUdPzzNda8', 0, '2021-01-31 04:19:35', '2021-01-31 04:19:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3416, 'o1qmn5KqCTBW07kyf0Qi-mxvciQg', 0, '2021-01-31 04:20:08', '2021-01-31 04:20:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3417, 'o1qmn5Ar5F0sFfJfiVmBmKwdX6Qg', 0, '2021-01-31 04:55:00', '2021-01-31 04:55:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3418, 'o1qmn5O_VHe0mHNsFikZ4kQesq9w', 0, '2021-01-31 06:11:52', '2021-01-31 06:11:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3419, 'o1qmn5H87q5OaVfC6C-u0MbjUIow', 0, '2021-01-31 06:12:27', '2021-01-31 06:12:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3420, 'o1qmn5I6X_hKzNWW7R7EvfVkkqXU', 0, '2021-01-31 06:12:43', '2021-01-31 06:12:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3421, 'o1qmn5GdUdOLV3H-TVpEP6lC3k5M', 1, '2021-01-31 06:14:03', '2021-01-31 06:14:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3422, 'o1qmn5LNdPQFwWpcoNo1YPX9fXp4', 0, '2021-01-31 06:29:55', '2021-01-31 06:29:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3423, 'o1qmn5Mm4qVywhXh_HXtdIQgNNwQ', 0, '2021-01-31 23:56:01', '2021-01-31 23:56:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3424, 'o1qmn5ATIFh_xUmgxZ9sKe4m_nLE', 0, '2021-02-01 05:25:48', '2021-02-01 05:25:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3425, 'o1qmn5G_XrhKz8C4Rsd4PoD8QhN8', 0, '2021-02-01 07:20:30', '2021-02-01 07:20:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3426, 'o1qmn5I2OxnRyRuobXSx9YBPI9ds', 0, '2021-02-01 09:55:19', '2021-02-01 09:55:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3427, 'o1qmn5IaBCjcEwJuWFLI7szoL8uM', 0, '2021-02-01 12:50:08', '2021-02-01 12:50:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3428, 'o1qmn5Kfy7J7kS6fCw3uMHeFrrHc', 1, '2021-02-01 14:00:08', '2021-03-06 20:52:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3429, 'o1qmn5A4RdgGi7RuLvMV-9weY76k', 0, '2021-02-01 14:04:48', '2021-02-01 14:04:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3430, 'o1qmn5Mj7eHj9Q9Kd166uslPLs-A', 0, '2021-02-01 19:26:27', '2021-02-01 19:26:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3431, 'o1qmn5Engg1FFkzMILebeGc7-MFA', 0, '2021-02-01 21:08:51', '2021-02-01 21:08:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3432, 'o1qmn5JVCyN8a9k9h2v9ok4GRRk4', 0, '2021-02-02 09:42:44', '2021-02-02 09:42:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3433, 'o1qmn5DT_k22pZrvyL07ijjpropE', 1, '2021-02-02 12:35:31', '2021-02-02 19:40:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3434, 'o1qmn5PSxAuFksPVYM99hPLVwxDU', 0, '2021-02-02 15:18:41', '2021-02-02 15:18:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3435, 'o1qmn5EZHMXJOf7JxKUCXQ_jCDjM', 3, '2021-02-02 17:18:17', '2021-02-02 17:27:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3436, 'o1qmn5O7mnYP2RbxdgM2bh2GAZv0', 0, '2021-02-03 04:55:20', '2021-02-03 04:55:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3437, 'o1qmn5PHsSoKwHKb_gqprMBOtG24', 0, '2021-02-03 10:20:24', '2021-02-03 10:20:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3438, 'o1qmn5ADpZOCPj5wAVU4o6f6kgNU', 0, '2021-02-03 11:22:11', '2021-02-03 11:22:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3439, 'o1qmn5IcVmbV0E9cw7DQo4PIn8rg', 0, '2021-02-03 11:25:39', '2021-02-03 11:25:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3440, 'o1qmn5P-6yEN3l80TMQyOF6vHwMg', 0, '2021-02-03 11:32:14', '2021-02-03 11:32:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3441, 'o1qmn5KhHHKYI4eXOvwe6oMaHFuk', 0, '2021-02-03 11:33:14', '2021-02-03 11:33:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3442, 'o1qmn5FsYmrZ2Pgnij7Xxk1FRM0Q', 1, '2021-02-03 12:41:15', '2021-02-04 15:59:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3443, 'o1qmn5DafcTdkDmdHpKvlHj4Idck', 0, '2021-02-03 22:17:53', '2021-02-03 22:17:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3444, 'o1qmn5IHfEWV0kiazNHkZE-xO9Eo', 0, '2021-02-03 23:22:38', '2021-02-03 23:22:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3445, 'o1qmn5PdbrSsRfNeZOTEFkOa4KzA', 0, '2021-02-04 01:17:50', '2021-02-04 01:17:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3446, 'o1qmn5B4gDh5HlObDm5FbYamlvqE', 0, '2021-02-04 01:18:06', '2021-02-04 01:18:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3447, 'o1qmn5Mv2KaCHwoAAR4jbw6xXE-c', 0, '2021-02-04 01:18:10', '2021-02-04 01:18:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3448, 'o1qmn5ASV7QsJBvFwxRnvELpyzPk', 0, '2021-02-04 02:17:17', '2021-02-04 02:17:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3449, 'o1qmn5JnU5YsMjB8VIBVlAxWQjmE', 0, '2021-02-04 02:17:21', '2021-02-04 02:17:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3450, 'o1qmn5MB4FOpahoFsUzDTzikUuEU', 1, '2021-02-04 05:03:48', '2021-02-08 02:22:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3451, 'o1qmn5EyBjZw7N-MwclZBKEVdA5E', 1, '2021-02-04 11:16:50', '2021-02-24 10:19:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3452, 'o1qmn5Do3jTnqzUKSqKsUyA1E_7k', 0, '2021-02-04 20:36:00', '2021-02-04 20:36:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3453, 'o1qmn5Flt9QfKTRuNZrrO0UJE8Nc', 0, '2021-02-04 22:09:48', '2021-02-04 22:09:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3454, 'o1qmn5N1CXcWk_Cf3qQ9g9j3g2Ps', 0, '2021-02-04 22:27:17', '2021-02-04 22:27:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3455, 'o1qmn5CHRJG1SLoEDwYDVkw0xKIc', 0, '2021-02-06 03:57:54', '2021-02-06 03:57:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3456, 'o1qmn5EijNtQwJlxqvnZYMSNCfvs', 0, '2021-02-06 07:00:37', '2021-02-06 07:00:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3457, 'o1qmn5LDgfBEuFvD0RXlxX73S2JM', 0, '2021-02-06 07:14:36', '2021-02-06 07:14:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3458, 'o1qmn5Ipxs9Z6CPrzEnEzlHe-vLo', 1, '2021-02-06 18:33:02', '2021-02-06 19:42:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3459, 'o1qmn5JN07bKtW2vOmyNzclB-cfo', 0, '2021-02-07 04:59:25', '2021-02-07 04:59:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3460, 'o1qmn5ORR_V2anJXw9dKElz6dPTY', 0, '2021-02-07 15:46:10', '2021-02-07 15:46:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3461, 'o1qmn5CfY4dnO_HYdkdBQqD8X5v8', 0, '2021-02-07 20:54:40', '2021-02-07 20:54:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3462, 'o1qmn5CVIeSL4MZ23gLpwaCP98jI', 0, '2021-02-08 11:07:43', '2021-02-08 11:07:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3463, 'o1qmn5OXgJei1ngjG76TvjLUSUlU', 0, '2021-02-08 11:13:32', '2021-02-08 11:13:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3464, 'o1qmn5HYQ-uo-ejyxjnu01-t39Wc', 0, '2021-02-08 16:47:35', '2021-02-08 16:47:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3465, 'o1qmn5Of9GY40e2tQD0qxG4Ba-rw', 0, '2021-02-09 09:34:48', '2021-02-09 09:34:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3466, 'o1qmn5D7zFUqBO2EJG_YvhxBW464', 0, '2021-02-09 15:02:44', '2021-02-09 15:02:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3467, 'o1qmn5K-SL9vXYFc7ZuBFG_fPqeY', 0, '2021-02-09 15:03:02', '2021-02-09 15:03:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3468, 'o1qmn5KJpSraqKJNOwtzd6ohD5gA', 0, '2021-02-09 15:47:41', '2021-02-09 15:47:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3469, 'o1qmn5N7wGxa2cEgfOx_ZBi-Sh1U', 0, '2021-02-09 15:48:02', '2021-02-09 15:48:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3470, 'o1qmn5Nr8blwrpLqwgxgM0HgvQoU', 0, '2021-02-09 16:32:40', '2021-02-09 16:32:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3471, 'o1qmn5Jc3QqWD5KierrM4RpB5X_E', 0, '2021-02-09 16:49:17', '2021-02-09 16:49:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3472, 'o1qmn5MAMhzPlkIH6KgMtamow5g8', 0, '2021-02-09 17:01:55', '2021-02-09 17:01:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3473, 'o1qmn5LMdfeRkm8rLWqHob1B15eU', 0, '2021-02-09 21:10:56', '2021-02-09 21:10:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3474, 'o1qmn5Ipkyhpi6juB_DaWJsyrjow', 0, '2021-02-09 23:06:03', '2021-02-09 23:06:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3475, 'o1qmn5JL0F5jPZYjUJ_s-E3w3--8', 0, '2021-02-10 08:23:23', '2021-02-10 08:23:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3476, 'o1qmn5Ndgp0eEh1DDHU_JvCUEZNA', 0, '2021-02-10 14:01:48', '2021-02-10 14:01:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3477, 'o1qmn5KNMv2CDXtOnFnhO0Zlvbj4', 0, '2021-02-10 16:32:57', '2021-02-10 16:32:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3478, 'o1qmn5Le-oet-RYY36TGiylusctQ', 0, '2021-02-10 21:21:08', '2021-02-10 21:21:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3479, 'o1qmn5H6bwBaiR9oTZ7HvIDcrT_w', 0, '2021-02-10 22:45:47', '2021-02-10 22:45:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3480, 'o1qmn5JJ-R57h951YhlRepVZWUY4', 0, '2021-02-11 02:25:27', '2021-02-11 02:25:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3481, 'o1qmn5CaqPf0-3h3WNPaqyfjrBk4', 0, '2021-02-11 04:03:14', '2021-02-11 04:03:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3482, 'o1qmn5LOS-e0s003PlwHA_GjfRZA', 0, '2021-02-11 10:52:16', '2021-02-11 10:52:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3483, 'o1qmn5IGPKDMMGFjNFp6MHZNXx_A', 0, '2021-02-11 13:40:09', '2021-02-11 13:40:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3484, 'o1qmn5ApUdA5ZdVo4B8ueDa-ICxc', 0, '2021-02-11 14:16:28', '2021-02-11 14:16:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3485, 'o1qmn5HjT8uVWBb_XZb_pUzMIxk4', 1, '2021-02-11 15:47:39', '2021-02-13 20:12:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3486, 'o1qmn5FdoEhe616DS-5rxcbTYhek', 0, '2021-02-11 18:27:59', '2021-02-11 18:27:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3487, 'o1qmn5Ltht8W13fajc6FwwZ-70c0', 0, '2021-02-11 18:28:54', '2021-02-11 18:28:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3488, 'o1qmn5OKZq4HB37WH93qw8nsA1L8', 0, '2021-02-11 20:00:41', '2021-02-11 20:00:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3489, 'o1qmn5AyJfjKUtsaPa_qhJ_4yS3I', 0, '2021-02-12 04:32:44', '2021-02-12 04:32:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3490, 'o1qmn5Mjwa-uLSoZaIktZ-y55sCw', 0, '2021-02-13 04:05:14', '2021-02-13 04:05:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3491, 'o1qmn5JwDX_w-XSlC62HJtHzS4HI', 0, '2021-02-13 04:34:58', '2021-02-13 04:34:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3492, 'o1qmn5I-w07mx7HxgMzmImTOO2zA', 0, '2021-02-13 21:42:29', '2021-02-13 21:42:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3493, 'o1qmn5Dm2HdS1wi28l08AGXuxyHw', 0, '2021-02-14 11:19:37', '2021-02-14 11:19:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3494, 'o1qmn5ET-WCTFZp9bTQXc8tZDttY', 1, '2021-02-14 14:32:39', '2021-02-16 16:44:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3495, 'o1qmn5GnSixiyIhPZmMhAzrewm-8', 0, '2021-02-16 05:02:34', '2021-02-16 05:02:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3496, 'o1qmn5A1TPM0ZZLa2mvuRueSvmSk', 1, '2021-02-16 08:37:15', '2021-03-26 13:32:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3497, 'o1qmn5Bk7cAwBSy3Xe5HMAk486T4', 0, '2021-02-16 22:25:12', '2021-02-16 22:25:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3498, 'o1qmn5NC1dwFbwgGVMtlwSP5OUdc', 0, '2021-02-16 22:51:52', '2021-02-16 22:51:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3499, 'o1qmn5PfEpzxbRVcha4TqgB_4f7Q', 0, '2021-02-17 08:55:55', '2021-02-17 08:55:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3500, 'o1qmn5EQkOxOtR8bOBVgAFio5mjY', 1, '2021-02-17 12:47:48', '2021-03-02 12:14:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3501, 'o1qmn5G62JD-lmtz1bklyZFH8uC4', 0, '2021-02-17 12:51:41', '2021-02-17 12:51:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3502, 'o1qmn5IqvXVFuzX839iWNzkic1DM', 1, '2021-02-18 09:07:24', '2021-02-18 15:09:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3503, 'o1qmn5NOR0SPQAFIATw1dZacDPeo', 0, '2021-02-18 15:19:44', '2021-02-18 15:19:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3504, 'o1qmn5PaHrDJmFD73DBmmXeQvw54', 0, '2021-02-18 20:53:13', '2021-02-18 20:53:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3505, 'o1qmn5CsGEQBaxM_aNqd_N_dFVrQ', 0, '2021-02-19 19:35:25', '2021-02-19 19:35:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3506, 'o1qmn5LyshJHMz9Csh4V60XdYODM', 0, '2021-02-19 23:09:05', '2021-02-19 23:09:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3507, 'o1qmn5HTLYuB2NSf9yDT8jALMPyY', 0, '2021-02-20 00:04:08', '2021-02-20 00:04:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3508, 'o1qmn5ASkUuFsVdA1-Vaf80GUows', 0, '2021-02-20 04:24:41', '2021-02-20 04:24:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3509, 'o1qmn5MCU374S-Z3vPl0CmTYg224', 0, '2021-02-20 09:33:03', '2021-02-20 09:33:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3510, 'o1qmn5F2ODf8-PUD9pMS7N6xJry8', 0, '2021-02-20 09:33:46', '2021-02-20 09:33:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3511, 'o1qmn5B5q1suBmLbjd2owoaff-J8', 0, '2021-02-20 09:34:41', '2021-02-20 09:34:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3512, 'o1qmn5IIkBgvMFhS9hptQOJnV37Q', 0, '2021-02-20 09:40:39', '2021-02-20 09:40:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3513, 'o1qmn5IIKJjfmgOIXnQ5olzOr-P0', 0, '2021-02-20 09:41:03', '2021-02-20 09:41:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3514, 'o1qmn5O0toLVT_0v6L9HboLDMBo8', 0, '2021-02-20 09:44:31', '2021-02-20 09:44:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3515, 'o1qmn5OxCv25GflpV43mPMI95CPM', 0, '2021-02-20 09:54:24', '2021-02-20 09:54:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3516, 'o1qmn5FV_AdcoZ5EF7okNC6BnUPs', 0, '2021-02-20 09:55:22', '2021-02-20 09:55:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3517, 'o1qmn5J8snP-57eqmRfGn8xMn4aA', 0, '2021-02-20 09:57:42', '2021-02-20 09:57:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3518, 'o1qmn5BUPfXKHoxVNk5aNZWZVuEg', 0, '2021-02-20 10:18:33', '2021-02-20 10:18:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3519, 'o1qmn5CRQaFZIlcWatOkQ_bvAoJE', 0, '2021-02-20 10:25:52', '2021-02-20 10:25:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3520, 'o1qmn5NRPlvL9P3L_ggv2pV9jhu8', 0, '2021-02-20 10:44:24', '2021-02-20 10:44:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3521, 'o1qmn5D5ZFPesizanDKUUra727Ho', 0, '2021-02-20 10:57:11', '2021-02-20 10:57:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3522, 'o1qmn5CFJg24r8RD_EVE79pgrJLo', 0, '2021-02-20 11:10:47', '2021-02-20 11:10:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3523, 'o1qmn5JRxR3QOdV7IPU1nC1HBctE', 0, '2021-02-20 11:20:26', '2021-02-20 11:20:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3524, 'o1qmn5CpAGZXEixZPbkwnuiGOYrw', 0, '2021-02-20 11:21:22', '2021-02-20 11:21:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3525, 'o1qmn5PwuHmmd4Mdmi1wqEi2lh4Y', 0, '2021-02-20 11:43:00', '2021-02-20 11:43:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3526, 'o1qmn5FmhN9vBsciA1vROznfUU6s', 0, '2021-02-20 11:51:40', '2021-02-20 11:51:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3527, 'o1qmn5JIEM8lEsdtTVi_G0i59gJM', 0, '2021-02-20 12:17:19', '2021-02-20 12:17:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3528, 'o1qmn5BfCpRIWwEeNa-OVTRf6Kdc', 0, '2021-02-20 12:31:40', '2021-02-20 12:31:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3529, 'o1qmn5BWbpRiv8oIF2-LXfrM2x24', 6, '2021-02-20 15:02:51', '2021-03-22 22:51:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3530, 'o1qmn5CbQ0L5hja0GD6L59Nx3JW4', 0, '2021-02-20 15:04:10', '2021-02-20 15:04:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3531, 'o1qmn5K0GQvBxDQybI2qbWo-iAIw', 0, '2021-02-20 20:13:29', '2021-02-20 20:13:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3532, 'o1qmn5OHS9v5FaNJdXMS66Hpncug', 0, '2021-02-20 22:42:02', '2021-02-20 22:42:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3533, 'o1qmn5Lp28iNZBZAeSBHNmvhS4As', 3, '2021-02-21 00:10:47', '2021-03-06 20:08:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3534, 'o1qmn5BiKXYCCE8wXB701Gd6STHc', 1, '2021-02-21 08:18:57', '2021-02-22 12:02:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3535, 'o1qmn5LxIKS35X_Ls3FoxHYoDh1U', 0, '2021-02-21 09:53:40', '2021-02-21 09:53:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3536, 'o1qmn5PBSyJ9U53YYBtAe_c5NF9w', 0, '2021-02-21 11:16:58', '2021-02-21 11:16:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3537, 'o1qmn5NcHONbrkrSw1pPNHzjxuG8', 2, '2021-02-21 18:49:14', '2021-03-14 22:19:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3538, 'o1qmn5Ak4dTgQFMmuK88RK_sCjbA', 0, '2021-02-22 09:51:24', '2021-02-22 09:51:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3539, 'o1qmn5DP5HgGo3eFo0ufGAPlVjsk', 3, '2021-02-22 10:32:39', '2021-02-23 10:41:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3540, 'o1qmn5MCjayCBIaK2oTwIjgyD0H0', 0, '2021-02-22 11:07:14', '2021-02-22 11:07:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3541, 'o1qmn5E32t7_ft96A2B8JDYB4_zw', 4, '2021-02-22 11:33:00', '2021-03-04 11:13:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3542, 'o1qmn5JX3SGQZafwWm12q4snebQ0', 0, '2021-02-22 20:01:09', '2021-02-22 20:01:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3543, 'o1qmn5Gmg2R8QErMf5Wc83rVihsA', 0, '2021-02-22 20:38:47', '2021-02-22 20:38:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3544, 'o1qmn5G_8Gs1BUN1-fSsy7fRRdNw', 0, '2021-02-23 07:37:18', '2021-02-23 07:37:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3545, 'o1qmn5PebuZRsEqDT02XU49MiBv4', 3, '2021-02-23 07:38:19', '2021-03-17 14:14:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3546, 'o1qmn5EIaQlklENcO6oQxBCQeOIc', 4, '2021-02-23 09:05:46', '2021-02-23 16:13:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3547, 'o1qmn5HKZ3ZdZnPnjDIpHaxSOylA', 1, '2021-02-23 09:58:01', '2021-03-17 12:31:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3548, 'o1qmn5PuIliNI8KX4VGhLJjFBnMk', 3, '2021-02-23 10:08:19', '2021-03-05 09:39:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3549, 'o1qmn5HR3bXr8WlnkbV3GU63YZP8', 0, '2021-02-23 13:07:19', '2021-02-23 13:07:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3550, 'o1qmn5HjACk-sSLgHce2Yi-QFZQU', 0, '2021-02-23 15:07:09', '2021-02-23 15:07:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3551, 'o1qmn5GcH-VoBWFrkTgAfsN00AJ0', 0, '2021-02-23 15:08:13', '2021-02-23 15:08:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3552, 'o1qmn5Kigc-UssuVOjpr0m0NLQCg', 0, '2021-02-23 15:29:20', '2021-02-23 15:29:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3553, 'o1qmn5HDFRcrZim0l3QVbrix0dOA', 1, '2021-02-23 15:31:34', '2021-03-26 20:57:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3554, 'o1qmn5H4rw4MipGJ4AfgC_oRyf3o', 0, '2021-02-23 16:28:05', '2021-02-23 16:28:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3555, 'o1qmn5JvkeUNfAm8RRJ_CaSKrN1M', 0, '2021-02-23 21:52:45', '2021-02-23 21:52:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3556, 'o1qmn5MbqSxE3zojXJpAM90jP8cU', 0, '2021-02-24 08:19:42', '2021-02-24 08:19:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3557, 'o1qmn5KEbfTN08ZrxYcsrp14dAaU', 0, '2021-02-24 08:20:00', '2021-02-24 08:20:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3558, 'o1qmn5Cu7IkfGEJEgtd5aXuBx3vY', 0, '2021-02-24 08:20:37', '2021-02-24 08:20:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3559, 'o1qmn5OQdOWgDUlm3y05KLacmx6M', 0, '2021-02-24 08:21:00', '2021-02-24 08:21:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3560, 'o1qmn5GVLgSh1RKdjhUJqs0fRkH8', 2, '2021-02-24 08:21:07', '2021-02-24 08:23:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3561, 'o1qmn5Fg411m_5TxWv4iL1L40moQ', 0, '2021-02-24 08:21:18', '2021-02-24 08:21:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3562, 'o1qmn5IIYOiBbZ76waAIncIrHiss', 0, '2021-02-24 08:21:40', '2021-02-24 08:21:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3563, 'o1qmn5HnpKk_-R90Y-9DgSUqS2Bk', 0, '2021-02-24 08:21:45', '2021-02-24 08:21:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3564, 'o1qmn5BoYVfzzFvx42Oqeh78JHP4', 0, '2021-02-24 08:22:07', '2021-02-24 08:22:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3565, 'o1qmn5HLWFDBn7Wz73LWHE5Ta4Ao', 0, '2021-02-24 08:23:09', '2021-02-24 08:23:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3566, 'o1qmn5KSH-p5QENeCu_8TQnqfs-M', 0, '2021-02-24 08:25:43', '2021-02-24 08:25:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3567, 'o1qmn5GQJWwJS5MI3zbndHIswDbY', 0, '2021-02-24 09:05:15', '2021-02-24 09:05:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3568, 'o1qmn5DbL0TF_R0c9m8G66gLmq7A', 0, '2021-02-24 09:05:26', '2021-02-24 09:05:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3569, 'o1qmn5HIX-AMd0I_CzpaKxUeSOEc', 0, '2021-02-24 09:44:41', '2021-02-24 09:44:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3570, 'o1qmn5I7NHVcL-a5JoxnLLA-BIDI', 0, '2021-02-24 09:44:52', '2021-02-24 09:44:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3571, 'o1qmn5F7RWumt6rAAWN6xkaMJnFs', 0, '2021-02-24 10:24:50', '2021-02-24 10:24:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3572, 'o1qmn5A2LlCHoybSzmk5LYUBXhC8', 1, '2021-02-24 10:45:06', '2021-02-27 12:45:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3573, 'o1qmn5OGotfmKh_8B2BESQ63yM-c', 3, '2021-02-24 10:46:59', '2021-03-03 15:32:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3574, 'o1qmn5IJO1yJum9A3sCSZ4iTkYYs', 1, '2021-02-24 10:50:35', '2021-02-24 14:38:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3575, 'o1qmn5C7ylciPaI9Kxcv_2JXqZB4', 0, '2021-02-24 11:05:21', '2021-02-24 11:05:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3576, 'o1qmn5LA8JQOaAtmRuk_wno3KPMI', 0, '2021-02-24 13:06:47', '2021-02-24 13:06:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3577, 'o1qmn5HEk9HhP8pBve0R_RKF6Kko', 0, '2021-02-24 14:00:19', '2021-02-24 14:00:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3578, 'o1qmn5N9Po5hnZEdgEc2WfF3EcnA', 2, '2021-02-24 14:53:12', '2021-03-03 15:31:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3579, 'o1qmn5JddpcNmGxSDH_2Uk8LBukM', 0, '2021-02-24 15:10:00', '2021-02-24 15:10:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3580, 'o1qmn5Fa9mXclSVhIqc8j7CE0Yxg', 0, '2021-02-24 15:43:08', '2021-02-24 15:43:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3581, 'o1qmn5Em5IAnzwsvTjCvCWYQf7Io', 2, '2021-02-24 16:01:22', '2021-02-25 20:18:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3582, 'o1qmn5OXfnC1y_rcYNzDCJyAsTwI', 0, '2021-02-25 04:55:30', '2021-02-25 04:55:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3583, 'o1qmn5Hi8gN72jkhh2ULDeCkuUiM', 1, '2021-02-25 10:05:24', '2021-02-25 10:08:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3584, 'o1qmn5Gmm804goPgu_8fs6PT3tAU', 1, '2021-02-25 12:32:29', '2021-02-25 13:20:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3585, 'o1qmn5IBt97NtElLagtewUcP_0sk', 1, '2021-02-25 13:16:32', '2021-03-04 08:19:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3586, 'o1qmn5NJgh77NGk0dHkgnqr75DQY', 3, '2021-02-25 14:04:14', '2021-03-06 11:44:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3587, 'o1qmn5MbmgrAZbt0I7q7ZJdmWFHs', 0, '2021-02-25 17:33:22', '2021-02-25 17:33:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3588, 'o1qmn5H7AjS4oFZZzRlyyaKx1OEk', 1, '2021-02-26 02:45:55', '2021-02-27 15:40:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3589, 'o1qmn5Cpnv2inTLeFsl1zUUFuj7E', 0, '2021-02-26 05:33:19', '2021-02-26 05:33:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3590, 'o1qmn5M3f5Tfah_GsYMJfLJiPyPE', 0, '2021-02-26 08:34:39', '2021-02-26 08:34:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3591, 'o1qmn5LfYBm7DESO3VPBU07u1-vE', 0, '2021-02-26 09:13:53', '2021-02-26 09:13:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3592, 'o1qmn5MW6VVtn9ahzg9Arof-z8gw', 0, '2021-02-26 09:37:26', '2021-02-26 09:37:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3593, 'o1qmn5Enc7jVuBHt78i9jWxuOeps', 0, '2021-02-26 11:15:06', '2021-02-26 11:15:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3594, 'o1qmn5FhJ7eqi0W9mk6kaLF3nHuk', 0, '2021-02-26 12:29:55', '2021-02-26 12:29:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3595, 'o1qmn5J_SPxUZG8LTORZyMhmmGB0', 0, '2021-02-26 13:29:46', '2021-02-26 13:29:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3596, 'o1qmn5GFlou9VRlEsnYYDza1PVPI', 0, '2021-02-26 13:40:46', '2021-02-26 13:40:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3597, 'o1qmn5L23rh3AeCxcVGnRGH4izaM', 0, '2021-02-26 14:30:04', '2021-02-26 14:30:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3598, 'o1qmn5Kznv64958kR6OdI89P6djs', 0, '2021-02-26 15:08:21', '2021-02-26 15:08:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3599, 'o1qmn5BC22z6RNwiWC6c1mtPyK7s', 2, '2021-02-26 15:26:13', '2021-03-07 21:37:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3600, 'o1qmn5EUrWbdcaBFasNvfp4AIEdM', 0, '2021-02-26 22:06:37', '2021-02-26 22:06:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3601, 'o1qmn5CGfgFLscEmGZdzDBaSJVFY', 1, '2021-02-27 13:38:59', '2021-02-27 16:52:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3602, 'o1qmn5LkkKsHjG_obLLAEZL7Nlgw', 0, '2021-02-27 15:09:26', '2021-02-27 15:09:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3603, 'o1qmn5BHH68UJ0izdYv_m9Zmv1Nw', 1, '2021-02-28 03:14:06', '2021-02-28 03:20:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3604, 'o1qmn5Jm3g9Io9i7mKX6T9IOKMME', 0, '2021-02-28 05:13:02', '2021-02-28 05:13:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3605, 'o1qmn5FRiXKJPhBntALo5IWdpB7A', 0, '2021-02-28 11:26:04', '2021-02-28 11:26:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3606, 'o1qmn5P3Kuofq6a-DzkdFuy0VxAs', 0, '2021-02-28 14:26:12', '2021-02-28 14:26:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3607, 'o1qmn5HegemVPObK7JHxu9TLFb08', 2, '2021-02-28 14:30:50', '2021-03-18 13:28:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3608, 'o1qmn5IEUYzKlquZnq_ewAg2EyrA', 0, '2021-02-28 15:39:01', '2021-02-28 15:39:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3609, 'o1qmn5JfayPVSxfP7DBAfwUuQeEI', 1, '2021-02-28 18:55:36', '2021-03-12 15:52:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3610, 'o1qmn5ApbvqAAQ4N7gJF9EkMQXu8', 0, '2021-03-01 04:45:00', '2021-03-01 04:45:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3611, 'o1qmn5ALtNrstr6kQacoFYSpxezE', 0, '2021-03-01 04:47:00', '2021-03-01 04:47:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3612, 'o1qmn5KD6MhxcBZUEfn_mnXH7oyI', 0, '2021-03-01 05:41:32', '2021-03-01 05:41:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3613, 'o1qmn5NISIoQkZvBCiBR1HDs7fMo', 0, '2021-03-01 10:25:24', '2021-03-01 10:25:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3614, 'o1qmn5DuIqCE3zYcozZpQwV-nKcM', 3, '2021-03-01 11:46:01', '2021-03-04 14:45:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3615, 'o1qmn5NTexJAi9vPZYhyjVQ8kcu8', 1, '2021-03-01 11:46:57', '2021-03-08 16:23:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3616, 'o1qmn5L-jcj_tFfd2d7p-E3fqNbs', 0, '2021-03-01 14:11:21', '2021-03-01 14:11:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3617, 'o1qmn5BSZUP5zdMw7JoL5trQ0i4k', 0, '2021-03-01 14:16:47', '2021-03-01 14:16:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3618, 'o1qmn5GmbkTzaVxeIgJOz69KCSm0', 2, '2021-03-01 14:17:50', '2021-03-15 11:15:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3619, 'o1qmn5AhBgM0xBuVTGg9G8vRvHoo', 1, '2021-03-01 14:25:18', '2021-03-10 12:22:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3620, 'o1qmn5JR6ms_g54Z1KpQ0dvD1jf0', 1, '2021-03-01 14:26:23', '2021-03-10 12:20:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3621, 'o1qmn5BG53ZOdaTcQPQ9AFr19YAQ', 1, '2021-03-01 14:33:46', '2021-03-10 12:24:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3622, 'o1qmn5NfeYQ51TN1Pp4W-3q6UrFw', 1, '2021-03-01 15:26:09', '2021-03-10 12:31:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3623, 'o1qmn5Ft2MtnAgzZ75aXLc8wnQxs', 0, '2021-03-01 15:56:11', '2021-03-01 15:56:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3624, 'o1qmn5BWLQl4JFVbKuaqio6Q62VM', 1, '2021-03-02 11:15:07', '2021-03-15 08:26:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3625, 'o1qmn5CZQvRYPywEcvUIa0ATxer4', 2, '2021-03-02 16:59:42', '2021-03-02 17:57:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3626, 'o1qmn5O8hWI3xu2pGJN-Kya67h18', 0, '2021-03-02 17:10:59', '2021-03-02 17:10:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3627, 'o1qmn5LUuvnjuSVbj0LORT2fPPf4', 1, '2021-03-02 20:14:32', '2021-03-17 07:59:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3628, 'o1qmn5IFBu6V3BQFoV30wiPVObN4', 0, '2021-03-02 20:15:32', '2021-03-02 20:15:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3629, 'o1qmn5HGx6vjArXWlOUT6SW_uozY', 0, '2021-03-02 20:19:27', '2021-03-02 20:19:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3630, 'o1qmn5DQhfsvJpLEyxNNQxniARvA', 0, '2021-03-03 05:28:41', '2021-03-03 05:28:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3631, 'o1qmn5M5llYCn3KkreoGwq3Pu_ZY', 2, '2021-03-03 23:03:24', '2021-03-06 19:09:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3632, 'o1qmn5AamZw5vXOaRD0jJbODXha4', 0, '2021-03-04 05:24:39', '2021-03-04 05:24:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3633, 'o1qmn5CywGa57ETwfygthcr3ZSmg', 0, '2021-03-04 06:48:21', '2021-03-04 06:48:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3634, 'o1qmn5Ef1xkHo1HCUh3rN2NMD2NE', 0, '2021-03-04 10:33:30', '2021-03-04 10:33:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3635, 'o1qmn5CorzNl4_-VsqP4zudn1zVw', 0, '2021-03-04 10:33:44', '2021-03-04 10:33:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3636, 'o1qmn5MMXdX79OXR2L9rHDTjwfH0', 1, '2021-03-04 10:33:50', '2021-03-18 13:21:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3637, 'o1qmn5Bnz-mF7uJDgImzdutprgmU', 1, '2021-03-04 10:33:51', '2021-03-09 10:50:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3638, 'o1qmn5PEAGKJTK0XOstPArLQS9S8', 0, '2021-03-04 10:34:11', '2021-03-04 10:34:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3639, 'o1qmn5FYxmGsgvJtFnB3fzzZ8p-Y', 1, '2021-03-04 10:34:27', '2021-03-05 08:10:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3640, 'o1qmn5MKdKfxAADHY4r0gOVAKCYI', 0, '2021-03-04 14:50:03', '2021-03-04 14:50:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3641, 'o1qmn5BOqSxgyiLEle5gz5_xuR20', 0, '2021-03-04 15:06:51', '2021-03-04 15:06:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3642, 'o1qmn5D8Ow5sZi6Sc7LkO0xF5S1U', 0, '2021-03-04 23:23:43', '2021-03-04 23:23:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3643, 'o1qmn5EO-7-aBnZwXdF_bnhzQHCA', 0, '2021-03-05 06:30:14', '2021-03-05 06:30:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3644, 'o1qmn5DUEz6AWOetqKf7ekUrpDzE', 0, '2021-03-05 08:46:59', '2021-03-05 08:46:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3645, 'o1qmn5MWOdq2Zp3xzTL2CrM4LosI', 2, '2021-03-05 09:38:09', '2021-03-08 10:15:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3646, 'o1qmn5La5vecgq6FtfDGpvXoujsE', 0, '2021-03-05 11:21:37', '2021-03-05 11:21:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3647, 'o1qmn5Fs2HAAB2pTj49FxcgcbhJ8', 0, '2021-03-05 11:23:43', '2021-03-05 11:23:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3648, 'o1qmn5Mu06OpE6kJXNV2t3dztFyQ', 0, '2021-03-05 11:30:53', '2021-03-05 11:30:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3649, 'o1qmn5Oi7Ml0asRTjUcZnNAfznwE', 2, '2021-03-05 12:04:14', '2021-03-05 16:15:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3650, 'o1qmn5N7-kFFXaMA_u2X0mSkGZY0', 0, '2021-03-05 14:29:53', '2021-03-05 14:29:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3651, 'o1qmn5F5xxA3xjH4ib9kTS6-O7FA', 0, '2021-03-05 14:30:24', '2021-03-05 14:30:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3652, 'o1qmn5GmV5cAqFevuEqmZqGit3Ss', 5, '2021-03-05 14:32:25', '2021-03-11 20:50:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3653, 'o1qmn5LBCcOPGEML4dfFo5WaXQVc', 1, '2021-03-05 14:35:06', '2021-03-05 14:36:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3654, 'o1qmn5HI17meQufeLJfN-e2fApmI', 0, '2021-03-05 14:46:58', '2021-03-05 14:46:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3655, 'o1qmn5JYpEEhd41PE4POTRgaOyfI', 0, '2021-03-05 15:16:15', '2021-03-05 15:16:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3656, 'o1qmn5NPRoTtmE1pbZhNCqQ8LyKA', 1, '2021-03-05 15:28:52', '2021-03-05 15:46:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3657, 'o1qmn5IlHhSFHBeU8FTutKARNRvk', 1, '2021-03-05 15:38:14', '2021-03-05 16:10:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3658, 'o1qmn5JK9QgBzy0YFWFjhsUrOBjM', 0, '2021-03-05 15:38:29', '2021-03-05 15:38:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3659, 'o1qmn5MJxIbGfajOtoKGmfOre03w', 1, '2021-03-05 15:38:52', '2021-03-05 16:04:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3660, 'o1qmn5FAwBGJOkUGYmzjGaKizlrU', 0, '2021-03-05 18:14:23', '2021-03-05 18:14:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3661, 'o1qmn5EQ_03ttMVLV5_M8uvNemwU', 0, '2021-03-05 18:14:24', '2021-03-05 18:14:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3662, 'o1qmn5HBDdeLXHHHFXjhM2D4RLVI', 0, '2021-03-05 18:14:41', '2021-03-05 18:14:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3663, 'o1qmn5MJq7jw1rE-8TMjAIoB2d8k', 0, '2021-03-05 18:14:43', '2021-03-05 18:14:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3664, 'o1qmn5Kp52hRccSgu-8bCGda6Cr0', 0, '2021-03-05 18:15:13', '2021-03-05 18:15:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3665, 'o1qmn5ET0xGlwerQxhct2xU3JdBY', 0, '2021-03-05 18:15:36', '2021-03-05 18:15:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3666, 'o1qmn5LxmkOgJEO-nkBS16azYaWk', 0, '2021-03-05 18:16:57', '2021-03-05 18:16:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3667, 'o1qmn5BkquFbCkmN6gkkxFosPeTA', 0, '2021-03-05 18:20:54', '2021-03-05 18:20:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3668, 'o1qmn5O9BX07JeXEkZqerp1vQY04', 0, '2021-03-05 18:24:32', '2021-03-05 18:24:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3669, 'o1qmn5LtuIiDqTuMY-l_wwc8TNfo', 0, '2021-03-05 18:39:47', '2021-03-05 18:39:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3670, 'o1qmn5C7Gs6Do53sC9Jy9tt58ocs', 0, '2021-03-05 19:04:40', '2021-03-05 19:04:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3671, 'o1qmn5DH0dFDpL52Z1PJKNF7CiPI', 0, '2021-03-05 20:04:07', '2021-03-05 20:04:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3672, 'o1qmn5JnzxQF_jH1i9W3ESQ3jdSs', 0, '2021-03-05 20:27:21', '2021-03-05 20:27:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3673, 'o1qmn5KDzzFlnFTmrMSny8zgIR3Q', 1, '2021-03-05 21:28:08', '2021-03-08 13:39:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3674, 'o1qmn5LlKkb_OiJW6xNixs-Ea47g', 0, '2021-03-06 08:42:06', '2021-03-06 08:42:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3675, 'o1qmn5EzAL2DxkHr3TU7bvJ2pw0M', 0, '2021-03-06 10:11:10', '2021-03-06 10:11:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3676, 'o1qmn5PALHnzxSPKJ6rJSW9anejc', 0, '2021-03-06 13:57:34', '2021-03-06 13:57:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3677, 'o1qmn5G-WEJmbyl9dBYZHeaYewbA', 0, '2021-03-06 18:27:56', '2021-03-06 18:27:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3678, 'o1qmn5Md5Tsaax0qgoPQXs-EIOkI', 0, '2021-03-06 20:45:08', '2021-03-06 20:45:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3679, 'o1qmn5FhhLdcozpKSsT8mZ7cyel4', 0, '2021-03-07 08:49:38', '2021-03-07 08:49:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3680, 'o1qmn5IqDc_H_RtsWGxViTDyLDpI', 0, '2021-03-07 10:34:43', '2021-03-07 10:34:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3681, 'o1qmn5D0dMNXKxSH9A_Uc7m5VE0I', 0, '2021-03-07 11:29:22', '2021-03-07 11:29:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3682, 'o1qmn5ASu2yKVZ53q4ztmI432X_Y', 1, '2021-03-07 18:44:18', '2021-03-08 11:42:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3683, 'o1qmn5Av9a6PJNk_dI8CqyBr0x0Q', 0, '2021-03-07 21:07:26', '2021-03-07 21:07:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3684, 'o1qmn5Jca2P1WHuHF8-PMJpO31aI', 0, '2021-03-08 05:04:34', '2021-03-08 05:04:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3685, 'o1qmn5DVAxv6wpHBriPvR0LctOUk', 0, '2021-03-08 10:28:03', '2021-03-08 10:28:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3686, 'o1qmn5P9hc5myUARJzNsCBeB_hX4', 0, '2021-03-08 11:57:48', '2021-03-08 11:57:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3687, 'o1qmn5MDW746Jwde-gObdsTpg-II', 0, '2021-03-08 13:07:07', '2021-03-08 13:07:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3688, 'o1qmn5PIijkSJQ13B5XC1rNMnrL4', 0, '2021-03-08 15:55:31', '2021-03-08 15:55:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3689, 'o1qmn5ECf_x_7HLyoAUgrHKCHwL8', 0, '2021-03-08 17:00:11', '2021-03-08 17:00:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3690, 'o1qmn5KDFqVeHsdcDLDAxDd8MLUg', 1, '2021-03-08 17:52:41', '2021-03-09 13:48:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3691, 'o1qmn5HG7blOprVQz4koT4X9ODf8', 1, '2021-03-08 23:06:29', '2021-03-26 12:16:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3692, 'o1qmn5FmjvRwa3m5F82-Lfg7Ggvs', 0, '2021-03-09 05:07:01', '2021-03-09 05:07:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3693, 'o1qmn5GKKQ5m_Eqo6dAyfrNO6ddU', 0, '2021-03-09 08:58:23', '2021-03-09 08:58:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3694, 'o1qmn5FK15viewG0-8mrNw_X6JwA', 0, '2021-03-09 10:14:15', '2021-03-09 10:14:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3695, 'o1qmn5ERG84Y3_h5u-YY3vNYKMIA', 0, '2021-03-09 11:32:01', '2021-03-09 11:32:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3696, 'o1qmn5PjFuA-fEecO7QNeLwVLjhg', 4, '2021-03-09 12:58:33', '2021-03-22 13:03:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3697, 'o1qmn5NL0m97kQoE9qwEh9bxfC9w', 0, '2021-03-09 12:59:50', '2021-03-09 12:59:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3698, 'o1qmn5I4YP6JAELGopM6UDU7UgYk', 1, '2021-03-09 14:58:46', '2021-03-09 15:26:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3699, 'o1qmn5HsddsGRiGRJJIud0SY1sfQ', 4, '2021-03-09 15:23:02', '2021-03-09 16:05:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3700, 'o1qmn5O8DerrAE3XHHT_nbXE1nXk', 0, '2021-03-09 21:40:27', '2021-03-09 21:40:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3701, 'o1qmn5PfXcqnIyefPy8qR6iZqrFg', 0, '2021-03-10 04:23:12', '2021-03-10 04:23:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3702, 'o1qmn5Fs__3b445WW5wdizM2mCE4', 0, '2021-03-10 09:43:13', '2021-03-10 09:43:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3703, 'o1qmn5LKnOGeJM5IxmGS70SRS0yw', 0, '2021-03-10 12:19:59', '2021-03-10 12:19:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3704, 'o1qmn5JNpcVmTjhD8d5VcLADd4iU', 0, '2021-03-10 12:20:08', '2021-03-10 12:20:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3705, 'o1qmn5JIBKW0zAHK5anSb-bcBc6k', 0, '2021-03-10 13:47:42', '2021-03-10 13:47:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3706, 'o1qmn5KQMYBXZuqdY0FJPLaZK7X4', 3, '2021-03-10 14:16:15', '2021-03-11 11:44:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3707, 'o1qmn5PHtsrCOFJvfbflgFagkb6E', 1, '2021-03-10 14:18:26', '2021-03-10 17:30:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3708, 'o1qmn5I3lgLCzT8PNVgw1-juqgSU', 0, '2021-03-10 21:04:40', '2021-03-10 21:04:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3709, 'o1qmn5Njcg8l3UzHt4Kuur_vFfoQ', 0, '2021-03-10 22:51:11', '2021-03-10 22:51:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3710, 'o1qmn5IksLbbvRG5W3BIAz2XHE0g', 0, '2021-03-11 06:07:17', '2021-03-11 06:07:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3711, 'o1qmn5KmrK9DkWgn_pMQXQVYTSOs', 0, '2021-03-11 07:06:07', '2021-03-11 07:06:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3712, 'o1qmn5KZhmdzmiYrYOuJlmcx5epE', 0, '2021-03-11 11:15:22', '2021-03-11 11:15:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3713, 'o1qmn5Lvm8xlp2lRVX3zElaV4HKM', 0, '2021-03-11 11:52:31', '2021-03-11 11:52:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3714, 'o1qmn5JiE3UOgYhNYmKloQxoZLcA', 1, '2021-03-11 12:53:25', '2021-03-22 08:08:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3715, 'o1qmn5KKzAgKOpNFepLklUFlpjoY', 1, '2021-03-11 12:55:43', '2021-03-13 19:56:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3716, 'o1qmn5KSmVSH__BH-c1zMTUcvhqY', 3, '2021-03-11 13:35:37', '2021-03-13 23:02:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3717, 'o1qmn5FKRAY3OMBMCBtYabQFP2TA', 1, '2021-03-11 13:43:34', '2021-03-15 18:09:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3718, 'o1qmn5F2w11eF5eTKhrCJDI62Vms', 0, '2021-03-11 13:51:06', '2021-03-11 13:51:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3719, 'o1qmn5FJiZTLHbL-khZeKu-M4kg8', 0, '2021-03-11 13:51:09', '2021-03-11 13:51:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3720, 'o1qmn5FEt2trylwbzXXS7MIsChKw', 0, '2021-03-11 13:52:38', '2021-03-11 13:52:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3721, 'o1qmn5IuGGsKR868w-gNuy4v6xeA', 0, '2021-03-11 17:34:44', '2021-03-11 17:34:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3722, 'o1qmn5NOcFo-QDJDMYu17vald18E', 0, '2021-03-11 17:35:58', '2021-03-11 17:35:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3723, 'o1qmn5CzHuGqu1EhnPQv8ziFEzwM', 2, '2021-03-11 20:55:26', '2021-03-12 11:17:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3724, 'o1qmn5HhD3HyYYj3G0oqwY3wkfDw', 0, '2021-03-11 21:26:51', '2021-03-11 21:26:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3725, 'o1qmn5NIYRoVFPS1DMfdYpA2q-3U', 0, '2021-03-12 07:56:41', '2021-03-12 07:56:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3726, 'o1qmn5AtzzypfISW3Du_L8uXNEeQ', 0, '2021-03-12 08:24:14', '2021-03-12 08:24:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3727, 'o1qmn5Ew5GUVRpKY2nfZqVwYUE8I', 0, '2021-03-12 08:24:19', '2021-03-12 08:24:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3728, 'o1qmn5FA3eG94fS_pafLbuZgrYLQ', 0, '2021-03-12 08:24:23', '2021-03-12 08:24:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3729, 'o1qmn5AduDyjFmNm0fCA5SMdHpec', 0, '2021-03-12 08:57:51', '2021-03-12 08:57:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3730, 'o1qmn5N5qFRLv2YFjwj9p8wii4ng', 1, '2021-03-12 08:59:56', '2021-03-12 09:06:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3731, 'o1qmn5KHlDn7rwlUt9uNLJsad7Vw', 0, '2021-03-12 09:12:52', '2021-03-12 09:12:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3732, 'o1qmn5K1Qaz2GaMXs1A2U8fgYdLw', 1, '2021-03-12 09:20:39', '2021-03-12 18:33:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3733, 'o1qmn5Eds5XN1KyV5wbpPpgb-ysc', 0, '2021-03-12 10:53:32', '2021-03-12 10:53:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3734, 'o1qmn5DIKlFYuYpeiqvdOedq5gB4', 1, '2021-03-12 12:15:14', '2021-03-20 07:56:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3735, 'o1qmn5KuIAMA1WxlskTD1A6f_e6E', 0, '2021-03-12 12:19:10', '2021-03-12 12:19:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3736, 'o1qmn5OST8WZiTQxvIYhNYzV9nIk', 5, '2021-03-12 12:24:30', '2021-03-17 12:56:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3737, 'o1qmn5Dn-4f0Njl469PMvUqSheCM', 3, '2021-03-12 12:46:20', '2021-03-12 12:47:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3738, 'o1qmn5J_muCosYIBGFQMyWLvimcM', 1, '2021-03-12 13:48:23', '2021-03-12 22:43:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3739, 'o1qmn5KG451BV6hr1rDbxC7uHuUw', 0, '2021-03-12 14:12:49', '2021-03-12 14:12:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3740, 'o1qmn5G6pwzZmnsABJq-848RfGDc', 0, '2021-03-12 15:30:33', '2021-03-12 15:30:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3741, 'o1qmn5DB54rt4Iuwr6o8GDOc3JhI', 0, '2021-03-12 16:03:41', '2021-03-12 16:03:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3742, 'o1qmn5GNbUEVXGrt7tPXPdjvMvNo', 0, '2021-03-12 16:28:50', '2021-03-12 16:28:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3743, 'o1qmn5J4Gqi7u6JEzRJlpHj3_zxs', 2, '2021-03-12 17:44:16', '2021-03-21 08:35:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3744, 'o1qmn5G8CFAxwkqSd0gdCSVoaIqc', 0, '2021-03-12 19:44:15', '2021-03-12 19:44:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3745, 'o1qmn5PVS6aIMVi_91i3i7OxVKQQ', 1, '2021-03-12 22:04:58', '2021-03-14 11:45:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3746, 'o1qmn5Hv0RSLuYYSBYv8FPt0zV3w', 1, '2021-03-13 00:07:21', '2021-03-26 00:56:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3747, 'o1qmn5K1CN3luF21QJAlncKLn-c0', 2, '2021-03-13 09:46:07', '2021-03-24 14:26:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3748, 'o1qmn5HjkWx5dKdan7tsX2Cdi_hc', 3, '2021-03-13 09:52:04', '2021-03-13 14:20:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3749, 'o1qmn5Ay0BwmO_L1DfJeusTGe-TQ', 2, '2021-03-13 11:16:21', '2021-03-18 13:45:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3750, 'o1qmn5GaeyBRhh7SY3Z-c71SgVtU', 0, '2021-03-13 12:17:38', '2021-03-13 12:17:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3751, 'o1qmn5LhaJ4IqLao6zpoU3xDkMOY', 0, '2021-03-13 13:26:25', '2021-03-13 13:26:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3752, 'o1qmn5GosLPthfZ4rF3Jy06Ac2Sw', 3, '2021-03-13 14:00:01', '2021-03-23 22:37:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3753, 'o1qmn5B8hJsIp5zCiA1vI-h0o9ro', 0, '2021-03-13 14:11:18', '2021-03-13 14:11:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3754, 'o1qmn5JoV2FUnagJqc3wJ2BhvhI8', 0, '2021-03-13 14:36:19', '2021-03-13 14:36:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3755, 'o1qmn5Dvn2lbkok1nUGbWpxIQ_Co', 1, '2021-03-13 17:40:48', '2021-03-13 18:24:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3756, 'o1qmn5EE01gjCxrU8of1MVs-1SKU', 0, '2021-03-13 17:53:54', '2021-03-13 17:53:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3757, 'o1qmn5OhkqqWDyA34ADFzERiyPWs', 0, '2021-03-13 19:06:29', '2021-03-13 19:06:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3758, 'o1qmn5Civ749FmecncgHO_9RZUE8', 0, '2021-03-13 19:56:58', '2021-03-13 19:56:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3759, 'o1qmn5FRVUPVokRRXePth-fCyx3M', 0, '2021-03-14 05:58:56', '2021-03-14 05:58:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3760, 'o1qmn5AVwN0gSBlb776HmWoPsdVw', 0, '2021-03-14 10:43:57', '2021-03-14 10:43:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3761, 'o1qmn5M025XE8AgmRzOI2wKIWtCw', 2, '2021-03-14 12:30:42', '2021-03-22 16:12:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3762, 'o1qmn5AJFfFuT-H6jchWpUnoicW4', 0, '2021-03-14 12:50:13', '2021-03-14 12:50:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3763, 'o1qmn5LG14f4hg_JLGD3aggoFlXk', 0, '2021-03-15 05:10:39', '2021-03-15 05:10:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3764, 'o1qmn5EoPLNoydU7nQ_8dhcuizGg', 0, '2021-03-15 08:50:21', '2021-03-15 08:50:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3765, 'o1qmn5IjfnQ2HJuWLfvMOA7IWois', 0, '2021-03-15 10:20:35', '2021-03-15 10:20:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3766, 'o1qmn5BVME52Zs5ySDyYrnEp-fig', 0, '2021-03-15 11:29:23', '2021-03-15 11:29:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3767, 'o1qmn5OZGsG82L3x-qx7w-r4oZWU', 0, '2021-03-15 11:37:23', '2021-03-15 11:37:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3768, 'o1qmn5Gt14tKQHtiwnEHJ2zkNgB0', 0, '2021-03-15 11:45:08', '2021-03-15 11:45:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3769, 'o1qmn5AbtRJTrI_jmiCMDqtbs5Gg', 0, '2021-03-15 12:17:29', '2021-03-15 12:17:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3770, 'o1qmn5KrR4Wsug2NS8fRoARRzJ74', 0, '2021-03-15 12:18:24', '2021-03-15 12:18:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3771, 'o1qmn5Cka1DLlv2myD16zEiTC4N8', 1, '2021-03-15 13:57:14', '2021-03-16 09:28:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3772, 'o1qmn5KPkTIJRGlwPfYu3mZmbK5c', 0, '2021-03-15 15:29:48', '2021-03-15 15:29:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3773, 'o1qmn5KjGxQawaj48kIu5XkUk6T8', 0, '2021-03-15 15:31:49', '2021-03-15 15:31:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3774, 'o1qmn5FbMmDQ7qFKteuuQZs9Mw-k', 0, '2021-03-15 16:35:20', '2021-03-15 16:35:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3775, 'o1qmn5JrKy1M6Hc_IlJH0lC7aJyc', 0, '2021-03-15 16:35:33', '2021-03-15 16:35:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3776, 'o1qmn5PrfgKNm6QALRp7m1k9NYis', 0, '2021-03-15 16:36:23', '2021-03-15 16:36:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3777, 'o1qmn5HEhj_z1V9CkDTIzN2FCX4I', 0, '2021-03-15 16:37:32', '2021-03-15 16:37:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3778, 'o1qmn5NugAqz8PJjj9Rs1GgmULy4', 0, '2021-03-15 16:39:34', '2021-03-15 16:39:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3779, 'o1qmn5JaInPzEO_ogJyoMlIjMWgY', 0, '2021-03-15 16:41:40', '2021-03-15 16:41:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3780, 'o1qmn5O-rIFk6J93wvQ3fCXcOWzM', 0, '2021-03-15 16:45:39', '2021-03-15 16:45:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3781, 'o1qmn5BW3ryremNJMAPsJPx1AlZ0', 0, '2021-03-15 16:48:29', '2021-03-15 16:48:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3782, 'o1qmn5NjrcOogzJe0FK-_It3RUHA', 0, '2021-03-15 16:57:49', '2021-03-15 16:57:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3783, 'o1qmn5HTfQz8YRpSbcp4Mu2CPq1U', 1, '2021-03-15 17:01:03', '2021-03-20 09:42:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3784, 'o1qmn5HaNFJqZyraqpJKqBjJepdg', 0, '2021-03-15 17:05:48', '2021-03-15 17:05:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3785, 'o1qmn5OCkycDBK-eaKwOFGaG0NOY', 0, '2021-03-15 18:06:21', '2021-03-15 18:06:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3786, 'o1qmn5LH-ah5kX4WhB3hq5EF6MAE', 0, '2021-03-15 18:14:00', '2021-03-15 18:14:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3787, 'o1qmn5GRJkfP0a--0XQc9iU5fBG8', 0, '2021-03-15 19:26:21', '2021-03-15 19:26:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3788, 'o1qmn5G7VgJfxW9psJmiejIIbq9A', 0, '2021-03-15 20:39:39', '2021-03-15 20:39:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3789, 'o1qmn5PlASxcLgxjkF_FvLahOoGo', 0, '2021-03-16 04:42:16', '2021-03-16 04:42:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3790, 'o1qmn5HBtWl56-tYGlCFmsU2PY40', 0, '2021-03-16 07:26:20', '2021-03-16 07:26:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3791, 'o1qmn5EDW1evjIZcEXTgxZZsRE_0', 0, '2021-03-16 07:26:30', '2021-03-16 07:26:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3792, 'o1qmn5GGZxzVDAn1eHgFwVtUcxVo', 0, '2021-03-16 07:27:14', '2021-03-16 07:27:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3793, 'o1qmn5EyTSBmBd7Ufps9FUJDs11M', 0, '2021-03-16 07:27:42', '2021-03-16 07:27:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3794, 'o1qmn5B1tKtXTP5E6k3G51ZnfyuE', 0, '2021-03-16 07:28:43', '2021-03-16 07:28:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3795, 'o1qmn5K20Eobc3607p4g92EXrQi0', 0, '2021-03-16 07:34:45', '2021-03-16 07:34:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3796, 'o1qmn5OiL0Z3mdq5NfQBIR07UZPU', 0, '2021-03-16 07:36:00', '2021-03-16 07:36:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3797, 'o1qmn5C_eWTKA30UflWXM5kbsr9Q', 0, '2021-03-16 09:24:08', '2021-03-16 09:24:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3798, 'o1qmn5BXBv6eZJG7b4eZoNo8sqnc', 4, '2021-03-16 09:38:05', '2021-03-28 17:39:17', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3799, 'o1qmn5FjASyjkSYdlJ3FrM-geasA', 0, '2021-03-16 10:34:57', '2021-03-16 10:34:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3800, 'o1qmn5LCPF8WuaCWcFX2eYPckNN0', 0, '2021-03-16 10:51:19', '2021-03-16 10:51:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3801, 'o1qmn5Fh0eZl-G77msxxJ-D-dGtE', 0, '2021-03-16 11:08:23', '2021-03-16 11:08:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3802, 'o1qmn5BseSjVxpDcpRxzgQwzmyzk', 0, '2021-03-16 13:07:15', '2021-03-16 13:07:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3803, 'o1qmn5I8yIKdkaUogrSBjhmT_3rE', 0, '2021-03-16 13:53:53', '2021-03-16 13:53:53', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3804, 'o1qmn5NxT3P8QhtVgUkdbQeJuRgo', 0, '2021-03-16 14:16:08', '2021-03-16 14:16:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3805, 'o1qmn5NfGnxqJP-owtLUArQ4jfME', 0, '2021-03-16 14:43:07', '2021-03-16 14:43:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3806, 'o1qmn5MshkFZ9OhXaB46wKibEhJk', 0, '2021-03-16 14:48:59', '2021-03-16 14:48:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3807, 'o1qmn5MpNSLe17NBnzZnWjbwHLeE', 0, '2021-03-16 15:21:36', '2021-03-16 15:21:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3808, 'o1qmn5GD0WDL22DzuFAPyLH5nUIM', 3, '2021-03-16 15:24:58', '2021-03-20 15:36:57', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3809, 'o1qmn5N_q6a1lOW6DnwcnYgS2YhU', 0, '2021-03-16 15:26:58', '2021-03-16 15:26:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3810, 'o1qmn5ORcjAdqON3crlvYNnZr6bg', 1, '2021-03-16 15:28:09', '2021-03-16 16:21:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3811, 'o1qmn5ItXAZ_PAXPuYR2BBOLKhyQ', 1, '2021-03-16 15:48:26', '2021-03-16 15:49:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3812, 'o1qmn5PwicbVUjtd7X14L8baxdBE', 0, '2021-03-16 15:50:29', '2021-03-16 15:50:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3813, 'o1qmn5Dbgnrt9jMRVK9rtdWl7WpU', 1, '2021-03-16 16:52:57', '2021-03-16 16:56:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3814, 'o1qmn5KoEQxUfv9MCcUsawajxumk', 0, '2021-03-16 17:32:28', '2021-03-16 17:32:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3815, 'o1qmn5A468l4_SFKCZZ_JXorXk8Y', 0, '2021-03-16 19:33:35', '2021-03-16 19:33:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3816, 'o1qmn5PyPchDaZQVoHnutDmk03AI', 1, '2021-03-16 22:21:07', '2021-03-19 07:01:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3817, 'o1qmn5Dgyp_5_c6irQh2-5qpHfx4', 0, '2021-03-16 23:08:38', '2021-03-16 23:08:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3818, 'o1qmn5DrQ0J64MLlMGT-mWxcr2F8', 0, '2021-03-17 05:13:30', '2021-03-17 05:13:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3819, 'o1qmn5NpwK6QLEMTHZSc685l-oEc', 1, '2021-03-17 08:09:57', '2021-03-21 11:57:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3820, 'o1qmn5I4JqnuLax94ZE7hEKjA0VE', 0, '2021-03-17 08:34:37', '2021-03-17 08:34:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3821, 'o1qmn5CbmRLMLCEAMaH7hhmlEi7s', 0, '2021-03-17 09:10:21', '2021-03-17 09:10:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3822, 'o1qmn5LZyZ4d1AvyiO640ehHJgcI', 0, '2021-03-17 09:29:41', '2021-03-17 09:29:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3823, 'o1qmn5Pe5KsS68ePswZXuHd-Wkzo', 0, '2021-03-17 09:43:59', '2021-03-17 09:43:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3824, 'o1qmn5Bz5GrEQhFrHStlORpVnqzw', 0, '2021-03-17 09:51:21', '2021-03-17 09:51:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3825, 'o1qmn5GayCJYq6FqZUVAgCwHJQpg', 1, '2021-03-17 09:56:04', '2021-03-17 10:06:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3826, 'o1qmn5CMVIa0VonH85xRYu2Lbwsw', 1, '2021-03-17 10:00:21', '2021-03-17 10:04:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3827, 'o1qmn5K8ofR-bZp4-wvNXHwucd8E', 2, '2021-03-17 12:41:20', '2021-03-17 12:54:47', 'https://thirdwx.qlogo.cn/mmopen/vi_32/VAI7zvicWpOQw1k4piaV1Oey51WoRJHtoXRfbRlXWk8hqSiafYobhyC52iaeLkOmozoaEDbc27rEnaxhn4Ug2rnG1A/132', '😳狂奔的蜗牛🐌', NULL, NULL, NULL, NULL, 0),
	(3828, 'o1qmn5DGFKP1z8WjzvkQMYBBngYs', 0, '2021-03-17 13:02:29', '2021-03-17 13:02:29', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3829, 'o1qmn5MTXFMOn3xfDb7xvoJ6HI2Y', 0, '2021-03-17 13:42:40', '2021-03-17 13:42:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3830, 'o1qmn5MK_XYPzdW4v61UpkIEuIiM', 0, '2021-03-17 13:43:52', '2021-03-17 13:43:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3831, 'o1qmn5Cppe1IgWbCjo15Cb2gKlZM', 0, '2021-03-17 13:58:36', '2021-03-17 13:58:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3832, 'o1qmn5KMVKyAzGXizdG3yIhh5CWo', 0, '2021-03-17 14:29:42', '2021-03-17 14:29:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3833, 'o1qmn5PG0zHM2qCKNtHWTXntRquk', 2, '2021-03-17 14:39:51', '2021-03-18 08:48:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3834, 'o1qmn5HlhSz545iht5ZBCeQr8wws', 0, '2021-03-17 14:54:25', '2021-03-17 14:54:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3835, 'o1qmn5Fiunk4LPvROaZ9eNexWsb8', 0, '2021-03-17 16:50:15', '2021-03-17 16:50:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3836, 'o1qmn5KuXOuLqykIy0aO3ssWUpZ0', 7, '2021-03-17 20:02:18', '2021-03-22 10:17:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3837, 'o1qmn5FW51nwlMc47XMmkCqYUHD8', 1, '2021-03-17 20:05:10', '2021-03-17 20:06:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3838, 'o1qmn5OsyKxJYtJl7HBBrpN0N6Ig', 1, '2021-03-17 21:26:00', '2021-03-22 18:34:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3839, 'o1qmn5F4-P-k-dLeuAKw_tS09LHg', 0, '2021-03-18 07:57:37', '2021-03-18 07:57:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3840, 'o1qmn5B--SS6TpZ4QqVCggeANo80', 1, '2021-03-18 09:30:08', '2021-03-18 15:33:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3841, 'o1qmn5K0EUsnXn-IcFnB6IyruDGU', 0, '2021-03-18 09:45:58', '2021-03-18 09:45:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3842, 'o1qmn5MXf94eqzQYxRgYOzc2zl4I', 0, '2021-03-18 09:54:42', '2021-03-18 09:54:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3843, 'o1qmn5KpCLZQr9RK-w4yE7cE870c', 0, '2021-03-18 11:12:27', '2021-03-18 11:12:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3844, 'o1qmn5FBUw0TR2HkN4V4fERqswDw', 0, '2021-03-18 11:23:42', '2021-03-18 11:23:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3845, 'o1qmn5G9xt0FGVi53GACbI-trIfo', 0, '2021-03-18 11:25:04', '2021-03-18 11:25:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3846, 'o1qmn5KeG1Q-6ohGmM8jlbDNbQ14', 0, '2021-03-18 11:35:16', '2021-03-18 11:35:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3847, 'o1qmn5DXnmJpeimfNHGYLj6bwZs8', 0, '2021-03-18 14:01:44', '2021-03-18 14:01:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3848, 'o1qmn5F59XGJ9FbrVMmCBKXeMg6w', 0, '2021-03-18 14:56:31', '2021-03-18 14:56:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3849, 'o1qmn5D1Bkryok_6ghIqT4EBHIiI', 0, '2021-03-18 15:28:10', '2021-03-18 15:28:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3850, 'o1qmn5DZdpOdSV2Bdt4zPhWlo1T0', 0, '2021-03-18 17:19:39', '2021-03-18 17:19:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3851, 'o1qmn5N-WnXX3xaKY8csgIvjDaVc', 0, '2021-03-18 17:29:36', '2021-03-18 17:29:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3852, 'o1qmn5LNpFzxnsSNDVHPARaqvH2w', 0, '2021-03-18 17:29:40', '2021-03-18 17:29:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3853, 'o1qmn5FPK_zHQ0KuxL4oh7CspuVY', 1, '2021-03-18 19:25:09', '2021-03-18 19:53:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3854, 'o1qmn5D8_zOHU-Gfb1lpaU7nwsRU', 0, '2021-03-18 22:13:55', '2021-03-18 22:13:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3855, 'o1qmn5F1ObI6a-0QIyxSB4i8dmdE', 0, '2021-03-19 09:35:50', '2021-03-19 09:35:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3856, 'o1qmn5DPsTZFvbk_qAr2k3ll_SWI', 0, '2021-03-19 11:55:28', '2021-03-19 11:55:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3857, 'o1qmn5NlHRI7VPHbfcqA7bWpxKOQ', 0, '2021-03-19 16:29:28', '2021-03-19 16:29:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3858, 'o1qmn5NrEElsU8YVnRx5Gl9fObTU', 0, '2021-03-19 17:14:20', '2021-03-19 17:14:20', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3859, 'o1qmn5NYYXNrxl3Hc0I5hbC60J6I', 0, '2021-03-19 17:19:28', '2021-03-19 17:19:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3860, 'o1qmn5CHE28LgKTNDSFADlCOo4Gs', 1, '2021-03-19 17:20:37', '2021-03-28 14:01:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3861, 'o1qmn5C_PvMQXp1P_aWh0t4RTNjw', 0, '2021-03-19 17:32:44', '2021-03-19 17:32:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3862, 'o1qmn5GhCelAfDVEwfgpsI6PIjFk', 1, '2021-03-19 17:43:33', '2021-03-27 17:19:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3863, 'o1qmn5AAiXUcVlokCVZNWz5Ao8Gw', 0, '2021-03-19 17:44:02', '2021-03-19 17:44:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3864, 'o1qmn5LQ4NWOXbwV_OhJJMi4Lylg', 10, '2021-03-19 17:50:38', '2021-03-22 14:31:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3865, 'o1qmn5JV9blIRWMNt1Nbrod4FQ6g', 0, '2021-03-19 19:09:38', '2021-03-19 19:09:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3866, 'o1qmn5LEARvCvMtgre11vzvOhmHw', 0, '2021-03-19 19:55:37', '2021-03-19 19:55:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3867, 'o1qmn5NJ2OwTLHL9PQbU37rEOELk', 0, '2021-03-20 09:48:02', '2021-03-20 09:48:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3868, 'o1qmn5FW7nbmnCi5hn99ez2ltZfw', 0, '2021-03-20 12:12:04', '2021-03-20 12:12:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3869, 'o1qmn5Mgn2ZSasXtaoQJWR5r-03I', 0, '2021-03-20 18:59:42', '2021-03-20 18:59:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3870, 'o1qmn5A7CASM_jm_SNiI5UlBJ3Xk', 0, '2021-03-21 04:41:01', '2021-03-21 04:41:01', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3871, 'o1qmn5No_j83Ob73jtd8N-I2LU-k', 0, '2021-03-21 11:31:24', '2021-03-21 11:31:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3872, 'o1qmn5DNQlfRIWv-kFlXKVZ0ym6A', 0, '2021-03-21 11:57:40', '2021-03-21 11:57:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3873, 'o1qmn5FzCH8nZP9EAKtAsJLC8v18', 5, '2021-03-21 12:27:26', '2021-03-25 09:46:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3874, 'o1qmn5ANb6nNdZojdDqKWzNRimOo', 0, '2021-03-21 12:27:30', '2021-03-21 12:27:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3875, 'o1qmn5KE9-SovZJZOBuhh5DeMDDY', 0, '2021-03-21 12:27:35', '2021-03-21 12:27:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3876, 'o1qmn5LEIUfx2Xzy4bvXynloRshM', 0, '2021-03-21 12:36:36', '2021-03-21 12:36:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3877, 'o1qmn5IXP9JVlAFU4fTs-gxz-EFI', 1, '2021-03-21 12:52:17', '2021-03-29 08:30:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3878, 'o1qmn5JAVqU5TwEQfNubt9XA_m0Q', 0, '2021-03-21 14:18:13', '2021-03-21 14:18:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3879, 'o1qmn5LafhzecVS1H-m4f3hPlK68', 1, '2021-03-21 14:19:35', '2021-03-22 16:22:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3880, 'o1qmn5LHFfXu8Hsqf6q99eH5j2N0', 4, '2021-03-21 14:49:12', '2021-03-24 16:40:05', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3881, 'o1qmn5PycK4W3ptovnplnvZB3DH8', 1, '2021-03-21 15:08:13', '2021-03-23 09:04:45', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3882, 'o1qmn5GJCh5kmD5HxRaxven1OfZc', 1, '2021-03-21 15:10:03', '2021-03-22 09:53:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3883, 'o1qmn5IuQiGVZAx2NXzGkDRHsVlM', 0, '2021-03-21 22:22:23', '2021-03-21 22:22:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3884, 'o1qmn5EDN94SPLJ4ftzhB8kQtns8', 0, '2021-03-22 05:13:36', '2021-03-22 05:13:36', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3885, 'o1qmn5AujVYFwD5NnTkn7Z5NN4KE', 0, '2021-03-22 09:10:33', '2021-03-22 09:10:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3886, 'o1qmn5I3qE6wm-SZT9-B44xDs3BU', 1, '2021-03-22 09:35:39', '2021-03-23 08:51:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3887, 'o1qmn5CtyknYoLpNSkAyscP0AEgI', 0, '2021-03-22 11:24:46', '2021-03-22 11:24:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3888, 'o1qmn5K1e5_I6fx6Cm4bbNxe5RAQ', 0, '2021-03-22 13:08:09', '2021-03-22 13:08:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3889, 'o1qmn5E9d9a6dR2AOU8SOvNz91AA', 1, '2021-03-22 13:18:06', '2021-03-22 14:45:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3890, 'o1qmn5EzRYv-FrEb0TWJfUMEL9cc', 1, '2021-03-22 13:25:05', '2021-03-23 15:08:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3891, 'o1qmn5EHEfU6l5qWJy0K-dk6N9Ng', 0, '2021-03-22 13:54:49', '2021-03-22 13:54:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3892, 'o1qmn5NixakYA6WaNU_b6l3-BT78', 0, '2021-03-22 14:10:58', '2021-03-22 14:10:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3893, 'o1qmn5JF3-ugT1M7wdqFxK-R3Imk', 0, '2021-03-22 15:54:15', '2021-03-22 15:54:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3894, 'o1qmn5J0JTs7hB0y_zDMoVKx-zXQ', 0, '2021-03-22 16:12:28', '2021-03-22 16:12:28', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3895, 'o1qmn5KSbUspZy-soAluSucXexMg', 0, '2021-03-22 16:30:51', '2021-03-22 16:30:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3896, 'o1qmn5G_fjRu08JH7IOFs3oCo_sI', 0, '2021-03-22 16:46:11', '2021-03-22 16:46:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3897, 'o1qmn5O7Lpn08Vsq9PsOVFDQcfyQ', 0, '2021-03-22 16:59:18', '2021-03-22 16:59:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3898, 'o1qmn5LmRfZveYcmX7eEAcmE2nNs', 0, '2021-03-22 17:46:19', '2021-03-22 17:46:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3899, 'o1qmn5KiEpQi0m2d275MEw3McKak', 0, '2021-03-22 18:36:59', '2021-03-22 18:36:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3900, 'o1qmn5NF5vrh_-iT5W8jNmevaFHM', 1, '2021-03-22 18:40:28', '2021-03-22 18:57:32', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3901, 'o1qmn5IVf6xY5VlZWRUE5Q122jUo', 0, '2021-03-22 18:59:33', '2021-03-22 18:59:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3902, 'o1qmn5AXKMOWoUpoWxGaoUghsujA', 0, '2021-03-22 19:25:03', '2021-03-22 19:25:03', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3903, 'o1qmn5D4jINmW1oB0R54GcEikKPo', 0, '2021-03-22 19:35:56', '2021-03-22 19:35:56', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3904, 'o1qmn5L2OZO2X6VgKQJNm3I6tKDc', 4, '2021-03-23 09:16:45', '2021-03-27 13:11:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3905, 'o1qmn5AQVZr48MUkU6px10GgJVs0', 0, '2021-03-23 10:01:27', '2021-03-23 10:01:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3906, 'o1qmn5LSlvoVwJFU-tBuoseLTKFk', 1, '2021-03-23 10:05:36', '2021-03-23 10:11:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3907, 'o1qmn5PuWy8gMZ34AmeKmKzbtxfo', 1, '2021-03-23 11:10:50', '2021-03-25 16:09:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3908, 'o1qmn5Gdv59dWhBroZCxEMFpGBdc', 2, '2021-03-23 11:26:29', '2021-03-28 00:09:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3909, 'o1qmn5NurXKAEg04Mgf3RW5BGCAM', 4, '2021-03-23 12:42:28', '2021-03-25 13:01:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3910, 'o1qmn5InLShTbKRu8gV8Xjs_LVQg', 1, '2021-03-23 12:50:37', '2021-03-23 13:24:26', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3911, 'o1qmn5BmaGJ6QXjyKiDlHIe6Mv4o', 2, '2021-03-23 13:04:32', '2021-03-26 19:02:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3912, 'o1qmn5BhLx6ZLUXOrweU9naUKMHk', 1, '2021-03-23 13:06:03', '2021-03-23 15:48:54', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3913, 'o1qmn5IRppMZciPT1gWXY3azCnKs', 0, '2021-03-23 15:19:09', '2021-03-23 15:19:09', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3914, 'o1qmn5CmOi9jW_a70c1doFT-zNZg', 0, '2021-03-23 17:40:13', '2021-03-23 17:40:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3915, 'o1qmn5IkLtutrgAOZcAuwBlDQHDQ', 0, '2021-03-23 19:08:48', '2021-03-23 19:08:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3916, 'o1qmn5KxhathBg2tXixO3nXDpVrw', 1, '2021-03-24 01:20:48', '2021-03-29 00:18:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3917, 'o1qmn5ILK41GYtSeTSj59IOw7ZDs', 0, '2021-03-24 05:53:43', '2021-03-24 05:53:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3918, 'o1qmn5EL1ECxSWxdh7nEj7wkJV5c', 0, '2021-03-24 09:36:40', '2021-03-24 09:36:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3919, 'o1qmn5CCihz3vhOWgLgn-itCrAKs', 0, '2021-03-24 09:39:10', '2021-03-24 09:39:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3920, 'o1qmn5Onr_zXUWKPKAlR1wwo9xeQ', 1, '2021-03-24 12:25:39', '2021-03-24 12:27:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3921, 'o1qmn5GrmHvkKjXd6BGiQmH1kG-0', 0, '2021-03-24 13:28:31', '2021-03-24 13:28:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3922, 'o1qmn5BKFLGWR8cwVu7phsRRqoa0', 1, '2021-03-24 13:57:39', '2021-03-25 19:25:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3923, 'o1qmn5KdJ3z13RXrrpUyMCg4LlOc', 1, '2021-03-24 14:17:49', '2021-03-24 14:53:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3924, 'o1qmn5CBZujvLkRYkdmrHc7zYIFY', 1, '2021-03-24 14:20:27', '2021-03-26 10:31:06', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3925, 'o1qmn5KGoE1BqvMCvWKig5x5sXG8', 2, '2021-03-24 14:35:24', '2021-03-26 12:38:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3926, 'o1qmn5GvJnKJjwO_64Kxs-8QUJOk', 0, '2021-03-24 14:50:07', '2021-03-24 14:50:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3927, 'o1qmn5DadFgv_5IKkOnXmMVWzW2A', 0, '2021-03-24 14:58:38', '2021-03-24 14:58:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3928, 'o1qmn5L_m58E_aCnbOYF836K3Xhc', 0, '2021-03-24 17:05:25', '2021-03-24 17:05:25', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3929, 'o1qmn5OBSBMcURFOau8oqDHgEeVE', 0, '2021-03-24 17:27:51', '2021-03-24 17:27:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3930, 'o1qmn5Hvsy_5m5_eWwAAecY1QHtM', 2, '2021-03-24 17:32:33', '2021-03-24 21:17:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3931, 'o1qmn5NHHWwivUny-8bQOgDTtgNU', 1, '2021-03-24 17:33:58', '2021-03-25 09:57:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3932, 'o1qmn5OO2NvUqLYIAxm6Wiw5fhEQ', 0, '2021-03-24 18:37:40', '2021-03-24 18:37:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3933, 'o1qmn5P84-144oEvn3PMDXaOEqas', 0, '2021-03-24 18:51:03', '2021-03-24 18:51:03', 'https://thirdwx.qlogo.cn/mmopen/vi_32/kZ8sA5rnh5KOMGEIKvicxgwDXZb7WQlia7SbgqvQWS80NNzlKZ5XW7MX4icYgpXjnw9P6R8nfZfLDPyNGl1TAr1tQ/132', '卢阿发15877441571', NULL, NULL, NULL, NULL, 0),
	(3934, 'o1qmn5M_2l83ErhshxQ2lvHxQHPA', 0, '2021-03-24 20:39:15', '2021-03-24 20:39:15', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3935, 'o1qmn5OgAolGBZpO3ulmg5XC_Rv4', 0, '2021-03-25 00:33:24', '2021-03-25 00:33:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3936, 'o1qmn5CLNxVK1Y0uMAY5c5c2wRBk', 0, '2021-03-25 09:56:10', '2021-03-25 09:56:10', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3937, 'o1qmn5P6KDekUmF-AtMcYqf6fJZ4', 0, '2021-03-25 10:00:22', '2021-03-25 10:00:22', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3938, 'o1qmn5OcEnNtbOFU5szdt3YUtRiE', 0, '2021-03-25 10:16:48', '2021-03-25 10:16:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3939, 'o1qmn5CheM6DGg5WyMoLg8Fi0ARM', 0, '2021-03-25 10:35:31', '2021-03-25 10:35:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3940, 'o1qmn5FshD-6n5SUexmVjc5u23kk', 0, '2021-03-25 10:35:34', '2021-03-25 10:35:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3941, 'o1qmn5GBIyk_O02XGzS8z6kz--1U', 0, '2021-03-25 10:35:34', '2021-03-25 10:35:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3942, 'o1qmn5LJe42QIJZ-whSiwwOZEnXk', 0, '2021-03-25 10:35:35', '2021-03-25 10:35:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3943, 'o1qmn5KuaJkFgd9QmHc2NFHkN_IY', 0, '2021-03-25 10:35:39', '2021-03-25 10:35:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3944, 'o1qmn5EcvmsIVYPuTC3QaHFG3Dls', 0, '2021-03-25 10:35:39', '2021-03-25 10:35:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3945, 'o1qmn5A4cfam5zLgektGGFWv4d10', 0, '2021-03-25 10:35:47', '2021-03-25 10:35:47', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3946, 'o1qmn5B2yBJvJsmezch2p7Xa7vQY', 0, '2021-03-25 10:35:51', '2021-03-25 10:35:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3947, 'o1qmn5A0YryZzp-09V4lkPuzhQRA', 0, '2021-03-25 10:35:52', '2021-03-25 10:35:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3948, 'o1qmn5DvQpH-7hatQU69JN2tM9pg', 0, '2021-03-25 11:03:41', '2021-03-25 11:03:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3949, 'o1qmn5LI_CFHrLq4XmtwU81oQdq4', 2, '2021-03-25 11:44:42', '2021-03-25 11:56:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3950, 'o1qmn5OC1BBjbnjHPrnIJALQEKV8', 0, '2021-03-25 12:09:40', '2021-03-25 12:09:40', 'https://thirdwx.qlogo.cn/mmhead/lqGdlbDIJFXttzibMia6XdNZ5LnszT1DicPJgsJbCZCic8w/132', '张品治', NULL, NULL, NULL, NULL, 0),
	(3951, 'o1qmn5CAIAklgoljU61nRMs7Hnn0', 1, '2021-03-25 12:10:40', '2021-03-27 19:41:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3952, 'o1qmn5MZuwFiHSrL-CL_0IIQd4SU', 0, '2021-03-25 12:26:27', '2021-03-25 12:26:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3953, 'o1qmn5BBcagxFN32rPFsavvTy6FE', 0, '2021-03-25 12:26:40', '2021-03-25 12:26:40', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3954, 'o1qmn5NufZKnkg5bEMw9_LcStpI4', 0, '2021-03-25 13:24:37', '2021-03-25 13:24:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3955, 'o1qmn5K2Q2tohwVe0SrckPZ563zg', 0, '2021-03-25 14:29:33', '2021-03-25 14:29:33', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3956, 'o1qmn5E7_R5G6G01DGo9ym9kcN70', 0, '2021-03-25 14:29:55', '2021-03-25 14:29:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3957, 'o1qmn5D372qjrJ_TVgI8k9bnQ55Y', 0, '2021-03-25 14:31:58', '2021-03-25 14:31:58', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3958, 'o1qmn5K0hqaEm1LE4B4KlMnnAHZI', 0, '2021-03-25 14:33:02', '2021-03-25 14:33:02', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3959, 'o1qmn5EmpiBSbWZ4DHMGWWkTnRgk', 0, '2021-03-25 15:12:18', '2021-03-25 15:12:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3960, 'o1qmn5KfC59YYoldYmBqSX4hKBA0', 0, '2021-03-25 15:39:42', '2021-03-25 15:39:42', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3961, 'o1qmn5L3lHND4cl6d3v3tMrRfnuE', 0, '2021-03-25 15:44:04', '2021-03-25 15:44:04', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3962, 'o1qmn5G7avAK_YlS6dj13AfaNNI8', 0, '2021-03-25 16:18:48', '2021-03-25 16:18:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3963, 'o1qmn5KNf1vZUld-qv4oMtHS7wF4', 0, '2021-03-25 16:28:55', '2021-03-25 16:28:55', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3964, 'o1qmn5Fyo9wGoKXopeGTVOz1ipIs', 0, '2021-03-25 16:29:16', '2021-03-25 16:29:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3965, 'o1qmn5P6lrBds_xxCFoTIfPQ7blQ', 0, '2021-03-25 16:38:38', '2021-03-25 16:38:38', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3966, 'o1qmn5DWHD0lZ-giWbpK3PAFIWhg', 0, '2021-03-25 16:52:52', '2021-03-25 16:52:52', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3967, 'o1qmn5OAjzFbw4G7OKHgG85vtAVU', 0, '2021-03-25 16:55:49', '2021-03-25 16:55:49', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3968, 'o1qmn5Mq22KR89HceJhsV2DUiibk', 0, '2021-03-25 18:27:59', '2021-03-25 18:27:59', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3969, 'o1qmn5HL9iAwTRlBCajAlx9Cvp1I', 0, '2021-03-25 19:03:39', '2021-03-25 19:03:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3970, 'o1qmn5JU42L4GBwd7EzF8JnPxy0Y', 0, '2021-03-25 19:36:13', '2021-03-25 19:36:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3971, 'o1qmn5NLXL-ieitC-cMB3oe3Z4Xg', 3, '2021-03-25 19:55:24', '2021-03-29 08:21:14', 'https://thirdwx.qlogo.cn/mmopen/vi_32/DYAIOgq83eqic5GSPfIyQzvTibqTUecwYEsZ3rRLbvksmuXSVgCMG5kzegNv6dunkt2HSkziaf6950DtjMLXutWdA/132', 'hope', NULL, NULL, NULL, NULL, 0),
	(3972, 'o1qmn5AAGkrZKVNLpn4P3K2iSwbw', 0, '2021-03-25 20:35:12', '2021-03-25 20:35:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3973, 'o1qmn5A0Gy2ZcUSTa_0rCxI7mbiM', 0, '2021-03-26 00:08:41', '2021-03-26 00:08:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3974, 'o1qmn5BOqPUi1qwVGiy6p71jju0A', 0, '2021-03-26 02:48:27', '2021-03-26 02:48:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3975, 'o1qmn5OXWY5_NKU7FBsMsvHA9-BQ', 0, '2021-03-26 09:29:48', '2021-03-26 09:29:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3976, 'o1qmn5EP-VFKu3KjCU4z1BAoLZSM', 0, '2021-03-26 09:30:18', '2021-03-26 09:30:18', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3977, 'o1qmn5D0PvjHGBY6oFk4hM_C8KZI', 0, '2021-03-26 10:00:50', '2021-03-26 10:00:50', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3978, 'o1qmn5FJFSAf0IubJxF5nPmTGAS4', 0, '2021-03-26 10:42:27', '2021-03-26 10:42:27', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3979, 'o1qmn5H2P_hnaxtGUj-jSj4mfTa8', 0, '2021-03-26 11:04:35', '2021-03-26 11:04:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3980, 'o1qmn5FcpbjmdSRvOIi06Wd1wkNg', 0, '2021-03-26 11:39:30', '2021-03-26 11:39:30', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3981, 'o1qmn5Hd8lulo1lR0C5CGF6mDedw', 0, '2021-03-26 12:59:23', '2021-03-26 12:59:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3982, 'o1qmn5BcIQ8cpnvlXCi9cjIpb80Y', 0, '2021-03-26 13:01:37', '2021-03-26 13:01:37', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3983, 'o1qmn5OjVAiKY7tMDezW33zLseJo', 0, '2021-03-26 13:04:19', '2021-03-26 13:04:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3984, 'o1qmn5JJNQnU_flZFozVqydwjt80', 1, '2021-03-26 15:05:50', '2021-03-29 10:30:16', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3985, 'o1qmn5HWy63kUzjQWah9q9Hynkxc', 1, '2021-03-26 15:24:01', '2021-03-26 20:34:48', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3986, 'o1qmn5L4gCp3oE2YKLNHhp8BjsB0', 0, '2021-03-26 15:25:19', '2021-03-26 15:25:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3987, 'o1qmn5GRMmDPIBMX8yT20ZEf1esg', 3, '2021-03-26 15:25:22', '2021-03-27 07:38:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3988, 'o1qmn5FUC9aZdu8KuDVlRGZTMqkA', 0, '2021-03-26 15:26:00', '2021-03-26 15:26:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3989, 'o1qmn5GKZMM-WiVoHaC8JZQkcNrg', 0, '2021-03-26 15:56:24', '2021-03-26 15:56:24', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3990, 'o1qmn5BnDDpXWtc-_GYq8eWnDxHM', 0, '2021-03-26 16:32:39', '2021-03-26 16:32:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3991, 'o1qmn5GwYVoderJ3H1z_dfFlIboY', 0, '2021-03-26 18:10:34', '2021-03-26 18:10:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3992, 'o1qmn5CJg7op6H4I8diYOkNT11os', 0, '2021-03-26 18:36:12', '2021-03-26 18:36:12', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3993, 'o1qmn5DsYw7rdCyPtPz6kmxcj1yI', 2, '2021-03-26 23:49:55', '2021-03-27 10:48:39', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3994, 'o1qmn5ADtFrdHk8diB891KsT7jq8', 0, '2021-03-27 04:13:13', '2021-03-27 04:13:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3995, 'o1qmn5FgVdjD5XawRNiPcW4tKLNk', 1, '2021-03-27 09:01:21', '2021-03-27 11:24:19', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3996, 'o1qmn5O4xlm2l-F9Kzn9e2km6urE', 0, '2021-03-27 11:48:13', '2021-03-27 11:48:13', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3997, 'o1qmn5FaBRZObJNKdYqbWdio3Ey4', 1, '2021-03-27 13:41:31', '2021-03-27 13:53:35', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3998, 'o1qmn5CsxqTGvHHPl2XF4EwKMR08', 0, '2021-03-27 13:52:07', '2021-03-27 13:52:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(3999, 'o1qmn5Do6wtnZEC-rVxN_dly_Sww', 0, '2021-03-27 15:00:15', '2021-03-27 15:00:15', 'https://thirdwx.qlogo.cn/mmopen/vi_32/DYAIOgq83equ5ia5LlYh9ia7y4OibTWiaeX53Cwf5un0mksc5dUpoA6Tz5GKhUt1kyhMMokVUiciaI2jmFWVgCbTWiciaw/132', '德技优品门窗-高靖', NULL, NULL, NULL, NULL, 0),
	(4000, 'o1qmn5HJ9dLhjiou4DrsUh8vYbxY', 0, '2021-03-27 15:52:31', '2021-03-27 15:52:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4001, 'o1qmn5LbUJlqkhJZtXrQh9xAiupw', 0, '2021-03-27 17:22:23', '2021-03-27 17:22:23', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4002, 'o1qmn5BvZfTxLlG0J0-oy7Bgz_CA', 0, '2021-03-27 22:23:44', '2021-03-27 22:23:44', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4003, 'o1qmn5NJi216NYPO6MZg64HOaDdo', 0, '2021-03-27 22:27:43', '2021-03-27 22:27:43', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4004, 'o1qmn5FHlRu5biGm-3cVKTZS9WTU', 1, '2021-03-27 23:59:55', '2021-03-28 00:04:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4005, 'o1qmn5H77dTqnAIyCJb2c5GyeFuw', 3, '2021-03-28 09:42:34', '2021-03-28 13:29:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4006, 'o1qmn5EgjLj_HOgamr4haV-pYasM', 0, '2021-03-28 11:43:15', '2021-03-28 11:43:15', 'https://thirdwx.qlogo.cn/mmhead/BtmyGyk1icWmbic3gB9ChhlsAcwjPEhAeukAic4tRjKAzI/132', '叶尧俐', NULL, NULL, NULL, NULL, 0),
	(4007, 'o1qmn5GoW8lh9KMSX0RcJxk1MCPA', 0, '2021-03-28 11:51:31', '2021-03-28 11:51:31', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4008, 'o1qmn5HAIS4nDq1WjCPSK2ljFDYE', 0, '2021-03-28 12:28:51', '2021-03-28 12:28:51', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4009, 'o1qmn5KRjRlrhYVc0deP4IM5mmng', 0, '2021-03-28 12:30:11', '2021-03-28 12:30:11', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4010, 'o1qmn5DI70Mz0qiT341ylSj1W-o4', 5, '2021-03-28 12:55:42', '2021-03-28 12:56:08', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4011, 'o1qmn5F59hYsPkMBiMX5_ur3kN1I', 0, '2021-03-28 13:03:14', '2021-03-28 13:03:14', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4012, 'o1qmn5P7mSF25gVLKL9L2Af_s4po', 0, '2021-03-28 13:03:41', '2021-03-28 13:03:41', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4013, 'o1qmn5P9UnbFTTjwNYvvPb444Tfw', 2, '2021-03-28 14:18:15', '2021-03-29 00:04:07', 'https://thirdwx.qlogo.cn/mmopen/vi_32/Q3auHgzwzM4BWdnJ0C28ib1gJJge8r20xvEln4nsAurBfZMRcMuGcJKofqrCsr7Nr9Dj2FbS5LZDg1NOlpdVnrQ/132', '神经蛙', NULL, NULL, NULL, NULL, 0),
	(4014, 'o1qmn5I6gdL-uaUWAuXFef37OcCA', 0, '2021-03-28 16:24:21', '2021-03-28 16:24:21', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4015, 'o1qmn5MYFxc8YIiTzWLBY3M49Wfs', 0, '2021-03-28 23:28:07', '2021-03-28 23:28:07', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4016, 'o1qmn5G0FGvPfK1u_GsziU8xo8XM', 0, '2021-03-28 23:28:34', '2021-03-28 23:28:34', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4017, 'o1qmn5GqPmW7LQOofQeHhSqwIUr4', 0, '2021-03-28 23:44:46', '2021-03-28 23:44:46', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4018, 'o1qmn5Np5bvvOKuc2xfXMSE92KOM', 0, '2021-03-29 00:08:45', '2021-03-29 00:08:45', 'https://thirdwx.qlogo.cn/mmopen/vi_32/ZdWRbAes7icW7k5d10x9aTGc2FTsrrks3fHKU6kazNcewz5oq5iaowkcDpaViafHc31Mp1m542tUpF5SgWjTb5FNw/132', '凯维斯13929040052', NULL, NULL, NULL, NULL, 0),
	(4019, 'o1qmn5AJU0vP-5OeNFj0CHqbF8Dw', 0, '2021-03-29 06:14:00', '2021-03-29 06:14:00', NULL, NULL, NULL, NULL, NULL, NULL, 0),
	(4020, 'o1qmn5H61oZca5sZ-_zOsFRQ48HM', 0, '2021-03-29 06:39:52', '2021-03-29 06:39:52', NULL, NULL, NULL, NULL, NULL, NULL, 0);
/*!40000 ALTER TABLE `wx_user` ENABLE KEYS */;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
